<?php
/**
 * Magento
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/osl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@magentocommerce.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade Magento to newer
 * versions in the future. If you wish to customize Magento for your
 * needs please refer to http://www.magentocommerce.com for more information.
 *
 * @category    Mage
 * @package     Mage_Catalog
 * @copyright   Copyright (c) 2010 Magento Inc. (http://www.magentocommerce.com)
 * @license     http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */
 
/**
 * Catalog product random items block
 *
 * @category   Mage
 * @package    Mage_Catalog
 * @author      Magento Core Team <core@magentocommerce.com>
 */
 
class Sns_Amoda_Block_Catalog_Product_List_Rating extends Mage_Catalog_Block_Product_List
{
    protected function _getProductCollection()
    {
        if (is_null($this->_productCollection)) {
        	$layer = $this->getLayer();
        	
            $categoryID = $this->getCategoryId();
            if($categoryID) {
              $category = new Mage_Catalog_Model_Category();
              $category->load($categoryID); // this is category id
              $collection = $category->getProductCollection();
            } else {
              $collection = Mage::getResourceModel('catalog/product_collection');
            }
            Mage::getModel('catalog/layer')->prepareProductCollection($collection);
            $this->_addReviewsCount($collection); 
            $collection->getSelect()->order('sns_rating_summary desc')->order('sns_reviews_count desc');

            //Zend_Debug::dump((string)$collection->getSelect()); die();

            $this->_productCollection = $collection;
        }
        return $this->_productCollection;
    }
    private function _addReviewsCount(& $collection, $reviews_count_alias="sns_reviews_count", $rating_summary_alias="sns_rating_summary" ){
        // add reviews_count and rating_summary
        $review_summary_table = Mage::getSingleton('core/resource')->getTableName('review/review_aggregate');
        $collection->getSelect()->joinLeft(
            array("rs_table" => $review_summary_table),
            "e.entity_id = rs_table.entity_pk_value AND rs_table.store_id=" . Mage::app()->getStore()->getId(), //.' WHERE rs_table.reviews_count >= 1',
            array(
                $reviews_count_alias  => "rs_table.reviews_count",
                $rating_summary_alias => "rs_table.rating_summary"
            )
        );
    }
}