SET FOREIGN_KEY_CHECKS=0;
SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;


CREATE TABLE IF NOT EXISTS `#__adminnotification_inbox` (
`notification_id` int(10) unsigned NOT NULL COMMENT 'Notification id',
  `severity` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Problem type',
  `date_added` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Create date',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `description` text COMMENT 'Description',
  `url` varchar(255) DEFAULT NULL COMMENT 'Url',
  `is_read` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Flag if notification read',
  `is_remove` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Flag if notification might be removed'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Adminnotification Inbox' AUTO_INCREMENT=94 ;

INSERT INTO `#__adminnotification_inbox` (`notification_id`, `severity`, `date_added`, `title`, `description`, `url`, `is_read`, `is_remove`) VALUES
(1, 4, '2008-07-24 22:24:40', 'Magento 1.1 Production Version Now Available', 'We are thrilled to announce the availability of the production release of Magento 1.1. Read more about the release in the Magento Blog.', 'http://www.magentocommerce.com/blog/comments/magento-11-is-here-1/', 0, 1),
(2, 4, '2008-08-01 22:30:16', 'Updated iPhone Theme is now available', 'Updated iPhone theme for Magento 1.1 is now available on Magento Connect and for upgrade through your Magento Connect Manager.', 'http://www.magentocommerce.com/blog/comments/updated-iphone-theme-for-magento-11-is-now-available/', 0, 1),
(3, 3, '2008-08-01 22:40:27', 'Magento version 1.1.2 is now available', 'Magento version 1.1.2 is now available for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-version-112-is-now-available/', 0, 1),
(4, 3, '2008-08-13 14:51:46', 'Magento version 1.1.3 is now available', 'Magento version 1.1.3 is now available', 'http://www.magentocommerce.com/blog/comments/magento-version-113-is-now-available/', 0, 1),
(5, 1, '2008-09-02 18:10:31', 'Magento Version 1.1.4 Security Update Now Available', 'Magento 1.1.4 Security Update Now Available. If you are using Magento version 1.1.x, we highly recommend upgrading to this version as soon as possible.', 'http://www.magentocommerce.com/blog/comments/magento-version-114-security-update/', 0, 1),
(6, 3, '2008-09-15 19:09:54', 'Magento version 1.1.5 Now Available', 'Magento version 1.1.5 Now Available.\n\nThis release includes many bug fixes, a new category manager and a new skin for the default Magento theme.', 'http://www.magentocommerce.com/blog/comments/magento-version-115-now-available/', 0, 1),
(7, 3, '2008-09-17 17:18:35', 'Magento version 1.1.6 Now Available', 'Magento version 1.1.6 Now Available.\n\nThis version includes bug fixes for Magento 1.1.x that are listed in the release notes section.', 'http://www.magentocommerce.com/blog/comments/magento-version-116-now-available/', 0, 1),
(8, 4, '2008-11-07 21:46:42', 'Reminder: Change Magento`s default phone numbers and callouts before site launch', 'Before launching your Magento store, please remember to change Magento`s default phone numbers that appear in email templates, callouts, templates, etc.', NULL, 0, 1),
(9, 3, '2008-11-19 23:31:12', 'Magento version 1.1.7 Now Available', 'Magento version 1.1.7 Now Available.\n\nThis version includes over 350 issue resolutions for Magento 1.1.x that are listed in the release notes section, and new functionality that includes:\n\n-Google Website Optimizer integration\n-Google Base integration\n-Scheduled DB logs cleaning option', 'http://www.magentocommerce.com/blog/comments/magento-version-117-now-available/', 0, 1),
(10, 3, '2008-11-26 19:24:50', 'Magento Version 1.1.8 Now Available', 'Magento version 1.1.8 now available.\n\nThis version includes some issue resolutions for Magento 1.1.x that are listed in the release notes section.', 'http://www.magentocommerce.com/blog/comments/magento-version-118-now-available/', 0, 1),
(11, 3, '2008-12-30 05:45:59', 'Magento version 1.2.0 is now available for download and upgrade', 'We are extremely happy to announce the availability of Magento version 1.2.0 for download and upgrade.\n\nThis version includes numerous issue resolutions for Magento version 1.1.x and some highly requested new features such as:\n\n    * Support for Downloadable/Digital Products. \n    * Added Layered Navigation to site search result page.\n    * Improved site search to utilize MySQL fulltext search\n    * Added support for fixed-taxes on product level.\n    * Upgraded Zend Framework to the latest stable version 1.7.2', 'http://www.magentocommerce.com/blog/comments/magento-version-120-is-now-available/', 0, 1),
(12, 2, '2008-12-30 19:59:22', 'Magento version 1.2.0.1 now available', 'Magento version 1.2.0.1 now available.This version includes some issue resolutions for Magento 1.2.x that are listed in the release notes section.', 'http://www.magentocommerce.com/blog/comments/magento-version-1201-available/', 0, 1),
(13, 2, '2009-01-12 18:41:49', 'Magento version 1.2.0.2 now available', 'Magento version 1.2.0.2 is now available for download and upgrade. This version includes an issue resolutions for Magento version 1.2.0.x as listed in the release notes.', 'http://www.magentocommerce.com/blog/comments/magento-version-1202-now-available/', 0, 1),
(14, 3, '2009-01-23 22:25:56', 'Magento version 1.2.0.3 now available', 'Magento version 1.2.0.3 is now available for download and upgrade. This version includes issue resolutions for Magento version 1.2.0.x as listed in the release notes.', 'http://www.magentocommerce.com/blog/comments/magento-version-1203-now-available/', 0, 1),
(15, 3, '2009-02-02 19:57:00', 'Magento version 1.2.1 is now available for download and upgrade', 'We are happy to announce the availability of Magento version 1.2.1 for download and upgrade.\n\nThis version includes some issue resolutions for Magento version 1.2.x. A full list of items included in this release can be found on the release notes page.', 'http://www.magentocommerce.com/blog/comments/magento-version-121-now-available/', 0, 1),
(16, 3, '2009-02-23 22:45:47', 'Magento version 1.2.1.1 now available', 'Magento version 1.2.1.1 now available.This version includes some issue resolutions for Magento 1.2.x that are listed in the release notes section.', 'http://www.magentocommerce.com/blog/comments/magento-version-1211-now-available/', 0, 1),
(17, 3, '2009-02-26 23:39:24', 'CSRF Attack Prevention', 'We have just posted a blog entry about a hypothetical CSRF attack on a Magento admin panel. Please read the post to find out if your Magento installation is at risk at http://www.magentocommerce.com/blog/comments/csrf-vulnerabilities-in-web-application-and-how-to-avoid-them-in-magento/', 'http://www.magentocommerce.com/blog/comments/csrf-vulnerabilities-in-web-application-and-how-to-avoid-them-in-magento/', 0, 1),
(18, 2, '2009-03-03 21:03:58', 'Magento version 1.2.1.2 now available', 'Magento version 1.2.1.2 is now available for download and upgrade.\nThis version includes some updates to improve admin security as described in the release notes page.', 'http://www.magentocommerce.com/blog/comments/magento-version-1212-now-available/', 0, 1),
(19, 3, '2009-03-30 23:22:40', 'Magento version 1.3.0 now available', 'Magento version 1.3.0 is now available for download and upgrade. This version includes numerous issue resolutions for Magento version 1.2.x and new features as described on the release notes page.', 'http://www.magentocommerce.com/blog/comments/magento-version-130-is-now-available/', 0, 1),
(20, 3, '2009-04-18 01:06:02', 'Magento version 1.3.1 now available', 'Magento version 1.3.1 is now available for download and upgrade. This version includes some issue resolutions for Magento version 1.3.x and new features such as Checkout By Amazon and Amazon Flexible Payment. To see a full list of updates please check the release notes page.', 'http://www.magentocommerce.com/blog/comments/magento-version-131-now-available/', 0, 1),
(21, 3, '2009-05-19 19:31:21', 'Magento version 1.3.1.1 now available', 'Magento version 1.3.1.1 is now available for download and upgrade. This version includes some issue resolutions for Magento version 1.3.x and a security update for Magento installations that run on multiple domains or sub-domains. If you are running Magento with multiple domains or sub-domains we highly recommend upgrading to this version.', 'http://www.magentocommerce.com/blog/comments/magento-version-1311-now-available/', 0, 1),
(22, 3, '2009-05-29 19:54:06', 'Magento version 1.3.2 now available', 'This version includes some improvements and issue resolutions for version 1.3.x that are listed on the release notes page. also included is a Beta version of the Compile module.', 'http://www.magentocommerce.com/blog/comments/magento-version-132-now-available/', 0, 1),
(23, 3, '2009-06-01 16:32:52', 'Magento version 1.3.2.1 now available', 'Magento version 1.3.2.1 now available for download and upgrade.\n\nThis release solves an issue for users running Magento with PHP 5.2.0, and changes to index.php to support the new Compiler Module.', 'http://www.magentocommerce.com/blog/comments/magento-version-1321-now-available/', 0, 1),
(24, 3, '2009-07-01 22:21:44', 'Magento version 1.3.2.2 now available', 'Magento version 1.3.2.2 is now available for download and upgrade.\n\nThis release includes issue resolution for Magento version 1.3.x. To see a full list of changes please visit the release notes page http://www.magentocommerce.com/download/release_notes.', 'http://www.magentocommerce.com/blog/comments/magento-version-1322-now-available/', 0, 1),
(25, 3, '2009-07-23 03:48:54', 'Magento version 1.3.2.3 now available', 'Magento version 1.3.2.3 is now available for download and upgrade.\n\nThis release includes issue resolution for Magento version 1.3.x. We recommend to upgrade to this version if PayPal payment modules are in use. To see a full list of changes please visit the release notes page http://www.magentocommerce.com/download/release_notes.', 'http://www.magentocommerce.com/blog/comments/magento-version-1323-now-available/', 0, 1),
(26, 4, '2009-08-28 15:26:28', 'PayPal is updating Payflow Pro and Website Payments Pro (Payflow Edition) UK.', 'If you are using Payflow Pro and/or Website Payments Pro (Payflow Edition) UK.  payment methods, you will need to update the URLÃƒÂ¢Ã¢â€šÂ¬Ã‹Å“s in your Magento Administrator Panel in order to process transactions after September 1, 2009. Full details are available here: http://www.magentocommerce.com/wiki/paypal_payflow_changes', 'http://www.magentocommerce.com/wiki/paypal_payflow_changes', 0, 1),
(27, 2, '2009-09-23 17:16:49', 'Magento Version 1.3.2.4 Security Update', 'Magento Version 1.3.2.4 is now available. This version includes a security updates for Magento 1.3.x that solves possible XSS vulnerability issue on customer registration page and is available through SVN, Download Page and through the Magento Connect Manager.', 'http://www.magentocommerce.com/blog/comments/magento-version-1324-security-update/', 0, 1),
(28, 4, '2009-09-25 11:57:54', 'Magento Preview Version 1.4.0.0-alpha2 is now available', 'We are happy to announce the availability of Magento Preview Version 1.4.0.0-alpha2 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1400-alpha2-now-available/', 0, 1),
(29, 4, '2009-10-06 21:55:40', 'Magento Preview Version 1.4.0.0-alpha3 is now available', 'We are happy to announce the availability of Magento Preview Version 1.4.0.0-alpha3 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1400-alpha3-now-available/', 0, 1),
(30, 4, '2009-12-08 21:30:36', 'Magento Preview Version 1.4.0.0-beta1 is now available', 'We are happy to announce the availability of Magento Preview Version 1.4.0.0-beta1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1400-beta1-now-available/', 0, 1),
(31, 4, '2009-12-31 07:22:12', 'Magento Preview Version 1.4.0.0-rc1 is now available', 'We are happy to announce the availability of Magento Preview Version 1.4.0.0-rc1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1400-rc1-now-available/', 0, 1),
(32, 4, '2010-02-13 01:39:53', 'Magento CE Version 1.4.0.0 Stable is now available', 'We are excited to announce the availability of Magento CE Version 1.4.0.0 Stable for upgrade and download.', 'http://bit.ly/c53rpK', 0, 1),
(33, 3, '2010-02-20 00:39:36', 'Magento CE Version 1.4.0.1 Stable is now available', 'Magento CE 1.4.0.1 Stable is now available for upgrade and download.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1401-stable-now-available/', 0, 1),
(34, 4, '2010-04-23 17:09:03', 'Magento Version CE 1.3.3.0 Stable - Now Available With Support for 3-D Secure', 'Based on community requests, we are excited to announce the release of Magento CE 1.3.3.0-Stable with support for 3-D Secure. This release is intended for Magento merchants using version 1.3.x, who want to add support for 3-D Secure.', 'http://www.magentocommerce.com/blog/comments/magento-version-ce-1330-stable-now-available-with-support-for-3-d-secure/', 0, 1),
(35, 4, '2010-05-31 14:20:21', 'Announcing the Launch of Magento Mobile', 'The Magento team is pleased to announce the launch of Magento mobile, a new product that will allow Magento merchants to easily create branded, native mobile storefront applications that are deeply integrated with MagentoÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢s market-leading eCommerce platform. The product includes a new administrative manager, a native iPhone app that is fully customizable, and a service where Magento manages the submission and maintenance process for the iTunes App Store.\n\nLearn more by visiting the Magento mobile product page and sign-up to be the first to launch a native mobile commerce app, fully integrated with Magento.', 'http://www.magentocommerce.com/product/mobile', 0, 1),
(36, 4, '2010-06-10 17:08:08', 'Magento CE Version 1.4.1.0 Stable is now available', 'We are excited to announce the availability of Magento CE Version 1.4.1.0 Stable for upgrade and download. Some of the highlights of this release include: Enhanced PayPal integration (more info to follow), Change of Database structure of the Sales module to no longer use EAV, and much more.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1410-stable-now-available/', 0, 1),
(37, 4, '2010-07-26 18:37:34', 'Magento CE Version 1.4.1.1 Stable is now available', 'We are excited to announce the availability of Magento CE Version 1.4.1.1 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1411-stable-now-available/', 0, 1),
(38, 4, '2010-07-28 02:12:12', 'Magento CE Version 1.4.2.0-beta1 Preview Release Now Available', 'This release gives a preview of the new Magento Connect Manager.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1420-beta1-now-available/', 0, 1),
(39, 4, '2010-07-28 17:15:01', 'Magento CE Version 1.4.1.1 Patch Available', 'As some users experienced issues with upgrading to CE 1.4.1.1 through PEAR channels we provided a patch for it that is available on our blog http://www.magentocommerce.com/blog/comments/magento-ce-version-1411-stable-patch/', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1411-stable-patch/', 0, 1),
(40, 4, '2010-10-11 21:13:25', 'Magento Mobile is now live!', 'Magento Mobile is now live! Signup today to have your own native iPhone mobile-shopping app in iTunes for the holiday season! Learn more at http://www.magentomobile.com/', 'http://www.magentomobile.com/', 0, 1),
(41, 4, '2010-11-08 19:52:06', 'Magento CE Version 1.4.2.0-RC1 Preview Release Now Available', 'We are happy to announce the availability of Magento Preview Version 1.4.2.0-RC1 for download.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1420-rc1-now-available/', 0, 1),
(42, 4, '2010-12-02 18:33:00', 'Magento CE Version 1.4.2.0-RC2 Preview Release Now Available', 'We are happy to announce the availability of Magento Preview Version 1.4.2.0-RC2 for download.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-1420-rc2-now-available/', 0, 1),
(43, 4, '2010-12-08 20:29:55', 'Magento CE Version 1.4.2.0 Stable is now available', 'We are excited to announce the availability of Magento CE Version 1.4.2.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1420-stable-now-available/', 0, 1),
(44, 4, '2010-12-17 21:23:55', 'Magento Preview Version CE 1.5.0.0-alpha1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-alpha1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-alpha1-now-available/', 0, 1),
(45, 4, '2010-12-29 21:51:08', 'Magento Preview Version CE 1.5.0.0-alpha2 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-alpha2 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-alpha2-now-available/', 0, 1),
(46, 4, '2011-01-13 22:35:36', 'Magento Preview Version CE 1.5.0.0-beta1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-beta1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-beta1-now-available/', 0, 1),
(47, 4, '2011-01-21 19:19:09', 'Magento Preview Version CE 1.5.0.0-beta2 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-beta2 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-beta2-now-available/', 0, 1),
(48, 4, '2011-01-27 19:27:57', 'Magento Preview Version CE 1.5.0.0-rc1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-rc1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-rc1-now-available/', 0, 1),
(49, 4, '2011-02-03 19:56:33', 'Magento Preview Version CE 1.5.0.0-rc2 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.0.0-rc2 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1500-rc2-now-available/', 0, 1),
(50, 4, '2011-02-08 17:43:23', 'Magento CE Version 1.5.0.0 Stable is now available', 'We are excited to announce the availability of Magento CE Version 1.5.0.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-community-professional-and-enterprise-editions-releases-now-availab/', 0, 1),
(51, 4, '2011-02-09 21:42:57', 'Magento CE 1.5.0.1 stable Now Available', 'We are excited to announce the availability of Magento CE Version 1.5.0.1 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-1501-stable-now-available/', 0, 1),
(52, 4, '2011-03-18 17:15:45', 'Magento CE 1.5.1.0-beta1 Now Available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.1.0-beta1 for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1510-beta1-now-available/', 0, 1),
(53, 4, '2011-03-31 15:43:02', 'Magento CE 1.5.1.0-rc1 Now Available', 'We are happy to announce the availability of Magento Preview Version CE 1.5.1.0-rc1 for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1510-rc1-now-available/', 0, 1),
(54, 4, '2011-04-26 16:21:07', 'Magento CE 1.5.1.0-stable Now Available', 'We are excited to announce the availability of Magento CE Version 1.5.1.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1510-stable-now-available/', 0, 1),
(55, 4, '2011-05-26 16:33:23', 'Magento Preview Version CE 1.6.0.0-alpha1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.0.0-alpha1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1600-alpha1-now-available/', 0, 1),
(56, 4, '2011-06-15 15:12:08', 'Magento Preview Version CE 1.6.0.0-beta1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.0.0-beta1for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1600-beta1-now-available/', 0, 1),
(57, 4, '2011-06-30 16:03:58', 'Magento Preview Version CE 1.6.0.0-rc1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.0.0-rc1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1600-rc1-now-available/', 0, 1),
(58, 4, '2011-07-11 16:07:39', 'Magento Preview Version CE 1.6.0.0-rc2 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.0.0-rc2 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1600-rc2-now-available/', 0, 1),
(59, 4, '2011-08-19 14:58:31', 'Magento CE 1.6.0.0-stable Now Available', 'We are excited to announce the availability of Magento CE Version 1.6.0.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1600-stable-now-available/', 0, 1),
(60, 4, '2011-09-16 22:31:26', 'Magento Preview Version CE 1.6.1.0-beta1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.1.0-beta1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1610-beta1-now-available/', 0, 1),
(61, 4, '2011-09-29 12:44:10', 'Magento Preview Version CE 1.6.1.0-rc1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.6.1.0-rc1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1610-rc1-now-available/', 0, 1),
(62, 4, '2011-10-19 14:50:05', 'Magento CE 1.6.1.0-stable Now Available', 'We are excited to announce the availability of Magento CE Version 1.6.1.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1610-stable-now-available/', 0, 1),
(63, 4, '2011-12-30 15:39:35', 'Magento Preview Version CE 1.7.0.0-alpha1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.7.0.0-alpha1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1700-alpha1-now-available/', 0, 1),
(64, 4, '2012-01-11 15:24:20', 'Magento CE 1.6.2.0-stable Now Available', 'We are excited to announce the availability of Magento CE Version 1.6.2.0 Stable for download and upgrade.', 'http://www.magentocommerce.com/blog/comments/magento-ce-version-1620-stable-now-available/', 0, 1),
(65, 4, '2012-03-02 17:54:12', 'Magento Preview Version CE 1.7.0.0-beta1 is now available', 'We are happy to announce the availability of Magento Preview Version CE 1.7.0.0-beta1 for download.\nAs this is a preview version it is NOT recommended in any way to be used in a production environment.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1700-beta1-now-available/', 0, 1),
(66, 4, '2012-04-23 07:02:40', 'Magento Community Preview Version CE 1.7.0.0-RC1 has been released!', 'Learn more about the exciting new features and updates in this release and how you can take it for a test drive. As this is a preview version, we need to stress that it''s likely unstable and that we DON''T recommend that you use it in any production environment just yet.', 'http://www.magentocommerce.com/blog/comments/magento-preview-version-ce-1700-rc1-now-available/', 0, 1),
(67, 4, '2012-05-11 02:46:54', 'Magento Community 1.7 and Magento Enterprise 1.12 now available!', 'Learn more about the exciting new features and updates in these releases.', 'http://www.magentocommerce.com/blog/comments/magento-enterprise-112-and-community-17-now-available/', 0, 1),
(68, 4, '2012-06-20 11:54:07', 'Magento Community Edition 1.7.0.1 now available! ', 'We have just released an updated version of Magento Community Edition, version 1.7.0.1. This update delivers new, minor functionality and fixes for some potential security vulnerabilities.', 'http://www.magentocommerce.com/blog/comments/magento-community-edition-1701-released/', 0, 1),
(69, 4, '2012-07-05 12:21:43', 'Important Security Update - Zend Platform Vulnerability', 'We have recently learned of a serious vulnerability in the Zend platform on which Magento is built. Learn more and access a patch that addresses this issue. ', 'http://www.magentocommerce.com/blog/comments/important-security-update-zend-platform-vulnerability/', 0, 1),
(70, 4, '2012-11-19 13:27:42', 'Wrap up more holiday sales with financing', 'Give your customers up to 6 months financing. You get paid right away with Bill Me Later, a PayPal service. ItÃ¢â‚¬â„¢s a great way to extend financing in time for the holidays. Learn More.', 'http://www.magentocommerce.com/paypal/billmelater?utm_source=CEMessaging&utm_medium=copy&utm_content=sixmonths&utm_campaign=BML', 0, 1),
(71, 4, '2012-12-07 04:22:30', 'Increase Your Sales With PayPal', 'Magento merchants using PayPal Express Checkout can help increase their sales on average 18%. It is one simple thing you can do right now to help boost your sales. Learn more.', 'http://www.magentocommerce.com/add-paypal?utm_source=CEModule&utm_medium=copy&utm_content=18&utm_campaign=choosepaypal', 0, 1),
(72, 4, '2013-01-15 15:02:07', 'Imagine 2013 Registration is Now Open!', 'Join 1500 merchants, partners, developers and enthusiasts from 35+ countries around the world for MagentoÃ¢â‚¬â„¢s premier global conference! Collaborate, learn, network and get inspired by the future of eCommerce. Tickets will sell out fast! April 8th Ã¢â‚¬â€œ 10th in Las Vegas.', 'https://registration.imagineecommerce.com/', 0, 1),
(73, 4, '2013-02-12 10:53:42', 'Get More eCommerce Power with Magento Enterprise', 'Limited time offer: Get a free, customized evaluation of your Community Edition site from a Magento Solution Partner. This evaluation gives you a clear look at the numerous benefits you can achieve by upgrading to Enterprise Edition. ', 'http://www.magentocommerce.com/community-to-enterprise?utm_source=CEMM&utm_medium=copy&utm_campaign=CE2EE', 0, 1),
(74, 2, '2013-09-27 10:28:13', 'Magento Community Edition 1.8.0.0 - now available for download!', 'Get tax, security, performance, and many other improvements. \n\nLearn more at http://www.magentocommerce.com/blog/comments/magento-community-edition-one-eight-now-available/ ', 'http://www.magentocommerce.com/blog/comments/magento-community-edition-one-eight-now-available/', 0, 1),
(75, 4, '2013-12-11 08:35:06', 'Magento Community Edition 1.8.1.0 is here!', 'This new version offers significant tax calculation, product quality, and security enhancements. Be sure to carefully review the upgrade instructions before starting. More information is available at http://www.magentocommerce.com/blog/comments/magento-community-edition-1810-is-here/', 'http://www.magentocommerce.com/blog/comments/magento-community-edition-1810-is-here/', 0, 1),
(76, 4, '2013-12-12 16:24:39', 'Important Magento Community Edition Patch', 'A security patch is available for Magento Community Edition 1.4.0.0 through 1.7.0.2; the issue has been fixed in Magento Community Edition 1.8.0.0 and later. It resolves a vulnerability discovered through our quarterly penetration testing process and has not been reported by merchants. We encourage all merchants to apply the patch in their next regularly scheduled maintenance cycle. The patch is available at http://www.magentocommerce.com/download in the Magento Community Edition Patches section.', 'http://www.magentocommerce.com/download', 0, 1),
(77, 4, '2014-01-21 11:34:48', 'PHP 5.4 Patch Now Available', 'Magento is advancing its platform and making development more efficient by adding support for PHP 5.4. Patches are available for download at www.magentocommerce.com/download and you can learn more about this update in our blog post at http://www.magentocommerce.com/blog/comments/magento-now-supports-php-54 .', 'http://www.magentocommerce.com/blog/comments/magento-now-supports-php-54', 0, 1),
(78, 4, '2014-02-20 10:51:46', 'Discover Card Validation Patch Available', 'A patch that resolves an issue with validating Discover credit cards is now available for download at http://www.magentocommerce.com/download. More information on the patch is available in the Magento Knowledge Base at http://www.magentocommerce.com/knowledge-base/entry/discover-card-validation', 'http://www.magentocommerce.com/knowledge-base/entry/discover-card-validation ', 0, 1),
(79, 4, '2014-03-04 08:12:26', 'Learn How to Quickly Increase Sales on Your Site', 'Adding the PayPal Express Checkout button to your checkout page can help increase sales 18% on average. ItÃ¢â‚¬â„¢s fast and easy and you can do it right now to boost sales. Express Checkout is already seamlessly integrated into Community Edition.', 'http://magento.com/paypal/CE_Express_Checkout_NA?utm_source=messagemodule&utm_medium=message&utm_campaign=Ceexpresscheckout', 0, 1),
(80, 4, '2014-05-13 09:46:11', 'Magento Community Edition 1.9 is now available!', 'It accelerates your entry into the mobile commerce space by slashing the time and cost of getting a mobile device-friendly responsive site.  And a new Bill Me Later payment option helps boost your sales. Visit http://magento.com/blog/magento-news/magento-enables-responsive-sites-half-time to learn more.', 'http://magento.com/blog/magento-news/magento-enables-responsive-sites-half-time', 0, 1),
(81, 4, '2014-10-07 21:55:06', 'ItÃ¢â‚¬â„¢s still not too late: Boost your 2014 Holiday sales today.', 'See results in as little as one week with eBay Enterprise Display and 2 business days with eBay Enterprise Affiliate. DID YOU KNOW: Get access to over 128 million highly qualified shoppers on eBay.com with eBay Enterprise Display. And the average retail client using product retargeting sees a $10 to $1 ROI on retargeting spend during Q4. With the eBay Enterprise Affiliate Network, get access to over 200,000 active network publishers across 30+ verticals, and only pay when a customer makes a purchase (Affiliate Network is only available in the U.S. & Canada).  GET STARTED TODAY by visiting www.ebayenterprise.com/turbochargesales', 'http://www.ebayenterprise.com/turbochargesales', 0, 1),
(82, 4, '2014-11-12 12:03:26', 'Important: PayPal Users Must Discontinue Using SSL 3.0 By December 3, 2014', 'To address a vulnerability with the SSL 3.0 security protocol, PayPal and other payment gateways will be disabling SSL 3.0 support. Merchants must upgrade to Transport Layer Service (TLS) by December 3, 2014 to avoid PayPal payment operation failures. Learn more about what you need to do at https://devblog.paypal.com/poodle-ssl-3-0-vulnerability/', 'https://devblog.paypal.com/poodle-ssl-3-0-vulnerability/', 0, 1),
(83, 4, '2014-11-24 16:25:21', 'Magento Community Edition 1.9.1 is available!', 'Magento Community Edition 1.9.1 empowers merchants to deliver compelling shopping experiences by offering enhanced responsive design capabilities, new swatches to display product variations, and improved performance through support for MySQL 5.6 and PHP 5.5. It also includes support for Google Universal Analytics and over 70 product improvements. Find out more at http://magento.com/blog/magento-news/magento-community-edition-191-now-available-download', 'http://magento.com/blog/magento-news/magento-community-edition-191-now-available-download', 0, 1),
(84, 4, '2014-10-07 21:55:06', 'Itâ€™s still not too late: Boost your 2014 Holiday sales today.', 'See results in as little as one week with eBay Enterprise Display and 2 business days with eBay Enterprise Affiliate. DID YOU KNOW: Get access to over 128 million highly qualified shoppers on eBay.com with eBay Enterprise Display. And the average retail client using product retargeting sees a $10 to $1 ROI on retargeting spend during Q4. With the eBay Enterprise Affiliate Network, get access to over 200,000 active network publishers across 30+ verticals, and only pay when a customer makes a purchase (Affiliate Network is only available in the U.S. & Canada).  GET STARTED TODAY by visiting www.ebayenterprise.com/turbochargesales', 'http://www.ebayenterprise.com/turbochargesales', 0, 0),
(85, 4, '2015-01-22 10:47:08', 'Join Us at Imagine Commerce 2015 - April 20-22 at the Wynn Las Vegas', 'Join Magento, eBay Enterprise, and over 2,000 merchants, developers, and eCommerce experts at the premier Commerce event of the year. With three days of cutting-edge keynote presentations, special technical programs, dynamic breakout sessions, and incredible networking opportunities, Imagine Commerce 2015 will educate, enrich, and inspire you to take your business to new heights. Register now at http://imagine2015.magento.com/.', 'http://imagine2015.magento.com/', 0, 0),
(86, 1, '2015-04-16 09:17:07', 'Critical Reminder: Download and install Magento security patches.  Download now.', 'Download and implement 2 important security patches (SUPEE-5344 and SUPEE-1533) from the Magento Community Edition download page (https://www.magentocommerce.com/products/downloads/magento/).  If you have not done so already, download and install 2 previously-released patches that prevent an attacker from remotely executing code on Magento software.  These issues affect all versions of Magento Community Edition.  A press release from Check Point Software Technologies in the coming days will make one of these issues widely known, possibly alerting hackers who may try to exploit it.  Ensure the patches are in place as a preventative measure before the issue is publicized.', 'https://www.magentocommerce.com/products/downloads/magento/ ', 0, 0),
(87, 1, '2015-04-19 15:37:00', 'Second Reminder: Download and install Magento critical security patches now.', 'If you have not done so already, download and install 2 previously-released security patches (SUPEE-5344 and SUPEE-1533) from the Magento Community Edition download page (https://www.magentocommerce.com/products/downloads/magento/).  These security issues affect all versions of Magento Community Edition and enable an attacker to remotely execute code on Magento software. A press release from Check Point Software Technologies tomorrow  will make one of these issues widely known, possibly alerting hackers who may try to exploit it.  Ensure the patches are in place as a preventative measure before the issue is publicized.', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0),
(88, 1, '2015-04-23 12:43:31', 'Urgent: Immediately install Magento critical security patches', 'It is critical for you to download and install 2 previously-released security patches (SUPEE-5344 and SUPEE-1533) from the Magento Community Edition download page (https://www.magentocommerce.com/products/downloads/magento/).  Please do this immediately, as Check Point Software Technologies has published a technical description of how they discovered the issue, which we feel might serve as a tutorial for implementing an attack against your website. ', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0),
(89, 1, '2015-05-14 17:34:01', 'Important: New Magento Security Patch - Install it Now', 'It is important for you to download and install a new security patch (SUPEE-5994) from the Magento Community Edition download page (https://www.magentocommerce.com/products/downloads/magento/).  Please apply this critical update immediately to help protect your site from exposure to multiple security vulnerabilities impacting all versions of the Magento Community Edition software. Please note that this patch should be installed in addition to the recent Shoplift patch (SUPEE-5344).', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0),
(90, 4, '2015-07-07 09:28:25', 'Now available:  Enhanced site quality and security with Community Edition 1.9.2', 'Magento Community Edition 1.9.2 is now available for download and features over 105 product improvements, nearly 170 automated functional tests to help internal development teams improve implementation quality and time to market, and several security enhancements. Read our blog announcement for more information (http://magento.com/blog/magento-news/magento-community-edition-192-now-available), or go to the Community Edition download page to get the software today (https://www.magentocommerce.com/products/downloads/magento/).', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0),
(91, 1, '2015-07-07 10:08:05', 'July 7, 2015: New Magento Security Patch (SUPEE-6285) â€“ Install Immediately', 'Today we are providing a new security patch (SUPEE-6285) that addresses critical security vulnerabilities. The patch is available for Community Edition 1.4.1 to 1.9.1.1 and is part of the core code of our latest release, Community Edition 1.9.2, available for download today.  PLEASE NOTE:  You must first implement SUPEE-5994 to ensure SUPEE-6285 works properly. Download Community Edition 1.9.2 or the patch from the Community Edition download page: https://www.magentocommerce.com/products/downloads/magento/  ', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0),
(92, 4, '2014-10-07 21:55:06', 'It’s still not too late: Boost your 2014 Holiday sales today.', 'See results in as little as one week with eBay Enterprise Display and 2 business days with eBay Enterprise Affiliate. DID YOU KNOW: Get access to over 128 million highly qualified shoppers on eBay.com with eBay Enterprise Display. And the average retail client using product retargeting sees a $10 to $1 ROI on retargeting spend during Q4. With the eBay Enterprise Affiliate Network, get access to over 200,000 active network publishers across 30+ verticals, and only pay when a customer makes a purchase (Affiliate Network is only available in the U.S. & Canada).  GET STARTED TODAY by visiting www.ebayenterprise.com/turbochargesales', 'http://www.ebayenterprise.com/turbochargesales', 0, 0),
(93, 1, '2015-07-07 10:08:05', 'July 7, 2015: New Magento Security Patch (SUPEE-6285) – Install Immediately', 'Today we are providing a new security patch (SUPEE-6285) that addresses critical security vulnerabilities. The patch is available for Community Edition 1.4.1 to 1.9.1.1 and is part of the core code of our latest release, Community Edition 1.9.2, available for download today.  PLEASE NOTE:  You must first implement SUPEE-5994 to ensure SUPEE-6285 works properly. Download Community Edition 1.9.2 or the patch from the Community Edition download page: https://www.magentocommerce.com/products/downloads/magento/  ', 'https://www.magentocommerce.com/products/downloads/magento/', 0, 0);

CREATE TABLE IF NOT EXISTS `#__admin_assert` (
`assert_id` int(10) unsigned NOT NULL COMMENT 'Assert ID',
  `assert_type` varchar(20) DEFAULT NULL COMMENT 'Assert Type',
  `assert_data` text COMMENT 'Assert Data'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Admin Assert Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__admin_role` (
`role_id` int(10) unsigned NOT NULL COMMENT 'Role ID',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Parent Role ID',
  `tree_level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Role Tree Level',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Role Sort Order',
  `role_type` varchar(1) NOT NULL DEFAULT '0' COMMENT 'Role Type',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'User ID',
  `role_name` varchar(50) DEFAULT NULL COMMENT 'Role Name'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Admin Role Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__admin_role` (`role_id`, `parent_id`, `tree_level`, `sort_order`, `role_type`, `user_id`, `role_name`) VALUES
(1, 0, 1, 1, 'G', 0, 'Administrators'),
(3, 1, 2, 0, 'U', 1, 'Stephen');

CREATE TABLE IF NOT EXISTS `#__admin_rule` (
`rule_id` int(10) unsigned NOT NULL COMMENT 'Rule ID',
  `role_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Role ID',
  `resource_id` varchar(255) DEFAULT NULL COMMENT 'Resource ID',
  `privileges` varchar(20) DEFAULT NULL COMMENT 'Privileges',
  `assert_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Assert ID',
  `role_type` varchar(1) DEFAULT NULL COMMENT 'Role Type',
  `permission` varchar(10) DEFAULT NULL COMMENT 'Permission'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Admin Rule Table' AUTO_INCREMENT=2 ;

INSERT INTO `#__admin_rule` (`rule_id`, `role_id`, `resource_id`, `privileges`, `assert_id`, `role_type`, `permission`) VALUES
(1, 1, 'all', NULL, 0, 'G', 'allow');

CREATE TABLE IF NOT EXISTS `#__admin_user` (
`user_id` int(10) unsigned NOT NULL COMMENT 'User ID',
  `firstname` varchar(32) DEFAULT NULL COMMENT 'User First Name',
  `lastname` varchar(32) DEFAULT NULL COMMENT 'User Last Name',
  `email` varchar(128) DEFAULT NULL COMMENT 'User Email',
  `username` varchar(40) DEFAULT NULL COMMENT 'User Login',
  `password` varchar(100) DEFAULT NULL COMMENT 'User Password',
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'User Created Time',
  `modified` timestamp NULL DEFAULT NULL COMMENT 'User Modified Time',
  `logdate` timestamp NULL DEFAULT NULL COMMENT 'User Last Login Time',
  `lognum` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'User Login Number',
  `reload_acl_flag` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Reload ACL',
  `is_active` smallint(6) NOT NULL DEFAULT '1' COMMENT 'User Is Active',
  `extra` text COMMENT 'User Extra Data',
  `rp_token` text COMMENT 'Reset Password Link Token',
  `rp_token_created_at` timestamp NULL DEFAULT NULL COMMENT 'Reset Password Link Token Creation Date'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Admin User Table' AUTO_INCREMENT=2 ;

INSERT INTO `#__admin_user` (`user_id`, `firstname`, `lastname`, `email`, `username`, `password`, `created`, `modified`, `logdate`, `lognum`, `reload_acl_flag`, `is_active`, `extra`, `rp_token`, `rp_token_created_at`) VALUES
(1, 'Stephen', 'Ngo', 'stephen105.ngo@gmail.com', 'admin', '7c8e303a70206092dc8deb3e0871ad0c:L25UyqBGReGEjkdWIjrhEVHlC2z5O5i1', '2014-12-03 00:00:45', '2015-07-14 19:27:08', '2015-07-14 19:27:37', 232, 0, 1, 'a:1:{s:11:"configState";a:58:{s:25:"sns_amoda_cfg_magneto_cfg";s:1:"0";s:21:"sns_amoda_cfg_general";s:1:"0";s:18:"sns_amoda_cfg_menu";s:1:"1";s:25:"sns_amoda_cfg_listingpage";s:1:"0";s:25:"sns_amoda_cfg_productpage";s:1:"0";s:20:"sns_amoda_cfg_social";s:1:"0";s:25:"sns_amoda_cfg_testimonial";s:1:"0";s:25:"sns_amoda_cfg_ourpartners";s:1:"1";s:27:"sns_amoda_cfg_storelocation";s:1:"0";s:24:"sns_amoda_cfg_footer_top";s:1:"0";s:27:"sns_amoda_cfg_footer_middle";s:1:"0";s:21:"sns_amoda_cfg_advance";s:1:"0";s:21:"sns_amoda_cfg_install";s:1:"0";s:14:"design_package";s:1:"0";s:12:"design_theme";s:1:"0";s:11:"design_head";s:1:"0";s:13:"design_header";s:1:"0";s:13:"design_footer";s:1:"1";s:16:"design_watermark";s:1:"0";s:17:"design_pagination";s:1:"0";s:12:"design_email";s:1:"0";s:29:"sns_slideshow_cfg_infomations";s:1:"1";s:25:"sns_slideshow_cfg_general";s:1:"1";s:31:"sns_producttabs_cfg_infomations";s:1:"1";s:27:"sns_producttabs_cfg_general";s:1:"1";s:28:"sns_products_cfg_infomations";s:1:"1";s:24:"sns_products_cfg_general";s:1:"1";s:28:"sns_amoda_cfg_slidercategory";s:1:"0";s:7:"web_seo";s:1:"0";s:12:"web_unsecure";s:1:"0";s:10:"web_secure";s:1:"0";s:11:"web_default";s:1:"1";s:9:"web_polls";s:1:"0";s:10:"web_cookie";s:1:"0";s:24:"web_browser_capabilities";s:1:"0";s:16:"catalog_frontend";s:1:"1";s:15:"catalog_sitemap";s:1:"0";s:14:"catalog_review";s:1:"0";s:21:"catalog_product_image";s:1:"0";s:20:"catalog_productalert";s:1:"0";s:25:"catalog_productalert_cron";s:1:"0";s:19:"catalog_placeholder";s:1:"0";s:25:"catalog_recently_products";s:1:"0";s:13:"catalog_price";s:1:"0";s:26:"catalog_layered_navigation";s:1:"0";s:18:"catalog_navigation";s:1:"0";s:11:"catalog_seo";s:1:"0";s:14:"catalog_search";s:1:"0";s:20:"catalog_downloadable";s:1:"0";s:22:"catalog_custom_options";s:1:"0";s:27:"sns_quicksearch_cfg_general";s:1:"1";s:7:"web_url";s:1:"0";s:11:"web_session";s:1:"0";s:9:"blog_blog";s:1:"1";s:9:"blog_menu";s:1:"0";s:13:"blog_comments";s:1:"0";s:14:"blog_recaptcha";s:1:"0";s:8:"blog_rss";s:1:"0";}}', NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__api2_acl_attribute` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `user_type` varchar(20) NOT NULL COMMENT 'Type of user',
  `resource_id` varchar(255) NOT NULL COMMENT 'Resource ID',
  `operation` varchar(20) NOT NULL COMMENT 'Operation',
  `allowed_attributes` text COMMENT 'Allowed attributes'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api2 Filter ACL Attributes' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__api2_acl_role` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `role_name` varchar(255) NOT NULL COMMENT 'Name of role'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Api2 Global ACL Roles' AUTO_INCREMENT=3 ;

INSERT INTO `#__api2_acl_role` (`entity_id`, `created_at`, `updated_at`, `role_name`) VALUES
(1, '2014-12-03 07:00:05', NULL, 'Guest'),
(2, '2014-12-03 07:00:05', NULL, 'Customer');

CREATE TABLE IF NOT EXISTS `#__api2_acl_rule` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `role_id` int(10) unsigned NOT NULL COMMENT 'Role ID',
  `resource_id` varchar(255) NOT NULL COMMENT 'Resource ID',
  `privilege` varchar(20) DEFAULT NULL COMMENT 'ACL Privilege'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api2 Global ACL Rules' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__api2_acl_user` (
  `admin_id` int(10) unsigned NOT NULL COMMENT 'Admin ID',
  `role_id` int(10) unsigned NOT NULL COMMENT 'Role ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api2 Global ACL Users';

CREATE TABLE IF NOT EXISTS `#__api_assert` (
`assert_id` int(10) unsigned NOT NULL COMMENT 'Assert id',
  `assert_type` varchar(20) DEFAULT NULL COMMENT 'Assert type',
  `assert_data` text COMMENT 'Assert additional data'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api ACL Asserts' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__api_role` (
`role_id` int(10) unsigned NOT NULL COMMENT 'Role id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Parent role id',
  `tree_level` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Role level in tree',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort order to display on admin area',
  `role_type` varchar(1) NOT NULL DEFAULT '0' COMMENT 'Role type',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'User id',
  `role_name` varchar(50) DEFAULT NULL COMMENT 'Role name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api ACL Roles' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__api_rule` (
`rule_id` int(10) unsigned NOT NULL COMMENT 'Api rule Id',
  `role_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Api role Id',
  `resource_id` varchar(255) DEFAULT NULL COMMENT 'Module code',
  `api_privileges` varchar(20) DEFAULT NULL COMMENT 'Privileges',
  `assert_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Assert id',
  `role_type` varchar(1) DEFAULT NULL COMMENT 'Role type',
  `api_permission` varchar(10) DEFAULT NULL COMMENT 'Permission'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api ACL Rules' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__api_session` (
  `user_id` int(10) unsigned NOT NULL COMMENT 'User id',
  `logdate` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Login date',
  `sessid` varchar(40) DEFAULT NULL COMMENT 'Sessioin id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api Sessions';

CREATE TABLE IF NOT EXISTS `#__api_user` (
`user_id` int(10) unsigned NOT NULL COMMENT 'User id',
  `firstname` varchar(32) DEFAULT NULL COMMENT 'First name',
  `lastname` varchar(32) DEFAULT NULL COMMENT 'Last name',
  `email` varchar(128) DEFAULT NULL COMMENT 'Email',
  `username` varchar(40) DEFAULT NULL COMMENT 'Nickname',
  `api_key` varchar(100) DEFAULT NULL COMMENT 'Api key',
  `created` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'User record create date',
  `modified` timestamp NULL DEFAULT NULL COMMENT 'User record modify date',
  `lognum` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Quantity of log ins',
  `reload_acl_flag` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Refresh ACL flag',
  `is_active` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Account status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Api Users' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__aw_blog` (
`post_id` int(11) unsigned NOT NULL,
  `title` varchar(255) NOT NULL DEFAULT '',
  `post_content` text NOT NULL,
  `status` smallint(6) NOT NULL DEFAULT '0',
  `created_time` datetime DEFAULT NULL,
  `update_time` datetime DEFAULT NULL,
  `identifier` varchar(255) NOT NULL DEFAULT '',
  `user` varchar(255) NOT NULL DEFAULT '',
  `update_user` varchar(255) NOT NULL DEFAULT '',
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL,
  `comments` tinyint(11) NOT NULL,
  `tags` text NOT NULL,
  `short_content` text NOT NULL
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=9 ;

INSERT INTO `#__aw_blog` (`post_id`, `title`, `post_content`, `status`, `created_time`, `update_time`, `identifier`, `user`, `update_user`, `meta_keywords`, `meta_description`, `comments`, `tags`, `short_content`) VALUES
(1, 'Lorem ipsum dolor sit amet', '<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer nec odio. Praesent libero. Sed cursus ante dapibus diam. Sed nisi. Nulla quis sem at nibh elementum imperdiet. Duis sagittis ipsum. Praesent mauris. Fusce nec tellus sed augue semper porta. Mauris massa. Vestibulum lacinia arcu eget nulla. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Curabitur sodales ligula in libero. Sed dignissim lacinia nunc. Sed lacinia, urna non tincidunt mattis, tortor neque adipiscing diam, a cursus ipsum ante quis turpis. Nulla facilisi. Ut fringilla. Suspendisse potenti.</p>', 1, '2014-12-08 03:37:25', '2015-06-09 03:30:57', 'lorem-ipsum-dolor-sit', 'Thangnm', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog1.jpg"}}" /></p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer nec odio. Praesent libero. Sed cursus ante dapibus diam. Sed nisi. Nulla quis sem at nibh elementum imperdiet. Duis sagittis ipsum. Praesent mauris. Fusce nec tellus sed augue semper porta. Mauris massa. Vestibulum lacinia arcu eget nulla. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Curabitur sodales ligula in libero. Sed dignissim lacinia nunc. Sed lacinia, urna non tincidunt mattis, tortor neque adipiscing diam, a cursus ipsum ante quis turpis. Nulla facilisi. Ut fringilla. Suspendisse potenti.</p>'),
(2, 'Nunc at velit quis lectus nonummy', '<p>Nunc at velit quis lectus nonummy eleifend. Curabitur eros. Aenean ligula dolor, gravida auctor, auctor et, suscipit in, erat. Sed malesuada, enim ut congue pharetra, massa elit convallis pede, ornare scelerisque libero neque ut neque. In at libero. Curabitur molestie. Sed vel neque. Proin et dolor ac ipsum elementum malesuada. Praesent id orci. Donec hendrerit. In hac habitasse platea dictumst. Aenean sit amet arcu a turpis posuere pretium. <br /><br /> Nulla mauris odio, vehicula in, condimentum sit amet, tempus id, metus. Donec at nisi sit amet felis blandit posuere. Aliquam erat volutpat. Cras lobortis orci in quam porttitor cursus. Aenean dignissim. Curabitur facilisis sem at nisi laoreet placerat. Duis sed ipsum ac nibh mattis feugiat. Proin sed purus. Vivamus lectus ipsum, rhoncus sed, scelerisque sit amet, ultrices in, dolor. Aliquam vel magna non nunc ornare bibendum. Sed libero. Maecenas at est. Vivamus ornare, felis et luctus dapibus, lacus leo convallis diam, eget dapibus augue arcu eget arcu.</p>', 1, '2014-12-08 03:38:43', '2015-06-09 03:31:07', 'uncat-velit-quis-lectus', 'Thangnm', 'Nguyen Thang', '', '', 0, 'velit quis lectus nonummy eleifend', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog2.jpg"}}" /></p>\r\n<p>Nunc at velit quis lectus nonummy eleifend. Curabitur eros. Aenean ligula dolor, gravida auctor, auctor et, suscipit in, erat. Sed malesuada, enim ut congue pharetra, massa elit convallis pede, ornare scelerisque libero neque ut neque. In at libero. Curabitur molestie. Sed vel neque. Proin et dolor ac ipsum elementum malesuada. Praesent id orci. Donec hendrerit. In hac habitasse platea dictumst.Aenean sit amet arcu a turpis posuere pretium.</p>'),
(3, 'Fusce auctor metus eu ultricies', '<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio. <br /><br /> Nullam porta urna quis mauris. Aliquam erat volutpat. Donec scelerisque quam vitae est. Aenean vitae diam at erat pellentesque condimentum. Duis pulvinar nisl sed orci. Vivamus turpis nisi, volutpat in, placerat et, pharetra nec, eros. Suspendisse tellus metus, sodales non, venenatis a, ultrices auctor, erat. In ut leo nec elit mattis pellentesque. Sed eros elit, cursus accumsan, sollicitudin a, iaculis quis, diam. Pellentesque fermentum, pede a nonummy varius, ligula velit laoreet erat, et lacinia nibh nulla sit amet nunc. Suspendisse at turpis quis augue pellentesque pretium. Nunc condimentum elit semper felis.</p>', 1, '2014-12-08 03:39:14', '2015-06-09 03:31:11', 'fusce-auctor-metus-eu-ultricies', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog3.jpg"}}" /></p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue,</p>'),
(4, ' Integer fringilla quam eget dolor', '<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nam nibh. Nunc varius facilisis eros. Sed erat. In in velit quis arcu ornare laoreet. Curabitur adipiscing luctus massa. Integer ut purus ac augue commodo commodo. Nunc nec mi eu justo tempor consectetuer. Etiam vitae nisl. In dignissim lacus ut ante. Cras elit lectus, bibendum a, adipiscing vitae, commodo et, dui. Ut tincidunt tortor. Donec nonummy, enim in lacinia pulvinar, velit tellus scelerisque augue, ac posuere libero urna eget neque. Cras ipsum. Vestibulum pretium, lectus nec venenatis volutpat, purus lectus ultrices risus, a condimentum risus mi et quam. Pellentesque auctor fringilla neque. Duis eu massa ut lorem iaculis vestibulum. Maecenas facilisis elit sed justo. Quisque volutpat malesuada velit.</p>\r\n<p>Nunc at velit quis lectus nonummy eleifend. Curabitur eros. Aenean ligula dolor, gravida auctor, auctor et, suscipit in, erat. Sed malesuada, enim ut congue pharetra, massa elit convallis pede, ornare scelerisque libero neque ut neque. In at libero. Curabitur molestie. Sed vel neque. Proin et dolor ac ipsum elementum malesuada. Praesent id orci. Donec hendrerit. In hac habitasse platea dictumst. Aenean sit amet arcu a turpis posuere pretium.</p>\r\n<p>Nulla mauris odio, vehicula in, condimentum sit amet, tempus id, metus. Donec at nisi sit amet felis blandit posuere. Aliquam erat volutpat. Cras lobortis orci in quam porttitor cursus. Aenean dignissim. Curabitur facilisis sem at nisi laoreet placerat. Duis sed ipsum ac nibh mattis feugiat. Proin sed purus. Vivamus lectus ipsum, rhoncus sed, scelerisque sit amet, ultrices in, dolor. Aliquam vel magna non nunc ornare bibendum. Sed libero. Maecenas at est. Vivamus ornare, felis et luctus dapibus, lacus leo convallis diam, eget dapibus augue arcu eget arcu.</p>', 1, '2014-12-08 03:39:47', '2015-06-09 03:31:17', 'ultricies-vulputate', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog3.jpg"}}" /></p>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Nam nibh. Nunc varius facilisis eros. Sed erat. In in velit quis arcu ornare laoreet. Curabitur adipiscing luctus massa. Integer ut purus ac augue commodo commodo. Nunc nec mi eu justo tempor consectetuer. hasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing</p>'),
(5, 'Duis imperdiet diam pharetra nisi', '<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>\r\n<p>Nullam porta urna quis mauris. Aliquam erat volutpat. Donec scelerisque quam vitae est. Aenean vitae diam at erat pellentesque condimentum. Duis pulvinar nisl sed orci. Vivamus turpis nisi, volutpat in, placerat et, pharetra nec, eros. Suspendisse tellus metus, sodales non, venenatis a, ultrices auctor, erat. In ut leo nec elit mattis pellentesque. Sed eros elit, cursus accumsan, sollicitudin a, iaculis quis, diam. Pellentesque fermentum, pede a nonummy varius, ligula velit laoreet erat, et lacinia nibh nulla sit amet nunc. Suspendisse at turpis quis augue pellentesque pretium. Nunc condimentum elit semper felis.</p>\r\n<p>Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing, odio in pretium feugiat, nulla magna vehicula lorem, at placerat tortor nisl eget velit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Suspendisse mollis fermentum massa.</p>', 1, '2014-12-08 03:40:19', '2015-06-09 03:31:22', 'diam-pharetra-nisi', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog1.jpg"}}" /></p>\r\n<p>Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. hasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing</p>'),
(6, 'Praesent laoreet ante tempor', '<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>\r\n<p>Nullam porta urna quis mauris. Aliquam erat volutpat. Donec scelerisque quam vitae est. Aenean vitae diam at erat pellentesque condimentum. Duis pulvinar nisl sed orci. Vivamus turpis nisi, volutpat in, placerat et, pharetra nec, eros. Suspendisse tellus metus, sodales non, venenatis a, ultrices auctor, erat. In ut leo nec elit mattis pellentesque. Sed eros elit, cursus accumsan, sollicitudin a, iaculis quis, diam. Pellentesque fermentum, pede a nonummy varius, ligula velit laoreet erat, et lacinia nibh nulla sit amet nunc. Suspendisse at turpis quis augue pellentesque pretium. Nunc condimentum elit semper felis.</p>\r\n<p>Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing, odio in pretium feugiat, nulla magna vehicula lorem, at placerat tortor nisl eget velit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Suspendisse mollis fermentum massa.</p>', 1, '2014-12-08 03:40:49', '2015-06-09 03:31:28', 'diam-pharetra-nisi1', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog3.jpg"}}" />Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. hasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing</p>'),
(7, 'Curabitur adipiscing odio in', '<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>\r\n<p>Nullam porta urna quis mauris. Aliquam erat volutpat. Donec scelerisque quam vitae est. Aenean vitae diam at erat pellentesque condimentum. Duis pulvinar nisl sed orci. Vivamus turpis nisi, volutpat in, placerat et, pharetra nec, eros. Suspendisse tellus metus, sodales non, venenatis a, ultrices auctor, erat. In ut leo nec elit mattis pellentesque. Sed eros elit, cursus accumsan, sollicitudin a, iaculis quis, diam. Pellentesque fermentum, pede a nonummy varius, ligula velit laoreet erat, et lacinia nibh nulla sit amet nunc. Suspendisse at turpis quis augue pellentesque pretium. Nunc condimentum elit semper felis.</p>\r\n<p>Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing, odio in pretium feugiat, nulla magna vehicula lorem, at placerat tortor nisl eget velit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Suspendisse mollis fermentum massa.</p>', 1, '2014-12-08 03:41:20', '2015-06-09 03:31:33', 'diam-pharetra-nisi2', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog2.jpg"}}" />Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. hasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing</p>'),
(8, 'Donec scelerisque quam vitae est.', '<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>\r\n<p>Nullam porta urna quis mauris. Aliquam erat volutpat. Donec scelerisque quam vitae est. Aenean vitae diam at erat pellentesque condimentum. Duis pulvinar nisl sed orci. Vivamus turpis nisi, volutpat in, placerat et, pharetra nec, eros. Suspendisse tellus metus, sodales non, venenatis a, ultrices auctor, erat. In ut leo nec elit mattis pellentesque. Sed eros elit, cursus accumsan, sollicitudin a, iaculis quis, diam. Pellentesque fermentum, pede a nonummy varius, ligula velit laoreet erat, et lacinia nibh nulla sit amet nunc. Suspendisse at turpis quis augue pellentesque pretium. Nunc condimentum elit semper felis.</p>\r\n<p>Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing, odio in pretium feugiat, nulla magna vehicula lorem, at placerat tortor nisl eget velit. Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Suspendisse mollis fermentum massa.</p>', 1, '2014-12-08 03:41:48', '2015-06-09 03:31:45', 'diam-pharetra-nisi3', 'Nguyen Thang', 'Nguyen Thang', '', '', 0, '', '<p><img style="float: left; margin-right: 10px;" alt="" src="{{media url="wysiwyg/amoda/blog/blog1.jpg"}}" />Duis imperdiet diam pharetra nisi. Fusce accumsan. Fusce adipiscing, felis non ornare egestas, risus elit placerat mauris, in mollis ante erat quis nisi. Quisque sed ipsum. Nulla facilisi. Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. hasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing</p>');

CREATE TABLE IF NOT EXISTS `#__aw_blog_cat` (
`cat_id` int(11) unsigned NOT NULL,
  `title` varchar(255) NOT NULL DEFAULT '',
  `identifier` varchar(255) NOT NULL DEFAULT '',
  `sort_order` tinyint(6) NOT NULL,
  `meta_keywords` text NOT NULL,
  `meta_description` text NOT NULL
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=2 ;

INSERT INTO `#__aw_blog_cat` (`cat_id`, `title`, `identifier`, `sort_order`, `meta_keywords`, `meta_description`) VALUES
(1, 'News', 'news', 0, '', '');

CREATE TABLE IF NOT EXISTS `#__aw_blog_cat_store` (
  `cat_id` smallint(6) unsigned DEFAULT NULL,
  `store_id` smallint(6) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `#__aw_blog_comment` (
`comment_id` int(11) unsigned NOT NULL,
  `post_id` smallint(11) NOT NULL DEFAULT '0',
  `comment` text NOT NULL,
  `status` smallint(6) NOT NULL DEFAULT '0',
  `created_time` datetime DEFAULT NULL,
  `user` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT ''
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

INSERT INTO `#__aw_blog_comment` (`comment_id`, `post_id`, `comment`, `status`, `created_time`, `user`, `email`) VALUES
(1, 8, 'Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing', 2, '2015-01-19 07:15:17', 'nguyen nguyen', 'admin@mystore.com'),
(2, 8, 'Donec arcu erat, sodales quis, cursus eget, posuere eget, tellus. Vestibulum eu risus. Curabitur adipiscing', 2, '2015-01-19 07:15:22', 'nguyen nguyen', 'admin@mystore.com');

CREATE TABLE IF NOT EXISTS `#__aw_blog_post_cat` (
  `cat_id` smallint(6) unsigned DEFAULT NULL,
  `post_id` smallint(6) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__aw_blog_post_cat` (`cat_id`, `post_id`) VALUES
(1, 1),
(1, 2),
(1, 3),
(1, 4),
(1, 5),
(1, 6),
(1, 7),
(1, 8);

CREATE TABLE IF NOT EXISTS `#__aw_blog_store` (
  `post_id` smallint(6) unsigned DEFAULT NULL,
  `store_id` smallint(6) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `#__aw_blog_store` (`post_id`, `store_id`) VALUES
(1, 1),
(1, 2),
(1, 3),
(1, 4),
(2, 1),
(2, 2),
(2, 3),
(2, 4),
(3, 1),
(3, 2),
(3, 3),
(3, 4),
(4, 1),
(4, 2),
(4, 3),
(4, 4),
(5, 1),
(5, 2),
(5, 3),
(5, 4),
(6, 1),
(6, 2),
(6, 3),
(6, 4),
(7, 1),
(7, 2),
(7, 3),
(7, 4),
(8, 1),
(8, 2),
(8, 3),
(8, 4);

CREATE TABLE IF NOT EXISTS `#__aw_blog_tags` (
`id` int(11) NOT NULL,
  `tag` varchar(255) NOT NULL,
  `tag_count` int(11) NOT NULL DEFAULT '0',
  `store_id` tinyint(4) NOT NULL
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3 ;

INSERT INTO `#__aw_blog_tags` (`id`, `tag`, `tag_count`, `store_id`) VALUES
(1, ' velit quis lectus nonummy eleifend', 1, 1),
(2, ' velit quis lectus nonummy eleifend', 1, 2);

CREATE TABLE IF NOT EXISTS `#__captcha_log` (
  `type` varchar(32) NOT NULL COMMENT 'Type',
  `value` varchar(32) NOT NULL COMMENT 'Value',
  `count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Count',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Update Time'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Count Login Attempts';

CREATE TABLE IF NOT EXISTS `#__cataloginventory_stock` (
`stock_id` smallint(5) unsigned NOT NULL COMMENT 'Stock Id',
  `stock_name` varchar(255) DEFAULT NULL COMMENT 'Stock Name'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Cataloginventory Stock' AUTO_INCREMENT=2 ;

INSERT INTO `#__cataloginventory_stock` (`stock_id`, `stock_name`) VALUES
(1, 'Default');

CREATE TABLE IF NOT EXISTS `#__cataloginventory_stock_item` (
`item_id` int(10) unsigned NOT NULL COMMENT 'Item Id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `stock_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Stock Id',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `min_qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Min Qty',
  `use_config_min_qty` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Min Qty',
  `is_qty_decimal` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Qty Decimal',
  `backorders` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Backorders',
  `use_config_backorders` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Backorders',
  `min_sale_qty` decimal(12,4) NOT NULL DEFAULT '1.0000' COMMENT 'Min Sale Qty',
  `use_config_min_sale_qty` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Min Sale Qty',
  `max_sale_qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Max Sale Qty',
  `use_config_max_sale_qty` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Max Sale Qty',
  `is_in_stock` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is In Stock',
  `low_stock_date` timestamp NULL DEFAULT NULL COMMENT 'Low Stock Date',
  `notify_stock_qty` decimal(12,4) DEFAULT NULL COMMENT 'Notify Stock Qty',
  `use_config_notify_stock_qty` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Notify Stock Qty',
  `manage_stock` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Manage Stock',
  `use_config_manage_stock` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Manage Stock',
  `stock_status_changed_auto` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Stock Status Changed Automatically',
  `use_config_qty_increments` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Qty Increments',
  `qty_increments` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Increments',
  `use_config_enable_qty_inc` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Use Config Enable Qty Increments',
  `enable_qty_increments` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Enable Qty Increments',
  `is_decimal_divided` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Divided into Multiple Boxes for Shipping'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Cataloginventory Stock Item' AUTO_INCREMENT=50 ;

INSERT INTO `#__cataloginventory_stock_item` (`item_id`, `product_id`, `stock_id`, `qty`, `min_qty`, `use_config_min_qty`, `is_qty_decimal`, `backorders`, `use_config_backorders`, `min_sale_qty`, `use_config_min_sale_qty`, `max_sale_qty`, `use_config_max_sale_qty`, `is_in_stock`, `low_stock_date`, `notify_stock_qty`, `use_config_notify_stock_qty`, `manage_stock`, `use_config_manage_stock`, `stock_status_changed_auto`, `use_config_qty_increments`, `qty_increments`, `use_config_enable_qty_inc`, `enable_qty_increments`, `is_decimal_divided`) VALUES
(7, 7, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(8, 8, 1, '83.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(9, 9, 1, '94.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(10, 10, 1, '96.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(11, 11, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(12, 12, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(13, 13, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(14, 14, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(15, 15, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(16, 16, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(17, 17, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(18, 18, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(19, 19, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(20, 20, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(21, 21, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(22, 22, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(23, 23, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(24, 24, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(25, 25, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(26, 26, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(27, 27, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(28, 28, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(29, 29, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(30, 30, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(31, 31, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(32, 32, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(33, 33, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(34, 34, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(35, 35, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(36, 36, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(37, 37, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(38, 38, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(39, 39, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(40, 40, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(41, 41, 1, '98.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(42, 42, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(44, 44, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(45, 45, 1, '0.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(46, 46, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(47, 47, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(48, 48, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0),
(49, 49, 1, '99.0000', '0.0000', 1, 0, 0, 1, '1.0000', 1, '0.0000', 1, 1, NULL, NULL, 1, 0, 1, 0, 1, '0.0000', 1, 0, 0);

CREATE TABLE IF NOT EXISTS `#__cataloginventory_stock_status` (
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `stock_id` smallint(5) unsigned NOT NULL COMMENT 'Stock Id',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint(5) unsigned NOT NULL COMMENT 'Stock Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cataloginventory Stock Status';

INSERT INTO `#__cataloginventory_stock_status` (`product_id`, `website_id`, `stock_id`, `qty`, `stock_status`) VALUES
(7, 1, 1, '0.0000', 1),
(8, 1, 1, '83.0000', 1),
(9, 1, 1, '94.0000', 1),
(10, 1, 1, '96.0000', 1),
(11, 1, 1, '99.0000', 1),
(12, 1, 1, '99.0000', 1),
(13, 1, 1, '0.0000', 1),
(14, 1, 1, '99.0000', 1),
(15, 1, 1, '99.0000', 1),
(16, 1, 1, '99.0000', 1),
(17, 1, 1, '99.0000', 1),
(18, 1, 1, '99.0000', 1),
(19, 1, 1, '0.0000', 1),
(20, 1, 1, '0.0000', 1),
(21, 1, 1, '0.0000', 1),
(22, 1, 1, '99.0000', 1),
(23, 1, 1, '99.0000', 1),
(24, 1, 1, '99.0000', 1),
(25, 1, 1, '99.0000', 1),
(26, 1, 1, '99.0000', 1),
(27, 1, 1, '99.0000', 1),
(28, 1, 1, '99.0000', 1),
(29, 1, 1, '99.0000', 1),
(30, 1, 1, '99.0000', 1),
(31, 1, 1, '99.0000', 1),
(32, 1, 1, '99.0000', 1),
(33, 1, 1, '99.0000', 1),
(34, 1, 1, '99.0000', 1),
(35, 1, 1, '99.0000', 1),
(36, 1, 1, '99.0000', 1),
(37, 1, 1, '99.0000', 1),
(38, 1, 1, '99.0000', 1),
(39, 1, 1, '99.0000', 1),
(40, 1, 1, '99.0000', 1),
(41, 1, 1, '98.0000', 1),
(42, 1, 1, '0.0000', 1),
(44, 1, 1, '0.0000', 1),
(45, 1, 1, '0.0000', 1),
(46, 1, 1, '99.0000', 1),
(47, 1, 1, '99.0000', 1),
(48, 1, 1, '99.0000', 1),
(49, 1, 1, '99.0000', 1);

CREATE TABLE IF NOT EXISTS `#__cataloginventory_stock_status_idx` (
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `stock_id` smallint(5) unsigned NOT NULL COMMENT 'Stock Id',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint(5) unsigned NOT NULL COMMENT 'Stock Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cataloginventory Stock Status Indexer Idx';

INSERT INTO `#__cataloginventory_stock_status_idx` (`product_id`, `website_id`, `stock_id`, `qty`, `stock_status`) VALUES
(7, 1, 1, '0.0000', 1),
(8, 1, 1, '83.0000', 1),
(9, 1, 1, '94.0000', 1),
(10, 1, 1, '96.0000', 1),
(11, 1, 1, '99.0000', 1),
(12, 1, 1, '99.0000', 1),
(13, 1, 1, '0.0000', 1),
(14, 1, 1, '99.0000', 1),
(15, 1, 1, '99.0000', 1),
(16, 1, 1, '99.0000', 1),
(17, 1, 1, '99.0000', 1),
(18, 1, 1, '99.0000', 1),
(19, 1, 1, '0.0000', 1),
(20, 1, 1, '0.0000', 1),
(21, 1, 1, '0.0000', 1),
(22, 1, 1, '99.0000', 1),
(23, 1, 1, '99.0000', 1),
(24, 1, 1, '99.0000', 1),
(25, 1, 1, '99.0000', 1),
(26, 1, 1, '99.0000', 1),
(27, 1, 1, '99.0000', 1),
(28, 1, 1, '99.0000', 1),
(29, 1, 1, '99.0000', 1),
(30, 1, 1, '99.0000', 1),
(31, 1, 1, '99.0000', 1),
(32, 1, 1, '99.0000', 1),
(33, 1, 1, '99.0000', 1),
(34, 1, 1, '99.0000', 1),
(35, 1, 1, '99.0000', 1),
(36, 1, 1, '99.0000', 1),
(37, 1, 1, '99.0000', 1),
(38, 1, 1, '99.0000', 1),
(39, 1, 1, '99.0000', 1),
(40, 1, 1, '99.0000', 1),
(41, 1, 1, '98.0000', 1),
(42, 1, 1, '0.0000', 1),
(44, 1, 1, '0.0000', 1),
(45, 1, 1, '0.0000', 1),
(46, 1, 1, '99.0000', 1),
(47, 1, 1, '99.0000', 1),
(48, 1, 1, '99.0000', 1),
(49, 1, 1, '99.0000', 1);

CREATE TABLE IF NOT EXISTS `#__cataloginventory_stock_status_tmp` (
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `stock_id` smallint(5) unsigned NOT NULL COMMENT 'Stock Id',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `stock_status` smallint(5) unsigned NOT NULL COMMENT 'Stock Status'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Cataloginventory Stock Status Indexer Tmp';

CREATE TABLE IF NOT EXISTS `#__catalogrule` (
`rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `from_date` date DEFAULT NULL COMMENT 'From Date',
  `to_date` date DEFAULT NULL COMMENT 'To Date',
  `is_active` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `actions_serialized` mediumtext COMMENT 'Actions Serialized',
  `stop_rules_processing` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Stop Rules Processing',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `sub_is_enable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Rule Enable For Subitems',
  `sub_simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action For Subitems',
  `sub_discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount For Subitems'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CatalogRule' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalogrule_affected_product` (
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CatalogRule Affected Product';

CREATE TABLE IF NOT EXISTS `#__catalogrule_customer_group` (
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Rules To Customer Groups Relations';

CREATE TABLE IF NOT EXISTS `#__catalogrule_group_website` (
  `rule_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Rule Id',
  `customer_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CatalogRule Group Website';

CREATE TABLE IF NOT EXISTS `#__catalogrule_product` (
`rule_product_id` int(10) unsigned NOT NULL COMMENT 'Rule Product Id',
  `rule_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Rule Id',
  `from_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'From Time',
  `to_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'To time',
  `customer_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group Id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `action_operator` varchar(10) DEFAULT 'to_fixed' COMMENT 'Action Operator',
  `action_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Action Amount',
  `action_stop` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Action Stop',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `sub_simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action For Subitems',
  `sub_discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount For Subitems'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CatalogRule Product' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalogrule_product_price` (
`rule_product_price_id` int(10) unsigned NOT NULL COMMENT 'Rule Product PriceId',
  `rule_date` date NOT NULL COMMENT 'Rule Date',
  `customer_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group Id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `rule_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Rule Price',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `latest_start_date` date DEFAULT NULL COMMENT 'Latest StartDate',
  `earliest_end_date` date DEFAULT NULL COMMENT 'Earliest EndDate'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CatalogRule Product Price' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalogrule_website` (
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Rules To Websites Relations';

CREATE TABLE IF NOT EXISTS `#__catalogsearch_fulltext` (
`fulltext_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `data_index` longtext COMMENT 'Data index'
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='Catalog search result table' AUTO_INCREMENT=4676 ;

INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4549, 49, 2, 'virtual-01|None|Virtual Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|95|1'),
(4548, 48, 2, 'custom-option|Buberry|Black|None|Custom Option|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|212|1'),
(4547, 47, 2, 'no-img|None|No image|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4507, 49, 1, 'virtual-01|None|Virtual Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|95|1'),
(4506, 48, 1, 'custom-option|Buberry|Black|None|Custom Option|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|212|1'),
(4504, 46, 1, 'download-01|None|Downloadable Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|1102|Links #1|Links #2|Links #3|Samples #1|Samples #2|Samples #3|1'),
(4505, 47, 1, 'no-img|None|No image|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4503, 45, 1, 'bud-02|Bundle Product 02|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Green|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Dior|Armani|Armani|Versace|White|Black|Blue|Black|Green|Black|Green|Black|Green|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|373.43|624|609|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4546, 46, 2, 'download-01|None|Downloadable Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|1102|Links #1|Links #2|Links #3|Samples #1|Samples #2|Samples #3|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4545, 45, 2, 'bud-02|Bundle Product 02|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Green|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Dior|Armani|Armani|Versace|White|Black|Blue|Black|Green|Black|Green|Black|Green|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|373.43|624|609|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4502, 44, 1, 'bud-01|Bundle Product|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Simple product 01|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Chanel|Dior|Armani|Armani|Armani|Versace|White|Black|Blue|Black|Blue|Green|Black|Blue|Green|Blue|Black|Green|None|None|None|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|366.45|373.43|624|668.9|609|68|76|79|Option #4|Option #3|Option #2|Option #1|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4501, 42, 1, 'grouped-01|Grouped Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|None|None|None|None|None|624|668.9|609|614|599|1'),
(4500, 41, 1, 'sim-05|Prada|Red|None|Simple product 05|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|113|1'),
(4499, 40, 1, 'sim-04|Gucci|White|None|Simple product 04|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|119|1'),
(4498, 39, 1, 'sim-03|Versace|Green|None|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|79|1'),
(4544, 44, 2, 'bud-01|Bundle Product|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Simple product 01|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Chanel|Dior|Armani|Armani|Armani|Versace|White|Black|Blue|Black|Blue|Green|Black|Blue|Green|Blue|Black|Green|None|None|None|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|366.45|373.43|624|668.9|609|68|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4540, 39, 2, 'sim-03|Versace|Green|None|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|79|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4541, 40, 2, 'sim-04|Gucci|White|None|Simple product 04|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|119|1'),
(4542, 41, 2, 'sim-05|Prada|Red|None|Simple product 05|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|113|1'),
(4543, 42, 2, 'grouped-01|Grouped Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|None|None|None|None|None|624|668.9|609|614|599|1'),
(4497, 38, 1, 'sim-02|Black|None|Simple product 02|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|76|1'),
(4496, 37, 1, 'sim-01|Blue|None|Simple product 01|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4495, 36, 1, 'Cfg-05-Versace|Versace|Red|None|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|194|1'),
(4494, 35, 1, 'Cfg-05-Hermes|Hermes|Red|None|Cfg 05 Hermes|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4493, 34, 1, 'Cfg-05-Chanel|Chanel|Red|None|Cfg 05 Chanel|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|209|1'),
(4492, 33, 1, 'Cfg-05-Buberry|Buberry|Red|None|Cfg 05 Buberry|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|199|1'),
(4491, 32, 1, 'Cfg-05-Armani|Armani|Red|None|Cfg 05 Armani|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4490, 31, 1, 'Cfg-04-Blue|Versace|Blue|None|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|109|1'),
(4489, 30, 1, 'Cfg-04-Green|Versace|Green|None|Cfg 04 Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4488, 29, 1, 'Cfg-04-Red|Versace|Red|None|Cfg 04 Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4487, 28, 1, 'Cfg-04-White|Versace|White|None|Cfg 04 White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4486, 27, 1, 'Cfg-04-Black|Versace|Black|None|Cfg 04 Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4485, 26, 1, 'Cfg-03-Prada-Red|Prada|Red|None|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|417|1'),
(4484, 25, 1, 'Cfg-03-Prada-Green|Prada|Green|None|Cfg 03 Prada Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|412|1'),
(4483, 24, 1, 'Cfg-03-Versace-Blue|Versace|Blue|None|Cfg 03 Versace Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|442.89|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4539, 38, 2, 'sim-02|Black|None|Simple product 02|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|76|1'),
(4538, 37, 2, 'sim-01|Blue|None|Simple product 01|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4537, 36, 2, 'Cfg-05-Versace|Versace|Red|None|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|194|1'),
(4536, 35, 2, 'Cfg-05-Hermes|Hermes|Red|None|Cfg 05 Hermes|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4535, 34, 2, 'Cfg-05-Chanel|Chanel|Red|None|Cfg 05 Chanel|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|209|1'),
(4534, 33, 2, 'Cfg-05-Buberry|Buberry|Red|None|Cfg 05 Buberry|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|199|1'),
(4533, 32, 2, 'Cfg-05-Armani|Armani|Red|None|Cfg 05 Armani|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4532, 31, 2, 'Cfg-04-Blue|Versace|Blue|None|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|109|1'),
(4531, 30, 2, 'Cfg-04-Green|Versace|Green|None|Cfg 04 Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4530, 29, 2, 'Cfg-04-Red|Versace|Red|None|Cfg 04 Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4529, 28, 2, 'Cfg-04-White|Versace|White|None|Cfg 04 White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4528, 27, 2, 'Cfg-04-Black|Versace|Black|None|Cfg 04 Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4527, 26, 2, 'Cfg-03-Prada-Red|Prada|Red|None|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|417|1'),
(4482, 23, 1, 'Cfg-03-Prada-Black|Prada|Black|None|Cfg 03 Prada Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|406|1'),
(4526, 25, 2, 'Cfg-03-Prada-Green|Prada|Green|None|Cfg 03 Prada Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|412|1'),
(4481, 22, 1, 'Cfg-03-Hermes-White|Hermes|White|None|Cfg 03 Hermes White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|410.97|1'),
(4480, 21, 1, 'Cfg-05|Red|Red|Red|Red|Red|Red|None|None|None|None|None|None|Configurable Product 05|Cfg 05 Armani|Cfg 05 Buberry|Cfg 05 Chanel|Cfg 05 Hermes|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|179|189|199|209|189|194|Armani|Buberry|Chanel|Hermes|Versace|1'),
(4525, 24, 2, 'Cfg-03-Versace-Blue|Versace|Blue|None|Cfg 03 Versace Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|442.89|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4524, 23, 2, 'Cfg-03-Prada-Black|Prada|Black|None|Cfg 03 Prada Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|406|1'),
(4523, 22, 2, 'Cfg-03-Hermes-White|Hermes|White|None|Cfg 03 Hermes White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|410.97|1'),
(4479, 20, 1, 'Cfg-04|Versace|Versace|Versace|Versace|Versace|Versace|None|None|None|None|None|None|Configurable Product 04|Cfg 04 Black|Cfg 04 White|Cfg 04 Red|Cfg 04 Green|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|99|100.98|100.98|100.98|100.98|109|Black|White|Red|Green|Blue|1'),
(4478, 19, 1, 'Cfg-03|None|None|None|None|None|None|Configurable Product 03|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 03 Prada Green|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|399|410.97|406|442.89|412|417|Hermes|Prada|Versace|Prada|Prada|White|Black|Blue|Green|Red|1'),
(4477, 18, 1, 'Cfg-02-Gucci-White|Gucci|White|None|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|352.49|1'),
(4522, 21, 2, 'Cfg-05|Red|Red|Red|Red|Red|Red|None|None|None|None|None|None|Configurable Product 05|Cfg 05 Armani|Cfg 05 Buberry|Cfg 05 Chanel|Cfg 05 Hermes|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|179|189|199|209|189|194|Armani|Buberry|Chanel|Hermes|Versace|1'),
(4476, 17, 1, 'Cfg-02-Gucci-Red|Gucci|Red|None|Cfg 02 Gucci Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|367.49|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4521, 20, 2, 'Cfg-04|Versace|Versace|Versace|Versace|Versace|Versace|None|None|None|None|None|None|Configurable Product 04|Cfg 04 Black|Cfg 04 White|Cfg 04 Red|Cfg 04 Green|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|99|100.98|100.98|100.98|100.98|109|Black|White|Red|Green|Blue|1'),
(4475, 16, 1, 'Cfg-02-Dior-Green|Dior|Green|None|Cfg 02 Dior Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4474, 15, 1, 'Cfg-02-Chanel-Blue|Chanel|Blue|None|Cfg 02 Chanel Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|366.45|1'),
(4473, 14, 1, 'Cfg-02-Chanel-Black|Chanel|Black|None|Cfg 02 Chanel Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4519, 18, 2, 'Cfg-02-Gucci-White|Gucci|White|None|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|352.49|1'),
(4520, 19, 2, 'Cfg-03|None|None|None|None|None|None|Configurable Product 03|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 03 Prada Green|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|399|410.97|406|442.89|412|417|Hermes|Prada|Versace|Prada|Prada|White|Black|Blue|Green|Red|1'),
(4472, 13, 1, 'Cfg-02|None|None|None|None|None|None|Configurable Product 02|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg 02 Gucci Red|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|349|373.43|366.45|373.43|367.49|352.49|Chanel|Chanel|Dior|Gucci|Gucci|Black|Blue|Green|Red|White|1'),
(4471, 12, 1, 'Cfg-01-Buberry-Green|Buberry|White|None|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4470, 11, 1, 'Cfg-01-Buberry-Red|Buberry|Red|None|Cfg Buberry Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|614|1'),
(4518, 17, 2, 'Cfg-02-Gucci-Red|Gucci|Red|None|Cfg 02 Gucci Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|367.49|1'),
(4517, 16, 2, 'Cfg-02-Dior-Green|Dior|Green|None|Cfg 02 Dior Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4516, 15, 2, 'Cfg-02-Chanel-Blue|Chanel|Blue|None|Cfg 02 Chanel Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|366.45|1'),
(4515, 14, 2, 'Cfg-02-Chanel-Black|Chanel|Black|None|Cfg 02 Chanel Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4513, 12, 2, 'Cfg-01-Buberry-Green|Buberry|White|None|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|1'),
(4514, 13, 2, 'Cfg-02|None|None|None|None|None|None|Configurable Product 02|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg 02 Gucci Red|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|349|373.43|366.45|373.43|367.49|352.49|Chanel|Chanel|Dior|Gucci|Gucci|Black|Blue|Green|Red|White|1'),
(4469, 10, 1, 'Cfg-01-Armani-Green|Armani|Green|None|Cfg Armani Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|609|1'),
(4468, 9, 1, 'Cfg-01-Armani-Blue|Armani|Blue|None|Cfg Armani Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|668.9|1'),
(4512, 11, 2, 'Cfg-01-Buberry-Red|Buberry|Red|None|Cfg Buberry Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|614|1'),
(4511, 10, 2, 'Cfg-01-Armani-Green|Armani|Green|None|Cfg Armani Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|609|1'),
(4509, 8, 2, 'Cfg-01-Armani-Black|Armani|Black|None|Cfg Armani Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|624|1'),
(4510, 9, 2, 'Cfg-01-Armani-Blue|Armani|Blue|None|Cfg Armani Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|668.9|1'),
(4467, 8, 1, 'Cfg-01-Armani-Black|Armani|Black|None|Cfg Armani Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|624|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4508, 7, 2, 'Cfg-01|None|None|None|None|None|None|Configurable Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|624|668.9|609|614|599|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|1'),
(4466, 7, 1, 'Cfg-01|None|None|None|None|None|None|Configurable Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|624|668.9|609|614|599|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|1'),
(4591, 49, 3, 'virtual-01|None|Virtual Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|95|1'),
(4590, 48, 3, 'custom-option|Buberry|Black|None|Custom Option|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|212|1'),
(4589, 47, 3, 'no-img|None|No image|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4588, 46, 3, 'download-01|None|Downloadable Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|1102|Links #1|Links #2|Links #3|Samples #1|Samples #2|Samples #3|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4587, 45, 3, 'bud-02|Bundle Product 02|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Green|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Dior|Armani|Armani|Versace|White|Black|Blue|Black|Green|Black|Green|Black|Green|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|373.43|624|609|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4586, 44, 3, 'bud-01|Bundle Product|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Simple product 01|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Chanel|Dior|Armani|Armani|Armani|Versace|White|Black|Blue|Black|Blue|Green|Black|Blue|Green|Blue|Black|Green|None|None|None|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|366.45|373.43|624|668.9|609|68|76|79|Option #4|Option #3|Option #2|Option #1|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4585, 42, 3, 'grouped-01|Grouped Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|None|None|None|None|None|624|668.9|609|614|599|1'),
(4584, 41, 3, 'sim-05|Prada|Red|None|Simple product 05|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|113|1'),
(4583, 40, 3, 'sim-04|Gucci|White|None|Simple product 04|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|119|1'),
(4582, 39, 3, 'sim-03|Versace|Green|None|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|79|1'),
(4581, 38, 3, 'sim-02|Black|None|Simple product 02|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|76|1'),
(4580, 37, 3, 'sim-01|Blue|None|Simple product 01|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4579, 36, 3, 'Cfg-05-Versace|Versace|Red|None|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|194|1'),
(4578, 35, 3, 'Cfg-05-Hermes|Hermes|Red|None|Cfg 05 Hermes|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4577, 34, 3, 'Cfg-05-Chanel|Chanel|Red|None|Cfg 05 Chanel|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|209|1'),
(4576, 33, 3, 'Cfg-05-Buberry|Buberry|Red|None|Cfg 05 Buberry|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|199|1'),
(4575, 32, 3, 'Cfg-05-Armani|Armani|Red|None|Cfg 05 Armani|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4574, 31, 3, 'Cfg-04-Blue|Versace|Blue|None|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|109|1'),
(4573, 30, 3, 'Cfg-04-Green|Versace|Green|None|Cfg 04 Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4572, 29, 3, 'Cfg-04-Red|Versace|Red|None|Cfg 04 Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4571, 28, 3, 'Cfg-04-White|Versace|White|None|Cfg 04 White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4570, 27, 3, 'Cfg-04-Black|Versace|Black|None|Cfg 04 Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4569, 26, 3, 'Cfg-03-Prada-Red|Prada|Red|None|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|417|1'),
(4568, 25, 3, 'Cfg-03-Prada-Green|Prada|Green|None|Cfg 03 Prada Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|412|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4567, 24, 3, 'Cfg-03-Versace-Blue|Versace|Blue|None|Cfg 03 Versace Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|442.89|1'),
(4566, 23, 3, 'Cfg-03-Prada-Black|Prada|Black|None|Cfg 03 Prada Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|406|1'),
(4565, 22, 3, 'Cfg-03-Hermes-White|Hermes|White|None|Cfg 03 Hermes White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|410.97|1'),
(4564, 21, 3, 'Cfg-05|Red|Red|Red|Red|Red|Red|None|None|None|None|None|None|Configurable Product 05|Cfg 05 Armani|Cfg 05 Buberry|Cfg 05 Chanel|Cfg 05 Hermes|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|179|189|199|209|189|194|Armani|Buberry|Chanel|Hermes|Versace|1'),
(4563, 20, 3, 'Cfg-04|Versace|Versace|Versace|Versace|Versace|Versace|None|None|None|None|None|None|Configurable Product 04|Cfg 04 Black|Cfg 04 White|Cfg 04 Red|Cfg 04 Green|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|99|100.98|100.98|100.98|100.98|109|Black|White|Red|Green|Blue|1'),
(4562, 19, 3, 'Cfg-03|None|None|None|None|None|None|Configurable Product 03|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 03 Prada Green|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|399|410.97|406|442.89|412|417|Hermes|Prada|Versace|Prada|Prada|White|Black|Blue|Green|Red|1'),
(4561, 18, 3, 'Cfg-02-Gucci-White|Gucci|White|None|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|352.49|1'),
(4560, 17, 3, 'Cfg-02-Gucci-Red|Gucci|Red|None|Cfg 02 Gucci Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|367.49|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4559, 16, 3, 'Cfg-02-Dior-Green|Dior|Green|None|Cfg 02 Dior Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4558, 15, 3, 'Cfg-02-Chanel-Blue|Chanel|Blue|None|Cfg 02 Chanel Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|366.45|1'),
(4557, 14, 3, 'Cfg-02-Chanel-Black|Chanel|Black|None|Cfg 02 Chanel Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4556, 13, 3, 'Cfg-02|None|None|None|None|None|None|Configurable Product 02|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg 02 Gucci Red|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|349|373.43|366.45|373.43|367.49|352.49|Chanel|Chanel|Dior|Gucci|Gucci|Black|Blue|Green|Red|White|1'),
(4551, 8, 3, 'Cfg-01-Armani-Black|Armani|Black|None|Cfg Armani Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|624|1'),
(4552, 9, 3, 'Cfg-01-Armani-Blue|Armani|Blue|None|Cfg Armani Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|668.9|1'),
(4553, 10, 3, 'Cfg-01-Armani-Green|Armani|Green|None|Cfg Armani Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|609|1'),
(4554, 11, 3, 'Cfg-01-Buberry-Red|Buberry|Red|None|Cfg Buberry Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|614|1'),
(4555, 12, 3, 'Cfg-01-Buberry-Green|Buberry|White|None|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|1'),
(4550, 7, 3, 'Cfg-01|None|None|None|None|None|None|Configurable Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|624|668.9|609|614|599|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|1'),
(4633, 49, 4, 'virtual-01|None|Virtual Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|95|1'),
(4632, 48, 4, 'custom-option|Buberry|Black|None|Custom Option|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|212|1'),
(4631, 47, 4, 'no-img|None|No image|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4630, 46, 4, 'download-01|None|Downloadable Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|1102|Links #1|Links #2|Links #3|Samples #1|Samples #2|Samples #3|1'),
(4629, 45, 4, 'bud-02|Bundle Product 02|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Green|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Dior|Armani|Armani|Versace|White|Black|Blue|Black|Green|Black|Green|Black|Green|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|373.43|624|609|76|79|Option #4|Option #3|Option #2|Option #1|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4628, 44, 4, 'bud-01|Bundle Product|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Simple product 01|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Chanel|Dior|Armani|Armani|Armani|Versace|White|Black|Blue|Black|Blue|Green|Black|Blue|Green|Blue|Black|Green|None|None|None|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|366.45|373.43|624|668.9|609|68|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4626, 41, 4, 'sim-05|Prada|Red|None|Simple product 05|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|113|1'),
(4627, 42, 4, 'grouped-01|Grouped Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|None|None|None|None|None|624|668.9|609|614|599|1'),
(4625, 40, 4, 'sim-04|Gucci|White|None|Simple product 04|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|119|1'),
(4624, 39, 4, 'sim-03|Versace|Green|None|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|79|1'),
(4623, 38, 4, 'sim-02|Black|None|Simple product 02|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|76|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4622, 37, 4, 'sim-01|Blue|None|Simple product 01|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4621, 36, 4, 'Cfg-05-Versace|Versace|Red|None|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|194|1'),
(4620, 35, 4, 'Cfg-05-Hermes|Hermes|Red|None|Cfg 05 Hermes|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4619, 34, 4, 'Cfg-05-Chanel|Chanel|Red|None|Cfg 05 Chanel|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|209|1'),
(4618, 33, 4, 'Cfg-05-Buberry|Buberry|Red|None|Cfg 05 Buberry|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|199|1'),
(4617, 32, 4, 'Cfg-05-Armani|Armani|Red|None|Cfg 05 Armani|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4616, 31, 4, 'Cfg-04-Blue|Versace|Blue|None|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|109|1'),
(4615, 30, 4, 'Cfg-04-Green|Versace|Green|None|Cfg 04 Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4614, 29, 4, 'Cfg-04-Red|Versace|Red|None|Cfg 04 Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4613, 28, 4, 'Cfg-04-White|Versace|White|None|Cfg 04 White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4612, 27, 4, 'Cfg-04-Black|Versace|Black|None|Cfg 04 Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4611, 26, 4, 'Cfg-03-Prada-Red|Prada|Red|None|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|417|1'),
(4610, 25, 4, 'Cfg-03-Prada-Green|Prada|Green|None|Cfg 03 Prada Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|412|1'),
(4609, 24, 4, 'Cfg-03-Versace-Blue|Versace|Blue|None|Cfg 03 Versace Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|442.89|1'),
(4608, 23, 4, 'Cfg-03-Prada-Black|Prada|Black|None|Cfg 03 Prada Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|406|1'),
(4607, 22, 4, 'Cfg-03-Hermes-White|Hermes|White|None|Cfg 03 Hermes White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|410.97|1'),
(4606, 21, 4, 'Cfg-05|Red|Red|Red|Red|Red|Red|None|None|None|None|None|None|Configurable Product 05|Cfg 05 Armani|Cfg 05 Buberry|Cfg 05 Chanel|Cfg 05 Hermes|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|179|189|199|209|189|194|Armani|Buberry|Chanel|Hermes|Versace|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4605, 20, 4, 'Cfg-04|Versace|Versace|Versace|Versace|Versace|Versace|None|None|None|None|None|None|Configurable Product 04|Cfg 04 Black|Cfg 04 White|Cfg 04 Red|Cfg 04 Green|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|99|100.98|100.98|100.98|100.98|109|Black|White|Red|Green|Blue|1'),
(4604, 19, 4, 'Cfg-03|None|None|None|None|None|None|Configurable Product 03|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 03 Prada Green|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|399|410.97|406|442.89|412|417|Hermes|Prada|Versace|Prada|Prada|White|Black|Blue|Green|Red|1'),
(4603, 18, 4, 'Cfg-02-Gucci-White|Gucci|White|None|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|352.49|1'),
(4602, 17, 4, 'Cfg-02-Gucci-Red|Gucci|Red|None|Cfg 02 Gucci Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|367.49|1'),
(4601, 16, 4, 'Cfg-02-Dior-Green|Dior|Green|None|Cfg 02 Dior Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4600, 15, 4, 'Cfg-02-Chanel-Blue|Chanel|Blue|None|Cfg 02 Chanel Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|366.45|1'),
(4599, 14, 4, 'Cfg-02-Chanel-Black|Chanel|Black|None|Cfg 02 Chanel Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4597, 12, 4, 'Cfg-01-Buberry-Green|Buberry|White|None|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4598, 13, 4, 'Cfg-02|None|None|None|None|None|None|Configurable Product 02|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg 02 Gucci Red|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|349|373.43|366.45|373.43|367.49|352.49|Chanel|Chanel|Dior|Gucci|Gucci|Black|Blue|Green|Red|White|1'),
(4596, 11, 4, 'Cfg-01-Buberry-Red|Buberry|Red|None|Cfg Buberry Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|614|1'),
(4595, 10, 4, 'Cfg-01-Armani-Green|Armani|Green|None|Cfg Armani Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|609|1'),
(4594, 9, 4, 'Cfg-01-Armani-Blue|Armani|Blue|None|Cfg Armani Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|668.9|1'),
(4593, 8, 4, 'Cfg-01-Armani-Black|Armani|Black|None|Cfg Armani Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|624|1'),
(4592, 7, 4, 'Cfg-01|None|None|None|None|None|None|Configurable Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|624|668.9|609|614|599|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|1'),
(4675, 49, 5, 'virtual-01|None|Virtual Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|95|1'),
(4674, 48, 5, 'custom-option|Buberry|Black|None|Custom Option|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|212|1'),
(4673, 47, 5, 'no-img|None|No image|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4672, 46, 5, 'download-01|None|Downloadable Product|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|1102|Links #1|Links #2|Links #3|Samples #1|Samples #2|Samples #3|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4671, 45, 5, 'bud-02|Bundle Product 02|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Green|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Dior|Armani|Armani|Versace|White|Black|Blue|Black|Green|Black|Green|Black|Green|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|373.43|624|609|76|79|Option #4|Option #3|Option #2|Option #1|1'),
(4670, 44, 5, 'bud-01|Bundle Product|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Simple product 01|Simple product 02|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Hermes|Prada|Versace|Chanel|Chanel|Dior|Armani|Armani|Armani|Versace|White|Black|Blue|Black|Blue|Green|Black|Blue|Green|Blue|Black|Green|None|None|None|None|None|None|None|None|None|None|None|None|410.97|406|442.89|373.43|366.45|373.43|624|668.9|609|68|76|79|Option #4|Option #3|Option #2|Option #1|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4668, 41, 5, 'sim-05|Prada|Red|None|Simple product 05|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|113|1'),
(4669, 42, 5, 'grouped-01|Grouped Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|None|None|None|None|None|624|668.9|609|614|599|1'),
(4667, 40, 5, 'sim-04|Gucci|White|None|Simple product 04|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|119|1'),
(4666, 39, 5, 'sim-03|Versace|Green|None|Simple product 03|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|79|1'),
(4665, 38, 5, 'sim-02|Black|None|Simple product 02|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|76|1'),
(4664, 37, 5, 'sim-01|Blue|None|Simple product 01|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|68|1'),
(4663, 36, 5, 'Cfg-05-Versace|Versace|Red|None|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|194|1'),
(4662, 35, 5, 'Cfg-05-Hermes|Hermes|Red|None|Cfg 05 Hermes|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4661, 34, 5, 'Cfg-05-Chanel|Chanel|Red|None|Cfg 05 Chanel|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|209|1'),
(4660, 33, 5, 'Cfg-05-Buberry|Buberry|Red|None|Cfg 05 Buberry|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|199|1'),
(4659, 32, 5, 'Cfg-05-Armani|Armani|Red|None|Cfg 05 Armani|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|189|1'),
(4658, 31, 5, 'Cfg-04-Blue|Versace|Blue|None|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|109|1'),
(4657, 30, 5, 'Cfg-04-Green|Versace|Green|None|Cfg 04 Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4656, 29, 5, 'Cfg-04-Red|Versace|Red|None|Cfg 04 Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4655, 28, 5, 'Cfg-04-White|Versace|White|None|Cfg 04 White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4654, 27, 5, 'Cfg-04-Black|Versace|Black|None|Cfg 04 Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|100.98|1'),
(4653, 26, 5, 'Cfg-03-Prada-Red|Prada|Red|None|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|417|1'),
(4652, 25, 5, 'Cfg-03-Prada-Green|Prada|Green|None|Cfg 03 Prada Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|412|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4651, 24, 5, 'Cfg-03-Versace-Blue|Versace|Blue|None|Cfg 03 Versace Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|442.89|1'),
(4650, 23, 5, 'Cfg-03-Prada-Black|Prada|Black|None|Cfg 03 Prada Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|406|1'),
(4649, 22, 5, 'Cfg-03-Hermes-White|Hermes|White|None|Cfg 03 Hermes White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|410.97|1'),
(4648, 21, 5, 'Cfg-05|Red|Red|Red|Red|Red|Red|None|None|None|None|None|None|Configurable Product 05|Cfg 05 Armani|Cfg 05 Buberry|Cfg 05 Chanel|Cfg 05 Hermes|Cfg 05 Versace|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|179|189|199|209|189|194|Armani|Buberry|Chanel|Hermes|Versace|1'),
(4647, 20, 5, 'Cfg-04|Versace|Versace|Versace|Versace|Versace|Versace|None|None|None|None|None|None|Configurable Product 04|Cfg 04 Black|Cfg 04 White|Cfg 04 Red|Cfg 04 Green|Cfg 04 Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|99|100.98|100.98|100.98|100.98|109|Black|White|Red|Green|Blue|1'),
(4646, 19, 5, 'Cfg-03|None|None|None|None|None|None|Configurable Product 03|Cfg 03 Hermes White|Cfg 03 Prada Black|Cfg 03 Versace Blue|Cfg 03 Prada Green|Cfg 03 Prada Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|399|410.97|406|442.89|412|417|Hermes|Prada|Versace|Prada|Prada|White|Black|Blue|Green|Red|1'),
(4645, 18, 5, 'Cfg-02-Gucci-White|Gucci|White|None|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|352.49|1'),
(4644, 17, 5, 'Cfg-02-Gucci-Red|Gucci|Red|None|Cfg 02 Gucci Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|367.49|1');
INSERT INTO `#__catalogsearch_fulltext` (`fulltext_id`, `product_id`, `store_id`, `data_index`) VALUES
(4643, 16, 5, 'Cfg-02-Dior-Green|Dior|Green|None|Cfg 02 Dior Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4642, 15, 5, 'Cfg-02-Chanel-Blue|Chanel|Blue|None|Cfg 02 Chanel Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|366.45|1'),
(4641, 14, 5, 'Cfg-02-Chanel-Black|Chanel|Black|None|Cfg 02 Chanel Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|373.43|1'),
(4639, 12, 5, 'Cfg-01-Buberry-Green|Buberry|White|None|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|1'),
(4640, 13, 5, 'Cfg-02|None|None|None|None|None|None|Configurable Product 02|Cfg 02 Chanel Black|Cfg 02 Chanel Blue|Cfg 02 Dior Green|Cfg 02 Gucci Red|Cfg 02 Gucci White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|349|373.43|366.45|373.43|367.49|352.49|Chanel|Chanel|Dior|Gucci|Gucci|Black|Blue|Green|Red|White|1'),
(4638, 11, 5, 'Cfg-01-Buberry-Red|Buberry|Red|None|Cfg Buberry Red|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|614|1'),
(4637, 10, 5, 'Cfg-01-Armani-Green|Armani|Green|None|Cfg Armani Green|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|609|1'),
(4636, 9, 5, 'Cfg-01-Armani-Blue|Armani|Blue|None|Cfg Armani Blue|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|668.9|1'),
(4635, 8, 5, 'Cfg-01-Armani-Black|Armani|Black|None|Cfg Armani Black|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|624|1'),
(4634, 7, 5, 'Cfg-01|None|None|None|None|None|None|Configurable Product|Cfg Armani Black|Cfg Armani Blue|Cfg Armani Green|Cfg Buberry Red|Cfg Buberry White|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum. Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui. Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh|599|624|668.9|609|614|599|Armani|Armani|Armani|Buberry|Buberry|Black|Blue|Green|Red|White|1');

CREATE TABLE IF NOT EXISTS `#__catalogsearch_query` (
`query_id` int(10) unsigned NOT NULL COMMENT 'Query ID',
  `query_text` varchar(255) DEFAULT NULL COMMENT 'Query text',
  `num_results` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Num results',
  `popularity` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Popularity',
  `redirect` varchar(255) DEFAULT NULL COMMENT 'Redirect',
  `synonym_for` varchar(255) DEFAULT NULL COMMENT 'Synonym for',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `display_in_terms` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Display in terms',
  `is_active` smallint(6) DEFAULT '1' COMMENT 'Active status',
  `is_processed` smallint(6) DEFAULT '0' COMMENT 'Processed status',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated at'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog search query table' AUTO_INCREMENT=17 ;

INSERT INTO `#__catalogsearch_query` (`query_id`, `query_text`, `num_results`, `popularity`, `redirect`, `synonym_for`, `store_id`, `display_in_terms`, `is_active`, `is_processed`, `updated_at`) VALUES
(1, 'a', 20, 29, NULL, NULL, 1, 1, 0, 0, '2015-03-20 00:25:34'),
(2, 'Cfg Buberry White', 9, 1, NULL, NULL, 1, 1, 1, 0, '2015-01-04 21:44:44'),
(3, 'cfg', 33, 4, NULL, NULL, 1, 1, 1, 0, '2015-01-18 21:14:51'),
(4, 'black', 20, 6, NULL, NULL, 1, 1, 1, 0, '2015-03-18 19:36:18'),
(5, 'bla', 20, 7, NULL, NULL, 1, 1, 1, 0, '2015-03-18 20:00:20'),
(6, 'COn', 12, 1, NULL, NULL, 3, 1, 1, 0, '2015-05-21 01:38:45'),
(7, 'Fas', 0, 1, NULL, NULL, 1, 1, 1, 0, '2015-05-25 19:58:35'),
(8, 'bun', 12, 2, NULL, NULL, 3, 1, 1, 0, '2015-06-10 02:30:53'),
(9, 'a', 16, 4, NULL, NULL, 3, 1, 1, 0, '2015-05-25 20:47:43'),
(10, 'cfg 03', 12, 1, NULL, NULL, 1, 1, 1, 0, '2015-05-28 00:32:01'),
(11, 'bun', 12, 1, NULL, NULL, 1, 1, 1, 0, '2015-05-28 21:43:59'),
(12, 'fade', 12, 1, NULL, NULL, 1, 1, 1, 0, '2015-06-04 21:29:46'),
(13, 'a', 12, 1, NULL, NULL, 2, 1, 1, 0, '2015-06-10 20:59:38'),
(14, 'fade', 11, 1, NULL, NULL, 3, 1, 1, 0, '2015-06-12 02:56:13'),
(15, 'cf', 11, 2, NULL, NULL, 1, 1, 1, 0, '2015-06-12 03:21:05'),
(16, '9', 11, 1, NULL, NULL, 1, 1, 1, 0, '2015-07-02 01:11:26');

CREATE TABLE IF NOT EXISTS `#__catalogsearch_result` (
  `query_id` int(10) unsigned NOT NULL COMMENT 'Query ID',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product ID',
  `relevance` decimal(20,4) NOT NULL DEFAULT '0.0000' COMMENT 'Relevance'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog search result table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_anc_categs_index_idx` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `path` varchar(255) DEFAULT NULL COMMENT 'Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Anchor Indexer Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_anc_categs_index_tmp` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `path` varchar(255) DEFAULT NULL COMMENT 'Path'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Category Anchor Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_anc_products_index_idx` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(10) unsigned DEFAULT NULL COMMENT 'Position'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Anchor Product Indexer Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_anc_products_index_tmp` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(10) unsigned DEFAULT NULL COMMENT 'Position'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Category Anchor Product Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attriute Set ID',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Parent Category ID',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Creation Time',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Update Time',
  `path` varchar(255) NOT NULL COMMENT 'Tree Path',
  `position` int(11) NOT NULL COMMENT 'Position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'Tree Level',
  `children_count` int(11) NOT NULL COMMENT 'Child Count'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Table' AUTO_INCREMENT=59 ;

INSERT INTO `#__catalog_category_entity` (`entity_id`, `entity_type_id`, `attribute_set_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`) VALUES
(1, 3, 0, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57),
(2, 3, 3, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56),
(3, 3, 3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0),
(4, 3, 3, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31),
(5, 3, 3, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0),
(6, 3, 3, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4),
(7, 3, 3, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0),
(8, 3, 3, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11),
(9, 3, 3, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9),
(10, 3, 3, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0),
(11, 3, 3, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0),
(12, 3, 3, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0),
(13, 3, 3, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0),
(14, 3, 3, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0),
(15, 3, 3, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0),
(16, 3, 3, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0),
(17, 3, 3, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0),
(18, 3, 3, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0),
(19, 3, 3, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3),
(20, 3, 3, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0),
(21, 3, 3, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0),
(22, 3, 3, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0),
(23, 3, 3, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0),
(24, 3, 3, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0),
(25, 3, 3, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0),
(26, 3, 3, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0),
(27, 3, 3, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0),
(28, 3, 3, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0),
(29, 3, 3, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0),
(30, 3, 3, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0),
(31, 3, 3, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5),
(32, 3, 3, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0),
(33, 3, 3, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20),
(34, 3, 3, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0),
(35, 3, 3, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0),
(36, 3, 3, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0),
(37, 3, 3, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0),
(38, 3, 3, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0),
(39, 3, 3, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0),
(40, 3, 3, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0),
(41, 3, 3, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0),
(42, 3, 3, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0),
(43, 3, 3, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4),
(44, 3, 3, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0),
(45, 3, 3, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0),
(46, 3, 3, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0),
(47, 3, 3, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0),
(48, 3, 3, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0),
(49, 3, 3, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0),
(50, 3, 3, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1),
(51, 3, 3, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0),
(52, 3, 3, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0),
(53, 3, 3, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0),
(54, 3, 3, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0),
(55, 3, 3, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0),
(56, 3, 3, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0),
(57, 3, 3, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0),
(58, 3, 3, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity_datetime` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Datetime Attribute Backend Table' AUTO_INCREMENT=35 ;

INSERT INTO `#__catalog_category_entity_datetime` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(1, 3, 59, 0, 42, NULL),
(2, 3, 60, 0, 42, NULL),
(3, 3, 59, 0, 43, NULL),
(4, 3, 60, 0, 43, NULL),
(5, 3, 59, 0, 44, NULL),
(6, 3, 60, 0, 44, NULL),
(7, 3, 59, 0, 45, NULL),
(8, 3, 60, 0, 45, NULL),
(9, 3, 59, 0, 46, NULL),
(10, 3, 60, 0, 46, NULL),
(11, 3, 59, 0, 47, NULL),
(12, 3, 60, 0, 47, NULL),
(13, 3, 59, 0, 48, NULL),
(14, 3, 60, 0, 48, NULL),
(15, 3, 59, 0, 49, NULL),
(16, 3, 60, 0, 49, NULL),
(17, 3, 59, 0, 50, NULL),
(18, 3, 60, 0, 50, NULL),
(19, 3, 59, 0, 51, NULL),
(20, 3, 60, 0, 51, NULL),
(21, 3, 59, 0, 52, NULL),
(22, 3, 60, 0, 52, NULL),
(23, 3, 59, 0, 53, NULL),
(24, 3, 60, 0, 53, NULL),
(25, 3, 59, 0, 54, NULL),
(26, 3, 60, 0, 54, NULL),
(27, 3, 59, 0, 55, NULL),
(28, 3, 60, 0, 55, NULL),
(29, 3, 59, 0, 56, NULL),
(30, 3, 60, 0, 56, NULL),
(31, 3, 59, 0, 57, NULL),
(32, 3, 60, 0, 57, NULL),
(33, 3, 59, 0, 58, NULL),
(34, 3, 60, 0, 58, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity_decimal` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(12,4) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Decimal Attribute Backend Table' AUTO_INCREMENT=57 ;

INSERT INTO `#__catalog_category_entity_decimal` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(1, 3, 70, 0, 3, NULL),
(2, 3, 70, 0, 4, NULL),
(3, 3, 70, 0, 5, NULL),
(4, 3, 70, 0, 6, NULL),
(5, 3, 70, 0, 7, NULL),
(6, 3, 70, 0, 8, NULL),
(7, 3, 70, 0, 9, NULL),
(8, 3, 70, 0, 10, NULL),
(9, 3, 70, 0, 11, NULL),
(10, 3, 70, 0, 12, NULL),
(11, 3, 70, 0, 13, NULL),
(12, 3, 70, 0, 14, NULL),
(13, 3, 70, 0, 15, NULL),
(14, 3, 70, 0, 16, NULL),
(15, 3, 70, 0, 17, NULL),
(16, 3, 70, 0, 18, NULL),
(17, 3, 70, 0, 19, NULL),
(18, 3, 70, 0, 20, NULL),
(19, 3, 70, 0, 21, NULL),
(20, 3, 70, 0, 22, NULL),
(21, 3, 70, 0, 23, NULL),
(22, 3, 70, 0, 24, NULL),
(23, 3, 70, 0, 25, NULL),
(24, 3, 70, 0, 26, NULL),
(25, 3, 70, 0, 27, NULL),
(26, 3, 70, 0, 28, NULL),
(27, 3, 70, 0, 29, NULL),
(28, 3, 70, 0, 30, NULL),
(29, 3, 70, 0, 31, NULL),
(30, 3, 70, 0, 32, NULL),
(31, 3, 70, 0, 33, NULL),
(32, 3, 70, 0, 34, NULL),
(33, 3, 70, 0, 35, NULL),
(34, 3, 70, 0, 36, NULL),
(35, 3, 70, 0, 37, NULL),
(36, 3, 70, 0, 38, NULL),
(37, 3, 70, 0, 39, NULL),
(38, 3, 70, 0, 40, NULL),
(39, 3, 70, 0, 41, NULL),
(40, 3, 70, 0, 42, NULL),
(41, 3, 70, 0, 43, NULL),
(42, 3, 70, 0, 44, NULL),
(43, 3, 70, 0, 45, NULL),
(44, 3, 70, 0, 46, NULL),
(45, 3, 70, 0, 47, NULL),
(46, 3, 70, 0, 48, NULL),
(47, 3, 70, 0, 49, NULL),
(48, 3, 70, 0, 50, NULL),
(49, 3, 70, 0, 51, NULL),
(50, 3, 70, 0, 52, NULL),
(51, 3, 70, 0, 53, NULL),
(52, 3, 70, 0, 54, NULL),
(53, 3, 70, 0, 55, NULL),
(54, 3, 70, 0, 56, NULL),
(55, 3, 70, 0, 57, NULL),
(56, 3, 70, 0, 58, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity_int` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int(11) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Integer Attribute Backend Table' AUTO_INCREMENT=311 ;

INSERT INTO `#__catalog_category_entity_int` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(1, 3, 67, 0, 1, 1),
(2, 3, 67, 1, 1, 1),
(3, 3, 42, 0, 2, 1),
(4, 3, 67, 0, 2, 1),
(5, 3, 42, 1, 2, 1),
(6, 3, 67, 1, 2, 1),
(7, 3, 42, 0, 3, 1),
(8, 3, 67, 0, 3, 1),
(9, 3, 50, 0, 3, NULL),
(10, 3, 51, 0, 3, 0),
(11, 3, 68, 0, 3, 1),
(12, 3, 42, 0, 4, 1),
(13, 3, 67, 0, 4, 1),
(14, 3, 50, 0, 4, NULL),
(15, 3, 51, 0, 4, 0),
(16, 3, 68, 0, 4, 1),
(17, 3, 42, 0, 5, 1),
(18, 3, 67, 0, 5, 1),
(19, 3, 50, 0, 5, NULL),
(20, 3, 51, 0, 5, 0),
(21, 3, 68, 0, 5, 1),
(22, 3, 42, 0, 6, 1),
(23, 3, 67, 0, 6, 1),
(24, 3, 50, 0, 6, NULL),
(25, 3, 51, 0, 6, 0),
(26, 3, 68, 0, 6, 1),
(27, 3, 42, 0, 7, 1),
(28, 3, 67, 0, 7, 1),
(29, 3, 50, 0, 7, NULL),
(30, 3, 51, 0, 7, 0),
(31, 3, 68, 0, 7, 1),
(32, 3, 42, 0, 8, 1),
(33, 3, 67, 0, 8, 1),
(34, 3, 50, 0, 8, NULL),
(35, 3, 51, 0, 8, 0),
(36, 3, 68, 0, 8, 1),
(37, 3, 42, 0, 9, 1),
(38, 3, 67, 0, 9, 1),
(39, 3, 50, 0, 9, NULL),
(40, 3, 51, 0, 9, 0),
(41, 3, 68, 0, 9, 1),
(42, 3, 42, 0, 10, 1),
(43, 3, 67, 0, 10, 1),
(44, 3, 50, 0, 10, NULL),
(45, 3, 51, 0, 10, 0),
(46, 3, 68, 0, 10, 1),
(47, 3, 42, 0, 11, 1),
(48, 3, 67, 0, 11, 1),
(49, 3, 50, 0, 11, NULL),
(50, 3, 51, 0, 11, 0),
(51, 3, 68, 0, 11, 1),
(52, 3, 42, 0, 12, 1),
(53, 3, 67, 0, 12, 1),
(54, 3, 50, 0, 12, NULL),
(55, 3, 51, 0, 12, 0),
(56, 3, 68, 0, 12, 1),
(57, 3, 42, 0, 13, 1),
(58, 3, 67, 0, 13, 1),
(59, 3, 50, 0, 13, NULL),
(60, 3, 51, 0, 13, 0),
(61, 3, 68, 0, 13, 1),
(62, 3, 42, 0, 14, 1),
(63, 3, 67, 0, 14, 1),
(64, 3, 50, 0, 14, NULL),
(65, 3, 51, 0, 14, 0),
(66, 3, 68, 0, 14, 1),
(67, 3, 42, 0, 15, 1),
(68, 3, 67, 0, 15, 1),
(69, 3, 50, 0, 15, NULL),
(70, 3, 51, 0, 15, 0),
(71, 3, 68, 0, 15, 1),
(72, 3, 42, 0, 16, 1),
(73, 3, 67, 0, 16, 1),
(74, 3, 50, 0, 16, NULL),
(75, 3, 51, 0, 16, 0),
(76, 3, 68, 0, 16, 1),
(77, 3, 42, 0, 17, 1),
(78, 3, 67, 0, 17, 1),
(79, 3, 50, 0, 17, NULL),
(80, 3, 51, 0, 17, 0),
(81, 3, 68, 0, 17, 1),
(82, 3, 42, 0, 18, 1),
(83, 3, 67, 0, 18, 1),
(84, 3, 50, 0, 18, NULL),
(85, 3, 51, 0, 18, 0),
(86, 3, 68, 0, 18, 1),
(87, 3, 42, 0, 19, 1),
(88, 3, 67, 0, 19, 1),
(89, 3, 50, 0, 19, NULL),
(90, 3, 51, 0, 19, 0),
(91, 3, 68, 0, 19, 1),
(92, 3, 42, 0, 20, 1),
(93, 3, 67, 0, 20, 1),
(94, 3, 50, 0, 20, NULL),
(95, 3, 51, 0, 20, 0),
(96, 3, 68, 0, 20, 1),
(97, 3, 42, 0, 21, 1),
(98, 3, 67, 0, 21, 1),
(99, 3, 50, 0, 21, NULL),
(100, 3, 51, 0, 21, 0),
(101, 3, 68, 0, 21, 1),
(102, 3, 42, 0, 22, 1),
(103, 3, 67, 0, 22, 1),
(104, 3, 50, 0, 22, NULL),
(105, 3, 51, 0, 22, 0),
(106, 3, 68, 0, 22, 1),
(107, 3, 42, 0, 23, 1),
(108, 3, 67, 0, 23, 1),
(109, 3, 50, 0, 23, NULL),
(110, 3, 51, 0, 23, 0),
(111, 3, 68, 0, 23, 1),
(112, 3, 42, 0, 24, 1),
(113, 3, 67, 0, 24, 1),
(114, 3, 50, 0, 24, NULL),
(115, 3, 51, 0, 24, 0),
(116, 3, 68, 0, 24, 1),
(117, 3, 42, 0, 25, 1),
(118, 3, 67, 0, 25, 1),
(119, 3, 50, 0, 25, NULL),
(120, 3, 51, 0, 25, 0),
(121, 3, 68, 0, 25, 1),
(122, 3, 42, 0, 26, 1),
(123, 3, 67, 0, 26, 1),
(124, 3, 50, 0, 26, NULL),
(125, 3, 51, 0, 26, 0),
(126, 3, 68, 0, 26, 1),
(127, 3, 42, 0, 27, 1),
(128, 3, 67, 0, 27, 1),
(129, 3, 50, 0, 27, NULL),
(130, 3, 51, 0, 27, 0),
(131, 3, 68, 0, 27, 1),
(132, 3, 42, 0, 28, 1),
(133, 3, 67, 0, 28, 1),
(134, 3, 50, 0, 28, NULL),
(135, 3, 51, 0, 28, 0),
(136, 3, 68, 0, 28, 1),
(137, 3, 42, 0, 29, 1),
(138, 3, 67, 0, 29, 1),
(139, 3, 50, 0, 29, NULL),
(140, 3, 51, 0, 29, 0),
(141, 3, 68, 0, 29, 1),
(142, 3, 42, 0, 30, 1),
(143, 3, 67, 0, 30, 1),
(144, 3, 50, 0, 30, NULL),
(145, 3, 51, 0, 30, 0),
(146, 3, 68, 0, 30, 1),
(147, 3, 42, 0, 31, 1),
(148, 3, 67, 0, 31, 1),
(149, 3, 50, 0, 31, NULL),
(150, 3, 51, 0, 31, 0),
(151, 3, 68, 0, 31, 1),
(152, 3, 42, 0, 32, 1),
(153, 3, 67, 0, 32, 1),
(154, 3, 50, 0, 32, NULL),
(155, 3, 51, 0, 32, 0),
(156, 3, 68, 0, 32, 1),
(157, 3, 42, 0, 33, 1),
(158, 3, 67, 0, 33, 1),
(159, 3, 50, 0, 33, NULL),
(160, 3, 51, 0, 33, 0),
(161, 3, 68, 0, 33, 1),
(162, 3, 42, 0, 34, 1),
(163, 3, 67, 0, 34, 1),
(164, 3, 50, 0, 34, NULL),
(165, 3, 51, 0, 34, 0),
(166, 3, 68, 0, 34, 1),
(167, 3, 42, 0, 35, 1),
(168, 3, 67, 0, 35, 1),
(169, 3, 50, 0, 35, NULL),
(170, 3, 51, 0, 35, 0),
(171, 3, 68, 0, 35, 1),
(172, 3, 42, 0, 36, 1),
(173, 3, 67, 0, 36, 1),
(174, 3, 50, 0, 36, NULL),
(175, 3, 51, 0, 36, 0),
(176, 3, 68, 0, 36, 1),
(177, 3, 42, 0, 37, 1),
(178, 3, 67, 0, 37, 1),
(179, 3, 50, 0, 37, NULL),
(180, 3, 51, 0, 37, 0),
(181, 3, 68, 0, 37, 1),
(182, 3, 42, 0, 38, 1),
(183, 3, 67, 0, 38, 1),
(184, 3, 50, 0, 38, NULL),
(185, 3, 51, 0, 38, 0),
(186, 3, 68, 0, 38, 1),
(187, 3, 42, 0, 39, 1),
(188, 3, 67, 0, 39, 1),
(189, 3, 50, 0, 39, NULL),
(190, 3, 51, 0, 39, 0),
(191, 3, 68, 0, 39, 1),
(192, 3, 42, 0, 40, 1),
(193, 3, 67, 0, 40, 1),
(194, 3, 50, 0, 40, NULL),
(195, 3, 51, 0, 40, 0),
(196, 3, 68, 0, 40, 1),
(197, 3, 42, 0, 41, 1),
(198, 3, 67, 0, 41, 1),
(199, 3, 50, 0, 41, 6),
(200, 3, 51, 0, 41, 0),
(201, 3, 68, 0, 41, 1),
(206, 3, 42, 0, 42, 1),
(207, 3, 67, 0, 42, 1),
(208, 3, 50, 0, 42, NULL),
(209, 3, 51, 0, 42, 0),
(210, 3, 68, 0, 42, 0),
(211, 3, 69, 0, 42, 0),
(212, 3, 42, 0, 43, 1),
(213, 3, 67, 0, 43, 1),
(214, 3, 50, 0, 43, NULL),
(215, 3, 51, 0, 43, 0),
(216, 3, 68, 0, 43, 0),
(217, 3, 69, 0, 43, 0),
(218, 3, 42, 0, 44, 1),
(219, 3, 67, 0, 44, 1),
(220, 3, 50, 0, 44, NULL),
(221, 3, 51, 0, 44, 0),
(222, 3, 68, 0, 44, 0),
(223, 3, 69, 0, 44, 0),
(224, 3, 42, 0, 45, 1),
(225, 3, 67, 0, 45, 1),
(226, 3, 50, 0, 45, NULL),
(227, 3, 51, 0, 45, 0),
(228, 3, 68, 0, 45, 0),
(229, 3, 69, 0, 45, 0),
(230, 3, 42, 0, 46, 1),
(231, 3, 67, 0, 46, 1),
(232, 3, 50, 0, 46, NULL),
(233, 3, 51, 0, 46, 0),
(234, 3, 68, 0, 46, 0),
(235, 3, 69, 0, 46, 0),
(236, 3, 42, 0, 47, 1),
(237, 3, 67, 0, 47, 1),
(238, 3, 50, 0, 47, NULL),
(239, 3, 51, 0, 47, 0),
(240, 3, 68, 0, 47, 0),
(241, 3, 69, 0, 47, 0),
(242, 3, 42, 0, 48, 1),
(243, 3, 67, 0, 48, 1),
(244, 3, 50, 0, 48, NULL),
(245, 3, 51, 0, 48, 0),
(246, 3, 68, 0, 48, 0),
(247, 3, 69, 0, 48, 0),
(248, 3, 42, 0, 49, 1),
(249, 3, 67, 0, 49, 1),
(250, 3, 50, 0, 49, NULL),
(251, 3, 51, 0, 49, 0),
(252, 3, 68, 0, 49, 0),
(253, 3, 69, 0, 49, 0),
(254, 3, 42, 0, 50, 1),
(255, 3, 67, 0, 50, 1),
(256, 3, 50, 0, 50, NULL),
(257, 3, 51, 0, 50, 0),
(258, 3, 68, 0, 50, 0),
(259, 3, 69, 0, 50, 0),
(263, 3, 42, 0, 51, 1),
(264, 3, 67, 0, 51, 1),
(265, 3, 50, 0, 51, NULL),
(266, 3, 51, 0, 51, 0),
(267, 3, 68, 0, 51, 0),
(268, 3, 69, 0, 51, 0),
(269, 3, 42, 0, 52, 1),
(270, 3, 67, 0, 52, 1),
(271, 3, 50, 0, 52, NULL),
(272, 3, 51, 0, 52, 0),
(273, 3, 68, 0, 52, 0),
(274, 3, 69, 0, 52, 0),
(275, 3, 42, 0, 53, 1),
(276, 3, 67, 0, 53, 1),
(277, 3, 50, 0, 53, NULL),
(278, 3, 51, 0, 53, 0),
(279, 3, 68, 0, 53, 0),
(280, 3, 69, 0, 53, 0),
(281, 3, 42, 0, 54, 1),
(282, 3, 67, 0, 54, 1),
(283, 3, 50, 0, 54, NULL),
(284, 3, 51, 0, 54, 0),
(285, 3, 68, 0, 54, 0),
(286, 3, 69, 0, 54, 0),
(287, 3, 42, 0, 55, 1),
(288, 3, 67, 0, 55, 1),
(289, 3, 50, 0, 55, NULL),
(290, 3, 51, 0, 55, 0),
(291, 3, 68, 0, 55, 0),
(292, 3, 69, 0, 55, 0),
(293, 3, 42, 0, 56, 1),
(294, 3, 67, 0, 56, 1),
(295, 3, 50, 0, 56, NULL),
(296, 3, 51, 0, 56, 0),
(297, 3, 68, 0, 56, 0),
(298, 3, 69, 0, 56, 0),
(299, 3, 42, 0, 57, 1),
(300, 3, 67, 0, 57, 1),
(301, 3, 50, 0, 57, NULL),
(302, 3, 51, 0, 57, 0),
(303, 3, 68, 0, 57, 0),
(304, 3, 69, 0, 57, 0),
(305, 3, 42, 0, 58, 1),
(306, 3, 67, 0, 58, 1),
(307, 3, 50, 0, 58, NULL),
(308, 3, 51, 0, 58, 0),
(309, 3, 68, 0, 58, 0),
(310, 3, 69, 0, 58, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity_text` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` text COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Text Attribute Backend Table' AUTO_INCREMENT=801 ;

INSERT INTO `#__catalog_category_entity_text` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(1, 3, 65, 0, 1, NULL),
(2, 3, 65, 1, 1, NULL),
(3, 3, 65, 0, 2, NULL),
(4, 3, 65, 1, 2, NULL),
(5, 3, 44, 0, 3, NULL),
(6, 3, 47, 0, 3, NULL),
(7, 3, 48, 0, 3, NULL),
(8, 3, 65, 0, 3, NULL),
(9, 3, 138, 0, 3, NULL),
(10, 3, 139, 0, 3, NULL),
(11, 3, 140, 0, 3, NULL),
(12, 3, 44, 0, 4, NULL),
(13, 3, 47, 0, 4, NULL),
(14, 3, 48, 0, 4, NULL),
(15, 3, 138, 0, 4, NULL),
(16, 3, 139, 0, 4, NULL),
(17, 3, 140, 0, 4, NULL),
(18, 3, 65, 0, 4, NULL),
(19, 3, 44, 0, 5, NULL),
(20, 3, 47, 0, 5, NULL),
(21, 3, 48, 0, 5, NULL),
(22, 3, 138, 0, 5, NULL),
(23, 3, 139, 0, 5, NULL),
(24, 3, 140, 0, 5, NULL),
(25, 3, 65, 0, 5, NULL),
(26, 3, 44, 0, 6, NULL),
(27, 3, 47, 0, 6, NULL),
(28, 3, 48, 0, 6, NULL),
(29, 3, 138, 0, 6, NULL),
(30, 3, 139, 0, 6, NULL),
(31, 3, 140, 0, 6, NULL),
(32, 3, 65, 0, 6, NULL),
(33, 3, 44, 0, 7, NULL),
(34, 3, 47, 0, 7, NULL),
(35, 3, 48, 0, 7, NULL),
(36, 3, 138, 0, 7, NULL),
(37, 3, 139, 0, 7, NULL),
(38, 3, 140, 0, 7, NULL),
(39, 3, 65, 0, 7, NULL),
(40, 3, 44, 0, 8, NULL),
(41, 3, 47, 0, 8, NULL),
(42, 3, 48, 0, 8, NULL),
(43, 3, 138, 0, 8, NULL),
(44, 3, 139, 0, 8, NULL),
(45, 3, 140, 0, 8, NULL),
(46, 3, 65, 0, 8, NULL),
(47, 3, 44, 0, 9, NULL),
(48, 3, 47, 0, 9, NULL),
(49, 3, 48, 0, 9, NULL),
(50, 3, 138, 0, 9, NULL),
(51, 3, 139, 0, 9, NULL),
(52, 3, 140, 0, 9, NULL),
(53, 3, 65, 0, 9, NULL),
(54, 3, 44, 0, 10, NULL),
(55, 3, 47, 0, 10, NULL),
(56, 3, 48, 0, 10, NULL),
(57, 3, 138, 0, 10, NULL),
(58, 3, 139, 0, 10, NULL),
(59, 3, 140, 0, 10, NULL),
(60, 3, 65, 0, 10, NULL),
(61, 3, 44, 0, 11, NULL),
(62, 3, 47, 0, 11, NULL),
(63, 3, 48, 0, 11, NULL),
(64, 3, 138, 0, 11, NULL),
(65, 3, 139, 0, 11, NULL),
(66, 3, 140, 0, 11, NULL),
(67, 3, 65, 0, 11, NULL),
(68, 3, 44, 0, 12, NULL),
(69, 3, 47, 0, 12, NULL),
(70, 3, 48, 0, 12, NULL),
(71, 3, 138, 0, 12, NULL),
(72, 3, 139, 0, 12, NULL),
(73, 3, 140, 0, 12, NULL),
(74, 3, 65, 0, 12, NULL),
(75, 3, 44, 0, 13, NULL),
(76, 3, 47, 0, 13, NULL),
(77, 3, 48, 0, 13, NULL),
(78, 3, 138, 0, 13, NULL),
(79, 3, 139, 0, 13, NULL),
(80, 3, 140, 0, 13, NULL),
(81, 3, 65, 0, 13, NULL),
(82, 3, 44, 0, 14, NULL),
(83, 3, 47, 0, 14, NULL),
(84, 3, 48, 0, 14, NULL),
(85, 3, 138, 0, 14, NULL),
(86, 3, 139, 0, 14, NULL),
(87, 3, 140, 0, 14, NULL),
(88, 3, 65, 0, 14, NULL),
(89, 3, 44, 0, 15, NULL),
(90, 3, 47, 0, 15, NULL),
(91, 3, 48, 0, 15, NULL),
(92, 3, 138, 0, 15, NULL),
(93, 3, 139, 0, 15, NULL),
(94, 3, 140, 0, 15, NULL),
(95, 3, 65, 0, 15, NULL),
(96, 3, 44, 0, 16, NULL),
(97, 3, 47, 0, 16, NULL),
(98, 3, 48, 0, 16, NULL),
(99, 3, 138, 0, 16, NULL),
(100, 3, 139, 0, 16, NULL),
(101, 3, 140, 0, 16, NULL),
(102, 3, 65, 0, 16, NULL),
(103, 3, 44, 0, 17, NULL),
(104, 3, 47, 0, 17, NULL),
(105, 3, 48, 0, 17, NULL),
(106, 3, 138, 0, 17, NULL),
(107, 3, 139, 0, 17, NULL),
(108, 3, 140, 0, 17, NULL),
(109, 3, 65, 0, 17, NULL),
(110, 3, 44, 0, 18, NULL),
(111, 3, 47, 0, 18, NULL),
(112, 3, 48, 0, 18, NULL),
(113, 3, 138, 0, 18, NULL),
(114, 3, 139, 0, 18, NULL),
(115, 3, 140, 0, 18, NULL),
(116, 3, 65, 0, 18, NULL),
(117, 3, 44, 0, 19, NULL),
(118, 3, 47, 0, 19, NULL),
(119, 3, 48, 0, 19, NULL),
(120, 3, 138, 0, 19, NULL),
(121, 3, 139, 0, 19, NULL),
(122, 3, 140, 0, 19, NULL),
(123, 3, 65, 0, 19, NULL),
(124, 3, 44, 0, 20, NULL),
(125, 3, 47, 0, 20, NULL),
(126, 3, 48, 0, 20, NULL),
(127, 3, 138, 0, 20, NULL),
(128, 3, 139, 0, 20, NULL),
(129, 3, 140, 0, 20, NULL),
(130, 3, 65, 0, 20, NULL),
(131, 3, 44, 0, 21, NULL),
(132, 3, 47, 0, 21, NULL),
(133, 3, 48, 0, 21, NULL),
(134, 3, 138, 0, 21, NULL),
(135, 3, 139, 0, 21, NULL),
(136, 3, 140, 0, 21, NULL),
(137, 3, 65, 0, 21, NULL),
(138, 3, 44, 0, 22, NULL),
(139, 3, 47, 0, 22, NULL),
(140, 3, 48, 0, 22, NULL),
(141, 3, 138, 0, 22, NULL),
(142, 3, 139, 0, 22, NULL),
(143, 3, 140, 0, 22, NULL),
(144, 3, 65, 0, 22, NULL),
(145, 3, 44, 0, 23, NULL),
(146, 3, 47, 0, 23, NULL),
(147, 3, 48, 0, 23, NULL),
(148, 3, 138, 0, 23, NULL),
(149, 3, 139, 0, 23, NULL),
(150, 3, 140, 0, 23, NULL),
(151, 3, 65, 0, 23, NULL),
(152, 3, 44, 0, 24, NULL),
(153, 3, 47, 0, 24, NULL),
(154, 3, 48, 0, 24, NULL),
(155, 3, 138, 0, 24, NULL),
(156, 3, 139, 0, 24, NULL),
(157, 3, 140, 0, 24, NULL),
(158, 3, 65, 0, 24, NULL),
(159, 3, 44, 0, 25, NULL),
(160, 3, 47, 0, 25, NULL),
(161, 3, 48, 0, 25, NULL),
(162, 3, 138, 0, 25, NULL),
(163, 3, 139, 0, 25, NULL),
(164, 3, 140, 0, 25, NULL),
(165, 3, 65, 0, 25, NULL),
(166, 3, 44, 0, 26, NULL),
(167, 3, 47, 0, 26, NULL),
(168, 3, 48, 0, 26, NULL),
(169, 3, 138, 0, 26, NULL),
(170, 3, 139, 0, 26, NULL),
(171, 3, 140, 0, 26, NULL),
(172, 3, 65, 0, 26, NULL),
(173, 3, 44, 0, 27, NULL),
(174, 3, 47, 0, 27, NULL),
(175, 3, 48, 0, 27, NULL),
(176, 3, 138, 0, 27, NULL),
(177, 3, 139, 0, 27, NULL),
(178, 3, 140, 0, 27, NULL),
(179, 3, 65, 0, 27, NULL),
(180, 3, 44, 0, 28, NULL),
(181, 3, 47, 0, 28, NULL),
(182, 3, 48, 0, 28, NULL),
(183, 3, 138, 0, 28, NULL),
(184, 3, 139, 0, 28, NULL),
(185, 3, 140, 0, 28, NULL),
(186, 3, 65, 0, 28, NULL),
(187, 3, 44, 0, 29, NULL),
(188, 3, 47, 0, 29, NULL),
(189, 3, 48, 0, 29, NULL),
(190, 3, 138, 0, 29, NULL),
(191, 3, 139, 0, 29, NULL),
(192, 3, 140, 0, 29, NULL),
(193, 3, 65, 0, 29, NULL),
(194, 3, 44, 0, 30, NULL),
(195, 3, 47, 0, 30, NULL),
(196, 3, 48, 0, 30, NULL),
(197, 3, 138, 0, 30, NULL),
(198, 3, 139, 0, 30, NULL),
(199, 3, 140, 0, 30, NULL),
(200, 3, 65, 0, 30, NULL),
(201, 3, 44, 0, 31, NULL),
(202, 3, 47, 0, 31, NULL),
(203, 3, 48, 0, 31, NULL),
(204, 3, 138, 0, 31, NULL),
(205, 3, 139, 0, 31, NULL),
(206, 3, 140, 0, 31, NULL),
(207, 3, 65, 0, 31, NULL),
(208, 3, 44, 0, 32, NULL),
(209, 3, 47, 0, 32, NULL),
(210, 3, 48, 0, 32, NULL),
(211, 3, 138, 0, 32, NULL),
(212, 3, 139, 0, 32, NULL),
(213, 3, 140, 0, 32, NULL),
(214, 3, 65, 0, 32, NULL),
(215, 3, 44, 0, 33, NULL),
(216, 3, 47, 0, 33, NULL),
(217, 3, 48, 0, 33, NULL),
(218, 3, 138, 0, 33, NULL),
(219, 3, 139, 0, 33, NULL),
(220, 3, 140, 0, 33, NULL),
(221, 3, 65, 0, 33, NULL),
(222, 3, 44, 0, 34, NULL),
(223, 3, 47, 0, 34, NULL),
(224, 3, 48, 0, 34, NULL),
(225, 3, 138, 0, 34, NULL),
(226, 3, 139, 0, 34, NULL),
(227, 3, 140, 0, 34, NULL),
(228, 3, 65, 0, 34, NULL),
(229, 3, 44, 0, 35, NULL),
(230, 3, 47, 0, 35, NULL),
(231, 3, 48, 0, 35, NULL),
(232, 3, 138, 0, 35, NULL),
(233, 3, 139, 0, 35, NULL),
(234, 3, 140, 0, 35, NULL),
(235, 3, 65, 0, 35, NULL),
(236, 3, 44, 0, 36, NULL),
(237, 3, 47, 0, 36, NULL),
(238, 3, 48, 0, 36, NULL),
(239, 3, 138, 0, 36, NULL),
(240, 3, 139, 0, 36, NULL),
(241, 3, 140, 0, 36, NULL),
(242, 3, 65, 0, 36, NULL),
(243, 3, 44, 0, 37, NULL),
(244, 3, 47, 0, 37, NULL),
(245, 3, 48, 0, 37, NULL),
(246, 3, 138, 0, 37, NULL),
(247, 3, 139, 0, 37, NULL),
(248, 3, 140, 0, 37, NULL),
(249, 3, 65, 0, 37, NULL),
(250, 3, 44, 0, 38, NULL),
(251, 3, 47, 0, 38, NULL),
(252, 3, 48, 0, 38, NULL),
(253, 3, 138, 0, 38, NULL),
(254, 3, 139, 0, 38, NULL),
(255, 3, 140, 0, 38, NULL),
(256, 3, 65, 0, 38, NULL),
(257, 3, 44, 0, 39, NULL),
(258, 3, 47, 0, 39, NULL),
(259, 3, 48, 0, 39, NULL),
(260, 3, 138, 0, 39, NULL),
(261, 3, 139, 0, 39, NULL),
(262, 3, 140, 0, 39, NULL),
(263, 3, 65, 0, 39, NULL),
(264, 3, 44, 0, 40, NULL),
(265, 3, 47, 0, 40, NULL),
(266, 3, 48, 0, 40, NULL),
(267, 3, 138, 0, 40, NULL),
(268, 3, 139, 0, 40, NULL),
(269, 3, 140, 0, 40, NULL),
(270, 3, 65, 0, 40, NULL),
(271, 3, 44, 0, 41, NULL),
(272, 3, 47, 0, 41, NULL),
(273, 3, 48, 0, 41, NULL),
(274, 3, 138, 0, 41, NULL),
(275, 3, 139, 0, 41, NULL),
(276, 3, 140, 0, 41, NULL),
(277, 3, 65, 0, 41, NULL),
(278, 3, 149, 0, 3, NULL),
(279, 3, 150, 0, 3, NULL),
(280, 3, 151, 0, 3, NULL),
(288, 3, 149, 0, 4, '<div class="row">\r\n    <div class="col-sm-6">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs </span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-6">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Platters </span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>'),
(289, 3, 150, 0, 4, NULL),
(290, 3, 151, 0, 4, NULL),
(295, 3, 149, 0, 5, NULL),
(296, 3, 150, 0, 5, NULL),
(297, 3, 151, 0, 5, NULL),
(302, 3, 149, 0, 6, NULL),
(303, 3, 150, 0, 6, NULL),
(304, 3, 151, 0, 6, NULL),
(309, 3, 44, 0, 42, NULL),
(310, 3, 47, 0, 42, NULL),
(311, 3, 48, 0, 42, NULL),
(312, 3, 62, 0, 42, NULL),
(313, 3, 149, 0, 42, NULL),
(314, 3, 150, 0, 42, NULL),
(315, 3, 151, 0, 42, NULL),
(316, 3, 65, 0, 42, NULL),
(317, 3, 44, 0, 43, NULL),
(318, 3, 47, 0, 43, NULL),
(319, 3, 48, 0, 43, NULL),
(320, 3, 62, 0, 43, NULL),
(321, 3, 149, 0, 43, NULL),
(322, 3, 150, 0, 43, NULL),
(323, 3, 151, 0, 43, NULL),
(324, 3, 65, 0, 43, NULL),
(325, 3, 44, 0, 44, NULL),
(326, 3, 47, 0, 44, NULL),
(327, 3, 48, 0, 44, NULL),
(328, 3, 62, 0, 44, NULL),
(329, 3, 149, 0, 44, '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>'),
(330, 3, 150, 0, 44, NULL),
(331, 3, 151, 0, 44, '<div class="row">\r\n<div class="col-sm-4"><a href="#" class="banner"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-8">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n'),
(332, 3, 65, 0, 44, NULL),
(333, 3, 44, 0, 45, NULL),
(334, 3, 47, 0, 45, NULL),
(335, 3, 48, 0, 45, NULL),
(336, 3, 62, 0, 45, NULL),
(337, 3, 149, 0, 45, NULL),
(338, 3, 150, 0, 45, NULL),
(339, 3, 151, 0, 45, NULL),
(340, 3, 65, 0, 45, NULL),
(341, 3, 44, 0, 46, NULL),
(342, 3, 47, 0, 46, NULL),
(343, 3, 48, 0, 46, NULL),
(344, 3, 62, 0, 46, NULL),
(345, 3, 149, 0, 46, NULL),
(346, 3, 150, 0, 46, NULL),
(347, 3, 151, 0, 46, NULL),
(348, 3, 65, 0, 46, NULL),
(349, 3, 44, 0, 47, NULL),
(350, 3, 47, 0, 47, NULL),
(351, 3, 48, 0, 47, NULL),
(352, 3, 62, 0, 47, NULL),
(353, 3, 149, 0, 47, NULL),
(354, 3, 150, 0, 47, NULL),
(355, 3, 151, 0, 47, NULL),
(356, 3, 65, 0, 47, NULL),
(357, 3, 44, 0, 48, NULL),
(358, 3, 47, 0, 48, NULL),
(359, 3, 48, 0, 48, NULL),
(360, 3, 62, 0, 48, NULL),
(361, 3, 149, 0, 48, NULL),
(362, 3, 150, 0, 48, NULL),
(363, 3, 151, 0, 48, NULL),
(364, 3, 65, 0, 48, NULL),
(365, 3, 44, 0, 49, NULL),
(366, 3, 47, 0, 49, NULL),
(367, 3, 48, 0, 49, NULL),
(368, 3, 62, 0, 49, NULL),
(369, 3, 149, 0, 49, NULL),
(370, 3, 150, 0, 49, NULL),
(371, 3, 151, 0, 49, NULL),
(372, 3, 65, 0, 49, NULL),
(373, 3, 44, 0, 50, NULL),
(374, 3, 47, 0, 50, NULL),
(375, 3, 48, 0, 50, NULL),
(376, 3, 62, 0, 50, NULL),
(377, 3, 149, 0, 50, NULL),
(378, 3, 150, 0, 50, NULL),
(379, 3, 151, 0, 50, NULL),
(380, 3, 65, 0, 50, NULL),
(400, 3, 44, 0, 51, NULL),
(401, 3, 47, 0, 51, NULL),
(402, 3, 48, 0, 51, NULL),
(403, 3, 62, 0, 51, NULL),
(404, 3, 149, 0, 51, NULL),
(405, 3, 150, 0, 51, NULL),
(406, 3, 151, 0, 51, NULL),
(407, 3, 65, 0, 51, NULL),
(408, 3, 44, 0, 52, NULL),
(409, 3, 47, 0, 52, NULL),
(410, 3, 48, 0, 52, NULL),
(411, 3, 62, 0, 52, NULL),
(412, 3, 149, 0, 52, NULL),
(413, 3, 150, 0, 52, NULL),
(414, 3, 151, 0, 52, NULL),
(415, 3, 65, 0, 52, NULL),
(416, 3, 44, 0, 53, NULL),
(417, 3, 47, 0, 53, NULL),
(418, 3, 48, 0, 53, NULL),
(419, 3, 62, 0, 53, NULL),
(420, 3, 149, 0, 53, NULL),
(421, 3, 150, 0, 53, NULL),
(422, 3, 151, 0, 53, NULL),
(423, 3, 65, 0, 53, NULL),
(424, 3, 44, 0, 54, NULL),
(425, 3, 47, 0, 54, NULL),
(426, 3, 48, 0, 54, NULL),
(427, 3, 62, 0, 54, NULL),
(428, 3, 149, 0, 54, NULL),
(429, 3, 150, 0, 54, NULL),
(430, 3, 151, 0, 54, NULL),
(431, 3, 65, 0, 54, NULL),
(607, 3, 149, 0, 33, NULL),
(608, 3, 150, 0, 33, NULL),
(609, 3, 151, 0, 33, NULL),
(614, 3, 149, 0, 9, NULL),
(615, 3, 150, 0, 9, NULL),
(616, 3, 151, 0, 9, NULL),
(621, 3, 149, 0, 19, NULL),
(622, 3, 150, 0, 19, NULL),
(623, 3, 151, 0, 19, NULL),
(624, 3, 44, 0, 55, NULL),
(625, 3, 47, 0, 55, NULL),
(626, 3, 48, 0, 55, NULL),
(627, 3, 62, 0, 55, NULL),
(628, 3, 149, 0, 55, NULL),
(629, 3, 150, 0, 55, NULL),
(630, 3, 151, 0, 55, NULL),
(631, 3, 65, 0, 55, NULL),
(632, 3, 44, 0, 56, NULL),
(633, 3, 47, 0, 56, NULL),
(634, 3, 48, 0, 56, NULL),
(635, 3, 62, 0, 56, NULL),
(636, 3, 149, 0, 56, NULL),
(637, 3, 150, 0, 56, NULL),
(638, 3, 151, 0, 56, NULL),
(639, 3, 65, 0, 56, NULL),
(640, 3, 44, 0, 57, NULL),
(641, 3, 47, 0, 57, NULL),
(642, 3, 48, 0, 57, NULL),
(643, 3, 62, 0, 57, NULL),
(644, 3, 149, 0, 57, NULL),
(645, 3, 150, 0, 57, NULL),
(646, 3, 151, 0, 57, NULL),
(647, 3, 65, 0, 57, NULL),
(728, 3, 149, 0, 40, NULL),
(729, 3, 150, 0, 40, NULL),
(730, 3, 151, 0, 40, NULL),
(731, 3, 160, 0, 3, NULL),
(732, 3, 161, 0, 3, NULL),
(733, 3, 162, 0, 3, NULL),
(738, 3, 160, 0, 4, NULL),
(739, 3, 161, 0, 4, NULL),
(740, 3, 162, 0, 4, NULL),
(745, 3, 160, 0, 44, '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>'),
(746, 3, 161, 0, 44, NULL),
(747, 3, 162, 0, 44, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n'),
(760, 3, 160, 0, 5, '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>'),
(761, 3, 161, 0, 5, NULL),
(762, 3, 162, 0, 5, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n'),
(767, 3, 160, 0, 6, NULL),
(768, 3, 161, 0, 6, NULL),
(769, 3, 162, 0, 6, NULL),
(774, 3, 160, 0, 42, NULL),
(775, 3, 161, 0, 42, NULL),
(776, 3, 162, 0, 42, NULL),
(782, 3, 160, 0, 43, NULL),
(783, 3, 161, 0, 43, NULL),
(784, 3, 162, 0, 43, NULL),
(790, 3, 160, 0, 45, NULL),
(791, 3, 161, 0, 45, NULL),
(792, 3, 162, 0, 45, NULL),
(793, 3, 44, 0, 58, NULL),
(794, 3, 47, 0, 58, NULL),
(795, 3, 48, 0, 58, NULL),
(796, 3, 62, 0, 58, NULL),
(797, 3, 160, 0, 58, NULL),
(798, 3, 161, 0, 58, NULL),
(799, 3, 162, 0, 58, NULL),
(800, 3, 65, 0, 58, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_category_entity_varchar` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Category Varchar Attribute Backend Table' AUTO_INCREMENT=1206 ;

INSERT INTO `#__catalog_category_entity_varchar` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(1, 3, 41, 0, 1, 'Root Catalog'),
(2, 3, 41, 1, 1, 'Root Catalog'),
(3, 3, 43, 1, 1, 'root-catalog'),
(4, 3, 41, 0, 2, 'Default Category'),
(5, 3, 41, 1, 2, 'Default Category'),
(6, 3, 49, 1, 2, 'PRODUCTS'),
(7, 3, 43, 1, 2, 'default-category'),
(8, 3, 41, 0, 3, 'Fashion'),
(9, 3, 46, 0, 3, NULL),
(10, 3, 49, 0, 3, 'PRODUCTS'),
(11, 3, 43, 0, 3, 'men'),
(12, 3, 57, 1, 3, 'men.html'),
(13, 3, 57, 0, 3, 'men.html'),
(14, 3, 142, 0, 3, NULL),
(15, 3, 141, 0, 3, NULL),
(16, 3, 132, 0, 3, '0'),
(17, 3, 133, 0, 3, NULL),
(18, 3, 134, 0, 3, '0'),
(19, 3, 135, 0, 3, '1'),
(20, 3, 136, 0, 3, '1'),
(21, 3, 137, 0, 3, '0'),
(22, 3, 41, 0, 4, 'Smartphone'),
(23, 3, 142, 0, 4, NULL),
(24, 3, 141, 0, 4, NULL),
(25, 3, 43, 0, 4, 'women'),
(26, 3, 46, 0, 4, NULL),
(27, 3, 49, 0, 4, 'PRODUCTS_AND_PAGE'),
(28, 3, 132, 0, 4, '0'),
(29, 3, 133, 0, 4, NULL),
(30, 3, 134, 0, 4, '0'),
(31, 3, 135, 0, 4, '1'),
(32, 3, 136, 0, 4, '1'),
(33, 3, 137, 0, 4, '0'),
(34, 3, 41, 0, 5, 'Sporst'),
(35, 3, 142, 0, 5, NULL),
(36, 3, 141, 0, 5, NULL),
(37, 3, 43, 0, 5, 'kid'),
(38, 3, 46, 0, 5, NULL),
(39, 3, 49, 0, 5, 'PRODUCTS'),
(40, 3, 132, 0, 5, '0'),
(41, 3, 133, 0, 5, NULL),
(42, 3, 134, 0, 5, '0'),
(43, 3, 135, 0, 5, '1'),
(44, 3, 136, 0, 5, '1'),
(45, 3, 137, 0, 5, '0'),
(46, 3, 57, 1, 5, 'kid.html'),
(47, 3, 57, 0, 5, 'kid.html'),
(48, 3, 41, 0, 6, 'PlayStation'),
(49, 3, 142, 0, 6, NULL),
(50, 3, 141, 0, 6, NULL),
(51, 3, 46, 0, 6, NULL),
(52, 3, 49, 0, 6, 'PRODUCTS'),
(53, 3, 132, 0, 6, '0'),
(54, 3, 133, 0, 6, NULL),
(55, 3, 134, 0, 6, '0'),
(56, 3, 135, 0, 6, '1'),
(57, 3, 136, 0, 6, '1'),
(58, 3, 137, 0, 6, '0'),
(59, 3, 43, 0, 6, 'accessories'),
(60, 3, 57, 1, 6, 'accessories.html'),
(61, 3, 57, 0, 6, 'accessories-17.html'),
(62, 3, 57, 1, 4, 'women.html'),
(63, 3, 57, 0, 4, 'women.html'),
(64, 3, 41, 0, 7, 'Rings'),
(65, 3, 142, 0, 7, NULL),
(66, 3, 141, 0, 7, NULL),
(67, 3, 43, 0, 7, 'rings'),
(68, 3, 46, 0, 7, NULL),
(69, 3, 49, 0, 7, 'PRODUCTS'),
(70, 3, 132, 0, 7, '0'),
(71, 3, 133, 0, 7, NULL),
(72, 3, 134, 0, 7, '0'),
(73, 3, 135, 0, 7, '1'),
(74, 3, 136, 0, 7, '1'),
(75, 3, 137, 0, 7, '0'),
(76, 3, 57, 1, 7, 'women/bags/shoes/rings.html'),
(77, 3, 57, 0, 7, 'women/bags/shoes/rings.html'),
(78, 3, 41, 0, 8, 'Shoes'),
(79, 3, 142, 0, 8, NULL),
(80, 3, 141, 0, 8, NULL),
(81, 3, 46, 0, 8, NULL),
(82, 3, 49, 0, 8, 'PRODUCTS'),
(83, 3, 132, 0, 8, '0'),
(84, 3, 133, 0, 8, NULL),
(85, 3, 134, 0, 8, '0'),
(86, 3, 135, 0, 8, '1'),
(87, 3, 136, 0, 8, '1'),
(88, 3, 137, 0, 8, '0'),
(89, 3, 43, 0, 8, 'shoes'),
(90, 3, 57, 1, 8, 'women/bags/shoes.html'),
(91, 3, 57, 0, 8, 'women/bags/shoes.html'),
(92, 3, 41, 0, 9, 'Shapewear'),
(93, 3, 142, 0, 9, NULL),
(94, 3, 141, 0, 9, NULL),
(95, 3, 43, 0, 9, 'shapewear'),
(96, 3, 46, 0, 9, NULL),
(97, 3, 49, 0, 9, 'PRODUCTS'),
(98, 3, 132, 0, 9, '0'),
(99, 3, 133, 0, 9, NULL),
(100, 3, 134, 0, 9, '0'),
(101, 3, 135, 0, 9, '1'),
(102, 3, 136, 0, 9, '1'),
(103, 3, 137, 0, 9, '0'),
(104, 3, 57, 1, 9, 'women/shapewear.html'),
(105, 3, 57, 0, 9, 'women/shapewear.html'),
(106, 3, 41, 0, 10, 'Sundresses'),
(107, 3, 142, 0, 10, NULL),
(108, 3, 141, 0, 10, NULL),
(109, 3, 43, 0, 10, 'sundresses'),
(110, 3, 46, 0, 10, NULL),
(111, 3, 49, 0, 10, 'PRODUCTS'),
(112, 3, 132, 0, 10, '0'),
(113, 3, 133, 0, 10, NULL),
(114, 3, 134, 0, 10, '0'),
(115, 3, 135, 0, 10, '1'),
(116, 3, 136, 0, 10, '1'),
(117, 3, 137, 0, 10, '0'),
(118, 3, 57, 1, 10, 'women/shapewear/sundresses.html'),
(119, 3, 57, 0, 10, 'women/shapewear/sundresses.html'),
(120, 3, 41, 0, 11, 'Footwear'),
(121, 3, 142, 0, 11, NULL),
(122, 3, 141, 0, 11, NULL),
(123, 3, 43, 0, 11, 'footwear'),
(124, 3, 46, 0, 11, NULL),
(125, 3, 49, 0, 11, 'PRODUCTS'),
(126, 3, 132, 0, 11, '0'),
(127, 3, 133, 0, 11, NULL),
(128, 3, 134, 0, 11, '0'),
(129, 3, 135, 0, 11, '1'),
(130, 3, 136, 0, 11, '1'),
(131, 3, 137, 0, 11, '0'),
(132, 3, 57, 1, 11, 'women/shapewear/footwear.html'),
(133, 3, 57, 0, 11, 'women/shapewear/footwear.html'),
(134, 3, 41, 0, 12, 'Novelty'),
(135, 3, 142, 0, 12, NULL),
(136, 3, 141, 0, 12, NULL),
(137, 3, 43, 0, 12, 'novelty'),
(138, 3, 46, 0, 12, NULL),
(139, 3, 49, 0, 12, 'PRODUCTS'),
(140, 3, 132, 0, 12, '0'),
(141, 3, 133, 0, 12, NULL),
(142, 3, 134, 0, 12, '0'),
(143, 3, 135, 0, 12, '1'),
(144, 3, 136, 0, 12, '1'),
(145, 3, 137, 0, 12, '0'),
(146, 3, 57, 1, 12, 'women/shapewear/novelty.html'),
(147, 3, 57, 0, 12, 'women/shapewear/novelty.html'),
(148, 3, 41, 0, 13, 'Outerwear'),
(149, 3, 142, 0, 13, NULL),
(150, 3, 141, 0, 13, NULL),
(151, 3, 43, 0, 13, 'outerwear'),
(152, 3, 46, 0, 13, NULL),
(153, 3, 49, 0, 13, 'PRODUCTS'),
(154, 3, 132, 0, 13, '0'),
(155, 3, 133, 0, 13, NULL),
(156, 3, 134, 0, 13, '0'),
(157, 3, 135, 0, 13, '1'),
(158, 3, 136, 0, 13, '1'),
(159, 3, 137, 0, 13, '0'),
(160, 3, 57, 1, 13, 'women/shapewear/outerwear.html'),
(161, 3, 57, 0, 13, 'women/shapewear/outerwear.html'),
(162, 3, 41, 0, 14, 'Hats'),
(163, 3, 142, 0, 14, NULL),
(164, 3, 141, 0, 14, NULL),
(165, 3, 43, 0, 14, 'hats'),
(166, 3, 46, 0, 14, NULL),
(167, 3, 49, 0, 14, 'PRODUCTS'),
(168, 3, 132, 0, 14, '0'),
(169, 3, 133, 0, 14, NULL),
(170, 3, 134, 0, 14, '0'),
(171, 3, 135, 0, 14, '1'),
(172, 3, 136, 0, 14, '1'),
(173, 3, 137, 0, 14, '0'),
(174, 3, 57, 1, 14, 'women/shapewear/hats.html'),
(175, 3, 57, 0, 14, 'women/shapewear/hats.html'),
(176, 3, 41, 0, 15, 'Gloves'),
(177, 3, 142, 0, 15, NULL),
(178, 3, 141, 0, 15, NULL),
(179, 3, 43, 0, 15, 'gloves'),
(180, 3, 46, 0, 15, NULL),
(181, 3, 49, 0, 15, 'PRODUCTS'),
(182, 3, 132, 0, 15, '0'),
(183, 3, 133, 0, 15, NULL),
(184, 3, 134, 0, 15, '0'),
(185, 3, 135, 0, 15, '1'),
(186, 3, 136, 0, 15, '1'),
(187, 3, 137, 0, 15, '0'),
(188, 3, 57, 1, 15, 'women/bags/shoes/gloves.html'),
(189, 3, 57, 0, 15, 'women/bags/shoes/gloves.html'),
(190, 3, 41, 0, 16, 'Leathers'),
(191, 3, 142, 0, 16, NULL),
(192, 3, 141, 0, 16, NULL),
(193, 3, 43, 0, 16, 'leathers'),
(194, 3, 46, 0, 16, NULL),
(195, 3, 49, 0, 16, 'PRODUCTS'),
(196, 3, 132, 0, 16, '0'),
(197, 3, 133, 0, 16, NULL),
(198, 3, 134, 0, 16, '0'),
(199, 3, 135, 0, 16, '1'),
(200, 3, 136, 0, 16, '1'),
(201, 3, 137, 0, 16, '0'),
(202, 3, 57, 1, 16, 'women/bags/shoes/leathers.html'),
(203, 3, 57, 0, 16, 'women/bags/shoes/leathers.html'),
(204, 3, 41, 0, 17, 'Cocktail'),
(205, 3, 142, 0, 17, NULL),
(206, 3, 141, 0, 17, NULL),
(207, 3, 43, 0, 17, 'cocktail'),
(208, 3, 46, 0, 17, NULL),
(209, 3, 49, 0, 17, 'PRODUCTS'),
(210, 3, 132, 0, 17, '0'),
(211, 3, 133, 0, 17, NULL),
(212, 3, 134, 0, 17, '0'),
(213, 3, 135, 0, 17, '1'),
(214, 3, 136, 0, 17, '1'),
(215, 3, 137, 0, 17, '0'),
(216, 3, 57, 1, 17, 'women/bags/shoes/cocktail.html'),
(217, 3, 57, 0, 17, 'women/bags/shoes/cocktail.html'),
(218, 3, 41, 0, 18, 'Bands'),
(219, 3, 142, 0, 18, NULL),
(220, 3, 141, 0, 18, NULL),
(221, 3, 43, 0, 18, 'bands'),
(222, 3, 46, 0, 18, NULL),
(223, 3, 49, 0, 18, 'PRODUCTS'),
(224, 3, 132, 0, 18, '0'),
(225, 3, 133, 0, 18, NULL),
(226, 3, 134, 0, 18, '0'),
(227, 3, 135, 0, 18, '1'),
(228, 3, 136, 0, 18, '1'),
(229, 3, 137, 0, 18, '0'),
(230, 3, 57, 1, 18, 'women/bags/bands.html'),
(231, 3, 57, 0, 18, 'women/bags/bands.html'),
(232, 3, 41, 0, 19, 'Bicycle'),
(233, 3, 142, 0, 19, NULL),
(234, 3, 141, 0, 19, NULL),
(235, 3, 43, 0, 19, 'bicycle'),
(236, 3, 46, 0, 19, NULL),
(237, 3, 49, 0, 19, 'PRODUCTS'),
(238, 3, 132, 0, 19, '0'),
(239, 3, 133, 0, 19, NULL),
(240, 3, 134, 0, 19, '0'),
(241, 3, 135, 0, 19, '1'),
(242, 3, 136, 0, 19, '1'),
(243, 3, 137, 0, 19, '0'),
(244, 3, 57, 1, 19, 'tv-audio/bicycle.html'),
(245, 3, 57, 0, 19, 'tv-audio/bicycle.html'),
(246, 3, 41, 0, 20, 'Jackets'),
(247, 3, 142, 0, 20, NULL),
(248, 3, 141, 0, 20, NULL),
(249, 3, 43, 0, 20, 'jackets'),
(250, 3, 46, 0, 20, NULL),
(251, 3, 49, 0, 20, 'PRODUCTS'),
(252, 3, 132, 0, 20, '0'),
(253, 3, 133, 0, 20, NULL),
(254, 3, 134, 0, 20, '0'),
(255, 3, 135, 0, 20, '1'),
(256, 3, 136, 0, 20, '1'),
(257, 3, 137, 0, 20, '0'),
(258, 3, 57, 1, 20, 'tv-audio/bicycle/jackets.html'),
(259, 3, 57, 0, 20, 'tv-audio/bicycle/jackets.html'),
(260, 3, 41, 0, 21, 'Hair'),
(261, 3, 142, 0, 21, NULL),
(262, 3, 141, 0, 21, NULL),
(263, 3, 43, 0, 21, 'hair'),
(264, 3, 46, 0, 21, NULL),
(265, 3, 49, 0, 21, 'PRODUCTS'),
(266, 3, 132, 0, 21, '0'),
(267, 3, 133, 0, 21, NULL),
(268, 3, 134, 0, 21, '0'),
(269, 3, 135, 0, 21, '1'),
(270, 3, 136, 0, 21, '1'),
(271, 3, 137, 0, 21, '0'),
(272, 3, 57, 1, 21, 'women/bags/shoes/shirts/hair.html'),
(273, 3, 57, 0, 21, 'women/bags/shoes/shirts/hair.html'),
(274, 3, 41, 0, 22, 'Clothing'),
(275, 3, 142, 0, 22, NULL),
(276, 3, 141, 0, 22, NULL),
(277, 3, 43, 0, 22, 'clothing'),
(278, 3, 46, 0, 22, NULL),
(279, 3, 49, 0, 22, 'PRODUCTS'),
(280, 3, 132, 0, 22, '0'),
(281, 3, 133, 0, 22, NULL),
(282, 3, 134, 0, 22, '0'),
(283, 3, 135, 0, 22, '1'),
(284, 3, 136, 0, 22, '1'),
(285, 3, 137, 0, 22, '0'),
(286, 3, 57, 1, 22, 'women/bags/shoes/clothing.html'),
(287, 3, 57, 0, 22, 'women/bags/shoes/clothing.html'),
(288, 3, 41, 0, 23, 'Blog'),
(289, 3, 142, 0, 23, NULL),
(290, 3, 141, 0, 23, NULL),
(291, 3, 43, 0, 23, 'blog'),
(292, 3, 46, 0, 23, NULL),
(293, 3, 49, 0, 23, 'PRODUCTS'),
(294, 3, 132, 0, 23, '0'),
(295, 3, 133, 0, 23, NULL),
(296, 3, 134, 0, 23, '0'),
(297, 3, 135, 0, 23, '1'),
(298, 3, 136, 0, 23, '1'),
(299, 3, 137, 0, 23, '0'),
(300, 3, 57, 1, 23, 'women/bags/blog.html'),
(301, 3, 57, 0, 23, 'women/bags/blog.html'),
(302, 3, 41, 0, 24, 'Scarves'),
(303, 3, 142, 0, 24, NULL),
(304, 3, 141, 0, 24, NULL),
(305, 3, 43, 0, 24, 'scarves'),
(306, 3, 46, 0, 24, NULL),
(307, 3, 49, 0, 24, 'PRODUCTS'),
(308, 3, 132, 0, 24, '0'),
(309, 3, 133, 0, 24, NULL),
(310, 3, 134, 0, 24, '0'),
(311, 3, 135, 0, 24, '1'),
(312, 3, 136, 0, 24, '1'),
(313, 3, 137, 0, 24, '0'),
(314, 3, 57, 1, 24, 'tv-audio/bicycle/scarves.html'),
(315, 3, 57, 0, 24, 'tv-audio/bicycle/scarves.html'),
(316, 3, 41, 0, 25, 'Lifestyle'),
(317, 3, 142, 0, 25, NULL),
(318, 3, 141, 0, 25, NULL),
(319, 3, 43, 0, 25, 'lifestyle'),
(320, 3, 46, 0, 25, NULL),
(321, 3, 49, 0, 25, 'PRODUCTS'),
(322, 3, 132, 0, 25, '0'),
(323, 3, 133, 0, 25, NULL),
(324, 3, 134, 0, 25, '0'),
(325, 3, 135, 0, 25, '1'),
(326, 3, 136, 0, 25, '1'),
(327, 3, 137, 0, 25, '0'),
(328, 3, 57, 1, 25, 'tv-audio/bicycle/lifestyle.html'),
(329, 3, 57, 0, 25, 'tv-audio/bicycle/lifestyle.html'),
(330, 3, 41, 0, 26, 'Bras'),
(331, 3, 142, 0, 26, NULL),
(332, 3, 141, 0, 26, NULL),
(333, 3, 43, 0, 26, 'bras'),
(334, 3, 46, 0, 26, NULL),
(335, 3, 49, 0, 26, 'PRODUCTS'),
(336, 3, 132, 0, 26, '0'),
(337, 3, 133, 0, 26, NULL),
(338, 3, 134, 0, 26, '0'),
(339, 3, 135, 0, 26, '1'),
(340, 3, 136, 0, 26, '1'),
(341, 3, 137, 0, 26, '0'),
(342, 3, 57, 1, 26, 'accessories/bras.html'),
(343, 3, 57, 0, 26, 'accessories-17/bras.html'),
(344, 3, 41, 0, 27, 'Helmet'),
(345, 3, 142, 0, 27, NULL),
(346, 3, 141, 0, 27, NULL),
(347, 3, 43, 0, 27, 'helmet'),
(348, 3, 46, 0, 27, NULL),
(349, 3, 49, 0, 27, 'PRODUCTS'),
(350, 3, 132, 0, 27, '0'),
(351, 3, 133, 0, 27, NULL),
(352, 3, 134, 0, 27, '0'),
(353, 3, 135, 0, 27, '1'),
(354, 3, 136, 0, 27, '1'),
(355, 3, 137, 0, 27, '0'),
(356, 3, 57, 1, 27, 'women/bags/shoes/shirts/helmet.html'),
(357, 3, 57, 0, 27, 'women/bags/shoes/shirts/helmet.html'),
(358, 3, 41, 0, 28, 'Cosmetics'),
(359, 3, 142, 0, 28, NULL),
(360, 3, 141, 0, 28, NULL),
(361, 3, 43, 0, 28, 'cosmetics'),
(362, 3, 46, 0, 28, NULL),
(363, 3, 49, 0, 28, 'PRODUCTS'),
(364, 3, 132, 0, 28, '0'),
(365, 3, 133, 0, 28, NULL),
(366, 3, 134, 0, 28, '0'),
(367, 3, 135, 0, 28, '1'),
(368, 3, 136, 0, 28, '1'),
(369, 3, 137, 0, 28, '0'),
(370, 3, 57, 1, 28, 'accessories/cosmetics.html'),
(371, 3, 57, 0, 28, 'accessories-17/cosmetics.html'),
(372, 3, 41, 0, 29, 'Camis'),
(373, 3, 142, 0, 29, NULL),
(374, 3, 141, 0, 29, NULL),
(375, 3, 43, 0, 29, 'camis'),
(376, 3, 46, 0, 29, NULL),
(377, 3, 49, 0, 29, 'PRODUCTS'),
(378, 3, 132, 0, 29, '0'),
(379, 3, 133, 0, 29, NULL),
(380, 3, 134, 0, 29, '0'),
(381, 3, 135, 0, 29, '1'),
(382, 3, 136, 0, 29, '1'),
(383, 3, 137, 0, 29, '0'),
(384, 3, 57, 1, 29, 'women/bags/shoes/shirts/camis.html'),
(385, 3, 57, 0, 29, 'women/bags/shoes/shirts/camis.html'),
(386, 3, 41, 0, 30, 'Lingerie'),
(387, 3, 142, 0, 30, NULL),
(388, 3, 141, 0, 30, NULL),
(389, 3, 43, 0, 30, 'lingerie'),
(390, 3, 46, 0, 30, NULL),
(391, 3, 49, 0, 30, 'PRODUCTS'),
(392, 3, 132, 0, 30, '0'),
(393, 3, 133, 0, 30, NULL),
(394, 3, 134, 0, 30, '0'),
(395, 3, 135, 0, 30, '1'),
(396, 3, 136, 0, 30, '1'),
(397, 3, 137, 0, 30, '0'),
(398, 3, 57, 1, 30, 'women/bags/shoes/shirts/lingerie.html'),
(399, 3, 57, 0, 30, 'women/bags/shoes/shirts/lingerie.html'),
(400, 3, 41, 0, 31, 'Shirts'),
(401, 3, 142, 0, 31, NULL),
(402, 3, 141, 0, 31, NULL),
(403, 3, 43, 0, 31, 'shirts'),
(404, 3, 46, 0, 31, NULL),
(405, 3, 49, 0, 31, 'PRODUCTS'),
(406, 3, 132, 0, 31, '0'),
(407, 3, 133, 0, 31, NULL),
(408, 3, 134, 0, 31, '0'),
(409, 3, 135, 0, 31, '1'),
(410, 3, 136, 0, 31, '1'),
(411, 3, 137, 0, 31, '0'),
(412, 3, 57, 1, 31, 'women/bags/shoes/shirts.html'),
(413, 3, 57, 0, 31, 'women/bags/shoes/shirts.html'),
(414, 3, 41, 0, 32, 'Tops'),
(415, 3, 142, 0, 32, NULL),
(416, 3, 141, 0, 32, NULL),
(417, 3, 43, 0, 32, 'tops'),
(418, 3, 46, 0, 32, NULL),
(419, 3, 49, 0, 32, 'PRODUCTS'),
(420, 3, 132, 0, 32, '0'),
(421, 3, 133, 0, 32, NULL),
(422, 3, 134, 0, 32, '0'),
(423, 3, 135, 0, 32, '1'),
(424, 3, 136, 0, 32, '1'),
(425, 3, 137, 0, 32, '0'),
(426, 3, 57, 1, 32, 'women/bags/shoes/shirts/tops.html'),
(427, 3, 57, 0, 32, 'women/bags/shoes/shirts/tops.html'),
(428, 3, 41, 0, 33, 'Bags'),
(429, 3, 142, 0, 33, NULL),
(430, 3, 141, 0, 33, NULL),
(431, 3, 43, 0, 33, 'bags'),
(432, 3, 46, 0, 33, NULL),
(433, 3, 49, 0, 33, 'PRODUCTS'),
(434, 3, 132, 0, 33, '0'),
(435, 3, 133, 0, 33, NULL),
(436, 3, 134, 0, 33, '0'),
(437, 3, 135, 0, 33, '1'),
(438, 3, 136, 0, 33, '1'),
(439, 3, 137, 0, 33, '0'),
(440, 3, 57, 1, 33, 'women/bags.html'),
(441, 3, 57, 0, 33, 'women/bags.html'),
(442, 3, 41, 0, 34, 'Nightwear'),
(443, 3, 142, 0, 34, NULL),
(444, 3, 141, 0, 34, NULL),
(445, 3, 43, 0, 34, 'nightwear'),
(446, 3, 46, 0, 34, NULL),
(447, 3, 49, 0, 34, 'PRODUCTS'),
(448, 3, 132, 0, 34, '0'),
(449, 3, 133, 0, 34, NULL),
(450, 3, 134, 0, 34, '0'),
(451, 3, 135, 0, 34, '1'),
(452, 3, 136, 0, 34, '1'),
(453, 3, 137, 0, 34, '0'),
(454, 3, 57, 1, 34, 'women/bags/nightwear.html'),
(455, 3, 57, 0, 34, 'women/bags/nightwear.html'),
(456, 3, 41, 0, 35, 'Briefs'),
(457, 3, 142, 0, 35, NULL),
(458, 3, 141, 0, 35, NULL),
(459, 3, 43, 0, 35, 'briefs'),
(460, 3, 46, 0, 35, NULL),
(461, 3, 49, 0, 35, 'PRODUCTS'),
(462, 3, 132, 0, 35, '0'),
(463, 3, 133, 0, 35, NULL),
(464, 3, 134, 0, 35, '0'),
(465, 3, 135, 0, 35, '1'),
(466, 3, 136, 0, 35, '1'),
(467, 3, 137, 0, 35, '0'),
(468, 3, 57, 1, 35, 'women/bags/briefs.html'),
(469, 3, 57, 0, 35, 'women/bags/briefs.html'),
(470, 3, 41, 0, 36, 'Duffle'),
(471, 3, 142, 0, 36, NULL),
(472, 3, 141, 0, 36, NULL),
(473, 3, 43, 0, 36, 'duffle'),
(474, 3, 46, 0, 36, NULL),
(475, 3, 49, 0, 36, 'PRODUCTS'),
(476, 3, 132, 0, 36, '0'),
(477, 3, 133, 0, 36, NULL),
(478, 3, 134, 0, 36, '0'),
(479, 3, 135, 0, 36, '1'),
(480, 3, 136, 0, 36, '1'),
(481, 3, 137, 0, 36, '0'),
(482, 3, 57, 1, 36, 'women/bags/duffle.html'),
(483, 3, 57, 0, 36, 'women/bags/duffle.html'),
(484, 3, 41, 0, 37, 'Dresses'),
(485, 3, 142, 0, 37, NULL),
(486, 3, 141, 0, 37, NULL),
(487, 3, 43, 0, 37, 'dresses'),
(488, 3, 46, 0, 37, NULL),
(489, 3, 49, 0, 37, 'PRODUCTS'),
(490, 3, 132, 0, 37, '0'),
(491, 3, 133, 0, 37, NULL),
(492, 3, 134, 0, 37, '0'),
(493, 3, 135, 0, 37, '1'),
(494, 3, 136, 0, 37, '1'),
(495, 3, 137, 0, 37, '0'),
(496, 3, 57, 1, 37, 'women/bags/dresses.html'),
(497, 3, 57, 0, 37, 'women/bags/dresses.html'),
(498, 3, 41, 0, 38, 'Laptop'),
(499, 3, 142, 0, 38, NULL),
(500, 3, 141, 0, 38, NULL),
(501, 3, 43, 0, 38, 'laptop'),
(502, 3, 46, 0, 38, NULL),
(503, 3, 49, 0, 38, 'PRODUCTS'),
(504, 3, 132, 0, 38, '0'),
(505, 3, 133, 0, 38, NULL),
(506, 3, 134, 0, 38, '0'),
(507, 3, 135, 0, 38, '1'),
(508, 3, 136, 0, 38, '1'),
(509, 3, 137, 0, 38, '0'),
(510, 3, 57, 1, 38, 'women/bags/laptop.html'),
(511, 3, 57, 0, 38, 'women/bags/laptop.html'),
(512, 3, 41, 0, 39, 'Cosmetic'),
(513, 3, 142, 0, 39, NULL),
(514, 3, 141, 0, 39, NULL),
(515, 3, 43, 0, 39, 'cosmetic'),
(516, 3, 46, 0, 39, NULL),
(517, 3, 49, 0, 39, 'PRODUCTS'),
(518, 3, 132, 0, 39, '0'),
(519, 3, 133, 0, 39, NULL),
(520, 3, 134, 0, 39, '0'),
(521, 3, 135, 0, 39, '1'),
(522, 3, 136, 0, 39, '1'),
(523, 3, 137, 0, 39, '0'),
(524, 3, 57, 1, 39, 'women/bags/cosmetic.html'),
(525, 3, 57, 0, 39, 'women/bags/cosmetic.html'),
(526, 3, 41, 0, 40, 'Cfg products'),
(527, 3, 142, 0, 40, 'cfg-products'),
(528, 3, 141, 0, 40, NULL),
(529, 3, 46, 0, 40, NULL),
(530, 3, 49, 0, 40, 'PRODUCTS_AND_PAGE'),
(531, 3, 132, 0, 40, '0'),
(532, 3, 133, 0, 40, NULL),
(533, 3, 134, 0, 40, '0'),
(534, 3, 135, 0, 40, '1'),
(535, 3, 136, 0, 40, '1'),
(536, 3, 137, 0, 40, '0'),
(537, 3, 43, 0, 40, 'cfg-products'),
(538, 3, 41, 0, 41, 'Product types'),
(539, 3, 142, 0, 41, 'product-types'),
(540, 3, 141, 0, 41, NULL),
(541, 3, 43, 0, 41, 'product-types'),
(542, 3, 46, 0, 41, NULL),
(543, 3, 49, 0, 41, 'PRODUCTS_AND_PAGE'),
(544, 3, 132, 0, 41, '0'),
(545, 3, 133, 0, 41, NULL),
(546, 3, 134, 0, 41, '0'),
(547, 3, 135, 0, 41, '1'),
(548, 3, 136, 0, 41, '1'),
(549, 3, 137, 0, 41, '0'),
(550, 3, 57, 1, 41, 'accessories/product-types.html'),
(551, 3, 57, 0, 41, 'accessories-17/product-types.html'),
(552, 3, 57, 1, 40, 'accessories/cfg-products.html'),
(553, 3, 57, 0, 40, 'accessories-17/cfg-products.html'),
(558, 3, 45, 0, 40, 'category_12_1.png'),
(559, 3, 153, 0, 3, 'houseware'),
(560, 3, 152, 0, 3, NULL),
(561, 3, 143, 0, 3, '0'),
(562, 3, 144, 0, 3, NULL),
(563, 3, 145, 0, 3, '0'),
(564, 3, 146, 0, 3, '1'),
(565, 3, 147, 0, 3, '1'),
(566, 3, 148, 0, 3, '0'),
(571, 3, 153, 0, 4, NULL),
(572, 3, 152, 0, 4, NULL),
(573, 3, 143, 0, 4, '0'),
(574, 3, 144, 0, 4, NULL),
(575, 3, 145, 0, 4, '1'),
(576, 3, 146, 0, 4, '6'),
(577, 3, 147, 0, 4, '6'),
(578, 3, 148, 0, 4, '2'),
(581, 3, 153, 0, 5, 'watch'),
(582, 3, 152, 0, 5, NULL),
(583, 3, 143, 0, 5, '0'),
(584, 3, 144, 0, 5, NULL),
(585, 3, 145, 0, 5, '0'),
(586, 3, 146, 0, 5, '1'),
(587, 3, 147, 0, 5, '1'),
(588, 3, 148, 0, 5, '0'),
(591, 3, 153, 0, 6, 'playStation'),
(592, 3, 152, 0, 6, NULL),
(593, 3, 143, 0, 6, '0'),
(594, 3, 144, 0, 6, NULL),
(595, 3, 145, 0, 6, '0'),
(596, 3, 146, 0, 6, '1'),
(597, 3, 147, 0, 6, '1'),
(598, 3, 148, 0, 6, '0'),
(601, 3, 41, 0, 42, 'Cameras & Photography'),
(602, 3, 153, 0, 42, 'cameras-photography'),
(603, 3, 152, 0, 42, NULL),
(604, 3, 43, 0, 42, 'cameras-photography'),
(605, 3, 46, 0, 42, NULL),
(606, 3, 49, 0, 42, 'PRODUCTS'),
(607, 3, 58, 0, 42, NULL),
(608, 3, 61, 0, 42, NULL),
(609, 3, 143, 0, 42, '0'),
(610, 3, 144, 0, 42, NULL),
(611, 3, 145, 0, 42, '0'),
(612, 3, 146, 0, 42, '1'),
(613, 3, 147, 0, 42, '1'),
(614, 3, 148, 0, 42, '0'),
(615, 3, 57, 1, 42, 'cameras-photography.html'),
(616, 3, 57, 0, 42, 'cameras-photography.html'),
(617, 3, 41, 0, 43, 'TV & Audio'),
(618, 3, 153, 0, 43, 'tv-audio'),
(619, 3, 152, 0, 43, NULL),
(620, 3, 43, 0, 43, 'tv-audio'),
(621, 3, 46, 0, 43, NULL),
(622, 3, 49, 0, 43, 'PRODUCTS'),
(623, 3, 58, 0, 43, NULL),
(624, 3, 61, 0, 43, NULL),
(625, 3, 143, 0, 43, '0'),
(626, 3, 144, 0, 43, NULL),
(627, 3, 145, 0, 43, '0'),
(628, 3, 146, 0, 43, '1'),
(629, 3, 147, 0, 43, '1'),
(630, 3, 148, 0, 43, '0'),
(631, 3, 57, 1, 43, 'tv-audio.html'),
(632, 3, 57, 0, 43, 'tv-audio.html'),
(633, 3, 41, 0, 44, 'Laptops & Computers'),
(634, 3, 153, 0, 44, 'laptops-computers'),
(635, 3, 152, 0, 44, NULL),
(636, 3, 43, 0, 44, 'laptops-computers'),
(637, 3, 46, 0, 44, NULL),
(638, 3, 49, 0, 44, 'PRODUCTS'),
(639, 3, 58, 0, 44, NULL),
(640, 3, 61, 0, 44, NULL),
(641, 3, 143, 0, 44, '0'),
(642, 3, 144, 0, 44, NULL),
(643, 3, 145, 0, 44, '1'),
(644, 3, 146, 0, 44, '1'),
(645, 3, 147, 0, 44, '3'),
(646, 3, 148, 0, 44, '1'),
(647, 3, 57, 1, 44, 'laptops-computers.html'),
(648, 3, 57, 0, 44, 'laptops-computers.html'),
(649, 3, 41, 0, 45, 'Smart Phones & Tablets'),
(650, 3, 153, 0, 45, 'smartphones-tablets'),
(651, 3, 152, 0, 45, NULL),
(652, 3, 43, 0, 45, 'smart-phones-tablets'),
(653, 3, 46, 0, 45, NULL),
(654, 3, 49, 0, 45, 'PRODUCTS'),
(655, 3, 58, 0, 45, NULL),
(656, 3, 61, 0, 45, NULL),
(657, 3, 143, 0, 45, '0'),
(658, 3, 144, 0, 45, NULL),
(659, 3, 145, 0, 45, '0'),
(660, 3, 146, 0, 45, '1'),
(661, 3, 147, 0, 45, '1'),
(662, 3, 148, 0, 45, '0'),
(663, 3, 57, 1, 45, 'smart-phones-tablets.html'),
(664, 3, 57, 0, 45, 'smart-phones-tablets.html'),
(665, 3, 41, 0, 46, 'Video Games & Consoles'),
(666, 3, 153, 0, 46, 'video games consoles'),
(667, 3, 152, 0, 46, NULL),
(668, 3, 43, 0, 46, 'video-games-consoles'),
(669, 3, 46, 0, 46, NULL),
(670, 3, 49, 0, 46, 'PRODUCTS'),
(671, 3, 58, 0, 46, NULL),
(672, 3, 61, 0, 46, NULL),
(673, 3, 143, 0, 46, '0'),
(674, 3, 144, 0, 46, NULL),
(675, 3, 145, 0, 46, '0'),
(676, 3, 146, 0, 46, '1'),
(677, 3, 147, 0, 46, '1'),
(678, 3, 148, 0, 46, '0'),
(679, 3, 57, 1, 46, 'video-games-consoles.html'),
(680, 3, 57, 0, 46, 'video-games-consoles.html'),
(681, 3, 41, 0, 47, 'Gadgets'),
(682, 3, 153, 0, 47, 'gadgets'),
(683, 3, 152, 0, 47, NULL),
(684, 3, 43, 0, 47, 'gadgets'),
(685, 3, 46, 0, 47, NULL),
(686, 3, 49, 0, 47, 'PRODUCTS'),
(687, 3, 58, 0, 47, NULL),
(688, 3, 61, 0, 47, NULL),
(689, 3, 143, 0, 47, '0'),
(690, 3, 144, 0, 47, NULL),
(691, 3, 145, 0, 47, '0'),
(692, 3, 146, 0, 47, '1'),
(693, 3, 147, 0, 47, '1'),
(694, 3, 148, 0, 47, '0'),
(695, 3, 57, 1, 47, 'gadgets.html'),
(696, 3, 57, 0, 47, 'gadgets.html'),
(697, 3, 41, 0, 48, 'Car Electronics & GPS'),
(698, 3, 153, 0, 48, 'car electronics GPS'),
(699, 3, 152, 0, 48, NULL),
(700, 3, 43, 0, 48, 'car-electronics-gps'),
(701, 3, 46, 0, 48, NULL),
(702, 3, 49, 0, 48, 'PRODUCTS'),
(703, 3, 58, 0, 48, NULL),
(704, 3, 61, 0, 48, NULL),
(705, 3, 143, 0, 48, '0'),
(706, 3, 144, 0, 48, NULL),
(707, 3, 145, 0, 48, '0'),
(708, 3, 146, 0, 48, '1'),
(709, 3, 147, 0, 48, '1'),
(710, 3, 148, 0, 48, '0'),
(711, 3, 57, 1, 48, 'car-electronics-gps.html'),
(712, 3, 57, 0, 48, 'car-electronics-gps.html'),
(713, 3, 41, 0, 49, 'Laptop'),
(714, 3, 153, 0, 49, 'laptop'),
(715, 3, 152, 0, 49, NULL),
(716, 3, 43, 0, 49, 'laptop'),
(717, 3, 46, 0, 49, NULL),
(718, 3, 49, 0, 49, 'PRODUCTS'),
(719, 3, 58, 0, 49, NULL),
(720, 3, 61, 0, 49, NULL),
(721, 3, 143, 0, 49, '0'),
(722, 3, 144, 0, 49, NULL),
(723, 3, 145, 0, 49, '0'),
(724, 3, 146, 0, 49, '1'),
(725, 3, 147, 0, 49, '1'),
(726, 3, 148, 0, 49, '0'),
(727, 3, 57, 1, 49, 'laptop.html'),
(728, 3, 57, 0, 49, 'laptop.html'),
(729, 3, 41, 0, 50, 'Accessories'),
(730, 3, 153, 0, 50, 'accessories'),
(731, 3, 152, 0, 50, NULL),
(732, 3, 43, 0, 50, 'accessories'),
(733, 3, 46, 0, 50, NULL),
(734, 3, 49, 0, 50, 'PRODUCTS'),
(735, 3, 58, 0, 50, NULL),
(736, 3, 61, 0, 50, NULL),
(737, 3, 143, 0, 50, '0'),
(738, 3, 144, 0, 50, NULL),
(739, 3, 145, 0, 50, '0'),
(740, 3, 146, 0, 50, '1'),
(741, 3, 147, 0, 50, '1'),
(742, 3, 148, 0, 50, '0'),
(743, 3, 57, 1, 50, 'accessories-27.html'),
(744, 3, 57, 0, 50, 'accessories-27.html'),
(760, 3, 41, 0, 51, 'Salad Plates'),
(761, 3, 153, 0, 51, 'Salad Plates'),
(762, 3, 152, 0, 51, NULL),
(763, 3, 43, 0, 51, 'salad-plates'),
(764, 3, 46, 0, 51, NULL),
(765, 3, 49, 0, 51, 'PRODUCTS'),
(766, 3, 58, 0, 51, NULL),
(767, 3, 61, 0, 51, NULL),
(768, 3, 143, 0, 51, '0'),
(769, 3, 144, 0, 51, NULL),
(770, 3, 145, 0, 51, '0'),
(771, 3, 146, 0, 51, '1'),
(772, 3, 147, 0, 51, '1'),
(773, 3, 148, 0, 51, '0'),
(774, 3, 57, 1, 51, 'women/shapewear/salad-plates.html'),
(775, 3, 57, 0, 51, 'women/shapewear/salad-plates.html'),
(776, 3, 41, 0, 52, 'Kitchen Storage '),
(777, 3, 153, 0, 52, 'Kitchen Storage '),
(778, 3, 152, 0, 52, NULL),
(779, 3, 43, 0, 52, 'kitchen-storage'),
(780, 3, 46, 0, 52, NULL),
(781, 3, 49, 0, 52, 'PRODUCTS'),
(782, 3, 58, 0, 52, NULL),
(783, 3, 61, 0, 52, NULL),
(784, 3, 143, 0, 52, '0'),
(785, 3, 144, 0, 52, NULL),
(786, 3, 145, 0, 52, '0'),
(787, 3, 146, 0, 52, '1'),
(788, 3, 147, 0, 52, '1'),
(789, 3, 148, 0, 52, '0'),
(790, 3, 57, 1, 52, 'women/shapewear/kitchen-storage.html'),
(791, 3, 57, 0, 52, 'women/shapewear/kitchen-storage.html'),
(792, 3, 41, 0, 53, 'Dish Racks'),
(793, 3, 153, 0, 53, 'Dish Racks'),
(794, 3, 152, 0, 53, NULL),
(795, 3, 43, 0, 53, 'dish-racks'),
(796, 3, 46, 0, 53, NULL),
(797, 3, 49, 0, 53, 'PRODUCTS'),
(798, 3, 58, 0, 53, NULL),
(799, 3, 61, 0, 53, NULL),
(800, 3, 143, 0, 53, '0'),
(801, 3, 144, 0, 53, NULL),
(802, 3, 145, 0, 53, '0'),
(803, 3, 146, 0, 53, '1'),
(804, 3, 147, 0, 53, '1'),
(805, 3, 148, 0, 53, '0'),
(806, 3, 57, 1, 53, 'women/shapewear/dish-racks.html'),
(807, 3, 57, 0, 53, 'women/shapewear/dish-racks.html'),
(808, 3, 41, 0, 54, 'Colanders'),
(809, 3, 153, 0, 54, 'Colanders'),
(810, 3, 152, 0, 54, NULL),
(811, 3, 43, 0, 54, 'colanders'),
(812, 3, 46, 0, 54, NULL),
(813, 3, 49, 0, 54, 'PRODUCTS'),
(814, 3, 58, 0, 54, NULL),
(815, 3, 61, 0, 54, NULL),
(816, 3, 143, 0, 54, '0'),
(817, 3, 144, 0, 54, NULL),
(818, 3, 145, 0, 54, '0'),
(819, 3, 146, 0, 54, '1'),
(820, 3, 147, 0, 54, '1'),
(821, 3, 148, 0, 54, '0'),
(822, 3, 57, 1, 54, 'women/shapewear/colanders.html'),
(823, 3, 57, 0, 54, 'women/shapewear/colanders.html'),
(826, 3, 45, 0, 3, 'category.png'),
(830, 3, 45, 0, 4, 'category_1.png'),
(836, 3, 45, 0, 44, 'category_2.png'),
(840, 3, 45, 0, 5, 'category_3.png'),
(844, 3, 45, 0, 6, 'category_4.png'),
(850, 3, 45, 0, 42, 'category_5.png'),
(856, 3, 45, 0, 43, 'category_6.png'),
(862, 3, 45, 0, 45, 'category_7.png'),
(868, 3, 45, 0, 46, 'category_8.png'),
(874, 3, 45, 0, 47, 'category_9.png'),
(880, 3, 45, 0, 48, 'category_10.png'),
(886, 3, 45, 0, 49, 'category_11.png'),
(892, 3, 45, 0, 50, 'category_12.png'),
(932, 3, 153, 0, 33, NULL),
(933, 3, 152, 0, 33, NULL),
(934, 3, 143, 0, 33, '0'),
(935, 3, 144, 0, 33, NULL),
(936, 3, 145, 0, 33, '0'),
(937, 3, 146, 0, 33, '1'),
(938, 3, 147, 0, 33, '1'),
(939, 3, 148, 0, 33, '0'),
(941, 3, 153, 0, 9, NULL),
(942, 3, 152, 0, 9, NULL),
(943, 3, 143, 0, 9, '0'),
(944, 3, 144, 0, 9, NULL),
(945, 3, 145, 0, 9, '0'),
(946, 3, 146, 0, 9, '1'),
(947, 3, 147, 0, 9, '1'),
(948, 3, 148, 0, 9, '0'),
(950, 3, 153, 0, 19, NULL),
(951, 3, 152, 0, 19, NULL),
(952, 3, 143, 0, 19, '0'),
(953, 3, 144, 0, 19, NULL),
(954, 3, 145, 0, 19, '0'),
(955, 3, 146, 0, 19, '1'),
(956, 3, 147, 0, 19, '1'),
(957, 3, 148, 0, 19, '0'),
(958, 3, 41, 0, 55, 'Casio Watches '),
(959, 3, 153, 0, 55, NULL),
(960, 3, 152, 0, 55, NULL),
(961, 3, 43, 0, 55, 'casio-watches'),
(962, 3, 46, 0, 55, NULL),
(963, 3, 49, 0, 55, 'PRODUCTS'),
(964, 3, 58, 0, 55, NULL),
(965, 3, 61, 0, 55, NULL),
(966, 3, 143, 0, 55, '0'),
(967, 3, 144, 0, 55, NULL),
(968, 3, 145, 0, 55, '0'),
(969, 3, 146, 0, 55, '1'),
(970, 3, 147, 0, 55, '1'),
(971, 3, 148, 0, 55, '0'),
(972, 3, 57, 1, 55, 'casio-watches.html'),
(973, 3, 57, 0, 55, 'casio-watches.html'),
(974, 3, 41, 0, 56, 'Asus Tablets '),
(975, 3, 153, 0, 56, NULL),
(976, 3, 152, 0, 56, NULL),
(977, 3, 43, 0, 56, 'asus-tablets'),
(978, 3, 46, 0, 56, NULL),
(979, 3, 49, 0, 56, 'PRODUCTS'),
(980, 3, 58, 0, 56, NULL),
(981, 3, 61, 0, 56, NULL),
(982, 3, 143, 0, 56, '0'),
(983, 3, 144, 0, 56, NULL),
(984, 3, 145, 0, 56, '0'),
(985, 3, 146, 0, 56, '1'),
(986, 3, 147, 0, 56, '1'),
(987, 3, 148, 0, 56, '0'),
(988, 3, 57, 1, 56, 'asus-tablets.html'),
(989, 3, 57, 0, 56, 'asus-tablets.html'),
(990, 3, 41, 0, 57, 'Women Fashion'),
(991, 3, 153, 0, 57, NULL),
(992, 3, 152, 0, 57, NULL),
(993, 3, 43, 0, 57, 'women-fashion'),
(994, 3, 46, 0, 57, NULL),
(995, 3, 49, 0, 57, 'PRODUCTS'),
(996, 3, 58, 0, 57, NULL),
(997, 3, 61, 0, 57, NULL),
(998, 3, 143, 0, 57, '0'),
(999, 3, 144, 0, 57, NULL),
(1000, 3, 145, 0, 57, '0'),
(1001, 3, 146, 0, 57, '1'),
(1002, 3, 147, 0, 57, '1'),
(1003, 3, 148, 0, 57, '0'),
(1004, 3, 57, 1, 57, 'women-fashion.html'),
(1005, 3, 57, 0, 57, 'women-fashion.html'),
(1074, 3, 153, 0, 40, NULL),
(1075, 3, 152, 0, 40, NULL),
(1076, 3, 143, 0, 40, '0'),
(1077, 3, 144, 0, 40, NULL),
(1078, 3, 145, 0, 40, '0'),
(1079, 3, 146, 0, 40, '1'),
(1080, 3, 147, 0, 40, '1'),
(1081, 3, 148, 0, 40, '0'),
(1082, 3, 164, 0, 3, NULL),
(1083, 3, 163, 0, 3, 'fa fa-male'),
(1084, 3, 154, 0, 3, '0'),
(1085, 3, 155, 0, 3, NULL),
(1086, 3, 156, 0, 3, '0'),
(1087, 3, 157, 0, 3, '1'),
(1088, 3, 158, 0, 3, '1'),
(1089, 3, 159, 0, 3, '0'),
(1092, 3, 164, 0, 4, NULL),
(1093, 3, 163, 0, 4, 'fa fa-mobile'),
(1094, 3, 154, 0, 4, '0'),
(1095, 3, 155, 0, 4, NULL),
(1096, 3, 156, 0, 4, '0'),
(1097, 3, 157, 0, 4, '1'),
(1098, 3, 158, 0, 4, '1'),
(1099, 3, 159, 0, 4, '0'),
(1101, 3, 164, 0, 44, 'laptops-computers'),
(1102, 3, 163, 0, 44, 'fa fa-laptop'),
(1103, 3, 154, 0, 44, '0'),
(1104, 3, 155, 0, 44, NULL),
(1105, 3, 156, 0, 44, '1'),
(1106, 3, 157, 0, 44, '1'),
(1107, 3, 158, 0, 44, '3'),
(1108, 3, 159, 0, 44, '1'),
(1116, 3, 164, 0, 5, NULL),
(1117, 3, 163, 0, 5, 'fa fa-futbol-o'),
(1118, 3, 154, 0, 5, '0'),
(1119, 3, 155, 0, 5, NULL),
(1120, 3, 156, 0, 5, '1'),
(1121, 3, 157, 0, 5, '1'),
(1122, 3, 158, 0, 5, '3'),
(1123, 3, 159, 0, 5, '1'),
(1126, 3, 164, 0, 6, NULL),
(1127, 3, 163, 0, 6, 'fa fa-gamepad'),
(1128, 3, 154, 0, 6, '0'),
(1129, 3, 155, 0, 6, NULL),
(1130, 3, 156, 0, 6, '0'),
(1131, 3, 157, 0, 6, '1'),
(1132, 3, 158, 0, 6, '1'),
(1133, 3, 159, 0, 6, '0'),
(1135, 3, 164, 0, 42, NULL),
(1136, 3, 163, 0, 42, 'fa fa-camera-retro'),
(1137, 3, 154, 0, 42, '0'),
(1138, 3, 155, 0, 42, NULL),
(1139, 3, 156, 0, 42, '0'),
(1140, 3, 157, 0, 42, '1'),
(1141, 3, 158, 0, 42, '1'),
(1142, 3, 159, 0, 42, '0'),
(1146, 3, 164, 0, 43, NULL),
(1147, 3, 163, 0, 43, 'fa fa-desktop'),
(1148, 3, 154, 0, 43, '0'),
(1149, 3, 155, 0, 43, NULL),
(1150, 3, 156, 0, 43, '0'),
(1151, 3, 157, 0, 43, '1'),
(1152, 3, 158, 0, 43, '1'),
(1153, 3, 159, 0, 43, '0'),
(1157, 3, 164, 0, 45, NULL),
(1158, 3, 163, 0, 45, 'fa fa-mobile-phone'),
(1159, 3, 154, 0, 45, '0'),
(1160, 3, 155, 0, 45, NULL),
(1161, 3, 156, 0, 45, '0'),
(1162, 3, 157, 0, 45, '1'),
(1163, 3, 158, 0, 45, '1'),
(1164, 3, 159, 0, 45, '0'),
(1165, 3, 57, 3, 50, 'accessories.html'),
(1166, 3, 57, 3, 6, 'accessories-17.html'),
(1167, 3, 57, 3, 19, 'tv-audio/bicycle.html'),
(1168, 3, 57, 3, 20, 'tv-audio/bicycle/jackets.html'),
(1169, 3, 57, 3, 24, 'tv-audio/bicycle/scarves.html'),
(1170, 3, 57, 3, 25, 'tv-audio/bicycle/lifestyle.html'),
(1171, 3, 57, 3, 26, 'accessories-17/bras.html'),
(1172, 3, 57, 3, 28, 'accessories-17/cosmetics.html'),
(1173, 3, 57, 3, 40, 'accessories-17/cfg-products.html'),
(1174, 3, 57, 3, 41, 'accessories-17/product-types.html'),
(1175, 3, 57, 2, 6, 'accessories.html'),
(1176, 3, 57, 2, 19, 'tv-audio/bicycle.html'),
(1177, 3, 57, 2, 20, 'tv-audio/bicycle/jackets.html'),
(1178, 3, 57, 2, 24, 'tv-audio/bicycle/scarves.html'),
(1179, 3, 57, 2, 25, 'tv-audio/bicycle/lifestyle.html'),
(1180, 3, 57, 2, 26, 'accessories/bras.html'),
(1181, 3, 57, 2, 28, 'accessories/cosmetics.html'),
(1182, 3, 57, 2, 40, 'accessories/cfg-products.html'),
(1183, 3, 57, 2, 41, 'accessories/product-types.html'),
(1184, 3, 57, 4, 50, 'accessories.html'),
(1185, 3, 57, 5, 50, 'accessories.html'),
(1186, 3, 41, 0, 58, 'Product types'),
(1187, 3, 164, 0, 58, NULL),
(1188, 3, 163, 0, 58, NULL),
(1189, 3, 43, 0, 58, 'product-types'),
(1190, 3, 46, 0, 58, NULL),
(1191, 3, 49, 0, 58, 'PRODUCTS'),
(1192, 3, 58, 0, 58, NULL),
(1193, 3, 61, 0, 58, NULL),
(1194, 3, 154, 0, 58, '0'),
(1195, 3, 155, 0, 58, NULL),
(1196, 3, 156, 0, 58, '0'),
(1197, 3, 157, 0, 58, '1'),
(1198, 3, 158, 0, 58, '1'),
(1199, 3, 159, 0, 58, '0'),
(1200, 3, 45, 0, 58, 'category_13.png'),
(1201, 3, 57, 1, 58, 'accessories-27/product-types.html'),
(1202, 3, 57, 0, 58, 'accessories-27/product-types.html'),
(1203, 3, 57, 3, 58, 'accessories/product-types.html'),
(1204, 3, 57, 4, 58, 'accessories/product-types.html'),
(1205, 3, 57, 5, 58, 'accessories/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_flat_store_1` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'entity_id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'parent_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'created_at',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'updated_at',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'path',
  `position` int(11) NOT NULL COMMENT 'position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'level',
  `children_count` int(11) NOT NULL COMMENT 'children_count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `all_children` text COMMENT 'All Children',
  `amoda_block_b` text COMMENT 'Block Bottom',
  `amoda_block_r` text COMMENT 'Block Right',
  `amoda_block_t` text COMMENT 'Block Top',
  `amoda_custom_icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `amoda_groupsubcat` varchar(255) DEFAULT NULL COMMENT 'Group Subcategories',
  `amoda_label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `amoda_menulink` varchar(255) DEFAULT NULL COMMENT 'Hide link',
  `amoda_menutype` varchar(255) DEFAULT NULL COMMENT 'Dropdown with',
  `amoda_subcat_colw` varchar(255) DEFAULT NULL COMMENT 'Col width for subcategories',
  `amoda_subcat_w` varchar(255) DEFAULT NULL COMMENT 'Width for subcategories block',
  `amoda_title_alias` varchar(255) DEFAULT NULL COMMENT 'Name alias',
  `available_sort_by` text COMMENT 'Available Product Listing Sort By',
  `children` text COMMENT 'Children',
  `custom_apply_to_products` int(11) DEFAULT NULL COMMENT 'Apply To Products',
  `custom_design` varchar(255) DEFAULT NULL COMMENT 'Custom Design',
  `custom_design_from` datetime DEFAULT NULL COMMENT 'Active From',
  `custom_design_to` datetime DEFAULT NULL COMMENT 'Active To',
  `custom_layout_update` text COMMENT 'Custom Layout Update',
  `custom_use_parent_settings` int(11) DEFAULT NULL COMMENT 'Use Parent Category Settings',
  `default_sort_by` varchar(255) DEFAULT NULL COMMENT 'Default Product Listing Sort By',
  `description` text COMMENT 'Description',
  `display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `filter_price_range` decimal(12,4) DEFAULT NULL COMMENT 'Layered Navigation Price Step',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `include_in_menu` int(11) DEFAULT NULL COMMENT 'Include in Navigation Menu',
  `is_active` int(11) DEFAULT NULL COMMENT 'Is Active',
  `is_anchor` int(11) DEFAULT NULL COMMENT 'Is Anchor',
  `landing_page` int(11) DEFAULT NULL COMMENT 'CMS Block',
  `meta_description` text COMMENT 'Meta Description',
  `meta_keywords` text COMMENT 'Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `path_in_store` text COMMENT 'Path In Store',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'URL Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Flat (Store 1)';

INSERT INTO `#__catalog_category_flat_store_1` (`entity_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`, `store_id`, `all_children`, `amoda_block_b`, `amoda_block_r`, `amoda_block_t`, `amoda_custom_icon`, `amoda_groupsubcat`, `amoda_label`, `amoda_menulink`, `amoda_menutype`, `amoda_subcat_colw`, `amoda_subcat_w`, `amoda_title_alias`, `available_sort_by`, `children`, `custom_apply_to_products`, `custom_design`, `custom_design_from`, `custom_design_to`, `custom_layout_update`, `custom_use_parent_settings`, `default_sort_by`, `description`, `display_mode`, `filter_price_range`, `image`, `include_in_menu`, `is_active`, `is_anchor`, `landing_page`, `meta_description`, `meta_keywords`, `meta_title`, `name`, `page_layout`, `path_in_store`, `url_key`, `url_path`) VALUES
(1, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'Root Catalog', NULL, NULL, 'root-catalog', NULL),
(2, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, 'Default Category', NULL, NULL, 'default-category', NULL),
(3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0, 1, NULL, NULL, NULL, NULL, 'fa fa-male', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Fashion', NULL, NULL, 'men', 'men.html'),
(4, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31, 1, NULL, NULL, NULL, NULL, 'fa fa-mobile', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smartphone', NULL, NULL, 'women', 'women.html'),
(5, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0, 1, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-futbol-o', '1', NULL, '0', '1', '3', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_3.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Sporst', NULL, NULL, 'kid', 'kid.html'),
(6, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4, 1, NULL, NULL, NULL, NULL, 'fa fa-gamepad', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_4.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'PlayStation', NULL, NULL, 'accessories', 'accessories.html'),
(7, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Rings', NULL, NULL, 'rings', 'women/bags/shoes/rings.html'),
(8, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shoes', NULL, NULL, 'shoes', 'women/bags/shoes.html'),
(9, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shapewear', NULL, NULL, 'shapewear', 'women/shapewear.html'),
(10, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Sundresses', NULL, NULL, 'sundresses', 'women/shapewear/sundresses.html'),
(11, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Footwear', NULL, NULL, 'footwear', 'women/shapewear/footwear.html'),
(12, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Novelty', NULL, NULL, 'novelty', 'women/shapewear/novelty.html'),
(13, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Outerwear', NULL, NULL, 'outerwear', 'women/shapewear/outerwear.html'),
(14, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hats', NULL, NULL, 'hats', 'women/shapewear/hats.html'),
(15, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Gloves', NULL, NULL, 'gloves', 'women/bags/shoes/gloves.html'),
(16, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Leathers', NULL, NULL, 'leathers', 'women/bags/shoes/leathers.html'),
(17, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cocktail', NULL, NULL, 'cocktail', 'women/bags/shoes/cocktail.html'),
(18, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bands', NULL, NULL, 'bands', 'women/bags/bands.html'),
(19, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bicycle', NULL, NULL, 'bicycle', 'tv-audio/bicycle.html'),
(20, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Jackets', NULL, NULL, 'jackets', 'tv-audio/bicycle/jackets.html'),
(21, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hair', NULL, NULL, 'hair', 'women/bags/shoes/shirts/hair.html'),
(22, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Clothing', NULL, NULL, 'clothing', 'women/bags/shoes/clothing.html'),
(23, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Blog', NULL, NULL, 'blog', 'women/bags/blog.html'),
(24, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Scarves', NULL, NULL, 'scarves', 'tv-audio/bicycle/scarves.html'),
(25, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lifestyle', NULL, NULL, 'lifestyle', 'tv-audio/bicycle/lifestyle.html'),
(26, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bras', NULL, NULL, 'bras', 'accessories/bras.html'),
(27, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Helmet', NULL, NULL, 'helmet', 'women/bags/shoes/shirts/helmet.html'),
(28, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetics', NULL, NULL, 'cosmetics', 'accessories/cosmetics.html'),
(29, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Camis', NULL, NULL, 'camis', 'women/bags/shoes/shirts/camis.html'),
(30, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lingerie', NULL, NULL, 'lingerie', 'women/bags/shoes/shirts/lingerie.html'),
(31, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shirts', NULL, NULL, 'shirts', 'women/bags/shoes/shirts.html'),
(32, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Tops', NULL, NULL, 'tops', 'women/bags/shoes/shirts/tops.html'),
(33, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bags', NULL, NULL, 'bags', 'women/bags.html'),
(34, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Nightwear', NULL, NULL, 'nightwear', 'women/bags/nightwear.html'),
(35, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Briefs', NULL, NULL, 'briefs', 'women/bags/briefs.html'),
(36, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Duffle', NULL, NULL, 'duffle', 'women/bags/duffle.html'),
(37, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dresses', NULL, NULL, 'dresses', 'women/bags/dresses.html'),
(38, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'women/bags/laptop.html'),
(39, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetic', NULL, NULL, 'cosmetic', 'women/bags/cosmetic.html'),
(40, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_12_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cfg products', NULL, NULL, 'cfg-products', 'accessories/cfg-products.html'),
(41, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, NULL, 1, 1, 0, 6, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories/product-types.html'),
(42, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0, 1, NULL, NULL, NULL, NULL, 'fa fa-camera-retro', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_5.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cameras & Photography', NULL, NULL, 'cameras-photography', 'cameras-photography.html'),
(43, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4, 1, NULL, NULL, NULL, NULL, 'fa fa-desktop', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_6.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'TV & Audio', NULL, NULL, 'tv-audio', 'tv-audio.html'),
(44, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0, 1, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-laptop', '1', NULL, '0', '1', '3', '1', 'laptops-computers', NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_2.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptops & Computers', NULL, NULL, 'laptops-computers', 'laptops-computers.html'),
(45, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0, 1, NULL, NULL, NULL, NULL, 'fa fa-mobile-phone', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_7.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smart Phones & Tablets', NULL, NULL, 'smart-phones-tablets', 'smart-phones-tablets.html'),
(46, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_8.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Video Games & Consoles', NULL, NULL, 'video-games-consoles', 'video-games-consoles.html'),
(47, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_9.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Gadgets', NULL, NULL, 'gadgets', 'gadgets.html'),
(48, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_10.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Car Electronics & GPS', NULL, NULL, 'car-electronics-gps', 'car-electronics-gps.html'),
(49, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_11.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'laptop.html'),
(50, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_12.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Accessories', NULL, NULL, 'accessories', 'accessories-27.html'),
(51, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Salad Plates', NULL, NULL, 'salad-plates', 'women/shapewear/salad-plates.html'),
(52, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Kitchen Storage ', NULL, NULL, 'kitchen-storage', 'women/shapewear/kitchen-storage.html'),
(53, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dish Racks', NULL, NULL, 'dish-racks', 'women/shapewear/dish-racks.html'),
(54, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Colanders', NULL, NULL, 'colanders', 'women/shapewear/colanders.html'),
(55, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Casio Watches ', NULL, NULL, 'casio-watches', 'casio-watches.html'),
(56, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Asus Tablets ', NULL, NULL, 'asus-tablets', 'asus-tablets.html'),
(57, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Women Fashion', NULL, NULL, 'women-fashion', 'women-fashion.html'),
(58, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0, 1, NULL, NULL, NULL, NULL, NULL, '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_13.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories-27/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_flat_store_2` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'entity_id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'parent_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'created_at',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'updated_at',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'path',
  `position` int(11) NOT NULL COMMENT 'position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'level',
  `children_count` int(11) NOT NULL COMMENT 'children_count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `all_children` text COMMENT 'All Children',
  `amoda_block_b` text COMMENT 'Block Bottom',
  `amoda_block_r` text COMMENT 'Block Right',
  `amoda_block_t` text COMMENT 'Block Top',
  `amoda_custom_icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `amoda_groupsubcat` varchar(255) DEFAULT NULL COMMENT 'Group Subcategories',
  `amoda_label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `amoda_menulink` varchar(255) DEFAULT NULL COMMENT 'Hide link',
  `amoda_menutype` varchar(255) DEFAULT NULL COMMENT 'Dropdown with',
  `amoda_subcat_colw` varchar(255) DEFAULT NULL COMMENT 'Col width for subcategories',
  `amoda_subcat_w` varchar(255) DEFAULT NULL COMMENT 'Width for subcategories block',
  `amoda_title_alias` varchar(255) DEFAULT NULL COMMENT 'Name alias',
  `available_sort_by` text COMMENT 'Available Product Listing Sort By',
  `children` text COMMENT 'Children',
  `custom_apply_to_products` int(11) DEFAULT NULL COMMENT 'Apply To Products',
  `custom_design` varchar(255) DEFAULT NULL COMMENT 'Custom Design',
  `custom_design_from` datetime DEFAULT NULL COMMENT 'Active From',
  `custom_design_to` datetime DEFAULT NULL COMMENT 'Active To',
  `custom_layout_update` text COMMENT 'Custom Layout Update',
  `custom_use_parent_settings` int(11) DEFAULT NULL COMMENT 'Use Parent Category Settings',
  `default_sort_by` varchar(255) DEFAULT NULL COMMENT 'Default Product Listing Sort By',
  `description` text COMMENT 'Description',
  `display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `filter_price_range` decimal(12,4) DEFAULT NULL COMMENT 'Layered Navigation Price Step',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `include_in_menu` int(11) DEFAULT NULL COMMENT 'Include in Navigation Menu',
  `is_active` int(11) DEFAULT NULL COMMENT 'Is Active',
  `is_anchor` int(11) DEFAULT NULL COMMENT 'Is Anchor',
  `landing_page` int(11) DEFAULT NULL COMMENT 'CMS Block',
  `meta_description` text COMMENT 'Meta Description',
  `meta_keywords` text COMMENT 'Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `path_in_store` text COMMENT 'Path In Store',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'URL Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Flat (Store 2)';

INSERT INTO `#__catalog_category_flat_store_2` (`entity_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`, `store_id`, `all_children`, `amoda_block_b`, `amoda_block_r`, `amoda_block_t`, `amoda_custom_icon`, `amoda_groupsubcat`, `amoda_label`, `amoda_menulink`, `amoda_menutype`, `amoda_subcat_colw`, `amoda_subcat_w`, `amoda_title_alias`, `available_sort_by`, `children`, `custom_apply_to_products`, `custom_design`, `custom_design_from`, `custom_design_to`, `custom_layout_update`, `custom_use_parent_settings`, `default_sort_by`, `description`, `display_mode`, `filter_price_range`, `image`, `include_in_menu`, `is_active`, `is_anchor`, `landing_page`, `meta_description`, `meta_keywords`, `meta_title`, `name`, `page_layout`, `path_in_store`, `url_key`, `url_path`) VALUES
(1, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'Root Catalog', NULL, NULL, NULL, NULL),
(2, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, 'Default Category', NULL, NULL, NULL, NULL),
(3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0, 2, NULL, NULL, NULL, NULL, 'fa fa-male', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Fashion', NULL, NULL, 'men', 'men.html'),
(4, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31, 2, NULL, NULL, NULL, NULL, 'fa fa-mobile', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smartphone', NULL, NULL, 'women', 'women.html'),
(5, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0, 2, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-futbol-o', '1', NULL, '0', '1', '3', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_3.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Sporst', NULL, NULL, 'kid', 'kid.html'),
(6, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4, 2, NULL, NULL, NULL, NULL, 'fa fa-gamepad', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_4.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'PlayStation', NULL, NULL, 'accessories', 'accessories.html'),
(7, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Rings', NULL, NULL, 'rings', 'women/bags/shoes/rings.html'),
(8, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shoes', NULL, NULL, 'shoes', 'women/bags/shoes.html'),
(9, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shapewear', NULL, NULL, 'shapewear', 'women/shapewear.html'),
(10, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Sundresses', NULL, NULL, 'sundresses', 'women/shapewear/sundresses.html'),
(11, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Footwear', NULL, NULL, 'footwear', 'women/shapewear/footwear.html'),
(12, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Novelty', NULL, NULL, 'novelty', 'women/shapewear/novelty.html'),
(13, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Outerwear', NULL, NULL, 'outerwear', 'women/shapewear/outerwear.html'),
(14, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hats', NULL, NULL, 'hats', 'women/shapewear/hats.html'),
(15, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Gloves', NULL, NULL, 'gloves', 'women/bags/shoes/gloves.html'),
(16, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Leathers', NULL, NULL, 'leathers', 'women/bags/shoes/leathers.html'),
(17, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cocktail', NULL, NULL, 'cocktail', 'women/bags/shoes/cocktail.html'),
(18, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bands', NULL, NULL, 'bands', 'women/bags/bands.html'),
(19, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bicycle', NULL, NULL, 'bicycle', 'tv-audio/bicycle.html'),
(20, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Jackets', NULL, NULL, 'jackets', 'tv-audio/bicycle/jackets.html'),
(21, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hair', NULL, NULL, 'hair', 'women/bags/shoes/shirts/hair.html'),
(22, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Clothing', NULL, NULL, 'clothing', 'women/bags/shoes/clothing.html'),
(23, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Blog', NULL, NULL, 'blog', 'women/bags/blog.html'),
(24, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Scarves', NULL, NULL, 'scarves', 'tv-audio/bicycle/scarves.html'),
(25, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lifestyle', NULL, NULL, 'lifestyle', 'tv-audio/bicycle/lifestyle.html'),
(26, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bras', NULL, NULL, 'bras', 'accessories/bras.html'),
(27, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Helmet', NULL, NULL, 'helmet', 'women/bags/shoes/shirts/helmet.html'),
(28, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetics', NULL, NULL, 'cosmetics', 'accessories/cosmetics.html'),
(29, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Camis', NULL, NULL, 'camis', 'women/bags/shoes/shirts/camis.html'),
(30, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lingerie', NULL, NULL, 'lingerie', 'women/bags/shoes/shirts/lingerie.html'),
(31, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shirts', NULL, NULL, 'shirts', 'women/bags/shoes/shirts.html'),
(32, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Tops', NULL, NULL, 'tops', 'women/bags/shoes/shirts/tops.html'),
(33, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bags', NULL, NULL, 'bags', 'women/bags.html'),
(34, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Nightwear', NULL, NULL, 'nightwear', 'women/bags/nightwear.html'),
(35, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Briefs', NULL, NULL, 'briefs', 'women/bags/briefs.html'),
(36, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Duffle', NULL, NULL, 'duffle', 'women/bags/duffle.html'),
(37, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dresses', NULL, NULL, 'dresses', 'women/bags/dresses.html'),
(38, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'women/bags/laptop.html'),
(39, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetic', NULL, NULL, 'cosmetic', 'women/bags/cosmetic.html'),
(40, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_12_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cfg products', NULL, NULL, 'cfg-products', 'accessories/cfg-products.html'),
(41, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, NULL, 1, 1, 0, 6, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories/product-types.html'),
(42, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0, 2, NULL, NULL, NULL, NULL, 'fa fa-camera-retro', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_5.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cameras & Photography', NULL, NULL, 'cameras-photography', 'cameras-photography.html'),
(43, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4, 2, NULL, NULL, NULL, NULL, 'fa fa-desktop', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_6.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'TV & Audio', NULL, NULL, 'tv-audio', 'tv-audio.html'),
(44, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0, 2, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-laptop', '1', NULL, '0', '1', '3', '1', 'laptops-computers', NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_2.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptops & Computers', NULL, NULL, 'laptops-computers', 'laptops-computers.html'),
(45, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0, 2, NULL, NULL, NULL, NULL, 'fa fa-mobile-phone', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_7.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smart Phones & Tablets', NULL, NULL, 'smart-phones-tablets', 'smart-phones-tablets.html'),
(46, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_8.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Video Games & Consoles', NULL, NULL, 'video-games-consoles', 'video-games-consoles.html'),
(47, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_9.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Gadgets', NULL, NULL, 'gadgets', 'gadgets.html'),
(48, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_10.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Car Electronics & GPS', NULL, NULL, 'car-electronics-gps', 'car-electronics-gps.html'),
(49, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_11.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'laptop.html'),
(50, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_12.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Accessories', NULL, NULL, 'accessories', 'accessories-27.html'),
(51, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Salad Plates', NULL, NULL, 'salad-plates', 'women/shapewear/salad-plates.html'),
(52, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Kitchen Storage ', NULL, NULL, 'kitchen-storage', 'women/shapewear/kitchen-storage.html'),
(53, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dish Racks', NULL, NULL, 'dish-racks', 'women/shapewear/dish-racks.html'),
(54, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Colanders', NULL, NULL, 'colanders', 'women/shapewear/colanders.html'),
(55, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Casio Watches ', NULL, NULL, 'casio-watches', 'casio-watches.html'),
(56, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Asus Tablets ', NULL, NULL, 'asus-tablets', 'asus-tablets.html'),
(57, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0, 2, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Women Fashion', NULL, NULL, 'women-fashion', 'women-fashion.html'),
(58, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0, 2, NULL, NULL, NULL, NULL, NULL, '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_13.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories-27/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_flat_store_3` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'entity_id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'parent_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'created_at',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'updated_at',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'path',
  `position` int(11) NOT NULL COMMENT 'position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'level',
  `children_count` int(11) NOT NULL COMMENT 'children_count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `all_children` text COMMENT 'All Children',
  `amoda_block_b` text COMMENT 'Block Bottom',
  `amoda_block_r` text COMMENT 'Block Right',
  `amoda_block_t` text COMMENT 'Block Top',
  `amoda_custom_icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `amoda_groupsubcat` varchar(255) DEFAULT NULL COMMENT 'Group Subcategories',
  `amoda_label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `amoda_menulink` varchar(255) DEFAULT NULL COMMENT 'Hide link',
  `amoda_menutype` varchar(255) DEFAULT NULL COMMENT 'Dropdown with',
  `amoda_subcat_colw` varchar(255) DEFAULT NULL COMMENT 'Col width for subcategories',
  `amoda_subcat_w` varchar(255) DEFAULT NULL COMMENT 'Width for subcategories block',
  `amoda_title_alias` varchar(255) DEFAULT NULL COMMENT 'Name alias',
  `available_sort_by` text COMMENT 'Available Product Listing Sort By',
  `children` text COMMENT 'Children',
  `custom_apply_to_products` int(11) DEFAULT NULL COMMENT 'Apply To Products',
  `custom_design` varchar(255) DEFAULT NULL COMMENT 'Custom Design',
  `custom_design_from` datetime DEFAULT NULL COMMENT 'Active From',
  `custom_design_to` datetime DEFAULT NULL COMMENT 'Active To',
  `custom_layout_update` text COMMENT 'Custom Layout Update',
  `custom_use_parent_settings` int(11) DEFAULT NULL COMMENT 'Use Parent Category Settings',
  `default_sort_by` varchar(255) DEFAULT NULL COMMENT 'Default Product Listing Sort By',
  `description` text COMMENT 'Description',
  `display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `filter_price_range` decimal(12,4) DEFAULT NULL COMMENT 'Layered Navigation Price Step',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `include_in_menu` int(11) DEFAULT NULL COMMENT 'Include in Navigation Menu',
  `is_active` int(11) DEFAULT NULL COMMENT 'Is Active',
  `is_anchor` int(11) DEFAULT NULL COMMENT 'Is Anchor',
  `landing_page` int(11) DEFAULT NULL COMMENT 'CMS Block',
  `meta_description` text COMMENT 'Meta Description',
  `meta_keywords` text COMMENT 'Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `path_in_store` text COMMENT 'Path In Store',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'URL Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Flat (Store 3)';

INSERT INTO `#__catalog_category_flat_store_3` (`entity_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`, `store_id`, `all_children`, `amoda_block_b`, `amoda_block_r`, `amoda_block_t`, `amoda_custom_icon`, `amoda_groupsubcat`, `amoda_label`, `amoda_menulink`, `amoda_menutype`, `amoda_subcat_colw`, `amoda_subcat_w`, `amoda_title_alias`, `available_sort_by`, `children`, `custom_apply_to_products`, `custom_design`, `custom_design_from`, `custom_design_to`, `custom_layout_update`, `custom_use_parent_settings`, `default_sort_by`, `description`, `display_mode`, `filter_price_range`, `image`, `include_in_menu`, `is_active`, `is_anchor`, `landing_page`, `meta_description`, `meta_keywords`, `meta_title`, `name`, `page_layout`, `path_in_store`, `url_key`, `url_path`) VALUES
(1, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'Root Catalog', NULL, NULL, NULL, NULL),
(2, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, 'Default Category', NULL, NULL, NULL, NULL),
(3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0, 3, NULL, NULL, NULL, NULL, 'fa fa-male', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Fashion', NULL, NULL, 'men', 'men.html'),
(4, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31, 3, NULL, NULL, NULL, NULL, 'fa fa-mobile', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smartphone', NULL, NULL, 'women', 'women.html'),
(5, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0, 3, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-futbol-o', '1', NULL, '0', '1', '3', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_3.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Sporst', NULL, NULL, 'kid', 'kid.html'),
(6, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4, 3, NULL, NULL, NULL, NULL, 'fa fa-gamepad', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_4.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'PlayStation', NULL, NULL, 'accessories', 'accessories-17.html'),
(7, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Rings', NULL, NULL, 'rings', 'women/bags/shoes/rings.html'),
(8, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shoes', NULL, NULL, 'shoes', 'women/bags/shoes.html'),
(9, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shapewear', NULL, NULL, 'shapewear', 'women/shapewear.html'),
(10, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Sundresses', NULL, NULL, 'sundresses', 'women/shapewear/sundresses.html'),
(11, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Footwear', NULL, NULL, 'footwear', 'women/shapewear/footwear.html'),
(12, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Novelty', NULL, NULL, 'novelty', 'women/shapewear/novelty.html'),
(13, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Outerwear', NULL, NULL, 'outerwear', 'women/shapewear/outerwear.html'),
(14, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hats', NULL, NULL, 'hats', 'women/shapewear/hats.html'),
(15, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Gloves', NULL, NULL, 'gloves', 'women/bags/shoes/gloves.html'),
(16, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Leathers', NULL, NULL, 'leathers', 'women/bags/shoes/leathers.html'),
(17, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cocktail', NULL, NULL, 'cocktail', 'women/bags/shoes/cocktail.html'),
(18, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bands', NULL, NULL, 'bands', 'women/bags/bands.html'),
(19, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bicycle', NULL, NULL, 'bicycle', 'tv-audio/bicycle.html'),
(20, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Jackets', NULL, NULL, 'jackets', 'tv-audio/bicycle/jackets.html'),
(21, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hair', NULL, NULL, 'hair', 'women/bags/shoes/shirts/hair.html'),
(22, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Clothing', NULL, NULL, 'clothing', 'women/bags/shoes/clothing.html'),
(23, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Blog', NULL, NULL, 'blog', 'women/bags/blog.html'),
(24, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Scarves', NULL, NULL, 'scarves', 'tv-audio/bicycle/scarves.html'),
(25, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lifestyle', NULL, NULL, 'lifestyle', 'tv-audio/bicycle/lifestyle.html'),
(26, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bras', NULL, NULL, 'bras', 'accessories-17/bras.html'),
(27, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Helmet', NULL, NULL, 'helmet', 'women/bags/shoes/shirts/helmet.html'),
(28, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetics', NULL, NULL, 'cosmetics', 'accessories-17/cosmetics.html'),
(29, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Camis', NULL, NULL, 'camis', 'women/bags/shoes/shirts/camis.html'),
(30, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lingerie', NULL, NULL, 'lingerie', 'women/bags/shoes/shirts/lingerie.html'),
(31, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shirts', NULL, NULL, 'shirts', 'women/bags/shoes/shirts.html'),
(32, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Tops', NULL, NULL, 'tops', 'women/bags/shoes/shirts/tops.html'),
(33, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bags', NULL, NULL, 'bags', 'women/bags.html'),
(34, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Nightwear', NULL, NULL, 'nightwear', 'women/bags/nightwear.html'),
(35, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Briefs', NULL, NULL, 'briefs', 'women/bags/briefs.html'),
(36, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Duffle', NULL, NULL, 'duffle', 'women/bags/duffle.html'),
(37, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dresses', NULL, NULL, 'dresses', 'women/bags/dresses.html'),
(38, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'women/bags/laptop.html'),
(39, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetic', NULL, NULL, 'cosmetic', 'women/bags/cosmetic.html'),
(40, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_12_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cfg products', NULL, NULL, 'cfg-products', 'accessories-17/cfg-products.html'),
(41, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, NULL, 1, 1, 0, 6, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories-17/product-types.html'),
(42, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0, 3, NULL, NULL, NULL, NULL, 'fa fa-camera-retro', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_5.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cameras & Photography', NULL, NULL, 'cameras-photography', 'cameras-photography.html'),
(43, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4, 3, NULL, NULL, NULL, NULL, 'fa fa-desktop', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_6.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'TV & Audio', NULL, NULL, 'tv-audio', 'tv-audio.html'),
(44, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0, 3, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-laptop', '1', NULL, '0', '1', '3', '1', 'laptops-computers', NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_2.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptops & Computers', NULL, NULL, 'laptops-computers', 'laptops-computers.html'),
(45, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0, 3, NULL, NULL, NULL, NULL, 'fa fa-mobile-phone', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_7.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smart Phones & Tablets', NULL, NULL, 'smart-phones-tablets', 'smart-phones-tablets.html'),
(46, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_8.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Video Games & Consoles', NULL, NULL, 'video-games-consoles', 'video-games-consoles.html'),
(47, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_9.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Gadgets', NULL, NULL, 'gadgets', 'gadgets.html'),
(48, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_10.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Car Electronics & GPS', NULL, NULL, 'car-electronics-gps', 'car-electronics-gps.html'),
(49, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_11.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'laptop.html'),
(50, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_12.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Accessories', NULL, NULL, 'accessories', 'accessories.html'),
(51, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Salad Plates', NULL, NULL, 'salad-plates', 'women/shapewear/salad-plates.html'),
(52, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Kitchen Storage ', NULL, NULL, 'kitchen-storage', 'women/shapewear/kitchen-storage.html'),
(53, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dish Racks', NULL, NULL, 'dish-racks', 'women/shapewear/dish-racks.html'),
(54, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Colanders', NULL, NULL, 'colanders', 'women/shapewear/colanders.html'),
(55, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Casio Watches ', NULL, NULL, 'casio-watches', 'casio-watches.html'),
(56, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Asus Tablets ', NULL, NULL, 'asus-tablets', 'asus-tablets.html'),
(57, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0, 3, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Women Fashion', NULL, NULL, 'women-fashion', 'women-fashion.html'),
(58, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0, 3, NULL, NULL, NULL, NULL, NULL, '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_13.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_flat_store_4` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'entity_id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'parent_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'created_at',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'updated_at',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'path',
  `position` int(11) NOT NULL COMMENT 'position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'level',
  `children_count` int(11) NOT NULL COMMENT 'children_count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `all_children` text COMMENT 'All Children',
  `amoda_block_b` text COMMENT 'Block Bottom',
  `amoda_block_r` text COMMENT 'Block Right',
  `amoda_block_t` text COMMENT 'Block Top',
  `amoda_custom_icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `amoda_groupsubcat` varchar(255) DEFAULT NULL COMMENT 'Group Subcategories',
  `amoda_label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `amoda_menulink` varchar(255) DEFAULT NULL COMMENT 'Hide link',
  `amoda_menutype` varchar(255) DEFAULT NULL COMMENT 'Dropdown with',
  `amoda_subcat_colw` varchar(255) DEFAULT NULL COMMENT 'Col width for subcategories',
  `amoda_subcat_w` varchar(255) DEFAULT NULL COMMENT 'Width for subcategories block',
  `amoda_title_alias` varchar(255) DEFAULT NULL COMMENT 'Name alias',
  `available_sort_by` text COMMENT 'Available Product Listing Sort By',
  `children` text COMMENT 'Children',
  `custom_apply_to_products` int(11) DEFAULT NULL COMMENT 'Apply To Products',
  `custom_design` varchar(255) DEFAULT NULL COMMENT 'Custom Design',
  `custom_design_from` datetime DEFAULT NULL COMMENT 'Active From',
  `custom_design_to` datetime DEFAULT NULL COMMENT 'Active To',
  `custom_layout_update` text COMMENT 'Custom Layout Update',
  `custom_use_parent_settings` int(11) DEFAULT NULL COMMENT 'Use Parent Category Settings',
  `default_sort_by` varchar(255) DEFAULT NULL COMMENT 'Default Product Listing Sort By',
  `description` text COMMENT 'Description',
  `display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `filter_price_range` decimal(12,4) DEFAULT NULL COMMENT 'Layered Navigation Price Step',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `include_in_menu` int(11) DEFAULT NULL COMMENT 'Include in Navigation Menu',
  `is_active` int(11) DEFAULT NULL COMMENT 'Is Active',
  `is_anchor` int(11) DEFAULT NULL COMMENT 'Is Anchor',
  `landing_page` int(11) DEFAULT NULL COMMENT 'CMS Block',
  `meta_description` text COMMENT 'Meta Description',
  `meta_keywords` text COMMENT 'Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `path_in_store` text COMMENT 'Path In Store',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'URL Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Flat (Store 4)';

INSERT INTO `#__catalog_category_flat_store_4` (`entity_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`, `store_id`, `all_children`, `amoda_block_b`, `amoda_block_r`, `amoda_block_t`, `amoda_custom_icon`, `amoda_groupsubcat`, `amoda_label`, `amoda_menulink`, `amoda_menutype`, `amoda_subcat_colw`, `amoda_subcat_w`, `amoda_title_alias`, `available_sort_by`, `children`, `custom_apply_to_products`, `custom_design`, `custom_design_from`, `custom_design_to`, `custom_layout_update`, `custom_use_parent_settings`, `default_sort_by`, `description`, `display_mode`, `filter_price_range`, `image`, `include_in_menu`, `is_active`, `is_anchor`, `landing_page`, `meta_description`, `meta_keywords`, `meta_title`, `name`, `page_layout`, `path_in_store`, `url_key`, `url_path`) VALUES
(1, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'Root Catalog', NULL, NULL, NULL, NULL),
(2, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, 'Default Category', NULL, NULL, NULL, NULL),
(3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0, 4, NULL, NULL, NULL, NULL, 'fa fa-male', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Fashion', NULL, NULL, 'men', 'men.html'),
(4, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31, 4, NULL, NULL, NULL, NULL, 'fa fa-mobile', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smartphone', NULL, NULL, 'women', 'women.html'),
(5, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0, 4, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-futbol-o', '1', NULL, '0', '1', '3', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_3.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Sporst', NULL, NULL, 'kid', 'kid.html'),
(6, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4, 4, NULL, NULL, NULL, NULL, 'fa fa-gamepad', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_4.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'PlayStation', NULL, NULL, 'accessories', 'accessories-17.html'),
(7, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Rings', NULL, NULL, 'rings', 'women/bags/shoes/rings.html'),
(8, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shoes', NULL, NULL, 'shoes', 'women/bags/shoes.html'),
(9, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shapewear', NULL, NULL, 'shapewear', 'women/shapewear.html'),
(10, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Sundresses', NULL, NULL, 'sundresses', 'women/shapewear/sundresses.html'),
(11, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Footwear', NULL, NULL, 'footwear', 'women/shapewear/footwear.html'),
(12, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Novelty', NULL, NULL, 'novelty', 'women/shapewear/novelty.html'),
(13, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Outerwear', NULL, NULL, 'outerwear', 'women/shapewear/outerwear.html'),
(14, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hats', NULL, NULL, 'hats', 'women/shapewear/hats.html'),
(15, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Gloves', NULL, NULL, 'gloves', 'women/bags/shoes/gloves.html'),
(16, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Leathers', NULL, NULL, 'leathers', 'women/bags/shoes/leathers.html'),
(17, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cocktail', NULL, NULL, 'cocktail', 'women/bags/shoes/cocktail.html'),
(18, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bands', NULL, NULL, 'bands', 'women/bags/bands.html'),
(19, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bicycle', NULL, NULL, 'bicycle', 'tv-audio/bicycle.html'),
(20, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Jackets', NULL, NULL, 'jackets', 'tv-audio/bicycle/jackets.html'),
(21, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hair', NULL, NULL, 'hair', 'women/bags/shoes/shirts/hair.html'),
(22, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Clothing', NULL, NULL, 'clothing', 'women/bags/shoes/clothing.html'),
(23, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Blog', NULL, NULL, 'blog', 'women/bags/blog.html'),
(24, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Scarves', NULL, NULL, 'scarves', 'tv-audio/bicycle/scarves.html'),
(25, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lifestyle', NULL, NULL, 'lifestyle', 'tv-audio/bicycle/lifestyle.html'),
(26, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bras', NULL, NULL, 'bras', 'accessories-17/bras.html'),
(27, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Helmet', NULL, NULL, 'helmet', 'women/bags/shoes/shirts/helmet.html'),
(28, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetics', NULL, NULL, 'cosmetics', 'accessories-17/cosmetics.html'),
(29, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Camis', NULL, NULL, 'camis', 'women/bags/shoes/shirts/camis.html'),
(30, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lingerie', NULL, NULL, 'lingerie', 'women/bags/shoes/shirts/lingerie.html'),
(31, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shirts', NULL, NULL, 'shirts', 'women/bags/shoes/shirts.html'),
(32, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Tops', NULL, NULL, 'tops', 'women/bags/shoes/shirts/tops.html'),
(33, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bags', NULL, NULL, 'bags', 'women/bags.html'),
(34, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Nightwear', NULL, NULL, 'nightwear', 'women/bags/nightwear.html'),
(35, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Briefs', NULL, NULL, 'briefs', 'women/bags/briefs.html'),
(36, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Duffle', NULL, NULL, 'duffle', 'women/bags/duffle.html'),
(37, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dresses', NULL, NULL, 'dresses', 'women/bags/dresses.html'),
(38, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'women/bags/laptop.html'),
(39, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetic', NULL, NULL, 'cosmetic', 'women/bags/cosmetic.html'),
(40, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_12_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cfg products', NULL, NULL, 'cfg-products', 'accessories-17/cfg-products.html'),
(41, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, NULL, 1, 1, 0, 6, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories-17/product-types.html'),
(42, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0, 4, NULL, NULL, NULL, NULL, 'fa fa-camera-retro', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_5.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cameras & Photography', NULL, NULL, 'cameras-photography', 'cameras-photography.html'),
(43, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4, 4, NULL, NULL, NULL, NULL, 'fa fa-desktop', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_6.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'TV & Audio', NULL, NULL, 'tv-audio', 'tv-audio.html'),
(44, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0, 4, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-laptop', '1', NULL, '0', '1', '3', '1', 'laptops-computers', NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_2.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptops & Computers', NULL, NULL, 'laptops-computers', 'laptops-computers.html'),
(45, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0, 4, NULL, NULL, NULL, NULL, 'fa fa-mobile-phone', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_7.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smart Phones & Tablets', NULL, NULL, 'smart-phones-tablets', 'smart-phones-tablets.html'),
(46, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_8.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Video Games & Consoles', NULL, NULL, 'video-games-consoles', 'video-games-consoles.html'),
(47, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_9.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Gadgets', NULL, NULL, 'gadgets', 'gadgets.html'),
(48, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_10.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Car Electronics & GPS', NULL, NULL, 'car-electronics-gps', 'car-electronics-gps.html'),
(49, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_11.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'laptop.html'),
(50, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_12.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Accessories', NULL, NULL, 'accessories', 'accessories.html'),
(51, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Salad Plates', NULL, NULL, 'salad-plates', 'women/shapewear/salad-plates.html'),
(52, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Kitchen Storage ', NULL, NULL, 'kitchen-storage', 'women/shapewear/kitchen-storage.html'),
(53, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dish Racks', NULL, NULL, 'dish-racks', 'women/shapewear/dish-racks.html'),
(54, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Colanders', NULL, NULL, 'colanders', 'women/shapewear/colanders.html'),
(55, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Casio Watches ', NULL, NULL, 'casio-watches', 'casio-watches.html'),
(56, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Asus Tablets ', NULL, NULL, 'asus-tablets', 'asus-tablets.html'),
(57, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0, 4, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Women Fashion', NULL, NULL, 'women-fashion', 'women-fashion.html'),
(58, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0, 4, NULL, NULL, NULL, NULL, NULL, '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_13.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_flat_store_5` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'entity_id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'parent_id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'created_at',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'updated_at',
  `path` varchar(255) NOT NULL DEFAULT '' COMMENT 'path',
  `position` int(11) NOT NULL COMMENT 'position',
  `level` int(11) NOT NULL DEFAULT '0' COMMENT 'level',
  `children_count` int(11) NOT NULL COMMENT 'children_count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `all_children` text COMMENT 'All Children',
  `amoda_block_b` text COMMENT 'Block Bottom',
  `amoda_block_r` text COMMENT 'Block Right',
  `amoda_block_t` text COMMENT 'Block Top',
  `amoda_custom_icon` varchar(255) DEFAULT NULL COMMENT 'Icon',
  `amoda_groupsubcat` varchar(255) DEFAULT NULL COMMENT 'Group Subcategories',
  `amoda_label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `amoda_menulink` varchar(255) DEFAULT NULL COMMENT 'Hide link',
  `amoda_menutype` varchar(255) DEFAULT NULL COMMENT 'Dropdown with',
  `amoda_subcat_colw` varchar(255) DEFAULT NULL COMMENT 'Col width for subcategories',
  `amoda_subcat_w` varchar(255) DEFAULT NULL COMMENT 'Width for subcategories block',
  `amoda_title_alias` varchar(255) DEFAULT NULL COMMENT 'Name alias',
  `available_sort_by` text COMMENT 'Available Product Listing Sort By',
  `children` text COMMENT 'Children',
  `custom_apply_to_products` int(11) DEFAULT NULL COMMENT 'Apply To Products',
  `custom_design` varchar(255) DEFAULT NULL COMMENT 'Custom Design',
  `custom_design_from` datetime DEFAULT NULL COMMENT 'Active From',
  `custom_design_to` datetime DEFAULT NULL COMMENT 'Active To',
  `custom_layout_update` text COMMENT 'Custom Layout Update',
  `custom_use_parent_settings` int(11) DEFAULT NULL COMMENT 'Use Parent Category Settings',
  `default_sort_by` varchar(255) DEFAULT NULL COMMENT 'Default Product Listing Sort By',
  `description` text COMMENT 'Description',
  `display_mode` varchar(255) DEFAULT NULL COMMENT 'Display Mode',
  `filter_price_range` decimal(12,4) DEFAULT NULL COMMENT 'Layered Navigation Price Step',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `include_in_menu` int(11) DEFAULT NULL COMMENT 'Include in Navigation Menu',
  `is_active` int(11) DEFAULT NULL COMMENT 'Is Active',
  `is_anchor` int(11) DEFAULT NULL COMMENT 'Is Anchor',
  `landing_page` int(11) DEFAULT NULL COMMENT 'CMS Block',
  `meta_description` text COMMENT 'Meta Description',
  `meta_keywords` text COMMENT 'Meta Keywords',
  `meta_title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `page_layout` varchar(255) DEFAULT NULL COMMENT 'Page Layout',
  `path_in_store` text COMMENT 'Path In Store',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'URL Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Flat (Store 5)';

INSERT INTO `#__catalog_category_flat_store_5` (`entity_id`, `parent_id`, `created_at`, `updated_at`, `path`, `position`, `level`, `children_count`, `store_id`, `all_children`, `amoda_block_b`, `amoda_block_r`, `amoda_block_t`, `amoda_custom_icon`, `amoda_groupsubcat`, `amoda_label`, `amoda_menulink`, `amoda_menutype`, `amoda_subcat_colw`, `amoda_subcat_w`, `amoda_title_alias`, `available_sort_by`, `children`, `custom_apply_to_products`, `custom_design`, `custom_design_from`, `custom_design_to`, `custom_layout_update`, `custom_use_parent_settings`, `default_sort_by`, `description`, `display_mode`, `filter_price_range`, `image`, `include_in_menu`, `is_active`, `is_anchor`, `landing_page`, `meta_description`, `meta_keywords`, `meta_title`, `name`, `page_layout`, `path_in_store`, `url_key`, `url_path`) VALUES
(1, 0, '2014-02-13 00:00:18', '2014-12-03 00:00:18', '1', 0, 0, 57, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, 'Root Catalog', NULL, NULL, NULL, NULL),
(2, 1, '2014-12-03 00:00:18', '2014-12-03 00:00:18', '1/2', 1, 1, 56, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 1, NULL, NULL, NULL, NULL, NULL, 'Default Category', NULL, NULL, NULL, NULL),
(3, 2, '2014-12-03 00:04:45', '2015-05-06 21:57:49', '1/2/3', 1, 2, 0, 5, NULL, NULL, NULL, NULL, 'fa fa-male', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Fashion', NULL, NULL, 'men', 'men.html'),
(4, 2, '2014-12-04 20:26:09', '2015-05-06 21:08:41', '1/2/4', 2, 2, 31, 5, NULL, NULL, NULL, NULL, 'fa fa-mobile', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smartphone', NULL, NULL, 'women', 'women.html'),
(5, 2, '2014-12-04 20:27:05', '2015-06-15 00:57:22', '1/2/5', 4, 2, 0, 5, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu2.jpg"}}" alt="" /></a></div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-futbol-o', '1', NULL, '0', '1', '3', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_3.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Sporst', NULL, NULL, 'kid', 'kid.html'),
(6, 2, '2014-12-04 20:27:28', '2015-05-06 21:13:27', '1/2/6', 5, 2, 4, 5, NULL, NULL, NULL, NULL, 'fa fa-gamepad', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, 'category_4.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'PlayStation', NULL, NULL, 'accessories', 'accessories-17.html'),
(7, 8, '2014-12-04 20:30:56', '2014-12-04 20:30:56', '1/2/4/33/8/7', 3, 5, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Rings', NULL, NULL, 'rings', 'women/bags/shoes/rings.html'),
(8, 33, '2014-12-04 20:31:17', '2014-12-04 20:31:17', '1/2/4/33/8', 3, 4, 11, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shoes', NULL, NULL, 'shoes', 'women/bags/shoes.html'),
(9, 4, '2014-04-12 20:31:53', '2015-01-12 21:13:15', '1/2/4/9', 2, 3, 9, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shapewear', NULL, NULL, 'shapewear', 'women/shapewear.html'),
(10, 9, '2014-12-04 20:32:15', '2014-12-04 20:32:15', '1/2/4/9/10', 5, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Sundresses', NULL, NULL, 'sundresses', 'women/shapewear/sundresses.html'),
(11, 9, '2014-12-04 20:32:36', '2014-12-04 20:32:36', '1/2/4/9/11', 4, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Footwear', NULL, NULL, 'footwear', 'women/shapewear/footwear.html'),
(12, 9, '2014-12-04 20:32:56', '2014-12-04 20:32:56', '1/2/4/9/12', 3, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Novelty', NULL, NULL, 'novelty', 'women/shapewear/novelty.html'),
(13, 9, '2014-12-04 20:33:18', '2014-12-04 20:33:18', '1/2/4/9/13', 2, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Outerwear', NULL, NULL, 'outerwear', 'women/shapewear/outerwear.html'),
(14, 9, '2014-12-04 20:33:36', '2014-12-04 20:33:36', '1/2/4/9/14', 1, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hats', NULL, NULL, 'hats', 'women/shapewear/hats.html'),
(15, 8, '2014-12-04 20:33:53', '2014-12-04 20:33:53', '1/2/4/33/8/15', 5, 5, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Gloves', NULL, NULL, 'gloves', 'women/bags/shoes/gloves.html'),
(16, 8, '2014-12-04 20:37:09', '2014-12-04 20:37:09', '1/2/4/33/8/16', 1, 5, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Leathers', NULL, NULL, 'leathers', 'women/bags/shoes/leathers.html'),
(17, 8, '2014-12-04 20:37:25', '2014-12-04 20:37:25', '1/2/4/33/8/17', 4, 5, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cocktail', NULL, NULL, 'cocktail', 'women/bags/shoes/cocktail.html'),
(18, 33, '2014-12-04 20:37:39', '2014-12-04 20:37:39', '1/2/4/33/18', 6, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bands', NULL, NULL, 'bands', 'women/bags/bands.html'),
(19, 43, '2014-04-12 20:37:54', '2015-01-12 21:13:37', '1/2/43/19', 1, 3, 3, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bicycle', NULL, NULL, 'bicycle', 'tv-audio/bicycle.html'),
(20, 19, '2014-12-04 20:38:13', '2014-12-04 20:38:13', '1/2/43/19/20', 2, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Jackets', NULL, NULL, 'jackets', 'tv-audio/bicycle/jackets.html'),
(21, 31, '2014-12-04 20:38:28', '2014-12-04 20:38:28', '1/2/4/33/8/31/21', 5, 6, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Hair', NULL, NULL, 'hair', 'women/bags/shoes/shirts/hair.html'),
(22, 8, '2014-12-04 20:38:43', '2014-12-04 20:38:43', '1/2/4/33/8/22', 6, 5, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Clothing', NULL, NULL, 'clothing', 'women/bags/shoes/clothing.html'),
(23, 33, '2014-12-04 20:39:00', '2014-12-04 20:39:00', '1/2/4/33/23', 5, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Blog', NULL, NULL, 'blog', 'women/bags/blog.html'),
(24, 19, '2014-12-04 20:39:16', '2014-12-04 20:39:16', '1/2/43/19/24', 3, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Scarves', NULL, NULL, 'scarves', 'tv-audio/bicycle/scarves.html'),
(25, 19, '2014-12-04 20:39:31', '2014-12-04 20:39:31', '1/2/43/19/25', 1, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lifestyle', NULL, NULL, 'lifestyle', 'tv-audio/bicycle/lifestyle.html'),
(26, 6, '2014-12-04 20:39:44', '2014-12-04 20:39:44', '1/2/6/26', 4, 3, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bras', NULL, NULL, 'bras', 'accessories-17/bras.html'),
(27, 31, '2014-12-04 20:39:59', '2014-12-04 20:39:59', '1/2/4/33/8/31/27', 3, 6, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Helmet', NULL, NULL, 'helmet', 'women/bags/shoes/shirts/helmet.html'),
(28, 6, '2014-12-04 20:40:14', '2014-12-04 20:40:14', '1/2/6/28', 3, 3, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetics', NULL, NULL, 'cosmetics', 'accessories-17/cosmetics.html'),
(29, 31, '2014-12-04 20:40:30', '2014-12-04 20:40:30', '1/2/4/33/8/31/29', 2, 6, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Camis', NULL, NULL, 'camis', 'women/bags/shoes/shirts/camis.html'),
(30, 31, '2014-12-04 20:40:43', '2014-12-04 20:40:43', '1/2/4/33/8/31/30', 4, 6, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Lingerie', NULL, NULL, 'lingerie', 'women/bags/shoes/shirts/lingerie.html'),
(31, 8, '2014-12-04 20:40:55', '2014-12-04 20:40:55', '1/2/4/33/8/31', 2, 5, 5, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Shirts', NULL, NULL, 'shirts', 'women/bags/shoes/shirts.html'),
(32, 31, '2014-12-04 20:41:08', '2014-12-04 20:41:08', '1/2/4/33/8/31/32', 1, 6, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Tops', NULL, NULL, 'tops', 'women/bags/shoes/shirts/tops.html'),
(33, 4, '2014-04-12 20:41:20', '2015-01-12 21:12:32', '1/2/4/33', 1, 3, 20, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Bags', NULL, NULL, 'bags', 'women/bags.html'),
(34, 33, '2014-12-04 20:41:33', '2014-12-04 20:41:33', '1/2/4/33/34', 9, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Nightwear', NULL, NULL, 'nightwear', 'women/bags/nightwear.html'),
(35, 33, '2014-12-04 20:41:46', '2014-12-04 20:41:46', '1/2/4/33/35', 2, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Briefs', NULL, NULL, 'briefs', 'women/bags/briefs.html'),
(36, 33, '2014-12-04 20:41:58', '2014-12-04 20:41:58', '1/2/4/33/36', 8, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Duffle', NULL, NULL, 'duffle', 'women/bags/duffle.html'),
(37, 33, '2014-12-04 20:42:11', '2014-12-04 20:42:11', '1/2/4/33/37', 4, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dresses', NULL, NULL, 'dresses', 'women/bags/dresses.html'),
(38, 33, '2014-12-04 20:42:27', '2014-12-04 20:42:27', '1/2/4/33/38', 1, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'women/bags/laptop.html'),
(39, 33, '2014-12-04 20:42:50', '2014-12-04 20:42:50', '1/2/4/33/39', 7, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Cosmetic', NULL, NULL, 'cosmetic', 'women/bags/cosmetic.html'),
(40, 6, '2014-12-08 02:27:12', '2015-01-23 19:42:50', '1/2/6/40', 1, 3, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, 'category_12_1.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cfg products', NULL, NULL, 'cfg-products', 'accessories-17/cfg-products.html'),
(41, 6, '2014-12-08 02:28:39', '2014-12-08 02:28:39', '1/2/6/41', 2, 3, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, 'PRODUCTS_AND_PAGE', NULL, NULL, 1, 1, 0, 6, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories-17/product-types.html'),
(42, 2, '2014-12-24 20:47:06', '2015-05-06 21:13:57', '1/2/42', 6, 2, 0, 5, NULL, NULL, NULL, NULL, 'fa fa-camera-retro', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_5.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Cameras & Photography', NULL, NULL, 'cameras-photography', 'cameras-photography.html'),
(43, 2, '2014-12-24 20:47:30', '2015-05-06 21:15:29', '1/2/43', 7, 2, 4, 5, NULL, NULL, NULL, NULL, 'fa fa-desktop', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_6.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'TV & Audio', NULL, NULL, 'tv-audio', 'tv-audio.html'),
(44, 2, '2014-12-24 20:47:55', '2015-06-15 00:57:03', '1/2/44', 3, 2, 0, 5, NULL, '<div class="row">\r\n<div class="col-sm-6"><a href="#" class="banner3"><img src="{{media url="wysiwyg/amoda/menu1.jpg"}}" alt="" /></a></div>\r\n<div class="col-sm-6">\r\n<h3>Lorem Ipsum is simply dummy </h3>\r\n<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>\r\n<a href="#" class="read-more"><i class="fa fa-arrow-circle-o-right"></i>Read more</a>\r\n</div>\r\n</div>\r\n', '<div class="row">\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-3">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware</span>\r\n                </a>\r\n            </li>	\r\n			 <li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>	\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>			\r\n        </ul>\r\n    </div>\r\n    <div class="col-sm-3">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Colanders</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Dish Racks</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Dinner Plates</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Cups, Mugs & Saucers</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Glassware & Drinkware</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Salad Plates</span>\r\n                </a>\r\n            </li>\r\n			<li>\r\n                <a href="#">\r\n                    <span>Kitchen Storage</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', NULL, 'fa fa-laptop', '1', NULL, '0', '1', '3', '1', 'laptops-computers', NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_2.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptops & Computers', NULL, NULL, 'laptops-computers', 'laptops-computers.html'),
(45, 2, '2014-12-24 20:48:19', '2015-05-06 21:59:03', '1/2/45', 8, 2, 0, 5, NULL, NULL, NULL, NULL, 'fa fa-mobile-phone', '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_7.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Smart Phones & Tablets', NULL, NULL, 'smart-phones-tablets', 'smart-phones-tablets.html'),
(46, 2, '2014-12-24 20:48:52', '2015-03-11 00:41:22', '1/2/46', 9, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_8.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Video Games & Consoles', NULL, NULL, 'video-games-consoles', 'video-games-consoles.html'),
(47, 2, '2014-12-24 20:49:29', '2015-03-11 00:41:42', '1/2/47', 10, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_9.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Gadgets', NULL, NULL, 'gadgets', 'gadgets.html'),
(48, 2, '2014-12-24 20:49:54', '2015-03-11 00:42:34', '1/2/48', 11, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_10.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Car Electronics & GPS', NULL, NULL, 'car-electronics-gps', 'car-electronics-gps.html'),
(49, 2, '2014-12-24 20:50:27', '2015-03-11 00:43:39', '1/2/49', 12, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_11.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Laptop', NULL, NULL, 'laptop', 'laptop.html'),
(50, 2, '2014-12-24 20:51:42', '2015-03-11 00:44:24', '1/2/50', 13, 2, 1, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_12.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Accessories', NULL, NULL, 'accessories', 'accessories.html'),
(51, 9, '2015-01-05 20:36:16', '2015-01-05 20:36:16', '1/2/4/9/51', 6, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Salad Plates', NULL, NULL, 'salad-plates', 'women/shapewear/salad-plates.html'),
(52, 9, '2015-01-05 20:36:55', '2015-01-05 20:36:55', '1/2/4/9/52', 7, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Kitchen Storage ', NULL, NULL, 'kitchen-storage', 'women/shapewear/kitchen-storage.html'),
(53, 9, '2015-01-05 20:37:13', '2015-01-05 20:37:13', '1/2/4/9/53', 8, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Dish Racks', NULL, NULL, 'dish-racks', 'women/shapewear/dish-racks.html'),
(54, 9, '2015-01-05 20:37:30', '2015-01-05 20:37:30', '1/2/4/9/54', 9, 4, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Colanders', NULL, NULL, 'colanders', 'women/shapewear/colanders.html'),
(55, 2, '2015-01-22 03:10:32', '2015-03-11 00:44:48', '1/2/55', 14, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Casio Watches ', NULL, NULL, 'casio-watches', 'casio-watches.html'),
(56, 2, '2015-01-22 03:10:50', '2015-03-11 00:45:59', '1/2/56', 15, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Asus Tablets ', NULL, NULL, 'asus-tablets', 'asus-tablets.html'),
(57, 2, '2015-01-22 03:11:23', '2015-03-11 00:46:12', '1/2/57', 16, 2, 0, 5, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, NULL, 1, 1, 0, NULL, NULL, NULL, NULL, 'Women Fashion', NULL, NULL, 'women-fashion', 'women-fashion.html'),
(58, 50, '2015-05-29 01:55:05', '2015-05-29 01:55:05', '1/2/50/58', 1, 3, 0, 5, NULL, NULL, NULL, NULL, NULL, '0', NULL, '0', '0', '1', '1', NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, 0, NULL, NULL, 'PRODUCTS', NULL, 'category_13.png', 1, 1, 0, NULL, NULL, NULL, NULL, 'Product types', NULL, NULL, 'product-types', 'accessories/product-types.html');

CREATE TABLE IF NOT EXISTS `#__catalog_category_product` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(11) NOT NULL DEFAULT '0' COMMENT 'Position'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product To Category Linkage Table';

INSERT INTO `#__catalog_category_product` (`category_id`, `product_id`, `position`) VALUES
(2, 7, 1),
(2, 13, 1),
(2, 19, 1),
(2, 20, 1),
(2, 21, 1),
(2, 42, 1),
(2, 44, 1),
(2, 45, 1),
(2, 46, 1),
(2, 47, 1),
(2, 48, 1),
(3, 7, 1),
(3, 8, 0),
(3, 9, 0),
(3, 10, 0),
(3, 11, 0),
(3, 12, 0),
(3, 13, 1),
(3, 14, 0),
(3, 15, 0),
(3, 16, 0),
(3, 17, 0),
(3, 18, 0),
(3, 19, 1),
(3, 20, 1),
(3, 21, 1),
(3, 22, 0),
(3, 23, 0),
(3, 24, 0),
(3, 25, 0),
(3, 26, 0),
(3, 27, 0),
(3, 28, 0),
(3, 29, 0),
(3, 30, 0),
(3, 31, 0),
(3, 32, 0),
(3, 33, 0),
(3, 34, 0),
(3, 35, 0),
(3, 36, 0),
(3, 37, 0),
(3, 38, 0),
(3, 39, 0),
(3, 40, 0),
(3, 41, 0),
(3, 42, 1),
(3, 44, 1),
(3, 45, 1),
(3, 46, 1),
(3, 47, 1),
(3, 48, 1),
(4, 7, 0),
(4, 8, 0),
(4, 9, 0),
(4, 10, 0),
(4, 11, 0),
(4, 12, 0),
(4, 13, 0),
(4, 14, 0),
(4, 15, 0),
(4, 16, 0),
(4, 17, 0),
(4, 18, 0),
(4, 19, 0),
(4, 20, 0),
(4, 21, 0),
(4, 22, 0),
(4, 23, 0),
(4, 24, 0),
(4, 25, 0),
(4, 26, 0),
(4, 27, 0),
(4, 28, 0),
(4, 29, 0),
(4, 30, 0),
(4, 31, 0),
(4, 32, 0),
(4, 33, 0),
(4, 34, 0),
(4, 35, 0),
(4, 36, 0),
(4, 37, 0),
(4, 38, 0),
(4, 39, 0),
(4, 40, 0),
(4, 41, 0),
(4, 42, 0),
(4, 44, 0),
(4, 45, 0),
(4, 46, 0),
(4, 47, 0),
(4, 48, 0),
(5, 29, 0),
(5, 30, 0),
(5, 31, 0),
(5, 32, 0),
(5, 33, 0),
(5, 34, 0),
(5, 35, 0),
(5, 36, 0),
(5, 37, 0),
(5, 38, 0),
(5, 39, 0),
(5, 40, 0),
(5, 41, 0),
(5, 42, 0),
(5, 44, 0),
(5, 45, 0),
(5, 46, 0),
(6, 29, 0),
(6, 30, 0),
(6, 31, 0),
(6, 32, 0),
(6, 33, 0),
(6, 34, 0),
(6, 35, 0),
(6, 36, 0),
(6, 37, 0),
(6, 38, 0),
(6, 39, 0),
(6, 40, 0),
(6, 41, 0),
(6, 42, 0),
(6, 44, 0),
(6, 45, 0),
(6, 46, 0),
(6, 47, 0),
(6, 48, 1),
(9, 33, 0),
(9, 34, 0),
(9, 35, 0),
(9, 36, 0),
(9, 37, 0),
(9, 38, 0),
(9, 39, 0),
(9, 40, 0),
(9, 41, 0),
(9, 42, 0),
(9, 44, 0),
(9, 45, 0),
(9, 46, 0),
(9, 47, 0),
(9, 48, 0),
(19, 29, 0),
(19, 30, 0),
(19, 31, 0),
(19, 32, 0),
(19, 33, 0),
(19, 34, 0),
(19, 35, 0),
(19, 36, 0),
(19, 37, 0),
(19, 38, 0),
(19, 39, 0),
(19, 40, 0),
(19, 41, 0),
(19, 42, 0),
(19, 44, 0),
(19, 45, 0),
(19, 46, 0),
(19, 47, 0),
(19, 48, 1),
(20, 48, 1),
(24, 48, 1),
(25, 48, 1),
(26, 48, 1),
(28, 48, 1),
(33, 29, 0),
(33, 30, 0),
(33, 31, 0),
(33, 32, 0),
(33, 33, 0),
(33, 34, 0),
(33, 35, 0),
(33, 36, 0),
(33, 37, 0),
(33, 38, 0),
(33, 39, 0),
(33, 40, 0),
(33, 41, 0),
(33, 42, 0),
(33, 44, 0),
(33, 45, 0),
(33, 46, 0),
(33, 47, 0),
(33, 48, 0),
(40, 7, 0),
(40, 13, 0),
(40, 19, 0),
(40, 20, 0),
(40, 21, 0),
(40, 48, 1),
(41, 7, 0),
(41, 13, 0),
(41, 19, 0),
(41, 20, 0),
(41, 21, 0),
(41, 37, 0),
(41, 42, 0),
(41, 44, 0),
(41, 45, 0),
(41, 46, 0),
(41, 47, 0),
(41, 48, 0),
(42, 29, 0),
(42, 30, 0),
(42, 31, 0),
(42, 32, 0),
(42, 33, 0),
(42, 34, 0),
(42, 35, 0),
(42, 36, 0),
(42, 37, 0),
(42, 38, 0),
(42, 39, 0),
(42, 40, 0),
(42, 41, 0),
(42, 42, 0),
(42, 44, 0),
(42, 45, 0),
(42, 46, 0),
(42, 47, 0),
(42, 48, 1),
(43, 29, 0),
(43, 30, 0),
(43, 31, 0),
(43, 32, 0),
(43, 33, 0),
(43, 34, 0),
(43, 35, 0),
(43, 36, 0),
(43, 37, 0),
(43, 38, 0),
(43, 39, 0),
(43, 40, 0),
(43, 41, 0),
(43, 42, 0),
(43, 44, 0),
(43, 45, 0),
(43, 46, 0),
(43, 47, 0),
(43, 48, 1),
(44, 29, 0),
(44, 30, 0),
(44, 31, 0),
(44, 32, 0),
(44, 33, 0),
(44, 34, 0),
(44, 35, 0),
(44, 36, 0),
(44, 37, 0),
(44, 38, 0),
(44, 39, 0),
(44, 40, 0),
(44, 41, 0),
(44, 42, 0),
(44, 44, 0),
(44, 45, 0),
(44, 46, 0),
(44, 47, 0),
(44, 48, 1),
(45, 29, 0),
(45, 30, 0),
(45, 31, 0),
(45, 32, 0),
(45, 33, 0),
(45, 34, 0),
(45, 35, 0),
(45, 36, 0),
(45, 37, 0),
(45, 38, 0),
(45, 39, 0),
(45, 40, 0),
(45, 41, 0),
(45, 42, 0),
(45, 44, 0),
(45, 45, 0),
(45, 46, 0),
(45, 47, 0),
(45, 48, 1),
(46, 29, 0),
(46, 30, 0),
(46, 31, 0),
(46, 32, 0),
(46, 33, 0),
(46, 34, 0),
(46, 35, 0),
(46, 36, 0),
(46, 37, 0),
(46, 38, 0),
(46, 39, 0),
(46, 40, 0),
(46, 41, 0),
(46, 42, 0),
(46, 44, 0),
(46, 45, 0),
(46, 46, 0),
(46, 47, 0),
(46, 48, 1),
(47, 29, 0),
(47, 30, 0),
(47, 31, 0),
(47, 32, 0),
(47, 33, 0),
(47, 34, 0),
(47, 35, 0),
(47, 36, 0),
(47, 37, 0),
(47, 38, 0),
(47, 39, 0),
(47, 40, 0),
(47, 41, 0),
(47, 42, 0),
(47, 44, 0),
(47, 45, 0),
(47, 46, 0),
(47, 47, 0),
(47, 48, 1),
(48, 29, 0),
(48, 30, 0),
(48, 31, 0),
(48, 32, 0),
(48, 33, 0),
(48, 34, 0),
(48, 35, 0),
(48, 36, 0),
(48, 37, 0),
(48, 38, 0),
(48, 39, 0),
(48, 40, 0),
(48, 41, 0),
(48, 42, 0),
(48, 44, 0),
(48, 45, 0),
(48, 46, 0),
(48, 47, 0),
(48, 48, 1),
(49, 29, 0),
(49, 30, 0),
(49, 31, 0),
(49, 32, 0),
(49, 33, 0),
(49, 34, 0),
(49, 35, 0),
(49, 36, 0),
(49, 37, 0),
(49, 38, 0),
(49, 39, 0),
(49, 40, 0),
(49, 41, 0),
(49, 42, 0),
(49, 44, 0),
(49, 45, 0),
(49, 46, 0),
(49, 47, 0),
(49, 48, 1),
(50, 29, 0),
(50, 30, 0),
(50, 31, 0),
(50, 32, 0),
(50, 33, 0),
(50, 34, 0),
(50, 35, 0),
(50, 36, 0),
(50, 37, 0),
(50, 38, 0),
(50, 39, 0),
(50, 40, 0),
(50, 41, 0),
(50, 42, 0),
(50, 44, 0),
(50, 45, 0),
(50, 46, 0),
(50, 47, 0),
(50, 48, 1),
(50, 49, 1),
(55, 29, 0),
(55, 30, 0),
(55, 31, 0),
(55, 32, 0),
(55, 33, 0),
(55, 34, 0),
(55, 35, 0),
(55, 36, 0),
(55, 37, 0),
(55, 38, 0),
(55, 39, 0),
(55, 40, 0),
(55, 41, 0),
(55, 42, 0),
(55, 44, 0),
(55, 45, 0),
(55, 46, 0),
(55, 47, 0),
(55, 48, 0),
(56, 29, 0),
(56, 30, 0),
(56, 31, 0),
(56, 32, 0),
(56, 33, 0),
(56, 34, 0),
(56, 35, 0),
(56, 36, 0),
(56, 37, 0),
(56, 38, 0),
(56, 39, 0),
(56, 40, 0),
(56, 41, 0),
(56, 42, 0),
(56, 44, 0),
(56, 45, 0),
(56, 46, 0),
(56, 47, 0),
(56, 48, 0),
(57, 29, 0),
(57, 30, 0),
(57, 31, 0),
(57, 32, 0),
(57, 33, 0),
(57, 34, 0),
(57, 35, 0),
(57, 36, 0),
(57, 37, 0),
(57, 38, 0),
(57, 39, 0),
(57, 40, 0),
(57, 41, 0),
(57, 42, 0),
(57, 44, 0),
(57, 45, 0),
(57, 46, 0),
(57, 47, 0),
(57, 48, 0),
(58, 7, 0),
(58, 13, 0),
(58, 19, 0),
(58, 20, 0),
(58, 21, 0),
(58, 37, 0),
(58, 42, 0),
(58, 44, 0),
(58, 45, 0),
(58, 46, 0),
(58, 47, 0),
(58, 48, 0),
(58, 49, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_category_product_index` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(11) DEFAULT NULL COMMENT 'Position',
  `is_parent` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint(5) unsigned NOT NULL COMMENT 'Visibility'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Product Index';

INSERT INTO `#__catalog_category_product_index` (`category_id`, `product_id`, `position`, `is_parent`, `store_id`, `visibility`) VALUES
(2, 8, 20004, 0, 1, 4),
(2, 9, 20004, 0, 1, 4),
(2, 10, 20004, 0, 1, 4),
(2, 11, 20004, 0, 1, 4),
(2, 12, 20004, 0, 1, 4),
(2, 14, 20004, 0, 1, 4),
(2, 15, 20004, 0, 1, 4),
(2, 16, 20004, 0, 1, 4),
(2, 17, 20004, 0, 1, 4),
(2, 18, 20004, 0, 1, 4),
(2, 22, 20004, 0, 1, 4),
(2, 23, 20004, 0, 1, 4),
(2, 24, 20004, 0, 1, 4),
(2, 25, 20004, 0, 1, 4),
(2, 26, 20004, 0, 1, 4),
(2, 27, 20004, 0, 1, 4),
(2, 28, 20004, 0, 1, 4),
(2, 29, 20004, 0, 1, 4),
(2, 30, 20004, 0, 1, 4),
(2, 31, 20004, 0, 1, 4),
(2, 32, 20004, 0, 1, 4),
(2, 33, 20004, 0, 1, 4),
(2, 34, 20004, 0, 1, 4),
(2, 35, 20004, 0, 1, 4),
(2, 36, 20004, 0, 1, 4),
(2, 37, 20004, 0, 1, 4),
(2, 38, 20004, 0, 1, 4),
(2, 39, 20004, 0, 1, 4),
(2, 40, 20004, 0, 1, 4),
(2, 41, 20004, 0, 1, 4),
(2, 49, 20007, 0, 1, 4),
(2, 7, 1, 1, 1, 4),
(2, 13, 1, 1, 1, 4),
(2, 19, 1, 1, 1, 4),
(2, 20, 1, 1, 1, 4),
(2, 21, 1, 1, 1, 4),
(2, 42, 1, 1, 1, 4),
(2, 44, 1, 1, 1, 4),
(2, 45, 1, 1, 1, 4),
(2, 46, 1, 1, 1, 4),
(2, 47, 1, 1, 1, 4),
(2, 48, 1, 1, 1, 4),
(3, 8, 0, 1, 1, 4),
(3, 9, 0, 1, 1, 4),
(3, 10, 0, 1, 1, 4),
(3, 11, 0, 1, 1, 4),
(3, 12, 0, 1, 1, 4),
(3, 14, 0, 1, 1, 4),
(3, 15, 0, 1, 1, 4),
(3, 16, 0, 1, 1, 4),
(3, 17, 0, 1, 1, 4),
(3, 18, 0, 1, 1, 4),
(3, 22, 0, 1, 1, 4),
(3, 23, 0, 1, 1, 4),
(3, 24, 0, 1, 1, 4),
(3, 25, 0, 1, 1, 4),
(3, 26, 0, 1, 1, 4),
(3, 27, 0, 1, 1, 4),
(3, 28, 0, 1, 1, 4),
(3, 29, 0, 1, 1, 4),
(3, 30, 0, 1, 1, 4),
(3, 31, 0, 1, 1, 4),
(3, 32, 0, 1, 1, 4),
(3, 33, 0, 1, 1, 4),
(3, 34, 0, 1, 1, 4),
(3, 35, 0, 1, 1, 4),
(3, 36, 0, 1, 1, 4),
(3, 37, 0, 1, 1, 4),
(3, 38, 0, 1, 1, 4),
(3, 39, 0, 1, 1, 4),
(3, 40, 0, 1, 1, 4),
(3, 41, 0, 1, 1, 4),
(3, 7, 1, 1, 1, 4),
(3, 13, 1, 1, 1, 4),
(3, 19, 1, 1, 1, 4),
(3, 20, 1, 1, 1, 4),
(3, 21, 1, 1, 1, 4),
(3, 42, 1, 1, 1, 4),
(3, 44, 1, 1, 1, 4),
(3, 45, 1, 1, 1, 4),
(3, 46, 1, 1, 1, 4),
(3, 47, 1, 1, 1, 4),
(3, 48, 1, 1, 1, 4),
(4, 7, 0, 1, 1, 4),
(4, 8, 0, 1, 1, 4),
(4, 9, 0, 1, 1, 4),
(4, 10, 0, 1, 1, 4),
(4, 11, 0, 1, 1, 4),
(4, 12, 0, 1, 1, 4),
(4, 13, 0, 1, 1, 4),
(4, 14, 0, 1, 1, 4),
(4, 15, 0, 1, 1, 4),
(4, 16, 0, 1, 1, 4),
(4, 17, 0, 1, 1, 4),
(4, 18, 0, 1, 1, 4),
(4, 19, 0, 1, 1, 4),
(4, 20, 0, 1, 1, 4),
(4, 21, 0, 1, 1, 4),
(4, 22, 0, 1, 1, 4),
(4, 23, 0, 1, 1, 4),
(4, 24, 0, 1, 1, 4),
(4, 25, 0, 1, 1, 4),
(4, 26, 0, 1, 1, 4),
(4, 27, 0, 1, 1, 4),
(4, 28, 0, 1, 1, 4),
(4, 29, 0, 1, 1, 4),
(4, 30, 0, 1, 1, 4),
(4, 31, 0, 1, 1, 4),
(4, 32, 0, 1, 1, 4),
(4, 33, 0, 1, 1, 4),
(4, 34, 0, 1, 1, 4),
(4, 35, 0, 1, 1, 4),
(4, 36, 0, 1, 1, 4),
(4, 37, 0, 1, 1, 4),
(4, 38, 0, 1, 1, 4),
(4, 39, 0, 1, 1, 4),
(4, 40, 0, 1, 1, 4),
(4, 41, 0, 1, 1, 4),
(4, 42, 0, 1, 1, 4),
(4, 44, 0, 1, 1, 4),
(4, 45, 0, 1, 1, 4),
(4, 46, 0, 1, 1, 4),
(4, 47, 0, 1, 1, 4),
(4, 48, 0, 1, 1, 4),
(5, 29, 0, 1, 1, 4),
(5, 30, 0, 1, 1, 4),
(5, 31, 0, 1, 1, 4),
(5, 32, 0, 1, 1, 4),
(5, 33, 0, 1, 1, 4),
(5, 34, 0, 1, 1, 4),
(5, 35, 0, 1, 1, 4),
(5, 36, 0, 1, 1, 4),
(5, 37, 0, 1, 1, 4),
(5, 38, 0, 1, 1, 4),
(5, 39, 0, 1, 1, 4),
(5, 40, 0, 1, 1, 4),
(5, 41, 0, 1, 1, 4),
(5, 42, 0, 1, 1, 4),
(5, 44, 0, 1, 1, 4),
(5, 45, 0, 1, 1, 4),
(5, 46, 0, 1, 1, 4),
(6, 29, 0, 1, 1, 4),
(6, 30, 0, 1, 1, 4),
(6, 31, 0, 1, 1, 4),
(6, 32, 0, 1, 1, 4),
(6, 33, 0, 1, 1, 4),
(6, 34, 0, 1, 1, 4),
(6, 35, 0, 1, 1, 4),
(6, 36, 0, 1, 1, 4),
(6, 37, 0, 1, 1, 4),
(6, 38, 0, 1, 1, 4),
(6, 39, 0, 1, 1, 4),
(6, 40, 0, 1, 1, 4),
(6, 41, 0, 1, 1, 4),
(6, 42, 0, 1, 1, 4),
(6, 44, 0, 1, 1, 4),
(6, 45, 0, 1, 1, 4),
(6, 46, 0, 1, 1, 4),
(6, 47, 0, 1, 1, 4),
(6, 48, 1, 1, 1, 4),
(9, 33, 0, 1, 1, 4),
(9, 34, 0, 1, 1, 4),
(9, 35, 0, 1, 1, 4),
(9, 36, 0, 1, 1, 4),
(9, 37, 0, 1, 1, 4),
(9, 38, 0, 1, 1, 4),
(9, 39, 0, 1, 1, 4),
(9, 40, 0, 1, 1, 4),
(9, 41, 0, 1, 1, 4),
(9, 42, 0, 1, 1, 4),
(9, 44, 0, 1, 1, 4),
(9, 45, 0, 1, 1, 4),
(9, 46, 0, 1, 1, 4),
(9, 47, 0, 1, 1, 4),
(9, 48, 0, 1, 1, 4),
(19, 29, 0, 1, 1, 4),
(19, 30, 0, 1, 1, 4),
(19, 31, 0, 1, 1, 4),
(19, 32, 0, 1, 1, 4),
(19, 33, 0, 1, 1, 4),
(19, 34, 0, 1, 1, 4),
(19, 35, 0, 1, 1, 4),
(19, 36, 0, 1, 1, 4),
(19, 37, 0, 1, 1, 4),
(19, 38, 0, 1, 1, 4),
(19, 39, 0, 1, 1, 4),
(19, 40, 0, 1, 1, 4),
(19, 41, 0, 1, 1, 4),
(19, 42, 0, 1, 1, 4),
(19, 44, 0, 1, 1, 4),
(19, 45, 0, 1, 1, 4),
(19, 46, 0, 1, 1, 4),
(19, 47, 0, 1, 1, 4),
(19, 48, 1, 1, 1, 4),
(20, 48, 1, 1, 1, 4),
(24, 48, 1, 1, 1, 4),
(25, 48, 1, 1, 1, 4),
(26, 48, 1, 1, 1, 4),
(28, 48, 1, 1, 1, 4),
(33, 29, 0, 1, 1, 4),
(33, 30, 0, 1, 1, 4),
(33, 31, 0, 1, 1, 4),
(33, 32, 0, 1, 1, 4),
(33, 33, 0, 1, 1, 4),
(33, 34, 0, 1, 1, 4),
(33, 35, 0, 1, 1, 4),
(33, 36, 0, 1, 1, 4),
(33, 37, 0, 1, 1, 4),
(33, 38, 0, 1, 1, 4),
(33, 39, 0, 1, 1, 4),
(33, 40, 0, 1, 1, 4),
(33, 41, 0, 1, 1, 4),
(33, 42, 0, 1, 1, 4),
(33, 44, 0, 1, 1, 4),
(33, 45, 0, 1, 1, 4),
(33, 46, 0, 1, 1, 4),
(33, 47, 0, 1, 1, 4),
(33, 48, 0, 1, 1, 4),
(40, 7, 0, 1, 1, 4),
(40, 13, 0, 1, 1, 4),
(40, 19, 0, 1, 1, 4),
(40, 20, 0, 1, 1, 4),
(40, 21, 0, 1, 1, 4),
(40, 48, 1, 1, 1, 4),
(41, 7, 0, 1, 1, 4),
(41, 13, 0, 1, 1, 4),
(41, 19, 0, 1, 1, 4),
(41, 20, 0, 1, 1, 4),
(41, 21, 0, 1, 1, 4),
(41, 37, 0, 1, 1, 4),
(41, 42, 0, 1, 1, 4),
(41, 44, 0, 1, 1, 4),
(41, 45, 0, 1, 1, 4),
(41, 46, 0, 1, 1, 4),
(41, 47, 0, 1, 1, 4),
(41, 48, 0, 1, 1, 4),
(42, 29, 0, 1, 1, 4),
(42, 30, 0, 1, 1, 4),
(42, 31, 0, 1, 1, 4),
(42, 32, 0, 1, 1, 4),
(42, 33, 0, 1, 1, 4),
(42, 34, 0, 1, 1, 4),
(42, 35, 0, 1, 1, 4),
(42, 36, 0, 1, 1, 4),
(42, 37, 0, 1, 1, 4),
(42, 38, 0, 1, 1, 4),
(42, 39, 0, 1, 1, 4),
(42, 40, 0, 1, 1, 4),
(42, 41, 0, 1, 1, 4),
(42, 42, 0, 1, 1, 4),
(42, 44, 0, 1, 1, 4),
(42, 45, 0, 1, 1, 4),
(42, 46, 0, 1, 1, 4),
(42, 47, 0, 1, 1, 4),
(42, 48, 1, 1, 1, 4),
(43, 29, 0, 1, 1, 4),
(43, 30, 0, 1, 1, 4),
(43, 31, 0, 1, 1, 4),
(43, 32, 0, 1, 1, 4),
(43, 33, 0, 1, 1, 4),
(43, 34, 0, 1, 1, 4),
(43, 35, 0, 1, 1, 4),
(43, 36, 0, 1, 1, 4),
(43, 37, 0, 1, 1, 4),
(43, 38, 0, 1, 1, 4),
(43, 39, 0, 1, 1, 4),
(43, 40, 0, 1, 1, 4),
(43, 41, 0, 1, 1, 4),
(43, 42, 0, 1, 1, 4),
(43, 44, 0, 1, 1, 4),
(43, 45, 0, 1, 1, 4),
(43, 46, 0, 1, 1, 4),
(43, 47, 0, 1, 1, 4),
(43, 48, 1, 1, 1, 4),
(44, 29, 0, 1, 1, 4),
(44, 30, 0, 1, 1, 4),
(44, 31, 0, 1, 1, 4),
(44, 32, 0, 1, 1, 4),
(44, 33, 0, 1, 1, 4),
(44, 34, 0, 1, 1, 4),
(44, 35, 0, 1, 1, 4),
(44, 36, 0, 1, 1, 4),
(44, 37, 0, 1, 1, 4),
(44, 38, 0, 1, 1, 4),
(44, 39, 0, 1, 1, 4),
(44, 40, 0, 1, 1, 4),
(44, 41, 0, 1, 1, 4),
(44, 42, 0, 1, 1, 4),
(44, 44, 0, 1, 1, 4),
(44, 45, 0, 1, 1, 4),
(44, 46, 0, 1, 1, 4),
(44, 47, 0, 1, 1, 4),
(44, 48, 1, 1, 1, 4),
(45, 29, 0, 1, 1, 4),
(45, 30, 0, 1, 1, 4),
(45, 31, 0, 1, 1, 4),
(45, 32, 0, 1, 1, 4),
(45, 33, 0, 1, 1, 4),
(45, 34, 0, 1, 1, 4),
(45, 35, 0, 1, 1, 4),
(45, 36, 0, 1, 1, 4),
(45, 37, 0, 1, 1, 4),
(45, 38, 0, 1, 1, 4),
(45, 39, 0, 1, 1, 4),
(45, 40, 0, 1, 1, 4),
(45, 41, 0, 1, 1, 4),
(45, 42, 0, 1, 1, 4),
(45, 44, 0, 1, 1, 4),
(45, 45, 0, 1, 1, 4),
(45, 46, 0, 1, 1, 4),
(45, 47, 0, 1, 1, 4),
(45, 48, 1, 1, 1, 4),
(46, 29, 0, 1, 1, 4),
(46, 30, 0, 1, 1, 4),
(46, 31, 0, 1, 1, 4),
(46, 32, 0, 1, 1, 4),
(46, 33, 0, 1, 1, 4),
(46, 34, 0, 1, 1, 4),
(46, 35, 0, 1, 1, 4),
(46, 36, 0, 1, 1, 4),
(46, 37, 0, 1, 1, 4),
(46, 38, 0, 1, 1, 4),
(46, 39, 0, 1, 1, 4),
(46, 40, 0, 1, 1, 4),
(46, 41, 0, 1, 1, 4),
(46, 42, 0, 1, 1, 4),
(46, 44, 0, 1, 1, 4),
(46, 45, 0, 1, 1, 4),
(46, 46, 0, 1, 1, 4),
(46, 47, 0, 1, 1, 4),
(46, 48, 1, 1, 1, 4),
(47, 29, 0, 1, 1, 4),
(47, 30, 0, 1, 1, 4),
(47, 31, 0, 1, 1, 4),
(47, 32, 0, 1, 1, 4),
(47, 33, 0, 1, 1, 4),
(47, 34, 0, 1, 1, 4),
(47, 35, 0, 1, 1, 4),
(47, 36, 0, 1, 1, 4),
(47, 37, 0, 1, 1, 4),
(47, 38, 0, 1, 1, 4),
(47, 39, 0, 1, 1, 4),
(47, 40, 0, 1, 1, 4),
(47, 41, 0, 1, 1, 4),
(47, 42, 0, 1, 1, 4),
(47, 44, 0, 1, 1, 4),
(47, 45, 0, 1, 1, 4),
(47, 46, 0, 1, 1, 4),
(47, 47, 0, 1, 1, 4),
(47, 48, 1, 1, 1, 4),
(48, 29, 0, 1, 1, 4),
(48, 30, 0, 1, 1, 4),
(48, 31, 0, 1, 1, 4),
(48, 32, 0, 1, 1, 4),
(48, 33, 0, 1, 1, 4),
(48, 34, 0, 1, 1, 4),
(48, 35, 0, 1, 1, 4),
(48, 36, 0, 1, 1, 4),
(48, 37, 0, 1, 1, 4),
(48, 38, 0, 1, 1, 4),
(48, 39, 0, 1, 1, 4),
(48, 40, 0, 1, 1, 4),
(48, 41, 0, 1, 1, 4),
(48, 42, 0, 1, 1, 4),
(48, 44, 0, 1, 1, 4),
(48, 45, 0, 1, 1, 4),
(48, 46, 0, 1, 1, 4),
(48, 47, 0, 1, 1, 4),
(48, 48, 1, 1, 1, 4),
(49, 29, 0, 1, 1, 4),
(49, 30, 0, 1, 1, 4),
(49, 31, 0, 1, 1, 4),
(49, 32, 0, 1, 1, 4),
(49, 33, 0, 1, 1, 4),
(49, 34, 0, 1, 1, 4),
(49, 35, 0, 1, 1, 4),
(49, 36, 0, 1, 1, 4),
(49, 37, 0, 1, 1, 4),
(49, 38, 0, 1, 1, 4),
(49, 39, 0, 1, 1, 4),
(49, 40, 0, 1, 1, 4),
(49, 41, 0, 1, 1, 4),
(49, 42, 0, 1, 1, 4),
(49, 44, 0, 1, 1, 4),
(49, 45, 0, 1, 1, 4),
(49, 46, 0, 1, 1, 4),
(49, 47, 0, 1, 1, 4),
(49, 48, 1, 1, 1, 4),
(50, 29, 0, 1, 1, 4),
(50, 30, 0, 1, 1, 4),
(50, 31, 0, 1, 1, 4),
(50, 32, 0, 1, 1, 4),
(50, 33, 0, 1, 1, 4),
(50, 34, 0, 1, 1, 4),
(50, 35, 0, 1, 1, 4),
(50, 36, 0, 1, 1, 4),
(50, 37, 0, 1, 1, 4),
(50, 38, 0, 1, 1, 4),
(50, 39, 0, 1, 1, 4),
(50, 40, 0, 1, 1, 4),
(50, 41, 0, 1, 1, 4),
(50, 42, 0, 1, 1, 4),
(50, 44, 0, 1, 1, 4),
(50, 45, 0, 1, 1, 4),
(50, 46, 0, 1, 1, 4),
(50, 47, 0, 1, 1, 4),
(50, 48, 1, 1, 1, 4),
(50, 49, 1, 1, 1, 4),
(55, 29, 0, 1, 1, 4),
(55, 30, 0, 1, 1, 4),
(55, 31, 0, 1, 1, 4),
(55, 32, 0, 1, 1, 4),
(55, 33, 0, 1, 1, 4),
(55, 34, 0, 1, 1, 4),
(55, 35, 0, 1, 1, 4),
(55, 36, 0, 1, 1, 4),
(55, 37, 0, 1, 1, 4),
(55, 38, 0, 1, 1, 4),
(55, 39, 0, 1, 1, 4),
(55, 40, 0, 1, 1, 4),
(55, 41, 0, 1, 1, 4),
(55, 42, 0, 1, 1, 4),
(55, 44, 0, 1, 1, 4),
(55, 45, 0, 1, 1, 4),
(55, 46, 0, 1, 1, 4),
(55, 47, 0, 1, 1, 4),
(55, 48, 0, 1, 1, 4),
(56, 29, 0, 1, 1, 4),
(56, 30, 0, 1, 1, 4),
(56, 31, 0, 1, 1, 4),
(56, 32, 0, 1, 1, 4),
(56, 33, 0, 1, 1, 4),
(56, 34, 0, 1, 1, 4),
(56, 35, 0, 1, 1, 4),
(56, 36, 0, 1, 1, 4),
(56, 37, 0, 1, 1, 4),
(56, 38, 0, 1, 1, 4),
(56, 39, 0, 1, 1, 4),
(56, 40, 0, 1, 1, 4),
(56, 41, 0, 1, 1, 4),
(56, 42, 0, 1, 1, 4),
(56, 44, 0, 1, 1, 4),
(56, 45, 0, 1, 1, 4),
(56, 46, 0, 1, 1, 4),
(56, 47, 0, 1, 1, 4),
(56, 48, 0, 1, 1, 4),
(57, 29, 0, 1, 1, 4),
(57, 30, 0, 1, 1, 4),
(57, 31, 0, 1, 1, 4),
(57, 32, 0, 1, 1, 4),
(57, 33, 0, 1, 1, 4),
(57, 34, 0, 1, 1, 4),
(57, 35, 0, 1, 1, 4),
(57, 36, 0, 1, 1, 4),
(57, 37, 0, 1, 1, 4),
(57, 38, 0, 1, 1, 4),
(57, 39, 0, 1, 1, 4),
(57, 40, 0, 1, 1, 4),
(57, 41, 0, 1, 1, 4),
(57, 42, 0, 1, 1, 4),
(57, 44, 0, 1, 1, 4),
(57, 45, 0, 1, 1, 4),
(57, 46, 0, 1, 1, 4),
(57, 47, 0, 1, 1, 4),
(57, 48, 0, 1, 1, 4),
(58, 7, 0, 1, 1, 4),
(58, 13, 0, 1, 1, 4),
(58, 19, 0, 1, 1, 4),
(58, 20, 0, 1, 1, 4),
(58, 21, 0, 1, 1, 4),
(58, 37, 0, 1, 1, 4),
(58, 42, 0, 1, 1, 4),
(58, 44, 0, 1, 1, 4),
(58, 45, 0, 1, 1, 4),
(58, 46, 0, 1, 1, 4),
(58, 47, 0, 1, 1, 4),
(58, 48, 0, 1, 1, 4),
(58, 49, 1, 1, 1, 4),
(2, 8, 20004, 0, 2, 4),
(2, 9, 20004, 0, 2, 4),
(2, 10, 20004, 0, 2, 4),
(2, 11, 20004, 0, 2, 4),
(2, 12, 20004, 0, 2, 4),
(2, 14, 20004, 0, 2, 4),
(2, 15, 20004, 0, 2, 4),
(2, 16, 20004, 0, 2, 4),
(2, 17, 20004, 0, 2, 4),
(2, 18, 20004, 0, 2, 4),
(2, 22, 20004, 0, 2, 4),
(2, 23, 20004, 0, 2, 4),
(2, 24, 20004, 0, 2, 4),
(2, 25, 20004, 0, 2, 4),
(2, 26, 20004, 0, 2, 4),
(2, 27, 20004, 0, 2, 4),
(2, 28, 20004, 0, 2, 4),
(2, 29, 20004, 0, 2, 4),
(2, 30, 20004, 0, 2, 4),
(2, 31, 20004, 0, 2, 4),
(2, 32, 20004, 0, 2, 4),
(2, 33, 20004, 0, 2, 4),
(2, 34, 20004, 0, 2, 4),
(2, 35, 20004, 0, 2, 4),
(2, 36, 20004, 0, 2, 4),
(2, 37, 20004, 0, 2, 4),
(2, 38, 20004, 0, 2, 4),
(2, 39, 20004, 0, 2, 4),
(2, 40, 20004, 0, 2, 4),
(2, 41, 20004, 0, 2, 4),
(2, 49, 20007, 0, 2, 4),
(2, 7, 1, 1, 2, 4),
(2, 13, 1, 1, 2, 4),
(2, 19, 1, 1, 2, 4),
(2, 20, 1, 1, 2, 4),
(2, 21, 1, 1, 2, 4),
(2, 42, 1, 1, 2, 4),
(2, 44, 1, 1, 2, 4),
(2, 45, 1, 1, 2, 4),
(2, 46, 1, 1, 2, 4),
(2, 47, 1, 1, 2, 4),
(2, 48, 1, 1, 2, 4),
(3, 8, 0, 1, 2, 4),
(3, 9, 0, 1, 2, 4),
(3, 10, 0, 1, 2, 4),
(3, 11, 0, 1, 2, 4),
(3, 12, 0, 1, 2, 4),
(3, 14, 0, 1, 2, 4),
(3, 15, 0, 1, 2, 4),
(3, 16, 0, 1, 2, 4),
(3, 17, 0, 1, 2, 4),
(3, 18, 0, 1, 2, 4),
(3, 22, 0, 1, 2, 4),
(3, 23, 0, 1, 2, 4),
(3, 24, 0, 1, 2, 4),
(3, 25, 0, 1, 2, 4),
(3, 26, 0, 1, 2, 4),
(3, 27, 0, 1, 2, 4),
(3, 28, 0, 1, 2, 4),
(3, 29, 0, 1, 2, 4),
(3, 30, 0, 1, 2, 4),
(3, 31, 0, 1, 2, 4),
(3, 32, 0, 1, 2, 4),
(3, 33, 0, 1, 2, 4),
(3, 34, 0, 1, 2, 4),
(3, 35, 0, 1, 2, 4),
(3, 36, 0, 1, 2, 4),
(3, 37, 0, 1, 2, 4),
(3, 38, 0, 1, 2, 4),
(3, 39, 0, 1, 2, 4),
(3, 40, 0, 1, 2, 4),
(3, 41, 0, 1, 2, 4),
(3, 7, 1, 1, 2, 4),
(3, 13, 1, 1, 2, 4),
(3, 19, 1, 1, 2, 4),
(3, 20, 1, 1, 2, 4),
(3, 21, 1, 1, 2, 4),
(3, 42, 1, 1, 2, 4),
(3, 44, 1, 1, 2, 4),
(3, 45, 1, 1, 2, 4),
(3, 46, 1, 1, 2, 4),
(3, 47, 1, 1, 2, 4),
(3, 48, 1, 1, 2, 4),
(4, 7, 0, 1, 2, 4),
(4, 8, 0, 1, 2, 4),
(4, 9, 0, 1, 2, 4),
(4, 10, 0, 1, 2, 4),
(4, 11, 0, 1, 2, 4),
(4, 12, 0, 1, 2, 4),
(4, 13, 0, 1, 2, 4),
(4, 14, 0, 1, 2, 4),
(4, 15, 0, 1, 2, 4),
(4, 16, 0, 1, 2, 4),
(4, 17, 0, 1, 2, 4),
(4, 18, 0, 1, 2, 4),
(4, 19, 0, 1, 2, 4),
(4, 20, 0, 1, 2, 4),
(4, 21, 0, 1, 2, 4),
(4, 22, 0, 1, 2, 4),
(4, 23, 0, 1, 2, 4),
(4, 24, 0, 1, 2, 4),
(4, 25, 0, 1, 2, 4),
(4, 26, 0, 1, 2, 4),
(4, 27, 0, 1, 2, 4),
(4, 28, 0, 1, 2, 4),
(4, 29, 0, 1, 2, 4),
(4, 30, 0, 1, 2, 4),
(4, 31, 0, 1, 2, 4),
(4, 32, 0, 1, 2, 4),
(4, 33, 0, 1, 2, 4),
(4, 34, 0, 1, 2, 4),
(4, 35, 0, 1, 2, 4),
(4, 36, 0, 1, 2, 4),
(4, 37, 0, 1, 2, 4),
(4, 38, 0, 1, 2, 4),
(4, 39, 0, 1, 2, 4),
(4, 40, 0, 1, 2, 4),
(4, 41, 0, 1, 2, 4),
(4, 42, 0, 1, 2, 4),
(4, 44, 0, 1, 2, 4),
(4, 45, 0, 1, 2, 4),
(4, 46, 0, 1, 2, 4),
(4, 47, 0, 1, 2, 4),
(4, 48, 0, 1, 2, 4),
(5, 29, 0, 1, 2, 4),
(5, 30, 0, 1, 2, 4),
(5, 31, 0, 1, 2, 4),
(5, 32, 0, 1, 2, 4),
(5, 33, 0, 1, 2, 4),
(5, 34, 0, 1, 2, 4),
(5, 35, 0, 1, 2, 4),
(5, 36, 0, 1, 2, 4),
(5, 37, 0, 1, 2, 4),
(5, 38, 0, 1, 2, 4),
(5, 39, 0, 1, 2, 4),
(5, 40, 0, 1, 2, 4),
(5, 41, 0, 1, 2, 4),
(5, 42, 0, 1, 2, 4),
(5, 44, 0, 1, 2, 4),
(5, 45, 0, 1, 2, 4),
(5, 46, 0, 1, 2, 4),
(6, 29, 0, 1, 2, 4),
(6, 30, 0, 1, 2, 4),
(6, 31, 0, 1, 2, 4),
(6, 32, 0, 1, 2, 4),
(6, 33, 0, 1, 2, 4),
(6, 34, 0, 1, 2, 4),
(6, 35, 0, 1, 2, 4),
(6, 36, 0, 1, 2, 4),
(6, 37, 0, 1, 2, 4),
(6, 38, 0, 1, 2, 4),
(6, 39, 0, 1, 2, 4),
(6, 40, 0, 1, 2, 4),
(6, 41, 0, 1, 2, 4),
(6, 42, 0, 1, 2, 4),
(6, 44, 0, 1, 2, 4),
(6, 45, 0, 1, 2, 4),
(6, 46, 0, 1, 2, 4),
(6, 47, 0, 1, 2, 4),
(6, 48, 1, 1, 2, 4),
(9, 33, 0, 1, 2, 4),
(9, 34, 0, 1, 2, 4),
(9, 35, 0, 1, 2, 4),
(9, 36, 0, 1, 2, 4),
(9, 37, 0, 1, 2, 4),
(9, 38, 0, 1, 2, 4),
(9, 39, 0, 1, 2, 4),
(9, 40, 0, 1, 2, 4),
(9, 41, 0, 1, 2, 4),
(9, 42, 0, 1, 2, 4),
(9, 44, 0, 1, 2, 4),
(9, 45, 0, 1, 2, 4),
(9, 46, 0, 1, 2, 4),
(9, 47, 0, 1, 2, 4),
(9, 48, 0, 1, 2, 4),
(19, 29, 0, 1, 2, 4),
(19, 30, 0, 1, 2, 4),
(19, 31, 0, 1, 2, 4),
(19, 32, 0, 1, 2, 4),
(19, 33, 0, 1, 2, 4),
(19, 34, 0, 1, 2, 4),
(19, 35, 0, 1, 2, 4),
(19, 36, 0, 1, 2, 4),
(19, 37, 0, 1, 2, 4),
(19, 38, 0, 1, 2, 4),
(19, 39, 0, 1, 2, 4),
(19, 40, 0, 1, 2, 4),
(19, 41, 0, 1, 2, 4),
(19, 42, 0, 1, 2, 4),
(19, 44, 0, 1, 2, 4),
(19, 45, 0, 1, 2, 4),
(19, 46, 0, 1, 2, 4),
(19, 47, 0, 1, 2, 4),
(19, 48, 1, 1, 2, 4),
(20, 48, 1, 1, 2, 4),
(24, 48, 1, 1, 2, 4),
(25, 48, 1, 1, 2, 4),
(26, 48, 1, 1, 2, 4),
(28, 48, 1, 1, 2, 4),
(33, 29, 0, 1, 2, 4),
(33, 30, 0, 1, 2, 4),
(33, 31, 0, 1, 2, 4),
(33, 32, 0, 1, 2, 4),
(33, 33, 0, 1, 2, 4),
(33, 34, 0, 1, 2, 4),
(33, 35, 0, 1, 2, 4),
(33, 36, 0, 1, 2, 4),
(33, 37, 0, 1, 2, 4),
(33, 38, 0, 1, 2, 4),
(33, 39, 0, 1, 2, 4),
(33, 40, 0, 1, 2, 4),
(33, 41, 0, 1, 2, 4),
(33, 42, 0, 1, 2, 4),
(33, 44, 0, 1, 2, 4),
(33, 45, 0, 1, 2, 4),
(33, 46, 0, 1, 2, 4),
(33, 47, 0, 1, 2, 4),
(33, 48, 0, 1, 2, 4),
(40, 7, 0, 1, 2, 4),
(40, 13, 0, 1, 2, 4),
(40, 19, 0, 1, 2, 4),
(40, 20, 0, 1, 2, 4),
(40, 21, 0, 1, 2, 4),
(40, 48, 1, 1, 2, 4),
(41, 7, 0, 1, 2, 4),
(41, 13, 0, 1, 2, 4),
(41, 19, 0, 1, 2, 4),
(41, 20, 0, 1, 2, 4),
(41, 21, 0, 1, 2, 4),
(41, 37, 0, 1, 2, 4),
(41, 42, 0, 1, 2, 4),
(41, 44, 0, 1, 2, 4),
(41, 45, 0, 1, 2, 4),
(41, 46, 0, 1, 2, 4),
(41, 47, 0, 1, 2, 4),
(41, 48, 0, 1, 2, 4),
(42, 29, 0, 1, 2, 4),
(42, 30, 0, 1, 2, 4),
(42, 31, 0, 1, 2, 4),
(42, 32, 0, 1, 2, 4),
(42, 33, 0, 1, 2, 4),
(42, 34, 0, 1, 2, 4),
(42, 35, 0, 1, 2, 4),
(42, 36, 0, 1, 2, 4),
(42, 37, 0, 1, 2, 4),
(42, 38, 0, 1, 2, 4),
(42, 39, 0, 1, 2, 4),
(42, 40, 0, 1, 2, 4),
(42, 41, 0, 1, 2, 4),
(42, 42, 0, 1, 2, 4),
(42, 44, 0, 1, 2, 4),
(42, 45, 0, 1, 2, 4),
(42, 46, 0, 1, 2, 4),
(42, 47, 0, 1, 2, 4),
(42, 48, 1, 1, 2, 4),
(43, 29, 0, 1, 2, 4),
(43, 30, 0, 1, 2, 4),
(43, 31, 0, 1, 2, 4),
(43, 32, 0, 1, 2, 4),
(43, 33, 0, 1, 2, 4),
(43, 34, 0, 1, 2, 4),
(43, 35, 0, 1, 2, 4),
(43, 36, 0, 1, 2, 4),
(43, 37, 0, 1, 2, 4),
(43, 38, 0, 1, 2, 4),
(43, 39, 0, 1, 2, 4),
(43, 40, 0, 1, 2, 4),
(43, 41, 0, 1, 2, 4),
(43, 42, 0, 1, 2, 4),
(43, 44, 0, 1, 2, 4),
(43, 45, 0, 1, 2, 4),
(43, 46, 0, 1, 2, 4),
(43, 47, 0, 1, 2, 4),
(43, 48, 1, 1, 2, 4),
(44, 29, 0, 1, 2, 4),
(44, 30, 0, 1, 2, 4),
(44, 31, 0, 1, 2, 4),
(44, 32, 0, 1, 2, 4),
(44, 33, 0, 1, 2, 4),
(44, 34, 0, 1, 2, 4),
(44, 35, 0, 1, 2, 4),
(44, 36, 0, 1, 2, 4),
(44, 37, 0, 1, 2, 4),
(44, 38, 0, 1, 2, 4),
(44, 39, 0, 1, 2, 4),
(44, 40, 0, 1, 2, 4),
(44, 41, 0, 1, 2, 4),
(44, 42, 0, 1, 2, 4),
(44, 44, 0, 1, 2, 4),
(44, 45, 0, 1, 2, 4),
(44, 46, 0, 1, 2, 4),
(44, 47, 0, 1, 2, 4),
(44, 48, 1, 1, 2, 4),
(45, 29, 0, 1, 2, 4),
(45, 30, 0, 1, 2, 4),
(45, 31, 0, 1, 2, 4),
(45, 32, 0, 1, 2, 4),
(45, 33, 0, 1, 2, 4),
(45, 34, 0, 1, 2, 4),
(45, 35, 0, 1, 2, 4),
(45, 36, 0, 1, 2, 4),
(45, 37, 0, 1, 2, 4),
(45, 38, 0, 1, 2, 4),
(45, 39, 0, 1, 2, 4),
(45, 40, 0, 1, 2, 4),
(45, 41, 0, 1, 2, 4),
(45, 42, 0, 1, 2, 4),
(45, 44, 0, 1, 2, 4),
(45, 45, 0, 1, 2, 4),
(45, 46, 0, 1, 2, 4),
(45, 47, 0, 1, 2, 4),
(45, 48, 1, 1, 2, 4),
(46, 29, 0, 1, 2, 4),
(46, 30, 0, 1, 2, 4),
(46, 31, 0, 1, 2, 4),
(46, 32, 0, 1, 2, 4),
(46, 33, 0, 1, 2, 4),
(46, 34, 0, 1, 2, 4),
(46, 35, 0, 1, 2, 4),
(46, 36, 0, 1, 2, 4),
(46, 37, 0, 1, 2, 4),
(46, 38, 0, 1, 2, 4),
(46, 39, 0, 1, 2, 4),
(46, 40, 0, 1, 2, 4),
(46, 41, 0, 1, 2, 4),
(46, 42, 0, 1, 2, 4),
(46, 44, 0, 1, 2, 4),
(46, 45, 0, 1, 2, 4),
(46, 46, 0, 1, 2, 4),
(46, 47, 0, 1, 2, 4),
(46, 48, 1, 1, 2, 4),
(47, 29, 0, 1, 2, 4),
(47, 30, 0, 1, 2, 4),
(47, 31, 0, 1, 2, 4),
(47, 32, 0, 1, 2, 4),
(47, 33, 0, 1, 2, 4),
(47, 34, 0, 1, 2, 4),
(47, 35, 0, 1, 2, 4),
(47, 36, 0, 1, 2, 4),
(47, 37, 0, 1, 2, 4),
(47, 38, 0, 1, 2, 4),
(47, 39, 0, 1, 2, 4),
(47, 40, 0, 1, 2, 4),
(47, 41, 0, 1, 2, 4),
(47, 42, 0, 1, 2, 4),
(47, 44, 0, 1, 2, 4),
(47, 45, 0, 1, 2, 4),
(47, 46, 0, 1, 2, 4),
(47, 47, 0, 1, 2, 4),
(47, 48, 1, 1, 2, 4),
(48, 29, 0, 1, 2, 4),
(48, 30, 0, 1, 2, 4),
(48, 31, 0, 1, 2, 4),
(48, 32, 0, 1, 2, 4),
(48, 33, 0, 1, 2, 4),
(48, 34, 0, 1, 2, 4),
(48, 35, 0, 1, 2, 4),
(48, 36, 0, 1, 2, 4),
(48, 37, 0, 1, 2, 4),
(48, 38, 0, 1, 2, 4),
(48, 39, 0, 1, 2, 4),
(48, 40, 0, 1, 2, 4),
(48, 41, 0, 1, 2, 4),
(48, 42, 0, 1, 2, 4),
(48, 44, 0, 1, 2, 4),
(48, 45, 0, 1, 2, 4),
(48, 46, 0, 1, 2, 4),
(48, 47, 0, 1, 2, 4),
(48, 48, 1, 1, 2, 4),
(49, 29, 0, 1, 2, 4),
(49, 30, 0, 1, 2, 4),
(49, 31, 0, 1, 2, 4),
(49, 32, 0, 1, 2, 4),
(49, 33, 0, 1, 2, 4),
(49, 34, 0, 1, 2, 4),
(49, 35, 0, 1, 2, 4),
(49, 36, 0, 1, 2, 4),
(49, 37, 0, 1, 2, 4),
(49, 38, 0, 1, 2, 4),
(49, 39, 0, 1, 2, 4),
(49, 40, 0, 1, 2, 4),
(49, 41, 0, 1, 2, 4),
(49, 42, 0, 1, 2, 4),
(49, 44, 0, 1, 2, 4),
(49, 45, 0, 1, 2, 4),
(49, 46, 0, 1, 2, 4),
(49, 47, 0, 1, 2, 4),
(49, 48, 1, 1, 2, 4),
(50, 29, 0, 1, 2, 4),
(50, 30, 0, 1, 2, 4),
(50, 31, 0, 1, 2, 4),
(50, 32, 0, 1, 2, 4),
(50, 33, 0, 1, 2, 4),
(50, 34, 0, 1, 2, 4),
(50, 35, 0, 1, 2, 4),
(50, 36, 0, 1, 2, 4),
(50, 37, 0, 1, 2, 4),
(50, 38, 0, 1, 2, 4),
(50, 39, 0, 1, 2, 4),
(50, 40, 0, 1, 2, 4),
(50, 41, 0, 1, 2, 4),
(50, 42, 0, 1, 2, 4),
(50, 44, 0, 1, 2, 4),
(50, 45, 0, 1, 2, 4),
(50, 46, 0, 1, 2, 4),
(50, 47, 0, 1, 2, 4),
(50, 48, 1, 1, 2, 4),
(50, 49, 1, 1, 2, 4),
(55, 29, 0, 1, 2, 4),
(55, 30, 0, 1, 2, 4),
(55, 31, 0, 1, 2, 4),
(55, 32, 0, 1, 2, 4),
(55, 33, 0, 1, 2, 4),
(55, 34, 0, 1, 2, 4),
(55, 35, 0, 1, 2, 4),
(55, 36, 0, 1, 2, 4),
(55, 37, 0, 1, 2, 4),
(55, 38, 0, 1, 2, 4),
(55, 39, 0, 1, 2, 4),
(55, 40, 0, 1, 2, 4),
(55, 41, 0, 1, 2, 4),
(55, 42, 0, 1, 2, 4),
(55, 44, 0, 1, 2, 4),
(55, 45, 0, 1, 2, 4),
(55, 46, 0, 1, 2, 4),
(55, 47, 0, 1, 2, 4),
(55, 48, 0, 1, 2, 4),
(56, 29, 0, 1, 2, 4),
(56, 30, 0, 1, 2, 4),
(56, 31, 0, 1, 2, 4),
(56, 32, 0, 1, 2, 4),
(56, 33, 0, 1, 2, 4),
(56, 34, 0, 1, 2, 4),
(56, 35, 0, 1, 2, 4),
(56, 36, 0, 1, 2, 4),
(56, 37, 0, 1, 2, 4),
(56, 38, 0, 1, 2, 4),
(56, 39, 0, 1, 2, 4),
(56, 40, 0, 1, 2, 4),
(56, 41, 0, 1, 2, 4),
(56, 42, 0, 1, 2, 4),
(56, 44, 0, 1, 2, 4),
(56, 45, 0, 1, 2, 4),
(56, 46, 0, 1, 2, 4),
(56, 47, 0, 1, 2, 4),
(56, 48, 0, 1, 2, 4),
(57, 29, 0, 1, 2, 4),
(57, 30, 0, 1, 2, 4),
(57, 31, 0, 1, 2, 4),
(57, 32, 0, 1, 2, 4),
(57, 33, 0, 1, 2, 4),
(57, 34, 0, 1, 2, 4),
(57, 35, 0, 1, 2, 4),
(57, 36, 0, 1, 2, 4),
(57, 37, 0, 1, 2, 4),
(57, 38, 0, 1, 2, 4),
(57, 39, 0, 1, 2, 4),
(57, 40, 0, 1, 2, 4),
(57, 41, 0, 1, 2, 4),
(57, 42, 0, 1, 2, 4),
(57, 44, 0, 1, 2, 4),
(57, 45, 0, 1, 2, 4),
(57, 46, 0, 1, 2, 4),
(57, 47, 0, 1, 2, 4),
(57, 48, 0, 1, 2, 4),
(58, 7, 0, 1, 2, 4),
(58, 13, 0, 1, 2, 4),
(58, 19, 0, 1, 2, 4),
(58, 20, 0, 1, 2, 4),
(58, 21, 0, 1, 2, 4),
(58, 37, 0, 1, 2, 4),
(58, 42, 0, 1, 2, 4),
(58, 44, 0, 1, 2, 4),
(58, 45, 0, 1, 2, 4),
(58, 46, 0, 1, 2, 4),
(58, 47, 0, 1, 2, 4),
(58, 48, 0, 1, 2, 4),
(58, 49, 1, 1, 2, 4),
(2, 8, 20004, 0, 3, 4),
(2, 9, 20004, 0, 3, 4),
(2, 10, 20004, 0, 3, 4),
(2, 11, 20004, 0, 3, 4),
(2, 12, 20004, 0, 3, 4),
(2, 14, 20004, 0, 3, 4),
(2, 15, 20004, 0, 3, 4),
(2, 16, 20004, 0, 3, 4),
(2, 17, 20004, 0, 3, 4),
(2, 18, 20004, 0, 3, 4),
(2, 22, 20004, 0, 3, 4),
(2, 23, 20004, 0, 3, 4),
(2, 24, 20004, 0, 3, 4),
(2, 25, 20004, 0, 3, 4),
(2, 26, 20004, 0, 3, 4),
(2, 27, 20004, 0, 3, 4),
(2, 28, 20004, 0, 3, 4),
(2, 29, 20004, 0, 3, 4),
(2, 30, 20004, 0, 3, 4),
(2, 31, 20004, 0, 3, 4),
(2, 32, 20004, 0, 3, 4),
(2, 33, 20004, 0, 3, 4),
(2, 34, 20004, 0, 3, 4),
(2, 35, 20004, 0, 3, 4),
(2, 36, 20004, 0, 3, 4),
(2, 37, 20004, 0, 3, 4),
(2, 38, 20004, 0, 3, 4),
(2, 39, 20004, 0, 3, 4),
(2, 40, 20004, 0, 3, 4),
(2, 41, 20004, 0, 3, 4),
(2, 49, 20007, 0, 3, 4),
(2, 7, 1, 1, 3, 4),
(2, 13, 1, 1, 3, 4),
(2, 19, 1, 1, 3, 4),
(2, 20, 1, 1, 3, 4),
(2, 21, 1, 1, 3, 4),
(2, 42, 1, 1, 3, 4),
(2, 44, 1, 1, 3, 4),
(2, 45, 1, 1, 3, 4),
(2, 46, 1, 1, 3, 4),
(2, 47, 1, 1, 3, 4),
(2, 48, 1, 1, 3, 4),
(3, 8, 0, 1, 3, 4),
(3, 9, 0, 1, 3, 4),
(3, 10, 0, 1, 3, 4),
(3, 11, 0, 1, 3, 4),
(3, 12, 0, 1, 3, 4),
(3, 14, 0, 1, 3, 4),
(3, 15, 0, 1, 3, 4),
(3, 16, 0, 1, 3, 4),
(3, 17, 0, 1, 3, 4),
(3, 18, 0, 1, 3, 4),
(3, 22, 0, 1, 3, 4),
(3, 23, 0, 1, 3, 4),
(3, 24, 0, 1, 3, 4),
(3, 25, 0, 1, 3, 4),
(3, 26, 0, 1, 3, 4),
(3, 27, 0, 1, 3, 4),
(3, 28, 0, 1, 3, 4),
(3, 29, 0, 1, 3, 4),
(3, 30, 0, 1, 3, 4),
(3, 31, 0, 1, 3, 4),
(3, 32, 0, 1, 3, 4),
(3, 33, 0, 1, 3, 4),
(3, 34, 0, 1, 3, 4),
(3, 35, 0, 1, 3, 4),
(3, 36, 0, 1, 3, 4),
(3, 37, 0, 1, 3, 4),
(3, 38, 0, 1, 3, 4),
(3, 39, 0, 1, 3, 4),
(3, 40, 0, 1, 3, 4),
(3, 41, 0, 1, 3, 4),
(3, 7, 1, 1, 3, 4),
(3, 13, 1, 1, 3, 4),
(3, 19, 1, 1, 3, 4),
(3, 20, 1, 1, 3, 4),
(3, 21, 1, 1, 3, 4),
(3, 42, 1, 1, 3, 4),
(3, 44, 1, 1, 3, 4),
(3, 45, 1, 1, 3, 4),
(3, 46, 1, 1, 3, 4),
(3, 47, 1, 1, 3, 4),
(3, 48, 1, 1, 3, 4),
(4, 7, 0, 1, 3, 4),
(4, 8, 0, 1, 3, 4),
(4, 9, 0, 1, 3, 4),
(4, 10, 0, 1, 3, 4),
(4, 11, 0, 1, 3, 4),
(4, 12, 0, 1, 3, 4),
(4, 13, 0, 1, 3, 4),
(4, 14, 0, 1, 3, 4),
(4, 15, 0, 1, 3, 4),
(4, 16, 0, 1, 3, 4),
(4, 17, 0, 1, 3, 4),
(4, 18, 0, 1, 3, 4),
(4, 19, 0, 1, 3, 4),
(4, 20, 0, 1, 3, 4),
(4, 21, 0, 1, 3, 4),
(4, 22, 0, 1, 3, 4),
(4, 23, 0, 1, 3, 4),
(4, 24, 0, 1, 3, 4),
(4, 25, 0, 1, 3, 4),
(4, 26, 0, 1, 3, 4),
(4, 27, 0, 1, 3, 4),
(4, 28, 0, 1, 3, 4),
(4, 29, 0, 1, 3, 4),
(4, 30, 0, 1, 3, 4),
(4, 31, 0, 1, 3, 4),
(4, 32, 0, 1, 3, 4),
(4, 33, 0, 1, 3, 4),
(4, 34, 0, 1, 3, 4),
(4, 35, 0, 1, 3, 4),
(4, 36, 0, 1, 3, 4),
(4, 37, 0, 1, 3, 4),
(4, 38, 0, 1, 3, 4),
(4, 39, 0, 1, 3, 4),
(4, 40, 0, 1, 3, 4),
(4, 41, 0, 1, 3, 4),
(4, 42, 0, 1, 3, 4),
(4, 44, 0, 1, 3, 4),
(4, 45, 0, 1, 3, 4),
(4, 46, 0, 1, 3, 4),
(4, 47, 0, 1, 3, 4),
(4, 48, 0, 1, 3, 4),
(5, 29, 0, 1, 3, 4),
(5, 30, 0, 1, 3, 4),
(5, 31, 0, 1, 3, 4),
(5, 32, 0, 1, 3, 4),
(5, 33, 0, 1, 3, 4),
(5, 34, 0, 1, 3, 4),
(5, 35, 0, 1, 3, 4),
(5, 36, 0, 1, 3, 4),
(5, 37, 0, 1, 3, 4),
(5, 38, 0, 1, 3, 4),
(5, 39, 0, 1, 3, 4),
(5, 40, 0, 1, 3, 4),
(5, 41, 0, 1, 3, 4),
(5, 42, 0, 1, 3, 4),
(5, 44, 0, 1, 3, 4),
(5, 45, 0, 1, 3, 4),
(5, 46, 0, 1, 3, 4),
(6, 29, 0, 1, 3, 4),
(6, 30, 0, 1, 3, 4),
(6, 31, 0, 1, 3, 4),
(6, 32, 0, 1, 3, 4),
(6, 33, 0, 1, 3, 4),
(6, 34, 0, 1, 3, 4),
(6, 35, 0, 1, 3, 4),
(6, 36, 0, 1, 3, 4),
(6, 37, 0, 1, 3, 4),
(6, 38, 0, 1, 3, 4),
(6, 39, 0, 1, 3, 4),
(6, 40, 0, 1, 3, 4),
(6, 41, 0, 1, 3, 4),
(6, 42, 0, 1, 3, 4),
(6, 44, 0, 1, 3, 4),
(6, 45, 0, 1, 3, 4),
(6, 46, 0, 1, 3, 4),
(6, 47, 0, 1, 3, 4),
(6, 48, 1, 1, 3, 4),
(9, 33, 0, 1, 3, 4),
(9, 34, 0, 1, 3, 4),
(9, 35, 0, 1, 3, 4),
(9, 36, 0, 1, 3, 4),
(9, 37, 0, 1, 3, 4),
(9, 38, 0, 1, 3, 4),
(9, 39, 0, 1, 3, 4),
(9, 40, 0, 1, 3, 4),
(9, 41, 0, 1, 3, 4),
(9, 42, 0, 1, 3, 4),
(9, 44, 0, 1, 3, 4),
(9, 45, 0, 1, 3, 4),
(9, 46, 0, 1, 3, 4),
(9, 47, 0, 1, 3, 4),
(9, 48, 0, 1, 3, 4),
(19, 29, 0, 1, 3, 4),
(19, 30, 0, 1, 3, 4),
(19, 31, 0, 1, 3, 4),
(19, 32, 0, 1, 3, 4),
(19, 33, 0, 1, 3, 4),
(19, 34, 0, 1, 3, 4),
(19, 35, 0, 1, 3, 4),
(19, 36, 0, 1, 3, 4),
(19, 37, 0, 1, 3, 4),
(19, 38, 0, 1, 3, 4),
(19, 39, 0, 1, 3, 4),
(19, 40, 0, 1, 3, 4),
(19, 41, 0, 1, 3, 4),
(19, 42, 0, 1, 3, 4),
(19, 44, 0, 1, 3, 4),
(19, 45, 0, 1, 3, 4),
(19, 46, 0, 1, 3, 4),
(19, 47, 0, 1, 3, 4),
(19, 48, 1, 1, 3, 4),
(20, 48, 1, 1, 3, 4),
(24, 48, 1, 1, 3, 4),
(25, 48, 1, 1, 3, 4),
(26, 48, 1, 1, 3, 4),
(28, 48, 1, 1, 3, 4),
(33, 29, 0, 1, 3, 4),
(33, 30, 0, 1, 3, 4),
(33, 31, 0, 1, 3, 4),
(33, 32, 0, 1, 3, 4),
(33, 33, 0, 1, 3, 4),
(33, 34, 0, 1, 3, 4),
(33, 35, 0, 1, 3, 4),
(33, 36, 0, 1, 3, 4),
(33, 37, 0, 1, 3, 4),
(33, 38, 0, 1, 3, 4),
(33, 39, 0, 1, 3, 4),
(33, 40, 0, 1, 3, 4),
(33, 41, 0, 1, 3, 4),
(33, 42, 0, 1, 3, 4),
(33, 44, 0, 1, 3, 4),
(33, 45, 0, 1, 3, 4),
(33, 46, 0, 1, 3, 4),
(33, 47, 0, 1, 3, 4),
(33, 48, 0, 1, 3, 4),
(40, 7, 0, 1, 3, 4),
(40, 13, 0, 1, 3, 4),
(40, 19, 0, 1, 3, 4),
(40, 20, 0, 1, 3, 4),
(40, 21, 0, 1, 3, 4),
(40, 48, 1, 1, 3, 4),
(41, 7, 0, 1, 3, 4),
(41, 13, 0, 1, 3, 4),
(41, 19, 0, 1, 3, 4),
(41, 20, 0, 1, 3, 4),
(41, 21, 0, 1, 3, 4),
(41, 37, 0, 1, 3, 4),
(41, 42, 0, 1, 3, 4),
(41, 44, 0, 1, 3, 4),
(41, 45, 0, 1, 3, 4),
(41, 46, 0, 1, 3, 4),
(41, 47, 0, 1, 3, 4),
(41, 48, 0, 1, 3, 4),
(42, 29, 0, 1, 3, 4),
(42, 30, 0, 1, 3, 4),
(42, 31, 0, 1, 3, 4),
(42, 32, 0, 1, 3, 4),
(42, 33, 0, 1, 3, 4),
(42, 34, 0, 1, 3, 4),
(42, 35, 0, 1, 3, 4),
(42, 36, 0, 1, 3, 4),
(42, 37, 0, 1, 3, 4),
(42, 38, 0, 1, 3, 4),
(42, 39, 0, 1, 3, 4),
(42, 40, 0, 1, 3, 4),
(42, 41, 0, 1, 3, 4),
(42, 42, 0, 1, 3, 4),
(42, 44, 0, 1, 3, 4),
(42, 45, 0, 1, 3, 4),
(42, 46, 0, 1, 3, 4),
(42, 47, 0, 1, 3, 4),
(42, 48, 1, 1, 3, 4),
(43, 29, 0, 1, 3, 4),
(43, 30, 0, 1, 3, 4),
(43, 31, 0, 1, 3, 4),
(43, 32, 0, 1, 3, 4),
(43, 33, 0, 1, 3, 4),
(43, 34, 0, 1, 3, 4),
(43, 35, 0, 1, 3, 4),
(43, 36, 0, 1, 3, 4),
(43, 37, 0, 1, 3, 4),
(43, 38, 0, 1, 3, 4),
(43, 39, 0, 1, 3, 4),
(43, 40, 0, 1, 3, 4),
(43, 41, 0, 1, 3, 4),
(43, 42, 0, 1, 3, 4),
(43, 44, 0, 1, 3, 4),
(43, 45, 0, 1, 3, 4),
(43, 46, 0, 1, 3, 4),
(43, 47, 0, 1, 3, 4),
(43, 48, 1, 1, 3, 4),
(44, 29, 0, 1, 3, 4),
(44, 30, 0, 1, 3, 4),
(44, 31, 0, 1, 3, 4),
(44, 32, 0, 1, 3, 4),
(44, 33, 0, 1, 3, 4),
(44, 34, 0, 1, 3, 4),
(44, 35, 0, 1, 3, 4),
(44, 36, 0, 1, 3, 4),
(44, 37, 0, 1, 3, 4),
(44, 38, 0, 1, 3, 4),
(44, 39, 0, 1, 3, 4),
(44, 40, 0, 1, 3, 4),
(44, 41, 0, 1, 3, 4),
(44, 42, 0, 1, 3, 4),
(44, 44, 0, 1, 3, 4),
(44, 45, 0, 1, 3, 4),
(44, 46, 0, 1, 3, 4),
(44, 47, 0, 1, 3, 4),
(44, 48, 1, 1, 3, 4),
(45, 29, 0, 1, 3, 4),
(45, 30, 0, 1, 3, 4),
(45, 31, 0, 1, 3, 4),
(45, 32, 0, 1, 3, 4),
(45, 33, 0, 1, 3, 4),
(45, 34, 0, 1, 3, 4),
(45, 35, 0, 1, 3, 4),
(45, 36, 0, 1, 3, 4),
(45, 37, 0, 1, 3, 4),
(45, 38, 0, 1, 3, 4),
(45, 39, 0, 1, 3, 4),
(45, 40, 0, 1, 3, 4),
(45, 41, 0, 1, 3, 4),
(45, 42, 0, 1, 3, 4),
(45, 44, 0, 1, 3, 4),
(45, 45, 0, 1, 3, 4),
(45, 46, 0, 1, 3, 4),
(45, 47, 0, 1, 3, 4),
(45, 48, 1, 1, 3, 4),
(46, 29, 0, 1, 3, 4),
(46, 30, 0, 1, 3, 4),
(46, 31, 0, 1, 3, 4),
(46, 32, 0, 1, 3, 4),
(46, 33, 0, 1, 3, 4),
(46, 34, 0, 1, 3, 4),
(46, 35, 0, 1, 3, 4),
(46, 36, 0, 1, 3, 4),
(46, 37, 0, 1, 3, 4),
(46, 38, 0, 1, 3, 4),
(46, 39, 0, 1, 3, 4),
(46, 40, 0, 1, 3, 4),
(46, 41, 0, 1, 3, 4),
(46, 42, 0, 1, 3, 4),
(46, 44, 0, 1, 3, 4),
(46, 45, 0, 1, 3, 4),
(46, 46, 0, 1, 3, 4),
(46, 47, 0, 1, 3, 4),
(46, 48, 1, 1, 3, 4),
(47, 29, 0, 1, 3, 4),
(47, 30, 0, 1, 3, 4),
(47, 31, 0, 1, 3, 4),
(47, 32, 0, 1, 3, 4),
(47, 33, 0, 1, 3, 4),
(47, 34, 0, 1, 3, 4),
(47, 35, 0, 1, 3, 4),
(47, 36, 0, 1, 3, 4),
(47, 37, 0, 1, 3, 4),
(47, 38, 0, 1, 3, 4),
(47, 39, 0, 1, 3, 4),
(47, 40, 0, 1, 3, 4),
(47, 41, 0, 1, 3, 4),
(47, 42, 0, 1, 3, 4),
(47, 44, 0, 1, 3, 4),
(47, 45, 0, 1, 3, 4),
(47, 46, 0, 1, 3, 4),
(47, 47, 0, 1, 3, 4),
(47, 48, 1, 1, 3, 4),
(48, 29, 0, 1, 3, 4),
(48, 30, 0, 1, 3, 4),
(48, 31, 0, 1, 3, 4),
(48, 32, 0, 1, 3, 4),
(48, 33, 0, 1, 3, 4),
(48, 34, 0, 1, 3, 4),
(48, 35, 0, 1, 3, 4),
(48, 36, 0, 1, 3, 4),
(48, 37, 0, 1, 3, 4),
(48, 38, 0, 1, 3, 4),
(48, 39, 0, 1, 3, 4),
(48, 40, 0, 1, 3, 4),
(48, 41, 0, 1, 3, 4),
(48, 42, 0, 1, 3, 4),
(48, 44, 0, 1, 3, 4),
(48, 45, 0, 1, 3, 4),
(48, 46, 0, 1, 3, 4),
(48, 47, 0, 1, 3, 4),
(48, 48, 1, 1, 3, 4),
(49, 29, 0, 1, 3, 4),
(49, 30, 0, 1, 3, 4),
(49, 31, 0, 1, 3, 4),
(49, 32, 0, 1, 3, 4),
(49, 33, 0, 1, 3, 4),
(49, 34, 0, 1, 3, 4),
(49, 35, 0, 1, 3, 4),
(49, 36, 0, 1, 3, 4),
(49, 37, 0, 1, 3, 4),
(49, 38, 0, 1, 3, 4),
(49, 39, 0, 1, 3, 4),
(49, 40, 0, 1, 3, 4),
(49, 41, 0, 1, 3, 4),
(49, 42, 0, 1, 3, 4),
(49, 44, 0, 1, 3, 4),
(49, 45, 0, 1, 3, 4),
(49, 46, 0, 1, 3, 4),
(49, 47, 0, 1, 3, 4),
(49, 48, 1, 1, 3, 4),
(50, 29, 0, 1, 3, 4),
(50, 30, 0, 1, 3, 4),
(50, 31, 0, 1, 3, 4),
(50, 32, 0, 1, 3, 4),
(50, 33, 0, 1, 3, 4),
(50, 34, 0, 1, 3, 4),
(50, 35, 0, 1, 3, 4),
(50, 36, 0, 1, 3, 4),
(50, 37, 0, 1, 3, 4),
(50, 38, 0, 1, 3, 4),
(50, 39, 0, 1, 3, 4),
(50, 40, 0, 1, 3, 4),
(50, 41, 0, 1, 3, 4),
(50, 42, 0, 1, 3, 4),
(50, 44, 0, 1, 3, 4),
(50, 45, 0, 1, 3, 4),
(50, 46, 0, 1, 3, 4),
(50, 47, 0, 1, 3, 4),
(50, 48, 1, 1, 3, 4),
(50, 49, 1, 1, 3, 4),
(55, 29, 0, 1, 3, 4),
(55, 30, 0, 1, 3, 4),
(55, 31, 0, 1, 3, 4),
(55, 32, 0, 1, 3, 4),
(55, 33, 0, 1, 3, 4),
(55, 34, 0, 1, 3, 4),
(55, 35, 0, 1, 3, 4),
(55, 36, 0, 1, 3, 4),
(55, 37, 0, 1, 3, 4),
(55, 38, 0, 1, 3, 4),
(55, 39, 0, 1, 3, 4),
(55, 40, 0, 1, 3, 4),
(55, 41, 0, 1, 3, 4),
(55, 42, 0, 1, 3, 4),
(55, 44, 0, 1, 3, 4),
(55, 45, 0, 1, 3, 4),
(55, 46, 0, 1, 3, 4),
(55, 47, 0, 1, 3, 4),
(55, 48, 0, 1, 3, 4),
(56, 29, 0, 1, 3, 4),
(56, 30, 0, 1, 3, 4),
(56, 31, 0, 1, 3, 4),
(56, 32, 0, 1, 3, 4),
(56, 33, 0, 1, 3, 4),
(56, 34, 0, 1, 3, 4),
(56, 35, 0, 1, 3, 4),
(56, 36, 0, 1, 3, 4),
(56, 37, 0, 1, 3, 4),
(56, 38, 0, 1, 3, 4),
(56, 39, 0, 1, 3, 4),
(56, 40, 0, 1, 3, 4),
(56, 41, 0, 1, 3, 4),
(56, 42, 0, 1, 3, 4),
(56, 44, 0, 1, 3, 4),
(56, 45, 0, 1, 3, 4),
(56, 46, 0, 1, 3, 4),
(56, 47, 0, 1, 3, 4),
(56, 48, 0, 1, 3, 4),
(57, 29, 0, 1, 3, 4),
(57, 30, 0, 1, 3, 4),
(57, 31, 0, 1, 3, 4),
(57, 32, 0, 1, 3, 4),
(57, 33, 0, 1, 3, 4),
(57, 34, 0, 1, 3, 4),
(57, 35, 0, 1, 3, 4),
(57, 36, 0, 1, 3, 4),
(57, 37, 0, 1, 3, 4),
(57, 38, 0, 1, 3, 4),
(57, 39, 0, 1, 3, 4),
(57, 40, 0, 1, 3, 4),
(57, 41, 0, 1, 3, 4),
(57, 42, 0, 1, 3, 4),
(57, 44, 0, 1, 3, 4),
(57, 45, 0, 1, 3, 4),
(57, 46, 0, 1, 3, 4),
(57, 47, 0, 1, 3, 4),
(57, 48, 0, 1, 3, 4),
(58, 7, 0, 1, 3, 4),
(58, 13, 0, 1, 3, 4),
(58, 19, 0, 1, 3, 4),
(58, 20, 0, 1, 3, 4),
(58, 21, 0, 1, 3, 4),
(58, 37, 0, 1, 3, 4),
(58, 42, 0, 1, 3, 4),
(58, 44, 0, 1, 3, 4),
(58, 45, 0, 1, 3, 4),
(58, 46, 0, 1, 3, 4),
(58, 47, 0, 1, 3, 4),
(58, 48, 0, 1, 3, 4),
(58, 49, 1, 1, 3, 4),
(2, 8, 20004, 0, 4, 4),
(2, 9, 20004, 0, 4, 4),
(2, 10, 20004, 0, 4, 4),
(2, 11, 20004, 0, 4, 4),
(2, 12, 20004, 0, 4, 4),
(2, 14, 20004, 0, 4, 4),
(2, 15, 20004, 0, 4, 4),
(2, 16, 20004, 0, 4, 4),
(2, 17, 20004, 0, 4, 4),
(2, 18, 20004, 0, 4, 4),
(2, 22, 20004, 0, 4, 4),
(2, 23, 20004, 0, 4, 4),
(2, 24, 20004, 0, 4, 4),
(2, 25, 20004, 0, 4, 4),
(2, 26, 20004, 0, 4, 4),
(2, 27, 20004, 0, 4, 4),
(2, 28, 20004, 0, 4, 4),
(2, 29, 20004, 0, 4, 4),
(2, 30, 20004, 0, 4, 4),
(2, 31, 20004, 0, 4, 4),
(2, 32, 20004, 0, 4, 4),
(2, 33, 20004, 0, 4, 4),
(2, 34, 20004, 0, 4, 4),
(2, 35, 20004, 0, 4, 4),
(2, 36, 20004, 0, 4, 4),
(2, 37, 20004, 0, 4, 4),
(2, 38, 20004, 0, 4, 4),
(2, 39, 20004, 0, 4, 4),
(2, 40, 20004, 0, 4, 4),
(2, 41, 20004, 0, 4, 4),
(2, 49, 20007, 0, 4, 4),
(2, 7, 1, 1, 4, 4),
(2, 13, 1, 1, 4, 4),
(2, 19, 1, 1, 4, 4),
(2, 20, 1, 1, 4, 4),
(2, 21, 1, 1, 4, 4),
(2, 42, 1, 1, 4, 4),
(2, 44, 1, 1, 4, 4),
(2, 45, 1, 1, 4, 4),
(2, 46, 1, 1, 4, 4),
(2, 47, 1, 1, 4, 4),
(2, 48, 1, 1, 4, 4),
(3, 8, 0, 1, 4, 4),
(3, 9, 0, 1, 4, 4),
(3, 10, 0, 1, 4, 4),
(3, 11, 0, 1, 4, 4),
(3, 12, 0, 1, 4, 4),
(3, 14, 0, 1, 4, 4),
(3, 15, 0, 1, 4, 4),
(3, 16, 0, 1, 4, 4),
(3, 17, 0, 1, 4, 4),
(3, 18, 0, 1, 4, 4),
(3, 22, 0, 1, 4, 4),
(3, 23, 0, 1, 4, 4),
(3, 24, 0, 1, 4, 4),
(3, 25, 0, 1, 4, 4),
(3, 26, 0, 1, 4, 4),
(3, 27, 0, 1, 4, 4),
(3, 28, 0, 1, 4, 4),
(3, 29, 0, 1, 4, 4),
(3, 30, 0, 1, 4, 4),
(3, 31, 0, 1, 4, 4),
(3, 32, 0, 1, 4, 4),
(3, 33, 0, 1, 4, 4),
(3, 34, 0, 1, 4, 4),
(3, 35, 0, 1, 4, 4),
(3, 36, 0, 1, 4, 4),
(3, 37, 0, 1, 4, 4),
(3, 38, 0, 1, 4, 4),
(3, 39, 0, 1, 4, 4),
(3, 40, 0, 1, 4, 4),
(3, 41, 0, 1, 4, 4),
(3, 7, 1, 1, 4, 4),
(3, 13, 1, 1, 4, 4),
(3, 19, 1, 1, 4, 4),
(3, 20, 1, 1, 4, 4),
(3, 21, 1, 1, 4, 4),
(3, 42, 1, 1, 4, 4),
(3, 44, 1, 1, 4, 4),
(3, 45, 1, 1, 4, 4),
(3, 46, 1, 1, 4, 4),
(3, 47, 1, 1, 4, 4),
(3, 48, 1, 1, 4, 4),
(4, 7, 0, 1, 4, 4),
(4, 8, 0, 1, 4, 4),
(4, 9, 0, 1, 4, 4),
(4, 10, 0, 1, 4, 4),
(4, 11, 0, 1, 4, 4),
(4, 12, 0, 1, 4, 4),
(4, 13, 0, 1, 4, 4),
(4, 14, 0, 1, 4, 4),
(4, 15, 0, 1, 4, 4),
(4, 16, 0, 1, 4, 4),
(4, 17, 0, 1, 4, 4),
(4, 18, 0, 1, 4, 4),
(4, 19, 0, 1, 4, 4),
(4, 20, 0, 1, 4, 4),
(4, 21, 0, 1, 4, 4),
(4, 22, 0, 1, 4, 4),
(4, 23, 0, 1, 4, 4),
(4, 24, 0, 1, 4, 4),
(4, 25, 0, 1, 4, 4),
(4, 26, 0, 1, 4, 4),
(4, 27, 0, 1, 4, 4),
(4, 28, 0, 1, 4, 4),
(4, 29, 0, 1, 4, 4),
(4, 30, 0, 1, 4, 4),
(4, 31, 0, 1, 4, 4),
(4, 32, 0, 1, 4, 4),
(4, 33, 0, 1, 4, 4),
(4, 34, 0, 1, 4, 4),
(4, 35, 0, 1, 4, 4),
(4, 36, 0, 1, 4, 4),
(4, 37, 0, 1, 4, 4),
(4, 38, 0, 1, 4, 4),
(4, 39, 0, 1, 4, 4),
(4, 40, 0, 1, 4, 4),
(4, 41, 0, 1, 4, 4),
(4, 42, 0, 1, 4, 4),
(4, 44, 0, 1, 4, 4),
(4, 45, 0, 1, 4, 4),
(4, 46, 0, 1, 4, 4),
(4, 47, 0, 1, 4, 4),
(4, 48, 0, 1, 4, 4),
(5, 29, 0, 1, 4, 4),
(5, 30, 0, 1, 4, 4),
(5, 31, 0, 1, 4, 4),
(5, 32, 0, 1, 4, 4),
(5, 33, 0, 1, 4, 4),
(5, 34, 0, 1, 4, 4),
(5, 35, 0, 1, 4, 4),
(5, 36, 0, 1, 4, 4),
(5, 37, 0, 1, 4, 4),
(5, 38, 0, 1, 4, 4),
(5, 39, 0, 1, 4, 4),
(5, 40, 0, 1, 4, 4),
(5, 41, 0, 1, 4, 4),
(5, 42, 0, 1, 4, 4),
(5, 44, 0, 1, 4, 4),
(5, 45, 0, 1, 4, 4),
(5, 46, 0, 1, 4, 4),
(6, 29, 0, 1, 4, 4),
(6, 30, 0, 1, 4, 4),
(6, 31, 0, 1, 4, 4),
(6, 32, 0, 1, 4, 4),
(6, 33, 0, 1, 4, 4),
(6, 34, 0, 1, 4, 4),
(6, 35, 0, 1, 4, 4),
(6, 36, 0, 1, 4, 4),
(6, 37, 0, 1, 4, 4),
(6, 38, 0, 1, 4, 4),
(6, 39, 0, 1, 4, 4),
(6, 40, 0, 1, 4, 4),
(6, 41, 0, 1, 4, 4),
(6, 42, 0, 1, 4, 4),
(6, 44, 0, 1, 4, 4),
(6, 45, 0, 1, 4, 4),
(6, 46, 0, 1, 4, 4),
(6, 47, 0, 1, 4, 4),
(6, 48, 1, 1, 4, 4),
(9, 33, 0, 1, 4, 4),
(9, 34, 0, 1, 4, 4),
(9, 35, 0, 1, 4, 4),
(9, 36, 0, 1, 4, 4),
(9, 37, 0, 1, 4, 4),
(9, 38, 0, 1, 4, 4),
(9, 39, 0, 1, 4, 4),
(9, 40, 0, 1, 4, 4),
(9, 41, 0, 1, 4, 4),
(9, 42, 0, 1, 4, 4),
(9, 44, 0, 1, 4, 4),
(9, 45, 0, 1, 4, 4),
(9, 46, 0, 1, 4, 4),
(9, 47, 0, 1, 4, 4),
(9, 48, 0, 1, 4, 4),
(19, 29, 0, 1, 4, 4),
(19, 30, 0, 1, 4, 4),
(19, 31, 0, 1, 4, 4),
(19, 32, 0, 1, 4, 4),
(19, 33, 0, 1, 4, 4),
(19, 34, 0, 1, 4, 4),
(19, 35, 0, 1, 4, 4),
(19, 36, 0, 1, 4, 4),
(19, 37, 0, 1, 4, 4),
(19, 38, 0, 1, 4, 4),
(19, 39, 0, 1, 4, 4),
(19, 40, 0, 1, 4, 4),
(19, 41, 0, 1, 4, 4),
(19, 42, 0, 1, 4, 4),
(19, 44, 0, 1, 4, 4),
(19, 45, 0, 1, 4, 4),
(19, 46, 0, 1, 4, 4),
(19, 47, 0, 1, 4, 4),
(19, 48, 1, 1, 4, 4),
(20, 48, 1, 1, 4, 4),
(24, 48, 1, 1, 4, 4),
(25, 48, 1, 1, 4, 4),
(26, 48, 1, 1, 4, 4),
(28, 48, 1, 1, 4, 4),
(33, 29, 0, 1, 4, 4),
(33, 30, 0, 1, 4, 4),
(33, 31, 0, 1, 4, 4),
(33, 32, 0, 1, 4, 4),
(33, 33, 0, 1, 4, 4),
(33, 34, 0, 1, 4, 4),
(33, 35, 0, 1, 4, 4),
(33, 36, 0, 1, 4, 4),
(33, 37, 0, 1, 4, 4),
(33, 38, 0, 1, 4, 4),
(33, 39, 0, 1, 4, 4),
(33, 40, 0, 1, 4, 4),
(33, 41, 0, 1, 4, 4),
(33, 42, 0, 1, 4, 4),
(33, 44, 0, 1, 4, 4),
(33, 45, 0, 1, 4, 4),
(33, 46, 0, 1, 4, 4),
(33, 47, 0, 1, 4, 4),
(33, 48, 0, 1, 4, 4),
(40, 7, 0, 1, 4, 4),
(40, 13, 0, 1, 4, 4),
(40, 19, 0, 1, 4, 4),
(40, 20, 0, 1, 4, 4),
(40, 21, 0, 1, 4, 4),
(40, 48, 1, 1, 4, 4),
(41, 7, 0, 1, 4, 4),
(41, 13, 0, 1, 4, 4),
(41, 19, 0, 1, 4, 4),
(41, 20, 0, 1, 4, 4),
(41, 21, 0, 1, 4, 4),
(41, 37, 0, 1, 4, 4),
(41, 42, 0, 1, 4, 4),
(41, 44, 0, 1, 4, 4),
(41, 45, 0, 1, 4, 4),
(41, 46, 0, 1, 4, 4),
(41, 47, 0, 1, 4, 4),
(41, 48, 0, 1, 4, 4),
(42, 29, 0, 1, 4, 4),
(42, 30, 0, 1, 4, 4),
(42, 31, 0, 1, 4, 4),
(42, 32, 0, 1, 4, 4),
(42, 33, 0, 1, 4, 4),
(42, 34, 0, 1, 4, 4),
(42, 35, 0, 1, 4, 4),
(42, 36, 0, 1, 4, 4),
(42, 37, 0, 1, 4, 4),
(42, 38, 0, 1, 4, 4),
(42, 39, 0, 1, 4, 4),
(42, 40, 0, 1, 4, 4),
(42, 41, 0, 1, 4, 4),
(42, 42, 0, 1, 4, 4),
(42, 44, 0, 1, 4, 4),
(42, 45, 0, 1, 4, 4),
(42, 46, 0, 1, 4, 4),
(42, 47, 0, 1, 4, 4),
(42, 48, 1, 1, 4, 4),
(43, 29, 0, 1, 4, 4),
(43, 30, 0, 1, 4, 4),
(43, 31, 0, 1, 4, 4),
(43, 32, 0, 1, 4, 4),
(43, 33, 0, 1, 4, 4),
(43, 34, 0, 1, 4, 4),
(43, 35, 0, 1, 4, 4),
(43, 36, 0, 1, 4, 4),
(43, 37, 0, 1, 4, 4),
(43, 38, 0, 1, 4, 4),
(43, 39, 0, 1, 4, 4),
(43, 40, 0, 1, 4, 4),
(43, 41, 0, 1, 4, 4),
(43, 42, 0, 1, 4, 4),
(43, 44, 0, 1, 4, 4),
(43, 45, 0, 1, 4, 4),
(43, 46, 0, 1, 4, 4),
(43, 47, 0, 1, 4, 4),
(43, 48, 1, 1, 4, 4),
(44, 29, 0, 1, 4, 4),
(44, 30, 0, 1, 4, 4),
(44, 31, 0, 1, 4, 4),
(44, 32, 0, 1, 4, 4),
(44, 33, 0, 1, 4, 4),
(44, 34, 0, 1, 4, 4),
(44, 35, 0, 1, 4, 4),
(44, 36, 0, 1, 4, 4),
(44, 37, 0, 1, 4, 4),
(44, 38, 0, 1, 4, 4),
(44, 39, 0, 1, 4, 4),
(44, 40, 0, 1, 4, 4),
(44, 41, 0, 1, 4, 4),
(44, 42, 0, 1, 4, 4),
(44, 44, 0, 1, 4, 4),
(44, 45, 0, 1, 4, 4),
(44, 46, 0, 1, 4, 4),
(44, 47, 0, 1, 4, 4),
(44, 48, 1, 1, 4, 4),
(45, 29, 0, 1, 4, 4),
(45, 30, 0, 1, 4, 4),
(45, 31, 0, 1, 4, 4),
(45, 32, 0, 1, 4, 4),
(45, 33, 0, 1, 4, 4),
(45, 34, 0, 1, 4, 4),
(45, 35, 0, 1, 4, 4),
(45, 36, 0, 1, 4, 4),
(45, 37, 0, 1, 4, 4),
(45, 38, 0, 1, 4, 4),
(45, 39, 0, 1, 4, 4),
(45, 40, 0, 1, 4, 4),
(45, 41, 0, 1, 4, 4),
(45, 42, 0, 1, 4, 4),
(45, 44, 0, 1, 4, 4),
(45, 45, 0, 1, 4, 4),
(45, 46, 0, 1, 4, 4),
(45, 47, 0, 1, 4, 4),
(45, 48, 1, 1, 4, 4),
(46, 29, 0, 1, 4, 4),
(46, 30, 0, 1, 4, 4),
(46, 31, 0, 1, 4, 4),
(46, 32, 0, 1, 4, 4),
(46, 33, 0, 1, 4, 4),
(46, 34, 0, 1, 4, 4),
(46, 35, 0, 1, 4, 4),
(46, 36, 0, 1, 4, 4),
(46, 37, 0, 1, 4, 4),
(46, 38, 0, 1, 4, 4),
(46, 39, 0, 1, 4, 4),
(46, 40, 0, 1, 4, 4),
(46, 41, 0, 1, 4, 4),
(46, 42, 0, 1, 4, 4),
(46, 44, 0, 1, 4, 4),
(46, 45, 0, 1, 4, 4),
(46, 46, 0, 1, 4, 4),
(46, 47, 0, 1, 4, 4),
(46, 48, 1, 1, 4, 4),
(47, 29, 0, 1, 4, 4),
(47, 30, 0, 1, 4, 4),
(47, 31, 0, 1, 4, 4),
(47, 32, 0, 1, 4, 4),
(47, 33, 0, 1, 4, 4),
(47, 34, 0, 1, 4, 4),
(47, 35, 0, 1, 4, 4),
(47, 36, 0, 1, 4, 4),
(47, 37, 0, 1, 4, 4),
(47, 38, 0, 1, 4, 4),
(47, 39, 0, 1, 4, 4),
(47, 40, 0, 1, 4, 4),
(47, 41, 0, 1, 4, 4),
(47, 42, 0, 1, 4, 4),
(47, 44, 0, 1, 4, 4),
(47, 45, 0, 1, 4, 4),
(47, 46, 0, 1, 4, 4),
(47, 47, 0, 1, 4, 4),
(47, 48, 1, 1, 4, 4),
(48, 29, 0, 1, 4, 4),
(48, 30, 0, 1, 4, 4),
(48, 31, 0, 1, 4, 4),
(48, 32, 0, 1, 4, 4),
(48, 33, 0, 1, 4, 4),
(48, 34, 0, 1, 4, 4),
(48, 35, 0, 1, 4, 4),
(48, 36, 0, 1, 4, 4),
(48, 37, 0, 1, 4, 4),
(48, 38, 0, 1, 4, 4),
(48, 39, 0, 1, 4, 4),
(48, 40, 0, 1, 4, 4),
(48, 41, 0, 1, 4, 4),
(48, 42, 0, 1, 4, 4),
(48, 44, 0, 1, 4, 4),
(48, 45, 0, 1, 4, 4),
(48, 46, 0, 1, 4, 4),
(48, 47, 0, 1, 4, 4),
(48, 48, 1, 1, 4, 4),
(49, 29, 0, 1, 4, 4),
(49, 30, 0, 1, 4, 4),
(49, 31, 0, 1, 4, 4),
(49, 32, 0, 1, 4, 4),
(49, 33, 0, 1, 4, 4),
(49, 34, 0, 1, 4, 4),
(49, 35, 0, 1, 4, 4),
(49, 36, 0, 1, 4, 4),
(49, 37, 0, 1, 4, 4),
(49, 38, 0, 1, 4, 4),
(49, 39, 0, 1, 4, 4),
(49, 40, 0, 1, 4, 4),
(49, 41, 0, 1, 4, 4),
(49, 42, 0, 1, 4, 4),
(49, 44, 0, 1, 4, 4),
(49, 45, 0, 1, 4, 4),
(49, 46, 0, 1, 4, 4),
(49, 47, 0, 1, 4, 4),
(49, 48, 1, 1, 4, 4),
(50, 29, 0, 1, 4, 4),
(50, 30, 0, 1, 4, 4),
(50, 31, 0, 1, 4, 4),
(50, 32, 0, 1, 4, 4),
(50, 33, 0, 1, 4, 4),
(50, 34, 0, 1, 4, 4),
(50, 35, 0, 1, 4, 4),
(50, 36, 0, 1, 4, 4),
(50, 37, 0, 1, 4, 4),
(50, 38, 0, 1, 4, 4),
(50, 39, 0, 1, 4, 4),
(50, 40, 0, 1, 4, 4),
(50, 41, 0, 1, 4, 4),
(50, 42, 0, 1, 4, 4),
(50, 44, 0, 1, 4, 4),
(50, 45, 0, 1, 4, 4),
(50, 46, 0, 1, 4, 4),
(50, 47, 0, 1, 4, 4),
(50, 48, 1, 1, 4, 4),
(50, 49, 1, 1, 4, 4),
(55, 29, 0, 1, 4, 4),
(55, 30, 0, 1, 4, 4),
(55, 31, 0, 1, 4, 4),
(55, 32, 0, 1, 4, 4),
(55, 33, 0, 1, 4, 4),
(55, 34, 0, 1, 4, 4),
(55, 35, 0, 1, 4, 4),
(55, 36, 0, 1, 4, 4),
(55, 37, 0, 1, 4, 4),
(55, 38, 0, 1, 4, 4),
(55, 39, 0, 1, 4, 4),
(55, 40, 0, 1, 4, 4),
(55, 41, 0, 1, 4, 4),
(55, 42, 0, 1, 4, 4),
(55, 44, 0, 1, 4, 4),
(55, 45, 0, 1, 4, 4),
(55, 46, 0, 1, 4, 4),
(55, 47, 0, 1, 4, 4),
(55, 48, 0, 1, 4, 4),
(56, 29, 0, 1, 4, 4),
(56, 30, 0, 1, 4, 4),
(56, 31, 0, 1, 4, 4),
(56, 32, 0, 1, 4, 4),
(56, 33, 0, 1, 4, 4),
(56, 34, 0, 1, 4, 4),
(56, 35, 0, 1, 4, 4),
(56, 36, 0, 1, 4, 4),
(56, 37, 0, 1, 4, 4),
(56, 38, 0, 1, 4, 4),
(56, 39, 0, 1, 4, 4),
(56, 40, 0, 1, 4, 4),
(56, 41, 0, 1, 4, 4),
(56, 42, 0, 1, 4, 4),
(56, 44, 0, 1, 4, 4),
(56, 45, 0, 1, 4, 4),
(56, 46, 0, 1, 4, 4),
(56, 47, 0, 1, 4, 4),
(56, 48, 0, 1, 4, 4),
(57, 29, 0, 1, 4, 4),
(57, 30, 0, 1, 4, 4),
(57, 31, 0, 1, 4, 4),
(57, 32, 0, 1, 4, 4),
(57, 33, 0, 1, 4, 4),
(57, 34, 0, 1, 4, 4),
(57, 35, 0, 1, 4, 4),
(57, 36, 0, 1, 4, 4),
(57, 37, 0, 1, 4, 4),
(57, 38, 0, 1, 4, 4),
(57, 39, 0, 1, 4, 4),
(57, 40, 0, 1, 4, 4),
(57, 41, 0, 1, 4, 4),
(57, 42, 0, 1, 4, 4),
(57, 44, 0, 1, 4, 4),
(57, 45, 0, 1, 4, 4),
(57, 46, 0, 1, 4, 4),
(57, 47, 0, 1, 4, 4),
(57, 48, 0, 1, 4, 4),
(58, 7, 0, 1, 4, 4),
(58, 13, 0, 1, 4, 4),
(58, 19, 0, 1, 4, 4),
(58, 20, 0, 1, 4, 4),
(58, 21, 0, 1, 4, 4),
(58, 37, 0, 1, 4, 4),
(58, 42, 0, 1, 4, 4),
(58, 44, 0, 1, 4, 4),
(58, 45, 0, 1, 4, 4),
(58, 46, 0, 1, 4, 4),
(58, 47, 0, 1, 4, 4),
(58, 48, 0, 1, 4, 4),
(58, 49, 1, 1, 4, 4),
(2, 8, 20004, 0, 5, 4),
(2, 9, 20004, 0, 5, 4),
(2, 10, 20004, 0, 5, 4),
(2, 11, 20004, 0, 5, 4),
(2, 12, 20004, 0, 5, 4),
(2, 14, 20004, 0, 5, 4),
(2, 15, 20004, 0, 5, 4),
(2, 16, 20004, 0, 5, 4),
(2, 17, 20004, 0, 5, 4),
(2, 18, 20004, 0, 5, 4),
(2, 22, 20004, 0, 5, 4),
(2, 23, 20004, 0, 5, 4),
(2, 24, 20004, 0, 5, 4),
(2, 25, 20004, 0, 5, 4),
(2, 26, 20004, 0, 5, 4),
(2, 27, 20004, 0, 5, 4),
(2, 28, 20004, 0, 5, 4),
(2, 29, 20004, 0, 5, 4),
(2, 30, 20004, 0, 5, 4),
(2, 31, 20004, 0, 5, 4),
(2, 32, 20004, 0, 5, 4),
(2, 33, 20004, 0, 5, 4),
(2, 34, 20004, 0, 5, 4),
(2, 35, 20004, 0, 5, 4),
(2, 36, 20004, 0, 5, 4),
(2, 37, 20004, 0, 5, 4),
(2, 38, 20004, 0, 5, 4),
(2, 39, 20004, 0, 5, 4),
(2, 40, 20004, 0, 5, 4),
(2, 41, 20004, 0, 5, 4),
(2, 49, 20007, 0, 5, 4),
(2, 7, 1, 1, 5, 4),
(2, 13, 1, 1, 5, 4),
(2, 19, 1, 1, 5, 4),
(2, 20, 1, 1, 5, 4),
(2, 21, 1, 1, 5, 4),
(2, 42, 1, 1, 5, 4),
(2, 44, 1, 1, 5, 4),
(2, 45, 1, 1, 5, 4),
(2, 46, 1, 1, 5, 4),
(2, 47, 1, 1, 5, 4),
(2, 48, 1, 1, 5, 4),
(3, 8, 0, 1, 5, 4),
(3, 9, 0, 1, 5, 4),
(3, 10, 0, 1, 5, 4),
(3, 11, 0, 1, 5, 4),
(3, 12, 0, 1, 5, 4),
(3, 14, 0, 1, 5, 4),
(3, 15, 0, 1, 5, 4),
(3, 16, 0, 1, 5, 4),
(3, 17, 0, 1, 5, 4),
(3, 18, 0, 1, 5, 4),
(3, 22, 0, 1, 5, 4),
(3, 23, 0, 1, 5, 4),
(3, 24, 0, 1, 5, 4),
(3, 25, 0, 1, 5, 4),
(3, 26, 0, 1, 5, 4),
(3, 27, 0, 1, 5, 4),
(3, 28, 0, 1, 5, 4),
(3, 29, 0, 1, 5, 4),
(3, 30, 0, 1, 5, 4),
(3, 31, 0, 1, 5, 4),
(3, 32, 0, 1, 5, 4),
(3, 33, 0, 1, 5, 4),
(3, 34, 0, 1, 5, 4),
(3, 35, 0, 1, 5, 4),
(3, 36, 0, 1, 5, 4),
(3, 37, 0, 1, 5, 4),
(3, 38, 0, 1, 5, 4),
(3, 39, 0, 1, 5, 4),
(3, 40, 0, 1, 5, 4),
(3, 41, 0, 1, 5, 4),
(3, 7, 1, 1, 5, 4),
(3, 13, 1, 1, 5, 4),
(3, 19, 1, 1, 5, 4),
(3, 20, 1, 1, 5, 4),
(3, 21, 1, 1, 5, 4),
(3, 42, 1, 1, 5, 4),
(3, 44, 1, 1, 5, 4),
(3, 45, 1, 1, 5, 4),
(3, 46, 1, 1, 5, 4),
(3, 47, 1, 1, 5, 4),
(3, 48, 1, 1, 5, 4),
(4, 7, 0, 1, 5, 4),
(4, 8, 0, 1, 5, 4),
(4, 9, 0, 1, 5, 4),
(4, 10, 0, 1, 5, 4),
(4, 11, 0, 1, 5, 4),
(4, 12, 0, 1, 5, 4),
(4, 13, 0, 1, 5, 4),
(4, 14, 0, 1, 5, 4),
(4, 15, 0, 1, 5, 4),
(4, 16, 0, 1, 5, 4),
(4, 17, 0, 1, 5, 4),
(4, 18, 0, 1, 5, 4),
(4, 19, 0, 1, 5, 4),
(4, 20, 0, 1, 5, 4),
(4, 21, 0, 1, 5, 4),
(4, 22, 0, 1, 5, 4),
(4, 23, 0, 1, 5, 4),
(4, 24, 0, 1, 5, 4),
(4, 25, 0, 1, 5, 4),
(4, 26, 0, 1, 5, 4),
(4, 27, 0, 1, 5, 4),
(4, 28, 0, 1, 5, 4),
(4, 29, 0, 1, 5, 4),
(4, 30, 0, 1, 5, 4),
(4, 31, 0, 1, 5, 4),
(4, 32, 0, 1, 5, 4),
(4, 33, 0, 1, 5, 4),
(4, 34, 0, 1, 5, 4),
(4, 35, 0, 1, 5, 4),
(4, 36, 0, 1, 5, 4),
(4, 37, 0, 1, 5, 4),
(4, 38, 0, 1, 5, 4),
(4, 39, 0, 1, 5, 4),
(4, 40, 0, 1, 5, 4),
(4, 41, 0, 1, 5, 4),
(4, 42, 0, 1, 5, 4),
(4, 44, 0, 1, 5, 4),
(4, 45, 0, 1, 5, 4),
(4, 46, 0, 1, 5, 4),
(4, 47, 0, 1, 5, 4),
(4, 48, 0, 1, 5, 4),
(5, 29, 0, 1, 5, 4),
(5, 30, 0, 1, 5, 4),
(5, 31, 0, 1, 5, 4),
(5, 32, 0, 1, 5, 4),
(5, 33, 0, 1, 5, 4),
(5, 34, 0, 1, 5, 4),
(5, 35, 0, 1, 5, 4),
(5, 36, 0, 1, 5, 4),
(5, 37, 0, 1, 5, 4),
(5, 38, 0, 1, 5, 4),
(5, 39, 0, 1, 5, 4),
(5, 40, 0, 1, 5, 4),
(5, 41, 0, 1, 5, 4),
(5, 42, 0, 1, 5, 4),
(5, 44, 0, 1, 5, 4),
(5, 45, 0, 1, 5, 4),
(5, 46, 0, 1, 5, 4),
(6, 29, 0, 1, 5, 4),
(6, 30, 0, 1, 5, 4),
(6, 31, 0, 1, 5, 4),
(6, 32, 0, 1, 5, 4),
(6, 33, 0, 1, 5, 4),
(6, 34, 0, 1, 5, 4),
(6, 35, 0, 1, 5, 4),
(6, 36, 0, 1, 5, 4),
(6, 37, 0, 1, 5, 4),
(6, 38, 0, 1, 5, 4),
(6, 39, 0, 1, 5, 4),
(6, 40, 0, 1, 5, 4),
(6, 41, 0, 1, 5, 4),
(6, 42, 0, 1, 5, 4),
(6, 44, 0, 1, 5, 4),
(6, 45, 0, 1, 5, 4),
(6, 46, 0, 1, 5, 4),
(6, 47, 0, 1, 5, 4),
(6, 48, 1, 1, 5, 4),
(9, 33, 0, 1, 5, 4),
(9, 34, 0, 1, 5, 4),
(9, 35, 0, 1, 5, 4),
(9, 36, 0, 1, 5, 4),
(9, 37, 0, 1, 5, 4),
(9, 38, 0, 1, 5, 4),
(9, 39, 0, 1, 5, 4),
(9, 40, 0, 1, 5, 4),
(9, 41, 0, 1, 5, 4),
(9, 42, 0, 1, 5, 4),
(9, 44, 0, 1, 5, 4),
(9, 45, 0, 1, 5, 4),
(9, 46, 0, 1, 5, 4),
(9, 47, 0, 1, 5, 4),
(9, 48, 0, 1, 5, 4),
(19, 29, 0, 1, 5, 4),
(19, 30, 0, 1, 5, 4),
(19, 31, 0, 1, 5, 4),
(19, 32, 0, 1, 5, 4),
(19, 33, 0, 1, 5, 4),
(19, 34, 0, 1, 5, 4),
(19, 35, 0, 1, 5, 4),
(19, 36, 0, 1, 5, 4),
(19, 37, 0, 1, 5, 4),
(19, 38, 0, 1, 5, 4),
(19, 39, 0, 1, 5, 4),
(19, 40, 0, 1, 5, 4),
(19, 41, 0, 1, 5, 4),
(19, 42, 0, 1, 5, 4),
(19, 44, 0, 1, 5, 4),
(19, 45, 0, 1, 5, 4),
(19, 46, 0, 1, 5, 4),
(19, 47, 0, 1, 5, 4),
(19, 48, 1, 1, 5, 4),
(20, 48, 1, 1, 5, 4),
(24, 48, 1, 1, 5, 4),
(25, 48, 1, 1, 5, 4),
(26, 48, 1, 1, 5, 4),
(28, 48, 1, 1, 5, 4),
(33, 29, 0, 1, 5, 4),
(33, 30, 0, 1, 5, 4),
(33, 31, 0, 1, 5, 4),
(33, 32, 0, 1, 5, 4),
(33, 33, 0, 1, 5, 4),
(33, 34, 0, 1, 5, 4),
(33, 35, 0, 1, 5, 4),
(33, 36, 0, 1, 5, 4),
(33, 37, 0, 1, 5, 4),
(33, 38, 0, 1, 5, 4),
(33, 39, 0, 1, 5, 4),
(33, 40, 0, 1, 5, 4),
(33, 41, 0, 1, 5, 4),
(33, 42, 0, 1, 5, 4),
(33, 44, 0, 1, 5, 4),
(33, 45, 0, 1, 5, 4),
(33, 46, 0, 1, 5, 4),
(33, 47, 0, 1, 5, 4),
(33, 48, 0, 1, 5, 4),
(40, 7, 0, 1, 5, 4),
(40, 13, 0, 1, 5, 4),
(40, 19, 0, 1, 5, 4),
(40, 20, 0, 1, 5, 4),
(40, 21, 0, 1, 5, 4),
(40, 48, 1, 1, 5, 4),
(41, 7, 0, 1, 5, 4),
(41, 13, 0, 1, 5, 4),
(41, 19, 0, 1, 5, 4),
(41, 20, 0, 1, 5, 4),
(41, 21, 0, 1, 5, 4),
(41, 37, 0, 1, 5, 4),
(41, 42, 0, 1, 5, 4),
(41, 44, 0, 1, 5, 4),
(41, 45, 0, 1, 5, 4),
(41, 46, 0, 1, 5, 4),
(41, 47, 0, 1, 5, 4),
(41, 48, 0, 1, 5, 4),
(42, 29, 0, 1, 5, 4),
(42, 30, 0, 1, 5, 4),
(42, 31, 0, 1, 5, 4),
(42, 32, 0, 1, 5, 4),
(42, 33, 0, 1, 5, 4),
(42, 34, 0, 1, 5, 4),
(42, 35, 0, 1, 5, 4),
(42, 36, 0, 1, 5, 4),
(42, 37, 0, 1, 5, 4),
(42, 38, 0, 1, 5, 4),
(42, 39, 0, 1, 5, 4),
(42, 40, 0, 1, 5, 4),
(42, 41, 0, 1, 5, 4),
(42, 42, 0, 1, 5, 4),
(42, 44, 0, 1, 5, 4),
(42, 45, 0, 1, 5, 4),
(42, 46, 0, 1, 5, 4),
(42, 47, 0, 1, 5, 4),
(42, 48, 1, 1, 5, 4),
(43, 29, 0, 1, 5, 4),
(43, 30, 0, 1, 5, 4),
(43, 31, 0, 1, 5, 4),
(43, 32, 0, 1, 5, 4),
(43, 33, 0, 1, 5, 4),
(43, 34, 0, 1, 5, 4),
(43, 35, 0, 1, 5, 4),
(43, 36, 0, 1, 5, 4),
(43, 37, 0, 1, 5, 4),
(43, 38, 0, 1, 5, 4),
(43, 39, 0, 1, 5, 4),
(43, 40, 0, 1, 5, 4),
(43, 41, 0, 1, 5, 4),
(43, 42, 0, 1, 5, 4),
(43, 44, 0, 1, 5, 4),
(43, 45, 0, 1, 5, 4),
(43, 46, 0, 1, 5, 4),
(43, 47, 0, 1, 5, 4),
(43, 48, 1, 1, 5, 4),
(44, 29, 0, 1, 5, 4),
(44, 30, 0, 1, 5, 4),
(44, 31, 0, 1, 5, 4),
(44, 32, 0, 1, 5, 4),
(44, 33, 0, 1, 5, 4),
(44, 34, 0, 1, 5, 4),
(44, 35, 0, 1, 5, 4),
(44, 36, 0, 1, 5, 4),
(44, 37, 0, 1, 5, 4),
(44, 38, 0, 1, 5, 4),
(44, 39, 0, 1, 5, 4),
(44, 40, 0, 1, 5, 4),
(44, 41, 0, 1, 5, 4),
(44, 42, 0, 1, 5, 4),
(44, 44, 0, 1, 5, 4),
(44, 45, 0, 1, 5, 4),
(44, 46, 0, 1, 5, 4),
(44, 47, 0, 1, 5, 4),
(44, 48, 1, 1, 5, 4),
(45, 29, 0, 1, 5, 4),
(45, 30, 0, 1, 5, 4),
(45, 31, 0, 1, 5, 4),
(45, 32, 0, 1, 5, 4),
(45, 33, 0, 1, 5, 4),
(45, 34, 0, 1, 5, 4),
(45, 35, 0, 1, 5, 4),
(45, 36, 0, 1, 5, 4),
(45, 37, 0, 1, 5, 4),
(45, 38, 0, 1, 5, 4),
(45, 39, 0, 1, 5, 4),
(45, 40, 0, 1, 5, 4),
(45, 41, 0, 1, 5, 4),
(45, 42, 0, 1, 5, 4),
(45, 44, 0, 1, 5, 4),
(45, 45, 0, 1, 5, 4),
(45, 46, 0, 1, 5, 4),
(45, 47, 0, 1, 5, 4),
(45, 48, 1, 1, 5, 4),
(46, 29, 0, 1, 5, 4),
(46, 30, 0, 1, 5, 4),
(46, 31, 0, 1, 5, 4),
(46, 32, 0, 1, 5, 4),
(46, 33, 0, 1, 5, 4),
(46, 34, 0, 1, 5, 4),
(46, 35, 0, 1, 5, 4),
(46, 36, 0, 1, 5, 4),
(46, 37, 0, 1, 5, 4),
(46, 38, 0, 1, 5, 4),
(46, 39, 0, 1, 5, 4),
(46, 40, 0, 1, 5, 4),
(46, 41, 0, 1, 5, 4),
(46, 42, 0, 1, 5, 4),
(46, 44, 0, 1, 5, 4),
(46, 45, 0, 1, 5, 4),
(46, 46, 0, 1, 5, 4),
(46, 47, 0, 1, 5, 4),
(46, 48, 1, 1, 5, 4),
(47, 29, 0, 1, 5, 4),
(47, 30, 0, 1, 5, 4),
(47, 31, 0, 1, 5, 4),
(47, 32, 0, 1, 5, 4),
(47, 33, 0, 1, 5, 4),
(47, 34, 0, 1, 5, 4),
(47, 35, 0, 1, 5, 4),
(47, 36, 0, 1, 5, 4),
(47, 37, 0, 1, 5, 4),
(47, 38, 0, 1, 5, 4),
(47, 39, 0, 1, 5, 4),
(47, 40, 0, 1, 5, 4),
(47, 41, 0, 1, 5, 4),
(47, 42, 0, 1, 5, 4),
(47, 44, 0, 1, 5, 4),
(47, 45, 0, 1, 5, 4),
(47, 46, 0, 1, 5, 4),
(47, 47, 0, 1, 5, 4),
(47, 48, 1, 1, 5, 4),
(48, 29, 0, 1, 5, 4),
(48, 30, 0, 1, 5, 4),
(48, 31, 0, 1, 5, 4),
(48, 32, 0, 1, 5, 4),
(48, 33, 0, 1, 5, 4),
(48, 34, 0, 1, 5, 4),
(48, 35, 0, 1, 5, 4),
(48, 36, 0, 1, 5, 4),
(48, 37, 0, 1, 5, 4),
(48, 38, 0, 1, 5, 4),
(48, 39, 0, 1, 5, 4),
(48, 40, 0, 1, 5, 4),
(48, 41, 0, 1, 5, 4),
(48, 42, 0, 1, 5, 4),
(48, 44, 0, 1, 5, 4),
(48, 45, 0, 1, 5, 4),
(48, 46, 0, 1, 5, 4),
(48, 47, 0, 1, 5, 4),
(48, 48, 1, 1, 5, 4),
(49, 29, 0, 1, 5, 4),
(49, 30, 0, 1, 5, 4),
(49, 31, 0, 1, 5, 4),
(49, 32, 0, 1, 5, 4),
(49, 33, 0, 1, 5, 4),
(49, 34, 0, 1, 5, 4),
(49, 35, 0, 1, 5, 4),
(49, 36, 0, 1, 5, 4),
(49, 37, 0, 1, 5, 4),
(49, 38, 0, 1, 5, 4),
(49, 39, 0, 1, 5, 4),
(49, 40, 0, 1, 5, 4),
(49, 41, 0, 1, 5, 4),
(49, 42, 0, 1, 5, 4),
(49, 44, 0, 1, 5, 4),
(49, 45, 0, 1, 5, 4),
(49, 46, 0, 1, 5, 4),
(49, 47, 0, 1, 5, 4),
(49, 48, 1, 1, 5, 4),
(50, 29, 0, 1, 5, 4),
(50, 30, 0, 1, 5, 4),
(50, 31, 0, 1, 5, 4),
(50, 32, 0, 1, 5, 4),
(50, 33, 0, 1, 5, 4),
(50, 34, 0, 1, 5, 4),
(50, 35, 0, 1, 5, 4),
(50, 36, 0, 1, 5, 4),
(50, 37, 0, 1, 5, 4),
(50, 38, 0, 1, 5, 4),
(50, 39, 0, 1, 5, 4),
(50, 40, 0, 1, 5, 4),
(50, 41, 0, 1, 5, 4),
(50, 42, 0, 1, 5, 4),
(50, 44, 0, 1, 5, 4),
(50, 45, 0, 1, 5, 4),
(50, 46, 0, 1, 5, 4),
(50, 47, 0, 1, 5, 4),
(50, 48, 1, 1, 5, 4),
(50, 49, 1, 1, 5, 4),
(55, 29, 0, 1, 5, 4),
(55, 30, 0, 1, 5, 4),
(55, 31, 0, 1, 5, 4),
(55, 32, 0, 1, 5, 4),
(55, 33, 0, 1, 5, 4),
(55, 34, 0, 1, 5, 4),
(55, 35, 0, 1, 5, 4),
(55, 36, 0, 1, 5, 4),
(55, 37, 0, 1, 5, 4),
(55, 38, 0, 1, 5, 4),
(55, 39, 0, 1, 5, 4),
(55, 40, 0, 1, 5, 4),
(55, 41, 0, 1, 5, 4),
(55, 42, 0, 1, 5, 4),
(55, 44, 0, 1, 5, 4),
(55, 45, 0, 1, 5, 4),
(55, 46, 0, 1, 5, 4),
(55, 47, 0, 1, 5, 4),
(55, 48, 0, 1, 5, 4),
(56, 29, 0, 1, 5, 4),
(56, 30, 0, 1, 5, 4),
(56, 31, 0, 1, 5, 4),
(56, 32, 0, 1, 5, 4),
(56, 33, 0, 1, 5, 4),
(56, 34, 0, 1, 5, 4),
(56, 35, 0, 1, 5, 4),
(56, 36, 0, 1, 5, 4),
(56, 37, 0, 1, 5, 4),
(56, 38, 0, 1, 5, 4),
(56, 39, 0, 1, 5, 4),
(56, 40, 0, 1, 5, 4),
(56, 41, 0, 1, 5, 4),
(56, 42, 0, 1, 5, 4),
(56, 44, 0, 1, 5, 4),
(56, 45, 0, 1, 5, 4),
(56, 46, 0, 1, 5, 4),
(56, 47, 0, 1, 5, 4),
(56, 48, 0, 1, 5, 4),
(57, 29, 0, 1, 5, 4),
(57, 30, 0, 1, 5, 4),
(57, 31, 0, 1, 5, 4),
(57, 32, 0, 1, 5, 4),
(57, 33, 0, 1, 5, 4),
(57, 34, 0, 1, 5, 4),
(57, 35, 0, 1, 5, 4),
(57, 36, 0, 1, 5, 4),
(57, 37, 0, 1, 5, 4),
(57, 38, 0, 1, 5, 4),
(57, 39, 0, 1, 5, 4),
(57, 40, 0, 1, 5, 4),
(57, 41, 0, 1, 5, 4),
(57, 42, 0, 1, 5, 4),
(57, 44, 0, 1, 5, 4),
(57, 45, 0, 1, 5, 4),
(57, 46, 0, 1, 5, 4),
(57, 47, 0, 1, 5, 4),
(57, 48, 0, 1, 5, 4),
(58, 7, 0, 1, 5, 4),
(58, 13, 0, 1, 5, 4),
(58, 19, 0, 1, 5, 4),
(58, 20, 0, 1, 5, 4),
(58, 21, 0, 1, 5, 4),
(58, 37, 0, 1, 5, 4),
(58, 42, 0, 1, 5, 4),
(58, 44, 0, 1, 5, 4),
(58, 45, 0, 1, 5, 4),
(58, 46, 0, 1, 5, 4),
(58, 47, 0, 1, 5, 4),
(58, 48, 0, 1, 5, 4),
(58, 49, 1, 1, 5, 4);

CREATE TABLE IF NOT EXISTS `#__catalog_category_product_index_enbl_idx` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `visibility` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Visibility'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Product Enabled Indexer Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_product_index_enbl_tmp` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `visibility` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Visibility'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Category Product Enabled Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_product_index_idx` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(11) NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_parent` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint(5) unsigned NOT NULL COMMENT 'Visibility'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Category Product Indexer Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_category_product_index_tmp` (
  `category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Category ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `position` int(11) NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_parent` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Parent',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint(5) unsigned NOT NULL COMMENT 'Visibility'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Category Product Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_compare_item` (
`catalog_compare_item_id` int(10) unsigned NOT NULL COMMENT 'Compare Item ID',
  `visitor_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Visitor ID',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Compare Table' AUTO_INCREMENT=3 ;

INSERT INTO `#__catalog_compare_item` (`catalog_compare_item_id`, `visitor_id`, `customer_id`, `product_id`, `store_id`) VALUES
(1, 28, NULL, 17, 3),
(2, 53, NULL, 39, 3);

CREATE TABLE IF NOT EXISTS `#__catalog_eav_attribute` (
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `frontend_input_renderer` varchar(255) DEFAULT NULL COMMENT 'Frontend Input Renderer',
  `is_global` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Global',
  `is_visible` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Visible',
  `is_searchable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Searchable',
  `is_filterable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable',
  `is_comparable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Comparable',
  `is_visible_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `is_html_allowed_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is HTML Allowed On Front',
  `is_used_for_price_rules` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Price Rules',
  `is_filterable_in_search` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Filterable In Search',
  `used_in_product_listing` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used In Product Listing',
  `used_for_sort_by` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Sorting',
  `is_configurable` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Configurable',
  `apply_to` varchar(255) DEFAULT NULL COMMENT 'Apply To',
  `is_visible_in_advanced_search` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible In Advanced Search',
  `position` int(11) NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_wysiwyg_enabled` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is WYSIWYG Enabled',
  `is_used_for_promo_rules` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Used For Promo Rules'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog EAV Attribute Table';

INSERT INTO `#__catalog_eav_attribute` (`attribute_id`, `frontend_input_renderer`, `is_global`, `is_visible`, `is_searchable`, `is_filterable`, `is_comparable`, `is_visible_on_front`, `is_html_allowed_on_front`, `is_used_for_price_rules`, `is_filterable_in_search`, `used_in_product_listing`, `used_for_sort_by`, `is_configurable`, `apply_to`, `is_visible_in_advanced_search`, `position`, `is_wysiwyg_enabled`, `is_used_for_promo_rules`) VALUES
(41, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(42, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(43, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(44, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(45, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(46, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(47, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(48, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(49, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(50, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(51, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(52, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(53, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(54, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(55, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(56, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(57, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(58, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(59, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(60, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(61, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(62, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(63, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(64, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(65, 'adminhtml/catalog_category_helper_sortby_available', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(66, 'adminhtml/catalog_category_helper_sortby_default', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(67, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(68, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(69, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(70, 'adminhtml/catalog_category_helper_pricestep', 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(71, NULL, 0, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, NULL, 1, 0, 0, 0),
(72, NULL, 0, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, 1, NULL, 1, 0, 1, 0),
(73, NULL, 0, 1, 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, NULL, 1, 0, 1, 0),
(74, NULL, 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 1, NULL, 1, 0, 0, 0),
(75, NULL, 2, 1, 1, 1, 0, 0, 0, 0, 0, 1, 1, 1, 'simple,configurable,virtual,bundle,downloadable', 1, 0, 0, 0),
(76, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(77, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(78, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(79, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'virtual,downloadable', 0, 0, 0, 0),
(80, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'simple,bundle', 0, 0, 0, 0),
(81, NULL, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 'simple,configurable', 1, 0, 0, 0),
(82, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(83, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(84, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(85, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(86, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(87, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(88, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(89, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(90, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(91, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(92, NULL, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 'simple,configurable', 1, 0, 0, 0),
(93, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(94, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(95, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(96, NULL, 2, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(97, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(98, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(99, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 'simple,configurable,virtual,bundle,downloadable', 0, 0, 0, 0),
(100, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'simple,virtual', 0, 0, 0, 0),
(101, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'simple,virtual', 0, 0, 0, 0),
(102, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(103, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(104, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(105, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(106, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(107, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(108, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(109, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(110, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, NULL, 0, 0, 0, 0),
(111, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(112, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, NULL, 0, 0, 0, 0),
(113, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, NULL, 0, 0, 0, 0),
(114, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, NULL, 0, 0, 0, 0),
(115, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(116, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(117, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'simple,configurable,bundle,grouped', 0, 0, 0, 0),
(118, 'adminhtml/catalog_product_helper_form_msrp_enabled', 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,bundle,configurable,virtual,downloadable', 0, 0, 0, 0),
(119, 'adminhtml/catalog_product_helper_form_msrp_price', 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,bundle,configurable,virtual,downloadable', 0, 0, 0, 0),
(120, NULL, 2, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,bundle,configurable,virtual,downloadable', 0, 0, 0, 0),
(121, NULL, 2, 1, 1, 0, 0, 0, 0, 0, 0, 1, 0, 1, 'simple,configurable,virtual,downloadable,bundle', 1, 0, 0, 0),
(122, 'giftmessage/adminhtml_product_helper_form_config', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, 0, 0, 0, 0),
(123, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'bundle', 0, 0, 0, 0),
(124, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'bundle', 0, 0, 0, 0),
(125, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'bundle', 0, 0, 0, 0),
(126, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'bundle', 0, 0, 0, 0),
(127, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'bundle', 0, 0, 0, 0),
(128, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'downloadable', 0, 0, 0, 0),
(129, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'downloadable', 0, 0, 0, 0),
(130, NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'downloadable', 0, 0, 0, 0),
(131, NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 'downloadable', 0, 0, 0, 0),
(132, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(133, NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(134, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(135, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(136, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(137, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(138, NULL, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(139, NULL, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(140, NULL, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(141, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(142, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(143, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(144, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(145, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(146, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(147, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(148, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(149, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(150, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(151, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(152, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(153, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(154, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(155, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(156, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(157, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(158, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(159, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(160, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(161, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(162, NULL, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, NULL, 0, 0, 1, 0),
(163, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0),
(164, NULL, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, NULL, 0, 0, 0, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `required` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required',
  `position` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Position',
  `type` varchar(255) DEFAULT NULL COMMENT 'Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Option' AUTO_INCREMENT=9 ;

INSERT INTO `#__catalog_product_bundle_option` (`option_id`, `parent_id`, `required`, `position`, `type`) VALUES
(1, 44, 0, 0, 'multi'),
(2, 44, 1, 0, 'checkbox'),
(3, 44, 0, 0, 'radio'),
(4, 44, 1, 0, 'select'),
(5, 45, 0, 4, 'multi'),
(6, 45, 1, 3, 'select'),
(7, 45, 0, 1, 'radio'),
(8, 45, 1, 2, 'select');

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_option_value` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value Id',
  `option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Option Value' AUTO_INCREMENT=21 ;

INSERT INTO `#__catalog_product_bundle_option_value` (`value_id`, `option_id`, `store_id`, `title`) VALUES
(1, 1, 0, 'Option #4'),
(2, 2, 0, 'Option #3'),
(3, 3, 0, 'Option #2'),
(4, 4, 0, 'Option #1'),
(17, 7, 0, 'Option #2'),
(18, 8, 0, 'Option #1'),
(19, 6, 0, 'Option #3'),
(20, 5, 0, 'Option #4');

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_price_index` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `min_price` decimal(12,4) NOT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) NOT NULL COMMENT 'Max Price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Price Index';

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_selection` (
`selection_id` int(10) unsigned NOT NULL COMMENT 'Selection Id',
  `option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `parent_product_id` int(10) unsigned NOT NULL COMMENT 'Parent Product Id',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `position` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Position',
  `is_default` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Default',
  `selection_price_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Price Type',
  `selection_price_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Selection Price Value',
  `selection_qty` decimal(12,4) DEFAULT NULL COMMENT 'Selection Qty',
  `selection_can_change_qty` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Selection Can Change Qty'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Selection' AUTO_INCREMENT=25 ;

INSERT INTO `#__catalog_product_bundle_selection` (`selection_id`, `option_id`, `parent_product_id`, `product_id`, `position`, `is_default`, `selection_price_type`, `selection_price_value`, `selection_qty`, `selection_can_change_qty`) VALUES
(1, 1, 44, 22, 0, 0, 0, '0.0000', '1.0000', 1),
(2, 1, 44, 23, 0, 0, 0, '0.0000', '1.0000', 1),
(3, 1, 44, 24, 0, 0, 0, '0.0000', '1.0000', 1),
(4, 2, 44, 14, 0, 0, 0, '0.0000', '1.0000', 1),
(5, 2, 44, 15, 0, 0, 0, '0.0000', '1.0000', 1),
(6, 2, 44, 16, 0, 0, 0, '0.0000', '1.0000', 1),
(7, 3, 44, 8, 0, 0, 0, '0.0000', '1.0000', 1),
(8, 3, 44, 9, 0, 0, 0, '0.0000', '1.0000', 1),
(9, 3, 44, 10, 0, 0, 0, '0.0000', '1.0000', 1),
(10, 4, 44, 37, 0, 0, 0, '0.0000', '55.0000', 1),
(11, 4, 44, 38, 0, 0, 0, '0.0000', '55.0000', 1),
(12, 4, 44, 39, 0, 0, 0, '0.0000', '55.0000', 1),
(13, 5, 45, 22, 0, 0, 0, '0.0000', '1.0000', 1),
(14, 5, 45, 23, 0, 0, 0, '0.0000', '1.0000', 1),
(15, 5, 45, 24, 0, 0, 0, '0.0000', '1.0000', 1),
(16, 6, 45, 14, 0, 0, 0, '0.0000', '1.0000', 1),
(18, 6, 45, 16, 0, 0, 0, '0.0000', '1.0000', 1),
(19, 7, 45, 8, 0, 0, 0, '0.0000', '1.0000', 1),
(21, 7, 45, 10, 0, 0, 0, '0.0000', '1.0000', 1),
(23, 8, 45, 38, 0, 0, 0, '0.0000', '55.0000', 1),
(24, 8, 45, 39, 0, 0, 0, '0.0000', '55.0000', 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_selection_price` (
  `selection_id` int(10) unsigned NOT NULL COMMENT 'Selection Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `selection_price_type` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Price Type',
  `selection_price_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Selection Price Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Selection Price';

CREATE TABLE IF NOT EXISTS `#__catalog_product_bundle_stock_index` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `stock_id` smallint(5) unsigned NOT NULL COMMENT 'Stock Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `stock_status` smallint(6) DEFAULT '0' COMMENT 'Stock Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Bundle Stock Index';

CREATE TABLE IF NOT EXISTS `#__catalog_product_enabled_index` (
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `visibility` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Visibility'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Visibility Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set ID',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type ID',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Creation Time',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Update Time'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Table' AUTO_INCREMENT=50 ;

INSERT INTO `#__catalog_product_entity` (`entity_id`, `entity_type_id`, `attribute_set_id`, `type_id`, `sku`, `has_options`, `required_options`, `created_at`, `updated_at`) VALUES
(7, 4, 4, 'configurable', 'Cfg-01', 1, 1, '2014-03-13 00:42:03', '2015-01-23 19:45:25'),
(8, 4, 4, 'simple', 'Cfg-01-Armani-Black', 0, 0, '2014-03-13 00:44:07', '2015-05-29 03:18:42'),
(9, 4, 4, 'simple', 'Cfg-01-Armani-Blue', 0, 0, '2014-03-13 00:44:38', '2015-05-29 03:18:31'),
(10, 4, 4, 'simple', 'Cfg-01-Armani-Green', 0, 0, '2014-03-13 00:44:55', '2015-05-29 03:18:16'),
(11, 4, 4, 'simple', 'Cfg-01-Buberry-Red', 0, 0, '2014-03-13 00:45:18', '2015-05-29 03:18:25'),
(12, 4, 4, 'simple', 'Cfg-01-Buberry-Green', 0, 0, '2014-03-13 00:45:37', '2015-05-29 03:18:48'),
(13, 4, 4, 'configurable', 'Cfg-02', 1, 1, '2014-12-04 01:56:14', '2015-01-16 00:06:57'),
(14, 4, 4, 'simple', 'Cfg-02-Chanel-Black', 0, 0, '2014-04-12 01:57:37', '2015-05-29 03:19:00'),
(15, 4, 4, 'simple', 'Cfg-02-Chanel-Blue', 0, 0, '2014-12-04 01:57:55', '2015-05-29 03:19:04'),
(16, 4, 4, 'simple', 'Cfg-02-Dior-Green', 0, 0, '2014-12-04 01:58:19', '2015-05-29 03:19:19'),
(17, 4, 4, 'simple', 'Cfg-02-Gucci-Red', 0, 0, '2014-04-12 01:59:06', '2015-05-29 03:13:53'),
(18, 4, 4, 'simple', 'Cfg-02-Gucci-White', 0, 0, '2014-12-04 01:59:25', '2015-05-29 03:19:12'),
(19, 4, 4, 'configurable', 'Cfg-03', 1, 1, '2014-04-12 02:18:40', '2015-03-25 20:28:06'),
(20, 4, 4, 'configurable', 'Cfg-04', 1, 1, '2014-04-12 02:20:25', '2015-01-16 00:16:21'),
(21, 4, 4, 'configurable', 'Cfg-05', 1, 1, '2014-12-04 02:21:54', '2015-01-16 00:18:27'),
(22, 4, 4, 'simple', 'Cfg-03-Hermes-White', 0, 0, '2014-12-04 02:23:05', '2015-05-29 03:09:45'),
(23, 4, 4, 'simple', 'Cfg-03-Prada-Black', 0, 0, '2014-12-04 02:23:30', '2015-05-29 03:19:16'),
(24, 4, 4, 'simple', 'Cfg-03-Versace-Blue', 0, 0, '2014-12-04 02:24:12', '2015-05-29 03:14:23'),
(25, 4, 4, 'simple', 'Cfg-03-Prada-Green', 0, 0, '2014-12-04 02:24:40', '2015-05-29 03:14:15'),
(26, 4, 4, 'simple', 'Cfg-03-Prada-Red', 0, 0, '2014-12-04 02:24:59', '2015-05-29 03:14:05'),
(27, 4, 4, 'simple', 'Cfg-04-Black', 0, 0, '2014-12-04 02:44:04', '2015-01-16 00:13:22'),
(28, 4, 4, 'simple', 'Cfg-04-White', 0, 0, '2014-04-12 02:44:20', '2015-05-29 02:34:13'),
(29, 4, 4, 'simple', 'Cfg-04-Red', 0, 0, '2014-12-04 02:44:31', '2015-05-29 02:49:20'),
(30, 4, 4, 'simple', 'Cfg-04-Green', 0, 0, '2014-12-04 02:44:41', '2015-05-29 02:49:14'),
(31, 4, 4, 'simple', 'Cfg-04-Blue', 0, 0, '2014-12-04 02:45:01', '2015-05-29 02:49:06'),
(32, 4, 4, 'simple', 'Cfg-05-Armani', 0, 0, '2014-12-04 02:51:01', '2015-01-16 00:17:09'),
(33, 4, 4, 'simple', 'Cfg-05-Buberry', 0, 0, '2014-12-04 02:51:20', '2015-05-29 02:48:57'),
(34, 4, 4, 'simple', 'Cfg-05-Chanel', 0, 0, '2014-12-04 02:51:47', '2015-05-29 02:48:48'),
(35, 4, 4, 'simple', 'Cfg-05-Hermes', 0, 0, '2014-12-04 02:52:02', '2015-05-29 02:48:38'),
(36, 4, 4, 'simple', 'Cfg-05-Versace', 0, 0, '2014-12-04 02:52:10', '2015-05-29 02:48:34'),
(37, 4, 4, 'simple', 'sim-01', 0, 0, '2014-12-04 03:20:22', '2015-05-29 02:48:26'),
(38, 4, 4, 'simple', 'sim-02', 0, 0, '2014-12-04 03:20:40', '2015-05-29 02:50:09'),
(39, 4, 4, 'simple', 'sim-03', 0, 0, '2014-12-04 03:24:38', '2015-05-29 02:48:12'),
(40, 4, 4, 'simple', 'sim-04', 0, 0, '2014-04-12 03:26:25', '2015-05-29 02:49:55'),
(41, 4, 4, 'simple', 'sim-05', 0, 0, '2014-12-04 03:28:23', '2015-05-29 02:50:03'),
(42, 4, 4, 'grouped', 'grouped-01', 0, 0, '2014-04-12 18:54:46', '2014-12-04 19:07:36'),
(44, 4, 4, 'bundle', 'bud-01', 1, 1, '2014-12-04 19:21:49', '2015-01-16 02:00:30'),
(45, 4, 4, 'bundle', 'bud-02', 1, 1, '2014-04-12 19:22:32', '2015-03-18 01:21:39'),
(46, 4, 4, 'downloadable', 'download-01', 1, 1, '2014-04-12 19:47:25', '2014-12-04 20:00:46'),
(47, 4, 4, 'simple', 'no-img', 0, 0, '2014-04-12 20:04:31', '2015-01-19 01:53:21'),
(48, 4, 4, 'simple', 'custom-option', 1, 1, '2014-12-04 20:11:59', '2015-03-24 02:26:45'),
(49, 4, 4, 'virtual', 'virtual-01', 0, 0, '2015-06-12 02:05:00', '2015-06-12 02:05:00');

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_datetime` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` datetime DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Datetime Attribute Backend Table' AUTO_INCREMENT=645 ;

INSERT INTO `#__catalog_product_entity_datetime` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(37, 4, 93, 0, 7, NULL),
(38, 4, 94, 0, 7, NULL),
(39, 4, 77, 0, 7, NULL),
(40, 4, 78, 0, 7, NULL),
(41, 4, 104, 0, 7, NULL),
(42, 4, 105, 0, 7, NULL),
(43, 4, 93, 0, 8, '2014-12-01 00:00:00'),
(44, 4, 94, 0, 8, NULL),
(45, 4, 77, 0, 8, NULL),
(46, 4, 78, 0, 8, NULL),
(47, 4, 104, 0, 8, NULL),
(48, 4, 105, 0, 8, NULL),
(49, 4, 93, 0, 9, NULL),
(50, 4, 94, 0, 9, NULL),
(51, 4, 77, 0, 9, '2015-01-04 00:00:00'),
(52, 4, 78, 0, 9, '2034-01-04 00:00:00'),
(53, 4, 104, 0, 9, NULL),
(54, 4, 105, 0, 9, NULL),
(55, 4, 93, 0, 10, NULL),
(56, 4, 94, 0, 10, NULL),
(57, 4, 77, 0, 10, '2015-01-04 00:00:00'),
(58, 4, 78, 0, 10, '2034-12-01 00:00:00'),
(59, 4, 104, 0, 10, NULL),
(60, 4, 105, 0, 10, NULL),
(61, 4, 93, 0, 11, '2014-12-01 00:00:00'),
(62, 4, 94, 0, 11, NULL),
(63, 4, 77, 0, 11, '2014-12-01 00:00:00'),
(64, 4, 78, 0, 11, '1970-01-01 00:00:00'),
(65, 4, 104, 0, 11, NULL),
(66, 4, 105, 0, 11, NULL),
(67, 4, 93, 0, 12, '2015-01-04 00:00:00'),
(68, 4, 94, 0, 12, NULL),
(69, 4, 77, 0, 12, '2015-01-04 00:00:00'),
(70, 4, 78, 0, 12, '2035-01-04 00:00:00'),
(71, 4, 104, 0, 12, NULL),
(72, 4, 105, 0, 12, NULL),
(169, 4, 93, 0, 13, NULL),
(170, 4, 94, 0, 13, NULL),
(171, 4, 77, 0, 13, NULL),
(172, 4, 78, 0, 13, NULL),
(173, 4, 104, 0, 13, NULL),
(174, 4, 105, 0, 13, NULL),
(181, 4, 93, 0, 14, NULL),
(182, 4, 94, 0, 14, NULL),
(183, 4, 77, 0, 14, NULL),
(184, 4, 78, 0, 14, NULL),
(185, 4, 104, 0, 14, NULL),
(186, 4, 105, 0, 14, NULL),
(187, 4, 93, 0, 15, NULL),
(188, 4, 94, 0, 15, NULL),
(189, 4, 77, 0, 15, NULL),
(190, 4, 78, 0, 15, NULL),
(191, 4, 104, 0, 15, NULL),
(192, 4, 105, 0, 15, NULL),
(193, 4, 93, 0, 16, NULL),
(194, 4, 94, 0, 16, NULL),
(195, 4, 77, 0, 16, NULL),
(196, 4, 78, 0, 16, NULL),
(197, 4, 104, 0, 16, NULL),
(198, 4, 105, 0, 16, NULL),
(199, 4, 93, 0, 17, NULL),
(200, 4, 94, 0, 17, NULL),
(201, 4, 77, 0, 17, NULL),
(202, 4, 78, 0, 17, NULL),
(203, 4, 104, 0, 17, NULL),
(204, 4, 105, 0, 17, NULL),
(205, 4, 93, 0, 18, NULL),
(206, 4, 94, 0, 18, NULL),
(207, 4, 77, 0, 18, NULL),
(208, 4, 78, 0, 18, NULL),
(209, 4, 104, 0, 18, NULL),
(210, 4, 105, 0, 18, NULL),
(259, 4, 93, 0, 19, NULL),
(260, 4, 94, 0, 19, NULL),
(261, 4, 77, 0, 19, NULL),
(262, 4, 78, 0, 19, NULL),
(263, 4, 104, 0, 19, NULL),
(264, 4, 105, 0, 19, NULL),
(265, 4, 93, 0, 20, NULL),
(266, 4, 94, 0, 20, NULL),
(267, 4, 77, 0, 20, NULL),
(268, 4, 78, 0, 20, NULL),
(269, 4, 104, 0, 20, NULL),
(270, 4, 105, 0, 20, NULL),
(271, 4, 93, 0, 21, NULL),
(272, 4, 94, 0, 21, NULL),
(273, 4, 77, 0, 21, NULL),
(274, 4, 78, 0, 21, NULL),
(275, 4, 104, 0, 21, NULL),
(276, 4, 105, 0, 21, NULL),
(277, 4, 93, 0, 22, NULL),
(278, 4, 94, 0, 22, NULL),
(279, 4, 77, 0, 22, NULL),
(280, 4, 78, 0, 22, NULL),
(281, 4, 104, 0, 22, NULL),
(282, 4, 105, 0, 22, NULL),
(283, 4, 93, 0, 23, NULL),
(284, 4, 94, 0, 23, NULL),
(285, 4, 77, 0, 23, NULL),
(286, 4, 78, 0, 23, NULL),
(287, 4, 104, 0, 23, NULL),
(288, 4, 105, 0, 23, NULL),
(289, 4, 93, 0, 24, NULL),
(290, 4, 94, 0, 24, NULL),
(291, 4, 77, 0, 24, NULL),
(292, 4, 78, 0, 24, NULL),
(293, 4, 104, 0, 24, NULL),
(294, 4, 105, 0, 24, NULL),
(295, 4, 93, 0, 25, NULL),
(296, 4, 94, 0, 25, NULL),
(297, 4, 77, 0, 25, NULL),
(298, 4, 78, 0, 25, NULL),
(299, 4, 104, 0, 25, NULL),
(300, 4, 105, 0, 25, NULL),
(301, 4, 93, 0, 26, NULL),
(302, 4, 94, 0, 26, NULL),
(303, 4, 77, 0, 26, NULL),
(304, 4, 78, 0, 26, NULL),
(305, 4, 104, 0, 26, NULL),
(306, 4, 105, 0, 26, NULL),
(367, 4, 93, 0, 27, NULL),
(368, 4, 94, 0, 27, NULL),
(369, 4, 77, 0, 27, NULL),
(370, 4, 78, 0, 27, NULL),
(371, 4, 104, 0, 27, NULL),
(372, 4, 105, 0, 27, NULL),
(373, 4, 93, 0, 28, NULL),
(374, 4, 94, 0, 28, NULL),
(375, 4, 77, 0, 28, NULL),
(376, 4, 78, 0, 28, NULL),
(377, 4, 104, 0, 28, NULL),
(378, 4, 105, 0, 28, NULL),
(379, 4, 93, 0, 29, NULL),
(380, 4, 94, 0, 29, NULL),
(381, 4, 77, 0, 29, NULL),
(382, 4, 78, 0, 29, NULL),
(383, 4, 104, 0, 29, NULL),
(384, 4, 105, 0, 29, NULL),
(385, 4, 93, 0, 30, NULL),
(386, 4, 94, 0, 30, NULL),
(387, 4, 77, 0, 30, NULL),
(388, 4, 78, 0, 30, NULL),
(389, 4, 104, 0, 30, NULL),
(390, 4, 105, 0, 30, NULL),
(391, 4, 93, 0, 31, NULL),
(392, 4, 94, 0, 31, NULL),
(393, 4, 77, 0, 31, NULL),
(394, 4, 78, 0, 31, NULL),
(395, 4, 104, 0, 31, NULL),
(396, 4, 105, 0, 31, NULL),
(445, 4, 93, 0, 32, NULL),
(446, 4, 94, 0, 32, NULL),
(447, 4, 77, 0, 32, NULL),
(448, 4, 78, 0, 32, NULL),
(449, 4, 104, 0, 32, NULL),
(450, 4, 105, 0, 32, NULL),
(451, 4, 93, 0, 33, NULL),
(452, 4, 94, 0, 33, NULL),
(453, 4, 77, 0, 33, NULL),
(454, 4, 78, 0, 33, NULL),
(455, 4, 104, 0, 33, NULL),
(456, 4, 105, 0, 33, NULL),
(457, 4, 93, 0, 34, NULL),
(458, 4, 94, 0, 34, NULL),
(459, 4, 77, 0, 34, NULL),
(460, 4, 78, 0, 34, NULL),
(461, 4, 104, 0, 34, NULL),
(462, 4, 105, 0, 34, NULL),
(463, 4, 93, 0, 35, NULL),
(464, 4, 94, 0, 35, NULL),
(465, 4, 77, 0, 35, NULL),
(466, 4, 78, 0, 35, NULL),
(467, 4, 104, 0, 35, NULL),
(468, 4, 105, 0, 35, NULL),
(469, 4, 93, 0, 36, NULL),
(470, 4, 94, 0, 36, NULL),
(471, 4, 77, 0, 36, NULL),
(472, 4, 78, 0, 36, NULL),
(473, 4, 104, 0, 36, NULL),
(474, 4, 105, 0, 36, NULL),
(523, 4, 93, 0, 37, NULL),
(524, 4, 94, 0, 37, NULL),
(525, 4, 77, 0, 37, NULL),
(526, 4, 78, 0, 37, NULL),
(527, 4, 104, 0, 37, NULL),
(528, 4, 105, 0, 37, NULL),
(529, 4, 77, 0, 38, NULL),
(530, 4, 78, 0, 38, NULL),
(531, 4, 93, 0, 38, NULL),
(532, 4, 94, 0, 38, NULL),
(533, 4, 104, 0, 38, NULL),
(534, 4, 105, 0, 38, NULL),
(541, 4, 93, 0, 39, NULL),
(542, 4, 94, 0, 39, NULL),
(543, 4, 77, 0, 39, NULL),
(544, 4, 78, 0, 39, NULL),
(545, 4, 104, 0, 39, NULL),
(546, 4, 105, 0, 39, NULL),
(547, 4, 93, 0, 40, NULL),
(548, 4, 94, 0, 40, NULL),
(549, 4, 77, 0, 40, NULL),
(550, 4, 78, 0, 40, NULL),
(551, 4, 104, 0, 40, NULL),
(552, 4, 105, 0, 40, NULL),
(553, 4, 93, 0, 41, NULL),
(554, 4, 94, 0, 41, NULL),
(555, 4, 77, 0, 41, NULL),
(556, 4, 78, 0, 41, NULL),
(557, 4, 104, 0, 41, NULL),
(558, 4, 105, 0, 41, NULL),
(559, 4, 93, 0, 42, NULL),
(560, 4, 94, 0, 42, NULL),
(561, 4, 104, 0, 42, NULL),
(562, 4, 105, 0, 42, NULL),
(579, 4, 93, 0, 44, NULL),
(580, 4, 94, 0, 44, NULL),
(581, 4, 77, 0, 44, NULL),
(582, 4, 78, 0, 44, NULL),
(583, 4, 104, 0, 44, NULL),
(584, 4, 105, 0, 44, NULL),
(585, 4, 77, 0, 45, NULL),
(586, 4, 78, 0, 45, NULL),
(587, 4, 93, 0, 45, NULL),
(588, 4, 94, 0, 45, NULL),
(589, 4, 104, 0, 45, NULL),
(590, 4, 105, 0, 45, NULL),
(615, 4, 93, 0, 46, NULL),
(616, 4, 94, 0, 46, NULL),
(617, 4, 77, 0, 46, NULL),
(618, 4, 78, 0, 46, NULL),
(619, 4, 104, 0, 46, NULL),
(620, 4, 105, 0, 46, NULL),
(627, 4, 93, 0, 47, NULL),
(628, 4, 94, 0, 47, NULL),
(629, 4, 77, 0, 47, NULL),
(630, 4, 78, 0, 47, NULL),
(631, 4, 104, 0, 47, NULL),
(632, 4, 105, 0, 47, NULL),
(633, 4, 93, 0, 48, NULL),
(634, 4, 94, 0, 48, NULL),
(635, 4, 77, 0, 48, NULL),
(636, 4, 78, 0, 48, NULL),
(637, 4, 104, 0, 48, NULL),
(638, 4, 105, 0, 48, NULL),
(639, 4, 93, 0, 49, NULL),
(640, 4, 94, 0, 49, NULL),
(641, 4, 77, 0, 49, NULL),
(642, 4, 78, 0, 49, NULL),
(643, 4, 104, 0, 49, NULL),
(644, 4, 105, 0, 49, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_decimal` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` decimal(12,4) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Decimal Attribute Backend Table' AUTO_INCREMENT=351 ;

INSERT INTO `#__catalog_product_entity_decimal` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(25, 4, 75, 0, 7, '599.0000'),
(26, 4, 76, 0, 7, NULL),
(27, 4, 120, 0, 7, NULL),
(28, 4, 80, 0, 8, '1.0000'),
(29, 4, 75, 0, 8, '624.0000'),
(30, 4, 76, 0, 8, NULL),
(31, 4, 120, 0, 8, NULL),
(32, 4, 80, 0, 9, '1.0000'),
(33, 4, 75, 0, 9, '668.9000'),
(34, 4, 76, 0, 9, '659.0000'),
(35, 4, 120, 0, 9, NULL),
(36, 4, 80, 0, 10, '1.0000'),
(37, 4, 75, 0, 10, '609.0000'),
(38, 4, 76, 0, 10, '521.0000'),
(39, 4, 120, 0, 10, NULL),
(40, 4, 80, 0, 11, '1.0000'),
(41, 4, 75, 0, 11, '614.0000'),
(42, 4, 76, 0, 11, '599.0000'),
(43, 4, 120, 0, 11, NULL),
(44, 4, 80, 0, 12, '1.0000'),
(45, 4, 75, 0, 12, '599.0000'),
(46, 4, 76, 0, 12, '499.0000'),
(47, 4, 120, 0, 12, NULL),
(96, 4, 75, 0, 13, '349.0000'),
(97, 4, 76, 0, 13, NULL),
(98, 4, 120, 0, 13, NULL),
(102, 4, 80, 0, 14, '1.0000'),
(103, 4, 75, 0, 14, '373.4300'),
(104, 4, 76, 0, 14, NULL),
(105, 4, 120, 0, 14, NULL),
(106, 4, 80, 0, 15, '1.0000'),
(107, 4, 75, 0, 15, '366.4500'),
(108, 4, 76, 0, 15, NULL),
(109, 4, 120, 0, 15, NULL),
(110, 4, 80, 0, 16, '1.0000'),
(111, 4, 75, 0, 16, '373.4300'),
(112, 4, 76, 0, 16, NULL),
(113, 4, 120, 0, 16, NULL),
(114, 4, 80, 0, 17, '1.0000'),
(115, 4, 75, 0, 17, '367.4900'),
(116, 4, 76, 0, 17, NULL),
(117, 4, 120, 0, 17, NULL),
(118, 4, 80, 0, 18, '1.0000'),
(119, 4, 75, 0, 18, '352.4900'),
(120, 4, 76, 0, 18, NULL),
(121, 4, 120, 0, 18, NULL),
(146, 4, 75, 0, 19, '399.0000'),
(147, 4, 76, 0, 19, NULL),
(148, 4, 120, 0, 19, NULL),
(149, 4, 75, 0, 20, '99.0000'),
(150, 4, 76, 0, 20, NULL),
(151, 4, 120, 0, 20, NULL),
(152, 4, 75, 0, 21, '179.0000'),
(153, 4, 76, 0, 21, NULL),
(154, 4, 120, 0, 21, NULL),
(155, 4, 80, 0, 22, '1.0000'),
(156, 4, 75, 0, 22, '410.9700'),
(157, 4, 76, 0, 22, NULL),
(158, 4, 120, 0, 22, NULL),
(159, 4, 80, 0, 23, '1.0000'),
(160, 4, 75, 0, 23, '406.0000'),
(161, 4, 76, 0, 23, NULL),
(162, 4, 120, 0, 23, NULL),
(163, 4, 80, 0, 24, '1.0000'),
(164, 4, 75, 0, 24, '442.8900'),
(165, 4, 76, 0, 24, NULL),
(166, 4, 120, 0, 24, NULL),
(167, 4, 80, 0, 25, '1.0000'),
(168, 4, 75, 0, 25, '412.0000'),
(169, 4, 76, 0, 25, NULL),
(170, 4, 120, 0, 25, NULL),
(171, 4, 80, 0, 26, '1.0000'),
(172, 4, 75, 0, 26, '417.0000'),
(173, 4, 76, 0, 26, NULL),
(174, 4, 120, 0, 26, NULL),
(205, 4, 80, 0, 27, '1.0000'),
(206, 4, 75, 0, 27, '100.9800'),
(207, 4, 76, 0, 27, NULL),
(208, 4, 120, 0, 27, NULL),
(209, 4, 80, 0, 28, '1.0000'),
(210, 4, 75, 0, 28, '100.9800'),
(211, 4, 76, 0, 28, NULL),
(212, 4, 120, 0, 28, NULL),
(213, 4, 80, 0, 29, '1.0000'),
(214, 4, 75, 0, 29, '100.9800'),
(215, 4, 76, 0, 29, NULL),
(216, 4, 120, 0, 29, NULL),
(217, 4, 80, 0, 30, '1.0000'),
(218, 4, 75, 0, 30, '100.9800'),
(219, 4, 76, 0, 30, NULL),
(220, 4, 120, 0, 30, NULL),
(221, 4, 80, 0, 31, '1.0000'),
(222, 4, 75, 0, 31, '109.0000'),
(223, 4, 76, 0, 31, NULL),
(224, 4, 120, 0, 31, NULL),
(249, 4, 80, 0, 32, '1.0000'),
(250, 4, 75, 0, 32, '189.0000'),
(251, 4, 76, 0, 32, NULL),
(252, 4, 120, 0, 32, NULL),
(253, 4, 80, 0, 33, '1.0000'),
(254, 4, 75, 0, 33, '199.0000'),
(255, 4, 76, 0, 33, NULL),
(256, 4, 120, 0, 33, NULL),
(257, 4, 80, 0, 34, '1.0000'),
(258, 4, 75, 0, 34, '209.0000'),
(259, 4, 76, 0, 34, NULL),
(260, 4, 120, 0, 34, NULL),
(261, 4, 80, 0, 35, '1.0000'),
(262, 4, 75, 0, 35, '189.0000'),
(263, 4, 76, 0, 35, NULL),
(264, 4, 120, 0, 35, NULL),
(265, 4, 80, 0, 36, '1.0000'),
(266, 4, 75, 0, 36, '194.0000'),
(267, 4, 76, 0, 36, NULL),
(268, 4, 120, 0, 36, NULL),
(293, 4, 80, 0, 37, '1.0000'),
(294, 4, 75, 0, 37, '68.0000'),
(295, 4, 76, 0, 37, NULL),
(296, 4, 120, 0, 37, NULL),
(297, 4, 75, 0, 38, '76.0000'),
(298, 4, 76, 0, 38, NULL),
(299, 4, 80, 0, 38, '1.0000'),
(300, 4, 120, 0, 38, NULL),
(304, 4, 80, 0, 39, '1.0000'),
(305, 4, 75, 0, 39, '79.0000'),
(306, 4, 76, 0, 39, NULL),
(307, 4, 120, 0, 39, NULL),
(308, 4, 80, 0, 40, '1.0000'),
(309, 4, 75, 0, 40, '119.0000'),
(310, 4, 76, 0, 40, NULL),
(311, 4, 120, 0, 40, NULL),
(312, 4, 80, 0, 41, '1.0000'),
(313, 4, 75, 0, 41, '113.0000'),
(314, 4, 76, 0, 41, NULL),
(315, 4, 120, 0, 41, NULL),
(324, 4, 76, 0, 44, NULL),
(325, 4, 76, 0, 45, NULL),
(326, 4, 80, 0, 45, '1.0000'),
(331, 4, 75, 0, 46, '1102.0000'),
(332, 4, 76, 0, 46, NULL),
(333, 4, 79, 0, 46, NULL),
(334, 4, 120, 0, 46, NULL),
(339, 4, 80, 0, 47, '1.0000'),
(340, 4, 75, 0, 47, '68.0000'),
(341, 4, 76, 0, 47, NULL),
(342, 4, 120, 0, 47, NULL),
(343, 4, 80, 0, 48, '1.0000'),
(344, 4, 75, 0, 48, '212.0000'),
(345, 4, 76, 0, 48, NULL),
(346, 4, 120, 0, 48, NULL),
(347, 4, 75, 0, 49, '95.0000'),
(348, 4, 76, 0, 49, NULL),
(349, 4, 79, 0, 49, NULL),
(350, 4, 120, 0, 49, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_gallery` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `position` int(11) NOT NULL DEFAULT '0' COMMENT 'Position',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Gallery Attribute Backend Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_group_price` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `all_groups` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Applicable To All Customer Groups',
  `customer_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Group Price Attribute Backend Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_int` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` int(11) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Integer Attribute Backend Table' AUTO_INCREMENT=316 ;

INSERT INTO `#__catalog_product_entity_int` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(37, 4, 96, 0, 7, 1),
(38, 4, 102, 0, 7, 4),
(39, 4, 121, 0, 7, 0),
(40, 4, 92, 0, 7, NULL),
(41, 4, 81, 0, 7, NULL),
(42, 4, 96, 0, 8, 1),
(43, 4, 102, 0, 8, 4),
(44, 4, 92, 0, 8, 3),
(45, 4, 81, 0, 8, 10),
(46, 4, 121, 0, 8, 0),
(47, 4, 100, 0, 8, 0),
(48, 4, 96, 0, 9, 1),
(49, 4, 102, 0, 9, 4),
(50, 4, 92, 0, 9, 4),
(51, 4, 81, 0, 9, 10),
(52, 4, 121, 0, 9, 0),
(53, 4, 100, 0, 9, 0),
(54, 4, 96, 0, 10, 1),
(55, 4, 102, 0, 10, 4),
(56, 4, 92, 0, 10, 6),
(57, 4, 81, 0, 10, 10),
(58, 4, 121, 0, 10, 0),
(59, 4, 100, 0, 10, 0),
(60, 4, 96, 0, 11, 1),
(61, 4, 102, 0, 11, 4),
(62, 4, 92, 0, 11, 5),
(63, 4, 81, 0, 11, 9),
(64, 4, 121, 0, 11, 0),
(65, 4, 100, 0, 11, 0),
(66, 4, 96, 0, 12, 1),
(67, 4, 102, 0, 12, 4),
(68, 4, 92, 0, 12, 8),
(69, 4, 81, 0, 12, 9),
(70, 4, 121, 0, 12, 0),
(71, 4, 100, 0, 12, 0),
(78, 4, 96, 0, 13, 1),
(79, 4, 102, 0, 13, 4),
(80, 4, 121, 0, 13, 0),
(81, 4, 92, 0, 13, NULL),
(82, 4, 81, 0, 13, NULL),
(83, 4, 96, 0, 14, 1),
(84, 4, 102, 0, 14, 4),
(85, 4, 92, 0, 14, 3),
(86, 4, 81, 0, 14, 15),
(87, 4, 121, 0, 14, 0),
(88, 4, 100, 0, 14, 0),
(89, 4, 96, 0, 15, 1),
(90, 4, 102, 0, 15, 4),
(91, 4, 92, 0, 15, 4),
(92, 4, 81, 0, 15, 15),
(93, 4, 121, 0, 15, 0),
(94, 4, 100, 0, 15, 0),
(95, 4, 96, 0, 16, 1),
(96, 4, 102, 0, 16, 4),
(97, 4, 92, 0, 16, 6),
(98, 4, 81, 0, 16, 12),
(99, 4, 121, 0, 16, 0),
(100, 4, 100, 0, 16, 0),
(101, 4, 96, 0, 17, 1),
(102, 4, 102, 0, 17, 4),
(103, 4, 92, 0, 17, 5),
(104, 4, 81, 0, 17, 13),
(105, 4, 121, 0, 17, 0),
(106, 4, 100, 0, 17, 0),
(107, 4, 96, 0, 18, 1),
(108, 4, 102, 0, 18, 4),
(109, 4, 92, 0, 18, 8),
(110, 4, 81, 0, 18, 13),
(111, 4, 121, 0, 18, 0),
(112, 4, 100, 0, 18, 0),
(118, 4, 96, 0, 19, 1),
(119, 4, 102, 0, 19, 4),
(120, 4, 121, 0, 19, 0),
(121, 4, 92, 0, 19, NULL),
(122, 4, 81, 0, 19, NULL),
(123, 4, 96, 0, 20, 1),
(124, 4, 102, 0, 20, 4),
(125, 4, 81, 0, 20, 16),
(126, 4, 121, 0, 20, 0),
(127, 4, 92, 0, 20, NULL),
(128, 4, 96, 0, 21, 1),
(129, 4, 102, 0, 21, 4),
(130, 4, 92, 0, 21, 5),
(131, 4, 121, 0, 21, 0),
(132, 4, 81, 0, 21, NULL),
(133, 4, 96, 0, 22, 1),
(134, 4, 102, 0, 22, 4),
(135, 4, 92, 0, 22, 8),
(136, 4, 81, 0, 22, 14),
(137, 4, 121, 0, 22, 0),
(138, 4, 100, 0, 22, 0),
(139, 4, 96, 0, 23, 1),
(140, 4, 102, 0, 23, 4),
(141, 4, 92, 0, 23, 3),
(142, 4, 81, 0, 23, 11),
(143, 4, 121, 0, 23, 0),
(144, 4, 100, 0, 23, 0),
(145, 4, 96, 0, 24, 1),
(146, 4, 102, 0, 24, 4),
(147, 4, 92, 0, 24, 4),
(148, 4, 81, 0, 24, 16),
(149, 4, 121, 0, 24, 0),
(150, 4, 100, 0, 24, 0),
(151, 4, 96, 0, 25, 1),
(152, 4, 102, 0, 25, 4),
(153, 4, 92, 0, 25, 6),
(154, 4, 81, 0, 25, 11),
(155, 4, 121, 0, 25, 0),
(156, 4, 100, 0, 25, 0),
(157, 4, 96, 0, 26, 1),
(158, 4, 102, 0, 26, 4),
(159, 4, 92, 0, 26, 5),
(160, 4, 81, 0, 26, 11),
(161, 4, 121, 0, 26, 0),
(162, 4, 100, 0, 26, 0),
(168, 4, 96, 0, 27, 1),
(169, 4, 102, 0, 27, 4),
(170, 4, 92, 0, 27, 3),
(171, 4, 81, 0, 27, 16),
(172, 4, 121, 0, 27, 0),
(173, 4, 100, 0, 27, 0),
(174, 4, 96, 0, 28, 1),
(175, 4, 102, 0, 28, 4),
(176, 4, 92, 0, 28, 8),
(177, 4, 81, 0, 28, 16),
(178, 4, 121, 0, 28, 0),
(179, 4, 100, 0, 28, 0),
(180, 4, 96, 0, 29, 1),
(181, 4, 102, 0, 29, 4),
(182, 4, 92, 0, 29, 5),
(183, 4, 81, 0, 29, 16),
(184, 4, 121, 0, 29, 0),
(185, 4, 100, 0, 29, 0),
(186, 4, 96, 0, 30, 1),
(187, 4, 102, 0, 30, 4),
(188, 4, 92, 0, 30, 6),
(189, 4, 81, 0, 30, 16),
(190, 4, 121, 0, 30, 0),
(191, 4, 100, 0, 30, 0),
(192, 4, 96, 0, 31, 1),
(193, 4, 102, 0, 31, 4),
(194, 4, 92, 0, 31, 4),
(195, 4, 81, 0, 31, 16),
(196, 4, 121, 0, 31, 0),
(197, 4, 100, 0, 31, 0),
(203, 4, 96, 0, 32, 1),
(204, 4, 102, 0, 32, 4),
(205, 4, 92, 0, 32, 5),
(206, 4, 81, 0, 32, 10),
(207, 4, 121, 0, 32, 0),
(208, 4, 100, 0, 32, 0),
(209, 4, 96, 0, 33, 1),
(210, 4, 102, 0, 33, 4),
(211, 4, 92, 0, 33, 5),
(212, 4, 81, 0, 33, 9),
(213, 4, 121, 0, 33, 0),
(214, 4, 100, 0, 33, 0),
(215, 4, 96, 0, 34, 1),
(216, 4, 102, 0, 34, 4),
(217, 4, 92, 0, 34, 5),
(218, 4, 81, 0, 34, 15),
(219, 4, 121, 0, 34, 0),
(220, 4, 100, 0, 34, 0),
(221, 4, 96, 0, 35, 1),
(222, 4, 102, 0, 35, 4),
(223, 4, 92, 0, 35, 5),
(224, 4, 81, 0, 35, 14),
(225, 4, 121, 0, 35, 0),
(226, 4, 100, 0, 35, 0),
(227, 4, 96, 0, 36, 1),
(228, 4, 102, 0, 36, 4),
(229, 4, 92, 0, 36, 5),
(230, 4, 81, 0, 36, 16),
(231, 4, 121, 0, 36, 0),
(232, 4, 100, 0, 36, 0),
(238, 4, 96, 0, 37, 1),
(239, 4, 102, 0, 37, 4),
(240, 4, 92, 0, 37, 4),
(241, 4, 81, 0, 37, NULL),
(242, 4, 121, 0, 37, 0),
(243, 4, 100, 0, 37, 0),
(244, 4, 81, 0, 38, NULL),
(245, 4, 92, 0, 38, 3),
(246, 4, 96, 0, 38, 1),
(247, 4, 100, 0, 38, 0),
(248, 4, 102, 0, 38, 4),
(249, 4, 121, 0, 38, 0),
(252, 4, 96, 0, 39, 1),
(253, 4, 102, 0, 39, 4),
(254, 4, 92, 0, 39, 6),
(255, 4, 81, 0, 39, 16),
(256, 4, 121, 0, 39, 0),
(257, 4, 100, 0, 39, 0),
(258, 4, 96, 0, 40, 1),
(259, 4, 102, 0, 40, 4),
(260, 4, 92, 0, 40, 8),
(261, 4, 81, 0, 40, 13),
(262, 4, 121, 0, 40, 0),
(263, 4, 100, 0, 40, 0),
(264, 4, 96, 0, 41, 1),
(265, 4, 102, 0, 41, 4),
(266, 4, 92, 0, 41, 5),
(267, 4, 81, 0, 41, 11),
(268, 4, 121, 0, 41, 0),
(269, 4, 100, 0, 41, 0),
(270, 4, 96, 0, 42, 1),
(271, 4, 102, 0, 42, 4),
(276, 4, 124, 0, 44, 0),
(277, 4, 125, 0, 44, 0),
(278, 4, 96, 0, 44, 1),
(279, 4, 102, 0, 44, 4),
(280, 4, 123, 0, 44, 0),
(281, 4, 126, 0, 44, 0),
(282, 4, 127, 0, 44, 0),
(283, 4, 124, 0, 45, 1),
(284, 4, 125, 0, 45, 1),
(285, 4, 96, 0, 45, 1),
(286, 4, 102, 0, 45, 4),
(287, 4, 123, 0, 45, 0),
(288, 4, 126, 0, 45, 1),
(289, 4, 127, 0, 45, 0),
(294, 4, 96, 0, 46, 1),
(295, 4, 102, 0, 46, 4),
(296, 4, 121, 0, 46, 0),
(297, 4, 128, 0, 46, 1),
(298, 4, 131, 0, 46, 1),
(300, 4, 96, 0, 47, 1),
(301, 4, 102, 0, 47, 4),
(302, 4, 92, 0, 47, NULL),
(303, 4, 81, 0, 47, NULL),
(304, 4, 121, 0, 47, 0),
(305, 4, 100, 0, 47, 0),
(306, 4, 96, 0, 48, 1),
(307, 4, 102, 0, 48, 4),
(308, 4, 92, 0, 48, 3),
(309, 4, 81, 0, 48, 9),
(310, 4, 121, 0, 48, 0),
(311, 4, 100, 0, 48, 0),
(312, 4, 96, 0, 49, 1),
(313, 4, 102, 0, 49, 4),
(314, 4, 121, 0, 49, 0),
(315, 4, 100, 0, 49, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_media_gallery` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Media Gallery Attribute Backend Table' AUTO_INCREMENT=203 ;

INSERT INTO `#__catalog_product_entity_media_gallery` (`value_id`, `attribute_id`, `entity_id`, `value`) VALUES
(17, 88, 8, '/0/0/00cfg01k.jpg'),
(18, 88, 7, '/0/0/00cfg01.jpg'),
(19, 88, 9, '/0/0/00cfg01b.jpg'),
(20, 88, 10, '/0/0/00cfg01g.jpg'),
(21, 88, 11, '/0/0/00cfg01r.jpg'),
(22, 88, 12, '/0/0/00cfg01w.jpg'),
(23, 88, 13, '/0/0/00cfg02.jpg'),
(24, 88, 14, '/0/0/00cfg02k.jpg'),
(25, 88, 15, '/0/0/00cfg02b.jpg'),
(26, 88, 16, '/0/0/00cfg02g.jpg'),
(27, 88, 17, '/0/0/00cfg02r.jpg'),
(28, 88, 18, '/0/0/00cfg02w.jpg'),
(29, 88, 19, '/0/0/00cfg03.jpg'),
(30, 88, 22, '/0/0/00cfg03w.jpg'),
(31, 88, 23, '/0/0/00cfg03k.jpg'),
(32, 88, 24, '/0/0/00cfg03b.jpg'),
(33, 88, 25, '/0/0/00cfg03g.jpg'),
(34, 88, 26, '/0/0/00cfg03r.jpg'),
(36, 88, 20, '/0/0/00cfg04.jpg'),
(37, 88, 27, '/0/0/00cfg04k.jpg'),
(38, 88, 28, '/0/0/00cfg04w.jpg'),
(39, 88, 29, '/0/0/00cfg04r.jpg'),
(40, 88, 31, '/0/0/00cfg04b.jpg'),
(41, 88, 30, '/0/0/00cfg04g.jpg'),
(42, 88, 21, '/0/0/00cfg05.jpg'),
(43, 88, 32, '/0/0/00cfg051.jpg'),
(44, 88, 33, '/0/0/00cfg052.jpg'),
(45, 88, 34, '/0/0/00cfg053.jpg'),
(46, 88, 35, '/0/0/00cfg054.jpg'),
(47, 88, 36, '/0/0/00cfg055.jpg'),
(48, 88, 37, '/0/1/01sim0105.jpg'),
(49, 88, 37, '/0/1/01sim0101.jpg'),
(50, 88, 37, '/0/1/01sim0103.jpg'),
(51, 88, 37, '/0/1/01sim0104.jpg'),
(52, 88, 37, '/0/1/01sim0102.jpg'),
(58, 88, 38, '/0/1/01sim0202.jpg'),
(59, 88, 38, '/0/1/01sim0205.jpg'),
(60, 88, 38, '/0/1/01sim0203.jpg'),
(61, 88, 38, '/0/1/01sim0201.jpg'),
(62, 88, 38, '/0/1/01sim0204.jpg'),
(63, 88, 39, '/0/1/01sim0305.jpg'),
(64, 88, 39, '/0/1/01sim0302.jpg'),
(65, 88, 39, '/0/1/01sim0303.jpg'),
(66, 88, 39, '/0/1/01sim0304.jpg'),
(67, 88, 39, '/0/1/01sim0301.jpg'),
(68, 88, 40, '/0/1/01sim0403.jpg'),
(69, 88, 40, '/0/1/01sim0402.jpg'),
(70, 88, 40, '/0/1/01sim0405.jpg'),
(71, 88, 40, '/0/1/01sim0404.jpg'),
(72, 88, 40, '/0/1/01sim0401.jpg'),
(73, 88, 41, '/0/1/01sim0503.jpg'),
(74, 88, 41, '/0/1/01sim0501.jpg'),
(75, 88, 41, '/0/1/01sim0505.jpg'),
(76, 88, 41, '/0/1/01sim0502.jpg'),
(77, 88, 41, '/0/1/01sim0504.jpg'),
(78, 88, 42, '/0/2/02group0103.jpg'),
(79, 88, 42, '/0/2/02group0101.jpg'),
(80, 88, 42, '/0/2/02group0105.jpg'),
(81, 88, 42, '/0/2/02group0104.jpg'),
(82, 88, 42, '/0/2/02group0102.jpg'),
(88, 88, 44, '/0/4/04bud0102.jpg'),
(89, 88, 44, '/0/4/04bud0104.jpg'),
(90, 88, 44, '/0/4/04bud0105.jpg'),
(91, 88, 44, '/0/4/04bud0103.jpg'),
(92, 88, 44, '/0/4/04bud0101.jpg'),
(93, 88, 45, '/0/4/04bud0205.jpg'),
(94, 88, 45, '/0/4/04bud0201.jpg'),
(95, 88, 45, '/0/4/04bud0203.jpg'),
(96, 88, 45, '/0/4/04bud0202.jpg'),
(97, 88, 45, '/0/4/04bud0204.jpg'),
(98, 88, 46, '/0/5/05down0104.jpg'),
(99, 88, 46, '/0/5/05down0105.jpg'),
(100, 88, 46, '/0/5/05down0102.jpg'),
(101, 88, 46, '/0/5/05down0101.jpg'),
(102, 88, 46, '/0/5/05down0103.jpg'),
(103, 88, 48, '/0/6/06custom0104.jpg'),
(104, 88, 48, '/0/6/06custom0105.jpg'),
(105, 88, 48, '/0/6/06custom0103.jpg'),
(106, 88, 48, '/0/6/06custom0101.jpg'),
(107, 88, 48, '/0/6/06custom0102.jpg'),
(108, 88, 8, '/0/0/00cfg01b_1.jpg'),
(109, 88, 8, '/0/0/00cfg01g_1.jpg'),
(110, 88, 8, '/0/0/00cfg01_1.jpg'),
(111, 88, 9, '/0/0/00cfg02g_1.jpg'),
(112, 88, 9, '/0/0/00cfg02w_1.jpg'),
(113, 88, 9, '/0/0/00cfg02k_1.jpg'),
(114, 88, 9, '/0/0/00cfg02r_1.jpg'),
(115, 88, 10, '/0/0/00cfg02b_1.jpg'),
(116, 88, 10, '/0/0/00cfg02g_2.jpg'),
(117, 88, 10, '/0/0/00cfg02k_2.jpg'),
(118, 88, 12, '/0/0/00cfg02g_3.jpg'),
(119, 88, 12, '/0/0/00cfg02g_2_1.jpg'),
(120, 88, 12, '/0/0/00cfg02g_1_1.jpg'),
(121, 88, 12, '/0/0/00cfg02_1.jpg'),
(122, 88, 12, '/0/0/00cfg02k_3.jpg'),
(123, 88, 12, '/0/0/00cfg02b_1_1.jpg'),
(124, 88, 12, '/0/0/00cfg02b_2.jpg'),
(132, 88, 11, '/0/0/00cfg01_2.jpg'),
(133, 88, 11, '/0/0/00cfg01r_1.jpg'),
(138, 88, 7, '/0/0/00cfg01k_1.jpg'),
(139, 88, 7, '/0/0/00cfg01r_2.jpg'),
(140, 88, 7, '/0/0/00cfg01b_2.jpg'),
(141, 88, 7, '/0/0/00cfg01g_2.jpg'),
(142, 88, 14, '/0/0/00cfg02b_3.jpg'),
(143, 88, 14, '/0/0/00cfg01w_1.jpg'),
(144, 88, 14, '/0/0/00cfg03k_1.jpg'),
(145, 88, 15, '/0/0/00cfg04w_1.jpg'),
(146, 88, 15, '/0/0/00cfg05_1.jpg'),
(147, 88, 15, '/0/0/00cfg02b_1_2.jpg'),
(148, 88, 16, '/0/0/00cfg04g_1.jpg'),
(149, 88, 16, '/0/0/00cfg04b_1.jpg'),
(150, 88, 17, '/0/0/00cfg04w_2.jpg'),
(151, 88, 17, '/0/0/00cfg04k_1.jpg'),
(152, 88, 17, '/0/0/00cfg04r_1.jpg'),
(153, 88, 17, '/0/0/00cfg02b_4.jpg'),
(154, 88, 18, '/0/0/00cfg01w_2.jpg'),
(155, 88, 18, '/0/0/00cfg02_2.jpg'),
(156, 88, 18, '/0/0/00cfg01k_2.jpg'),
(157, 88, 13, '/0/0/00cfg03g_1.jpg'),
(158, 88, 13, '/0/0/00cfg03_1.jpg'),
(159, 88, 13, '/0/0/00cfg03w_1.jpg'),
(160, 88, 13, '/0/0/00cfg03r_1.jpg'),
(161, 88, 23, '/0/0/00cfg01r_1_1.jpg'),
(162, 88, 23, '/0/0/00cfg02r_2.jpg'),
(163, 88, 24, '/0/0/00cfg04_1.jpg'),
(164, 88, 24, '/0/0/00cfg03b_1.jpg'),
(165, 88, 24, '/0/0/00cfg03w_2.jpg'),
(166, 88, 25, '/0/0/00cfg01r_1_2.jpg'),
(167, 88, 25, '/0/0/00cfg01b_3.jpg'),
(168, 88, 26, '/0/0/00cfg03k_2.jpg'),
(169, 88, 26, '/0/0/00cfg04b_2.jpg'),
(170, 88, 19, '/0/0/00cfg05_2.jpg'),
(171, 88, 19, '/0/0/00cfg04w_3.jpg'),
(172, 88, 19, '/0/0/00cfg01r_3.jpg'),
(173, 88, 19, '/0/0/00cfg04k_2.jpg'),
(174, 88, 22, '/0/0/00cfg01w_3.jpg'),
(175, 88, 27, '/0/0/00cfg01g_3.jpg'),
(176, 88, 28, '/0/0/00cfg01w_1_1.jpg'),
(177, 88, 29, '/0/0/00cfg052_1.jpg'),
(178, 88, 30, '/0/0/00cfg03w_1_1.jpg'),
(179, 88, 31, '/0/0/00cfg03w_1_2.jpg'),
(180, 88, 20, '/0/0/00cfg02w_2.jpg'),
(181, 88, 20, '/0/0/00cfg04b_3.jpg'),
(182, 88, 20, '/0/0/00cfg01k_3.jpg'),
(183, 88, 20, '/0/0/00cfg03w_3.jpg'),
(184, 88, 20, '/0/0/00cfg01w_4.jpg'),
(185, 88, 32, '/0/0/00cfg04b_4.jpg'),
(186, 88, 33, '/0/0/00cfg01_3.jpg'),
(187, 88, 34, '/0/0/00cfg051_1.jpg'),
(188, 88, 36, '/0/0/00cfg03b_2.jpg'),
(189, 88, 21, '/0/0/00cfg04w_1_1.jpg'),
(190, 88, 21, '/0/0/00cfg053_1.jpg'),
(191, 88, 21, '/0/0/00cfg055_1.jpg'),
(192, 88, 35, '/0/0/00cfg03g_2.jpg'),
(193, 88, 35, '/0/0/00cfg01k_4.jpg'),
(194, 88, 47, '/0/0/00cfg01b_4.jpg'),
(195, 88, 47, '/0/0/00cfg03r_2.jpg'),
(196, 88, 47, '/0/0/00cfg01r_4.jpg'),
(197, 88, 47, '/0/0/00cfg04_2.jpg'),
(198, 88, 49, '/2/_/2.jpg'),
(199, 88, 49, '/1/_/1.jpg'),
(200, 88, 49, '/3/_/3.jpg'),
(201, 88, 49, '/5/_/5.jpg'),
(202, 88, 49, '/4/_/4.jpg');

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_media_gallery_value` (
  `value_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Value ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label',
  `position` int(10) unsigned DEFAULT NULL COMMENT 'Position',
  `disabled` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Disabled'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Media Gallery Attribute Value Table';

INSERT INTO `#__catalog_product_entity_media_gallery_value` (`value_id`, `store_id`, `label`, `position`, `disabled`) VALUES
(17, 0, NULL, 1, 0),
(18, 0, NULL, 1, 0),
(19, 0, NULL, 1, 0),
(20, 0, NULL, 1, 0),
(21, 0, NULL, 1, 0),
(22, 0, NULL, 1, 0),
(23, 0, NULL, 1, 0),
(24, 0, NULL, 1, 0),
(25, 0, NULL, 1, 0),
(26, 0, NULL, 1, 0),
(27, 0, NULL, 1, 0),
(28, 0, NULL, 1, 0),
(29, 0, NULL, 1, 0),
(30, 0, NULL, 1, 0),
(31, 0, NULL, 1, 0),
(32, 0, NULL, 1, 0),
(33, 0, NULL, 1, 0),
(34, 0, NULL, 1, 0),
(36, 0, NULL, 1, 0),
(37, 0, NULL, 1, 0),
(38, 0, NULL, 1, 0),
(39, 0, NULL, 1, 0),
(40, 0, NULL, 1, 0),
(41, 0, NULL, 1, 0),
(42, 0, NULL, 1, 0),
(43, 0, NULL, 1, 0),
(44, 0, NULL, 1, 0),
(45, 0, NULL, 1, 0),
(46, 0, NULL, 1, 0),
(47, 0, NULL, 1, 0),
(48, 0, NULL, 1, 0),
(49, 0, NULL, 2, 0),
(50, 0, NULL, 3, 0),
(51, 0, NULL, 4, 0),
(52, 0, NULL, 5, 0),
(58, 0, NULL, 6, 0),
(59, 0, NULL, 7, 0),
(60, 0, NULL, 8, 0),
(61, 0, NULL, 9, 0),
(62, 0, NULL, 10, 0),
(63, 0, NULL, 1, 0),
(64, 0, NULL, 2, 0),
(65, 0, NULL, 3, 0),
(66, 0, NULL, 4, 0),
(67, 0, NULL, 5, 0),
(68, 0, NULL, 1, 0),
(69, 0, NULL, 2, 0),
(70, 0, NULL, 3, 0),
(71, 0, NULL, 4, 0),
(72, 0, NULL, 5, 0),
(73, 0, NULL, 1, 0),
(74, 0, NULL, 2, 0),
(75, 0, NULL, 3, 0),
(76, 0, NULL, 4, 0),
(77, 0, NULL, 5, 0),
(78, 0, NULL, 1, 0),
(79, 0, NULL, 2, 0),
(80, 0, NULL, 3, 0),
(81, 0, NULL, 4, 0),
(82, 0, NULL, 5, 0),
(88, 0, NULL, 1, 0),
(89, 0, NULL, 2, 0),
(90, 0, NULL, 3, 0),
(91, 0, NULL, 4, 0),
(92, 0, NULL, 5, 0),
(93, 0, NULL, 1, 0),
(94, 0, NULL, 2, 0),
(95, 0, NULL, 3, 0),
(96, 0, NULL, 4, 0),
(97, 0, NULL, 5, 0),
(98, 0, NULL, 1, 0),
(99, 0, NULL, 2, 0),
(100, 0, NULL, 3, 0),
(101, 0, NULL, 4, 0),
(102, 0, NULL, 5, 0),
(103, 0, NULL, 1, 0),
(103, 1, NULL, 1, 0),
(103, 2, NULL, 1, 0),
(104, 0, NULL, 2, 0),
(104, 1, NULL, 2, 0),
(104, 2, NULL, 2, 0),
(105, 0, NULL, 3, 0),
(105, 1, NULL, 3, 0),
(105, 2, NULL, 3, 0),
(106, 0, NULL, 4, 0),
(106, 1, NULL, 4, 0),
(106, 2, NULL, 4, 0),
(107, 0, NULL, 5, 0),
(107, 1, NULL, 5, 0),
(107, 2, NULL, 5, 0),
(108, 0, NULL, 2, 0),
(109, 0, NULL, 3, 0),
(110, 0, NULL, 4, 0),
(111, 0, NULL, 2, 0),
(112, 0, NULL, 3, 0),
(113, 0, NULL, 4, 0),
(114, 0, NULL, 5, 0),
(115, 0, NULL, 2, 0),
(116, 0, NULL, 3, 0),
(117, 0, NULL, 4, 0),
(118, 0, NULL, 2, 0),
(119, 0, NULL, 3, 0),
(120, 0, NULL, 4, 0),
(121, 0, NULL, 5, 0),
(122, 0, NULL, 6, 0),
(123, 0, NULL, 7, 0),
(124, 0, NULL, 8, 0),
(132, 0, NULL, 2, 0),
(133, 0, NULL, 3, 0),
(138, 0, NULL, 2, 0),
(139, 0, NULL, 3, 0),
(140, 0, NULL, 4, 0),
(141, 0, NULL, 5, 0),
(142, 0, NULL, 2, 0),
(143, 0, NULL, 3, 0),
(144, 0, NULL, 4, 0),
(145, 0, NULL, 2, 0),
(146, 0, NULL, 3, 0),
(147, 0, NULL, 4, 0),
(148, 0, NULL, 2, 0),
(149, 0, NULL, 3, 0),
(150, 0, NULL, 2, 0),
(151, 0, NULL, 3, 0),
(152, 0, NULL, 4, 0),
(153, 0, NULL, 5, 0),
(154, 0, NULL, 2, 0),
(155, 0, NULL, 3, 0),
(156, 0, NULL, 4, 0),
(157, 0, NULL, 2, 0),
(158, 0, NULL, 3, 0),
(159, 0, NULL, 4, 0),
(160, 0, NULL, 5, 0),
(161, 0, NULL, 2, 0),
(162, 0, NULL, 3, 0),
(163, 0, NULL, 2, 0),
(164, 0, NULL, 3, 0),
(165, 0, NULL, 4, 0),
(166, 0, NULL, 2, 0),
(167, 0, NULL, 3, 0),
(168, 0, NULL, 2, 0),
(169, 0, NULL, 3, 0),
(170, 0, NULL, 2, 0),
(171, 0, NULL, 3, 0),
(172, 0, NULL, 4, 0),
(173, 0, NULL, 5, 0),
(174, 0, NULL, 2, 0),
(175, 0, NULL, 2, 0),
(176, 0, NULL, 2, 0),
(177, 0, NULL, 2, 0),
(178, 0, NULL, 2, 0),
(179, 0, NULL, 2, 0),
(180, 0, NULL, 2, 0),
(181, 0, NULL, 3, 0),
(182, 0, NULL, 4, 0),
(183, 0, NULL, 5, 0),
(184, 0, NULL, 6, 0),
(185, 0, NULL, 2, 0),
(186, 0, NULL, 2, 0),
(187, 0, NULL, 2, 0),
(188, 0, NULL, 2, 0),
(189, 0, NULL, 2, 0),
(190, 0, NULL, 3, 0),
(191, 0, NULL, 4, 0),
(192, 0, NULL, 2, 0),
(193, 0, NULL, 3, 0),
(194, 0, NULL, 1, 0),
(195, 0, NULL, 2, 0),
(196, 0, NULL, 3, 0),
(197, 0, NULL, 4, 0),
(198, 0, NULL, 1, 0),
(199, 0, NULL, 2, 0),
(200, 0, NULL, 3, 0),
(201, 0, NULL, 4, 0),
(202, 0, NULL, 5, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_text` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` text COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Text Attribute Backend Table' AUTO_INCREMENT=344 ;

INSERT INTO `#__catalog_product_entity_text` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(29, 4, 72, 0, 7, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(30, 4, 73, 0, 7, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(31, 4, 83, 0, 7, NULL),
(32, 4, 106, 0, 7, NULL),
(33, 4, 72, 0, 8, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(34, 4, 73, 0, 8, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(35, 4, 83, 0, 8, NULL),
(36, 4, 101, 0, 8, NULL),
(37, 4, 106, 0, 8, NULL),
(38, 4, 72, 0, 9, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(39, 4, 73, 0, 9, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(40, 4, 83, 0, 9, NULL),
(41, 4, 101, 0, 9, NULL),
(42, 4, 106, 0, 9, NULL),
(43, 4, 72, 0, 10, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(44, 4, 73, 0, 10, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(45, 4, 83, 0, 10, NULL),
(46, 4, 101, 0, 10, NULL),
(47, 4, 106, 0, 10, NULL),
(48, 4, 72, 0, 11, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(49, 4, 73, 0, 11, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(50, 4, 83, 0, 11, NULL),
(51, 4, 101, 0, 11, NULL),
(52, 4, 106, 0, 11, NULL),
(53, 4, 72, 0, 12, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(54, 4, 73, 0, 12, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(55, 4, 83, 0, 12, NULL),
(56, 4, 101, 0, 12, NULL),
(57, 4, 106, 0, 12, NULL),
(90, 4, 72, 0, 13, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(91, 4, 73, 0, 13, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(92, 4, 83, 0, 13, NULL),
(93, 4, 106, 0, 13, NULL),
(96, 4, 72, 0, 14, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(97, 4, 73, 0, 14, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(98, 4, 83, 0, 14, NULL),
(99, 4, 101, 0, 14, NULL),
(100, 4, 106, 0, 14, NULL),
(101, 4, 72, 0, 15, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(102, 4, 73, 0, 15, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(103, 4, 83, 0, 15, NULL),
(104, 4, 101, 0, 15, NULL),
(105, 4, 106, 0, 15, NULL),
(106, 4, 72, 0, 16, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(107, 4, 73, 0, 16, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(108, 4, 83, 0, 16, NULL),
(109, 4, 101, 0, 16, NULL),
(110, 4, 106, 0, 16, NULL),
(111, 4, 72, 0, 17, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(112, 4, 73, 0, 17, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(113, 4, 83, 0, 17, NULL),
(114, 4, 101, 0, 17, NULL),
(115, 4, 106, 0, 17, NULL),
(116, 4, 72, 0, 18, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(117, 4, 73, 0, 18, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(118, 4, 83, 0, 18, NULL),
(119, 4, 101, 0, 18, NULL),
(120, 4, 106, 0, 18, NULL),
(137, 4, 72, 0, 19, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(138, 4, 73, 0, 19, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(139, 4, 83, 0, 19, NULL),
(140, 4, 106, 0, 19, NULL),
(141, 4, 72, 0, 20, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(142, 4, 73, 0, 20, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(143, 4, 83, 0, 20, NULL),
(144, 4, 106, 0, 20, NULL),
(145, 4, 72, 0, 21, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(146, 4, 73, 0, 21, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(147, 4, 83, 0, 21, NULL),
(148, 4, 106, 0, 21, NULL),
(149, 4, 72, 0, 22, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(150, 4, 73, 0, 22, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(151, 4, 83, 0, 22, NULL),
(152, 4, 101, 0, 22, NULL),
(153, 4, 106, 0, 22, NULL),
(154, 4, 72, 0, 23, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(155, 4, 73, 0, 23, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(156, 4, 83, 0, 23, NULL),
(157, 4, 101, 0, 23, NULL),
(158, 4, 106, 0, 23, NULL),
(159, 4, 72, 0, 24, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(160, 4, 73, 0, 24, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(161, 4, 83, 0, 24, NULL),
(162, 4, 101, 0, 24, NULL),
(163, 4, 106, 0, 24, NULL),
(164, 4, 72, 0, 25, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(165, 4, 73, 0, 25, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(166, 4, 83, 0, 25, NULL),
(167, 4, 101, 0, 25, NULL),
(168, 4, 106, 0, 25, NULL),
(169, 4, 72, 0, 26, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(170, 4, 73, 0, 26, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(171, 4, 83, 0, 26, NULL),
(172, 4, 101, 0, 26, NULL),
(173, 4, 106, 0, 26, NULL),
(194, 4, 72, 0, 27, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(195, 4, 73, 0, 27, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(196, 4, 83, 0, 27, NULL),
(197, 4, 101, 0, 27, NULL),
(198, 4, 106, 0, 27, NULL),
(199, 4, 72, 0, 28, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(200, 4, 73, 0, 28, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(201, 4, 83, 0, 28, NULL),
(202, 4, 101, 0, 28, NULL),
(203, 4, 106, 0, 28, NULL);
INSERT INTO `#__catalog_product_entity_text` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(204, 4, 72, 0, 29, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(205, 4, 73, 0, 29, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(206, 4, 83, 0, 29, NULL),
(207, 4, 101, 0, 29, NULL),
(208, 4, 106, 0, 29, NULL),
(209, 4, 72, 0, 30, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(210, 4, 73, 0, 30, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(211, 4, 83, 0, 30, NULL),
(212, 4, 101, 0, 30, NULL),
(213, 4, 106, 0, 30, NULL),
(214, 4, 72, 0, 31, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(215, 4, 73, 0, 31, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(216, 4, 83, 0, 31, NULL),
(217, 4, 101, 0, 31, NULL),
(218, 4, 106, 0, 31, NULL),
(235, 4, 72, 0, 32, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(236, 4, 73, 0, 32, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(237, 4, 83, 0, 32, NULL),
(238, 4, 101, 0, 32, NULL),
(239, 4, 106, 0, 32, NULL),
(240, 4, 72, 0, 33, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(241, 4, 73, 0, 33, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(242, 4, 83, 0, 33, NULL),
(243, 4, 101, 0, 33, NULL),
(244, 4, 106, 0, 33, NULL),
(245, 4, 72, 0, 34, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(246, 4, 73, 0, 34, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(247, 4, 83, 0, 34, NULL),
(248, 4, 101, 0, 34, NULL),
(249, 4, 106, 0, 34, NULL),
(250, 4, 72, 0, 35, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(251, 4, 73, 0, 35, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(252, 4, 83, 0, 35, NULL),
(253, 4, 101, 0, 35, NULL),
(254, 4, 106, 0, 35, NULL),
(255, 4, 72, 0, 36, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(256, 4, 73, 0, 36, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(257, 4, 83, 0, 36, NULL),
(258, 4, 101, 0, 36, NULL),
(259, 4, 106, 0, 36, NULL),
(276, 4, 72, 0, 37, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(277, 4, 73, 0, 37, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(278, 4, 83, 0, 37, NULL),
(279, 4, 106, 0, 37, NULL),
(280, 4, 72, 0, 38, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(281, 4, 73, 0, 38, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(282, 4, 83, 0, 38, NULL),
(283, 4, 106, 0, 38, NULL),
(286, 4, 72, 0, 39, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(287, 4, 73, 0, 39, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(288, 4, 83, 0, 39, NULL),
(289, 4, 106, 0, 39, NULL),
(290, 4, 72, 0, 40, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(291, 4, 73, 0, 40, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(292, 4, 83, 0, 40, NULL),
(293, 4, 106, 0, 40, NULL),
(294, 4, 72, 0, 41, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(295, 4, 73, 0, 41, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(296, 4, 83, 0, 41, NULL),
(297, 4, 106, 0, 41, NULL),
(298, 4, 72, 0, 42, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(299, 4, 73, 0, 42, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(300, 4, 83, 0, 42, NULL),
(301, 4, 106, 0, 42, NULL),
(310, 4, 72, 0, 44, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(311, 4, 73, 0, 44, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(312, 4, 83, 0, 44, NULL),
(313, 4, 106, 0, 44, NULL),
(314, 4, 72, 0, 45, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(315, 4, 73, 0, 45, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(316, 4, 83, 0, 45, NULL),
(317, 4, 106, 0, 45, NULL),
(326, 4, 72, 0, 46, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(327, 4, 73, 0, 46, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(328, 4, 83, 0, 46, NULL),
(329, 4, 106, 0, 46, NULL),
(332, 4, 72, 0, 47, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(333, 4, 73, 0, 47, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(334, 4, 83, 0, 47, NULL),
(335, 4, 106, 0, 47, NULL),
(336, 4, 72, 0, 48, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(337, 4, 73, 0, 48, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(338, 4, 83, 0, 48, NULL),
(339, 4, 106, 0, 48, NULL),
(340, 4, 72, 0, 49, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh, sit amet accumsan nunc nunc et lorem. Quisque at augue. Donec elit ligula, pellentesque id, feugiat sed, malesuada a, turpis. Donec nunc quam, commodo ut, venenatis ut, feugiat quis, tortor. Nunc id risus vestibulum turpis facilisis fringilla. Pellentesque turpis ipsum, ultrices at, consequat sit amet, sollicitudin at, pede. Suspendisse potenti. Fusce eu ante sit amet lacus cursus tempor. Donec bibendum, metus nec tristique mollis, metus felis pellentesque sapien, eu mattis turpis lorem quis quam. In ligula nibh, varius quis, elementum sed, pellentesque vel, lectus. Praesent erat orci, hendrerit bibendum, tristique et, consectetuer eget, elit. Mauris vel mi at dui commodo elementum.</p>\r\n<p>Cras ut ante et est elementum tristique. Curabitur pulvinar massa in tellus. Nullam eu massa. Etiam nulla. Sed in dui. Curabitur eleifend leo sit amet lorem vehicula venenatis. Mauris suscipit purus vitae dui.</p>\r\n<p>Fusce auctor, metus eu ultricies vulputate, sapien nibh faucibus ligula, eget sollicitudin augue risus et dolor. Aenean pellentesque, tortor in cursus mattis, ante diam malesuada ligula, ac vestibulum neque turpis ut enim. Cras ornare. Proin ac nisi. Praesent laoreet ante tempor urna. In imperdiet. Nam ut metus et orci fermentum nonummy. Cras vel nunc. Donec feugiat neque eget purus. Quisque rhoncus. Phasellus tempus massa aliquet urna. Integer fringilla quam eget dolor. Curabitur mattis. Aliquam ac lacus. In congue, odio ut tristique adipiscing, diam leo fermentum ipsum, nec sollicitudin dui quam et tortor. Proin id neque ac pede egestas lacinia. Curabitur non odio.</p>'),
(341, 4, 73, 0, 49, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>'),
(342, 4, 83, 0, 49, NULL),
(343, 4, 106, 0, 49, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_tier_price` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `all_groups` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Applicable To All Customer Groups',
  `customer_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Group ID',
  `qty` decimal(12,4) NOT NULL DEFAULT '1.0000' COMMENT 'QTY',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Tier Price Attribute Backend Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalog_product_entity_varchar` (
`value_id` int(11) NOT NULL COMMENT 'Value ID',
  `entity_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Varchar Attribute Backend Table' AUTO_INCREMENT=1834 ;

INSERT INTO `#__catalog_product_entity_varchar` (`value_id`, `entity_type_id`, `attribute_id`, `store_id`, `entity_id`, `value`) VALUES
(192, 4, 71, 0, 7, 'Configurable Product'),
(193, 4, 97, 0, 7, 'configurable-product'),
(194, 4, 117, 0, 7, 'US'),
(195, 4, 118, 0, 7, '2'),
(196, 4, 119, 0, 7, '4'),
(197, 4, 82, 0, 7, NULL),
(198, 4, 84, 0, 7, NULL),
(199, 4, 85, 0, 7, '/0/0/00cfg01.jpg'),
(200, 4, 86, 0, 7, '/0/0/00cfg01.jpg'),
(201, 4, 87, 0, 7, '/0/0/00cfg01.jpg'),
(202, 4, 103, 0, 7, NULL),
(203, 4, 107, 0, 7, NULL),
(204, 4, 109, 0, 7, 'container1'),
(205, 4, 122, 0, 7, NULL),
(206, 4, 98, 1, 7, 'configurable-product.html'),
(207, 4, 98, 0, 7, 'configurable-product.html'),
(208, 4, 71, 0, 8, 'Cfg Armani Black'),
(209, 4, 117, 0, 8, 'US'),
(210, 4, 118, 0, 8, '2'),
(211, 4, 119, 0, 8, '4'),
(212, 4, 82, 0, 8, NULL),
(213, 4, 84, 0, 8, NULL),
(214, 4, 103, 0, 8, NULL),
(215, 4, 107, 0, 8, NULL),
(216, 4, 109, 0, 8, 'container1'),
(217, 4, 122, 0, 8, NULL),
(218, 4, 97, 0, 8, 'configurable-product-armani-black'),
(219, 4, 98, 1, 8, 'configurable-product-armani-black.html'),
(220, 4, 98, 0, 8, 'configurable-product-armani-black.html'),
(221, 4, 71, 0, 9, 'Cfg Armani Blue'),
(222, 4, 117, 0, 9, 'US'),
(223, 4, 118, 0, 9, '2'),
(224, 4, 119, 0, 9, '4'),
(225, 4, 82, 0, 9, NULL),
(226, 4, 84, 0, 9, NULL),
(227, 4, 103, 0, 9, NULL),
(228, 4, 107, 0, 9, NULL),
(229, 4, 109, 0, 9, 'container1'),
(230, 4, 122, 0, 9, NULL),
(231, 4, 97, 0, 9, 'configurable-product-armani-blue'),
(232, 4, 98, 1, 9, 'configurable-product-armani-blue.html'),
(233, 4, 98, 0, 9, 'configurable-product-armani-blue.html'),
(234, 4, 71, 0, 10, 'Cfg Armani Green'),
(235, 4, 117, 0, 10, 'US'),
(236, 4, 118, 0, 10, '2'),
(237, 4, 119, 0, 10, '4'),
(238, 4, 82, 0, 10, NULL),
(239, 4, 84, 0, 10, NULL),
(240, 4, 103, 0, 10, NULL),
(241, 4, 107, 0, 10, NULL),
(242, 4, 109, 0, 10, 'container1'),
(243, 4, 122, 0, 10, NULL),
(244, 4, 97, 0, 10, 'configurable-product-armani-green'),
(245, 4, 98, 1, 10, 'configurable-product-armani-green.html'),
(246, 4, 98, 0, 10, 'configurable-product-armani-green.html'),
(247, 4, 71, 0, 11, 'Cfg Buberry Red'),
(248, 4, 117, 0, 11, 'US'),
(249, 4, 118, 0, 11, '2'),
(250, 4, 119, 0, 11, '4'),
(251, 4, 82, 0, 11, NULL),
(252, 4, 84, 0, 11, NULL),
(253, 4, 103, 0, 11, NULL),
(254, 4, 107, 0, 11, NULL),
(255, 4, 109, 0, 11, 'container1'),
(256, 4, 122, 0, 11, NULL),
(257, 4, 97, 0, 11, 'configurable-product-buberry-red'),
(258, 4, 98, 1, 11, 'configurable-product-buberry-red.html'),
(259, 4, 98, 0, 11, 'configurable-product-buberry-red.html'),
(260, 4, 71, 0, 12, 'Cfg Buberry White'),
(261, 4, 117, 0, 12, 'US'),
(262, 4, 118, 0, 12, '2'),
(263, 4, 119, 0, 12, '4'),
(264, 4, 82, 0, 12, NULL),
(265, 4, 84, 0, 12, NULL),
(266, 4, 103, 0, 12, NULL),
(267, 4, 107, 0, 12, NULL),
(268, 4, 109, 0, 12, 'container1'),
(269, 4, 122, 0, 12, NULL),
(270, 4, 97, 0, 12, 'configurable-product-buberry-green'),
(271, 4, 98, 1, 12, 'configurable-product-buberry-green.html'),
(272, 4, 98, 0, 12, 'configurable-product-buberry-green.html'),
(273, 4, 85, 0, 12, '/0/0/00cfg01w.jpg'),
(274, 4, 86, 0, 12, '/0/0/00cfg01w.jpg'),
(275, 4, 87, 0, 12, '/0/0/00cfg01w.jpg'),
(287, 4, 85, 0, 8, '/0/0/00cfg01k.jpg'),
(288, 4, 86, 0, 8, '/0/0/00cfg01k.jpg'),
(289, 4, 87, 0, 8, '/0/0/00cfg01k.jpg'),
(296, 4, 85, 0, 9, '/0/0/00cfg01b.jpg'),
(297, 4, 86, 0, 9, '/0/0/00cfg01b.jpg'),
(298, 4, 87, 0, 9, '/0/0/00cfg01b.jpg'),
(305, 4, 85, 0, 10, '/0/0/00cfg01g.jpg'),
(306, 4, 86, 0, 10, '/0/0/00cfg01g.jpg'),
(307, 4, 87, 0, 10, '/0/0/00cfg01g.jpg'),
(314, 4, 85, 0, 11, '/0/0/00cfg01r.jpg'),
(315, 4, 86, 0, 11, '/0/0/00cfg01r.jpg'),
(316, 4, 87, 0, 11, '/0/0/00cfg01r.jpg'),
(344, 4, 112, 0, 8, NULL),
(345, 4, 113, 0, 8, NULL),
(346, 4, 114, 0, 8, NULL),
(355, 4, 112, 0, 7, NULL),
(356, 4, 113, 0, 7, NULL),
(357, 4, 114, 0, 7, NULL),
(366, 4, 112, 0, 9, NULL),
(367, 4, 113, 0, 9, NULL),
(368, 4, 114, 0, 9, NULL),
(377, 4, 112, 0, 10, NULL),
(378, 4, 113, 0, 10, NULL),
(379, 4, 114, 0, 10, NULL),
(388, 4, 112, 0, 11, NULL),
(389, 4, 113, 0, 11, NULL),
(390, 4, 114, 0, 11, NULL),
(399, 4, 112, 0, 12, NULL),
(400, 4, 113, 0, 12, NULL),
(401, 4, 114, 0, 12, NULL),
(410, 4, 71, 0, 13, 'Configurable Product 02'),
(411, 4, 97, 0, 13, 'configurable-product-02'),
(412, 4, 117, 0, 13, 'GB'),
(413, 4, 118, 0, 13, '2'),
(414, 4, 119, 0, 13, '4'),
(415, 4, 82, 0, 13, NULL),
(416, 4, 84, 0, 13, NULL),
(417, 4, 85, 0, 13, '/0/0/00cfg02.jpg'),
(418, 4, 86, 0, 13, '/0/0/00cfg02.jpg'),
(419, 4, 87, 0, 13, '/0/0/00cfg02.jpg'),
(420, 4, 103, 0, 13, NULL),
(421, 4, 107, 0, 13, NULL),
(422, 4, 109, 0, 13, 'container1'),
(423, 4, 122, 0, 13, NULL),
(424, 4, 98, 1, 13, 'configurable-product-02.html'),
(425, 4, 98, 0, 13, 'configurable-product-02.html'),
(431, 4, 71, 0, 14, 'Cfg 02 Chanel Black'),
(432, 4, 117, 0, 14, 'GB'),
(433, 4, 118, 0, 14, '2'),
(434, 4, 119, 0, 14, '4'),
(435, 4, 82, 0, 14, NULL),
(436, 4, 84, 0, 14, NULL),
(437, 4, 103, 0, 14, NULL),
(438, 4, 107, 0, 14, NULL),
(439, 4, 109, 0, 14, 'container1'),
(440, 4, 122, 0, 14, NULL),
(441, 4, 97, 0, 14, 'configurable-product-02-chanel-black'),
(442, 4, 98, 1, 14, 'configurable-product-02-chanel-black.html'),
(443, 4, 98, 0, 14, 'configurable-product-02-chanel-black.html'),
(444, 4, 71, 0, 15, 'Cfg 02 Chanel Blue'),
(445, 4, 117, 0, 15, 'GB'),
(446, 4, 118, 0, 15, '2'),
(447, 4, 119, 0, 15, '4'),
(448, 4, 82, 0, 15, NULL),
(449, 4, 84, 0, 15, NULL),
(450, 4, 103, 0, 15, NULL),
(451, 4, 107, 0, 15, NULL),
(452, 4, 109, 0, 15, 'container1'),
(453, 4, 122, 0, 15, NULL),
(454, 4, 97, 0, 15, 'configurable-product-02-chanel-blue'),
(455, 4, 98, 1, 15, 'configurable-product-02-chanel-blue.html'),
(456, 4, 98, 0, 15, 'configurable-product-02-chanel-blue.html'),
(457, 4, 71, 0, 16, 'Cfg 02 Dior Green'),
(458, 4, 117, 0, 16, 'GB'),
(459, 4, 118, 0, 16, '2'),
(460, 4, 119, 0, 16, '4'),
(461, 4, 82, 0, 16, NULL),
(462, 4, 84, 0, 16, NULL),
(463, 4, 103, 0, 16, NULL),
(464, 4, 107, 0, 16, NULL),
(465, 4, 109, 0, 16, 'container1'),
(466, 4, 122, 0, 16, NULL),
(467, 4, 97, 0, 16, 'configurable-product-02-dior-green'),
(468, 4, 98, 1, 16, 'configurable-product-02-dior-green.html'),
(469, 4, 98, 0, 16, 'configurable-product-02-dior-green.html'),
(470, 4, 71, 0, 17, 'Cfg 02 Gucci Red'),
(471, 4, 117, 0, 17, 'GB'),
(472, 4, 118, 0, 17, '2'),
(473, 4, 119, 0, 17, '4'),
(474, 4, 82, 0, 17, NULL),
(475, 4, 84, 0, 17, NULL),
(476, 4, 103, 0, 17, NULL),
(477, 4, 107, 0, 17, NULL),
(478, 4, 109, 0, 17, 'container1'),
(479, 4, 122, 0, 17, NULL),
(480, 4, 97, 0, 17, 'configurable-product-02-gucci-red'),
(481, 4, 98, 1, 17, 'configurable-product-02-gucci-red.html'),
(482, 4, 98, 0, 17, 'configurable-product-02-gucci-red.html'),
(483, 4, 71, 0, 18, 'Cfg 02 Gucci White'),
(484, 4, 117, 0, 18, 'GB'),
(485, 4, 118, 0, 18, '2'),
(486, 4, 119, 0, 18, '4'),
(487, 4, 82, 0, 18, NULL),
(488, 4, 84, 0, 18, NULL),
(489, 4, 103, 0, 18, NULL),
(490, 4, 107, 0, 18, NULL),
(491, 4, 109, 0, 18, 'container1'),
(492, 4, 122, 0, 18, NULL),
(493, 4, 97, 0, 18, 'configurable-product-02-gucci-white'),
(494, 4, 98, 1, 18, 'configurable-product-02-gucci-white.html'),
(495, 4, 98, 0, 18, 'configurable-product-02-gucci-white.html'),
(496, 4, 112, 0, 13, NULL),
(497, 4, 113, 0, 13, NULL),
(498, 4, 114, 0, 13, NULL),
(507, 4, 85, 0, 14, '/0/0/00cfg02k.jpg'),
(508, 4, 86, 0, 14, '/0/0/00cfg02k.jpg'),
(509, 4, 87, 0, 14, '/0/0/00cfg02k.jpg'),
(516, 4, 112, 0, 14, NULL),
(517, 4, 113, 0, 14, NULL),
(518, 4, 114, 0, 14, NULL),
(527, 4, 85, 0, 15, '/0/0/00cfg02b.jpg'),
(528, 4, 86, 0, 15, '/0/0/00cfg02b.jpg'),
(529, 4, 87, 0, 15, '/0/0/00cfg02b.jpg'),
(530, 4, 112, 0, 15, NULL),
(531, 4, 113, 0, 15, NULL),
(532, 4, 114, 0, 15, NULL),
(539, 4, 85, 0, 16, '/0/0/00cfg02g.jpg'),
(540, 4, 86, 0, 16, '/0/0/00cfg02g.jpg'),
(541, 4, 87, 0, 16, '/0/0/00cfg02g.jpg'),
(542, 4, 112, 0, 16, NULL),
(543, 4, 113, 0, 16, NULL),
(544, 4, 114, 0, 16, NULL),
(551, 4, 85, 0, 17, '/0/0/00cfg02r.jpg'),
(552, 4, 86, 0, 17, '/0/0/00cfg02r.jpg'),
(553, 4, 87, 0, 17, '/0/0/00cfg02r.jpg'),
(554, 4, 112, 0, 17, NULL),
(555, 4, 113, 0, 17, NULL),
(556, 4, 114, 0, 17, NULL),
(563, 4, 85, 0, 18, '/0/0/00cfg02w.jpg'),
(564, 4, 86, 0, 18, '/0/0/00cfg02w.jpg'),
(565, 4, 87, 0, 18, '/0/0/00cfg02w.jpg'),
(566, 4, 112, 0, 18, NULL),
(567, 4, 113, 0, 18, NULL),
(568, 4, 114, 0, 18, NULL),
(583, 4, 71, 0, 19, 'Configurable Product 03'),
(584, 4, 97, 0, 19, 'configurable-product-03'),
(585, 4, 117, 0, 19, 'CA'),
(586, 4, 118, 0, 19, '2'),
(587, 4, 119, 0, 19, '4'),
(588, 4, 82, 0, 19, NULL),
(589, 4, 84, 0, 19, NULL),
(590, 4, 85, 0, 19, '/0/0/00cfg03.jpg'),
(591, 4, 86, 0, 19, '/0/0/00cfg03.jpg'),
(592, 4, 87, 0, 19, '/0/0/00cfg03.jpg'),
(593, 4, 103, 0, 19, NULL),
(594, 4, 107, 0, 19, NULL),
(595, 4, 109, 0, 19, 'container1'),
(596, 4, 122, 0, 19, NULL),
(597, 4, 98, 1, 19, 'configurable-product-03.html'),
(598, 4, 98, 0, 19, 'configurable-product-03.html'),
(599, 4, 71, 0, 20, 'Configurable Product 04'),
(600, 4, 97, 0, 20, 'configurable-product-04'),
(601, 4, 117, 0, 20, 'CN'),
(602, 4, 118, 0, 20, '2'),
(603, 4, 119, 0, 20, '4'),
(604, 4, 82, 0, 20, NULL),
(605, 4, 84, 0, 20, NULL),
(606, 4, 85, 0, 20, '/0/0/00cfg04.jpg'),
(607, 4, 86, 0, 20, '/0/0/00cfg04.jpg'),
(608, 4, 87, 0, 20, '/0/0/00cfg04.jpg'),
(609, 4, 103, 0, 20, NULL),
(610, 4, 107, 0, 20, NULL),
(611, 4, 109, 0, 20, 'container1'),
(612, 4, 122, 0, 20, NULL),
(613, 4, 98, 1, 20, 'configurable-product-04.html'),
(614, 4, 98, 0, 20, 'configurable-product-04.html'),
(615, 4, 71, 0, 21, 'Configurable Product 05'),
(616, 4, 97, 0, 21, 'configurable-product-05'),
(617, 4, 117, 0, 21, 'MX'),
(618, 4, 118, 0, 21, '2'),
(619, 4, 119, 0, 21, '4'),
(620, 4, 82, 0, 21, NULL),
(621, 4, 84, 0, 21, NULL),
(622, 4, 85, 0, 21, '/0/0/00cfg05.jpg'),
(623, 4, 86, 0, 21, '/0/0/00cfg05.jpg'),
(624, 4, 87, 0, 21, '/0/0/00cfg05.jpg'),
(625, 4, 103, 0, 21, NULL),
(626, 4, 107, 0, 21, NULL),
(627, 4, 109, 0, 21, 'container1'),
(628, 4, 122, 0, 21, NULL),
(629, 4, 98, 1, 21, 'configurable-product-05.html'),
(630, 4, 98, 0, 21, 'configurable-product-05.html'),
(631, 4, 71, 0, 22, 'Cfg 03 Hermes White'),
(632, 4, 117, 0, 22, 'CA'),
(633, 4, 118, 0, 22, '2'),
(634, 4, 119, 0, 22, '4'),
(635, 4, 82, 0, 22, NULL),
(636, 4, 84, 0, 22, NULL),
(637, 4, 103, 0, 22, NULL),
(638, 4, 107, 0, 22, NULL),
(639, 4, 109, 0, 22, 'container1'),
(640, 4, 122, 0, 22, NULL),
(641, 4, 97, 0, 22, 'configurable-product-03-hermes-white'),
(642, 4, 98, 1, 22, 'configurable-product-03-hermes-white.html'),
(643, 4, 98, 0, 22, 'configurable-product-03-hermes-white.html'),
(644, 4, 71, 0, 23, 'Cfg 03 Prada Black'),
(645, 4, 117, 0, 23, 'CA'),
(646, 4, 118, 0, 23, '2'),
(647, 4, 119, 0, 23, '4'),
(648, 4, 82, 0, 23, NULL),
(649, 4, 84, 0, 23, NULL),
(650, 4, 103, 0, 23, NULL),
(651, 4, 107, 0, 23, NULL),
(652, 4, 109, 0, 23, 'container1'),
(653, 4, 122, 0, 23, NULL),
(654, 4, 97, 0, 23, 'configurable-product-03-prada-black'),
(655, 4, 98, 1, 23, 'configurable-product-03-prada-black.html'),
(656, 4, 98, 0, 23, 'configurable-product-03-prada-black.html'),
(657, 4, 71, 0, 24, 'Cfg 03 Versace Blue'),
(658, 4, 117, 0, 24, 'CA'),
(659, 4, 118, 0, 24, '2'),
(660, 4, 119, 0, 24, '4'),
(661, 4, 82, 0, 24, NULL),
(662, 4, 84, 0, 24, NULL),
(663, 4, 103, 0, 24, NULL),
(664, 4, 107, 0, 24, NULL),
(665, 4, 109, 0, 24, 'container1'),
(666, 4, 122, 0, 24, NULL),
(667, 4, 97, 0, 24, 'configurable-product-03-versace-blue'),
(668, 4, 98, 1, 24, 'configurable-product-03-versace-blue.html'),
(669, 4, 98, 0, 24, 'configurable-product-03-versace-blue.html'),
(670, 4, 71, 0, 25, 'Cfg 03 Prada Green'),
(671, 4, 117, 0, 25, 'CA'),
(672, 4, 118, 0, 25, '2'),
(673, 4, 119, 0, 25, '4'),
(674, 4, 82, 0, 25, NULL),
(675, 4, 84, 0, 25, NULL),
(676, 4, 103, 0, 25, NULL),
(677, 4, 107, 0, 25, NULL),
(678, 4, 109, 0, 25, 'container1'),
(679, 4, 122, 0, 25, NULL),
(680, 4, 97, 0, 25, 'configurable-product-03-prada-green'),
(681, 4, 98, 1, 25, 'configurable-product-03-prada-green.html'),
(682, 4, 98, 0, 25, 'configurable-product-03-prada-green.html'),
(683, 4, 71, 0, 26, 'Cfg 03 Prada Red'),
(684, 4, 117, 0, 26, 'CA'),
(685, 4, 118, 0, 26, '2'),
(686, 4, 119, 0, 26, '4'),
(687, 4, 82, 0, 26, NULL),
(688, 4, 84, 0, 26, NULL),
(689, 4, 103, 0, 26, NULL),
(690, 4, 107, 0, 26, NULL),
(691, 4, 109, 0, 26, 'container1'),
(692, 4, 122, 0, 26, NULL),
(693, 4, 97, 0, 26, 'configurable-product-03-prada-red'),
(694, 4, 98, 1, 26, 'configurable-product-03-prada-red.html'),
(695, 4, 98, 0, 26, 'configurable-product-03-prada-red.html'),
(701, 4, 112, 0, 19, NULL),
(702, 4, 113, 0, 19, NULL),
(703, 4, 114, 0, 19, NULL),
(712, 4, 85, 0, 22, '/0/0/00cfg03w.jpg'),
(713, 4, 86, 0, 22, '/0/0/00cfg03w.jpg'),
(714, 4, 87, 0, 22, '/0/0/00cfg03w.jpg'),
(715, 4, 112, 0, 22, NULL),
(716, 4, 113, 0, 22, NULL),
(717, 4, 114, 0, 22, NULL),
(724, 4, 85, 0, 23, '/0/0/00cfg03k.jpg'),
(725, 4, 86, 0, 23, '/0/0/00cfg03k.jpg'),
(726, 4, 87, 0, 23, '/0/0/00cfg03k.jpg'),
(727, 4, 112, 0, 23, NULL),
(728, 4, 113, 0, 23, NULL),
(729, 4, 114, 0, 23, NULL),
(736, 4, 85, 0, 24, '/0/0/00cfg03b.jpg'),
(737, 4, 86, 0, 24, '/0/0/00cfg03b.jpg'),
(738, 4, 87, 0, 24, '/0/0/00cfg03b.jpg'),
(739, 4, 112, 0, 24, NULL),
(740, 4, 113, 0, 24, NULL),
(741, 4, 114, 0, 24, NULL),
(748, 4, 85, 0, 25, '/0/0/00cfg03g.jpg'),
(749, 4, 86, 0, 25, '/0/0/00cfg03g.jpg'),
(750, 4, 87, 0, 25, '/0/0/00cfg03g.jpg'),
(751, 4, 112, 0, 25, NULL),
(752, 4, 113, 0, 25, NULL),
(753, 4, 114, 0, 25, NULL),
(760, 4, 85, 0, 26, '/0/0/00cfg03r.jpg'),
(761, 4, 86, 0, 26, '/0/0/00cfg03r.jpg'),
(762, 4, 87, 0, 26, '/0/0/00cfg03r.jpg'),
(763, 4, 112, 0, 26, NULL),
(764, 4, 113, 0, 26, NULL),
(765, 4, 114, 0, 26, NULL),
(780, 4, 112, 0, 20, NULL),
(781, 4, 113, 0, 20, NULL),
(782, 4, 114, 0, 20, NULL),
(799, 4, 71, 0, 27, 'Cfg 04 Black'),
(800, 4, 117, 0, 27, 'CN'),
(801, 4, 118, 0, 27, '2'),
(802, 4, 119, 0, 27, '4'),
(803, 4, 82, 0, 27, NULL),
(804, 4, 84, 0, 27, NULL),
(805, 4, 103, 0, 27, NULL),
(806, 4, 107, 0, 27, NULL),
(807, 4, 109, 0, 27, 'container1'),
(808, 4, 122, 0, 27, NULL),
(809, 4, 97, 0, 27, 'configurable-product-04-black'),
(810, 4, 98, 1, 27, 'configurable-product-04-black.html'),
(811, 4, 98, 0, 27, 'configurable-product-04-black.html'),
(812, 4, 71, 0, 28, 'Cfg 04 White'),
(813, 4, 117, 0, 28, 'CN'),
(814, 4, 118, 0, 28, '2'),
(815, 4, 119, 0, 28, '4'),
(816, 4, 82, 0, 28, NULL),
(817, 4, 84, 0, 28, NULL),
(818, 4, 103, 0, 28, NULL),
(819, 4, 107, 0, 28, NULL),
(820, 4, 109, 0, 28, 'container1'),
(821, 4, 122, 0, 28, NULL),
(822, 4, 97, 0, 28, 'configurable-product-04-white'),
(823, 4, 98, 1, 28, 'configurable-product-04-white.html'),
(824, 4, 98, 0, 28, 'configurable-product-04-white.html'),
(825, 4, 71, 0, 29, 'Cfg 04 Red'),
(826, 4, 117, 0, 29, 'CN'),
(827, 4, 118, 0, 29, '2'),
(828, 4, 119, 0, 29, '4'),
(829, 4, 82, 0, 29, NULL),
(830, 4, 84, 0, 29, NULL),
(831, 4, 103, 0, 29, NULL),
(832, 4, 107, 0, 29, NULL),
(833, 4, 109, 0, 29, 'container1'),
(834, 4, 122, 0, 29, NULL),
(835, 4, 97, 0, 29, 'configurable-product-04-red'),
(836, 4, 98, 1, 29, 'configurable-product-04-red.html'),
(837, 4, 98, 0, 29, 'configurable-product-04-red.html'),
(838, 4, 71, 0, 30, 'Cfg 04 Green'),
(839, 4, 117, 0, 30, 'CN'),
(840, 4, 118, 0, 30, '2'),
(841, 4, 119, 0, 30, '4'),
(842, 4, 82, 0, 30, NULL),
(843, 4, 84, 0, 30, NULL),
(844, 4, 103, 0, 30, NULL),
(845, 4, 107, 0, 30, NULL),
(846, 4, 109, 0, 30, 'container1'),
(847, 4, 122, 0, 30, NULL),
(848, 4, 97, 0, 30, 'configurable-product-04-green'),
(849, 4, 98, 1, 30, 'configurable-product-04-green.html'),
(850, 4, 98, 0, 30, 'configurable-product-04-green.html'),
(851, 4, 71, 0, 31, 'Cfg 04 Blue'),
(852, 4, 117, 0, 31, 'CN'),
(853, 4, 118, 0, 31, '2'),
(854, 4, 119, 0, 31, '4'),
(855, 4, 82, 0, 31, NULL),
(856, 4, 84, 0, 31, NULL),
(857, 4, 103, 0, 31, NULL),
(858, 4, 107, 0, 31, NULL),
(859, 4, 109, 0, 31, 'container1'),
(860, 4, 122, 0, 31, NULL),
(861, 4, 97, 0, 31, 'configurable-product-04-blue'),
(862, 4, 98, 1, 31, 'configurable-product-04-blue.html'),
(863, 4, 98, 0, 31, 'configurable-product-04-blue.html'),
(875, 4, 85, 0, 27, '/0/0/00cfg04k.jpg'),
(876, 4, 86, 0, 27, '/0/0/00cfg04k.jpg'),
(877, 4, 87, 0, 27, '/0/0/00cfg04k.jpg'),
(878, 4, 112, 0, 27, NULL),
(879, 4, 113, 0, 27, NULL),
(880, 4, 114, 0, 27, NULL),
(887, 4, 85, 0, 28, '/0/0/00cfg04w.jpg'),
(888, 4, 86, 0, 28, '/0/0/00cfg04w.jpg'),
(889, 4, 87, 0, 28, '/0/0/00cfg04w.jpg'),
(896, 4, 112, 0, 28, NULL),
(897, 4, 113, 0, 28, NULL),
(898, 4, 114, 0, 28, NULL),
(907, 4, 85, 0, 29, '/0/0/00cfg04r.jpg'),
(908, 4, 86, 0, 29, '/0/0/00cfg04r.jpg'),
(909, 4, 87, 0, 29, '/0/0/00cfg04r.jpg'),
(910, 4, 112, 0, 29, NULL),
(911, 4, 113, 0, 29, NULL),
(912, 4, 114, 0, 29, NULL),
(919, 4, 85, 0, 31, '/0/0/00cfg04b.jpg'),
(920, 4, 86, 0, 31, '/0/0/00cfg04b.jpg'),
(921, 4, 87, 0, 31, '/0/0/00cfg04b.jpg'),
(922, 4, 112, 0, 31, NULL),
(923, 4, 113, 0, 31, NULL),
(924, 4, 114, 0, 31, NULL),
(931, 4, 85, 0, 30, '/0/0/00cfg04g.jpg'),
(932, 4, 86, 0, 30, '/0/0/00cfg04g.jpg'),
(933, 4, 87, 0, 30, '/0/0/00cfg04g.jpg'),
(934, 4, 112, 0, 30, NULL),
(935, 4, 113, 0, 30, NULL),
(936, 4, 114, 0, 30, NULL),
(951, 4, 71, 0, 32, 'Cfg 05 Armani'),
(952, 4, 117, 0, 32, 'MX'),
(953, 4, 118, 0, 32, '2'),
(954, 4, 119, 0, 32, '4'),
(955, 4, 82, 0, 32, NULL),
(956, 4, 84, 0, 32, NULL),
(957, 4, 103, 0, 32, NULL),
(958, 4, 107, 0, 32, NULL),
(959, 4, 109, 0, 32, 'container1'),
(960, 4, 122, 0, 32, NULL),
(961, 4, 97, 0, 32, 'configurable-product-05-armani'),
(962, 4, 98, 1, 32, 'configurable-product-05-armani.html'),
(963, 4, 98, 0, 32, 'configurable-product-05-armani.html'),
(964, 4, 71, 0, 33, 'Cfg 05 Buberry'),
(965, 4, 117, 0, 33, 'MX'),
(966, 4, 118, 0, 33, '2'),
(967, 4, 119, 0, 33, '4'),
(968, 4, 82, 0, 33, NULL),
(969, 4, 84, 0, 33, NULL),
(970, 4, 103, 0, 33, NULL),
(971, 4, 107, 0, 33, NULL),
(972, 4, 109, 0, 33, 'container1'),
(973, 4, 122, 0, 33, NULL),
(974, 4, 97, 0, 33, 'configurable-product-05-buberry'),
(975, 4, 98, 1, 33, 'configurable-product-05-buberry.html'),
(976, 4, 98, 0, 33, 'configurable-product-05-buberry.html'),
(977, 4, 71, 0, 34, 'Cfg 05 Chanel'),
(978, 4, 117, 0, 34, 'MX'),
(979, 4, 118, 0, 34, '2'),
(980, 4, 119, 0, 34, '4'),
(981, 4, 82, 0, 34, NULL),
(982, 4, 84, 0, 34, NULL),
(983, 4, 103, 0, 34, NULL),
(984, 4, 107, 0, 34, NULL),
(985, 4, 109, 0, 34, 'container1'),
(986, 4, 122, 0, 34, NULL),
(987, 4, 97, 0, 34, 'configurable-product-05-chanel'),
(988, 4, 98, 1, 34, 'configurable-product-05-chanel.html'),
(989, 4, 98, 0, 34, 'configurable-product-05-chanel.html'),
(990, 4, 71, 0, 35, 'Cfg 05 Hermes'),
(991, 4, 117, 0, 35, 'MX'),
(992, 4, 118, 0, 35, '2'),
(993, 4, 119, 0, 35, '4'),
(994, 4, 82, 0, 35, NULL),
(995, 4, 84, 0, 35, NULL),
(996, 4, 103, 0, 35, NULL),
(997, 4, 107, 0, 35, NULL),
(998, 4, 109, 0, 35, 'container1'),
(999, 4, 122, 0, 35, NULL),
(1000, 4, 97, 0, 35, 'configurable-product-05-hermes'),
(1001, 4, 98, 1, 35, 'configurable-product-05-hermes.html'),
(1002, 4, 98, 0, 35, 'configurable-product-05-hermes.html'),
(1003, 4, 71, 0, 36, 'Cfg 05 Versace'),
(1004, 4, 117, 0, 36, 'MX'),
(1005, 4, 118, 0, 36, '2'),
(1006, 4, 119, 0, 36, '4'),
(1007, 4, 82, 0, 36, NULL),
(1008, 4, 84, 0, 36, NULL),
(1009, 4, 103, 0, 36, NULL),
(1010, 4, 107, 0, 36, NULL),
(1011, 4, 109, 0, 36, 'container1'),
(1012, 4, 122, 0, 36, NULL),
(1013, 4, 97, 0, 36, 'configurable-product-05-versace'),
(1014, 4, 98, 1, 36, 'configurable-product-05-versace.html'),
(1015, 4, 98, 0, 36, 'configurable-product-05-versace.html'),
(1021, 4, 112, 0, 21, NULL),
(1022, 4, 113, 0, 21, NULL),
(1023, 4, 114, 0, 21, NULL),
(1032, 4, 85, 0, 32, '/0/0/00cfg051.jpg'),
(1033, 4, 86, 0, 32, '/0/0/00cfg051.jpg'),
(1034, 4, 87, 0, 32, '/0/0/00cfg051.jpg'),
(1035, 4, 112, 0, 32, NULL),
(1036, 4, 113, 0, 32, NULL),
(1037, 4, 114, 0, 32, NULL),
(1044, 4, 85, 0, 33, '/0/0/00cfg052.jpg'),
(1045, 4, 86, 0, 33, '/0/0/00cfg052.jpg'),
(1046, 4, 87, 0, 33, '/0/0/00cfg052.jpg'),
(1047, 4, 112, 0, 33, NULL),
(1048, 4, 113, 0, 33, NULL),
(1049, 4, 114, 0, 33, NULL),
(1056, 4, 85, 0, 34, '/0/0/00cfg053.jpg'),
(1057, 4, 86, 0, 34, '/0/0/00cfg053.jpg'),
(1058, 4, 87, 0, 34, '/0/0/00cfg053.jpg'),
(1059, 4, 112, 0, 34, NULL),
(1060, 4, 113, 0, 34, NULL),
(1061, 4, 114, 0, 34, NULL),
(1068, 4, 85, 0, 35, '/0/0/00cfg054.jpg'),
(1069, 4, 86, 0, 35, '/0/0/00cfg054.jpg'),
(1070, 4, 87, 0, 35, '/0/0/00cfg054.jpg'),
(1071, 4, 112, 0, 35, NULL),
(1072, 4, 113, 0, 35, NULL),
(1073, 4, 114, 0, 35, NULL),
(1080, 4, 85, 0, 36, '/0/0/00cfg055.jpg'),
(1081, 4, 86, 0, 36, '/0/0/00cfg055.jpg'),
(1082, 4, 87, 0, 36, '/0/0/00cfg055.jpg'),
(1083, 4, 112, 0, 36, NULL),
(1084, 4, 113, 0, 36, NULL),
(1085, 4, 114, 0, 36, NULL),
(1100, 4, 71, 0, 37, 'Simple product 01'),
(1101, 4, 97, 0, 37, 'simple-product-01'),
(1102, 4, 117, 0, 37, NULL),
(1103, 4, 118, 0, 37, '2'),
(1104, 4, 119, 0, 37, '4'),
(1105, 4, 82, 0, 37, NULL),
(1106, 4, 84, 0, 37, NULL),
(1107, 4, 85, 0, 37, '/0/1/01sim0105.jpg'),
(1108, 4, 86, 0, 37, '/0/1/01sim0105.jpg'),
(1109, 4, 87, 0, 37, '/0/1/01sim0105.jpg'),
(1110, 4, 103, 0, 37, NULL),
(1111, 4, 107, 0, 37, NULL),
(1112, 4, 109, 0, 37, 'container1'),
(1113, 4, 122, 0, 37, NULL),
(1114, 4, 112, 0, 37, NULL),
(1115, 4, 113, 0, 37, NULL),
(1116, 4, 114, 0, 37, NULL),
(1117, 4, 98, 1, 37, 'simple-product-01.html'),
(1118, 4, 98, 0, 37, 'simple-product-01.html'),
(1119, 4, 71, 0, 38, 'Simple product 02'),
(1120, 4, 82, 0, 38, NULL),
(1121, 4, 84, 0, 38, NULL),
(1122, 4, 85, 0, 38, '/0/1/01sim0202.jpg'),
(1123, 4, 86, 0, 38, '/0/1/01sim0202.jpg'),
(1124, 4, 87, 0, 38, '/0/1/01sim0202.jpg'),
(1125, 4, 97, 0, 38, 'simple-product-02'),
(1126, 4, 98, 0, 38, 'simple-product-02.html'),
(1127, 4, 103, 0, 38, NULL),
(1128, 4, 107, 0, 38, NULL),
(1129, 4, 109, 0, 38, 'container1'),
(1130, 4, 112, 0, 38, NULL),
(1131, 4, 113, 0, 38, NULL),
(1132, 4, 114, 0, 38, NULL),
(1133, 4, 117, 0, 38, NULL),
(1134, 4, 118, 0, 38, '2'),
(1135, 4, 119, 0, 38, '4'),
(1136, 4, 122, 0, 38, NULL),
(1137, 4, 98, 1, 38, 'simple-product-02.html'),
(1153, 4, 71, 0, 39, 'Simple product 03'),
(1154, 4, 97, 0, 39, 'simple-product-03'),
(1155, 4, 117, 0, 39, 'AU'),
(1156, 4, 118, 0, 39, '2'),
(1157, 4, 119, 0, 39, '4'),
(1158, 4, 82, 0, 39, NULL),
(1159, 4, 84, 0, 39, NULL),
(1160, 4, 85, 0, 39, '/0/1/01sim0305.jpg'),
(1161, 4, 86, 0, 39, '/0/1/01sim0305.jpg'),
(1162, 4, 87, 0, 39, '/0/1/01sim0305.jpg'),
(1163, 4, 103, 0, 39, NULL),
(1164, 4, 107, 0, 39, NULL),
(1165, 4, 109, 0, 39, 'container1'),
(1166, 4, 122, 0, 39, NULL),
(1167, 4, 112, 0, 39, NULL),
(1168, 4, 113, 0, 39, NULL),
(1169, 4, 114, 0, 39, NULL),
(1170, 4, 98, 1, 39, 'simple-product-03.html'),
(1171, 4, 98, 0, 39, 'simple-product-03.html'),
(1172, 4, 71, 0, 40, 'Simple product 04'),
(1173, 4, 97, 0, 40, 'simple-product-04'),
(1174, 4, 117, 0, 40, 'AR'),
(1175, 4, 118, 0, 40, '2'),
(1176, 4, 119, 0, 40, '4'),
(1177, 4, 82, 0, 40, NULL),
(1178, 4, 84, 0, 40, NULL),
(1179, 4, 85, 0, 40, '/0/1/01sim0403.jpg'),
(1180, 4, 86, 0, 40, '/0/1/01sim0403.jpg'),
(1181, 4, 87, 0, 40, '/0/1/01sim0403.jpg'),
(1182, 4, 103, 0, 40, NULL),
(1183, 4, 107, 0, 40, NULL),
(1184, 4, 109, 0, 40, 'container1'),
(1185, 4, 122, 0, 40, NULL),
(1186, 4, 112, 0, 40, NULL),
(1187, 4, 113, 0, 40, NULL),
(1188, 4, 114, 0, 40, NULL),
(1189, 4, 98, 1, 40, 'simple-product-04.html'),
(1190, 4, 98, 0, 40, 'simple-product-04.html'),
(1191, 4, 71, 0, 41, 'Simple product 05'),
(1192, 4, 97, 0, 41, 'simple-product-05'),
(1193, 4, 117, 0, 41, 'FR'),
(1194, 4, 118, 0, 41, '2'),
(1195, 4, 119, 0, 41, '4'),
(1196, 4, 82, 0, 41, NULL),
(1197, 4, 84, 0, 41, NULL),
(1198, 4, 85, 0, 41, '/0/1/01sim0503.jpg'),
(1199, 4, 86, 0, 41, '/0/1/01sim0503.jpg'),
(1200, 4, 87, 0, 41, '/0/1/01sim0503.jpg'),
(1201, 4, 103, 0, 41, NULL),
(1202, 4, 107, 0, 41, NULL),
(1203, 4, 109, 0, 41, 'container1'),
(1204, 4, 122, 0, 41, NULL),
(1205, 4, 112, 0, 41, NULL),
(1206, 4, 113, 0, 41, NULL),
(1207, 4, 114, 0, 41, NULL),
(1208, 4, 98, 1, 41, 'simple-product-05.html'),
(1209, 4, 98, 0, 41, 'simple-product-05.html'),
(1210, 4, 71, 0, 42, 'Grouped Product'),
(1211, 4, 97, 0, 42, 'grouped-product'),
(1212, 4, 117, 0, 42, 'CM'),
(1213, 4, 82, 0, 42, NULL),
(1214, 4, 84, 0, 42, NULL),
(1215, 4, 85, 0, 42, '/0/2/02group0101.jpg'),
(1216, 4, 86, 0, 42, '/0/2/02group0101.jpg'),
(1217, 4, 87, 0, 42, '/0/2/02group0101.jpg'),
(1218, 4, 103, 0, 42, NULL),
(1219, 4, 107, 0, 42, NULL),
(1220, 4, 109, 0, 42, 'container1'),
(1221, 4, 122, 0, 42, NULL),
(1222, 4, 98, 1, 42, 'grouped-product.html'),
(1223, 4, 98, 0, 42, 'grouped-product.html'),
(1224, 4, 112, 0, 42, NULL),
(1225, 4, 113, 0, 42, NULL),
(1226, 4, 114, 0, 42, NULL),
(1261, 4, 71, 0, 44, 'Bundle Product'),
(1262, 4, 97, 0, 44, 'bundle-product'),
(1263, 4, 117, 0, 44, 'BB'),
(1264, 4, 82, 0, 44, NULL),
(1265, 4, 84, 0, 44, NULL),
(1266, 4, 85, 0, 44, '/0/4/04bud0102.jpg'),
(1267, 4, 86, 0, 44, '/0/4/04bud0102.jpg'),
(1268, 4, 87, 0, 44, '/0/4/04bud0102.jpg'),
(1269, 4, 103, 0, 44, NULL),
(1270, 4, 107, 0, 44, NULL),
(1271, 4, 109, 0, 44, 'container1'),
(1272, 4, 118, 0, 44, '0'),
(1273, 4, 122, 0, 44, NULL),
(1274, 4, 98, 1, 44, 'bundle-product.html'),
(1275, 4, 98, 0, 44, 'bundle-product.html'),
(1276, 4, 71, 0, 45, 'Bundle Product 02'),
(1277, 4, 82, 0, 45, NULL),
(1278, 4, 84, 0, 45, NULL),
(1279, 4, 85, 0, 45, '/0/4/04bud0201.jpg'),
(1280, 4, 86, 0, 45, '/0/4/04bud0201.jpg'),
(1281, 4, 87, 0, 45, '/0/4/04bud0201.jpg'),
(1282, 4, 97, 0, 45, 'bundle-product-02'),
(1283, 4, 98, 0, 45, 'bundle-product-02.html'),
(1284, 4, 103, 0, 45, NULL),
(1285, 4, 107, 0, 45, NULL),
(1286, 4, 109, 0, 45, 'container2'),
(1287, 4, 117, 0, 45, 'BB'),
(1288, 4, 118, 0, 45, '0'),
(1289, 4, 122, 0, 45, NULL),
(1290, 4, 98, 1, 45, 'bundle-product-02.html'),
(1307, 4, 112, 0, 44, NULL),
(1308, 4, 113, 0, 44, NULL),
(1309, 4, 114, 0, 44, NULL),
(1319, 4, 112, 0, 45, NULL),
(1320, 4, 113, 0, 45, NULL),
(1321, 4, 114, 0, 45, NULL),
(1331, 4, 71, 0, 46, 'Downloadable Product'),
(1332, 4, 97, 0, 46, 'downloadable-product'),
(1333, 4, 118, 0, 46, '2'),
(1334, 4, 119, 0, 46, '4'),
(1335, 4, 82, 0, 46, NULL),
(1336, 4, 84, 0, 46, NULL),
(1337, 4, 85, 0, 46, '/0/5/05down0105.jpg'),
(1338, 4, 86, 0, 46, '/0/5/05down0105.jpg'),
(1339, 4, 87, 0, 46, '/0/5/05down0105.jpg'),
(1340, 4, 103, 0, 46, NULL),
(1341, 4, 107, 0, 46, NULL),
(1342, 4, 109, 0, 46, 'container1'),
(1343, 4, 129, 0, 46, 'Samples'),
(1344, 4, 130, 0, 46, 'Links'),
(1345, 4, 122, 0, 46, NULL),
(1346, 4, 98, 1, 46, 'downloadable-product.html'),
(1347, 4, 98, 0, 46, 'downloadable-product.html'),
(1348, 4, 112, 0, 46, NULL),
(1349, 4, 113, 0, 46, NULL),
(1350, 4, 114, 0, 46, NULL),
(1359, 4, 71, 0, 47, 'No image'),
(1360, 4, 97, 0, 47, 'no-image'),
(1361, 4, 117, 0, 47, NULL),
(1362, 4, 118, 0, 47, '2'),
(1363, 4, 119, 0, 47, '4'),
(1364, 4, 82, 0, 47, NULL),
(1365, 4, 84, 0, 47, NULL),
(1366, 4, 85, 0, 47, '/0/0/00cfg01b_4.jpg'),
(1367, 4, 86, 0, 47, '/0/0/00cfg01b_4.jpg'),
(1368, 4, 87, 0, 47, '/0/0/00cfg01b_4.jpg'),
(1369, 4, 103, 0, 47, NULL),
(1370, 4, 107, 0, 47, NULL),
(1371, 4, 109, 0, 47, 'container1'),
(1372, 4, 122, 0, 47, NULL),
(1373, 4, 98, 1, 47, 'no-image.html'),
(1374, 4, 98, 0, 47, 'no-image.html'),
(1375, 4, 71, 0, 48, 'Custom Option'),
(1376, 4, 97, 0, 48, 'custom-option'),
(1377, 4, 117, 0, 48, 'AZ'),
(1378, 4, 118, 0, 48, '2'),
(1379, 4, 119, 0, 48, '4'),
(1380, 4, 82, 0, 48, NULL),
(1381, 4, 84, 0, 48, NULL),
(1382, 4, 85, 0, 48, '/0/6/06custom0104.jpg'),
(1383, 4, 86, 0, 48, '/0/6/06custom0104.jpg'),
(1384, 4, 87, 0, 48, '/0/6/06custom0104.jpg'),
(1385, 4, 103, 0, 48, NULL),
(1386, 4, 107, 0, 48, NULL),
(1387, 4, 109, 0, 48, 'container1'),
(1388, 4, 122, 0, 48, NULL),
(1389, 4, 98, 1, 48, 'custom-option.html'),
(1390, 4, 98, 0, 48, 'custom-option.html'),
(1391, 4, 112, 0, 48, NULL),
(1392, 4, 113, 0, 48, NULL),
(1393, 4, 114, 0, 48, NULL),
(1804, 4, 112, 0, 47, NULL),
(1805, 4, 113, 0, 47, NULL),
(1806, 4, 114, 0, 47, NULL),
(1807, 4, 112, 1, 48, NULL),
(1808, 4, 113, 1, 48, NULL),
(1809, 4, 114, 1, 48, NULL),
(1812, 4, 98, 2, 48, 'custom-option.html'),
(1813, 4, 112, 2, 48, NULL),
(1814, 4, 113, 2, 48, NULL),
(1815, 4, 114, 2, 48, NULL),
(1816, 4, 71, 0, 49, 'Virtual Product'),
(1817, 4, 97, 0, 49, 'virtual-product'),
(1818, 4, 118, 0, 49, '2'),
(1819, 4, 119, 0, 49, '4'),
(1820, 4, 82, 0, 49, NULL),
(1821, 4, 84, 0, 49, NULL),
(1822, 4, 85, 0, 49, '/2/_/2.jpg'),
(1823, 4, 86, 0, 49, '/2/_/2.jpg'),
(1824, 4, 87, 0, 49, '/2/_/2.jpg'),
(1825, 4, 103, 0, 49, NULL),
(1826, 4, 107, 0, 49, NULL),
(1827, 4, 109, 0, 49, 'container1'),
(1828, 4, 122, 0, 49, NULL),
(1829, 4, 112, 0, 49, NULL),
(1830, 4, 113, 0, 49, NULL),
(1831, 4, 114, 0, 49, NULL),
(1832, 4, 98, 1, 49, 'virtual-product.html'),
(1833, 4, 98, 0, 49, 'virtual-product.html');

CREATE TABLE IF NOT EXISTS `#__catalog_product_flat_1` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type Id',
  `cost` decimal(12,4) DEFAULT NULL COMMENT 'Cost',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `gift_message_available` smallint(6) DEFAULT NULL COMMENT 'Gift Message Available',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `image_label` varchar(255) DEFAULT NULL COMMENT 'Image Label',
  `is_recurring` smallint(6) DEFAULT NULL COMMENT 'Is Recurring',
  `links_exist` int(11) DEFAULT NULL COMMENT 'Links Exist',
  `links_purchased_separately` int(11) DEFAULT NULL COMMENT 'Links Purchased Separately',
  `links_title` varchar(255) DEFAULT NULL COMMENT 'Links Title',
  `msrp` decimal(12,4) DEFAULT NULL COMMENT 'Msrp',
  `msrp_display_actual_price_type` varchar(255) DEFAULT NULL COMMENT 'Msrp Display Actual Price Type',
  `msrp_enabled` smallint(6) DEFAULT NULL COMMENT 'Msrp Enabled',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `news_from_date` datetime DEFAULT NULL COMMENT 'News From Date',
  `news_to_date` datetime DEFAULT NULL COMMENT 'News To Date',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `price_type` int(11) DEFAULT NULL COMMENT 'Price Type',
  `price_view` int(11) DEFAULT NULL COMMENT 'Price View',
  `recurring_profile` text COMMENT 'Recurring Profile',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `shipment_type` int(11) DEFAULT NULL COMMENT 'Shipment Type',
  `short_description` text COMMENT 'Short Description',
  `sku` varchar(64) DEFAULT NULL COMMENT 'Sku',
  `sku_type` int(11) DEFAULT NULL COMMENT 'Sku Type',
  `small_image` varchar(255) DEFAULT NULL COMMENT 'Small Image',
  `small_image_label` varchar(255) DEFAULT NULL COMMENT 'Small Image Label',
  `special_from_date` datetime DEFAULT NULL COMMENT 'Special From Date',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `special_to_date` datetime DEFAULT NULL COMMENT 'Special To Date',
  `tax_class_id` int(10) unsigned DEFAULT NULL COMMENT 'Tax Class Id',
  `thumbnail` varchar(255) DEFAULT NULL COMMENT 'Thumbnail',
  `thumbnail_label` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Label',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path',
  `visibility` smallint(5) unsigned DEFAULT NULL COMMENT 'Visibility',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `weight_type` int(11) DEFAULT NULL COMMENT 'Weight Type',
  `status` smallint(5) unsigned DEFAULT NULL COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Flat (Store 1)';

INSERT INTO `#__catalog_product_flat_1` (`entity_id`, `attribute_set_id`, `type_id`, `cost`, `created_at`, `gift_message_available`, `has_options`, `image_label`, `is_recurring`, `links_exist`, `links_purchased_separately`, `links_title`, `msrp`, `msrp_display_actual_price_type`, `msrp_enabled`, `name`, `news_from_date`, `news_to_date`, `price`, `price_type`, `price_view`, `recurring_profile`, `required_options`, `shipment_type`, `short_description`, `sku`, `sku_type`, `small_image`, `small_image_label`, `special_from_date`, `special_price`, `special_to_date`, `tax_class_id`, `thumbnail`, `thumbnail_label`, `updated_at`, `url_key`, `url_path`, `visibility`, `weight`, `weight_type`, `status`) VALUES
(7, 4, 'configurable', NULL, '2014-03-13 00:42:03', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product', NULL, NULL, '599.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01', NULL, '/0/0/00cfg01.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01.jpg', NULL, '2015-01-23 19:45:25', 'configurable-product', 'configurable-product.html', 4, NULL, NULL, 1),
(8, 4, 'simple', NULL, '2014-03-13 00:44:07', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Black', '2014-12-01 00:00:00', NULL, '624.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Black', NULL, '/0/0/00cfg01k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01k.jpg', NULL, '2015-05-29 03:18:42', 'configurable-product-armani-black', 'configurable-product-armani-black.html', 4, '1.0000', NULL, 1),
(9, 4, 'simple', NULL, '2014-03-13 00:44:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Blue', NULL, NULL, '668.9000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Blue', NULL, '/0/0/00cfg01b.jpg', NULL, '2015-01-04 00:00:00', '659.0000', '2034-01-04 00:00:00', 0, '/0/0/00cfg01b.jpg', NULL, '2015-05-29 03:18:31', 'configurable-product-armani-blue', 'configurable-product-armani-blue.html', 4, '1.0000', NULL, 1),
(10, 4, 'simple', NULL, '2014-03-13 00:44:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Green', NULL, NULL, '609.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Green', NULL, '/0/0/00cfg01g.jpg', NULL, '2015-01-04 00:00:00', '521.0000', '2034-12-01 00:00:00', 0, '/0/0/00cfg01g.jpg', NULL, '2015-05-29 03:18:16', 'configurable-product-armani-green', 'configurable-product-armani-green.html', 4, '1.0000', NULL, 1),
(11, 4, 'simple', NULL, '2014-03-13 00:45:18', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry Red', '2014-12-01 00:00:00', NULL, '614.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Red', NULL, '/0/0/00cfg01r.jpg', NULL, '2014-12-01 00:00:00', '599.0000', '1970-01-01 00:00:00', 0, '/0/0/00cfg01r.jpg', NULL, '2015-05-29 03:18:25', 'configurable-product-buberry-red', 'configurable-product-buberry-red.html', 4, '1.0000', NULL, 1),
(12, 4, 'simple', NULL, '2014-03-13 00:45:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry White', '2015-01-04 00:00:00', NULL, '599.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Green', NULL, '/0/0/00cfg01w.jpg', NULL, '2015-01-04 00:00:00', '499.0000', '2035-01-04 00:00:00', 0, '/0/0/00cfg01w.jpg', NULL, '2015-05-29 03:18:48', 'configurable-product-buberry-green', 'configurable-product-buberry-green.html', 4, '1.0000', NULL, 1),
(13, 4, 'configurable', NULL, '2014-12-04 01:56:14', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 02', NULL, NULL, '349.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02', NULL, '/0/0/00cfg02.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02.jpg', NULL, '2015-01-16 00:06:57', 'configurable-product-02', 'configurable-product-02.html', 4, NULL, NULL, 1),
(14, 4, 'simple', NULL, '2014-04-12 01:57:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Black', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Black', NULL, '/0/0/00cfg02k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02k.jpg', NULL, '2015-05-29 03:19:00', 'configurable-product-02-chanel-black', 'configurable-product-02-chanel-black.html', 4, '1.0000', NULL, 1),
(15, 4, 'simple', NULL, '2014-12-04 01:57:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Blue', NULL, NULL, '366.4500', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Blue', NULL, '/0/0/00cfg02b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02b.jpg', NULL, '2015-05-29 03:19:04', 'configurable-product-02-chanel-blue', 'configurable-product-02-chanel-blue.html', 4, '1.0000', NULL, 1),
(16, 4, 'simple', NULL, '2014-12-04 01:58:19', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Dior Green', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Dior-Green', NULL, '/0/0/00cfg02g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02g.jpg', NULL, '2015-05-29 03:19:19', 'configurable-product-02-dior-green', 'configurable-product-02-dior-green.html', 4, '1.0000', NULL, 1),
(17, 4, 'simple', NULL, '2014-04-12 01:59:06', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci Red', NULL, NULL, '367.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-Red', NULL, '/0/0/00cfg02r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02r.jpg', NULL, '2015-05-29 03:13:53', 'configurable-product-02-gucci-red', 'configurable-product-02-gucci-red.html', 4, '1.0000', NULL, 1),
(18, 4, 'simple', NULL, '2014-12-04 01:59:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci White', NULL, NULL, '352.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-White', NULL, '/0/0/00cfg02w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02w.jpg', NULL, '2015-05-29 03:19:12', 'configurable-product-02-gucci-white', 'configurable-product-02-gucci-white.html', 4, '1.0000', NULL, 1),
(19, 4, 'configurable', NULL, '2014-04-12 02:18:40', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 03', NULL, NULL, '399.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03', NULL, '/0/0/00cfg03.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03.jpg', NULL, '2015-03-25 20:28:06', 'configurable-product-03', 'configurable-product-03.html', 4, NULL, NULL, 1),
(20, 4, 'configurable', NULL, '2014-04-12 02:20:25', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 04', NULL, NULL, '99.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04', NULL, '/0/0/00cfg04.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04.jpg', NULL, '2015-01-16 00:16:21', 'configurable-product-04', 'configurable-product-04.html', 4, NULL, NULL, 1),
(21, 4, 'configurable', NULL, '2014-12-04 02:21:54', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 05', NULL, NULL, '179.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05', NULL, '/0/0/00cfg05.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg05.jpg', NULL, '2015-01-16 00:18:27', 'configurable-product-05', 'configurable-product-05.html', 4, NULL, NULL, 1),
(22, 4, 'simple', NULL, '2014-12-04 02:23:05', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Hermes White', NULL, NULL, '410.9700', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Hermes-White', NULL, '/0/0/00cfg03w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03w.jpg', NULL, '2015-05-29 03:09:45', 'configurable-product-03-hermes-white', 'configurable-product-03-hermes-white.html', 4, '1.0000', NULL, 1),
(23, 4, 'simple', NULL, '2014-12-04 02:23:30', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Black', NULL, NULL, '406.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Black', NULL, '/0/0/00cfg03k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03k.jpg', NULL, '2015-05-29 03:19:16', 'configurable-product-03-prada-black', 'configurable-product-03-prada-black.html', 4, '1.0000', NULL, 1),
(24, 4, 'simple', NULL, '2014-12-04 02:24:12', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Versace Blue', NULL, NULL, '442.8900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Versace-Blue', NULL, '/0/0/00cfg03b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03b.jpg', NULL, '2015-05-29 03:14:23', 'configurable-product-03-versace-blue', 'configurable-product-03-versace-blue.html', 4, '1.0000', NULL, 1),
(25, 4, 'simple', NULL, '2014-12-04 02:24:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Green', NULL, NULL, '412.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Green', NULL, '/0/0/00cfg03g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03g.jpg', NULL, '2015-05-29 03:14:15', 'configurable-product-03-prada-green', 'configurable-product-03-prada-green.html', 4, '1.0000', NULL, 1),
(26, 4, 'simple', NULL, '2014-12-04 02:24:59', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Red', NULL, NULL, '417.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Red', NULL, '/0/0/00cfg03r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03r.jpg', NULL, '2015-05-29 03:14:05', 'configurable-product-03-prada-red', 'configurable-product-03-prada-red.html', 4, '1.0000', NULL, 1),
(27, 4, 'simple', NULL, '2014-12-04 02:44:04', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Black', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Black', NULL, '/0/0/00cfg04k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04k.jpg', NULL, '2015-01-16 00:13:22', 'configurable-product-04-black', 'configurable-product-04-black.html', 4, '1.0000', NULL, 1),
(28, 4, 'simple', NULL, '2014-04-12 02:44:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 White', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-White', NULL, '/0/0/00cfg04w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04w.jpg', NULL, '2015-05-29 02:34:13', 'configurable-product-04-white', 'configurable-product-04-white.html', 4, '1.0000', NULL, 1),
(29, 4, 'simple', NULL, '2014-12-04 02:44:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Red', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Red', NULL, '/0/0/00cfg04r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04r.jpg', NULL, '2015-05-29 02:49:20', 'configurable-product-04-red', 'configurable-product-04-red.html', 4, '1.0000', NULL, 1),
(30, 4, 'simple', NULL, '2014-12-04 02:44:41', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Green', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Green', NULL, '/0/0/00cfg04g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04g.jpg', NULL, '2015-05-29 02:49:14', 'configurable-product-04-green', 'configurable-product-04-green.html', 4, '1.0000', NULL, 1),
(31, 4, 'simple', NULL, '2014-12-04 02:45:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Blue', NULL, NULL, '109.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Blue', NULL, '/0/0/00cfg04b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04b.jpg', NULL, '2015-05-29 02:49:06', 'configurable-product-04-blue', 'configurable-product-04-blue.html', 4, '1.0000', NULL, 1),
(32, 4, 'simple', NULL, '2014-12-04 02:51:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Armani', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Armani', NULL, '/0/0/00cfg051.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg051.jpg', NULL, '2015-01-16 00:17:09', 'configurable-product-05-armani', 'configurable-product-05-armani.html', 4, '1.0000', NULL, 1),
(33, 4, 'simple', NULL, '2014-12-04 02:51:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Buberry', NULL, NULL, '199.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Buberry', NULL, '/0/0/00cfg052.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg052.jpg', NULL, '2015-05-29 02:48:57', 'configurable-product-05-buberry', 'configurable-product-05-buberry.html', 4, '1.0000', NULL, 1),
(34, 4, 'simple', NULL, '2014-12-04 02:51:47', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Chanel', NULL, NULL, '209.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Chanel', NULL, '/0/0/00cfg053.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg053.jpg', NULL, '2015-05-29 02:48:48', 'configurable-product-05-chanel', 'configurable-product-05-chanel.html', 4, '1.0000', NULL, 1),
(35, 4, 'simple', NULL, '2014-12-04 02:52:02', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Hermes', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Hermes', NULL, '/0/0/00cfg054.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg054.jpg', NULL, '2015-05-29 02:48:38', 'configurable-product-05-hermes', 'configurable-product-05-hermes.html', 4, '1.0000', NULL, 1),
(36, 4, 'simple', NULL, '2014-12-04 02:52:10', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Versace', NULL, NULL, '194.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Versace', NULL, '/0/0/00cfg055.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg055.jpg', NULL, '2015-05-29 02:48:34', 'configurable-product-05-versace', 'configurable-product-05-versace.html', 4, '1.0000', NULL, 1),
(37, 4, 'simple', NULL, '2014-12-04 03:20:22', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 01', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-01', NULL, '/0/1/01sim0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0105.jpg', NULL, '2015-05-29 02:48:26', 'simple-product-01', 'simple-product-01.html', 4, '1.0000', NULL, 1),
(38, 4, 'simple', NULL, '2014-12-04 03:20:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 02', NULL, NULL, '76.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-02', NULL, '/0/1/01sim0202.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0202.jpg', NULL, '2015-05-29 02:50:09', 'simple-product-02', 'simple-product-02.html', 4, '1.0000', NULL, 1),
(39, 4, 'simple', NULL, '2014-12-04 03:24:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 03', NULL, NULL, '79.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-03', NULL, '/0/1/01sim0305.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0305.jpg', NULL, '2015-05-29 02:48:12', 'simple-product-03', 'simple-product-03.html', 4, '1.0000', NULL, 1),
(40, 4, 'simple', NULL, '2014-04-12 03:26:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 04', NULL, NULL, '119.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-04', NULL, '/0/1/01sim0403.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0403.jpg', NULL, '2015-05-29 02:49:55', 'simple-product-04', 'simple-product-04.html', 4, '1.0000', NULL, 1),
(41, 4, 'simple', NULL, '2014-12-04 03:28:23', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 05', NULL, NULL, '113.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-05', NULL, '/0/1/01sim0503.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0503.jpg', NULL, '2015-05-29 02:50:03', 'simple-product-05', 'simple-product-05.html', 4, '1.0000', NULL, 1),
(42, 4, 'grouped', NULL, '2014-04-12 18:54:46', NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Grouped Product', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'grouped-01', NULL, '/0/2/02group0101.jpg', NULL, NULL, NULL, NULL, NULL, '/0/2/02group0101.jpg', NULL, '2014-12-04 19:07:36', 'grouped-product', 'grouped-product.html', 4, NULL, NULL, 1),
(44, 4, 'bundle', NULL, '2014-12-04 19:21:49', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product', NULL, NULL, NULL, 0, 0, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-01', 0, '/0/4/04bud0102.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0102.jpg', NULL, '2015-01-16 02:00:30', 'bundle-product', 'bundle-product.html', 4, NULL, 0, 1),
(45, 4, 'bundle', NULL, '2014-04-12 19:22:32', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product 02', NULL, NULL, NULL, 0, 1, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-02', 1, '/0/4/04bud0201.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0201.jpg', NULL, '2015-03-18 01:21:39', 'bundle-product-02', 'bundle-product-02.html', 4, '1.0000', 1, 1),
(46, 4, 'downloadable', NULL, '2014-04-12 19:47:25', NULL, 1, NULL, NULL, 1, 1, 'Links', NULL, '4', 2, 'Downloadable Product', NULL, NULL, '1102.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'download-01', NULL, '/0/5/05down0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/5/05down0105.jpg', NULL, '2014-12-04 20:00:46', 'downloadable-product', 'downloadable-product.html', 4, NULL, NULL, 1),
(47, 4, 'simple', NULL, '2014-04-12 20:04:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'No image', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'no-img', NULL, '/0/0/00cfg01b_4.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01b_4.jpg', NULL, '2015-01-19 01:53:21', 'no-image', 'no-image.html', 4, '1.0000', NULL, 1),
(48, 4, 'simple', NULL, '2014-12-04 20:11:59', NULL, 1, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Custom Option', NULL, NULL, '212.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'custom-option', NULL, '/0/6/06custom0104.jpg', NULL, NULL, NULL, NULL, 0, '/0/6/06custom0104.jpg', NULL, '2015-03-24 02:26:45', 'custom-option', 'custom-option.html', 4, '1.0000', NULL, 1),
(49, 4, 'virtual', NULL, '2015-06-12 02:05:00', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Virtual Product', NULL, NULL, '95.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'virtual-01', NULL, '/2/_/2.jpg', NULL, NULL, NULL, NULL, 0, '/2/_/2.jpg', NULL, '2015-06-12 02:05:00', 'virtual-product', 'virtual-product.html', 4, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_flat_2` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type Id',
  `cost` decimal(12,4) DEFAULT NULL COMMENT 'Cost',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `gift_message_available` smallint(6) DEFAULT NULL COMMENT 'Gift Message Available',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `image_label` varchar(255) DEFAULT NULL COMMENT 'Image Label',
  `is_recurring` smallint(6) DEFAULT NULL COMMENT 'Is Recurring',
  `links_exist` int(11) DEFAULT NULL COMMENT 'Links Exist',
  `links_purchased_separately` int(11) DEFAULT NULL COMMENT 'Links Purchased Separately',
  `links_title` varchar(255) DEFAULT NULL COMMENT 'Links Title',
  `msrp` decimal(12,4) DEFAULT NULL COMMENT 'Msrp',
  `msrp_display_actual_price_type` varchar(255) DEFAULT NULL COMMENT 'Msrp Display Actual Price Type',
  `msrp_enabled` smallint(6) DEFAULT NULL COMMENT 'Msrp Enabled',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `news_from_date` datetime DEFAULT NULL COMMENT 'News From Date',
  `news_to_date` datetime DEFAULT NULL COMMENT 'News To Date',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `price_type` int(11) DEFAULT NULL COMMENT 'Price Type',
  `price_view` int(11) DEFAULT NULL COMMENT 'Price View',
  `recurring_profile` text COMMENT 'Recurring Profile',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `shipment_type` int(11) DEFAULT NULL COMMENT 'Shipment Type',
  `short_description` text COMMENT 'Short Description',
  `sku` varchar(64) DEFAULT NULL COMMENT 'Sku',
  `sku_type` int(11) DEFAULT NULL COMMENT 'Sku Type',
  `small_image` varchar(255) DEFAULT NULL COMMENT 'Small Image',
  `small_image_label` varchar(255) DEFAULT NULL COMMENT 'Small Image Label',
  `special_from_date` datetime DEFAULT NULL COMMENT 'Special From Date',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `special_to_date` datetime DEFAULT NULL COMMENT 'Special To Date',
  `tax_class_id` int(10) unsigned DEFAULT NULL COMMENT 'Tax Class Id',
  `thumbnail` varchar(255) DEFAULT NULL COMMENT 'Thumbnail',
  `thumbnail_label` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Label',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path',
  `visibility` smallint(5) unsigned DEFAULT NULL COMMENT 'Visibility',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `weight_type` int(11) DEFAULT NULL COMMENT 'Weight Type',
  `status` smallint(5) unsigned DEFAULT NULL COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Flat (Store 2)';

INSERT INTO `#__catalog_product_flat_2` (`entity_id`, `attribute_set_id`, `type_id`, `cost`, `created_at`, `gift_message_available`, `has_options`, `image_label`, `is_recurring`, `links_exist`, `links_purchased_separately`, `links_title`, `msrp`, `msrp_display_actual_price_type`, `msrp_enabled`, `name`, `news_from_date`, `news_to_date`, `price`, `price_type`, `price_view`, `recurring_profile`, `required_options`, `shipment_type`, `short_description`, `sku`, `sku_type`, `small_image`, `small_image_label`, `special_from_date`, `special_price`, `special_to_date`, `tax_class_id`, `thumbnail`, `thumbnail_label`, `updated_at`, `url_key`, `url_path`, `visibility`, `weight`, `weight_type`, `status`) VALUES
(7, 4, 'configurable', NULL, '2014-03-13 00:42:03', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product', NULL, NULL, '599.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01', NULL, '/0/0/00cfg01.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01.jpg', NULL, '2015-01-23 19:45:25', 'configurable-product', 'configurable-product.html', 4, NULL, NULL, 1),
(8, 4, 'simple', NULL, '2014-03-13 00:44:07', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Black', '2014-12-01 00:00:00', NULL, '624.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Black', NULL, '/0/0/00cfg01k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01k.jpg', NULL, '2015-05-29 03:18:42', 'configurable-product-armani-black', 'configurable-product-armani-black.html', 4, '1.0000', NULL, 1),
(9, 4, 'simple', NULL, '2014-03-13 00:44:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Blue', NULL, NULL, '668.9000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Blue', NULL, '/0/0/00cfg01b.jpg', NULL, '2015-01-04 00:00:00', '659.0000', '2034-01-04 00:00:00', 0, '/0/0/00cfg01b.jpg', NULL, '2015-05-29 03:18:31', 'configurable-product-armani-blue', 'configurable-product-armani-blue.html', 4, '1.0000', NULL, 1),
(10, 4, 'simple', NULL, '2014-03-13 00:44:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Green', NULL, NULL, '609.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Green', NULL, '/0/0/00cfg01g.jpg', NULL, '2015-01-04 00:00:00', '521.0000', '2034-12-01 00:00:00', 0, '/0/0/00cfg01g.jpg', NULL, '2015-05-29 03:18:16', 'configurable-product-armani-green', 'configurable-product-armani-green.html', 4, '1.0000', NULL, 1),
(11, 4, 'simple', NULL, '2014-03-13 00:45:18', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry Red', '2014-12-01 00:00:00', NULL, '614.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Red', NULL, '/0/0/00cfg01r.jpg', NULL, '2014-12-01 00:00:00', '599.0000', '1970-01-01 00:00:00', 0, '/0/0/00cfg01r.jpg', NULL, '2015-05-29 03:18:25', 'configurable-product-buberry-red', 'configurable-product-buberry-red.html', 4, '1.0000', NULL, 1),
(12, 4, 'simple', NULL, '2014-03-13 00:45:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry White', '2015-01-04 00:00:00', NULL, '599.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Green', NULL, '/0/0/00cfg01w.jpg', NULL, '2015-01-04 00:00:00', '499.0000', '2035-01-04 00:00:00', 0, '/0/0/00cfg01w.jpg', NULL, '2015-05-29 03:18:48', 'configurable-product-buberry-green', 'configurable-product-buberry-green.html', 4, '1.0000', NULL, 1),
(13, 4, 'configurable', NULL, '2014-12-04 01:56:14', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 02', NULL, NULL, '349.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02', NULL, '/0/0/00cfg02.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02.jpg', NULL, '2015-01-16 00:06:57', 'configurable-product-02', 'configurable-product-02.html', 4, NULL, NULL, 1),
(14, 4, 'simple', NULL, '2014-04-12 01:57:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Black', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Black', NULL, '/0/0/00cfg02k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02k.jpg', NULL, '2015-05-29 03:19:00', 'configurable-product-02-chanel-black', 'configurable-product-02-chanel-black.html', 4, '1.0000', NULL, 1),
(15, 4, 'simple', NULL, '2014-12-04 01:57:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Blue', NULL, NULL, '366.4500', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Blue', NULL, '/0/0/00cfg02b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02b.jpg', NULL, '2015-05-29 03:19:04', 'configurable-product-02-chanel-blue', 'configurable-product-02-chanel-blue.html', 4, '1.0000', NULL, 1),
(16, 4, 'simple', NULL, '2014-12-04 01:58:19', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Dior Green', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Dior-Green', NULL, '/0/0/00cfg02g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02g.jpg', NULL, '2015-05-29 03:19:19', 'configurable-product-02-dior-green', 'configurable-product-02-dior-green.html', 4, '1.0000', NULL, 1),
(17, 4, 'simple', NULL, '2014-04-12 01:59:06', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci Red', NULL, NULL, '367.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-Red', NULL, '/0/0/00cfg02r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02r.jpg', NULL, '2015-05-29 03:13:53', 'configurable-product-02-gucci-red', 'configurable-product-02-gucci-red.html', 4, '1.0000', NULL, 1),
(18, 4, 'simple', NULL, '2014-12-04 01:59:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci White', NULL, NULL, '352.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-White', NULL, '/0/0/00cfg02w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02w.jpg', NULL, '2015-05-29 03:19:12', 'configurable-product-02-gucci-white', 'configurable-product-02-gucci-white.html', 4, '1.0000', NULL, 1),
(19, 4, 'configurable', NULL, '2014-04-12 02:18:40', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 03', NULL, NULL, '399.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03', NULL, '/0/0/00cfg03.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03.jpg', NULL, '2015-03-25 20:28:06', 'configurable-product-03', 'configurable-product-03.html', 4, NULL, NULL, 1),
(20, 4, 'configurable', NULL, '2014-04-12 02:20:25', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 04', NULL, NULL, '99.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04', NULL, '/0/0/00cfg04.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04.jpg', NULL, '2015-01-16 00:16:21', 'configurable-product-04', 'configurable-product-04.html', 4, NULL, NULL, 1),
(21, 4, 'configurable', NULL, '2014-12-04 02:21:54', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 05', NULL, NULL, '179.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05', NULL, '/0/0/00cfg05.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg05.jpg', NULL, '2015-01-16 00:18:27', 'configurable-product-05', 'configurable-product-05.html', 4, NULL, NULL, 1),
(22, 4, 'simple', NULL, '2014-12-04 02:23:05', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Hermes White', NULL, NULL, '410.9700', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Hermes-White', NULL, '/0/0/00cfg03w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03w.jpg', NULL, '2015-05-29 03:09:45', 'configurable-product-03-hermes-white', 'configurable-product-03-hermes-white.html', 4, '1.0000', NULL, 1),
(23, 4, 'simple', NULL, '2014-12-04 02:23:30', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Black', NULL, NULL, '406.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Black', NULL, '/0/0/00cfg03k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03k.jpg', NULL, '2015-05-29 03:19:16', 'configurable-product-03-prada-black', 'configurable-product-03-prada-black.html', 4, '1.0000', NULL, 1),
(24, 4, 'simple', NULL, '2014-12-04 02:24:12', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Versace Blue', NULL, NULL, '442.8900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Versace-Blue', NULL, '/0/0/00cfg03b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03b.jpg', NULL, '2015-05-29 03:14:23', 'configurable-product-03-versace-blue', 'configurable-product-03-versace-blue.html', 4, '1.0000', NULL, 1),
(25, 4, 'simple', NULL, '2014-12-04 02:24:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Green', NULL, NULL, '412.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Green', NULL, '/0/0/00cfg03g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03g.jpg', NULL, '2015-05-29 03:14:15', 'configurable-product-03-prada-green', 'configurable-product-03-prada-green.html', 4, '1.0000', NULL, 1),
(26, 4, 'simple', NULL, '2014-12-04 02:24:59', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Red', NULL, NULL, '417.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Red', NULL, '/0/0/00cfg03r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03r.jpg', NULL, '2015-05-29 03:14:05', 'configurable-product-03-prada-red', 'configurable-product-03-prada-red.html', 4, '1.0000', NULL, 1),
(27, 4, 'simple', NULL, '2014-12-04 02:44:04', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Black', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Black', NULL, '/0/0/00cfg04k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04k.jpg', NULL, '2015-01-16 00:13:22', 'configurable-product-04-black', 'configurable-product-04-black.html', 4, '1.0000', NULL, 1),
(28, 4, 'simple', NULL, '2014-04-12 02:44:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 White', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-White', NULL, '/0/0/00cfg04w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04w.jpg', NULL, '2015-05-29 02:34:13', 'configurable-product-04-white', 'configurable-product-04-white.html', 4, '1.0000', NULL, 1),
(29, 4, 'simple', NULL, '2014-12-04 02:44:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Red', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Red', NULL, '/0/0/00cfg04r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04r.jpg', NULL, '2015-05-29 02:49:20', 'configurable-product-04-red', 'configurable-product-04-red.html', 4, '1.0000', NULL, 1),
(30, 4, 'simple', NULL, '2014-12-04 02:44:41', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Green', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Green', NULL, '/0/0/00cfg04g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04g.jpg', NULL, '2015-05-29 02:49:14', 'configurable-product-04-green', 'configurable-product-04-green.html', 4, '1.0000', NULL, 1),
(31, 4, 'simple', NULL, '2014-12-04 02:45:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Blue', NULL, NULL, '109.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Blue', NULL, '/0/0/00cfg04b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04b.jpg', NULL, '2015-05-29 02:49:06', 'configurable-product-04-blue', 'configurable-product-04-blue.html', 4, '1.0000', NULL, 1),
(32, 4, 'simple', NULL, '2014-12-04 02:51:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Armani', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Armani', NULL, '/0/0/00cfg051.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg051.jpg', NULL, '2015-01-16 00:17:09', 'configurable-product-05-armani', 'configurable-product-05-armani.html', 4, '1.0000', NULL, 1),
(33, 4, 'simple', NULL, '2014-12-04 02:51:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Buberry', NULL, NULL, '199.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Buberry', NULL, '/0/0/00cfg052.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg052.jpg', NULL, '2015-05-29 02:48:57', 'configurable-product-05-buberry', 'configurable-product-05-buberry.html', 4, '1.0000', NULL, 1),
(34, 4, 'simple', NULL, '2014-12-04 02:51:47', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Chanel', NULL, NULL, '209.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Chanel', NULL, '/0/0/00cfg053.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg053.jpg', NULL, '2015-05-29 02:48:48', 'configurable-product-05-chanel', 'configurable-product-05-chanel.html', 4, '1.0000', NULL, 1),
(35, 4, 'simple', NULL, '2014-12-04 02:52:02', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Hermes', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Hermes', NULL, '/0/0/00cfg054.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg054.jpg', NULL, '2015-05-29 02:48:38', 'configurable-product-05-hermes', 'configurable-product-05-hermes.html', 4, '1.0000', NULL, 1),
(36, 4, 'simple', NULL, '2014-12-04 02:52:10', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Versace', NULL, NULL, '194.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Versace', NULL, '/0/0/00cfg055.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg055.jpg', NULL, '2015-05-29 02:48:34', 'configurable-product-05-versace', 'configurable-product-05-versace.html', 4, '1.0000', NULL, 1),
(37, 4, 'simple', NULL, '2014-12-04 03:20:22', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 01', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-01', NULL, '/0/1/01sim0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0105.jpg', NULL, '2015-05-29 02:48:26', 'simple-product-01', 'simple-product-01.html', 4, '1.0000', NULL, 1),
(38, 4, 'simple', NULL, '2014-12-04 03:20:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 02', NULL, NULL, '76.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-02', NULL, '/0/1/01sim0202.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0202.jpg', NULL, '2015-05-29 02:50:09', 'simple-product-02', 'simple-product-02.html', 4, '1.0000', NULL, 1),
(39, 4, 'simple', NULL, '2014-12-04 03:24:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 03', NULL, NULL, '79.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-03', NULL, '/0/1/01sim0305.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0305.jpg', NULL, '2015-05-29 02:48:12', 'simple-product-03', 'simple-product-03.html', 4, '1.0000', NULL, 1),
(40, 4, 'simple', NULL, '2014-04-12 03:26:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 04', NULL, NULL, '119.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-04', NULL, '/0/1/01sim0403.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0403.jpg', NULL, '2015-05-29 02:49:55', 'simple-product-04', 'simple-product-04.html', 4, '1.0000', NULL, 1),
(41, 4, 'simple', NULL, '2014-12-04 03:28:23', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 05', NULL, NULL, '113.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-05', NULL, '/0/1/01sim0503.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0503.jpg', NULL, '2015-05-29 02:50:03', 'simple-product-05', 'simple-product-05.html', 4, '1.0000', NULL, 1),
(42, 4, 'grouped', NULL, '2014-04-12 18:54:46', NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Grouped Product', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'grouped-01', NULL, '/0/2/02group0101.jpg', NULL, NULL, NULL, NULL, NULL, '/0/2/02group0101.jpg', NULL, '2014-12-04 19:07:36', 'grouped-product', 'grouped-product.html', 4, NULL, NULL, 1),
(44, 4, 'bundle', NULL, '2014-12-04 19:21:49', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product', NULL, NULL, NULL, 0, 0, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-01', 0, '/0/4/04bud0102.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0102.jpg', NULL, '2015-01-16 02:00:30', 'bundle-product', 'bundle-product.html', 4, NULL, 0, 1),
(45, 4, 'bundle', NULL, '2014-04-12 19:22:32', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product 02', NULL, NULL, NULL, 0, 1, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-02', 1, '/0/4/04bud0201.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0201.jpg', NULL, '2015-03-18 01:21:39', 'bundle-product-02', 'bundle-product-02.html', 4, '1.0000', 1, 1),
(46, 4, 'downloadable', NULL, '2014-04-12 19:47:25', NULL, 1, NULL, NULL, 1, 1, 'Links', NULL, '4', 2, 'Downloadable Product', NULL, NULL, '1102.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'download-01', NULL, '/0/5/05down0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/5/05down0105.jpg', NULL, '2014-12-04 20:00:46', 'downloadable-product', 'downloadable-product.html', 4, NULL, NULL, 1),
(47, 4, 'simple', NULL, '2014-04-12 20:04:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'No image', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'no-img', NULL, '/0/0/00cfg01b_4.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01b_4.jpg', NULL, '2015-01-19 01:53:21', 'no-image', 'no-image.html', 4, '1.0000', NULL, 1),
(48, 4, 'simple', NULL, '2014-12-04 20:11:59', NULL, 1, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Custom Option', NULL, NULL, '212.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'custom-option', NULL, '/0/6/06custom0104.jpg', NULL, NULL, NULL, NULL, 0, '/0/6/06custom0104.jpg', NULL, '2015-03-24 02:26:45', 'custom-option', 'custom-option.html', 4, '1.0000', NULL, 1),
(49, 4, 'virtual', NULL, '2015-06-12 02:05:00', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Virtual Product', NULL, NULL, '95.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'virtual-01', NULL, '/2/_/2.jpg', NULL, NULL, NULL, NULL, 0, '/2/_/2.jpg', NULL, '2015-06-12 02:05:00', 'virtual-product', 'virtual-product.html', 4, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_flat_3` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type Id',
  `cost` decimal(12,4) DEFAULT NULL COMMENT 'Cost',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `gift_message_available` smallint(6) DEFAULT NULL COMMENT 'Gift Message Available',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `image_label` varchar(255) DEFAULT NULL COMMENT 'Image Label',
  `is_recurring` smallint(6) DEFAULT NULL COMMENT 'Is Recurring',
  `links_exist` int(11) DEFAULT NULL COMMENT 'Links Exist',
  `links_purchased_separately` int(11) DEFAULT NULL COMMENT 'Links Purchased Separately',
  `links_title` varchar(255) DEFAULT NULL COMMENT 'Links Title',
  `msrp` decimal(12,4) DEFAULT NULL COMMENT 'Msrp',
  `msrp_display_actual_price_type` varchar(255) DEFAULT NULL COMMENT 'Msrp Display Actual Price Type',
  `msrp_enabled` smallint(6) DEFAULT NULL COMMENT 'Msrp Enabled',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `news_from_date` datetime DEFAULT NULL COMMENT 'News From Date',
  `news_to_date` datetime DEFAULT NULL COMMENT 'News To Date',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `price_type` int(11) DEFAULT NULL COMMENT 'Price Type',
  `price_view` int(11) DEFAULT NULL COMMENT 'Price View',
  `recurring_profile` text COMMENT 'Recurring Profile',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `shipment_type` int(11) DEFAULT NULL COMMENT 'Shipment Type',
  `short_description` text COMMENT 'Short Description',
  `sku` varchar(64) DEFAULT NULL COMMENT 'Sku',
  `sku_type` int(11) DEFAULT NULL COMMENT 'Sku Type',
  `small_image` varchar(255) DEFAULT NULL COMMENT 'Small Image',
  `small_image_label` varchar(255) DEFAULT NULL COMMENT 'Small Image Label',
  `special_from_date` datetime DEFAULT NULL COMMENT 'Special From Date',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `special_to_date` datetime DEFAULT NULL COMMENT 'Special To Date',
  `tax_class_id` int(10) unsigned DEFAULT NULL COMMENT 'Tax Class Id',
  `thumbnail` varchar(255) DEFAULT NULL COMMENT 'Thumbnail',
  `thumbnail_label` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Label',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path',
  `visibility` smallint(5) unsigned DEFAULT NULL COMMENT 'Visibility',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `weight_type` int(11) DEFAULT NULL COMMENT 'Weight Type',
  `status` smallint(5) unsigned DEFAULT NULL COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Flat (Store 3)';

INSERT INTO `#__catalog_product_flat_3` (`entity_id`, `attribute_set_id`, `type_id`, `cost`, `created_at`, `gift_message_available`, `has_options`, `image_label`, `is_recurring`, `links_exist`, `links_purchased_separately`, `links_title`, `msrp`, `msrp_display_actual_price_type`, `msrp_enabled`, `name`, `news_from_date`, `news_to_date`, `price`, `price_type`, `price_view`, `recurring_profile`, `required_options`, `shipment_type`, `short_description`, `sku`, `sku_type`, `small_image`, `small_image_label`, `special_from_date`, `special_price`, `special_to_date`, `tax_class_id`, `thumbnail`, `thumbnail_label`, `updated_at`, `url_key`, `url_path`, `visibility`, `weight`, `weight_type`, `status`) VALUES
(7, 4, 'configurable', NULL, '2014-03-13 00:42:03', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product', NULL, NULL, '599.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01', NULL, '/0/0/00cfg01.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01.jpg', NULL, '2015-01-23 19:45:25', 'configurable-product', 'configurable-product.html', 4, NULL, NULL, 1),
(8, 4, 'simple', NULL, '2014-03-13 00:44:07', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Black', '2014-12-01 00:00:00', NULL, '624.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Black', NULL, '/0/0/00cfg01k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01k.jpg', NULL, '2015-05-29 03:18:42', 'configurable-product-armani-black', 'configurable-product-armani-black.html', 4, '1.0000', NULL, 1),
(9, 4, 'simple', NULL, '2014-03-13 00:44:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Blue', NULL, NULL, '668.9000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Blue', NULL, '/0/0/00cfg01b.jpg', NULL, '2015-01-04 00:00:00', '659.0000', '2034-01-04 00:00:00', 0, '/0/0/00cfg01b.jpg', NULL, '2015-05-29 03:18:31', 'configurable-product-armani-blue', 'configurable-product-armani-blue.html', 4, '1.0000', NULL, 1),
(10, 4, 'simple', NULL, '2014-03-13 00:44:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Green', NULL, NULL, '609.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Green', NULL, '/0/0/00cfg01g.jpg', NULL, '2015-01-04 00:00:00', '521.0000', '2034-12-01 00:00:00', 0, '/0/0/00cfg01g.jpg', NULL, '2015-05-29 03:18:16', 'configurable-product-armani-green', 'configurable-product-armani-green.html', 4, '1.0000', NULL, 1),
(11, 4, 'simple', NULL, '2014-03-13 00:45:18', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry Red', '2014-12-01 00:00:00', NULL, '614.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Red', NULL, '/0/0/00cfg01r.jpg', NULL, '2014-12-01 00:00:00', '599.0000', '1970-01-01 00:00:00', 0, '/0/0/00cfg01r.jpg', NULL, '2015-05-29 03:18:25', 'configurable-product-buberry-red', 'configurable-product-buberry-red.html', 4, '1.0000', NULL, 1),
(12, 4, 'simple', NULL, '2014-03-13 00:45:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry White', '2015-01-04 00:00:00', NULL, '599.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Green', NULL, '/0/0/00cfg01w.jpg', NULL, '2015-01-04 00:00:00', '499.0000', '2035-01-04 00:00:00', 0, '/0/0/00cfg01w.jpg', NULL, '2015-05-29 03:18:48', 'configurable-product-buberry-green', 'configurable-product-buberry-green.html', 4, '1.0000', NULL, 1),
(13, 4, 'configurable', NULL, '2014-12-04 01:56:14', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 02', NULL, NULL, '349.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02', NULL, '/0/0/00cfg02.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02.jpg', NULL, '2015-01-16 00:06:57', 'configurable-product-02', 'configurable-product-02.html', 4, NULL, NULL, 1),
(14, 4, 'simple', NULL, '2014-04-12 01:57:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Black', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Black', NULL, '/0/0/00cfg02k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02k.jpg', NULL, '2015-05-29 03:19:00', 'configurable-product-02-chanel-black', 'configurable-product-02-chanel-black.html', 4, '1.0000', NULL, 1),
(15, 4, 'simple', NULL, '2014-12-04 01:57:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Blue', NULL, NULL, '366.4500', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Blue', NULL, '/0/0/00cfg02b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02b.jpg', NULL, '2015-05-29 03:19:04', 'configurable-product-02-chanel-blue', 'configurable-product-02-chanel-blue.html', 4, '1.0000', NULL, 1),
(16, 4, 'simple', NULL, '2014-12-04 01:58:19', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Dior Green', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Dior-Green', NULL, '/0/0/00cfg02g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02g.jpg', NULL, '2015-05-29 03:19:19', 'configurable-product-02-dior-green', 'configurable-product-02-dior-green.html', 4, '1.0000', NULL, 1),
(17, 4, 'simple', NULL, '2014-04-12 01:59:06', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci Red', NULL, NULL, '367.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-Red', NULL, '/0/0/00cfg02r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02r.jpg', NULL, '2015-05-29 03:13:53', 'configurable-product-02-gucci-red', 'configurable-product-02-gucci-red.html', 4, '1.0000', NULL, 1),
(18, 4, 'simple', NULL, '2014-12-04 01:59:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci White', NULL, NULL, '352.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-White', NULL, '/0/0/00cfg02w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02w.jpg', NULL, '2015-05-29 03:19:12', 'configurable-product-02-gucci-white', 'configurable-product-02-gucci-white.html', 4, '1.0000', NULL, 1),
(19, 4, 'configurable', NULL, '2014-04-12 02:18:40', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 03', NULL, NULL, '399.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03', NULL, '/0/0/00cfg03.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03.jpg', NULL, '2015-03-25 20:28:06', 'configurable-product-03', 'configurable-product-03.html', 4, NULL, NULL, 1),
(20, 4, 'configurable', NULL, '2014-04-12 02:20:25', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 04', NULL, NULL, '99.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04', NULL, '/0/0/00cfg04.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04.jpg', NULL, '2015-01-16 00:16:21', 'configurable-product-04', 'configurable-product-04.html', 4, NULL, NULL, 1),
(21, 4, 'configurable', NULL, '2014-12-04 02:21:54', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 05', NULL, NULL, '179.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05', NULL, '/0/0/00cfg05.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg05.jpg', NULL, '2015-01-16 00:18:27', 'configurable-product-05', 'configurable-product-05.html', 4, NULL, NULL, 1),
(22, 4, 'simple', NULL, '2014-12-04 02:23:05', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Hermes White', NULL, NULL, '410.9700', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Hermes-White', NULL, '/0/0/00cfg03w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03w.jpg', NULL, '2015-05-29 03:09:45', 'configurable-product-03-hermes-white', 'configurable-product-03-hermes-white.html', 4, '1.0000', NULL, 1),
(23, 4, 'simple', NULL, '2014-12-04 02:23:30', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Black', NULL, NULL, '406.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Black', NULL, '/0/0/00cfg03k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03k.jpg', NULL, '2015-05-29 03:19:16', 'configurable-product-03-prada-black', 'configurable-product-03-prada-black.html', 4, '1.0000', NULL, 1),
(24, 4, 'simple', NULL, '2014-12-04 02:24:12', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Versace Blue', NULL, NULL, '442.8900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Versace-Blue', NULL, '/0/0/00cfg03b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03b.jpg', NULL, '2015-05-29 03:14:23', 'configurable-product-03-versace-blue', 'configurable-product-03-versace-blue.html', 4, '1.0000', NULL, 1),
(25, 4, 'simple', NULL, '2014-12-04 02:24:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Green', NULL, NULL, '412.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Green', NULL, '/0/0/00cfg03g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03g.jpg', NULL, '2015-05-29 03:14:15', 'configurable-product-03-prada-green', 'configurable-product-03-prada-green.html', 4, '1.0000', NULL, 1),
(26, 4, 'simple', NULL, '2014-12-04 02:24:59', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Red', NULL, NULL, '417.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Red', NULL, '/0/0/00cfg03r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03r.jpg', NULL, '2015-05-29 03:14:05', 'configurable-product-03-prada-red', 'configurable-product-03-prada-red.html', 4, '1.0000', NULL, 1),
(27, 4, 'simple', NULL, '2014-12-04 02:44:04', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Black', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Black', NULL, '/0/0/00cfg04k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04k.jpg', NULL, '2015-01-16 00:13:22', 'configurable-product-04-black', 'configurable-product-04-black.html', 4, '1.0000', NULL, 1),
(28, 4, 'simple', NULL, '2014-04-12 02:44:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 White', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-White', NULL, '/0/0/00cfg04w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04w.jpg', NULL, '2015-05-29 02:34:13', 'configurable-product-04-white', 'configurable-product-04-white.html', 4, '1.0000', NULL, 1),
(29, 4, 'simple', NULL, '2014-12-04 02:44:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Red', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Red', NULL, '/0/0/00cfg04r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04r.jpg', NULL, '2015-05-29 02:49:20', 'configurable-product-04-red', 'configurable-product-04-red.html', 4, '1.0000', NULL, 1),
(30, 4, 'simple', NULL, '2014-12-04 02:44:41', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Green', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Green', NULL, '/0/0/00cfg04g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04g.jpg', NULL, '2015-05-29 02:49:14', 'configurable-product-04-green', 'configurable-product-04-green.html', 4, '1.0000', NULL, 1),
(31, 4, 'simple', NULL, '2014-12-04 02:45:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Blue', NULL, NULL, '109.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Blue', NULL, '/0/0/00cfg04b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04b.jpg', NULL, '2015-05-29 02:49:06', 'configurable-product-04-blue', 'configurable-product-04-blue.html', 4, '1.0000', NULL, 1),
(32, 4, 'simple', NULL, '2014-12-04 02:51:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Armani', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Armani', NULL, '/0/0/00cfg051.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg051.jpg', NULL, '2015-01-16 00:17:09', 'configurable-product-05-armani', 'configurable-product-05-armani.html', 4, '1.0000', NULL, 1),
(33, 4, 'simple', NULL, '2014-12-04 02:51:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Buberry', NULL, NULL, '199.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Buberry', NULL, '/0/0/00cfg052.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg052.jpg', NULL, '2015-05-29 02:48:57', 'configurable-product-05-buberry', 'configurable-product-05-buberry.html', 4, '1.0000', NULL, 1),
(34, 4, 'simple', NULL, '2014-12-04 02:51:47', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Chanel', NULL, NULL, '209.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Chanel', NULL, '/0/0/00cfg053.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg053.jpg', NULL, '2015-05-29 02:48:48', 'configurable-product-05-chanel', 'configurable-product-05-chanel.html', 4, '1.0000', NULL, 1),
(35, 4, 'simple', NULL, '2014-12-04 02:52:02', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Hermes', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Hermes', NULL, '/0/0/00cfg054.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg054.jpg', NULL, '2015-05-29 02:48:38', 'configurable-product-05-hermes', 'configurable-product-05-hermes.html', 4, '1.0000', NULL, 1),
(36, 4, 'simple', NULL, '2014-12-04 02:52:10', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Versace', NULL, NULL, '194.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Versace', NULL, '/0/0/00cfg055.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg055.jpg', NULL, '2015-05-29 02:48:34', 'configurable-product-05-versace', 'configurable-product-05-versace.html', 4, '1.0000', NULL, 1),
(37, 4, 'simple', NULL, '2014-12-04 03:20:22', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 01', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-01', NULL, '/0/1/01sim0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0105.jpg', NULL, '2015-05-29 02:48:26', 'simple-product-01', 'simple-product-01.html', 4, '1.0000', NULL, 1),
(38, 4, 'simple', NULL, '2014-12-04 03:20:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 02', NULL, NULL, '76.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-02', NULL, '/0/1/01sim0202.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0202.jpg', NULL, '2015-05-29 02:50:09', 'simple-product-02', 'simple-product-02.html', 4, '1.0000', NULL, 1),
(39, 4, 'simple', NULL, '2014-12-04 03:24:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 03', NULL, NULL, '79.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-03', NULL, '/0/1/01sim0305.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0305.jpg', NULL, '2015-05-29 02:48:12', 'simple-product-03', 'simple-product-03.html', 4, '1.0000', NULL, 1),
(40, 4, 'simple', NULL, '2014-04-12 03:26:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 04', NULL, NULL, '119.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-04', NULL, '/0/1/01sim0403.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0403.jpg', NULL, '2015-05-29 02:49:55', 'simple-product-04', 'simple-product-04.html', 4, '1.0000', NULL, 1),
(41, 4, 'simple', NULL, '2014-12-04 03:28:23', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 05', NULL, NULL, '113.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-05', NULL, '/0/1/01sim0503.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0503.jpg', NULL, '2015-05-29 02:50:03', 'simple-product-05', 'simple-product-05.html', 4, '1.0000', NULL, 1),
(42, 4, 'grouped', NULL, '2014-04-12 18:54:46', NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Grouped Product', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'grouped-01', NULL, '/0/2/02group0101.jpg', NULL, NULL, NULL, NULL, NULL, '/0/2/02group0101.jpg', NULL, '2014-12-04 19:07:36', 'grouped-product', 'grouped-product.html', 4, NULL, NULL, 1),
(44, 4, 'bundle', NULL, '2014-12-04 19:21:49', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product', NULL, NULL, NULL, 0, 0, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-01', 0, '/0/4/04bud0102.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0102.jpg', NULL, '2015-01-16 02:00:30', 'bundle-product', 'bundle-product.html', 4, NULL, 0, 1),
(45, 4, 'bundle', NULL, '2014-04-12 19:22:32', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product 02', NULL, NULL, NULL, 0, 1, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-02', 1, '/0/4/04bud0201.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0201.jpg', NULL, '2015-03-18 01:21:39', 'bundle-product-02', 'bundle-product-02.html', 4, '1.0000', 1, 1),
(46, 4, 'downloadable', NULL, '2014-04-12 19:47:25', NULL, 1, NULL, NULL, 1, 1, 'Links', NULL, '4', 2, 'Downloadable Product', NULL, NULL, '1102.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'download-01', NULL, '/0/5/05down0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/5/05down0105.jpg', NULL, '2014-12-04 20:00:46', 'downloadable-product', 'downloadable-product.html', 4, NULL, NULL, 1),
(47, 4, 'simple', NULL, '2014-04-12 20:04:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'No image', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'no-img', NULL, '/0/0/00cfg01b_4.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01b_4.jpg', NULL, '2015-01-19 01:53:21', 'no-image', 'no-image.html', 4, '1.0000', NULL, 1),
(48, 4, 'simple', NULL, '2014-12-04 20:11:59', NULL, 1, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Custom Option', NULL, NULL, '212.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'custom-option', NULL, '/0/6/06custom0104.jpg', NULL, NULL, NULL, NULL, 0, '/0/6/06custom0104.jpg', NULL, '2015-03-24 02:26:45', 'custom-option', 'custom-option.html', 4, '1.0000', NULL, 1),
(49, 4, 'virtual', NULL, '2015-06-12 02:05:00', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Virtual Product', NULL, NULL, '95.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'virtual-01', NULL, '/2/_/2.jpg', NULL, NULL, NULL, NULL, 0, '/2/_/2.jpg', NULL, '2015-06-12 02:05:00', 'virtual-product', 'virtual-product.html', 4, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_flat_4` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type Id',
  `cost` decimal(12,4) DEFAULT NULL COMMENT 'Cost',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `gift_message_available` smallint(6) DEFAULT NULL COMMENT 'Gift Message Available',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `image_label` varchar(255) DEFAULT NULL COMMENT 'Image Label',
  `is_recurring` smallint(6) DEFAULT NULL COMMENT 'Is Recurring',
  `links_exist` int(11) DEFAULT NULL COMMENT 'Links Exist',
  `links_purchased_separately` int(11) DEFAULT NULL COMMENT 'Links Purchased Separately',
  `links_title` varchar(255) DEFAULT NULL COMMENT 'Links Title',
  `msrp` decimal(12,4) DEFAULT NULL COMMENT 'Msrp',
  `msrp_display_actual_price_type` varchar(255) DEFAULT NULL COMMENT 'Msrp Display Actual Price Type',
  `msrp_enabled` smallint(6) DEFAULT NULL COMMENT 'Msrp Enabled',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `news_from_date` datetime DEFAULT NULL COMMENT 'News From Date',
  `news_to_date` datetime DEFAULT NULL COMMENT 'News To Date',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `price_type` int(11) DEFAULT NULL COMMENT 'Price Type',
  `price_view` int(11) DEFAULT NULL COMMENT 'Price View',
  `recurring_profile` text COMMENT 'Recurring Profile',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `shipment_type` int(11) DEFAULT NULL COMMENT 'Shipment Type',
  `short_description` text COMMENT 'Short Description',
  `sku` varchar(64) DEFAULT NULL COMMENT 'Sku',
  `sku_type` int(11) DEFAULT NULL COMMENT 'Sku Type',
  `small_image` varchar(255) DEFAULT NULL COMMENT 'Small Image',
  `small_image_label` varchar(255) DEFAULT NULL COMMENT 'Small Image Label',
  `special_from_date` datetime DEFAULT NULL COMMENT 'Special From Date',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `special_to_date` datetime DEFAULT NULL COMMENT 'Special To Date',
  `tax_class_id` int(10) unsigned DEFAULT NULL COMMENT 'Tax Class Id',
  `thumbnail` varchar(255) DEFAULT NULL COMMENT 'Thumbnail',
  `thumbnail_label` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Label',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path',
  `visibility` smallint(5) unsigned DEFAULT NULL COMMENT 'Visibility',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `weight_type` int(11) DEFAULT NULL COMMENT 'Weight Type',
  `status` smallint(5) unsigned DEFAULT NULL COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Flat (Store 4)';

INSERT INTO `#__catalog_product_flat_4` (`entity_id`, `attribute_set_id`, `type_id`, `cost`, `created_at`, `gift_message_available`, `has_options`, `image_label`, `is_recurring`, `links_exist`, `links_purchased_separately`, `links_title`, `msrp`, `msrp_display_actual_price_type`, `msrp_enabled`, `name`, `news_from_date`, `news_to_date`, `price`, `price_type`, `price_view`, `recurring_profile`, `required_options`, `shipment_type`, `short_description`, `sku`, `sku_type`, `small_image`, `small_image_label`, `special_from_date`, `special_price`, `special_to_date`, `tax_class_id`, `thumbnail`, `thumbnail_label`, `updated_at`, `url_key`, `url_path`, `visibility`, `weight`, `weight_type`, `status`) VALUES
(7, 4, 'configurable', NULL, '2014-03-13 00:42:03', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product', NULL, NULL, '599.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01', NULL, '/0/0/00cfg01.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01.jpg', NULL, '2015-01-23 19:45:25', 'configurable-product', 'configurable-product.html', 4, NULL, NULL, 1),
(8, 4, 'simple', NULL, '2014-03-13 00:44:07', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Black', '2014-12-01 00:00:00', NULL, '624.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Black', NULL, '/0/0/00cfg01k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01k.jpg', NULL, '2015-05-29 03:18:42', 'configurable-product-armani-black', 'configurable-product-armani-black.html', 4, '1.0000', NULL, 1),
(9, 4, 'simple', NULL, '2014-03-13 00:44:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Blue', NULL, NULL, '668.9000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Blue', NULL, '/0/0/00cfg01b.jpg', NULL, '2015-01-04 00:00:00', '659.0000', '2034-01-04 00:00:00', 0, '/0/0/00cfg01b.jpg', NULL, '2015-05-29 03:18:31', 'configurable-product-armani-blue', 'configurable-product-armani-blue.html', 4, '1.0000', NULL, 1),
(10, 4, 'simple', NULL, '2014-03-13 00:44:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Green', NULL, NULL, '609.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Green', NULL, '/0/0/00cfg01g.jpg', NULL, '2015-01-04 00:00:00', '521.0000', '2034-12-01 00:00:00', 0, '/0/0/00cfg01g.jpg', NULL, '2015-05-29 03:18:16', 'configurable-product-armani-green', 'configurable-product-armani-green.html', 4, '1.0000', NULL, 1),
(11, 4, 'simple', NULL, '2014-03-13 00:45:18', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry Red', '2014-12-01 00:00:00', NULL, '614.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Red', NULL, '/0/0/00cfg01r.jpg', NULL, '2014-12-01 00:00:00', '599.0000', '1970-01-01 00:00:00', 0, '/0/0/00cfg01r.jpg', NULL, '2015-05-29 03:18:25', 'configurable-product-buberry-red', 'configurable-product-buberry-red.html', 4, '1.0000', NULL, 1),
(12, 4, 'simple', NULL, '2014-03-13 00:45:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry White', '2015-01-04 00:00:00', NULL, '599.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Green', NULL, '/0/0/00cfg01w.jpg', NULL, '2015-01-04 00:00:00', '499.0000', '2035-01-04 00:00:00', 0, '/0/0/00cfg01w.jpg', NULL, '2015-05-29 03:18:48', 'configurable-product-buberry-green', 'configurable-product-buberry-green.html', 4, '1.0000', NULL, 1),
(13, 4, 'configurable', NULL, '2014-12-04 01:56:14', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 02', NULL, NULL, '349.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02', NULL, '/0/0/00cfg02.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02.jpg', NULL, '2015-01-16 00:06:57', 'configurable-product-02', 'configurable-product-02.html', 4, NULL, NULL, 1),
(14, 4, 'simple', NULL, '2014-04-12 01:57:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Black', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Black', NULL, '/0/0/00cfg02k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02k.jpg', NULL, '2015-05-29 03:19:00', 'configurable-product-02-chanel-black', 'configurable-product-02-chanel-black.html', 4, '1.0000', NULL, 1),
(15, 4, 'simple', NULL, '2014-12-04 01:57:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Blue', NULL, NULL, '366.4500', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Blue', NULL, '/0/0/00cfg02b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02b.jpg', NULL, '2015-05-29 03:19:04', 'configurable-product-02-chanel-blue', 'configurable-product-02-chanel-blue.html', 4, '1.0000', NULL, 1),
(16, 4, 'simple', NULL, '2014-12-04 01:58:19', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Dior Green', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Dior-Green', NULL, '/0/0/00cfg02g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02g.jpg', NULL, '2015-05-29 03:19:19', 'configurable-product-02-dior-green', 'configurable-product-02-dior-green.html', 4, '1.0000', NULL, 1),
(17, 4, 'simple', NULL, '2014-04-12 01:59:06', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci Red', NULL, NULL, '367.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-Red', NULL, '/0/0/00cfg02r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02r.jpg', NULL, '2015-05-29 03:13:53', 'configurable-product-02-gucci-red', 'configurable-product-02-gucci-red.html', 4, '1.0000', NULL, 1),
(18, 4, 'simple', NULL, '2014-12-04 01:59:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci White', NULL, NULL, '352.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-White', NULL, '/0/0/00cfg02w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02w.jpg', NULL, '2015-05-29 03:19:12', 'configurable-product-02-gucci-white', 'configurable-product-02-gucci-white.html', 4, '1.0000', NULL, 1),
(19, 4, 'configurable', NULL, '2014-04-12 02:18:40', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 03', NULL, NULL, '399.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03', NULL, '/0/0/00cfg03.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03.jpg', NULL, '2015-03-25 20:28:06', 'configurable-product-03', 'configurable-product-03.html', 4, NULL, NULL, 1),
(20, 4, 'configurable', NULL, '2014-04-12 02:20:25', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 04', NULL, NULL, '99.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04', NULL, '/0/0/00cfg04.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04.jpg', NULL, '2015-01-16 00:16:21', 'configurable-product-04', 'configurable-product-04.html', 4, NULL, NULL, 1),
(21, 4, 'configurable', NULL, '2014-12-04 02:21:54', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 05', NULL, NULL, '179.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05', NULL, '/0/0/00cfg05.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg05.jpg', NULL, '2015-01-16 00:18:27', 'configurable-product-05', 'configurable-product-05.html', 4, NULL, NULL, 1),
(22, 4, 'simple', NULL, '2014-12-04 02:23:05', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Hermes White', NULL, NULL, '410.9700', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Hermes-White', NULL, '/0/0/00cfg03w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03w.jpg', NULL, '2015-05-29 03:09:45', 'configurable-product-03-hermes-white', 'configurable-product-03-hermes-white.html', 4, '1.0000', NULL, 1),
(23, 4, 'simple', NULL, '2014-12-04 02:23:30', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Black', NULL, NULL, '406.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Black', NULL, '/0/0/00cfg03k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03k.jpg', NULL, '2015-05-29 03:19:16', 'configurable-product-03-prada-black', 'configurable-product-03-prada-black.html', 4, '1.0000', NULL, 1),
(24, 4, 'simple', NULL, '2014-12-04 02:24:12', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Versace Blue', NULL, NULL, '442.8900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Versace-Blue', NULL, '/0/0/00cfg03b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03b.jpg', NULL, '2015-05-29 03:14:23', 'configurable-product-03-versace-blue', 'configurable-product-03-versace-blue.html', 4, '1.0000', NULL, 1),
(25, 4, 'simple', NULL, '2014-12-04 02:24:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Green', NULL, NULL, '412.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Green', NULL, '/0/0/00cfg03g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03g.jpg', NULL, '2015-05-29 03:14:15', 'configurable-product-03-prada-green', 'configurable-product-03-prada-green.html', 4, '1.0000', NULL, 1),
(26, 4, 'simple', NULL, '2014-12-04 02:24:59', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Red', NULL, NULL, '417.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Red', NULL, '/0/0/00cfg03r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03r.jpg', NULL, '2015-05-29 03:14:05', 'configurable-product-03-prada-red', 'configurable-product-03-prada-red.html', 4, '1.0000', NULL, 1),
(27, 4, 'simple', NULL, '2014-12-04 02:44:04', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Black', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Black', NULL, '/0/0/00cfg04k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04k.jpg', NULL, '2015-01-16 00:13:22', 'configurable-product-04-black', 'configurable-product-04-black.html', 4, '1.0000', NULL, 1),
(28, 4, 'simple', NULL, '2014-04-12 02:44:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 White', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-White', NULL, '/0/0/00cfg04w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04w.jpg', NULL, '2015-05-29 02:34:13', 'configurable-product-04-white', 'configurable-product-04-white.html', 4, '1.0000', NULL, 1),
(29, 4, 'simple', NULL, '2014-12-04 02:44:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Red', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Red', NULL, '/0/0/00cfg04r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04r.jpg', NULL, '2015-05-29 02:49:20', 'configurable-product-04-red', 'configurable-product-04-red.html', 4, '1.0000', NULL, 1),
(30, 4, 'simple', NULL, '2014-12-04 02:44:41', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Green', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Green', NULL, '/0/0/00cfg04g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04g.jpg', NULL, '2015-05-29 02:49:14', 'configurable-product-04-green', 'configurable-product-04-green.html', 4, '1.0000', NULL, 1),
(31, 4, 'simple', NULL, '2014-12-04 02:45:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Blue', NULL, NULL, '109.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Blue', NULL, '/0/0/00cfg04b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04b.jpg', NULL, '2015-05-29 02:49:06', 'configurable-product-04-blue', 'configurable-product-04-blue.html', 4, '1.0000', NULL, 1),
(32, 4, 'simple', NULL, '2014-12-04 02:51:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Armani', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Armani', NULL, '/0/0/00cfg051.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg051.jpg', NULL, '2015-01-16 00:17:09', 'configurable-product-05-armani', 'configurable-product-05-armani.html', 4, '1.0000', NULL, 1),
(33, 4, 'simple', NULL, '2014-12-04 02:51:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Buberry', NULL, NULL, '199.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Buberry', NULL, '/0/0/00cfg052.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg052.jpg', NULL, '2015-05-29 02:48:57', 'configurable-product-05-buberry', 'configurable-product-05-buberry.html', 4, '1.0000', NULL, 1),
(34, 4, 'simple', NULL, '2014-12-04 02:51:47', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Chanel', NULL, NULL, '209.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Chanel', NULL, '/0/0/00cfg053.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg053.jpg', NULL, '2015-05-29 02:48:48', 'configurable-product-05-chanel', 'configurable-product-05-chanel.html', 4, '1.0000', NULL, 1),
(35, 4, 'simple', NULL, '2014-12-04 02:52:02', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Hermes', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Hermes', NULL, '/0/0/00cfg054.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg054.jpg', NULL, '2015-05-29 02:48:38', 'configurable-product-05-hermes', 'configurable-product-05-hermes.html', 4, '1.0000', NULL, 1),
(36, 4, 'simple', NULL, '2014-12-04 02:52:10', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Versace', NULL, NULL, '194.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Versace', NULL, '/0/0/00cfg055.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg055.jpg', NULL, '2015-05-29 02:48:34', 'configurable-product-05-versace', 'configurable-product-05-versace.html', 4, '1.0000', NULL, 1),
(37, 4, 'simple', NULL, '2014-12-04 03:20:22', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 01', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-01', NULL, '/0/1/01sim0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0105.jpg', NULL, '2015-05-29 02:48:26', 'simple-product-01', 'simple-product-01.html', 4, '1.0000', NULL, 1),
(38, 4, 'simple', NULL, '2014-12-04 03:20:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 02', NULL, NULL, '76.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-02', NULL, '/0/1/01sim0202.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0202.jpg', NULL, '2015-05-29 02:50:09', 'simple-product-02', 'simple-product-02.html', 4, '1.0000', NULL, 1),
(39, 4, 'simple', NULL, '2014-12-04 03:24:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 03', NULL, NULL, '79.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-03', NULL, '/0/1/01sim0305.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0305.jpg', NULL, '2015-05-29 02:48:12', 'simple-product-03', 'simple-product-03.html', 4, '1.0000', NULL, 1),
(40, 4, 'simple', NULL, '2014-04-12 03:26:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 04', NULL, NULL, '119.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-04', NULL, '/0/1/01sim0403.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0403.jpg', NULL, '2015-05-29 02:49:55', 'simple-product-04', 'simple-product-04.html', 4, '1.0000', NULL, 1),
(41, 4, 'simple', NULL, '2014-12-04 03:28:23', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 05', NULL, NULL, '113.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-05', NULL, '/0/1/01sim0503.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0503.jpg', NULL, '2015-05-29 02:50:03', 'simple-product-05', 'simple-product-05.html', 4, '1.0000', NULL, 1),
(42, 4, 'grouped', NULL, '2014-04-12 18:54:46', NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Grouped Product', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'grouped-01', NULL, '/0/2/02group0101.jpg', NULL, NULL, NULL, NULL, NULL, '/0/2/02group0101.jpg', NULL, '2014-12-04 19:07:36', 'grouped-product', 'grouped-product.html', 4, NULL, NULL, 1),
(44, 4, 'bundle', NULL, '2014-12-04 19:21:49', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product', NULL, NULL, NULL, 0, 0, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-01', 0, '/0/4/04bud0102.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0102.jpg', NULL, '2015-01-16 02:00:30', 'bundle-product', 'bundle-product.html', 4, NULL, 0, 1),
(45, 4, 'bundle', NULL, '2014-04-12 19:22:32', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product 02', NULL, NULL, NULL, 0, 1, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-02', 1, '/0/4/04bud0201.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0201.jpg', NULL, '2015-03-18 01:21:39', 'bundle-product-02', 'bundle-product-02.html', 4, '1.0000', 1, 1),
(46, 4, 'downloadable', NULL, '2014-04-12 19:47:25', NULL, 1, NULL, NULL, 1, 1, 'Links', NULL, '4', 2, 'Downloadable Product', NULL, NULL, '1102.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'download-01', NULL, '/0/5/05down0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/5/05down0105.jpg', NULL, '2014-12-04 20:00:46', 'downloadable-product', 'downloadable-product.html', 4, NULL, NULL, 1),
(47, 4, 'simple', NULL, '2014-04-12 20:04:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'No image', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'no-img', NULL, '/0/0/00cfg01b_4.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01b_4.jpg', NULL, '2015-01-19 01:53:21', 'no-image', 'no-image.html', 4, '1.0000', NULL, 1),
(48, 4, 'simple', NULL, '2014-12-04 20:11:59', NULL, 1, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Custom Option', NULL, NULL, '212.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'custom-option', NULL, '/0/6/06custom0104.jpg', NULL, NULL, NULL, NULL, 0, '/0/6/06custom0104.jpg', NULL, '2015-03-24 02:26:45', 'custom-option', 'custom-option.html', 4, '1.0000', NULL, 1),
(49, 4, 'virtual', NULL, '2015-06-12 02:05:00', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Virtual Product', NULL, NULL, '95.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'virtual-01', NULL, '/2/_/2.jpg', NULL, NULL, NULL, NULL, 0, '/2/_/2.jpg', NULL, '2015-06-12 02:05:00', 'virtual-product', 'virtual-product.html', 4, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_flat_5` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `type_id` varchar(32) NOT NULL DEFAULT 'simple' COMMENT 'Type Id',
  `cost` decimal(12,4) DEFAULT NULL COMMENT 'Cost',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `gift_message_available` smallint(6) DEFAULT NULL COMMENT 'Gift Message Available',
  `has_options` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Has Options',
  `image_label` varchar(255) DEFAULT NULL COMMENT 'Image Label',
  `is_recurring` smallint(6) DEFAULT NULL COMMENT 'Is Recurring',
  `links_exist` int(11) DEFAULT NULL COMMENT 'Links Exist',
  `links_purchased_separately` int(11) DEFAULT NULL COMMENT 'Links Purchased Separately',
  `links_title` varchar(255) DEFAULT NULL COMMENT 'Links Title',
  `msrp` decimal(12,4) DEFAULT NULL COMMENT 'Msrp',
  `msrp_display_actual_price_type` varchar(255) DEFAULT NULL COMMENT 'Msrp Display Actual Price Type',
  `msrp_enabled` smallint(6) DEFAULT NULL COMMENT 'Msrp Enabled',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `news_from_date` datetime DEFAULT NULL COMMENT 'News From Date',
  `news_to_date` datetime DEFAULT NULL COMMENT 'News To Date',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `price_type` int(11) DEFAULT NULL COMMENT 'Price Type',
  `price_view` int(11) DEFAULT NULL COMMENT 'Price View',
  `recurring_profile` text COMMENT 'Recurring Profile',
  `required_options` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Required Options',
  `shipment_type` int(11) DEFAULT NULL COMMENT 'Shipment Type',
  `short_description` text COMMENT 'Short Description',
  `sku` varchar(64) DEFAULT NULL COMMENT 'Sku',
  `sku_type` int(11) DEFAULT NULL COMMENT 'Sku Type',
  `small_image` varchar(255) DEFAULT NULL COMMENT 'Small Image',
  `small_image_label` varchar(255) DEFAULT NULL COMMENT 'Small Image Label',
  `special_from_date` datetime DEFAULT NULL COMMENT 'Special From Date',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `special_to_date` datetime DEFAULT NULL COMMENT 'Special To Date',
  `tax_class_id` int(10) unsigned DEFAULT NULL COMMENT 'Tax Class Id',
  `thumbnail` varchar(255) DEFAULT NULL COMMENT 'Thumbnail',
  `thumbnail_label` varchar(255) DEFAULT NULL COMMENT 'Thumbnail Label',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `url_key` varchar(255) DEFAULT NULL COMMENT 'Url Key',
  `url_path` varchar(255) DEFAULT NULL COMMENT 'Url Path',
  `visibility` smallint(5) unsigned DEFAULT NULL COMMENT 'Visibility',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `weight_type` int(11) DEFAULT NULL COMMENT 'Weight Type',
  `status` smallint(5) unsigned DEFAULT NULL COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Flat (Store 5)';

INSERT INTO `#__catalog_product_flat_5` (`entity_id`, `attribute_set_id`, `type_id`, `cost`, `created_at`, `gift_message_available`, `has_options`, `image_label`, `is_recurring`, `links_exist`, `links_purchased_separately`, `links_title`, `msrp`, `msrp_display_actual_price_type`, `msrp_enabled`, `name`, `news_from_date`, `news_to_date`, `price`, `price_type`, `price_view`, `recurring_profile`, `required_options`, `shipment_type`, `short_description`, `sku`, `sku_type`, `small_image`, `small_image_label`, `special_from_date`, `special_price`, `special_to_date`, `tax_class_id`, `thumbnail`, `thumbnail_label`, `updated_at`, `url_key`, `url_path`, `visibility`, `weight`, `weight_type`, `status`) VALUES
(7, 4, 'configurable', NULL, '2014-03-13 00:42:03', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product', NULL, NULL, '599.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01', NULL, '/0/0/00cfg01.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01.jpg', NULL, '2015-01-23 19:45:25', 'configurable-product', 'configurable-product.html', 4, NULL, NULL, 1),
(8, 4, 'simple', NULL, '2014-03-13 00:44:07', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Black', '2014-12-01 00:00:00', NULL, '624.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Black', NULL, '/0/0/00cfg01k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01k.jpg', NULL, '2015-05-29 03:18:42', 'configurable-product-armani-black', 'configurable-product-armani-black.html', 4, '1.0000', NULL, 1),
(9, 4, 'simple', NULL, '2014-03-13 00:44:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Blue', NULL, NULL, '668.9000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Blue', NULL, '/0/0/00cfg01b.jpg', NULL, '2015-01-04 00:00:00', '659.0000', '2034-01-04 00:00:00', 0, '/0/0/00cfg01b.jpg', NULL, '2015-05-29 03:18:31', 'configurable-product-armani-blue', 'configurable-product-armani-blue.html', 4, '1.0000', NULL, 1),
(10, 4, 'simple', NULL, '2014-03-13 00:44:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Armani Green', NULL, NULL, '609.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Armani-Green', NULL, '/0/0/00cfg01g.jpg', NULL, '2015-01-04 00:00:00', '521.0000', '2034-12-01 00:00:00', 0, '/0/0/00cfg01g.jpg', NULL, '2015-05-29 03:18:16', 'configurable-product-armani-green', 'configurable-product-armani-green.html', 4, '1.0000', NULL, 1),
(11, 4, 'simple', NULL, '2014-03-13 00:45:18', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry Red', '2014-12-01 00:00:00', NULL, '614.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Red', NULL, '/0/0/00cfg01r.jpg', NULL, '2014-12-01 00:00:00', '599.0000', '1970-01-01 00:00:00', 0, '/0/0/00cfg01r.jpg', NULL, '2015-05-29 03:18:25', 'configurable-product-buberry-red', 'configurable-product-buberry-red.html', 4, '1.0000', NULL, 1),
(12, 4, 'simple', NULL, '2014-03-13 00:45:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg Buberry White', '2015-01-04 00:00:00', NULL, '599.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-01-Buberry-Green', NULL, '/0/0/00cfg01w.jpg', NULL, '2015-01-04 00:00:00', '499.0000', '2035-01-04 00:00:00', 0, '/0/0/00cfg01w.jpg', NULL, '2015-05-29 03:18:48', 'configurable-product-buberry-green', 'configurable-product-buberry-green.html', 4, '1.0000', NULL, 1),
(13, 4, 'configurable', NULL, '2014-12-04 01:56:14', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 02', NULL, NULL, '349.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02', NULL, '/0/0/00cfg02.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02.jpg', NULL, '2015-01-16 00:06:57', 'configurable-product-02', 'configurable-product-02.html', 4, NULL, NULL, 1),
(14, 4, 'simple', NULL, '2014-04-12 01:57:37', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Black', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Black', NULL, '/0/0/00cfg02k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02k.jpg', NULL, '2015-05-29 03:19:00', 'configurable-product-02-chanel-black', 'configurable-product-02-chanel-black.html', 4, '1.0000', NULL, 1),
(15, 4, 'simple', NULL, '2014-12-04 01:57:55', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Chanel Blue', NULL, NULL, '366.4500', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Chanel-Blue', NULL, '/0/0/00cfg02b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02b.jpg', NULL, '2015-05-29 03:19:04', 'configurable-product-02-chanel-blue', 'configurable-product-02-chanel-blue.html', 4, '1.0000', NULL, 1),
(16, 4, 'simple', NULL, '2014-12-04 01:58:19', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Dior Green', NULL, NULL, '373.4300', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Dior-Green', NULL, '/0/0/00cfg02g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02g.jpg', NULL, '2015-05-29 03:19:19', 'configurable-product-02-dior-green', 'configurable-product-02-dior-green.html', 4, '1.0000', NULL, 1),
(17, 4, 'simple', NULL, '2014-04-12 01:59:06', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci Red', NULL, NULL, '367.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-Red', NULL, '/0/0/00cfg02r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02r.jpg', NULL, '2015-05-29 03:13:53', 'configurable-product-02-gucci-red', 'configurable-product-02-gucci-red.html', 4, '1.0000', NULL, 1),
(18, 4, 'simple', NULL, '2014-12-04 01:59:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 02 Gucci White', NULL, NULL, '352.4900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-02-Gucci-White', NULL, '/0/0/00cfg02w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg02w.jpg', NULL, '2015-05-29 03:19:12', 'configurable-product-02-gucci-white', 'configurable-product-02-gucci-white.html', 4, '1.0000', NULL, 1),
(19, 4, 'configurable', NULL, '2014-04-12 02:18:40', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 03', NULL, NULL, '399.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03', NULL, '/0/0/00cfg03.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03.jpg', NULL, '2015-03-25 20:28:06', 'configurable-product-03', 'configurable-product-03.html', 4, NULL, NULL, 1),
(20, 4, 'configurable', NULL, '2014-04-12 02:20:25', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 04', NULL, NULL, '99.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04', NULL, '/0/0/00cfg04.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04.jpg', NULL, '2015-01-16 00:16:21', 'configurable-product-04', 'configurable-product-04.html', 4, NULL, NULL, 1),
(21, 4, 'configurable', NULL, '2014-12-04 02:21:54', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, '4', 2, 'Configurable Product 05', NULL, NULL, '179.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05', NULL, '/0/0/00cfg05.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg05.jpg', NULL, '2015-01-16 00:18:27', 'configurable-product-05', 'configurable-product-05.html', 4, NULL, NULL, 1),
(22, 4, 'simple', NULL, '2014-12-04 02:23:05', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Hermes White', NULL, NULL, '410.9700', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Hermes-White', NULL, '/0/0/00cfg03w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03w.jpg', NULL, '2015-05-29 03:09:45', 'configurable-product-03-hermes-white', 'configurable-product-03-hermes-white.html', 4, '1.0000', NULL, 1),
(23, 4, 'simple', NULL, '2014-12-04 02:23:30', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Black', NULL, NULL, '406.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Black', NULL, '/0/0/00cfg03k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03k.jpg', NULL, '2015-05-29 03:19:16', 'configurable-product-03-prada-black', 'configurable-product-03-prada-black.html', 4, '1.0000', NULL, 1),
(24, 4, 'simple', NULL, '2014-12-04 02:24:12', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Versace Blue', NULL, NULL, '442.8900', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Versace-Blue', NULL, '/0/0/00cfg03b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03b.jpg', NULL, '2015-05-29 03:14:23', 'configurable-product-03-versace-blue', 'configurable-product-03-versace-blue.html', 4, '1.0000', NULL, 1),
(25, 4, 'simple', NULL, '2014-12-04 02:24:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Green', NULL, NULL, '412.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Green', NULL, '/0/0/00cfg03g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03g.jpg', NULL, '2015-05-29 03:14:15', 'configurable-product-03-prada-green', 'configurable-product-03-prada-green.html', 4, '1.0000', NULL, 1),
(26, 4, 'simple', NULL, '2014-12-04 02:24:59', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 03 Prada Red', NULL, NULL, '417.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-03-Prada-Red', NULL, '/0/0/00cfg03r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg03r.jpg', NULL, '2015-05-29 03:14:05', 'configurable-product-03-prada-red', 'configurable-product-03-prada-red.html', 4, '1.0000', NULL, 1),
(27, 4, 'simple', NULL, '2014-12-04 02:44:04', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Black', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Black', NULL, '/0/0/00cfg04k.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04k.jpg', NULL, '2015-01-16 00:13:22', 'configurable-product-04-black', 'configurable-product-04-black.html', 4, '1.0000', NULL, 1),
(28, 4, 'simple', NULL, '2014-04-12 02:44:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 White', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-White', NULL, '/0/0/00cfg04w.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04w.jpg', NULL, '2015-05-29 02:34:13', 'configurable-product-04-white', 'configurable-product-04-white.html', 4, '1.0000', NULL, 1),
(29, 4, 'simple', NULL, '2014-12-04 02:44:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Red', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Red', NULL, '/0/0/00cfg04r.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04r.jpg', NULL, '2015-05-29 02:49:20', 'configurable-product-04-red', 'configurable-product-04-red.html', 4, '1.0000', NULL, 1),
(30, 4, 'simple', NULL, '2014-12-04 02:44:41', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Green', NULL, NULL, '100.9800', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Green', NULL, '/0/0/00cfg04g.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04g.jpg', NULL, '2015-05-29 02:49:14', 'configurable-product-04-green', 'configurable-product-04-green.html', 4, '1.0000', NULL, 1),
(31, 4, 'simple', NULL, '2014-12-04 02:45:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 04 Blue', NULL, NULL, '109.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-04-Blue', NULL, '/0/0/00cfg04b.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg04b.jpg', NULL, '2015-05-29 02:49:06', 'configurable-product-04-blue', 'configurable-product-04-blue.html', 4, '1.0000', NULL, 1),
(32, 4, 'simple', NULL, '2014-12-04 02:51:01', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Armani', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Armani', NULL, '/0/0/00cfg051.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg051.jpg', NULL, '2015-01-16 00:17:09', 'configurable-product-05-armani', 'configurable-product-05-armani.html', 4, '1.0000', NULL, 1),
(33, 4, 'simple', NULL, '2014-12-04 02:51:20', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Buberry', NULL, NULL, '199.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Buberry', NULL, '/0/0/00cfg052.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg052.jpg', NULL, '2015-05-29 02:48:57', 'configurable-product-05-buberry', 'configurable-product-05-buberry.html', 4, '1.0000', NULL, 1),
(34, 4, 'simple', NULL, '2014-12-04 02:51:47', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Chanel', NULL, NULL, '209.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Chanel', NULL, '/0/0/00cfg053.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg053.jpg', NULL, '2015-05-29 02:48:48', 'configurable-product-05-chanel', 'configurable-product-05-chanel.html', 4, '1.0000', NULL, 1),
(35, 4, 'simple', NULL, '2014-12-04 02:52:02', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Hermes', NULL, NULL, '189.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Hermes', NULL, '/0/0/00cfg054.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg054.jpg', NULL, '2015-05-29 02:48:38', 'configurable-product-05-hermes', 'configurable-product-05-hermes.html', 4, '1.0000', NULL, 1),
(36, 4, 'simple', NULL, '2014-12-04 02:52:10', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Cfg 05 Versace', NULL, NULL, '194.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'Cfg-05-Versace', NULL, '/0/0/00cfg055.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg055.jpg', NULL, '2015-05-29 02:48:34', 'configurable-product-05-versace', 'configurable-product-05-versace.html', 4, '1.0000', NULL, 1),
(37, 4, 'simple', NULL, '2014-12-04 03:20:22', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 01', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-01', NULL, '/0/1/01sim0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0105.jpg', NULL, '2015-05-29 02:48:26', 'simple-product-01', 'simple-product-01.html', 4, '1.0000', NULL, 1),
(38, 4, 'simple', NULL, '2014-12-04 03:20:40', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 02', NULL, NULL, '76.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-02', NULL, '/0/1/01sim0202.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0202.jpg', NULL, '2015-05-29 02:50:09', 'simple-product-02', 'simple-product-02.html', 4, '1.0000', NULL, 1),
(39, 4, 'simple', NULL, '2014-12-04 03:24:38', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 03', NULL, NULL, '79.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-03', NULL, '/0/1/01sim0305.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0305.jpg', NULL, '2015-05-29 02:48:12', 'simple-product-03', 'simple-product-03.html', 4, '1.0000', NULL, 1),
(40, 4, 'simple', NULL, '2014-04-12 03:26:25', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 04', NULL, NULL, '119.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-04', NULL, '/0/1/01sim0403.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0403.jpg', NULL, '2015-05-29 02:49:55', 'simple-product-04', 'simple-product-04.html', 4, '1.0000', NULL, 1),
(41, 4, 'simple', NULL, '2014-12-04 03:28:23', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Simple product 05', NULL, NULL, '113.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'sim-05', NULL, '/0/1/01sim0503.jpg', NULL, NULL, NULL, NULL, 0, '/0/1/01sim0503.jpg', NULL, '2015-05-29 02:50:03', 'simple-product-05', 'simple-product-05.html', 4, '1.0000', NULL, 1),
(42, 4, 'grouped', NULL, '2014-04-12 18:54:46', NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'Grouped Product', NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'grouped-01', NULL, '/0/2/02group0101.jpg', NULL, NULL, NULL, NULL, NULL, '/0/2/02group0101.jpg', NULL, '2014-12-04 19:07:36', 'grouped-product', 'grouped-product.html', 4, NULL, NULL, 1),
(44, 4, 'bundle', NULL, '2014-12-04 19:21:49', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product', NULL, NULL, NULL, 0, 0, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-01', 0, '/0/4/04bud0102.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0102.jpg', NULL, '2015-01-16 02:00:30', 'bundle-product', 'bundle-product.html', 4, NULL, 0, 1),
(45, 4, 'bundle', NULL, '2014-04-12 19:22:32', NULL, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 'Bundle Product 02', NULL, NULL, NULL, 0, 1, NULL, 1, 0, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'bud-02', 1, '/0/4/04bud0201.jpg', NULL, NULL, NULL, NULL, NULL, '/0/4/04bud0201.jpg', NULL, '2015-03-18 01:21:39', 'bundle-product-02', 'bundle-product-02.html', 4, '1.0000', 1, 1),
(46, 4, 'downloadable', NULL, '2014-04-12 19:47:25', NULL, 1, NULL, NULL, 1, 1, 'Links', NULL, '4', 2, 'Downloadable Product', NULL, NULL, '1102.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'download-01', NULL, '/0/5/05down0105.jpg', NULL, NULL, NULL, NULL, 0, '/0/5/05down0105.jpg', NULL, '2014-12-04 20:00:46', 'downloadable-product', 'downloadable-product.html', 4, NULL, NULL, 1),
(47, 4, 'simple', NULL, '2014-04-12 20:04:31', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'No image', NULL, NULL, '68.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'no-img', NULL, '/0/0/00cfg01b_4.jpg', NULL, NULL, NULL, NULL, 0, '/0/0/00cfg01b_4.jpg', NULL, '2015-01-19 01:53:21', 'no-image', 'no-image.html', 4, '1.0000', NULL, 1),
(48, 4, 'simple', NULL, '2014-12-04 20:11:59', NULL, 1, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Custom Option', NULL, NULL, '212.0000', NULL, NULL, NULL, 1, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'custom-option', NULL, '/0/6/06custom0104.jpg', NULL, NULL, NULL, NULL, 0, '/0/6/06custom0104.jpg', NULL, '2015-03-24 02:26:45', 'custom-option', 'custom-option.html', 4, '1.0000', NULL, 1),
(49, 4, 'virtual', NULL, '2015-06-12 02:05:00', NULL, 0, NULL, 0, NULL, NULL, NULL, NULL, '4', 2, 'Virtual Product', NULL, NULL, '95.0000', NULL, NULL, NULL, 0, NULL, '<p>Ut metus. Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. Sed eu velit. Maecenas molestie, ipsum nec nonummy mattis, ipsum lectus imperdiet nibh</p>', 'virtual-01', NULL, '/2/_/2.jpg', NULL, NULL, NULL, NULL, 0, '/2/_/2.jpg', NULL, '2015-06-12 02:05:00', 'virtual-product', 'virtual-product.html', 4, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` int(10) unsigned NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Index Table';

INSERT INTO `#__catalog_product_index_eav` (`entity_id`, `attribute_id`, `store_id`, `value`) VALUES
(7, 81, 1, 9),
(7, 81, 1, 10),
(7, 81, 2, 9),
(7, 81, 2, 10),
(7, 81, 3, 9),
(7, 81, 3, 10),
(7, 81, 4, 9),
(7, 81, 4, 10),
(7, 81, 5, 9),
(7, 81, 5, 10),
(8, 81, 1, 10),
(8, 81, 2, 10),
(8, 81, 3, 10),
(8, 81, 4, 10),
(8, 81, 5, 10),
(9, 81, 1, 10),
(9, 81, 2, 10),
(9, 81, 3, 10),
(9, 81, 4, 10),
(9, 81, 5, 10),
(10, 81, 1, 10),
(10, 81, 2, 10),
(10, 81, 3, 10),
(10, 81, 4, 10),
(10, 81, 5, 10),
(11, 81, 1, 9),
(11, 81, 2, 9),
(11, 81, 3, 9),
(11, 81, 4, 9),
(11, 81, 5, 9),
(12, 81, 1, 9),
(12, 81, 2, 9),
(12, 81, 3, 9),
(12, 81, 4, 9),
(12, 81, 5, 9),
(13, 81, 1, 12),
(13, 81, 1, 13),
(13, 81, 1, 15),
(13, 81, 2, 12),
(13, 81, 2, 13),
(13, 81, 2, 15),
(13, 81, 3, 12),
(13, 81, 3, 13),
(13, 81, 3, 15),
(13, 81, 4, 12),
(13, 81, 4, 13),
(13, 81, 4, 15),
(13, 81, 5, 12),
(13, 81, 5, 13),
(13, 81, 5, 15),
(14, 81, 1, 15),
(14, 81, 2, 15),
(14, 81, 3, 15),
(14, 81, 4, 15),
(14, 81, 5, 15),
(15, 81, 1, 15),
(15, 81, 2, 15),
(15, 81, 3, 15),
(15, 81, 4, 15),
(15, 81, 5, 15),
(16, 81, 1, 12),
(16, 81, 2, 12),
(16, 81, 3, 12),
(16, 81, 4, 12),
(16, 81, 5, 12),
(17, 81, 1, 13),
(17, 81, 2, 13),
(17, 81, 3, 13),
(17, 81, 4, 13),
(17, 81, 5, 13),
(18, 81, 1, 13),
(18, 81, 2, 13),
(18, 81, 3, 13),
(18, 81, 4, 13),
(18, 81, 5, 13),
(19, 81, 1, 11),
(19, 81, 1, 14),
(19, 81, 1, 16),
(19, 81, 2, 11),
(19, 81, 2, 14),
(19, 81, 2, 16),
(19, 81, 3, 11),
(19, 81, 3, 14),
(19, 81, 3, 16),
(19, 81, 4, 11),
(19, 81, 4, 14),
(19, 81, 4, 16),
(19, 81, 5, 11),
(19, 81, 5, 14),
(19, 81, 5, 16),
(20, 81, 1, 16),
(20, 81, 2, 16),
(20, 81, 3, 16),
(20, 81, 4, 16),
(20, 81, 5, 16),
(21, 81, 1, 9),
(21, 81, 1, 10),
(21, 81, 1, 14),
(21, 81, 1, 15),
(21, 81, 1, 16),
(21, 81, 2, 9),
(21, 81, 2, 10),
(21, 81, 2, 14),
(21, 81, 2, 15),
(21, 81, 2, 16),
(21, 81, 3, 9),
(21, 81, 3, 10),
(21, 81, 3, 14),
(21, 81, 3, 15),
(21, 81, 3, 16),
(21, 81, 4, 9),
(21, 81, 4, 10),
(21, 81, 4, 14),
(21, 81, 4, 15),
(21, 81, 4, 16),
(21, 81, 5, 9),
(21, 81, 5, 10),
(21, 81, 5, 14),
(21, 81, 5, 15),
(21, 81, 5, 16),
(22, 81, 1, 14),
(22, 81, 2, 14),
(22, 81, 3, 14),
(22, 81, 4, 14),
(22, 81, 5, 14),
(23, 81, 1, 11),
(23, 81, 2, 11),
(23, 81, 3, 11),
(23, 81, 4, 11),
(23, 81, 5, 11),
(24, 81, 1, 16),
(24, 81, 2, 16),
(24, 81, 3, 16),
(24, 81, 4, 16),
(24, 81, 5, 16),
(25, 81, 1, 11),
(25, 81, 2, 11),
(25, 81, 3, 11),
(25, 81, 4, 11),
(25, 81, 5, 11),
(26, 81, 1, 11),
(26, 81, 2, 11),
(26, 81, 3, 11),
(26, 81, 4, 11),
(26, 81, 5, 11),
(27, 81, 1, 16),
(27, 81, 2, 16),
(27, 81, 3, 16),
(27, 81, 4, 16),
(27, 81, 5, 16),
(28, 81, 1, 16),
(28, 81, 2, 16),
(28, 81, 3, 16),
(28, 81, 4, 16),
(28, 81, 5, 16),
(29, 81, 1, 16),
(29, 81, 2, 16),
(29, 81, 3, 16),
(29, 81, 4, 16),
(29, 81, 5, 16),
(30, 81, 1, 16),
(30, 81, 2, 16),
(30, 81, 3, 16),
(30, 81, 4, 16),
(30, 81, 5, 16),
(31, 81, 1, 16),
(31, 81, 2, 16),
(31, 81, 3, 16),
(31, 81, 4, 16),
(31, 81, 5, 16),
(32, 81, 1, 10),
(32, 81, 2, 10),
(32, 81, 3, 10),
(32, 81, 4, 10),
(32, 81, 5, 10),
(33, 81, 1, 9),
(33, 81, 2, 9),
(33, 81, 3, 9),
(33, 81, 4, 9),
(33, 81, 5, 9),
(34, 81, 1, 15),
(34, 81, 2, 15),
(34, 81, 3, 15),
(34, 81, 4, 15),
(34, 81, 5, 15),
(35, 81, 1, 14),
(35, 81, 2, 14),
(35, 81, 3, 14),
(35, 81, 4, 14),
(35, 81, 5, 14),
(36, 81, 1, 16),
(36, 81, 2, 16),
(36, 81, 3, 16),
(36, 81, 4, 16),
(36, 81, 5, 16),
(39, 81, 1, 16),
(39, 81, 2, 16),
(39, 81, 3, 16),
(39, 81, 4, 16),
(39, 81, 5, 16),
(40, 81, 1, 13),
(40, 81, 2, 13),
(40, 81, 3, 13),
(40, 81, 4, 13),
(40, 81, 5, 13),
(41, 81, 1, 11),
(41, 81, 2, 11),
(41, 81, 3, 11),
(41, 81, 4, 11),
(41, 81, 5, 11),
(42, 81, 1, 9),
(42, 81, 1, 10),
(42, 81, 2, 9),
(42, 81, 2, 10),
(42, 81, 3, 9),
(42, 81, 3, 10),
(42, 81, 4, 9),
(42, 81, 4, 10),
(42, 81, 5, 9),
(42, 81, 5, 10),
(44, 81, 1, 10),
(44, 81, 1, 11),
(44, 81, 1, 12),
(44, 81, 1, 14),
(44, 81, 1, 15),
(44, 81, 1, 16),
(44, 81, 2, 10),
(44, 81, 2, 11),
(44, 81, 2, 12),
(44, 81, 2, 14),
(44, 81, 2, 15),
(44, 81, 2, 16),
(44, 81, 3, 10),
(44, 81, 3, 11),
(44, 81, 3, 12),
(44, 81, 3, 14),
(44, 81, 3, 15),
(44, 81, 3, 16),
(44, 81, 4, 10),
(44, 81, 4, 11),
(44, 81, 4, 12),
(44, 81, 4, 14),
(44, 81, 4, 15),
(44, 81, 4, 16),
(44, 81, 5, 10),
(44, 81, 5, 11),
(44, 81, 5, 12),
(44, 81, 5, 14),
(44, 81, 5, 15),
(44, 81, 5, 16),
(45, 81, 1, 10),
(45, 81, 1, 11),
(45, 81, 1, 12),
(45, 81, 1, 14),
(45, 81, 1, 15),
(45, 81, 1, 16),
(45, 81, 2, 10),
(45, 81, 2, 11),
(45, 81, 2, 12),
(45, 81, 2, 14),
(45, 81, 2, 15),
(45, 81, 2, 16),
(45, 81, 3, 10),
(45, 81, 3, 11),
(45, 81, 3, 12),
(45, 81, 3, 14),
(45, 81, 3, 15),
(45, 81, 3, 16),
(45, 81, 4, 10),
(45, 81, 4, 11),
(45, 81, 4, 12),
(45, 81, 4, 14),
(45, 81, 4, 15),
(45, 81, 4, 16),
(45, 81, 5, 10),
(45, 81, 5, 11),
(45, 81, 5, 12),
(45, 81, 5, 14),
(45, 81, 5, 15),
(45, 81, 5, 16),
(48, 81, 1, 9),
(48, 81, 2, 9),
(48, 81, 3, 9),
(48, 81, 4, 9),
(48, 81, 5, 9),
(7, 92, 1, 3),
(7, 92, 1, 4),
(7, 92, 1, 5),
(7, 92, 1, 6),
(7, 92, 1, 8),
(7, 92, 2, 3),
(7, 92, 2, 4),
(7, 92, 2, 5),
(7, 92, 2, 6),
(7, 92, 2, 8),
(7, 92, 3, 3),
(7, 92, 3, 4),
(7, 92, 3, 5),
(7, 92, 3, 6),
(7, 92, 3, 8),
(7, 92, 4, 3),
(7, 92, 4, 4),
(7, 92, 4, 5),
(7, 92, 4, 6),
(7, 92, 4, 8),
(7, 92, 5, 3),
(7, 92, 5, 4),
(7, 92, 5, 5),
(7, 92, 5, 6),
(7, 92, 5, 8),
(8, 92, 1, 3),
(8, 92, 2, 3),
(8, 92, 3, 3),
(8, 92, 4, 3),
(8, 92, 5, 3),
(9, 92, 1, 4),
(9, 92, 2, 4),
(9, 92, 3, 4),
(9, 92, 4, 4),
(9, 92, 5, 4),
(10, 92, 1, 6),
(10, 92, 2, 6),
(10, 92, 3, 6),
(10, 92, 4, 6),
(10, 92, 5, 6),
(11, 92, 1, 5),
(11, 92, 2, 5),
(11, 92, 3, 5),
(11, 92, 4, 5),
(11, 92, 5, 5),
(12, 92, 1, 8),
(12, 92, 2, 8),
(12, 92, 3, 8),
(12, 92, 4, 8),
(12, 92, 5, 8),
(13, 92, 1, 3),
(13, 92, 1, 4),
(13, 92, 1, 5),
(13, 92, 1, 6),
(13, 92, 1, 8),
(13, 92, 2, 3),
(13, 92, 2, 4),
(13, 92, 2, 5),
(13, 92, 2, 6),
(13, 92, 2, 8),
(13, 92, 3, 3),
(13, 92, 3, 4),
(13, 92, 3, 5),
(13, 92, 3, 6),
(13, 92, 3, 8),
(13, 92, 4, 3),
(13, 92, 4, 4),
(13, 92, 4, 5),
(13, 92, 4, 6),
(13, 92, 4, 8),
(13, 92, 5, 3),
(13, 92, 5, 4),
(13, 92, 5, 5),
(13, 92, 5, 6),
(13, 92, 5, 8),
(14, 92, 1, 3),
(14, 92, 2, 3),
(14, 92, 3, 3),
(14, 92, 4, 3),
(14, 92, 5, 3),
(15, 92, 1, 4),
(15, 92, 2, 4),
(15, 92, 3, 4),
(15, 92, 4, 4),
(15, 92, 5, 4),
(16, 92, 1, 6),
(16, 92, 2, 6),
(16, 92, 3, 6),
(16, 92, 4, 6),
(16, 92, 5, 6),
(17, 92, 1, 5),
(17, 92, 2, 5),
(17, 92, 3, 5),
(17, 92, 4, 5),
(17, 92, 5, 5),
(18, 92, 1, 8),
(18, 92, 2, 8),
(18, 92, 3, 8),
(18, 92, 4, 8),
(18, 92, 5, 8),
(19, 92, 1, 3),
(19, 92, 1, 4),
(19, 92, 1, 5),
(19, 92, 1, 6),
(19, 92, 1, 8),
(19, 92, 2, 3),
(19, 92, 2, 4),
(19, 92, 2, 5),
(19, 92, 2, 6),
(19, 92, 2, 8),
(19, 92, 3, 3),
(19, 92, 3, 4),
(19, 92, 3, 5),
(19, 92, 3, 6),
(19, 92, 3, 8),
(19, 92, 4, 3),
(19, 92, 4, 4),
(19, 92, 4, 5),
(19, 92, 4, 6),
(19, 92, 4, 8),
(19, 92, 5, 3),
(19, 92, 5, 4),
(19, 92, 5, 5),
(19, 92, 5, 6),
(19, 92, 5, 8),
(20, 92, 1, 3),
(20, 92, 1, 4),
(20, 92, 1, 5),
(20, 92, 1, 6),
(20, 92, 1, 8),
(20, 92, 2, 3),
(20, 92, 2, 4),
(20, 92, 2, 5),
(20, 92, 2, 6),
(20, 92, 2, 8),
(20, 92, 3, 3),
(20, 92, 3, 4),
(20, 92, 3, 5),
(20, 92, 3, 6),
(20, 92, 3, 8),
(20, 92, 4, 3),
(20, 92, 4, 4),
(20, 92, 4, 5),
(20, 92, 4, 6),
(20, 92, 4, 8),
(20, 92, 5, 3),
(20, 92, 5, 4),
(20, 92, 5, 5),
(20, 92, 5, 6),
(20, 92, 5, 8),
(21, 92, 1, 5),
(21, 92, 2, 5),
(21, 92, 3, 5),
(21, 92, 4, 5),
(21, 92, 5, 5),
(22, 92, 1, 8),
(22, 92, 2, 8),
(22, 92, 3, 8),
(22, 92, 4, 8),
(22, 92, 5, 8),
(23, 92, 1, 3),
(23, 92, 2, 3),
(23, 92, 3, 3),
(23, 92, 4, 3),
(23, 92, 5, 3),
(24, 92, 1, 4),
(24, 92, 2, 4),
(24, 92, 3, 4),
(24, 92, 4, 4),
(24, 92, 5, 4),
(25, 92, 1, 6),
(25, 92, 2, 6),
(25, 92, 3, 6),
(25, 92, 4, 6),
(25, 92, 5, 6),
(26, 92, 1, 5),
(26, 92, 2, 5),
(26, 92, 3, 5),
(26, 92, 4, 5),
(26, 92, 5, 5),
(27, 92, 1, 3),
(27, 92, 2, 3),
(27, 92, 3, 3),
(27, 92, 4, 3),
(27, 92, 5, 3),
(28, 92, 1, 8),
(28, 92, 2, 8),
(28, 92, 3, 8),
(28, 92, 4, 8),
(28, 92, 5, 8),
(29, 92, 1, 5),
(29, 92, 2, 5),
(29, 92, 3, 5),
(29, 92, 4, 5),
(29, 92, 5, 5),
(30, 92, 1, 6),
(30, 92, 2, 6),
(30, 92, 3, 6),
(30, 92, 4, 6),
(30, 92, 5, 6),
(31, 92, 1, 4),
(31, 92, 2, 4),
(31, 92, 3, 4),
(31, 92, 4, 4),
(31, 92, 5, 4),
(32, 92, 1, 5),
(32, 92, 2, 5),
(32, 92, 3, 5),
(32, 92, 4, 5),
(32, 92, 5, 5),
(33, 92, 1, 5),
(33, 92, 2, 5),
(33, 92, 3, 5),
(33, 92, 4, 5),
(33, 92, 5, 5),
(34, 92, 1, 5),
(34, 92, 2, 5),
(34, 92, 3, 5),
(34, 92, 4, 5),
(34, 92, 5, 5),
(35, 92, 1, 5),
(35, 92, 2, 5),
(35, 92, 3, 5),
(35, 92, 4, 5),
(35, 92, 5, 5),
(36, 92, 1, 5),
(36, 92, 2, 5),
(36, 92, 3, 5),
(36, 92, 4, 5),
(36, 92, 5, 5),
(37, 92, 1, 4),
(37, 92, 2, 4),
(37, 92, 3, 4),
(37, 92, 4, 4),
(37, 92, 5, 4),
(38, 92, 1, 3),
(38, 92, 2, 3),
(38, 92, 3, 3),
(38, 92, 4, 3),
(38, 92, 5, 3),
(39, 92, 1, 6),
(39, 92, 2, 6),
(39, 92, 3, 6),
(39, 92, 4, 6),
(39, 92, 5, 6),
(40, 92, 1, 8),
(40, 92, 2, 8),
(40, 92, 3, 8),
(40, 92, 4, 8),
(40, 92, 5, 8),
(41, 92, 1, 5),
(41, 92, 2, 5),
(41, 92, 3, 5),
(41, 92, 4, 5),
(41, 92, 5, 5),
(42, 92, 1, 3),
(42, 92, 1, 4),
(42, 92, 1, 5),
(42, 92, 1, 6),
(42, 92, 1, 8),
(42, 92, 2, 3),
(42, 92, 2, 4),
(42, 92, 2, 5),
(42, 92, 2, 6),
(42, 92, 2, 8),
(42, 92, 3, 3),
(42, 92, 3, 4),
(42, 92, 3, 5),
(42, 92, 3, 6),
(42, 92, 3, 8),
(42, 92, 4, 3),
(42, 92, 4, 4),
(42, 92, 4, 5),
(42, 92, 4, 6),
(42, 92, 4, 8),
(42, 92, 5, 3),
(42, 92, 5, 4),
(42, 92, 5, 5),
(42, 92, 5, 6),
(42, 92, 5, 8),
(44, 92, 1, 3),
(44, 92, 1, 4),
(44, 92, 1, 6),
(44, 92, 1, 8),
(44, 92, 2, 3),
(44, 92, 2, 4),
(44, 92, 2, 6),
(44, 92, 2, 8),
(44, 92, 3, 3),
(44, 92, 3, 4),
(44, 92, 3, 6),
(44, 92, 3, 8),
(44, 92, 4, 3),
(44, 92, 4, 4),
(44, 92, 4, 6),
(44, 92, 4, 8),
(44, 92, 5, 3),
(44, 92, 5, 4),
(44, 92, 5, 6),
(44, 92, 5, 8),
(45, 92, 1, 3),
(45, 92, 1, 4),
(45, 92, 1, 6),
(45, 92, 1, 8),
(45, 92, 2, 3),
(45, 92, 2, 4),
(45, 92, 2, 6),
(45, 92, 2, 8),
(45, 92, 3, 3),
(45, 92, 3, 4),
(45, 92, 3, 6),
(45, 92, 3, 8),
(45, 92, 4, 3),
(45, 92, 4, 4),
(45, 92, 4, 6),
(45, 92, 4, 8),
(45, 92, 5, 3),
(45, 92, 5, 4),
(45, 92, 5, 6),
(45, 92, 5, 8),
(48, 92, 1, 3),
(48, 92, 2, 3),
(48, 92, 3, 3),
(48, 92, 4, 3),
(48, 92, 5, 3),
(7, 121, 1, 0),
(7, 121, 2, 0),
(7, 121, 3, 0),
(7, 121, 4, 0),
(7, 121, 5, 0),
(8, 121, 1, 0),
(8, 121, 2, 0),
(8, 121, 3, 0),
(8, 121, 4, 0),
(8, 121, 5, 0),
(9, 121, 1, 0),
(9, 121, 2, 0),
(9, 121, 3, 0),
(9, 121, 4, 0),
(9, 121, 5, 0),
(10, 121, 1, 0),
(10, 121, 2, 0),
(10, 121, 3, 0),
(10, 121, 4, 0),
(10, 121, 5, 0),
(11, 121, 1, 0),
(11, 121, 2, 0),
(11, 121, 3, 0),
(11, 121, 4, 0),
(11, 121, 5, 0),
(12, 121, 1, 0),
(12, 121, 2, 0),
(12, 121, 3, 0),
(12, 121, 4, 0),
(12, 121, 5, 0),
(13, 121, 1, 0),
(13, 121, 2, 0),
(13, 121, 3, 0),
(13, 121, 4, 0),
(13, 121, 5, 0),
(14, 121, 1, 0),
(14, 121, 2, 0),
(14, 121, 3, 0),
(14, 121, 4, 0),
(14, 121, 5, 0),
(15, 121, 1, 0),
(15, 121, 2, 0),
(15, 121, 3, 0),
(15, 121, 4, 0),
(15, 121, 5, 0),
(16, 121, 1, 0),
(16, 121, 2, 0),
(16, 121, 3, 0),
(16, 121, 4, 0),
(16, 121, 5, 0),
(17, 121, 1, 0),
(17, 121, 2, 0),
(17, 121, 3, 0),
(17, 121, 4, 0),
(17, 121, 5, 0),
(18, 121, 1, 0),
(18, 121, 2, 0),
(18, 121, 3, 0),
(18, 121, 4, 0),
(18, 121, 5, 0),
(19, 121, 1, 0),
(19, 121, 2, 0),
(19, 121, 3, 0),
(19, 121, 4, 0),
(19, 121, 5, 0),
(20, 121, 1, 0),
(20, 121, 2, 0),
(20, 121, 3, 0),
(20, 121, 4, 0),
(20, 121, 5, 0),
(21, 121, 1, 0),
(21, 121, 2, 0),
(21, 121, 3, 0),
(21, 121, 4, 0),
(21, 121, 5, 0),
(22, 121, 1, 0),
(22, 121, 2, 0),
(22, 121, 3, 0),
(22, 121, 4, 0),
(22, 121, 5, 0),
(23, 121, 1, 0),
(23, 121, 2, 0),
(23, 121, 3, 0),
(23, 121, 4, 0),
(23, 121, 5, 0),
(24, 121, 1, 0),
(24, 121, 2, 0),
(24, 121, 3, 0),
(24, 121, 4, 0),
(24, 121, 5, 0),
(25, 121, 1, 0),
(25, 121, 2, 0),
(25, 121, 3, 0),
(25, 121, 4, 0),
(25, 121, 5, 0),
(26, 121, 1, 0),
(26, 121, 2, 0),
(26, 121, 3, 0),
(26, 121, 4, 0),
(26, 121, 5, 0),
(27, 121, 1, 0),
(27, 121, 2, 0),
(27, 121, 3, 0),
(27, 121, 4, 0),
(27, 121, 5, 0),
(28, 121, 1, 0),
(28, 121, 2, 0),
(28, 121, 3, 0),
(28, 121, 4, 0),
(28, 121, 5, 0),
(29, 121, 1, 0),
(29, 121, 2, 0),
(29, 121, 3, 0),
(29, 121, 4, 0),
(29, 121, 5, 0),
(30, 121, 1, 0),
(30, 121, 2, 0),
(30, 121, 3, 0),
(30, 121, 4, 0),
(30, 121, 5, 0),
(31, 121, 1, 0),
(31, 121, 2, 0),
(31, 121, 3, 0),
(31, 121, 4, 0),
(31, 121, 5, 0),
(32, 121, 1, 0),
(32, 121, 2, 0),
(32, 121, 3, 0),
(32, 121, 4, 0),
(32, 121, 5, 0),
(33, 121, 1, 0),
(33, 121, 2, 0),
(33, 121, 3, 0),
(33, 121, 4, 0),
(33, 121, 5, 0),
(34, 121, 1, 0),
(34, 121, 2, 0),
(34, 121, 3, 0),
(34, 121, 4, 0),
(34, 121, 5, 0),
(35, 121, 1, 0),
(35, 121, 2, 0),
(35, 121, 3, 0),
(35, 121, 4, 0),
(35, 121, 5, 0),
(36, 121, 1, 0),
(36, 121, 2, 0),
(36, 121, 3, 0),
(36, 121, 4, 0),
(36, 121, 5, 0),
(37, 121, 1, 0),
(37, 121, 2, 0),
(37, 121, 3, 0),
(37, 121, 4, 0),
(37, 121, 5, 0),
(38, 121, 1, 0),
(38, 121, 2, 0),
(38, 121, 3, 0),
(38, 121, 4, 0),
(38, 121, 5, 0),
(39, 121, 1, 0),
(39, 121, 2, 0),
(39, 121, 3, 0),
(39, 121, 4, 0),
(39, 121, 5, 0),
(40, 121, 1, 0),
(40, 121, 2, 0),
(40, 121, 3, 0),
(40, 121, 4, 0),
(40, 121, 5, 0),
(41, 121, 1, 0),
(41, 121, 2, 0),
(41, 121, 3, 0),
(41, 121, 4, 0),
(41, 121, 5, 0),
(42, 121, 1, 0),
(42, 121, 2, 0),
(42, 121, 3, 0),
(42, 121, 4, 0),
(42, 121, 5, 0),
(44, 121, 1, 0),
(44, 121, 2, 0),
(44, 121, 3, 0),
(44, 121, 4, 0),
(44, 121, 5, 0),
(45, 121, 1, 0),
(45, 121, 2, 0),
(45, 121, 3, 0),
(45, 121, 4, 0),
(45, 121, 5, 0),
(46, 121, 1, 0),
(46, 121, 2, 0),
(46, 121, 3, 0),
(46, 121, 4, 0),
(46, 121, 5, 0),
(47, 121, 1, 0),
(47, 121, 2, 0),
(47, 121, 3, 0),
(47, 121, 4, 0),
(47, 121, 5, 0),
(48, 121, 1, 0),
(48, 121, 2, 0),
(48, 121, 3, 0),
(48, 121, 4, 0),
(48, 121, 5, 0),
(49, 121, 1, 0),
(49, 121, 2, 0),
(49, 121, 3, 0),
(49, 121, 4, 0),
(49, 121, 5, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav_decimal` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Decimal Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav_decimal_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Decimal Indexer Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav_decimal_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` decimal(12,4) NOT NULL COMMENT 'Value'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Decimal Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` int(10) unsigned NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Indexer Index Table';

INSERT INTO `#__catalog_product_index_eav_idx` (`entity_id`, `attribute_id`, `store_id`, `value`) VALUES
(7, 81, 1, 9),
(7, 81, 1, 10),
(7, 81, 2, 9),
(7, 81, 2, 10),
(7, 81, 3, 9),
(7, 81, 3, 10),
(7, 81, 4, 9),
(7, 81, 4, 10),
(7, 81, 5, 9),
(7, 81, 5, 10),
(8, 81, 1, 10),
(8, 81, 2, 10),
(8, 81, 3, 10),
(8, 81, 4, 10),
(8, 81, 5, 10),
(9, 81, 1, 10),
(9, 81, 2, 10),
(9, 81, 3, 10),
(9, 81, 4, 10),
(9, 81, 5, 10),
(10, 81, 1, 10),
(10, 81, 2, 10),
(10, 81, 3, 10),
(10, 81, 4, 10),
(10, 81, 5, 10),
(11, 81, 1, 9),
(11, 81, 2, 9),
(11, 81, 3, 9),
(11, 81, 4, 9),
(11, 81, 5, 9),
(12, 81, 1, 9),
(12, 81, 2, 9),
(12, 81, 3, 9),
(12, 81, 4, 9),
(12, 81, 5, 9),
(13, 81, 1, 12),
(13, 81, 1, 13),
(13, 81, 1, 15),
(13, 81, 2, 12),
(13, 81, 2, 13),
(13, 81, 2, 15),
(13, 81, 3, 12),
(13, 81, 3, 13),
(13, 81, 3, 15),
(13, 81, 4, 12),
(13, 81, 4, 13),
(13, 81, 4, 15),
(13, 81, 5, 12),
(13, 81, 5, 13),
(13, 81, 5, 15),
(14, 81, 1, 15),
(14, 81, 2, 15),
(14, 81, 3, 15),
(14, 81, 4, 15),
(14, 81, 5, 15),
(15, 81, 1, 15),
(15, 81, 2, 15),
(15, 81, 3, 15),
(15, 81, 4, 15),
(15, 81, 5, 15),
(16, 81, 1, 12),
(16, 81, 2, 12),
(16, 81, 3, 12),
(16, 81, 4, 12),
(16, 81, 5, 12),
(17, 81, 1, 13),
(17, 81, 2, 13),
(17, 81, 3, 13),
(17, 81, 4, 13),
(17, 81, 5, 13),
(18, 81, 1, 13),
(18, 81, 2, 13),
(18, 81, 3, 13),
(18, 81, 4, 13),
(18, 81, 5, 13),
(19, 81, 1, 11),
(19, 81, 1, 14),
(19, 81, 1, 16),
(19, 81, 2, 11),
(19, 81, 2, 14),
(19, 81, 2, 16),
(19, 81, 3, 11),
(19, 81, 3, 14),
(19, 81, 3, 16),
(19, 81, 4, 11),
(19, 81, 4, 14),
(19, 81, 4, 16),
(19, 81, 5, 11),
(19, 81, 5, 14),
(19, 81, 5, 16),
(20, 81, 1, 16),
(20, 81, 2, 16),
(20, 81, 3, 16),
(20, 81, 4, 16),
(20, 81, 5, 16),
(21, 81, 1, 9),
(21, 81, 1, 10),
(21, 81, 1, 14),
(21, 81, 1, 15),
(21, 81, 1, 16),
(21, 81, 2, 9),
(21, 81, 2, 10),
(21, 81, 2, 14),
(21, 81, 2, 15),
(21, 81, 2, 16),
(21, 81, 3, 9),
(21, 81, 3, 10),
(21, 81, 3, 14),
(21, 81, 3, 15),
(21, 81, 3, 16),
(21, 81, 4, 9),
(21, 81, 4, 10),
(21, 81, 4, 14),
(21, 81, 4, 15),
(21, 81, 4, 16),
(21, 81, 5, 9),
(21, 81, 5, 10),
(21, 81, 5, 14),
(21, 81, 5, 15),
(21, 81, 5, 16),
(22, 81, 1, 14),
(22, 81, 2, 14),
(22, 81, 3, 14),
(22, 81, 4, 14),
(22, 81, 5, 14),
(23, 81, 1, 11),
(23, 81, 2, 11),
(23, 81, 3, 11),
(23, 81, 4, 11),
(23, 81, 5, 11),
(24, 81, 1, 16),
(24, 81, 2, 16),
(24, 81, 3, 16),
(24, 81, 4, 16),
(24, 81, 5, 16),
(25, 81, 1, 11),
(25, 81, 2, 11),
(25, 81, 3, 11),
(25, 81, 4, 11),
(25, 81, 5, 11),
(26, 81, 1, 11),
(26, 81, 2, 11),
(26, 81, 3, 11),
(26, 81, 4, 11),
(26, 81, 5, 11),
(27, 81, 1, 16),
(27, 81, 2, 16),
(27, 81, 3, 16),
(27, 81, 4, 16),
(27, 81, 5, 16),
(28, 81, 1, 16),
(28, 81, 2, 16),
(28, 81, 3, 16),
(28, 81, 4, 16),
(28, 81, 5, 16),
(29, 81, 1, 16),
(29, 81, 2, 16),
(29, 81, 3, 16),
(29, 81, 4, 16),
(29, 81, 5, 16),
(30, 81, 1, 16),
(30, 81, 2, 16),
(30, 81, 3, 16),
(30, 81, 4, 16),
(30, 81, 5, 16),
(31, 81, 1, 16),
(31, 81, 2, 16),
(31, 81, 3, 16),
(31, 81, 4, 16),
(31, 81, 5, 16),
(32, 81, 1, 10),
(32, 81, 2, 10),
(32, 81, 3, 10),
(32, 81, 4, 10),
(32, 81, 5, 10),
(33, 81, 1, 9),
(33, 81, 2, 9),
(33, 81, 3, 9),
(33, 81, 4, 9),
(33, 81, 5, 9),
(34, 81, 1, 15),
(34, 81, 2, 15),
(34, 81, 3, 15),
(34, 81, 4, 15),
(34, 81, 5, 15),
(35, 81, 1, 14),
(35, 81, 2, 14),
(35, 81, 3, 14),
(35, 81, 4, 14),
(35, 81, 5, 14),
(36, 81, 1, 16),
(36, 81, 2, 16),
(36, 81, 3, 16),
(36, 81, 4, 16),
(36, 81, 5, 16),
(39, 81, 1, 16),
(39, 81, 2, 16),
(39, 81, 3, 16),
(39, 81, 4, 16),
(39, 81, 5, 16),
(40, 81, 1, 13),
(40, 81, 2, 13),
(40, 81, 3, 13),
(40, 81, 4, 13),
(40, 81, 5, 13),
(41, 81, 1, 11),
(41, 81, 2, 11),
(41, 81, 3, 11),
(41, 81, 4, 11),
(41, 81, 5, 11),
(42, 81, 1, 9),
(42, 81, 1, 10),
(42, 81, 2, 9),
(42, 81, 2, 10),
(42, 81, 3, 9),
(42, 81, 3, 10),
(42, 81, 4, 9),
(42, 81, 4, 10),
(42, 81, 5, 9),
(42, 81, 5, 10),
(44, 81, 1, 10),
(44, 81, 1, 11),
(44, 81, 1, 12),
(44, 81, 1, 14),
(44, 81, 1, 15),
(44, 81, 1, 16),
(44, 81, 2, 10),
(44, 81, 2, 11),
(44, 81, 2, 12),
(44, 81, 2, 14),
(44, 81, 2, 15),
(44, 81, 2, 16),
(44, 81, 3, 10),
(44, 81, 3, 11),
(44, 81, 3, 12),
(44, 81, 3, 14),
(44, 81, 3, 15),
(44, 81, 3, 16),
(44, 81, 4, 10),
(44, 81, 4, 11),
(44, 81, 4, 12),
(44, 81, 4, 14),
(44, 81, 4, 15),
(44, 81, 4, 16),
(44, 81, 5, 10),
(44, 81, 5, 11),
(44, 81, 5, 12),
(44, 81, 5, 14),
(44, 81, 5, 15),
(44, 81, 5, 16),
(45, 81, 1, 10),
(45, 81, 1, 11),
(45, 81, 1, 12),
(45, 81, 1, 14),
(45, 81, 1, 15),
(45, 81, 1, 16),
(45, 81, 2, 10),
(45, 81, 2, 11),
(45, 81, 2, 12),
(45, 81, 2, 14),
(45, 81, 2, 15),
(45, 81, 2, 16),
(45, 81, 3, 10),
(45, 81, 3, 11),
(45, 81, 3, 12),
(45, 81, 3, 14),
(45, 81, 3, 15),
(45, 81, 3, 16),
(45, 81, 4, 10),
(45, 81, 4, 11),
(45, 81, 4, 12),
(45, 81, 4, 14),
(45, 81, 4, 15),
(45, 81, 4, 16),
(45, 81, 5, 10),
(45, 81, 5, 11),
(45, 81, 5, 12),
(45, 81, 5, 14),
(45, 81, 5, 15),
(45, 81, 5, 16),
(48, 81, 1, 9),
(48, 81, 2, 9),
(48, 81, 3, 9),
(48, 81, 4, 9),
(48, 81, 5, 9),
(7, 92, 1, 3),
(7, 92, 1, 4),
(7, 92, 1, 5),
(7, 92, 1, 6),
(7, 92, 1, 8),
(7, 92, 2, 3),
(7, 92, 2, 4),
(7, 92, 2, 5),
(7, 92, 2, 6),
(7, 92, 2, 8),
(7, 92, 3, 3),
(7, 92, 3, 4),
(7, 92, 3, 5),
(7, 92, 3, 6),
(7, 92, 3, 8),
(7, 92, 4, 3),
(7, 92, 4, 4),
(7, 92, 4, 5),
(7, 92, 4, 6),
(7, 92, 4, 8),
(7, 92, 5, 3),
(7, 92, 5, 4),
(7, 92, 5, 5),
(7, 92, 5, 6),
(7, 92, 5, 8),
(8, 92, 1, 3),
(8, 92, 2, 3),
(8, 92, 3, 3),
(8, 92, 4, 3),
(8, 92, 5, 3),
(9, 92, 1, 4),
(9, 92, 2, 4),
(9, 92, 3, 4),
(9, 92, 4, 4),
(9, 92, 5, 4),
(10, 92, 1, 6),
(10, 92, 2, 6),
(10, 92, 3, 6),
(10, 92, 4, 6),
(10, 92, 5, 6),
(11, 92, 1, 5),
(11, 92, 2, 5),
(11, 92, 3, 5),
(11, 92, 4, 5),
(11, 92, 5, 5),
(12, 92, 1, 8),
(12, 92, 2, 8),
(12, 92, 3, 8),
(12, 92, 4, 8),
(12, 92, 5, 8),
(13, 92, 1, 3),
(13, 92, 1, 4),
(13, 92, 1, 5),
(13, 92, 1, 6),
(13, 92, 1, 8),
(13, 92, 2, 3),
(13, 92, 2, 4),
(13, 92, 2, 5),
(13, 92, 2, 6),
(13, 92, 2, 8),
(13, 92, 3, 3),
(13, 92, 3, 4),
(13, 92, 3, 5),
(13, 92, 3, 6),
(13, 92, 3, 8),
(13, 92, 4, 3),
(13, 92, 4, 4),
(13, 92, 4, 5),
(13, 92, 4, 6),
(13, 92, 4, 8),
(13, 92, 5, 3),
(13, 92, 5, 4),
(13, 92, 5, 5),
(13, 92, 5, 6),
(13, 92, 5, 8),
(14, 92, 1, 3),
(14, 92, 2, 3),
(14, 92, 3, 3),
(14, 92, 4, 3),
(14, 92, 5, 3),
(15, 92, 1, 4),
(15, 92, 2, 4),
(15, 92, 3, 4),
(15, 92, 4, 4),
(15, 92, 5, 4),
(16, 92, 1, 6),
(16, 92, 2, 6),
(16, 92, 3, 6),
(16, 92, 4, 6),
(16, 92, 5, 6),
(17, 92, 1, 5),
(17, 92, 2, 5),
(17, 92, 3, 5),
(17, 92, 4, 5),
(17, 92, 5, 5),
(18, 92, 1, 8),
(18, 92, 2, 8),
(18, 92, 3, 8),
(18, 92, 4, 8),
(18, 92, 5, 8),
(19, 92, 1, 3),
(19, 92, 1, 4),
(19, 92, 1, 5),
(19, 92, 1, 6),
(19, 92, 1, 8),
(19, 92, 2, 3),
(19, 92, 2, 4),
(19, 92, 2, 5),
(19, 92, 2, 6),
(19, 92, 2, 8),
(19, 92, 3, 3),
(19, 92, 3, 4),
(19, 92, 3, 5),
(19, 92, 3, 6),
(19, 92, 3, 8),
(19, 92, 4, 3),
(19, 92, 4, 4),
(19, 92, 4, 5),
(19, 92, 4, 6),
(19, 92, 4, 8),
(19, 92, 5, 3),
(19, 92, 5, 4),
(19, 92, 5, 5),
(19, 92, 5, 6),
(19, 92, 5, 8),
(20, 92, 1, 3),
(20, 92, 1, 4),
(20, 92, 1, 5),
(20, 92, 1, 6),
(20, 92, 1, 8),
(20, 92, 2, 3),
(20, 92, 2, 4),
(20, 92, 2, 5),
(20, 92, 2, 6),
(20, 92, 2, 8),
(20, 92, 3, 3),
(20, 92, 3, 4),
(20, 92, 3, 5),
(20, 92, 3, 6),
(20, 92, 3, 8),
(20, 92, 4, 3),
(20, 92, 4, 4),
(20, 92, 4, 5),
(20, 92, 4, 6),
(20, 92, 4, 8),
(20, 92, 5, 3),
(20, 92, 5, 4),
(20, 92, 5, 5),
(20, 92, 5, 6),
(20, 92, 5, 8),
(21, 92, 1, 5),
(21, 92, 2, 5),
(21, 92, 3, 5),
(21, 92, 4, 5),
(21, 92, 5, 5),
(22, 92, 1, 8),
(22, 92, 2, 8),
(22, 92, 3, 8),
(22, 92, 4, 8),
(22, 92, 5, 8),
(23, 92, 1, 3),
(23, 92, 2, 3),
(23, 92, 3, 3),
(23, 92, 4, 3),
(23, 92, 5, 3),
(24, 92, 1, 4),
(24, 92, 2, 4),
(24, 92, 3, 4),
(24, 92, 4, 4),
(24, 92, 5, 4),
(25, 92, 1, 6),
(25, 92, 2, 6),
(25, 92, 3, 6),
(25, 92, 4, 6),
(25, 92, 5, 6),
(26, 92, 1, 5),
(26, 92, 2, 5),
(26, 92, 3, 5),
(26, 92, 4, 5),
(26, 92, 5, 5),
(27, 92, 1, 3),
(27, 92, 2, 3),
(27, 92, 3, 3),
(27, 92, 4, 3),
(27, 92, 5, 3),
(28, 92, 1, 8),
(28, 92, 2, 8),
(28, 92, 3, 8),
(28, 92, 4, 8),
(28, 92, 5, 8),
(29, 92, 1, 5),
(29, 92, 2, 5),
(29, 92, 3, 5),
(29, 92, 4, 5),
(29, 92, 5, 5),
(30, 92, 1, 6),
(30, 92, 2, 6),
(30, 92, 3, 6),
(30, 92, 4, 6),
(30, 92, 5, 6),
(31, 92, 1, 4),
(31, 92, 2, 4),
(31, 92, 3, 4),
(31, 92, 4, 4),
(31, 92, 5, 4),
(32, 92, 1, 5),
(32, 92, 2, 5),
(32, 92, 3, 5),
(32, 92, 4, 5),
(32, 92, 5, 5),
(33, 92, 1, 5),
(33, 92, 2, 5),
(33, 92, 3, 5),
(33, 92, 4, 5),
(33, 92, 5, 5),
(34, 92, 1, 5),
(34, 92, 2, 5),
(34, 92, 3, 5),
(34, 92, 4, 5),
(34, 92, 5, 5),
(35, 92, 1, 5),
(35, 92, 2, 5),
(35, 92, 3, 5),
(35, 92, 4, 5),
(35, 92, 5, 5),
(36, 92, 1, 5),
(36, 92, 2, 5),
(36, 92, 3, 5),
(36, 92, 4, 5),
(36, 92, 5, 5),
(37, 92, 1, 4),
(37, 92, 2, 4),
(37, 92, 3, 4),
(37, 92, 4, 4),
(37, 92, 5, 4),
(38, 92, 1, 3),
(38, 92, 2, 3),
(38, 92, 3, 3),
(38, 92, 4, 3),
(38, 92, 5, 3),
(39, 92, 1, 6),
(39, 92, 2, 6),
(39, 92, 3, 6),
(39, 92, 4, 6),
(39, 92, 5, 6),
(40, 92, 1, 8),
(40, 92, 2, 8),
(40, 92, 3, 8),
(40, 92, 4, 8),
(40, 92, 5, 8),
(41, 92, 1, 5),
(41, 92, 2, 5),
(41, 92, 3, 5),
(41, 92, 4, 5),
(41, 92, 5, 5),
(42, 92, 1, 3),
(42, 92, 1, 4),
(42, 92, 1, 5),
(42, 92, 1, 6),
(42, 92, 1, 8),
(42, 92, 2, 3),
(42, 92, 2, 4),
(42, 92, 2, 5),
(42, 92, 2, 6),
(42, 92, 2, 8),
(42, 92, 3, 3),
(42, 92, 3, 4),
(42, 92, 3, 5),
(42, 92, 3, 6),
(42, 92, 3, 8),
(42, 92, 4, 3),
(42, 92, 4, 4),
(42, 92, 4, 5),
(42, 92, 4, 6),
(42, 92, 4, 8),
(42, 92, 5, 3),
(42, 92, 5, 4),
(42, 92, 5, 5),
(42, 92, 5, 6),
(42, 92, 5, 8),
(44, 92, 1, 3),
(44, 92, 1, 4),
(44, 92, 1, 6),
(44, 92, 1, 8),
(44, 92, 2, 3),
(44, 92, 2, 4),
(44, 92, 2, 6),
(44, 92, 2, 8),
(44, 92, 3, 3),
(44, 92, 3, 4),
(44, 92, 3, 6),
(44, 92, 3, 8),
(44, 92, 4, 3),
(44, 92, 4, 4),
(44, 92, 4, 6),
(44, 92, 4, 8),
(44, 92, 5, 3),
(44, 92, 5, 4),
(44, 92, 5, 6),
(44, 92, 5, 8),
(45, 92, 1, 3),
(45, 92, 1, 4),
(45, 92, 1, 6),
(45, 92, 1, 8),
(45, 92, 2, 3),
(45, 92, 2, 4),
(45, 92, 2, 6),
(45, 92, 2, 8),
(45, 92, 3, 3),
(45, 92, 3, 4),
(45, 92, 3, 6),
(45, 92, 3, 8),
(45, 92, 4, 3),
(45, 92, 4, 4),
(45, 92, 4, 6),
(45, 92, 4, 8),
(45, 92, 5, 3),
(45, 92, 5, 4),
(45, 92, 5, 6),
(45, 92, 5, 8),
(48, 92, 1, 3),
(48, 92, 2, 3),
(48, 92, 3, 3),
(48, 92, 4, 3),
(48, 92, 5, 3),
(7, 121, 1, 0),
(7, 121, 2, 0),
(7, 121, 3, 0),
(7, 121, 4, 0),
(7, 121, 5, 0),
(8, 121, 1, 0),
(8, 121, 2, 0),
(8, 121, 3, 0),
(8, 121, 4, 0),
(8, 121, 5, 0),
(9, 121, 1, 0),
(9, 121, 2, 0),
(9, 121, 3, 0),
(9, 121, 4, 0),
(9, 121, 5, 0),
(10, 121, 1, 0),
(10, 121, 2, 0),
(10, 121, 3, 0),
(10, 121, 4, 0),
(10, 121, 5, 0),
(11, 121, 1, 0),
(11, 121, 2, 0),
(11, 121, 3, 0),
(11, 121, 4, 0),
(11, 121, 5, 0),
(12, 121, 1, 0),
(12, 121, 2, 0),
(12, 121, 3, 0),
(12, 121, 4, 0),
(12, 121, 5, 0),
(13, 121, 1, 0),
(13, 121, 2, 0),
(13, 121, 3, 0),
(13, 121, 4, 0),
(13, 121, 5, 0),
(14, 121, 1, 0),
(14, 121, 2, 0),
(14, 121, 3, 0),
(14, 121, 4, 0),
(14, 121, 5, 0),
(15, 121, 1, 0),
(15, 121, 2, 0),
(15, 121, 3, 0),
(15, 121, 4, 0),
(15, 121, 5, 0),
(16, 121, 1, 0),
(16, 121, 2, 0),
(16, 121, 3, 0),
(16, 121, 4, 0),
(16, 121, 5, 0),
(17, 121, 1, 0),
(17, 121, 2, 0),
(17, 121, 3, 0),
(17, 121, 4, 0),
(17, 121, 5, 0),
(18, 121, 1, 0),
(18, 121, 2, 0),
(18, 121, 3, 0),
(18, 121, 4, 0),
(18, 121, 5, 0),
(19, 121, 1, 0),
(19, 121, 2, 0),
(19, 121, 3, 0),
(19, 121, 4, 0),
(19, 121, 5, 0),
(20, 121, 1, 0),
(20, 121, 2, 0),
(20, 121, 3, 0),
(20, 121, 4, 0),
(20, 121, 5, 0),
(21, 121, 1, 0),
(21, 121, 2, 0),
(21, 121, 3, 0),
(21, 121, 4, 0),
(21, 121, 5, 0),
(22, 121, 1, 0),
(22, 121, 2, 0),
(22, 121, 3, 0),
(22, 121, 4, 0),
(22, 121, 5, 0),
(23, 121, 1, 0),
(23, 121, 2, 0),
(23, 121, 3, 0),
(23, 121, 4, 0),
(23, 121, 5, 0),
(24, 121, 1, 0),
(24, 121, 2, 0),
(24, 121, 3, 0),
(24, 121, 4, 0),
(24, 121, 5, 0),
(25, 121, 1, 0),
(25, 121, 2, 0),
(25, 121, 3, 0),
(25, 121, 4, 0),
(25, 121, 5, 0),
(26, 121, 1, 0),
(26, 121, 2, 0),
(26, 121, 3, 0),
(26, 121, 4, 0),
(26, 121, 5, 0),
(27, 121, 1, 0),
(27, 121, 2, 0),
(27, 121, 3, 0),
(27, 121, 4, 0),
(27, 121, 5, 0),
(28, 121, 1, 0),
(28, 121, 2, 0),
(28, 121, 3, 0),
(28, 121, 4, 0),
(28, 121, 5, 0),
(29, 121, 1, 0),
(29, 121, 2, 0),
(29, 121, 3, 0),
(29, 121, 4, 0),
(29, 121, 5, 0),
(30, 121, 1, 0),
(30, 121, 2, 0),
(30, 121, 3, 0),
(30, 121, 4, 0),
(30, 121, 5, 0),
(31, 121, 1, 0),
(31, 121, 2, 0),
(31, 121, 3, 0),
(31, 121, 4, 0),
(31, 121, 5, 0),
(32, 121, 1, 0),
(32, 121, 2, 0),
(32, 121, 3, 0),
(32, 121, 4, 0),
(32, 121, 5, 0),
(33, 121, 1, 0),
(33, 121, 2, 0),
(33, 121, 3, 0),
(33, 121, 4, 0),
(33, 121, 5, 0),
(34, 121, 1, 0),
(34, 121, 2, 0),
(34, 121, 3, 0),
(34, 121, 4, 0),
(34, 121, 5, 0),
(35, 121, 1, 0),
(35, 121, 2, 0),
(35, 121, 3, 0),
(35, 121, 4, 0),
(35, 121, 5, 0),
(36, 121, 1, 0),
(36, 121, 2, 0),
(36, 121, 3, 0),
(36, 121, 4, 0),
(36, 121, 5, 0),
(37, 121, 1, 0),
(37, 121, 2, 0),
(37, 121, 3, 0),
(37, 121, 4, 0),
(37, 121, 5, 0),
(38, 121, 1, 0),
(38, 121, 2, 0),
(38, 121, 3, 0),
(38, 121, 4, 0),
(38, 121, 5, 0),
(39, 121, 1, 0),
(39, 121, 2, 0),
(39, 121, 3, 0),
(39, 121, 4, 0),
(39, 121, 5, 0),
(40, 121, 1, 0),
(40, 121, 2, 0),
(40, 121, 3, 0),
(40, 121, 4, 0),
(40, 121, 5, 0),
(41, 121, 1, 0),
(41, 121, 2, 0),
(41, 121, 3, 0),
(41, 121, 4, 0),
(41, 121, 5, 0),
(42, 121, 1, 0),
(42, 121, 2, 0),
(42, 121, 3, 0),
(42, 121, 4, 0),
(42, 121, 5, 0),
(44, 121, 1, 0),
(44, 121, 2, 0),
(44, 121, 3, 0),
(44, 121, 4, 0),
(44, 121, 5, 0),
(45, 121, 1, 0),
(45, 121, 2, 0),
(45, 121, 3, 0),
(45, 121, 4, 0),
(45, 121, 5, 0),
(46, 121, 1, 0),
(46, 121, 2, 0),
(46, 121, 3, 0),
(46, 121, 4, 0),
(46, 121, 5, 0),
(47, 121, 1, 0),
(47, 121, 2, 0),
(47, 121, 3, 0),
(47, 121, 4, 0),
(47, 121, 5, 0),
(48, 121, 1, 0),
(48, 121, 2, 0),
(48, 121, 3, 0),
(48, 121, 4, 0),
(48, 121, 5, 0),
(49, 121, 1, 0),
(49, 121, 2, 0),
(49, 121, 3, 0),
(49, 121, 4, 0),
(49, 121, 5, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_eav_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `value` int(10) unsigned NOT NULL COMMENT 'Value'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product EAV Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_group_price` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Group Price Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(12,4) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Index Table';

INSERT INTO `#__catalog_product_index_price` (`entity_id`, `customer_group_id`, `website_id`, `tax_class_id`, `price`, `final_price`, `min_price`, `max_price`, `tier_price`, `group_price`) VALUES
(7, 0, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 1, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 2, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 3, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(8, 0, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 1, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 2, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 3, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(9, 0, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 1, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 2, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 3, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(10, 0, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 1, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 2, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 3, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(11, 0, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 1, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 2, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 3, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(12, 0, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 1, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 2, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 3, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(13, 0, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 1, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 2, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 3, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(14, 0, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 1, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 2, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 3, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(15, 0, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 1, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 2, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 3, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(16, 0, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 1, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 2, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 3, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(17, 0, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 1, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 2, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 3, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(18, 0, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 1, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 2, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 3, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(19, 0, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 1, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 2, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 3, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(20, 0, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 1, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 2, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 3, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(21, 0, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 1, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 2, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 3, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(22, 0, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 1, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 2, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 3, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(23, 0, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 1, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 2, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 3, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(24, 0, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 1, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 2, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 3, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(25, 0, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 1, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 2, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 3, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(26, 0, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 1, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 2, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 3, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(27, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(31, 0, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 1, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 2, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 3, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(32, 0, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 1, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 2, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 3, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(33, 0, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 1, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 2, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 3, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(34, 0, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 1, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 2, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 3, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(35, 0, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 1, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 2, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 3, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(36, 0, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 1, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 2, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 3, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(37, 0, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 1, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 2, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 3, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(38, 0, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 1, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 2, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 3, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(39, 0, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 1, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 2, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 3, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(40, 0, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 1, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 2, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 3, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(41, 0, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 1, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 2, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 3, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(42, 0, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 1, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 2, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 3, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(44, 0, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 1, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 2, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 3, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(45, 0, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 1, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 2, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 3, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(46, 0, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 1, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 2, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 3, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(47, 0, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 1, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 2, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 3, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(48, 0, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 1, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 2, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 3, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(49, 0, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 1, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 2, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 3, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class Id',
  `price_type` smallint(5) unsigned NOT NULL COMMENT 'Price Type',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `tier_percent` decimal(12,4) DEFAULT NULL COMMENT 'Tier Percent',
  `orig_price` decimal(12,4) DEFAULT NULL COMMENT 'Orig Price',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(12,4) DEFAULT NULL COMMENT 'Base Tier',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `base_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Group Price',
  `group_price_percent` decimal(12,4) DEFAULT NULL COMMENT 'Group Price Percent'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Idx';

INSERT INTO `#__catalog_product_index_price_bundle_idx` (`entity_id`, `customer_group_id`, `website_id`, `tax_class_id`, `price_type`, `special_price`, `tier_percent`, `orig_price`, `price`, `min_price`, `max_price`, `tier_price`, `base_tier`, `group_price`, `base_group_price`, `group_price_percent`) VALUES
(44, 0, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(44, 1, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(44, 2, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(44, 3, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(45, 0, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(45, 1, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(45, 2, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL),
(45, 3, 1, 0, 0, '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_opt_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `alt_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `alt_tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `alt_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Group Price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Opt Idx';

INSERT INTO `#__catalog_product_index_price_bundle_opt_idx` (`entity_id`, `customer_group_id`, `website_id`, `option_id`, `min_price`, `alt_price`, `max_price`, `tier_price`, `alt_tier_price`, `group_price`, `alt_group_price`) VALUES
(44, 0, 1, 1, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(44, 0, 1, 2, '366.4500', '0.0000', '1113.3100', NULL, '0.0000', NULL, '0.0000'),
(44, 0, 1, 3, '0.0000', '521.0000', '659.0000', '0.0000', NULL, '0.0000', NULL),
(44, 0, 1, 4, '3740.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(44, 1, 1, 1, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(44, 1, 1, 2, '366.4500', '0.0000', '1113.3100', NULL, '0.0000', NULL, '0.0000'),
(44, 1, 1, 3, '0.0000', '521.0000', '659.0000', '0.0000', NULL, '0.0000', NULL),
(44, 1, 1, 4, '3740.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(44, 2, 1, 1, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(44, 2, 1, 2, '366.4500', '0.0000', '1113.3100', NULL, '0.0000', NULL, '0.0000'),
(44, 2, 1, 3, '0.0000', '521.0000', '659.0000', '0.0000', NULL, '0.0000', NULL),
(44, 2, 1, 4, '3740.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(44, 3, 1, 1, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(44, 3, 1, 2, '366.4500', '0.0000', '1113.3100', NULL, '0.0000', NULL, '0.0000'),
(44, 3, 1, 3, '0.0000', '521.0000', '659.0000', '0.0000', NULL, '0.0000', NULL),
(44, 3, 1, 4, '3740.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(45, 0, 1, 5, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(45, 0, 1, 6, '373.4300', '0.0000', '373.4300', NULL, '0.0000', NULL, '0.0000'),
(45, 0, 1, 7, '0.0000', '521.0000', '624.0000', '0.0000', NULL, '0.0000', NULL),
(45, 0, 1, 8, '4180.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(45, 1, 1, 5, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(45, 1, 1, 6, '373.4300', '0.0000', '373.4300', NULL, '0.0000', NULL, '0.0000'),
(45, 1, 1, 7, '0.0000', '521.0000', '624.0000', '0.0000', NULL, '0.0000', NULL),
(45, 1, 1, 8, '4180.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(45, 2, 1, 5, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(45, 2, 1, 6, '373.4300', '0.0000', '373.4300', NULL, '0.0000', NULL, '0.0000'),
(45, 2, 1, 7, '0.0000', '521.0000', '624.0000', '0.0000', NULL, '0.0000', NULL),
(45, 2, 1, 8, '4180.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000'),
(45, 3, 1, 5, '0.0000', '406.0000', '1259.8600', '0.0000', NULL, '0.0000', NULL),
(45, 3, 1, 6, '373.4300', '0.0000', '373.4300', NULL, '0.0000', NULL, '0.0000'),
(45, 3, 1, 7, '0.0000', '521.0000', '624.0000', '0.0000', NULL, '0.0000', NULL),
(45, 3, 1, 8, '4180.0000', '0.0000', '4345.0000', NULL, '0.0000', NULL, '0.0000');

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_opt_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `alt_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `alt_tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `alt_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Alt Group Price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Opt Tmp';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_sel_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `selection_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Id',
  `group_type` smallint(5) unsigned DEFAULT '0' COMMENT 'Group Type',
  `is_required` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Required',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Sel Idx';

INSERT INTO `#__catalog_product_index_price_bundle_sel_idx` (`entity_id`, `customer_group_id`, `website_id`, `option_id`, `selection_id`, `group_type`, `is_required`, `price`, `tier_price`, `group_price`) VALUES
(44, 0, 1, 1, 1, 1, 0, '410.9700', NULL, NULL),
(44, 0, 1, 1, 2, 1, 0, '406.0000', NULL, NULL),
(44, 0, 1, 1, 3, 1, 0, '442.8900', NULL, NULL),
(44, 0, 1, 2, 4, 1, 1, '373.4300', NULL, NULL),
(44, 0, 1, 2, 5, 1, 1, '366.4500', NULL, NULL),
(44, 0, 1, 2, 6, 1, 1, '373.4300', NULL, NULL),
(44, 0, 1, 3, 7, 0, 0, '624.0000', NULL, NULL),
(44, 0, 1, 3, 8, 0, 0, '659.0000', NULL, NULL),
(44, 0, 1, 3, 9, 0, 0, '521.0000', NULL, NULL),
(44, 0, 1, 4, 10, 0, 1, '3740.0000', NULL, NULL),
(44, 0, 1, 4, 11, 0, 1, '4180.0000', NULL, NULL),
(44, 0, 1, 4, 12, 0, 1, '4345.0000', NULL, NULL),
(44, 1, 1, 1, 1, 1, 0, '410.9700', NULL, NULL),
(44, 1, 1, 1, 2, 1, 0, '406.0000', NULL, NULL),
(44, 1, 1, 1, 3, 1, 0, '442.8900', NULL, NULL),
(44, 1, 1, 2, 4, 1, 1, '373.4300', NULL, NULL),
(44, 1, 1, 2, 5, 1, 1, '366.4500', NULL, NULL),
(44, 1, 1, 2, 6, 1, 1, '373.4300', NULL, NULL),
(44, 1, 1, 3, 7, 0, 0, '624.0000', NULL, NULL),
(44, 1, 1, 3, 8, 0, 0, '659.0000', NULL, NULL),
(44, 1, 1, 3, 9, 0, 0, '521.0000', NULL, NULL),
(44, 1, 1, 4, 10, 0, 1, '3740.0000', NULL, NULL),
(44, 1, 1, 4, 11, 0, 1, '4180.0000', NULL, NULL),
(44, 1, 1, 4, 12, 0, 1, '4345.0000', NULL, NULL),
(44, 2, 1, 1, 1, 1, 0, '410.9700', NULL, NULL),
(44, 2, 1, 1, 2, 1, 0, '406.0000', NULL, NULL),
(44, 2, 1, 1, 3, 1, 0, '442.8900', NULL, NULL),
(44, 2, 1, 2, 4, 1, 1, '373.4300', NULL, NULL),
(44, 2, 1, 2, 5, 1, 1, '366.4500', NULL, NULL),
(44, 2, 1, 2, 6, 1, 1, '373.4300', NULL, NULL),
(44, 2, 1, 3, 7, 0, 0, '624.0000', NULL, NULL),
(44, 2, 1, 3, 8, 0, 0, '659.0000', NULL, NULL),
(44, 2, 1, 3, 9, 0, 0, '521.0000', NULL, NULL),
(44, 2, 1, 4, 10, 0, 1, '3740.0000', NULL, NULL),
(44, 2, 1, 4, 11, 0, 1, '4180.0000', NULL, NULL),
(44, 2, 1, 4, 12, 0, 1, '4345.0000', NULL, NULL),
(44, 3, 1, 1, 1, 1, 0, '410.9700', NULL, NULL),
(44, 3, 1, 1, 2, 1, 0, '406.0000', NULL, NULL),
(44, 3, 1, 1, 3, 1, 0, '442.8900', NULL, NULL),
(44, 3, 1, 2, 4, 1, 1, '373.4300', NULL, NULL),
(44, 3, 1, 2, 5, 1, 1, '366.4500', NULL, NULL),
(44, 3, 1, 2, 6, 1, 1, '373.4300', NULL, NULL),
(44, 3, 1, 3, 7, 0, 0, '624.0000', NULL, NULL),
(44, 3, 1, 3, 8, 0, 0, '659.0000', NULL, NULL),
(44, 3, 1, 3, 9, 0, 0, '521.0000', NULL, NULL),
(44, 3, 1, 4, 10, 0, 1, '3740.0000', NULL, NULL),
(44, 3, 1, 4, 11, 0, 1, '4180.0000', NULL, NULL),
(44, 3, 1, 4, 12, 0, 1, '4345.0000', NULL, NULL),
(45, 0, 1, 5, 13, 1, 0, '410.9700', NULL, NULL),
(45, 0, 1, 5, 14, 1, 0, '406.0000', NULL, NULL),
(45, 0, 1, 5, 15, 1, 0, '442.8900', NULL, NULL),
(45, 0, 1, 6, 16, 0, 1, '373.4300', NULL, NULL),
(45, 0, 1, 6, 18, 0, 1, '373.4300', NULL, NULL),
(45, 0, 1, 7, 19, 0, 0, '624.0000', NULL, NULL),
(45, 0, 1, 7, 21, 0, 0, '521.0000', NULL, NULL),
(45, 0, 1, 8, 23, 0, 1, '4180.0000', NULL, NULL),
(45, 0, 1, 8, 24, 0, 1, '4345.0000', NULL, NULL),
(45, 1, 1, 5, 13, 1, 0, '410.9700', NULL, NULL),
(45, 1, 1, 5, 14, 1, 0, '406.0000', NULL, NULL),
(45, 1, 1, 5, 15, 1, 0, '442.8900', NULL, NULL),
(45, 1, 1, 6, 16, 0, 1, '373.4300', NULL, NULL),
(45, 1, 1, 6, 18, 0, 1, '373.4300', NULL, NULL),
(45, 1, 1, 7, 19, 0, 0, '624.0000', NULL, NULL),
(45, 1, 1, 7, 21, 0, 0, '521.0000', NULL, NULL),
(45, 1, 1, 8, 23, 0, 1, '4180.0000', NULL, NULL),
(45, 1, 1, 8, 24, 0, 1, '4345.0000', NULL, NULL),
(45, 2, 1, 5, 13, 1, 0, '410.9700', NULL, NULL),
(45, 2, 1, 5, 14, 1, 0, '406.0000', NULL, NULL),
(45, 2, 1, 5, 15, 1, 0, '442.8900', NULL, NULL),
(45, 2, 1, 6, 16, 0, 1, '373.4300', NULL, NULL),
(45, 2, 1, 6, 18, 0, 1, '373.4300', NULL, NULL),
(45, 2, 1, 7, 19, 0, 0, '624.0000', NULL, NULL),
(45, 2, 1, 7, 21, 0, 0, '521.0000', NULL, NULL),
(45, 2, 1, 8, 23, 0, 1, '4180.0000', NULL, NULL),
(45, 2, 1, 8, 24, 0, 1, '4345.0000', NULL, NULL),
(45, 3, 1, 5, 13, 1, 0, '410.9700', NULL, NULL),
(45, 3, 1, 5, 14, 1, 0, '406.0000', NULL, NULL),
(45, 3, 1, 5, 15, 1, 0, '442.8900', NULL, NULL),
(45, 3, 1, 6, 16, 0, 1, '373.4300', NULL, NULL),
(45, 3, 1, 6, 18, 0, 1, '373.4300', NULL, NULL),
(45, 3, 1, 7, 19, 0, 0, '624.0000', NULL, NULL),
(45, 3, 1, 7, 21, 0, 0, '521.0000', NULL, NULL),
(45, 3, 1, 8, 23, 0, 1, '4180.0000', NULL, NULL),
(45, 3, 1, 8, 24, 0, 1, '4345.0000', NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_sel_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `selection_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Selection Id',
  `group_type` smallint(5) unsigned DEFAULT '0' COMMENT 'Group Type',
  `is_required` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Required',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Sel Tmp';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_bundle_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class Id',
  `price_type` smallint(5) unsigned NOT NULL COMMENT 'Price Type',
  `special_price` decimal(12,4) DEFAULT NULL COMMENT 'Special Price',
  `tier_percent` decimal(12,4) DEFAULT NULL COMMENT 'Tier Percent',
  `orig_price` decimal(12,4) DEFAULT NULL COMMENT 'Orig Price',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(12,4) DEFAULT NULL COMMENT 'Base Tier',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `base_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Group Price',
  `group_price_percent` decimal(12,4) DEFAULT NULL COMMENT 'Group Price Percent'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Index Price Bundle Tmp';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_cfg_opt_agr_idx` (
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int(10) unsigned NOT NULL COMMENT 'Child ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Config Option Aggregate Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_cfg_opt_agr_tmp` (
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int(10) unsigned NOT NULL COMMENT 'Child ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Config Option Aggregate Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_cfg_opt_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Config Option Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_cfg_opt_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Config Option Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_downlod_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Minimum price',
  `max_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Maximum price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Indexer Table for price of downloadable products';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_downlod_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Minimum price',
  `max_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Maximum price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Temporary Indexer Table for price of downloadable products';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_final_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `orig_price` decimal(12,4) DEFAULT NULL COMMENT 'Original Price',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(12,4) DEFAULT NULL COMMENT 'Base Tier',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `base_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Group Price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Final Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_final_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `orig_price` decimal(12,4) DEFAULT NULL COMMENT 'Original Price',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `base_tier` decimal(12,4) DEFAULT NULL COMMENT 'Base Tier',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price',
  `base_group_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Group Price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Final Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(12,4) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Index Table';

INSERT INTO `#__catalog_product_index_price_idx` (`entity_id`, `customer_group_id`, `website_id`, `tax_class_id`, `price`, `final_price`, `min_price`, `max_price`, `tier_price`, `group_price`) VALUES
(7, 0, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 1, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 2, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(7, 3, 1, 0, '599.0000', '599.0000', '604.0000', '668.9000', NULL, NULL),
(8, 0, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 1, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 2, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(8, 3, 1, 0, '624.0000', '624.0000', '624.0000', '624.0000', NULL, NULL),
(9, 0, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 1, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 2, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(9, 3, 1, 0, '668.9000', '659.0000', '659.0000', '659.0000', NULL, NULL),
(10, 0, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 1, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 2, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(10, 3, 1, 0, '609.0000', '521.0000', '521.0000', '521.0000', NULL, NULL),
(11, 0, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 1, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 2, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(11, 3, 1, 0, '614.0000', '614.0000', '614.0000', '614.0000', NULL, NULL),
(12, 0, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 1, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 2, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(12, 3, 1, 0, '599.0000', '499.0000', '499.0000', '499.0000', NULL, NULL),
(13, 0, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 1, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 2, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(13, 3, 1, 0, '349.0000', '349.0000', '352.4900', '373.4300', NULL, NULL),
(14, 0, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 1, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 2, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(14, 3, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(15, 0, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 1, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 2, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(15, 3, 1, 0, '366.4500', '366.4500', '366.4500', '366.4500', NULL, NULL),
(16, 0, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 1, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 2, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(16, 3, 1, 0, '373.4300', '373.4300', '373.4300', '373.4300', NULL, NULL),
(17, 0, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 1, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 2, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(17, 3, 1, 0, '367.4900', '367.4900', '367.4900', '367.4900', NULL, NULL),
(18, 0, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 1, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 2, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(18, 3, 1, 0, '352.4900', '352.4900', '352.4900', '352.4900', NULL, NULL),
(19, 0, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 1, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 2, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(19, 3, 1, 0, '399.0000', '399.0000', '399.0000', '442.8900', NULL, NULL),
(20, 0, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 1, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 2, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(20, 3, 1, 0, '99.0000', '99.0000', '100.9800', '109.0000', NULL, NULL),
(21, 0, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 1, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 2, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(21, 3, 1, 0, '179.0000', '179.0000', '189.0000', '209.0000', NULL, NULL),
(22, 0, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 1, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 2, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(22, 3, 1, 0, '410.9700', '410.9700', '410.9700', '410.9700', NULL, NULL),
(23, 0, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 1, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 2, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(23, 3, 1, 0, '406.0000', '406.0000', '406.0000', '406.0000', NULL, NULL),
(24, 0, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 1, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 2, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(24, 3, 1, 0, '442.8900', '442.8900', '442.8900', '442.8900', NULL, NULL),
(25, 0, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 1, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 2, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(25, 3, 1, 0, '412.0000', '412.0000', '412.0000', '412.0000', NULL, NULL),
(26, 0, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 1, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 2, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(26, 3, 1, 0, '417.0000', '417.0000', '417.0000', '417.0000', NULL, NULL),
(27, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(27, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(28, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(29, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 0, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 1, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 2, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(30, 3, 1, 0, '100.9800', '100.9800', '100.9800', '100.9800', NULL, NULL),
(31, 0, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 1, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 2, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(31, 3, 1, 0, '109.0000', '109.0000', '109.0000', '109.0000', NULL, NULL),
(32, 0, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 1, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 2, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(32, 3, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(33, 0, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 1, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 2, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(33, 3, 1, 0, '199.0000', '199.0000', '199.0000', '199.0000', NULL, NULL),
(34, 0, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 1, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 2, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(34, 3, 1, 0, '209.0000', '209.0000', '209.0000', '209.0000', NULL, NULL),
(35, 0, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 1, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 2, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(35, 3, 1, 0, '189.0000', '189.0000', '189.0000', '189.0000', NULL, NULL),
(36, 0, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 1, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 2, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(36, 3, 1, 0, '194.0000', '194.0000', '194.0000', '194.0000', NULL, NULL),
(37, 0, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 1, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 2, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(37, 3, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(38, 0, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 1, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 2, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(38, 3, 1, 0, '76.0000', '76.0000', '76.0000', '76.0000', NULL, NULL),
(39, 0, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 1, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 2, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(39, 3, 1, 0, '79.0000', '79.0000', '79.0000', '79.0000', NULL, NULL),
(40, 0, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 1, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 2, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(40, 3, 1, 0, '119.0000', '119.0000', '119.0000', '119.0000', NULL, NULL),
(41, 0, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 1, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 2, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(41, 3, 1, 0, '113.0000', '113.0000', '113.0000', '113.0000', NULL, NULL),
(42, 0, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 1, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 2, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(42, 3, 1, 0, NULL, NULL, '499.0000', '659.0000', NULL, NULL),
(44, 0, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 1, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 2, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(44, 3, 1, 0, '0.0000', '0.0000', '4106.4500', '7377.1700', NULL, NULL),
(45, 0, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 1, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 2, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(45, 3, 1, 0, '0.0000', '0.0000', '4553.4300', '6602.2900', NULL, NULL),
(46, 0, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 1, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 2, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(46, 3, 1, 0, '1102.0000', '1102.0000', '1112.0000', '1147.0000', NULL, NULL),
(47, 0, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 1, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 2, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(47, 3, 1, 0, '68.0000', '68.0000', '68.0000', '68.0000', NULL, NULL),
(48, 0, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 1, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 2, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(48, 3, 1, 0, '212.0000', '212.0000', '212.0000', '1050.0000', NULL, NULL),
(49, 0, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 1, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 2, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL),
(49, 3, 1, 0, '95.0000', '95.0000', '95.0000', '95.0000', NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_opt_agr_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Option Aggregate Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_opt_agr_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Option Aggregate Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_opt_idx` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Option Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_opt_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Option Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_price_tmp` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `tax_class_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Tax Class ID',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `final_price` decimal(12,4) DEFAULT NULL COMMENT 'Final Price',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price',
  `max_price` decimal(12,4) DEFAULT NULL COMMENT 'Max Price',
  `tier_price` decimal(12,4) DEFAULT NULL COMMENT 'Tier Price',
  `group_price` decimal(12,4) DEFAULT NULL COMMENT 'Group price'
) ENGINE=MEMORY DEFAULT CHARSET=utf8 COMMENT='Catalog Product Price Indexer Temp Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_tier_price` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `min_price` decimal(12,4) DEFAULT NULL COMMENT 'Min Price'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Tier Price Index Table';

CREATE TABLE IF NOT EXISTS `#__catalog_product_index_website` (
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID',
  `website_date` date DEFAULT NULL COMMENT 'Website Date',
  `rate` float DEFAULT '1' COMMENT 'Rate'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Website Index Table';

INSERT INTO `#__catalog_product_index_website` (`website_id`, `website_date`, `rate`) VALUES
(1, '2015-07-14', 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_link` (
`link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `linked_product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Linked Product ID',
  `link_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Link Type ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product To Product Linkage Table' AUTO_INCREMENT=2327 ;

INSERT INTO `#__catalog_product_link` (`link_id`, `product_id`, `linked_product_id`, `link_type_id`) VALUES
(221, 7, 29, 1),
(222, 7, 30, 1),
(223, 7, 31, 1),
(224, 7, 32, 1),
(225, 7, 33, 1),
(226, 7, 34, 1),
(227, 7, 35, 1),
(228, 7, 36, 1),
(229, 7, 37, 1),
(230, 7, 38, 1),
(231, 7, 39, 1),
(232, 7, 40, 1),
(233, 7, 41, 1),
(234, 7, 42, 1),
(236, 7, 44, 1),
(237, 7, 45, 1),
(238, 7, 46, 1),
(239, 7, 47, 1),
(240, 7, 48, 1),
(2063, 8, 29, 1),
(2064, 8, 30, 1),
(2065, 8, 31, 1),
(2066, 8, 32, 1),
(2067, 8, 33, 1),
(2068, 8, 34, 1),
(2069, 8, 35, 1),
(2070, 8, 36, 1),
(2071, 8, 37, 1),
(2072, 8, 38, 1),
(2073, 8, 39, 1),
(2074, 8, 40, 1),
(2075, 8, 41, 1),
(2076, 8, 42, 1),
(2078, 8, 44, 1),
(2079, 8, 45, 1),
(2080, 8, 46, 1),
(2081, 8, 47, 1),
(2082, 8, 48, 1),
(2022, 9, 7, 1),
(2023, 9, 8, 1),
(2024, 9, 10, 1),
(2025, 9, 11, 1),
(2026, 9, 12, 1),
(2027, 9, 13, 1),
(2028, 9, 14, 1),
(2029, 9, 15, 1),
(2030, 9, 16, 1),
(2031, 9, 17, 1),
(2032, 9, 18, 1),
(2033, 9, 19, 1),
(2034, 9, 20, 1),
(2035, 9, 21, 1),
(2036, 9, 22, 1),
(2037, 9, 23, 1),
(2038, 9, 24, 1),
(2039, 9, 25, 1),
(2040, 9, 26, 1),
(2041, 9, 27, 1),
(2042, 9, 28, 1),
(2043, 9, 29, 1),
(2044, 9, 30, 1),
(2045, 9, 31, 1),
(2046, 9, 32, 1),
(2047, 9, 33, 1),
(2048, 9, 34, 1),
(2049, 9, 35, 1),
(2050, 9, 36, 1),
(2051, 9, 37, 1),
(2052, 9, 38, 1),
(2053, 9, 39, 1),
(2054, 9, 40, 1),
(2055, 9, 41, 1),
(2056, 9, 42, 1),
(2058, 9, 44, 1),
(2059, 9, 45, 1),
(2060, 9, 46, 1),
(2061, 9, 47, 1),
(2062, 9, 48, 1),
(1940, 10, 7, 1),
(1941, 10, 8, 1),
(1942, 10, 9, 1),
(1943, 10, 11, 1),
(1944, 10, 12, 1),
(1945, 10, 13, 1),
(1946, 10, 14, 1),
(1947, 10, 15, 1),
(1948, 10, 16, 1),
(1949, 10, 17, 1),
(1950, 10, 18, 1),
(1951, 10, 19, 1),
(1952, 10, 20, 1),
(1953, 10, 21, 1),
(1954, 10, 22, 1),
(1955, 10, 23, 1),
(1956, 10, 24, 1),
(1957, 10, 25, 1),
(1958, 10, 26, 1),
(1959, 10, 27, 1),
(1960, 10, 28, 1),
(1961, 10, 29, 1),
(1962, 10, 30, 1),
(1963, 10, 31, 1),
(1964, 10, 32, 1),
(1965, 10, 33, 1),
(1966, 10, 34, 1),
(1967, 10, 35, 1),
(1968, 10, 36, 1),
(1969, 10, 37, 1),
(1970, 10, 38, 1),
(1971, 10, 39, 1),
(1972, 10, 40, 1),
(1973, 10, 41, 1),
(1974, 10, 42, 1),
(1976, 10, 44, 1),
(1977, 10, 45, 1),
(1978, 10, 46, 1),
(1979, 10, 47, 1),
(1980, 10, 48, 1),
(1981, 11, 7, 1),
(1982, 11, 8, 1),
(1983, 11, 9, 1),
(1984, 11, 10, 1),
(1985, 11, 12, 1),
(1986, 11, 13, 1),
(1987, 11, 14, 1),
(1988, 11, 15, 1),
(1989, 11, 16, 1),
(1990, 11, 17, 1),
(1991, 11, 18, 1),
(1992, 11, 19, 1),
(1993, 11, 20, 1),
(1994, 11, 21, 1),
(1995, 11, 22, 1),
(1996, 11, 23, 1),
(1997, 11, 24, 1),
(1998, 11, 25, 1),
(1999, 11, 26, 1),
(2000, 11, 27, 1),
(2001, 11, 28, 1),
(2002, 11, 29, 1),
(2003, 11, 30, 1),
(2004, 11, 31, 1),
(2005, 11, 32, 1),
(2006, 11, 33, 1),
(2007, 11, 34, 1),
(2008, 11, 35, 1),
(2009, 11, 36, 1),
(2010, 11, 37, 1),
(2011, 11, 38, 1),
(2012, 11, 39, 1),
(2013, 11, 40, 1),
(2014, 11, 41, 1),
(2015, 11, 42, 1),
(2017, 11, 44, 1),
(2018, 11, 45, 1),
(2019, 11, 46, 1),
(2020, 11, 47, 1),
(2021, 11, 48, 1),
(2083, 12, 29, 1),
(2084, 12, 30, 1),
(2085, 12, 31, 1),
(2086, 12, 32, 1),
(2087, 12, 33, 1),
(2088, 12, 34, 1),
(2089, 12, 35, 1),
(2090, 12, 36, 1),
(2091, 12, 37, 1),
(2092, 12, 38, 1),
(2093, 12, 39, 1),
(2094, 12, 40, 1),
(2095, 12, 41, 1),
(2096, 12, 42, 1),
(2098, 12, 44, 1),
(2099, 12, 45, 1),
(2100, 12, 46, 1),
(2101, 12, 47, 1),
(2102, 12, 48, 1),
(2103, 14, 7, 1),
(2104, 14, 8, 1),
(2105, 14, 9, 1),
(2106, 14, 10, 1),
(2107, 14, 11, 1),
(2108, 14, 12, 1),
(2109, 14, 13, 1),
(2110, 14, 15, 1),
(2111, 14, 16, 1),
(2112, 14, 17, 1),
(2113, 14, 18, 1),
(2114, 14, 19, 1),
(2115, 14, 20, 1),
(2116, 14, 21, 1),
(2117, 14, 22, 1),
(2118, 14, 23, 1),
(2119, 14, 24, 1),
(2120, 14, 25, 1),
(2121, 14, 26, 1),
(2122, 14, 27, 1),
(2123, 14, 28, 1),
(2124, 14, 29, 1),
(2125, 14, 30, 1),
(2126, 14, 31, 1),
(2127, 14, 32, 1),
(2128, 14, 33, 1),
(2129, 14, 34, 1),
(2130, 14, 35, 1),
(2131, 14, 36, 1),
(2132, 14, 37, 1),
(2133, 14, 38, 1),
(2134, 14, 39, 1),
(2135, 14, 40, 1),
(2136, 14, 41, 1),
(2137, 14, 42, 1),
(2139, 14, 44, 1),
(2140, 14, 45, 1),
(2141, 14, 46, 1),
(2142, 14, 47, 1),
(2143, 14, 48, 1),
(2144, 15, 29, 1),
(2145, 15, 30, 1),
(2146, 15, 31, 1),
(2147, 15, 32, 1),
(2148, 15, 33, 1),
(2149, 15, 34, 1),
(2150, 15, 35, 1),
(2151, 15, 36, 1),
(2152, 15, 37, 1),
(2153, 15, 38, 1),
(2154, 15, 39, 1),
(2155, 15, 40, 1),
(2156, 15, 41, 1),
(2157, 15, 42, 1),
(2159, 15, 44, 1),
(2160, 15, 45, 1),
(2161, 15, 46, 1),
(2162, 15, 47, 1),
(2163, 15, 48, 1),
(2246, 16, 7, 1),
(2247, 16, 8, 1),
(2248, 16, 9, 1),
(2249, 16, 10, 1),
(2250, 16, 11, 1),
(2251, 16, 12, 1),
(2252, 16, 13, 1),
(2253, 16, 14, 1),
(2254, 16, 15, 1),
(2255, 16, 17, 1),
(2256, 16, 18, 1),
(2257, 16, 19, 1),
(2258, 16, 20, 1),
(2259, 16, 21, 1),
(2260, 16, 22, 1),
(2261, 16, 23, 1),
(2262, 16, 24, 1),
(2263, 16, 25, 1),
(2264, 16, 26, 1),
(2265, 16, 27, 1),
(2266, 16, 28, 1),
(2267, 16, 29, 1),
(2268, 16, 30, 1),
(2269, 16, 31, 1),
(2270, 16, 32, 1),
(2271, 16, 33, 1),
(2272, 16, 34, 1),
(2273, 16, 35, 1),
(2274, 16, 36, 1),
(2275, 16, 37, 1),
(2276, 16, 38, 1),
(2277, 16, 39, 1),
(2278, 16, 40, 1),
(2279, 16, 41, 1),
(2280, 16, 42, 1),
(2282, 16, 44, 1),
(2283, 16, 45, 1),
(2284, 16, 46, 1),
(2285, 16, 47, 1),
(2286, 16, 48, 1),
(1776, 17, 7, 1),
(1777, 17, 8, 1),
(1778, 17, 9, 1),
(1779, 17, 10, 1),
(1780, 17, 11, 1),
(1781, 17, 12, 1),
(1782, 17, 13, 1),
(1783, 17, 14, 1),
(1784, 17, 15, 1),
(1785, 17, 16, 1),
(1786, 17, 18, 1),
(1787, 17, 19, 1),
(1788, 17, 20, 1),
(1789, 17, 21, 1),
(1790, 17, 22, 1),
(1791, 17, 23, 1),
(1792, 17, 24, 1),
(1793, 17, 25, 1),
(1794, 17, 26, 1),
(1795, 17, 27, 1),
(1796, 17, 28, 1),
(1797, 17, 29, 1),
(1798, 17, 30, 1),
(1799, 17, 31, 1),
(1800, 17, 32, 1),
(1801, 17, 33, 1),
(1802, 17, 34, 1),
(1803, 17, 35, 1),
(1804, 17, 36, 1),
(1805, 17, 37, 1),
(1806, 17, 38, 1),
(1807, 17, 39, 1),
(1808, 17, 40, 1),
(1809, 17, 41, 1),
(1810, 17, 42, 1),
(1812, 17, 44, 1),
(1813, 17, 45, 1),
(1814, 17, 46, 1),
(1815, 17, 47, 1),
(1816, 17, 48, 1),
(2164, 18, 7, 1),
(2165, 18, 8, 1),
(2166, 18, 9, 1),
(2167, 18, 10, 1),
(2168, 18, 11, 1),
(2169, 18, 12, 1),
(2170, 18, 13, 1),
(2171, 18, 14, 1),
(2172, 18, 15, 1),
(2173, 18, 16, 1),
(2174, 18, 17, 1),
(2175, 18, 19, 1),
(2176, 18, 20, 1),
(2177, 18, 21, 1),
(2178, 18, 22, 1),
(2179, 18, 23, 1),
(2180, 18, 24, 1),
(2181, 18, 25, 1),
(2182, 18, 26, 1),
(2183, 18, 27, 1),
(2184, 18, 28, 1),
(2185, 18, 29, 1),
(2186, 18, 30, 1),
(2187, 18, 31, 1),
(2188, 18, 32, 1),
(2189, 18, 33, 1),
(2190, 18, 34, 1),
(2191, 18, 35, 1),
(2192, 18, 36, 1),
(2193, 18, 37, 1),
(2194, 18, 38, 1),
(2195, 18, 39, 1),
(2196, 18, 40, 1),
(2197, 18, 41, 1),
(2198, 18, 42, 1),
(2200, 18, 44, 1),
(2201, 18, 45, 1),
(2202, 18, 46, 1),
(2203, 18, 47, 1),
(2204, 18, 48, 1),
(41, 19, 29, 1),
(42, 19, 30, 1),
(43, 19, 31, 1),
(44, 19, 32, 1),
(45, 19, 33, 1),
(46, 19, 34, 1),
(47, 19, 35, 1),
(48, 19, 36, 1),
(49, 19, 37, 1),
(50, 19, 38, 1),
(51, 19, 39, 1),
(52, 19, 40, 1),
(53, 19, 41, 1),
(54, 19, 42, 1),
(56, 19, 44, 1),
(57, 19, 45, 1),
(58, 19, 46, 1),
(59, 19, 47, 1),
(60, 19, 48, 1),
(2205, 23, 7, 1),
(2206, 23, 8, 1),
(2207, 23, 9, 1),
(2208, 23, 10, 1),
(2209, 23, 11, 1),
(2210, 23, 12, 1),
(2211, 23, 13, 1),
(2212, 23, 14, 1),
(2213, 23, 15, 1),
(2214, 23, 16, 1),
(2215, 23, 17, 1),
(2216, 23, 18, 1),
(2217, 23, 19, 1),
(2218, 23, 20, 1),
(2219, 23, 21, 1),
(2220, 23, 22, 1),
(2221, 23, 24, 1),
(2222, 23, 25, 1),
(2223, 23, 26, 1),
(2224, 23, 27, 1),
(2225, 23, 28, 1),
(2226, 23, 29, 1),
(2227, 23, 30, 1),
(2228, 23, 31, 1),
(2229, 23, 32, 1),
(2230, 23, 33, 1),
(2231, 23, 34, 1),
(2232, 23, 35, 1),
(2233, 23, 36, 1),
(2234, 23, 37, 1),
(2235, 23, 38, 1),
(2236, 23, 39, 1),
(2237, 23, 40, 1),
(2238, 23, 41, 1),
(2239, 23, 42, 1),
(2241, 23, 44, 1),
(2242, 23, 45, 1),
(2243, 23, 46, 1),
(2244, 23, 47, 1),
(2245, 23, 48, 1),
(1899, 24, 7, 1),
(1900, 24, 8, 1),
(1901, 24, 9, 1),
(1902, 24, 10, 1),
(1903, 24, 11, 1),
(1904, 24, 12, 1),
(1905, 24, 13, 1),
(1906, 24, 14, 1),
(1907, 24, 15, 1),
(1908, 24, 16, 1),
(1909, 24, 17, 1),
(1910, 24, 18, 1),
(1911, 24, 19, 1),
(1912, 24, 20, 1),
(1913, 24, 21, 1),
(1914, 24, 22, 1),
(1915, 24, 23, 1),
(1916, 24, 25, 1),
(1917, 24, 26, 1),
(1918, 24, 27, 1),
(1919, 24, 28, 1),
(1920, 24, 29, 1),
(1921, 24, 30, 1),
(1922, 24, 31, 1),
(1923, 24, 32, 1),
(1924, 24, 33, 1),
(1925, 24, 34, 1),
(1926, 24, 35, 1),
(1927, 24, 36, 1),
(1928, 24, 37, 1),
(1929, 24, 38, 1),
(1930, 24, 39, 1),
(1931, 24, 40, 1),
(1932, 24, 41, 1),
(1933, 24, 42, 1),
(1935, 24, 44, 1),
(1936, 24, 45, 1),
(1937, 24, 46, 1),
(1938, 24, 47, 1),
(1939, 24, 48, 1),
(1858, 25, 7, 1),
(1859, 25, 8, 1),
(1860, 25, 9, 1),
(1861, 25, 10, 1),
(1862, 25, 11, 1),
(1863, 25, 12, 1),
(1864, 25, 13, 1),
(1865, 25, 14, 1),
(1866, 25, 15, 1),
(1867, 25, 16, 1),
(1868, 25, 17, 1),
(1869, 25, 18, 1),
(1870, 25, 19, 1),
(1871, 25, 20, 1),
(1872, 25, 21, 1),
(1873, 25, 22, 1),
(1874, 25, 23, 1),
(1875, 25, 24, 1),
(1876, 25, 26, 1),
(1877, 25, 27, 1),
(1878, 25, 28, 1),
(1879, 25, 29, 1),
(1880, 25, 30, 1),
(1881, 25, 31, 1),
(1882, 25, 32, 1),
(1883, 25, 33, 1),
(1884, 25, 34, 1),
(1885, 25, 35, 1),
(1886, 25, 36, 1),
(1887, 25, 37, 1),
(1888, 25, 38, 1),
(1889, 25, 39, 1),
(1890, 25, 40, 1),
(1891, 25, 41, 1),
(1892, 25, 42, 1),
(1894, 25, 44, 1),
(1895, 25, 45, 1),
(1896, 25, 46, 1),
(1897, 25, 47, 1),
(1898, 25, 48, 1),
(1817, 26, 7, 1),
(1818, 26, 8, 1),
(1819, 26, 9, 1),
(1820, 26, 10, 1),
(1821, 26, 11, 1),
(1822, 26, 12, 1),
(1823, 26, 13, 1),
(1824, 26, 14, 1),
(1825, 26, 15, 1),
(1826, 26, 16, 1),
(1827, 26, 17, 1),
(1828, 26, 18, 1),
(1829, 26, 19, 1),
(1830, 26, 20, 1),
(1831, 26, 21, 1),
(1832, 26, 22, 1),
(1833, 26, 23, 1),
(1834, 26, 24, 1),
(1835, 26, 25, 1),
(1836, 26, 27, 1),
(1837, 26, 28, 1),
(1838, 26, 29, 1),
(1839, 26, 30, 1),
(1840, 26, 31, 1),
(1841, 26, 32, 1),
(1842, 26, 33, 1),
(1843, 26, 34, 1),
(1844, 26, 35, 1),
(1845, 26, 36, 1),
(1846, 26, 37, 1),
(1847, 26, 38, 1),
(1848, 26, 39, 1),
(1849, 26, 40, 1),
(1850, 26, 41, 1),
(1851, 26, 42, 1),
(1853, 26, 44, 1),
(1854, 26, 45, 1),
(1855, 26, 46, 1),
(1856, 26, 47, 1),
(1857, 26, 48, 1),
(290, 28, 8, 1),
(291, 28, 9, 1),
(292, 28, 10, 1),
(293, 28, 11, 1),
(294, 28, 12, 1),
(295, 28, 14, 1),
(296, 28, 15, 1),
(297, 28, 16, 1),
(298, 28, 17, 1),
(299, 28, 18, 1),
(300, 28, 22, 1),
(301, 28, 23, 1),
(302, 28, 24, 1),
(303, 28, 25, 1),
(304, 28, 26, 1),
(305, 28, 27, 1),
(306, 28, 29, 1),
(307, 28, 30, 1),
(308, 28, 31, 1),
(309, 28, 32, 1),
(310, 28, 33, 1),
(311, 28, 34, 1),
(312, 28, 35, 1),
(313, 28, 36, 1),
(314, 28, 37, 1),
(315, 28, 38, 1),
(316, 28, 39, 1),
(317, 28, 40, 1),
(318, 28, 41, 1),
(1017, 29, 7, 1),
(1018, 29, 8, 1),
(1019, 29, 9, 1),
(1020, 29, 10, 1),
(1021, 29, 11, 1),
(1022, 29, 12, 1),
(1023, 29, 13, 1),
(1024, 29, 14, 1),
(1025, 29, 15, 1),
(1026, 29, 16, 1),
(1027, 29, 17, 1),
(1028, 29, 18, 1),
(1029, 29, 19, 1),
(1030, 29, 20, 1),
(1031, 29, 21, 1),
(1032, 29, 22, 1),
(1033, 29, 23, 1),
(1034, 29, 24, 1),
(1035, 29, 25, 1),
(1036, 29, 26, 1),
(1037, 29, 27, 1),
(1038, 29, 28, 1),
(1039, 29, 30, 1),
(1040, 29, 31, 1),
(1041, 29, 32, 1),
(1042, 29, 33, 1),
(1043, 29, 34, 1),
(1044, 29, 35, 1),
(1045, 29, 36, 1),
(1046, 29, 37, 1),
(1047, 29, 38, 1),
(1048, 29, 39, 1),
(1049, 29, 40, 1),
(1050, 29, 41, 1),
(1051, 29, 42, 1),
(1053, 29, 44, 1),
(1054, 29, 45, 1),
(1055, 29, 46, 1),
(1056, 29, 47, 1),
(1057, 29, 48, 1),
(976, 30, 7, 1),
(977, 30, 8, 1),
(978, 30, 9, 1),
(979, 30, 10, 1),
(980, 30, 11, 1),
(981, 30, 12, 1),
(982, 30, 13, 1),
(983, 30, 14, 1),
(984, 30, 15, 1),
(985, 30, 16, 1),
(986, 30, 17, 1),
(987, 30, 18, 1),
(988, 30, 19, 1),
(989, 30, 20, 1),
(990, 30, 21, 1),
(991, 30, 22, 1),
(992, 30, 23, 1),
(993, 30, 24, 1),
(994, 30, 25, 1),
(995, 30, 26, 1),
(996, 30, 27, 1),
(997, 30, 28, 1),
(998, 30, 29, 1),
(999, 30, 31, 1),
(1000, 30, 32, 1),
(1001, 30, 33, 1),
(1002, 30, 34, 1),
(1003, 30, 35, 1),
(1004, 30, 36, 1),
(1005, 30, 37, 1),
(1006, 30, 38, 1),
(1007, 30, 39, 1),
(1008, 30, 40, 1),
(1009, 30, 41, 1),
(1010, 30, 42, 1),
(1012, 30, 44, 1),
(1013, 30, 45, 1),
(1014, 30, 46, 1),
(1015, 30, 47, 1),
(1016, 30, 48, 1),
(935, 31, 7, 1),
(936, 31, 8, 1),
(937, 31, 9, 1),
(938, 31, 10, 1),
(939, 31, 11, 1),
(940, 31, 12, 1),
(941, 31, 13, 1),
(942, 31, 14, 1),
(943, 31, 15, 1),
(944, 31, 16, 1),
(945, 31, 17, 1),
(946, 31, 18, 1),
(947, 31, 19, 1),
(948, 31, 20, 1),
(949, 31, 21, 1),
(950, 31, 22, 1),
(951, 31, 23, 1),
(952, 31, 24, 1),
(953, 31, 25, 1),
(954, 31, 26, 1),
(955, 31, 27, 1),
(956, 31, 28, 1),
(957, 31, 29, 1),
(958, 31, 30, 1),
(959, 31, 32, 1),
(960, 31, 33, 1),
(961, 31, 34, 1),
(962, 31, 35, 1),
(963, 31, 36, 1),
(964, 31, 37, 1),
(965, 31, 38, 1),
(966, 31, 39, 1),
(967, 31, 40, 1),
(968, 31, 41, 1),
(969, 31, 42, 1),
(971, 31, 44, 1),
(972, 31, 45, 1),
(973, 31, 46, 1),
(974, 31, 47, 1),
(975, 31, 48, 1),
(894, 33, 7, 1),
(895, 33, 8, 1),
(896, 33, 9, 1),
(897, 33, 10, 1),
(898, 33, 11, 1),
(899, 33, 12, 1),
(900, 33, 13, 1),
(901, 33, 14, 1),
(902, 33, 15, 1),
(903, 33, 16, 1),
(904, 33, 17, 1),
(905, 33, 18, 1),
(906, 33, 19, 1),
(907, 33, 20, 1),
(908, 33, 21, 1),
(909, 33, 22, 1),
(910, 33, 23, 1),
(911, 33, 24, 1),
(912, 33, 25, 1),
(913, 33, 26, 1),
(914, 33, 27, 1),
(915, 33, 28, 1),
(916, 33, 29, 1),
(917, 33, 30, 1),
(918, 33, 31, 1),
(919, 33, 32, 1),
(920, 33, 34, 1),
(921, 33, 35, 1),
(922, 33, 36, 1),
(923, 33, 37, 1),
(924, 33, 38, 1),
(925, 33, 39, 1),
(926, 33, 40, 1),
(927, 33, 41, 1),
(928, 33, 42, 1),
(930, 33, 44, 1),
(931, 33, 45, 1),
(932, 33, 46, 1),
(933, 33, 47, 1),
(934, 33, 48, 1),
(853, 34, 7, 1),
(854, 34, 8, 1),
(855, 34, 9, 1),
(856, 34, 10, 1),
(857, 34, 11, 1),
(858, 34, 12, 1),
(859, 34, 13, 1),
(860, 34, 14, 1),
(861, 34, 15, 1),
(862, 34, 16, 1),
(863, 34, 17, 1),
(864, 34, 18, 1),
(865, 34, 19, 1),
(866, 34, 20, 1),
(867, 34, 21, 1),
(868, 34, 22, 1),
(869, 34, 23, 1),
(870, 34, 24, 1),
(871, 34, 25, 1),
(872, 34, 26, 1),
(873, 34, 27, 1),
(874, 34, 28, 1),
(875, 34, 29, 1),
(876, 34, 30, 1),
(877, 34, 31, 1),
(878, 34, 32, 1),
(879, 34, 33, 1),
(880, 34, 35, 1),
(881, 34, 36, 1),
(882, 34, 37, 1),
(883, 34, 38, 1),
(884, 34, 39, 1),
(885, 34, 40, 1),
(886, 34, 41, 1),
(887, 34, 42, 1),
(889, 34, 44, 1),
(890, 34, 45, 1),
(891, 34, 46, 1),
(892, 34, 47, 1),
(893, 34, 48, 1),
(812, 35, 7, 1),
(813, 35, 8, 1),
(814, 35, 9, 1),
(815, 35, 10, 1),
(816, 35, 11, 1),
(817, 35, 12, 1),
(818, 35, 13, 1),
(819, 35, 14, 1),
(820, 35, 15, 1),
(821, 35, 16, 1),
(822, 35, 17, 1),
(823, 35, 18, 1),
(824, 35, 19, 1),
(825, 35, 20, 1),
(826, 35, 21, 1),
(827, 35, 22, 1),
(828, 35, 23, 1),
(829, 35, 24, 1),
(830, 35, 25, 1),
(831, 35, 26, 1),
(832, 35, 27, 1),
(833, 35, 28, 1),
(834, 35, 29, 1),
(835, 35, 30, 1),
(836, 35, 31, 1),
(837, 35, 32, 1),
(838, 35, 33, 1),
(839, 35, 34, 1),
(840, 35, 36, 1),
(841, 35, 37, 1),
(842, 35, 38, 1),
(843, 35, 39, 1),
(844, 35, 40, 1),
(845, 35, 41, 1),
(846, 35, 42, 1),
(848, 35, 44, 1),
(849, 35, 45, 1),
(850, 35, 46, 1),
(851, 35, 47, 1),
(852, 35, 48, 1),
(771, 36, 7, 1),
(772, 36, 8, 1),
(773, 36, 9, 1),
(774, 36, 10, 1),
(775, 36, 11, 1),
(776, 36, 12, 1),
(777, 36, 13, 1),
(778, 36, 14, 1),
(779, 36, 15, 1),
(780, 36, 16, 1),
(781, 36, 17, 1),
(782, 36, 18, 1),
(783, 36, 19, 1),
(784, 36, 20, 1),
(785, 36, 21, 1),
(786, 36, 22, 1),
(787, 36, 23, 1),
(788, 36, 24, 1),
(789, 36, 25, 1),
(790, 36, 26, 1),
(791, 36, 27, 1),
(792, 36, 28, 1),
(793, 36, 29, 1),
(794, 36, 30, 1),
(795, 36, 31, 1),
(796, 36, 32, 1),
(797, 36, 33, 1),
(798, 36, 34, 1),
(799, 36, 35, 1),
(800, 36, 37, 1),
(801, 36, 38, 1),
(802, 36, 39, 1),
(803, 36, 40, 1),
(804, 36, 41, 1),
(805, 36, 42, 1),
(807, 36, 44, 1),
(808, 36, 45, 1),
(809, 36, 46, 1),
(810, 36, 47, 1),
(811, 36, 48, 1),
(730, 37, 7, 1),
(731, 37, 8, 1),
(732, 37, 9, 1),
(733, 37, 10, 1),
(734, 37, 11, 1),
(735, 37, 12, 1),
(736, 37, 13, 1),
(737, 37, 14, 1),
(738, 37, 15, 1),
(739, 37, 16, 1),
(740, 37, 17, 1),
(741, 37, 18, 1),
(742, 37, 19, 1),
(743, 37, 20, 1),
(744, 37, 21, 1),
(745, 37, 22, 1),
(746, 37, 23, 1),
(747, 37, 24, 1),
(748, 37, 25, 1),
(749, 37, 26, 1),
(750, 37, 27, 1),
(751, 37, 28, 1),
(752, 37, 29, 1),
(753, 37, 30, 1),
(754, 37, 31, 1),
(755, 37, 32, 1),
(756, 37, 33, 1),
(757, 37, 34, 1),
(758, 37, 35, 1),
(759, 37, 36, 1),
(760, 37, 38, 1),
(761, 37, 39, 1),
(762, 37, 40, 1),
(763, 37, 41, 1),
(764, 37, 42, 1),
(766, 37, 44, 1),
(767, 37, 45, 1),
(768, 37, 46, 1),
(769, 37, 47, 1),
(770, 37, 48, 1),
(1140, 38, 7, 1),
(1141, 38, 8, 1),
(1142, 38, 9, 1),
(1143, 38, 10, 1),
(1144, 38, 11, 1),
(1145, 38, 12, 1),
(1146, 38, 13, 1),
(1147, 38, 14, 1),
(1148, 38, 15, 1),
(1149, 38, 16, 1),
(1150, 38, 17, 1),
(1151, 38, 18, 1),
(1152, 38, 19, 1),
(1153, 38, 20, 1),
(1154, 38, 21, 1),
(1155, 38, 22, 1),
(1156, 38, 23, 1),
(1157, 38, 24, 1),
(1158, 38, 25, 1),
(1159, 38, 26, 1),
(1160, 38, 27, 1),
(1161, 38, 28, 1),
(1162, 38, 29, 1),
(1163, 38, 30, 1),
(1164, 38, 31, 1),
(1165, 38, 32, 1),
(1166, 38, 33, 1),
(1167, 38, 34, 1),
(1168, 38, 35, 1),
(1169, 38, 36, 1),
(1170, 38, 37, 1),
(1171, 38, 39, 1),
(1172, 38, 40, 1),
(1173, 38, 41, 1),
(1174, 38, 42, 1),
(1176, 38, 44, 1),
(1177, 38, 45, 1),
(1178, 38, 46, 1),
(1179, 38, 47, 1),
(1180, 38, 48, 1),
(689, 39, 7, 1),
(690, 39, 8, 1),
(691, 39, 9, 1),
(692, 39, 10, 1),
(693, 39, 11, 1),
(694, 39, 12, 1),
(695, 39, 13, 1),
(696, 39, 14, 1),
(697, 39, 15, 1),
(698, 39, 16, 1),
(699, 39, 17, 1),
(700, 39, 18, 1),
(701, 39, 19, 1),
(702, 39, 20, 1),
(703, 39, 21, 1),
(704, 39, 22, 1),
(705, 39, 23, 1),
(706, 39, 24, 1),
(707, 39, 25, 1),
(708, 39, 26, 1),
(709, 39, 27, 1),
(710, 39, 28, 1),
(711, 39, 29, 1),
(712, 39, 30, 1),
(713, 39, 31, 1),
(714, 39, 32, 1),
(715, 39, 33, 1),
(716, 39, 34, 1),
(717, 39, 35, 1),
(718, 39, 36, 1),
(719, 39, 37, 1),
(720, 39, 38, 1),
(721, 39, 40, 1),
(722, 39, 41, 1),
(723, 39, 42, 1),
(725, 39, 44, 1),
(726, 39, 45, 1),
(727, 39, 46, 1),
(728, 39, 47, 1),
(729, 39, 48, 1),
(1058, 40, 7, 1),
(1059, 40, 8, 1),
(1060, 40, 9, 1),
(1061, 40, 10, 1),
(1062, 40, 11, 1),
(1063, 40, 12, 1),
(1064, 40, 13, 1),
(1065, 40, 14, 1),
(1066, 40, 15, 1),
(1067, 40, 16, 1),
(1068, 40, 17, 1),
(1069, 40, 18, 1),
(1070, 40, 19, 1),
(1071, 40, 20, 1),
(1072, 40, 21, 1),
(1073, 40, 22, 1),
(1074, 40, 23, 1),
(1075, 40, 24, 1),
(1076, 40, 25, 1),
(1077, 40, 26, 1),
(1078, 40, 27, 1),
(1079, 40, 28, 1),
(1080, 40, 29, 1),
(1081, 40, 30, 1),
(1082, 40, 31, 1),
(1083, 40, 32, 1),
(1084, 40, 33, 1),
(1085, 40, 34, 1),
(1086, 40, 35, 1),
(1087, 40, 36, 1),
(1088, 40, 37, 1),
(1089, 40, 38, 1),
(1090, 40, 39, 1),
(1091, 40, 41, 1),
(1092, 40, 42, 1),
(1094, 40, 44, 1),
(1095, 40, 45, 1),
(1096, 40, 46, 1),
(1097, 40, 47, 1),
(1098, 40, 48, 1),
(1099, 41, 7, 1),
(1100, 41, 8, 1),
(1101, 41, 9, 1),
(1102, 41, 10, 1),
(1103, 41, 11, 1),
(1104, 41, 12, 1),
(1105, 41, 13, 1),
(1106, 41, 14, 1),
(1107, 41, 15, 1),
(1108, 41, 16, 1),
(1109, 41, 17, 1),
(1110, 41, 18, 1),
(1111, 41, 19, 1),
(1112, 41, 20, 1),
(1113, 41, 21, 1),
(1114, 41, 22, 1),
(1115, 41, 23, 1),
(1116, 41, 24, 1),
(1117, 41, 25, 1),
(1118, 41, 26, 1),
(1119, 41, 27, 1),
(1120, 41, 28, 1),
(1121, 41, 29, 1),
(1122, 41, 30, 1),
(1123, 41, 31, 1),
(1124, 41, 32, 1),
(1125, 41, 33, 1),
(1126, 41, 34, 1),
(1127, 41, 35, 1),
(1128, 41, 36, 1),
(1129, 41, 37, 1),
(1130, 41, 38, 1),
(1131, 41, 39, 1),
(1132, 41, 40, 1),
(1133, 41, 42, 1),
(1135, 41, 44, 1),
(1136, 41, 45, 1),
(1137, 41, 46, 1),
(1138, 41, 47, 1),
(1139, 41, 48, 1),
(61, 44, 28, 1),
(62, 44, 29, 1),
(63, 44, 30, 1),
(64, 44, 31, 1),
(65, 44, 32, 1),
(66, 44, 33, 1),
(67, 44, 34, 1),
(68, 44, 35, 1),
(69, 44, 36, 1),
(70, 44, 37, 1),
(71, 44, 38, 1),
(72, 44, 39, 1),
(73, 44, 40, 1),
(74, 44, 41, 1),
(75, 44, 42, 1),
(77, 44, 45, 1),
(78, 44, 46, 1),
(79, 44, 47, 1),
(80, 44, 48, 1),
(6, 48, 37, 1),
(7, 48, 38, 1),
(8, 48, 39, 1),
(9, 48, 40, 1),
(10, 48, 41, 1),
(2287, 49, 28, 1),
(2288, 49, 29, 1),
(2289, 49, 30, 1),
(2290, 49, 31, 1),
(2291, 49, 32, 1),
(2292, 49, 33, 1),
(2293, 49, 34, 1),
(2294, 49, 35, 1),
(2295, 49, 36, 1),
(2296, 49, 37, 1),
(2297, 49, 38, 1),
(2298, 49, 39, 1),
(2299, 49, 40, 1),
(2300, 49, 41, 1),
(2301, 49, 42, 1),
(2302, 49, 44, 1),
(2303, 49, 45, 1),
(2304, 49, 46, 1),
(2305, 49, 47, 1),
(2306, 49, 48, 1),
(1, 42, 8, 3),
(2, 42, 9, 3),
(3, 42, 10, 3),
(4, 42, 11, 3),
(5, 42, 12, 3),
(241, 7, 29, 4),
(242, 7, 30, 4),
(243, 7, 31, 4),
(244, 7, 32, 4),
(245, 7, 33, 4),
(246, 7, 34, 4),
(247, 7, 35, 4),
(248, 7, 36, 4),
(249, 7, 37, 4),
(250, 7, 38, 4),
(251, 7, 39, 4),
(252, 7, 40, 4),
(253, 7, 41, 4),
(254, 7, 42, 4),
(256, 7, 44, 4),
(257, 7, 45, 4),
(258, 7, 46, 4),
(259, 7, 47, 4),
(260, 7, 48, 4),
(1632, 8, 7, 4),
(1633, 8, 9, 4),
(1634, 8, 10, 4),
(1635, 8, 11, 4),
(1636, 8, 12, 4),
(1637, 8, 13, 4),
(1638, 8, 14, 4),
(1639, 8, 15, 4),
(1640, 8, 16, 4),
(1641, 8, 17, 4),
(1642, 8, 18, 4),
(1643, 8, 19, 4),
(1644, 8, 20, 4),
(1645, 8, 21, 4),
(1646, 8, 22, 4),
(1647, 8, 23, 4),
(1648, 8, 24, 4),
(1649, 8, 25, 4),
(1650, 8, 26, 4),
(1651, 8, 27, 4),
(1652, 8, 28, 4),
(161, 8, 29, 4),
(162, 8, 30, 4),
(163, 8, 31, 4),
(164, 8, 32, 4),
(165, 8, 33, 4),
(166, 8, 34, 4),
(167, 8, 35, 4),
(168, 8, 36, 4),
(169, 8, 37, 4),
(170, 8, 38, 4),
(171, 8, 39, 4),
(172, 8, 40, 4),
(173, 8, 41, 4),
(174, 8, 42, 4),
(176, 8, 44, 4),
(177, 8, 45, 4),
(178, 8, 46, 4),
(179, 8, 47, 4),
(180, 8, 48, 4),
(1653, 9, 7, 4),
(1654, 9, 8, 4),
(1655, 9, 10, 4),
(1656, 9, 11, 4),
(1657, 9, 12, 4),
(1658, 9, 13, 4),
(1659, 9, 14, 4),
(1660, 9, 15, 4),
(1661, 9, 16, 4),
(1662, 9, 17, 4),
(1663, 9, 18, 4),
(1664, 9, 19, 4),
(1665, 9, 20, 4),
(1666, 9, 21, 4),
(1667, 9, 22, 4),
(1668, 9, 23, 4),
(1669, 9, 24, 4),
(1670, 9, 25, 4),
(1671, 9, 26, 4),
(1672, 9, 27, 4),
(1673, 9, 28, 4),
(1674, 9, 29, 4),
(1675, 9, 30, 4),
(1676, 9, 31, 4),
(1677, 9, 32, 4),
(1678, 9, 33, 4),
(1679, 9, 34, 4),
(1680, 9, 35, 4),
(1681, 9, 36, 4),
(1682, 9, 37, 4),
(1683, 9, 38, 4),
(1684, 9, 39, 4),
(1685, 9, 40, 4),
(1686, 9, 41, 4),
(1687, 9, 42, 4),
(1689, 9, 44, 4),
(1690, 9, 45, 4),
(1691, 9, 46, 4),
(1692, 9, 47, 4),
(1693, 9, 48, 4),
(1694, 10, 7, 4),
(1695, 10, 8, 4),
(1696, 10, 9, 4),
(1697, 10, 11, 4),
(1698, 10, 12, 4),
(1699, 10, 13, 4),
(1700, 10, 14, 4),
(1701, 10, 15, 4),
(1702, 10, 16, 4),
(1703, 10, 17, 4),
(1704, 10, 18, 4),
(1705, 10, 19, 4),
(1706, 10, 20, 4),
(1707, 10, 21, 4),
(1708, 10, 22, 4),
(1709, 10, 23, 4),
(1710, 10, 24, 4),
(1711, 10, 25, 4),
(1712, 10, 26, 4),
(1713, 10, 27, 4),
(1714, 10, 28, 4),
(1715, 10, 29, 4),
(1716, 10, 30, 4),
(1717, 10, 31, 4),
(1718, 10, 32, 4),
(1719, 10, 33, 4),
(1720, 10, 34, 4),
(1721, 10, 35, 4),
(1722, 10, 36, 4),
(1723, 10, 37, 4),
(1724, 10, 38, 4),
(1725, 10, 39, 4),
(1726, 10, 40, 4),
(1727, 10, 41, 4),
(1728, 10, 42, 4),
(1730, 10, 44, 4),
(1731, 10, 45, 4),
(1732, 10, 46, 4),
(1733, 10, 47, 4),
(1734, 10, 48, 4),
(1735, 11, 7, 4),
(1736, 11, 8, 4),
(1737, 11, 9, 4),
(1738, 11, 10, 4),
(1739, 11, 12, 4),
(1740, 11, 13, 4),
(1741, 11, 14, 4),
(1742, 11, 15, 4),
(1743, 11, 16, 4),
(1744, 11, 17, 4),
(1745, 11, 18, 4),
(1746, 11, 19, 4),
(1747, 11, 20, 4),
(1748, 11, 21, 4),
(1749, 11, 22, 4),
(1750, 11, 23, 4),
(1751, 11, 24, 4),
(1752, 11, 25, 4),
(1753, 11, 26, 4),
(1754, 11, 27, 4),
(1755, 11, 28, 4),
(1756, 11, 29, 4),
(1757, 11, 30, 4),
(1758, 11, 31, 4),
(1759, 11, 32, 4),
(1760, 11, 33, 4),
(1761, 11, 34, 4),
(1762, 11, 35, 4),
(1763, 11, 36, 4),
(1764, 11, 37, 4),
(1765, 11, 38, 4),
(1766, 11, 39, 4),
(1767, 11, 40, 4),
(1768, 11, 41, 4),
(1769, 11, 42, 4),
(1771, 11, 44, 4),
(1772, 11, 45, 4),
(1773, 11, 46, 4),
(1774, 11, 47, 4),
(1775, 11, 48, 4),
(1591, 12, 7, 4),
(1592, 12, 8, 4),
(1593, 12, 9, 4),
(1594, 12, 10, 4),
(1595, 12, 11, 4),
(1596, 12, 13, 4),
(1597, 12, 14, 4),
(1598, 12, 15, 4),
(1599, 12, 16, 4),
(1600, 12, 17, 4),
(1601, 12, 18, 4),
(1602, 12, 19, 4),
(1603, 12, 20, 4),
(1604, 12, 21, 4),
(1605, 12, 22, 4),
(1606, 12, 23, 4),
(1607, 12, 24, 4),
(1608, 12, 25, 4),
(1609, 12, 26, 4),
(1610, 12, 27, 4),
(1611, 12, 28, 4),
(1612, 12, 29, 4),
(1613, 12, 30, 4),
(1614, 12, 31, 4),
(1615, 12, 32, 4),
(1616, 12, 33, 4),
(1617, 12, 34, 4),
(1618, 12, 35, 4),
(1619, 12, 36, 4),
(1620, 12, 37, 4),
(1621, 12, 38, 4),
(1622, 12, 39, 4),
(1623, 12, 40, 4),
(1624, 12, 41, 4),
(1625, 12, 42, 4),
(1627, 12, 44, 4),
(1628, 12, 45, 4),
(1629, 12, 46, 4),
(1630, 12, 47, 4),
(1631, 12, 48, 4),
(1550, 14, 7, 4),
(1551, 14, 8, 4),
(1552, 14, 9, 4),
(1553, 14, 10, 4),
(1554, 14, 11, 4),
(1555, 14, 12, 4),
(1556, 14, 13, 4),
(1557, 14, 15, 4),
(1558, 14, 16, 4),
(1559, 14, 17, 4),
(1560, 14, 18, 4),
(1561, 14, 19, 4),
(1562, 14, 20, 4),
(1563, 14, 21, 4),
(1564, 14, 22, 4),
(1565, 14, 23, 4),
(1566, 14, 24, 4),
(1567, 14, 25, 4),
(1568, 14, 26, 4),
(1569, 14, 27, 4),
(1570, 14, 28, 4),
(1571, 14, 29, 4),
(1572, 14, 30, 4),
(1573, 14, 31, 4),
(1574, 14, 32, 4),
(1575, 14, 33, 4),
(1576, 14, 34, 4),
(1577, 14, 35, 4),
(1578, 14, 36, 4),
(1579, 14, 37, 4),
(1580, 14, 38, 4),
(1581, 14, 39, 4),
(1582, 14, 40, 4),
(1583, 14, 41, 4),
(1584, 14, 42, 4),
(1586, 14, 44, 4),
(1587, 14, 45, 4),
(1588, 14, 46, 4),
(1589, 14, 47, 4),
(1590, 14, 48, 4),
(1509, 15, 7, 4),
(1510, 15, 8, 4),
(1511, 15, 9, 4),
(1512, 15, 10, 4),
(1513, 15, 11, 4),
(1514, 15, 12, 4),
(1515, 15, 13, 4),
(1516, 15, 14, 4),
(1517, 15, 16, 4),
(1518, 15, 17, 4),
(1519, 15, 18, 4),
(1520, 15, 19, 4),
(1521, 15, 20, 4),
(1522, 15, 21, 4),
(1523, 15, 22, 4),
(1524, 15, 23, 4),
(1525, 15, 24, 4),
(1526, 15, 25, 4),
(1527, 15, 26, 4),
(1528, 15, 27, 4),
(1529, 15, 28, 4),
(1530, 15, 29, 4),
(1531, 15, 30, 4),
(1532, 15, 31, 4),
(1533, 15, 32, 4),
(1534, 15, 33, 4),
(1535, 15, 34, 4),
(1536, 15, 35, 4),
(1537, 15, 36, 4),
(1538, 15, 37, 4),
(1539, 15, 38, 4),
(1540, 15, 39, 4),
(1541, 15, 40, 4),
(1542, 15, 41, 4),
(1543, 15, 42, 4),
(1545, 15, 44, 4),
(1546, 15, 45, 4),
(1547, 15, 46, 4),
(1548, 15, 47, 4),
(1549, 15, 48, 4),
(1468, 16, 7, 4),
(1469, 16, 8, 4),
(1470, 16, 9, 4),
(1471, 16, 10, 4),
(1472, 16, 11, 4),
(1473, 16, 12, 4),
(1474, 16, 13, 4),
(1475, 16, 14, 4),
(1476, 16, 15, 4),
(1477, 16, 17, 4),
(1478, 16, 18, 4),
(1479, 16, 19, 4),
(1480, 16, 20, 4),
(1481, 16, 21, 4),
(1482, 16, 22, 4),
(1483, 16, 23, 4),
(1484, 16, 24, 4),
(1485, 16, 25, 4),
(1486, 16, 26, 4),
(1487, 16, 27, 4),
(1488, 16, 28, 4),
(1489, 16, 29, 4),
(1490, 16, 30, 4),
(1491, 16, 31, 4),
(1492, 16, 32, 4),
(1493, 16, 33, 4),
(1494, 16, 34, 4),
(1495, 16, 35, 4),
(1496, 16, 36, 4),
(1497, 16, 37, 4),
(1498, 16, 38, 4),
(1499, 16, 39, 4),
(1500, 16, 40, 4),
(1501, 16, 41, 4),
(1502, 16, 42, 4),
(1504, 16, 44, 4),
(1505, 16, 45, 4),
(1506, 16, 46, 4),
(1507, 16, 47, 4),
(1508, 16, 48, 4),
(1428, 17, 7, 4),
(1429, 17, 8, 4),
(1430, 17, 9, 4),
(1431, 17, 10, 4),
(1432, 17, 11, 4),
(1433, 17, 12, 4),
(1434, 17, 13, 4),
(1435, 17, 14, 4),
(1436, 17, 15, 4),
(1437, 17, 16, 4),
(1438, 17, 18, 4),
(1439, 17, 19, 4),
(1440, 17, 20, 4),
(1441, 17, 21, 4),
(1442, 17, 22, 4),
(1443, 17, 23, 4),
(1444, 17, 24, 4),
(1445, 17, 25, 4),
(1446, 17, 26, 4),
(1447, 17, 27, 4),
(1448, 17, 28, 4),
(1449, 17, 29, 4),
(1450, 17, 30, 4),
(1451, 17, 31, 4),
(1452, 17, 32, 4),
(1453, 17, 33, 4),
(1454, 17, 34, 4),
(1455, 17, 35, 4),
(1456, 17, 36, 4),
(1457, 17, 37, 4),
(1458, 17, 38, 4),
(1459, 17, 39, 4),
(1460, 17, 40, 4),
(1461, 17, 41, 4),
(1462, 17, 42, 4),
(1464, 17, 44, 4),
(1465, 17, 45, 4),
(1181, 17, 46, 4),
(1466, 17, 47, 4),
(1467, 17, 48, 4),
(1387, 18, 7, 4),
(1388, 18, 8, 4),
(1389, 18, 9, 4),
(1390, 18, 10, 4),
(1391, 18, 11, 4),
(1392, 18, 12, 4),
(1393, 18, 13, 4),
(1394, 18, 14, 4),
(1395, 18, 15, 4),
(1396, 18, 16, 4),
(1397, 18, 17, 4),
(1398, 18, 19, 4),
(1399, 18, 20, 4),
(1400, 18, 21, 4),
(1401, 18, 22, 4),
(1402, 18, 23, 4),
(1403, 18, 24, 4),
(1404, 18, 25, 4),
(1405, 18, 26, 4),
(1406, 18, 27, 4),
(1407, 18, 28, 4),
(1408, 18, 29, 4),
(1409, 18, 30, 4),
(1410, 18, 31, 4),
(1411, 18, 32, 4),
(1412, 18, 33, 4),
(1413, 18, 34, 4),
(1414, 18, 35, 4),
(1415, 18, 36, 4),
(1416, 18, 37, 4),
(1417, 18, 38, 4),
(1418, 18, 39, 4),
(1419, 18, 40, 4),
(1420, 18, 41, 4),
(1421, 18, 42, 4),
(1423, 18, 44, 4),
(1424, 18, 45, 4),
(1425, 18, 46, 4),
(1426, 18, 47, 4),
(1427, 18, 48, 4),
(21, 19, 29, 4),
(22, 19, 30, 4),
(23, 19, 31, 4),
(24, 19, 32, 4),
(25, 19, 33, 4),
(26, 19, 34, 4),
(27, 19, 35, 4),
(28, 19, 36, 4),
(29, 19, 37, 4),
(30, 19, 38, 4),
(31, 19, 39, 4),
(32, 19, 40, 4),
(33, 19, 41, 4),
(34, 19, 42, 4),
(36, 19, 44, 4),
(37, 19, 45, 4),
(38, 19, 46, 4),
(39, 19, 47, 4),
(40, 19, 48, 4),
(1346, 22, 7, 4),
(1347, 22, 8, 4),
(1348, 22, 9, 4),
(1349, 22, 10, 4),
(1350, 22, 11, 4),
(1351, 22, 12, 4),
(1352, 22, 13, 4),
(1353, 22, 14, 4),
(1354, 22, 15, 4),
(1355, 22, 16, 4),
(1356, 22, 17, 4),
(1357, 22, 18, 4),
(1358, 22, 19, 4),
(1359, 22, 20, 4),
(1360, 22, 21, 4),
(1361, 22, 23, 4),
(1362, 22, 24, 4),
(1363, 22, 25, 4),
(1364, 22, 26, 4),
(1365, 22, 27, 4),
(1366, 22, 28, 4),
(1367, 22, 29, 4),
(1368, 22, 30, 4),
(1369, 22, 31, 4),
(1370, 22, 32, 4),
(1371, 22, 33, 4),
(1372, 22, 34, 4),
(1373, 22, 35, 4),
(1374, 22, 36, 4),
(1375, 22, 37, 4),
(1376, 22, 38, 4),
(1377, 22, 39, 4),
(1378, 22, 40, 4),
(1379, 22, 41, 4),
(1380, 22, 42, 4),
(1382, 22, 44, 4),
(1383, 22, 45, 4),
(1384, 22, 46, 4),
(1385, 22, 47, 4),
(1386, 22, 48, 4),
(1305, 23, 7, 4),
(1306, 23, 8, 4),
(1307, 23, 9, 4),
(1308, 23, 10, 4),
(1309, 23, 11, 4),
(1310, 23, 12, 4),
(1311, 23, 13, 4),
(1312, 23, 14, 4),
(1313, 23, 15, 4),
(1314, 23, 16, 4),
(1315, 23, 17, 4),
(1316, 23, 18, 4),
(1317, 23, 19, 4),
(1318, 23, 20, 4),
(1319, 23, 21, 4),
(1320, 23, 22, 4),
(1321, 23, 24, 4),
(1322, 23, 25, 4),
(1323, 23, 26, 4),
(1324, 23, 27, 4),
(1325, 23, 28, 4),
(1326, 23, 29, 4),
(1327, 23, 30, 4),
(1328, 23, 31, 4),
(1329, 23, 32, 4),
(1330, 23, 33, 4),
(1331, 23, 34, 4),
(1332, 23, 35, 4),
(1333, 23, 36, 4),
(1334, 23, 37, 4),
(1335, 23, 38, 4),
(1336, 23, 39, 4),
(1337, 23, 40, 4),
(1338, 23, 41, 4),
(1339, 23, 42, 4),
(1341, 23, 44, 4),
(1342, 23, 45, 4),
(1343, 23, 46, 4),
(1344, 23, 47, 4),
(1345, 23, 48, 4),
(1223, 24, 7, 4),
(1224, 24, 8, 4),
(1225, 24, 9, 4),
(1226, 24, 10, 4),
(1227, 24, 11, 4),
(1228, 24, 12, 4),
(1229, 24, 13, 4),
(1230, 24, 14, 4),
(1231, 24, 15, 4),
(1232, 24, 16, 4),
(1233, 24, 17, 4),
(1234, 24, 18, 4),
(1235, 24, 19, 4),
(1236, 24, 20, 4),
(1237, 24, 21, 4),
(1238, 24, 22, 4),
(1239, 24, 23, 4),
(1240, 24, 25, 4),
(1241, 24, 26, 4),
(1242, 24, 27, 4),
(1243, 24, 28, 4),
(1244, 24, 29, 4),
(1245, 24, 30, 4),
(1246, 24, 31, 4),
(1247, 24, 32, 4),
(1248, 24, 33, 4),
(1249, 24, 34, 4),
(1250, 24, 35, 4),
(1251, 24, 36, 4),
(1252, 24, 37, 4),
(1253, 24, 38, 4),
(1254, 24, 39, 4),
(1255, 24, 40, 4),
(1256, 24, 41, 4),
(1257, 24, 42, 4),
(1259, 24, 44, 4),
(1260, 24, 45, 4),
(1261, 24, 46, 4),
(1262, 24, 47, 4),
(1263, 24, 48, 4),
(1264, 25, 7, 4),
(1265, 25, 8, 4),
(1266, 25, 9, 4),
(1267, 25, 10, 4),
(1268, 25, 11, 4),
(1269, 25, 12, 4),
(1270, 25, 13, 4),
(1271, 25, 14, 4),
(1272, 25, 15, 4),
(1273, 25, 16, 4),
(1274, 25, 17, 4),
(1275, 25, 18, 4),
(1276, 25, 19, 4),
(1277, 25, 20, 4),
(1278, 25, 21, 4),
(1279, 25, 22, 4),
(1280, 25, 23, 4),
(1281, 25, 24, 4),
(1282, 25, 26, 4),
(1283, 25, 27, 4),
(1284, 25, 28, 4),
(1285, 25, 29, 4),
(1286, 25, 30, 4),
(1287, 25, 31, 4),
(1288, 25, 32, 4),
(1289, 25, 33, 4),
(1290, 25, 34, 4),
(1291, 25, 35, 4),
(1292, 25, 36, 4),
(1293, 25, 37, 4),
(1294, 25, 38, 4),
(1295, 25, 39, 4),
(1296, 25, 40, 4),
(1297, 25, 41, 4),
(1298, 25, 42, 4),
(1300, 25, 44, 4),
(1301, 25, 45, 4),
(1302, 25, 46, 4),
(1303, 25, 47, 4),
(1304, 25, 48, 4),
(1182, 26, 7, 4),
(1183, 26, 8, 4),
(1184, 26, 9, 4),
(1185, 26, 10, 4),
(1186, 26, 11, 4),
(1187, 26, 12, 4),
(1188, 26, 13, 4),
(1189, 26, 14, 4),
(1190, 26, 15, 4),
(1191, 26, 16, 4),
(1192, 26, 17, 4),
(1193, 26, 18, 4),
(1194, 26, 19, 4),
(1195, 26, 20, 4),
(1196, 26, 21, 4),
(1197, 26, 22, 4),
(1198, 26, 23, 4),
(1199, 26, 24, 4),
(1200, 26, 25, 4),
(1201, 26, 27, 4),
(1202, 26, 28, 4),
(1203, 26, 29, 4),
(1204, 26, 30, 4),
(1205, 26, 31, 4),
(1206, 26, 32, 4),
(1207, 26, 33, 4),
(1208, 26, 34, 4),
(1209, 26, 35, 4),
(1210, 26, 36, 4),
(1211, 26, 37, 4),
(1212, 26, 38, 4),
(1213, 26, 39, 4),
(1214, 26, 40, 4),
(1215, 26, 41, 4),
(1216, 26, 42, 4),
(1218, 26, 44, 4),
(1219, 26, 45, 4),
(1220, 26, 46, 4),
(1221, 26, 47, 4),
(1222, 26, 48, 4),
(261, 28, 8, 4),
(262, 28, 9, 4),
(263, 28, 10, 4),
(264, 28, 11, 4),
(265, 28, 12, 4),
(266, 28, 14, 4),
(267, 28, 15, 4),
(268, 28, 16, 4),
(269, 28, 17, 4),
(270, 28, 18, 4),
(271, 28, 22, 4),
(272, 28, 23, 4),
(273, 28, 24, 4),
(274, 28, 25, 4),
(275, 28, 26, 4),
(276, 28, 27, 4),
(277, 28, 29, 4),
(278, 28, 30, 4),
(279, 28, 31, 4),
(280, 28, 32, 4),
(281, 28, 33, 4),
(282, 28, 34, 4),
(283, 28, 35, 4),
(284, 28, 36, 4),
(285, 28, 37, 4),
(286, 28, 38, 4),
(287, 28, 39, 4),
(288, 28, 40, 4),
(289, 28, 41, 4),
(319, 29, 8, 4),
(320, 29, 9, 4),
(321, 29, 10, 4),
(322, 29, 11, 4),
(323, 29, 12, 4),
(324, 29, 13, 4),
(325, 29, 14, 4),
(326, 29, 15, 4),
(327, 29, 16, 4),
(328, 29, 17, 4),
(329, 29, 18, 4),
(330, 29, 22, 4),
(331, 29, 23, 4),
(332, 29, 24, 4),
(333, 29, 25, 4),
(334, 29, 26, 4),
(335, 29, 27, 4),
(336, 29, 28, 4),
(337, 29, 30, 4),
(338, 29, 31, 4),
(339, 29, 32, 4),
(340, 29, 33, 4),
(341, 29, 34, 4),
(342, 29, 35, 4),
(343, 29, 36, 4),
(344, 29, 37, 4),
(345, 29, 38, 4),
(346, 29, 39, 4),
(347, 29, 40, 4),
(348, 29, 41, 4),
(349, 30, 8, 4),
(350, 30, 9, 4),
(351, 30, 10, 4),
(352, 30, 11, 4),
(353, 30, 12, 4),
(354, 30, 14, 4),
(355, 30, 15, 4),
(356, 30, 16, 4),
(357, 30, 17, 4),
(358, 30, 18, 4),
(359, 30, 22, 4),
(360, 30, 23, 4),
(361, 30, 24, 4),
(362, 30, 25, 4),
(363, 30, 26, 4),
(364, 30, 27, 4),
(365, 30, 28, 4),
(366, 30, 29, 4),
(367, 30, 31, 4),
(368, 30, 32, 4),
(369, 30, 33, 4),
(370, 30, 34, 4),
(371, 30, 35, 4),
(372, 30, 36, 4),
(373, 30, 37, 4),
(374, 30, 38, 4),
(375, 30, 39, 4),
(376, 30, 40, 4),
(377, 30, 41, 4),
(378, 31, 8, 4),
(379, 31, 9, 4),
(380, 31, 10, 4),
(381, 31, 11, 4),
(382, 31, 12, 4),
(383, 31, 13, 4),
(384, 31, 14, 4),
(385, 31, 15, 4),
(386, 31, 16, 4),
(387, 31, 17, 4),
(388, 31, 18, 4),
(389, 31, 22, 4),
(390, 31, 23, 4),
(391, 31, 24, 4),
(392, 31, 25, 4),
(393, 31, 26, 4),
(394, 31, 27, 4),
(395, 31, 28, 4),
(396, 31, 29, 4),
(397, 31, 30, 4),
(398, 31, 32, 4),
(399, 31, 33, 4),
(400, 31, 34, 4),
(401, 31, 35, 4),
(402, 31, 36, 4),
(403, 31, 37, 4),
(404, 31, 38, 4),
(405, 31, 39, 4),
(406, 31, 40, 4),
(407, 31, 41, 4),
(408, 33, 8, 4),
(409, 33, 9, 4),
(410, 33, 10, 4),
(411, 33, 11, 4),
(412, 33, 12, 4),
(413, 33, 13, 4),
(414, 33, 14, 4),
(415, 33, 15, 4),
(416, 33, 16, 4),
(417, 33, 17, 4),
(418, 33, 18, 4),
(419, 33, 22, 4),
(420, 33, 23, 4),
(421, 33, 24, 4),
(422, 33, 25, 4),
(423, 33, 26, 4),
(424, 33, 27, 4),
(425, 33, 28, 4),
(426, 33, 29, 4),
(427, 33, 30, 4),
(428, 33, 31, 4),
(429, 33, 32, 4),
(430, 33, 34, 4),
(431, 33, 35, 4),
(432, 33, 36, 4),
(433, 33, 37, 4),
(434, 33, 38, 4),
(435, 33, 39, 4),
(436, 33, 40, 4),
(437, 33, 41, 4),
(438, 34, 8, 4),
(439, 34, 9, 4),
(440, 34, 10, 4),
(441, 34, 11, 4),
(442, 34, 12, 4),
(443, 34, 14, 4),
(444, 34, 15, 4),
(445, 34, 16, 4),
(446, 34, 17, 4),
(447, 34, 18, 4),
(448, 34, 22, 4),
(449, 34, 23, 4),
(450, 34, 24, 4),
(451, 34, 25, 4),
(452, 34, 26, 4),
(453, 34, 27, 4),
(454, 34, 28, 4),
(455, 34, 29, 4),
(456, 34, 30, 4),
(457, 34, 31, 4),
(458, 34, 32, 4),
(459, 34, 33, 4),
(460, 34, 35, 4),
(461, 34, 36, 4),
(462, 34, 37, 4),
(463, 34, 38, 4),
(464, 34, 39, 4),
(465, 34, 40, 4),
(466, 34, 41, 4),
(467, 35, 8, 4),
(468, 35, 9, 4),
(469, 35, 10, 4),
(470, 35, 11, 4),
(471, 35, 12, 4),
(472, 35, 14, 4),
(473, 35, 15, 4),
(474, 35, 16, 4),
(475, 35, 17, 4),
(476, 35, 18, 4),
(477, 35, 22, 4),
(478, 35, 23, 4),
(479, 35, 24, 4),
(480, 35, 25, 4),
(481, 35, 26, 4),
(482, 35, 27, 4),
(483, 35, 28, 4),
(484, 35, 29, 4),
(485, 35, 30, 4),
(486, 35, 31, 4),
(487, 35, 32, 4),
(488, 35, 33, 4),
(489, 35, 34, 4),
(490, 35, 36, 4),
(491, 35, 37, 4),
(492, 35, 38, 4),
(493, 35, 39, 4),
(494, 35, 40, 4),
(495, 35, 41, 4),
(496, 36, 8, 4),
(497, 36, 9, 4),
(498, 36, 10, 4),
(499, 36, 11, 4),
(500, 36, 12, 4),
(501, 36, 14, 4),
(502, 36, 15, 4),
(503, 36, 16, 4),
(504, 36, 17, 4),
(505, 36, 18, 4),
(506, 36, 22, 4),
(507, 36, 23, 4),
(508, 36, 24, 4),
(509, 36, 25, 4),
(510, 36, 26, 4),
(511, 36, 27, 4),
(512, 36, 28, 4),
(513, 36, 29, 4),
(514, 36, 30, 4),
(515, 36, 31, 4),
(516, 36, 32, 4),
(517, 36, 33, 4),
(518, 36, 34, 4),
(519, 36, 35, 4),
(520, 36, 37, 4),
(521, 36, 38, 4),
(522, 36, 39, 4),
(523, 36, 40, 4),
(524, 36, 41, 4),
(525, 37, 7, 4),
(526, 37, 8, 4),
(527, 37, 9, 4),
(528, 37, 10, 4),
(529, 37, 11, 4),
(530, 37, 12, 4),
(531, 37, 13, 4),
(532, 37, 14, 4),
(533, 37, 15, 4),
(534, 37, 16, 4),
(535, 37, 17, 4),
(536, 37, 18, 4),
(537, 37, 19, 4),
(538, 37, 20, 4),
(539, 37, 21, 4),
(540, 37, 22, 4),
(541, 37, 23, 4),
(542, 37, 24, 4),
(543, 37, 25, 4),
(544, 37, 26, 4),
(545, 37, 27, 4),
(546, 37, 28, 4),
(547, 37, 29, 4),
(548, 37, 30, 4),
(549, 37, 31, 4),
(550, 37, 32, 4),
(551, 37, 33, 4),
(552, 37, 34, 4),
(553, 37, 35, 4),
(554, 37, 36, 4),
(555, 37, 38, 4),
(556, 37, 39, 4),
(557, 37, 40, 4),
(558, 37, 41, 4),
(559, 37, 42, 4),
(561, 37, 44, 4),
(562, 37, 45, 4),
(563, 37, 46, 4),
(564, 37, 47, 4),
(565, 37, 48, 4),
(566, 38, 7, 4),
(567, 38, 8, 4),
(568, 38, 9, 4),
(569, 38, 10, 4),
(570, 38, 11, 4),
(571, 38, 12, 4),
(572, 38, 13, 4),
(573, 38, 14, 4),
(574, 38, 15, 4),
(575, 38, 16, 4),
(576, 38, 17, 4),
(577, 38, 18, 4),
(578, 38, 19, 4),
(579, 38, 20, 4),
(580, 38, 21, 4),
(581, 38, 22, 4),
(582, 38, 23, 4),
(583, 38, 24, 4),
(584, 38, 25, 4),
(585, 38, 26, 4),
(586, 38, 27, 4),
(587, 38, 28, 4),
(588, 38, 29, 4),
(589, 38, 30, 4),
(590, 38, 31, 4),
(591, 38, 32, 4),
(592, 38, 33, 4),
(593, 38, 34, 4),
(594, 38, 35, 4),
(595, 38, 36, 4),
(596, 38, 37, 4),
(597, 38, 39, 4),
(598, 38, 40, 4),
(599, 38, 41, 4),
(600, 38, 42, 4),
(602, 38, 44, 4),
(603, 38, 45, 4),
(604, 38, 46, 4),
(605, 38, 47, 4),
(606, 38, 48, 4),
(607, 39, 7, 4),
(608, 39, 8, 4),
(609, 39, 9, 4),
(610, 39, 10, 4),
(611, 39, 11, 4),
(612, 39, 12, 4),
(613, 39, 13, 4),
(614, 39, 14, 4),
(615, 39, 15, 4),
(616, 39, 16, 4),
(617, 39, 17, 4),
(618, 39, 18, 4),
(619, 39, 19, 4),
(620, 39, 20, 4),
(621, 39, 21, 4),
(622, 39, 22, 4),
(623, 39, 23, 4),
(624, 39, 24, 4),
(625, 39, 25, 4),
(626, 39, 26, 4),
(627, 39, 27, 4),
(628, 39, 28, 4),
(629, 39, 29, 4),
(630, 39, 30, 4),
(631, 39, 31, 4),
(632, 39, 32, 4),
(633, 39, 33, 4),
(634, 39, 34, 4),
(635, 39, 35, 4),
(636, 39, 36, 4),
(637, 39, 37, 4),
(638, 39, 38, 4),
(639, 39, 40, 4),
(640, 39, 41, 4),
(641, 39, 42, 4),
(643, 39, 44, 4),
(644, 39, 45, 4),
(645, 39, 46, 4),
(646, 39, 47, 4),
(647, 39, 48, 4),
(648, 40, 7, 4),
(649, 40, 8, 4),
(650, 40, 9, 4),
(651, 40, 10, 4),
(652, 40, 11, 4),
(653, 40, 12, 4),
(654, 40, 13, 4),
(655, 40, 14, 4),
(656, 40, 15, 4),
(657, 40, 16, 4),
(658, 40, 17, 4),
(659, 40, 18, 4),
(660, 40, 19, 4),
(661, 40, 20, 4),
(662, 40, 21, 4),
(663, 40, 22, 4),
(664, 40, 23, 4),
(665, 40, 24, 4),
(666, 40, 25, 4),
(667, 40, 26, 4),
(668, 40, 27, 4),
(669, 40, 28, 4),
(670, 40, 29, 4),
(671, 40, 30, 4),
(672, 40, 31, 4),
(673, 40, 32, 4),
(674, 40, 33, 4),
(675, 40, 34, 4),
(676, 40, 35, 4),
(677, 40, 36, 4),
(678, 40, 37, 4),
(679, 40, 38, 4),
(680, 40, 39, 4),
(681, 40, 41, 4),
(682, 40, 42, 4),
(684, 40, 44, 4),
(685, 40, 45, 4),
(686, 40, 46, 4),
(687, 40, 47, 4),
(688, 40, 48, 4),
(201, 41, 28, 4),
(202, 41, 29, 4),
(203, 41, 30, 4),
(204, 41, 31, 4),
(205, 41, 32, 4),
(206, 41, 33, 4),
(207, 41, 34, 4),
(208, 41, 35, 4),
(209, 41, 36, 4),
(210, 41, 37, 4),
(211, 41, 38, 4),
(212, 41, 39, 4),
(213, 41, 40, 4),
(214, 41, 42, 4),
(216, 41, 44, 4),
(217, 41, 45, 4),
(218, 41, 46, 4),
(219, 41, 47, 4),
(220, 41, 48, 4),
(81, 44, 28, 4),
(82, 44, 29, 4),
(83, 44, 30, 4),
(84, 44, 31, 4),
(85, 44, 32, 4),
(86, 44, 33, 4),
(87, 44, 34, 4),
(88, 44, 35, 4),
(89, 44, 36, 4),
(90, 44, 37, 4),
(91, 44, 38, 4),
(92, 44, 39, 4),
(93, 44, 40, 4),
(94, 44, 41, 4),
(95, 44, 42, 4),
(97, 44, 45, 4),
(98, 44, 46, 4),
(99, 44, 47, 4),
(100, 44, 48, 4),
(11, 48, 42, 4),
(13, 48, 44, 4),
(14, 48, 45, 4),
(15, 48, 46, 4),
(2307, 49, 28, 4),
(2308, 49, 29, 4),
(2309, 49, 30, 4),
(2310, 49, 31, 4),
(2311, 49, 32, 4),
(2312, 49, 33, 4),
(2313, 49, 34, 4),
(2314, 49, 35, 4),
(2315, 49, 36, 4),
(2316, 49, 37, 4),
(2317, 49, 38, 4),
(2318, 49, 39, 4),
(2319, 49, 40, 4),
(2320, 49, 41, 4),
(2321, 49, 42, 4),
(2322, 49, 44, 4),
(2323, 49, 45, 4),
(2324, 49, 46, 4),
(2325, 49, 47, 4),
(2326, 49, 48, 4),
(121, 7, 29, 5),
(122, 7, 30, 5),
(123, 7, 31, 5),
(124, 7, 32, 5),
(125, 7, 33, 5),
(126, 7, 34, 5),
(127, 7, 35, 5),
(128, 7, 36, 5),
(129, 7, 37, 5),
(130, 7, 38, 5),
(131, 7, 39, 5),
(132, 7, 40, 5),
(133, 7, 41, 5),
(134, 7, 42, 5),
(136, 7, 44, 5),
(137, 7, 45, 5),
(138, 7, 46, 5),
(139, 7, 47, 5),
(140, 7, 48, 5),
(181, 41, 28, 5),
(182, 41, 29, 5),
(183, 41, 30, 5),
(184, 41, 31, 5),
(185, 41, 32, 5),
(186, 41, 33, 5),
(187, 41, 34, 5),
(188, 41, 35, 5),
(189, 41, 36, 5),
(190, 41, 37, 5),
(191, 41, 38, 5),
(192, 41, 39, 5),
(193, 41, 40, 5),
(194, 41, 42, 5),
(196, 41, 44, 5),
(197, 41, 45, 5),
(198, 41, 46, 5),
(199, 41, 47, 5),
(200, 41, 48, 5),
(101, 44, 28, 5),
(102, 44, 29, 5),
(103, 44, 30, 5),
(104, 44, 31, 5),
(105, 44, 32, 5),
(106, 44, 33, 5),
(107, 44, 34, 5),
(108, 44, 35, 5),
(109, 44, 36, 5),
(110, 44, 37, 5),
(111, 44, 38, 5),
(112, 44, 39, 5),
(113, 44, 40, 5),
(114, 44, 41, 5),
(115, 44, 42, 5),
(117, 44, 45, 5),
(118, 44, 46, 5),
(119, 44, 47, 5),
(120, 44, 48, 5),
(16, 48, 32, 5),
(17, 48, 33, 5),
(18, 48, 34, 5),
(19, 48, 35, 5),
(20, 48, 36, 5);

CREATE TABLE IF NOT EXISTS `#__catalog_product_link_attribute` (
`product_link_attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Product Link Attribute ID',
  `link_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Link Type ID',
  `product_link_attribute_code` varchar(32) DEFAULT NULL COMMENT 'Product Link Attribute Code',
  `data_type` varchar(32) DEFAULT NULL COMMENT 'Data Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Link Attribute Table' AUTO_INCREMENT=6 ;

INSERT INTO `#__catalog_product_link_attribute` (`product_link_attribute_id`, `link_type_id`, `product_link_attribute_code`, `data_type`) VALUES
(1, 1, 'position', 'int'),
(2, 3, 'position', 'int'),
(3, 3, 'qty', 'decimal'),
(4, 4, 'position', 'int'),
(5, 5, 'position', 'int');

CREATE TABLE IF NOT EXISTS `#__catalog_product_link_attribute_decimal` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `product_link_attribute_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Product Link Attribute ID',
  `link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Link Decimal Attribute Table' AUTO_INCREMENT=6 ;

INSERT INTO `#__catalog_product_link_attribute_decimal` (`value_id`, `product_link_attribute_id`, `link_id`, `value`) VALUES
(1, 3, 1, '0.0000'),
(2, 3, 2, '0.0000'),
(3, 3, 3, '0.0000'),
(4, 3, 4, '0.0000'),
(5, 3, 5, '0.0000');

CREATE TABLE IF NOT EXISTS `#__catalog_product_link_attribute_int` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `product_link_attribute_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Product Link Attribute ID',
  `link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Link Integer Attribute Table' AUTO_INCREMENT=3366 ;

INSERT INTO `#__catalog_product_link_attribute_int` (`value_id`, `product_link_attribute_id`, `link_id`, `value`) VALUES
(1, 2, 1, 0),
(2, 2, 2, 0),
(3, 2, 3, 0),
(4, 2, 4, 0),
(5, 2, 5, 0),
(11, 1, 6, 0),
(12, 1, 7, 0),
(13, 1, 8, 0),
(14, 1, 9, 0),
(15, 1, 10, 0),
(16, 4, 11, 0),
(18, 4, 13, 0),
(19, 4, 14, 0),
(20, 4, 15, 0),
(21, 5, 16, 0),
(22, 5, 17, 0),
(23, 5, 18, 0),
(24, 5, 19, 0),
(25, 5, 20, 0),
(26, 4, 21, 0),
(27, 4, 22, 0),
(28, 4, 23, 0),
(29, 4, 24, 0),
(30, 4, 25, 0),
(31, 4, 26, 0),
(32, 4, 27, 0),
(33, 4, 28, 0),
(34, 4, 29, 0),
(35, 4, 30, 0),
(36, 4, 31, 0),
(37, 4, 32, 0),
(38, 4, 33, 0),
(39, 4, 34, 0),
(41, 4, 36, 0),
(42, 4, 37, 0),
(43, 4, 38, 0),
(44, 4, 39, 0),
(45, 4, 40, 0),
(46, 1, 41, 0),
(47, 1, 42, 0),
(48, 1, 43, 0),
(49, 1, 44, 0),
(50, 1, 45, 0),
(51, 1, 46, 0),
(52, 1, 47, 0),
(53, 1, 48, 0),
(54, 1, 49, 0),
(55, 1, 50, 0),
(56, 1, 51, 0),
(57, 1, 52, 0),
(58, 1, 53, 0),
(59, 1, 54, 0),
(61, 1, 56, 0),
(62, 1, 57, 0),
(63, 1, 58, 0),
(64, 1, 59, 0),
(65, 1, 60, 0),
(66, 1, 61, 0),
(67, 1, 62, 0),
(68, 1, 63, 0),
(69, 1, 64, 0),
(70, 1, 65, 0),
(71, 1, 66, 0),
(72, 1, 67, 0),
(73, 1, 68, 0),
(74, 1, 69, 0),
(75, 1, 70, 0),
(76, 1, 71, 0),
(77, 1, 72, 0),
(78, 1, 73, 0),
(79, 1, 74, 0),
(80, 1, 75, 0),
(82, 1, 77, 0),
(83, 1, 78, 0),
(84, 1, 79, 0),
(85, 1, 80, 0),
(86, 4, 81, 0),
(87, 4, 82, 0),
(88, 4, 83, 0),
(89, 4, 84, 0),
(90, 4, 85, 0),
(91, 4, 86, 0),
(92, 4, 87, 0),
(93, 4, 88, 0),
(94, 4, 89, 0),
(95, 4, 90, 0),
(96, 4, 91, 0),
(97, 4, 92, 0),
(98, 4, 93, 0),
(99, 4, 94, 0),
(100, 4, 95, 0),
(102, 4, 97, 0),
(103, 4, 98, 0),
(104, 4, 99, 0),
(105, 4, 100, 0),
(106, 5, 101, 0),
(107, 5, 102, 0),
(108, 5, 103, 0),
(109, 5, 104, 0),
(110, 5, 105, 0),
(111, 5, 106, 0),
(112, 5, 107, 0),
(113, 5, 108, 0),
(114, 5, 109, 0),
(115, 5, 110, 0),
(116, 5, 111, 0),
(117, 5, 112, 0),
(118, 5, 113, 0),
(119, 5, 114, 0),
(120, 5, 115, 0),
(122, 5, 117, 0),
(123, 5, 118, 0),
(124, 5, 119, 0),
(125, 5, 120, 0),
(126, 5, 121, 0),
(127, 5, 122, 0),
(128, 5, 123, 0),
(129, 5, 124, 0),
(130, 5, 125, 0),
(131, 5, 126, 0),
(132, 5, 127, 0),
(133, 5, 128, 0),
(134, 5, 129, 0),
(135, 5, 130, 0),
(136, 5, 131, 0),
(137, 5, 132, 0),
(138, 5, 133, 0),
(139, 5, 134, 0),
(141, 5, 136, 0),
(142, 5, 137, 0),
(143, 5, 138, 0),
(144, 5, 139, 0),
(145, 5, 140, 0),
(166, 4, 161, 0),
(167, 4, 162, 0),
(168, 4, 163, 0),
(169, 4, 164, 0),
(170, 4, 165, 0),
(171, 4, 166, 0),
(172, 4, 167, 0),
(173, 4, 168, 0),
(174, 4, 169, 0),
(175, 4, 170, 0),
(176, 4, 171, 0),
(177, 4, 172, 0),
(178, 4, 173, 0),
(179, 4, 174, 0),
(181, 4, 176, 0),
(182, 4, 177, 0),
(183, 4, 178, 0),
(184, 4, 179, 0),
(185, 4, 180, 0),
(186, 5, 181, 0),
(187, 5, 182, 0),
(188, 5, 183, 0),
(189, 5, 184, 0),
(190, 5, 185, 0),
(191, 5, 186, 0),
(192, 5, 187, 0),
(193, 5, 188, 0),
(194, 5, 189, 0),
(195, 5, 190, 0),
(196, 5, 191, 0),
(197, 5, 192, 0),
(198, 5, 193, 0),
(199, 5, 194, 0),
(201, 5, 196, 0),
(202, 5, 197, 0),
(203, 5, 198, 0),
(204, 5, 199, 0),
(205, 5, 200, 0),
(206, 4, 201, 0),
(207, 4, 202, 0),
(208, 4, 203, 0),
(209, 4, 204, 0),
(210, 4, 205, 0),
(211, 4, 206, 0),
(212, 4, 207, 0),
(213, 4, 208, 0),
(214, 4, 209, 0),
(215, 4, 210, 0),
(216, 4, 211, 0),
(217, 4, 212, 0),
(218, 4, 213, 0),
(219, 4, 214, 0),
(221, 4, 216, 0),
(222, 4, 217, 0),
(223, 4, 218, 0),
(224, 4, 219, 0),
(225, 4, 220, 0),
(226, 1, 221, 0),
(227, 1, 222, 0),
(228, 1, 223, 0),
(229, 1, 224, 0),
(230, 1, 225, 0),
(231, 1, 226, 0),
(232, 1, 227, 0),
(233, 1, 228, 0),
(234, 1, 229, 0),
(235, 1, 230, 0),
(236, 1, 231, 0),
(237, 1, 232, 0),
(238, 1, 233, 0),
(239, 1, 234, 0),
(241, 1, 236, 0),
(242, 1, 237, 0),
(243, 1, 238, 0),
(244, 1, 239, 0),
(245, 1, 240, 0),
(246, 4, 241, 0),
(247, 4, 242, 0),
(248, 4, 243, 0),
(249, 4, 244, 0),
(250, 4, 245, 0),
(251, 4, 246, 0),
(252, 4, 247, 0),
(253, 4, 248, 0),
(254, 4, 249, 0),
(255, 4, 250, 0),
(256, 4, 251, 0),
(257, 4, 252, 0),
(258, 4, 253, 0),
(259, 4, 254, 0),
(261, 4, 256, 0),
(262, 4, 257, 0),
(263, 4, 258, 0),
(264, 4, 259, 0),
(265, 4, 260, 0),
(266, 4, 261, 0),
(267, 4, 262, 0),
(268, 4, 263, 0),
(269, 4, 264, 0),
(270, 4, 265, 0),
(271, 4, 266, 0),
(272, 4, 267, 0),
(273, 4, 268, 0),
(274, 4, 269, 0),
(275, 4, 270, 0),
(276, 4, 271, 0),
(277, 4, 272, 0),
(278, 4, 273, 0),
(279, 4, 274, 0),
(280, 4, 275, 0),
(281, 4, 276, 0),
(282, 4, 277, 0),
(283, 4, 278, 0),
(284, 4, 279, 0),
(285, 4, 280, 0),
(286, 4, 281, 0),
(287, 4, 282, 0),
(288, 4, 283, 0),
(289, 4, 284, 0),
(290, 4, 285, 0),
(291, 4, 286, 0),
(292, 4, 287, 0),
(293, 4, 288, 0),
(294, 4, 289, 0),
(295, 1, 290, 0),
(296, 1, 291, 0),
(297, 1, 292, 0),
(298, 1, 293, 0),
(299, 1, 294, 0),
(300, 1, 295, 0),
(301, 1, 296, 0),
(302, 1, 297, 0),
(303, 1, 298, 0),
(304, 1, 299, 0),
(305, 1, 300, 0),
(306, 1, 301, 0),
(307, 1, 302, 0),
(308, 1, 303, 0),
(309, 1, 304, 0),
(310, 1, 305, 0),
(311, 1, 306, 0),
(312, 1, 307, 0),
(313, 1, 308, 0),
(314, 1, 309, 0),
(315, 1, 310, 0),
(316, 1, 311, 0),
(317, 1, 312, 0),
(318, 1, 313, 0),
(319, 1, 314, 0),
(320, 1, 315, 0),
(321, 1, 316, 0),
(322, 1, 317, 0),
(323, 1, 318, 0),
(353, 4, 319, 0),
(354, 4, 320, 0),
(355, 4, 321, 0),
(356, 4, 322, 0),
(357, 4, 323, 0),
(358, 4, 324, 0),
(359, 4, 325, 0),
(360, 4, 326, 0),
(361, 4, 327, 0),
(362, 4, 328, 0),
(363, 4, 329, 0),
(364, 4, 330, 0),
(365, 4, 331, 0),
(366, 4, 332, 0),
(367, 4, 333, 0),
(368, 4, 334, 0),
(369, 4, 335, 0),
(370, 4, 336, 0),
(371, 4, 337, 0),
(372, 4, 338, 0),
(373, 4, 339, 0),
(374, 4, 340, 0),
(375, 4, 341, 0),
(376, 4, 342, 0),
(377, 4, 343, 0),
(378, 4, 344, 0),
(379, 4, 345, 0),
(380, 4, 346, 0),
(381, 4, 347, 0),
(382, 4, 348, 0),
(383, 4, 349, 0),
(384, 4, 350, 0),
(385, 4, 351, 0),
(386, 4, 352, 0),
(387, 4, 353, 0),
(388, 4, 354, 0),
(389, 4, 355, 0),
(390, 4, 356, 0),
(391, 4, 357, 0),
(392, 4, 358, 0),
(393, 4, 359, 0),
(394, 4, 360, 0),
(395, 4, 361, 0),
(396, 4, 362, 0),
(397, 4, 363, 0),
(398, 4, 364, 0),
(399, 4, 365, 0),
(400, 4, 366, 0),
(401, 4, 367, 0),
(402, 4, 368, 0),
(403, 4, 369, 0),
(404, 4, 370, 0),
(405, 4, 371, 0),
(406, 4, 372, 0),
(407, 4, 373, 0),
(408, 4, 374, 0),
(409, 4, 375, 0),
(410, 4, 376, 0),
(411, 4, 377, 0),
(412, 4, 378, 0),
(413, 4, 379, 0),
(414, 4, 380, 0),
(415, 4, 381, 0),
(416, 4, 382, 0),
(417, 4, 383, 0),
(418, 4, 384, 0),
(419, 4, 385, 0),
(420, 4, 386, 0),
(421, 4, 387, 0),
(422, 4, 388, 0),
(423, 4, 389, 0),
(424, 4, 390, 0),
(425, 4, 391, 0),
(426, 4, 392, 0),
(427, 4, 393, 0),
(428, 4, 394, 0),
(429, 4, 395, 0),
(430, 4, 396, 0),
(431, 4, 397, 0),
(432, 4, 398, 0),
(433, 4, 399, 0),
(434, 4, 400, 0),
(435, 4, 401, 0),
(436, 4, 402, 0),
(437, 4, 403, 0),
(438, 4, 404, 0),
(439, 4, 405, 0),
(440, 4, 406, 0),
(441, 4, 407, 0),
(442, 4, 408, 0),
(443, 4, 409, 0),
(444, 4, 410, 0),
(445, 4, 411, 0),
(446, 4, 412, 0),
(447, 4, 413, 0),
(448, 4, 414, 0),
(449, 4, 415, 0),
(450, 4, 416, 0),
(451, 4, 417, 0),
(452, 4, 418, 0),
(453, 4, 419, 0),
(454, 4, 420, 0),
(455, 4, 421, 0),
(456, 4, 422, 0),
(457, 4, 423, 0),
(458, 4, 424, 0),
(459, 4, 425, 0),
(460, 4, 426, 0),
(461, 4, 427, 0),
(462, 4, 428, 0),
(463, 4, 429, 0),
(464, 4, 430, 0),
(465, 4, 431, 0),
(466, 4, 432, 0),
(467, 4, 433, 0),
(468, 4, 434, 0),
(469, 4, 435, 0),
(470, 4, 436, 0),
(471, 4, 437, 0),
(472, 4, 438, 0),
(473, 4, 439, 0),
(474, 4, 440, 0),
(475, 4, 441, 0),
(476, 4, 442, 0),
(477, 4, 443, 0),
(478, 4, 444, 0),
(479, 4, 445, 0),
(480, 4, 446, 0),
(481, 4, 447, 0),
(482, 4, 448, 0),
(483, 4, 449, 0),
(484, 4, 450, 0),
(485, 4, 451, 0),
(486, 4, 452, 0),
(487, 4, 453, 0),
(488, 4, 454, 0),
(489, 4, 455, 0),
(490, 4, 456, 0),
(491, 4, 457, 0),
(492, 4, 458, 0),
(493, 4, 459, 0),
(494, 4, 460, 0),
(495, 4, 461, 0),
(496, 4, 462, 0),
(497, 4, 463, 0),
(498, 4, 464, 0),
(499, 4, 465, 0),
(500, 4, 466, 0),
(501, 4, 467, 0),
(502, 4, 468, 0),
(503, 4, 469, 0),
(504, 4, 470, 0),
(505, 4, 471, 0),
(506, 4, 472, 0),
(507, 4, 473, 0),
(508, 4, 474, 0),
(509, 4, 475, 0),
(510, 4, 476, 0),
(511, 4, 477, 0),
(512, 4, 478, 0),
(513, 4, 479, 0),
(514, 4, 480, 0),
(515, 4, 481, 0),
(516, 4, 482, 0),
(517, 4, 483, 0),
(518, 4, 484, 0),
(519, 4, 485, 0),
(520, 4, 486, 0),
(521, 4, 487, 0),
(522, 4, 488, 0),
(523, 4, 489, 0),
(524, 4, 490, 0),
(525, 4, 491, 0),
(526, 4, 492, 0),
(527, 4, 493, 0),
(528, 4, 494, 0),
(529, 4, 495, 0),
(530, 4, 496, 0),
(531, 4, 497, 0),
(532, 4, 498, 0),
(533, 4, 499, 0),
(534, 4, 500, 0),
(535, 4, 501, 0),
(536, 4, 502, 0),
(537, 4, 503, 0),
(538, 4, 504, 0),
(539, 4, 505, 0),
(540, 4, 506, 0),
(541, 4, 507, 0),
(542, 4, 508, 0),
(543, 4, 509, 0),
(544, 4, 510, 0),
(545, 4, 511, 0),
(546, 4, 512, 0),
(547, 4, 513, 0),
(548, 4, 514, 0),
(549, 4, 515, 0),
(550, 4, 516, 0),
(551, 4, 517, 0),
(552, 4, 518, 0),
(553, 4, 519, 0),
(554, 4, 520, 0),
(555, 4, 521, 0),
(556, 4, 522, 0),
(557, 4, 523, 0),
(558, 4, 524, 0),
(559, 4, 525, 0),
(560, 4, 526, 0),
(561, 4, 527, 0),
(562, 4, 528, 0),
(563, 4, 529, 0),
(564, 4, 530, 0),
(565, 4, 531, 0),
(566, 4, 532, 0),
(567, 4, 533, 0),
(568, 4, 534, 0),
(569, 4, 535, 0),
(570, 4, 536, 0),
(571, 4, 537, 0),
(572, 4, 538, 0),
(573, 4, 539, 0),
(574, 4, 540, 0),
(575, 4, 541, 0),
(576, 4, 542, 0),
(577, 4, 543, 0),
(578, 4, 544, 0),
(579, 4, 545, 0),
(580, 4, 546, 0),
(581, 4, 547, 0),
(582, 4, 548, 0),
(583, 4, 549, 0),
(584, 4, 550, 0),
(585, 4, 551, 0),
(586, 4, 552, 0),
(587, 4, 553, 0),
(588, 4, 554, 0),
(589, 4, 555, 0),
(590, 4, 556, 0),
(591, 4, 557, 0),
(592, 4, 558, 0),
(593, 4, 559, 0),
(595, 4, 561, 0),
(596, 4, 562, 0),
(597, 4, 563, 0),
(598, 4, 564, 0),
(599, 4, 565, 0),
(600, 4, 566, 0),
(601, 4, 567, 0),
(602, 4, 568, 0),
(603, 4, 569, 0),
(604, 4, 570, 0),
(605, 4, 571, 0),
(606, 4, 572, 0),
(607, 4, 573, 0),
(608, 4, 574, 0),
(609, 4, 575, 0),
(610, 4, 576, 0),
(611, 4, 577, 0),
(612, 4, 578, 0),
(613, 4, 579, 0),
(614, 4, 580, 0),
(615, 4, 581, 0),
(616, 4, 582, 0),
(617, 4, 583, 0),
(618, 4, 584, 0),
(619, 4, 585, 0),
(620, 4, 586, 0),
(621, 4, 587, 0),
(622, 4, 588, 0),
(623, 4, 589, 0),
(624, 4, 590, 0),
(625, 4, 591, 0),
(626, 4, 592, 0),
(627, 4, 593, 0),
(628, 4, 594, 0),
(629, 4, 595, 0),
(630, 4, 596, 0),
(631, 4, 597, 0),
(632, 4, 598, 0),
(633, 4, 599, 0),
(634, 4, 600, 0),
(636, 4, 602, 0),
(637, 4, 603, 0),
(638, 4, 604, 0),
(639, 4, 605, 0),
(640, 4, 606, 0),
(641, 4, 607, 0),
(642, 4, 608, 0),
(643, 4, 609, 0),
(644, 4, 610, 0),
(645, 4, 611, 0),
(646, 4, 612, 0),
(647, 4, 613, 0),
(648, 4, 614, 0),
(649, 4, 615, 0),
(650, 4, 616, 0),
(651, 4, 617, 0),
(652, 4, 618, 0),
(653, 4, 619, 0),
(654, 4, 620, 0),
(655, 4, 621, 0),
(656, 4, 622, 0),
(657, 4, 623, 0),
(658, 4, 624, 0),
(659, 4, 625, 0),
(660, 4, 626, 0),
(661, 4, 627, 0),
(662, 4, 628, 0),
(663, 4, 629, 0),
(664, 4, 630, 0),
(665, 4, 631, 0),
(666, 4, 632, 0),
(667, 4, 633, 0),
(668, 4, 634, 0),
(669, 4, 635, 0),
(670, 4, 636, 0),
(671, 4, 637, 0),
(672, 4, 638, 0),
(673, 4, 639, 0),
(674, 4, 640, 0),
(675, 4, 641, 0),
(677, 4, 643, 0),
(678, 4, 644, 0),
(679, 4, 645, 0),
(680, 4, 646, 0),
(681, 4, 647, 0),
(682, 4, 648, 0),
(683, 4, 649, 0),
(684, 4, 650, 0),
(685, 4, 651, 0),
(686, 4, 652, 0),
(687, 4, 653, 0),
(688, 4, 654, 0),
(689, 4, 655, 0),
(690, 4, 656, 0),
(691, 4, 657, 0),
(692, 4, 658, 0),
(693, 4, 659, 0),
(694, 4, 660, 0),
(695, 4, 661, 0),
(696, 4, 662, 0),
(697, 4, 663, 0),
(698, 4, 664, 0),
(699, 4, 665, 0),
(700, 4, 666, 0),
(701, 4, 667, 0),
(702, 4, 668, 0),
(703, 4, 669, 0),
(704, 4, 670, 0),
(705, 4, 671, 0),
(706, 4, 672, 0),
(707, 4, 673, 0),
(708, 4, 674, 0),
(709, 4, 675, 0),
(710, 4, 676, 0),
(711, 4, 677, 0),
(712, 4, 678, 0),
(713, 4, 679, 0),
(714, 4, 680, 0),
(715, 4, 681, 0),
(716, 4, 682, 0),
(718, 4, 684, 0),
(719, 4, 685, 0),
(720, 4, 686, 0),
(721, 4, 687, 0),
(722, 4, 688, 0),
(784, 1, 689, 0),
(785, 1, 690, 0),
(786, 1, 691, 0),
(787, 1, 692, 0),
(788, 1, 693, 0),
(789, 1, 694, 0),
(790, 1, 695, 0),
(791, 1, 696, 0),
(792, 1, 697, 0),
(793, 1, 698, 0),
(794, 1, 699, 0),
(795, 1, 700, 0),
(796, 1, 701, 0),
(797, 1, 702, 0),
(798, 1, 703, 0),
(799, 1, 704, 0),
(800, 1, 705, 0),
(801, 1, 706, 0),
(802, 1, 707, 0),
(803, 1, 708, 0),
(804, 1, 709, 0),
(805, 1, 710, 0),
(806, 1, 711, 0),
(807, 1, 712, 0),
(808, 1, 713, 0),
(809, 1, 714, 0),
(810, 1, 715, 0),
(811, 1, 716, 0),
(812, 1, 717, 0),
(813, 1, 718, 0),
(814, 1, 719, 0),
(815, 1, 720, 0),
(816, 1, 721, 0),
(817, 1, 722, 0),
(818, 1, 723, 0),
(820, 1, 725, 0),
(821, 1, 726, 0),
(822, 1, 727, 0),
(823, 1, 728, 0),
(824, 1, 729, 0),
(866, 1, 730, 0),
(867, 1, 731, 0),
(868, 1, 732, 0),
(869, 1, 733, 0),
(870, 1, 734, 0),
(871, 1, 735, 0),
(872, 1, 736, 0),
(873, 1, 737, 0),
(874, 1, 738, 0),
(875, 1, 739, 0),
(876, 1, 740, 0),
(877, 1, 741, 0),
(878, 1, 742, 0),
(879, 1, 743, 0),
(880, 1, 744, 0),
(881, 1, 745, 0),
(882, 1, 746, 0),
(883, 1, 747, 0),
(884, 1, 748, 0),
(885, 1, 749, 0),
(886, 1, 750, 0),
(887, 1, 751, 0),
(888, 1, 752, 0),
(889, 1, 753, 0),
(890, 1, 754, 0),
(891, 1, 755, 0),
(892, 1, 756, 0),
(893, 1, 757, 0),
(894, 1, 758, 0),
(895, 1, 759, 0),
(896, 1, 760, 0),
(897, 1, 761, 0),
(898, 1, 762, 0),
(899, 1, 763, 0),
(900, 1, 764, 0),
(902, 1, 766, 0),
(903, 1, 767, 0),
(904, 1, 768, 0),
(905, 1, 769, 0),
(906, 1, 770, 0),
(948, 1, 771, 0),
(949, 1, 772, 0),
(950, 1, 773, 0),
(951, 1, 774, 0),
(952, 1, 775, 0),
(953, 1, 776, 0),
(954, 1, 777, 0),
(955, 1, 778, 0),
(956, 1, 779, 0),
(957, 1, 780, 0),
(958, 1, 781, 0),
(959, 1, 782, 0),
(960, 1, 783, 0),
(961, 1, 784, 0),
(962, 1, 785, 0),
(963, 1, 786, 0),
(964, 1, 787, 0),
(965, 1, 788, 0),
(966, 1, 789, 0),
(967, 1, 790, 0),
(968, 1, 791, 0),
(969, 1, 792, 0),
(970, 1, 793, 0),
(971, 1, 794, 0),
(972, 1, 795, 0),
(973, 1, 796, 0),
(974, 1, 797, 0),
(975, 1, 798, 0),
(976, 1, 799, 0),
(977, 1, 800, 0),
(978, 1, 801, 0),
(979, 1, 802, 0),
(980, 1, 803, 0),
(981, 1, 804, 0),
(982, 1, 805, 0),
(984, 1, 807, 0),
(985, 1, 808, 0),
(986, 1, 809, 0),
(987, 1, 810, 0),
(988, 1, 811, 0),
(1018, 1, 812, 0),
(1019, 1, 813, 0),
(1020, 1, 814, 0),
(1021, 1, 815, 0),
(1022, 1, 816, 0),
(1023, 1, 817, 0),
(1024, 1, 818, 0),
(1025, 1, 819, 0),
(1026, 1, 820, 0),
(1027, 1, 821, 0),
(1028, 1, 822, 0),
(1029, 1, 823, 0),
(1030, 1, 824, 0),
(1031, 1, 825, 0),
(1032, 1, 826, 0),
(1033, 1, 827, 0),
(1034, 1, 828, 0),
(1035, 1, 829, 0),
(1036, 1, 830, 0),
(1037, 1, 831, 0),
(1038, 1, 832, 0),
(1039, 1, 833, 0),
(1040, 1, 834, 0),
(1041, 1, 835, 0),
(1042, 1, 836, 0),
(1043, 1, 837, 0),
(1044, 1, 838, 0),
(1045, 1, 839, 0),
(1046, 1, 840, 0),
(1047, 1, 841, 0),
(1048, 1, 842, 0),
(1049, 1, 843, 0),
(1050, 1, 844, 0),
(1051, 1, 845, 0),
(1052, 1, 846, 0),
(1054, 1, 848, 0),
(1055, 1, 849, 0),
(1056, 1, 850, 0),
(1057, 1, 851, 0),
(1058, 1, 852, 0),
(1088, 1, 853, 0),
(1089, 1, 854, 0),
(1090, 1, 855, 0),
(1091, 1, 856, 0),
(1092, 1, 857, 0),
(1093, 1, 858, 0),
(1094, 1, 859, 0),
(1095, 1, 860, 0),
(1096, 1, 861, 0),
(1097, 1, 862, 0),
(1098, 1, 863, 0),
(1099, 1, 864, 0),
(1100, 1, 865, 0),
(1101, 1, 866, 0),
(1102, 1, 867, 0),
(1103, 1, 868, 0),
(1104, 1, 869, 0),
(1105, 1, 870, 0),
(1106, 1, 871, 0),
(1107, 1, 872, 0),
(1108, 1, 873, 0),
(1109, 1, 874, 0),
(1110, 1, 875, 0),
(1111, 1, 876, 0),
(1112, 1, 877, 0),
(1113, 1, 878, 0),
(1114, 1, 879, 0),
(1115, 1, 880, 0),
(1116, 1, 881, 0),
(1117, 1, 882, 0),
(1118, 1, 883, 0),
(1119, 1, 884, 0),
(1120, 1, 885, 0),
(1121, 1, 886, 0),
(1122, 1, 887, 0),
(1124, 1, 889, 0),
(1125, 1, 890, 0),
(1126, 1, 891, 0),
(1127, 1, 892, 0),
(1128, 1, 893, 0),
(1158, 1, 894, 0),
(1159, 1, 895, 0),
(1160, 1, 896, 0),
(1161, 1, 897, 0),
(1162, 1, 898, 0),
(1163, 1, 899, 0),
(1164, 1, 900, 0),
(1165, 1, 901, 0),
(1166, 1, 902, 0),
(1167, 1, 903, 0),
(1168, 1, 904, 0),
(1169, 1, 905, 0),
(1170, 1, 906, 0),
(1171, 1, 907, 0),
(1172, 1, 908, 0),
(1173, 1, 909, 0),
(1174, 1, 910, 0),
(1175, 1, 911, 0),
(1176, 1, 912, 0),
(1177, 1, 913, 0),
(1178, 1, 914, 0),
(1179, 1, 915, 0),
(1180, 1, 916, 0),
(1181, 1, 917, 0),
(1182, 1, 918, 0),
(1183, 1, 919, 0),
(1184, 1, 920, 0),
(1185, 1, 921, 0),
(1186, 1, 922, 0),
(1187, 1, 923, 0),
(1188, 1, 924, 0),
(1189, 1, 925, 0),
(1190, 1, 926, 0),
(1191, 1, 927, 0),
(1192, 1, 928, 0),
(1194, 1, 930, 0),
(1195, 1, 931, 0),
(1196, 1, 932, 0),
(1197, 1, 933, 0),
(1198, 1, 934, 0),
(1229, 1, 935, 0),
(1230, 1, 936, 0),
(1231, 1, 937, 0),
(1232, 1, 938, 0),
(1233, 1, 939, 0),
(1234, 1, 940, 0),
(1235, 1, 941, 0),
(1236, 1, 942, 0),
(1237, 1, 943, 0),
(1238, 1, 944, 0),
(1239, 1, 945, 0),
(1240, 1, 946, 0),
(1241, 1, 947, 0),
(1242, 1, 948, 0),
(1243, 1, 949, 0),
(1244, 1, 950, 0),
(1245, 1, 951, 0),
(1246, 1, 952, 0),
(1247, 1, 953, 0),
(1248, 1, 954, 0),
(1249, 1, 955, 0),
(1250, 1, 956, 0),
(1251, 1, 957, 0),
(1252, 1, 958, 0),
(1253, 1, 959, 0),
(1254, 1, 960, 0),
(1255, 1, 961, 0),
(1256, 1, 962, 0),
(1257, 1, 963, 0),
(1258, 1, 964, 0),
(1259, 1, 965, 0),
(1260, 1, 966, 0),
(1261, 1, 967, 0),
(1262, 1, 968, 0),
(1263, 1, 969, 0),
(1265, 1, 971, 0),
(1266, 1, 972, 0),
(1267, 1, 973, 0),
(1268, 1, 974, 0),
(1269, 1, 975, 0),
(1300, 1, 976, 0),
(1301, 1, 977, 0),
(1302, 1, 978, 0),
(1303, 1, 979, 0),
(1304, 1, 980, 0),
(1305, 1, 981, 0),
(1306, 1, 982, 0),
(1307, 1, 983, 0),
(1308, 1, 984, 0),
(1309, 1, 985, 0),
(1310, 1, 986, 0),
(1311, 1, 987, 0),
(1312, 1, 988, 0),
(1313, 1, 989, 0),
(1314, 1, 990, 0),
(1315, 1, 991, 0),
(1316, 1, 992, 0),
(1317, 1, 993, 0),
(1318, 1, 994, 0),
(1319, 1, 995, 0),
(1320, 1, 996, 0),
(1321, 1, 997, 0),
(1322, 1, 998, 0),
(1323, 1, 999, 0),
(1324, 1, 1000, 0),
(1325, 1, 1001, 0),
(1326, 1, 1002, 0),
(1327, 1, 1003, 0),
(1328, 1, 1004, 0),
(1329, 1, 1005, 0),
(1330, 1, 1006, 0),
(1331, 1, 1007, 0),
(1332, 1, 1008, 0),
(1333, 1, 1009, 0),
(1334, 1, 1010, 0),
(1336, 1, 1012, 0),
(1337, 1, 1013, 0),
(1338, 1, 1014, 0),
(1339, 1, 1015, 0),
(1340, 1, 1016, 0),
(1370, 1, 1017, 0),
(1371, 1, 1018, 0),
(1372, 1, 1019, 0),
(1373, 1, 1020, 0),
(1374, 1, 1021, 0),
(1375, 1, 1022, 0),
(1376, 1, 1023, 0),
(1377, 1, 1024, 0),
(1378, 1, 1025, 0),
(1379, 1, 1026, 0),
(1380, 1, 1027, 0),
(1381, 1, 1028, 0),
(1382, 1, 1029, 0),
(1383, 1, 1030, 0),
(1384, 1, 1031, 0),
(1385, 1, 1032, 0),
(1386, 1, 1033, 0),
(1387, 1, 1034, 0),
(1388, 1, 1035, 0),
(1389, 1, 1036, 0),
(1390, 1, 1037, 0),
(1391, 1, 1038, 0),
(1392, 1, 1039, 0),
(1393, 1, 1040, 0),
(1394, 1, 1041, 0),
(1395, 1, 1042, 0),
(1396, 1, 1043, 0),
(1397, 1, 1044, 0),
(1398, 1, 1045, 0),
(1399, 1, 1046, 0),
(1400, 1, 1047, 0),
(1401, 1, 1048, 0),
(1402, 1, 1049, 0),
(1403, 1, 1050, 0),
(1404, 1, 1051, 0),
(1406, 1, 1053, 0),
(1407, 1, 1054, 0),
(1408, 1, 1055, 0),
(1409, 1, 1056, 0),
(1410, 1, 1057, 0),
(1441, 1, 1058, 0),
(1442, 1, 1059, 0),
(1443, 1, 1060, 0),
(1444, 1, 1061, 0),
(1445, 1, 1062, 0),
(1446, 1, 1063, 0),
(1447, 1, 1064, 0),
(1448, 1, 1065, 0),
(1449, 1, 1066, 0),
(1450, 1, 1067, 0),
(1451, 1, 1068, 0),
(1452, 1, 1069, 0),
(1453, 1, 1070, 0),
(1454, 1, 1071, 0),
(1455, 1, 1072, 0),
(1456, 1, 1073, 0),
(1457, 1, 1074, 0),
(1458, 1, 1075, 0),
(1459, 1, 1076, 0),
(1460, 1, 1077, 0),
(1461, 1, 1078, 0),
(1462, 1, 1079, 0),
(1463, 1, 1080, 0),
(1464, 1, 1081, 0),
(1465, 1, 1082, 0),
(1466, 1, 1083, 0),
(1467, 1, 1084, 0),
(1468, 1, 1085, 0),
(1469, 1, 1086, 0),
(1470, 1, 1087, 0),
(1471, 1, 1088, 0),
(1472, 1, 1089, 0),
(1473, 1, 1090, 0),
(1474, 1, 1091, 0),
(1475, 1, 1092, 0),
(1477, 1, 1094, 0),
(1478, 1, 1095, 0),
(1479, 1, 1096, 0),
(1480, 1, 1097, 0),
(1481, 1, 1098, 0),
(1523, 1, 1099, 0),
(1524, 1, 1100, 0),
(1525, 1, 1101, 0),
(1526, 1, 1102, 0),
(1527, 1, 1103, 0),
(1528, 1, 1104, 0),
(1529, 1, 1105, 0),
(1530, 1, 1106, 0),
(1531, 1, 1107, 0),
(1532, 1, 1108, 0),
(1533, 1, 1109, 0),
(1534, 1, 1110, 0),
(1535, 1, 1111, 0),
(1536, 1, 1112, 0),
(1537, 1, 1113, 0),
(1538, 1, 1114, 0),
(1539, 1, 1115, 0),
(1540, 1, 1116, 0),
(1541, 1, 1117, 0),
(1542, 1, 1118, 0),
(1543, 1, 1119, 0),
(1544, 1, 1120, 0),
(1545, 1, 1121, 0),
(1546, 1, 1122, 0),
(1547, 1, 1123, 0),
(1548, 1, 1124, 0),
(1549, 1, 1125, 0),
(1550, 1, 1126, 0),
(1551, 1, 1127, 0),
(1552, 1, 1128, 0),
(1553, 1, 1129, 0),
(1554, 1, 1130, 0),
(1555, 1, 1131, 0),
(1556, 1, 1132, 0),
(1557, 1, 1133, 0),
(1559, 1, 1135, 0),
(1560, 1, 1136, 0),
(1561, 1, 1137, 0),
(1562, 1, 1138, 0),
(1563, 1, 1139, 0),
(1584, 1, 1140, 0),
(1585, 1, 1141, 0),
(1586, 1, 1142, 0),
(1587, 1, 1143, 0),
(1588, 1, 1144, 0),
(1589, 1, 1145, 0),
(1590, 1, 1146, 0),
(1591, 1, 1147, 0),
(1592, 1, 1148, 0),
(1593, 1, 1149, 0),
(1594, 1, 1150, 0),
(1595, 1, 1151, 0),
(1596, 1, 1152, 0),
(1597, 1, 1153, 0),
(1598, 1, 1154, 0),
(1599, 1, 1155, 0),
(1600, 1, 1156, 0),
(1601, 1, 1157, 0),
(1602, 1, 1158, 0),
(1603, 1, 1159, 0),
(1604, 1, 1160, 0),
(1605, 1, 1161, 0),
(1606, 1, 1162, 0),
(1607, 1, 1163, 0),
(1608, 1, 1164, 0),
(1609, 1, 1165, 0),
(1610, 1, 1166, 0),
(1611, 1, 1167, 0),
(1612, 1, 1168, 0),
(1613, 1, 1169, 0),
(1614, 1, 1170, 0),
(1615, 1, 1171, 0),
(1616, 1, 1172, 0),
(1617, 1, 1173, 0),
(1618, 1, 1174, 0),
(1620, 1, 1176, 0),
(1621, 1, 1177, 0),
(1622, 1, 1178, 0),
(1623, 1, 1179, 0),
(1624, 1, 1180, 0),
(1666, 4, 1181, 0),
(1667, 4, 1182, 0),
(1668, 4, 1183, 0),
(1669, 4, 1184, 0),
(1670, 4, 1185, 0),
(1671, 4, 1186, 0),
(1672, 4, 1187, 0),
(1673, 4, 1188, 0),
(1674, 4, 1189, 0),
(1675, 4, 1190, 0),
(1676, 4, 1191, 0),
(1677, 4, 1192, 0),
(1678, 4, 1193, 0),
(1679, 4, 1194, 0),
(1680, 4, 1195, 0),
(1681, 4, 1196, 0),
(1682, 4, 1197, 0),
(1683, 4, 1198, 0),
(1684, 4, 1199, 0),
(1685, 4, 1200, 0),
(1686, 4, 1201, 0),
(1687, 4, 1202, 0),
(1688, 4, 1203, 0),
(1689, 4, 1204, 0),
(1690, 4, 1205, 0),
(1691, 4, 1206, 0),
(1692, 4, 1207, 0),
(1693, 4, 1208, 0),
(1694, 4, 1209, 0),
(1695, 4, 1210, 0),
(1696, 4, 1211, 0),
(1697, 4, 1212, 0),
(1698, 4, 1213, 0),
(1699, 4, 1214, 0),
(1700, 4, 1215, 0),
(1701, 4, 1216, 0),
(1703, 4, 1218, 0),
(1704, 4, 1219, 0),
(1705, 4, 1220, 0),
(1706, 4, 1221, 0),
(1707, 4, 1222, 0),
(1708, 4, 1223, 0),
(1709, 4, 1224, 0),
(1710, 4, 1225, 0),
(1711, 4, 1226, 0),
(1712, 4, 1227, 0),
(1713, 4, 1228, 0),
(1714, 4, 1229, 0),
(1715, 4, 1230, 0),
(1716, 4, 1231, 0),
(1717, 4, 1232, 0),
(1718, 4, 1233, 0),
(1719, 4, 1234, 0),
(1720, 4, 1235, 0),
(1721, 4, 1236, 0),
(1722, 4, 1237, 0),
(1723, 4, 1238, 0),
(1724, 4, 1239, 0),
(1725, 4, 1240, 0),
(1726, 4, 1241, 0),
(1727, 4, 1242, 0),
(1728, 4, 1243, 0),
(1729, 4, 1244, 0),
(1730, 4, 1245, 0),
(1731, 4, 1246, 0),
(1732, 4, 1247, 0),
(1733, 4, 1248, 0),
(1734, 4, 1249, 0),
(1735, 4, 1250, 0),
(1736, 4, 1251, 0),
(1737, 4, 1252, 0),
(1738, 4, 1253, 0),
(1739, 4, 1254, 0),
(1740, 4, 1255, 0),
(1741, 4, 1256, 0),
(1742, 4, 1257, 0),
(1744, 4, 1259, 0),
(1745, 4, 1260, 0),
(1746, 4, 1261, 0),
(1747, 4, 1262, 0),
(1748, 4, 1263, 0),
(1749, 4, 1264, 0),
(1750, 4, 1265, 0),
(1751, 4, 1266, 0),
(1752, 4, 1267, 0),
(1753, 4, 1268, 0),
(1754, 4, 1269, 0),
(1755, 4, 1270, 0),
(1756, 4, 1271, 0),
(1757, 4, 1272, 0),
(1758, 4, 1273, 0),
(1759, 4, 1274, 0),
(1760, 4, 1275, 0),
(1761, 4, 1276, 0),
(1762, 4, 1277, 0),
(1763, 4, 1278, 0),
(1764, 4, 1279, 0),
(1765, 4, 1280, 0),
(1766, 4, 1281, 0),
(1767, 4, 1282, 0),
(1768, 4, 1283, 0),
(1769, 4, 1284, 0),
(1770, 4, 1285, 0),
(1771, 4, 1286, 0),
(1772, 4, 1287, 0),
(1773, 4, 1288, 0),
(1774, 4, 1289, 0),
(1775, 4, 1290, 0),
(1776, 4, 1291, 0),
(1777, 4, 1292, 0),
(1778, 4, 1293, 0),
(1779, 4, 1294, 0),
(1780, 4, 1295, 0),
(1781, 4, 1296, 0),
(1782, 4, 1297, 0),
(1783, 4, 1298, 0),
(1785, 4, 1300, 0),
(1786, 4, 1301, 0),
(1787, 4, 1302, 0),
(1788, 4, 1303, 0),
(1789, 4, 1304, 0),
(1790, 4, 1305, 0),
(1791, 4, 1306, 0),
(1792, 4, 1307, 0),
(1793, 4, 1308, 0),
(1794, 4, 1309, 0),
(1795, 4, 1310, 0),
(1796, 4, 1311, 0),
(1797, 4, 1312, 0),
(1798, 4, 1313, 0),
(1799, 4, 1314, 0),
(1800, 4, 1315, 0),
(1801, 4, 1316, 0),
(1802, 4, 1317, 0),
(1803, 4, 1318, 0),
(1804, 4, 1319, 0),
(1805, 4, 1320, 0),
(1806, 4, 1321, 0),
(1807, 4, 1322, 0),
(1808, 4, 1323, 0),
(1809, 4, 1324, 0),
(1810, 4, 1325, 0),
(1811, 4, 1326, 0),
(1812, 4, 1327, 0),
(1813, 4, 1328, 0),
(1814, 4, 1329, 0),
(1815, 4, 1330, 0),
(1816, 4, 1331, 0),
(1817, 4, 1332, 0),
(1818, 4, 1333, 0),
(1819, 4, 1334, 0),
(1820, 4, 1335, 0),
(1821, 4, 1336, 0),
(1822, 4, 1337, 0),
(1823, 4, 1338, 0),
(1824, 4, 1339, 0),
(1826, 4, 1341, 0),
(1827, 4, 1342, 0),
(1828, 4, 1343, 0),
(1829, 4, 1344, 0),
(1830, 4, 1345, 0),
(1831, 4, 1346, 0),
(1832, 4, 1347, 0),
(1833, 4, 1348, 0),
(1834, 4, 1349, 0),
(1835, 4, 1350, 0),
(1836, 4, 1351, 0),
(1837, 4, 1352, 0),
(1838, 4, 1353, 0),
(1839, 4, 1354, 0),
(1840, 4, 1355, 0),
(1841, 4, 1356, 0),
(1842, 4, 1357, 0),
(1843, 4, 1358, 0),
(1844, 4, 1359, 0),
(1845, 4, 1360, 0),
(1846, 4, 1361, 0),
(1847, 4, 1362, 0),
(1848, 4, 1363, 0),
(1849, 4, 1364, 0),
(1850, 4, 1365, 0),
(1851, 4, 1366, 0),
(1852, 4, 1367, 0),
(1853, 4, 1368, 0),
(1854, 4, 1369, 0),
(1855, 4, 1370, 0),
(1856, 4, 1371, 0),
(1857, 4, 1372, 0),
(1858, 4, 1373, 0),
(1859, 4, 1374, 0),
(1860, 4, 1375, 0),
(1861, 4, 1376, 0),
(1862, 4, 1377, 0),
(1863, 4, 1378, 0),
(1864, 4, 1379, 0),
(1865, 4, 1380, 0),
(1867, 4, 1382, 0),
(1868, 4, 1383, 0),
(1869, 4, 1384, 0),
(1870, 4, 1385, 0),
(1871, 4, 1386, 0),
(1872, 4, 1387, 0),
(1873, 4, 1388, 0),
(1874, 4, 1389, 0),
(1875, 4, 1390, 0),
(1876, 4, 1391, 0),
(1877, 4, 1392, 0),
(1878, 4, 1393, 0),
(1879, 4, 1394, 0),
(1880, 4, 1395, 0),
(1881, 4, 1396, 0),
(1882, 4, 1397, 0),
(1883, 4, 1398, 0),
(1884, 4, 1399, 0),
(1885, 4, 1400, 0),
(1886, 4, 1401, 0),
(1887, 4, 1402, 0),
(1888, 4, 1403, 0),
(1889, 4, 1404, 0),
(1890, 4, 1405, 0),
(1891, 4, 1406, 0),
(1892, 4, 1407, 0),
(1893, 4, 1408, 0),
(1894, 4, 1409, 0),
(1895, 4, 1410, 0),
(1896, 4, 1411, 0),
(1897, 4, 1412, 0),
(1898, 4, 1413, 0),
(1899, 4, 1414, 0),
(1900, 4, 1415, 0),
(1901, 4, 1416, 0),
(1902, 4, 1417, 0),
(1903, 4, 1418, 0),
(1904, 4, 1419, 0),
(1905, 4, 1420, 0),
(1906, 4, 1421, 0),
(1908, 4, 1423, 0),
(1909, 4, 1424, 0),
(1910, 4, 1425, 0),
(1911, 4, 1426, 0),
(1912, 4, 1427, 0),
(1913, 4, 1428, 0),
(1914, 4, 1429, 0),
(1915, 4, 1430, 0),
(1916, 4, 1431, 0),
(1917, 4, 1432, 0),
(1918, 4, 1433, 0),
(1919, 4, 1434, 0),
(1920, 4, 1435, 0),
(1921, 4, 1436, 0),
(1922, 4, 1437, 0),
(1923, 4, 1438, 0),
(1924, 4, 1439, 0),
(1925, 4, 1440, 0),
(1926, 4, 1441, 0),
(1927, 4, 1442, 0),
(1928, 4, 1443, 0),
(1929, 4, 1444, 0),
(1930, 4, 1445, 0),
(1931, 4, 1446, 0),
(1932, 4, 1447, 0),
(1933, 4, 1448, 0),
(1934, 4, 1449, 0),
(1935, 4, 1450, 0),
(1936, 4, 1451, 0),
(1937, 4, 1452, 0),
(1938, 4, 1453, 0),
(1939, 4, 1454, 0),
(1940, 4, 1455, 0),
(1941, 4, 1456, 0),
(1942, 4, 1457, 0),
(1943, 4, 1458, 0),
(1944, 4, 1459, 0),
(1945, 4, 1460, 0),
(1946, 4, 1461, 0),
(1947, 4, 1462, 0),
(1949, 4, 1464, 0),
(1950, 4, 1465, 0),
(1952, 4, 1466, 0),
(1953, 4, 1467, 0),
(1954, 4, 1468, 0),
(1955, 4, 1469, 0),
(1956, 4, 1470, 0),
(1957, 4, 1471, 0),
(1958, 4, 1472, 0),
(1959, 4, 1473, 0),
(1960, 4, 1474, 0),
(1961, 4, 1475, 0),
(1962, 4, 1476, 0),
(1963, 4, 1477, 0),
(1964, 4, 1478, 0),
(1965, 4, 1479, 0),
(1966, 4, 1480, 0),
(1967, 4, 1481, 0),
(1968, 4, 1482, 0),
(1969, 4, 1483, 0),
(1970, 4, 1484, 0),
(1971, 4, 1485, 0),
(1972, 4, 1486, 0),
(1973, 4, 1487, 0),
(1974, 4, 1488, 0),
(1975, 4, 1489, 0),
(1976, 4, 1490, 0),
(1977, 4, 1491, 0),
(1978, 4, 1492, 0),
(1979, 4, 1493, 0),
(1980, 4, 1494, 0),
(1981, 4, 1495, 0),
(1982, 4, 1496, 0),
(1983, 4, 1497, 0),
(1984, 4, 1498, 0),
(1985, 4, 1499, 0),
(1986, 4, 1500, 0),
(1987, 4, 1501, 0),
(1988, 4, 1502, 0),
(1990, 4, 1504, 0),
(1991, 4, 1505, 0),
(1992, 4, 1506, 0),
(1993, 4, 1507, 0),
(1994, 4, 1508, 0),
(1995, 4, 1509, 0),
(1996, 4, 1510, 0),
(1997, 4, 1511, 0),
(1998, 4, 1512, 0),
(1999, 4, 1513, 0),
(2000, 4, 1514, 0),
(2001, 4, 1515, 0),
(2002, 4, 1516, 0),
(2003, 4, 1517, 0),
(2004, 4, 1518, 0),
(2005, 4, 1519, 0),
(2006, 4, 1520, 0),
(2007, 4, 1521, 0),
(2008, 4, 1522, 0),
(2009, 4, 1523, 0),
(2010, 4, 1524, 0),
(2011, 4, 1525, 0),
(2012, 4, 1526, 0),
(2013, 4, 1527, 0),
(2014, 4, 1528, 0),
(2015, 4, 1529, 0),
(2016, 4, 1530, 0),
(2017, 4, 1531, 0),
(2018, 4, 1532, 0),
(2019, 4, 1533, 0),
(2020, 4, 1534, 0),
(2021, 4, 1535, 0),
(2022, 4, 1536, 0),
(2023, 4, 1537, 0),
(2024, 4, 1538, 0),
(2025, 4, 1539, 0),
(2026, 4, 1540, 0),
(2027, 4, 1541, 0),
(2028, 4, 1542, 0),
(2029, 4, 1543, 0),
(2031, 4, 1545, 0),
(2032, 4, 1546, 0),
(2033, 4, 1547, 0),
(2034, 4, 1548, 0),
(2035, 4, 1549, 0),
(2036, 4, 1550, 0),
(2037, 4, 1551, 0),
(2038, 4, 1552, 0),
(2039, 4, 1553, 0),
(2040, 4, 1554, 0),
(2041, 4, 1555, 0),
(2042, 4, 1556, 0),
(2043, 4, 1557, 0),
(2044, 4, 1558, 0),
(2045, 4, 1559, 0),
(2046, 4, 1560, 0),
(2047, 4, 1561, 0),
(2048, 4, 1562, 0),
(2049, 4, 1563, 0),
(2050, 4, 1564, 0),
(2051, 4, 1565, 0),
(2052, 4, 1566, 0),
(2053, 4, 1567, 0),
(2054, 4, 1568, 0),
(2055, 4, 1569, 0),
(2056, 4, 1570, 0),
(2057, 4, 1571, 0),
(2058, 4, 1572, 0),
(2059, 4, 1573, 0),
(2060, 4, 1574, 0),
(2061, 4, 1575, 0),
(2062, 4, 1576, 0),
(2063, 4, 1577, 0),
(2064, 4, 1578, 0),
(2065, 4, 1579, 0),
(2066, 4, 1580, 0),
(2067, 4, 1581, 0),
(2068, 4, 1582, 0),
(2069, 4, 1583, 0),
(2070, 4, 1584, 0),
(2072, 4, 1586, 0),
(2073, 4, 1587, 0),
(2074, 4, 1588, 0),
(2075, 4, 1589, 0),
(2076, 4, 1590, 0),
(2077, 4, 1591, 0),
(2078, 4, 1592, 0),
(2079, 4, 1593, 0),
(2080, 4, 1594, 0),
(2081, 4, 1595, 0),
(2082, 4, 1596, 0),
(2083, 4, 1597, 0),
(2084, 4, 1598, 0),
(2085, 4, 1599, 0),
(2086, 4, 1600, 0),
(2087, 4, 1601, 0),
(2088, 4, 1602, 0),
(2089, 4, 1603, 0),
(2090, 4, 1604, 0),
(2091, 4, 1605, 0),
(2092, 4, 1606, 0),
(2093, 4, 1607, 0),
(2094, 4, 1608, 0),
(2095, 4, 1609, 0),
(2096, 4, 1610, 0),
(2097, 4, 1611, 0),
(2098, 4, 1612, 0),
(2099, 4, 1613, 0),
(2100, 4, 1614, 0),
(2101, 4, 1615, 0),
(2102, 4, 1616, 0),
(2103, 4, 1617, 0),
(2104, 4, 1618, 0),
(2105, 4, 1619, 0),
(2106, 4, 1620, 0),
(2107, 4, 1621, 0),
(2108, 4, 1622, 0),
(2109, 4, 1623, 0),
(2110, 4, 1624, 0),
(2111, 4, 1625, 0),
(2113, 4, 1627, 0),
(2114, 4, 1628, 0),
(2115, 4, 1629, 0),
(2116, 4, 1630, 0),
(2117, 4, 1631, 0),
(2118, 4, 1632, 0),
(2119, 4, 1633, 0),
(2120, 4, 1634, 0),
(2121, 4, 1635, 0),
(2122, 4, 1636, 0),
(2123, 4, 1637, 0),
(2124, 4, 1638, 0),
(2125, 4, 1639, 0),
(2126, 4, 1640, 0),
(2127, 4, 1641, 0),
(2128, 4, 1642, 0),
(2129, 4, 1643, 0),
(2130, 4, 1644, 0),
(2131, 4, 1645, 0),
(2132, 4, 1646, 0),
(2133, 4, 1647, 0),
(2134, 4, 1648, 0),
(2135, 4, 1649, 0),
(2136, 4, 1650, 0),
(2137, 4, 1651, 0),
(2138, 4, 1652, 0),
(2159, 4, 1653, 0),
(2160, 4, 1654, 0),
(2161, 4, 1655, 0),
(2162, 4, 1656, 0),
(2163, 4, 1657, 0),
(2164, 4, 1658, 0),
(2165, 4, 1659, 0),
(2166, 4, 1660, 0),
(2167, 4, 1661, 0),
(2168, 4, 1662, 0),
(2169, 4, 1663, 0),
(2170, 4, 1664, 0),
(2171, 4, 1665, 0),
(2172, 4, 1666, 0),
(2173, 4, 1667, 0),
(2174, 4, 1668, 0),
(2175, 4, 1669, 0),
(2176, 4, 1670, 0),
(2177, 4, 1671, 0),
(2178, 4, 1672, 0),
(2179, 4, 1673, 0),
(2180, 4, 1674, 0),
(2181, 4, 1675, 0),
(2182, 4, 1676, 0),
(2183, 4, 1677, 0),
(2184, 4, 1678, 0),
(2185, 4, 1679, 0),
(2186, 4, 1680, 0),
(2187, 4, 1681, 0),
(2188, 4, 1682, 0),
(2189, 4, 1683, 0),
(2190, 4, 1684, 0),
(2191, 4, 1685, 0),
(2192, 4, 1686, 0),
(2193, 4, 1687, 0),
(2195, 4, 1689, 0),
(2196, 4, 1690, 0),
(2197, 4, 1691, 0),
(2198, 4, 1692, 0),
(2199, 4, 1693, 0),
(2200, 4, 1694, 0),
(2201, 4, 1695, 0),
(2202, 4, 1696, 0),
(2203, 4, 1697, 0),
(2204, 4, 1698, 0),
(2205, 4, 1699, 0),
(2206, 4, 1700, 0),
(2207, 4, 1701, 0),
(2208, 4, 1702, 0),
(2209, 4, 1703, 0),
(2210, 4, 1704, 0),
(2211, 4, 1705, 0),
(2212, 4, 1706, 0),
(2213, 4, 1707, 0),
(2214, 4, 1708, 0),
(2215, 4, 1709, 0),
(2216, 4, 1710, 0),
(2217, 4, 1711, 0),
(2218, 4, 1712, 0),
(2219, 4, 1713, 0),
(2220, 4, 1714, 0),
(2221, 4, 1715, 0),
(2222, 4, 1716, 0),
(2223, 4, 1717, 0),
(2224, 4, 1718, 0),
(2225, 4, 1719, 0),
(2226, 4, 1720, 0),
(2227, 4, 1721, 0),
(2228, 4, 1722, 0),
(2229, 4, 1723, 0),
(2230, 4, 1724, 0),
(2231, 4, 1725, 0),
(2232, 4, 1726, 0),
(2233, 4, 1727, 0),
(2234, 4, 1728, 0),
(2236, 4, 1730, 0),
(2237, 4, 1731, 0),
(2238, 4, 1732, 0),
(2239, 4, 1733, 0),
(2240, 4, 1734, 0),
(2241, 4, 1735, 0),
(2242, 4, 1736, 0),
(2243, 4, 1737, 0),
(2244, 4, 1738, 0),
(2245, 4, 1739, 0),
(2246, 4, 1740, 0),
(2247, 4, 1741, 0),
(2248, 4, 1742, 0),
(2249, 4, 1743, 0),
(2250, 4, 1744, 0),
(2251, 4, 1745, 0),
(2252, 4, 1746, 0),
(2253, 4, 1747, 0),
(2254, 4, 1748, 0),
(2255, 4, 1749, 0),
(2256, 4, 1750, 0),
(2257, 4, 1751, 0),
(2258, 4, 1752, 0),
(2259, 4, 1753, 0),
(2260, 4, 1754, 0),
(2261, 4, 1755, 0),
(2262, 4, 1756, 0),
(2263, 4, 1757, 0),
(2264, 4, 1758, 0),
(2265, 4, 1759, 0),
(2266, 4, 1760, 0),
(2267, 4, 1761, 0),
(2268, 4, 1762, 0),
(2269, 4, 1763, 0),
(2270, 4, 1764, 0),
(2271, 4, 1765, 0),
(2272, 4, 1766, 0),
(2273, 4, 1767, 0),
(2274, 4, 1768, 0),
(2275, 4, 1769, 0),
(2277, 4, 1771, 0),
(2278, 4, 1772, 0),
(2279, 4, 1773, 0),
(2280, 4, 1774, 0),
(2281, 4, 1775, 0),
(2282, 1, 1776, 0),
(2283, 1, 1777, 0),
(2284, 1, 1778, 0),
(2285, 1, 1779, 0),
(2286, 1, 1780, 0),
(2287, 1, 1781, 0),
(2288, 1, 1782, 0),
(2289, 1, 1783, 0),
(2290, 1, 1784, 0),
(2291, 1, 1785, 0),
(2292, 1, 1786, 0),
(2293, 1, 1787, 0),
(2294, 1, 1788, 0),
(2295, 1, 1789, 0),
(2296, 1, 1790, 0),
(2297, 1, 1791, 0),
(2298, 1, 1792, 0),
(2299, 1, 1793, 0),
(2300, 1, 1794, 0),
(2301, 1, 1795, 0),
(2302, 1, 1796, 0),
(2303, 1, 1797, 0),
(2304, 1, 1798, 0),
(2305, 1, 1799, 0),
(2306, 1, 1800, 0),
(2307, 1, 1801, 0),
(2308, 1, 1802, 0),
(2309, 1, 1803, 0),
(2310, 1, 1804, 0),
(2311, 1, 1805, 0),
(2312, 1, 1806, 0),
(2313, 1, 1807, 0),
(2314, 1, 1808, 0),
(2315, 1, 1809, 0),
(2316, 1, 1810, 0),
(2318, 1, 1812, 0),
(2319, 1, 1813, 0),
(2320, 1, 1814, 0),
(2321, 1, 1815, 0),
(2322, 1, 1816, 0),
(2364, 1, 1817, 0),
(2365, 1, 1818, 0),
(2366, 1, 1819, 0),
(2367, 1, 1820, 0),
(2368, 1, 1821, 0),
(2369, 1, 1822, 0),
(2370, 1, 1823, 0),
(2371, 1, 1824, 0),
(2372, 1, 1825, 0),
(2373, 1, 1826, 0),
(2374, 1, 1827, 0),
(2375, 1, 1828, 0),
(2376, 1, 1829, 0),
(2377, 1, 1830, 0),
(2378, 1, 1831, 0),
(2379, 1, 1832, 0),
(2380, 1, 1833, 0),
(2381, 1, 1834, 0),
(2382, 1, 1835, 0),
(2383, 1, 1836, 0),
(2384, 1, 1837, 0),
(2385, 1, 1838, 0),
(2386, 1, 1839, 0),
(2387, 1, 1840, 0),
(2388, 1, 1841, 0),
(2389, 1, 1842, 0),
(2390, 1, 1843, 0),
(2391, 1, 1844, 0),
(2392, 1, 1845, 0),
(2393, 1, 1846, 0),
(2394, 1, 1847, 0),
(2395, 1, 1848, 0),
(2396, 1, 1849, 0),
(2397, 1, 1850, 0),
(2398, 1, 1851, 0),
(2400, 1, 1853, 0),
(2401, 1, 1854, 0),
(2402, 1, 1855, 0),
(2403, 1, 1856, 0),
(2404, 1, 1857, 0),
(2446, 1, 1858, 0),
(2447, 1, 1859, 0),
(2448, 1, 1860, 0),
(2449, 1, 1861, 0),
(2450, 1, 1862, 0),
(2451, 1, 1863, 0),
(2452, 1, 1864, 0),
(2453, 1, 1865, 0),
(2454, 1, 1866, 0),
(2455, 1, 1867, 0),
(2456, 1, 1868, 0),
(2457, 1, 1869, 0),
(2458, 1, 1870, 0),
(2459, 1, 1871, 0),
(2460, 1, 1872, 0),
(2461, 1, 1873, 0),
(2462, 1, 1874, 0),
(2463, 1, 1875, 0),
(2464, 1, 1876, 0),
(2465, 1, 1877, 0),
(2466, 1, 1878, 0),
(2467, 1, 1879, 0),
(2468, 1, 1880, 0),
(2469, 1, 1881, 0),
(2470, 1, 1882, 0),
(2471, 1, 1883, 0),
(2472, 1, 1884, 0),
(2473, 1, 1885, 0),
(2474, 1, 1886, 0),
(2475, 1, 1887, 0),
(2476, 1, 1888, 0),
(2477, 1, 1889, 0),
(2478, 1, 1890, 0),
(2479, 1, 1891, 0),
(2480, 1, 1892, 0),
(2482, 1, 1894, 0),
(2483, 1, 1895, 0),
(2484, 1, 1896, 0),
(2485, 1, 1897, 0),
(2486, 1, 1898, 0),
(2528, 1, 1899, 0),
(2529, 1, 1900, 0),
(2530, 1, 1901, 0),
(2531, 1, 1902, 0),
(2532, 1, 1903, 0),
(2533, 1, 1904, 0),
(2534, 1, 1905, 0),
(2535, 1, 1906, 0),
(2536, 1, 1907, 0),
(2537, 1, 1908, 0),
(2538, 1, 1909, 0),
(2539, 1, 1910, 0),
(2540, 1, 1911, 0),
(2541, 1, 1912, 0),
(2542, 1, 1913, 0),
(2543, 1, 1914, 0),
(2544, 1, 1915, 0),
(2545, 1, 1916, 0),
(2546, 1, 1917, 0),
(2547, 1, 1918, 0),
(2548, 1, 1919, 0),
(2549, 1, 1920, 0),
(2550, 1, 1921, 0),
(2551, 1, 1922, 0),
(2552, 1, 1923, 0),
(2553, 1, 1924, 0),
(2554, 1, 1925, 0),
(2555, 1, 1926, 0),
(2556, 1, 1927, 0),
(2557, 1, 1928, 0),
(2558, 1, 1929, 0),
(2559, 1, 1930, 0),
(2560, 1, 1931, 0),
(2561, 1, 1932, 0),
(2562, 1, 1933, 0),
(2564, 1, 1935, 0),
(2565, 1, 1936, 0),
(2566, 1, 1937, 0),
(2567, 1, 1938, 0),
(2568, 1, 1939, 0),
(2610, 1, 1940, 0),
(2611, 1, 1941, 0),
(2612, 1, 1942, 0),
(2613, 1, 1943, 0),
(2614, 1, 1944, 0),
(2615, 1, 1945, 0),
(2616, 1, 1946, 0),
(2617, 1, 1947, 0),
(2618, 1, 1948, 0),
(2619, 1, 1949, 0),
(2620, 1, 1950, 0),
(2621, 1, 1951, 0),
(2622, 1, 1952, 0),
(2623, 1, 1953, 0),
(2624, 1, 1954, 0),
(2625, 1, 1955, 0),
(2626, 1, 1956, 0),
(2627, 1, 1957, 0),
(2628, 1, 1958, 0),
(2629, 1, 1959, 0),
(2630, 1, 1960, 0),
(2631, 1, 1961, 0),
(2632, 1, 1962, 0),
(2633, 1, 1963, 0),
(2634, 1, 1964, 0),
(2635, 1, 1965, 0),
(2636, 1, 1966, 0),
(2637, 1, 1967, 0),
(2638, 1, 1968, 0),
(2639, 1, 1969, 0),
(2640, 1, 1970, 0),
(2641, 1, 1971, 0),
(2642, 1, 1972, 0),
(2643, 1, 1973, 0),
(2644, 1, 1974, 0),
(2646, 1, 1976, 0),
(2647, 1, 1977, 0),
(2648, 1, 1978, 0),
(2649, 1, 1979, 0),
(2650, 1, 1980, 0),
(2692, 1, 1981, 0),
(2693, 1, 1982, 0),
(2694, 1, 1983, 0),
(2695, 1, 1984, 0),
(2696, 1, 1985, 0),
(2697, 1, 1986, 0),
(2698, 1, 1987, 0),
(2699, 1, 1988, 0),
(2700, 1, 1989, 0),
(2701, 1, 1990, 0),
(2702, 1, 1991, 0),
(2703, 1, 1992, 0),
(2704, 1, 1993, 0),
(2705, 1, 1994, 0),
(2706, 1, 1995, 0),
(2707, 1, 1996, 0),
(2708, 1, 1997, 0),
(2709, 1, 1998, 0),
(2710, 1, 1999, 0),
(2711, 1, 2000, 0),
(2712, 1, 2001, 0),
(2713, 1, 2002, 0),
(2714, 1, 2003, 0),
(2715, 1, 2004, 0),
(2716, 1, 2005, 0),
(2717, 1, 2006, 0),
(2718, 1, 2007, 0),
(2719, 1, 2008, 0),
(2720, 1, 2009, 0),
(2721, 1, 2010, 0),
(2722, 1, 2011, 0),
(2723, 1, 2012, 0),
(2724, 1, 2013, 0),
(2725, 1, 2014, 0),
(2726, 1, 2015, 0),
(2728, 1, 2017, 0),
(2729, 1, 2018, 0),
(2730, 1, 2019, 0),
(2731, 1, 2020, 0),
(2732, 1, 2021, 0),
(2774, 1, 2022, 0),
(2775, 1, 2023, 0),
(2776, 1, 2024, 0),
(2777, 1, 2025, 0),
(2778, 1, 2026, 0),
(2779, 1, 2027, 0),
(2780, 1, 2028, 0),
(2781, 1, 2029, 0),
(2782, 1, 2030, 0),
(2783, 1, 2031, 0),
(2784, 1, 2032, 0),
(2785, 1, 2033, 0),
(2786, 1, 2034, 0),
(2787, 1, 2035, 0),
(2788, 1, 2036, 0),
(2789, 1, 2037, 0),
(2790, 1, 2038, 0),
(2791, 1, 2039, 0),
(2792, 1, 2040, 0),
(2793, 1, 2041, 0),
(2794, 1, 2042, 0),
(2795, 1, 2043, 0),
(2796, 1, 2044, 0),
(2797, 1, 2045, 0),
(2798, 1, 2046, 0),
(2799, 1, 2047, 0),
(2800, 1, 2048, 0),
(2801, 1, 2049, 0),
(2802, 1, 2050, 0),
(2803, 1, 2051, 0),
(2804, 1, 2052, 0),
(2805, 1, 2053, 0),
(2806, 1, 2054, 0),
(2807, 1, 2055, 0),
(2808, 1, 2056, 0),
(2810, 1, 2058, 0),
(2811, 1, 2059, 0),
(2812, 1, 2060, 0),
(2813, 1, 2061, 0),
(2814, 1, 2062, 0),
(2856, 1, 2063, 0),
(2857, 1, 2064, 0),
(2858, 1, 2065, 0),
(2859, 1, 2066, 0),
(2860, 1, 2067, 0),
(2861, 1, 2068, 0),
(2862, 1, 2069, 0),
(2863, 1, 2070, 0),
(2864, 1, 2071, 0),
(2865, 1, 2072, 0),
(2866, 1, 2073, 0),
(2867, 1, 2074, 0),
(2868, 1, 2075, 0),
(2869, 1, 2076, 0),
(2871, 1, 2078, 0),
(2872, 1, 2079, 0),
(2873, 1, 2080, 0),
(2874, 1, 2081, 0),
(2875, 1, 2082, 0),
(2917, 1, 2083, 0),
(2918, 1, 2084, 0),
(2919, 1, 2085, 0),
(2920, 1, 2086, 0),
(2921, 1, 2087, 0),
(2922, 1, 2088, 0),
(2923, 1, 2089, 0),
(2924, 1, 2090, 0),
(2925, 1, 2091, 0),
(2926, 1, 2092, 0),
(2927, 1, 2093, 0),
(2928, 1, 2094, 0),
(2929, 1, 2095, 0),
(2930, 1, 2096, 0),
(2932, 1, 2098, 0),
(2933, 1, 2099, 0),
(2934, 1, 2100, 0),
(2935, 1, 2101, 0),
(2936, 1, 2102, 0),
(2978, 1, 2103, 0),
(2979, 1, 2104, 0),
(2980, 1, 2105, 0),
(2981, 1, 2106, 0),
(2982, 1, 2107, 0),
(2983, 1, 2108, 0),
(2984, 1, 2109, 0),
(2985, 1, 2110, 0),
(2986, 1, 2111, 0),
(2987, 1, 2112, 0),
(2988, 1, 2113, 0),
(2989, 1, 2114, 0),
(2990, 1, 2115, 0),
(2991, 1, 2116, 0),
(2992, 1, 2117, 0),
(2993, 1, 2118, 0),
(2994, 1, 2119, 0),
(2995, 1, 2120, 0),
(2996, 1, 2121, 0),
(2997, 1, 2122, 0),
(2998, 1, 2123, 0),
(2999, 1, 2124, 0),
(3000, 1, 2125, 0),
(3001, 1, 2126, 0),
(3002, 1, 2127, 0),
(3003, 1, 2128, 0),
(3004, 1, 2129, 0),
(3005, 1, 2130, 0),
(3006, 1, 2131, 0),
(3007, 1, 2132, 0),
(3008, 1, 2133, 0),
(3009, 1, 2134, 0),
(3010, 1, 2135, 0),
(3011, 1, 2136, 0),
(3012, 1, 2137, 0),
(3014, 1, 2139, 0),
(3015, 1, 2140, 0),
(3016, 1, 2141, 0),
(3017, 1, 2142, 0),
(3018, 1, 2143, 0),
(3060, 1, 2144, 0),
(3061, 1, 2145, 0),
(3062, 1, 2146, 0),
(3063, 1, 2147, 0),
(3064, 1, 2148, 0),
(3065, 1, 2149, 0),
(3066, 1, 2150, 0),
(3067, 1, 2151, 0),
(3068, 1, 2152, 0),
(3069, 1, 2153, 0),
(3070, 1, 2154, 0),
(3071, 1, 2155, 0),
(3072, 1, 2156, 0),
(3073, 1, 2157, 0),
(3075, 1, 2159, 0),
(3076, 1, 2160, 0),
(3077, 1, 2161, 0),
(3078, 1, 2162, 0),
(3079, 1, 2163, 0),
(3121, 1, 2164, 0),
(3122, 1, 2165, 0),
(3123, 1, 2166, 0),
(3124, 1, 2167, 0),
(3125, 1, 2168, 0),
(3126, 1, 2169, 0),
(3127, 1, 2170, 0),
(3128, 1, 2171, 0),
(3129, 1, 2172, 0),
(3130, 1, 2173, 0),
(3131, 1, 2174, 0),
(3132, 1, 2175, 0),
(3133, 1, 2176, 0),
(3134, 1, 2177, 0),
(3135, 1, 2178, 0),
(3136, 1, 2179, 0),
(3137, 1, 2180, 0),
(3138, 1, 2181, 0),
(3139, 1, 2182, 0),
(3140, 1, 2183, 0),
(3141, 1, 2184, 0),
(3142, 1, 2185, 0),
(3143, 1, 2186, 0),
(3144, 1, 2187, 0),
(3145, 1, 2188, 0),
(3146, 1, 2189, 0),
(3147, 1, 2190, 0),
(3148, 1, 2191, 0),
(3149, 1, 2192, 0),
(3150, 1, 2193, 0),
(3151, 1, 2194, 0),
(3152, 1, 2195, 0),
(3153, 1, 2196, 0),
(3154, 1, 2197, 0),
(3155, 1, 2198, 0),
(3157, 1, 2200, 0),
(3158, 1, 2201, 0),
(3159, 1, 2202, 0),
(3160, 1, 2203, 0),
(3161, 1, 2204, 0),
(3203, 1, 2205, 0),
(3204, 1, 2206, 0),
(3205, 1, 2207, 0),
(3206, 1, 2208, 0),
(3207, 1, 2209, 0),
(3208, 1, 2210, 0),
(3209, 1, 2211, 0),
(3210, 1, 2212, 0),
(3211, 1, 2213, 0),
(3212, 1, 2214, 0),
(3213, 1, 2215, 0),
(3214, 1, 2216, 0),
(3215, 1, 2217, 0),
(3216, 1, 2218, 0),
(3217, 1, 2219, 0),
(3218, 1, 2220, 0),
(3219, 1, 2221, 0),
(3220, 1, 2222, 0),
(3221, 1, 2223, 0),
(3222, 1, 2224, 0),
(3223, 1, 2225, 0),
(3224, 1, 2226, 0),
(3225, 1, 2227, 0),
(3226, 1, 2228, 0),
(3227, 1, 2229, 0),
(3228, 1, 2230, 0),
(3229, 1, 2231, 0),
(3230, 1, 2232, 0),
(3231, 1, 2233, 0),
(3232, 1, 2234, 0),
(3233, 1, 2235, 0),
(3234, 1, 2236, 0),
(3235, 1, 2237, 0),
(3236, 1, 2238, 0),
(3237, 1, 2239, 0),
(3239, 1, 2241, 0),
(3240, 1, 2242, 0),
(3241, 1, 2243, 0),
(3242, 1, 2244, 0),
(3243, 1, 2245, 0),
(3285, 1, 2246, 0),
(3286, 1, 2247, 0),
(3287, 1, 2248, 0),
(3288, 1, 2249, 0),
(3289, 1, 2250, 0),
(3290, 1, 2251, 0),
(3291, 1, 2252, 0),
(3292, 1, 2253, 0),
(3293, 1, 2254, 0),
(3294, 1, 2255, 0),
(3295, 1, 2256, 0),
(3296, 1, 2257, 0),
(3297, 1, 2258, 0),
(3298, 1, 2259, 0),
(3299, 1, 2260, 0),
(3300, 1, 2261, 0),
(3301, 1, 2262, 0),
(3302, 1, 2263, 0),
(3303, 1, 2264, 0),
(3304, 1, 2265, 0),
(3305, 1, 2266, 0),
(3306, 1, 2267, 0),
(3307, 1, 2268, 0),
(3308, 1, 2269, 0),
(3309, 1, 2270, 0),
(3310, 1, 2271, 0),
(3311, 1, 2272, 0),
(3312, 1, 2273, 0),
(3313, 1, 2274, 0),
(3314, 1, 2275, 0),
(3315, 1, 2276, 0),
(3316, 1, 2277, 0),
(3317, 1, 2278, 0),
(3318, 1, 2279, 0),
(3319, 1, 2280, 0),
(3321, 1, 2282, 0),
(3322, 1, 2283, 0),
(3323, 1, 2284, 0),
(3324, 1, 2285, 0),
(3325, 1, 2286, 0),
(3326, 1, 2287, 0),
(3327, 1, 2288, 0),
(3328, 1, 2289, 0),
(3329, 1, 2290, 0),
(3330, 1, 2291, 0),
(3331, 1, 2292, 0),
(3332, 1, 2293, 0),
(3333, 1, 2294, 0),
(3334, 1, 2295, 0),
(3335, 1, 2296, 0),
(3336, 1, 2297, 0),
(3337, 1, 2298, 0),
(3338, 1, 2299, 0),
(3339, 1, 2300, 0),
(3340, 1, 2301, 0),
(3341, 1, 2302, 0),
(3342, 1, 2303, 0),
(3343, 1, 2304, 0),
(3344, 1, 2305, 0),
(3345, 1, 2306, 0),
(3346, 4, 2307, 0),
(3347, 4, 2308, 0),
(3348, 4, 2309, 0),
(3349, 4, 2310, 0),
(3350, 4, 2311, 0),
(3351, 4, 2312, 0),
(3352, 4, 2313, 0),
(3353, 4, 2314, 0),
(3354, 4, 2315, 0),
(3355, 4, 2316, 0),
(3356, 4, 2317, 0),
(3357, 4, 2318, 0),
(3358, 4, 2319, 0),
(3359, 4, 2320, 0),
(3360, 4, 2321, 0),
(3361, 4, 2322, 0),
(3362, 4, 2323, 0),
(3363, 4, 2324, 0),
(3364, 4, 2325, 0),
(3365, 4, 2326, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_link_attribute_varchar` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `product_link_attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Link Attribute ID',
  `link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Link Varchar Attribute Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__catalog_product_link_type` (
`link_type_id` smallint(5) unsigned NOT NULL COMMENT 'Link Type ID',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Link Type Table' AUTO_INCREMENT=6 ;

INSERT INTO `#__catalog_product_link_type` (`link_type_id`, `code`) VALUES
(1, 'relation'),
(3, 'super'),
(4, 'up_sell'),
(5, 'cross_sell');

CREATE TABLE IF NOT EXISTS `#__catalog_product_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Option ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `type` varchar(50) DEFAULT NULL COMMENT 'Type',
  `is_require` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Is Required',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `max_characters` int(10) unsigned DEFAULT NULL COMMENT 'Max Characters',
  `file_extension` varchar(50) DEFAULT NULL COMMENT 'File Extension',
  `image_size_x` smallint(5) unsigned DEFAULT NULL COMMENT 'Image Size X',
  `image_size_y` smallint(5) unsigned DEFAULT NULL COMMENT 'Image Size Y',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Table' AUTO_INCREMENT=11 ;

INSERT INTO `#__catalog_product_option` (`option_id`, `product_id`, `type`, `is_require`, `sku`, `max_characters`, `file_extension`, `image_size_x`, `image_size_y`, `sort_order`) VALUES
(1, 48, 'time', 0, NULL, NULL, NULL, NULL, NULL, 10),
(2, 48, 'date_time', 0, NULL, NULL, NULL, NULL, NULL, 9),
(3, 48, 'date', 0, NULL, NULL, NULL, NULL, NULL, 8),
(4, 48, 'multiple', 0, NULL, NULL, NULL, NULL, NULL, 7),
(5, 48, 'checkbox', 0, NULL, NULL, NULL, NULL, NULL, 6),
(6, 48, 'radio', 0, NULL, NULL, NULL, NULL, NULL, 5),
(7, 48, 'drop_down', 0, NULL, NULL, NULL, NULL, NULL, 4),
(8, 48, 'file', 0, NULL, NULL, 'png', 1000, 1000, 3),
(9, 48, 'area', 1, NULL, 0, NULL, NULL, NULL, 2),
(10, 48, 'field', 1, 'custom-options', 0, NULL, NULL, NULL, 1);

CREATE TABLE IF NOT EXISTS `#__catalog_product_option_price` (
`option_price_id` int(10) unsigned NOT NULL COMMENT 'Option Price ID',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Price Table' AUTO_INCREMENT=7 ;

INSERT INTO `#__catalog_product_option_price` (`option_price_id`, `option_id`, `store_id`, `price`, `price_type`) VALUES
(1, 1, 0, '15.0000', 'fixed'),
(2, 2, 0, '10.0000', 'fixed'),
(3, 3, 0, '20.0000', 'fixed'),
(4, 8, 0, '15.0000', 'fixed'),
(5, 9, 0, '214.0000', 'fixed'),
(6, 10, 0, '200.0000', 'percent');

CREATE TABLE IF NOT EXISTS `#__catalog_product_option_title` (
`option_title_id` int(10) unsigned NOT NULL COMMENT 'Option Title ID',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Title Table' AUTO_INCREMENT=11 ;

INSERT INTO `#__catalog_product_option_title` (`option_title_id`, `option_id`, `store_id`, `title`) VALUES
(1, 1, 0, 'Option #10'),
(2, 2, 0, 'Option #9'),
(3, 3, 0, 'Option #8'),
(4, 4, 0, 'Option #7'),
(5, 5, 0, 'Option #6'),
(6, 6, 0, 'Option #5'),
(7, 7, 0, 'Option #4'),
(8, 8, 0, 'Option #3'),
(9, 9, 0, 'Option #2'),
(10, 10, 0, 'Option #1');

CREATE TABLE IF NOT EXISTS `#__catalog_product_option_type_price` (
`option_type_price_id` int(10) unsigned NOT NULL COMMENT 'Option Type Price ID',
  `option_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `price_type` varchar(7) NOT NULL DEFAULT 'fixed' COMMENT 'Price Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Type Price Table' AUTO_INCREMENT=16 ;

INSERT INTO `#__catalog_product_option_type_price` (`option_type_price_id`, `option_type_id`, `store_id`, `price`, `price_type`) VALUES
(1, 1, 0, '5.0000', 'fixed'),
(2, 2, 0, '10.0000', 'fixed'),
(3, 3, 0, '15.0000', 'fixed'),
(4, 4, 0, '20.0000', 'fixed'),
(5, 5, 0, '25.0000', 'fixed'),
(6, 6, 0, '5.0000', 'fixed'),
(7, 7, 0, '10.0000', 'fixed'),
(8, 8, 0, '15.0000', 'fixed'),
(9, 9, 0, '5.0000', 'fixed'),
(10, 10, 0, '10.0000', 'fixed'),
(11, 11, 0, '15.0000', 'fixed'),
(12, 12, 0, '5.0000', 'fixed'),
(13, 13, 0, '10.0000', 'fixed'),
(14, 14, 0, '15.0000', 'fixed'),
(15, 15, 0, '20.0000', 'fixed');

CREATE TABLE IF NOT EXISTS `#__catalog_product_option_type_title` (
`option_type_title_id` int(10) unsigned NOT NULL COMMENT 'Option Type Title ID',
  `option_type_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Type ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Type Title Table' AUTO_INCREMENT=16 ;

INSERT INTO `#__catalog_product_option_type_title` (`option_type_title_id`, `option_type_id`, `store_id`, `title`) VALUES
(1, 1, 0, 'Option #7-1'),
(2, 2, 0, 'Option #7-2'),
(3, 3, 0, 'Option #7-3'),
(4, 4, 0, 'Option #7-4'),
(5, 5, 0, 'Option #7-5'),
(6, 6, 0, 'Option #6-1'),
(7, 7, 0, 'Option #6-2'),
(8, 8, 0, 'Option #6-3'),
(9, 9, 0, 'Option #5-1'),
(10, 10, 0, 'Option #5-2'),
(11, 11, 0, 'Option #5-3'),
(12, 12, 0, 'Option #4-1'),
(13, 13, 0, 'Option #4-2'),
(14, 14, 0, 'Option #4-3'),
(15, 15, 0, 'Option #4-4');

CREATE TABLE IF NOT EXISTS `#__catalog_product_option_type_value` (
`option_type_id` int(10) unsigned NOT NULL COMMENT 'Option Type ID',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option ID',
  `sku` varchar(64) DEFAULT NULL COMMENT 'SKU',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Option Type Value Table' AUTO_INCREMENT=16 ;

INSERT INTO `#__catalog_product_option_type_value` (`option_type_id`, `option_id`, `sku`, `sort_order`) VALUES
(1, 4, NULL, 0),
(2, 4, NULL, 0),
(3, 4, NULL, 0),
(4, 4, NULL, 0),
(5, 4, NULL, 0),
(6, 5, NULL, 0),
(7, 5, NULL, 0),
(8, 5, NULL, 0),
(9, 6, NULL, 0),
(10, 6, NULL, 0),
(11, 6, NULL, 0),
(12, 7, NULL, 0),
(13, 7, NULL, 0),
(14, 7, NULL, 0),
(15, 7, NULL, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_relation` (
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent ID',
  `child_id` int(10) unsigned NOT NULL COMMENT 'Child ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product Relation Table';

INSERT INTO `#__catalog_product_relation` (`parent_id`, `child_id`) VALUES
(7, 8),
(42, 8),
(44, 8),
(45, 8),
(7, 9),
(42, 9),
(44, 9),
(7, 10),
(42, 10),
(44, 10),
(45, 10),
(7, 11),
(42, 11),
(7, 12),
(42, 12),
(13, 14),
(44, 14),
(45, 14),
(13, 15),
(44, 15),
(13, 16),
(44, 16),
(45, 16),
(13, 17),
(13, 18),
(19, 22),
(44, 22),
(45, 22),
(19, 23),
(44, 23),
(45, 23),
(19, 24),
(44, 24),
(45, 24),
(19, 25),
(19, 26),
(20, 27),
(20, 28),
(20, 29),
(20, 30),
(20, 31),
(21, 32),
(21, 33),
(21, 34),
(21, 35),
(21, 36),
(44, 37),
(44, 38),
(45, 38),
(44, 39),
(45, 39);

CREATE TABLE IF NOT EXISTS `#__catalog_product_super_attribute` (
`product_super_attribute_id` int(10) unsigned NOT NULL COMMENT 'Product Super Attribute ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute ID',
  `position` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Position'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Super Attribute Table' AUTO_INCREMENT=11 ;

INSERT INTO `#__catalog_product_super_attribute` (`product_super_attribute_id`, `product_id`, `attribute_id`, `position`) VALUES
(3, 7, 92, 0),
(4, 7, 81, 0),
(5, 13, 92, 0),
(6, 13, 81, 0),
(7, 19, 92, 0),
(8, 19, 81, 0),
(9, 20, 92, 0),
(10, 21, 81, 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_super_attribute_label` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `product_super_attribute_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Super Attribute ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `use_default` smallint(5) unsigned DEFAULT '0' COMMENT 'Use Default Value',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Super Attribute Label Table' AUTO_INCREMENT=11 ;

INSERT INTO `#__catalog_product_super_attribute_label` (`value_id`, `product_super_attribute_id`, `store_id`, `use_default`, `value`) VALUES
(3, 3, 0, 0, 'Color'),
(4, 4, 0, 0, 'Manufacturer'),
(5, 5, 0, 0, 'Color'),
(6, 6, 0, 0, 'Manufacturer'),
(7, 7, 0, 0, 'Color'),
(8, 8, 0, 0, 'Manufacturer'),
(9, 9, 0, 0, 'Color'),
(10, 10, 0, 0, 'Manufacturer');

CREATE TABLE IF NOT EXISTS `#__catalog_product_super_attribute_pricing` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value ID',
  `product_super_attribute_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Super Attribute ID',
  `value_index` varchar(255) DEFAULT NULL COMMENT 'Value Index',
  `is_percent` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Percent',
  `pricing_value` decimal(12,4) DEFAULT NULL COMMENT 'Pricing Value',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Super Attribute Pricing Table' AUTO_INCREMENT=36 ;

INSERT INTO `#__catalog_product_super_attribute_pricing` (`value_id`, `product_super_attribute_id`, `value_index`, `is_percent`, `pricing_value`, `website_id`) VALUES
(6, 4, '10', 0, '10.0000', 0),
(8, 3, '4', 1, '10.0000', 0),
(9, 3, '5', 0, '15.0000', 0),
(10, 3, '8', 0, '5.0000', 0),
(11, 3, '6', 0, '20.0000', 0),
(12, 6, '15', 1, '5.0000', 0),
(13, 6, '12', 1, '3.0000', 0),
(14, 6, '13', 1, '1.0000', 0),
(15, 5, '3', 1, '2.0000', 0),
(16, 5, '6', 1, '4.0000', 0),
(17, 5, '5', 0, '15.0000', 0),
(19, 8, '11', 0, '3.0000', 0),
(20, 8, '16', 1, '5.0000', 0),
(22, 7, '3', 0, '4.0000', 0),
(23, 7, '4', 1, '6.0000', 0),
(24, 7, '6', 0, '10.0000', 0),
(25, 7, '5', 0, '15.0000', 0),
(26, 9, '3', 1, '2.0000', 0),
(27, 9, '8', 1, '2.0000', 0),
(28, 9, '5', 1, '2.0000', 0),
(29, 9, '6', 1, '2.0000', 0),
(30, 9, '4', 0, '10.0000', 0),
(31, 10, '10', 0, '10.0000', 0),
(32, 10, '9', 0, '20.0000', 0),
(33, 10, '15', 0, '30.0000', 0),
(34, 10, '14', 0, '10.0000', 0),
(35, 10, '16', 0, '15.0000', 0);

CREATE TABLE IF NOT EXISTS `#__catalog_product_super_link` (
`link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Parent ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Catalog Product Super Link Table' AUTO_INCREMENT=30 ;

INSERT INTO `#__catalog_product_super_link` (`link_id`, `product_id`, `parent_id`) VALUES
(5, 8, 7),
(6, 9, 7),
(7, 10, 7),
(8, 11, 7),
(9, 12, 7),
(10, 14, 13),
(11, 15, 13),
(12, 16, 13),
(13, 17, 13),
(14, 18, 13),
(15, 22, 19),
(16, 23, 19),
(17, 24, 19),
(18, 25, 19),
(19, 26, 19),
(20, 27, 20),
(21, 28, 20),
(22, 29, 20),
(23, 30, 20),
(24, 31, 20),
(25, 32, 21),
(26, 33, 21),
(27, 34, 21),
(28, 35, 21),
(29, 36, 21);

CREATE TABLE IF NOT EXISTS `#__catalog_product_website` (
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product ID',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Catalog Product To Website Linkage Table';

INSERT INTO `#__catalog_product_website` (`product_id`, `website_id`) VALUES
(7, 1),
(8, 1),
(9, 1),
(10, 1),
(11, 1),
(12, 1),
(13, 1),
(14, 1),
(15, 1),
(16, 1),
(17, 1),
(18, 1),
(19, 1),
(20, 1),
(21, 1),
(22, 1),
(23, 1),
(24, 1),
(25, 1),
(26, 1),
(27, 1),
(28, 1),
(29, 1),
(30, 1),
(31, 1),
(32, 1),
(33, 1),
(34, 1),
(35, 1),
(36, 1),
(37, 1),
(38, 1),
(39, 1),
(40, 1),
(41, 1),
(42, 1),
(44, 1),
(45, 1),
(46, 1),
(47, 1),
(48, 1),
(49, 1);

CREATE TABLE IF NOT EXISTS `#__checkout_agreement` (
`agreement_id` int(10) unsigned NOT NULL COMMENT 'Agreement Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `content` text COMMENT 'Content',
  `content_height` varchar(25) DEFAULT NULL COMMENT 'Content Height',
  `checkbox_text` text COMMENT 'Checkbox Text',
  `is_active` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `is_html` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is Html'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Checkout Agreement' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__checkout_agreement_store` (
  `agreement_id` int(10) unsigned NOT NULL COMMENT 'Agreement Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Checkout Agreement Store';

CREATE TABLE IF NOT EXISTS `#__cms_block` (
`block_id` smallint(6) NOT NULL COMMENT 'Block ID',
  `title` varchar(255) NOT NULL COMMENT 'Block Title',
  `identifier` varchar(255) NOT NULL COMMENT 'Block String Identifier',
  `content` mediumtext COMMENT 'Block Content',
  `creation_time` timestamp NULL DEFAULT NULL COMMENT 'Block Creation Time',
  `update_time` timestamp NULL DEFAULT NULL COMMENT 'Block Modification Time',
  `is_active` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Is Block Active'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='CMS Block Table' AUTO_INCREMENT=65 ;

INSERT INTO `#__cms_block` (`block_id`, `title`, `identifier`, `content`, `creation_time`, `update_time`, `is_active`) VALUES
(1, 'Footer Links', 'footer_links', '\n<ul>\n    <li><a href="{{store direct_url="about-magento-demo-store"}}">About Us</a></li>\n    <li><a href="{{store direct_url="customer-service"}}">Customer Service</a></li>\n<li class="last privacy"><a href="{{store direct_url="privacy-policy-cookie-restriction-mode"}}">Privacy Policy</a></li>\r\n</ul>', '2014-12-03 00:00:13', '2014-12-03 00:00:13', 1),
(2, 'Footer Links Company', 'footer_links_company', '\n<div class="links">\n    <div class="block-title">\n        <strong><span>Company</span></strong>\n    </div>\n    <ul>\n        <li><a href="{{store url=""}}about-magento-demo-store/">About Us</a></li>\n        <li><a href="{{store url=""}}contacts/">Contact Us</a></li>\n        <li><a href="{{store url=""}}customer-service/">Customer Service</a></li>\n        <li><a href="{{store url=""}}privacy-policy-cookie-restriction-mode/">Privacy Policy</a></li>\n    </ul>\n</div>', '2014-12-03 00:00:13', '2014-12-03 00:00:13', 1),
(3, 'Cookie restriction notice', 'cookie_restriction_notice_block', '<p>This website requires cookies to provide all of its features. For more information on what data is contained in the cookies, please see our <a href="{{store direct_url="privacy-policy-cookie-restriction-mode"}}">Privacy Policy page</a>. To accept cookies from this site, please click the Allow button below.</p>', '2014-12-03 00:00:13', '2014-12-03 00:00:13', 1),
(4, 'Connect us and Payment methods', 'amoda_payment', '<ul class="payment">\r\n<li><a title="Discover" href="#" data-original-title="Discover" data-toggle="tooltip"><i class="fa fa-cc-discover">&nbsp;</i></a></li>\r\n<li><a title="Mastercard" href="#" data-original-title="Mastercard" data-toggle="tooltip"><i class="fa fa-cc-mastercard">&nbsp;</i></a></li>\r\n<li><a title="Paypal" href="#" data-original-title="Paypal" data-toggle="tooltip"><i class="fa fa-cc-paypal">&nbsp;</i></a></li>\r\n<li><a title="Stripe" href="#" data-original-title="Stripe" data-toggle="tooltip"><i class="fa fa-cc-stripe">&nbsp;</i></a></li>\r\n<li><a title="Visa" href="#" data-original-title="Visa" data-toggle="tooltip"><i class="fa fa-cc-visa">&nbsp;</i></a></li>\r\n</ul>', '2014-12-03 01:39:48', '2015-05-04 02:20:03', 1),
(5, 'Banner category''s', 'amoda_banner_cat', '<div class="block"><a class="banner1" href="#"><img alt="" src="{{media url="wysiwyg/amoda/banner_left.jpg"}}" /></a></div>', '2014-12-03 01:39:49', '2015-01-16 00:23:46', 1),
(7, 'Our Offers', 'amoda_footer_middle1', '<h6>Our Offers</h6>\r\n<ul>\r\n<li><a href="#">Delivery</a></li>\r\n<li><a href="#">Service</a></li>\r\n<li><a href="#">Gift Cards</a></li>\r\n<li><a href="#">Manufacturers</a></li>\r\n<li><a href="{{store direct_url="contacts"}}">Contacts</a></li>\r\n</ul>', '2014-12-03 01:39:49', '2015-04-27 02:18:39', 1),
(8, 'Shipping Info', 'amoda_footer_middle2', '<h6>Shipping Info</h6>\r\n<ul>\r\n<li><a href="#">New products</a></li>\r\n<li><a href="#">Top sellers</a></li>\r\n<li><a href="#">Manufactirers</a></li>\r\n<li><a href="#">Suppliers</a></li>\r\n<li><a href="#">Specials</a></li>\r\n</ul>', '2014-12-03 01:39:49', '2015-04-27 02:21:22', 1),
(9, 'Our Account', 'amoda_footer_middle3', '<h6>Our Account</h6>\r\n<ul>\r\n<li><a href="#">Recalls</a></li>\r\n<li><a href="{{store direct_url="customer/account"}}">My Account</a></li>\r\n<li><a href="{{store direct_url="sales/guest/form"}}">Orders and Returns</a></li>\r\n<li><a href="{{store direct_url="catalog/seo_sitemap/category"}}">Site Map</a></li>\r\n<li><a href="{{store direct_url="catalogsearch/term/popular"}}">Search Terms</a></li>\r\n</ul>', '2014-12-03 01:39:49', '2015-04-27 02:22:07', 1),
(10, 'Informations', 'amoda_footer_middle4', '<h6>Informations</h6>\n<ul>\n	<li><a href="#">Recalls</a></li>\n	<li><a href="#">Return Policy</a></li>\n<li><a href="{{store direct_url="about-magento-demo-store"}}">About Us</a></li>\n<li><a href="{{store direct_url="contacts"}}">Contact Us</a></li>\n<li><a href="{{store direct_url="customer-service"}}">Customer Service</a></li>\n<li><a href="{{store direct_url="privacy-policy-cookie-restriction-mode"}}">Privacy Policy</a></li>\n<li><a href="{{store direct_url="blog"}}">Blogs</a></li>\n</ul>', '2014-12-03 01:39:49', '2014-12-03 01:39:49', 1),
(12, 'Custom Block', 'amoda_custom_block', '<p class="text-center"><img src="{{media url="wysiwyg/amoda/logo.png"}}" alt="" /></p>\n<p style="padding: 0px 7%;"><em>ÃƒÂ¢Ã¢â€šÂ¬Ã…â€œ Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry''s standard dummy text ever since the when an unknown printer took a galley of type. ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â</em></p>', '2014-12-03 01:39:50', '2014-12-03 01:39:50', 1),
(13, 'Banner 2', 'amoda_banner2', '<div class="amoda_banner2 mrb40">\r\n<div class="row">\r\n<div class="col-md-3 col-xs-6 col-phone-12"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-2.jpg"}}" /></a></div>\r\n<div class="col-md-3 col-xs-6 col-phone-12 pull-right"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-4.jpg"}}" /></a></div>\r\n<div class="col-md-6 col-xs-12 col-phone-12"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-3.jpg"}}" /></a></div>\r\n</div>\r\n</div>', '2014-12-03 01:39:50', '2015-06-30 20:54:00', 1),
(16, 'Sticky Custom', 'amoda_sticky_custom', '<p><img style="margin-top: 5px;" src="http://placehold.it/240x180" alt="" /></p>\n<p>Retra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', '2014-12-03 01:39:50', '2014-12-03 01:39:50', 1),
(18, 'Banner detail', 'amoda_banner_detail', '<div class="banner-details"><a class="banner2" href="#"><img alt="" src="{{media url="wysiwyg/amoda/banner-details.jpg"}}" /></a></div>', '2014-12-03 01:39:51', '2015-01-16 01:55:28', 1),
(38, 'Amoda  policy shop', 'amoda_policy', '<ul class="ca-menu">\r\n<li>\r\n<i class="fa fa-plane"></i>\r\n<div class="ca-content">\r\n<h2>Free Shipping</h2>\r\n<h3>On order over $100.00</h3>\r\n</div>\r\n</li>\r\n<li>\r\n<i class="fa fa-rotate-right"></i>\r\n<div class="ca-content">\r\n<h2>30 DAYS MONEY BACK</h2>\r\n<h3>For member</h3>\r\n</div>\r\n</li>\r\n<li>\r\n<i class="fa fa-lock"></i>\r\n<div class="ca-content">\r\n<h2>PAYMENT SECURED</h2>\r\n<h3>For member</h3>\r\n</div>\r\n</li>\r\n</ul>', '2014-12-27 03:17:58', '2014-12-28 20:19:32', 1),
(39, 'Banner 1', 'amoda_banner1', '<div class="banner-home-top mrb30"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-1.jpg"}}" /></a></div>', '2015-01-07 02:26:43', '2015-05-18 00:48:46', 1),
(40, 'Amoda  slideshow 2', 'amoda_slide_html2', '<div class="slideshow1 v3">\r\n    <img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow1_v2.jpg''}}" data-u="image" />\r\n    <div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Sale off 30%</div>\r\n    <div data-u="caption" data-t="CLIP|LR" data-t2="B" data-du="800" data-d="-300" class="captionOrange item3" >Lorem Ipsum has been the industry''s standard dummy text ever sine 1500s, Lorem Ipsum is simply dummy text of the. </div>\r\n    <div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-01-08 21:53:37', '2015-05-14 21:38:17', 1),
(41, 'Amoda  slideshow 3', 'amoda_slide_html3', '<div class="slideshow1 v3">\r\n    <img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow1_v3.jpg''}}" data-u="image" />\r\n    <div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Collection 2015</div>\r\n    <div class="item1 v1" style="top: 240px;" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-01-08 23:58:24', '2015-05-14 21:51:10', 1),
(42, 'Amoda  slideshow 1', 'amoda_slide_html1', '<div class="slideshow1 v2">\r\n    <img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow1_v1.jpg''}}" data-u="image" />\r\n    <div class="captionOrange item3" data-d="-300" data-du="600" data-t2="B" data-t="CLIP|LR" data-u="caption">Old style</div>\r\n    <div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Beautifull Nostagic</div>\r\n    <div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="RTT|360" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-01-09 01:00:56', '2015-05-14 01:54:44', 1),
(43, 'Amoda banner', 'amoda_banner', '<div class="row">\r\n<div class="col-sm-6 col-xs-12"><a class="banner2" href="#"><img alt="" src="{{media url="wysiwyg/amoda/bb_06.jpg"}}" /></a></div>\r\n<div class="col-sm-6 col-xs-12"><a class="banner2" href="#"><img alt="" src="{{media url="wysiwyg/amoda/bb_08.jpg"}}" /></a></div>\r\n</div>', '2015-01-09 01:59:16', '2015-01-15 19:50:00', 1),
(44, 'Amoda Drop menu', 'amoda_block_drop_menu', '<div class="row">\r\n    <div class="col-sm-2">\r\n        <h4 class="title">Clother</h4>\r\n         <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Cosmetic </h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Brand</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Cosmetic </h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Cosmetic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Clother</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Electronic</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n	<div class="col-sm-2">\r\n        <h4 class="title">Kid fashion</h4>\r\n        <ul class="menu">\r\n            <li>\r\n                <a href="#">\r\n                    <span>Clother</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Fashion</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                 <span>Shoes</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>Mixing Bowls</span>\r\n                </a>\r\n            </li>\r\n            <li>\r\n                <a href="#">\r\n                    <span>View all</span>\r\n                </a>\r\n            </li>\r\n        </ul>\r\n    </div>\r\n</div>', '2015-01-11 21:56:31', '2015-01-11 22:07:12', 1),
(45, 'amoda time work', 'amoda_time_work', '<p class="time-work">Time work: <i>Mon - Sat (7am - 5:30 pm)</i></p>', '2015-04-27 20:41:25', '2015-05-04 01:18:12', 1),
(46, 'amoda logo footer', 'amoda_logo_footer', '<p><a href="#"><img alt="" src="{{media url=''wysiwyg/amoda/logo.png''}}" /></a></p>\r\n<p class="content">Lorem Ipsum is simyp. Lorem Ipsum has been the industry''s standard dummy text ever since.Lorem Ipsum is simyp. Lorem Ipsum has been the industry''s standard dummy text ever since. Lorem Ipsum has been the industry''s standard dummy text ever since.Lorem Ipsum is simyp.</p>', '2015-04-29 00:20:13', '2015-06-29 20:55:00', 1),
(47, 'amoda policy footer', 'amoda_policy_footer', '<div class="sns_footer_policy">\r\n<div class="container ">\r\n<div class="container_in">\r\n<div class="row">\r\n<div class="col-md-3 col-xs-6 col-phone-12">\r\n<div class="policy_custom">\r\n<div class="policy-icon"><em class="fa fa-truck">&nbsp;</em></div>\r\n<p class="policy-titile">Free Shipping</p>\r\n<p class="policy-ct">Lorem Ipsum has been.</p>\r\n</div>\r\n</div>\r\n<div class="col-md-3 col-xs-6  col-phone-12 ">\r\n<div class="policy_custom">\r\n<div class="policy-icon"><em class="fa fa-money">&nbsp;</em></div>\r\n<p class="policy-titile">Money back</p>\r\n<p class="policy-ct">Lorem Ipsum has been.</p>\r\n</div>\r\n</div>\r\n<div class="col-md-3 col-xs-6 col-phone-12">\r\n<div class="policy_custom">\r\n<div class="policy-icon"><em class="fa fa-support">&nbsp;</em></div>\r\n<p class="policy-titile">Support 24/7</p>\r\n<p class="policy-ct">Lorem Ipsum has been.</p>\r\n</div>\r\n</div>\r\n<div class="col-md-3 col-xs-6 col-phone-12">\r\n<div class="policy_custom">\r\n<div class="policy-icon"><em class="fa fa-retweet">&nbsp;</em></div>\r\n<p class="policy-titile">Return in 30 day</p>\r\n<p class="policy-ct">Lorem Ipsum has been.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>', '2015-05-04 19:53:02', '2015-06-29 20:42:07', 1),
(48, 'amoda banner3', 'amoda_banner3', '<div class="banner-home-top mrb0"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-5.jpg"}}" /></a></div>', '2015-05-10 21:23:24', '2015-06-29 03:16:59', 1),
(49, 'amoda slide2 html1', 'amoda_slide2_html1', '<div class="slideshow1 v2"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow2_v1.jpg''}}" data-u="image" />\r\n<div class="captionOrange item3" data-d="-300" data-du="600" data-t2="B" data-t="CLIP|LR" data-u="caption">Old style</div>\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Beautifull Nostagic</div>\r\n<div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="RTT|360" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-15 02:36:39', '2015-05-25 23:49:38', 1),
(50, 'amoda slide2 html2', 'amoda_slide2_html2', '<div class="slideshow1 v3"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow2_v2.jpg''}}" data-u="image" />\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Sale off 30%</div>\r\n<div class="captionOrange item3" data-u="caption" data-t="CLIP|LR" data-t2="B" data-du="800" data-d="-300">Lorem Ipsum has been the industry''s standard dummy text ever sine 1500s, Lorem Ipsum is simply dummy text of the.</div>\r\n<div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-15 02:37:36', '2015-05-25 23:50:41', 1),
(51, 'amoda slide2 html3', 'amoda_slide2_html3', '<div class="slideshow1 v3"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow2_v3.jpg''}}" data-u="image" />\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Collection 2015</div>\r\n<div class="item1 v1" style="top: 240px;" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-15 02:38:19', '2015-05-25 23:53:43', 1),
(52, 'amoda slide3 html1', 'amoda_slide3_html1', '<div class="slideshow2 v2"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow3_v1.jpg''}}" data-u="image" />\r\n<div class="captionOrange item3" data-d="-300" data-du="600" data-t2="B" data-t="CLIP|LR" data-u="caption">Old style</div>\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Beautifull Nostagic</div>\r\n<div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="RTT|360" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-15 21:01:53', '2015-05-16 01:01:28', 1),
(53, 'amoda slide3 html2', 'amoda_slide3_html2', '<div class="slideshow2 v3"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow3_v2.jpg''}}" data-u="image" />\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Sale off 30%</div>\r\n<div class="captionOrange item3" data-u="caption" data-t="CLIP|LR" data-t2="B" data-du="800" data-d="-300">Lorem Ipsum has been the industry''s standard dummy text ever sine 1500s, Lorem Ipsum is simply dummy text of the.</div>\r\n<div class="item1 v1" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-16 00:02:44', '2015-05-16 01:01:36', 1),
(54, 'amoda slide3 html3', 'amoda_slide3_html3', '<div class="slideshow2 v3"><img alt="" src="{{media url=''wysiwyg/amoda/slideshow/slideshow3_v3.jpg''}}" data-u="image" />\r\n<div class="captionOrange item2" data-d="-50" data-du="800" data-t2="T" data-t="T|IB" data-u="caption">Collection 2015</div>\r\n<div class="item1 v1" style="top: 240px;" data-t2="NO" data-du="1500" data-d="-50" data-t="R|IB" data-u="caption"><a class="submit" href="#">Read more</a></div>\r\n</div>', '2015-05-16 00:03:57', '2015-05-16 01:01:45', 1),
(55, 'Banner v3 1', 'amodav3_banner1', '<div class="banner-home-top mrb45"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-v3-1.jpg"}}" /></a></div>', '2015-05-16 02:50:42', '2015-07-01 00:28:42', 1),
(56, 'Banner v3 2', 'amoda_bannerv3_2', '<div class="amoda_banner2 mrb30">\r\n<div class="row">\r\n<div class="col-md-4 col-xs-4 col-phone-12 pull-rigt"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-2.jpg"}}" /></a></div>\r\n<div class="col-md-8 col-xs-8 col-phone-12"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static-block-3.jpg"}}" /></a></div>\r\n</div>\r\n</div>', '2015-05-18 00:18:07', '2015-05-18 00:18:07', 1),
(57, 'amoda bannerv3 4', 'amoda_bannerv3_4', '<div class="amoda_banner2 mrb40">\r\n<div class="row">\r\n<div class="col-md-6 col-xs-6 col-phone-12"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/statickv3_1.jpg"}}" /></a></div>\r\n<div class="col-md-6 col-xs-6 col-phone-12"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/statickv3_2.jpg"}}" /></a></div>\r\n</div>\r\n</div>', '2015-05-18 00:24:22', '2015-07-01 00:46:09', 1),
(58, 'Amoda - menu html Featured', 'amoda_menu_featured', '<ul>\r\n<li><a href="{{store direct_url="accessories/product-types.html"}}">Product Type</a></li>\r\n<li><a href="{{store direct_url="men.html"}}">Listing Page</a></li>\r\n<li><a href="{{store direct_url="accessories-15/configurable-product-04-red.html"}}">Detail Product</a></li>\r\n<li><a href="{{store direct_url="page404"}}">Page 404</a></li>\r\n</ul>', '2015-05-29 01:45:21', '2015-06-12 02:12:14', 1),
(59, 'amoda - Slidercategory 1', 'amoda_slidercat1', '<ul>\r\n    <li><a href="#">Iphone plus 65GB(new)</a></li>\r\n    <li><a href="#">Nokia lumia 525</a></li>\r\n    <li><a href="#">Canon G10 sale 20%</a></li>\r\n    <li><a href="#">TV Led bravia 6879</a></li>\r\n    <li><a href="#">Light city 720 500v</a></li>\r\n</ul>', '2015-06-15 02:47:35', '2015-06-15 02:47:35', 1),
(60, 'amoda - Slidercategory 2', 'amoda_slidercat2', '<ul>\r\n<li><a href="#">Iphone plus 64GB(new)</a></li>\r\n<li><a href="#">Nokia lumia 520</a></li>\r\n<li><a href="#">Canon G10 sale 20%</a></li>\r\n<li><a href="#">TV Led bravia 6879</a></li>\r\n<li><a href="#">Light city 720 500v</a></li>\r\n</ul>', '2015-06-15 03:06:59', '2015-06-15 03:07:41', 1),
(61, 'amoda - Slidercategory 3', 'amoda_slidercat3', '<ul>\r\n<li><a href="#">Iphone 6 plus 65GB(new)</a></li>\r\n<li><a href="#">Nokia lumia 630</a></li>\r\n<li><a href="#">Canon G12 sale 20%</a></li>\r\n<li><a href="#">TV Led bravia 1234</a></li>\r\n<li><a href="#">Light city 720 1000v</a></li>\r\n</ul>', '2015-06-15 03:17:06', '2015-06-15 03:17:06', 1),
(62, 'amoda - Slidercategory 4', 'amoda_slidercat4', '<ul>\r\n<li><a href="#">Iphone plus 65GB(new)</a></li>\r\n<li><a href="#">Nokia lumia 525</a></li>\r\n<li><a href="#">Canon G10 sale 20%</a></li>\r\n<li><a href="#">TV Led bravia 6879</a></li>\r\n<li><a href="#">Light city 720 500v</a></li>\r\n</ul>', '2015-06-15 03:17:53', '2015-06-15 03:17:53', 1),
(63, 'amoda - Slidercategory 5', 'amoda_slidercat5', '<ul>\r\n<li><a href="#">Iphone plus 65GB(new)</a></li>\r\n<li><a href="#">Nokia lumia 525</a></li>\r\n<li><a href="#">Canon G10 sale 20%</a></li>\r\n<li><a href="#">TV Led bravia 6879</a></li>\r\n<li><a href="#">Light city 720 500v</a></li>\r\n</ul>', '2015-06-15 03:18:41', '2015-06-15 03:18:41', 1),
(64, 'amoda banner3 v3', 'amoda_banner3_v3', '<div class="banner-home-top mrb40"><a class="banner3" href="#"><img alt="" src="{{media url="wysiwyg/amoda/static_banner3_v3.jpg"}}" /></a></div>', '2015-06-30 00:28:16', '2015-07-01 00:43:04', 1);

CREATE TABLE IF NOT EXISTS `#__cms_block_store` (
  `block_id` smallint(6) NOT NULL COMMENT 'Block ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CMS Block To Store Linkage Table';

INSERT INTO `#__cms_block_store` (`block_id`, `store_id`) VALUES
(1, 0),
(2, 0),
(3, 0),
(4, 0),
(5, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(16, 0),
(18, 0),
(38, 0),
(39, 0),
(40, 0),
(41, 0),
(42, 0),
(43, 0),
(44, 0),
(45, 0),
(46, 0),
(47, 0),
(48, 0),
(55, 0),
(56, 0),
(58, 0),
(59, 0),
(60, 0),
(61, 0),
(62, 0),
(63, 0),
(49, 2),
(50, 2),
(51, 3),
(52, 3),
(53, 3),
(54, 3),
(57, 3),
(64, 3),
(49, 4),
(50, 4),
(51, 4);

CREATE TABLE IF NOT EXISTS `#__cms_page` (
`page_id` smallint(6) NOT NULL COMMENT 'Page ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Page Title',
  `root_template` varchar(255) DEFAULT NULL COMMENT 'Page Template',
  `meta_keywords` text COMMENT 'Page Meta Keywords',
  `meta_description` text COMMENT 'Page Meta Description',
  `identifier` varchar(100) DEFAULT NULL COMMENT 'Page String Identifier',
  `content_heading` varchar(255) DEFAULT NULL COMMENT 'Page Content Heading',
  `content` mediumtext COMMENT 'Page Content',
  `creation_time` timestamp NULL DEFAULT NULL COMMENT 'Page Creation Time',
  `update_time` timestamp NULL DEFAULT NULL COMMENT 'Page Modification Time',
  `is_active` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Is Page Active',
  `sort_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Page Sort Order',
  `layout_update_xml` text COMMENT 'Page Layout Update Content',
  `custom_theme` varchar(100) DEFAULT NULL COMMENT 'Page Custom Theme',
  `custom_root_template` varchar(255) DEFAULT NULL COMMENT 'Page Custom Template',
  `custom_layout_update_xml` text COMMENT 'Page Custom Layout Update Content',
  `custom_theme_from` date DEFAULT NULL COMMENT 'Page Custom Theme Active From Date',
  `custom_theme_to` date DEFAULT NULL COMMENT 'Page Custom Theme Active To Date'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='CMS Page Table' AUTO_INCREMENT=11 ;

INSERT INTO `#__cms_page` (`page_id`, `title`, `root_template`, `meta_keywords`, `meta_description`, `identifier`, `content_heading`, `content`, `creation_time`, `update_time`, `is_active`, `sort_order`, `layout_update_xml`, `custom_theme`, `custom_root_template`, `custom_layout_update_xml`, `custom_theme_from`, `custom_theme_to`) VALUES
(1, '404 Not Found 1', 'one_column', 'Page keywords', 'Page description', 'no-route', NULL, '<div class="page-title">\r\n<h1>Whoops, our bad...</h1>\r\n</div>\r\n<dl><dt>The page you requested was not found, and we have a fine guess why.</dt><dd>\r\n<ul class="disc">\r\n<li>If you typed the URL directly, please make sure the spelling is correct.</li>\r\n<li>If you clicked on a link to get here, the link is outdated.</li>\r\n</ul>\r\n</dd></dl><dl><dt>What can you do?</dt><dd>Have no fear, help is near! There are many ways you can get back on track with Magento Store.</dd><dd>\r\n<ul class="disc">\r\n<li><a onclick="history.go(-1); return false;" href="#">Go back</a> to the previous page.</li>\r\n<li>Use the search bar at the top of the page to search for your products.</li>\r\n<li>Follow these links to get you back on track!<br /><a href="{{store url=""}}">Store Home</a> <span class="separator">|</span> <a href="{{store url="customer/account"}}">My Account</a></li>\r\n</ul>\r\n</dd></dl>', '2014-12-03 00:00:13', '2015-05-28 20:43:50', 1, 0, NULL, NULL, NULL, NULL, NULL, NULL),
(2, 'Home page', 'two_columns_right', NULL, NULL, 'home', NULL, '<div class="page-title"><h2>Home Page</h2></div>', '2014-12-03 00:00:13', '2014-12-03 00:00:19', 1, 0, '<!--<reference name="content">\n        <block type="catalog/product_new" name="home.catalog.product.new" alias="product_new" template="catalog/product/new.phtml" after="cms_page">\n            <action method="addPriceBlockType">\n                <type>bundle</type>\n                <block>bundle/catalog_product_price</block>\n                <template>bundle/catalog/product/price.phtml</template>\n            </action>\n        </block>\n        <block type="reports/product_viewed" name="home.reports.product.viewed" alias="product_viewed" template="reports/home_product_viewed.phtml" after="product_new">\n            <action method="addPriceBlockType">\n                <type>bundle</type>\n                <block>bundle/catalog_product_price</block>\n                <template>bundle/catalog/product/price.phtml</template>\n            </action>\n        </block>\n        <block type="reports/product_compared" name="home.reports.product.compared" template="reports/home_product_compared.phtml" after="product_viewed">\n            <action method="addPriceBlockType">\n                <type>bundle</type>\n                <block>bundle/catalog_product_price</block>\n                <template>bundle/catalog/product/price.phtml</template>\n            </action>\n        </block>\n    </reference>\n    <reference name="right">\n        <action method="unsetChild"><alias>right.reports.product.viewed</alias></action>\n        <action method="unsetChild"><alias>right.reports.product.compared</alias></action>\n    </reference>-->', NULL, NULL, NULL, NULL, NULL),
(3, 'About Us', 'one_column', NULL, NULL, 'about-magento-demo-store', NULL, '<div class="page-title">\r\n<h1>About Magento Store</h1>\r\n</div>\r\n<div class="col3-set">\r\n<div class="col-1">\r\n<p style="line-height: 1.2em;"><small>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede.</small></p>\r\n<p style="color: #888; font: 1.2em/1.4em georgia, serif;">Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta.</p>\r\n</div>\r\n<div class="col-2">\r\n<p><strong style="color: #de036f;">Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit.</strong></p>\r\n<p>Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</p>\r\n<p>Maecenas ullamcorper, odio vel tempus egestas, dui orci faucibus orci, sit amet aliquet lectus dolor et quam. Pellentesque consequat luctus purus. Nunc et risus. Etiam a nibh. Phasellus dignissim metus eget nisi. Vestibulum sapien dolor, aliquet nec, porta ac, malesuada a, libero. Praesent feugiat purus eget est. Nulla facilisi. Vestibulum tincidunt sapien eu velit. Mauris purus. Maecenas eget mauris eu orci accumsan feugiat. Pellentesque eget velit. Nunc tincidunt.</p>\r\n</div>\r\n<div class="col-3">\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper</p>\r\n<p><strong style="color: #de036f;">Maecenas ullamcorper, odio vel tempus egestas, dui orci faucibus orci, sit amet aliquet lectus dolor et quam. Pellentesque consequat luctus purus.</strong></p>\r\n<p>Nunc et risus. Etiam a nibh. Phasellus dignissim metus eget nisi.</p>\r\n<div class="divider">&nbsp;</div>\r\n<p>To all of you, from all of us at Magento Store - Thank you and Happy eCommerce!</p>\r\n<p style="line-height: 1.2em;"><strong style="font: italic 2em Georgia, serif;">John Doe</strong><br /> <small>Some important guy</small></p>\r\n</div>\r\n</div>', '2014-12-03 00:00:13', '2015-01-19 01:41:56', 1, 0, NULL, NULL, NULL, NULL, NULL, NULL),
(4, 'Customer Service', 'one_column', NULL, NULL, 'customer-service', NULL, '<div class="page-title">\r\n<h1>Customer Service</h1>\r\n</div>\r\n<ul class="disc">\r\n<li><a href="#answer1">Shipping &amp; Delivery</a></li>\r\n<li><a href="#answer2">Privacy &amp; Security</a></li>\r\n<li><a href="#answer3">Returns &amp; Replacements</a></li>\r\n<li><a href="#answer4">Ordering</a></li>\r\n<li><a href="#answer5">Payment, Pricing &amp; Promotions</a></li>\r\n<li><a href="#answer6">Viewing Orders</a></li>\r\n<li><a href="#answer7">Updating Account Information</a></li>\r\n</ul>\r\n<dl><dt id="answer1">Shipping &amp; Delivery</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer2">Privacy &amp; Security</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer3">Returns &amp; Replacements</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer4">Ordering</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer5">Payment, Pricing &amp; Promotions</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer6">Viewing Orders</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd><dt id="answer7">Updating Account Information</dt><dd>Lorem ipsum dolor sit amet, consectetuer adipiscing elit. Morbi luctus. Duis lobortis. Nulla nec velit. Mauris pulvinar erat non massa. Suspendisse tortor turpis, porta nec, tempus vitae, iaculis semper, pede. Cras vel libero id lectus rhoncus porta. Suspendisse convallis felis ac enim. Vivamus tortor nisl, lobortis in, faucibus et, tempus at, dui. Nunc risus. Proin scelerisque augue. Nam ullamcorper. Phasellus id massa. Pellentesque nisl. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Nunc augue. Aenean sed justo non leo vehicula laoreet. Praesent ipsum libero, auctor ac, tempus nec, tempor nec, justo.</dd></dl>', '2014-12-03 00:00:13', '2015-01-19 01:44:02', 1, 0, NULL, NULL, NULL, NULL, NULL, NULL),
(5, 'Enable Cookies', 'one_column', NULL, NULL, 'enable-cookies', NULL, '<div class="std">\n    <ul class="messages">\n        <li class="notice-msg">\n            <ul>\n                <li>Please enable cookies in your web browser to continue.</li>\n            </ul>\n        </li>\n    </ul>\n    <div class="page-title">\n        <h1><a name="top"></a>What are Cookies?</h1>\n    </div>\n    <p>Cookies are short pieces of data that are sent to your computer when you visit a website.\n    On later visits, this data is then returned to that website. Cookies allow us to recognize you automatically\n    whenever you visit our site so that we can personalize your experience and provide you with better service.\n    We also use cookies (and similar browser data, such as Flash cookies) for fraud prevention and other purposes.\n     If your web browser is set to refuse cookies from our website, you will not be able to complete a purchase\n     or take advantage of certain features of our website, such as storing items in your Shopping Cart or\n     receiving personalized recommendations. As a result, we strongly encourage you to configure your web\n     browser to accept cookies from our website.</p>\n    <h2 class="subtitle">Enabling Cookies</h2>\n    <ul class="disc">\n        <li><a href="#ie7">Internet Explorer 7.x</a></li>\n        <li><a href="#ie6">Internet Explorer 6.x</a></li>\n        <li><a href="#firefox">Mozilla/Firefox</a></li>\n        <li><a href="#opera">Opera 7.x</a></li>\n    </ul>\n    <h3><a name="ie7"></a>Internet Explorer 7.x</h3>\n    <ol>\n        <li>\n            <p>Start Internet Explorer</p>\n        </li>\n        <li>\n            <p>Under the <strong>Tools</strong> menu, click <strong>Internet Options</strong></p>\n            <p><img src="{{skin url="images/cookies/ie7-1.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Click the <strong>Privacy</strong> tab</p>\n            <p><img src="{{skin url="images/cookies/ie7-2.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Click the <strong>Advanced</strong> button</p>\n            <p><img src="{{skin url="images/cookies/ie7-3.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Put a check mark in the box for <strong>Override Automatic Cookie Handling</strong>,\n            put another check mark in the <strong>Always accept session cookies </strong>box</p>\n            <p><img src="{{skin url="images/cookies/ie7-4.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Click <strong>OK</strong></p>\n            <p><img src="{{skin url="images/cookies/ie7-5.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Click <strong>OK</strong></p>\n            <p><img src="{{skin url="images/cookies/ie7-6.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Restart Internet Explore</p>\n        </li>\n    </ol>\n    <p class="a-top"><a href="#top">Back to Top</a></p>\n    <h3><a name="ie6"></a>Internet Explorer 6.x</h3>\n    <ol>\n        <li>\n            <p>Select <strong>Internet Options</strong> from the Tools menu</p>\n            <p><img src="{{skin url="images/cookies/ie6-1.gif"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Click on the <strong>Privacy</strong> tab</p>\n        </li>\n        <li>\n            <p>Click the <strong>Default</strong> button (or manually slide the bar down to <strong>Medium</strong>)\n            under <strong>Settings</strong>. Click <strong>OK</strong></p>\n            <p><img src="{{skin url="images/cookies/ie6-2.gif"}}" alt="" /></p>\n        </li>\n    </ol>\n    <p class="a-top"><a href="#top">Back to Top</a></p>\n    <h3><a name="firefox"></a>Mozilla/Firefox</h3>\n    <ol>\n        <li>\n            <p>Click on the <strong>Tools</strong>-menu in Mozilla</p>\n        </li>\n        <li>\n            <p>Click on the <strong>Options...</strong> item in the menu - a new window open</p>\n        </li>\n        <li>\n            <p>Click on the <strong>Privacy</strong> selection in the left part of the window. (See image below)</p>\n            <p><img src="{{skin url="images/cookies/firefox.png"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>Expand the <strong>Cookies</strong> section</p>\n        </li>\n        <li>\n            <p>Check the <strong>Enable cookies</strong> and <strong>Accept cookies normally</strong> checkboxes</p>\n        </li>\n        <li>\n            <p>Save changes by clicking <strong>Ok</strong>.</p>\n        </li>\n    </ol>\n    <p class="a-top"><a href="#top">Back to Top</a></p>\n    <h3><a name="opera"></a>Opera 7.x</h3>\n    <ol>\n        <li>\n            <p>Click on the <strong>Tools</strong> menu in Opera</p>\n        </li>\n        <li>\n            <p>Click on the <strong>Preferences...</strong> item in the menu - a new window open</p>\n        </li>\n        <li>\n            <p>Click on the <strong>Privacy</strong> selection near the bottom left of the window. (See image below)</p>\n            <p><img src="{{skin url="images/cookies/opera.png"}}" alt="" /></p>\n        </li>\n        <li>\n            <p>The <strong>Enable cookies</strong> checkbox must be checked, and <strong>Accept all cookies</strong>\n            should be selected in the &quot;<strong>Normal cookies</strong>&quot; drop-down</p>\n        </li>\n        <li>\n            <p>Save changes by clicking <strong>Ok</strong></p>\n        </li>\n    </ol>\n    <p class="a-top"><a href="#top">Back to Top</a></p>\n</div>\n', '2014-12-03 00:00:13', '2014-12-03 00:00:13', 1, 0, NULL, NULL, NULL, NULL, NULL, NULL),
(6, 'Privacy Policy', 'one_column', NULL, NULL, 'privacy-policy-cookie-restriction-mode', 'Privacy Policy', '<p style="color: #ff0000; font-weight: bold; font-size: 13px">\n    Please replace this text with you Privacy Policy.\n    Please add any additional cookies your website uses below (e.g., Google Analytics)\n</p>\n<p>\n    This privacy policy sets out how {{config path="general/store_information/name"}} uses and protects any information\n    that you give {{config path="general/store_information/name"}} when you use this website.\n    {{config path="general/store_information/name"}} is committed to ensuring that your privacy is protected.\n    Should we ask you to provide certain information by which you can be identified when using this website,\n    then you can be assured that it will only be used in accordance with this privacy statement.\n    {{config path="general/store_information/name"}} may change this policy from time to time by updating this page.\n    You should check this page from time to time to ensure that you are happy with any changes.\n</p>\n<h2>What we collect</h2>\n<p>We may collect the following information:</p>\n<ul>\n    <li>name</li>\n    <li>contact information including email address</li>\n    <li>demographic information such as postcode, preferences and interests</li>\n    <li>other information relevant to customer surveys and/or offers</li>\n</ul>\n<p>\n    For the exhaustive list of cookies we collect see the <a href="#list">List of cookies we collect</a> section.\n</p>\n<h2>What we do with the information we gather</h2>\n<p>\n    We require this information to understand your needs and provide you with a better service,\n    and in particular for the following reasons:\n</p>\n<ul>\n    <li>Internal record keeping.</li>\n    <li>We may use the information to improve our products and services.</li>\n    <li>\n        We may periodically send promotional emails about new products, special offers or other information which we\n        think you may find interesting using the email address which you have provided.\n    </li>\n    <li>\n        From time to time, we may also use your information to contact you for market research purposes.\n        We may contact you by email, phone, fax or mail. We may use the information to customise the website\n        according to your interests.\n    </li>\n</ul>\n<h2>Security</h2>\n<p>\n    We are committed to ensuring that your information is secure. In order to prevent unauthorised access or disclosure,\n    we have put in place suitable physical, electronic and managerial procedures to safeguard and secure\n    the information we collect online.\n</p>\n<h2>How we use cookies</h2>\n<p>\n    A cookie is a small file which asks permission to be placed on your computer''s hard drive.\n    Once you agree, the file is added and the cookie helps analyse web traffic or lets you know when you visit\n    a particular site. Cookies allow web applications to respond to you as an individual. The web application\n    can tailor its operations to your needs, likes and dislikes by gathering and remembering information about\n    your preferences.\n</p>\n<p>\n    We use traffic log cookies to identify which pages are being used. This helps us analyse data about web page traffic\n    and improve our website in order to tailor it to customer needs. We only use this information for statistical\n    analysis purposes and then the data is removed from the system.\n</p>\n<p>\n    Overall, cookies help us provide you with a better website, by enabling us to monitor which pages you find useful\n    and which you do not. A cookie in no way gives us access to your computer or any information about you,\n    other than the data you choose to share with us. You can choose to accept or decline cookies.\n    Most web browsers automatically accept cookies, but you can usually modify your browser setting\n    to decline cookies if you prefer. This may prevent you from taking full advantage of the website.\n</p>\n<h2>Links to other websites</h2>\n<p>\n    Our website may contain links to other websites of interest. However, once you have used these links\n    to leave our site, you should note that we do not have any control over that other website.\n    Therefore, we cannot be responsible for the protection and privacy of any information which you provide whilst\n    visiting such sites and such sites are not governed by this privacy statement.\n    You should exercise caution and look at the privacy statement applicable to the website in question.\n</p>\n<h2>Controlling your personal information</h2>\n<p>You may choose to restrict the collection or use of your personal information in the following ways:</p>\n<ul>\n    <li>\n        whenever you are asked to fill in a form on the website, look for the box that you can click to indicate\n        that you do not want the information to be used by anybody for direct marketing purposes\n    </li>\n    <li>\n        if you have previously agreed to us using your personal information for direct marketing purposes,\n        you may change your mind at any time by writing to or emailing us at\n        {{config path="trans_email/ident_general/email"}}\n    </li>\n</ul>\n<p>\n    We will not sell, distribute or lease your personal information to third parties unless we have your permission\n    or are required by law to do so. We may use your personal information to send you promotional information\n    about third parties which we think you may find interesting if you tell us that you wish this to happen.\n</p>\n<p>\n    You may request details of personal information which we hold about you under the Data Protection Act 1998.\n    A small fee will be payable. If you would like a copy of the information held on you please write to\n    {{config path="general/store_information/address"}}.\n</p>\n<p>\n    If you believe that any information we are holding on you is incorrect or incomplete,\n    please write to or email us as soon as possible, at the above address.\n    We will promptly correct any information found to be incorrect.\n</p>\n<h2><a name="list"></a>List of cookies we collect</h2>\n<p>The table below lists the cookies we collect and what information they store.</p>\n<table class="data-table">\n    <thead>\n        <tr>\n            <th>COOKIE name</th>\n            <th>COOKIE Description</th>\n        </tr>\n    </thead>\n    <tbody>\n        <tr>\n            <th>CART</th>\n            <td>The association with your shopping cart.</td>\n        </tr>\n        <tr>\n            <th>CATEGORY_INFO</th>\n            <td>Stores the category info on the page, that allows to display pages more quickly.</td>\n        </tr>\n        <tr>\n            <th>COMPARE</th>\n            <td>The items that you have in the Compare Products list.</td>\n        </tr>\n        <tr>\n            <th>CURRENCY</th>\n            <td>Your preferred currency</td>\n        </tr>\n        <tr>\n            <th>CUSTOMER</th>\n            <td>An encrypted version of your customer id with the store.</td>\n        </tr>\n        <tr>\n            <th>CUSTOMER_AUTH</th>\n            <td>An indicator if you are currently logged into the store.</td>\n        </tr>\n        <tr>\n            <th>CUSTOMER_INFO</th>\n            <td>An encrypted version of the customer group you belong to.</td>\n        </tr>\n        <tr>\n            <th>CUSTOMER_SEGMENT_IDS</th>\n            <td>Stores the Customer Segment ID</td>\n        </tr>\n        <tr>\n            <th>EXTERNAL_NO_CACHE</th>\n            <td>A flag, which indicates whether caching is disabled or not.</td>\n        </tr>\n        <tr>\n            <th>FRONTEND</th>\n            <td>You sesssion ID on the server.</td>\n        </tr>\n        <tr>\n            <th>GUEST-VIEW</th>\n            <td>Allows guests to edit their orders.</td>\n        </tr>\n        <tr>\n            <th>LAST_CATEGORY</th>\n            <td>The last category you visited.</td>\n        </tr>\n        <tr>\n            <th>LAST_PRODUCT</th>\n            <td>The most recent product you have viewed.</td>\n        </tr>\n        <tr>\n            <th>NEWMESSAGE</th>\n            <td>Indicates whether a new message has been received.</td>\n        </tr>\n        <tr>\n            <th>NO_CACHE</th>\n            <td>Indicates whether it is allowed to use cache.</td>\n        </tr>\n        <tr>\n            <th>PERSISTENT_SHOPPING_CART</th>\n            <td>A link to information about your cart and viewing history if you have asked the site.</td>\n        </tr>\n        <tr>\n            <th>POLL</th>\n            <td>The ID of any polls you have recently voted in.</td>\n        </tr>\n        <tr>\n            <th>POLLN</th>\n            <td>Information on what polls you have voted on.</td>\n        </tr>\n        <tr>\n            <th>RECENTLYCOMPARED</th>\n            <td>The items that you have recently compared.            </td>\n        </tr>\n        <tr>\n            <th>STF</th>\n            <td>Information on products you have emailed to friends.</td>\n        </tr>\n        <tr>\n            <th>STORE</th>\n            <td>The store view or language you have selected.</td>\n        </tr>\n        <tr>\n            <th>USER_ALLOWED_SAVE_COOKIE</th>\n            <td>Indicates whether a customer allowed to use cookies.</td>\n        </tr>\n        <tr>\n            <th>VIEWED_PRODUCT_IDS</th>\n            <td>The products that you have recently viewed.</td>\n        </tr>\n        <tr>\n            <th>WISHLIST</th>\n            <td>An encrypted list of products added to your Wishlist.</td>\n        </tr>\n        <tr>\n            <th>WISHLIST_CNT</th>\n            <td>The number of items in your Wishlist.</td>\n        </tr>\n    </tbody>\n</table>', '2014-12-03 00:00:13', '2014-12-03 00:00:13', 1, 0, NULL, NULL, NULL, NULL, NULL, NULL),
(7, 'Amoda - Responsive Magento Theme', 'one_column', NULL, NULL, 'amoda_home_page', NULL, '<div style="display: none;">sns</div>', '2014-12-03 01:39:41', '2015-06-30 20:43:47', 1, 0, '<reference name="header">\r\n    <block type="amoda/wrapper" name="section.amodaheader" as="cat_slideshow">\r\n        <action method="setId"><id>sns_header_bot</id></action>\r\n        <action method="setContainer"><container>1</container></action>\r\n        <action method="setRow"><row>1</row></action>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no1">\r\n            <action method="setId"><id>col-home-left</id></action>\r\n            <action method="setParams"><params>class="col-lg-3 col-md-3 col-sm-12"</params></action>\r\n            <block type="amoda/menu" name="menu.left" as="menu" before="-" />\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no2">\r\n            <action method="setParams"><params>class="col-lg-6 col-md-6 col-sm-7"</params></action>\r\n            <action method="setId"><id>col-home-right</id></action>\r\n            <block type="slideshow/slideshow" name="sns.slideshow" as="slideshow" />\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no3">\r\n            <action method="setParams"><params>class="col-lg-3 col-md-3 col-sm-5"</params></action>\r\n            <block type="products/deals" name="home.hotdeal" before="-">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Hot Deal</title>\r\n                        <product_limitation>6</product_limitation>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n        </block>\r\n    </block>\r\n</reference>\r\n<reference name="content">\r\n    <block type="amoda/wrapper" name="section.amoda1">\r\n        <action method="setParams"><params>class="top_content"</params></action>\r\n        <action method="setRow"><row>1</row></action>\r\n        <block type="amoda/wrapper" name="section.amoda1.no1">\r\n            <action method="setParams"><params>class="col-md-3 col-sm-5"</params></action>\r\n            <block type="cms/block" name="amoda_banner1">\r\n                <action method="setBlockId"><block_id>amoda_banner1</block_id></action>\r\n            </block>\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amoda1.no2">\r\n            <action method="setParams"><params>class="col-md-9 col-sm-7 mrb30"</params></action>\r\n            <block type="core/template" template="sns/blocks/partners.phtml" />\r\n        </block>\r\n    </block>\r\n    <block type="amoda/wrapper" name="section.no1.producttabs">\r\n        <action method="setParams"><params>class="wrapper"</params></action>\r\n        <block type="producttabs/slider" name="producttabs.slider">\r\n            <action method="setConfig">\r\n                <name>\r\n                    <number_per_display>10</number_per_display>\r\n                </name>\r\n            </action>\r\n        </block>\r\n    </block>\r\n    <block type="cms/block" name="amoda_banner2">\r\n        <action method="setBlockId"><block_id>amoda_banner2</block_id></action>\r\n    </block>\r\n    <block type="amoda/wrapper" name="section.amoda2">\r\n        <action method="setParams"><params>class="top_content"</params></action>\r\n        <action method="setRow"><row>1</row></action>\r\n        <block type="amoda/wrapper" name="section.amoda2.no1">\r\n            <action method="setParams"><params>class="col-md-9 col-sm-8"</params></action>\r\n            <block type="producttabs/grid" name="producttabs.grid">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Featured Product</title>\r\n                        <number_per_display>6</number_per_display>\r\n                        <screen_sm>2</screen_sm>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="products/slider" name="product.slider">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Top rating</title>\r\n                        <product_order_by>top_rating</product_order_by>\r\n                        <screen_phone>1</screen_phone>\r\n                        <screen_sm>2</screen_sm>\r\n                        <screen_md>3</screen_md>\r\n                        <screen_lg>3</screen_lg>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="cms/block" name="amoda_banner3">\r\n                <action method="setBlockId"><block_id>amoda_banner3</block_id></action>\r\n            </block>\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amoda2.no2">\r\n            <action method="setParams"><params>class="col-md-3 col-sm-4"</params></action>\r\n\r\n            <block type="products/slider" name="product.slider" template="sns/products/slider_topseller.phtml">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Top Seller</title>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="newsletter/subscribe" name="content.subscribe" template="newsletter/subscribe-content.phtml" />\r\n            <block type="tag/popular" name="tags_popular" after="catalog.product.related" template="tag/popular.phtml"/>\r\n        </block>\r\n    </block>\r\n\r\n</reference>', NULL, NULL, NULL, NULL, NULL),
(8, 'Amoda - Responsive Magento Theme v2', 'one_column', NULL, NULL, 'amoda_home_page_v2', NULL, '<div style="display: none;">sns</div>', '2015-05-15 01:38:51', '2015-06-29 20:37:40', 1, 0, '<reference name="header">\r\n    <block type="amoda/wrapper" name="section.amodaheader" as="cat_slideshow">\r\n        <action method="setId"><id>sns_header_bot</id></action>\r\n        <action method="setContainer"><container>1</container></action>\r\n        <action method="setRow"><row>1</row></action>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no1">\r\n            <action method="setId"><id>col-home-left</id></action>\r\n            <action method="setParams"><params>class="col-lg-3 col-md-3 col-sm-12"</params></action>\r\n            <block type="amoda/menu" name="menu.left" as="menu" before="-" />\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no2">\r\n            <action method="setParams"><params>class="col-lg-9 col-md-9 col-sm-12"</params></action>\r\n            <action method="setId"><id>col-home-right</id></action>\r\n            <block type="slideshow/slideshow" name="sns.slideshow" as="slideshow" />\r\n        </block>\r\n    </block>\r\n</reference>\r\n<reference name="content">\r\n    <block type="amoda/wrapper" name="section.no1.producttabs">\r\n        <action method="setParams"><params>class="wrapper"</params></action>\r\n        <block type="producttabs/slider" name="producttabs.slider">\r\n            <action method="setConfig">\r\n                <name>\r\n                    <number_per_display>10</number_per_display>\r\n                </name>\r\n            </action>\r\n        </block>\r\n    </block>\r\n    <block type="cms/block" name="amoda_banner2">\r\n        <action method="setBlockId"><block_id>amoda_banner2</block_id></action>\r\n    </block>\r\n    <block type="amoda/wrapper" name="section.amoda2">\r\n        <action method="setParams"><params>class="top_content"</params></action>\r\n        <action method="setRow"><row>1</row></action>\r\n        <block type="amoda/wrapper" name="section.amoda2.no1">\r\n            <action method="setParams"><params>class="col-md-9 col-sm-8"</params></action>\r\n            <block type="producttabs/grid" name="producttabs.grid">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Featured Product</title>\r\n                        <number_per_display>6</number_per_display>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="products/slider" name="product.slider">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Top rating</title>\r\n                        <product_order_by>top_rating</product_order_by>\r\n                        <screen_phone>1</screen_phone>\r\n                        <screen_sm>2</screen_sm>\r\n                        <screen_md>3</screen_md>\r\n                        <screen_lg>3</screen_lg>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="cms/block" name="amoda_banner3">\r\n                <action method="setBlockId"><block_id>amoda_banner3</block_id></action>\r\n            </block>\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amoda2.no2">\r\n            <action method="setParams"><params>class="col-md-3 col-sm-4"</params></action>\r\n\r\n            <block type="products/slider" name="product.slider" template="sns/products/slider_topseller.phtml">\r\n                <action method="setConfig">\r\n                    <name>\r\n                        <title>Top Seller</title>\r\n                    </name>\r\n                </action>\r\n            </block>\r\n            <block type="newsletter/subscribe" name="content.subscribe" template="newsletter/subscribe-content.phtml" />\r\n            <block type="core/template" template="sns/blocks/partnersv2.phtml" />\r\n        </block>\r\n    </block>\r\n</reference>', NULL, NULL, NULL, NULL, NULL),
(9, 'Amoda - Responsive Magento Theme v3', 'two_columns_left', NULL, NULL, 'amoda_home_page_v3', NULL, '<div style="display: none;">sns</div>', '2015-05-15 20:55:39', '2015-06-30 00:39:58', 1, 0, '<reference name="left">\r\n\r\n    <block type="products/deals" name="home.hotdeal" before="-">\r\n        <action method="setConfig">\r\n            <name>\r\n                <title>Hot Deal</title>\r\n                <product_limitation>6</product_limitation>\r\n            </name>\r\n        </action>\r\n    </block>\r\n    \r\n    <block type="products/slider" after="amoda_banner1" name="sns.products.list" template="sns/products/slide_seller.phtml">\r\n        <action method="setConfig">\r\n            <name>\r\n                <title>Best Sellers</title>\r\n                <product_order_by>created_at</product_order_by>\r\n            </name>\r\n        </action>\r\n    </block>\r\n    <block type="cms/block" name="amodav3_banner1" after="sns.products.list">\r\n        <action method="setBlockId"><block_id>amodav3_banner1</block_id></action>\r\n    </block>\r\n    <block type="newsletter/subscribe" after="amodav3_banner1" name="content.subscribe" template="newsletter/subscribe-content.phtml" />\r\n    <block type="core/template" after="content.subscribe" template="sns/blocks/partnersv3.phtml" />\r\n\r\n</reference>\r\n<reference name="header">\r\n    <block type="amoda/wrapper" name="section.amodaheader" as="cat_slideshow">\r\n        <action method="setId"><id>sns_header_bot</id></action>\r\n        <action method="setParams"><params>class="cat_slide_position"</params></action>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no1">\r\n            <action method="setParams"><params>class="cat_position"</params></action>\r\n            <action method="setContainer"><container>1</container></action>\r\n            <action method="setRow"><row>1</row></action>\r\n            <block type="amoda/wrapper" name="section.amodacat">\r\n                <action method="setId"><id>col-home-left</id></action>\r\n                <action method="setParams"><params>class="col-md-3"</params></action>\r\n                <block type="amoda/menu" name="menu.left" as="menu" before="-" />\r\n            </block>\r\n        </block>\r\n        <block type="amoda/wrapper" name="section.amodaheader.no2">\r\n            <action method="setId"><id>col-home-right</id></action>\r\n            <block type="slideshow/slideshow" name="sns.slideshow" as="slideshow" />\r\n        </block>\r\n    </block>\r\n</reference>\r\n<reference name="content">\r\n    <!-- <block type="cms/block" name="amoda_banner2">\r\n        <action method="setBlockId"><block_id>amoda_bannerv3_2</block_id></action>\r\n    </block> -->\r\n    <block type="producttabs/slider" name="producttabs.slider">\r\n        <action method="setConfig">\r\n            <name>\r\n                <number_per_display>10</number_per_display>\r\n            </name>\r\n        </action>\r\n    </block>\r\n    <block type="cms/block" name="amoda_banner3">\r\n        <action method="setBlockId"><block_id>amoda_banner3_v3</block_id></action>\r\n    </block>\r\n\r\n    <block type="producttabs/grid" name="producttabs.grid">\r\n        <action method="setConfig">\r\n            <name>\r\n                <title>Featured Product</title>\r\n                <number_per_display>6</number_per_display>\r\n            </name>\r\n        </action>\r\n    </block>\r\n    <block type="cms/block" name="amoda_bannerv3_2">\r\n        <action method="setBlockId"><block_id>amoda_bannerv3_4</block_id></action>\r\n    </block>\r\n    <block type="products/slider" name="product.slider">\r\n        <action method="setConfig">\r\n            <name>\r\n                <title>Top rating</title>\r\n                <product_order_by>top_rating</product_order_by>\r\n                <screen_phone>1</screen_phone>\r\n                <screen_sm>2</screen_sm>\r\n                <screen_md>3</screen_md>\r\n                <screen_lg>3</screen_lg>\r\n            </name>\r\n        </action>\r\n    </block>\r\n\r\n</reference>', NULL, NULL, NULL, NULL, NULL),
(10, 'Amoda - Not Found', 'one_column', NULL, NULL, 'amoda_no_route', NULL, '<div class="page-notpound">\r\n<div class="img"><img alt="" src="{{media url="wysiwyg/amoda/404page.png"}}" /></div>\r\n<div class="submit"><a class="button" title="Go to home" href="{{store url=""}}">Go to home</a></div>\r\n<div class="content">To find a product, please type it is name in the field below</div>\r\n</div>', '2015-05-28 21:03:09', '2015-07-02 00:55:59', 1, 0, '<reference name="content">\r\n<block type="core/template" name="top.search" as="topSearch" template="catalogsearch/form.mini.phtml"/>\r\n</reference>', NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__cms_page_store` (
  `page_id` smallint(6) NOT NULL COMMENT 'Page ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='CMS Page To Store Linkage Table';

INSERT INTO `#__cms_page_store` (`page_id`, `store_id`) VALUES
(1, 0),
(2, 0),
(3, 0),
(4, 0),
(5, 0),
(6, 0),
(10, 0),
(7, 1),
(8, 2),
(9, 3),
(8, 4);

CREATE TABLE IF NOT EXISTS `#__core_cache` (
  `id` varchar(200) NOT NULL COMMENT 'Cache Id',
  `data` mediumblob COMMENT 'Cache Data',
  `create_time` int(11) DEFAULT NULL COMMENT 'Cache Creation Time',
  `update_time` int(11) DEFAULT NULL COMMENT 'Time of Cache Updating',
  `expire_time` int(11) DEFAULT NULL COMMENT 'Cache Expiration Time'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Caches';

CREATE TABLE IF NOT EXISTS `#__core_cache_option` (
  `code` varchar(32) NOT NULL COMMENT 'Code',
  `value` smallint(6) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cache Options';

INSERT INTO `#__core_cache_option` (`code`, `value`) VALUES
('block_html', 0),
('collections', 0),
('config', 0),
('config_api', 0),
('config_api2', 0),
('eav', 0),
('layout', 0),
('translate', 0);

CREATE TABLE IF NOT EXISTS `#__core_cache_tag` (
  `tag` varchar(100) NOT NULL COMMENT 'Tag',
  `cache_id` varchar(200) NOT NULL COMMENT 'Cache Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tag Caches';

CREATE TABLE IF NOT EXISTS `#__core_config_data` (
`config_id` int(10) unsigned NOT NULL COMMENT 'Config Id',
  `scope` varchar(8) NOT NULL DEFAULT 'default' COMMENT 'Config Scope',
  `scope_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Config Scope Id',
  `path` varchar(255) NOT NULL DEFAULT 'general' COMMENT 'Config Path',
  `value` text COMMENT 'Config Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Config Data' AUTO_INCREMENT=407 ;

INSERT INTO `#__core_config_data` (`config_id`, `scope`, `scope_id`, `path`, `value`) VALUES
(1, 'default', 0, 'general/region/display_all', '1'),
(2, 'default', 0, 'general/region/state_required', 'AT,CA,CH,DE,EE,ES,FI,FR,LT,LV,RO,US'),
(3, 'default', 0, 'catalog/category/root_id', '2'),
(4, 'default', 0, 'payment/paypal_express/skip_order_review_step', '1'),
(5, 'default', 0, 'payment/payflow_link/mobile_optimized', '1'),
(6, 'default', 0, 'payment/payflow_advanced/mobile_optimized', '1'),
(7, 'default', 0, 'payment/hosted_pro/mobile_optimized', '1'),
(8, 'default', 0, 'admin/dashboard/enable_charts', '1'),
(9, 'default', 0, 'web/unsecure/base_url', 'http://dev.snsgroup.me/magento/trial/sns-amoda/'),
(10, 'default', 0, 'web/secure/base_url', 'http://dev.snsgroup.me/magento/trial/sns-amoda/'),
(11, 'default', 0, 'general/locale/code', 'en_US'),
(12, 'default', 0, 'general/locale/timezone', 'America/Los_Angeles'),
(13, 'default', 0, 'currency/options/base', 'USD'),
(14, 'default', 0, 'currency/options/default', 'USD'),
(15, 'default', 0, 'currency/options/allow', 'EUR,USD'),
(16, 'default', 0, 'design/header/logo_src', 'images/logo.png'),
(17, 'default', 0, 'web/default/cms_home_page', 'amoda_home_page'),
(18, 'default', 0, 'sns_amoda_cfg/general/fontFamily', 'arial'),
(19, 'default', 0, 'sns_amoda_cfg/general/fontSize', '14px'),
(20, 'default', 0, 'sns_amoda_cfg/general/layoutType', '1'),
(21, 'default', 0, 'sns_amoda_cfg/general/bodyBgColor', '#ffffff'),
(22, 'default', 0, 'sns_amoda_cfg/general/bodyBgImage', 'pattern_0'),
(23, 'default', 0, 'sns_amoda_cfg/general/bodyBgImage2', NULL),
(24, 'default', 0, 'sns_amoda_cfg/general/bodyBgPosition', 'center top'),
(25, 'default', 0, 'sns_amoda_cfg/general/bodyBgRepeat', 'repeat'),
(26, 'default', 0, 'sns_amoda_cfg/general/bodyBgAttachment', 'fixed'),
(27, 'default', 0, 'sns_amoda_cfg/general/styleHeader', 'solid'),
(28, 'default', 0, 'sns_amoda_cfg/general/googleFont', 'Lato:400,700,900'),
(29, 'default', 0, 'sns_amoda_cfg/general/googleFontTargets', 'body#bd'),
(30, 'default', 0, 'sns_amoda_cfg/general/useTagNew', '1'),
(31, 'default', 0, 'sns_amoda_cfg/general/useTagSale', '1'),
(32, 'default', 0, 'sns_amoda_cfg/general/dealsCountdown', '1'),
(33, 'default', 0, 'sns_amoda_cfg/general/useImageHover', '1'),
(34, 'default', 0, 'sns_amoda_cfg/general/effectImageHover', NULL),
(35, 'default', 0, 'sns_amoda_cfg/menu/customItems', 'a:4:{s:18:"_1429322636542_542";a:7:{s:5:"title";s:4:"Home";s:4:"link";s:16:"{{store url=""}}";s:6:"target";s:5:"_self";s:5:"label";s:4:"none";s:8:"position";s:5:"first";s:8:"block_id";s:1:"0";s:6:"status";s:1:"0";}s:18:"_1429851703648_648";a:7:{s:5:"title";s:8:"Features";s:4:"link";s:1:"#";s:6:"target";s:5:"_self";s:5:"label";s:4:"none";s:8:"position";s:5:"first";s:8:"block_id";s:19:"amoda_menu_featured";s:6:"status";s:1:"1";}s:18:"_1429851704278_278";a:7:{s:5:"title";s:10:"Contact Us";s:4:"link";s:24:"{{store url=''contacts''}}";s:6:"target";s:5:"_self";s:5:"label";s:4:"none";s:8:"position";s:5:"first";s:8:"block_id";s:1:"0";s:6:"status";s:1:"0";}s:18:"_1429851704896_896";a:7:{s:5:"title";s:4:"Blog";s:4:"link";s:20:"{{store url=''blog''}}";s:6:"target";s:5:"_self";s:5:"label";s:4:"none";s:8:"position";s:5:"first";s:8:"block_id";s:1:"0";s:6:"status";s:1:"0";}}'),
(36, 'default', 0, 'sns_amoda_cfg/menu/resMenu', 'sidebar'),
(37, 'default', 0, 'sns_amoda_cfg/menu/keepMenu', '0'),
(38, 'default', 0, 'sns_amoda_cfg/listingpage/displayAddtocart', '1'),
(39, 'default', 0, 'sns_amoda_cfg/listingpage/displayWishlist', '1'),
(40, 'default', 0, 'sns_amoda_cfg/listingpage/displayCompare', '1'),
(41, 'default', 0, 'sns_amoda_cfg/productpage/useAddThis', '0'),
(42, 'default', 0, 'sns_amoda_cfg/productpage/customtabStatus', '1'),
(43, 'default', 0, 'sns_amoda_cfg/productpage/customtabTitle', 'Custom tab'),
(44, 'default', 0, 'sns_amoda_cfg/productpage/customtabStaticblock', 'amoda_sticky_custom'),
(45, 'default', 0, 'sns_amoda_cfg/social/status', '1'),
(46, 'default', 0, 'sns_amoda_cfg/social/items', 'a:6:{s:18:"_1404877041312_312";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:11:"fa-facebook";s:6:"target";s:5:"_self";}s:18:"_1404877043240_240";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:10:"fa-twitter";s:6:"target";s:5:"_self";}s:18:"_1404890310671_671";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:14:"fa-google-plus";s:6:"target";s:5:"_self";}s:18:"_1404890311224_224";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:12:"fa-pinterest";s:6:"target";s:5:"_self";}s:18:"_1409806909803_803";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:11:"fa-dribbble";s:6:"target";s:5:"_self";}s:18:"_1409806925787_787";a:4:{s:5:"title";s:9:"SNS Theme";s:4:"link";s:1:"#";s:4:"icon";s:11:"fa-linkedin";s:6:"target";s:5:"_self";}}'),
(47, 'default', 0, 'sns_amoda_cfg/testimonial/status', '1'),
(48, 'default', 0, 'sns_amoda_cfg/testimonial/title', 'What clien say ?'),
(49, 'default', 0, 'sns_amoda_cfg/testimonial/items', 'a:0:{}'),
(50, 'default', 0, 'sns_amoda_cfg/ourpartners/enabled', '1'),
(51, 'default', 0, 'sns_amoda_cfg/ourpartners/title', 'Our Brands'),
(52, 'default', 0, 'sns_amoda_cfg/ourpartners/bg_color', NULL),
(53, 'default', 0, 'sns_amoda_cfg/ourpartners/bg_img', NULL),
(54, 'default', 0, 'sns_amoda_cfg/ourpartners/partners', 'a:14:{s:17:"_1429851456090_90";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our1.jpg";}s:18:"_1429851469560_560";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our2.jpg";}s:17:"_1429851470079_79";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our3.jpg";}s:18:"_1429851470854_854";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our4.jpg";}s:18:"_1429851471351_351";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our5.jpg";}s:18:"_1429851472119_119";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our6.jpg";}s:18:"_1429851472640_640";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our7.jpg";}s:18:"_1429851473319_319";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our8.jpg";}s:18:"_1429851473928_928";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our9.jpg";}s:18:"_1429851474504_504";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:30:"wysiwyg/amoda/brands/our10.jpg";}s:18:"_1429851475123_123";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our3.jpg";}s:17:"_1429851477018_18";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our4.jpg";}s:18:"_1429851477776_776";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our7.jpg";}s:18:"_1429851578347_347";a:4:{s:5:"title";s:9:"SNS Group";s:4:"link";s:1:"#";s:6:"target";s:6:"_blank";s:5:"image";s:29:"wysiwyg/amoda/brands/our8.jpg";}}'),
(55, 'default', 0, 'sns_amoda_cfg/storelocation/status', '1'),
(56, 'default', 0, 'sns_amoda_cfg/storelocation/statusfooter', '1'),
(57, 'default', 0, 'sns_amoda_cfg/storelocation/store_name', 'Support'),
(58, 'default', 0, 'sns_amoda_cfg/storelocation/store_info', 'Lorem Ipsum is simyp. Lorem Ipsum has been the industry''s standard dummy text ever since.'),
(59, 'default', 0, 'sns_amoda_cfg/storelocation/store_address', '5 Avenue Anatole France 75007'),
(60, 'default', 0, 'sns_amoda_cfg/storelocation/store_phone', '+00-123-456-789'),
(61, 'default', 0, 'sns_amoda_cfg/storelocation/store_email', 'contact@amoda.com'),
(62, 'default', 0, 'sns_amoda_cfg/storelocation/map_zoom', '14'),
(63, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col1', 'amoda_footer_top1'),
(64, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col2', 'amoda_footer_top2'),
(65, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col3', 'amoda_footer_top3'),
(66, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col4', 'amoda_footer_top4'),
(67, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col5', 'amoda_footer_top5'),
(68, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col6', 'amoda_footer_top6'),
(69, 'default', 0, 'sns_amoda_cfg/advance/lessEnabled', '1'),
(70, 'default', 0, 'sns_amoda_cfg/advance/lessCompress', '1'),
(71, 'default', 0, 'sns_amoda_cfg/advance/themeColor', '#f38554'),
(72, 'default', 0, 'sns_amoda_cfg/advance/themeColor2', '#0dbfa5'),
(73, 'default', 0, 'sns_amoda_cfg/advance/showCpanel', '1'),
(74, 'default', 0, 'sns_amoda_cfg/advance/scrollToTop', '1'),
(75, 'default', 0, 'sns_amoda_cfg/advance/customcss', NULL),
(76, 'default', 0, 'sns_amoda_cfg/advance/showTooltip', '1'),
(77, 'default', 0, 'sns_amoda_cfg/install/overwrite_blocks', '0'),
(78, 'default', 0, 'sns_amoda_cfg/install/overwrite_pages', '0'),
(79, 'default', 0, 'design/package/name', 'sns_amoda'),
(80, 'default', 0, 'design/package/ua_regexp', 'a:0:{}'),
(81, 'default', 0, 'design/theme/locale', NULL),
(82, 'default', 0, 'design/theme/template', NULL),
(83, 'default', 0, 'design/theme/template_ua_regexp', 'a:0:{}'),
(84, 'default', 0, 'design/theme/skin', NULL),
(85, 'default', 0, 'design/theme/skin_ua_regexp', 'a:0:{}'),
(86, 'default', 0, 'design/theme/layout', NULL),
(87, 'default', 0, 'design/theme/layout_ua_regexp', 'a:0:{}'),
(88, 'default', 0, 'design/theme/default', NULL),
(89, 'default', 0, 'design/theme/default_ua_regexp', 'a:0:{}'),
(90, 'default', 0, 'design/head/default_title', 'Magento Commerce'),
(91, 'default', 0, 'design/head/title_prefix', NULL),
(92, 'default', 0, 'design/head/title_suffix', NULL),
(93, 'default', 0, 'design/head/default_description', 'Default Description'),
(94, 'default', 0, 'design/head/default_keywords', 'Magento, Varien, E-commerce'),
(95, 'default', 0, 'design/head/default_robots', 'INDEX,FOLLOW'),
(96, 'default', 0, 'design/head/includes', NULL),
(97, 'default', 0, 'design/head/demonotice', '0'),
(98, 'default', 0, 'design/header/logo_alt', 'Magento Commerce'),
(99, 'default', 0, 'design/header/logo_src_small', 'images/logo.gif'),
(100, 'default', 0, 'design/header/welcome', 'Default welcome msg!'),
(101, 'default', 0, 'design/footer/copyright', '&copy; 2015 Magento Demo Store. All Rights Reserved.'),
(102, 'default', 0, 'design/footer/absolute_footer', NULL),
(103, 'default', 0, 'design/watermark/image_size', NULL),
(104, 'default', 0, 'design/watermark/image_imageOpacity', NULL),
(105, 'default', 0, 'design/watermark/image_position', 'stretch'),
(106, 'default', 0, 'design/watermark/small_image_size', NULL),
(107, 'default', 0, 'design/watermark/small_image_imageOpacity', NULL),
(108, 'default', 0, 'design/watermark/small_image_position', 'stretch'),
(109, 'default', 0, 'design/watermark/thumbnail_size', NULL),
(110, 'default', 0, 'design/watermark/thumbnail_imageOpacity', NULL),
(111, 'default', 0, 'design/watermark/thumbnail_position', 'stretch'),
(112, 'default', 0, 'design/pagination/pagination_frame', '5'),
(113, 'default', 0, 'design/pagination/pagination_frame_skip', NULL),
(114, 'default', 0, 'design/pagination/anchor_text_for_previous', NULL),
(115, 'default', 0, 'design/pagination/anchor_text_for_next', NULL),
(116, 'default', 0, 'design/email/logo_alt', NULL),
(117, 'default', 0, 'design/email/logo_width', NULL),
(118, 'default', 0, 'design/email/logo_height', NULL),
(119, 'default', 0, 'design/email/header', 'design_email_header'),
(120, 'default', 0, 'design/email/footer', 'design_email_footer'),
(121, 'default', 0, 'design/email/css_non_inline', 'email-non-inline.css'),
(122, 'default', 0, 'currency/webservicex/timeout', '100'),
(123, 'default', 0, 'currency/import/enabled', '0'),
(124, 'default', 0, 'currency/import/service', 'webservicex'),
(125, 'default', 0, 'crontab/jobs/currency_rates_update/schedule/cron_expr', '0 0 * * *'),
(126, 'default', 0, 'currency/import/time', '00,00,00'),
(127, 'default', 0, 'currency/import/frequency', 'D'),
(128, 'default', 0, 'currency/import/error_email', NULL),
(129, 'default', 0, 'currency/import/error_email_identity', 'general'),
(130, 'default', 0, 'currency/import/error_email_template', 'currency_import_error_email_template'),
(131, 'default', 0, 'sns_quicksearch_cfg/general/isenabled', '1'),
(132, 'default', 0, 'sns_quicksearch_cfg/general/show_catfilter', '1'),
(133, 'default', 0, 'sns_quicksearch_cfg/general/show_popular', '0'),
(134, 'default', 0, 'sns_quicksearch_cfg/general/limit_popular', '5'),
(135, 'default', 0, 'sns_quicksearch_cfg/general/show_more', '0'),
(136, 'default', 0, 'sns_quicksearch_cfg/general/show_advanced', '0'),
(137, 'default', 0, 'configswatches/general/enabled', '1'),
(138, 'default', 0, 'configswatches/general/swatch_attributes', '92,81'),
(139, 'default', 0, 'configswatches/general/product_list_attribute', '92'),
(140, 'default', 0, 'configswatches/product_detail_dimensions/width', '21'),
(141, 'default', 0, 'configswatches/product_detail_dimensions/height', '21'),
(142, 'default', 0, 'configswatches/product_listing_dimensions/width', '15'),
(143, 'default', 0, 'configswatches/product_listing_dimensions/height', '15'),
(144, 'default', 0, 'configswatches/layered_nav_dimensions/width', '15'),
(145, 'default', 0, 'configswatches/layered_nav_dimensions/height', '15'),
(146, 'default', 0, 'catalog/frontend/list_mode', 'grid-list'),
(147, 'default', 0, 'catalog/frontend/grid_per_page_values', '15,30,45'),
(148, 'default', 0, 'catalog/frontend/grid_per_page', '15'),
(149, 'default', 0, 'catalog/frontend/list_per_page_values', '6,12,18,24,30'),
(150, 'default', 0, 'catalog/frontend/list_per_page', '6'),
(151, 'default', 0, 'catalog/frontend/list_allow_all', '0'),
(152, 'default', 0, 'catalog/frontend/default_sort_by', 'position'),
(153, 'default', 0, 'catalog/frontend/flat_catalog_category', '1'),
(154, 'default', 0, 'catalog/frontend/flat_catalog_product', '1'),
(155, 'default', 0, 'catalog/frontend/parse_url_directives', '1'),
(156, 'default', 0, 'catalog/sitemap/tree_mode', '0'),
(157, 'default', 0, 'catalog/sitemap/lines_perpage', '30'),
(158, 'default', 0, 'catalog/review/allow_guest', '1'),
(159, 'default', 0, 'catalog/product_image/base_width', '1800'),
(160, 'default', 0, 'catalog/product_image/small_width', '210'),
(161, 'default', 0, 'catalog/productalert/allow_price', '0'),
(162, 'default', 0, 'catalog/productalert/email_price_template', 'catalog_productalert_email_price_template'),
(163, 'default', 0, 'catalog/productalert/allow_stock', '0'),
(164, 'default', 0, 'catalog/productalert/email_stock_template', 'catalog_productalert_email_stock_template'),
(165, 'default', 0, 'catalog/productalert/email_identity', 'general'),
(166, 'default', 0, 'catalog/productalert_cron/frequency', 'D'),
(167, 'default', 0, 'crontab/jobs/catalog_product_alert/schedule/cron_expr', '0 0 * * *'),
(168, 'default', 0, 'crontab/jobs/catalog_product_alert/run/model', 'productalert/observer::process'),
(169, 'default', 0, 'catalog/productalert_cron/time', '00,00,00'),
(170, 'default', 0, 'catalog/productalert_cron/error_email', NULL),
(171, 'default', 0, 'catalog/productalert_cron/error_email_identity', 'general'),
(172, 'default', 0, 'catalog/productalert_cron/error_email_template', 'catalog_productalert_cron_error_email_template'),
(173, 'default', 0, 'catalog/recently_products/scope', 'website'),
(174, 'default', 0, 'catalog/recently_products/viewed_count', '5'),
(175, 'default', 0, 'catalog/recently_products/compared_count', '5'),
(176, 'default', 0, 'catalog/price/scope', '0'),
(177, 'default', 0, 'catalog/layered_navigation/display_product_count', '1'),
(178, 'default', 0, 'catalog/layered_navigation/price_range_calculation', 'auto'),
(179, 'default', 0, 'catalog/navigation/max_depth', '0'),
(180, 'default', 0, 'catalog/seo/site_map', '1'),
(181, 'default', 0, 'catalog/seo/search_terms', '1'),
(182, 'default', 0, 'catalog/seo/product_url_suffix', '.html'),
(183, 'default', 0, 'catalog/seo/category_url_suffix', '.html'),
(184, 'default', 0, 'catalog/seo/product_use_categories', '1'),
(185, 'default', 0, 'catalog/seo/save_rewrites_history', '1'),
(186, 'default', 0, 'catalog/seo/title_separator', '-'),
(187, 'default', 0, 'catalog/seo/category_canonical_tag', '0'),
(188, 'default', 0, 'catalog/seo/product_canonical_tag', '0'),
(189, 'default', 0, 'catalog/search/min_query_length', '1'),
(190, 'default', 0, 'catalog/search/max_query_length', '128'),
(191, 'default', 0, 'catalog/search/max_query_words', '10'),
(192, 'default', 0, 'catalog/search/search_type', '1'),
(193, 'default', 0, 'catalog/search/use_layered_navigation_count', '2000'),
(194, 'default', 0, 'catalog/downloadable/order_item_status', '9'),
(195, 'default', 0, 'catalog/downloadable/downloads_number', '0'),
(196, 'default', 0, 'catalog/downloadable/shareable', '0'),
(197, 'default', 0, 'catalog/downloadable/samples_title', 'Samples'),
(198, 'default', 0, 'catalog/downloadable/links_title', 'Links'),
(199, 'default', 0, 'catalog/downloadable/links_target_new_window', '1'),
(200, 'default', 0, 'catalog/downloadable/content_disposition', 'inline'),
(201, 'default', 0, 'catalog/downloadable/disable_guest_checkout', '1'),
(202, 'default', 0, 'catalog/custom_options/use_calendar', '0'),
(203, 'default', 0, 'catalog/custom_options/date_fields_order', 'm,d,y'),
(204, 'default', 0, 'catalog/custom_options/time_format', '12h'),
(205, 'default', 0, 'catalog/custom_options/year_range', ','),
(206, 'default', 0, 'sns_products_cfg/general/title', 'Other products'),
(207, 'default', 0, 'sns_products_cfg/product_selection/product_source', 'catalog'),
(208, 'default', 0, 'sns_products_cfg/product_selection/product_category', '2,3,4'),
(209, 'default', 0, 'sns_products_cfg/product_selection/product_order_by', 'position'),
(210, 'default', 0, 'sns_products_cfg/product_selection/product_order_dir', 'asc'),
(211, 'default', 0, 'sns_products_cfg/product_selection/product_filter_by', 'all'),
(212, 'default', 0, 'sns_products_cfg/product_selection/product_limitation', '8'),
(213, 'default', 0, 'sns_products_cfg/slider_cfg/screen_phone', '1'),
(214, 'default', 0, 'sns_products_cfg/slider_cfg/screen_xs', '2'),
(215, 'default', 0, 'sns_products_cfg/slider_cfg/screen_sm', '3'),
(216, 'default', 0, 'sns_products_cfg/slider_cfg/screen_md', '3'),
(217, 'default', 0, 'sns_products_cfg/slider_cfg/screen_lg', '4'),
(218, 'default', 0, 'sns_products_cfg/product_selection/product_ids', '7, 13, 19, 20, 21'),
(219, 'default', 0, 'sns_producttabs_cfg/general/isenabled', '1'),
(220, 'default', 0, 'sns_producttabs_cfg/general/title', 'New Products'),
(221, 'default', 0, 'sns_producttabs_cfg/general/effects', 'bounceInRight'),
(222, 'default', 0, 'sns_producttabs_cfg/general/list_products_by', 'category'),
(223, 'default', 0, 'sns_producttabs_cfg/general/order_type', 'created_at,price,is_featured'),
(224, 'default', 0, 'sns_producttabs_cfg/general/product_order_dir', 'asc'),
(225, 'default', 0, 'sns_producttabs_cfg/general/number_per_display', '6'),
(226, 'default', 0, 'sns_producttabs_cfg/general/screen_xs', '2'),
(227, 'default', 0, 'sns_producttabs_cfg/general/screen_sm', '3'),
(228, 'default', 0, 'sns_producttabs_cfg/general/screen_md', '4'),
(229, 'default', 0, 'sns_producttabs_cfg/general/screen_lg', '4'),
(230, 'default', 0, 'sns_producttabs_cfg/general/show_number_loadmore', '0'),
(231, 'default', 0, 'sns_producttabs_cfg/general/number_per_loadmore', '6'),
(232, 'default', 0, 'sns_producttabs_cfg/general/product_category', '3,4,6,43,47'),
(233, 'default', 0, 'sns_producttabs_cfg/general/product_order_by', 'created_at'),
(234, 'default', 0, 'sns_products_cfg/general/product_source', 'catalog'),
(235, 'default', 0, 'sns_products_cfg/general/product_category', '3,4,9,10,11,12,13,14,51,52,53,54,33,8,7,15,16,17,22,31,21,27,29,30,32,18,34,36,38,5,19,24,26,40,42,44,46,48,50'),
(236, 'default', 0, 'sns_products_cfg/general/product_order_by', 'top_rating'),
(237, 'default', 0, 'sns_products_cfg/general/product_order_dir', 'asc'),
(238, 'default', 0, 'sns_products_cfg/general/product_filter_by', 'all'),
(239, 'default', 0, 'sns_products_cfg/general/product_limitation', '24'),
(240, 'default', 0, 'sns_products_cfg/general/screen_phone', '1'),
(241, 'default', 0, 'sns_products_cfg/general/screen_xs', '3'),
(242, 'default', 0, 'sns_products_cfg/general/screen_sm', '3'),
(243, 'default', 0, 'sns_products_cfg/general/screen_md', '3'),
(244, 'default', 0, 'sns_products_cfg/general/screen_lg', '3'),
(245, 'default', 0, 'facebook_cfg/general/fanpageName', 'snstheme'),
(246, 'default', 0, 'facebook_cfg/general/isenabled', '1'),
(247, 'default', 0, 'facebook_cfg/general/numberDisplay', '20'),
(248, 'default', 0, 'facebook_cfg/general/title', 'Facebook'),
(249, 'default', 0, 'twitter_cfg/general/isenabled', '1'),
(250, 'default', 0, 'twitter_cfg/general/title', 'Twitter'),
(251, 'default', 0, 'twitter_cfg/general/widgets_id', '420187988887212033'),
(252, 'default', 0, 'twitter_cfg/general/limit', '2'),
(253, 'default', 0, 'twitter_cfg/general/follow_link', '1'),
(254, 'default', 0, 'twitter_cfg/general/avartar', '1'),
(255, 'default', 0, 'twitter_cfg/general/interact_link', '1'),
(256, 'default', 0, 'twitter_cfg/general/date', '1'),
(257, 'default', 0, 'sns_slideshow_cfg/general/title', 'SNS Slideshow'),
(258, 'default', 0, 'sns_slideshow_cfg/general/slide_width', '554'),
(259, 'default', 0, 'sns_slideshow_cfg/general/slide_height', '450'),
(260, 'default', 0, 'sns_slideshow_cfg/general/autoplay', '300000'),
(261, 'default', 0, 'sns_slideshow_cfg/general/pauseonhover', '1'),
(262, 'default', 0, 'sns_slideshow_cfg/general/slide_transitions', 'rotateoverlap,switch,rotaterelay,doors,rotateinplusoutminus,flytwins,rotateinminusoutplus,rotateaxisupoverlap,chessreplacetb,chessreplacelr,shifttb,shiftlr,returntb,returnlr,rotateaxisdown,extrudereplace,fade,fadeinl,fadeinr,fadeint,fadeinb,fadeinlr,fadeinlrchess,fadeintb,fadeintbchess,fadeincorners,fadeoutl,fadeoutr,fadeoutt,fadeoutb,fadeoutlr,fadeoutlrchess,fadeouttb,fadeouttbchess,fadeoutcorners,fadeflyinl,fadeflyinr,fadeflyint,fadeflyinb,fadeflyinlr,fadeflyinlrchess,fadeflyintb,fadeflyintbchess,fadeflyincorners,fadeflyoutl,fadeflyoutr,fadeflyoutt,fadeflyoutb,fadeflyoutlr,fadeflyoutlrchess,fadeflyouttb,fadeflyouttbchess,fadeflyoutcorners,fadeclipinh,fadeclipinv,fadeclipouth,fadeclipoutv,fadestairs,faderandom,fadeswirl,fadezigzag,swingoutsideinstairs,swingoutsideinzigzag,swingoutsideinswirl,swingoutsideinrandom,swingoutsideinrandomchess,swingoutsideinsquare,swingoutsideoutstairs,swingoutsideoutzigzag,swingoutsideoutswirl,swingoutsideoutrandom,swingoutsideoutrandomchess,swingoutsideoutsquare,swinginsideinstairs,swinginsideinzigzag,swinginsideinswirl,swinginsideinrandom,swinginsideinrandomchess,swinginsideinsquare,swinginsideoutzigzag,swinginsideoutswirl,dodgedanceoutsideinstairs,dodgedanceoutsideinswirl,dodgedanceoutsideinzigzag,dodgedanceoutsideinrandom,dodgedanceoutsideinrandomchess,dodgedanceoutsideinsquare,dodgedanceoutsideoutstairs,dodgedanceoutsideoutswirl,dodgedanceoutsideoutzigzag,dodgedanceoutsideoutrandom,dodgedanceoutsideoutrandomchess,dodgedanceoutsideoutsquare,dodgedanceinsideinstairs,dodgedanceinsideinswirl,dodgedanceinsideinzigzag,dodgedanceinsideinrandom,dodgedanceinsideinrandomchess,dodgedanceinsideinsquare,dodgedanceinsideoutstairs,dodgedanceinsideoutswirl,dodgedanceinsideoutzigzag,dodgedanceinsideoutrandom,dodgedanceinsideoutrandomchess,dodgedanceinsideoutsquare,dodgepetoutsideinstairs,dodgepetoutsideinswirl,dodgepetoutsideinzigzag,dodgepetoutsideinrandom,dodgepetoutsideinrandomchess,dodgepetoutsideinsquare,dodgepetoutsideoutstairs,dodgepetoutsideoutswirl,dodgepetoutsideoutzigzag,dodgepetoutsideoutrandom,dodgepetoutsideoutrandomchess,dodgepetoutsideoutsquare,dodgepetinsideinstairs,dodgepetinsideinswirl,dodgepetinsideinzigzag,dodgepetinsideinrandom,dodgepetinsideinrandomchess,dodgepetinsideinsquare,dodgepetinsideoutstairs,dodgepetinsideoutswirl,dodgepetinsideoutzigzag,dodgepetinsideoutrandom,dodgepetinsideoutrandomchess,dodgepetinsideoutsquare,dodgeoutsideoutstairs,dodgeoutsideoutswirl,dodgeoutsideoutzigzag,dodgeoutsideoutrandom,dodgeoutsideoutrandomchess,dodgeoutsideoutsquare,dodgeoutsideinstairs,dodgeoutsideinswirl,dodgeoutsideinzigzag,dodgeoutsideinrandom,dodgeoutsideinrandomchess,dodgeoutsideinsquare,dodgeinsideoutstairs,dodgeinsideoutswirl,dodgeinsideoutzigzag,dodgeinsideoutrandom,dodgeinsideoutrandomchess,dodgeinsideoutsquare,dodgeinsideinstairs,dodgeinsideinswirl,dodgeinsideinzigzag,dodgeinsideinrandom,dodgeinsideinrandomchess,dodgeinsideinsquare,dodgeinsideintl,dodgeinsideintr,dodgeinsideinbl,dodgeinsideinbr,dodgeinsideouttl,dodgeinsideouttr,dodgeinsideoutbl,dodgeinsideoutbr,flutteroutsidein,flutteroutsideinwind,flutteroutsideinswirl,flutteroutsideincolumn,flutteroutsideout,flutteroutsideoutwind,flutteroutsideoutswirl,flutteroutsideoutcolumn,flutterinsidein,flutterinsideinwind,flutterinsideinswirl,flutterinsideincolumn,flutterinsideout,flutterinsideoutwind,flutterinsideoutswirl,flutterinsideoutcolumn,rotatevdoubleplusin,rotatehdoubleplusin,rotatevdoubleminusin,rotatehdoubleminusin,rotatevdoubleplusout,rotatehdoubleplusout,rotatevdoubleminusout,rotatehdoubleminusout,rotatevforkplusin,rotatehforkplusin,rotatevforkplusout,rotatehforkplusout,rotatezoomplusin,rotatezoomplusinl,rotatezoomplusinr,rotatezoomplusint,rotatezoomplusinb,rotatezoomplusintl,rotatezoomplusintr,rotatezoomplusinbl,rotatezoomplusinbr,rotatezoomplusout,rotatezoomplusoutl,rotatezoomplusoutr,rotatezoomplusoutt,rotatezoomplusoutb,rotatezoomplusouttl,rotatezoomplusouttr,rotatezoomplusoutbl,rotatezoomplusoutbr,rotatezoomminusin,rotatezoomminusinl,rotatezoomminusinr,rotatezoomminusint,rotatezoomminusinb,rotatezoomminusintl,rotatezoomminusintr,rotatezoomminusinbl,rotatezoomminusinbr,rotatezoomminusout,rotatezoomminusoutl,rotatezoomminusoutr,rotatezoomminusoutt,rotatezoomminusoutb,rotatezoomminusouttl,rotatezoomminusouttr,rotatezoomminusoutbl,rotatezoomminusoutbr,zoomvdoubleplusin,zoomhdoubleplusin,zoomvdoubleminusin,zoomhdoubleminusin,zoomvdoubleplusout,zoomhdoubleplusout,zoomvdoubleminusout,zoomhdoubleminusout,zoomplusin,zoomplusinl,zoomplusinr,zoomplusint,zoomplusinb,zoomplusintl,zoomplusintr,zoomplusinbl,zoomplusinbr,zoomplusout,zoomplusoutl,zoomplusoutr,zoomplusoutt,zoomplusoutb,zoomplusouttl,zoomplusouttr,zoomplusoutbl,zoomplusoutbr,zoomminusin,zoomminusinl,zoomminusinr,zoomminusint,zoomminusinb,zoomminusintl,zoomminusintr,zoomminusinbl,zoomminusinbr,zoomminusout,zoomminusoutl,zoomminusoutr,zoomminusoutt,zoomminusoutb,zoomminusouttl,zoomminusouttr,zoomminusoutbl,zoomminusoutbr,collapsestairs,collapseswirl,collapsesquare,collapserectanglecross,collapserectangle,collapsecross,collapsecircle,collapsezigzag,collapserandom,expandstairs,expandstraight,expandswirl,expandsquare,expandrectanglecross,expandrectangle,expandcross,expandzigzag,expandrandom,dominoesstripe,extrudeoutstripe,extrudeinstripe,horizontalblindstripe,verticalblindstripe,horizontalstripe,verticalstripe,horizontalmovingstripe,verticalmovingstripe,horizontalfadestripe,verticalfadestripe,horizontalflystripe,verticalflystripe,horizontalchessstripe,verticalchessstripe,horizontalrandomfadestripe,verticalrandomfadestripe,horizontalbouncestripe,verticalbouncestripe,waveout,waveouteagle,waveoutswirl,waveoutzigzag,waveoutsquare,waveoutrectangle,waveoutcircle,waveoutcross,waveoutrectanglecross,wavein,waveineagle,waveinswirl,waveinzigzag,waveinsquare,waveinrectangle,waveincircle,waveincross,waveinrectanglecross,jumpoutstraight,jumpoutswirl,jumpoutzigzag,jumpoutsquare,jumpoutsquarewithchess,jumpoutrectangle,jumpoutcircle,jumpoutrectanglecross,jumpinstraight,jumpinswirl,jumpinzigzag,jumpinsquare,jumpinsquarewithchess,jumpinrectangle,jumpincircle,jumpinrectanglecross,parabolaswirlin,parabolaswirlout,parabolazigzagin,parabolazigzagout,parabolastairsin,parabolastairsout,floatrightrandom,floatuprandom,floatuprandomwithchess,floatrightzigzag,floatupzigzag,floatupzigzagwithchess,floatrightswirl,floatupswirl,floatupswirlwithchess,flyrightrandom,flyuprandom,flyuprandomwithchess,flyrightzigzag,flyupzigzag,flyupzigzagwithchess,flyrightswirl,flyupswirl,flyupswirlwithchess,slidedown,slideright,bouncedown,bounceright'),
(263, 'default', 0, 'sns_slideshow_cfg/general/rand_transition', '1'),
(264, 'default', 0, 'sns_slideshow_cfg/general/slides_html', 'amoda_slide_html1,amoda_slide_html2,amoda_slide_html3'),
(265, 'default', 0, 'sns_amoda_cfg/advance/quickView', '1'),
(266, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col7', 'amoda_footer_top7'),
(267, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col8', 'amoda_footer_top8'),
(268, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col9', 'amoda_footer_top9'),
(269, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col10', 'amoda_footer_top10'),
(270, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col11', 'amoda_footer_top11'),
(271, 'default', 0, 'sns_amoda_cfg/footer/staticblock_col12', 'amoda_footer_top12'),
(272, 'default', 0, 'sns_amoda_cfg/footer_top/status', '1'),
(273, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col1', 'amoda_footer_top1'),
(274, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col2', 'amoda_footer_top2'),
(275, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col3', 'amoda_footer_top3'),
(276, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col4', 'amoda_footer_top4'),
(277, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col5', 'amoda_footer_top5'),
(278, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col6', 'amoda_footer_top6'),
(279, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col7', 'amoda_footer_top7'),
(280, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col8', 'amoda_footer_top8'),
(281, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col9', 'amoda_footer_top9'),
(282, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col10', 'amoda_footer_top10'),
(283, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col11', 'amoda_footer_top11'),
(284, 'default', 0, 'sns_amoda_cfg/footer_top/staticblock_col12', 'amoda_footer_top12'),
(285, 'default', 0, 'sns_amoda_cfg/footer_middle/status', '1'),
(286, 'default', 0, 'sns_amoda_cfg/footer_middle/staticblock_col1', 'amoda_footer_middle1'),
(287, 'default', 0, 'sns_amoda_cfg/footer_middle/staticblock_col2', 'amoda_footer_middle2'),
(288, 'default', 0, 'sns_amoda_cfg/footer_middle/staticblock_col3', 'amoda_footer_middle3'),
(289, 'default', 0, 'sns_amoda_cfg/footer_middle/staticblock_col4', '0'),
(290, 'default', 0, 'sns_quicksearch_cfg/general/root_catalog', '4'),
(291, 'default', 0, 'sns_quicksearch_cfg/general/level', '3'),
(292, 'stores', 1, 'dev/debug/template_hints', '0'),
(293, 'default', 0, 'sns_producttabs_cfg/general/screen_xs_grid', '2'),
(294, 'default', 0, 'sns_producttabs_cfg/general/screen_sm_grid', '3'),
(295, 'default', 0, 'sns_producttabs_cfg/general/screen_md_grid', '3'),
(296, 'default', 0, 'sns_producttabs_cfg/general/screen_lg_grid', '3'),
(297, 'default', 0, 'twitter_cfg/general/account_name', NULL),
(298, 'default', 0, 'sns_amoda_cfg/menu/status', '1'),
(299, 'default', 0, 'sns_amoda_cfg/menu/customMainMenu', 'custom'),
(301, 'default', 0, 'blog/blog/enabled', '1'),
(302, 'default', 0, 'blog/blog/route', NULL),
(303, 'default', 0, 'blog/blog/title', 'Blog'),
(304, 'default', 0, 'blog/blog/keywords', NULL),
(305, 'default', 0, 'blog/blog/description', NULL),
(306, 'default', 0, 'blog/blog/layout', 'page/2columns-left.phtml'),
(307, 'default', 0, 'blog/blog/dateformat', 'full'),
(308, 'default', 0, 'blog/blog/blogcrumbs', '1'),
(309, 'default', 0, 'blog/blog/readmore', NULL),
(310, 'default', 0, 'blog/blog/useshortcontent', '1'),
(311, 'default', 0, 'blog/blog/parse_cms', '0'),
(312, 'default', 0, 'blog/blog/perpage', '3'),
(313, 'default', 0, 'blog/blog/categories_urls', '1'),
(314, 'default', 0, 'blog/blog/bookmarkslist', '0'),
(315, 'default', 0, 'blog/blog/bookmarkspost', '0'),
(316, 'default', 0, 'blog/blog/sorter', 'DESC'),
(317, 'default', 0, 'blog/menu/left', '2'),
(318, 'default', 0, 'blog/menu/right', '2'),
(319, 'default', 0, 'blog/menu/footer', '1'),
(320, 'default', 0, 'blog/menu/top', '1'),
(321, 'default', 0, 'blog/menu/recent', NULL),
(322, 'default', 0, 'blog/menu/category', '1'),
(323, 'default', 0, 'blog/menu/tagcloud_size', '10'),
(324, 'default', 0, 'blog/comments/enabled', '1'),
(325, 'default', 0, 'blog/comments/login', '1'),
(326, 'default', 0, 'blog/comments/approval', '1'),
(327, 'default', 0, 'blog/comments/loginauto', '1'),
(328, 'default', 0, 'blog/comments/recipient_email', NULL),
(329, 'default', 0, 'blog/comments/sender_email_identity', 'general'),
(330, 'default', 0, 'blog/comments/email_template', 'blog_comments_email_template'),
(331, 'default', 0, 'blog/comments/page_count', '10'),
(332, 'default', 0, 'blog/recaptcha/enabled', '0'),
(333, 'default', 0, 'blog/recaptcha/publickey', NULL),
(334, 'default', 0, 'blog/recaptcha/privatekey', NULL),
(335, 'default', 0, 'blog/rss/enable', '0'),
(336, 'default', 0, 'blog/rss/image', NULL),
(337, 'default', 0, 'blog/rss/posts', NULL),
(338, 'default', 0, 'sns_producttabs_cfg/general/screen_phone_grid', '2'),
(339, 'stores', 1, 'dev/translate_inline/active', '0'),
(340, 'stores', 2, 'sns_amoda_cfg/general/layoutType', '1'),
(341, 'default', 0, 'sns_proaddto_cfg/general/isenabled', '1'),
(342, 'default', 0, 'sns_proaddto_cfg/confirmbox/width', '100'),
(343, 'default', 0, 'sns_proaddto_cfg/confirmbox/height', '120'),
(344, 'default', 0, 'sns_proaddto_cfg/confirmbox/autoclose', '1'),
(345, 'default', 0, 'sns_proaddto_cfg/confirmbox/timer', '8'),
(346, 'default', 0, 'sns_amoda_cfg/slidercategory/enabled', '1'),
(347, 'default', 0, 'sns_amoda_cfg/slidercategory/title', 'Hot categories'),
(348, 'default', 0, 'sns_amoda_cfg/slidercategory/bg_color', NULL),
(349, 'default', 0, 'sns_amoda_cfg/slidercategory/bg_img', NULL),
(350, 'default', 0, 'sns_amoda_cfg/slidercategory/category', 'a:6:{s:18:"_1431572912316_316";a:5:{s:5:"title";s:5:"Watch";s:4:"icon";s:13:"fa fa-clock-o";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat1";s:5:"image";s:32:"wysiwyg/amoda/static-block-8.jpg";}s:18:"_1431572916446_446";a:5:{s:5:"title";s:6:"Camera";s:4:"icon";s:12:"fa fa-camera";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat2";s:5:"image";s:32:"wysiwyg/amoda/static-block-7.jpg";}s:17:"_1431574329066_66";a:5:{s:5:"title";s:5:"Phone";s:4:"icon";s:11:"fa fa-phone";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat3";s:5:"image";s:32:"wysiwyg/amoda/static-block-6.jpg";}s:18:"_1431574330120_120";a:5:{s:5:"title";s:6:"Laptop";s:4:"icon";s:12:"fa fa-laptop";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat4";s:5:"image";s:33:"wysiwyg/amoda/static-block-10.jpg";}s:18:"_1431574331880_880";a:5:{s:5:"title";s:10:"TV & Audio";s:4:"icon";s:16:"fa fa-desktop fa";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat5";s:5:"image";s:32:"wysiwyg/amoda/static-block-9.jpg";}s:18:"_1435630931434_434";a:5:{s:5:"title";s:6:"Laptop";s:4:"icon";s:12:"fa fa-laptop";s:4:"link";s:8:"men.html";s:8:"block_id";s:16:"amoda_slidercat3";s:5:"image";s:32:"wysiwyg/amoda/static-block-6.jpg";}}'),
(351, 'stores', 2, 'web/default/cms_home_page', 'amoda_home_page_v2'),
(352, 'stores', 2, 'sns_slideshow_cfg/general/slide_width', '843'),
(353, 'stores', 2, 'sns_slideshow_cfg/general/slides_html', 'amoda_slide2_html1,amoda_slide2_html2,amoda_slide2_html3'),
(354, 'stores', 3, 'web/default/cms_home_page', 'amoda_home_page_v3'),
(355, 'stores', 3, 'sns_slideshow_cfg/general/slide_width', '1920'),
(356, 'stores', 3, 'sns_slideshow_cfg/general/slide_height', '562'),
(357, 'stores', 3, 'sns_slideshow_cfg/general/slides_html', 'amoda_slide3_html1,amoda_slide3_html2,amoda_slide3_html3'),
(358, 'stores', 3, 'sns_slideshow_cfg/general/autoplay', '3000'),
(359, 'stores', 3, 'sns_producttabs_cfg/general/screen_md', '3'),
(360, 'stores', 3, 'sns_producttabs_cfg/general/screen_lg', '3'),
(361, 'stores', 4, 'sns_amoda_cfg/general/layoutType', '2'),
(362, 'stores', 4, 'sns_amoda_cfg/general/bodyBgImage', 'pattern_5'),
(363, 'stores', 4, 'web/default/cms_home_page', 'amoda_home_page_v2'),
(364, 'stores', 4, 'sns_slideshow_cfg/general/slide_width', '843'),
(365, 'stores', 4, 'sns_slideshow_cfg/general/slide_height', '450'),
(366, 'stores', 4, 'sns_slideshow_cfg/general/slides_html', 'amoda_slide2_html1,amoda_slide2_html2,amoda_slide2_html3'),
(367, 'default', 0, 'web/url/use_store', '0'),
(368, 'default', 0, 'web/url/redirect_to_base', '1'),
(369, 'default', 0, 'web/seo/use_rewrites', '0'),
(370, 'default', 0, 'web/unsecure/base_link_url', '{{unsecure_base_url}}'),
(371, 'default', 0, 'web/unsecure/base_skin_url', '{{unsecure_base_url}}skin/'),
(372, 'default', 0, 'web/unsecure/base_media_url', '{{unsecure_base_url}}media/'),
(373, 'default', 0, 'web/unsecure/base_js_url', '{{unsecure_base_url}}js/'),
(374, 'default', 0, 'web/secure/base_link_url', '{{secure_base_url}}'),
(375, 'default', 0, 'web/secure/base_skin_url', '{{secure_base_url}}skin/'),
(376, 'default', 0, 'web/secure/base_media_url', '{{secure_base_url}}media/'),
(377, 'default', 0, 'web/secure/base_js_url', '{{secure_base_url}}js/'),
(378, 'default', 0, 'web/secure/use_in_frontend', '0'),
(379, 'default', 0, 'web/secure/use_in_adminhtml', '0'),
(380, 'default', 0, 'web/secure/offloader_header', 'SSL_OFFLOADED'),
(381, 'default', 0, 'web/default/front', 'cms'),
(382, 'default', 0, 'web/default/no_route', 'cms/index/noRoute'),
(383, 'default', 0, 'web/default/cms_no_route', 'amoda_no_route'),
(384, 'default', 0, 'web/default/cms_no_cookies', 'enable-cookies'),
(385, 'default', 0, 'web/default/show_cms_breadcrumbs', '1'),
(386, 'default', 0, 'web/polls/poll_check_by_ip', '0'),
(387, 'default', 0, 'web/cookie/cookie_lifetime', '3600'),
(388, 'default', 0, 'web/cookie/cookie_path', NULL),
(389, 'default', 0, 'web/cookie/cookie_domain', NULL),
(390, 'default', 0, 'web/cookie/cookie_httponly', '1'),
(391, 'default', 0, 'web/cookie/cookie_restriction', '0'),
(392, 'default', 0, 'web/session/use_remote_addr', '0'),
(393, 'default', 0, 'web/session/use_http_via', '0'),
(394, 'default', 0, 'web/session/use_http_x_forwarded_for', '0'),
(395, 'default', 0, 'web/session/use_http_user_agent', '0'),
(396, 'default', 0, 'web/session/use_frontend_sid', '1'),
(397, 'default', 0, 'web/browser_capabilities/cookies', '1'),
(398, 'default', 0, 'web/browser_capabilities/javascript', '1'),
(399, 'stores', 1, 'sns_producttabs_cfg/general/screen_sm_grid', '2'),
(400, 'stores', 2, 'sns_producttabs_cfg/general/screen_sm_grid', '2'),
(401, 'stores', 3, 'sns_producttabs_cfg/general/product_category', '3,43,47');

CREATE TABLE IF NOT EXISTS `#__core_email_queue` (
`message_id` int(10) unsigned NOT NULL COMMENT 'Message Id',
  `entity_id` int(10) unsigned DEFAULT NULL COMMENT 'Entity ID',
  `entity_type` varchar(128) DEFAULT NULL COMMENT 'Entity Type',
  `event_type` varchar(128) DEFAULT NULL COMMENT 'Event Type',
  `message_body_hash` varchar(64) NOT NULL COMMENT 'Message Body Hash',
  `message_body` mediumtext NOT NULL COMMENT 'Message Body',
  `message_parameters` text NOT NULL COMMENT 'Message Parameters',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Creation Time',
  `processed_at` timestamp NULL DEFAULT NULL COMMENT 'Finish Time'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Email Queue' AUTO_INCREMENT=2 ;

CREATE TABLE IF NOT EXISTS `#__core_email_queue_recipients` (
`recipient_id` int(10) unsigned NOT NULL COMMENT 'Recipient Id',
  `message_id` int(10) unsigned NOT NULL COMMENT 'Message ID',
  `recipient_email` varchar(128) NOT NULL COMMENT 'Recipient Email',
  `recipient_name` varchar(255) NOT NULL COMMENT 'Recipient Name',
  `email_type` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Email Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Email Queue' AUTO_INCREMENT=2 ;

INSERT INTO `#__core_email_queue_recipients` (`recipient_id`, `message_id`, `recipient_email`, `recipient_name`, `email_type`) VALUES
(1, 1, 'admin@mystore.com', 'nguyen nguyen', 0);

CREATE TABLE IF NOT EXISTS `#__core_email_template` (
`template_id` int(10) unsigned NOT NULL COMMENT 'Template Id',
  `template_code` varchar(150) NOT NULL COMMENT 'Template Name',
  `template_text` text NOT NULL COMMENT 'Template Content',
  `template_styles` text COMMENT 'Templste Styles',
  `template_type` int(10) unsigned DEFAULT NULL COMMENT 'Template Type',
  `template_subject` varchar(200) NOT NULL COMMENT 'Template Subject',
  `template_sender_name` varchar(200) DEFAULT NULL COMMENT 'Template Sender Name',
  `template_sender_email` varchar(200) DEFAULT NULL COMMENT 'Template Sender Email',
  `added_at` timestamp NULL DEFAULT NULL COMMENT 'Date of Template Creation',
  `modified_at` timestamp NULL DEFAULT NULL COMMENT 'Date of Template Modification',
  `orig_template_code` varchar(200) DEFAULT NULL COMMENT 'Original Template Code',
  `orig_template_variables` text COMMENT 'Original Template Variables'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Email Templates' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_flag` (
`flag_id` int(10) unsigned NOT NULL COMMENT 'Flag Id',
  `flag_code` varchar(255) NOT NULL COMMENT 'Flag Code',
  `state` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Flag State',
  `flag_data` text COMMENT 'Flag Data',
  `last_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT 'Date of Last Flag Update'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Flag' AUTO_INCREMENT=3 ;

INSERT INTO `#__core_flag` (`flag_id`, `flag_code`, `state`, `flag_data`, `last_update`) VALUES
(1, 'admin_notification_survey', 0, 'a:1:{s:13:"survey_viewed";b:1;}', '2015-07-14 19:27:08'),
(2, 'catalog_product_flat', 0, 'a:6:{s:8:"is_built";b:1;s:16:"is_store_built_1";b:1;s:16:"is_store_built_2";b:1;s:16:"is_store_built_3";b:1;s:16:"is_store_built_4";b:1;s:16:"is_store_built_5";b:1;}', '2015-07-14 19:28:30');

CREATE TABLE IF NOT EXISTS `#__core_layout_link` (
`layout_link_id` int(10) unsigned NOT NULL COMMENT 'Link Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `area` varchar(64) DEFAULT NULL COMMENT 'Area',
  `package` varchar(64) DEFAULT NULL COMMENT 'Package',
  `theme` varchar(64) DEFAULT NULL COMMENT 'Theme',
  `layout_update_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Layout Update Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Layout Link' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_layout_update` (
`layout_update_id` int(10) unsigned NOT NULL COMMENT 'Layout Update Id',
  `handle` varchar(255) DEFAULT NULL COMMENT 'Handle',
  `xml` text COMMENT 'Xml',
  `sort_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Layout Updates' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_resource` (
  `code` varchar(50) NOT NULL COMMENT 'Resource Code',
  `version` varchar(50) DEFAULT NULL COMMENT 'Resource Version',
  `data_version` varchar(50) DEFAULT NULL COMMENT 'Data Version'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Resources';

INSERT INTO `#__core_resource` (`code`, `version`, `data_version`) VALUES
('adminnotification_setup', '1.6.0.0', '1.6.0.0'),
('admin_setup', '1.6.1.1', '1.6.1.1'),
('api2_setup', '1.0.0.0', '1.0.0.0'),
('api_setup', '1.6.0.1', '1.6.0.1'),
('backup_setup', '1.6.0.0', '1.6.0.0'),
('blog_setup', '1.3.5', '1.3.5'),
('bundle_setup', '1.6.0.0.1', '1.6.0.0.1'),
('captcha_setup', '1.7.0.0.0', '1.7.0.0.0'),
('catalogindex_setup', '1.6.0.0', '1.6.0.0'),
('cataloginventory_setup', '1.6.0.0.2', '1.6.0.0.2'),
('catalogrule_setup', '1.6.0.3', '1.6.0.3'),
('catalogsearch_setup', '1.8.2.0', '1.8.2.0'),
('catalog_setup', '1.6.0.0.19.1.2', '1.6.0.0.19.1.2'),
('checkout_setup', '1.6.0.0', '1.6.0.0'),
('cms_setup', '1.6.0.0.2', '1.6.0.0.2'),
('compiler_setup', '1.6.0.0', '1.6.0.0'),
('contacts_setup', '1.6.0.0', '1.6.0.0'),
('core_setup', '1.6.0.6', '1.6.0.6'),
('cron_setup', '1.6.0.0', '1.6.0.0'),
('customer_setup', '1.6.2.0.4', '1.6.2.0.4'),
('dataflow_setup', '1.6.0.0', '1.6.0.0'),
('directory_setup', '1.6.0.3', '1.6.0.3'),
('downloadable_setup', '1.6.0.0.2', '1.6.0.0.2'),
('eav_setup', '1.6.0.1', '1.6.0.1'),
('facebook_setup', '1.1.0', '1.1.0'),
('giftmessage_setup', '1.6.0.0', '1.6.0.0'),
('googleanalytics_setup', '1.6.0.0', '1.6.0.0'),
('importexport_setup', '1.6.0.2', '1.6.0.2'),
('index_setup', '1.6.0.0', '1.6.0.0'),
('log_setup', '1.6.1.1', '1.6.1.1'),
('moneybookers_setup', '1.6.0.0', '1.6.0.0'),
('newsletter_setup', '1.6.0.2', '1.6.0.2'),
('oauth_setup', '1.0.0.0', '1.0.0.0'),
('paygate_setup', '1.6.0.0', '1.6.0.0'),
('payment_setup', '1.6.0.0', '1.6.0.0'),
('paypaluk_setup', '1.6.0.0', '1.6.0.0'),
('paypal_setup', '1.6.0.6', '1.6.0.6'),
('persistent_setup', '1.0.0.0', '1.0.0.0'),
('poll_setup', '1.6.0.1', '1.6.0.1'),
('proaddto_setup', '1.0.0', '1.0.0'),
('productalert_setup', '1.6.0.0', '1.6.0.0'),
('quicksearch_setup', '1.0.0', '1.0.0'),
('rating_setup', '1.6.0.1', '1.6.0.1'),
('reports_setup', '1.6.0.0.1', '1.6.0.0.1'),
('review_setup', '1.6.0.0', '1.6.0.0'),
('salesrule_setup', '1.6.0.3', '1.6.0.3'),
('sales_setup', '1.6.0.9', '1.6.0.9'),
('sendfriend_setup', '1.6.0.1', '1.6.0.1'),
('shipping_setup', '1.6.0.0', '1.6.0.0'),
('sitemap_setup', '1.6.0.0', '1.6.0.0'),
('sns_amoda_setup', '1.0.1', '1.0.1'),
('sns_products_setup', '1.1.0', '1.1.0'),
('sns_producttabs_setup', '2.0.0', '2.0.0'),
('sns_slideshow_setup', '1.0.0', '1.0.0'),
('tag_setup', '1.6.0.0', '1.6.0.0'),
('tax_setup', '1.6.0.4', '1.6.0.4'),
('twitter_setup', '1.1.0', '1.1.0'),
('usa_setup', '1.6.0.3', '1.6.0.3'),
('weee_setup', '1.6.0.0', '1.6.0.0'),
('widget_setup', '1.6.0.0', '1.6.0.0'),
('wishlist_setup', '1.6.0.0', '1.6.0.0');

CREATE TABLE IF NOT EXISTS `#__core_session` (
  `session_id` varchar(255) NOT NULL COMMENT 'Session Id',
  `session_expires` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Date of Session Expiration',
  `session_data` mediumblob NOT NULL COMMENT 'Session Data'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Database Sessions Storage';

CREATE TABLE IF NOT EXISTS `#__core_store` (
`store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Group Id',
  `name` varchar(255) NOT NULL COMMENT 'Store Name',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Sort Order',
  `is_active` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Activity'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Stores' AUTO_INCREMENT=6 ;

INSERT INTO `#__core_store` (`store_id`, `code`, `website_id`, `group_id`, `name`, `sort_order`, `is_active`) VALUES
(0, 'admin', 0, 0, 'Admin', 0, 1),
(1, 'english', 1, 1, 'English', 0, 1),
(2, 'french', 1, 1, 'French', 0, 1),
(3, 'germany', 1, 1, 'Germany', 0, 1),
(4, 'italy', 1, 1, 'Italy', 0, 1),
(5, 'potugar', 1, 1, 'Potugar', 0, 0);

CREATE TABLE IF NOT EXISTS `#__core_store_group` (
`group_id` smallint(5) unsigned NOT NULL COMMENT 'Group Id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `name` varchar(255) NOT NULL COMMENT 'Store Group Name',
  `root_category_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Root Category Id',
  `default_store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Default Store Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Store Groups' AUTO_INCREMENT=2 ;

INSERT INTO `#__core_store_group` (`group_id`, `website_id`, `name`, `root_category_id`, `default_store_id`) VALUES
(0, 0, 'Default', 0, 0),
(1, 1, 'Main Website Store', 2, 1);

CREATE TABLE IF NOT EXISTS `#__core_translate` (
`key_id` int(10) unsigned NOT NULL COMMENT 'Key Id of Translation',
  `string` varchar(255) NOT NULL DEFAULT 'Translate String' COMMENT 'Translation String',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `translate` varchar(255) DEFAULT NULL COMMENT 'Translate',
  `locale` varchar(20) NOT NULL DEFAULT 'en_US' COMMENT 'Locale',
  `crc_string` bigint(20) NOT NULL DEFAULT '1591228201' COMMENT 'Translation String CRC32 Hash'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Translations' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_url_rewrite` (
`url_rewrite_id` int(10) unsigned NOT NULL COMMENT 'Rewrite Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `id_path` varchar(255) DEFAULT NULL COMMENT 'Id Path',
  `request_path` varchar(255) DEFAULT NULL COMMENT 'Request Path',
  `target_path` varchar(255) DEFAULT NULL COMMENT 'Target Path',
  `is_system` smallint(5) unsigned DEFAULT '1' COMMENT 'Defines is Rewrite System',
  `options` varchar(255) DEFAULT NULL COMMENT 'Options',
  `description` varchar(255) DEFAULT NULL COMMENT 'Deascription',
  `category_id` int(10) unsigned DEFAULT NULL COMMENT 'Category Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Url Rewrites' AUTO_INCREMENT=64364 ;

INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(1, 1, 'category/3', 'men.html', 'catalog/category/view/id/3', 1, NULL, NULL, 3, NULL),
(44, 2, 'category/3', 'men.html', 'catalog/category/view/id/3', 1, NULL, NULL, 3, NULL),
(57, 1, 'product/7', 'configurable-product.html', 'catalog/product/view/id/7', 1, NULL, NULL, NULL, 7),
(58, 1, 'product/7/3', 'men/configurable-product.html', 'catalog/product/view/id/7/category/3', 1, NULL, NULL, 3, 7),
(59, 2, 'product/7', 'configurable-product.html', 'catalog/product/view/id/7', 1, NULL, NULL, NULL, 7),
(60, 2, 'product/7/3', 'men/configurable-product.html', 'catalog/product/view/id/7/category/3', 1, NULL, NULL, 3, 7),
(61, 1, 'product/8', 'configurable-product-armani-black.html', 'catalog/product/view/id/8', 1, NULL, NULL, NULL, 8),
(62, 2, 'product/8', 'configurable-product-armani-black.html', 'catalog/product/view/id/8', 1, NULL, NULL, NULL, 8),
(63, 1, 'product/9', 'configurable-product-armani-blue.html', 'catalog/product/view/id/9', 1, NULL, NULL, NULL, 9),
(64, 2, 'product/9', 'configurable-product-armani-blue.html', 'catalog/product/view/id/9', 1, NULL, NULL, NULL, 9),
(65, 1, 'product/10', 'configurable-product-armani-green.html', 'catalog/product/view/id/10', 1, NULL, NULL, NULL, 10),
(66, 2, 'product/10', 'configurable-product-armani-green.html', 'catalog/product/view/id/10', 1, NULL, NULL, NULL, 10),
(67, 1, 'product/11', 'configurable-product-buberry-red.html', 'catalog/product/view/id/11', 1, NULL, NULL, NULL, 11),
(68, 2, 'product/11', 'configurable-product-buberry-red.html', 'catalog/product/view/id/11', 1, NULL, NULL, NULL, 11),
(69, 1, 'product/12', 'configurable-product-buberry-green.html', 'catalog/product/view/id/12', 1, NULL, NULL, NULL, 12),
(70, 2, 'product/12', 'configurable-product-buberry-green.html', 'catalog/product/view/id/12', 1, NULL, NULL, NULL, 12),
(139, 1, 'product/8/3', 'men/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/3', 1, NULL, NULL, 3, 8),
(141, 1, 'product/9/3', 'men/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/3', 1, NULL, NULL, 3, 9),
(143, 1, 'product/10/3', 'men/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/3', 1, NULL, NULL, 3, 10),
(145, 1, 'product/11/3', 'men/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/3', 1, NULL, NULL, 3, 11),
(147, 1, 'product/12/3', 'men/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/3', 1, NULL, NULL, 3, 12),
(152, 2, 'product/8/3', 'men/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/3', 1, NULL, NULL, 3, 8),
(154, 2, 'product/9/3', 'men/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/3', 1, NULL, NULL, 3, 9),
(156, 2, 'product/10/3', 'men/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/3', 1, NULL, NULL, 3, 10),
(158, 2, 'product/11/3', 'men/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/3', 1, NULL, NULL, 3, 11),
(160, 2, 'product/12/3', 'men/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/3', 1, NULL, NULL, 3, 12),
(161, 1, 'product/13', 'configurable-product-02.html', 'catalog/product/view/id/13', 1, NULL, NULL, NULL, 13),
(162, 1, 'product/13/3', 'men/configurable-product-02.html', 'catalog/product/view/id/13/category/3', 1, NULL, NULL, 3, 13),
(163, 2, 'product/13', 'configurable-product-02.html', 'catalog/product/view/id/13', 1, NULL, NULL, NULL, 13),
(164, 2, 'product/13/3', 'men/configurable-product-02.html', 'catalog/product/view/id/13/category/3', 1, NULL, NULL, 3, 13),
(165, 1, 'product/14', 'configurable-product-02-chanel-black.html', 'catalog/product/view/id/14', 1, NULL, NULL, NULL, 14),
(166, 2, 'product/14', 'configurable-product-02-chanel-black.html', 'catalog/product/view/id/14', 1, NULL, NULL, NULL, 14),
(167, 1, 'product/15', 'configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15', 1, NULL, NULL, NULL, 15),
(168, 2, 'product/15', 'configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15', 1, NULL, NULL, NULL, 15),
(169, 1, 'product/16', 'configurable-product-02-dior-green.html', 'catalog/product/view/id/16', 1, NULL, NULL, NULL, 16),
(170, 2, 'product/16', 'configurable-product-02-dior-green.html', 'catalog/product/view/id/16', 1, NULL, NULL, NULL, 16),
(171, 1, 'product/17', 'configurable-product-02-gucci-red.html', 'catalog/product/view/id/17', 1, NULL, NULL, NULL, 17),
(172, 2, 'product/17', 'configurable-product-02-gucci-red.html', 'catalog/product/view/id/17', 1, NULL, NULL, NULL, 17),
(173, 1, 'product/18', 'configurable-product-02-gucci-white.html', 'catalog/product/view/id/18', 1, NULL, NULL, NULL, 18),
(174, 2, 'product/18', 'configurable-product-02-gucci-white.html', 'catalog/product/view/id/18', 1, NULL, NULL, NULL, 18),
(191, 1, 'product/14/3', 'men/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/3', 1, NULL, NULL, 3, 14),
(193, 1, 'product/15/3', 'men/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/3', 1, NULL, NULL, 3, 15),
(195, 1, 'product/16/3', 'men/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/3', 1, NULL, NULL, 3, 16),
(197, 1, 'product/17/3', 'men/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/3', 1, NULL, NULL, 3, 17),
(199, 1, 'product/18/3', 'men/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/3', 1, NULL, NULL, 3, 18),
(216, 2, 'product/14/3', 'men/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/3', 1, NULL, NULL, 3, 14),
(218, 2, 'product/15/3', 'men/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/3', 1, NULL, NULL, 3, 15),
(220, 2, 'product/16/3', 'men/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/3', 1, NULL, NULL, 3, 16),
(222, 2, 'product/17/3', 'men/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/3', 1, NULL, NULL, 3, 17),
(224, 2, 'product/18/3', 'men/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/3', 1, NULL, NULL, 3, 18),
(225, 1, 'product/19', 'configurable-product-03.html', 'catalog/product/view/id/19', 1, NULL, NULL, NULL, 19),
(226, 1, 'product/19/3', 'men/configurable-product-03.html', 'catalog/product/view/id/19/category/3', 1, NULL, NULL, 3, 19),
(227, 2, 'product/19', 'configurable-product-03.html', 'catalog/product/view/id/19', 1, NULL, NULL, NULL, 19),
(228, 2, 'product/19/3', 'men/configurable-product-03.html', 'catalog/product/view/id/19/category/3', 1, NULL, NULL, 3, 19),
(229, 1, 'product/20', 'configurable-product-04.html', 'catalog/product/view/id/20', 1, NULL, NULL, NULL, 20),
(230, 1, 'product/20/3', 'men/configurable-product-04.html', 'catalog/product/view/id/20/category/3', 1, NULL, NULL, 3, 20),
(231, 2, 'product/20', 'configurable-product-04.html', 'catalog/product/view/id/20', 1, NULL, NULL, NULL, 20),
(232, 2, 'product/20/3', 'men/configurable-product-04.html', 'catalog/product/view/id/20/category/3', 1, NULL, NULL, 3, 20),
(233, 1, 'product/21', 'configurable-product-05.html', 'catalog/product/view/id/21', 1, NULL, NULL, NULL, 21),
(234, 1, 'product/21/3', 'men/configurable-product-05.html', 'catalog/product/view/id/21/category/3', 1, NULL, NULL, 3, 21),
(235, 2, 'product/21', 'configurable-product-05.html', 'catalog/product/view/id/21', 1, NULL, NULL, NULL, 21),
(236, 2, 'product/21/3', 'men/configurable-product-05.html', 'catalog/product/view/id/21/category/3', 1, NULL, NULL, 3, 21),
(237, 1, 'product/22', 'configurable-product-03-hermes-white.html', 'catalog/product/view/id/22', 1, NULL, NULL, NULL, 22),
(238, 2, 'product/22', 'configurable-product-03-hermes-white.html', 'catalog/product/view/id/22', 1, NULL, NULL, NULL, 22),
(239, 1, 'product/23', 'configurable-product-03-prada-black.html', 'catalog/product/view/id/23', 1, NULL, NULL, NULL, 23),
(240, 2, 'product/23', 'configurable-product-03-prada-black.html', 'catalog/product/view/id/23', 1, NULL, NULL, NULL, 23),
(241, 1, 'product/24', 'configurable-product-03-versace-blue.html', 'catalog/product/view/id/24', 1, NULL, NULL, NULL, 24),
(242, 2, 'product/24', 'configurable-product-03-versace-blue.html', 'catalog/product/view/id/24', 1, NULL, NULL, NULL, 24),
(243, 1, 'product/25', 'configurable-product-03-prada-green.html', 'catalog/product/view/id/25', 1, NULL, NULL, NULL, 25),
(244, 2, 'product/25', 'configurable-product-03-prada-green.html', 'catalog/product/view/id/25', 1, NULL, NULL, NULL, 25),
(245, 1, 'product/26', 'configurable-product-03-prada-red.html', 'catalog/product/view/id/26', 1, NULL, NULL, NULL, 26),
(246, 2, 'product/26', 'configurable-product-03-prada-red.html', 'catalog/product/view/id/26', 1, NULL, NULL, NULL, 26),
(279, 1, 'product/22/3', 'men/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/3', 1, NULL, NULL, 3, 22),
(281, 1, 'product/23/3', 'men/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/3', 1, NULL, NULL, 3, 23),
(283, 1, 'product/24/3', 'men/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/3', 1, NULL, NULL, 3, 24),
(285, 1, 'product/25/3', 'men/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/3', 1, NULL, NULL, 3, 25),
(287, 1, 'product/26/3', 'men/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/3', 1, NULL, NULL, 3, 26),
(320, 2, 'product/22/3', 'men/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/3', 1, NULL, NULL, 3, 22),
(322, 2, 'product/23/3', 'men/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/3', 1, NULL, NULL, 3, 23),
(324, 2, 'product/24/3', 'men/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/3', 1, NULL, NULL, 3, 24),
(326, 2, 'product/25/3', 'men/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/3', 1, NULL, NULL, 3, 25),
(328, 2, 'product/26/3', 'men/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/3', 1, NULL, NULL, 3, 26),
(329, 1, 'product/27', 'configurable-product-04-black.html', 'catalog/product/view/id/27', 1, NULL, NULL, NULL, 27),
(330, 2, 'product/27', 'configurable-product-04-black.html', 'catalog/product/view/id/27', 1, NULL, NULL, NULL, 27),
(331, 1, 'product/28', 'configurable-product-04-white.html', 'catalog/product/view/id/28', 1, NULL, NULL, NULL, 28),
(332, 2, 'product/28', 'configurable-product-04-white.html', 'catalog/product/view/id/28', 1, NULL, NULL, NULL, 28),
(333, 1, 'product/29', 'configurable-product-04-red.html', 'catalog/product/view/id/29', 1, NULL, NULL, NULL, 29),
(334, 2, 'product/29', 'configurable-product-04-red.html', 'catalog/product/view/id/29', 1, NULL, NULL, NULL, 29),
(335, 1, 'product/30', 'configurable-product-04-green.html', 'catalog/product/view/id/30', 1, NULL, NULL, NULL, 30),
(336, 2, 'product/30', 'configurable-product-04-green.html', 'catalog/product/view/id/30', 1, NULL, NULL, NULL, 30),
(337, 1, 'product/31', 'configurable-product-04-blue.html', 'catalog/product/view/id/31', 1, NULL, NULL, NULL, 31),
(338, 2, 'product/31', 'configurable-product-04-blue.html', 'catalog/product/view/id/31', 1, NULL, NULL, NULL, 31),
(381, 1, 'product/27/3', 'men/configurable-product-04-black.html', 'catalog/product/view/id/27/category/3', 1, NULL, NULL, 3, 27),
(383, 1, 'product/28/3', 'men/configurable-product-04-white.html', 'catalog/product/view/id/28/category/3', 1, NULL, NULL, 3, 28),
(385, 1, 'product/29/3', 'men/configurable-product-04-red.html', 'catalog/product/view/id/29/category/3', 1, NULL, NULL, 3, 29),
(387, 1, 'product/30/3', 'men/configurable-product-04-green.html', 'catalog/product/view/id/30/category/3', 1, NULL, NULL, 3, 30),
(389, 1, 'product/31/3', 'men/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/3', 1, NULL, NULL, 3, 31),
(432, 2, 'product/27/3', 'men/configurable-product-04-black.html', 'catalog/product/view/id/27/category/3', 1, NULL, NULL, 3, 27),
(434, 2, 'product/28/3', 'men/configurable-product-04-white.html', 'catalog/product/view/id/28/category/3', 1, NULL, NULL, 3, 28),
(436, 2, 'product/29/3', 'men/configurable-product-04-red.html', 'catalog/product/view/id/29/category/3', 1, NULL, NULL, 3, 29),
(438, 2, 'product/30/3', 'men/configurable-product-04-green.html', 'catalog/product/view/id/30/category/3', 1, NULL, NULL, 3, 30),
(440, 2, 'product/31/3', 'men/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/3', 1, NULL, NULL, 3, 31),
(441, 1, 'product/32', 'configurable-product-05-armani.html', 'catalog/product/view/id/32', 1, NULL, NULL, NULL, 32),
(442, 2, 'product/32', 'configurable-product-05-armani.html', 'catalog/product/view/id/32', 1, NULL, NULL, NULL, 32),
(443, 1, 'product/33', 'configurable-product-05-buberry.html', 'catalog/product/view/id/33', 1, NULL, NULL, NULL, 33),
(444, 2, 'product/33', 'configurable-product-05-buberry.html', 'catalog/product/view/id/33', 1, NULL, NULL, NULL, 33),
(445, 1, 'product/34', 'configurable-product-05-chanel.html', 'catalog/product/view/id/34', 1, NULL, NULL, NULL, 34),
(446, 2, 'product/34', 'configurable-product-05-chanel.html', 'catalog/product/view/id/34', 1, NULL, NULL, NULL, 34),
(447, 1, 'product/35', 'configurable-product-05-hermes.html', 'catalog/product/view/id/35', 1, NULL, NULL, NULL, 35),
(448, 2, 'product/35', 'configurable-product-05-hermes.html', 'catalog/product/view/id/35', 1, NULL, NULL, NULL, 35),
(449, 1, 'product/36', 'configurable-product-05-versace.html', 'catalog/product/view/id/36', 1, NULL, NULL, NULL, 36),
(450, 2, 'product/36', 'configurable-product-05-versace.html', 'catalog/product/view/id/36', 1, NULL, NULL, NULL, 36),
(503, 1, 'product/32/3', 'men/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/3', 1, NULL, NULL, 3, 32),
(505, 1, 'product/33/3', 'men/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/3', 1, NULL, NULL, 3, 33),
(507, 1, 'product/34/3', 'men/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/3', 1, NULL, NULL, 3, 34),
(509, 1, 'product/35/3', 'men/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/3', 1, NULL, NULL, 3, 35),
(511, 1, 'product/36/3', 'men/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/3', 1, NULL, NULL, 3, 36),
(564, 2, 'product/32/3', 'men/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/3', 1, NULL, NULL, 3, 32),
(566, 2, 'product/33/3', 'men/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/3', 1, NULL, NULL, 3, 33),
(568, 2, 'product/34/3', 'men/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/3', 1, NULL, NULL, 3, 34),
(570, 2, 'product/35/3', 'men/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/3', 1, NULL, NULL, 3, 35),
(572, 2, 'product/36/3', 'men/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/3', 1, NULL, NULL, 3, 36),
(573, 1, 'product/37', 'simple-product-01.html', 'catalog/product/view/id/37', 1, NULL, NULL, NULL, 37),
(574, 2, 'product/37', 'simple-product-01.html', 'catalog/product/view/id/37', 1, NULL, NULL, NULL, 37),
(575, 1, 'product/38', 'simple-product-02.html', 'catalog/product/view/id/38', 1, NULL, NULL, NULL, 38),
(576, 2, 'product/38', 'simple-product-02.html', 'catalog/product/view/id/38', 1, NULL, NULL, NULL, 38),
(578, 1, '12691500_1417688529', 'simple-product-01-38.html', 'simple-product-02.html', 0, 'RP', NULL, NULL, 38),
(580, 2, '13396200_1417688529', 'simple-product-01-38.html', 'simple-product-02.html', 0, 'RP', NULL, NULL, 38),
(581, 1, 'product/39', 'simple-product-03.html', 'catalog/product/view/id/39', 1, NULL, NULL, NULL, 39),
(582, 2, 'product/39', 'simple-product-03.html', 'catalog/product/view/id/39', 1, NULL, NULL, NULL, 39),
(583, 1, 'product/40', 'simple-product-04.html', 'catalog/product/view/id/40', 1, NULL, NULL, NULL, 40),
(584, 2, 'product/40', 'simple-product-04.html', 'catalog/product/view/id/40', 1, NULL, NULL, NULL, 40),
(585, 1, 'product/41', 'simple-product-05.html', 'catalog/product/view/id/41', 1, NULL, NULL, NULL, 41),
(586, 2, 'product/41', 'simple-product-05.html', 'catalog/product/view/id/41', 1, NULL, NULL, NULL, 41),
(649, 1, 'product/37/3', 'men/simple-product-01.html', 'catalog/product/view/id/37/category/3', 1, NULL, NULL, 3, 37),
(651, 1, 'product/38/3', 'men/simple-product-02.html', 'catalog/product/view/id/38/category/3', 1, NULL, NULL, 3, 38),
(653, 1, 'product/39/3', 'men/simple-product-03.html', 'catalog/product/view/id/39/category/3', 1, NULL, NULL, 3, 39),
(655, 1, 'product/40/3', 'men/simple-product-04.html', 'catalog/product/view/id/40/category/3', 1, NULL, NULL, 3, 40),
(657, 1, 'product/41/3', 'men/simple-product-05.html', 'catalog/product/view/id/41/category/3', 1, NULL, NULL, 3, 41),
(720, 2, 'product/37/3', 'men/simple-product-01.html', 'catalog/product/view/id/37/category/3', 1, NULL, NULL, 3, 37),
(722, 2, 'product/38/3', 'men/simple-product-02.html', 'catalog/product/view/id/38/category/3', 1, NULL, NULL, 3, 38),
(724, 2, 'product/39/3', 'men/simple-product-03.html', 'catalog/product/view/id/39/category/3', 1, NULL, NULL, 3, 39),
(726, 2, 'product/40/3', 'men/simple-product-04.html', 'catalog/product/view/id/40/category/3', 1, NULL, NULL, 3, 40),
(728, 2, 'product/41/3', 'men/simple-product-05.html', 'catalog/product/view/id/41/category/3', 1, NULL, NULL, 3, 41),
(729, 1, 'product/42', 'grouped-product.html', 'catalog/product/view/id/42', 1, NULL, NULL, NULL, 42),
(730, 1, 'product/42/3', 'men/grouped-product.html', 'catalog/product/view/id/42/category/3', 1, NULL, NULL, 3, 42),
(731, 2, 'product/42', 'grouped-product.html', 'catalog/product/view/id/42', 1, NULL, NULL, NULL, 42),
(732, 2, 'product/42/3', 'men/grouped-product.html', 'catalog/product/view/id/42/category/3', 1, NULL, NULL, 3, 42),
(737, 1, 'product/44', 'bundle-product.html', 'catalog/product/view/id/44', 1, NULL, NULL, NULL, 44),
(738, 1, 'product/44/3', 'men/bundle-product.html', 'catalog/product/view/id/44/category/3', 1, NULL, NULL, 3, 44),
(739, 2, 'product/44', 'bundle-product.html', 'catalog/product/view/id/44', 1, NULL, NULL, NULL, 44),
(740, 2, 'product/44/3', 'men/bundle-product.html', 'catalog/product/view/id/44/category/3', 1, NULL, NULL, 3, 44),
(741, 1, 'product/45', 'bundle-product-02.html', 'catalog/product/view/id/45', 1, NULL, NULL, NULL, 45),
(742, 1, 'product/45/3', 'men/bundle-product-02.html', 'catalog/product/view/id/45/category/3', 1, NULL, NULL, 3, 45),
(743, 2, 'product/45', 'bundle-product-02.html', 'catalog/product/view/id/45', 1, NULL, NULL, NULL, 45),
(744, 2, 'product/45/3', 'men/bundle-product-02.html', 'catalog/product/view/id/45/category/3', 1, NULL, NULL, 3, 45),
(746, 1, '98759500_1417746288', 'bundle-product-45.html', 'bundle-product-02.html', 0, 'RP', NULL, NULL, 45),
(748, 1, '99173000_1417746288', 'men/bundle-product-45.html', 'men/bundle-product-02.html', 0, 'RP', NULL, 3, 45),
(750, 2, '99899600_1417746288', 'bundle-product-45.html', 'bundle-product-02.html', 0, 'RP', NULL, NULL, 45),
(752, 2, '00147000_1417746289', 'men/bundle-product-45.html', 'men/bundle-product-02.html', 0, 'RP', NULL, 3, 45),
(753, 1, 'product/46', 'downloadable-product.html', 'catalog/product/view/id/46', 1, NULL, NULL, NULL, 46),
(754, 1, 'product/46/3', 'men/downloadable-product.html', 'catalog/product/view/id/46/category/3', 1, NULL, NULL, 3, 46),
(755, 2, 'product/46', 'downloadable-product.html', 'catalog/product/view/id/46', 1, NULL, NULL, NULL, 46),
(756, 2, 'product/46/3', 'men/downloadable-product.html', 'catalog/product/view/id/46/category/3', 1, NULL, NULL, 3, 46),
(757, 1, 'product/47', 'no-image.html', 'catalog/product/view/id/47', 1, NULL, NULL, NULL, 47),
(758, 1, 'product/47/3', 'men/no-image.html', 'catalog/product/view/id/47/category/3', 1, NULL, NULL, 3, 47),
(759, 2, 'product/47', 'no-image.html', 'catalog/product/view/id/47', 1, NULL, NULL, NULL, 47),
(760, 2, 'product/47/3', 'men/no-image.html', 'catalog/product/view/id/47/category/3', 1, NULL, NULL, 3, 47),
(765, 1, 'category/5', 'kid.html', 'catalog/category/view/id/5', 1, NULL, NULL, 5, NULL),
(766, 2, 'category/5', 'kid.html', 'catalog/category/view/id/5', 1, NULL, NULL, 5, NULL),
(767, 1, 'category/6', 'accessories.html', 'catalog/category/view/id/6', 1, NULL, NULL, 6, NULL),
(768, 2, 'category/6', 'accessories.html', 'catalog/category/view/id/6', 1, NULL, NULL, 6, NULL),
(773, 1, 'category/4', 'women.html', 'catalog/category/view/id/4', 1, NULL, NULL, 4, NULL),
(775, 1, 'product/29/4', 'women/configurable-product-04-red.html', 'catalog/product/view/id/29/category/4', 1, NULL, NULL, 4, 29),
(777, 1, 'product/30/4', 'women/configurable-product-04-green.html', 'catalog/product/view/id/30/category/4', 1, NULL, NULL, 4, 30),
(779, 1, 'product/31/4', 'women/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/4', 1, NULL, NULL, 4, 31),
(781, 1, 'product/32/4', 'women/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/4', 1, NULL, NULL, 4, 32),
(783, 1, 'product/33/4', 'women/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/4', 1, NULL, NULL, 4, 33),
(785, 1, 'product/34/4', 'women/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/4', 1, NULL, NULL, 4, 34),
(787, 1, 'product/35/4', 'women/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/4', 1, NULL, NULL, 4, 35),
(789, 1, 'product/36/4', 'women/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/4', 1, NULL, NULL, 4, 36),
(791, 1, 'product/37/4', 'women/simple-product-01.html', 'catalog/product/view/id/37/category/4', 1, NULL, NULL, 4, 37),
(793, 1, 'product/38/4', 'women/simple-product-02.html', 'catalog/product/view/id/38/category/4', 1, NULL, NULL, 4, 38),
(795, 1, 'product/39/4', 'women/simple-product-03.html', 'catalog/product/view/id/39/category/4', 1, NULL, NULL, 4, 39),
(797, 1, 'product/40/4', 'women/simple-product-04.html', 'catalog/product/view/id/40/category/4', 1, NULL, NULL, 4, 40),
(799, 1, 'product/41/4', 'women/simple-product-05.html', 'catalog/product/view/id/41/category/4', 1, NULL, NULL, 4, 41),
(801, 1, 'product/42/4', 'women/grouped-product.html', 'catalog/product/view/id/42/category/4', 1, NULL, NULL, 4, 42),
(805, 1, 'product/44/4', 'women/bundle-product.html', 'catalog/product/view/id/44/category/4', 1, NULL, NULL, 4, 44),
(807, 1, 'product/45/4', 'women/bundle-product-02.html', 'catalog/product/view/id/45/category/4', 1, NULL, NULL, 4, 45),
(809, 1, 'product/46/4', 'women/downloadable-product.html', 'catalog/product/view/id/46/category/4', 1, NULL, NULL, 4, 46),
(811, 1, 'product/47/4', 'women/no-image.html', 'catalog/product/view/id/47/category/4', 1, NULL, NULL, 4, 47),
(814, 2, 'category/4', 'women.html', 'catalog/category/view/id/4', 1, NULL, NULL, 4, NULL),
(816, 2, 'product/29/4', 'women/configurable-product-04-red.html', 'catalog/product/view/id/29/category/4', 1, NULL, NULL, 4, 29),
(818, 2, 'product/30/4', 'women/configurable-product-04-green.html', 'catalog/product/view/id/30/category/4', 1, NULL, NULL, 4, 30),
(820, 2, 'product/31/4', 'women/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/4', 1, NULL, NULL, 4, 31),
(822, 2, 'product/32/4', 'women/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/4', 1, NULL, NULL, 4, 32),
(824, 2, 'product/33/4', 'women/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/4', 1, NULL, NULL, 4, 33),
(826, 2, 'product/34/4', 'women/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/4', 1, NULL, NULL, 4, 34),
(828, 2, 'product/35/4', 'women/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/4', 1, NULL, NULL, 4, 35),
(830, 2, 'product/36/4', 'women/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/4', 1, NULL, NULL, 4, 36),
(832, 2, 'product/37/4', 'women/simple-product-01.html', 'catalog/product/view/id/37/category/4', 1, NULL, NULL, 4, 37),
(834, 2, 'product/38/4', 'women/simple-product-02.html', 'catalog/product/view/id/38/category/4', 1, NULL, NULL, 4, 38),
(836, 2, 'product/39/4', 'women/simple-product-03.html', 'catalog/product/view/id/39/category/4', 1, NULL, NULL, 4, 39),
(838, 2, 'product/40/4', 'women/simple-product-04.html', 'catalog/product/view/id/40/category/4', 1, NULL, NULL, 4, 40),
(840, 2, 'product/41/4', 'women/simple-product-05.html', 'catalog/product/view/id/41/category/4', 1, NULL, NULL, 4, 41),
(842, 2, 'product/42/4', 'women/grouped-product.html', 'catalog/product/view/id/42/category/4', 1, NULL, NULL, 4, 42),
(846, 2, 'product/44/4', 'women/bundle-product.html', 'catalog/product/view/id/44/category/4', 1, NULL, NULL, 4, 44),
(848, 2, 'product/45/4', 'women/bundle-product-02.html', 'catalog/product/view/id/45/category/4', 1, NULL, NULL, 4, 45),
(850, 2, 'product/46/4', 'women/downloadable-product.html', 'catalog/product/view/id/46/category/4', 1, NULL, NULL, 4, 46),
(852, 2, 'product/47/4', 'women/no-image.html', 'catalog/product/view/id/47/category/4', 1, NULL, NULL, 4, 47),
(1160, 1, '67920200_1417750078', 'kid/accessories.html', 'accessories.html', 0, 'RP', NULL, 6, NULL),
(1162, 2, '68753400_1417750078', 'kid/accessories.html', 'accessories.html', 0, 'RP', NULL, 6, NULL),
(2079, 1, 'category/7', 'women/bags/shoes/rings.html', 'catalog/category/view/id/7', 1, NULL, NULL, 7, NULL),
(2080, 2, 'category/7', 'women/bags/shoes/rings.html', 'catalog/category/view/id/7', 1, NULL, NULL, 7, NULL),
(2081, 1, 'category/8', 'women/bags/shoes.html', 'catalog/category/view/id/8', 1, NULL, NULL, 8, NULL),
(2082, 2, 'category/8', 'women/bags/shoes.html', 'catalog/category/view/id/8', 1, NULL, NULL, 8, NULL),
(2089, 1, 'category/9', 'women/shapewear.html', 'catalog/category/view/id/9', 1, NULL, NULL, 9, NULL),
(2090, 2, 'category/9', 'women/shapewear.html', 'catalog/category/view/id/9', 1, NULL, NULL, 9, NULL),
(2091, 1, 'category/10', 'women/shapewear/sundresses.html', 'catalog/category/view/id/10', 1, NULL, NULL, 10, NULL),
(2092, 2, 'category/10', 'women/shapewear/sundresses.html', 'catalog/category/view/id/10', 1, NULL, NULL, 10, NULL),
(2093, 1, 'category/11', 'women/shapewear/footwear.html', 'catalog/category/view/id/11', 1, NULL, NULL, 11, NULL),
(2094, 2, 'category/11', 'women/shapewear/footwear.html', 'catalog/category/view/id/11', 1, NULL, NULL, 11, NULL),
(2095, 1, 'category/12', 'women/shapewear/novelty.html', 'catalog/category/view/id/12', 1, NULL, NULL, 12, NULL),
(2096, 2, 'category/12', 'women/shapewear/novelty.html', 'catalog/category/view/id/12', 1, NULL, NULL, 12, NULL),
(2097, 1, 'category/13', 'women/shapewear/outerwear.html', 'catalog/category/view/id/13', 1, NULL, NULL, 13, NULL),
(2098, 2, 'category/13', 'women/shapewear/outerwear.html', 'catalog/category/view/id/13', 1, NULL, NULL, 13, NULL),
(2099, 1, 'category/14', 'women/shapewear/hats.html', 'catalog/category/view/id/14', 1, NULL, NULL, 14, NULL),
(2100, 2, 'category/14', 'women/shapewear/hats.html', 'catalog/category/view/id/14', 1, NULL, NULL, 14, NULL),
(2101, 1, 'category/15', 'women/bags/shoes/gloves.html', 'catalog/category/view/id/15', 1, NULL, NULL, 15, NULL),
(2102, 2, 'category/15', 'women/bags/shoes/gloves.html', 'catalog/category/view/id/15', 1, NULL, NULL, 15, NULL),
(2104, 1, '42257000_1417750564', 'accessories/shapewear/sundresses/footwear/novelty/outerwear/hats/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(2106, 2, '43200500_1417750564', 'accessories/shapewear/sundresses/footwear/novelty/outerwear/hats/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(2130, 1, '95623700_1417750570', 'accessories/shapewear/sundresses/footwear/novelty/outerwear/hats.html', 'women/shapewear/hats.html', 0, 'RP', NULL, 14, NULL),
(2132, 2, '96696000_1417750570', 'accessories/shapewear/sundresses/footwear/novelty/outerwear/hats.html', 'women/shapewear/hats.html', 0, 'RP', NULL, 14, NULL),
(2148, 1, '70493100_1417750575', 'accessories/shapewear/sundresses/footwear/novelty/outerwear.html', 'women/shapewear/outerwear.html', 0, 'RP', NULL, 13, NULL),
(2150, 2, '71346900_1417750575', 'accessories/shapewear/sundresses/footwear/novelty/outerwear.html', 'women/shapewear/outerwear.html', 0, 'RP', NULL, 13, NULL),
(2166, 1, '39360400_1417750582', 'accessories/shapewear/sundresses/footwear/novelty.html', 'women/shapewear/novelty.html', 0, 'RP', NULL, 12, NULL),
(2168, 2, '40431600_1417750582', 'accessories/shapewear/sundresses/footwear/novelty.html', 'women/shapewear/novelty.html', 0, 'RP', NULL, 12, NULL),
(2184, 1, '56359600_1417750587', 'accessories/shapewear/sundresses/footwear.html', 'women/shapewear/footwear.html', 0, 'RP', NULL, 11, NULL),
(2186, 2, '57318800_1417750587', 'accessories/shapewear/sundresses/footwear.html', 'women/shapewear/footwear.html', 0, 'RP', NULL, 11, NULL),
(2201, 1, 'category/16', 'women/bags/shoes/leathers.html', 'catalog/category/view/id/16', 1, NULL, NULL, 16, NULL),
(2202, 2, 'category/16', 'women/bags/shoes/leathers.html', 'catalog/category/view/id/16', 1, NULL, NULL, 16, NULL),
(2203, 1, 'category/17', 'women/bags/shoes/cocktail.html', 'catalog/category/view/id/17', 1, NULL, NULL, 17, NULL),
(2204, 2, 'category/17', 'women/bags/shoes/cocktail.html', 'catalog/category/view/id/17', 1, NULL, NULL, 17, NULL),
(2205, 1, 'category/18', 'women/bags/bands.html', 'catalog/category/view/id/18', 1, NULL, NULL, 18, NULL),
(2206, 2, 'category/18', 'women/bags/bands.html', 'catalog/category/view/id/18', 1, NULL, NULL, 18, NULL),
(2207, 1, 'category/19', 'tv-audio/bicycle.html', 'catalog/category/view/id/19', 1, NULL, NULL, 19, NULL),
(2208, 2, 'category/19', 'tv-audio/bicycle.html', 'catalog/category/view/id/19', 1, NULL, NULL, 19, NULL),
(2209, 1, 'category/20', 'tv-audio/bicycle/jackets.html', 'catalog/category/view/id/20', 1, NULL, NULL, 20, NULL),
(2210, 2, 'category/20', 'tv-audio/bicycle/jackets.html', 'catalog/category/view/id/20', 1, NULL, NULL, 20, NULL),
(2211, 1, 'category/21', 'women/bags/shoes/shirts/hair.html', 'catalog/category/view/id/21', 1, NULL, NULL, 21, NULL),
(2212, 2, 'category/21', 'women/bags/shoes/shirts/hair.html', 'catalog/category/view/id/21', 1, NULL, NULL, 21, NULL),
(2213, 1, 'category/22', 'women/bags/shoes/clothing.html', 'catalog/category/view/id/22', 1, NULL, NULL, 22, NULL),
(2214, 2, 'category/22', 'women/bags/shoes/clothing.html', 'catalog/category/view/id/22', 1, NULL, NULL, 22, NULL),
(2215, 1, 'category/23', 'women/bags/blog.html', 'catalog/category/view/id/23', 1, NULL, NULL, 23, NULL),
(2216, 2, 'category/23', 'women/bags/blog.html', 'catalog/category/view/id/23', 1, NULL, NULL, 23, NULL),
(2217, 1, 'category/24', 'tv-audio/bicycle/scarves.html', 'catalog/category/view/id/24', 1, NULL, NULL, 24, NULL),
(2218, 2, 'category/24', 'tv-audio/bicycle/scarves.html', 'catalog/category/view/id/24', 1, NULL, NULL, 24, NULL),
(2219, 1, 'category/25', 'tv-audio/bicycle/lifestyle.html', 'catalog/category/view/id/25', 1, NULL, NULL, 25, NULL),
(2220, 2, 'category/25', 'tv-audio/bicycle/lifestyle.html', 'catalog/category/view/id/25', 1, NULL, NULL, 25, NULL),
(2221, 1, 'category/26', 'accessories/bras.html', 'catalog/category/view/id/26', 1, NULL, NULL, 26, NULL),
(2222, 2, 'category/26', 'accessories/bras.html', 'catalog/category/view/id/26', 1, NULL, NULL, 26, NULL),
(2223, 1, 'category/27', 'women/bags/shoes/shirts/helmet.html', 'catalog/category/view/id/27', 1, NULL, NULL, 27, NULL),
(2224, 2, 'category/27', 'women/bags/shoes/shirts/helmet.html', 'catalog/category/view/id/27', 1, NULL, NULL, 27, NULL),
(2225, 1, 'category/28', 'accessories/cosmetics.html', 'catalog/category/view/id/28', 1, NULL, NULL, 28, NULL),
(2226, 2, 'category/28', 'accessories/cosmetics.html', 'catalog/category/view/id/28', 1, NULL, NULL, 28, NULL),
(2227, 1, 'category/29', 'women/bags/shoes/shirts/camis.html', 'catalog/category/view/id/29', 1, NULL, NULL, 29, NULL),
(2228, 2, 'category/29', 'women/bags/shoes/shirts/camis.html', 'catalog/category/view/id/29', 1, NULL, NULL, 29, NULL),
(2229, 1, 'category/30', 'women/bags/shoes/shirts/lingerie.html', 'catalog/category/view/id/30', 1, NULL, NULL, 30, NULL),
(2230, 2, 'category/30', 'women/bags/shoes/shirts/lingerie.html', 'catalog/category/view/id/30', 1, NULL, NULL, 30, NULL),
(2231, 1, 'category/31', 'women/bags/shoes/shirts.html', 'catalog/category/view/id/31', 1, NULL, NULL, 31, NULL),
(2232, 2, 'category/31', 'women/bags/shoes/shirts.html', 'catalog/category/view/id/31', 1, NULL, NULL, 31, NULL),
(2233, 1, 'category/32', 'women/bags/shoes/shirts/tops.html', 'catalog/category/view/id/32', 1, NULL, NULL, 32, NULL),
(2234, 2, 'category/32', 'women/bags/shoes/shirts/tops.html', 'catalog/category/view/id/32', 1, NULL, NULL, 32, NULL),
(2235, 1, 'category/33', 'women/bags.html', 'catalog/category/view/id/33', 1, NULL, NULL, 33, NULL),
(2236, 2, 'category/33', 'women/bags.html', 'catalog/category/view/id/33', 1, NULL, NULL, 33, NULL),
(2237, 1, 'category/34', 'women/bags/nightwear.html', 'catalog/category/view/id/34', 1, NULL, NULL, 34, NULL),
(2238, 2, 'category/34', 'women/bags/nightwear.html', 'catalog/category/view/id/34', 1, NULL, NULL, 34, NULL),
(2239, 1, 'category/35', 'women/bags/briefs.html', 'catalog/category/view/id/35', 1, NULL, NULL, 35, NULL),
(2240, 2, 'category/35', 'women/bags/briefs.html', 'catalog/category/view/id/35', 1, NULL, NULL, 35, NULL),
(2241, 1, 'category/36', 'women/bags/duffle.html', 'catalog/category/view/id/36', 1, NULL, NULL, 36, NULL),
(2242, 2, 'category/36', 'women/bags/duffle.html', 'catalog/category/view/id/36', 1, NULL, NULL, 36, NULL),
(2243, 1, 'category/37', 'women/bags/dresses.html', 'catalog/category/view/id/37', 1, NULL, NULL, 37, NULL),
(2244, 2, 'category/37', 'women/bags/dresses.html', 'catalog/category/view/id/37', 1, NULL, NULL, 37, NULL),
(2245, 1, 'category/38', 'women/bags/laptop.html', 'catalog/category/view/id/38', 1, NULL, NULL, 38, NULL),
(2246, 2, 'category/38', 'women/bags/laptop.html', 'catalog/category/view/id/38', 1, NULL, NULL, 38, NULL),
(2247, 1, 'category/39', 'women/bags/cosmetic.html', 'catalog/category/view/id/39', 1, NULL, NULL, 39, NULL),
(2248, 2, 'category/39', 'women/bags/cosmetic.html', 'catalog/category/view/id/39', 1, NULL, NULL, 39, NULL),
(2250, 1, '57091800_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(2252, 1, '57619000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(2254, 1, '58069400_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(2256, 1, '58509000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(2258, 1, '58946300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(2260, 1, '59362300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(2262, 1, '59758300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(2264, 1, '60143000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2266, 1, '60481000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2268, 1, '60861500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2270, 1, '61236700_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2272, 1, '61613400_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2274, 1, '62011300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2276, 1, '62342100_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2278, 1, '62697900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2280, 1, '63124000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2282, 1, '63600600_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2284, 1, '63995900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2286, 1, '64385600_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2288, 1, '64768900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2290, 1, '65196200_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2292, 2, '66551400_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(2294, 2, '66877900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(2296, 2, '67156500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(2298, 2, '67419100_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(2300, 2, '67681300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(2302, 2, '67942500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(2304, 2, '68206800_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(2306, 2, '68477400_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2308, 2, '68786900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2310, 2, '69055500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2312, 2, '69320900_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2314, 2, '69588200_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2316, 2, '69878600_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2318, 2, '70160200_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2320, 2, '70439100_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2322, 2, '70806500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2324, 2, '71084000_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2326, 2, '71364500_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2328, 2, '71645100_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2330, 2, '71933300_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2332, 2, '72219100_1417750976', 'accessories/shoes/leathers/cocktail/bands/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2386, 1, '19654100_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(2388, 1, '20025900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(2390, 1, '20408100_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(2392, 1, '20771900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(2394, 1, '21135300_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2396, 1, '21505100_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2398, 1, '21870800_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2400, 1, '22237900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2402, 1, '22717700_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2404, 1, '23128600_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2406, 1, '23535500_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2408, 1, '23899800_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2410, 1, '24277800_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2412, 1, '24688400_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2414, 1, '25081700_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2416, 1, '25515700_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2418, 1, '25908300_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2420, 1, '26296100_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2422, 2, '27733500_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(2424, 2, '28027900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(2426, 2, '28319400_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(2428, 2, '28631100_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(2430, 2, '28910800_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2432, 2, '29267300_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2434, 2, '29566500_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2436, 2, '29847200_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2438, 2, '30137400_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2440, 2, '30444600_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2442, 2, '30727900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2444, 2, '31005600_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2446, 2, '31285900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2448, 2, '31569900_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2450, 2, '31909600_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(2452, 2, '32197200_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2454, 2, '32482000_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2456, 2, '32768700_1417750983', 'accessories/shoes/bicycle/jackets/hair/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2502, 1, '09104800_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2504, 1, '09647000_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2506, 1, '10181200_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2508, 1, '10710700_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2510, 1, '11193400_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2512, 1, '11689400_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2514, 1, '12185500_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2516, 1, '12678100_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2518, 1, '13162300_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2520, 1, '13643600_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2522, 1, '14146300_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2524, 1, '14804900_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2526, 1, '15312800_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2528, 1, '15831800_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2530, 2, '17309200_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(2532, 2, '17740100_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(2534, 2, '18198200_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2536, 2, '18597400_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2538, 2, '19005100_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2540, 2, '19410200_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2542, 2, '19817400_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2544, 2, '20176200_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2546, 2, '20652800_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2548, 2, '21025900_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2550, 2, '21449400_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2552, 2, '21875800_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2554, 2, '22305500_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2556, 2, '22676500_1417750993', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2602, 1, '61717900_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2604, 1, '62258100_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2606, 1, '62748600_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2608, 1, '63246800_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2610, 1, '63775500_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2612, 1, '64375600_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2614, 1, '64816600_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2616, 1, '65288700_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2618, 1, '65766000_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2620, 1, '66239200_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2622, 1, '66719100_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2624, 1, '67196900_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2626, 2, '68531400_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(2628, 2, '68874900_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(2630, 2, '69311300_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(2632, 2, '69621400_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2634, 2, '69973800_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2636, 2, '70341300_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2638, 2, '70751500_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2640, 2, '71108900_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2642, 2, '71475600_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2644, 2, '71850800_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2646, 2, '72230100_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2648, 2, '72603500_1417751004', 'accessories/shoes/bicycle/bras/helmet/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2694, 1, '35666700_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2696, 1, '36318400_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2698, 1, '36816300_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2700, 1, '37367100_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2702, 1, '37914700_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2704, 1, '39330300_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2706, 1, '39898200_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2708, 1, '40427700_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2710, 1, '40930500_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2712, 2, '42418200_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2714, 2, '42773800_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2716, 2, '43166100_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2718, 2, '43546300_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2720, 2, '43952500_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2722, 2, '44349900_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2724, 2, '44746500_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2726, 2, '45155100_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2728, 2, '45577200_1417751011', 'accessories/shoes/bicycle/cosmetics/camis/lingerie/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2782, 1, '14547200_1417751019', 'accessories/shoes/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2784, 1, '15048200_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2786, 1, '15552400_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2788, 1, '16036800_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2790, 1, '16509900_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2792, 1, '16989000_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2794, 1, '17472800_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2796, 2, '18873400_1417751019', 'accessories/shoes/shirts/tops/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2798, 2, '19242400_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2800, 2, '19597000_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2802, 2, '19987100_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2804, 2, '20355900_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2806, 2, '20717200_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2808, 2, '21210200_1417751019', 'accessories/shoes/shirts/tops/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2830, 1, '10999400_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2832, 1, '11517500_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2834, 1, '12001900_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2836, 1, '12512600_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2838, 2, '13928600_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2840, 2, '14319800_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2842, 2, '14717900_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2844, 2, '15118900_1417751025', 'accessories/shoes/shirts/bags/nightwear/briefs/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2862, 1, '81124200_1417751031', 'accessories/shoes/shirts/bags/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2864, 1, '81704000_1417751031', 'accessories/shoes/shirts/bags/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2866, 2, '83103200_1417751031', 'accessories/shoes/shirts/bags/duffle/dresses/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2868, 2, '83470800_1417751031', 'accessories/shoes/shirts/bags/duffle/dresses/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2880, 1, '62380800_1417751042', 'accessories/shoes/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2882, 1, '62882600_1417751042', 'accessories/shoes/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2884, 1, '63387500_1417751042', 'accessories/shoes/shirts/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2886, 1, '63881800_1417751042', 'accessories/shoes/shirts/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2888, 1, '64474300_1417751042', 'accessories/shoes/shirts/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2890, 1, '64963500_1417751042', 'accessories/shoes/shirts/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2892, 1, '65468700_1417751042', 'accessories/shoes/shirts/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2894, 1, '65931100_1417751042', 'accessories/shoes/shirts/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2896, 1, '66453600_1417751042', 'accessories/shoes/shirts/bags/duffle/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(2898, 2, '67729900_1417751042', 'accessories/shoes/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(2900, 2, '68141900_1417751042', 'accessories/shoes/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(2902, 2, '68519100_1417751042', 'accessories/shoes/shirts/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(2904, 2, '68915600_1417751042', 'accessories/shoes/shirts/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(2906, 2, '69316000_1417751042', 'accessories/shoes/shirts/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(2908, 2, '69718200_1417751042', 'accessories/shoes/shirts/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(2910, 2, '70232900_1417751042', 'accessories/shoes/shirts/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(2912, 2, '70626800_1417751042', 'accessories/shoes/shirts/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(2914, 2, '71033400_1417751042', 'accessories/shoes/shirts/bags/duffle/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3016, 1, '42174600_1417751068', 'accessories/shirts/bags/duffle/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3018, 2, '43295700_1417751068', 'accessories/shirts/bags/duffle/laptop/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3030, 1, '04835500_1417751079', 'accessories/shirts/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3032, 2, '06051900_1417751079', 'accessories/shirts/bags/nightwear/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3062, 1, '18650600_1417751090', 'accessories/shirts/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(3064, 1, '19170900_1417751090', 'accessories/shirts/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(3066, 1, '19681700_1417751090', 'accessories/shirts/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(3068, 1, '20211100_1417751090', 'accessories/shirts/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3070, 1, '20821900_1417751090', 'accessories/shirts/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3072, 1, '21337200_1417751090', 'accessories/shirts/bags/duffle/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3074, 2, '22662500_1417751090', 'accessories/shirts/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(3076, 2, '23052000_1417751090', 'accessories/shirts/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(3078, 2, '23389300_1417751090', 'accessories/shirts/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(3080, 2, '23913100_1417751090', 'accessories/shirts/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3082, 2, '24312000_1417751090', 'accessories/shirts/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3084, 2, '24768200_1417751090', 'accessories/shirts/bags/duffle/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3158, 1, '61652100_1417751096', 'accessories/shoes/bicycle/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(3160, 2, '62764400_1417751096', 'accessories/shoes/bicycle/cosmetics/camis/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(3170, 1, '33835300_1417751103', 'accessories/shoes/bicycle/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(3172, 2, '34936800_1417751103', 'accessories/shoes/bicycle/cosmetics/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(3184, 1, '71549200_1417751109', 'accessories/shoes/bicycle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(3186, 2, '72564200_1417751109', 'accessories/shoes/bicycle/bras/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(3200, 1, '79455100_1417751118', 'accessories/shoes/bicycle/jackets/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(3202, 2, '80467200_1417751118', 'accessories/shoes/bicycle/jackets/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(3218, 1, '32960600_1417751126', 'accessories/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3220, 2, '34033600_1417751126', 'accessories/bags/duffle/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3240, 1, '30520500_1417751131', 'accessories/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3242, 2, '31644800_1417751131', 'accessories/bags/duffle/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3260, 1, '29279100_1417751136', 'accessories/bags/duffle/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3262, 2, '30371300_1417751136', 'accessories/bags/duffle/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3278, 1, '89170000_1417751143', 'accessories/shoes/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(3280, 1, '89645800_1417751143', 'accessories/shoes/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(3282, 1, '90066800_1417751143', 'accessories/shoes/bicycle/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3284, 1, '90484800_1417751143', 'accessories/shoes/bicycle/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3286, 1, '90998700_1417751143', 'accessories/shoes/bicycle/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(3288, 1, '91376700_1417751143', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(3290, 1, '91838800_1417751143', 'accessories/shoes/bicycle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(3292, 1, '92306300_1417751143', 'accessories/shoes/bicycle/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(3294, 1, '92784500_1417751143', 'accessories/shoes/bicycle/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3296, 2, '94042800_1417751143', 'accessories/shoes/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(3298, 2, '94326700_1417751143', 'accessories/shoes/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(3300, 2, '94601800_1417751143', 'accessories/shoes/bicycle/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3302, 2, '94882600_1417751143', 'accessories/shoes/bicycle/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3304, 2, '95172600_1417751143', 'accessories/shoes/bicycle/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(3306, 2, '95457500_1417751143', 'accessories/shoes/bicycle/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(3308, 2, '96010500_1417751143', 'accessories/shoes/bicycle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(3310, 2, '96358900_1417751143', 'accessories/shoes/bicycle/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(3312, 2, '96737800_1417751143', 'accessories/shoes/bicycle/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3390, 1, '75570300_1417751150', 'accessories/bicycle/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(3392, 2, '76678200_1417751150', 'accessories/bicycle/clothing/blog/scarves/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(3414, 1, '68761000_1417751155', 'accessories/bicycle/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(3416, 2, '69962300_1417751155', 'accessories/bicycle/clothing/blog/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(3438, 1, '07643000_1417751162', 'accessories/bicycle/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3440, 2, '08856600_1417751162', 'accessories/bicycle/clothing/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3462, 1, '79141000_1417751169', 'accessories/bicycle/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3464, 2, '80269500_1417751169', 'accessories/bicycle/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3486, 1, '90124400_1417751175', 'accessories/bicycle/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3488, 2, '91241900_1417751175', 'accessories/bicycle/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3510, 1, '38231500_1417751181', 'accessories/bicycle/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3512, 2, '39311400_1417751181', 'accessories/bicycle/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3534, 1, '72888900_1417751189', 'accessories/shoes/leathers/cocktail/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3536, 2, '73938000_1417751189', 'accessories/shoes/leathers/cocktail/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3550, 1, '69530900_1417751195', 'accessories/shoes/leathers/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(3552, 2, '70605900_1417751195', 'accessories/shoes/leathers/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(3624, 1, '18433100_1417751212', 'accessories/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(3626, 2, '19413700_1417751212', 'accessories/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(3702, 1, '20196600_1417751222', 'accessories/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(3704, 2, '21327800_1417751222', 'accessories/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(3782, 1, '20427600_1417751228', 'accessories/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(3784, 2, '21424600_1417751228', 'accessories/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(3864, 1, '18725500_1417751240', 'accessories/bags/dresses/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3866, 2, '19863500_1417751240', 'accessories/bags/dresses/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(3888, 1, '27695900_1417751245', 'accessories/bags/dresses/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3890, 2, '28682600_1417751245', 'accessories/bags/dresses/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3904, 1, '85329100_1417751262', 'accessories/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(3906, 1, '85866600_1417751262', 'accessories/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(3908, 1, '86379300_1417751262', 'accessories/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(3910, 1, '86919200_1417751262', 'accessories/bags/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3912, 1, '87442800_1417751262', 'accessories/bags/dresses/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3914, 1, '87983200_1417751262', 'accessories/bags/dresses/blog/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3916, 1, '88507000_1417751262', 'accessories/bags/dresses/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3918, 1, '89016500_1417751262', 'accessories/bags/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3920, 1, '89541300_1417751262', 'accessories/bags/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(3922, 2, '90929000_1417751262', 'accessories/bags.html', 'women/bags.html', 0, 'RP', NULL, 33, NULL),
(3924, 2, '91433300_1417751262', 'accessories/bags/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(3926, 2, '91833100_1417751262', 'accessories/bags/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(3928, 2, '92233800_1417751262', 'accessories/bags/dresses.html', 'women/bags/dresses.html', 0, 'RP', NULL, 37, NULL),
(3930, 2, '92639400_1417751262', 'accessories/bags/dresses/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(3932, 2, '92940400_1417751262', 'accessories/bags/dresses/blog/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(3934, 2, '93353000_1417751262', 'accessories/bags/dresses/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(3936, 2, '93893900_1417751262', 'accessories/bags/laptop.html', 'women/bags/laptop.html', 0, 'RP', NULL, 38, NULL),
(3938, 2, '94335700_1417751262', 'accessories/bags/cosmetic.html', 'women/bags/cosmetic.html', 0, 'RP', NULL, 39, NULL),
(4090, 1, '59997500_1417751270', 'accessories/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(4092, 1, '60415500_1417751270', 'accessories/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(4094, 1, '60908100_1417751270', 'accessories/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(4096, 1, '61396800_1417751270', 'accessories/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(4098, 1, '61923400_1417751270', 'accessories/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(4100, 1, '62542300_1417751270', 'accessories/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(4102, 2, '63834500_1417751270', 'accessories/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(4104, 2, '64139700_1417751270', 'accessories/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(4106, 2, '64523400_1417751270', 'accessories/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(4108, 2, '64969900_1417751270', 'accessories/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(4110, 2, '65343100_1417751270', 'accessories/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(4112, 2, '65729300_1417751270', 'accessories/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(4264, 1, '00123700_1417751279', 'accessories/shoes.html', 'women/bags/shoes.html', 0, 'RP', NULL, 8, NULL),
(4266, 1, '00578500_1417751279', 'accessories/shoes/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(4268, 1, '01165700_1417751279', 'accessories/shoes/leathers.html', 'women/bags/shoes/leathers.html', 0, 'RP', NULL, 16, NULL),
(4270, 1, '01570300_1417751279', 'accessories/shoes/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(4272, 1, '02190200_1417751279', 'accessories/shoes/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(4274, 1, '02823300_1417751279', 'accessories/shoes/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(4276, 2, '03961600_1417751279', 'accessories/shoes.html', 'women/bags/shoes.html', 0, 'RP', NULL, 8, NULL),
(4278, 2, '04408300_1417751279', 'accessories/shoes/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(4280, 2, '04671400_1417751279', 'accessories/shoes/leathers.html', 'women/bags/shoes/leathers.html', 0, 'RP', NULL, 16, NULL),
(4282, 2, '04972400_1417751279', 'accessories/shoes/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(4284, 2, '05308100_1417751279', 'accessories/shoes/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(4286, 2, '05561800_1417751279', 'accessories/shoes/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(4438, 1, '69760600_1417751290', 'accessories/shapewear.html', 'women/shapewear.html', 0, 'RP', NULL, 9, NULL),
(4440, 1, '70156100_1417751290', 'accessories/shapewear/sundresses.html', 'women/shapewear/sundresses.html', 0, 'RP', NULL, 10, NULL),
(4442, 1, '70571000_1417751290', 'accessories/shapewear/footwear.html', 'women/shapewear/footwear.html', 0, 'RP', NULL, 11, NULL),
(4444, 1, '70925600_1417751290', 'accessories/shapewear/novelty.html', 'women/shapewear/novelty.html', 0, 'RP', NULL, 12, NULL),
(4446, 1, '71299100_1417751290', 'accessories/shapewear/outerwear.html', 'women/shapewear/outerwear.html', 0, 'RP', NULL, 13, NULL),
(4448, 1, '71688500_1417751290', 'accessories/shapewear/hats.html', 'women/shapewear/hats.html', 0, 'RP', NULL, 14, NULL),
(4450, 2, '72891800_1417751290', 'accessories/shapewear.html', 'women/shapewear.html', 0, 'RP', NULL, 9, NULL),
(4452, 2, '73166800_1417751290', 'accessories/shapewear/sundresses.html', 'women/shapewear/sundresses.html', 0, 'RP', NULL, 10, NULL),
(4454, 2, '73442100_1417751290', 'accessories/shapewear/footwear.html', 'women/shapewear/footwear.html', 0, 'RP', NULL, 11, NULL),
(4456, 2, '73732400_1417751290', 'accessories/shapewear/novelty.html', 'women/shapewear/novelty.html', 0, 'RP', NULL, 12, NULL),
(4458, 2, '74149700_1417751290', 'accessories/shapewear/outerwear.html', 'women/shapewear/outerwear.html', 0, 'RP', NULL, 13, NULL),
(4460, 2, '74414300_1417751290', 'accessories/shapewear/hats.html', 'women/shapewear/hats.html', 0, 'RP', NULL, 14, NULL),
(4613, 1, 'product/7/4', 'women/configurable-product.html', 'catalog/product/view/id/7/category/4', 1, NULL, NULL, 4, 7),
(4615, 1, 'product/8/4', 'women/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/4', 1, NULL, NULL, 4, 8),
(4617, 1, 'product/9/4', 'women/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/4', 1, NULL, NULL, 4, 9),
(4619, 1, 'product/10/4', 'women/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/4', 1, NULL, NULL, 4, 10),
(4621, 1, 'product/11/4', 'women/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/4', 1, NULL, NULL, 4, 11),
(4623, 1, 'product/12/4', 'women/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/4', 1, NULL, NULL, 4, 12),
(4625, 1, 'product/13/4', 'women/configurable-product-02.html', 'catalog/product/view/id/13/category/4', 1, NULL, NULL, 4, 13),
(4627, 1, 'product/14/4', 'women/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/4', 1, NULL, NULL, 4, 14),
(4629, 1, 'product/15/4', 'women/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/4', 1, NULL, NULL, 4, 15),
(4631, 1, 'product/16/4', 'women/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/4', 1, NULL, NULL, 4, 16),
(4633, 1, 'product/17/4', 'women/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/4', 1, NULL, NULL, 4, 17),
(4635, 1, 'product/18/4', 'women/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/4', 1, NULL, NULL, 4, 18),
(4637, 1, 'product/19/4', 'women/configurable-product-03.html', 'catalog/product/view/id/19/category/4', 1, NULL, NULL, 4, 19),
(4639, 1, 'product/20/4', 'women/configurable-product-04.html', 'catalog/product/view/id/20/category/4', 1, NULL, NULL, 4, 20),
(4641, 1, 'product/21/4', 'women/configurable-product-05.html', 'catalog/product/view/id/21/category/4', 1, NULL, NULL, 4, 21),
(4643, 1, 'product/22/4', 'women/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/4', 1, NULL, NULL, 4, 22),
(4645, 1, 'product/23/4', 'women/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/4', 1, NULL, NULL, 4, 23),
(4647, 1, 'product/24/4', 'women/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/4', 1, NULL, NULL, 4, 24),
(4649, 1, 'product/25/4', 'women/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/4', 1, NULL, NULL, 4, 25),
(4651, 1, 'product/26/4', 'women/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/4', 1, NULL, NULL, 4, 26),
(4653, 1, 'product/27/4', 'women/configurable-product-04-black.html', 'catalog/product/view/id/27/category/4', 1, NULL, NULL, 4, 27),
(4655, 1, 'product/28/4', 'women/configurable-product-04-white.html', 'catalog/product/view/id/28/category/4', 1, NULL, NULL, 4, 28),
(4725, 2, 'product/7/4', 'women/configurable-product.html', 'catalog/product/view/id/7/category/4', 1, NULL, NULL, 4, 7),
(4727, 2, 'product/8/4', 'women/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/4', 1, NULL, NULL, 4, 8),
(4729, 2, 'product/9/4', 'women/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/4', 1, NULL, NULL, 4, 9),
(4731, 2, 'product/10/4', 'women/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/4', 1, NULL, NULL, 4, 10),
(4733, 2, 'product/11/4', 'women/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/4', 1, NULL, NULL, 4, 11),
(4735, 2, 'product/12/4', 'women/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/4', 1, NULL, NULL, 4, 12),
(4737, 2, 'product/13/4', 'women/configurable-product-02.html', 'catalog/product/view/id/13/category/4', 1, NULL, NULL, 4, 13),
(4739, 2, 'product/14/4', 'women/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/4', 1, NULL, NULL, 4, 14),
(4741, 2, 'product/15/4', 'women/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/4', 1, NULL, NULL, 4, 15),
(4743, 2, 'product/16/4', 'women/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/4', 1, NULL, NULL, 4, 16),
(4745, 2, 'product/17/4', 'women/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/4', 1, NULL, NULL, 4, 17),
(4747, 2, 'product/18/4', 'women/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/4', 1, NULL, NULL, 4, 18),
(4749, 2, 'product/19/4', 'women/configurable-product-03.html', 'catalog/product/view/id/19/category/4', 1, NULL, NULL, 4, 19),
(4751, 2, 'product/20/4', 'women/configurable-product-04.html', 'catalog/product/view/id/20/category/4', 1, NULL, NULL, 4, 20),
(4753, 2, 'product/21/4', 'women/configurable-product-05.html', 'catalog/product/view/id/21/category/4', 1, NULL, NULL, 4, 21),
(4755, 2, 'product/22/4', 'women/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/4', 1, NULL, NULL, 4, 22),
(4757, 2, 'product/23/4', 'women/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/4', 1, NULL, NULL, 4, 23),
(4759, 2, 'product/24/4', 'women/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/4', 1, NULL, NULL, 4, 24),
(4761, 2, 'product/25/4', 'women/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/4', 1, NULL, NULL, 4, 25),
(4763, 2, 'product/26/4', 'women/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/4', 1, NULL, NULL, 4, 26),
(4765, 2, 'product/27/4', 'women/configurable-product-04-black.html', 'catalog/product/view/id/27/category/4', 1, NULL, NULL, 4, 27),
(4767, 2, 'product/28/4', 'women/configurable-product-04-white.html', 'catalog/product/view/id/28/category/4', 1, NULL, NULL, 4, 28),
(4769, 1, '88472700_1418030700', 'accessories/bicycle/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(4771, 2, '89463900_1418030700', 'accessories/bicycle/cosmetics.html', 'accessories/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(4797, 1, '09859300_1418030706', 'accessories/bicycle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(4799, 2, '10847800_1418030706', 'accessories/bicycle/bras.html', 'accessories/bras.html', 0, 'RP', NULL, 26, NULL),
(4822, 1, 'category/41', 'accessories/product-types.html', 'catalog/category/view/id/41', 1, NULL, NULL, 41, NULL),
(4824, 1, 'product/7/41', 'accessories/product-types/configurable-product.html', 'catalog/product/view/id/7/category/41', 1, NULL, NULL, 41, 7),
(4826, 1, 'product/13/41', 'accessories/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/41', 1, NULL, NULL, 41, 13),
(4828, 1, 'product/19/41', 'accessories/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/41', 1, NULL, NULL, 41, 19),
(4830, 1, 'product/20/41', 'accessories/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/41', 1, NULL, NULL, 41, 20),
(4832, 1, 'product/21/41', 'accessories/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/41', 1, NULL, NULL, 41, 21),
(4834, 1, 'product/37/41', 'accessories/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/41', 1, NULL, NULL, 41, 37),
(4836, 1, 'product/42/41', 'accessories/product-types/grouped-product.html', 'catalog/product/view/id/42/category/41', 1, NULL, NULL, 41, 42),
(4840, 1, 'product/44/41', 'accessories/product-types/bundle-product.html', 'catalog/product/view/id/44/category/41', 1, NULL, NULL, 41, 44),
(4842, 1, 'product/45/41', 'accessories/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/41', 1, NULL, NULL, 41, 45),
(4844, 1, 'product/46/41', 'accessories/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/41', 1, NULL, NULL, 41, 46),
(4846, 1, 'product/47/41', 'accessories/product-types/no-image.html', 'catalog/product/view/id/47/category/41', 1, NULL, NULL, 41, 47),
(4849, 2, 'category/41', 'accessories/product-types.html', 'catalog/category/view/id/41', 1, NULL, NULL, 41, NULL),
(4851, 2, 'product/7/41', 'accessories/product-types/configurable-product.html', 'catalog/product/view/id/7/category/41', 1, NULL, NULL, 41, 7),
(4853, 2, 'product/13/41', 'accessories/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/41', 1, NULL, NULL, 41, 13),
(4855, 2, 'product/19/41', 'accessories/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/41', 1, NULL, NULL, 41, 19),
(4857, 2, 'product/20/41', 'accessories/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/41', 1, NULL, NULL, 41, 20),
(4859, 2, 'product/21/41', 'accessories/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/41', 1, NULL, NULL, 41, 21),
(4861, 2, 'product/37/41', 'accessories/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/41', 1, NULL, NULL, 41, 37),
(4863, 2, 'product/42/41', 'accessories/product-types/grouped-product.html', 'catalog/product/view/id/42/category/41', 1, NULL, NULL, 41, 42),
(4867, 2, 'product/44/41', 'accessories/product-types/bundle-product.html', 'catalog/product/view/id/44/category/41', 1, NULL, NULL, 41, 44),
(4869, 2, 'product/45/41', 'accessories/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/41', 1, NULL, NULL, 41, 45),
(4871, 2, 'product/46/41', 'accessories/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/41', 1, NULL, NULL, 41, 46),
(4873, 2, 'product/47/41', 'accessories/product-types/no-image.html', 'catalog/product/view/id/47/category/41', 1, NULL, NULL, 41, 47),
(4944, 1, 'category/40', 'accessories/cfg-products.html', 'catalog/category/view/id/40', 1, NULL, NULL, 40, NULL),
(4946, 1, 'product/7/40', 'accessories/cfg-products/configurable-product.html', 'catalog/product/view/id/7/category/40', 1, NULL, NULL, 40, 7),
(4948, 1, 'product/13/40', 'accessories/cfg-products/configurable-product-02.html', 'catalog/product/view/id/13/category/40', 1, NULL, NULL, 40, 13),
(4950, 1, 'product/19/40', 'accessories/cfg-products/configurable-product-03.html', 'catalog/product/view/id/19/category/40', 1, NULL, NULL, 40, 19),
(4952, 1, 'product/20/40', 'accessories/cfg-products/configurable-product-04.html', 'catalog/product/view/id/20/category/40', 1, NULL, NULL, 40, 20),
(4954, 1, 'product/21/40', 'accessories/cfg-products/configurable-product-05.html', 'catalog/product/view/id/21/category/40', 1, NULL, NULL, 40, 21),
(4955, 2, 'category/40', 'accessories/cfg-products.html', 'catalog/category/view/id/40', 1, NULL, NULL, 40, NULL),
(4957, 2, 'product/7/40', 'accessories/cfg-products/configurable-product.html', 'catalog/product/view/id/7/category/40', 1, NULL, NULL, 40, 7),
(4959, 2, 'product/13/40', 'accessories/cfg-products/configurable-product-02.html', 'catalog/product/view/id/13/category/40', 1, NULL, NULL, 40, 13),
(4961, 2, 'product/19/40', 'accessories/cfg-products/configurable-product-03.html', 'catalog/product/view/id/19/category/40', 1, NULL, NULL, 40, 19),
(4963, 2, 'product/20/40', 'accessories/cfg-products/configurable-product-04.html', 'catalog/product/view/id/20/category/40', 1, NULL, NULL, 40, 20),
(4965, 2, 'product/21/40', 'accessories/cfg-products/configurable-product-05.html', 'catalog/product/view/id/21/category/40', 1, NULL, NULL, 40, 21),
(4966, 1, 'category/42', 'cameras-photography.html', 'catalog/category/view/id/42', 1, NULL, NULL, 42, NULL),
(4967, 2, 'category/42', 'cameras-photography.html', 'catalog/category/view/id/42', 1, NULL, NULL, 42, NULL),
(4968, 1, 'category/43', 'tv-audio.html', 'catalog/category/view/id/43', 1, NULL, NULL, 43, NULL),
(4969, 2, 'category/43', 'tv-audio.html', 'catalog/category/view/id/43', 1, NULL, NULL, 43, NULL),
(4970, 1, 'category/44', 'laptops-computers.html', 'catalog/category/view/id/44', 1, NULL, NULL, 44, NULL),
(4971, 2, 'category/44', 'laptops-computers.html', 'catalog/category/view/id/44', 1, NULL, NULL, 44, NULL),
(4972, 1, 'category/45', 'smart-phones-tablets.html', 'catalog/category/view/id/45', 1, NULL, NULL, 45, NULL),
(4973, 2, 'category/45', 'smart-phones-tablets.html', 'catalog/category/view/id/45', 1, NULL, NULL, 45, NULL),
(4974, 1, 'category/46', 'video-games-consoles.html', 'catalog/category/view/id/46', 1, NULL, NULL, 46, NULL),
(4975, 2, 'category/46', 'video-games-consoles.html', 'catalog/category/view/id/46', 1, NULL, NULL, 46, NULL),
(4976, 1, 'category/47', 'gadgets.html', 'catalog/category/view/id/47', 1, NULL, NULL, 47, NULL),
(4977, 2, 'category/47', 'gadgets.html', 'catalog/category/view/id/47', 1, NULL, NULL, 47, NULL),
(4978, 1, 'category/48', 'car-electronics-gps.html', 'catalog/category/view/id/48', 1, NULL, NULL, 48, NULL),
(4979, 2, 'category/48', 'car-electronics-gps.html', 'catalog/category/view/id/48', 1, NULL, NULL, 48, NULL),
(4980, 1, 'category/49', 'laptop.html', 'catalog/category/view/id/49', 1, NULL, NULL, 49, NULL),
(4981, 2, 'category/49', 'laptop.html', 'catalog/category/view/id/49', 1, NULL, NULL, 49, NULL);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(4982, 1, 'category/50', 'accessories-27.html', 'catalog/category/view/id/50', 1, NULL, NULL, 50, NULL),
(4983, 2, 'category/50', 'accessories-27.html', 'catalog/category/view/id/50', 1, NULL, NULL, 50, NULL),
(4985, 1, '86938500_1420513257', 'women/shoes.html', 'women/bags/shoes.html', 0, 'RP', NULL, 8, NULL),
(4987, 1, '87938500_1420513257', 'women/shoes/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(4989, 1, '88338600_1420513257', 'women/shoes/leathers.html', 'women/bags/shoes/leathers.html', 0, 'RP', NULL, 16, NULL),
(4991, 1, '89138600_1420513257', 'women/shoes/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(4993, 1, '89738600_1420513257', 'women/shoes/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(4995, 1, '90138700_1420513257', 'women/shoes/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(4997, 2, '91738800_1420513257', 'women/shoes.html', 'women/bags/shoes.html', 0, 'RP', NULL, 8, NULL),
(4999, 2, '93938900_1420513257', 'women/shoes/gloves.html', 'women/bags/shoes/gloves.html', 0, 'RP', NULL, 15, NULL),
(5001, 2, '94338900_1420513257', 'women/shoes/leathers.html', 'women/bags/shoes/leathers.html', 0, 'RP', NULL, 16, NULL),
(5003, 2, '94738900_1420513257', 'women/shoes/cocktail.html', 'women/bags/shoes/cocktail.html', 0, 'RP', NULL, 17, NULL),
(5005, 2, '95039000_1420513257', 'women/shoes/clothing.html', 'women/bags/shoes/clothing.html', 0, 'RP', NULL, 22, NULL),
(5007, 2, '95339000_1420513257', 'women/shoes/rings.html', 'women/bags/shoes/rings.html', 0, 'RP', NULL, 7, NULL),
(5335, 1, '79201100_1420513303', 'women/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(5337, 1, '80401200_1420513303', 'women/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(5339, 1, '81701300_1420513303', 'women/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(5341, 1, '82301300_1420513303', 'women/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(5343, 1, '82901400_1420513303', 'women/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(5345, 1, '83401400_1420513303', 'women/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(5347, 2, '84901500_1420513303', 'women/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(5349, 2, '85301500_1420513303', 'women/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(5351, 2, '86001500_1420513303', 'women/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(5353, 2, '86401600_1420513303', 'women/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(5355, 2, '88101700_1420513303', 'women/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(5357, 2, '88601700_1420513303', 'women/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(5615, 1, '61038700_1420515163', 'women/bags/dresses/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(5617, 2, '62538800_1420515163', 'women/bags/dresses/briefs.html', 'women/bags/briefs.html', 0, 'RP', NULL, 35, NULL),
(5667, 1, '76985400_1420515171', 'women/bags/dresses/blog/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5669, 2, '78085400_1420515171', 'women/bags/dresses/blog/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5679, 1, '93626400_1420515178', 'women/bags/dresses/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5681, 2, '95326500_1420515178', 'women/bags/dresses/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5691, 1, '93454900_1420515183', 'women/bags/dresses/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(5693, 2, '95455100_1420515183', 'women/bags/dresses/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(5717, 1, '60421700_1420515195', 'women/bags/cosmetic/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(5719, 2, '61821800_1420515195', 'women/bags/cosmetic/blog.html', 'women/bags/blog.html', 0, 'RP', NULL, 23, NULL),
(5767, 1, '68650800_1420515200', 'women/bags/cosmetic/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5769, 2, '69750800_1420515200', 'women/bags/cosmetic/bands.html', 'women/bags/bands.html', 0, 'RP', NULL, 18, NULL),
(5815, 1, '71665300_1420515220', 'women/bags/duffle/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(5817, 1, '72465400_1420515220', 'women/bags/duffle/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(5819, 1, '73265400_1420515220', 'women/bags/duffle/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(5821, 1, '73865500_1420515220', 'women/bags/duffle/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(5823, 1, '74765500_1420515220', 'women/bags/duffle/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(5825, 1, '75265500_1420515220', 'women/bags/duffle/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(5827, 2, '76565600_1420515220', 'women/bags/duffle/shirts.html', 'women/bags/shoes/shirts.html', 0, 'RP', NULL, 31, NULL),
(5829, 2, '76965600_1420515220', 'women/bags/duffle/shirts/hair.html', 'women/bags/shoes/shirts/hair.html', 0, 'RP', NULL, 21, NULL),
(5831, 2, '77265700_1420515220', 'women/bags/duffle/shirts/helmet.html', 'women/bags/shoes/shirts/helmet.html', 0, 'RP', NULL, 27, NULL),
(5833, 2, '77865700_1420515220', 'women/bags/duffle/shirts/camis.html', 'women/bags/shoes/shirts/camis.html', 0, 'RP', NULL, 29, NULL),
(5835, 2, '78365700_1420515220', 'women/bags/duffle/shirts/lingerie.html', 'women/bags/shoes/shirts/lingerie.html', 0, 'RP', NULL, 30, NULL),
(5837, 2, '78765700_1420515220', 'women/bags/duffle/shirts/tops.html', 'women/bags/shoes/shirts/tops.html', 0, 'RP', NULL, 32, NULL),
(6085, 1, '32646500_1420515322', 'women/shapewear/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(6087, 2, '35146600_1420515322', 'women/shapewear/nightwear.html', 'women/bags/nightwear.html', 0, 'RP', NULL, 34, NULL),
(6143, 1, '59276600_1420515327', 'women/shapewear/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(6145, 2, '60476700_1420515327', 'women/shapewear/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(6383, 1, '57710900_1420515333', 'women/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(6385, 2, '58910900_1420515333', 'women/duffle.html', 'women/bags/duffle.html', 0, 'RP', NULL, 36, NULL),
(6652, 1, 'category/51', 'women/shapewear/salad-plates.html', 'catalog/category/view/id/51', 1, NULL, NULL, 51, NULL),
(6653, 2, 'category/51', 'women/shapewear/salad-plates.html', 'catalog/category/view/id/51', 1, NULL, NULL, 51, NULL),
(6654, 1, 'category/52', 'women/shapewear/kitchen-storage.html', 'catalog/category/view/id/52', 1, NULL, NULL, 52, NULL),
(6655, 2, 'category/52', 'women/shapewear/kitchen-storage.html', 'catalog/category/view/id/52', 1, NULL, NULL, 52, NULL),
(6656, 1, 'category/53', 'women/shapewear/dish-racks.html', 'catalog/category/view/id/53', 1, NULL, NULL, 53, NULL),
(6657, 2, 'category/53', 'women/shapewear/dish-racks.html', 'catalog/category/view/id/53', 1, NULL, NULL, 53, NULL),
(6658, 1, 'category/54', 'women/shapewear/colanders.html', 'catalog/category/view/id/54', 1, NULL, NULL, 54, NULL),
(6659, 2, 'category/54', 'women/shapewear/colanders.html', 'catalog/category/view/id/54', 1, NULL, NULL, 54, NULL),
(6897, 1, '80936900_1420517278', 'accessories-1.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(7178, 2, '73047900_1420517280', 'accessories-1.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(7459, 1, '63753100_1420517281', 'accessories-2.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(7740, 2, '61558700_1420517282', 'accessories-2.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(8023, 1, '34848900_1420517333', 'accessories-3.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(8304, 2, '18053700_1420517334', 'accessories-3.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(8585, 1, '30560100_1420517335', 'accessories-4.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(8866, 2, '34866100_1420517336', 'accessories-4.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(8913, 1, 'product/29/33', 'women/bags/configurable-product-04-red.html', 'catalog/product/view/id/29/category/33', 1, NULL, NULL, 33, 29),
(8915, 1, 'product/30/33', 'women/bags/configurable-product-04-green.html', 'catalog/product/view/id/30/category/33', 1, NULL, NULL, 33, 30),
(8917, 1, 'product/31/33', 'women/bags/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/33', 1, NULL, NULL, 33, 31),
(8919, 1, 'product/32/33', 'women/bags/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/33', 1, NULL, NULL, 33, 32),
(8921, 1, 'product/33/33', 'women/bags/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/33', 1, NULL, NULL, 33, 33),
(8923, 1, 'product/34/33', 'women/bags/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/33', 1, NULL, NULL, 33, 34),
(8925, 1, 'product/35/33', 'women/bags/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/33', 1, NULL, NULL, 33, 35),
(8927, 1, 'product/36/33', 'women/bags/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/33', 1, NULL, NULL, 33, 36),
(8929, 1, 'product/37/33', 'women/bags/simple-product-01.html', 'catalog/product/view/id/37/category/33', 1, NULL, NULL, 33, 37),
(8931, 1, 'product/38/33', 'women/bags/simple-product-02.html', 'catalog/product/view/id/38/category/33', 1, NULL, NULL, 33, 38),
(8933, 1, 'product/39/33', 'women/bags/simple-product-03.html', 'catalog/product/view/id/39/category/33', 1, NULL, NULL, 33, 39),
(8935, 1, 'product/40/33', 'women/bags/simple-product-04.html', 'catalog/product/view/id/40/category/33', 1, NULL, NULL, 33, 40),
(8937, 1, 'product/41/33', 'women/bags/simple-product-05.html', 'catalog/product/view/id/41/category/33', 1, NULL, NULL, 33, 41),
(8939, 1, 'product/42/33', 'women/bags/grouped-product.html', 'catalog/product/view/id/42/category/33', 1, NULL, NULL, 33, 42),
(8943, 1, 'product/44/33', 'women/bags/bundle-product.html', 'catalog/product/view/id/44/category/33', 1, NULL, NULL, 33, 44),
(8945, 1, 'product/45/33', 'women/bags/bundle-product-02.html', 'catalog/product/view/id/45/category/33', 1, NULL, NULL, 33, 45),
(8947, 1, 'product/46/33', 'women/bags/downloadable-product.html', 'catalog/product/view/id/46/category/33', 1, NULL, NULL, 33, 46),
(8949, 1, 'product/47/33', 'women/bags/no-image.html', 'catalog/product/view/id/47/category/33', 1, NULL, NULL, 33, 47),
(8974, 2, 'product/29/33', 'women/bags/configurable-product-04-red.html', 'catalog/product/view/id/29/category/33', 1, NULL, NULL, 33, 29),
(8976, 2, 'product/30/33', 'women/bags/configurable-product-04-green.html', 'catalog/product/view/id/30/category/33', 1, NULL, NULL, 33, 30),
(8978, 2, 'product/31/33', 'women/bags/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/33', 1, NULL, NULL, 33, 31),
(8980, 2, 'product/32/33', 'women/bags/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/33', 1, NULL, NULL, 33, 32),
(8982, 2, 'product/33/33', 'women/bags/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/33', 1, NULL, NULL, 33, 33),
(8984, 2, 'product/34/33', 'women/bags/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/33', 1, NULL, NULL, 33, 34),
(8986, 2, 'product/35/33', 'women/bags/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/33', 1, NULL, NULL, 33, 35),
(8988, 2, 'product/36/33', 'women/bags/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/33', 1, NULL, NULL, 33, 36),
(8990, 2, 'product/37/33', 'women/bags/simple-product-01.html', 'catalog/product/view/id/37/category/33', 1, NULL, NULL, 33, 37),
(8992, 2, 'product/38/33', 'women/bags/simple-product-02.html', 'catalog/product/view/id/38/category/33', 1, NULL, NULL, 33, 38),
(8994, 2, 'product/39/33', 'women/bags/simple-product-03.html', 'catalog/product/view/id/39/category/33', 1, NULL, NULL, 33, 39),
(8996, 2, 'product/40/33', 'women/bags/simple-product-04.html', 'catalog/product/view/id/40/category/33', 1, NULL, NULL, 33, 40),
(8998, 2, 'product/41/33', 'women/bags/simple-product-05.html', 'catalog/product/view/id/41/category/33', 1, NULL, NULL, 33, 41),
(9000, 2, 'product/42/33', 'women/bags/grouped-product.html', 'catalog/product/view/id/42/category/33', 1, NULL, NULL, 33, 42),
(9004, 2, 'product/44/33', 'women/bags/bundle-product.html', 'catalog/product/view/id/44/category/33', 1, NULL, NULL, 33, 44),
(9006, 2, 'product/45/33', 'women/bags/bundle-product-02.html', 'catalog/product/view/id/45/category/33', 1, NULL, NULL, 33, 45),
(9008, 2, 'product/46/33', 'women/bags/downloadable-product.html', 'catalog/product/view/id/46/category/33', 1, NULL, NULL, 33, 46),
(9010, 2, 'product/47/33', 'women/bags/no-image.html', 'catalog/product/view/id/47/category/33', 1, NULL, NULL, 33, 47),
(9035, 1, 'product/33/9', 'women/shapewear/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/9', 1, NULL, NULL, 9, 33),
(9037, 1, 'product/34/9', 'women/shapewear/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/9', 1, NULL, NULL, 9, 34),
(9039, 1, 'product/35/9', 'women/shapewear/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/9', 1, NULL, NULL, 9, 35),
(9041, 1, 'product/36/9', 'women/shapewear/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/9', 1, NULL, NULL, 9, 36),
(9043, 1, 'product/37/9', 'women/shapewear/simple-product-01.html', 'catalog/product/view/id/37/category/9', 1, NULL, NULL, 9, 37),
(9045, 1, 'product/38/9', 'women/shapewear/simple-product-02.html', 'catalog/product/view/id/38/category/9', 1, NULL, NULL, 9, 38),
(9047, 1, 'product/39/9', 'women/shapewear/simple-product-03.html', 'catalog/product/view/id/39/category/9', 1, NULL, NULL, 9, 39),
(9049, 1, 'product/40/9', 'women/shapewear/simple-product-04.html', 'catalog/product/view/id/40/category/9', 1, NULL, NULL, 9, 40),
(9051, 1, 'product/41/9', 'women/shapewear/simple-product-05.html', 'catalog/product/view/id/41/category/9', 1, NULL, NULL, 9, 41),
(9053, 1, 'product/42/9', 'women/shapewear/grouped-product.html', 'catalog/product/view/id/42/category/9', 1, NULL, NULL, 9, 42),
(9057, 1, 'product/44/9', 'women/shapewear/bundle-product.html', 'catalog/product/view/id/44/category/9', 1, NULL, NULL, 9, 44),
(9059, 1, 'product/45/9', 'women/shapewear/bundle-product-02.html', 'catalog/product/view/id/45/category/9', 1, NULL, NULL, 9, 45),
(9061, 1, 'product/46/9', 'women/shapewear/downloadable-product.html', 'catalog/product/view/id/46/category/9', 1, NULL, NULL, 9, 46),
(9063, 1, 'product/47/9', 'women/shapewear/no-image.html', 'catalog/product/view/id/47/category/9', 1, NULL, NULL, 9, 47),
(9077, 2, 'product/33/9', 'women/shapewear/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/9', 1, NULL, NULL, 9, 33),
(9079, 2, 'product/34/9', 'women/shapewear/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/9', 1, NULL, NULL, 9, 34),
(9081, 2, 'product/35/9', 'women/shapewear/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/9', 1, NULL, NULL, 9, 35),
(9083, 2, 'product/36/9', 'women/shapewear/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/9', 1, NULL, NULL, 9, 36),
(9085, 2, 'product/37/9', 'women/shapewear/simple-product-01.html', 'catalog/product/view/id/37/category/9', 1, NULL, NULL, 9, 37),
(9087, 2, 'product/38/9', 'women/shapewear/simple-product-02.html', 'catalog/product/view/id/38/category/9', 1, NULL, NULL, 9, 38),
(9089, 2, 'product/39/9', 'women/shapewear/simple-product-03.html', 'catalog/product/view/id/39/category/9', 1, NULL, NULL, 9, 39),
(9091, 2, 'product/40/9', 'women/shapewear/simple-product-04.html', 'catalog/product/view/id/40/category/9', 1, NULL, NULL, 9, 40),
(9093, 2, 'product/41/9', 'women/shapewear/simple-product-05.html', 'catalog/product/view/id/41/category/9', 1, NULL, NULL, 9, 41),
(9095, 2, 'product/42/9', 'women/shapewear/grouped-product.html', 'catalog/product/view/id/42/category/9', 1, NULL, NULL, 9, 42),
(9099, 2, 'product/44/9', 'women/shapewear/bundle-product.html', 'catalog/product/view/id/44/category/9', 1, NULL, NULL, 9, 44),
(9101, 2, 'product/45/9', 'women/shapewear/bundle-product-02.html', 'catalog/product/view/id/45/category/9', 1, NULL, NULL, 9, 45),
(9103, 2, 'product/46/9', 'women/shapewear/downloadable-product.html', 'catalog/product/view/id/46/category/9', 1, NULL, NULL, 9, 46),
(9105, 2, 'product/47/9', 'women/shapewear/no-image.html', 'catalog/product/view/id/47/category/9', 1, NULL, NULL, 9, 47),
(9119, 1, 'product/29/19', 'tv-audio/bicycle/configurable-product-04-red.html', 'catalog/product/view/id/29/category/19', 1, NULL, NULL, 19, 29),
(9121, 1, 'product/30/19', 'tv-audio/bicycle/configurable-product-04-green.html', 'catalog/product/view/id/30/category/19', 1, NULL, NULL, 19, 30),
(9123, 1, 'product/31/19', 'tv-audio/bicycle/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/19', 1, NULL, NULL, 19, 31),
(9125, 1, 'product/32/19', 'tv-audio/bicycle/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/19', 1, NULL, NULL, 19, 32),
(9127, 1, 'product/33/19', 'tv-audio/bicycle/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/19', 1, NULL, NULL, 19, 33),
(9129, 1, 'product/34/19', 'tv-audio/bicycle/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/19', 1, NULL, NULL, 19, 34),
(9131, 1, 'product/35/19', 'tv-audio/bicycle/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/19', 1, NULL, NULL, 19, 35),
(9133, 1, 'product/36/19', 'tv-audio/bicycle/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/19', 1, NULL, NULL, 19, 36),
(9135, 1, 'product/37/19', 'tv-audio/bicycle/simple-product-01.html', 'catalog/product/view/id/37/category/19', 1, NULL, NULL, 19, 37),
(9137, 1, 'product/38/19', 'tv-audio/bicycle/simple-product-02.html', 'catalog/product/view/id/38/category/19', 1, NULL, NULL, 19, 38),
(9139, 1, 'product/39/19', 'tv-audio/bicycle/simple-product-03.html', 'catalog/product/view/id/39/category/19', 1, NULL, NULL, 19, 39),
(9141, 1, 'product/40/19', 'tv-audio/bicycle/simple-product-04.html', 'catalog/product/view/id/40/category/19', 1, NULL, NULL, 19, 40),
(9143, 1, 'product/41/19', 'tv-audio/bicycle/simple-product-05.html', 'catalog/product/view/id/41/category/19', 1, NULL, NULL, 19, 41),
(9145, 1, 'product/42/19', 'tv-audio/bicycle/grouped-product.html', 'catalog/product/view/id/42/category/19', 1, NULL, NULL, 19, 42),
(9149, 1, 'product/44/19', 'tv-audio/bicycle/bundle-product.html', 'catalog/product/view/id/44/category/19', 1, NULL, NULL, 19, 44),
(9151, 1, 'product/45/19', 'tv-audio/bicycle/bundle-product-02.html', 'catalog/product/view/id/45/category/19', 1, NULL, NULL, 19, 45),
(9153, 1, 'product/46/19', 'tv-audio/bicycle/downloadable-product.html', 'catalog/product/view/id/46/category/19', 1, NULL, NULL, 19, 46),
(9155, 1, 'product/47/19', 'tv-audio/bicycle/no-image.html', 'catalog/product/view/id/47/category/19', 1, NULL, NULL, 19, 47),
(9169, 2, 'product/29/19', 'tv-audio/bicycle/configurable-product-04-red.html', 'catalog/product/view/id/29/category/19', 1, NULL, NULL, 19, 29),
(9171, 2, 'product/30/19', 'tv-audio/bicycle/configurable-product-04-green.html', 'catalog/product/view/id/30/category/19', 1, NULL, NULL, 19, 30),
(9173, 2, 'product/31/19', 'tv-audio/bicycle/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/19', 1, NULL, NULL, 19, 31),
(9175, 2, 'product/32/19', 'tv-audio/bicycle/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/19', 1, NULL, NULL, 19, 32),
(9177, 2, 'product/33/19', 'tv-audio/bicycle/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/19', 1, NULL, NULL, 19, 33),
(9179, 2, 'product/34/19', 'tv-audio/bicycle/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/19', 1, NULL, NULL, 19, 34),
(9181, 2, 'product/35/19', 'tv-audio/bicycle/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/19', 1, NULL, NULL, 19, 35),
(9183, 2, 'product/36/19', 'tv-audio/bicycle/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/19', 1, NULL, NULL, 19, 36),
(9185, 2, 'product/37/19', 'tv-audio/bicycle/simple-product-01.html', 'catalog/product/view/id/37/category/19', 1, NULL, NULL, 19, 37),
(9187, 2, 'product/38/19', 'tv-audio/bicycle/simple-product-02.html', 'catalog/product/view/id/38/category/19', 1, NULL, NULL, 19, 38),
(9189, 2, 'product/39/19', 'tv-audio/bicycle/simple-product-03.html', 'catalog/product/view/id/39/category/19', 1, NULL, NULL, 19, 39),
(9191, 2, 'product/40/19', 'tv-audio/bicycle/simple-product-04.html', 'catalog/product/view/id/40/category/19', 1, NULL, NULL, 19, 40),
(9193, 2, 'product/41/19', 'tv-audio/bicycle/simple-product-05.html', 'catalog/product/view/id/41/category/19', 1, NULL, NULL, 19, 41),
(9195, 2, 'product/42/19', 'tv-audio/bicycle/grouped-product.html', 'catalog/product/view/id/42/category/19', 1, NULL, NULL, 19, 42),
(9199, 2, 'product/44/19', 'tv-audio/bicycle/bundle-product.html', 'catalog/product/view/id/44/category/19', 1, NULL, NULL, 19, 44),
(9201, 2, 'product/45/19', 'tv-audio/bicycle/bundle-product-02.html', 'catalog/product/view/id/45/category/19', 1, NULL, NULL, 19, 45),
(9203, 2, 'product/46/19', 'tv-audio/bicycle/downloadable-product.html', 'catalog/product/view/id/46/category/19', 1, NULL, NULL, 19, 46),
(9205, 2, 'product/47/19', 'tv-audio/bicycle/no-image.html', 'catalog/product/view/id/47/category/19', 1, NULL, NULL, 19, 47),
(9206, 1, 'category/55', 'casio-watches.html', 'catalog/category/view/id/55', 1, NULL, NULL, 55, NULL),
(9207, 2, 'category/55', 'casio-watches.html', 'catalog/category/view/id/55', 1, NULL, NULL, 55, NULL),
(9208, 1, 'category/56', 'asus-tablets.html', 'catalog/category/view/id/56', 1, NULL, NULL, 56, NULL),
(9209, 2, 'category/56', 'asus-tablets.html', 'catalog/category/view/id/56', 1, NULL, NULL, 56, NULL),
(9210, 1, 'category/57', 'women-fashion.html', 'catalog/category/view/id/57', 1, NULL, NULL, 57, NULL),
(9211, 2, 'category/57', 'women-fashion.html', 'catalog/category/view/id/57', 1, NULL, NULL, 57, NULL),
(9216, 1, 'product/29/5', 'kid/configurable-product-04-red.html', 'catalog/product/view/id/29/category/5', 1, NULL, NULL, 5, 29),
(9218, 1, 'product/30/5', 'kid/configurable-product-04-green.html', 'catalog/product/view/id/30/category/5', 1, NULL, NULL, 5, 30),
(9220, 1, 'product/31/5', 'kid/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/5', 1, NULL, NULL, 5, 31),
(9222, 1, 'product/32/5', 'kid/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/5', 1, NULL, NULL, 5, 32),
(9224, 1, 'product/33/5', 'kid/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/5', 1, NULL, NULL, 5, 33),
(9226, 1, 'product/34/5', 'kid/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/5', 1, NULL, NULL, 5, 34),
(9228, 1, 'product/35/5', 'kid/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/5', 1, NULL, NULL, 5, 35),
(9230, 1, 'product/36/5', 'kid/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/5', 1, NULL, NULL, 5, 36),
(9232, 1, 'product/37/5', 'kid/simple-product-01.html', 'catalog/product/view/id/37/category/5', 1, NULL, NULL, 5, 37),
(9234, 1, 'product/38/5', 'kid/simple-product-02.html', 'catalog/product/view/id/38/category/5', 1, NULL, NULL, 5, 38),
(9236, 1, 'product/39/5', 'kid/simple-product-03.html', 'catalog/product/view/id/39/category/5', 1, NULL, NULL, 5, 39),
(9238, 1, 'product/40/5', 'kid/simple-product-04.html', 'catalog/product/view/id/40/category/5', 1, NULL, NULL, 5, 40),
(9240, 1, 'product/41/5', 'kid/simple-product-05.html', 'catalog/product/view/id/41/category/5', 1, NULL, NULL, 5, 41),
(9242, 1, 'product/42/5', 'kid/grouped-product.html', 'catalog/product/view/id/42/category/5', 1, NULL, NULL, 5, 42),
(9246, 1, 'product/44/5', 'kid/bundle-product.html', 'catalog/product/view/id/44/category/5', 1, NULL, NULL, 5, 44),
(9248, 1, 'product/45/5', 'kid/bundle-product-02.html', 'catalog/product/view/id/45/category/5', 1, NULL, NULL, 5, 45),
(9250, 1, 'product/46/5', 'kid/downloadable-product.html', 'catalog/product/view/id/46/category/5', 1, NULL, NULL, 5, 46),
(9257, 2, 'product/29/5', 'kid/configurable-product-04-red.html', 'catalog/product/view/id/29/category/5', 1, NULL, NULL, 5, 29),
(9259, 2, 'product/30/5', 'kid/configurable-product-04-green.html', 'catalog/product/view/id/30/category/5', 1, NULL, NULL, 5, 30),
(9261, 2, 'product/31/5', 'kid/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/5', 1, NULL, NULL, 5, 31),
(9263, 2, 'product/32/5', 'kid/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/5', 1, NULL, NULL, 5, 32),
(9265, 2, 'product/33/5', 'kid/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/5', 1, NULL, NULL, 5, 33),
(9267, 2, 'product/34/5', 'kid/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/5', 1, NULL, NULL, 5, 34),
(9269, 2, 'product/35/5', 'kid/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/5', 1, NULL, NULL, 5, 35),
(9271, 2, 'product/36/5', 'kid/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/5', 1, NULL, NULL, 5, 36),
(9273, 2, 'product/37/5', 'kid/simple-product-01.html', 'catalog/product/view/id/37/category/5', 1, NULL, NULL, 5, 37),
(9275, 2, 'product/38/5', 'kid/simple-product-02.html', 'catalog/product/view/id/38/category/5', 1, NULL, NULL, 5, 38),
(9277, 2, 'product/39/5', 'kid/simple-product-03.html', 'catalog/product/view/id/39/category/5', 1, NULL, NULL, 5, 39),
(9279, 2, 'product/40/5', 'kid/simple-product-04.html', 'catalog/product/view/id/40/category/5', 1, NULL, NULL, 5, 40),
(9281, 2, 'product/41/5', 'kid/simple-product-05.html', 'catalog/product/view/id/41/category/5', 1, NULL, NULL, 5, 41),
(9283, 2, 'product/42/5', 'kid/grouped-product.html', 'catalog/product/view/id/42/category/5', 1, NULL, NULL, 5, 42),
(9287, 2, 'product/44/5', 'kid/bundle-product.html', 'catalog/product/view/id/44/category/5', 1, NULL, NULL, 5, 44),
(9289, 2, 'product/45/5', 'kid/bundle-product-02.html', 'catalog/product/view/id/45/category/5', 1, NULL, NULL, 5, 45),
(9291, 2, 'product/46/5', 'kid/downloadable-product.html', 'catalog/product/view/id/46/category/5', 1, NULL, NULL, 5, 46),
(9372, 1, 'product/29/44', 'laptops-computers/configurable-product-04-red.html', 'catalog/product/view/id/29/category/44', 1, NULL, NULL, 44, 29),
(9374, 1, 'product/30/44', 'laptops-computers/configurable-product-04-green.html', 'catalog/product/view/id/30/category/44', 1, NULL, NULL, 44, 30),
(9376, 1, 'product/31/44', 'laptops-computers/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/44', 1, NULL, NULL, 44, 31),
(9378, 1, 'product/32/44', 'laptops-computers/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/44', 1, NULL, NULL, 44, 32),
(9380, 1, 'product/33/44', 'laptops-computers/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/44', 1, NULL, NULL, 44, 33),
(9382, 1, 'product/34/44', 'laptops-computers/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/44', 1, NULL, NULL, 44, 34),
(9384, 1, 'product/35/44', 'laptops-computers/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/44', 1, NULL, NULL, 44, 35),
(9386, 1, 'product/36/44', 'laptops-computers/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/44', 1, NULL, NULL, 44, 36),
(9388, 1, 'product/37/44', 'laptops-computers/simple-product-01.html', 'catalog/product/view/id/37/category/44', 1, NULL, NULL, 44, 37),
(9390, 1, 'product/38/44', 'laptops-computers/simple-product-02.html', 'catalog/product/view/id/38/category/44', 1, NULL, NULL, 44, 38),
(9392, 1, 'product/39/44', 'laptops-computers/simple-product-03.html', 'catalog/product/view/id/39/category/44', 1, NULL, NULL, 44, 39),
(9394, 1, 'product/40/44', 'laptops-computers/simple-product-04.html', 'catalog/product/view/id/40/category/44', 1, NULL, NULL, 44, 40),
(9396, 1, 'product/41/44', 'laptops-computers/simple-product-05.html', 'catalog/product/view/id/41/category/44', 1, NULL, NULL, 44, 41),
(9398, 1, 'product/42/44', 'laptops-computers/grouped-product.html', 'catalog/product/view/id/42/category/44', 1, NULL, NULL, 44, 42),
(9402, 1, 'product/44/44', 'laptops-computers/bundle-product.html', 'catalog/product/view/id/44/category/44', 1, NULL, NULL, 44, 44),
(9404, 1, 'product/45/44', 'laptops-computers/bundle-product-02.html', 'catalog/product/view/id/45/category/44', 1, NULL, NULL, 44, 45),
(9406, 1, 'product/46/44', 'laptops-computers/downloadable-product.html', 'catalog/product/view/id/46/category/44', 1, NULL, NULL, 44, 46),
(9408, 1, 'product/47/44', 'laptops-computers/no-image.html', 'catalog/product/view/id/47/category/44', 1, NULL, NULL, 44, 47),
(9413, 2, 'product/29/44', 'laptops-computers/configurable-product-04-red.html', 'catalog/product/view/id/29/category/44', 1, NULL, NULL, 44, 29),
(9415, 2, 'product/30/44', 'laptops-computers/configurable-product-04-green.html', 'catalog/product/view/id/30/category/44', 1, NULL, NULL, 44, 30),
(9417, 2, 'product/31/44', 'laptops-computers/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/44', 1, NULL, NULL, 44, 31),
(9419, 2, 'product/32/44', 'laptops-computers/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/44', 1, NULL, NULL, 44, 32),
(9421, 2, 'product/33/44', 'laptops-computers/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/44', 1, NULL, NULL, 44, 33),
(9423, 2, 'product/34/44', 'laptops-computers/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/44', 1, NULL, NULL, 44, 34),
(9425, 2, 'product/35/44', 'laptops-computers/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/44', 1, NULL, NULL, 44, 35),
(9427, 2, 'product/36/44', 'laptops-computers/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/44', 1, NULL, NULL, 44, 36),
(9429, 2, 'product/37/44', 'laptops-computers/simple-product-01.html', 'catalog/product/view/id/37/category/44', 1, NULL, NULL, 44, 37),
(9431, 2, 'product/38/44', 'laptops-computers/simple-product-02.html', 'catalog/product/view/id/38/category/44', 1, NULL, NULL, 44, 38),
(9433, 2, 'product/39/44', 'laptops-computers/simple-product-03.html', 'catalog/product/view/id/39/category/44', 1, NULL, NULL, 44, 39),
(9435, 2, 'product/40/44', 'laptops-computers/simple-product-04.html', 'catalog/product/view/id/40/category/44', 1, NULL, NULL, 44, 40),
(9437, 2, 'product/41/44', 'laptops-computers/simple-product-05.html', 'catalog/product/view/id/41/category/44', 1, NULL, NULL, 44, 41),
(9439, 2, 'product/42/44', 'laptops-computers/grouped-product.html', 'catalog/product/view/id/42/category/44', 1, NULL, NULL, 44, 42),
(9443, 2, 'product/44/44', 'laptops-computers/bundle-product.html', 'catalog/product/view/id/44/category/44', 1, NULL, NULL, 44, 44),
(9445, 2, 'product/45/44', 'laptops-computers/bundle-product-02.html', 'catalog/product/view/id/45/category/44', 1, NULL, NULL, 44, 45),
(9447, 2, 'product/46/44', 'laptops-computers/downloadable-product.html', 'catalog/product/view/id/46/category/44', 1, NULL, NULL, 44, 46),
(9449, 2, 'product/47/44', 'laptops-computers/no-image.html', 'catalog/product/view/id/47/category/44', 1, NULL, NULL, 44, 47),
(9454, 1, 'product/29/6', 'accessories/configurable-product-04-red.html', 'catalog/product/view/id/29/category/6', 1, NULL, NULL, 6, 29),
(9456, 1, 'product/30/6', 'accessories/configurable-product-04-green.html', 'catalog/product/view/id/30/category/6', 1, NULL, NULL, 6, 30),
(9458, 1, 'product/31/6', 'accessories/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/6', 1, NULL, NULL, 6, 31),
(9460, 1, 'product/32/6', 'accessories/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/6', 1, NULL, NULL, 6, 32),
(9462, 1, 'product/33/6', 'accessories/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/6', 1, NULL, NULL, 6, 33),
(9464, 1, 'product/34/6', 'accessories/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/6', 1, NULL, NULL, 6, 34),
(9466, 1, 'product/35/6', 'accessories/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/6', 1, NULL, NULL, 6, 35),
(9468, 1, 'product/36/6', 'accessories/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/6', 1, NULL, NULL, 6, 36),
(9470, 1, 'product/37/6', 'accessories/simple-product-01.html', 'catalog/product/view/id/37/category/6', 1, NULL, NULL, 6, 37),
(9472, 1, 'product/38/6', 'accessories/simple-product-02.html', 'catalog/product/view/id/38/category/6', 1, NULL, NULL, 6, 38),
(9474, 1, 'product/39/6', 'accessories/simple-product-03.html', 'catalog/product/view/id/39/category/6', 1, NULL, NULL, 6, 39),
(9476, 1, 'product/40/6', 'accessories/simple-product-04.html', 'catalog/product/view/id/40/category/6', 1, NULL, NULL, 6, 40),
(9478, 1, 'product/41/6', 'accessories/simple-product-05.html', 'catalog/product/view/id/41/category/6', 1, NULL, NULL, 6, 41),
(9480, 1, 'product/42/6', 'accessories/grouped-product.html', 'catalog/product/view/id/42/category/6', 1, NULL, NULL, 6, 42),
(9484, 1, 'product/44/6', 'accessories/bundle-product.html', 'catalog/product/view/id/44/category/6', 1, NULL, NULL, 6, 44),
(9486, 1, 'product/45/6', 'accessories/bundle-product-02.html', 'catalog/product/view/id/45/category/6', 1, NULL, NULL, 6, 45),
(9488, 1, 'product/46/6', 'accessories/downloadable-product.html', 'catalog/product/view/id/46/category/6', 1, NULL, NULL, 6, 46),
(9490, 1, 'product/47/6', 'accessories/no-image.html', 'catalog/product/view/id/47/category/6', 1, NULL, NULL, 6, 47),
(9591, 2, 'product/29/6', 'accessories/configurable-product-04-red.html', 'catalog/product/view/id/29/category/6', 1, NULL, NULL, 6, 29),
(9593, 2, 'product/30/6', 'accessories/configurable-product-04-green.html', 'catalog/product/view/id/30/category/6', 1, NULL, NULL, 6, 30),
(9595, 2, 'product/31/6', 'accessories/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/6', 1, NULL, NULL, 6, 31),
(9597, 2, 'product/32/6', 'accessories/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/6', 1, NULL, NULL, 6, 32),
(9599, 2, 'product/33/6', 'accessories/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/6', 1, NULL, NULL, 6, 33),
(9601, 2, 'product/34/6', 'accessories/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/6', 1, NULL, NULL, 6, 34),
(9603, 2, 'product/35/6', 'accessories/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/6', 1, NULL, NULL, 6, 35),
(9605, 2, 'product/36/6', 'accessories/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/6', 1, NULL, NULL, 6, 36),
(9607, 2, 'product/37/6', 'accessories/simple-product-01.html', 'catalog/product/view/id/37/category/6', 1, NULL, NULL, 6, 37),
(9609, 2, 'product/38/6', 'accessories/simple-product-02.html', 'catalog/product/view/id/38/category/6', 1, NULL, NULL, 6, 38),
(9611, 2, 'product/39/6', 'accessories/simple-product-03.html', 'catalog/product/view/id/39/category/6', 1, NULL, NULL, 6, 39),
(9613, 2, 'product/40/6', 'accessories/simple-product-04.html', 'catalog/product/view/id/40/category/6', 1, NULL, NULL, 6, 40),
(9615, 2, 'product/41/6', 'accessories/simple-product-05.html', 'catalog/product/view/id/41/category/6', 1, NULL, NULL, 6, 41),
(9617, 2, 'product/42/6', 'accessories/grouped-product.html', 'catalog/product/view/id/42/category/6', 1, NULL, NULL, 6, 42),
(9621, 2, 'product/44/6', 'accessories/bundle-product.html', 'catalog/product/view/id/44/category/6', 1, NULL, NULL, 6, 44),
(9623, 2, 'product/45/6', 'accessories/bundle-product-02.html', 'catalog/product/view/id/45/category/6', 1, NULL, NULL, 6, 45),
(9625, 2, 'product/46/6', 'accessories/downloadable-product.html', 'catalog/product/view/id/46/category/6', 1, NULL, NULL, 6, 46),
(9627, 2, 'product/47/6', 'accessories/no-image.html', 'catalog/product/view/id/47/category/6', 1, NULL, NULL, 6, 47),
(9728, 1, 'product/29/42', 'cameras-photography/configurable-product-04-red.html', 'catalog/product/view/id/29/category/42', 1, NULL, NULL, 42, 29),
(9730, 1, 'product/30/42', 'cameras-photography/configurable-product-04-green.html', 'catalog/product/view/id/30/category/42', 1, NULL, NULL, 42, 30),
(9732, 1, 'product/31/42', 'cameras-photography/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/42', 1, NULL, NULL, 42, 31),
(9734, 1, 'product/32/42', 'cameras-photography/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/42', 1, NULL, NULL, 42, 32),
(9736, 1, 'product/33/42', 'cameras-photography/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/42', 1, NULL, NULL, 42, 33),
(9738, 1, 'product/34/42', 'cameras-photography/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/42', 1, NULL, NULL, 42, 34),
(9740, 1, 'product/35/42', 'cameras-photography/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/42', 1, NULL, NULL, 42, 35),
(9742, 1, 'product/36/42', 'cameras-photography/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/42', 1, NULL, NULL, 42, 36),
(9744, 1, 'product/37/42', 'cameras-photography/simple-product-01.html', 'catalog/product/view/id/37/category/42', 1, NULL, NULL, 42, 37),
(9746, 1, 'product/38/42', 'cameras-photography/simple-product-02.html', 'catalog/product/view/id/38/category/42', 1, NULL, NULL, 42, 38),
(9748, 1, 'product/39/42', 'cameras-photography/simple-product-03.html', 'catalog/product/view/id/39/category/42', 1, NULL, NULL, 42, 39),
(9750, 1, 'product/40/42', 'cameras-photography/simple-product-04.html', 'catalog/product/view/id/40/category/42', 1, NULL, NULL, 42, 40),
(9752, 1, 'product/41/42', 'cameras-photography/simple-product-05.html', 'catalog/product/view/id/41/category/42', 1, NULL, NULL, 42, 41),
(9754, 1, 'product/42/42', 'cameras-photography/grouped-product.html', 'catalog/product/view/id/42/category/42', 1, NULL, NULL, 42, 42),
(9758, 1, 'product/44/42', 'cameras-photography/bundle-product.html', 'catalog/product/view/id/44/category/42', 1, NULL, NULL, 42, 44),
(9760, 1, 'product/45/42', 'cameras-photography/bundle-product-02.html', 'catalog/product/view/id/45/category/42', 1, NULL, NULL, 42, 45),
(9762, 1, 'product/46/42', 'cameras-photography/downloadable-product.html', 'catalog/product/view/id/46/category/42', 1, NULL, NULL, 42, 46),
(9764, 1, 'product/47/42', 'cameras-photography/no-image.html', 'catalog/product/view/id/47/category/42', 1, NULL, NULL, 42, 47),
(9769, 2, 'product/29/42', 'cameras-photography/configurable-product-04-red.html', 'catalog/product/view/id/29/category/42', 1, NULL, NULL, 42, 29),
(9771, 2, 'product/30/42', 'cameras-photography/configurable-product-04-green.html', 'catalog/product/view/id/30/category/42', 1, NULL, NULL, 42, 30),
(9773, 2, 'product/31/42', 'cameras-photography/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/42', 1, NULL, NULL, 42, 31),
(9775, 2, 'product/32/42', 'cameras-photography/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/42', 1, NULL, NULL, 42, 32),
(9777, 2, 'product/33/42', 'cameras-photography/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/42', 1, NULL, NULL, 42, 33),
(9779, 2, 'product/34/42', 'cameras-photography/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/42', 1, NULL, NULL, 42, 34),
(9781, 2, 'product/35/42', 'cameras-photography/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/42', 1, NULL, NULL, 42, 35),
(9783, 2, 'product/36/42', 'cameras-photography/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/42', 1, NULL, NULL, 42, 36),
(9785, 2, 'product/37/42', 'cameras-photography/simple-product-01.html', 'catalog/product/view/id/37/category/42', 1, NULL, NULL, 42, 37),
(9787, 2, 'product/38/42', 'cameras-photography/simple-product-02.html', 'catalog/product/view/id/38/category/42', 1, NULL, NULL, 42, 38),
(9789, 2, 'product/39/42', 'cameras-photography/simple-product-03.html', 'catalog/product/view/id/39/category/42', 1, NULL, NULL, 42, 39),
(9791, 2, 'product/40/42', 'cameras-photography/simple-product-04.html', 'catalog/product/view/id/40/category/42', 1, NULL, NULL, 42, 40),
(9793, 2, 'product/41/42', 'cameras-photography/simple-product-05.html', 'catalog/product/view/id/41/category/42', 1, NULL, NULL, 42, 41),
(9795, 2, 'product/42/42', 'cameras-photography/grouped-product.html', 'catalog/product/view/id/42/category/42', 1, NULL, NULL, 42, 42),
(9799, 2, 'product/44/42', 'cameras-photography/bundle-product.html', 'catalog/product/view/id/44/category/42', 1, NULL, NULL, 42, 44),
(9801, 2, 'product/45/42', 'cameras-photography/bundle-product-02.html', 'catalog/product/view/id/45/category/42', 1, NULL, NULL, 42, 45),
(9803, 2, 'product/46/42', 'cameras-photography/downloadable-product.html', 'catalog/product/view/id/46/category/42', 1, NULL, NULL, 42, 46),
(9805, 2, 'product/47/42', 'cameras-photography/no-image.html', 'catalog/product/view/id/47/category/42', 1, NULL, NULL, 42, 47),
(9810, 1, 'product/29/43', 'tv-audio/configurable-product-04-red.html', 'catalog/product/view/id/29/category/43', 1, NULL, NULL, 43, 29),
(9812, 1, 'product/30/43', 'tv-audio/configurable-product-04-green.html', 'catalog/product/view/id/30/category/43', 1, NULL, NULL, 43, 30),
(9814, 1, 'product/31/43', 'tv-audio/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/43', 1, NULL, NULL, 43, 31),
(9816, 1, 'product/32/43', 'tv-audio/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/43', 1, NULL, NULL, 43, 32),
(9818, 1, 'product/33/43', 'tv-audio/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/43', 1, NULL, NULL, 43, 33),
(9820, 1, 'product/34/43', 'tv-audio/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/43', 1, NULL, NULL, 43, 34),
(9822, 1, 'product/35/43', 'tv-audio/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/43', 1, NULL, NULL, 43, 35),
(9824, 1, 'product/36/43', 'tv-audio/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/43', 1, NULL, NULL, 43, 36),
(9826, 1, 'product/37/43', 'tv-audio/simple-product-01.html', 'catalog/product/view/id/37/category/43', 1, NULL, NULL, 43, 37),
(9828, 1, 'product/38/43', 'tv-audio/simple-product-02.html', 'catalog/product/view/id/38/category/43', 1, NULL, NULL, 43, 38),
(9830, 1, 'product/39/43', 'tv-audio/simple-product-03.html', 'catalog/product/view/id/39/category/43', 1, NULL, NULL, 43, 39),
(9832, 1, 'product/40/43', 'tv-audio/simple-product-04.html', 'catalog/product/view/id/40/category/43', 1, NULL, NULL, 43, 40),
(9834, 1, 'product/41/43', 'tv-audio/simple-product-05.html', 'catalog/product/view/id/41/category/43', 1, NULL, NULL, 43, 41),
(9836, 1, 'product/42/43', 'tv-audio/grouped-product.html', 'catalog/product/view/id/42/category/43', 1, NULL, NULL, 43, 42),
(9840, 1, 'product/44/43', 'tv-audio/bundle-product.html', 'catalog/product/view/id/44/category/43', 1, NULL, NULL, 43, 44),
(9842, 1, 'product/45/43', 'tv-audio/bundle-product-02.html', 'catalog/product/view/id/45/category/43', 1, NULL, NULL, 43, 45),
(9844, 1, 'product/46/43', 'tv-audio/downloadable-product.html', 'catalog/product/view/id/46/category/43', 1, NULL, NULL, 43, 46),
(9846, 1, 'product/47/43', 'tv-audio/no-image.html', 'catalog/product/view/id/47/category/43', 1, NULL, NULL, 43, 47),
(9851, 2, 'product/29/43', 'tv-audio/configurable-product-04-red.html', 'catalog/product/view/id/29/category/43', 1, NULL, NULL, 43, 29),
(9853, 2, 'product/30/43', 'tv-audio/configurable-product-04-green.html', 'catalog/product/view/id/30/category/43', 1, NULL, NULL, 43, 30),
(9855, 2, 'product/31/43', 'tv-audio/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/43', 1, NULL, NULL, 43, 31),
(9857, 2, 'product/32/43', 'tv-audio/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/43', 1, NULL, NULL, 43, 32),
(9859, 2, 'product/33/43', 'tv-audio/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/43', 1, NULL, NULL, 43, 33),
(9861, 2, 'product/34/43', 'tv-audio/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/43', 1, NULL, NULL, 43, 34),
(9863, 2, 'product/35/43', 'tv-audio/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/43', 1, NULL, NULL, 43, 35),
(9865, 2, 'product/36/43', 'tv-audio/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/43', 1, NULL, NULL, 43, 36),
(9867, 2, 'product/37/43', 'tv-audio/simple-product-01.html', 'catalog/product/view/id/37/category/43', 1, NULL, NULL, 43, 37),
(9869, 2, 'product/38/43', 'tv-audio/simple-product-02.html', 'catalog/product/view/id/38/category/43', 1, NULL, NULL, 43, 38),
(9871, 2, 'product/39/43', 'tv-audio/simple-product-03.html', 'catalog/product/view/id/39/category/43', 1, NULL, NULL, 43, 39),
(9873, 2, 'product/40/43', 'tv-audio/simple-product-04.html', 'catalog/product/view/id/40/category/43', 1, NULL, NULL, 43, 40),
(9875, 2, 'product/41/43', 'tv-audio/simple-product-05.html', 'catalog/product/view/id/41/category/43', 1, NULL, NULL, 43, 41),
(9877, 2, 'product/42/43', 'tv-audio/grouped-product.html', 'catalog/product/view/id/42/category/43', 1, NULL, NULL, 43, 42),
(9881, 2, 'product/44/43', 'tv-audio/bundle-product.html', 'catalog/product/view/id/44/category/43', 1, NULL, NULL, 43, 44),
(9883, 2, 'product/45/43', 'tv-audio/bundle-product-02.html', 'catalog/product/view/id/45/category/43', 1, NULL, NULL, 43, 45),
(9885, 2, 'product/46/43', 'tv-audio/downloadable-product.html', 'catalog/product/view/id/46/category/43', 1, NULL, NULL, 43, 46),
(9887, 2, 'product/47/43', 'tv-audio/no-image.html', 'catalog/product/view/id/47/category/43', 1, NULL, NULL, 43, 47),
(9892, 1, 'product/29/45', 'smart-phones-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/45', 1, NULL, NULL, 45, 29),
(9894, 1, 'product/30/45', 'smart-phones-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/45', 1, NULL, NULL, 45, 30),
(9896, 1, 'product/31/45', 'smart-phones-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/45', 1, NULL, NULL, 45, 31),
(9898, 1, 'product/32/45', 'smart-phones-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/45', 1, NULL, NULL, 45, 32),
(9900, 1, 'product/33/45', 'smart-phones-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/45', 1, NULL, NULL, 45, 33),
(9902, 1, 'product/34/45', 'smart-phones-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/45', 1, NULL, NULL, 45, 34),
(9904, 1, 'product/35/45', 'smart-phones-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/45', 1, NULL, NULL, 45, 35),
(9906, 1, 'product/36/45', 'smart-phones-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/45', 1, NULL, NULL, 45, 36),
(9908, 1, 'product/37/45', 'smart-phones-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/45', 1, NULL, NULL, 45, 37),
(9910, 1, 'product/38/45', 'smart-phones-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/45', 1, NULL, NULL, 45, 38),
(9912, 1, 'product/39/45', 'smart-phones-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/45', 1, NULL, NULL, 45, 39),
(9914, 1, 'product/40/45', 'smart-phones-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/45', 1, NULL, NULL, 45, 40),
(9916, 1, 'product/41/45', 'smart-phones-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/45', 1, NULL, NULL, 45, 41),
(9918, 1, 'product/42/45', 'smart-phones-tablets/grouped-product.html', 'catalog/product/view/id/42/category/45', 1, NULL, NULL, 45, 42),
(9922, 1, 'product/44/45', 'smart-phones-tablets/bundle-product.html', 'catalog/product/view/id/44/category/45', 1, NULL, NULL, 45, 44),
(9924, 1, 'product/45/45', 'smart-phones-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/45', 1, NULL, NULL, 45, 45),
(9926, 1, 'product/46/45', 'smart-phones-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/45', 1, NULL, NULL, 45, 46),
(9928, 1, 'product/47/45', 'smart-phones-tablets/no-image.html', 'catalog/product/view/id/47/category/45', 1, NULL, NULL, 45, 47),
(9933, 2, 'product/29/45', 'smart-phones-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/45', 1, NULL, NULL, 45, 29),
(9935, 2, 'product/30/45', 'smart-phones-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/45', 1, NULL, NULL, 45, 30),
(9937, 2, 'product/31/45', 'smart-phones-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/45', 1, NULL, NULL, 45, 31),
(9939, 2, 'product/32/45', 'smart-phones-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/45', 1, NULL, NULL, 45, 32),
(9941, 2, 'product/33/45', 'smart-phones-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/45', 1, NULL, NULL, 45, 33);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(9943, 2, 'product/34/45', 'smart-phones-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/45', 1, NULL, NULL, 45, 34),
(9945, 2, 'product/35/45', 'smart-phones-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/45', 1, NULL, NULL, 45, 35),
(9947, 2, 'product/36/45', 'smart-phones-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/45', 1, NULL, NULL, 45, 36),
(9949, 2, 'product/37/45', 'smart-phones-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/45', 1, NULL, NULL, 45, 37),
(9951, 2, 'product/38/45', 'smart-phones-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/45', 1, NULL, NULL, 45, 38),
(9953, 2, 'product/39/45', 'smart-phones-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/45', 1, NULL, NULL, 45, 39),
(9955, 2, 'product/40/45', 'smart-phones-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/45', 1, NULL, NULL, 45, 40),
(9957, 2, 'product/41/45', 'smart-phones-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/45', 1, NULL, NULL, 45, 41),
(9959, 2, 'product/42/45', 'smart-phones-tablets/grouped-product.html', 'catalog/product/view/id/42/category/45', 1, NULL, NULL, 45, 42),
(9963, 2, 'product/44/45', 'smart-phones-tablets/bundle-product.html', 'catalog/product/view/id/44/category/45', 1, NULL, NULL, 45, 44),
(9965, 2, 'product/45/45', 'smart-phones-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/45', 1, NULL, NULL, 45, 45),
(9967, 2, 'product/46/45', 'smart-phones-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/45', 1, NULL, NULL, 45, 46),
(9969, 2, 'product/47/45', 'smart-phones-tablets/no-image.html', 'catalog/product/view/id/47/category/45', 1, NULL, NULL, 45, 47),
(9974, 1, 'product/29/46', 'video-games-consoles/configurable-product-04-red.html', 'catalog/product/view/id/29/category/46', 1, NULL, NULL, 46, 29),
(9976, 1, 'product/30/46', 'video-games-consoles/configurable-product-04-green.html', 'catalog/product/view/id/30/category/46', 1, NULL, NULL, 46, 30),
(9978, 1, 'product/31/46', 'video-games-consoles/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/46', 1, NULL, NULL, 46, 31),
(9980, 1, 'product/32/46', 'video-games-consoles/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/46', 1, NULL, NULL, 46, 32),
(9982, 1, 'product/33/46', 'video-games-consoles/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/46', 1, NULL, NULL, 46, 33),
(9984, 1, 'product/34/46', 'video-games-consoles/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/46', 1, NULL, NULL, 46, 34),
(9986, 1, 'product/35/46', 'video-games-consoles/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/46', 1, NULL, NULL, 46, 35),
(9988, 1, 'product/36/46', 'video-games-consoles/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/46', 1, NULL, NULL, 46, 36),
(9990, 1, 'product/37/46', 'video-games-consoles/simple-product-01.html', 'catalog/product/view/id/37/category/46', 1, NULL, NULL, 46, 37),
(9992, 1, 'product/38/46', 'video-games-consoles/simple-product-02.html', 'catalog/product/view/id/38/category/46', 1, NULL, NULL, 46, 38),
(9994, 1, 'product/39/46', 'video-games-consoles/simple-product-03.html', 'catalog/product/view/id/39/category/46', 1, NULL, NULL, 46, 39),
(9996, 1, 'product/40/46', 'video-games-consoles/simple-product-04.html', 'catalog/product/view/id/40/category/46', 1, NULL, NULL, 46, 40),
(9998, 1, 'product/41/46', 'video-games-consoles/simple-product-05.html', 'catalog/product/view/id/41/category/46', 1, NULL, NULL, 46, 41),
(10000, 1, 'product/42/46', 'video-games-consoles/grouped-product.html', 'catalog/product/view/id/42/category/46', 1, NULL, NULL, 46, 42),
(10004, 1, 'product/44/46', 'video-games-consoles/bundle-product.html', 'catalog/product/view/id/44/category/46', 1, NULL, NULL, 46, 44),
(10006, 1, 'product/45/46', 'video-games-consoles/bundle-product-02.html', 'catalog/product/view/id/45/category/46', 1, NULL, NULL, 46, 45),
(10008, 1, 'product/46/46', 'video-games-consoles/downloadable-product.html', 'catalog/product/view/id/46/category/46', 1, NULL, NULL, 46, 46),
(10010, 1, 'product/47/46', 'video-games-consoles/no-image.html', 'catalog/product/view/id/47/category/46', 1, NULL, NULL, 46, 47),
(10015, 2, 'product/29/46', 'video-games-consoles/configurable-product-04-red.html', 'catalog/product/view/id/29/category/46', 1, NULL, NULL, 46, 29),
(10017, 2, 'product/30/46', 'video-games-consoles/configurable-product-04-green.html', 'catalog/product/view/id/30/category/46', 1, NULL, NULL, 46, 30),
(10019, 2, 'product/31/46', 'video-games-consoles/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/46', 1, NULL, NULL, 46, 31),
(10021, 2, 'product/32/46', 'video-games-consoles/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/46', 1, NULL, NULL, 46, 32),
(10023, 2, 'product/33/46', 'video-games-consoles/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/46', 1, NULL, NULL, 46, 33),
(10025, 2, 'product/34/46', 'video-games-consoles/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/46', 1, NULL, NULL, 46, 34),
(10027, 2, 'product/35/46', 'video-games-consoles/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/46', 1, NULL, NULL, 46, 35),
(10029, 2, 'product/36/46', 'video-games-consoles/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/46', 1, NULL, NULL, 46, 36),
(10031, 2, 'product/37/46', 'video-games-consoles/simple-product-01.html', 'catalog/product/view/id/37/category/46', 1, NULL, NULL, 46, 37),
(10033, 2, 'product/38/46', 'video-games-consoles/simple-product-02.html', 'catalog/product/view/id/38/category/46', 1, NULL, NULL, 46, 38),
(10035, 2, 'product/39/46', 'video-games-consoles/simple-product-03.html', 'catalog/product/view/id/39/category/46', 1, NULL, NULL, 46, 39),
(10037, 2, 'product/40/46', 'video-games-consoles/simple-product-04.html', 'catalog/product/view/id/40/category/46', 1, NULL, NULL, 46, 40),
(10039, 2, 'product/41/46', 'video-games-consoles/simple-product-05.html', 'catalog/product/view/id/41/category/46', 1, NULL, NULL, 46, 41),
(10041, 2, 'product/42/46', 'video-games-consoles/grouped-product.html', 'catalog/product/view/id/42/category/46', 1, NULL, NULL, 46, 42),
(10045, 2, 'product/44/46', 'video-games-consoles/bundle-product.html', 'catalog/product/view/id/44/category/46', 1, NULL, NULL, 46, 44),
(10047, 2, 'product/45/46', 'video-games-consoles/bundle-product-02.html', 'catalog/product/view/id/45/category/46', 1, NULL, NULL, 46, 45),
(10049, 2, 'product/46/46', 'video-games-consoles/downloadable-product.html', 'catalog/product/view/id/46/category/46', 1, NULL, NULL, 46, 46),
(10051, 2, 'product/47/46', 'video-games-consoles/no-image.html', 'catalog/product/view/id/47/category/46', 1, NULL, NULL, 46, 47),
(10056, 1, 'product/29/47', 'gadgets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/47', 1, NULL, NULL, 47, 29),
(10058, 1, 'product/30/47', 'gadgets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/47', 1, NULL, NULL, 47, 30),
(10060, 1, 'product/31/47', 'gadgets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/47', 1, NULL, NULL, 47, 31),
(10062, 1, 'product/32/47', 'gadgets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/47', 1, NULL, NULL, 47, 32),
(10064, 1, 'product/33/47', 'gadgets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/47', 1, NULL, NULL, 47, 33),
(10066, 1, 'product/34/47', 'gadgets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/47', 1, NULL, NULL, 47, 34),
(10068, 1, 'product/35/47', 'gadgets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/47', 1, NULL, NULL, 47, 35),
(10070, 1, 'product/36/47', 'gadgets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/47', 1, NULL, NULL, 47, 36),
(10072, 1, 'product/37/47', 'gadgets/simple-product-01.html', 'catalog/product/view/id/37/category/47', 1, NULL, NULL, 47, 37),
(10074, 1, 'product/38/47', 'gadgets/simple-product-02.html', 'catalog/product/view/id/38/category/47', 1, NULL, NULL, 47, 38),
(10076, 1, 'product/39/47', 'gadgets/simple-product-03.html', 'catalog/product/view/id/39/category/47', 1, NULL, NULL, 47, 39),
(10078, 1, 'product/40/47', 'gadgets/simple-product-04.html', 'catalog/product/view/id/40/category/47', 1, NULL, NULL, 47, 40),
(10080, 1, 'product/41/47', 'gadgets/simple-product-05.html', 'catalog/product/view/id/41/category/47', 1, NULL, NULL, 47, 41),
(10082, 1, 'product/42/47', 'gadgets/grouped-product.html', 'catalog/product/view/id/42/category/47', 1, NULL, NULL, 47, 42),
(10086, 1, 'product/44/47', 'gadgets/bundle-product.html', 'catalog/product/view/id/44/category/47', 1, NULL, NULL, 47, 44),
(10088, 1, 'product/45/47', 'gadgets/bundle-product-02.html', 'catalog/product/view/id/45/category/47', 1, NULL, NULL, 47, 45),
(10090, 1, 'product/46/47', 'gadgets/downloadable-product.html', 'catalog/product/view/id/46/category/47', 1, NULL, NULL, 47, 46),
(10092, 1, 'product/47/47', 'gadgets/no-image.html', 'catalog/product/view/id/47/category/47', 1, NULL, NULL, 47, 47),
(10097, 2, 'product/29/47', 'gadgets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/47', 1, NULL, NULL, 47, 29),
(10099, 2, 'product/30/47', 'gadgets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/47', 1, NULL, NULL, 47, 30),
(10101, 2, 'product/31/47', 'gadgets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/47', 1, NULL, NULL, 47, 31),
(10103, 2, 'product/32/47', 'gadgets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/47', 1, NULL, NULL, 47, 32),
(10105, 2, 'product/33/47', 'gadgets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/47', 1, NULL, NULL, 47, 33),
(10107, 2, 'product/34/47', 'gadgets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/47', 1, NULL, NULL, 47, 34),
(10109, 2, 'product/35/47', 'gadgets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/47', 1, NULL, NULL, 47, 35),
(10111, 2, 'product/36/47', 'gadgets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/47', 1, NULL, NULL, 47, 36),
(10113, 2, 'product/37/47', 'gadgets/simple-product-01.html', 'catalog/product/view/id/37/category/47', 1, NULL, NULL, 47, 37),
(10115, 2, 'product/38/47', 'gadgets/simple-product-02.html', 'catalog/product/view/id/38/category/47', 1, NULL, NULL, 47, 38),
(10117, 2, 'product/39/47', 'gadgets/simple-product-03.html', 'catalog/product/view/id/39/category/47', 1, NULL, NULL, 47, 39),
(10119, 2, 'product/40/47', 'gadgets/simple-product-04.html', 'catalog/product/view/id/40/category/47', 1, NULL, NULL, 47, 40),
(10121, 2, 'product/41/47', 'gadgets/simple-product-05.html', 'catalog/product/view/id/41/category/47', 1, NULL, NULL, 47, 41),
(10123, 2, 'product/42/47', 'gadgets/grouped-product.html', 'catalog/product/view/id/42/category/47', 1, NULL, NULL, 47, 42),
(10127, 2, 'product/44/47', 'gadgets/bundle-product.html', 'catalog/product/view/id/44/category/47', 1, NULL, NULL, 47, 44),
(10129, 2, 'product/45/47', 'gadgets/bundle-product-02.html', 'catalog/product/view/id/45/category/47', 1, NULL, NULL, 47, 45),
(10131, 2, 'product/46/47', 'gadgets/downloadable-product.html', 'catalog/product/view/id/46/category/47', 1, NULL, NULL, 47, 46),
(10133, 2, 'product/47/47', 'gadgets/no-image.html', 'catalog/product/view/id/47/category/47', 1, NULL, NULL, 47, 47),
(10138, 1, 'product/29/48', 'car-electronics-gps/configurable-product-04-red.html', 'catalog/product/view/id/29/category/48', 1, NULL, NULL, 48, 29),
(10140, 1, 'product/30/48', 'car-electronics-gps/configurable-product-04-green.html', 'catalog/product/view/id/30/category/48', 1, NULL, NULL, 48, 30),
(10142, 1, 'product/31/48', 'car-electronics-gps/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/48', 1, NULL, NULL, 48, 31),
(10144, 1, 'product/32/48', 'car-electronics-gps/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/48', 1, NULL, NULL, 48, 32),
(10146, 1, 'product/33/48', 'car-electronics-gps/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/48', 1, NULL, NULL, 48, 33),
(10148, 1, 'product/34/48', 'car-electronics-gps/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/48', 1, NULL, NULL, 48, 34),
(10150, 1, 'product/35/48', 'car-electronics-gps/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/48', 1, NULL, NULL, 48, 35),
(10152, 1, 'product/36/48', 'car-electronics-gps/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/48', 1, NULL, NULL, 48, 36),
(10154, 1, 'product/37/48', 'car-electronics-gps/simple-product-01.html', 'catalog/product/view/id/37/category/48', 1, NULL, NULL, 48, 37),
(10156, 1, 'product/38/48', 'car-electronics-gps/simple-product-02.html', 'catalog/product/view/id/38/category/48', 1, NULL, NULL, 48, 38),
(10158, 1, 'product/39/48', 'car-electronics-gps/simple-product-03.html', 'catalog/product/view/id/39/category/48', 1, NULL, NULL, 48, 39),
(10160, 1, 'product/40/48', 'car-electronics-gps/simple-product-04.html', 'catalog/product/view/id/40/category/48', 1, NULL, NULL, 48, 40),
(10162, 1, 'product/41/48', 'car-electronics-gps/simple-product-05.html', 'catalog/product/view/id/41/category/48', 1, NULL, NULL, 48, 41),
(10164, 1, 'product/42/48', 'car-electronics-gps/grouped-product.html', 'catalog/product/view/id/42/category/48', 1, NULL, NULL, 48, 42),
(10168, 1, 'product/44/48', 'car-electronics-gps/bundle-product.html', 'catalog/product/view/id/44/category/48', 1, NULL, NULL, 48, 44),
(10170, 1, 'product/45/48', 'car-electronics-gps/bundle-product-02.html', 'catalog/product/view/id/45/category/48', 1, NULL, NULL, 48, 45),
(10172, 1, 'product/46/48', 'car-electronics-gps/downloadable-product.html', 'catalog/product/view/id/46/category/48', 1, NULL, NULL, 48, 46),
(10174, 1, 'product/47/48', 'car-electronics-gps/no-image.html', 'catalog/product/view/id/47/category/48', 1, NULL, NULL, 48, 47),
(10179, 2, 'product/29/48', 'car-electronics-gps/configurable-product-04-red.html', 'catalog/product/view/id/29/category/48', 1, NULL, NULL, 48, 29),
(10181, 2, 'product/30/48', 'car-electronics-gps/configurable-product-04-green.html', 'catalog/product/view/id/30/category/48', 1, NULL, NULL, 48, 30),
(10183, 2, 'product/31/48', 'car-electronics-gps/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/48', 1, NULL, NULL, 48, 31),
(10185, 2, 'product/32/48', 'car-electronics-gps/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/48', 1, NULL, NULL, 48, 32),
(10187, 2, 'product/33/48', 'car-electronics-gps/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/48', 1, NULL, NULL, 48, 33),
(10189, 2, 'product/34/48', 'car-electronics-gps/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/48', 1, NULL, NULL, 48, 34),
(10191, 2, 'product/35/48', 'car-electronics-gps/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/48', 1, NULL, NULL, 48, 35),
(10193, 2, 'product/36/48', 'car-electronics-gps/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/48', 1, NULL, NULL, 48, 36),
(10195, 2, 'product/37/48', 'car-electronics-gps/simple-product-01.html', 'catalog/product/view/id/37/category/48', 1, NULL, NULL, 48, 37),
(10197, 2, 'product/38/48', 'car-electronics-gps/simple-product-02.html', 'catalog/product/view/id/38/category/48', 1, NULL, NULL, 48, 38),
(10199, 2, 'product/39/48', 'car-electronics-gps/simple-product-03.html', 'catalog/product/view/id/39/category/48', 1, NULL, NULL, 48, 39),
(10201, 2, 'product/40/48', 'car-electronics-gps/simple-product-04.html', 'catalog/product/view/id/40/category/48', 1, NULL, NULL, 48, 40),
(10203, 2, 'product/41/48', 'car-electronics-gps/simple-product-05.html', 'catalog/product/view/id/41/category/48', 1, NULL, NULL, 48, 41),
(10205, 2, 'product/42/48', 'car-electronics-gps/grouped-product.html', 'catalog/product/view/id/42/category/48', 1, NULL, NULL, 48, 42),
(10209, 2, 'product/44/48', 'car-electronics-gps/bundle-product.html', 'catalog/product/view/id/44/category/48', 1, NULL, NULL, 48, 44),
(10211, 2, 'product/45/48', 'car-electronics-gps/bundle-product-02.html', 'catalog/product/view/id/45/category/48', 1, NULL, NULL, 48, 45),
(10213, 2, 'product/46/48', 'car-electronics-gps/downloadable-product.html', 'catalog/product/view/id/46/category/48', 1, NULL, NULL, 48, 46),
(10215, 2, 'product/47/48', 'car-electronics-gps/no-image.html', 'catalog/product/view/id/47/category/48', 1, NULL, NULL, 48, 47),
(10220, 1, 'product/29/49', 'laptop/configurable-product-04-red.html', 'catalog/product/view/id/29/category/49', 1, NULL, NULL, 49, 29),
(10222, 1, 'product/30/49', 'laptop/configurable-product-04-green.html', 'catalog/product/view/id/30/category/49', 1, NULL, NULL, 49, 30),
(10224, 1, 'product/31/49', 'laptop/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/49', 1, NULL, NULL, 49, 31),
(10226, 1, 'product/32/49', 'laptop/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/49', 1, NULL, NULL, 49, 32),
(10228, 1, 'product/33/49', 'laptop/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/49', 1, NULL, NULL, 49, 33),
(10230, 1, 'product/34/49', 'laptop/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/49', 1, NULL, NULL, 49, 34),
(10232, 1, 'product/35/49', 'laptop/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/49', 1, NULL, NULL, 49, 35),
(10234, 1, 'product/36/49', 'laptop/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/49', 1, NULL, NULL, 49, 36),
(10236, 1, 'product/37/49', 'laptop/simple-product-01.html', 'catalog/product/view/id/37/category/49', 1, NULL, NULL, 49, 37),
(10238, 1, 'product/38/49', 'laptop/simple-product-02.html', 'catalog/product/view/id/38/category/49', 1, NULL, NULL, 49, 38),
(10240, 1, 'product/39/49', 'laptop/simple-product-03.html', 'catalog/product/view/id/39/category/49', 1, NULL, NULL, 49, 39),
(10242, 1, 'product/40/49', 'laptop/simple-product-04.html', 'catalog/product/view/id/40/category/49', 1, NULL, NULL, 49, 40),
(10244, 1, 'product/41/49', 'laptop/simple-product-05.html', 'catalog/product/view/id/41/category/49', 1, NULL, NULL, 49, 41),
(10246, 1, 'product/42/49', 'laptop/grouped-product.html', 'catalog/product/view/id/42/category/49', 1, NULL, NULL, 49, 42),
(10250, 1, 'product/44/49', 'laptop/bundle-product.html', 'catalog/product/view/id/44/category/49', 1, NULL, NULL, 49, 44),
(10252, 1, 'product/45/49', 'laptop/bundle-product-02.html', 'catalog/product/view/id/45/category/49', 1, NULL, NULL, 49, 45),
(10254, 1, 'product/46/49', 'laptop/downloadable-product.html', 'catalog/product/view/id/46/category/49', 1, NULL, NULL, 49, 46),
(10256, 1, 'product/47/49', 'laptop/no-image.html', 'catalog/product/view/id/47/category/49', 1, NULL, NULL, 49, 47),
(10261, 2, 'product/29/49', 'laptop/configurable-product-04-red.html', 'catalog/product/view/id/29/category/49', 1, NULL, NULL, 49, 29),
(10263, 2, 'product/30/49', 'laptop/configurable-product-04-green.html', 'catalog/product/view/id/30/category/49', 1, NULL, NULL, 49, 30),
(10265, 2, 'product/31/49', 'laptop/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/49', 1, NULL, NULL, 49, 31),
(10267, 2, 'product/32/49', 'laptop/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/49', 1, NULL, NULL, 49, 32),
(10269, 2, 'product/33/49', 'laptop/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/49', 1, NULL, NULL, 49, 33),
(10271, 2, 'product/34/49', 'laptop/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/49', 1, NULL, NULL, 49, 34),
(10273, 2, 'product/35/49', 'laptop/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/49', 1, NULL, NULL, 49, 35),
(10275, 2, 'product/36/49', 'laptop/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/49', 1, NULL, NULL, 49, 36),
(10277, 2, 'product/37/49', 'laptop/simple-product-01.html', 'catalog/product/view/id/37/category/49', 1, NULL, NULL, 49, 37),
(10279, 2, 'product/38/49', 'laptop/simple-product-02.html', 'catalog/product/view/id/38/category/49', 1, NULL, NULL, 49, 38),
(10281, 2, 'product/39/49', 'laptop/simple-product-03.html', 'catalog/product/view/id/39/category/49', 1, NULL, NULL, 49, 39),
(10283, 2, 'product/40/49', 'laptop/simple-product-04.html', 'catalog/product/view/id/40/category/49', 1, NULL, NULL, 49, 40),
(10285, 2, 'product/41/49', 'laptop/simple-product-05.html', 'catalog/product/view/id/41/category/49', 1, NULL, NULL, 49, 41),
(10287, 2, 'product/42/49', 'laptop/grouped-product.html', 'catalog/product/view/id/42/category/49', 1, NULL, NULL, 49, 42),
(10291, 2, 'product/44/49', 'laptop/bundle-product.html', 'catalog/product/view/id/44/category/49', 1, NULL, NULL, 49, 44),
(10293, 2, 'product/45/49', 'laptop/bundle-product-02.html', 'catalog/product/view/id/45/category/49', 1, NULL, NULL, 49, 45),
(10295, 2, 'product/46/49', 'laptop/downloadable-product.html', 'catalog/product/view/id/46/category/49', 1, NULL, NULL, 49, 46),
(10297, 2, 'product/47/49', 'laptop/no-image.html', 'catalog/product/view/id/47/category/49', 1, NULL, NULL, 49, 47),
(10301, 1, '42385700_1426059865', 'accessories-5.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(10303, 1, 'product/29/50', 'accessories-27/configurable-product-04-red.html', 'catalog/product/view/id/29/category/50', 1, NULL, NULL, 50, 29),
(10305, 1, 'product/30/50', 'accessories-27/configurable-product-04-green.html', 'catalog/product/view/id/30/category/50', 1, NULL, NULL, 50, 30),
(10307, 1, 'product/31/50', 'accessories-27/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/50', 1, NULL, NULL, 50, 31),
(10309, 1, 'product/32/50', 'accessories-27/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/50', 1, NULL, NULL, 50, 32),
(10311, 1, 'product/33/50', 'accessories-27/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/50', 1, NULL, NULL, 50, 33),
(10313, 1, 'product/34/50', 'accessories-27/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/50', 1, NULL, NULL, 50, 34),
(10315, 1, 'product/35/50', 'accessories-27/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/50', 1, NULL, NULL, 50, 35),
(10317, 1, 'product/36/50', 'accessories-27/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/50', 1, NULL, NULL, 50, 36),
(10319, 1, 'product/37/50', 'accessories-27/simple-product-01.html', 'catalog/product/view/id/37/category/50', 1, NULL, NULL, 50, 37),
(10321, 1, 'product/38/50', 'accessories-27/simple-product-02.html', 'catalog/product/view/id/38/category/50', 1, NULL, NULL, 50, 38),
(10323, 1, 'product/39/50', 'accessories-27/simple-product-03.html', 'catalog/product/view/id/39/category/50', 1, NULL, NULL, 50, 39),
(10325, 1, 'product/40/50', 'accessories-27/simple-product-04.html', 'catalog/product/view/id/40/category/50', 1, NULL, NULL, 50, 40),
(10327, 1, 'product/41/50', 'accessories-27/simple-product-05.html', 'catalog/product/view/id/41/category/50', 1, NULL, NULL, 50, 41),
(10329, 1, 'product/42/50', 'accessories-27/grouped-product.html', 'catalog/product/view/id/42/category/50', 1, NULL, NULL, 50, 42),
(10333, 1, 'product/44/50', 'accessories-27/bundle-product.html', 'catalog/product/view/id/44/category/50', 1, NULL, NULL, 50, 44),
(10335, 1, 'product/45/50', 'accessories-27/bundle-product-02.html', 'catalog/product/view/id/45/category/50', 1, NULL, NULL, 50, 45),
(10337, 1, 'product/46/50', 'accessories-27/downloadable-product.html', 'catalog/product/view/id/46/category/50', 1, NULL, NULL, 50, 46),
(10339, 1, 'product/47/50', 'accessories-27/no-image.html', 'catalog/product/view/id/47/category/50', 1, NULL, NULL, 50, 47),
(10344, 2, '43491500_1426059866', 'accessories-5.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(10346, 2, 'product/29/50', 'accessories-27/configurable-product-04-red.html', 'catalog/product/view/id/29/category/50', 1, NULL, NULL, 50, 29),
(10348, 2, 'product/30/50', 'accessories-27/configurable-product-04-green.html', 'catalog/product/view/id/30/category/50', 1, NULL, NULL, 50, 30),
(10350, 2, 'product/31/50', 'accessories-27/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/50', 1, NULL, NULL, 50, 31),
(10352, 2, 'product/32/50', 'accessories-27/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/50', 1, NULL, NULL, 50, 32),
(10354, 2, 'product/33/50', 'accessories-27/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/50', 1, NULL, NULL, 50, 33),
(10356, 2, 'product/34/50', 'accessories-27/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/50', 1, NULL, NULL, 50, 34),
(10358, 2, 'product/35/50', 'accessories-27/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/50', 1, NULL, NULL, 50, 35),
(10360, 2, 'product/36/50', 'accessories-27/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/50', 1, NULL, NULL, 50, 36),
(10362, 2, 'product/37/50', 'accessories-27/simple-product-01.html', 'catalog/product/view/id/37/category/50', 1, NULL, NULL, 50, 37),
(10364, 2, 'product/38/50', 'accessories-27/simple-product-02.html', 'catalog/product/view/id/38/category/50', 1, NULL, NULL, 50, 38),
(10366, 2, 'product/39/50', 'accessories-27/simple-product-03.html', 'catalog/product/view/id/39/category/50', 1, NULL, NULL, 50, 39),
(10368, 2, 'product/40/50', 'accessories-27/simple-product-04.html', 'catalog/product/view/id/40/category/50', 1, NULL, NULL, 50, 40),
(10370, 2, 'product/41/50', 'accessories-27/simple-product-05.html', 'catalog/product/view/id/41/category/50', 1, NULL, NULL, 50, 41),
(10372, 2, 'product/42/50', 'accessories-27/grouped-product.html', 'catalog/product/view/id/42/category/50', 1, NULL, NULL, 50, 42),
(10376, 2, 'product/44/50', 'accessories-27/bundle-product.html', 'catalog/product/view/id/44/category/50', 1, NULL, NULL, 50, 44),
(10378, 2, 'product/45/50', 'accessories-27/bundle-product-02.html', 'catalog/product/view/id/45/category/50', 1, NULL, NULL, 50, 45),
(10380, 2, 'product/46/50', 'accessories-27/downloadable-product.html', 'catalog/product/view/id/46/category/50', 1, NULL, NULL, 50, 46),
(10382, 2, 'product/47/50', 'accessories-27/no-image.html', 'catalog/product/view/id/47/category/50', 1, NULL, NULL, 50, 47),
(10388, 1, 'product/29/55', 'casio-watches/configurable-product-04-red.html', 'catalog/product/view/id/29/category/55', 1, NULL, NULL, 55, 29),
(10390, 1, 'product/30/55', 'casio-watches/configurable-product-04-green.html', 'catalog/product/view/id/30/category/55', 1, NULL, NULL, 55, 30),
(10392, 1, 'product/31/55', 'casio-watches/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/55', 1, NULL, NULL, 55, 31),
(10394, 1, 'product/32/55', 'casio-watches/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/55', 1, NULL, NULL, 55, 32),
(10396, 1, 'product/33/55', 'casio-watches/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/55', 1, NULL, NULL, 55, 33),
(10398, 1, 'product/34/55', 'casio-watches/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/55', 1, NULL, NULL, 55, 34),
(10400, 1, 'product/35/55', 'casio-watches/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/55', 1, NULL, NULL, 55, 35),
(10402, 1, 'product/36/55', 'casio-watches/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/55', 1, NULL, NULL, 55, 36),
(10404, 1, 'product/37/55', 'casio-watches/simple-product-01.html', 'catalog/product/view/id/37/category/55', 1, NULL, NULL, 55, 37),
(10406, 1, 'product/38/55', 'casio-watches/simple-product-02.html', 'catalog/product/view/id/38/category/55', 1, NULL, NULL, 55, 38),
(10408, 1, 'product/39/55', 'casio-watches/simple-product-03.html', 'catalog/product/view/id/39/category/55', 1, NULL, NULL, 55, 39),
(10410, 1, 'product/40/55', 'casio-watches/simple-product-04.html', 'catalog/product/view/id/40/category/55', 1, NULL, NULL, 55, 40),
(10412, 1, 'product/41/55', 'casio-watches/simple-product-05.html', 'catalog/product/view/id/41/category/55', 1, NULL, NULL, 55, 41),
(10414, 1, 'product/42/55', 'casio-watches/grouped-product.html', 'catalog/product/view/id/42/category/55', 1, NULL, NULL, 55, 42),
(10418, 1, 'product/44/55', 'casio-watches/bundle-product.html', 'catalog/product/view/id/44/category/55', 1, NULL, NULL, 55, 44),
(10420, 1, 'product/45/55', 'casio-watches/bundle-product-02.html', 'catalog/product/view/id/45/category/55', 1, NULL, NULL, 55, 45),
(10422, 1, 'product/46/55', 'casio-watches/downloadable-product.html', 'catalog/product/view/id/46/category/55', 1, NULL, NULL, 55, 46),
(10424, 1, 'product/47/55', 'casio-watches/no-image.html', 'catalog/product/view/id/47/category/55', 1, NULL, NULL, 55, 47),
(10429, 2, 'product/29/55', 'casio-watches/configurable-product-04-red.html', 'catalog/product/view/id/29/category/55', 1, NULL, NULL, 55, 29),
(10431, 2, 'product/30/55', 'casio-watches/configurable-product-04-green.html', 'catalog/product/view/id/30/category/55', 1, NULL, NULL, 55, 30),
(10433, 2, 'product/31/55', 'casio-watches/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/55', 1, NULL, NULL, 55, 31),
(10435, 2, 'product/32/55', 'casio-watches/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/55', 1, NULL, NULL, 55, 32),
(10437, 2, 'product/33/55', 'casio-watches/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/55', 1, NULL, NULL, 55, 33),
(10439, 2, 'product/34/55', 'casio-watches/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/55', 1, NULL, NULL, 55, 34),
(10441, 2, 'product/35/55', 'casio-watches/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/55', 1, NULL, NULL, 55, 35),
(10443, 2, 'product/36/55', 'casio-watches/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/55', 1, NULL, NULL, 55, 36),
(10445, 2, 'product/37/55', 'casio-watches/simple-product-01.html', 'catalog/product/view/id/37/category/55', 1, NULL, NULL, 55, 37),
(10447, 2, 'product/38/55', 'casio-watches/simple-product-02.html', 'catalog/product/view/id/38/category/55', 1, NULL, NULL, 55, 38),
(10449, 2, 'product/39/55', 'casio-watches/simple-product-03.html', 'catalog/product/view/id/39/category/55', 1, NULL, NULL, 55, 39),
(10451, 2, 'product/40/55', 'casio-watches/simple-product-04.html', 'catalog/product/view/id/40/category/55', 1, NULL, NULL, 55, 40),
(10453, 2, 'product/41/55', 'casio-watches/simple-product-05.html', 'catalog/product/view/id/41/category/55', 1, NULL, NULL, 55, 41),
(10455, 2, 'product/42/55', 'casio-watches/grouped-product.html', 'catalog/product/view/id/42/category/55', 1, NULL, NULL, 55, 42),
(10459, 2, 'product/44/55', 'casio-watches/bundle-product.html', 'catalog/product/view/id/44/category/55', 1, NULL, NULL, 55, 44),
(10461, 2, 'product/45/55', 'casio-watches/bundle-product-02.html', 'catalog/product/view/id/45/category/55', 1, NULL, NULL, 55, 45),
(10463, 2, 'product/46/55', 'casio-watches/downloadable-product.html', 'catalog/product/view/id/46/category/55', 1, NULL, NULL, 55, 46),
(10465, 2, 'product/47/55', 'casio-watches/no-image.html', 'catalog/product/view/id/47/category/55', 1, NULL, NULL, 55, 47),
(10470, 1, 'product/29/56', 'asus-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/56', 1, NULL, NULL, 56, 29),
(10472, 1, 'product/30/56', 'asus-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/56', 1, NULL, NULL, 56, 30),
(10474, 1, 'product/31/56', 'asus-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/56', 1, NULL, NULL, 56, 31),
(10476, 1, 'product/32/56', 'asus-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/56', 1, NULL, NULL, 56, 32),
(10478, 1, 'product/33/56', 'asus-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/56', 1, NULL, NULL, 56, 33),
(10480, 1, 'product/34/56', 'asus-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/56', 1, NULL, NULL, 56, 34),
(10482, 1, 'product/35/56', 'asus-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/56', 1, NULL, NULL, 56, 35),
(10484, 1, 'product/36/56', 'asus-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/56', 1, NULL, NULL, 56, 36),
(10486, 1, 'product/37/56', 'asus-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/56', 1, NULL, NULL, 56, 37),
(10488, 1, 'product/38/56', 'asus-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/56', 1, NULL, NULL, 56, 38),
(10490, 1, 'product/39/56', 'asus-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/56', 1, NULL, NULL, 56, 39),
(10492, 1, 'product/40/56', 'asus-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/56', 1, NULL, NULL, 56, 40),
(10494, 1, 'product/41/56', 'asus-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/56', 1, NULL, NULL, 56, 41),
(10496, 1, 'product/42/56', 'asus-tablets/grouped-product.html', 'catalog/product/view/id/42/category/56', 1, NULL, NULL, 56, 42),
(10500, 1, 'product/44/56', 'asus-tablets/bundle-product.html', 'catalog/product/view/id/44/category/56', 1, NULL, NULL, 56, 44),
(10502, 1, 'product/45/56', 'asus-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/56', 1, NULL, NULL, 56, 45),
(10504, 1, 'product/46/56', 'asus-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/56', 1, NULL, NULL, 56, 46),
(10506, 1, 'product/47/56', 'asus-tablets/no-image.html', 'catalog/product/view/id/47/category/56', 1, NULL, NULL, 56, 47),
(10511, 2, 'product/29/56', 'asus-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/56', 1, NULL, NULL, 56, 29),
(10513, 2, 'product/30/56', 'asus-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/56', 1, NULL, NULL, 56, 30),
(10515, 2, 'product/31/56', 'asus-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/56', 1, NULL, NULL, 56, 31),
(10517, 2, 'product/32/56', 'asus-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/56', 1, NULL, NULL, 56, 32),
(10519, 2, 'product/33/56', 'asus-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/56', 1, NULL, NULL, 56, 33),
(10521, 2, 'product/34/56', 'asus-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/56', 1, NULL, NULL, 56, 34),
(10523, 2, 'product/35/56', 'asus-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/56', 1, NULL, NULL, 56, 35),
(10525, 2, 'product/36/56', 'asus-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/56', 1, NULL, NULL, 56, 36),
(10527, 2, 'product/37/56', 'asus-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/56', 1, NULL, NULL, 56, 37),
(10529, 2, 'product/38/56', 'asus-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/56', 1, NULL, NULL, 56, 38),
(10531, 2, 'product/39/56', 'asus-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/56', 1, NULL, NULL, 56, 39),
(10533, 2, 'product/40/56', 'asus-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/56', 1, NULL, NULL, 56, 40),
(10535, 2, 'product/41/56', 'asus-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/56', 1, NULL, NULL, 56, 41),
(10537, 2, 'product/42/56', 'asus-tablets/grouped-product.html', 'catalog/product/view/id/42/category/56', 1, NULL, NULL, 56, 42),
(10541, 2, 'product/44/56', 'asus-tablets/bundle-product.html', 'catalog/product/view/id/44/category/56', 1, NULL, NULL, 56, 44),
(10543, 2, 'product/45/56', 'asus-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/56', 1, NULL, NULL, 56, 45),
(10545, 2, 'product/46/56', 'asus-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/56', 1, NULL, NULL, 56, 46),
(10547, 2, 'product/47/56', 'asus-tablets/no-image.html', 'catalog/product/view/id/47/category/56', 1, NULL, NULL, 56, 47),
(10552, 1, 'product/29/57', 'women-fashion/configurable-product-04-red.html', 'catalog/product/view/id/29/category/57', 1, NULL, NULL, 57, 29),
(10554, 1, 'product/30/57', 'women-fashion/configurable-product-04-green.html', 'catalog/product/view/id/30/category/57', 1, NULL, NULL, 57, 30),
(10556, 1, 'product/31/57', 'women-fashion/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/57', 1, NULL, NULL, 57, 31),
(10558, 1, 'product/32/57', 'women-fashion/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/57', 1, NULL, NULL, 57, 32),
(10560, 1, 'product/33/57', 'women-fashion/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/57', 1, NULL, NULL, 57, 33),
(10562, 1, 'product/34/57', 'women-fashion/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/57', 1, NULL, NULL, 57, 34),
(10564, 1, 'product/35/57', 'women-fashion/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/57', 1, NULL, NULL, 57, 35),
(10566, 1, 'product/36/57', 'women-fashion/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/57', 1, NULL, NULL, 57, 36),
(10568, 1, 'product/37/57', 'women-fashion/simple-product-01.html', 'catalog/product/view/id/37/category/57', 1, NULL, NULL, 57, 37),
(10570, 1, 'product/38/57', 'women-fashion/simple-product-02.html', 'catalog/product/view/id/38/category/57', 1, NULL, NULL, 57, 38),
(10572, 1, 'product/39/57', 'women-fashion/simple-product-03.html', 'catalog/product/view/id/39/category/57', 1, NULL, NULL, 57, 39),
(10574, 1, 'product/40/57', 'women-fashion/simple-product-04.html', 'catalog/product/view/id/40/category/57', 1, NULL, NULL, 57, 40),
(10576, 1, 'product/41/57', 'women-fashion/simple-product-05.html', 'catalog/product/view/id/41/category/57', 1, NULL, NULL, 57, 41),
(10578, 1, 'product/42/57', 'women-fashion/grouped-product.html', 'catalog/product/view/id/42/category/57', 1, NULL, NULL, 57, 42),
(10582, 1, 'product/44/57', 'women-fashion/bundle-product.html', 'catalog/product/view/id/44/category/57', 1, NULL, NULL, 57, 44),
(10584, 1, 'product/45/57', 'women-fashion/bundle-product-02.html', 'catalog/product/view/id/45/category/57', 1, NULL, NULL, 57, 45),
(10586, 1, 'product/46/57', 'women-fashion/downloadable-product.html', 'catalog/product/view/id/46/category/57', 1, NULL, NULL, 57, 46),
(10588, 1, 'product/47/57', 'women-fashion/no-image.html', 'catalog/product/view/id/47/category/57', 1, NULL, NULL, 57, 47),
(10593, 2, 'product/29/57', 'women-fashion/configurable-product-04-red.html', 'catalog/product/view/id/29/category/57', 1, NULL, NULL, 57, 29),
(10595, 2, 'product/30/57', 'women-fashion/configurable-product-04-green.html', 'catalog/product/view/id/30/category/57', 1, NULL, NULL, 57, 30),
(10597, 2, 'product/31/57', 'women-fashion/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/57', 1, NULL, NULL, 57, 31),
(10599, 2, 'product/32/57', 'women-fashion/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/57', 1, NULL, NULL, 57, 32),
(10601, 2, 'product/33/57', 'women-fashion/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/57', 1, NULL, NULL, 57, 33),
(10603, 2, 'product/34/57', 'women-fashion/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/57', 1, NULL, NULL, 57, 34),
(10605, 2, 'product/35/57', 'women-fashion/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/57', 1, NULL, NULL, 57, 35),
(10607, 2, 'product/36/57', 'women-fashion/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/57', 1, NULL, NULL, 57, 36),
(10609, 2, 'product/37/57', 'women-fashion/simple-product-01.html', 'catalog/product/view/id/37/category/57', 1, NULL, NULL, 57, 37),
(10611, 2, 'product/38/57', 'women-fashion/simple-product-02.html', 'catalog/product/view/id/38/category/57', 1, NULL, NULL, 57, 38),
(10613, 2, 'product/39/57', 'women-fashion/simple-product-03.html', 'catalog/product/view/id/39/category/57', 1, NULL, NULL, 57, 39),
(10615, 2, 'product/40/57', 'women-fashion/simple-product-04.html', 'catalog/product/view/id/40/category/57', 1, NULL, NULL, 57, 40),
(10617, 2, 'product/41/57', 'women-fashion/simple-product-05.html', 'catalog/product/view/id/41/category/57', 1, NULL, NULL, 57, 41),
(10619, 2, 'product/42/57', 'women-fashion/grouped-product.html', 'catalog/product/view/id/42/category/57', 1, NULL, NULL, 57, 42),
(10623, 2, 'product/44/57', 'women-fashion/bundle-product.html', 'catalog/product/view/id/44/category/57', 1, NULL, NULL, 57, 44),
(10625, 2, 'product/45/57', 'women-fashion/bundle-product-02.html', 'catalog/product/view/id/45/category/57', 1, NULL, NULL, 57, 45),
(10627, 2, 'product/46/57', 'women-fashion/downloadable-product.html', 'catalog/product/view/id/46/category/57', 1, NULL, NULL, 57, 46),
(10629, 2, 'product/47/57', 'women-fashion/no-image.html', 'catalog/product/view/id/47/category/57', 1, NULL, NULL, 57, 47),
(10684, 1, 'product/48', 'custom-option.html', 'catalog/product/view/id/48', 1, NULL, NULL, NULL, 48),
(10685, 1, 'product/48/3', 'men/custom-option.html', 'catalog/product/view/id/48/category/3', 1, NULL, NULL, 3, 48),
(10686, 1, 'product/48/4', 'women/custom-option.html', 'catalog/product/view/id/48/category/4', 1, NULL, NULL, 4, 48),
(10687, 1, 'product/48/6', 'accessories/custom-option.html', 'catalog/product/view/id/48/category/6', 1, NULL, NULL, 6, 48),
(10688, 1, 'product/48/9', 'women/shapewear/custom-option.html', 'catalog/product/view/id/48/category/9', 1, NULL, NULL, 9, 48),
(10689, 1, 'product/48/19', 'tv-audio/bicycle/custom-option.html', 'catalog/product/view/id/48/category/19', 1, NULL, NULL, 19, 48),
(10690, 1, 'product/48/20', 'tv-audio/bicycle/jackets/custom-option.html', 'catalog/product/view/id/48/category/20', 1, NULL, NULL, 20, 48),
(10691, 1, 'product/48/24', 'tv-audio/bicycle/scarves/custom-option.html', 'catalog/product/view/id/48/category/24', 1, NULL, NULL, 24, 48),
(10692, 1, 'product/48/25', 'tv-audio/bicycle/lifestyle/custom-option.html', 'catalog/product/view/id/48/category/25', 1, NULL, NULL, 25, 48),
(10693, 1, 'product/48/26', 'accessories/bras/custom-option.html', 'catalog/product/view/id/48/category/26', 1, NULL, NULL, 26, 48),
(10694, 1, 'product/48/28', 'accessories/cosmetics/custom-option.html', 'catalog/product/view/id/48/category/28', 1, NULL, NULL, 28, 48),
(10695, 1, 'product/48/33', 'women/bags/custom-option.html', 'catalog/product/view/id/48/category/33', 1, NULL, NULL, 33, 48),
(10696, 1, 'product/48/40', 'accessories/cfg-products/custom-option.html', 'catalog/product/view/id/48/category/40', 1, NULL, NULL, 40, 48),
(10697, 1, 'product/48/41', 'accessories/product-types/custom-option.html', 'catalog/product/view/id/48/category/41', 1, NULL, NULL, 41, 48),
(10698, 1, 'product/48/42', 'cameras-photography/custom-option.html', 'catalog/product/view/id/48/category/42', 1, NULL, NULL, 42, 48),
(10699, 1, 'product/48/43', 'tv-audio/custom-option.html', 'catalog/product/view/id/48/category/43', 1, NULL, NULL, 43, 48),
(10700, 1, 'product/48/44', 'laptops-computers/custom-option.html', 'catalog/product/view/id/48/category/44', 1, NULL, NULL, 44, 48),
(10701, 1, 'product/48/45', 'smart-phones-tablets/custom-option.html', 'catalog/product/view/id/48/category/45', 1, NULL, NULL, 45, 48),
(10702, 1, 'product/48/46', 'video-games-consoles/custom-option.html', 'catalog/product/view/id/48/category/46', 1, NULL, NULL, 46, 48),
(10703, 1, 'product/48/47', 'gadgets/custom-option.html', 'catalog/product/view/id/48/category/47', 1, NULL, NULL, 47, 48),
(10704, 1, 'product/48/48', 'car-electronics-gps/custom-option.html', 'catalog/product/view/id/48/category/48', 1, NULL, NULL, 48, 48),
(10705, 1, 'product/48/49', 'laptop/custom-option.html', 'catalog/product/view/id/48/category/49', 1, NULL, NULL, 49, 48),
(10706, 1, 'product/48/50', 'accessories-27/custom-option.html', 'catalog/product/view/id/48/category/50', 1, NULL, NULL, 50, 48),
(10707, 1, 'product/48/55', 'casio-watches/custom-option.html', 'catalog/product/view/id/48/category/55', 1, NULL, NULL, 55, 48),
(10708, 1, 'product/48/56', 'asus-tablets/custom-option.html', 'catalog/product/view/id/48/category/56', 1, NULL, NULL, 56, 48),
(10709, 1, 'product/48/57', 'women-fashion/custom-option.html', 'catalog/product/view/id/48/category/57', 1, NULL, NULL, 57, 48),
(10710, 2, 'product/48', 'custom-option.html', 'catalog/product/view/id/48', 1, NULL, NULL, NULL, 48),
(10711, 2, 'product/48/3', 'men/custom-option.html', 'catalog/product/view/id/48/category/3', 1, NULL, NULL, 3, 48),
(10712, 2, 'product/48/4', 'women/custom-option.html', 'catalog/product/view/id/48/category/4', 1, NULL, NULL, 4, 48),
(10713, 2, 'product/48/6', 'accessories/custom-option.html', 'catalog/product/view/id/48/category/6', 1, NULL, NULL, 6, 48),
(10714, 2, 'product/48/9', 'women/shapewear/custom-option.html', 'catalog/product/view/id/48/category/9', 1, NULL, NULL, 9, 48),
(10715, 2, 'product/48/19', 'tv-audio/bicycle/custom-option.html', 'catalog/product/view/id/48/category/19', 1, NULL, NULL, 19, 48),
(10716, 2, 'product/48/20', 'tv-audio/bicycle/jackets/custom-option.html', 'catalog/product/view/id/48/category/20', 1, NULL, NULL, 20, 48),
(10717, 2, 'product/48/24', 'tv-audio/bicycle/scarves/custom-option.html', 'catalog/product/view/id/48/category/24', 1, NULL, NULL, 24, 48),
(10718, 2, 'product/48/25', 'tv-audio/bicycle/lifestyle/custom-option.html', 'catalog/product/view/id/48/category/25', 1, NULL, NULL, 25, 48),
(10719, 2, 'product/48/26', 'accessories/bras/custom-option.html', 'catalog/product/view/id/48/category/26', 1, NULL, NULL, 26, 48),
(10720, 2, 'product/48/28', 'accessories/cosmetics/custom-option.html', 'catalog/product/view/id/48/category/28', 1, NULL, NULL, 28, 48),
(10721, 2, 'product/48/33', 'women/bags/custom-option.html', 'catalog/product/view/id/48/category/33', 1, NULL, NULL, 33, 48),
(10722, 2, 'product/48/40', 'accessories/cfg-products/custom-option.html', 'catalog/product/view/id/48/category/40', 1, NULL, NULL, 40, 48),
(10723, 2, 'product/48/41', 'accessories/product-types/custom-option.html', 'catalog/product/view/id/48/category/41', 1, NULL, NULL, 41, 48),
(10724, 2, 'product/48/42', 'cameras-photography/custom-option.html', 'catalog/product/view/id/48/category/42', 1, NULL, NULL, 42, 48),
(10725, 2, 'product/48/43', 'tv-audio/custom-option.html', 'catalog/product/view/id/48/category/43', 1, NULL, NULL, 43, 48),
(10726, 2, 'product/48/44', 'laptops-computers/custom-option.html', 'catalog/product/view/id/48/category/44', 1, NULL, NULL, 44, 48),
(10727, 2, 'product/48/45', 'smart-phones-tablets/custom-option.html', 'catalog/product/view/id/48/category/45', 1, NULL, NULL, 45, 48),
(10728, 2, 'product/48/46', 'video-games-consoles/custom-option.html', 'catalog/product/view/id/48/category/46', 1, NULL, NULL, 46, 48),
(10729, 2, 'product/48/47', 'gadgets/custom-option.html', 'catalog/product/view/id/48/category/47', 1, NULL, NULL, 47, 48),
(10730, 2, 'product/48/48', 'car-electronics-gps/custom-option.html', 'catalog/product/view/id/48/category/48', 1, NULL, NULL, 48, 48),
(10731, 2, 'product/48/49', 'laptop/custom-option.html', 'catalog/product/view/id/48/category/49', 1, NULL, NULL, 49, 48),
(10732, 2, 'product/48/50', 'accessories-27/custom-option.html', 'catalog/product/view/id/48/category/50', 1, NULL, NULL, 50, 48),
(10733, 2, 'product/48/55', 'casio-watches/custom-option.html', 'catalog/product/view/id/48/category/55', 1, NULL, NULL, 55, 48),
(10734, 2, 'product/48/56', 'asus-tablets/custom-option.html', 'catalog/product/view/id/48/category/56', 1, NULL, NULL, 56, 48),
(10735, 2, 'product/48/57', 'women-fashion/custom-option.html', 'catalog/product/view/id/48/category/57', 1, NULL, NULL, 57, 48),
(10779, 1, '87905300_1428666314', 'accessories-6.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(10884, 1, '68086200_1428666316', 'accessories-6/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(10904, 1, '97340100_1428666316', 'accessories-6/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(10924, 1, '23367000_1428666317', 'accessories-6/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(10944, 1, '48011700_1428666317', 'accessories-6/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(10965, 1, '97197300_1428666317', 'accessories-6/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(10986, 1, '44546800_1428666318', 'accessories-6/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(11007, 1, '82993800_1428666318', 'accessories-6/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(11028, 1, '32415300_1428666319', 'accessories-6/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(11050, 1, '68388400_1428666319', 'accessories-6/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(11071, 1, '03667500_1428666320', 'accessories-6/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(11092, 1, '39659200_1428666320', 'accessories-6/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(11113, 1, '69652900_1428666320', 'accessories-6/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(11134, 1, '98969500_1428666320', 'accessories-6/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(11156, 1, '27733100_1428666321', 'accessories-6/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(11200, 1, '81741500_1428666321', 'accessories-6/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(11222, 1, '10304400_1428666322', 'accessories-6/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(11244, 1, '39362000_1428666322', 'accessories-6/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(11265, 1, '67708100_1428666322', 'accessories-6/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(11292, 1, '08361000_1428666323', 'accessories-6/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(11339, 2, '52907100_1428666324', 'accessories-6.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(11444, 2, '18700700_1428666326', 'accessories-6/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(11464, 2, '44282700_1428666326', 'accessories-6/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(11484, 2, '69344700_1428666326', 'accessories-6/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(11504, 2, '98141100_1428666326', 'accessories-6/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(11525, 2, '26257700_1428666327', 'accessories-6/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(11546, 2, '52160500_1428666327', 'accessories-6/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(11567, 2, '78556700_1428666327', 'accessories-6/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(11588, 2, '03858800_1428666328', 'accessories-6/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(11610, 2, '32543300_1428666328', 'accessories-6/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(11631, 2, '58483500_1428666328', 'accessories-6/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(11652, 2, '85316500_1428666328', 'accessories-6/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(11673, 2, '12995500_1428666329', 'accessories-6/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(11694, 2, '39319400_1428666329', 'accessories-6/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(11716, 2, '67468600_1428666329', 'accessories-6/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(11760, 2, '25908500_1428666330', 'accessories-6/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(11782, 2, '52506700_1428666330', 'accessories-6/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(11804, 2, '80617200_1428666330', 'accessories-6/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(11825, 2, '09181000_1428666331', 'accessories-6/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(11852, 2, '44798900_1428666331', 'accessories-6/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(11896, 1, '29442100_1430974325', 'accessories-7.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(12001, 1, '18152900_1430974327', 'accessories-7/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(12021, 1, '48954600_1430974327', 'accessories-7/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(12041, 1, '73456000_1430974327', 'accessories-7/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(12061, 1, '07358000_1430974328', 'accessories-7/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(12082, 1, '37659700_1430974328', 'accessories-7/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(12103, 1, '94062900_1430974328', 'accessories-7/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(12124, 1, '28764900_1430974329', 'accessories-7/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(12145, 1, '63566900_1430974329', 'accessories-7/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(12167, 1, '93768600_1430974329', 'accessories-7/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(12188, 1, '22170200_1430974330', 'accessories-7/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(12209, 1, '51771900_1430974330', 'accessories-7/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(12230, 1, '88074000_1430974330', 'accessories-7/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(12251, 1, '16575600_1430974331', 'accessories-7/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(12273, 1, '43577200_1430974331', 'accessories-7/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(12317, 1, '91980000_1430974331', 'accessories-7/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(12339, 1, '19081500_1430974332', 'accessories-7/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(12361, 1, '43782900_1430974332', 'accessories-7/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(12382, 1, '63284000_1430974332', 'accessories-7/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(12409, 1, '05886500_1430974333', 'accessories-7/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(12456, 2, '43294300_1430974334', 'accessories-7.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(12561, 2, '71307400_1430974336', 'accessories-7/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(12581, 2, '11909700_1430974337', 'accessories-7/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(12601, 2, '35911100_1430974337', 'accessories-7/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(12621, 2, '69613000_1430974337', 'accessories-7/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(12642, 2, '97614600_1430974337', 'accessories-7/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(12663, 2, '22516000_1430974338', 'accessories-7/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(12684, 2, '45717300_1430974338', 'accessories-7/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(12705, 2, '69018700_1430974338', 'accessories-7/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(12727, 2, '00420500_1430974339', 'accessories-7/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(12748, 2, '25321900_1430974339', 'accessories-7/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(12769, 2, '55623600_1430974339', 'accessories-7/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(12790, 2, '92025700_1430974339', 'accessories-7/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(12811, 2, '25627600_1430974340', 'accessories-7/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(12833, 2, '57829500_1430974340', 'accessories-7/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(12877, 2, '03032100_1430974341', 'accessories-7/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(12899, 2, '30333600_1430974341', 'accessories-7/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(12921, 2, '69635900_1430974341', 'accessories-7/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(12942, 2, '88437000_1430974341', 'accessories-7/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(12969, 2, '25539100_1430974342', 'accessories-7/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(13016, 1, '76548000_1430981284', 'accessories-8.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(13121, 1, '18861800_1430981287', 'accessories-8/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(13141, 1, '44063300_1430981287', 'accessories-8/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(13161, 1, '96666300_1430981287', 'accessories-8/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(13181, 1, '20367600_1430981288', 'accessories-8/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(13202, 1, '51369400_1430981288', 'accessories-8/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(13223, 1, '91871700_1430981288', 'accessories-8/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(13244, 1, '22973500_1430981289', 'accessories-8/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(13265, 1, '71476300_1430981289', 'accessories-8/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(13287, 1, '00577900_1430981290', 'accessories-8/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(13308, 1, '24279300_1430981290', 'accessories-8/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(13329, 1, '42780300_1430981290', 'accessories-8/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(13350, 1, '69681900_1430981290', 'accessories-8/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(13371, 1, '93483200_1430981290', 'accessories-8/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(13393, 1, '19184700_1430981291', 'accessories-8/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(13437, 1, '71387700_1430981291', 'accessories-8/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(13459, 1, '94489000_1430981291', 'accessories-8/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(13481, 1, '32491200_1430981292', 'accessories-8/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(13502, 1, '49492200_1430981292', 'accessories-8/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(13529, 1, '90594500_1430981292', 'accessories-8/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(13576, 2, '99100700_1430981293', 'accessories-8.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(13681, 2, '56509700_1430981295', 'accessories-8/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(13701, 2, '82211200_1430981295', 'accessories-8/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(13721, 2, '06512600_1430981296', 'accessories-8/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(13741, 2, '34514200_1430981296', 'accessories-8/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(13762, 2, '58315600_1430981296', 'accessories-8/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(13783, 2, '84517100_1430981296', 'accessories-8/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(13804, 2, '10918600_1430981297', 'accessories-8/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(13825, 2, '43520400_1430981297', 'accessories-8/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(13847, 2, '69521900_1430981297', 'accessories-8/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(13868, 2, '92623200_1430981297', 'accessories-8/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(13889, 2, '21624900_1430981298', 'accessories-8/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(13910, 2, '44226200_1430981298', 'accessories-8/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(13931, 2, '69327600_1430981298', 'accessories-8/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(13953, 2, '93729000_1430981298', 'accessories-8/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(13997, 2, '61532900_1430981299', 'accessories-8/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(14019, 2, '93934700_1430981299', 'accessories-8/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(14041, 2, '25436600_1430981300', 'accessories-8/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(14062, 2, '62138600_1430981300', 'accessories-8/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(14089, 2, '89840200_1430981300', 'accessories-8/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(14133, 1, '04253700_1431328992', 'accessories-9.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(14238, 1, '57668200_1431328994', 'accessories-9/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(14258, 1, '82769600_1431328994', 'accessories-9/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(14278, 1, '24372000_1431328995', 'accessories-9/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(14298, 1, '64274300_1431328995', 'accessories-9/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(14319, 1, '81675300_1431328995', 'accessories-9/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(14340, 1, '99676300_1431328995', 'accessories-9/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(14361, 1, '21377600_1431328996', 'accessories-9/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(14382, 1, '41878700_1431328996', 'accessories-9/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(14404, 1, '24283400_1431328997', 'accessories-9/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(14425, 1, '57985400_1431328997', 'accessories-9/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(14446, 1, '75086300_1431328997', 'accessories-9/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(14467, 1, '97187600_1431328997', 'accessories-9/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(14488, 1, '16088700_1431328998', 'accessories-9/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(14510, 1, '34489700_1431328998', 'accessories-9/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(14554, 1, '75692100_1431328998', 'accessories-9/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(14576, 1, '96593300_1431328998', 'accessories-9/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(14598, 1, '15894400_1431328999', 'accessories-9/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(14619, 1, '35095500_1431328999', 'accessories-9/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(14646, 1, '60096900_1431328999', 'accessories-9/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(14693, 2, '83904000_1431329000', 'accessories-9.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(14798, 2, '33312600_1431329002', 'accessories-9/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(14818, 2, '59614100_1431329002', 'accessories-9/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(14838, 2, '90915900_1431329002', 'accessories-9/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(14858, 2, '07916800_1431329003', 'accessories-9/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(14879, 2, '24817800_1431329003', 'accessories-9/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(14900, 2, '42118800_1431329003', 'accessories-9/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(14921, 2, '66720200_1431329003', 'accessories-9/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(14942, 2, '02422200_1431329004', 'accessories-9/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(14964, 2, '39124300_1431329004', 'accessories-9/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(14985, 2, '92527400_1431329004', 'accessories-9/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(15006, 2, '51230700_1431329005', 'accessories-9/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(15027, 2, '96733300_1431329005', 'accessories-9/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(15048, 2, '54136600_1431329006', 'accessories-9/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(15070, 2, '92038800_1431329006', 'accessories-9/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(15114, 2, '59142600_1431329007', 'accessories-9/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(15136, 2, '02545100_1431329008', 'accessories-9/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(15158, 2, '52148000_1431329008', 'accessories-9/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(15179, 2, '57554000_1431329009', 'accessories-9/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(15206, 2, '64360100_1431329010', 'accessories-9/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(15250, 1, '97441100_1431676118', 'accessories-10.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(15355, 1, '79251500_1431676120', 'accessories-10/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(15375, 1, '03352900_1431676121', 'accessories-10/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(15395, 1, '18253800_1431676121', 'accessories-10/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(15415, 1, '33754700_1431676121', 'accessories-10/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(15436, 1, '61756300_1431676121', 'accessories-10/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(15457, 1, '93658100_1431676121', 'accessories-10/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(15478, 1, '20459600_1431676122', 'accessories-10/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(15499, 1, '44761000_1431676122', 'accessories-10/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(15521, 1, '76262800_1431676122', 'accessories-10/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(15542, 1, '92463700_1431676122', 'accessories-10/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(15563, 1, '21265400_1431676123', 'accessories-10/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(15584, 1, '48566900_1431676123', 'accessories-10/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(15605, 1, '72968300_1431676123', 'accessories-10/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(15627, 1, '01870000_1431676124', 'accessories-10/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(15671, 1, '37672000_1431676124', 'accessories-10/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(15693, 1, '65073600_1431676124', 'accessories-10/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(15715, 1, '00275600_1431676125', 'accessories-10/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(15736, 1, '27977200_1431676125', 'accessories-10/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(15763, 1, '57978900_1431676125', 'accessories-10/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(15810, 2, '15587900_1431676127', 'accessories-10.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(15915, 2, '49895600_1431676128', 'accessories-10/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(15935, 2, '73997000_1431676128', 'accessories-10/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(15955, 2, '01298600_1431676129', 'accessories-10/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(15975, 2, '26400000_1431676129', 'accessories-10/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(15996, 2, '42900900_1431676129', 'accessories-10/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(16017, 2, '93903800_1431676129', 'accessories-10/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(16038, 2, '22605500_1431676130', 'accessories-10/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(16059, 2, '47806900_1431676130', 'accessories-10/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(16081, 2, '75908500_1431676130', 'accessories-10/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(16102, 2, '04810200_1431676131', 'accessories-10/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(16123, 2, '25511400_1431676131', 'accessories-10/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(16144, 2, '41412300_1431676131', 'accessories-10/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(16165, 2, '60013300_1431676131', 'accessories-10/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(16187, 2, '77114300_1431676131', 'accessories-10/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(16231, 2, '20016800_1431676132', 'accessories-10/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(16253, 2, '47218300_1431676132', 'accessories-10/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(16275, 2, '76220000_1431676132', 'accessories-10/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(16296, 2, '97521200_1431676132', 'accessories-10/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(16323, 2, '18922400_1431676133', 'accessories-10/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(16327, 3, 'category/3', 'men.html', 'catalog/category/view/id/3', 1, NULL, NULL, 3, NULL),
(16328, 3, 'category/4', 'women.html', 'catalog/category/view/id/4', 1, NULL, NULL, 4, NULL),
(16329, 3, 'category/33', 'women/bags.html', 'catalog/category/view/id/33', 1, NULL, NULL, 33, NULL),
(16330, 3, 'category/18', 'women/bags/bands.html', 'catalog/category/view/id/18', 1, NULL, NULL, 18, NULL),
(16331, 3, 'category/23', 'women/bags/blog.html', 'catalog/category/view/id/23', 1, NULL, NULL, 23, NULL),
(16332, 3, 'category/34', 'women/bags/nightwear.html', 'catalog/category/view/id/34', 1, NULL, NULL, 34, NULL),
(16333, 3, 'category/35', 'women/bags/briefs.html', 'catalog/category/view/id/35', 1, NULL, NULL, 35, NULL),
(16334, 3, 'category/36', 'women/bags/duffle.html', 'catalog/category/view/id/36', 1, NULL, NULL, 36, NULL),
(16335, 3, 'category/37', 'women/bags/dresses.html', 'catalog/category/view/id/37', 1, NULL, NULL, 37, NULL),
(16336, 3, 'category/38', 'women/bags/laptop.html', 'catalog/category/view/id/38', 1, NULL, NULL, 38, NULL),
(16337, 3, 'category/39', 'women/bags/cosmetic.html', 'catalog/category/view/id/39', 1, NULL, NULL, 39, NULL),
(16338, 3, 'category/8', 'women/bags/shoes.html', 'catalog/category/view/id/8', 1, NULL, NULL, 8, NULL),
(16339, 3, 'category/15', 'women/bags/shoes/gloves.html', 'catalog/category/view/id/15', 1, NULL, NULL, 15, NULL),
(16340, 3, 'category/16', 'women/bags/shoes/leathers.html', 'catalog/category/view/id/16', 1, NULL, NULL, 16, NULL),
(16341, 3, 'category/17', 'women/bags/shoes/cocktail.html', 'catalog/category/view/id/17', 1, NULL, NULL, 17, NULL),
(16342, 3, 'category/22', 'women/bags/shoes/clothing.html', 'catalog/category/view/id/22', 1, NULL, NULL, 22, NULL),
(16343, 3, 'category/31', 'women/bags/shoes/shirts.html', 'catalog/category/view/id/31', 1, NULL, NULL, 31, NULL),
(16344, 3, 'category/21', 'women/bags/shoes/shirts/hair.html', 'catalog/category/view/id/21', 1, NULL, NULL, 21, NULL),
(16345, 3, 'category/27', 'women/bags/shoes/shirts/helmet.html', 'catalog/category/view/id/27', 1, NULL, NULL, 27, NULL),
(16346, 3, 'category/29', 'women/bags/shoes/shirts/camis.html', 'catalog/category/view/id/29', 1, NULL, NULL, 29, NULL),
(16347, 3, 'category/30', 'women/bags/shoes/shirts/lingerie.html', 'catalog/category/view/id/30', 1, NULL, NULL, 30, NULL),
(16348, 3, 'category/32', 'women/bags/shoes/shirts/tops.html', 'catalog/category/view/id/32', 1, NULL, NULL, 32, NULL),
(16349, 3, 'category/7', 'women/bags/shoes/rings.html', 'catalog/category/view/id/7', 1, NULL, NULL, 7, NULL),
(16350, 3, 'category/9', 'women/shapewear.html', 'catalog/category/view/id/9', 1, NULL, NULL, 9, NULL),
(16351, 3, 'category/10', 'women/shapewear/sundresses.html', 'catalog/category/view/id/10', 1, NULL, NULL, 10, NULL),
(16352, 3, 'category/11', 'women/shapewear/footwear.html', 'catalog/category/view/id/11', 1, NULL, NULL, 11, NULL),
(16353, 3, 'category/12', 'women/shapewear/novelty.html', 'catalog/category/view/id/12', 1, NULL, NULL, 12, NULL),
(16354, 3, 'category/13', 'women/shapewear/outerwear.html', 'catalog/category/view/id/13', 1, NULL, NULL, 13, NULL),
(16355, 3, 'category/14', 'women/shapewear/hats.html', 'catalog/category/view/id/14', 1, NULL, NULL, 14, NULL),
(16356, 3, 'category/51', 'women/shapewear/salad-plates.html', 'catalog/category/view/id/51', 1, NULL, NULL, 51, NULL),
(16357, 3, 'category/52', 'women/shapewear/kitchen-storage.html', 'catalog/category/view/id/52', 1, NULL, NULL, 52, NULL),
(16358, 3, 'category/53', 'women/shapewear/dish-racks.html', 'catalog/category/view/id/53', 1, NULL, NULL, 53, NULL),
(16359, 3, 'category/54', 'women/shapewear/colanders.html', 'catalog/category/view/id/54', 1, NULL, NULL, 54, NULL),
(16360, 3, 'category/42', 'cameras-photography.html', 'catalog/category/view/id/42', 1, NULL, NULL, 42, NULL),
(16361, 3, 'category/43', 'tv-audio.html', 'catalog/category/view/id/43', 1, NULL, NULL, 43, NULL),
(16362, 3, 'category/44', 'laptops-computers.html', 'catalog/category/view/id/44', 1, NULL, NULL, 44, NULL),
(16363, 3, 'category/45', 'smart-phones-tablets.html', 'catalog/category/view/id/45', 1, NULL, NULL, 45, NULL),
(16364, 3, 'category/46', 'video-games-consoles.html', 'catalog/category/view/id/46', 1, NULL, NULL, 46, NULL),
(16365, 3, 'category/47', 'gadgets.html', 'catalog/category/view/id/47', 1, NULL, NULL, 47, NULL),
(16366, 3, 'category/48', 'car-electronics-gps.html', 'catalog/category/view/id/48', 1, NULL, NULL, 48, NULL),
(16367, 3, 'category/49', 'laptop.html', 'catalog/category/view/id/49', 1, NULL, NULL, 49, NULL),
(16368, 3, 'category/5', 'kid.html', 'catalog/category/view/id/5', 1, NULL, NULL, 5, NULL),
(16369, 3, 'category/50', 'accessories.html', 'catalog/category/view/id/50', 1, NULL, NULL, 50, NULL),
(16370, 3, 'category/55', 'casio-watches.html', 'catalog/category/view/id/55', 1, NULL, NULL, 55, NULL),
(16371, 3, 'category/56', 'asus-tablets.html', 'catalog/category/view/id/56', 1, NULL, NULL, 56, NULL),
(16372, 3, 'category/57', 'women-fashion.html', 'catalog/category/view/id/57', 1, NULL, NULL, 57, NULL),
(16373, 3, 'category/6', 'accessories-17.html', 'catalog/category/view/id/6', 1, NULL, NULL, 6, NULL),
(16374, 3, 'category/19', 'tv-audio/bicycle.html', 'catalog/category/view/id/19', 1, NULL, NULL, 19, NULL),
(16375, 3, 'category/20', 'tv-audio/bicycle/jackets.html', 'catalog/category/view/id/20', 1, NULL, NULL, 20, NULL),
(16376, 3, 'category/24', 'tv-audio/bicycle/scarves.html', 'catalog/category/view/id/24', 1, NULL, NULL, 24, NULL),
(16377, 3, 'category/25', 'tv-audio/bicycle/lifestyle.html', 'catalog/category/view/id/25', 1, NULL, NULL, 25, NULL),
(16378, 3, 'category/26', 'accessories-17/bras.html', 'catalog/category/view/id/26', 1, NULL, NULL, 26, NULL),
(16379, 3, 'category/28', 'accessories-17/cosmetics.html', 'catalog/category/view/id/28', 1, NULL, NULL, 28, NULL),
(16380, 3, 'category/40', 'accessories-17/cfg-products.html', 'catalog/category/view/id/40', 1, NULL, NULL, 40, NULL),
(16381, 3, 'category/41', 'accessories-17/product-types.html', 'catalog/category/view/id/41', 1, NULL, NULL, 41, NULL),
(16382, 3, 'product/7', 'configurable-product.html', 'catalog/product/view/id/7', 1, NULL, NULL, NULL, 7),
(16383, 3, 'product/7/3', 'men/configurable-product.html', 'catalog/product/view/id/7/category/3', 1, NULL, NULL, 3, 7),
(16384, 3, 'product/7/4', 'women/configurable-product.html', 'catalog/product/view/id/7/category/4', 1, NULL, NULL, 4, 7),
(16385, 3, 'product/7/40', 'accessories-17/cfg-products/configurable-product.html', 'catalog/product/view/id/7/category/40', 1, NULL, NULL, 40, 7),
(16386, 3, 'product/7/41', 'accessories-17/product-types/configurable-product.html', 'catalog/product/view/id/7/category/41', 1, NULL, NULL, 41, 7),
(16387, 3, 'product/8', 'configurable-product-armani-black.html', 'catalog/product/view/id/8', 1, NULL, NULL, NULL, 8),
(16388, 3, 'product/8/3', 'men/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/3', 1, NULL, NULL, 3, 8),
(16389, 3, 'product/8/4', 'women/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/4', 1, NULL, NULL, 4, 8),
(16390, 3, 'product/9', 'configurable-product-armani-blue.html', 'catalog/product/view/id/9', 1, NULL, NULL, NULL, 9),
(16391, 3, 'product/9/3', 'men/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/3', 1, NULL, NULL, 3, 9),
(16392, 3, 'product/9/4', 'women/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/4', 1, NULL, NULL, 4, 9),
(16393, 3, 'product/10', 'configurable-product-armani-green.html', 'catalog/product/view/id/10', 1, NULL, NULL, NULL, 10),
(16394, 3, 'product/10/3', 'men/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/3', 1, NULL, NULL, 3, 10),
(16395, 3, 'product/10/4', 'women/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/4', 1, NULL, NULL, 4, 10),
(16396, 3, 'product/11', 'configurable-product-buberry-red.html', 'catalog/product/view/id/11', 1, NULL, NULL, NULL, 11),
(16397, 3, 'product/11/3', 'men/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/3', 1, NULL, NULL, 3, 11),
(16398, 3, 'product/11/4', 'women/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/4', 1, NULL, NULL, 4, 11),
(16399, 3, 'product/12', 'configurable-product-buberry-green.html', 'catalog/product/view/id/12', 1, NULL, NULL, NULL, 12),
(16400, 3, 'product/12/3', 'men/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/3', 1, NULL, NULL, 3, 12),
(16401, 3, 'product/12/4', 'women/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/4', 1, NULL, NULL, 4, 12),
(16402, 3, 'product/13', 'configurable-product-02.html', 'catalog/product/view/id/13', 1, NULL, NULL, NULL, 13),
(16403, 3, 'product/13/3', 'men/configurable-product-02.html', 'catalog/product/view/id/13/category/3', 1, NULL, NULL, 3, 13),
(16404, 3, 'product/13/4', 'women/configurable-product-02.html', 'catalog/product/view/id/13/category/4', 1, NULL, NULL, 4, 13),
(16405, 3, 'product/13/40', 'accessories-17/cfg-products/configurable-product-02.html', 'catalog/product/view/id/13/category/40', 1, NULL, NULL, 40, 13),
(16406, 3, 'product/13/41', 'accessories-17/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/41', 1, NULL, NULL, 41, 13),
(16407, 3, 'product/14', 'configurable-product-02-chanel-black.html', 'catalog/product/view/id/14', 1, NULL, NULL, NULL, 14),
(16408, 3, 'product/14/3', 'men/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/3', 1, NULL, NULL, 3, 14),
(16409, 3, 'product/14/4', 'women/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/4', 1, NULL, NULL, 4, 14),
(16410, 3, 'product/15', 'configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15', 1, NULL, NULL, NULL, 15),
(16411, 3, 'product/15/3', 'men/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/3', 1, NULL, NULL, 3, 15),
(16412, 3, 'product/15/4', 'women/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/4', 1, NULL, NULL, 4, 15),
(16413, 3, 'product/16', 'configurable-product-02-dior-green.html', 'catalog/product/view/id/16', 1, NULL, NULL, NULL, 16),
(16414, 3, 'product/16/3', 'men/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/3', 1, NULL, NULL, 3, 16),
(16415, 3, 'product/16/4', 'women/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/4', 1, NULL, NULL, 4, 16),
(16416, 3, 'product/17', 'configurable-product-02-gucci-red.html', 'catalog/product/view/id/17', 1, NULL, NULL, NULL, 17),
(16417, 3, 'product/17/3', 'men/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/3', 1, NULL, NULL, 3, 17),
(16418, 3, 'product/17/4', 'women/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/4', 1, NULL, NULL, 4, 17),
(16419, 3, 'product/18', 'configurable-product-02-gucci-white.html', 'catalog/product/view/id/18', 1, NULL, NULL, NULL, 18),
(16420, 3, 'product/18/3', 'men/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/3', 1, NULL, NULL, 3, 18),
(16421, 3, 'product/18/4', 'women/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/4', 1, NULL, NULL, 4, 18),
(16422, 3, 'product/19', 'configurable-product-03.html', 'catalog/product/view/id/19', 1, NULL, NULL, NULL, 19),
(16423, 3, 'product/19/3', 'men/configurable-product-03.html', 'catalog/product/view/id/19/category/3', 1, NULL, NULL, 3, 19),
(16424, 3, 'product/19/4', 'women/configurable-product-03.html', 'catalog/product/view/id/19/category/4', 1, NULL, NULL, 4, 19),
(16425, 3, 'product/19/40', 'accessories-17/cfg-products/configurable-product-03.html', 'catalog/product/view/id/19/category/40', 1, NULL, NULL, 40, 19),
(16426, 3, 'product/19/41', 'accessories-17/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/41', 1, NULL, NULL, 41, 19),
(16427, 3, 'product/20', 'configurable-product-04.html', 'catalog/product/view/id/20', 1, NULL, NULL, NULL, 20),
(16428, 3, 'product/20/3', 'men/configurable-product-04.html', 'catalog/product/view/id/20/category/3', 1, NULL, NULL, 3, 20),
(16429, 3, 'product/20/4', 'women/configurable-product-04.html', 'catalog/product/view/id/20/category/4', 1, NULL, NULL, 4, 20),
(16430, 3, 'product/20/40', 'accessories-17/cfg-products/configurable-product-04.html', 'catalog/product/view/id/20/category/40', 1, NULL, NULL, 40, 20),
(16431, 3, 'product/20/41', 'accessories-17/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/41', 1, NULL, NULL, 41, 20),
(16432, 3, 'product/21', 'configurable-product-05.html', 'catalog/product/view/id/21', 1, NULL, NULL, NULL, 21),
(16433, 3, 'product/21/3', 'men/configurable-product-05.html', 'catalog/product/view/id/21/category/3', 1, NULL, NULL, 3, 21),
(16434, 3, 'product/21/4', 'women/configurable-product-05.html', 'catalog/product/view/id/21/category/4', 1, NULL, NULL, 4, 21),
(16435, 3, 'product/21/40', 'accessories-17/cfg-products/configurable-product-05.html', 'catalog/product/view/id/21/category/40', 1, NULL, NULL, 40, 21),
(16436, 3, 'product/21/41', 'accessories-17/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/41', 1, NULL, NULL, 41, 21),
(16437, 3, 'product/22', 'configurable-product-03-hermes-white.html', 'catalog/product/view/id/22', 1, NULL, NULL, NULL, 22),
(16438, 3, 'product/22/3', 'men/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/3', 1, NULL, NULL, 3, 22),
(16439, 3, 'product/22/4', 'women/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/4', 1, NULL, NULL, 4, 22),
(16440, 3, 'product/23', 'configurable-product-03-prada-black.html', 'catalog/product/view/id/23', 1, NULL, NULL, NULL, 23),
(16441, 3, 'product/23/3', 'men/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/3', 1, NULL, NULL, 3, 23),
(16442, 3, 'product/23/4', 'women/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/4', 1, NULL, NULL, 4, 23),
(16443, 3, 'product/24', 'configurable-product-03-versace-blue.html', 'catalog/product/view/id/24', 1, NULL, NULL, NULL, 24),
(16444, 3, 'product/24/3', 'men/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/3', 1, NULL, NULL, 3, 24),
(16445, 3, 'product/24/4', 'women/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/4', 1, NULL, NULL, 4, 24),
(16446, 3, 'product/25', 'configurable-product-03-prada-green.html', 'catalog/product/view/id/25', 1, NULL, NULL, NULL, 25),
(16447, 3, 'product/25/3', 'men/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/3', 1, NULL, NULL, 3, 25),
(16448, 3, 'product/25/4', 'women/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/4', 1, NULL, NULL, 4, 25),
(16449, 3, 'product/26', 'configurable-product-03-prada-red.html', 'catalog/product/view/id/26', 1, NULL, NULL, NULL, 26),
(16450, 3, 'product/26/3', 'men/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/3', 1, NULL, NULL, 3, 26),
(16451, 3, 'product/26/4', 'women/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/4', 1, NULL, NULL, 4, 26),
(16452, 3, 'product/27', 'configurable-product-04-black.html', 'catalog/product/view/id/27', 1, NULL, NULL, NULL, 27),
(16453, 3, 'product/27/3', 'men/configurable-product-04-black.html', 'catalog/product/view/id/27/category/3', 1, NULL, NULL, 3, 27),
(16454, 3, 'product/27/4', 'women/configurable-product-04-black.html', 'catalog/product/view/id/27/category/4', 1, NULL, NULL, 4, 27),
(16455, 3, 'product/28', 'configurable-product-04-white.html', 'catalog/product/view/id/28', 1, NULL, NULL, NULL, 28),
(16456, 3, 'product/28/3', 'men/configurable-product-04-white.html', 'catalog/product/view/id/28/category/3', 1, NULL, NULL, 3, 28),
(16457, 3, 'product/28/4', 'women/configurable-product-04-white.html', 'catalog/product/view/id/28/category/4', 1, NULL, NULL, 4, 28),
(16458, 3, 'product/29', 'configurable-product-04-red.html', 'catalog/product/view/id/29', 1, NULL, NULL, NULL, 29),
(16459, 3, 'product/29/3', 'men/configurable-product-04-red.html', 'catalog/product/view/id/29/category/3', 1, NULL, NULL, 3, 29),
(16460, 3, 'product/29/4', 'women/configurable-product-04-red.html', 'catalog/product/view/id/29/category/4', 1, NULL, NULL, 4, 29),
(16461, 3, 'product/29/5', 'kid/configurable-product-04-red.html', 'catalog/product/view/id/29/category/5', 1, NULL, NULL, 5, 29),
(16462, 3, 'product/29/6', 'accessories-17/configurable-product-04-red.html', 'catalog/product/view/id/29/category/6', 1, NULL, NULL, 6, 29),
(16463, 3, 'product/29/19', 'tv-audio/bicycle/configurable-product-04-red.html', 'catalog/product/view/id/29/category/19', 1, NULL, NULL, 19, 29),
(16464, 3, 'product/29/33', 'women/bags/configurable-product-04-red.html', 'catalog/product/view/id/29/category/33', 1, NULL, NULL, 33, 29),
(16465, 3, 'product/29/42', 'cameras-photography/configurable-product-04-red.html', 'catalog/product/view/id/29/category/42', 1, NULL, NULL, 42, 29),
(16466, 3, 'product/29/43', 'tv-audio/configurable-product-04-red.html', 'catalog/product/view/id/29/category/43', 1, NULL, NULL, 43, 29),
(16467, 3, 'product/29/44', 'laptops-computers/configurable-product-04-red.html', 'catalog/product/view/id/29/category/44', 1, NULL, NULL, 44, 29),
(16468, 3, 'product/29/45', 'smart-phones-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/45', 1, NULL, NULL, 45, 29),
(16469, 3, 'product/29/46', 'video-games-consoles/configurable-product-04-red.html', 'catalog/product/view/id/29/category/46', 1, NULL, NULL, 46, 29),
(16470, 3, 'product/29/47', 'gadgets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/47', 1, NULL, NULL, 47, 29),
(16471, 3, 'product/29/48', 'car-electronics-gps/configurable-product-04-red.html', 'catalog/product/view/id/29/category/48', 1, NULL, NULL, 48, 29),
(16472, 3, 'product/29/49', 'laptop/configurable-product-04-red.html', 'catalog/product/view/id/29/category/49', 1, NULL, NULL, 49, 29),
(16473, 3, 'product/29/50', 'accessories/configurable-product-04-red.html', 'catalog/product/view/id/29/category/50', 1, NULL, NULL, 50, 29),
(16474, 3, 'product/29/55', 'casio-watches/configurable-product-04-red.html', 'catalog/product/view/id/29/category/55', 1, NULL, NULL, 55, 29),
(16475, 3, 'product/29/56', 'asus-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/56', 1, NULL, NULL, 56, 29),
(16476, 3, 'product/29/57', 'women-fashion/configurable-product-04-red.html', 'catalog/product/view/id/29/category/57', 1, NULL, NULL, 57, 29),
(16477, 3, 'product/30', 'configurable-product-04-green.html', 'catalog/product/view/id/30', 1, NULL, NULL, NULL, 30),
(16478, 3, 'product/30/3', 'men/configurable-product-04-green.html', 'catalog/product/view/id/30/category/3', 1, NULL, NULL, 3, 30),
(16479, 3, 'product/30/4', 'women/configurable-product-04-green.html', 'catalog/product/view/id/30/category/4', 1, NULL, NULL, 4, 30),
(16480, 3, 'product/30/5', 'kid/configurable-product-04-green.html', 'catalog/product/view/id/30/category/5', 1, NULL, NULL, 5, 30),
(16481, 3, 'product/30/6', 'accessories-17/configurable-product-04-green.html', 'catalog/product/view/id/30/category/6', 1, NULL, NULL, 6, 30),
(16482, 3, 'product/30/19', 'tv-audio/bicycle/configurable-product-04-green.html', 'catalog/product/view/id/30/category/19', 1, NULL, NULL, 19, 30),
(16483, 3, 'product/30/33', 'women/bags/configurable-product-04-green.html', 'catalog/product/view/id/30/category/33', 1, NULL, NULL, 33, 30),
(16484, 3, 'product/30/42', 'cameras-photography/configurable-product-04-green.html', 'catalog/product/view/id/30/category/42', 1, NULL, NULL, 42, 30),
(16485, 3, 'product/30/43', 'tv-audio/configurable-product-04-green.html', 'catalog/product/view/id/30/category/43', 1, NULL, NULL, 43, 30),
(16486, 3, 'product/30/44', 'laptops-computers/configurable-product-04-green.html', 'catalog/product/view/id/30/category/44', 1, NULL, NULL, 44, 30),
(16487, 3, 'product/30/45', 'smart-phones-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/45', 1, NULL, NULL, 45, 30),
(16488, 3, 'product/30/46', 'video-games-consoles/configurable-product-04-green.html', 'catalog/product/view/id/30/category/46', 1, NULL, NULL, 46, 30),
(16489, 3, 'product/30/47', 'gadgets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/47', 1, NULL, NULL, 47, 30),
(16490, 3, 'product/30/48', 'car-electronics-gps/configurable-product-04-green.html', 'catalog/product/view/id/30/category/48', 1, NULL, NULL, 48, 30),
(16491, 3, 'product/30/49', 'laptop/configurable-product-04-green.html', 'catalog/product/view/id/30/category/49', 1, NULL, NULL, 49, 30),
(16492, 3, 'product/30/50', 'accessories/configurable-product-04-green.html', 'catalog/product/view/id/30/category/50', 1, NULL, NULL, 50, 30),
(16493, 3, 'product/30/55', 'casio-watches/configurable-product-04-green.html', 'catalog/product/view/id/30/category/55', 1, NULL, NULL, 55, 30),
(16494, 3, 'product/30/56', 'asus-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/56', 1, NULL, NULL, 56, 30),
(16495, 3, 'product/30/57', 'women-fashion/configurable-product-04-green.html', 'catalog/product/view/id/30/category/57', 1, NULL, NULL, 57, 30),
(16496, 3, 'product/31', 'configurable-product-04-blue.html', 'catalog/product/view/id/31', 1, NULL, NULL, NULL, 31),
(16497, 3, 'product/31/3', 'men/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/3', 1, NULL, NULL, 3, 31),
(16498, 3, 'product/31/4', 'women/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/4', 1, NULL, NULL, 4, 31),
(16499, 3, 'product/31/5', 'kid/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/5', 1, NULL, NULL, 5, 31),
(16500, 3, 'product/31/6', 'accessories-17/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/6', 1, NULL, NULL, 6, 31),
(16501, 3, 'product/31/19', 'tv-audio/bicycle/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/19', 1, NULL, NULL, 19, 31),
(16502, 3, 'product/31/33', 'women/bags/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/33', 1, NULL, NULL, 33, 31),
(16503, 3, 'product/31/42', 'cameras-photography/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/42', 1, NULL, NULL, 42, 31),
(16504, 3, 'product/31/43', 'tv-audio/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/43', 1, NULL, NULL, 43, 31);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(16505, 3, 'product/31/44', 'laptops-computers/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/44', 1, NULL, NULL, 44, 31),
(16506, 3, 'product/31/45', 'smart-phones-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/45', 1, NULL, NULL, 45, 31),
(16507, 3, 'product/31/46', 'video-games-consoles/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/46', 1, NULL, NULL, 46, 31),
(16508, 3, 'product/31/47', 'gadgets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/47', 1, NULL, NULL, 47, 31),
(16509, 3, 'product/31/48', 'car-electronics-gps/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/48', 1, NULL, NULL, 48, 31),
(16510, 3, 'product/31/49', 'laptop/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/49', 1, NULL, NULL, 49, 31),
(16511, 3, 'product/31/50', 'accessories/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/50', 1, NULL, NULL, 50, 31),
(16512, 3, 'product/31/55', 'casio-watches/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/55', 1, NULL, NULL, 55, 31),
(16513, 3, 'product/31/56', 'asus-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/56', 1, NULL, NULL, 56, 31),
(16514, 3, 'product/31/57', 'women-fashion/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/57', 1, NULL, NULL, 57, 31),
(16515, 3, 'product/32', 'configurable-product-05-armani.html', 'catalog/product/view/id/32', 1, NULL, NULL, NULL, 32),
(16516, 3, 'product/32/3', 'men/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/3', 1, NULL, NULL, 3, 32),
(16517, 3, 'product/32/4', 'women/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/4', 1, NULL, NULL, 4, 32),
(16518, 3, 'product/32/5', 'kid/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/5', 1, NULL, NULL, 5, 32),
(16519, 3, 'product/32/6', 'accessories-17/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/6', 1, NULL, NULL, 6, 32),
(16520, 3, 'product/32/19', 'tv-audio/bicycle/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/19', 1, NULL, NULL, 19, 32),
(16521, 3, 'product/32/33', 'women/bags/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/33', 1, NULL, NULL, 33, 32),
(16522, 3, 'product/32/42', 'cameras-photography/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/42', 1, NULL, NULL, 42, 32),
(16523, 3, 'product/32/43', 'tv-audio/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/43', 1, NULL, NULL, 43, 32),
(16524, 3, 'product/32/44', 'laptops-computers/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/44', 1, NULL, NULL, 44, 32),
(16525, 3, 'product/32/45', 'smart-phones-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/45', 1, NULL, NULL, 45, 32),
(16526, 3, 'product/32/46', 'video-games-consoles/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/46', 1, NULL, NULL, 46, 32),
(16527, 3, 'product/32/47', 'gadgets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/47', 1, NULL, NULL, 47, 32),
(16528, 3, 'product/32/48', 'car-electronics-gps/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/48', 1, NULL, NULL, 48, 32),
(16529, 3, 'product/32/49', 'laptop/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/49', 1, NULL, NULL, 49, 32),
(16530, 3, 'product/32/50', 'accessories/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/50', 1, NULL, NULL, 50, 32),
(16531, 3, 'product/32/55', 'casio-watches/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/55', 1, NULL, NULL, 55, 32),
(16532, 3, 'product/32/56', 'asus-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/56', 1, NULL, NULL, 56, 32),
(16533, 3, 'product/32/57', 'women-fashion/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/57', 1, NULL, NULL, 57, 32),
(16534, 3, 'product/33', 'configurable-product-05-buberry.html', 'catalog/product/view/id/33', 1, NULL, NULL, NULL, 33),
(16535, 3, 'product/33/3', 'men/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/3', 1, NULL, NULL, 3, 33),
(16536, 3, 'product/33/4', 'women/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/4', 1, NULL, NULL, 4, 33),
(16537, 3, 'product/33/5', 'kid/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/5', 1, NULL, NULL, 5, 33),
(16538, 3, 'product/33/6', 'accessories-17/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/6', 1, NULL, NULL, 6, 33),
(16539, 3, 'product/33/9', 'women/shapewear/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/9', 1, NULL, NULL, 9, 33),
(16540, 3, 'product/33/19', 'tv-audio/bicycle/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/19', 1, NULL, NULL, 19, 33),
(16541, 3, 'product/33/33', 'women/bags/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/33', 1, NULL, NULL, 33, 33),
(16542, 3, 'product/33/42', 'cameras-photography/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/42', 1, NULL, NULL, 42, 33),
(16543, 3, 'product/33/43', 'tv-audio/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/43', 1, NULL, NULL, 43, 33),
(16544, 3, 'product/33/44', 'laptops-computers/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/44', 1, NULL, NULL, 44, 33),
(16545, 3, 'product/33/45', 'smart-phones-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/45', 1, NULL, NULL, 45, 33),
(16546, 3, 'product/33/46', 'video-games-consoles/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/46', 1, NULL, NULL, 46, 33),
(16547, 3, 'product/33/47', 'gadgets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/47', 1, NULL, NULL, 47, 33),
(16548, 3, 'product/33/48', 'car-electronics-gps/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/48', 1, NULL, NULL, 48, 33),
(16549, 3, 'product/33/49', 'laptop/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/49', 1, NULL, NULL, 49, 33),
(16550, 3, 'product/33/50', 'accessories/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/50', 1, NULL, NULL, 50, 33),
(16551, 3, 'product/33/55', 'casio-watches/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/55', 1, NULL, NULL, 55, 33),
(16552, 3, 'product/33/56', 'asus-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/56', 1, NULL, NULL, 56, 33),
(16553, 3, 'product/33/57', 'women-fashion/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/57', 1, NULL, NULL, 57, 33),
(16554, 3, 'product/34', 'configurable-product-05-chanel.html', 'catalog/product/view/id/34', 1, NULL, NULL, NULL, 34),
(16555, 3, 'product/34/3', 'men/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/3', 1, NULL, NULL, 3, 34),
(16556, 3, 'product/34/4', 'women/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/4', 1, NULL, NULL, 4, 34),
(16557, 3, 'product/34/5', 'kid/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/5', 1, NULL, NULL, 5, 34),
(16558, 3, 'product/34/6', 'accessories-17/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/6', 1, NULL, NULL, 6, 34),
(16559, 3, 'product/34/9', 'women/shapewear/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/9', 1, NULL, NULL, 9, 34),
(16560, 3, 'product/34/19', 'tv-audio/bicycle/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/19', 1, NULL, NULL, 19, 34),
(16561, 3, 'product/34/33', 'women/bags/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/33', 1, NULL, NULL, 33, 34),
(16562, 3, 'product/34/42', 'cameras-photography/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/42', 1, NULL, NULL, 42, 34),
(16563, 3, 'product/34/43', 'tv-audio/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/43', 1, NULL, NULL, 43, 34),
(16564, 3, 'product/34/44', 'laptops-computers/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/44', 1, NULL, NULL, 44, 34),
(16565, 3, 'product/34/45', 'smart-phones-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/45', 1, NULL, NULL, 45, 34),
(16566, 3, 'product/34/46', 'video-games-consoles/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/46', 1, NULL, NULL, 46, 34),
(16567, 3, 'product/34/47', 'gadgets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/47', 1, NULL, NULL, 47, 34),
(16568, 3, 'product/34/48', 'car-electronics-gps/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/48', 1, NULL, NULL, 48, 34),
(16569, 3, 'product/34/49', 'laptop/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/49', 1, NULL, NULL, 49, 34),
(16570, 3, 'product/34/50', 'accessories/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/50', 1, NULL, NULL, 50, 34),
(16571, 3, 'product/34/55', 'casio-watches/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/55', 1, NULL, NULL, 55, 34),
(16572, 3, 'product/34/56', 'asus-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/56', 1, NULL, NULL, 56, 34),
(16573, 3, 'product/34/57', 'women-fashion/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/57', 1, NULL, NULL, 57, 34),
(16574, 3, 'product/35', 'configurable-product-05-hermes.html', 'catalog/product/view/id/35', 1, NULL, NULL, NULL, 35),
(16575, 3, 'product/35/3', 'men/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/3', 1, NULL, NULL, 3, 35),
(16576, 3, 'product/35/4', 'women/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/4', 1, NULL, NULL, 4, 35),
(16577, 3, 'product/35/5', 'kid/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/5', 1, NULL, NULL, 5, 35),
(16578, 3, 'product/35/6', 'accessories-17/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/6', 1, NULL, NULL, 6, 35),
(16579, 3, 'product/35/9', 'women/shapewear/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/9', 1, NULL, NULL, 9, 35),
(16580, 3, 'product/35/19', 'tv-audio/bicycle/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/19', 1, NULL, NULL, 19, 35),
(16581, 3, 'product/35/33', 'women/bags/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/33', 1, NULL, NULL, 33, 35),
(16582, 3, 'product/35/42', 'cameras-photography/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/42', 1, NULL, NULL, 42, 35),
(16583, 3, 'product/35/43', 'tv-audio/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/43', 1, NULL, NULL, 43, 35),
(16584, 3, 'product/35/44', 'laptops-computers/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/44', 1, NULL, NULL, 44, 35),
(16585, 3, 'product/35/45', 'smart-phones-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/45', 1, NULL, NULL, 45, 35),
(16586, 3, 'product/35/46', 'video-games-consoles/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/46', 1, NULL, NULL, 46, 35),
(16587, 3, 'product/35/47', 'gadgets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/47', 1, NULL, NULL, 47, 35),
(16588, 3, 'product/35/48', 'car-electronics-gps/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/48', 1, NULL, NULL, 48, 35),
(16589, 3, 'product/35/49', 'laptop/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/49', 1, NULL, NULL, 49, 35),
(16590, 3, 'product/35/50', 'accessories/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/50', 1, NULL, NULL, 50, 35),
(16591, 3, 'product/35/55', 'casio-watches/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/55', 1, NULL, NULL, 55, 35),
(16592, 3, 'product/35/56', 'asus-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/56', 1, NULL, NULL, 56, 35),
(16593, 3, 'product/35/57', 'women-fashion/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/57', 1, NULL, NULL, 57, 35),
(16594, 3, 'product/36', 'configurable-product-05-versace.html', 'catalog/product/view/id/36', 1, NULL, NULL, NULL, 36),
(16595, 3, 'product/36/3', 'men/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/3', 1, NULL, NULL, 3, 36),
(16596, 3, 'product/36/4', 'women/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/4', 1, NULL, NULL, 4, 36),
(16597, 3, 'product/36/5', 'kid/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/5', 1, NULL, NULL, 5, 36),
(16598, 3, 'product/36/6', 'accessories-17/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/6', 1, NULL, NULL, 6, 36),
(16599, 3, 'product/36/9', 'women/shapewear/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/9', 1, NULL, NULL, 9, 36),
(16600, 3, 'product/36/19', 'tv-audio/bicycle/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/19', 1, NULL, NULL, 19, 36),
(16601, 3, 'product/36/33', 'women/bags/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/33', 1, NULL, NULL, 33, 36),
(16602, 3, 'product/36/42', 'cameras-photography/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/42', 1, NULL, NULL, 42, 36),
(16603, 3, 'product/36/43', 'tv-audio/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/43', 1, NULL, NULL, 43, 36),
(16604, 3, 'product/36/44', 'laptops-computers/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/44', 1, NULL, NULL, 44, 36),
(16605, 3, 'product/36/45', 'smart-phones-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/45', 1, NULL, NULL, 45, 36),
(16606, 3, 'product/36/46', 'video-games-consoles/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/46', 1, NULL, NULL, 46, 36),
(16607, 3, 'product/36/47', 'gadgets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/47', 1, NULL, NULL, 47, 36),
(16608, 3, 'product/36/48', 'car-electronics-gps/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/48', 1, NULL, NULL, 48, 36),
(16609, 3, 'product/36/49', 'laptop/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/49', 1, NULL, NULL, 49, 36),
(16610, 3, 'product/36/50', 'accessories/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/50', 1, NULL, NULL, 50, 36),
(16611, 3, 'product/36/55', 'casio-watches/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/55', 1, NULL, NULL, 55, 36),
(16612, 3, 'product/36/56', 'asus-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/56', 1, NULL, NULL, 56, 36),
(16613, 3, 'product/36/57', 'women-fashion/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/57', 1, NULL, NULL, 57, 36),
(16614, 3, 'product/37', 'simple-product-01.html', 'catalog/product/view/id/37', 1, NULL, NULL, NULL, 37),
(16615, 3, 'product/37/3', 'men/simple-product-01.html', 'catalog/product/view/id/37/category/3', 1, NULL, NULL, 3, 37),
(16616, 3, 'product/37/4', 'women/simple-product-01.html', 'catalog/product/view/id/37/category/4', 1, NULL, NULL, 4, 37),
(16617, 3, 'product/37/5', 'kid/simple-product-01.html', 'catalog/product/view/id/37/category/5', 1, NULL, NULL, 5, 37),
(16618, 3, 'product/37/6', 'accessories-17/simple-product-01.html', 'catalog/product/view/id/37/category/6', 1, NULL, NULL, 6, 37),
(16619, 3, 'product/37/9', 'women/shapewear/simple-product-01.html', 'catalog/product/view/id/37/category/9', 1, NULL, NULL, 9, 37),
(16620, 3, 'product/37/19', 'tv-audio/bicycle/simple-product-01.html', 'catalog/product/view/id/37/category/19', 1, NULL, NULL, 19, 37),
(16621, 3, 'product/37/33', 'women/bags/simple-product-01.html', 'catalog/product/view/id/37/category/33', 1, NULL, NULL, 33, 37),
(16622, 3, 'product/37/41', 'accessories-17/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/41', 1, NULL, NULL, 41, 37),
(16623, 3, 'product/37/42', 'cameras-photography/simple-product-01.html', 'catalog/product/view/id/37/category/42', 1, NULL, NULL, 42, 37),
(16624, 3, 'product/37/43', 'tv-audio/simple-product-01.html', 'catalog/product/view/id/37/category/43', 1, NULL, NULL, 43, 37),
(16625, 3, 'product/37/44', 'laptops-computers/simple-product-01.html', 'catalog/product/view/id/37/category/44', 1, NULL, NULL, 44, 37),
(16626, 3, 'product/37/45', 'smart-phones-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/45', 1, NULL, NULL, 45, 37),
(16627, 3, 'product/37/46', 'video-games-consoles/simple-product-01.html', 'catalog/product/view/id/37/category/46', 1, NULL, NULL, 46, 37),
(16628, 3, 'product/37/47', 'gadgets/simple-product-01.html', 'catalog/product/view/id/37/category/47', 1, NULL, NULL, 47, 37),
(16629, 3, 'product/37/48', 'car-electronics-gps/simple-product-01.html', 'catalog/product/view/id/37/category/48', 1, NULL, NULL, 48, 37),
(16630, 3, 'product/37/49', 'laptop/simple-product-01.html', 'catalog/product/view/id/37/category/49', 1, NULL, NULL, 49, 37),
(16631, 3, 'product/37/50', 'accessories/simple-product-01.html', 'catalog/product/view/id/37/category/50', 1, NULL, NULL, 50, 37),
(16632, 3, 'product/37/55', 'casio-watches/simple-product-01.html', 'catalog/product/view/id/37/category/55', 1, NULL, NULL, 55, 37),
(16633, 3, 'product/37/56', 'asus-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/56', 1, NULL, NULL, 56, 37),
(16634, 3, 'product/37/57', 'women-fashion/simple-product-01.html', 'catalog/product/view/id/37/category/57', 1, NULL, NULL, 57, 37),
(16635, 3, 'product/38', 'simple-product-02.html', 'catalog/product/view/id/38', 1, NULL, NULL, NULL, 38),
(16636, 3, 'product/38/3', 'men/simple-product-02.html', 'catalog/product/view/id/38/category/3', 1, NULL, NULL, 3, 38),
(16637, 3, 'product/38/4', 'women/simple-product-02.html', 'catalog/product/view/id/38/category/4', 1, NULL, NULL, 4, 38),
(16638, 3, 'product/38/5', 'kid/simple-product-02.html', 'catalog/product/view/id/38/category/5', 1, NULL, NULL, 5, 38),
(16639, 3, 'product/38/6', 'accessories-17/simple-product-02.html', 'catalog/product/view/id/38/category/6', 1, NULL, NULL, 6, 38),
(16640, 3, 'product/38/9', 'women/shapewear/simple-product-02.html', 'catalog/product/view/id/38/category/9', 1, NULL, NULL, 9, 38),
(16641, 3, 'product/38/19', 'tv-audio/bicycle/simple-product-02.html', 'catalog/product/view/id/38/category/19', 1, NULL, NULL, 19, 38),
(16642, 3, 'product/38/33', 'women/bags/simple-product-02.html', 'catalog/product/view/id/38/category/33', 1, NULL, NULL, 33, 38),
(16643, 3, 'product/38/42', 'cameras-photography/simple-product-02.html', 'catalog/product/view/id/38/category/42', 1, NULL, NULL, 42, 38),
(16644, 3, 'product/38/43', 'tv-audio/simple-product-02.html', 'catalog/product/view/id/38/category/43', 1, NULL, NULL, 43, 38),
(16645, 3, 'product/38/44', 'laptops-computers/simple-product-02.html', 'catalog/product/view/id/38/category/44', 1, NULL, NULL, 44, 38),
(16646, 3, 'product/38/45', 'smart-phones-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/45', 1, NULL, NULL, 45, 38),
(16647, 3, 'product/38/46', 'video-games-consoles/simple-product-02.html', 'catalog/product/view/id/38/category/46', 1, NULL, NULL, 46, 38),
(16648, 3, 'product/38/47', 'gadgets/simple-product-02.html', 'catalog/product/view/id/38/category/47', 1, NULL, NULL, 47, 38),
(16649, 3, 'product/38/48', 'car-electronics-gps/simple-product-02.html', 'catalog/product/view/id/38/category/48', 1, NULL, NULL, 48, 38),
(16650, 3, 'product/38/49', 'laptop/simple-product-02.html', 'catalog/product/view/id/38/category/49', 1, NULL, NULL, 49, 38),
(16651, 3, 'product/38/50', 'accessories/simple-product-02.html', 'catalog/product/view/id/38/category/50', 1, NULL, NULL, 50, 38),
(16652, 3, 'product/38/55', 'casio-watches/simple-product-02.html', 'catalog/product/view/id/38/category/55', 1, NULL, NULL, 55, 38),
(16653, 3, 'product/38/56', 'asus-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/56', 1, NULL, NULL, 56, 38),
(16654, 3, 'product/38/57', 'women-fashion/simple-product-02.html', 'catalog/product/view/id/38/category/57', 1, NULL, NULL, 57, 38),
(16655, 3, 'product/39', 'simple-product-03.html', 'catalog/product/view/id/39', 1, NULL, NULL, NULL, 39),
(16656, 3, 'product/39/3', 'men/simple-product-03.html', 'catalog/product/view/id/39/category/3', 1, NULL, NULL, 3, 39),
(16657, 3, 'product/39/4', 'women/simple-product-03.html', 'catalog/product/view/id/39/category/4', 1, NULL, NULL, 4, 39),
(16658, 3, 'product/39/5', 'kid/simple-product-03.html', 'catalog/product/view/id/39/category/5', 1, NULL, NULL, 5, 39),
(16659, 3, 'product/39/6', 'accessories-17/simple-product-03.html', 'catalog/product/view/id/39/category/6', 1, NULL, NULL, 6, 39),
(16660, 3, 'product/39/9', 'women/shapewear/simple-product-03.html', 'catalog/product/view/id/39/category/9', 1, NULL, NULL, 9, 39),
(16661, 3, 'product/39/19', 'tv-audio/bicycle/simple-product-03.html', 'catalog/product/view/id/39/category/19', 1, NULL, NULL, 19, 39),
(16662, 3, 'product/39/33', 'women/bags/simple-product-03.html', 'catalog/product/view/id/39/category/33', 1, NULL, NULL, 33, 39),
(16663, 3, 'product/39/42', 'cameras-photography/simple-product-03.html', 'catalog/product/view/id/39/category/42', 1, NULL, NULL, 42, 39),
(16664, 3, 'product/39/43', 'tv-audio/simple-product-03.html', 'catalog/product/view/id/39/category/43', 1, NULL, NULL, 43, 39),
(16665, 3, 'product/39/44', 'laptops-computers/simple-product-03.html', 'catalog/product/view/id/39/category/44', 1, NULL, NULL, 44, 39),
(16666, 3, 'product/39/45', 'smart-phones-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/45', 1, NULL, NULL, 45, 39),
(16667, 3, 'product/39/46', 'video-games-consoles/simple-product-03.html', 'catalog/product/view/id/39/category/46', 1, NULL, NULL, 46, 39),
(16668, 3, 'product/39/47', 'gadgets/simple-product-03.html', 'catalog/product/view/id/39/category/47', 1, NULL, NULL, 47, 39),
(16669, 3, 'product/39/48', 'car-electronics-gps/simple-product-03.html', 'catalog/product/view/id/39/category/48', 1, NULL, NULL, 48, 39),
(16670, 3, 'product/39/49', 'laptop/simple-product-03.html', 'catalog/product/view/id/39/category/49', 1, NULL, NULL, 49, 39),
(16671, 3, 'product/39/50', 'accessories/simple-product-03.html', 'catalog/product/view/id/39/category/50', 1, NULL, NULL, 50, 39),
(16672, 3, 'product/39/55', 'casio-watches/simple-product-03.html', 'catalog/product/view/id/39/category/55', 1, NULL, NULL, 55, 39),
(16673, 3, 'product/39/56', 'asus-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/56', 1, NULL, NULL, 56, 39),
(16674, 3, 'product/39/57', 'women-fashion/simple-product-03.html', 'catalog/product/view/id/39/category/57', 1, NULL, NULL, 57, 39),
(16675, 3, 'product/40', 'simple-product-04.html', 'catalog/product/view/id/40', 1, NULL, NULL, NULL, 40),
(16676, 3, 'product/40/3', 'men/simple-product-04.html', 'catalog/product/view/id/40/category/3', 1, NULL, NULL, 3, 40),
(16677, 3, 'product/40/4', 'women/simple-product-04.html', 'catalog/product/view/id/40/category/4', 1, NULL, NULL, 4, 40),
(16678, 3, 'product/40/5', 'kid/simple-product-04.html', 'catalog/product/view/id/40/category/5', 1, NULL, NULL, 5, 40),
(16679, 3, 'product/40/6', 'accessories-17/simple-product-04.html', 'catalog/product/view/id/40/category/6', 1, NULL, NULL, 6, 40),
(16680, 3, 'product/40/9', 'women/shapewear/simple-product-04.html', 'catalog/product/view/id/40/category/9', 1, NULL, NULL, 9, 40),
(16681, 3, 'product/40/19', 'tv-audio/bicycle/simple-product-04.html', 'catalog/product/view/id/40/category/19', 1, NULL, NULL, 19, 40),
(16682, 3, 'product/40/33', 'women/bags/simple-product-04.html', 'catalog/product/view/id/40/category/33', 1, NULL, NULL, 33, 40),
(16683, 3, 'product/40/42', 'cameras-photography/simple-product-04.html', 'catalog/product/view/id/40/category/42', 1, NULL, NULL, 42, 40),
(16684, 3, 'product/40/43', 'tv-audio/simple-product-04.html', 'catalog/product/view/id/40/category/43', 1, NULL, NULL, 43, 40),
(16685, 3, 'product/40/44', 'laptops-computers/simple-product-04.html', 'catalog/product/view/id/40/category/44', 1, NULL, NULL, 44, 40),
(16686, 3, 'product/40/45', 'smart-phones-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/45', 1, NULL, NULL, 45, 40),
(16687, 3, 'product/40/46', 'video-games-consoles/simple-product-04.html', 'catalog/product/view/id/40/category/46', 1, NULL, NULL, 46, 40),
(16688, 3, 'product/40/47', 'gadgets/simple-product-04.html', 'catalog/product/view/id/40/category/47', 1, NULL, NULL, 47, 40),
(16689, 3, 'product/40/48', 'car-electronics-gps/simple-product-04.html', 'catalog/product/view/id/40/category/48', 1, NULL, NULL, 48, 40),
(16690, 3, 'product/40/49', 'laptop/simple-product-04.html', 'catalog/product/view/id/40/category/49', 1, NULL, NULL, 49, 40),
(16691, 3, 'product/40/50', 'accessories/simple-product-04.html', 'catalog/product/view/id/40/category/50', 1, NULL, NULL, 50, 40),
(16692, 3, 'product/40/55', 'casio-watches/simple-product-04.html', 'catalog/product/view/id/40/category/55', 1, NULL, NULL, 55, 40),
(16693, 3, 'product/40/56', 'asus-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/56', 1, NULL, NULL, 56, 40),
(16694, 3, 'product/40/57', 'women-fashion/simple-product-04.html', 'catalog/product/view/id/40/category/57', 1, NULL, NULL, 57, 40),
(16695, 3, 'product/41', 'simple-product-05.html', 'catalog/product/view/id/41', 1, NULL, NULL, NULL, 41),
(16696, 3, 'product/41/3', 'men/simple-product-05.html', 'catalog/product/view/id/41/category/3', 1, NULL, NULL, 3, 41),
(16697, 3, 'product/41/4', 'women/simple-product-05.html', 'catalog/product/view/id/41/category/4', 1, NULL, NULL, 4, 41),
(16698, 3, 'product/41/5', 'kid/simple-product-05.html', 'catalog/product/view/id/41/category/5', 1, NULL, NULL, 5, 41),
(16699, 3, 'product/41/6', 'accessories-17/simple-product-05.html', 'catalog/product/view/id/41/category/6', 1, NULL, NULL, 6, 41),
(16700, 3, 'product/41/9', 'women/shapewear/simple-product-05.html', 'catalog/product/view/id/41/category/9', 1, NULL, NULL, 9, 41),
(16701, 3, 'product/41/19', 'tv-audio/bicycle/simple-product-05.html', 'catalog/product/view/id/41/category/19', 1, NULL, NULL, 19, 41),
(16702, 3, 'product/41/33', 'women/bags/simple-product-05.html', 'catalog/product/view/id/41/category/33', 1, NULL, NULL, 33, 41),
(16703, 3, 'product/41/42', 'cameras-photography/simple-product-05.html', 'catalog/product/view/id/41/category/42', 1, NULL, NULL, 42, 41),
(16704, 3, 'product/41/43', 'tv-audio/simple-product-05.html', 'catalog/product/view/id/41/category/43', 1, NULL, NULL, 43, 41),
(16705, 3, 'product/41/44', 'laptops-computers/simple-product-05.html', 'catalog/product/view/id/41/category/44', 1, NULL, NULL, 44, 41),
(16706, 3, 'product/41/45', 'smart-phones-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/45', 1, NULL, NULL, 45, 41),
(16707, 3, 'product/41/46', 'video-games-consoles/simple-product-05.html', 'catalog/product/view/id/41/category/46', 1, NULL, NULL, 46, 41),
(16708, 3, 'product/41/47', 'gadgets/simple-product-05.html', 'catalog/product/view/id/41/category/47', 1, NULL, NULL, 47, 41),
(16709, 3, 'product/41/48', 'car-electronics-gps/simple-product-05.html', 'catalog/product/view/id/41/category/48', 1, NULL, NULL, 48, 41),
(16710, 3, 'product/41/49', 'laptop/simple-product-05.html', 'catalog/product/view/id/41/category/49', 1, NULL, NULL, 49, 41),
(16711, 3, 'product/41/50', 'accessories/simple-product-05.html', 'catalog/product/view/id/41/category/50', 1, NULL, NULL, 50, 41),
(16712, 3, 'product/41/55', 'casio-watches/simple-product-05.html', 'catalog/product/view/id/41/category/55', 1, NULL, NULL, 55, 41),
(16713, 3, 'product/41/56', 'asus-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/56', 1, NULL, NULL, 56, 41),
(16714, 3, 'product/41/57', 'women-fashion/simple-product-05.html', 'catalog/product/view/id/41/category/57', 1, NULL, NULL, 57, 41),
(16715, 3, 'product/42', 'grouped-product.html', 'catalog/product/view/id/42', 1, NULL, NULL, NULL, 42),
(16716, 3, 'product/42/3', 'men/grouped-product.html', 'catalog/product/view/id/42/category/3', 1, NULL, NULL, 3, 42),
(16717, 3, 'product/42/4', 'women/grouped-product.html', 'catalog/product/view/id/42/category/4', 1, NULL, NULL, 4, 42),
(16718, 3, 'product/42/5', 'kid/grouped-product.html', 'catalog/product/view/id/42/category/5', 1, NULL, NULL, 5, 42),
(16719, 3, 'product/42/6', 'accessories-17/grouped-product.html', 'catalog/product/view/id/42/category/6', 1, NULL, NULL, 6, 42),
(16720, 3, 'product/42/9', 'women/shapewear/grouped-product.html', 'catalog/product/view/id/42/category/9', 1, NULL, NULL, 9, 42),
(16721, 3, 'product/42/19', 'tv-audio/bicycle/grouped-product.html', 'catalog/product/view/id/42/category/19', 1, NULL, NULL, 19, 42),
(16722, 3, 'product/42/33', 'women/bags/grouped-product.html', 'catalog/product/view/id/42/category/33', 1, NULL, NULL, 33, 42),
(16723, 3, 'product/42/41', 'accessories-17/product-types/grouped-product.html', 'catalog/product/view/id/42/category/41', 1, NULL, NULL, 41, 42),
(16724, 3, 'product/42/42', 'cameras-photography/grouped-product.html', 'catalog/product/view/id/42/category/42', 1, NULL, NULL, 42, 42),
(16725, 3, 'product/42/43', 'tv-audio/grouped-product.html', 'catalog/product/view/id/42/category/43', 1, NULL, NULL, 43, 42),
(16726, 3, 'product/42/44', 'laptops-computers/grouped-product.html', 'catalog/product/view/id/42/category/44', 1, NULL, NULL, 44, 42),
(16727, 3, 'product/42/45', 'smart-phones-tablets/grouped-product.html', 'catalog/product/view/id/42/category/45', 1, NULL, NULL, 45, 42),
(16728, 3, 'product/42/46', 'video-games-consoles/grouped-product.html', 'catalog/product/view/id/42/category/46', 1, NULL, NULL, 46, 42),
(16729, 3, 'product/42/47', 'gadgets/grouped-product.html', 'catalog/product/view/id/42/category/47', 1, NULL, NULL, 47, 42),
(16730, 3, 'product/42/48', 'car-electronics-gps/grouped-product.html', 'catalog/product/view/id/42/category/48', 1, NULL, NULL, 48, 42),
(16731, 3, 'product/42/49', 'laptop/grouped-product.html', 'catalog/product/view/id/42/category/49', 1, NULL, NULL, 49, 42),
(16732, 3, 'product/42/50', 'accessories/grouped-product.html', 'catalog/product/view/id/42/category/50', 1, NULL, NULL, 50, 42),
(16733, 3, 'product/42/55', 'casio-watches/grouped-product.html', 'catalog/product/view/id/42/category/55', 1, NULL, NULL, 55, 42),
(16734, 3, 'product/42/56', 'asus-tablets/grouped-product.html', 'catalog/product/view/id/42/category/56', 1, NULL, NULL, 56, 42),
(16735, 3, 'product/42/57', 'women-fashion/grouped-product.html', 'catalog/product/view/id/42/category/57', 1, NULL, NULL, 57, 42),
(16757, 3, 'product/44', 'bundle-product.html', 'catalog/product/view/id/44', 1, NULL, NULL, NULL, 44),
(16758, 3, 'product/44/3', 'men/bundle-product.html', 'catalog/product/view/id/44/category/3', 1, NULL, NULL, 3, 44),
(16759, 3, 'product/44/4', 'women/bundle-product.html', 'catalog/product/view/id/44/category/4', 1, NULL, NULL, 4, 44),
(16760, 3, 'product/44/5', 'kid/bundle-product.html', 'catalog/product/view/id/44/category/5', 1, NULL, NULL, 5, 44),
(16761, 3, 'product/44/6', 'accessories-17/bundle-product.html', 'catalog/product/view/id/44/category/6', 1, NULL, NULL, 6, 44),
(16762, 3, 'product/44/9', 'women/shapewear/bundle-product.html', 'catalog/product/view/id/44/category/9', 1, NULL, NULL, 9, 44),
(16763, 3, 'product/44/19', 'tv-audio/bicycle/bundle-product.html', 'catalog/product/view/id/44/category/19', 1, NULL, NULL, 19, 44),
(16764, 3, 'product/44/33', 'women/bags/bundle-product.html', 'catalog/product/view/id/44/category/33', 1, NULL, NULL, 33, 44),
(16765, 3, 'product/44/41', 'accessories-17/product-types/bundle-product.html', 'catalog/product/view/id/44/category/41', 1, NULL, NULL, 41, 44),
(16766, 3, 'product/44/42', 'cameras-photography/bundle-product.html', 'catalog/product/view/id/44/category/42', 1, NULL, NULL, 42, 44),
(16767, 3, 'product/44/43', 'tv-audio/bundle-product.html', 'catalog/product/view/id/44/category/43', 1, NULL, NULL, 43, 44),
(16768, 3, 'product/44/44', 'laptops-computers/bundle-product.html', 'catalog/product/view/id/44/category/44', 1, NULL, NULL, 44, 44),
(16769, 3, 'product/44/45', 'smart-phones-tablets/bundle-product.html', 'catalog/product/view/id/44/category/45', 1, NULL, NULL, 45, 44),
(16770, 3, 'product/44/46', 'video-games-consoles/bundle-product.html', 'catalog/product/view/id/44/category/46', 1, NULL, NULL, 46, 44),
(16771, 3, 'product/44/47', 'gadgets/bundle-product.html', 'catalog/product/view/id/44/category/47', 1, NULL, NULL, 47, 44),
(16772, 3, 'product/44/48', 'car-electronics-gps/bundle-product.html', 'catalog/product/view/id/44/category/48', 1, NULL, NULL, 48, 44),
(16773, 3, 'product/44/49', 'laptop/bundle-product.html', 'catalog/product/view/id/44/category/49', 1, NULL, NULL, 49, 44),
(16774, 3, 'product/44/50', 'accessories/bundle-product.html', 'catalog/product/view/id/44/category/50', 1, NULL, NULL, 50, 44),
(16775, 3, 'product/44/55', 'casio-watches/bundle-product.html', 'catalog/product/view/id/44/category/55', 1, NULL, NULL, 55, 44),
(16776, 3, 'product/44/56', 'asus-tablets/bundle-product.html', 'catalog/product/view/id/44/category/56', 1, NULL, NULL, 56, 44),
(16777, 3, 'product/44/57', 'women-fashion/bundle-product.html', 'catalog/product/view/id/44/category/57', 1, NULL, NULL, 57, 44),
(16778, 3, 'product/45', 'bundle-product-02.html', 'catalog/product/view/id/45', 1, NULL, NULL, NULL, 45),
(16779, 3, 'product/45/3', 'men/bundle-product-02.html', 'catalog/product/view/id/45/category/3', 1, NULL, NULL, 3, 45),
(16780, 3, 'product/45/4', 'women/bundle-product-02.html', 'catalog/product/view/id/45/category/4', 1, NULL, NULL, 4, 45),
(16781, 3, 'product/45/5', 'kid/bundle-product-02.html', 'catalog/product/view/id/45/category/5', 1, NULL, NULL, 5, 45),
(16782, 3, 'product/45/6', 'accessories-17/bundle-product-02.html', 'catalog/product/view/id/45/category/6', 1, NULL, NULL, 6, 45),
(16783, 3, 'product/45/9', 'women/shapewear/bundle-product-02.html', 'catalog/product/view/id/45/category/9', 1, NULL, NULL, 9, 45),
(16784, 3, 'product/45/19', 'tv-audio/bicycle/bundle-product-02.html', 'catalog/product/view/id/45/category/19', 1, NULL, NULL, 19, 45),
(16785, 3, 'product/45/33', 'women/bags/bundle-product-02.html', 'catalog/product/view/id/45/category/33', 1, NULL, NULL, 33, 45),
(16786, 3, 'product/45/41', 'accessories-17/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/41', 1, NULL, NULL, 41, 45),
(16787, 3, 'product/45/42', 'cameras-photography/bundle-product-02.html', 'catalog/product/view/id/45/category/42', 1, NULL, NULL, 42, 45),
(16788, 3, 'product/45/43', 'tv-audio/bundle-product-02.html', 'catalog/product/view/id/45/category/43', 1, NULL, NULL, 43, 45),
(16789, 3, 'product/45/44', 'laptops-computers/bundle-product-02.html', 'catalog/product/view/id/45/category/44', 1, NULL, NULL, 44, 45),
(16790, 3, 'product/45/45', 'smart-phones-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/45', 1, NULL, NULL, 45, 45),
(16791, 3, 'product/45/46', 'video-games-consoles/bundle-product-02.html', 'catalog/product/view/id/45/category/46', 1, NULL, NULL, 46, 45),
(16792, 3, 'product/45/47', 'gadgets/bundle-product-02.html', 'catalog/product/view/id/45/category/47', 1, NULL, NULL, 47, 45),
(16793, 3, 'product/45/48', 'car-electronics-gps/bundle-product-02.html', 'catalog/product/view/id/45/category/48', 1, NULL, NULL, 48, 45),
(16794, 3, 'product/45/49', 'laptop/bundle-product-02.html', 'catalog/product/view/id/45/category/49', 1, NULL, NULL, 49, 45),
(16795, 3, 'product/45/50', 'accessories/bundle-product-02.html', 'catalog/product/view/id/45/category/50', 1, NULL, NULL, 50, 45),
(16796, 3, 'product/45/55', 'casio-watches/bundle-product-02.html', 'catalog/product/view/id/45/category/55', 1, NULL, NULL, 55, 45),
(16797, 3, 'product/45/56', 'asus-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/56', 1, NULL, NULL, 56, 45),
(16798, 3, 'product/45/57', 'women-fashion/bundle-product-02.html', 'catalog/product/view/id/45/category/57', 1, NULL, NULL, 57, 45),
(16799, 3, 'product/46', 'downloadable-product.html', 'catalog/product/view/id/46', 1, NULL, NULL, NULL, 46),
(16800, 3, 'product/46/3', 'men/downloadable-product.html', 'catalog/product/view/id/46/category/3', 1, NULL, NULL, 3, 46),
(16801, 3, 'product/46/4', 'women/downloadable-product.html', 'catalog/product/view/id/46/category/4', 1, NULL, NULL, 4, 46),
(16802, 3, 'product/46/5', 'kid/downloadable-product.html', 'catalog/product/view/id/46/category/5', 1, NULL, NULL, 5, 46),
(16803, 3, 'product/46/6', 'accessories-17/downloadable-product.html', 'catalog/product/view/id/46/category/6', 1, NULL, NULL, 6, 46),
(16804, 3, 'product/46/9', 'women/shapewear/downloadable-product.html', 'catalog/product/view/id/46/category/9', 1, NULL, NULL, 9, 46),
(16805, 3, 'product/46/19', 'tv-audio/bicycle/downloadable-product.html', 'catalog/product/view/id/46/category/19', 1, NULL, NULL, 19, 46),
(16806, 3, 'product/46/33', 'women/bags/downloadable-product.html', 'catalog/product/view/id/46/category/33', 1, NULL, NULL, 33, 46),
(16807, 3, 'product/46/41', 'accessories-17/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/41', 1, NULL, NULL, 41, 46),
(16808, 3, 'product/46/42', 'cameras-photography/downloadable-product.html', 'catalog/product/view/id/46/category/42', 1, NULL, NULL, 42, 46),
(16809, 3, 'product/46/43', 'tv-audio/downloadable-product.html', 'catalog/product/view/id/46/category/43', 1, NULL, NULL, 43, 46),
(16810, 3, 'product/46/44', 'laptops-computers/downloadable-product.html', 'catalog/product/view/id/46/category/44', 1, NULL, NULL, 44, 46),
(16811, 3, 'product/46/45', 'smart-phones-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/45', 1, NULL, NULL, 45, 46),
(16812, 3, 'product/46/46', 'video-games-consoles/downloadable-product.html', 'catalog/product/view/id/46/category/46', 1, NULL, NULL, 46, 46),
(16813, 3, 'product/46/47', 'gadgets/downloadable-product.html', 'catalog/product/view/id/46/category/47', 1, NULL, NULL, 47, 46),
(16814, 3, 'product/46/48', 'car-electronics-gps/downloadable-product.html', 'catalog/product/view/id/46/category/48', 1, NULL, NULL, 48, 46),
(16815, 3, 'product/46/49', 'laptop/downloadable-product.html', 'catalog/product/view/id/46/category/49', 1, NULL, NULL, 49, 46),
(16816, 3, 'product/46/50', 'accessories/downloadable-product.html', 'catalog/product/view/id/46/category/50', 1, NULL, NULL, 50, 46),
(16817, 3, 'product/46/55', 'casio-watches/downloadable-product.html', 'catalog/product/view/id/46/category/55', 1, NULL, NULL, 55, 46),
(16818, 3, 'product/46/56', 'asus-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/56', 1, NULL, NULL, 56, 46),
(16819, 3, 'product/46/57', 'women-fashion/downloadable-product.html', 'catalog/product/view/id/46/category/57', 1, NULL, NULL, 57, 46),
(16820, 3, 'product/47', 'no-image.html', 'catalog/product/view/id/47', 1, NULL, NULL, NULL, 47),
(16821, 3, 'product/47/3', 'men/no-image.html', 'catalog/product/view/id/47/category/3', 1, NULL, NULL, 3, 47),
(16822, 3, 'product/47/4', 'women/no-image.html', 'catalog/product/view/id/47/category/4', 1, NULL, NULL, 4, 47),
(16823, 3, 'product/47/6', 'accessories-17/no-image.html', 'catalog/product/view/id/47/category/6', 1, NULL, NULL, 6, 47),
(16824, 3, 'product/47/9', 'women/shapewear/no-image.html', 'catalog/product/view/id/47/category/9', 1, NULL, NULL, 9, 47),
(16825, 3, 'product/47/19', 'tv-audio/bicycle/no-image.html', 'catalog/product/view/id/47/category/19', 1, NULL, NULL, 19, 47),
(16826, 3, 'product/47/33', 'women/bags/no-image.html', 'catalog/product/view/id/47/category/33', 1, NULL, NULL, 33, 47),
(16827, 3, 'product/47/41', 'accessories-17/product-types/no-image.html', 'catalog/product/view/id/47/category/41', 1, NULL, NULL, 41, 47),
(16828, 3, 'product/47/42', 'cameras-photography/no-image.html', 'catalog/product/view/id/47/category/42', 1, NULL, NULL, 42, 47),
(16829, 3, 'product/47/43', 'tv-audio/no-image.html', 'catalog/product/view/id/47/category/43', 1, NULL, NULL, 43, 47),
(16830, 3, 'product/47/44', 'laptops-computers/no-image.html', 'catalog/product/view/id/47/category/44', 1, NULL, NULL, 44, 47),
(16831, 3, 'product/47/45', 'smart-phones-tablets/no-image.html', 'catalog/product/view/id/47/category/45', 1, NULL, NULL, 45, 47),
(16832, 3, 'product/47/46', 'video-games-consoles/no-image.html', 'catalog/product/view/id/47/category/46', 1, NULL, NULL, 46, 47),
(16833, 3, 'product/47/47', 'gadgets/no-image.html', 'catalog/product/view/id/47/category/47', 1, NULL, NULL, 47, 47),
(16834, 3, 'product/47/48', 'car-electronics-gps/no-image.html', 'catalog/product/view/id/47/category/48', 1, NULL, NULL, 48, 47),
(16835, 3, 'product/47/49', 'laptop/no-image.html', 'catalog/product/view/id/47/category/49', 1, NULL, NULL, 49, 47),
(16836, 3, 'product/47/50', 'accessories/no-image.html', 'catalog/product/view/id/47/category/50', 1, NULL, NULL, 50, 47),
(16837, 3, 'product/47/55', 'casio-watches/no-image.html', 'catalog/product/view/id/47/category/55', 1, NULL, NULL, 55, 47),
(16838, 3, 'product/47/56', 'asus-tablets/no-image.html', 'catalog/product/view/id/47/category/56', 1, NULL, NULL, 56, 47),
(16839, 3, 'product/47/57', 'women-fashion/no-image.html', 'catalog/product/view/id/47/category/57', 1, NULL, NULL, 57, 47),
(16840, 3, 'product/48', 'custom-option.html', 'catalog/product/view/id/48', 1, NULL, NULL, NULL, 48),
(16841, 3, 'product/48/3', 'men/custom-option.html', 'catalog/product/view/id/48/category/3', 1, NULL, NULL, 3, 48),
(16842, 3, 'product/48/4', 'women/custom-option.html', 'catalog/product/view/id/48/category/4', 1, NULL, NULL, 4, 48),
(16843, 3, 'product/48/6', 'accessories-17/custom-option.html', 'catalog/product/view/id/48/category/6', 1, NULL, NULL, 6, 48),
(16844, 3, 'product/48/9', 'women/shapewear/custom-option.html', 'catalog/product/view/id/48/category/9', 1, NULL, NULL, 9, 48),
(16845, 3, 'product/48/19', 'tv-audio/bicycle/custom-option.html', 'catalog/product/view/id/48/category/19', 1, NULL, NULL, 19, 48),
(16846, 3, 'product/48/20', 'tv-audio/bicycle/jackets/custom-option.html', 'catalog/product/view/id/48/category/20', 1, NULL, NULL, 20, 48),
(16847, 3, 'product/48/24', 'tv-audio/bicycle/scarves/custom-option.html', 'catalog/product/view/id/48/category/24', 1, NULL, NULL, 24, 48),
(16848, 3, 'product/48/25', 'tv-audio/bicycle/lifestyle/custom-option.html', 'catalog/product/view/id/48/category/25', 1, NULL, NULL, 25, 48),
(16849, 3, 'product/48/26', 'accessories-17/bras/custom-option.html', 'catalog/product/view/id/48/category/26', 1, NULL, NULL, 26, 48),
(16850, 3, 'product/48/28', 'accessories-17/cosmetics/custom-option.html', 'catalog/product/view/id/48/category/28', 1, NULL, NULL, 28, 48),
(16851, 3, 'product/48/33', 'women/bags/custom-option.html', 'catalog/product/view/id/48/category/33', 1, NULL, NULL, 33, 48),
(16852, 3, 'product/48/40', 'accessories-17/cfg-products/custom-option.html', 'catalog/product/view/id/48/category/40', 1, NULL, NULL, 40, 48),
(16853, 3, 'product/48/41', 'accessories-17/product-types/custom-option.html', 'catalog/product/view/id/48/category/41', 1, NULL, NULL, 41, 48),
(16854, 3, 'product/48/42', 'cameras-photography/custom-option.html', 'catalog/product/view/id/48/category/42', 1, NULL, NULL, 42, 48),
(16855, 3, 'product/48/43', 'tv-audio/custom-option.html', 'catalog/product/view/id/48/category/43', 1, NULL, NULL, 43, 48),
(16856, 3, 'product/48/44', 'laptops-computers/custom-option.html', 'catalog/product/view/id/48/category/44', 1, NULL, NULL, 44, 48),
(16857, 3, 'product/48/45', 'smart-phones-tablets/custom-option.html', 'catalog/product/view/id/48/category/45', 1, NULL, NULL, 45, 48),
(16858, 3, 'product/48/46', 'video-games-consoles/custom-option.html', 'catalog/product/view/id/48/category/46', 1, NULL, NULL, 46, 48),
(16859, 3, 'product/48/47', 'gadgets/custom-option.html', 'catalog/product/view/id/48/category/47', 1, NULL, NULL, 47, 48),
(16860, 3, 'product/48/48', 'car-electronics-gps/custom-option.html', 'catalog/product/view/id/48/category/48', 1, NULL, NULL, 48, 48),
(16861, 3, 'product/48/49', 'laptop/custom-option.html', 'catalog/product/view/id/48/category/49', 1, NULL, NULL, 49, 48),
(16862, 3, 'product/48/50', 'accessories/custom-option.html', 'catalog/product/view/id/48/category/50', 1, NULL, NULL, 50, 48),
(16863, 3, 'product/48/55', 'casio-watches/custom-option.html', 'catalog/product/view/id/48/category/55', 1, NULL, NULL, 55, 48),
(16864, 3, 'product/48/56', 'asus-tablets/custom-option.html', 'catalog/product/view/id/48/category/56', 1, NULL, NULL, 56, 48),
(16865, 3, 'product/48/57', 'women-fashion/custom-option.html', 'catalog/product/view/id/48/category/57', 1, NULL, NULL, 57, 48),
(16866, 4, 'category/3', 'men.html', 'catalog/category/view/id/3', 1, NULL, NULL, 3, NULL),
(16867, 4, 'category/4', 'women.html', 'catalog/category/view/id/4', 1, NULL, NULL, 4, NULL),
(16868, 4, 'category/33', 'women/bags.html', 'catalog/category/view/id/33', 1, NULL, NULL, 33, NULL),
(16869, 4, 'category/18', 'women/bags/bands.html', 'catalog/category/view/id/18', 1, NULL, NULL, 18, NULL),
(16870, 4, 'category/23', 'women/bags/blog.html', 'catalog/category/view/id/23', 1, NULL, NULL, 23, NULL),
(16871, 4, 'category/34', 'women/bags/nightwear.html', 'catalog/category/view/id/34', 1, NULL, NULL, 34, NULL),
(16872, 4, 'category/35', 'women/bags/briefs.html', 'catalog/category/view/id/35', 1, NULL, NULL, 35, NULL),
(16873, 4, 'category/36', 'women/bags/duffle.html', 'catalog/category/view/id/36', 1, NULL, NULL, 36, NULL),
(16874, 4, 'category/37', 'women/bags/dresses.html', 'catalog/category/view/id/37', 1, NULL, NULL, 37, NULL),
(16875, 4, 'category/38', 'women/bags/laptop.html', 'catalog/category/view/id/38', 1, NULL, NULL, 38, NULL),
(16876, 4, 'category/39', 'women/bags/cosmetic.html', 'catalog/category/view/id/39', 1, NULL, NULL, 39, NULL),
(16877, 4, 'category/8', 'women/bags/shoes.html', 'catalog/category/view/id/8', 1, NULL, NULL, 8, NULL),
(16878, 4, 'category/15', 'women/bags/shoes/gloves.html', 'catalog/category/view/id/15', 1, NULL, NULL, 15, NULL),
(16879, 4, 'category/16', 'women/bags/shoes/leathers.html', 'catalog/category/view/id/16', 1, NULL, NULL, 16, NULL),
(16880, 4, 'category/17', 'women/bags/shoes/cocktail.html', 'catalog/category/view/id/17', 1, NULL, NULL, 17, NULL),
(16881, 4, 'category/22', 'women/bags/shoes/clothing.html', 'catalog/category/view/id/22', 1, NULL, NULL, 22, NULL),
(16882, 4, 'category/31', 'women/bags/shoes/shirts.html', 'catalog/category/view/id/31', 1, NULL, NULL, 31, NULL),
(16883, 4, 'category/21', 'women/bags/shoes/shirts/hair.html', 'catalog/category/view/id/21', 1, NULL, NULL, 21, NULL),
(16884, 4, 'category/27', 'women/bags/shoes/shirts/helmet.html', 'catalog/category/view/id/27', 1, NULL, NULL, 27, NULL),
(16885, 4, 'category/29', 'women/bags/shoes/shirts/camis.html', 'catalog/category/view/id/29', 1, NULL, NULL, 29, NULL),
(16886, 4, 'category/30', 'women/bags/shoes/shirts/lingerie.html', 'catalog/category/view/id/30', 1, NULL, NULL, 30, NULL),
(16887, 4, 'category/32', 'women/bags/shoes/shirts/tops.html', 'catalog/category/view/id/32', 1, NULL, NULL, 32, NULL),
(16888, 4, 'category/7', 'women/bags/shoes/rings.html', 'catalog/category/view/id/7', 1, NULL, NULL, 7, NULL),
(16889, 4, 'category/9', 'women/shapewear.html', 'catalog/category/view/id/9', 1, NULL, NULL, 9, NULL),
(16890, 4, 'category/10', 'women/shapewear/sundresses.html', 'catalog/category/view/id/10', 1, NULL, NULL, 10, NULL),
(16891, 4, 'category/11', 'women/shapewear/footwear.html', 'catalog/category/view/id/11', 1, NULL, NULL, 11, NULL),
(16892, 4, 'category/12', 'women/shapewear/novelty.html', 'catalog/category/view/id/12', 1, NULL, NULL, 12, NULL),
(16893, 4, 'category/13', 'women/shapewear/outerwear.html', 'catalog/category/view/id/13', 1, NULL, NULL, 13, NULL),
(16894, 4, 'category/14', 'women/shapewear/hats.html', 'catalog/category/view/id/14', 1, NULL, NULL, 14, NULL),
(16895, 4, 'category/51', 'women/shapewear/salad-plates.html', 'catalog/category/view/id/51', 1, NULL, NULL, 51, NULL),
(16896, 4, 'category/52', 'women/shapewear/kitchen-storage.html', 'catalog/category/view/id/52', 1, NULL, NULL, 52, NULL),
(16897, 4, 'category/53', 'women/shapewear/dish-racks.html', 'catalog/category/view/id/53', 1, NULL, NULL, 53, NULL),
(16898, 4, 'category/54', 'women/shapewear/colanders.html', 'catalog/category/view/id/54', 1, NULL, NULL, 54, NULL),
(16899, 4, 'category/42', 'cameras-photography.html', 'catalog/category/view/id/42', 1, NULL, NULL, 42, NULL),
(16900, 4, 'category/43', 'tv-audio.html', 'catalog/category/view/id/43', 1, NULL, NULL, 43, NULL),
(16901, 4, 'category/44', 'laptops-computers.html', 'catalog/category/view/id/44', 1, NULL, NULL, 44, NULL),
(16902, 4, 'category/45', 'smart-phones-tablets.html', 'catalog/category/view/id/45', 1, NULL, NULL, 45, NULL),
(16903, 4, 'category/46', 'video-games-consoles.html', 'catalog/category/view/id/46', 1, NULL, NULL, 46, NULL),
(16904, 4, 'category/47', 'gadgets.html', 'catalog/category/view/id/47', 1, NULL, NULL, 47, NULL),
(16905, 4, 'category/48', 'car-electronics-gps.html', 'catalog/category/view/id/48', 1, NULL, NULL, 48, NULL),
(16906, 4, 'category/49', 'laptop.html', 'catalog/category/view/id/49', 1, NULL, NULL, 49, NULL);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(16907, 4, 'category/5', 'kid.html', 'catalog/category/view/id/5', 1, NULL, NULL, 5, NULL),
(16908, 4, 'category/50', 'accessories.html', 'catalog/category/view/id/50', 1, NULL, NULL, 50, NULL),
(16909, 4, 'category/55', 'casio-watches.html', 'catalog/category/view/id/55', 1, NULL, NULL, 55, NULL),
(16910, 4, 'category/56', 'asus-tablets.html', 'catalog/category/view/id/56', 1, NULL, NULL, 56, NULL),
(16911, 4, 'category/57', 'women-fashion.html', 'catalog/category/view/id/57', 1, NULL, NULL, 57, NULL),
(16912, 4, 'category/6', 'accessories-17.html', 'catalog/category/view/id/6', 1, NULL, NULL, 6, NULL),
(16913, 4, 'category/19', 'tv-audio/bicycle.html', 'catalog/category/view/id/19', 1, NULL, NULL, 19, NULL),
(16914, 4, 'category/20', 'tv-audio/bicycle/jackets.html', 'catalog/category/view/id/20', 1, NULL, NULL, 20, NULL),
(16915, 4, 'category/24', 'tv-audio/bicycle/scarves.html', 'catalog/category/view/id/24', 1, NULL, NULL, 24, NULL),
(16916, 4, 'category/25', 'tv-audio/bicycle/lifestyle.html', 'catalog/category/view/id/25', 1, NULL, NULL, 25, NULL),
(16917, 4, 'category/26', 'accessories-17/bras.html', 'catalog/category/view/id/26', 1, NULL, NULL, 26, NULL),
(16918, 4, 'category/28', 'accessories-17/cosmetics.html', 'catalog/category/view/id/28', 1, NULL, NULL, 28, NULL),
(16919, 4, 'category/40', 'accessories-17/cfg-products.html', 'catalog/category/view/id/40', 1, NULL, NULL, 40, NULL),
(16920, 4, 'category/41', 'accessories-17/product-types.html', 'catalog/category/view/id/41', 1, NULL, NULL, 41, NULL),
(16921, 4, 'product/7', 'configurable-product.html', 'catalog/product/view/id/7', 1, NULL, NULL, NULL, 7),
(16922, 4, 'product/7/3', 'men/configurable-product.html', 'catalog/product/view/id/7/category/3', 1, NULL, NULL, 3, 7),
(16923, 4, 'product/7/4', 'women/configurable-product.html', 'catalog/product/view/id/7/category/4', 1, NULL, NULL, 4, 7),
(16924, 4, 'product/7/40', 'accessories-17/cfg-products/configurable-product.html', 'catalog/product/view/id/7/category/40', 1, NULL, NULL, 40, 7),
(16925, 4, 'product/7/41', 'accessories-17/product-types/configurable-product.html', 'catalog/product/view/id/7/category/41', 1, NULL, NULL, 41, 7),
(16926, 4, 'product/8', 'configurable-product-armani-black.html', 'catalog/product/view/id/8', 1, NULL, NULL, NULL, 8),
(16927, 4, 'product/8/3', 'men/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/3', 1, NULL, NULL, 3, 8),
(16928, 4, 'product/8/4', 'women/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/4', 1, NULL, NULL, 4, 8),
(16929, 4, 'product/9', 'configurable-product-armani-blue.html', 'catalog/product/view/id/9', 1, NULL, NULL, NULL, 9),
(16930, 4, 'product/9/3', 'men/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/3', 1, NULL, NULL, 3, 9),
(16931, 4, 'product/9/4', 'women/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/4', 1, NULL, NULL, 4, 9),
(16932, 4, 'product/10', 'configurable-product-armani-green.html', 'catalog/product/view/id/10', 1, NULL, NULL, NULL, 10),
(16933, 4, 'product/10/3', 'men/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/3', 1, NULL, NULL, 3, 10),
(16934, 4, 'product/10/4', 'women/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/4', 1, NULL, NULL, 4, 10),
(16935, 4, 'product/11', 'configurable-product-buberry-red.html', 'catalog/product/view/id/11', 1, NULL, NULL, NULL, 11),
(16936, 4, 'product/11/3', 'men/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/3', 1, NULL, NULL, 3, 11),
(16937, 4, 'product/11/4', 'women/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/4', 1, NULL, NULL, 4, 11),
(16938, 4, 'product/12', 'configurable-product-buberry-green.html', 'catalog/product/view/id/12', 1, NULL, NULL, NULL, 12),
(16939, 4, 'product/12/3', 'men/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/3', 1, NULL, NULL, 3, 12),
(16940, 4, 'product/12/4', 'women/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/4', 1, NULL, NULL, 4, 12),
(16941, 4, 'product/13', 'configurable-product-02.html', 'catalog/product/view/id/13', 1, NULL, NULL, NULL, 13),
(16942, 4, 'product/13/3', 'men/configurable-product-02.html', 'catalog/product/view/id/13/category/3', 1, NULL, NULL, 3, 13),
(16943, 4, 'product/13/4', 'women/configurable-product-02.html', 'catalog/product/view/id/13/category/4', 1, NULL, NULL, 4, 13),
(16944, 4, 'product/13/40', 'accessories-17/cfg-products/configurable-product-02.html', 'catalog/product/view/id/13/category/40', 1, NULL, NULL, 40, 13),
(16945, 4, 'product/13/41', 'accessories-17/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/41', 1, NULL, NULL, 41, 13),
(16946, 4, 'product/14', 'configurable-product-02-chanel-black.html', 'catalog/product/view/id/14', 1, NULL, NULL, NULL, 14),
(16947, 4, 'product/14/3', 'men/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/3', 1, NULL, NULL, 3, 14),
(16948, 4, 'product/14/4', 'women/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/4', 1, NULL, NULL, 4, 14),
(16949, 4, 'product/15', 'configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15', 1, NULL, NULL, NULL, 15),
(16950, 4, 'product/15/3', 'men/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/3', 1, NULL, NULL, 3, 15),
(16951, 4, 'product/15/4', 'women/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/4', 1, NULL, NULL, 4, 15),
(16952, 4, 'product/16', 'configurable-product-02-dior-green.html', 'catalog/product/view/id/16', 1, NULL, NULL, NULL, 16),
(16953, 4, 'product/16/3', 'men/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/3', 1, NULL, NULL, 3, 16),
(16954, 4, 'product/16/4', 'women/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/4', 1, NULL, NULL, 4, 16),
(16955, 4, 'product/17', 'configurable-product-02-gucci-red.html', 'catalog/product/view/id/17', 1, NULL, NULL, NULL, 17),
(16956, 4, 'product/17/3', 'men/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/3', 1, NULL, NULL, 3, 17),
(16957, 4, 'product/17/4', 'women/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/4', 1, NULL, NULL, 4, 17),
(16958, 4, 'product/18', 'configurable-product-02-gucci-white.html', 'catalog/product/view/id/18', 1, NULL, NULL, NULL, 18),
(16959, 4, 'product/18/3', 'men/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/3', 1, NULL, NULL, 3, 18),
(16960, 4, 'product/18/4', 'women/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/4', 1, NULL, NULL, 4, 18),
(16961, 4, 'product/19', 'configurable-product-03.html', 'catalog/product/view/id/19', 1, NULL, NULL, NULL, 19),
(16962, 4, 'product/19/3', 'men/configurable-product-03.html', 'catalog/product/view/id/19/category/3', 1, NULL, NULL, 3, 19),
(16963, 4, 'product/19/4', 'women/configurable-product-03.html', 'catalog/product/view/id/19/category/4', 1, NULL, NULL, 4, 19),
(16964, 4, 'product/19/40', 'accessories-17/cfg-products/configurable-product-03.html', 'catalog/product/view/id/19/category/40', 1, NULL, NULL, 40, 19),
(16965, 4, 'product/19/41', 'accessories-17/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/41', 1, NULL, NULL, 41, 19),
(16966, 4, 'product/20', 'configurable-product-04.html', 'catalog/product/view/id/20', 1, NULL, NULL, NULL, 20),
(16967, 4, 'product/20/3', 'men/configurable-product-04.html', 'catalog/product/view/id/20/category/3', 1, NULL, NULL, 3, 20),
(16968, 4, 'product/20/4', 'women/configurable-product-04.html', 'catalog/product/view/id/20/category/4', 1, NULL, NULL, 4, 20),
(16969, 4, 'product/20/40', 'accessories-17/cfg-products/configurable-product-04.html', 'catalog/product/view/id/20/category/40', 1, NULL, NULL, 40, 20),
(16970, 4, 'product/20/41', 'accessories-17/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/41', 1, NULL, NULL, 41, 20),
(16971, 4, 'product/21', 'configurable-product-05.html', 'catalog/product/view/id/21', 1, NULL, NULL, NULL, 21),
(16972, 4, 'product/21/3', 'men/configurable-product-05.html', 'catalog/product/view/id/21/category/3', 1, NULL, NULL, 3, 21),
(16973, 4, 'product/21/4', 'women/configurable-product-05.html', 'catalog/product/view/id/21/category/4', 1, NULL, NULL, 4, 21),
(16974, 4, 'product/21/40', 'accessories-17/cfg-products/configurable-product-05.html', 'catalog/product/view/id/21/category/40', 1, NULL, NULL, 40, 21),
(16975, 4, 'product/21/41', 'accessories-17/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/41', 1, NULL, NULL, 41, 21),
(16976, 4, 'product/22', 'configurable-product-03-hermes-white.html', 'catalog/product/view/id/22', 1, NULL, NULL, NULL, 22),
(16977, 4, 'product/22/3', 'men/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/3', 1, NULL, NULL, 3, 22),
(16978, 4, 'product/22/4', 'women/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/4', 1, NULL, NULL, 4, 22),
(16979, 4, 'product/23', 'configurable-product-03-prada-black.html', 'catalog/product/view/id/23', 1, NULL, NULL, NULL, 23),
(16980, 4, 'product/23/3', 'men/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/3', 1, NULL, NULL, 3, 23),
(16981, 4, 'product/23/4', 'women/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/4', 1, NULL, NULL, 4, 23),
(16982, 4, 'product/24', 'configurable-product-03-versace-blue.html', 'catalog/product/view/id/24', 1, NULL, NULL, NULL, 24),
(16983, 4, 'product/24/3', 'men/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/3', 1, NULL, NULL, 3, 24),
(16984, 4, 'product/24/4', 'women/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/4', 1, NULL, NULL, 4, 24),
(16985, 4, 'product/25', 'configurable-product-03-prada-green.html', 'catalog/product/view/id/25', 1, NULL, NULL, NULL, 25),
(16986, 4, 'product/25/3', 'men/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/3', 1, NULL, NULL, 3, 25),
(16987, 4, 'product/25/4', 'women/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/4', 1, NULL, NULL, 4, 25),
(16988, 4, 'product/26', 'configurable-product-03-prada-red.html', 'catalog/product/view/id/26', 1, NULL, NULL, NULL, 26),
(16989, 4, 'product/26/3', 'men/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/3', 1, NULL, NULL, 3, 26),
(16990, 4, 'product/26/4', 'women/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/4', 1, NULL, NULL, 4, 26),
(16991, 4, 'product/27', 'configurable-product-04-black.html', 'catalog/product/view/id/27', 1, NULL, NULL, NULL, 27),
(16992, 4, 'product/27/3', 'men/configurable-product-04-black.html', 'catalog/product/view/id/27/category/3', 1, NULL, NULL, 3, 27),
(16993, 4, 'product/27/4', 'women/configurable-product-04-black.html', 'catalog/product/view/id/27/category/4', 1, NULL, NULL, 4, 27),
(16994, 4, 'product/28', 'configurable-product-04-white.html', 'catalog/product/view/id/28', 1, NULL, NULL, NULL, 28),
(16995, 4, 'product/28/3', 'men/configurable-product-04-white.html', 'catalog/product/view/id/28/category/3', 1, NULL, NULL, 3, 28),
(16996, 4, 'product/28/4', 'women/configurable-product-04-white.html', 'catalog/product/view/id/28/category/4', 1, NULL, NULL, 4, 28),
(16997, 4, 'product/29', 'configurable-product-04-red.html', 'catalog/product/view/id/29', 1, NULL, NULL, NULL, 29),
(16998, 4, 'product/29/3', 'men/configurable-product-04-red.html', 'catalog/product/view/id/29/category/3', 1, NULL, NULL, 3, 29),
(16999, 4, 'product/29/4', 'women/configurable-product-04-red.html', 'catalog/product/view/id/29/category/4', 1, NULL, NULL, 4, 29),
(17000, 4, 'product/29/5', 'kid/configurable-product-04-red.html', 'catalog/product/view/id/29/category/5', 1, NULL, NULL, 5, 29),
(17001, 4, 'product/29/6', 'accessories-17/configurable-product-04-red.html', 'catalog/product/view/id/29/category/6', 1, NULL, NULL, 6, 29),
(17002, 4, 'product/29/19', 'tv-audio/bicycle/configurable-product-04-red.html', 'catalog/product/view/id/29/category/19', 1, NULL, NULL, 19, 29),
(17003, 4, 'product/29/33', 'women/bags/configurable-product-04-red.html', 'catalog/product/view/id/29/category/33', 1, NULL, NULL, 33, 29),
(17004, 4, 'product/29/42', 'cameras-photography/configurable-product-04-red.html', 'catalog/product/view/id/29/category/42', 1, NULL, NULL, 42, 29),
(17005, 4, 'product/29/43', 'tv-audio/configurable-product-04-red.html', 'catalog/product/view/id/29/category/43', 1, NULL, NULL, 43, 29),
(17006, 4, 'product/29/44', 'laptops-computers/configurable-product-04-red.html', 'catalog/product/view/id/29/category/44', 1, NULL, NULL, 44, 29),
(17007, 4, 'product/29/45', 'smart-phones-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/45', 1, NULL, NULL, 45, 29),
(17008, 4, 'product/29/46', 'video-games-consoles/configurable-product-04-red.html', 'catalog/product/view/id/29/category/46', 1, NULL, NULL, 46, 29),
(17009, 4, 'product/29/47', 'gadgets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/47', 1, NULL, NULL, 47, 29),
(17010, 4, 'product/29/48', 'car-electronics-gps/configurable-product-04-red.html', 'catalog/product/view/id/29/category/48', 1, NULL, NULL, 48, 29),
(17011, 4, 'product/29/49', 'laptop/configurable-product-04-red.html', 'catalog/product/view/id/29/category/49', 1, NULL, NULL, 49, 29),
(17012, 4, 'product/29/50', 'accessories/configurable-product-04-red.html', 'catalog/product/view/id/29/category/50', 1, NULL, NULL, 50, 29),
(17013, 4, 'product/29/55', 'casio-watches/configurable-product-04-red.html', 'catalog/product/view/id/29/category/55', 1, NULL, NULL, 55, 29),
(17014, 4, 'product/29/56', 'asus-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/56', 1, NULL, NULL, 56, 29),
(17015, 4, 'product/29/57', 'women-fashion/configurable-product-04-red.html', 'catalog/product/view/id/29/category/57', 1, NULL, NULL, 57, 29),
(17016, 4, 'product/30', 'configurable-product-04-green.html', 'catalog/product/view/id/30', 1, NULL, NULL, NULL, 30),
(17017, 4, 'product/30/3', 'men/configurable-product-04-green.html', 'catalog/product/view/id/30/category/3', 1, NULL, NULL, 3, 30),
(17018, 4, 'product/30/4', 'women/configurable-product-04-green.html', 'catalog/product/view/id/30/category/4', 1, NULL, NULL, 4, 30),
(17019, 4, 'product/30/5', 'kid/configurable-product-04-green.html', 'catalog/product/view/id/30/category/5', 1, NULL, NULL, 5, 30),
(17020, 4, 'product/30/6', 'accessories-17/configurable-product-04-green.html', 'catalog/product/view/id/30/category/6', 1, NULL, NULL, 6, 30),
(17021, 4, 'product/30/19', 'tv-audio/bicycle/configurable-product-04-green.html', 'catalog/product/view/id/30/category/19', 1, NULL, NULL, 19, 30),
(17022, 4, 'product/30/33', 'women/bags/configurable-product-04-green.html', 'catalog/product/view/id/30/category/33', 1, NULL, NULL, 33, 30),
(17023, 4, 'product/30/42', 'cameras-photography/configurable-product-04-green.html', 'catalog/product/view/id/30/category/42', 1, NULL, NULL, 42, 30),
(17024, 4, 'product/30/43', 'tv-audio/configurable-product-04-green.html', 'catalog/product/view/id/30/category/43', 1, NULL, NULL, 43, 30),
(17025, 4, 'product/30/44', 'laptops-computers/configurable-product-04-green.html', 'catalog/product/view/id/30/category/44', 1, NULL, NULL, 44, 30),
(17026, 4, 'product/30/45', 'smart-phones-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/45', 1, NULL, NULL, 45, 30),
(17027, 4, 'product/30/46', 'video-games-consoles/configurable-product-04-green.html', 'catalog/product/view/id/30/category/46', 1, NULL, NULL, 46, 30),
(17028, 4, 'product/30/47', 'gadgets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/47', 1, NULL, NULL, 47, 30),
(17029, 4, 'product/30/48', 'car-electronics-gps/configurable-product-04-green.html', 'catalog/product/view/id/30/category/48', 1, NULL, NULL, 48, 30),
(17030, 4, 'product/30/49', 'laptop/configurable-product-04-green.html', 'catalog/product/view/id/30/category/49', 1, NULL, NULL, 49, 30),
(17031, 4, 'product/30/50', 'accessories/configurable-product-04-green.html', 'catalog/product/view/id/30/category/50', 1, NULL, NULL, 50, 30),
(17032, 4, 'product/30/55', 'casio-watches/configurable-product-04-green.html', 'catalog/product/view/id/30/category/55', 1, NULL, NULL, 55, 30),
(17033, 4, 'product/30/56', 'asus-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/56', 1, NULL, NULL, 56, 30),
(17034, 4, 'product/30/57', 'women-fashion/configurable-product-04-green.html', 'catalog/product/view/id/30/category/57', 1, NULL, NULL, 57, 30),
(17035, 4, 'product/31', 'configurable-product-04-blue.html', 'catalog/product/view/id/31', 1, NULL, NULL, NULL, 31),
(17036, 4, 'product/31/3', 'men/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/3', 1, NULL, NULL, 3, 31),
(17037, 4, 'product/31/4', 'women/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/4', 1, NULL, NULL, 4, 31),
(17038, 4, 'product/31/5', 'kid/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/5', 1, NULL, NULL, 5, 31),
(17039, 4, 'product/31/6', 'accessories-17/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/6', 1, NULL, NULL, 6, 31),
(17040, 4, 'product/31/19', 'tv-audio/bicycle/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/19', 1, NULL, NULL, 19, 31),
(17041, 4, 'product/31/33', 'women/bags/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/33', 1, NULL, NULL, 33, 31),
(17042, 4, 'product/31/42', 'cameras-photography/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/42', 1, NULL, NULL, 42, 31),
(17043, 4, 'product/31/43', 'tv-audio/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/43', 1, NULL, NULL, 43, 31),
(17044, 4, 'product/31/44', 'laptops-computers/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/44', 1, NULL, NULL, 44, 31),
(17045, 4, 'product/31/45', 'smart-phones-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/45', 1, NULL, NULL, 45, 31),
(17046, 4, 'product/31/46', 'video-games-consoles/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/46', 1, NULL, NULL, 46, 31),
(17047, 4, 'product/31/47', 'gadgets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/47', 1, NULL, NULL, 47, 31),
(17048, 4, 'product/31/48', 'car-electronics-gps/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/48', 1, NULL, NULL, 48, 31),
(17049, 4, 'product/31/49', 'laptop/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/49', 1, NULL, NULL, 49, 31),
(17050, 4, 'product/31/50', 'accessories/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/50', 1, NULL, NULL, 50, 31),
(17051, 4, 'product/31/55', 'casio-watches/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/55', 1, NULL, NULL, 55, 31),
(17052, 4, 'product/31/56', 'asus-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/56', 1, NULL, NULL, 56, 31),
(17053, 4, 'product/31/57', 'women-fashion/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/57', 1, NULL, NULL, 57, 31),
(17054, 4, 'product/32', 'configurable-product-05-armani.html', 'catalog/product/view/id/32', 1, NULL, NULL, NULL, 32),
(17055, 4, 'product/32/3', 'men/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/3', 1, NULL, NULL, 3, 32),
(17056, 4, 'product/32/4', 'women/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/4', 1, NULL, NULL, 4, 32),
(17057, 4, 'product/32/5', 'kid/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/5', 1, NULL, NULL, 5, 32),
(17058, 4, 'product/32/6', 'accessories-17/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/6', 1, NULL, NULL, 6, 32),
(17059, 4, 'product/32/19', 'tv-audio/bicycle/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/19', 1, NULL, NULL, 19, 32),
(17060, 4, 'product/32/33', 'women/bags/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/33', 1, NULL, NULL, 33, 32),
(17061, 4, 'product/32/42', 'cameras-photography/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/42', 1, NULL, NULL, 42, 32),
(17062, 4, 'product/32/43', 'tv-audio/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/43', 1, NULL, NULL, 43, 32),
(17063, 4, 'product/32/44', 'laptops-computers/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/44', 1, NULL, NULL, 44, 32),
(17064, 4, 'product/32/45', 'smart-phones-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/45', 1, NULL, NULL, 45, 32),
(17065, 4, 'product/32/46', 'video-games-consoles/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/46', 1, NULL, NULL, 46, 32),
(17066, 4, 'product/32/47', 'gadgets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/47', 1, NULL, NULL, 47, 32),
(17067, 4, 'product/32/48', 'car-electronics-gps/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/48', 1, NULL, NULL, 48, 32),
(17068, 4, 'product/32/49', 'laptop/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/49', 1, NULL, NULL, 49, 32),
(17069, 4, 'product/32/50', 'accessories/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/50', 1, NULL, NULL, 50, 32),
(17070, 4, 'product/32/55', 'casio-watches/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/55', 1, NULL, NULL, 55, 32),
(17071, 4, 'product/32/56', 'asus-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/56', 1, NULL, NULL, 56, 32),
(17072, 4, 'product/32/57', 'women-fashion/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/57', 1, NULL, NULL, 57, 32),
(17073, 4, 'product/33', 'configurable-product-05-buberry.html', 'catalog/product/view/id/33', 1, NULL, NULL, NULL, 33),
(17074, 4, 'product/33/3', 'men/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/3', 1, NULL, NULL, 3, 33),
(17075, 4, 'product/33/4', 'women/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/4', 1, NULL, NULL, 4, 33),
(17076, 4, 'product/33/5', 'kid/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/5', 1, NULL, NULL, 5, 33),
(17077, 4, 'product/33/6', 'accessories-17/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/6', 1, NULL, NULL, 6, 33),
(17078, 4, 'product/33/9', 'women/shapewear/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/9', 1, NULL, NULL, 9, 33),
(17079, 4, 'product/33/19', 'tv-audio/bicycle/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/19', 1, NULL, NULL, 19, 33),
(17080, 4, 'product/33/33', 'women/bags/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/33', 1, NULL, NULL, 33, 33),
(17081, 4, 'product/33/42', 'cameras-photography/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/42', 1, NULL, NULL, 42, 33),
(17082, 4, 'product/33/43', 'tv-audio/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/43', 1, NULL, NULL, 43, 33),
(17083, 4, 'product/33/44', 'laptops-computers/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/44', 1, NULL, NULL, 44, 33),
(17084, 4, 'product/33/45', 'smart-phones-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/45', 1, NULL, NULL, 45, 33),
(17085, 4, 'product/33/46', 'video-games-consoles/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/46', 1, NULL, NULL, 46, 33),
(17086, 4, 'product/33/47', 'gadgets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/47', 1, NULL, NULL, 47, 33),
(17087, 4, 'product/33/48', 'car-electronics-gps/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/48', 1, NULL, NULL, 48, 33),
(17088, 4, 'product/33/49', 'laptop/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/49', 1, NULL, NULL, 49, 33),
(17089, 4, 'product/33/50', 'accessories/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/50', 1, NULL, NULL, 50, 33),
(17090, 4, 'product/33/55', 'casio-watches/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/55', 1, NULL, NULL, 55, 33),
(17091, 4, 'product/33/56', 'asus-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/56', 1, NULL, NULL, 56, 33),
(17092, 4, 'product/33/57', 'women-fashion/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/57', 1, NULL, NULL, 57, 33),
(17093, 4, 'product/34', 'configurable-product-05-chanel.html', 'catalog/product/view/id/34', 1, NULL, NULL, NULL, 34),
(17094, 4, 'product/34/3', 'men/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/3', 1, NULL, NULL, 3, 34),
(17095, 4, 'product/34/4', 'women/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/4', 1, NULL, NULL, 4, 34),
(17096, 4, 'product/34/5', 'kid/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/5', 1, NULL, NULL, 5, 34),
(17097, 4, 'product/34/6', 'accessories-17/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/6', 1, NULL, NULL, 6, 34),
(17098, 4, 'product/34/9', 'women/shapewear/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/9', 1, NULL, NULL, 9, 34),
(17099, 4, 'product/34/19', 'tv-audio/bicycle/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/19', 1, NULL, NULL, 19, 34),
(17100, 4, 'product/34/33', 'women/bags/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/33', 1, NULL, NULL, 33, 34),
(17101, 4, 'product/34/42', 'cameras-photography/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/42', 1, NULL, NULL, 42, 34),
(17102, 4, 'product/34/43', 'tv-audio/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/43', 1, NULL, NULL, 43, 34),
(17103, 4, 'product/34/44', 'laptops-computers/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/44', 1, NULL, NULL, 44, 34),
(17104, 4, 'product/34/45', 'smart-phones-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/45', 1, NULL, NULL, 45, 34),
(17105, 4, 'product/34/46', 'video-games-consoles/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/46', 1, NULL, NULL, 46, 34),
(17106, 4, 'product/34/47', 'gadgets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/47', 1, NULL, NULL, 47, 34),
(17107, 4, 'product/34/48', 'car-electronics-gps/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/48', 1, NULL, NULL, 48, 34),
(17108, 4, 'product/34/49', 'laptop/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/49', 1, NULL, NULL, 49, 34),
(17109, 4, 'product/34/50', 'accessories/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/50', 1, NULL, NULL, 50, 34),
(17110, 4, 'product/34/55', 'casio-watches/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/55', 1, NULL, NULL, 55, 34),
(17111, 4, 'product/34/56', 'asus-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/56', 1, NULL, NULL, 56, 34),
(17112, 4, 'product/34/57', 'women-fashion/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/57', 1, NULL, NULL, 57, 34),
(17113, 4, 'product/35', 'configurable-product-05-hermes.html', 'catalog/product/view/id/35', 1, NULL, NULL, NULL, 35),
(17114, 4, 'product/35/3', 'men/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/3', 1, NULL, NULL, 3, 35),
(17115, 4, 'product/35/4', 'women/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/4', 1, NULL, NULL, 4, 35),
(17116, 4, 'product/35/5', 'kid/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/5', 1, NULL, NULL, 5, 35),
(17117, 4, 'product/35/6', 'accessories-17/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/6', 1, NULL, NULL, 6, 35),
(17118, 4, 'product/35/9', 'women/shapewear/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/9', 1, NULL, NULL, 9, 35),
(17119, 4, 'product/35/19', 'tv-audio/bicycle/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/19', 1, NULL, NULL, 19, 35),
(17120, 4, 'product/35/33', 'women/bags/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/33', 1, NULL, NULL, 33, 35),
(17121, 4, 'product/35/42', 'cameras-photography/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/42', 1, NULL, NULL, 42, 35),
(17122, 4, 'product/35/43', 'tv-audio/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/43', 1, NULL, NULL, 43, 35),
(17123, 4, 'product/35/44', 'laptops-computers/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/44', 1, NULL, NULL, 44, 35),
(17124, 4, 'product/35/45', 'smart-phones-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/45', 1, NULL, NULL, 45, 35),
(17125, 4, 'product/35/46', 'video-games-consoles/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/46', 1, NULL, NULL, 46, 35),
(17126, 4, 'product/35/47', 'gadgets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/47', 1, NULL, NULL, 47, 35),
(17127, 4, 'product/35/48', 'car-electronics-gps/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/48', 1, NULL, NULL, 48, 35),
(17128, 4, 'product/35/49', 'laptop/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/49', 1, NULL, NULL, 49, 35),
(17129, 4, 'product/35/50', 'accessories/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/50', 1, NULL, NULL, 50, 35),
(17130, 4, 'product/35/55', 'casio-watches/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/55', 1, NULL, NULL, 55, 35),
(17131, 4, 'product/35/56', 'asus-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/56', 1, NULL, NULL, 56, 35),
(17132, 4, 'product/35/57', 'women-fashion/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/57', 1, NULL, NULL, 57, 35),
(17133, 4, 'product/36', 'configurable-product-05-versace.html', 'catalog/product/view/id/36', 1, NULL, NULL, NULL, 36),
(17134, 4, 'product/36/3', 'men/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/3', 1, NULL, NULL, 3, 36),
(17135, 4, 'product/36/4', 'women/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/4', 1, NULL, NULL, 4, 36),
(17136, 4, 'product/36/5', 'kid/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/5', 1, NULL, NULL, 5, 36),
(17137, 4, 'product/36/6', 'accessories-17/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/6', 1, NULL, NULL, 6, 36),
(17138, 4, 'product/36/9', 'women/shapewear/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/9', 1, NULL, NULL, 9, 36),
(17139, 4, 'product/36/19', 'tv-audio/bicycle/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/19', 1, NULL, NULL, 19, 36),
(17140, 4, 'product/36/33', 'women/bags/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/33', 1, NULL, NULL, 33, 36),
(17141, 4, 'product/36/42', 'cameras-photography/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/42', 1, NULL, NULL, 42, 36),
(17142, 4, 'product/36/43', 'tv-audio/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/43', 1, NULL, NULL, 43, 36),
(17143, 4, 'product/36/44', 'laptops-computers/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/44', 1, NULL, NULL, 44, 36),
(17144, 4, 'product/36/45', 'smart-phones-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/45', 1, NULL, NULL, 45, 36),
(17145, 4, 'product/36/46', 'video-games-consoles/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/46', 1, NULL, NULL, 46, 36),
(17146, 4, 'product/36/47', 'gadgets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/47', 1, NULL, NULL, 47, 36),
(17147, 4, 'product/36/48', 'car-electronics-gps/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/48', 1, NULL, NULL, 48, 36),
(17148, 4, 'product/36/49', 'laptop/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/49', 1, NULL, NULL, 49, 36),
(17149, 4, 'product/36/50', 'accessories/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/50', 1, NULL, NULL, 50, 36),
(17150, 4, 'product/36/55', 'casio-watches/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/55', 1, NULL, NULL, 55, 36),
(17151, 4, 'product/36/56', 'asus-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/56', 1, NULL, NULL, 56, 36),
(17152, 4, 'product/36/57', 'women-fashion/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/57', 1, NULL, NULL, 57, 36),
(17153, 4, 'product/37', 'simple-product-01.html', 'catalog/product/view/id/37', 1, NULL, NULL, NULL, 37),
(17154, 4, 'product/37/3', 'men/simple-product-01.html', 'catalog/product/view/id/37/category/3', 1, NULL, NULL, 3, 37),
(17155, 4, 'product/37/4', 'women/simple-product-01.html', 'catalog/product/view/id/37/category/4', 1, NULL, NULL, 4, 37),
(17156, 4, 'product/37/5', 'kid/simple-product-01.html', 'catalog/product/view/id/37/category/5', 1, NULL, NULL, 5, 37),
(17157, 4, 'product/37/6', 'accessories-17/simple-product-01.html', 'catalog/product/view/id/37/category/6', 1, NULL, NULL, 6, 37),
(17158, 4, 'product/37/9', 'women/shapewear/simple-product-01.html', 'catalog/product/view/id/37/category/9', 1, NULL, NULL, 9, 37),
(17159, 4, 'product/37/19', 'tv-audio/bicycle/simple-product-01.html', 'catalog/product/view/id/37/category/19', 1, NULL, NULL, 19, 37),
(17160, 4, 'product/37/33', 'women/bags/simple-product-01.html', 'catalog/product/view/id/37/category/33', 1, NULL, NULL, 33, 37),
(17161, 4, 'product/37/41', 'accessories-17/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/41', 1, NULL, NULL, 41, 37),
(17162, 4, 'product/37/42', 'cameras-photography/simple-product-01.html', 'catalog/product/view/id/37/category/42', 1, NULL, NULL, 42, 37),
(17163, 4, 'product/37/43', 'tv-audio/simple-product-01.html', 'catalog/product/view/id/37/category/43', 1, NULL, NULL, 43, 37),
(17164, 4, 'product/37/44', 'laptops-computers/simple-product-01.html', 'catalog/product/view/id/37/category/44', 1, NULL, NULL, 44, 37),
(17165, 4, 'product/37/45', 'smart-phones-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/45', 1, NULL, NULL, 45, 37),
(17166, 4, 'product/37/46', 'video-games-consoles/simple-product-01.html', 'catalog/product/view/id/37/category/46', 1, NULL, NULL, 46, 37),
(17167, 4, 'product/37/47', 'gadgets/simple-product-01.html', 'catalog/product/view/id/37/category/47', 1, NULL, NULL, 47, 37),
(17168, 4, 'product/37/48', 'car-electronics-gps/simple-product-01.html', 'catalog/product/view/id/37/category/48', 1, NULL, NULL, 48, 37),
(17169, 4, 'product/37/49', 'laptop/simple-product-01.html', 'catalog/product/view/id/37/category/49', 1, NULL, NULL, 49, 37),
(17170, 4, 'product/37/50', 'accessories/simple-product-01.html', 'catalog/product/view/id/37/category/50', 1, NULL, NULL, 50, 37),
(17171, 4, 'product/37/55', 'casio-watches/simple-product-01.html', 'catalog/product/view/id/37/category/55', 1, NULL, NULL, 55, 37),
(17172, 4, 'product/37/56', 'asus-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/56', 1, NULL, NULL, 56, 37),
(17173, 4, 'product/37/57', 'women-fashion/simple-product-01.html', 'catalog/product/view/id/37/category/57', 1, NULL, NULL, 57, 37),
(17174, 4, 'product/38', 'simple-product-02.html', 'catalog/product/view/id/38', 1, NULL, NULL, NULL, 38),
(17175, 4, 'product/38/3', 'men/simple-product-02.html', 'catalog/product/view/id/38/category/3', 1, NULL, NULL, 3, 38),
(17176, 4, 'product/38/4', 'women/simple-product-02.html', 'catalog/product/view/id/38/category/4', 1, NULL, NULL, 4, 38),
(17177, 4, 'product/38/5', 'kid/simple-product-02.html', 'catalog/product/view/id/38/category/5', 1, NULL, NULL, 5, 38),
(17178, 4, 'product/38/6', 'accessories-17/simple-product-02.html', 'catalog/product/view/id/38/category/6', 1, NULL, NULL, 6, 38),
(17179, 4, 'product/38/9', 'women/shapewear/simple-product-02.html', 'catalog/product/view/id/38/category/9', 1, NULL, NULL, 9, 38),
(17180, 4, 'product/38/19', 'tv-audio/bicycle/simple-product-02.html', 'catalog/product/view/id/38/category/19', 1, NULL, NULL, 19, 38),
(17181, 4, 'product/38/33', 'women/bags/simple-product-02.html', 'catalog/product/view/id/38/category/33', 1, NULL, NULL, 33, 38),
(17182, 4, 'product/38/42', 'cameras-photography/simple-product-02.html', 'catalog/product/view/id/38/category/42', 1, NULL, NULL, 42, 38),
(17183, 4, 'product/38/43', 'tv-audio/simple-product-02.html', 'catalog/product/view/id/38/category/43', 1, NULL, NULL, 43, 38),
(17184, 4, 'product/38/44', 'laptops-computers/simple-product-02.html', 'catalog/product/view/id/38/category/44', 1, NULL, NULL, 44, 38),
(17185, 4, 'product/38/45', 'smart-phones-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/45', 1, NULL, NULL, 45, 38),
(17186, 4, 'product/38/46', 'video-games-consoles/simple-product-02.html', 'catalog/product/view/id/38/category/46', 1, NULL, NULL, 46, 38),
(17187, 4, 'product/38/47', 'gadgets/simple-product-02.html', 'catalog/product/view/id/38/category/47', 1, NULL, NULL, 47, 38),
(17188, 4, 'product/38/48', 'car-electronics-gps/simple-product-02.html', 'catalog/product/view/id/38/category/48', 1, NULL, NULL, 48, 38),
(17189, 4, 'product/38/49', 'laptop/simple-product-02.html', 'catalog/product/view/id/38/category/49', 1, NULL, NULL, 49, 38),
(17190, 4, 'product/38/50', 'accessories/simple-product-02.html', 'catalog/product/view/id/38/category/50', 1, NULL, NULL, 50, 38),
(17191, 4, 'product/38/55', 'casio-watches/simple-product-02.html', 'catalog/product/view/id/38/category/55', 1, NULL, NULL, 55, 38),
(17192, 4, 'product/38/56', 'asus-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/56', 1, NULL, NULL, 56, 38),
(17193, 4, 'product/38/57', 'women-fashion/simple-product-02.html', 'catalog/product/view/id/38/category/57', 1, NULL, NULL, 57, 38),
(17194, 4, 'product/39', 'simple-product-03.html', 'catalog/product/view/id/39', 1, NULL, NULL, NULL, 39),
(17195, 4, 'product/39/3', 'men/simple-product-03.html', 'catalog/product/view/id/39/category/3', 1, NULL, NULL, 3, 39),
(17196, 4, 'product/39/4', 'women/simple-product-03.html', 'catalog/product/view/id/39/category/4', 1, NULL, NULL, 4, 39),
(17197, 4, 'product/39/5', 'kid/simple-product-03.html', 'catalog/product/view/id/39/category/5', 1, NULL, NULL, 5, 39),
(17198, 4, 'product/39/6', 'accessories-17/simple-product-03.html', 'catalog/product/view/id/39/category/6', 1, NULL, NULL, 6, 39),
(17199, 4, 'product/39/9', 'women/shapewear/simple-product-03.html', 'catalog/product/view/id/39/category/9', 1, NULL, NULL, 9, 39),
(17200, 4, 'product/39/19', 'tv-audio/bicycle/simple-product-03.html', 'catalog/product/view/id/39/category/19', 1, NULL, NULL, 19, 39),
(17201, 4, 'product/39/33', 'women/bags/simple-product-03.html', 'catalog/product/view/id/39/category/33', 1, NULL, NULL, 33, 39),
(17202, 4, 'product/39/42', 'cameras-photography/simple-product-03.html', 'catalog/product/view/id/39/category/42', 1, NULL, NULL, 42, 39),
(17203, 4, 'product/39/43', 'tv-audio/simple-product-03.html', 'catalog/product/view/id/39/category/43', 1, NULL, NULL, 43, 39),
(17204, 4, 'product/39/44', 'laptops-computers/simple-product-03.html', 'catalog/product/view/id/39/category/44', 1, NULL, NULL, 44, 39),
(17205, 4, 'product/39/45', 'smart-phones-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/45', 1, NULL, NULL, 45, 39),
(17206, 4, 'product/39/46', 'video-games-consoles/simple-product-03.html', 'catalog/product/view/id/39/category/46', 1, NULL, NULL, 46, 39),
(17207, 4, 'product/39/47', 'gadgets/simple-product-03.html', 'catalog/product/view/id/39/category/47', 1, NULL, NULL, 47, 39),
(17208, 4, 'product/39/48', 'car-electronics-gps/simple-product-03.html', 'catalog/product/view/id/39/category/48', 1, NULL, NULL, 48, 39),
(17209, 4, 'product/39/49', 'laptop/simple-product-03.html', 'catalog/product/view/id/39/category/49', 1, NULL, NULL, 49, 39),
(17210, 4, 'product/39/50', 'accessories/simple-product-03.html', 'catalog/product/view/id/39/category/50', 1, NULL, NULL, 50, 39),
(17211, 4, 'product/39/55', 'casio-watches/simple-product-03.html', 'catalog/product/view/id/39/category/55', 1, NULL, NULL, 55, 39),
(17212, 4, 'product/39/56', 'asus-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/56', 1, NULL, NULL, 56, 39),
(17213, 4, 'product/39/57', 'women-fashion/simple-product-03.html', 'catalog/product/view/id/39/category/57', 1, NULL, NULL, 57, 39),
(17214, 4, 'product/40', 'simple-product-04.html', 'catalog/product/view/id/40', 1, NULL, NULL, NULL, 40),
(17215, 4, 'product/40/3', 'men/simple-product-04.html', 'catalog/product/view/id/40/category/3', 1, NULL, NULL, 3, 40),
(17216, 4, 'product/40/4', 'women/simple-product-04.html', 'catalog/product/view/id/40/category/4', 1, NULL, NULL, 4, 40),
(17217, 4, 'product/40/5', 'kid/simple-product-04.html', 'catalog/product/view/id/40/category/5', 1, NULL, NULL, 5, 40),
(17218, 4, 'product/40/6', 'accessories-17/simple-product-04.html', 'catalog/product/view/id/40/category/6', 1, NULL, NULL, 6, 40),
(17219, 4, 'product/40/9', 'women/shapewear/simple-product-04.html', 'catalog/product/view/id/40/category/9', 1, NULL, NULL, 9, 40),
(17220, 4, 'product/40/19', 'tv-audio/bicycle/simple-product-04.html', 'catalog/product/view/id/40/category/19', 1, NULL, NULL, 19, 40),
(17221, 4, 'product/40/33', 'women/bags/simple-product-04.html', 'catalog/product/view/id/40/category/33', 1, NULL, NULL, 33, 40),
(17222, 4, 'product/40/42', 'cameras-photography/simple-product-04.html', 'catalog/product/view/id/40/category/42', 1, NULL, NULL, 42, 40),
(17223, 4, 'product/40/43', 'tv-audio/simple-product-04.html', 'catalog/product/view/id/40/category/43', 1, NULL, NULL, 43, 40),
(17224, 4, 'product/40/44', 'laptops-computers/simple-product-04.html', 'catalog/product/view/id/40/category/44', 1, NULL, NULL, 44, 40),
(17225, 4, 'product/40/45', 'smart-phones-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/45', 1, NULL, NULL, 45, 40),
(17226, 4, 'product/40/46', 'video-games-consoles/simple-product-04.html', 'catalog/product/view/id/40/category/46', 1, NULL, NULL, 46, 40),
(17227, 4, 'product/40/47', 'gadgets/simple-product-04.html', 'catalog/product/view/id/40/category/47', 1, NULL, NULL, 47, 40),
(17228, 4, 'product/40/48', 'car-electronics-gps/simple-product-04.html', 'catalog/product/view/id/40/category/48', 1, NULL, NULL, 48, 40),
(17229, 4, 'product/40/49', 'laptop/simple-product-04.html', 'catalog/product/view/id/40/category/49', 1, NULL, NULL, 49, 40),
(17230, 4, 'product/40/50', 'accessories/simple-product-04.html', 'catalog/product/view/id/40/category/50', 1, NULL, NULL, 50, 40),
(17231, 4, 'product/40/55', 'casio-watches/simple-product-04.html', 'catalog/product/view/id/40/category/55', 1, NULL, NULL, 55, 40),
(17232, 4, 'product/40/56', 'asus-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/56', 1, NULL, NULL, 56, 40),
(17233, 4, 'product/40/57', 'women-fashion/simple-product-04.html', 'catalog/product/view/id/40/category/57', 1, NULL, NULL, 57, 40),
(17234, 4, 'product/41', 'simple-product-05.html', 'catalog/product/view/id/41', 1, NULL, NULL, NULL, 41),
(17235, 4, 'product/41/3', 'men/simple-product-05.html', 'catalog/product/view/id/41/category/3', 1, NULL, NULL, 3, 41),
(17236, 4, 'product/41/4', 'women/simple-product-05.html', 'catalog/product/view/id/41/category/4', 1, NULL, NULL, 4, 41),
(17237, 4, 'product/41/5', 'kid/simple-product-05.html', 'catalog/product/view/id/41/category/5', 1, NULL, NULL, 5, 41),
(17238, 4, 'product/41/6', 'accessories-17/simple-product-05.html', 'catalog/product/view/id/41/category/6', 1, NULL, NULL, 6, 41),
(17239, 4, 'product/41/9', 'women/shapewear/simple-product-05.html', 'catalog/product/view/id/41/category/9', 1, NULL, NULL, 9, 41),
(17240, 4, 'product/41/19', 'tv-audio/bicycle/simple-product-05.html', 'catalog/product/view/id/41/category/19', 1, NULL, NULL, 19, 41),
(17241, 4, 'product/41/33', 'women/bags/simple-product-05.html', 'catalog/product/view/id/41/category/33', 1, NULL, NULL, 33, 41),
(17242, 4, 'product/41/42', 'cameras-photography/simple-product-05.html', 'catalog/product/view/id/41/category/42', 1, NULL, NULL, 42, 41),
(17243, 4, 'product/41/43', 'tv-audio/simple-product-05.html', 'catalog/product/view/id/41/category/43', 1, NULL, NULL, 43, 41),
(17244, 4, 'product/41/44', 'laptops-computers/simple-product-05.html', 'catalog/product/view/id/41/category/44', 1, NULL, NULL, 44, 41),
(17245, 4, 'product/41/45', 'smart-phones-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/45', 1, NULL, NULL, 45, 41),
(17246, 4, 'product/41/46', 'video-games-consoles/simple-product-05.html', 'catalog/product/view/id/41/category/46', 1, NULL, NULL, 46, 41),
(17247, 4, 'product/41/47', 'gadgets/simple-product-05.html', 'catalog/product/view/id/41/category/47', 1, NULL, NULL, 47, 41),
(17248, 4, 'product/41/48', 'car-electronics-gps/simple-product-05.html', 'catalog/product/view/id/41/category/48', 1, NULL, NULL, 48, 41),
(17249, 4, 'product/41/49', 'laptop/simple-product-05.html', 'catalog/product/view/id/41/category/49', 1, NULL, NULL, 49, 41),
(17250, 4, 'product/41/50', 'accessories/simple-product-05.html', 'catalog/product/view/id/41/category/50', 1, NULL, NULL, 50, 41),
(17251, 4, 'product/41/55', 'casio-watches/simple-product-05.html', 'catalog/product/view/id/41/category/55', 1, NULL, NULL, 55, 41),
(17252, 4, 'product/41/56', 'asus-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/56', 1, NULL, NULL, 56, 41),
(17253, 4, 'product/41/57', 'women-fashion/simple-product-05.html', 'catalog/product/view/id/41/category/57', 1, NULL, NULL, 57, 41),
(17254, 4, 'product/42', 'grouped-product.html', 'catalog/product/view/id/42', 1, NULL, NULL, NULL, 42),
(17255, 4, 'product/42/3', 'men/grouped-product.html', 'catalog/product/view/id/42/category/3', 1, NULL, NULL, 3, 42),
(17256, 4, 'product/42/4', 'women/grouped-product.html', 'catalog/product/view/id/42/category/4', 1, NULL, NULL, 4, 42),
(17257, 4, 'product/42/5', 'kid/grouped-product.html', 'catalog/product/view/id/42/category/5', 1, NULL, NULL, 5, 42),
(17258, 4, 'product/42/6', 'accessories-17/grouped-product.html', 'catalog/product/view/id/42/category/6', 1, NULL, NULL, 6, 42),
(17259, 4, 'product/42/9', 'women/shapewear/grouped-product.html', 'catalog/product/view/id/42/category/9', 1, NULL, NULL, 9, 42),
(17260, 4, 'product/42/19', 'tv-audio/bicycle/grouped-product.html', 'catalog/product/view/id/42/category/19', 1, NULL, NULL, 19, 42),
(17261, 4, 'product/42/33', 'women/bags/grouped-product.html', 'catalog/product/view/id/42/category/33', 1, NULL, NULL, 33, 42),
(17262, 4, 'product/42/41', 'accessories-17/product-types/grouped-product.html', 'catalog/product/view/id/42/category/41', 1, NULL, NULL, 41, 42),
(17263, 4, 'product/42/42', 'cameras-photography/grouped-product.html', 'catalog/product/view/id/42/category/42', 1, NULL, NULL, 42, 42),
(17264, 4, 'product/42/43', 'tv-audio/grouped-product.html', 'catalog/product/view/id/42/category/43', 1, NULL, NULL, 43, 42),
(17265, 4, 'product/42/44', 'laptops-computers/grouped-product.html', 'catalog/product/view/id/42/category/44', 1, NULL, NULL, 44, 42),
(17266, 4, 'product/42/45', 'smart-phones-tablets/grouped-product.html', 'catalog/product/view/id/42/category/45', 1, NULL, NULL, 45, 42),
(17267, 4, 'product/42/46', 'video-games-consoles/grouped-product.html', 'catalog/product/view/id/42/category/46', 1, NULL, NULL, 46, 42),
(17268, 4, 'product/42/47', 'gadgets/grouped-product.html', 'catalog/product/view/id/42/category/47', 1, NULL, NULL, 47, 42),
(17269, 4, 'product/42/48', 'car-electronics-gps/grouped-product.html', 'catalog/product/view/id/42/category/48', 1, NULL, NULL, 48, 42),
(17270, 4, 'product/42/49', 'laptop/grouped-product.html', 'catalog/product/view/id/42/category/49', 1, NULL, NULL, 49, 42),
(17271, 4, 'product/42/50', 'accessories/grouped-product.html', 'catalog/product/view/id/42/category/50', 1, NULL, NULL, 50, 42),
(17272, 4, 'product/42/55', 'casio-watches/grouped-product.html', 'catalog/product/view/id/42/category/55', 1, NULL, NULL, 55, 42),
(17273, 4, 'product/42/56', 'asus-tablets/grouped-product.html', 'catalog/product/view/id/42/category/56', 1, NULL, NULL, 56, 42),
(17274, 4, 'product/42/57', 'women-fashion/grouped-product.html', 'catalog/product/view/id/42/category/57', 1, NULL, NULL, 57, 42),
(17296, 4, 'product/44', 'bundle-product.html', 'catalog/product/view/id/44', 1, NULL, NULL, NULL, 44),
(17297, 4, 'product/44/3', 'men/bundle-product.html', 'catalog/product/view/id/44/category/3', 1, NULL, NULL, 3, 44),
(17298, 4, 'product/44/4', 'women/bundle-product.html', 'catalog/product/view/id/44/category/4', 1, NULL, NULL, 4, 44),
(17299, 4, 'product/44/5', 'kid/bundle-product.html', 'catalog/product/view/id/44/category/5', 1, NULL, NULL, 5, 44);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(17300, 4, 'product/44/6', 'accessories-17/bundle-product.html', 'catalog/product/view/id/44/category/6', 1, NULL, NULL, 6, 44),
(17301, 4, 'product/44/9', 'women/shapewear/bundle-product.html', 'catalog/product/view/id/44/category/9', 1, NULL, NULL, 9, 44),
(17302, 4, 'product/44/19', 'tv-audio/bicycle/bundle-product.html', 'catalog/product/view/id/44/category/19', 1, NULL, NULL, 19, 44),
(17303, 4, 'product/44/33', 'women/bags/bundle-product.html', 'catalog/product/view/id/44/category/33', 1, NULL, NULL, 33, 44),
(17304, 4, 'product/44/41', 'accessories-17/product-types/bundle-product.html', 'catalog/product/view/id/44/category/41', 1, NULL, NULL, 41, 44),
(17305, 4, 'product/44/42', 'cameras-photography/bundle-product.html', 'catalog/product/view/id/44/category/42', 1, NULL, NULL, 42, 44),
(17306, 4, 'product/44/43', 'tv-audio/bundle-product.html', 'catalog/product/view/id/44/category/43', 1, NULL, NULL, 43, 44),
(17307, 4, 'product/44/44', 'laptops-computers/bundle-product.html', 'catalog/product/view/id/44/category/44', 1, NULL, NULL, 44, 44),
(17308, 4, 'product/44/45', 'smart-phones-tablets/bundle-product.html', 'catalog/product/view/id/44/category/45', 1, NULL, NULL, 45, 44),
(17309, 4, 'product/44/46', 'video-games-consoles/bundle-product.html', 'catalog/product/view/id/44/category/46', 1, NULL, NULL, 46, 44),
(17310, 4, 'product/44/47', 'gadgets/bundle-product.html', 'catalog/product/view/id/44/category/47', 1, NULL, NULL, 47, 44),
(17311, 4, 'product/44/48', 'car-electronics-gps/bundle-product.html', 'catalog/product/view/id/44/category/48', 1, NULL, NULL, 48, 44),
(17312, 4, 'product/44/49', 'laptop/bundle-product.html', 'catalog/product/view/id/44/category/49', 1, NULL, NULL, 49, 44),
(17313, 4, 'product/44/50', 'accessories/bundle-product.html', 'catalog/product/view/id/44/category/50', 1, NULL, NULL, 50, 44),
(17314, 4, 'product/44/55', 'casio-watches/bundle-product.html', 'catalog/product/view/id/44/category/55', 1, NULL, NULL, 55, 44),
(17315, 4, 'product/44/56', 'asus-tablets/bundle-product.html', 'catalog/product/view/id/44/category/56', 1, NULL, NULL, 56, 44),
(17316, 4, 'product/44/57', 'women-fashion/bundle-product.html', 'catalog/product/view/id/44/category/57', 1, NULL, NULL, 57, 44),
(17317, 4, 'product/45', 'bundle-product-02.html', 'catalog/product/view/id/45', 1, NULL, NULL, NULL, 45),
(17318, 4, 'product/45/3', 'men/bundle-product-02.html', 'catalog/product/view/id/45/category/3', 1, NULL, NULL, 3, 45),
(17319, 4, 'product/45/4', 'women/bundle-product-02.html', 'catalog/product/view/id/45/category/4', 1, NULL, NULL, 4, 45),
(17320, 4, 'product/45/5', 'kid/bundle-product-02.html', 'catalog/product/view/id/45/category/5', 1, NULL, NULL, 5, 45),
(17321, 4, 'product/45/6', 'accessories-17/bundle-product-02.html', 'catalog/product/view/id/45/category/6', 1, NULL, NULL, 6, 45),
(17322, 4, 'product/45/9', 'women/shapewear/bundle-product-02.html', 'catalog/product/view/id/45/category/9', 1, NULL, NULL, 9, 45),
(17323, 4, 'product/45/19', 'tv-audio/bicycle/bundle-product-02.html', 'catalog/product/view/id/45/category/19', 1, NULL, NULL, 19, 45),
(17324, 4, 'product/45/33', 'women/bags/bundle-product-02.html', 'catalog/product/view/id/45/category/33', 1, NULL, NULL, 33, 45),
(17325, 4, 'product/45/41', 'accessories-17/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/41', 1, NULL, NULL, 41, 45),
(17326, 4, 'product/45/42', 'cameras-photography/bundle-product-02.html', 'catalog/product/view/id/45/category/42', 1, NULL, NULL, 42, 45),
(17327, 4, 'product/45/43', 'tv-audio/bundle-product-02.html', 'catalog/product/view/id/45/category/43', 1, NULL, NULL, 43, 45),
(17328, 4, 'product/45/44', 'laptops-computers/bundle-product-02.html', 'catalog/product/view/id/45/category/44', 1, NULL, NULL, 44, 45),
(17329, 4, 'product/45/45', 'smart-phones-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/45', 1, NULL, NULL, 45, 45),
(17330, 4, 'product/45/46', 'video-games-consoles/bundle-product-02.html', 'catalog/product/view/id/45/category/46', 1, NULL, NULL, 46, 45),
(17331, 4, 'product/45/47', 'gadgets/bundle-product-02.html', 'catalog/product/view/id/45/category/47', 1, NULL, NULL, 47, 45),
(17332, 4, 'product/45/48', 'car-electronics-gps/bundle-product-02.html', 'catalog/product/view/id/45/category/48', 1, NULL, NULL, 48, 45),
(17333, 4, 'product/45/49', 'laptop/bundle-product-02.html', 'catalog/product/view/id/45/category/49', 1, NULL, NULL, 49, 45),
(17334, 4, 'product/45/50', 'accessories/bundle-product-02.html', 'catalog/product/view/id/45/category/50', 1, NULL, NULL, 50, 45),
(17335, 4, 'product/45/55', 'casio-watches/bundle-product-02.html', 'catalog/product/view/id/45/category/55', 1, NULL, NULL, 55, 45),
(17336, 4, 'product/45/56', 'asus-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/56', 1, NULL, NULL, 56, 45),
(17337, 4, 'product/45/57', 'women-fashion/bundle-product-02.html', 'catalog/product/view/id/45/category/57', 1, NULL, NULL, 57, 45),
(17338, 4, 'product/46', 'downloadable-product.html', 'catalog/product/view/id/46', 1, NULL, NULL, NULL, 46),
(17339, 4, 'product/46/3', 'men/downloadable-product.html', 'catalog/product/view/id/46/category/3', 1, NULL, NULL, 3, 46),
(17340, 4, 'product/46/4', 'women/downloadable-product.html', 'catalog/product/view/id/46/category/4', 1, NULL, NULL, 4, 46),
(17341, 4, 'product/46/5', 'kid/downloadable-product.html', 'catalog/product/view/id/46/category/5', 1, NULL, NULL, 5, 46),
(17342, 4, 'product/46/6', 'accessories-17/downloadable-product.html', 'catalog/product/view/id/46/category/6', 1, NULL, NULL, 6, 46),
(17343, 4, 'product/46/9', 'women/shapewear/downloadable-product.html', 'catalog/product/view/id/46/category/9', 1, NULL, NULL, 9, 46),
(17344, 4, 'product/46/19', 'tv-audio/bicycle/downloadable-product.html', 'catalog/product/view/id/46/category/19', 1, NULL, NULL, 19, 46),
(17345, 4, 'product/46/33', 'women/bags/downloadable-product.html', 'catalog/product/view/id/46/category/33', 1, NULL, NULL, 33, 46),
(17346, 4, 'product/46/41', 'accessories-17/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/41', 1, NULL, NULL, 41, 46),
(17347, 4, 'product/46/42', 'cameras-photography/downloadable-product.html', 'catalog/product/view/id/46/category/42', 1, NULL, NULL, 42, 46),
(17348, 4, 'product/46/43', 'tv-audio/downloadable-product.html', 'catalog/product/view/id/46/category/43', 1, NULL, NULL, 43, 46),
(17349, 4, 'product/46/44', 'laptops-computers/downloadable-product.html', 'catalog/product/view/id/46/category/44', 1, NULL, NULL, 44, 46),
(17350, 4, 'product/46/45', 'smart-phones-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/45', 1, NULL, NULL, 45, 46),
(17351, 4, 'product/46/46', 'video-games-consoles/downloadable-product.html', 'catalog/product/view/id/46/category/46', 1, NULL, NULL, 46, 46),
(17352, 4, 'product/46/47', 'gadgets/downloadable-product.html', 'catalog/product/view/id/46/category/47', 1, NULL, NULL, 47, 46),
(17353, 4, 'product/46/48', 'car-electronics-gps/downloadable-product.html', 'catalog/product/view/id/46/category/48', 1, NULL, NULL, 48, 46),
(17354, 4, 'product/46/49', 'laptop/downloadable-product.html', 'catalog/product/view/id/46/category/49', 1, NULL, NULL, 49, 46),
(17355, 4, 'product/46/50', 'accessories/downloadable-product.html', 'catalog/product/view/id/46/category/50', 1, NULL, NULL, 50, 46),
(17356, 4, 'product/46/55', 'casio-watches/downloadable-product.html', 'catalog/product/view/id/46/category/55', 1, NULL, NULL, 55, 46),
(17357, 4, 'product/46/56', 'asus-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/56', 1, NULL, NULL, 56, 46),
(17358, 4, 'product/46/57', 'women-fashion/downloadable-product.html', 'catalog/product/view/id/46/category/57', 1, NULL, NULL, 57, 46),
(17359, 4, 'product/47', 'no-image.html', 'catalog/product/view/id/47', 1, NULL, NULL, NULL, 47),
(17360, 4, 'product/47/3', 'men/no-image.html', 'catalog/product/view/id/47/category/3', 1, NULL, NULL, 3, 47),
(17361, 4, 'product/47/4', 'women/no-image.html', 'catalog/product/view/id/47/category/4', 1, NULL, NULL, 4, 47),
(17362, 4, 'product/47/6', 'accessories-17/no-image.html', 'catalog/product/view/id/47/category/6', 1, NULL, NULL, 6, 47),
(17363, 4, 'product/47/9', 'women/shapewear/no-image.html', 'catalog/product/view/id/47/category/9', 1, NULL, NULL, 9, 47),
(17364, 4, 'product/47/19', 'tv-audio/bicycle/no-image.html', 'catalog/product/view/id/47/category/19', 1, NULL, NULL, 19, 47),
(17365, 4, 'product/47/33', 'women/bags/no-image.html', 'catalog/product/view/id/47/category/33', 1, NULL, NULL, 33, 47),
(17366, 4, 'product/47/41', 'accessories-17/product-types/no-image.html', 'catalog/product/view/id/47/category/41', 1, NULL, NULL, 41, 47),
(17367, 4, 'product/47/42', 'cameras-photography/no-image.html', 'catalog/product/view/id/47/category/42', 1, NULL, NULL, 42, 47),
(17368, 4, 'product/47/43', 'tv-audio/no-image.html', 'catalog/product/view/id/47/category/43', 1, NULL, NULL, 43, 47),
(17369, 4, 'product/47/44', 'laptops-computers/no-image.html', 'catalog/product/view/id/47/category/44', 1, NULL, NULL, 44, 47),
(17370, 4, 'product/47/45', 'smart-phones-tablets/no-image.html', 'catalog/product/view/id/47/category/45', 1, NULL, NULL, 45, 47),
(17371, 4, 'product/47/46', 'video-games-consoles/no-image.html', 'catalog/product/view/id/47/category/46', 1, NULL, NULL, 46, 47),
(17372, 4, 'product/47/47', 'gadgets/no-image.html', 'catalog/product/view/id/47/category/47', 1, NULL, NULL, 47, 47),
(17373, 4, 'product/47/48', 'car-electronics-gps/no-image.html', 'catalog/product/view/id/47/category/48', 1, NULL, NULL, 48, 47),
(17374, 4, 'product/47/49', 'laptop/no-image.html', 'catalog/product/view/id/47/category/49', 1, NULL, NULL, 49, 47),
(17375, 4, 'product/47/50', 'accessories/no-image.html', 'catalog/product/view/id/47/category/50', 1, NULL, NULL, 50, 47),
(17376, 4, 'product/47/55', 'casio-watches/no-image.html', 'catalog/product/view/id/47/category/55', 1, NULL, NULL, 55, 47),
(17377, 4, 'product/47/56', 'asus-tablets/no-image.html', 'catalog/product/view/id/47/category/56', 1, NULL, NULL, 56, 47),
(17378, 4, 'product/47/57', 'women-fashion/no-image.html', 'catalog/product/view/id/47/category/57', 1, NULL, NULL, 57, 47),
(17379, 4, 'product/48', 'custom-option.html', 'catalog/product/view/id/48', 1, NULL, NULL, NULL, 48),
(17380, 4, 'product/48/3', 'men/custom-option.html', 'catalog/product/view/id/48/category/3', 1, NULL, NULL, 3, 48),
(17381, 4, 'product/48/4', 'women/custom-option.html', 'catalog/product/view/id/48/category/4', 1, NULL, NULL, 4, 48),
(17382, 4, 'product/48/6', 'accessories-17/custom-option.html', 'catalog/product/view/id/48/category/6', 1, NULL, NULL, 6, 48),
(17383, 4, 'product/48/9', 'women/shapewear/custom-option.html', 'catalog/product/view/id/48/category/9', 1, NULL, NULL, 9, 48),
(17384, 4, 'product/48/19', 'tv-audio/bicycle/custom-option.html', 'catalog/product/view/id/48/category/19', 1, NULL, NULL, 19, 48),
(17385, 4, 'product/48/20', 'tv-audio/bicycle/jackets/custom-option.html', 'catalog/product/view/id/48/category/20', 1, NULL, NULL, 20, 48),
(17386, 4, 'product/48/24', 'tv-audio/bicycle/scarves/custom-option.html', 'catalog/product/view/id/48/category/24', 1, NULL, NULL, 24, 48),
(17387, 4, 'product/48/25', 'tv-audio/bicycle/lifestyle/custom-option.html', 'catalog/product/view/id/48/category/25', 1, NULL, NULL, 25, 48),
(17388, 4, 'product/48/26', 'accessories-17/bras/custom-option.html', 'catalog/product/view/id/48/category/26', 1, NULL, NULL, 26, 48),
(17389, 4, 'product/48/28', 'accessories-17/cosmetics/custom-option.html', 'catalog/product/view/id/48/category/28', 1, NULL, NULL, 28, 48),
(17390, 4, 'product/48/33', 'women/bags/custom-option.html', 'catalog/product/view/id/48/category/33', 1, NULL, NULL, 33, 48),
(17391, 4, 'product/48/40', 'accessories-17/cfg-products/custom-option.html', 'catalog/product/view/id/48/category/40', 1, NULL, NULL, 40, 48),
(17392, 4, 'product/48/41', 'accessories-17/product-types/custom-option.html', 'catalog/product/view/id/48/category/41', 1, NULL, NULL, 41, 48),
(17393, 4, 'product/48/42', 'cameras-photography/custom-option.html', 'catalog/product/view/id/48/category/42', 1, NULL, NULL, 42, 48),
(17394, 4, 'product/48/43', 'tv-audio/custom-option.html', 'catalog/product/view/id/48/category/43', 1, NULL, NULL, 43, 48),
(17395, 4, 'product/48/44', 'laptops-computers/custom-option.html', 'catalog/product/view/id/48/category/44', 1, NULL, NULL, 44, 48),
(17396, 4, 'product/48/45', 'smart-phones-tablets/custom-option.html', 'catalog/product/view/id/48/category/45', 1, NULL, NULL, 45, 48),
(17397, 4, 'product/48/46', 'video-games-consoles/custom-option.html', 'catalog/product/view/id/48/category/46', 1, NULL, NULL, 46, 48),
(17398, 4, 'product/48/47', 'gadgets/custom-option.html', 'catalog/product/view/id/48/category/47', 1, NULL, NULL, 47, 48),
(17399, 4, 'product/48/48', 'car-electronics-gps/custom-option.html', 'catalog/product/view/id/48/category/48', 1, NULL, NULL, 48, 48),
(17400, 4, 'product/48/49', 'laptop/custom-option.html', 'catalog/product/view/id/48/category/49', 1, NULL, NULL, 49, 48),
(17401, 4, 'product/48/50', 'accessories/custom-option.html', 'catalog/product/view/id/48/category/50', 1, NULL, NULL, 50, 48),
(17402, 4, 'product/48/55', 'casio-watches/custom-option.html', 'catalog/product/view/id/48/category/55', 1, NULL, NULL, 55, 48),
(17403, 4, 'product/48/56', 'asus-tablets/custom-option.html', 'catalog/product/view/id/48/category/56', 1, NULL, NULL, 56, 48),
(17404, 4, 'product/48/57', 'women-fashion/custom-option.html', 'catalog/product/view/id/48/category/57', 1, NULL, NULL, 57, 48),
(17405, 5, 'category/3', 'men.html', 'catalog/category/view/id/3', 1, NULL, NULL, 3, NULL),
(17406, 5, 'category/4', 'women.html', 'catalog/category/view/id/4', 1, NULL, NULL, 4, NULL),
(17407, 5, 'category/33', 'women/bags.html', 'catalog/category/view/id/33', 1, NULL, NULL, 33, NULL),
(17408, 5, 'category/18', 'women/bags/bands.html', 'catalog/category/view/id/18', 1, NULL, NULL, 18, NULL),
(17409, 5, 'category/23', 'women/bags/blog.html', 'catalog/category/view/id/23', 1, NULL, NULL, 23, NULL),
(17410, 5, 'category/34', 'women/bags/nightwear.html', 'catalog/category/view/id/34', 1, NULL, NULL, 34, NULL),
(17411, 5, 'category/35', 'women/bags/briefs.html', 'catalog/category/view/id/35', 1, NULL, NULL, 35, NULL),
(17412, 5, 'category/36', 'women/bags/duffle.html', 'catalog/category/view/id/36', 1, NULL, NULL, 36, NULL),
(17413, 5, 'category/37', 'women/bags/dresses.html', 'catalog/category/view/id/37', 1, NULL, NULL, 37, NULL),
(17414, 5, 'category/38', 'women/bags/laptop.html', 'catalog/category/view/id/38', 1, NULL, NULL, 38, NULL),
(17415, 5, 'category/39', 'women/bags/cosmetic.html', 'catalog/category/view/id/39', 1, NULL, NULL, 39, NULL),
(17416, 5, 'category/8', 'women/bags/shoes.html', 'catalog/category/view/id/8', 1, NULL, NULL, 8, NULL),
(17417, 5, 'category/15', 'women/bags/shoes/gloves.html', 'catalog/category/view/id/15', 1, NULL, NULL, 15, NULL),
(17418, 5, 'category/16', 'women/bags/shoes/leathers.html', 'catalog/category/view/id/16', 1, NULL, NULL, 16, NULL),
(17419, 5, 'category/17', 'women/bags/shoes/cocktail.html', 'catalog/category/view/id/17', 1, NULL, NULL, 17, NULL),
(17420, 5, 'category/22', 'women/bags/shoes/clothing.html', 'catalog/category/view/id/22', 1, NULL, NULL, 22, NULL),
(17421, 5, 'category/31', 'women/bags/shoes/shirts.html', 'catalog/category/view/id/31', 1, NULL, NULL, 31, NULL),
(17422, 5, 'category/21', 'women/bags/shoes/shirts/hair.html', 'catalog/category/view/id/21', 1, NULL, NULL, 21, NULL),
(17423, 5, 'category/27', 'women/bags/shoes/shirts/helmet.html', 'catalog/category/view/id/27', 1, NULL, NULL, 27, NULL),
(17424, 5, 'category/29', 'women/bags/shoes/shirts/camis.html', 'catalog/category/view/id/29', 1, NULL, NULL, 29, NULL),
(17425, 5, 'category/30', 'women/bags/shoes/shirts/lingerie.html', 'catalog/category/view/id/30', 1, NULL, NULL, 30, NULL),
(17426, 5, 'category/32', 'women/bags/shoes/shirts/tops.html', 'catalog/category/view/id/32', 1, NULL, NULL, 32, NULL),
(17427, 5, 'category/7', 'women/bags/shoes/rings.html', 'catalog/category/view/id/7', 1, NULL, NULL, 7, NULL),
(17428, 5, 'category/9', 'women/shapewear.html', 'catalog/category/view/id/9', 1, NULL, NULL, 9, NULL),
(17429, 5, 'category/10', 'women/shapewear/sundresses.html', 'catalog/category/view/id/10', 1, NULL, NULL, 10, NULL),
(17430, 5, 'category/11', 'women/shapewear/footwear.html', 'catalog/category/view/id/11', 1, NULL, NULL, 11, NULL),
(17431, 5, 'category/12', 'women/shapewear/novelty.html', 'catalog/category/view/id/12', 1, NULL, NULL, 12, NULL),
(17432, 5, 'category/13', 'women/shapewear/outerwear.html', 'catalog/category/view/id/13', 1, NULL, NULL, 13, NULL),
(17433, 5, 'category/14', 'women/shapewear/hats.html', 'catalog/category/view/id/14', 1, NULL, NULL, 14, NULL),
(17434, 5, 'category/51', 'women/shapewear/salad-plates.html', 'catalog/category/view/id/51', 1, NULL, NULL, 51, NULL),
(17435, 5, 'category/52', 'women/shapewear/kitchen-storage.html', 'catalog/category/view/id/52', 1, NULL, NULL, 52, NULL),
(17436, 5, 'category/53', 'women/shapewear/dish-racks.html', 'catalog/category/view/id/53', 1, NULL, NULL, 53, NULL),
(17437, 5, 'category/54', 'women/shapewear/colanders.html', 'catalog/category/view/id/54', 1, NULL, NULL, 54, NULL),
(17438, 5, 'category/42', 'cameras-photography.html', 'catalog/category/view/id/42', 1, NULL, NULL, 42, NULL),
(17439, 5, 'category/43', 'tv-audio.html', 'catalog/category/view/id/43', 1, NULL, NULL, 43, NULL),
(17440, 5, 'category/44', 'laptops-computers.html', 'catalog/category/view/id/44', 1, NULL, NULL, 44, NULL),
(17441, 5, 'category/45', 'smart-phones-tablets.html', 'catalog/category/view/id/45', 1, NULL, NULL, 45, NULL),
(17442, 5, 'category/46', 'video-games-consoles.html', 'catalog/category/view/id/46', 1, NULL, NULL, 46, NULL),
(17443, 5, 'category/47', 'gadgets.html', 'catalog/category/view/id/47', 1, NULL, NULL, 47, NULL),
(17444, 5, 'category/48', 'car-electronics-gps.html', 'catalog/category/view/id/48', 1, NULL, NULL, 48, NULL),
(17445, 5, 'category/49', 'laptop.html', 'catalog/category/view/id/49', 1, NULL, NULL, 49, NULL),
(17446, 5, 'category/5', 'kid.html', 'catalog/category/view/id/5', 1, NULL, NULL, 5, NULL),
(17447, 5, 'category/50', 'accessories.html', 'catalog/category/view/id/50', 1, NULL, NULL, 50, NULL),
(17448, 5, 'category/55', 'casio-watches.html', 'catalog/category/view/id/55', 1, NULL, NULL, 55, NULL),
(17449, 5, 'category/56', 'asus-tablets.html', 'catalog/category/view/id/56', 1, NULL, NULL, 56, NULL),
(17450, 5, 'category/57', 'women-fashion.html', 'catalog/category/view/id/57', 1, NULL, NULL, 57, NULL),
(17451, 5, 'category/6', 'accessories-17.html', 'catalog/category/view/id/6', 1, NULL, NULL, 6, NULL),
(17452, 5, 'category/19', 'tv-audio/bicycle.html', 'catalog/category/view/id/19', 1, NULL, NULL, 19, NULL),
(17453, 5, 'category/20', 'tv-audio/bicycle/jackets.html', 'catalog/category/view/id/20', 1, NULL, NULL, 20, NULL),
(17454, 5, 'category/24', 'tv-audio/bicycle/scarves.html', 'catalog/category/view/id/24', 1, NULL, NULL, 24, NULL),
(17455, 5, 'category/25', 'tv-audio/bicycle/lifestyle.html', 'catalog/category/view/id/25', 1, NULL, NULL, 25, NULL),
(17456, 5, 'category/26', 'accessories-17/bras.html', 'catalog/category/view/id/26', 1, NULL, NULL, 26, NULL),
(17457, 5, 'category/28', 'accessories-17/cosmetics.html', 'catalog/category/view/id/28', 1, NULL, NULL, 28, NULL),
(17458, 5, 'category/40', 'accessories-17/cfg-products.html', 'catalog/category/view/id/40', 1, NULL, NULL, 40, NULL),
(17459, 5, 'category/41', 'accessories-17/product-types.html', 'catalog/category/view/id/41', 1, NULL, NULL, 41, NULL),
(17460, 5, 'product/7', 'configurable-product.html', 'catalog/product/view/id/7', 1, NULL, NULL, NULL, 7),
(17461, 5, 'product/7/3', 'men/configurable-product.html', 'catalog/product/view/id/7/category/3', 1, NULL, NULL, 3, 7),
(17462, 5, 'product/7/4', 'women/configurable-product.html', 'catalog/product/view/id/7/category/4', 1, NULL, NULL, 4, 7),
(17463, 5, 'product/7/40', 'accessories-17/cfg-products/configurable-product.html', 'catalog/product/view/id/7/category/40', 1, NULL, NULL, 40, 7),
(17464, 5, 'product/7/41', 'accessories-17/product-types/configurable-product.html', 'catalog/product/view/id/7/category/41', 1, NULL, NULL, 41, 7),
(17465, 5, 'product/8', 'configurable-product-armani-black.html', 'catalog/product/view/id/8', 1, NULL, NULL, NULL, 8),
(17466, 5, 'product/8/3', 'men/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/3', 1, NULL, NULL, 3, 8),
(17467, 5, 'product/8/4', 'women/configurable-product-armani-black.html', 'catalog/product/view/id/8/category/4', 1, NULL, NULL, 4, 8),
(17468, 5, 'product/9', 'configurable-product-armani-blue.html', 'catalog/product/view/id/9', 1, NULL, NULL, NULL, 9),
(17469, 5, 'product/9/3', 'men/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/3', 1, NULL, NULL, 3, 9),
(17470, 5, 'product/9/4', 'women/configurable-product-armani-blue.html', 'catalog/product/view/id/9/category/4', 1, NULL, NULL, 4, 9),
(17471, 5, 'product/10', 'configurable-product-armani-green.html', 'catalog/product/view/id/10', 1, NULL, NULL, NULL, 10),
(17472, 5, 'product/10/3', 'men/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/3', 1, NULL, NULL, 3, 10),
(17473, 5, 'product/10/4', 'women/configurable-product-armani-green.html', 'catalog/product/view/id/10/category/4', 1, NULL, NULL, 4, 10),
(17474, 5, 'product/11', 'configurable-product-buberry-red.html', 'catalog/product/view/id/11', 1, NULL, NULL, NULL, 11),
(17475, 5, 'product/11/3', 'men/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/3', 1, NULL, NULL, 3, 11),
(17476, 5, 'product/11/4', 'women/configurable-product-buberry-red.html', 'catalog/product/view/id/11/category/4', 1, NULL, NULL, 4, 11),
(17477, 5, 'product/12', 'configurable-product-buberry-green.html', 'catalog/product/view/id/12', 1, NULL, NULL, NULL, 12),
(17478, 5, 'product/12/3', 'men/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/3', 1, NULL, NULL, 3, 12),
(17479, 5, 'product/12/4', 'women/configurable-product-buberry-green.html', 'catalog/product/view/id/12/category/4', 1, NULL, NULL, 4, 12),
(17480, 5, 'product/13', 'configurable-product-02.html', 'catalog/product/view/id/13', 1, NULL, NULL, NULL, 13),
(17481, 5, 'product/13/3', 'men/configurable-product-02.html', 'catalog/product/view/id/13/category/3', 1, NULL, NULL, 3, 13),
(17482, 5, 'product/13/4', 'women/configurable-product-02.html', 'catalog/product/view/id/13/category/4', 1, NULL, NULL, 4, 13),
(17483, 5, 'product/13/40', 'accessories-17/cfg-products/configurable-product-02.html', 'catalog/product/view/id/13/category/40', 1, NULL, NULL, 40, 13),
(17484, 5, 'product/13/41', 'accessories-17/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/41', 1, NULL, NULL, 41, 13),
(17485, 5, 'product/14', 'configurable-product-02-chanel-black.html', 'catalog/product/view/id/14', 1, NULL, NULL, NULL, 14),
(17486, 5, 'product/14/3', 'men/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/3', 1, NULL, NULL, 3, 14),
(17487, 5, 'product/14/4', 'women/configurable-product-02-chanel-black.html', 'catalog/product/view/id/14/category/4', 1, NULL, NULL, 4, 14),
(17488, 5, 'product/15', 'configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15', 1, NULL, NULL, NULL, 15),
(17489, 5, 'product/15/3', 'men/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/3', 1, NULL, NULL, 3, 15),
(17490, 5, 'product/15/4', 'women/configurable-product-02-chanel-blue.html', 'catalog/product/view/id/15/category/4', 1, NULL, NULL, 4, 15),
(17491, 5, 'product/16', 'configurable-product-02-dior-green.html', 'catalog/product/view/id/16', 1, NULL, NULL, NULL, 16),
(17492, 5, 'product/16/3', 'men/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/3', 1, NULL, NULL, 3, 16),
(17493, 5, 'product/16/4', 'women/configurable-product-02-dior-green.html', 'catalog/product/view/id/16/category/4', 1, NULL, NULL, 4, 16),
(17494, 5, 'product/17', 'configurable-product-02-gucci-red.html', 'catalog/product/view/id/17', 1, NULL, NULL, NULL, 17),
(17495, 5, 'product/17/3', 'men/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/3', 1, NULL, NULL, 3, 17),
(17496, 5, 'product/17/4', 'women/configurable-product-02-gucci-red.html', 'catalog/product/view/id/17/category/4', 1, NULL, NULL, 4, 17),
(17497, 5, 'product/18', 'configurable-product-02-gucci-white.html', 'catalog/product/view/id/18', 1, NULL, NULL, NULL, 18),
(17498, 5, 'product/18/3', 'men/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/3', 1, NULL, NULL, 3, 18),
(17499, 5, 'product/18/4', 'women/configurable-product-02-gucci-white.html', 'catalog/product/view/id/18/category/4', 1, NULL, NULL, 4, 18),
(17500, 5, 'product/19', 'configurable-product-03.html', 'catalog/product/view/id/19', 1, NULL, NULL, NULL, 19),
(17501, 5, 'product/19/3', 'men/configurable-product-03.html', 'catalog/product/view/id/19/category/3', 1, NULL, NULL, 3, 19),
(17502, 5, 'product/19/4', 'women/configurable-product-03.html', 'catalog/product/view/id/19/category/4', 1, NULL, NULL, 4, 19),
(17503, 5, 'product/19/40', 'accessories-17/cfg-products/configurable-product-03.html', 'catalog/product/view/id/19/category/40', 1, NULL, NULL, 40, 19),
(17504, 5, 'product/19/41', 'accessories-17/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/41', 1, NULL, NULL, 41, 19),
(17505, 5, 'product/20', 'configurable-product-04.html', 'catalog/product/view/id/20', 1, NULL, NULL, NULL, 20),
(17506, 5, 'product/20/3', 'men/configurable-product-04.html', 'catalog/product/view/id/20/category/3', 1, NULL, NULL, 3, 20),
(17507, 5, 'product/20/4', 'women/configurable-product-04.html', 'catalog/product/view/id/20/category/4', 1, NULL, NULL, 4, 20),
(17508, 5, 'product/20/40', 'accessories-17/cfg-products/configurable-product-04.html', 'catalog/product/view/id/20/category/40', 1, NULL, NULL, 40, 20),
(17509, 5, 'product/20/41', 'accessories-17/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/41', 1, NULL, NULL, 41, 20),
(17510, 5, 'product/21', 'configurable-product-05.html', 'catalog/product/view/id/21', 1, NULL, NULL, NULL, 21),
(17511, 5, 'product/21/3', 'men/configurable-product-05.html', 'catalog/product/view/id/21/category/3', 1, NULL, NULL, 3, 21),
(17512, 5, 'product/21/4', 'women/configurable-product-05.html', 'catalog/product/view/id/21/category/4', 1, NULL, NULL, 4, 21),
(17513, 5, 'product/21/40', 'accessories-17/cfg-products/configurable-product-05.html', 'catalog/product/view/id/21/category/40', 1, NULL, NULL, 40, 21),
(17514, 5, 'product/21/41', 'accessories-17/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/41', 1, NULL, NULL, 41, 21),
(17515, 5, 'product/22', 'configurable-product-03-hermes-white.html', 'catalog/product/view/id/22', 1, NULL, NULL, NULL, 22),
(17516, 5, 'product/22/3', 'men/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/3', 1, NULL, NULL, 3, 22),
(17517, 5, 'product/22/4', 'women/configurable-product-03-hermes-white.html', 'catalog/product/view/id/22/category/4', 1, NULL, NULL, 4, 22),
(17518, 5, 'product/23', 'configurable-product-03-prada-black.html', 'catalog/product/view/id/23', 1, NULL, NULL, NULL, 23),
(17519, 5, 'product/23/3', 'men/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/3', 1, NULL, NULL, 3, 23),
(17520, 5, 'product/23/4', 'women/configurable-product-03-prada-black.html', 'catalog/product/view/id/23/category/4', 1, NULL, NULL, 4, 23),
(17521, 5, 'product/24', 'configurable-product-03-versace-blue.html', 'catalog/product/view/id/24', 1, NULL, NULL, NULL, 24),
(17522, 5, 'product/24/3', 'men/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/3', 1, NULL, NULL, 3, 24),
(17523, 5, 'product/24/4', 'women/configurable-product-03-versace-blue.html', 'catalog/product/view/id/24/category/4', 1, NULL, NULL, 4, 24),
(17524, 5, 'product/25', 'configurable-product-03-prada-green.html', 'catalog/product/view/id/25', 1, NULL, NULL, NULL, 25),
(17525, 5, 'product/25/3', 'men/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/3', 1, NULL, NULL, 3, 25),
(17526, 5, 'product/25/4', 'women/configurable-product-03-prada-green.html', 'catalog/product/view/id/25/category/4', 1, NULL, NULL, 4, 25),
(17527, 5, 'product/26', 'configurable-product-03-prada-red.html', 'catalog/product/view/id/26', 1, NULL, NULL, NULL, 26),
(17528, 5, 'product/26/3', 'men/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/3', 1, NULL, NULL, 3, 26),
(17529, 5, 'product/26/4', 'women/configurable-product-03-prada-red.html', 'catalog/product/view/id/26/category/4', 1, NULL, NULL, 4, 26),
(17530, 5, 'product/27', 'configurable-product-04-black.html', 'catalog/product/view/id/27', 1, NULL, NULL, NULL, 27),
(17531, 5, 'product/27/3', 'men/configurable-product-04-black.html', 'catalog/product/view/id/27/category/3', 1, NULL, NULL, 3, 27),
(17532, 5, 'product/27/4', 'women/configurable-product-04-black.html', 'catalog/product/view/id/27/category/4', 1, NULL, NULL, 4, 27),
(17533, 5, 'product/28', 'configurable-product-04-white.html', 'catalog/product/view/id/28', 1, NULL, NULL, NULL, 28),
(17534, 5, 'product/28/3', 'men/configurable-product-04-white.html', 'catalog/product/view/id/28/category/3', 1, NULL, NULL, 3, 28),
(17535, 5, 'product/28/4', 'women/configurable-product-04-white.html', 'catalog/product/view/id/28/category/4', 1, NULL, NULL, 4, 28),
(17536, 5, 'product/29', 'configurable-product-04-red.html', 'catalog/product/view/id/29', 1, NULL, NULL, NULL, 29),
(17537, 5, 'product/29/3', 'men/configurable-product-04-red.html', 'catalog/product/view/id/29/category/3', 1, NULL, NULL, 3, 29),
(17538, 5, 'product/29/4', 'women/configurable-product-04-red.html', 'catalog/product/view/id/29/category/4', 1, NULL, NULL, 4, 29),
(17539, 5, 'product/29/5', 'kid/configurable-product-04-red.html', 'catalog/product/view/id/29/category/5', 1, NULL, NULL, 5, 29),
(17540, 5, 'product/29/6', 'accessories-17/configurable-product-04-red.html', 'catalog/product/view/id/29/category/6', 1, NULL, NULL, 6, 29),
(17541, 5, 'product/29/19', 'tv-audio/bicycle/configurable-product-04-red.html', 'catalog/product/view/id/29/category/19', 1, NULL, NULL, 19, 29),
(17542, 5, 'product/29/33', 'women/bags/configurable-product-04-red.html', 'catalog/product/view/id/29/category/33', 1, NULL, NULL, 33, 29),
(17543, 5, 'product/29/42', 'cameras-photography/configurable-product-04-red.html', 'catalog/product/view/id/29/category/42', 1, NULL, NULL, 42, 29),
(17544, 5, 'product/29/43', 'tv-audio/configurable-product-04-red.html', 'catalog/product/view/id/29/category/43', 1, NULL, NULL, 43, 29),
(17545, 5, 'product/29/44', 'laptops-computers/configurable-product-04-red.html', 'catalog/product/view/id/29/category/44', 1, NULL, NULL, 44, 29),
(17546, 5, 'product/29/45', 'smart-phones-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/45', 1, NULL, NULL, 45, 29),
(17547, 5, 'product/29/46', 'video-games-consoles/configurable-product-04-red.html', 'catalog/product/view/id/29/category/46', 1, NULL, NULL, 46, 29),
(17548, 5, 'product/29/47', 'gadgets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/47', 1, NULL, NULL, 47, 29),
(17549, 5, 'product/29/48', 'car-electronics-gps/configurable-product-04-red.html', 'catalog/product/view/id/29/category/48', 1, NULL, NULL, 48, 29),
(17550, 5, 'product/29/49', 'laptop/configurable-product-04-red.html', 'catalog/product/view/id/29/category/49', 1, NULL, NULL, 49, 29),
(17551, 5, 'product/29/50', 'accessories/configurable-product-04-red.html', 'catalog/product/view/id/29/category/50', 1, NULL, NULL, 50, 29),
(17552, 5, 'product/29/55', 'casio-watches/configurable-product-04-red.html', 'catalog/product/view/id/29/category/55', 1, NULL, NULL, 55, 29),
(17553, 5, 'product/29/56', 'asus-tablets/configurable-product-04-red.html', 'catalog/product/view/id/29/category/56', 1, NULL, NULL, 56, 29),
(17554, 5, 'product/29/57', 'women-fashion/configurable-product-04-red.html', 'catalog/product/view/id/29/category/57', 1, NULL, NULL, 57, 29),
(17555, 5, 'product/30', 'configurable-product-04-green.html', 'catalog/product/view/id/30', 1, NULL, NULL, NULL, 30),
(17556, 5, 'product/30/3', 'men/configurable-product-04-green.html', 'catalog/product/view/id/30/category/3', 1, NULL, NULL, 3, 30),
(17557, 5, 'product/30/4', 'women/configurable-product-04-green.html', 'catalog/product/view/id/30/category/4', 1, NULL, NULL, 4, 30),
(17558, 5, 'product/30/5', 'kid/configurable-product-04-green.html', 'catalog/product/view/id/30/category/5', 1, NULL, NULL, 5, 30),
(17559, 5, 'product/30/6', 'accessories-17/configurable-product-04-green.html', 'catalog/product/view/id/30/category/6', 1, NULL, NULL, 6, 30),
(17560, 5, 'product/30/19', 'tv-audio/bicycle/configurable-product-04-green.html', 'catalog/product/view/id/30/category/19', 1, NULL, NULL, 19, 30),
(17561, 5, 'product/30/33', 'women/bags/configurable-product-04-green.html', 'catalog/product/view/id/30/category/33', 1, NULL, NULL, 33, 30),
(17562, 5, 'product/30/42', 'cameras-photography/configurable-product-04-green.html', 'catalog/product/view/id/30/category/42', 1, NULL, NULL, 42, 30),
(17563, 5, 'product/30/43', 'tv-audio/configurable-product-04-green.html', 'catalog/product/view/id/30/category/43', 1, NULL, NULL, 43, 30),
(17564, 5, 'product/30/44', 'laptops-computers/configurable-product-04-green.html', 'catalog/product/view/id/30/category/44', 1, NULL, NULL, 44, 30),
(17565, 5, 'product/30/45', 'smart-phones-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/45', 1, NULL, NULL, 45, 30),
(17566, 5, 'product/30/46', 'video-games-consoles/configurable-product-04-green.html', 'catalog/product/view/id/30/category/46', 1, NULL, NULL, 46, 30),
(17567, 5, 'product/30/47', 'gadgets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/47', 1, NULL, NULL, 47, 30),
(17568, 5, 'product/30/48', 'car-electronics-gps/configurable-product-04-green.html', 'catalog/product/view/id/30/category/48', 1, NULL, NULL, 48, 30),
(17569, 5, 'product/30/49', 'laptop/configurable-product-04-green.html', 'catalog/product/view/id/30/category/49', 1, NULL, NULL, 49, 30),
(17570, 5, 'product/30/50', 'accessories/configurable-product-04-green.html', 'catalog/product/view/id/30/category/50', 1, NULL, NULL, 50, 30),
(17571, 5, 'product/30/55', 'casio-watches/configurable-product-04-green.html', 'catalog/product/view/id/30/category/55', 1, NULL, NULL, 55, 30),
(17572, 5, 'product/30/56', 'asus-tablets/configurable-product-04-green.html', 'catalog/product/view/id/30/category/56', 1, NULL, NULL, 56, 30),
(17573, 5, 'product/30/57', 'women-fashion/configurable-product-04-green.html', 'catalog/product/view/id/30/category/57', 1, NULL, NULL, 57, 30),
(17574, 5, 'product/31', 'configurable-product-04-blue.html', 'catalog/product/view/id/31', 1, NULL, NULL, NULL, 31),
(17575, 5, 'product/31/3', 'men/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/3', 1, NULL, NULL, 3, 31),
(17576, 5, 'product/31/4', 'women/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/4', 1, NULL, NULL, 4, 31),
(17577, 5, 'product/31/5', 'kid/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/5', 1, NULL, NULL, 5, 31),
(17578, 5, 'product/31/6', 'accessories-17/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/6', 1, NULL, NULL, 6, 31),
(17579, 5, 'product/31/19', 'tv-audio/bicycle/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/19', 1, NULL, NULL, 19, 31),
(17580, 5, 'product/31/33', 'women/bags/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/33', 1, NULL, NULL, 33, 31),
(17581, 5, 'product/31/42', 'cameras-photography/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/42', 1, NULL, NULL, 42, 31),
(17582, 5, 'product/31/43', 'tv-audio/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/43', 1, NULL, NULL, 43, 31),
(17583, 5, 'product/31/44', 'laptops-computers/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/44', 1, NULL, NULL, 44, 31),
(17584, 5, 'product/31/45', 'smart-phones-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/45', 1, NULL, NULL, 45, 31),
(17585, 5, 'product/31/46', 'video-games-consoles/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/46', 1, NULL, NULL, 46, 31),
(17586, 5, 'product/31/47', 'gadgets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/47', 1, NULL, NULL, 47, 31),
(17587, 5, 'product/31/48', 'car-electronics-gps/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/48', 1, NULL, NULL, 48, 31),
(17588, 5, 'product/31/49', 'laptop/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/49', 1, NULL, NULL, 49, 31),
(17589, 5, 'product/31/50', 'accessories/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/50', 1, NULL, NULL, 50, 31),
(17590, 5, 'product/31/55', 'casio-watches/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/55', 1, NULL, NULL, 55, 31),
(17591, 5, 'product/31/56', 'asus-tablets/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/56', 1, NULL, NULL, 56, 31),
(17592, 5, 'product/31/57', 'women-fashion/configurable-product-04-blue.html', 'catalog/product/view/id/31/category/57', 1, NULL, NULL, 57, 31),
(17593, 5, 'product/32', 'configurable-product-05-armani.html', 'catalog/product/view/id/32', 1, NULL, NULL, NULL, 32),
(17594, 5, 'product/32/3', 'men/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/3', 1, NULL, NULL, 3, 32),
(17595, 5, 'product/32/4', 'women/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/4', 1, NULL, NULL, 4, 32),
(17596, 5, 'product/32/5', 'kid/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/5', 1, NULL, NULL, 5, 32),
(17597, 5, 'product/32/6', 'accessories-17/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/6', 1, NULL, NULL, 6, 32),
(17598, 5, 'product/32/19', 'tv-audio/bicycle/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/19', 1, NULL, NULL, 19, 32),
(17599, 5, 'product/32/33', 'women/bags/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/33', 1, NULL, NULL, 33, 32),
(17600, 5, 'product/32/42', 'cameras-photography/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/42', 1, NULL, NULL, 42, 32),
(17601, 5, 'product/32/43', 'tv-audio/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/43', 1, NULL, NULL, 43, 32),
(17602, 5, 'product/32/44', 'laptops-computers/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/44', 1, NULL, NULL, 44, 32),
(17603, 5, 'product/32/45', 'smart-phones-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/45', 1, NULL, NULL, 45, 32),
(17604, 5, 'product/32/46', 'video-games-consoles/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/46', 1, NULL, NULL, 46, 32),
(17605, 5, 'product/32/47', 'gadgets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/47', 1, NULL, NULL, 47, 32),
(17606, 5, 'product/32/48', 'car-electronics-gps/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/48', 1, NULL, NULL, 48, 32),
(17607, 5, 'product/32/49', 'laptop/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/49', 1, NULL, NULL, 49, 32),
(17608, 5, 'product/32/50', 'accessories/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/50', 1, NULL, NULL, 50, 32),
(17609, 5, 'product/32/55', 'casio-watches/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/55', 1, NULL, NULL, 55, 32),
(17610, 5, 'product/32/56', 'asus-tablets/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/56', 1, NULL, NULL, 56, 32),
(17611, 5, 'product/32/57', 'women-fashion/configurable-product-05-armani.html', 'catalog/product/view/id/32/category/57', 1, NULL, NULL, 57, 32),
(17612, 5, 'product/33', 'configurable-product-05-buberry.html', 'catalog/product/view/id/33', 1, NULL, NULL, NULL, 33),
(17613, 5, 'product/33/3', 'men/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/3', 1, NULL, NULL, 3, 33),
(17614, 5, 'product/33/4', 'women/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/4', 1, NULL, NULL, 4, 33),
(17615, 5, 'product/33/5', 'kid/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/5', 1, NULL, NULL, 5, 33),
(17616, 5, 'product/33/6', 'accessories-17/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/6', 1, NULL, NULL, 6, 33),
(17617, 5, 'product/33/9', 'women/shapewear/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/9', 1, NULL, NULL, 9, 33),
(17618, 5, 'product/33/19', 'tv-audio/bicycle/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/19', 1, NULL, NULL, 19, 33),
(17619, 5, 'product/33/33', 'women/bags/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/33', 1, NULL, NULL, 33, 33),
(17620, 5, 'product/33/42', 'cameras-photography/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/42', 1, NULL, NULL, 42, 33),
(17621, 5, 'product/33/43', 'tv-audio/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/43', 1, NULL, NULL, 43, 33),
(17622, 5, 'product/33/44', 'laptops-computers/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/44', 1, NULL, NULL, 44, 33),
(17623, 5, 'product/33/45', 'smart-phones-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/45', 1, NULL, NULL, 45, 33),
(17624, 5, 'product/33/46', 'video-games-consoles/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/46', 1, NULL, NULL, 46, 33),
(17625, 5, 'product/33/47', 'gadgets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/47', 1, NULL, NULL, 47, 33),
(17626, 5, 'product/33/48', 'car-electronics-gps/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/48', 1, NULL, NULL, 48, 33),
(17627, 5, 'product/33/49', 'laptop/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/49', 1, NULL, NULL, 49, 33),
(17628, 5, 'product/33/50', 'accessories/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/50', 1, NULL, NULL, 50, 33),
(17629, 5, 'product/33/55', 'casio-watches/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/55', 1, NULL, NULL, 55, 33),
(17630, 5, 'product/33/56', 'asus-tablets/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/56', 1, NULL, NULL, 56, 33),
(17631, 5, 'product/33/57', 'women-fashion/configurable-product-05-buberry.html', 'catalog/product/view/id/33/category/57', 1, NULL, NULL, 57, 33),
(17632, 5, 'product/34', 'configurable-product-05-chanel.html', 'catalog/product/view/id/34', 1, NULL, NULL, NULL, 34),
(17633, 5, 'product/34/3', 'men/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/3', 1, NULL, NULL, 3, 34),
(17634, 5, 'product/34/4', 'women/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/4', 1, NULL, NULL, 4, 34),
(17635, 5, 'product/34/5', 'kid/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/5', 1, NULL, NULL, 5, 34),
(17636, 5, 'product/34/6', 'accessories-17/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/6', 1, NULL, NULL, 6, 34),
(17637, 5, 'product/34/9', 'women/shapewear/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/9', 1, NULL, NULL, 9, 34),
(17638, 5, 'product/34/19', 'tv-audio/bicycle/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/19', 1, NULL, NULL, 19, 34),
(17639, 5, 'product/34/33', 'women/bags/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/33', 1, NULL, NULL, 33, 34),
(17640, 5, 'product/34/42', 'cameras-photography/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/42', 1, NULL, NULL, 42, 34),
(17641, 5, 'product/34/43', 'tv-audio/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/43', 1, NULL, NULL, 43, 34),
(17642, 5, 'product/34/44', 'laptops-computers/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/44', 1, NULL, NULL, 44, 34),
(17643, 5, 'product/34/45', 'smart-phones-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/45', 1, NULL, NULL, 45, 34),
(17644, 5, 'product/34/46', 'video-games-consoles/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/46', 1, NULL, NULL, 46, 34),
(17645, 5, 'product/34/47', 'gadgets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/47', 1, NULL, NULL, 47, 34),
(17646, 5, 'product/34/48', 'car-electronics-gps/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/48', 1, NULL, NULL, 48, 34),
(17647, 5, 'product/34/49', 'laptop/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/49', 1, NULL, NULL, 49, 34),
(17648, 5, 'product/34/50', 'accessories/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/50', 1, NULL, NULL, 50, 34),
(17649, 5, 'product/34/55', 'casio-watches/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/55', 1, NULL, NULL, 55, 34),
(17650, 5, 'product/34/56', 'asus-tablets/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/56', 1, NULL, NULL, 56, 34),
(17651, 5, 'product/34/57', 'women-fashion/configurable-product-05-chanel.html', 'catalog/product/view/id/34/category/57', 1, NULL, NULL, 57, 34),
(17652, 5, 'product/35', 'configurable-product-05-hermes.html', 'catalog/product/view/id/35', 1, NULL, NULL, NULL, 35),
(17653, 5, 'product/35/3', 'men/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/3', 1, NULL, NULL, 3, 35),
(17654, 5, 'product/35/4', 'women/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/4', 1, NULL, NULL, 4, 35),
(17655, 5, 'product/35/5', 'kid/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/5', 1, NULL, NULL, 5, 35),
(17656, 5, 'product/35/6', 'accessories-17/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/6', 1, NULL, NULL, 6, 35),
(17657, 5, 'product/35/9', 'women/shapewear/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/9', 1, NULL, NULL, 9, 35),
(17658, 5, 'product/35/19', 'tv-audio/bicycle/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/19', 1, NULL, NULL, 19, 35),
(17659, 5, 'product/35/33', 'women/bags/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/33', 1, NULL, NULL, 33, 35),
(17660, 5, 'product/35/42', 'cameras-photography/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/42', 1, NULL, NULL, 42, 35),
(17661, 5, 'product/35/43', 'tv-audio/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/43', 1, NULL, NULL, 43, 35),
(17662, 5, 'product/35/44', 'laptops-computers/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/44', 1, NULL, NULL, 44, 35),
(17663, 5, 'product/35/45', 'smart-phones-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/45', 1, NULL, NULL, 45, 35),
(17664, 5, 'product/35/46', 'video-games-consoles/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/46', 1, NULL, NULL, 46, 35),
(17665, 5, 'product/35/47', 'gadgets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/47', 1, NULL, NULL, 47, 35),
(17666, 5, 'product/35/48', 'car-electronics-gps/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/48', 1, NULL, NULL, 48, 35),
(17667, 5, 'product/35/49', 'laptop/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/49', 1, NULL, NULL, 49, 35),
(17668, 5, 'product/35/50', 'accessories/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/50', 1, NULL, NULL, 50, 35),
(17669, 5, 'product/35/55', 'casio-watches/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/55', 1, NULL, NULL, 55, 35),
(17670, 5, 'product/35/56', 'asus-tablets/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/56', 1, NULL, NULL, 56, 35),
(17671, 5, 'product/35/57', 'women-fashion/configurable-product-05-hermes.html', 'catalog/product/view/id/35/category/57', 1, NULL, NULL, 57, 35),
(17672, 5, 'product/36', 'configurable-product-05-versace.html', 'catalog/product/view/id/36', 1, NULL, NULL, NULL, 36),
(17673, 5, 'product/36/3', 'men/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/3', 1, NULL, NULL, 3, 36),
(17674, 5, 'product/36/4', 'women/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/4', 1, NULL, NULL, 4, 36),
(17675, 5, 'product/36/5', 'kid/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/5', 1, NULL, NULL, 5, 36),
(17676, 5, 'product/36/6', 'accessories-17/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/6', 1, NULL, NULL, 6, 36),
(17677, 5, 'product/36/9', 'women/shapewear/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/9', 1, NULL, NULL, 9, 36),
(17678, 5, 'product/36/19', 'tv-audio/bicycle/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/19', 1, NULL, NULL, 19, 36);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(17679, 5, 'product/36/33', 'women/bags/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/33', 1, NULL, NULL, 33, 36),
(17680, 5, 'product/36/42', 'cameras-photography/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/42', 1, NULL, NULL, 42, 36),
(17681, 5, 'product/36/43', 'tv-audio/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/43', 1, NULL, NULL, 43, 36),
(17682, 5, 'product/36/44', 'laptops-computers/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/44', 1, NULL, NULL, 44, 36),
(17683, 5, 'product/36/45', 'smart-phones-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/45', 1, NULL, NULL, 45, 36),
(17684, 5, 'product/36/46', 'video-games-consoles/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/46', 1, NULL, NULL, 46, 36),
(17685, 5, 'product/36/47', 'gadgets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/47', 1, NULL, NULL, 47, 36),
(17686, 5, 'product/36/48', 'car-electronics-gps/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/48', 1, NULL, NULL, 48, 36),
(17687, 5, 'product/36/49', 'laptop/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/49', 1, NULL, NULL, 49, 36),
(17688, 5, 'product/36/50', 'accessories/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/50', 1, NULL, NULL, 50, 36),
(17689, 5, 'product/36/55', 'casio-watches/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/55', 1, NULL, NULL, 55, 36),
(17690, 5, 'product/36/56', 'asus-tablets/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/56', 1, NULL, NULL, 56, 36),
(17691, 5, 'product/36/57', 'women-fashion/configurable-product-05-versace.html', 'catalog/product/view/id/36/category/57', 1, NULL, NULL, 57, 36),
(17692, 5, 'product/37', 'simple-product-01.html', 'catalog/product/view/id/37', 1, NULL, NULL, NULL, 37),
(17693, 5, 'product/37/3', 'men/simple-product-01.html', 'catalog/product/view/id/37/category/3', 1, NULL, NULL, 3, 37),
(17694, 5, 'product/37/4', 'women/simple-product-01.html', 'catalog/product/view/id/37/category/4', 1, NULL, NULL, 4, 37),
(17695, 5, 'product/37/5', 'kid/simple-product-01.html', 'catalog/product/view/id/37/category/5', 1, NULL, NULL, 5, 37),
(17696, 5, 'product/37/6', 'accessories-17/simple-product-01.html', 'catalog/product/view/id/37/category/6', 1, NULL, NULL, 6, 37),
(17697, 5, 'product/37/9', 'women/shapewear/simple-product-01.html', 'catalog/product/view/id/37/category/9', 1, NULL, NULL, 9, 37),
(17698, 5, 'product/37/19', 'tv-audio/bicycle/simple-product-01.html', 'catalog/product/view/id/37/category/19', 1, NULL, NULL, 19, 37),
(17699, 5, 'product/37/33', 'women/bags/simple-product-01.html', 'catalog/product/view/id/37/category/33', 1, NULL, NULL, 33, 37),
(17700, 5, 'product/37/41', 'accessories-17/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/41', 1, NULL, NULL, 41, 37),
(17701, 5, 'product/37/42', 'cameras-photography/simple-product-01.html', 'catalog/product/view/id/37/category/42', 1, NULL, NULL, 42, 37),
(17702, 5, 'product/37/43', 'tv-audio/simple-product-01.html', 'catalog/product/view/id/37/category/43', 1, NULL, NULL, 43, 37),
(17703, 5, 'product/37/44', 'laptops-computers/simple-product-01.html', 'catalog/product/view/id/37/category/44', 1, NULL, NULL, 44, 37),
(17704, 5, 'product/37/45', 'smart-phones-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/45', 1, NULL, NULL, 45, 37),
(17705, 5, 'product/37/46', 'video-games-consoles/simple-product-01.html', 'catalog/product/view/id/37/category/46', 1, NULL, NULL, 46, 37),
(17706, 5, 'product/37/47', 'gadgets/simple-product-01.html', 'catalog/product/view/id/37/category/47', 1, NULL, NULL, 47, 37),
(17707, 5, 'product/37/48', 'car-electronics-gps/simple-product-01.html', 'catalog/product/view/id/37/category/48', 1, NULL, NULL, 48, 37),
(17708, 5, 'product/37/49', 'laptop/simple-product-01.html', 'catalog/product/view/id/37/category/49', 1, NULL, NULL, 49, 37),
(17709, 5, 'product/37/50', 'accessories/simple-product-01.html', 'catalog/product/view/id/37/category/50', 1, NULL, NULL, 50, 37),
(17710, 5, 'product/37/55', 'casio-watches/simple-product-01.html', 'catalog/product/view/id/37/category/55', 1, NULL, NULL, 55, 37),
(17711, 5, 'product/37/56', 'asus-tablets/simple-product-01.html', 'catalog/product/view/id/37/category/56', 1, NULL, NULL, 56, 37),
(17712, 5, 'product/37/57', 'women-fashion/simple-product-01.html', 'catalog/product/view/id/37/category/57', 1, NULL, NULL, 57, 37),
(17713, 5, 'product/38', 'simple-product-02.html', 'catalog/product/view/id/38', 1, NULL, NULL, NULL, 38),
(17714, 5, 'product/38/3', 'men/simple-product-02.html', 'catalog/product/view/id/38/category/3', 1, NULL, NULL, 3, 38),
(17715, 5, 'product/38/4', 'women/simple-product-02.html', 'catalog/product/view/id/38/category/4', 1, NULL, NULL, 4, 38),
(17716, 5, 'product/38/5', 'kid/simple-product-02.html', 'catalog/product/view/id/38/category/5', 1, NULL, NULL, 5, 38),
(17717, 5, 'product/38/6', 'accessories-17/simple-product-02.html', 'catalog/product/view/id/38/category/6', 1, NULL, NULL, 6, 38),
(17718, 5, 'product/38/9', 'women/shapewear/simple-product-02.html', 'catalog/product/view/id/38/category/9', 1, NULL, NULL, 9, 38),
(17719, 5, 'product/38/19', 'tv-audio/bicycle/simple-product-02.html', 'catalog/product/view/id/38/category/19', 1, NULL, NULL, 19, 38),
(17720, 5, 'product/38/33', 'women/bags/simple-product-02.html', 'catalog/product/view/id/38/category/33', 1, NULL, NULL, 33, 38),
(17721, 5, 'product/38/42', 'cameras-photography/simple-product-02.html', 'catalog/product/view/id/38/category/42', 1, NULL, NULL, 42, 38),
(17722, 5, 'product/38/43', 'tv-audio/simple-product-02.html', 'catalog/product/view/id/38/category/43', 1, NULL, NULL, 43, 38),
(17723, 5, 'product/38/44', 'laptops-computers/simple-product-02.html', 'catalog/product/view/id/38/category/44', 1, NULL, NULL, 44, 38),
(17724, 5, 'product/38/45', 'smart-phones-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/45', 1, NULL, NULL, 45, 38),
(17725, 5, 'product/38/46', 'video-games-consoles/simple-product-02.html', 'catalog/product/view/id/38/category/46', 1, NULL, NULL, 46, 38),
(17726, 5, 'product/38/47', 'gadgets/simple-product-02.html', 'catalog/product/view/id/38/category/47', 1, NULL, NULL, 47, 38),
(17727, 5, 'product/38/48', 'car-electronics-gps/simple-product-02.html', 'catalog/product/view/id/38/category/48', 1, NULL, NULL, 48, 38),
(17728, 5, 'product/38/49', 'laptop/simple-product-02.html', 'catalog/product/view/id/38/category/49', 1, NULL, NULL, 49, 38),
(17729, 5, 'product/38/50', 'accessories/simple-product-02.html', 'catalog/product/view/id/38/category/50', 1, NULL, NULL, 50, 38),
(17730, 5, 'product/38/55', 'casio-watches/simple-product-02.html', 'catalog/product/view/id/38/category/55', 1, NULL, NULL, 55, 38),
(17731, 5, 'product/38/56', 'asus-tablets/simple-product-02.html', 'catalog/product/view/id/38/category/56', 1, NULL, NULL, 56, 38),
(17732, 5, 'product/38/57', 'women-fashion/simple-product-02.html', 'catalog/product/view/id/38/category/57', 1, NULL, NULL, 57, 38),
(17733, 5, 'product/39', 'simple-product-03.html', 'catalog/product/view/id/39', 1, NULL, NULL, NULL, 39),
(17734, 5, 'product/39/3', 'men/simple-product-03.html', 'catalog/product/view/id/39/category/3', 1, NULL, NULL, 3, 39),
(17735, 5, 'product/39/4', 'women/simple-product-03.html', 'catalog/product/view/id/39/category/4', 1, NULL, NULL, 4, 39),
(17736, 5, 'product/39/5', 'kid/simple-product-03.html', 'catalog/product/view/id/39/category/5', 1, NULL, NULL, 5, 39),
(17737, 5, 'product/39/6', 'accessories-17/simple-product-03.html', 'catalog/product/view/id/39/category/6', 1, NULL, NULL, 6, 39),
(17738, 5, 'product/39/9', 'women/shapewear/simple-product-03.html', 'catalog/product/view/id/39/category/9', 1, NULL, NULL, 9, 39),
(17739, 5, 'product/39/19', 'tv-audio/bicycle/simple-product-03.html', 'catalog/product/view/id/39/category/19', 1, NULL, NULL, 19, 39),
(17740, 5, 'product/39/33', 'women/bags/simple-product-03.html', 'catalog/product/view/id/39/category/33', 1, NULL, NULL, 33, 39),
(17741, 5, 'product/39/42', 'cameras-photography/simple-product-03.html', 'catalog/product/view/id/39/category/42', 1, NULL, NULL, 42, 39),
(17742, 5, 'product/39/43', 'tv-audio/simple-product-03.html', 'catalog/product/view/id/39/category/43', 1, NULL, NULL, 43, 39),
(17743, 5, 'product/39/44', 'laptops-computers/simple-product-03.html', 'catalog/product/view/id/39/category/44', 1, NULL, NULL, 44, 39),
(17744, 5, 'product/39/45', 'smart-phones-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/45', 1, NULL, NULL, 45, 39),
(17745, 5, 'product/39/46', 'video-games-consoles/simple-product-03.html', 'catalog/product/view/id/39/category/46', 1, NULL, NULL, 46, 39),
(17746, 5, 'product/39/47', 'gadgets/simple-product-03.html', 'catalog/product/view/id/39/category/47', 1, NULL, NULL, 47, 39),
(17747, 5, 'product/39/48', 'car-electronics-gps/simple-product-03.html', 'catalog/product/view/id/39/category/48', 1, NULL, NULL, 48, 39),
(17748, 5, 'product/39/49', 'laptop/simple-product-03.html', 'catalog/product/view/id/39/category/49', 1, NULL, NULL, 49, 39),
(17749, 5, 'product/39/50', 'accessories/simple-product-03.html', 'catalog/product/view/id/39/category/50', 1, NULL, NULL, 50, 39),
(17750, 5, 'product/39/55', 'casio-watches/simple-product-03.html', 'catalog/product/view/id/39/category/55', 1, NULL, NULL, 55, 39),
(17751, 5, 'product/39/56', 'asus-tablets/simple-product-03.html', 'catalog/product/view/id/39/category/56', 1, NULL, NULL, 56, 39),
(17752, 5, 'product/39/57', 'women-fashion/simple-product-03.html', 'catalog/product/view/id/39/category/57', 1, NULL, NULL, 57, 39),
(17753, 5, 'product/40', 'simple-product-04.html', 'catalog/product/view/id/40', 1, NULL, NULL, NULL, 40),
(17754, 5, 'product/40/3', 'men/simple-product-04.html', 'catalog/product/view/id/40/category/3', 1, NULL, NULL, 3, 40),
(17755, 5, 'product/40/4', 'women/simple-product-04.html', 'catalog/product/view/id/40/category/4', 1, NULL, NULL, 4, 40),
(17756, 5, 'product/40/5', 'kid/simple-product-04.html', 'catalog/product/view/id/40/category/5', 1, NULL, NULL, 5, 40),
(17757, 5, 'product/40/6', 'accessories-17/simple-product-04.html', 'catalog/product/view/id/40/category/6', 1, NULL, NULL, 6, 40),
(17758, 5, 'product/40/9', 'women/shapewear/simple-product-04.html', 'catalog/product/view/id/40/category/9', 1, NULL, NULL, 9, 40),
(17759, 5, 'product/40/19', 'tv-audio/bicycle/simple-product-04.html', 'catalog/product/view/id/40/category/19', 1, NULL, NULL, 19, 40),
(17760, 5, 'product/40/33', 'women/bags/simple-product-04.html', 'catalog/product/view/id/40/category/33', 1, NULL, NULL, 33, 40),
(17761, 5, 'product/40/42', 'cameras-photography/simple-product-04.html', 'catalog/product/view/id/40/category/42', 1, NULL, NULL, 42, 40),
(17762, 5, 'product/40/43', 'tv-audio/simple-product-04.html', 'catalog/product/view/id/40/category/43', 1, NULL, NULL, 43, 40),
(17763, 5, 'product/40/44', 'laptops-computers/simple-product-04.html', 'catalog/product/view/id/40/category/44', 1, NULL, NULL, 44, 40),
(17764, 5, 'product/40/45', 'smart-phones-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/45', 1, NULL, NULL, 45, 40),
(17765, 5, 'product/40/46', 'video-games-consoles/simple-product-04.html', 'catalog/product/view/id/40/category/46', 1, NULL, NULL, 46, 40),
(17766, 5, 'product/40/47', 'gadgets/simple-product-04.html', 'catalog/product/view/id/40/category/47', 1, NULL, NULL, 47, 40),
(17767, 5, 'product/40/48', 'car-electronics-gps/simple-product-04.html', 'catalog/product/view/id/40/category/48', 1, NULL, NULL, 48, 40),
(17768, 5, 'product/40/49', 'laptop/simple-product-04.html', 'catalog/product/view/id/40/category/49', 1, NULL, NULL, 49, 40),
(17769, 5, 'product/40/50', 'accessories/simple-product-04.html', 'catalog/product/view/id/40/category/50', 1, NULL, NULL, 50, 40),
(17770, 5, 'product/40/55', 'casio-watches/simple-product-04.html', 'catalog/product/view/id/40/category/55', 1, NULL, NULL, 55, 40),
(17771, 5, 'product/40/56', 'asus-tablets/simple-product-04.html', 'catalog/product/view/id/40/category/56', 1, NULL, NULL, 56, 40),
(17772, 5, 'product/40/57', 'women-fashion/simple-product-04.html', 'catalog/product/view/id/40/category/57', 1, NULL, NULL, 57, 40),
(17773, 5, 'product/41', 'simple-product-05.html', 'catalog/product/view/id/41', 1, NULL, NULL, NULL, 41),
(17774, 5, 'product/41/3', 'men/simple-product-05.html', 'catalog/product/view/id/41/category/3', 1, NULL, NULL, 3, 41),
(17775, 5, 'product/41/4', 'women/simple-product-05.html', 'catalog/product/view/id/41/category/4', 1, NULL, NULL, 4, 41),
(17776, 5, 'product/41/5', 'kid/simple-product-05.html', 'catalog/product/view/id/41/category/5', 1, NULL, NULL, 5, 41),
(17777, 5, 'product/41/6', 'accessories-17/simple-product-05.html', 'catalog/product/view/id/41/category/6', 1, NULL, NULL, 6, 41),
(17778, 5, 'product/41/9', 'women/shapewear/simple-product-05.html', 'catalog/product/view/id/41/category/9', 1, NULL, NULL, 9, 41),
(17779, 5, 'product/41/19', 'tv-audio/bicycle/simple-product-05.html', 'catalog/product/view/id/41/category/19', 1, NULL, NULL, 19, 41),
(17780, 5, 'product/41/33', 'women/bags/simple-product-05.html', 'catalog/product/view/id/41/category/33', 1, NULL, NULL, 33, 41),
(17781, 5, 'product/41/42', 'cameras-photography/simple-product-05.html', 'catalog/product/view/id/41/category/42', 1, NULL, NULL, 42, 41),
(17782, 5, 'product/41/43', 'tv-audio/simple-product-05.html', 'catalog/product/view/id/41/category/43', 1, NULL, NULL, 43, 41),
(17783, 5, 'product/41/44', 'laptops-computers/simple-product-05.html', 'catalog/product/view/id/41/category/44', 1, NULL, NULL, 44, 41),
(17784, 5, 'product/41/45', 'smart-phones-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/45', 1, NULL, NULL, 45, 41),
(17785, 5, 'product/41/46', 'video-games-consoles/simple-product-05.html', 'catalog/product/view/id/41/category/46', 1, NULL, NULL, 46, 41),
(17786, 5, 'product/41/47', 'gadgets/simple-product-05.html', 'catalog/product/view/id/41/category/47', 1, NULL, NULL, 47, 41),
(17787, 5, 'product/41/48', 'car-electronics-gps/simple-product-05.html', 'catalog/product/view/id/41/category/48', 1, NULL, NULL, 48, 41),
(17788, 5, 'product/41/49', 'laptop/simple-product-05.html', 'catalog/product/view/id/41/category/49', 1, NULL, NULL, 49, 41),
(17789, 5, 'product/41/50', 'accessories/simple-product-05.html', 'catalog/product/view/id/41/category/50', 1, NULL, NULL, 50, 41),
(17790, 5, 'product/41/55', 'casio-watches/simple-product-05.html', 'catalog/product/view/id/41/category/55', 1, NULL, NULL, 55, 41),
(17791, 5, 'product/41/56', 'asus-tablets/simple-product-05.html', 'catalog/product/view/id/41/category/56', 1, NULL, NULL, 56, 41),
(17792, 5, 'product/41/57', 'women-fashion/simple-product-05.html', 'catalog/product/view/id/41/category/57', 1, NULL, NULL, 57, 41),
(17793, 5, 'product/42', 'grouped-product.html', 'catalog/product/view/id/42', 1, NULL, NULL, NULL, 42),
(17794, 5, 'product/42/3', 'men/grouped-product.html', 'catalog/product/view/id/42/category/3', 1, NULL, NULL, 3, 42),
(17795, 5, 'product/42/4', 'women/grouped-product.html', 'catalog/product/view/id/42/category/4', 1, NULL, NULL, 4, 42),
(17796, 5, 'product/42/5', 'kid/grouped-product.html', 'catalog/product/view/id/42/category/5', 1, NULL, NULL, 5, 42),
(17797, 5, 'product/42/6', 'accessories-17/grouped-product.html', 'catalog/product/view/id/42/category/6', 1, NULL, NULL, 6, 42),
(17798, 5, 'product/42/9', 'women/shapewear/grouped-product.html', 'catalog/product/view/id/42/category/9', 1, NULL, NULL, 9, 42),
(17799, 5, 'product/42/19', 'tv-audio/bicycle/grouped-product.html', 'catalog/product/view/id/42/category/19', 1, NULL, NULL, 19, 42),
(17800, 5, 'product/42/33', 'women/bags/grouped-product.html', 'catalog/product/view/id/42/category/33', 1, NULL, NULL, 33, 42),
(17801, 5, 'product/42/41', 'accessories-17/product-types/grouped-product.html', 'catalog/product/view/id/42/category/41', 1, NULL, NULL, 41, 42),
(17802, 5, 'product/42/42', 'cameras-photography/grouped-product.html', 'catalog/product/view/id/42/category/42', 1, NULL, NULL, 42, 42),
(17803, 5, 'product/42/43', 'tv-audio/grouped-product.html', 'catalog/product/view/id/42/category/43', 1, NULL, NULL, 43, 42),
(17804, 5, 'product/42/44', 'laptops-computers/grouped-product.html', 'catalog/product/view/id/42/category/44', 1, NULL, NULL, 44, 42),
(17805, 5, 'product/42/45', 'smart-phones-tablets/grouped-product.html', 'catalog/product/view/id/42/category/45', 1, NULL, NULL, 45, 42),
(17806, 5, 'product/42/46', 'video-games-consoles/grouped-product.html', 'catalog/product/view/id/42/category/46', 1, NULL, NULL, 46, 42),
(17807, 5, 'product/42/47', 'gadgets/grouped-product.html', 'catalog/product/view/id/42/category/47', 1, NULL, NULL, 47, 42),
(17808, 5, 'product/42/48', 'car-electronics-gps/grouped-product.html', 'catalog/product/view/id/42/category/48', 1, NULL, NULL, 48, 42),
(17809, 5, 'product/42/49', 'laptop/grouped-product.html', 'catalog/product/view/id/42/category/49', 1, NULL, NULL, 49, 42),
(17810, 5, 'product/42/50', 'accessories/grouped-product.html', 'catalog/product/view/id/42/category/50', 1, NULL, NULL, 50, 42),
(17811, 5, 'product/42/55', 'casio-watches/grouped-product.html', 'catalog/product/view/id/42/category/55', 1, NULL, NULL, 55, 42),
(17812, 5, 'product/42/56', 'asus-tablets/grouped-product.html', 'catalog/product/view/id/42/category/56', 1, NULL, NULL, 56, 42),
(17813, 5, 'product/42/57', 'women-fashion/grouped-product.html', 'catalog/product/view/id/42/category/57', 1, NULL, NULL, 57, 42),
(17835, 5, 'product/44', 'bundle-product.html', 'catalog/product/view/id/44', 1, NULL, NULL, NULL, 44),
(17836, 5, 'product/44/3', 'men/bundle-product.html', 'catalog/product/view/id/44/category/3', 1, NULL, NULL, 3, 44),
(17837, 5, 'product/44/4', 'women/bundle-product.html', 'catalog/product/view/id/44/category/4', 1, NULL, NULL, 4, 44),
(17838, 5, 'product/44/5', 'kid/bundle-product.html', 'catalog/product/view/id/44/category/5', 1, NULL, NULL, 5, 44),
(17839, 5, 'product/44/6', 'accessories-17/bundle-product.html', 'catalog/product/view/id/44/category/6', 1, NULL, NULL, 6, 44),
(17840, 5, 'product/44/9', 'women/shapewear/bundle-product.html', 'catalog/product/view/id/44/category/9', 1, NULL, NULL, 9, 44),
(17841, 5, 'product/44/19', 'tv-audio/bicycle/bundle-product.html', 'catalog/product/view/id/44/category/19', 1, NULL, NULL, 19, 44),
(17842, 5, 'product/44/33', 'women/bags/bundle-product.html', 'catalog/product/view/id/44/category/33', 1, NULL, NULL, 33, 44),
(17843, 5, 'product/44/41', 'accessories-17/product-types/bundle-product.html', 'catalog/product/view/id/44/category/41', 1, NULL, NULL, 41, 44),
(17844, 5, 'product/44/42', 'cameras-photography/bundle-product.html', 'catalog/product/view/id/44/category/42', 1, NULL, NULL, 42, 44),
(17845, 5, 'product/44/43', 'tv-audio/bundle-product.html', 'catalog/product/view/id/44/category/43', 1, NULL, NULL, 43, 44),
(17846, 5, 'product/44/44', 'laptops-computers/bundle-product.html', 'catalog/product/view/id/44/category/44', 1, NULL, NULL, 44, 44),
(17847, 5, 'product/44/45', 'smart-phones-tablets/bundle-product.html', 'catalog/product/view/id/44/category/45', 1, NULL, NULL, 45, 44),
(17848, 5, 'product/44/46', 'video-games-consoles/bundle-product.html', 'catalog/product/view/id/44/category/46', 1, NULL, NULL, 46, 44),
(17849, 5, 'product/44/47', 'gadgets/bundle-product.html', 'catalog/product/view/id/44/category/47', 1, NULL, NULL, 47, 44),
(17850, 5, 'product/44/48', 'car-electronics-gps/bundle-product.html', 'catalog/product/view/id/44/category/48', 1, NULL, NULL, 48, 44),
(17851, 5, 'product/44/49', 'laptop/bundle-product.html', 'catalog/product/view/id/44/category/49', 1, NULL, NULL, 49, 44),
(17852, 5, 'product/44/50', 'accessories/bundle-product.html', 'catalog/product/view/id/44/category/50', 1, NULL, NULL, 50, 44),
(17853, 5, 'product/44/55', 'casio-watches/bundle-product.html', 'catalog/product/view/id/44/category/55', 1, NULL, NULL, 55, 44),
(17854, 5, 'product/44/56', 'asus-tablets/bundle-product.html', 'catalog/product/view/id/44/category/56', 1, NULL, NULL, 56, 44),
(17855, 5, 'product/44/57', 'women-fashion/bundle-product.html', 'catalog/product/view/id/44/category/57', 1, NULL, NULL, 57, 44),
(17856, 5, 'product/45', 'bundle-product-02.html', 'catalog/product/view/id/45', 1, NULL, NULL, NULL, 45),
(17857, 5, 'product/45/3', 'men/bundle-product-02.html', 'catalog/product/view/id/45/category/3', 1, NULL, NULL, 3, 45),
(17858, 5, 'product/45/4', 'women/bundle-product-02.html', 'catalog/product/view/id/45/category/4', 1, NULL, NULL, 4, 45),
(17859, 5, 'product/45/5', 'kid/bundle-product-02.html', 'catalog/product/view/id/45/category/5', 1, NULL, NULL, 5, 45),
(17860, 5, 'product/45/6', 'accessories-17/bundle-product-02.html', 'catalog/product/view/id/45/category/6', 1, NULL, NULL, 6, 45),
(17861, 5, 'product/45/9', 'women/shapewear/bundle-product-02.html', 'catalog/product/view/id/45/category/9', 1, NULL, NULL, 9, 45),
(17862, 5, 'product/45/19', 'tv-audio/bicycle/bundle-product-02.html', 'catalog/product/view/id/45/category/19', 1, NULL, NULL, 19, 45),
(17863, 5, 'product/45/33', 'women/bags/bundle-product-02.html', 'catalog/product/view/id/45/category/33', 1, NULL, NULL, 33, 45),
(17864, 5, 'product/45/41', 'accessories-17/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/41', 1, NULL, NULL, 41, 45),
(17865, 5, 'product/45/42', 'cameras-photography/bundle-product-02.html', 'catalog/product/view/id/45/category/42', 1, NULL, NULL, 42, 45),
(17866, 5, 'product/45/43', 'tv-audio/bundle-product-02.html', 'catalog/product/view/id/45/category/43', 1, NULL, NULL, 43, 45),
(17867, 5, 'product/45/44', 'laptops-computers/bundle-product-02.html', 'catalog/product/view/id/45/category/44', 1, NULL, NULL, 44, 45),
(17868, 5, 'product/45/45', 'smart-phones-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/45', 1, NULL, NULL, 45, 45),
(17869, 5, 'product/45/46', 'video-games-consoles/bundle-product-02.html', 'catalog/product/view/id/45/category/46', 1, NULL, NULL, 46, 45),
(17870, 5, 'product/45/47', 'gadgets/bundle-product-02.html', 'catalog/product/view/id/45/category/47', 1, NULL, NULL, 47, 45),
(17871, 5, 'product/45/48', 'car-electronics-gps/bundle-product-02.html', 'catalog/product/view/id/45/category/48', 1, NULL, NULL, 48, 45),
(17872, 5, 'product/45/49', 'laptop/bundle-product-02.html', 'catalog/product/view/id/45/category/49', 1, NULL, NULL, 49, 45),
(17873, 5, 'product/45/50', 'accessories/bundle-product-02.html', 'catalog/product/view/id/45/category/50', 1, NULL, NULL, 50, 45),
(17874, 5, 'product/45/55', 'casio-watches/bundle-product-02.html', 'catalog/product/view/id/45/category/55', 1, NULL, NULL, 55, 45),
(17875, 5, 'product/45/56', 'asus-tablets/bundle-product-02.html', 'catalog/product/view/id/45/category/56', 1, NULL, NULL, 56, 45),
(17876, 5, 'product/45/57', 'women-fashion/bundle-product-02.html', 'catalog/product/view/id/45/category/57', 1, NULL, NULL, 57, 45),
(17877, 5, 'product/46', 'downloadable-product.html', 'catalog/product/view/id/46', 1, NULL, NULL, NULL, 46),
(17878, 5, 'product/46/3', 'men/downloadable-product.html', 'catalog/product/view/id/46/category/3', 1, NULL, NULL, 3, 46),
(17879, 5, 'product/46/4', 'women/downloadable-product.html', 'catalog/product/view/id/46/category/4', 1, NULL, NULL, 4, 46),
(17880, 5, 'product/46/5', 'kid/downloadable-product.html', 'catalog/product/view/id/46/category/5', 1, NULL, NULL, 5, 46),
(17881, 5, 'product/46/6', 'accessories-17/downloadable-product.html', 'catalog/product/view/id/46/category/6', 1, NULL, NULL, 6, 46),
(17882, 5, 'product/46/9', 'women/shapewear/downloadable-product.html', 'catalog/product/view/id/46/category/9', 1, NULL, NULL, 9, 46),
(17883, 5, 'product/46/19', 'tv-audio/bicycle/downloadable-product.html', 'catalog/product/view/id/46/category/19', 1, NULL, NULL, 19, 46),
(17884, 5, 'product/46/33', 'women/bags/downloadable-product.html', 'catalog/product/view/id/46/category/33', 1, NULL, NULL, 33, 46),
(17885, 5, 'product/46/41', 'accessories-17/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/41', 1, NULL, NULL, 41, 46),
(17886, 5, 'product/46/42', 'cameras-photography/downloadable-product.html', 'catalog/product/view/id/46/category/42', 1, NULL, NULL, 42, 46),
(17887, 5, 'product/46/43', 'tv-audio/downloadable-product.html', 'catalog/product/view/id/46/category/43', 1, NULL, NULL, 43, 46),
(17888, 5, 'product/46/44', 'laptops-computers/downloadable-product.html', 'catalog/product/view/id/46/category/44', 1, NULL, NULL, 44, 46),
(17889, 5, 'product/46/45', 'smart-phones-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/45', 1, NULL, NULL, 45, 46),
(17890, 5, 'product/46/46', 'video-games-consoles/downloadable-product.html', 'catalog/product/view/id/46/category/46', 1, NULL, NULL, 46, 46),
(17891, 5, 'product/46/47', 'gadgets/downloadable-product.html', 'catalog/product/view/id/46/category/47', 1, NULL, NULL, 47, 46),
(17892, 5, 'product/46/48', 'car-electronics-gps/downloadable-product.html', 'catalog/product/view/id/46/category/48', 1, NULL, NULL, 48, 46),
(17893, 5, 'product/46/49', 'laptop/downloadable-product.html', 'catalog/product/view/id/46/category/49', 1, NULL, NULL, 49, 46),
(17894, 5, 'product/46/50', 'accessories/downloadable-product.html', 'catalog/product/view/id/46/category/50', 1, NULL, NULL, 50, 46),
(17895, 5, 'product/46/55', 'casio-watches/downloadable-product.html', 'catalog/product/view/id/46/category/55', 1, NULL, NULL, 55, 46),
(17896, 5, 'product/46/56', 'asus-tablets/downloadable-product.html', 'catalog/product/view/id/46/category/56', 1, NULL, NULL, 56, 46),
(17897, 5, 'product/46/57', 'women-fashion/downloadable-product.html', 'catalog/product/view/id/46/category/57', 1, NULL, NULL, 57, 46),
(17898, 5, 'product/47', 'no-image.html', 'catalog/product/view/id/47', 1, NULL, NULL, NULL, 47),
(17899, 5, 'product/47/3', 'men/no-image.html', 'catalog/product/view/id/47/category/3', 1, NULL, NULL, 3, 47),
(17900, 5, 'product/47/4', 'women/no-image.html', 'catalog/product/view/id/47/category/4', 1, NULL, NULL, 4, 47),
(17901, 5, 'product/47/6', 'accessories-17/no-image.html', 'catalog/product/view/id/47/category/6', 1, NULL, NULL, 6, 47),
(17902, 5, 'product/47/9', 'women/shapewear/no-image.html', 'catalog/product/view/id/47/category/9', 1, NULL, NULL, 9, 47),
(17903, 5, 'product/47/19', 'tv-audio/bicycle/no-image.html', 'catalog/product/view/id/47/category/19', 1, NULL, NULL, 19, 47),
(17904, 5, 'product/47/33', 'women/bags/no-image.html', 'catalog/product/view/id/47/category/33', 1, NULL, NULL, 33, 47),
(17905, 5, 'product/47/41', 'accessories-17/product-types/no-image.html', 'catalog/product/view/id/47/category/41', 1, NULL, NULL, 41, 47),
(17906, 5, 'product/47/42', 'cameras-photography/no-image.html', 'catalog/product/view/id/47/category/42', 1, NULL, NULL, 42, 47),
(17907, 5, 'product/47/43', 'tv-audio/no-image.html', 'catalog/product/view/id/47/category/43', 1, NULL, NULL, 43, 47),
(17908, 5, 'product/47/44', 'laptops-computers/no-image.html', 'catalog/product/view/id/47/category/44', 1, NULL, NULL, 44, 47),
(17909, 5, 'product/47/45', 'smart-phones-tablets/no-image.html', 'catalog/product/view/id/47/category/45', 1, NULL, NULL, 45, 47),
(17910, 5, 'product/47/46', 'video-games-consoles/no-image.html', 'catalog/product/view/id/47/category/46', 1, NULL, NULL, 46, 47),
(17911, 5, 'product/47/47', 'gadgets/no-image.html', 'catalog/product/view/id/47/category/47', 1, NULL, NULL, 47, 47),
(17912, 5, 'product/47/48', 'car-electronics-gps/no-image.html', 'catalog/product/view/id/47/category/48', 1, NULL, NULL, 48, 47),
(17913, 5, 'product/47/49', 'laptop/no-image.html', 'catalog/product/view/id/47/category/49', 1, NULL, NULL, 49, 47),
(17914, 5, 'product/47/50', 'accessories/no-image.html', 'catalog/product/view/id/47/category/50', 1, NULL, NULL, 50, 47),
(17915, 5, 'product/47/55', 'casio-watches/no-image.html', 'catalog/product/view/id/47/category/55', 1, NULL, NULL, 55, 47),
(17916, 5, 'product/47/56', 'asus-tablets/no-image.html', 'catalog/product/view/id/47/category/56', 1, NULL, NULL, 56, 47),
(17917, 5, 'product/47/57', 'women-fashion/no-image.html', 'catalog/product/view/id/47/category/57', 1, NULL, NULL, 57, 47),
(17918, 5, 'product/48', 'custom-option.html', 'catalog/product/view/id/48', 1, NULL, NULL, NULL, 48),
(17919, 5, 'product/48/3', 'men/custom-option.html', 'catalog/product/view/id/48/category/3', 1, NULL, NULL, 3, 48),
(17920, 5, 'product/48/4', 'women/custom-option.html', 'catalog/product/view/id/48/category/4', 1, NULL, NULL, 4, 48),
(17921, 5, 'product/48/6', 'accessories-17/custom-option.html', 'catalog/product/view/id/48/category/6', 1, NULL, NULL, 6, 48),
(17922, 5, 'product/48/9', 'women/shapewear/custom-option.html', 'catalog/product/view/id/48/category/9', 1, NULL, NULL, 9, 48),
(17923, 5, 'product/48/19', 'tv-audio/bicycle/custom-option.html', 'catalog/product/view/id/48/category/19', 1, NULL, NULL, 19, 48),
(17924, 5, 'product/48/20', 'tv-audio/bicycle/jackets/custom-option.html', 'catalog/product/view/id/48/category/20', 1, NULL, NULL, 20, 48),
(17925, 5, 'product/48/24', 'tv-audio/bicycle/scarves/custom-option.html', 'catalog/product/view/id/48/category/24', 1, NULL, NULL, 24, 48),
(17926, 5, 'product/48/25', 'tv-audio/bicycle/lifestyle/custom-option.html', 'catalog/product/view/id/48/category/25', 1, NULL, NULL, 25, 48),
(17927, 5, 'product/48/26', 'accessories-17/bras/custom-option.html', 'catalog/product/view/id/48/category/26', 1, NULL, NULL, 26, 48),
(17928, 5, 'product/48/28', 'accessories-17/cosmetics/custom-option.html', 'catalog/product/view/id/48/category/28', 1, NULL, NULL, 28, 48),
(17929, 5, 'product/48/33', 'women/bags/custom-option.html', 'catalog/product/view/id/48/category/33', 1, NULL, NULL, 33, 48),
(17930, 5, 'product/48/40', 'accessories-17/cfg-products/custom-option.html', 'catalog/product/view/id/48/category/40', 1, NULL, NULL, 40, 48),
(17931, 5, 'product/48/41', 'accessories-17/product-types/custom-option.html', 'catalog/product/view/id/48/category/41', 1, NULL, NULL, 41, 48),
(17932, 5, 'product/48/42', 'cameras-photography/custom-option.html', 'catalog/product/view/id/48/category/42', 1, NULL, NULL, 42, 48),
(17933, 5, 'product/48/43', 'tv-audio/custom-option.html', 'catalog/product/view/id/48/category/43', 1, NULL, NULL, 43, 48),
(17934, 5, 'product/48/44', 'laptops-computers/custom-option.html', 'catalog/product/view/id/48/category/44', 1, NULL, NULL, 44, 48),
(17935, 5, 'product/48/45', 'smart-phones-tablets/custom-option.html', 'catalog/product/view/id/48/category/45', 1, NULL, NULL, 45, 48),
(17936, 5, 'product/48/46', 'video-games-consoles/custom-option.html', 'catalog/product/view/id/48/category/46', 1, NULL, NULL, 46, 48),
(17937, 5, 'product/48/47', 'gadgets/custom-option.html', 'catalog/product/view/id/48/category/47', 1, NULL, NULL, 47, 48),
(17938, 5, 'product/48/48', 'car-electronics-gps/custom-option.html', 'catalog/product/view/id/48/category/48', 1, NULL, NULL, 48, 48),
(17939, 5, 'product/48/49', 'laptop/custom-option.html', 'catalog/product/view/id/48/category/49', 1, NULL, NULL, 49, 48),
(17940, 5, 'product/48/50', 'accessories/custom-option.html', 'catalog/product/view/id/48/category/50', 1, NULL, NULL, 50, 48),
(17941, 5, 'product/48/55', 'casio-watches/custom-option.html', 'catalog/product/view/id/48/category/55', 1, NULL, NULL, 55, 48),
(17942, 5, 'product/48/56', 'asus-tablets/custom-option.html', 'catalog/product/view/id/48/category/56', 1, NULL, NULL, 56, 48),
(17943, 5, 'product/48/57', 'women-fashion/custom-option.html', 'catalog/product/view/id/48/category/57', 1, NULL, NULL, 57, 48),
(17987, 1, '45024300_1431679385', 'accessories-11.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(18092, 1, '96233000_1431679386', 'accessories-11/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(18112, 1, '17934200_1431679387', 'accessories-11/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(18132, 1, '41535500_1431679387', 'accessories-11/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(18152, 1, '64236800_1431679387', 'accessories-11/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(18173, 1, '06239200_1431679388', 'accessories-11/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(18194, 1, '31940700_1431679388', 'accessories-11/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(18215, 1, '51741900_1431679388', 'accessories-11/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(18236, 1, '71843000_1431679388', 'accessories-11/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(18258, 1, '91744100_1431679388', 'accessories-11/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(18279, 1, '12145300_1431679389', 'accessories-11/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(18300, 1, '33546500_1431679389', 'accessories-11/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(18321, 1, '54147700_1431679389', 'accessories-11/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(18342, 1, '81749300_1431679389', 'accessories-11/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(18364, 1, '02950500_1431679390', 'accessories-11/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(18408, 1, '53753400_1431679390', 'accessories-11/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(18430, 1, '80054900_1431679390', 'accessories-11/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(18452, 1, '95055800_1431679390', 'accessories-11/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(18473, 1, '14756900_1431679391', 'accessories-11/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(18500, 1, '41658400_1431679391', 'accessories-11/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(18547, 2, '50764700_1431679392', 'accessories-11.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(18652, 2, '43075700_1431679394', 'accessories-11/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(18672, 2, '58776600_1431679394', 'accessories-11/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(18692, 2, '44981500_1431679395', 'accessories-11/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(18712, 2, '68882900_1431679395', 'accessories-11/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(18733, 2, '92784200_1431679395', 'accessories-11/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(18754, 2, '22685900_1431679396', 'accessories-11/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(18775, 2, '45187200_1431679396', 'accessories-11/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(18796, 2, '75088900_1431679396', 'accessories-11/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(18818, 2, '19491500_1431679397', 'accessories-11/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(18839, 2, '38592600_1431679397', 'accessories-11/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(18860, 2, '64594100_1431679397', 'accessories-11/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(18881, 2, '89895500_1431679397', 'accessories-11/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(18902, 2, '12996800_1431679398', 'accessories-11/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(18924, 2, '42298500_1431679398', 'accessories-11/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(18968, 2, '08402300_1431679399', 'accessories-11/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(18990, 2, '30203500_1431679399', 'accessories-11/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(19012, 2, '59005200_1431679399', 'accessories-11/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(19033, 2, '84506600_1431679399', 'accessories-11/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(19060, 2, '13508300_1431679400', 'accessories-11/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(19111, 3, '22020200_1431679402', 'accessories-1.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(19113, 3, '28420600_1431679402', 'accessories-1/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(19115, 3, '32920900_1431679402', 'accessories-1/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(19117, 3, '38621200_1431679402', 'accessories-1/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(19119, 3, '43421500_1431679402', 'accessories-1/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(19121, 3, '48221700_1431679402', 'accessories-1/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(19123, 3, '52722000_1431679402', 'accessories-1/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(19125, 3, '58622300_1431679402', 'accessories-1/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(19127, 3, '65722700_1431679402', 'accessories-1/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(19132, 3, '02624800_1431679403', 'accessories-1/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(19134, 3, '04424900_1431679403', 'accessories-1/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(19154, 3, '42527100_1431679403', 'accessories-1/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(19156, 3, '44327200_1431679403', 'accessories-1/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(19176, 3, '65128400_1431679403', 'accessories-1/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(19178, 3, '67028500_1431679403', 'accessories-1/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(19183, 3, '72428800_1431679403', 'accessories-1/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(19185, 3, '74528900_1431679403', 'accessories-1/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(19190, 3, '78529200_1431679403', 'accessories-1/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(19192, 3, '90229800_1431679403', 'accessories-1/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(19219, 3, '58833800_1431679404', 'accessories-1/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(19221, 3, '60933900_1431679404', 'accessories-1/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(19240, 3, '80735000_1431679404', 'accessories-1/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(19242, 3, '00236100_1431679405', 'accessories-1/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(19261, 3, '19437200_1431679405', 'accessories-1/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(19263, 3, '21537400_1431679405', 'accessories-1/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(19282, 3, '40238400_1431679405', 'accessories-1/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(19284, 3, '42338500_1431679405', 'accessories-1/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(19303, 3, '61839700_1431679405', 'accessories-1/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(19306, 3, '70940200_1431679405', 'accessories-1/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(19325, 3, '92441400_1431679405', 'accessories-1/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(19328, 3, '07242300_1431679406', 'accessories-1/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(19347, 3, '33743800_1431679406', 'accessories-1/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(19350, 3, '38744100_1431679406', 'accessories-1/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(19369, 3, '61645400_1431679406', 'accessories-1/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(19372, 3, '64945600_1431679406', 'accessories-1/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(19391, 3, '84646700_1431679406', 'accessories-1/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(19394, 3, '88546900_1431679406', 'accessories-1/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(19397, 3, '94047200_1431679406', 'accessories-1/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(19415, 3, '17348600_1431679407', 'accessories-1/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(19418, 3, '21748800_1431679407', 'accessories-1/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(19437, 3, '48750400_1431679407', 'accessories-1/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(19440, 3, '52950600_1431679407', 'accessories-1/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(19459, 3, '78252000_1431679407', 'accessories-1/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(19462, 3, '82052300_1431679407', 'accessories-1/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(19481, 3, '99853300_1431679407', 'accessories-1/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(19484, 3, '03553500_1431679408', 'accessories-1/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(19503, 3, '31255100_1431679408', 'accessories-1/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(19506, 3, '35255300_1431679408', 'accessories-1/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(19509, 3, '38255500_1431679408', 'accessories-1/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(19551, 3, '80757900_1431679408', 'accessories-1/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(19554, 3, '84058100_1431679408', 'accessories-1/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(19557, 3, '87558300_1431679408', 'accessories-1/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(19575, 3, '05759300_1431679409', 'accessories-1/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(19578, 3, '19460100_1431679409', 'accessories-1/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(19581, 3, '25060400_1431679409', 'accessories-1/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(19599, 3, '44561600_1431679409', 'accessories-1/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(19602, 3, '47761700_1431679409', 'accessories-1/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(19605, 3, '51261900_1431679409', 'accessories-1/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(19622, 3, '72163100_1431679409', 'accessories-1/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(19625, 3, '77363400_1431679409', 'accessories-1/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(19628, 3, '80963600_1431679409', 'accessories-1/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(19645, 3, '97964600_1431679409', 'accessories-1/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(19648, 3, '00864800_1431679410', 'accessories-1/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(19650, 3, '03164900_1431679410', 'accessories-1/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(19652, 3, '05565000_1431679410', 'accessories-1/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(19654, 3, '08565200_1431679410', 'accessories-1/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(19656, 3, '10865300_1431679410', 'accessories-1/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(19658, 3, '13765500_1431679410', 'accessories-1/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(19661, 3, '20465900_1431679410', 'accessories-1/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(19663, 3, '22766000_1431679410', 'accessories-1/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(19723, 4, '98576100_1431679411', 'accessories-1.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(19725, 4, '01276200_1431679412', 'accessories-1/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(19727, 4, '03476400_1431679412', 'accessories-1/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(19729, 4, '05676500_1431679412', 'accessories-1/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(19731, 4, '08876700_1431679412', 'accessories-1/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(19733, 4, '11476800_1431679412', 'accessories-1/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(19735, 4, '13676900_1431679412', 'accessories-1/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(19737, 4, '15777100_1431679412', 'accessories-1/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(19739, 4, '17977200_1431679412', 'accessories-1/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(19744, 4, '46778800_1431679412', 'accessories-1/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(19746, 4, '49779000_1431679412', 'accessories-1/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(19766, 4, '68480100_1431679412', 'accessories-1/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(19768, 4, '71780300_1431679412', 'accessories-1/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(19788, 4, '91581400_1431679412', 'accessories-1/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(19790, 4, '94181600_1431679412', 'accessories-1/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(19795, 4, '99281800_1431679412', 'accessories-1/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(19797, 4, '02382000_1431679413', 'accessories-1/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(19802, 4, '07982300_1431679413', 'accessories-1/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(19804, 4, '10282500_1431679413', 'accessories-1/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(19831, 4, '36184000_1431679413', 'accessories-1/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(19833, 4, '38384100_1431679413', 'accessories-1/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(19852, 4, '56485100_1431679413', 'accessories-1/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(19854, 4, '58885300_1431679413', 'accessories-1/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(19873, 4, '78786400_1431679413', 'accessories-1/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(19875, 4, '80886500_1431679413', 'accessories-1/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(19894, 4, '99387600_1431679413', 'accessories-1/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(19896, 4, '01487700_1431679414', 'accessories-1/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(19915, 4, '21388800_1431679414', 'accessories-1/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(19918, 4, '24789000_1431679414', 'accessories-1/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(19937, 4, '54090700_1431679414', 'accessories-1/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(19940, 4, '58090900_1431679414', 'accessories-1/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(19959, 4, '77292000_1431679414', 'accessories-1/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(19962, 4, '80392200_1431679414', 'accessories-1/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(19981, 4, '99493300_1431679414', 'accessories-1/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(19984, 4, '16094200_1431679415', 'accessories-1/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(20003, 4, '35995400_1431679415', 'accessories-1/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(20006, 4, '44295900_1431679415', 'accessories-1/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(20009, 4, '49296100_1431679415', 'accessories-1/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(20027, 4, '67297200_1431679415', 'accessories-1/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(20030, 4, '71397400_1431679415', 'accessories-1/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(20049, 4, '91298500_1431679415', 'accessories-1/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(20052, 4, '94198700_1431679415', 'accessories-1/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(20071, 4, '12799800_1431679416', 'accessories-1/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(20074, 4, '15699900_1431679416', 'accessories-1/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(20093, 4, '33901000_1431679416', 'accessories-1/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(20096, 4, '38001200_1431679416', 'accessories-1/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(20115, 4, '58302400_1431679416', 'accessories-1/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(20118, 4, '63602700_1431679416', 'accessories-1/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(20121, 4, '68202900_1431679416', 'accessories-1/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(20163, 4, '38307000_1431679417', 'accessories-1/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(20166, 4, '42407200_1431679417', 'accessories-1/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(20169, 4, '45807400_1431679417', 'accessories-1/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(20187, 4, '64208400_1431679417', 'accessories-1/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(20190, 4, '67408600_1431679417', 'accessories-1/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(20193, 4, '70508800_1431679417', 'accessories-1/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(20211, 4, '02410600_1431679418', 'accessories-1/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(20214, 4, '07710900_1431679418', 'accessories-1/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(20217, 4, '11511100_1431679418', 'accessories-1/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(20234, 4, '31612300_1431679418', 'accessories-1/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(20237, 4, '35212500_1431679418', 'accessories-1/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(20240, 4, '38412700_1431679418', 'accessories-1/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(20257, 4, '61514000_1431679418', 'accessories-1/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(20260, 4, '65614200_1431679418', 'accessories-1/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(20262, 4, '68614400_1431679418', 'accessories-1/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(20264, 4, '70814500_1431679418', 'accessories-1/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(20266, 4, '74214700_1431679418', 'accessories-1/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(20268, 4, '76614900_1431679418', 'accessories-1/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(20270, 4, '79115000_1431679418', 'accessories-1/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(20273, 4, '82315200_1431679418', 'accessories-1/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(20275, 4, '85115400_1431679418', 'accessories-1/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(20335, 5, '11622600_1431679420', 'accessories-1.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(20337, 5, '13822700_1431679420', 'accessories-1/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(20339, 5, '16022800_1431679420', 'accessories-1/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(20341, 5, '18523000_1431679420', 'accessories-1/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(20343, 5, '20623100_1431679420', 'accessories-1/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(20345, 5, '23223200_1431679420', 'accessories-1/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(20347, 5, '25423400_1431679420', 'accessories-1/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(20349, 5, '27823500_1431679420', 'accessories-1/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(20351, 5, '30123600_1431679420', 'accessories-1/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(20356, 5, '52024900_1431679420', 'accessories-1/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(20358, 5, '54225000_1431679420', 'accessories-1/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(20378, 5, '73626100_1431679420', 'accessories-1/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(20380, 5, '76226300_1431679420', 'accessories-1/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(20400, 5, '97727500_1431679420', 'accessories-1/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(20402, 5, '00627700_1431679421', 'accessories-1/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(20407, 5, '07528100_1431679421', 'accessories-1/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(20409, 5, '11028300_1431679421', 'accessories-1/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(20414, 5, '20128800_1431679421', 'accessories-1/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(20416, 5, '22929000_1431679421', 'accessories-1/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(20443, 5, '55330800_1431679421', 'accessories-1/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(20445, 5, '57830900_1431679421', 'accessories-1/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(20464, 5, '87432600_1431679421', 'accessories-1/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(20466, 5, '90032800_1431679421', 'accessories-1/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(20485, 5, '19034400_1431679422', 'accessories-1/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(20487, 5, '21734600_1431679422', 'accessories-1/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(20506, 5, '49936200_1431679422', 'accessories-1/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(20508, 5, '52136300_1431679422', 'accessories-1/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(20527, 5, '74137600_1431679422', 'accessories-1/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(20530, 5, '78437800_1431679422', 'accessories-1/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(20549, 5, '99239000_1431679422', 'accessories-1/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(20552, 5, '02439200_1431679423', 'accessories-1/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(20571, 5, '24940500_1431679423', 'accessories-1/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(20574, 5, '29640800_1431679423', 'accessories-1/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(20593, 5, '54142200_1431679423', 'accessories-1/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(20596, 5, '59042500_1431679423', 'accessories-1/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(20615, 5, '78543600_1431679423', 'accessories-1/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(20618, 5, '81643700_1431679423', 'accessories-1/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(20621, 5, '84343900_1431679423', 'accessories-1/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(20639, 5, '99244800_1431679423', 'accessories-1/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(20642, 5, '02244900_1431679424', 'accessories-1/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(20661, 5, '28746400_1431679424', 'accessories-1/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(20664, 5, '31746600_1431679424', 'accessories-1/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(20683, 5, '51947800_1431679424', 'accessories-1/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(20686, 5, '55047900_1431679424', 'accessories-1/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(20705, 5, '72949000_1431679424', 'accessories-1/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(20708, 5, '78149300_1431679424', 'accessories-1/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(20727, 5, '99950500_1431679424', 'accessories-1/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(20730, 5, '03050700_1431679425', 'accessories-1/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(20733, 5, '06050900_1431679425', 'accessories-1/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(20775, 5, '87555500_1431679425', 'accessories-1/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(20778, 5, '98056100_1431679425', 'accessories-1/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(20781, 5, '01456300_1431679426', 'accessories-1/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(20799, 5, '21657500_1431679426', 'accessories-1/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(20802, 5, '26857800_1431679426', 'accessories-1/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(20805, 5, '31158000_1431679426', 'accessories-1/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(20823, 5, '50359100_1431679426', 'accessories-1/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(20826, 5, '56459500_1431679426', 'accessories-1/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(20829, 5, '61259700_1431679426', 'accessories-1/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(20846, 5, '79760800_1431679426', 'accessories-1/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(20849, 5, '82861000_1431679426', 'accessories-1/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(20852, 5, '87461200_1431679426', 'accessories-1/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(20869, 5, '04862200_1431679427', 'accessories-1/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(20872, 5, '08062400_1431679427', 'accessories-1/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(20874, 5, '11462600_1431679427', 'accessories-1/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(20876, 5, '13962800_1431679427', 'accessories-1/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(20878, 5, '16662900_1431679427', 'accessories-1/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(20880, 5, '18963000_1431679427', 'accessories-1/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(20882, 5, '21363200_1431679427', 'accessories-1/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(20885, 5, '25163400_1431679427', 'accessories-1/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(20887, 5, '29063600_1431679427', 'accessories-1/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(20931, 1, '26969900_1432116059', 'accessories-12.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(21036, 1, '96779700_1432116060', 'accessories-12/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(21056, 1, '47682600_1432116061', 'accessories-12/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(21076, 1, '80184400_1432116061', 'accessories-12/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(21096, 1, '14286400_1432116062', 'accessories-12/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(21117, 1, '39087800_1432116062', 'accessories-12/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(21138, 1, '81390200_1432116062', 'accessories-12/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(21159, 1, '11391900_1432116063', 'accessories-12/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(21180, 1, '55894500_1432116063', 'accessories-12/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(21202, 1, '14397800_1432116064', 'accessories-12/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(21223, 1, '55700200_1432116064', 'accessories-12/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(21244, 1, '89302100_1432116064', 'accessories-12/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(21265, 1, '38304900_1432116065', 'accessories-12/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(21286, 1, '81907400_1432116065', 'accessories-12/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(21308, 1, '14109200_1432116066', 'accessories-12/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(21352, 1, '97114000_1432116066', 'accessories-12/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(21374, 1, '58417500_1432116067', 'accessories-12/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(21396, 1, '30621600_1432116068', 'accessories-12/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(21417, 1, '73724100_1432116068', 'accessories-12/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(21444, 1, '00231300_1432116070', 'accessories-12/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(21491, 2, '91742300_1432116071', 'accessories-12.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(21596, 2, '60574800_1432116077', 'accessories-12/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(21616, 2, '93876700_1432116077', 'accessories-12/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(21636, 2, '34979100_1432116078', 'accessories-12/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(21656, 2, '64180700_1432116078', 'accessories-12/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(21677, 2, '91082300_1432116078', 'accessories-12/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(21698, 2, '27384400_1432116079', 'accessories-12/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(21719, 2, '66486600_1432116079', 'accessories-12/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(21740, 2, '26690000_1432116080', 'accessories-12/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(21762, 2, '70592600_1432116080', 'accessories-12/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(21783, 2, '11194900_1432116081', 'accessories-12/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(21804, 2, '40296500_1432116081', 'accessories-12/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(21825, 2, '60297700_1432116081', 'accessories-12/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(21846, 2, '87099200_1432116081', 'accessories-12/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(21868, 2, '10800600_1432116082', 'accessories-12/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(21912, 2, '64703700_1432116082', 'accessories-12/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(21934, 2, '93405300_1432116082', 'accessories-12/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(21956, 2, '25307100_1432116083', 'accessories-12/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(21977, 2, '56108900_1432116083', 'accessories-12/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(22004, 2, '02011500_1432116084', 'accessories-12/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(22055, 3, '92233800_1432116087', 'accessories-2.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(22057, 3, '98234200_1432116087', 'accessories-2/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(22059, 3, '12835000_1432116088', 'accessories-2/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(22061, 3, '20135400_1432116088', 'accessories-2/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(22063, 3, '33436200_1432116088', 'accessories-2/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(22065, 3, '39536500_1432116088', 'accessories-2/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(22067, 3, '92939600_1432116088', 'accessories-2/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(22069, 3, '97039800_1432116088', 'accessories-2/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(22071, 3, '02940200_1432116089', 'accessories-2/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(22076, 3, '59143400_1432116089', 'accessories-2/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(22078, 3, '63143600_1432116089', 'accessories-2/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(22098, 3, '26047200_1432116090', 'accessories-2/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(22100, 3, '40148000_1432116090', 'accessories-2/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(22120, 3, '75650000_1432116090', 'accessories-2/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(22122, 3, '78950200_1432116090', 'accessories-2/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(22127, 3, '85250600_1432116090', 'accessories-2/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(22129, 3, '88650800_1432116090', 'accessories-2/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(22134, 3, '95051100_1432116090', 'accessories-2/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(22136, 3, '98151300_1432116090', 'accessories-2/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(22163, 3, '32353300_1432116091', 'accessories-2/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(22165, 3, '35353500_1432116091', 'accessories-2/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(22184, 3, '64255100_1432116091', 'accessories-2/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(22186, 3, '66855300_1432116091', 'accessories-2/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(22205, 3, '88056500_1432116091', 'accessories-2/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(22207, 3, '91556700_1432116091', 'accessories-2/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(22226, 3, '08757700_1432116092', 'accessories-2/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(22228, 3, '11757800_1432116092', 'accessories-2/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(22247, 3, '29858900_1432116092', 'accessories-2/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(22250, 3, '33259100_1432116092', 'accessories-2/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(22269, 3, '56160400_1432116092', 'accessories-2/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(22272, 3, '60960600_1432116092', 'accessories-2/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(22291, 3, '80861800_1432116092', 'accessories-2/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(22294, 3, '87662200_1432116092', 'accessories-2/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(22313, 3, '03263100_1432116093', 'accessories-2/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(22316, 3, '05863200_1432116093', 'accessories-2/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(22335, 3, '24364300_1432116093', 'accessories-2/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(22338, 3, '27764500_1432116093', 'accessories-2/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(22341, 3, '31864700_1432116093', 'accessories-2/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(22359, 3, '62966500_1432116093', 'accessories-2/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(22362, 3, '66866700_1432116093', 'accessories-2/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(22381, 3, '94468300_1432116093', 'accessories-2/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(22384, 3, '98868500_1432116093', 'accessories-2/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(22403, 3, '31770400_1432116094', 'accessories-2/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(22406, 3, '37170700_1432116094', 'accessories-2/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(22425, 3, '64772300_1432116094', 'accessories-2/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(22428, 3, '70172600_1432116094', 'accessories-2/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(22447, 3, '92373900_1432116094', 'accessories-2/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(22450, 3, '96574100_1432116094', 'accessories-2/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(22453, 3, '02874500_1432116095', 'accessories-2/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(22495, 3, '56177500_1432116095', 'accessories-2/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(22498, 3, '59577700_1432116095', 'accessories-2/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(22501, 3, '62477900_1432116095', 'accessories-2/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(22519, 3, '82479000_1432116095', 'accessories-2/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(22522, 3, '87779300_1432116095', 'accessories-2/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(22525, 3, '91979600_1432116095', 'accessories-2/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(22543, 3, '12380700_1432116096', 'accessories-2/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(22546, 3, '18181100_1432116096', 'accessories-2/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(22549, 3, '22881300_1432116096', 'accessories-2/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(22566, 3, '42782500_1432116096', 'accessories-2/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(22569, 3, '46582700_1432116096', 'accessories-2/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(22572, 3, '50482900_1432116096', 'accessories-2/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(22589, 3, '66983900_1432116096', 'accessories-2/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(22592, 3, '70484100_1432116096', 'accessories-2/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(22594, 3, '73784200_1432116096', 'accessories-2/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(22596, 3, '76584400_1432116096', 'accessories-2/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(22598, 3, '79084600_1432116096', 'accessories-2/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(22600, 3, '81984700_1432116096', 'accessories-2/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(22602, 3, '84384900_1432116096', 'accessories-2/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(22605, 3, '88485100_1432116096', 'accessories-2/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(22607, 3, '90985200_1432116096', 'accessories-2/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(22667, 4, '22692800_1432116098', 'accessories-2.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(22669, 4, '26893000_1432116098', 'accessories-2/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(22671, 4, '30493200_1432116098', 'accessories-2/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(22673, 4, '34393400_1432116098', 'accessories-2/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(22675, 4, '41293800_1432116098', 'accessories-2/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(22677, 4, '47594200_1432116098', 'accessories-2/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(22679, 4, '95196900_1432116098', 'accessories-2/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(22681, 4, '97297000_1432116098', 'accessories-2/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(22683, 4, '99397200_1432116098', 'accessories-2/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(22688, 4, '21098400_1432116099', 'accessories-2/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(22690, 4, '26698700_1432116099', 'accessories-2/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(22710, 4, '54800300_1432116099', 'accessories-2/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(22712, 4, '58500500_1432116099', 'accessories-2/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(22732, 4, '87102200_1432116099', 'accessories-2/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(22734, 4, '90402400_1432116099', 'accessories-2/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(22739, 4, '98702800_1432116099', 'accessories-2/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(22741, 4, '02403000_1432116100', 'accessories-2/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(22746, 4, '11403600_1432116100', 'accessories-2/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(22748, 4, '15303800_1432116100', 'accessories-2/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(22775, 4, '52905900_1432116100', 'accessories-2/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(22777, 4, '56206100_1432116100', 'accessories-2/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(22796, 4, '88208000_1432116100', 'accessories-2/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(22798, 4, '92108200_1432116100', 'accessories-2/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(22817, 4, '22109900_1432116101', 'accessories-2/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(22819, 4, '25710100_1432116101', 'accessories-2/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(22838, 4, '52211600_1432116101', 'accessories-2/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(22840, 4, '55611800_1432116101', 'accessories-2/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(22859, 4, '82913400_1432116101', 'accessories-2/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(22862, 4, '88213700_1432116101', 'accessories-2/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(22881, 4, '22815700_1432116102', 'accessories-2/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(22884, 4, '30016100_1432116102', 'accessories-2/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(22903, 4, '51517300_1432116102', 'accessories-2/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(22906, 4, '54217400_1432116102', 'accessories-2/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(22925, 4, '75018600_1432116102', 'accessories-2/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(22928, 4, '78118800_1432116102', 'accessories-2/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(22947, 4, '98920000_1432116102', 'accessories-2/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(22950, 4, '04120300_1432116103', 'accessories-2/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(22953, 4, '09520600_1432116103', 'accessories-2/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(22971, 4, '39622300_1432116103', 'accessories-2/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(22974, 4, '45522700_1432116103', 'accessories-2/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(22993, 4, '76124400_1432116103', 'accessories-2/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(22996, 4, '81324700_1432116103', 'accessories-2/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(23015, 4, '10426400_1432116104', 'accessories-2/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(23018, 4, '14726600_1432116104', 'accessories-2/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(23037, 4, '45628400_1432116104', 'accessories-2/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(23040, 4, '53028800_1432116104', 'accessories-2/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(23059, 4, '88730900_1432116104', 'accessories-2/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(23062, 4, '94331200_1432116104', 'accessories-2/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(23065, 4, '03731700_1432116105', 'accessories-2/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(23107, 4, '70435500_1432116105', 'accessories-2/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(23110, 4, '74635800_1432116105', 'accessories-2/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(23113, 4, '79536100_1432116105', 'accessories-2/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(23131, 4, '07637700_1432116106', 'accessories-2/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(23134, 4, '11837900_1432116106', 'accessories-2/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(23137, 4, '15238100_1432116106', 'accessories-2/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(23155, 4, '57440500_1432116106', 'accessories-2/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(23158, 4, '61640800_1432116106', 'accessories-2/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(23161, 4, '66141000_1432116106', 'accessories-2/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(23178, 4, '92842500_1432116106', 'accessories-2/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(23181, 4, '96442700_1432116106', 'accessories-2/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(23184, 4, '99742900_1432116106', 'accessories-2/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(23201, 4, '23944300_1432116107', 'accessories-2/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(23204, 4, '29344600_1432116107', 'accessories-2/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(23206, 4, '32844800_1432116107', 'accessories-2/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(23208, 4, '36145000_1432116107', 'accessories-2/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(23210, 4, '38945200_1432116107', 'accessories-2/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(23212, 4, '41445300_1432116107', 'accessories-2/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(23214, 4, '44345500_1432116107', 'accessories-2/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(23217, 4, '48345700_1432116107', 'accessories-2/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(23219, 4, '51745900_1432116107', 'accessories-2/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(23279, 5, '51557300_1432116109', 'accessories-2.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(23281, 5, '85559300_1432116109', 'accessories-2/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(23283, 5, '88859500_1432116109', 'accessories-2/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(23285, 5, '91859600_1432116109', 'accessories-2/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(23287, 5, '28961800_1432116110', 'accessories-2/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(23289, 5, '74264400_1432116110', 'accessories-2/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(23291, 5, '77964600_1432116110', 'accessories-2/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(23293, 5, '81464800_1432116110', 'accessories-2/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(23295, 5, '84164900_1432116110', 'accessories-2/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(23300, 5, '10466400_1432116111', 'accessories-2/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(23302, 5, '13866600_1432116111', 'accessories-2/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(23322, 5, '39968100_1432116111', 'accessories-2/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(23324, 5, '44568400_1432116111', 'accessories-2/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(23344, 5, '76370200_1432116111', 'accessories-2/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(23346, 5, '78970300_1432116111', 'accessories-2/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(23351, 5, '86270800_1432116111', 'accessories-2/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(23353, 5, '88970900_1432116111', 'accessories-2/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(23358, 5, '94571200_1432116111', 'accessories-2/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(23360, 5, '96771400_1432116111', 'accessories-2/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(23387, 5, '31073300_1432116112', 'accessories-2/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(23389, 5, '34673500_1432116112', 'accessories-2/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(23408, 5, '57974900_1432116112', 'accessories-2/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(23410, 5, '61075000_1432116112', 'accessories-2/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(23429, 5, '03977500_1432116113', 'accessories-2/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(23431, 5, '08477700_1432116113', 'accessories-2/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(23450, 5, '59880700_1432116113', 'accessories-2/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(23452, 5, '74781500_1432116113', 'accessories-2/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(23471, 5, '06383300_1432116114', 'accessories-2/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(23474, 5, '15583900_1432116114', 'accessories-2/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(23493, 5, '40385300_1432116114', 'accessories-2/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(23496, 5, '44985600_1432116114', 'accessories-2/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(23515, 5, '70787000_1432116114', 'accessories-2/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(23518, 5, '87888000_1432116114', 'accessories-2/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(23537, 5, '43891200_1432116115', 'accessories-2/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(23540, 5, '54491800_1432116115', 'accessories-2/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(23559, 5, '81093300_1432116115', 'accessories-2/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(23562, 5, '84493500_1432116115', 'accessories-2/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(23565, 5, '87693700_1432116115', 'accessories-2/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(23583, 5, '15095300_1432116116', 'accessories-2/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(23586, 5, '21295600_1432116116', 'accessories-2/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(23605, 5, '49697300_1432116116', 'accessories-2/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(23608, 5, '55797600_1432116116', 'accessories-2/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(23627, 5, '91299600_1432116116', 'accessories-2/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(23630, 5, '96399900_1432116116', 'accessories-2/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(23649, 5, '30601900_1432116117', 'accessories-2/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(23652, 5, '35902200_1432116117', 'accessories-2/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(23671, 5, '67204000_1432116117', 'accessories-2/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(23674, 5, '72304300_1432116117', 'accessories-2/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(23677, 5, '78904700_1432116117', 'accessories-2/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(23719, 5, '47808600_1432116118', 'accessories-2/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(23722, 5, '52308900_1432116118', 'accessories-2/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(23725, 5, '59609300_1432116118', 'accessories-2/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(23743, 5, '93011200_1432116118', 'accessories-2/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(23746, 5, '97311400_1432116118', 'accessories-2/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(23749, 5, '01911700_1432116119', 'accessories-2/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(23767, 5, '32113400_1432116119', 'accessories-2/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(23770, 5, '36013600_1432116119', 'accessories-2/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(23773, 5, '40213900_1432116119', 'accessories-2/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(23790, 5, '59115000_1432116119', 'accessories-2/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(23793, 5, '63815200_1432116119', 'accessories-2/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(23796, 5, '67615400_1432116119', 'accessories-2/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(23813, 5, '92716900_1432116119', 'accessories-2/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(23816, 5, '18418400_1432116120', 'accessories-2/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(23818, 5, '21518500_1432116120', 'accessories-2/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(23820, 5, '24318700_1432116120', 'accessories-2/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(23822, 5, '27918900_1432116120', 'accessories-2/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(23824, 5, '31319100_1432116120', 'accessories-2/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(23826, 5, '34619300_1432116120', 'accessories-2/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(23829, 5, '40319600_1432116120', 'accessories-2/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(23831, 5, '46320000_1432116120', 'accessories-2/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(23868, 1, '76909200_1432631234', 'accessories/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(23870, 1, '82619800_1432631234', 'accessories/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(23872, 1, '89979500_1432631234', 'accessories/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(23874, 1, '95480700_1432631234', 'accessories/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(23883, 1, '29148600_1432631235', 'accessories-13.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(23974, 1, '46072500_1432631237', 'accessories/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(23985, 1, '71203800_1432631237', 'accessories-13/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(23995, 1, '93680700_1432631237', 'accessories/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(24006, 1, '13213600_1432631238', 'accessories-13/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(24016, 1, '37641500_1432631238', 'accessories/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(24027, 1, '58240300_1432631238', 'accessories-13/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(24037, 1, '72443400_1432631238', 'accessories/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(24048, 1, '96925800_1432631238', 'accessories-13/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(24059, 1, '17367300_1432631239', 'accessories/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(24070, 1, '37072300_1432631239', 'accessories-13/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(24081, 1, '65349400_1432631239', 'accessories/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(24092, 1, '84221400_1432631239', 'accessories-13/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(24103, 1, '03635100_1432631240', 'accessories/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(24114, 1, '24494700_1432631240', 'accessories-13/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(24125, 1, '46412600_1432631240', 'accessories/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(24136, 1, '67166400_1432631240', 'accessories-13/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(24147, 1, '89231000_1432631240', 'accessories/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(24159, 1, '10209600_1432631241', 'accessories-13/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(24170, 1, '29569700_1432631241', 'accessories/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(24181, 1, '50178600_1432631241', 'accessories-13/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(24192, 1, '69220300_1432631241', 'accessories/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(24203, 1, '88474900_1432631241', 'accessories-13/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(24214, 1, '13418200_1432631242', 'accessories/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(24225, 1, '42182000_1432631242', 'accessories-13/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(24236, 1, '62549600_1432631242', 'accessories/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(24247, 1, '81650600_1432631242', 'accessories-13/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(24258, 1, '00823000_1432631243', 'accessories/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(24270, 1, '22862700_1432631243', 'accessories-13/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(24304, 1, '82409000_1432631243', 'accessories/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(24316, 1, '07334300_1432631244', 'accessories-13/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(24327, 1, '28397900_1432631244', 'accessories/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(24339, 1, '55273100_1432631244', 'accessories-13/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(24350, 1, '74810100_1432631244', 'accessories/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(24362, 1, '96875300_1432631244', 'accessories-13/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(24372, 1, '15624700_1432631245', 'accessories/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(24384, 1, '38083800_1432631245', 'accessories-13/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(24394, 1, '56812100_1432631245', 'accessories/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(24396, 1, '60454800_1432631245', 'accessories/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(24398, 1, '64629700_1432631245', 'accessories/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(24400, 1, '68582500_1432631245', 'accessories/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(24415, 1, '96092500_1432631245', 'accessories-13/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(24455, 2, '49666600_1432631247', 'accessories/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(24457, 2, '54461500_1432631247', 'accessories/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(24459, 2, '59348600_1432631247', 'accessories/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(24461, 2, '63684500_1432631247', 'accessories/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(24470, 2, '02514000_1432631248', 'accessories-13.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(24561, 2, '85639500_1432631249', 'accessories/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(24572, 2, '05325200_1432631250', 'accessories-13/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(24582, 2, '23060400_1432631250', 'accessories/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(24593, 2, '41693900_1432631250', 'accessories-13/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(24603, 2, '59601000_1432631250', 'accessories/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(24614, 2, '78918700_1432631250', 'accessories-13/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(24624, 2, '97206500_1432631250', 'accessories/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(24635, 2, '18869900_1432631251', 'accessories-13/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(24646, 2, '39224700_1432631251', 'accessories/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(24657, 2, '60477300_1432631251', 'accessories-13/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(24668, 2, '81199700_1432631251', 'accessories/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(24679, 2, '01676000_1432631252', 'accessories-13/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(24690, 2, '20895900_1432631252', 'accessories/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(24701, 2, '47432300_1432631252', 'accessories-13/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(24712, 2, '68840000_1432631252', 'accessories/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(24723, 2, '87658000_1432631252', 'accessories-13/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(24734, 2, '14815000_1432631253', 'accessories/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(24746, 2, '47299200_1432631253', 'accessories-13/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(24757, 2, '66602600_1432631253', 'accessories/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(24768, 2, '86497900_1432631253', 'accessories-13/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(24779, 2, '08068500_1432631254', 'accessories/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(24790, 2, '35911600_1432631254', 'accessories-13/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(24801, 2, '76292000_1432631254', 'accessories/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(24812, 2, '93978200_1432631254', 'accessories-13/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(24823, 2, '09245800_1432631255', 'accessories/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(24834, 2, '28145900_1432631255', 'accessories-13/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(24845, 2, '46005600_1432631255', 'accessories/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(24857, 2, '67690100_1432631255', 'accessories-13/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(24891, 2, '55373700_1432631256', 'accessories/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(24903, 2, '78959800_1432631256', 'accessories-13/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(24914, 2, '01847100_1432631257', 'accessories/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(24926, 2, '25681900_1432631257', 'accessories-13/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(24937, 2, '48782700_1432631257', 'accessories/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(24949, 2, '71506100_1432631257', 'accessories-13/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(24959, 2, '91853900_1432631257', 'accessories/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(24971, 2, '16291500_1432631258', 'accessories-13/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(24981, 2, '36891300_1432631258', 'accessories/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(24983, 2, '41716000_1432631258', 'accessories/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(24985, 2, '46524000_1432631258', 'accessories/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(24987, 2, '50430200_1432631258', 'accessories/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(25002, 2, '80979000_1432631258', 'accessories-13/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(25042, 3, '31673300_1432631260', 'accessories-3/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(25044, 3, '36845700_1432631260', 'accessories-3/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(25046, 3, '41206900_1432631260', 'accessories-3/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(25048, 3, '45620700_1432631260', 'accessories-3/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(25061, 3, '92451600_1432631260', 'accessories-3.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(25063, 3, '96822500_1432631260', 'accessories-3/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(25065, 3, '01276100_1432631261', 'accessories-3/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(25067, 3, '06063500_1432631261', 'accessories-3/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(25069, 3, '10407900_1432631261', 'accessories-3/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(25074, 3, '28564800_1432631261', 'accessories-3/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(25076, 3, '32816700_1432631261', 'accessories-3/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(25096, 3, '68000200_1432631261', 'accessories-3/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(25098, 3, '72215000_1432631261', 'accessories-3/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(25118, 3, '09233300_1432631262', 'accessories-3/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(25120, 3, '13066300_1432631262', 'accessories-3/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(25125, 3, '22807000_1432631262', 'accessories-3/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(25127, 3, '26822900_1432631262', 'accessories-3/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(25132, 3, '37606200_1432631262', 'accessories-3/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(25134, 3, '42095300_1432631262', 'accessories-3/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(25161, 3, '90812000_1432631262', 'accessories-3/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(25163, 3, '94957800_1432631262', 'accessories-3/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(25182, 3, '39377900_1432631263', 'accessories-3/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(25184, 3, '43622700_1432631263', 'accessories-3/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(25203, 3, '76407400_1432631263', 'accessories-3/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(25205, 3, '80418300_1432631263', 'accessories-3/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(25224, 3, '17219500_1432631264', 'accessories-3/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(25226, 3, '21311200_1432631264', 'accessories-3/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(25245, 3, '58403600_1432631264', 'accessories-3/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(25248, 3, '66746600_1432631264', 'accessories-3/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(25267, 3, '99215100_1432631264', 'accessories-3/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(25270, 3, '06672300_1432631265', 'accessories-3/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(25289, 3, '40413000_1432631265', 'accessories-3/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(25292, 3, '46422000_1432631265', 'accessories-3/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(25311, 3, '79657700_1432631265', 'accessories-3/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(25314, 3, '85209100_1432631265', 'accessories-3/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(25333, 3, '18401700_1432631266', 'accessories-3/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(25336, 3, '24116800_1432631266', 'accessories-3/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(25339, 3, '29327600_1432631266', 'accessories-3/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(25357, 3, '67260000_1432631266', 'accessories-3/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(25360, 3, '72813300_1432631266', 'accessories-3/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(25379, 3, '14532900_1432631267', 'accessories-3/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(25382, 3, '20475800_1432631267', 'accessories-3/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(25401, 3, '56834400_1432631267', 'accessories-3/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(25404, 3, '63236100_1432631267', 'accessories-3/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(25423, 3, '98884300_1432631267', 'accessories-3/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(25426, 3, '04415700_1432631268', 'accessories-3/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(25445, 3, '38411000_1432631268', 'accessories-3/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(25448, 3, '43679800_1432631268', 'accessories-3/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(25451, 3, '49205100_1432631268', 'accessories-3/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(25493, 3, '32015600_1432631269', 'accessories-3/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(25496, 3, '39218900_1432631269', 'accessories-3/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(25499, 3, '45476500_1432631269', 'accessories-3/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(25517, 3, '90801300_1432631269', 'accessories-3/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(25520, 3, '97651700_1432631269', 'accessories-3/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(25523, 3, '02810300_1432631270', 'accessories-3/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(25541, 3, '39439400_1432631270', 'accessories-3/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(25544, 3, '45216900_1432631270', 'accessories-3/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(25547, 3, '68512000_1432631270', 'accessories-3/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(25564, 3, '01337200_1432631271', 'accessories-3/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(25567, 3, '12195300_1432631271', 'accessories-3/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(25570, 3, '21609700_1432631271', 'accessories-3/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(25587, 3, '53425500_1432631271', 'accessories-3/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(25590, 3, '61329800_1432631271', 'accessories-3/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(25592, 3, '66021800_1432631271', 'accessories-3/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(25594, 3, '70127700_1432631271', 'accessories-3/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(25596, 3, '74090500_1432631271', 'accessories-3/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(25598, 3, '78011400_1432631271', 'accessories-3/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(25600, 3, '82264000_1432631271', 'accessories-3/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(25603, 3, '88248500_1432631271', 'accessories-3/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(25605, 3, '92044800_1432631271', 'accessories-3/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(25654, 4, '91601900_1432631273', 'accessories-3/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(25656, 4, '96023900_1432631273', 'accessories-3/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(25658, 4, '00001500_1432631274', 'accessories-3/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(25660, 4, '04166000_1432631274', 'accessories-3/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(25673, 4, '51491800_1432631274', 'accessories-3.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(25675, 4, '57739100_1432631274', 'accessories-3/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(25677, 4, '70407400_1432631274', 'accessories-3/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(25679, 4, '83490600_1432631274', 'accessories-3/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(25681, 4, '96487700_1432631274', 'accessories-3/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(25686, 4, '14813300_1432631275', 'accessories-3/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(25688, 4, '18601300_1432631275', 'accessories-3/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(25708, 4, '56962400_1432631275', 'accessories-3/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(25710, 4, '61334200_1432631275', 'accessories-3/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(25730, 4, '20578300_1432631276', 'accessories-3/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(25732, 4, '25021700_1432631276', 'accessories-3/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(25737, 4, '35368800_1432631276', 'accessories-3/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(25739, 4, '39080400_1432631276', 'accessories-3/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(25744, 4, '49199100_1432631276', 'accessories-3/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(25746, 4, '54092000_1432631276', 'accessories-3/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(25773, 4, '19298600_1432631277', 'accessories-3/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(25775, 4, '24073800_1432631277', 'accessories-3/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(25794, 4, '68379000_1432631277', 'accessories-3/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(25796, 4, '73161600_1432631277', 'accessories-3/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(25815, 4, '22199000_1432631278', 'accessories-3/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(25817, 4, '26856100_1432631278', 'accessories-3/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(25836, 4, '69369200_1432631278', 'accessories-3/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(25838, 4, '74659500_1432631278', 'accessories-3/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(25857, 4, '17103700_1432631279', 'accessories-3/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(25860, 4, '23537100_1432631279', 'accessories-3/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(25879, 4, '63391700_1432631279', 'accessories-3/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(25882, 4, '74569000_1432631279', 'accessories-3/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(25901, 4, '14817200_1432631280', 'accessories-3/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(25904, 4, '20832400_1432631280', 'accessories-3/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(25923, 4, '57007900_1432631280', 'accessories-3/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(25926, 4, '65219800_1432631280', 'accessories-3/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(25945, 4, '03196200_1432631281', 'accessories-3/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(25948, 4, '09597800_1432631281', 'accessories-3/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(25951, 4, '15358700_1432631281', 'accessories-3/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(25969, 4, '54046900_1432631281', 'accessories-3/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(25972, 4, '59760900_1432631281', 'accessories-3/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(25991, 4, '05204000_1432631282', 'accessories-3/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(25994, 4, '11276800_1432631282', 'accessories-3/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(26013, 4, '52256000_1432631282', 'accessories-3/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(26016, 4, '59012200_1432631282', 'accessories-3/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(26035, 4, '94785600_1432631282', 'accessories-3/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(26038, 4, '00893800_1432631283', 'accessories-3/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(26057, 4, '34489700_1432631283', 'accessories-3/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(26060, 4, '89518700_1432631283', 'accessories-3/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(26063, 4, '96024400_1432631283', 'accessories-3/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(26105, 4, '90800200_1432631284', 'accessories-3/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(26108, 4, '01968100_1432631285', 'accessories-3/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(26111, 4, '08504000_1432631285', 'accessories-3/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(26129, 4, '43243100_1432631285', 'accessories-3/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(26132, 4, '52021700_1432631285', 'accessories-3/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(26135, 4, '58403000_1432631285', 'accessories-3/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(26153, 4, '94194100_1432631285', 'accessories-3/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(26156, 4, '99615700_1432631285', 'accessories-3/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(26159, 4, '05191100_1432631286', 'accessories-3/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(26176, 4, '37225000_1432631286', 'accessories-3/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(26179, 4, '42817000_1432631286', 'accessories-3/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(26182, 4, '48803600_1432631286', 'accessories-3/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(26199, 4, '81193900_1432631286', 'accessories-3/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(26202, 4, '86795200_1432631286', 'accessories-3/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(26204, 4, '91394000_1432631286', 'accessories-3/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(26206, 4, '95211300_1432631286', 'accessories-3/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(26208, 4, '00821800_1432631287', 'accessories-3/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(26210, 4, '05074000_1432631287', 'accessories-3/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(26212, 4, '09379200_1432631287', 'accessories-3/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(26215, 4, '15465900_1432631287', 'accessories-3/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(26217, 4, '19014000_1432631287', 'accessories-3/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(26266, 5, '98228900_1432631288', 'accessories-3/bicycle.html', 'tv-audio/bicycle.html', 0, 'RP', NULL, 19, NULL),
(26268, 5, '02437600_1432631289', 'accessories-3/bicycle/jackets.html', 'tv-audio/bicycle/jackets.html', 0, 'RP', NULL, 20, NULL),
(26270, 5, '06792700_1432631289', 'accessories-3/bicycle/scarves.html', 'tv-audio/bicycle/scarves.html', 0, 'RP', NULL, 24, NULL),
(26272, 5, '11899000_1432631289', 'accessories-3/bicycle/lifestyle.html', 'tv-audio/bicycle/lifestyle.html', 0, 'RP', NULL, 25, NULL),
(26285, 5, '63025800_1432631289', 'accessories-3.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(26287, 5, '68378900_1432631289', 'accessories-3/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(26289, 5, '72399700_1432631289', 'accessories-3/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(26291, 5, '76800200_1432631289', 'accessories-3/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(26293, 5, '80442300_1432631289', 'accessories-3/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(26298, 5, '00926300_1432631290', 'accessories-3/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(26300, 5, '07052100_1432631290', 'accessories-3/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(26320, 5, '45194600_1432631290', 'accessories-3/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(26322, 5, '50853300_1432631290', 'accessories-3/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(26342, 5, '99857000_1432631290', 'accessories-3/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(26344, 5, '07360500_1432631291', 'accessories-3/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(26349, 5, '16788500_1432631291', 'accessories-3/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(26351, 5, '21460100_1432631291', 'accessories-3/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(26356, 5, '31604400_1432631291', 'accessories-3/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(26358, 5, '37026400_1432631291', 'accessories-3/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(26385, 5, '87683200_1432631291', 'accessories-3/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(26387, 5, '92092100_1432631291', 'accessories-3/bicycle/configurable-product-04-red.html', 'tv-audio/bicycle/configurable-product-04-red.html', 0, 'RP', NULL, 19, 29),
(26406, 5, '28420900_1432631292', 'accessories-3/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(26408, 5, '32300200_1432631292', 'accessories-3/bicycle/configurable-product-04-green.html', 'tv-audio/bicycle/configurable-product-04-green.html', 0, 'RP', NULL, 19, 30),
(26427, 5, '66915800_1432631292', 'accessories-3/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(26429, 5, '70813800_1432631292', 'accessories-3/bicycle/configurable-product-04-blue.html', 'tv-audio/bicycle/configurable-product-04-blue.html', 0, 'RP', NULL, 19, 31),
(26448, 5, '07333900_1432631293', 'accessories-3/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(26450, 5, '11196200_1432631293', 'accessories-3/bicycle/configurable-product-05-armani.html', 'tv-audio/bicycle/configurable-product-05-armani.html', 0, 'RP', NULL, 19, 32),
(26469, 5, '50783500_1432631293', 'accessories-3/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(26472, 5, '57063500_1432631293', 'accessories-3/bicycle/configurable-product-05-buberry.html', 'tv-audio/bicycle/configurable-product-05-buberry.html', 0, 'RP', NULL, 19, 33),
(26491, 5, '55627500_1432631294', 'accessories-3/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(26494, 5, '66583600_1432631294', 'accessories-3/bicycle/configurable-product-05-chanel.html', 'tv-audio/bicycle/configurable-product-05-chanel.html', 0, 'RP', NULL, 19, 34),
(26513, 5, '21075300_1432631295', 'accessories-3/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(26516, 5, '38252500_1432631295', 'accessories-3/bicycle/configurable-product-05-hermes.html', 'tv-audio/bicycle/configurable-product-05-hermes.html', 0, 'RP', NULL, 19, 35),
(26535, 5, '78942100_1432631295', 'accessories-3/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(26538, 5, '86594000_1432631295', 'accessories-3/bicycle/configurable-product-05-versace.html', 'tv-audio/bicycle/configurable-product-05-versace.html', 0, 'RP', NULL, 19, 36),
(26557, 5, '27235600_1432631296', 'accessories-3/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(26560, 5, '32809600_1432631296', 'accessories-3/bicycle/simple-product-01.html', 'tv-audio/bicycle/simple-product-01.html', 0, 'RP', NULL, 19, 37),
(26563, 5, '38773500_1432631296', 'accessories-3/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(26581, 5, '71839700_1432631296', 'accessories-3/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(26584, 5, '76997400_1432631296', 'accessories-3/bicycle/simple-product-02.html', 'tv-audio/bicycle/simple-product-02.html', 0, 'RP', NULL, 19, 38),
(26603, 5, '18266600_1432631297', 'accessories-3/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(26606, 5, '24599000_1432631297', 'accessories-3/bicycle/simple-product-03.html', 'tv-audio/bicycle/simple-product-03.html', 0, 'RP', NULL, 19, 39),
(26625, 5, '62034700_1432631297', 'accessories-3/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(26628, 5, '65590500_1432631297', 'accessories-3/bicycle/simple-product-04.html', 'tv-audio/bicycle/simple-product-04.html', 0, 'RP', NULL, 19, 40),
(26647, 5, '97967100_1432631297', 'accessories-3/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(26650, 5, '06519000_1432631298', 'accessories-3/bicycle/simple-product-05.html', 'tv-audio/bicycle/simple-product-05.html', 0, 'RP', NULL, 19, 41),
(26669, 5, '45919200_1432631298', 'accessories-3/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(26672, 5, '57051800_1432631298', 'accessories-3/bicycle/grouped-product.html', 'tv-audio/bicycle/grouped-product.html', 0, 'RP', NULL, 19, 42),
(26675, 5, '64866800_1432631298', 'accessories-3/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(26717, 5, '49998900_1432631299', 'accessories-3/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(26720, 5, '56906100_1432631299', 'accessories-3/bicycle/bundle-product.html', 'tv-audio/bicycle/bundle-product.html', 0, 'RP', NULL, 19, 44),
(26723, 5, '63383100_1432631299', 'accessories-3/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(26741, 5, '94890000_1432631299', 'accessories-3/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(26744, 5, '00821700_1432631300', 'accessories-3/bicycle/bundle-product-02.html', 'tv-audio/bicycle/bundle-product-02.html', 0, 'RP', NULL, 19, 45),
(26747, 5, '04173500_1432631300', 'accessories-3/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(26765, 5, '35992700_1432631300', 'accessories-3/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(26768, 5, '42370800_1432631300', 'accessories-3/bicycle/downloadable-product.html', 'tv-audio/bicycle/downloadable-product.html', 0, 'RP', NULL, 19, 46),
(26771, 5, '48632200_1432631300', 'accessories-3/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(26788, 5, '96088500_1432631300', 'accessories-3/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(26791, 5, '06436200_1432631301', 'accessories-3/bicycle/no-image.html', 'tv-audio/bicycle/no-image.html', 0, 'RP', NULL, 19, 47),
(26794, 5, '12606000_1432631301', 'accessories-3/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(26811, 5, '47753100_1432631301', 'accessories-3/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(26814, 5, '55018100_1432631301', 'accessories-3/bicycle/custom-option.html', 'tv-audio/bicycle/custom-option.html', 0, 'RP', NULL, 19, 48),
(26816, 5, '61237400_1432631301', 'accessories-3/bicycle/jackets/custom-option.html', 'tv-audio/bicycle/jackets/custom-option.html', 0, 'RP', NULL, 20, 48),
(26818, 5, '66075400_1432631301', 'accessories-3/bicycle/scarves/custom-option.html', 'tv-audio/bicycle/scarves/custom-option.html', 0, 'RP', NULL, 24, 48),
(26820, 5, '71355500_1432631301', 'accessories-3/bicycle/lifestyle/custom-option.html', 'tv-audio/bicycle/lifestyle/custom-option.html', 0, 'RP', NULL, 25, 48),
(26822, 5, '76581600_1432631301', 'accessories-3/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(26824, 5, '83572300_1432631301', 'accessories-3/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(26827, 5, '91872900_1432631301', 'accessories-3/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(26829, 5, '97012000_1432631301', 'accessories-3/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(26877, 1, '50477200_1432710012', 'accessories-14.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(26978, 1, '01891600_1432710015', 'accessories-14/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(26998, 1, '32993400_1432710015', 'accessories-14/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(27018, 1, '56194700_1432710015', 'accessories-14/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(27038, 1, '73995700_1432710015', 'accessories-14/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(27059, 1, '94196900_1432710015', 'accessories-14/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(27080, 1, '14498000_1432710016', 'accessories-14/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(27101, 1, '35099200_1432710016', 'accessories-14/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(27122, 1, '77501600_1432710016', 'accessories-14/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(27144, 1, '09703500_1432710017', 'accessories-14/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(27165, 1, '33504800_1432710017', 'accessories-14/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(27186, 1, '69806900_1432710017', 'accessories-14/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(27207, 1, '00408700_1432710018', 'accessories-14/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(27228, 1, '19409700_1432710018', 'accessories-14/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(27250, 1, '46711300_1432710018', 'accessories-14/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(27294, 1, '52717400_1432710019', 'accessories-14/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(27316, 1, '06620400_1432710020', 'accessories-14/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(27338, 1, '43422500_1432710020', 'accessories-14/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(27359, 1, '61223600_1432710020', 'accessories-14/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(27386, 1, '01525900_1432710021', 'accessories-14/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(27437, 2, '10732100_1432710022', 'accessories-14.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(27538, 2, '12537900_1432710023', 'accessories-14/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(27558, 2, '34939200_1432710023', 'accessories-14/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(27578, 2, '64340900_1432710023', 'accessories-14/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(27598, 2, '84142000_1432710023', 'accessories-14/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(27619, 2, '02143100_1432710024', 'accessories-14/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(27640, 2, '25544400_1432710024', 'accessories-14/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(27661, 2, '67546800_1432710024', 'accessories-14/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(27682, 2, '93448300_1432710024', 'accessories-14/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(27704, 2, '27050200_1432710025', 'accessories-14/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(27725, 2, '85953600_1432710025', 'accessories-14/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(27746, 2, '02754500_1432710026', 'accessories-14/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(27767, 2, '19755500_1432710026', 'accessories-14/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(27788, 2, '36056400_1432710026', 'accessories-14/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(27810, 2, '56057600_1432710026', 'accessories-14/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(27854, 2, '08360600_1432710027', 'accessories-14/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(27876, 2, '30161800_1432710027', 'accessories-14/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(27898, 2, '50063000_1432710027', 'accessories-14/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(27919, 2, '66663900_1432710027', 'accessories-14/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(27946, 2, '14666700_1432710028', 'accessories-14/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(28001, 3, '66075300_1432710029', 'accessories-4.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(28003, 3, '69475500_1432710029', 'accessories-4/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(28005, 3, '73375700_1432710029', 'accessories-4/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(28007, 3, '80176100_1432710029', 'accessories-4/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(28009, 3, '84176400_1432710029', 'accessories-4/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(28014, 3, '99877300_1432710029', 'accessories-4/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(28016, 3, '01977400_1432710030', 'accessories-4/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(28036, 3, '17078200_1432710030', 'accessories-4/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(28038, 3, '19578400_1432710030', 'accessories-4/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(28058, 3, '39079500_1432710030', 'accessories-4/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(28060, 3, '41679600_1432710030', 'accessories-4/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(28065, 3, '46279900_1432710030', 'accessories-4/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(28067, 3, '48280000_1432710030', 'accessories-4/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(28072, 3, '52680300_1432710030', 'accessories-4/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(28074, 3, '55280400_1432710030', 'accessories-4/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(28101, 3, '91382500_1432710030', 'accessories-4/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(28121, 3, '13483800_1432710031', 'accessories-4/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(28141, 3, '36785100_1432710031', 'accessories-4/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(28161, 3, '52086000_1432710031', 'accessories-4/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(28181, 3, '14889600_1432710032', 'accessories-4/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(28202, 3, '43291200_1432710032', 'accessories-4/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(28223, 3, '70792800_1432710032', 'accessories-4/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(28244, 3, '04194700_1432710033', 'accessories-4/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(28265, 3, '56697700_1432710033', 'accessories-4/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(28270, 3, '62198000_1432710033', 'accessories-4/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(28288, 3, '99100100_1432710033', 'accessories-4/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(28309, 3, '36802200_1432710034', 'accessories-4/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(28330, 3, '61903700_1432710034', 'accessories-4/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(28351, 3, '19807000_1432710035', 'accessories-4/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(28372, 3, '36708000_1432710035', 'accessories-4/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(28377, 3, '42408300_1432710035', 'accessories-4/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(28418, 3, '80310500_1432710035', 'accessories-4/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(28423, 3, '86410800_1432710035', 'accessories-4/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(28441, 3, '05111900_1432710036', 'accessories-4/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(28446, 3, '09612100_1432710036', 'accessories-4/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(28464, 3, '24213000_1432710036', 'accessories-4/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(28469, 3, '28813200_1432710036', 'accessories-4/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(28486, 3, '42814000_1432710036', 'accessories-4/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(28491, 3, '48014300_1432710036', 'accessories-4/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(28508, 3, '61515100_1432710036', 'accessories-4/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(28515, 3, '67015400_1432710036', 'accessories-4/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(28517, 3, '69215500_1432710036', 'accessories-4/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(28520, 3, '71815700_1432710036', 'accessories-4/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(28522, 3, '73715800_1432710036', 'accessories-4/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(28586, 4, '14623900_1432710038', 'accessories-4.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(28588, 4, '17124000_1432710038', 'accessories-4/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(28590, 4, '18924100_1432710038', 'accessories-4/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(28592, 4, '23224300_1432710038', 'accessories-4/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(28594, 4, '25124500_1432710038', 'accessories-4/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(28599, 4, '43025500_1432710038', 'accessories-4/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(28601, 4, '44925600_1432710038', 'accessories-4/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(28621, 4, '69927000_1432710038', 'accessories-4/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(28623, 4, '72327200_1432710038', 'accessories-4/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(28643, 4, '92128300_1432710038', 'accessories-4/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(28645, 4, '94828400_1432710038', 'accessories-4/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(28650, 4, '98528700_1432710038', 'accessories-4/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(28652, 4, '00328800_1432710039', 'accessories-4/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(28657, 4, '07629200_1432710039', 'accessories-4/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(28659, 4, '10429300_1432710039', 'accessories-4/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(28686, 4, '41031100_1432710039', 'accessories-4/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(28706, 4, '59332100_1432710039', 'accessories-4/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(28726, 4, '76333100_1432710039', 'accessories-4/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(28746, 4, '95534200_1432710039', 'accessories-4/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(28766, 4, '12535200_1432710040', 'accessories-4/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(28787, 4, '30436200_1432710040', 'accessories-4/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(28808, 4, '49237300_1432710040', 'accessories-4/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(28829, 4, '67138300_1432710040', 'accessories-4/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(28850, 4, '83739200_1432710040', 'accessories-4/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(28855, 4, '88339500_1432710040', 'accessories-4/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(28873, 4, '02940300_1432710041', 'accessories-4/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(28894, 4, '22341500_1432710041', 'accessories-4/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(28915, 4, '39942500_1432710041', 'accessories-4/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(28936, 4, '62543800_1432710041', 'accessories-4/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(28957, 4, '80444800_1432710041', 'accessories-4/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(28962, 4, '84545000_1432710041', 'accessories-4/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(29003, 4, '25147300_1432710042', 'accessories-4/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(29008, 4, '39448200_1432710042', 'accessories-4/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(29026, 4, '57949200_1432710042', 'accessories-4/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(29031, 4, '62249500_1432710042', 'accessories-4/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(29049, 4, '78150400_1432710042', 'accessories-4/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(29054, 4, '82850600_1432710042', 'accessories-4/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(29071, 4, '99151600_1432710042', 'accessories-4/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(29076, 4, '03751800_1432710043', 'accessories-4/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(29093, 4, '17752600_1432710043', 'accessories-4/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(29100, 4, '24253000_1432710043', 'accessories-4/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(29102, 4, '26153100_1432710043', 'accessories-4/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(29105, 4, '28953300_1432710043', 'accessories-4/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(29107, 4, '30953400_1432710043', 'accessories-4/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(29171, 5, '74961600_1432710044', 'accessories-4.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(29173, 5, '76861700_1432710044', 'accessories-4/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(29175, 5, '78761800_1432710044', 'accessories-4/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(29177, 5, '80662000_1432710044', 'accessories-4/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(29179, 5, '83162100_1432710044', 'accessories-4/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(29184, 5, '02063200_1432710045', 'accessories-4/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(29186, 5, '04963300_1432710045', 'accessories-4/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(29206, 5, '24664500_1432710045', 'accessories-4/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(29208, 5, '28464700_1432710045', 'accessories-4/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(29228, 5, '54766200_1432710045', 'accessories-4/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(29230, 5, '57066300_1432710045', 'accessories-4/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(29235, 5, '62066600_1432710045', 'accessories-4/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(29237, 5, '64166700_1432710045', 'accessories-4/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(29242, 5, '70667100_1432710045', 'accessories-4/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(29244, 5, '72767200_1432710045', 'accessories-4/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(29271, 5, '94568500_1432710045', 'accessories-4/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(29291, 5, '14169600_1432710046', 'accessories-4/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(29311, 5, '31670600_1432710046', 'accessories-4/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(29331, 5, '50671700_1432710046', 'accessories-4/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(29351, 5, '81673400_1432710046', 'accessories-4/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(29372, 5, '01774600_1432710047', 'accessories-4/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(29393, 5, '53577600_1432710047', 'accessories-4/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(29414, 5, '84079300_1432710047', 'accessories-4/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(29435, 5, '47482900_1432710048', 'accessories-4/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(29440, 5, '59583600_1432710048', 'accessories-4/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(29458, 5, '81384900_1432710048', 'accessories-4/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(29479, 5, '24687300_1432710049', 'accessories-4/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(29500, 5, '59789400_1432710049', 'accessories-4/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(29521, 5, '25293100_1432710050', 'accessories-4/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(29542, 5, '54094800_1432710050', 'accessories-4/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(29547, 5, '60495100_1432710050', 'accessories-4/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(29588, 5, '05197700_1432710051', 'accessories-4/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(29593, 5, '11398000_1432710051', 'accessories-4/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(29611, 5, '32899300_1432710051', 'accessories-4/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(29616, 5, '36999500_1432710051', 'accessories-4/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(29634, 5, '54000500_1432710051', 'accessories-4/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(29639, 5, '57800700_1432710051', 'accessories-4/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(29656, 5, '77901800_1432710051', 'accessories-4/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(29661, 5, '82602100_1432710051', 'accessories-4/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(29678, 5, '95602800_1432710051', 'accessories-4/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(29685, 5, '01003200_1432710052', 'accessories-4/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(29687, 5, '05803400_1432710052', 'accessories-4/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(29690, 5, '10203700_1432710052', 'accessories-4/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(29692, 5, '12403800_1432710052', 'accessories-4/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(29740, 1, '68678500_1432889926', 'accessories-15.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(29741, 1, 'category/58', 'accessories-27/product-types.html', 'catalog/category/view/id/58', 1, NULL, NULL, 58, NULL),
(29755, 1, 'product/7/58', 'accessories-27/product-types/configurable-product.html', 'catalog/product/view/id/7/category/58', 1, NULL, NULL, 58, 7),
(29776, 1, 'product/13/58', 'accessories-27/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/58', 1, NULL, NULL, 58, 13),
(29797, 1, 'product/19/58', 'accessories-27/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/58', 1, NULL, NULL, 58, 19),
(29803, 1, 'product/20/58', 'accessories-27/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/58', 1, NULL, NULL, 58, 20),
(29809, 1, 'product/21/58', 'accessories-27/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/58', 1, NULL, NULL, 58, 21),
(29847, 1, '95985800_1432889927', 'accessories-15/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(29867, 1, '09686600_1432889928', 'accessories-15/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(29887, 1, '29787700_1432889928', 'accessories-15/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(29907, 1, '46988700_1432889928', 'accessories-15/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(29928, 1, '62689600_1432889928', 'accessories-15/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(29949, 1, '80190600_1432889928', 'accessories-15/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(29970, 1, '97391600_1432889928', 'accessories-15/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(29991, 1, '16792700_1432889929', 'accessories-15/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(30013, 1, '39394000_1432889929', 'accessories-15/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(30017, 1, 'product/37/58', 'accessories-27/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/58', 1, NULL, NULL, 58, 37),
(30035, 1, '59595200_1432889929', 'accessories-15/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(30056, 1, '84896600_1432889929', 'accessories-15/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(30077, 1, '01497600_1432889930', 'accessories-15/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(30098, 1, '26899000_1432889930', 'accessories-15/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(30120, 1, '45600100_1432889930', 'accessories-15/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(30124, 1, 'product/42/58', 'accessories-27/product-types/grouped-product.html', 'catalog/product/view/id/42/category/58', 1, NULL, NULL, 58, 42),
(30166, 1, '14204000_1432889931', 'accessories-15/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(30170, 1, 'product/44/58', 'accessories-27/product-types/bundle-product.html', 'catalog/product/view/id/44/category/58', 1, NULL, NULL, 58, 44),
(30189, 1, '47405900_1432889931', 'accessories-15/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(30193, 1, 'product/45/58', 'accessories-27/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/58', 1, NULL, NULL, 58, 45),
(30212, 1, '00108900_1432889932', 'accessories-15/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(30216, 1, 'product/46/58', 'accessories-27/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/58', 1, NULL, NULL, 58, 46),
(30234, 1, '30110600_1432889932', 'accessories-15/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(30238, 1, 'product/47/58', 'accessories-27/product-types/no-image.html', 'catalog/product/view/id/47/category/58', 1, NULL, NULL, 58, 47),
(30262, 1, '03314800_1432889933', 'accessories-15/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(30266, 1, 'product/48/58', 'accessories-27/product-types/custom-option.html', 'catalog/product/view/id/48/category/58', 1, NULL, NULL, 58, 48),
(30314, 2, '72830200_1432889935', 'accessories-15.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(30315, 2, 'category/58', 'accessories-27/product-types.html', 'catalog/category/view/id/58', 1, NULL, NULL, 58, NULL),
(30329, 2, 'product/7/58', 'accessories-27/product-types/configurable-product.html', 'catalog/product/view/id/7/category/58', 1, NULL, NULL, 58, 7),
(30350, 2, 'product/13/58', 'accessories-27/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/58', 1, NULL, NULL, 58, 13),
(30371, 2, 'product/19/58', 'accessories-27/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/58', 1, NULL, NULL, 58, 19),
(30377, 2, 'product/20/58', 'accessories-27/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/58', 1, NULL, NULL, 58, 20),
(30383, 2, 'product/21/58', 'accessories-27/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/58', 1, NULL, NULL, 58, 21),
(30421, 2, '70441500_1432889937', 'accessories-15/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(30441, 2, '89242600_1432889937', 'accessories-15/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(30461, 2, '08143700_1432889938', 'accessories-15/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(30481, 2, '29744900_1432889938', 'accessories-15/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(30502, 2, '51046100_1432889938', 'accessories-15/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(30523, 2, '69947200_1432889938', 'accessories-15/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(30544, 2, '93548600_1432889938', 'accessories-15/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(30565, 2, '16549900_1432889939', 'accessories-15/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(30587, 2, '43351400_1432889939', 'accessories-15/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(30591, 2, 'product/37/58', 'accessories-27/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/58', 1, NULL, NULL, 58, 37),
(30609, 2, '64752600_1432889939', 'accessories-15/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(30630, 2, '86753900_1432889939', 'accessories-15/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(30651, 2, '13855500_1432889940', 'accessories-15/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(30672, 2, '35056700_1432889940', 'accessories-15/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(30694, 2, '65458400_1432889940', 'accessories-15/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(30698, 2, 'product/42/58', 'accessories-27/product-types/grouped-product.html', 'catalog/product/view/id/42/category/58', 1, NULL, NULL, 58, 42),
(30740, 2, '34862400_1432889941', 'accessories-15/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(30744, 2, 'product/44/58', 'accessories-27/product-types/bundle-product.html', 'catalog/product/view/id/44/category/58', 1, NULL, NULL, 58, 44),
(30763, 2, '17467100_1432889942', 'accessories-15/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(30767, 2, 'product/45/58', 'accessories-27/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/58', 1, NULL, NULL, 58, 45),
(30786, 2, '40968400_1432889942', 'accessories-15/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(30790, 2, 'product/46/58', 'accessories-27/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/58', 1, NULL, NULL, 58, 46),
(30808, 2, '85371000_1432889942', 'accessories-15/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(30812, 2, 'product/47/58', 'accessories-27/product-types/no-image.html', 'catalog/product/view/id/47/category/58', 1, NULL, NULL, 58, 47),
(30836, 2, '38274000_1432889943', 'accessories-15/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(30840, 2, 'product/48/58', 'accessories-27/product-types/custom-option.html', 'catalog/product/view/id/48/category/58', 1, NULL, NULL, 58, 48),
(30888, 3, 'category/58', 'accessories/product-types.html', 'catalog/category/view/id/58', 1, NULL, NULL, 58, NULL),
(30893, 3, '23590300_1432889946', 'accessories-5.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(30895, 3, '26990500_1432889946', 'accessories-5/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(30897, 3, '30790700_1432889946', 'accessories-5/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(30899, 3, '37591100_1432889946', 'accessories-5/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(30901, 3, '48591800_1432889946', 'accessories-5/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(30906, 3, '97994600_1432889946', 'accessories-5/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(30908, 3, '02094800_1432889947', 'accessories-5/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(30909, 3, 'product/7/58', 'accessories/product-types/configurable-product.html', 'catalog/product/view/id/7/category/58', 1, NULL, NULL, 58, 7),
(30929, 3, '31496500_1432889947', 'accessories-5/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(30931, 3, '33596600_1432889947', 'accessories-5/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(30932, 3, 'product/13/58', 'accessories/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/58', 1, NULL, NULL, 58, 13),
(30952, 3, '48797500_1432889947', 'accessories-5/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(30954, 3, '52797700_1432889947', 'accessories-5/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(30955, 3, 'product/19/58', 'accessories/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/58', 1, NULL, NULL, 58, 19),
(30960, 3, '57098000_1432889947', 'accessories-5/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(30962, 3, '59498100_1432889947', 'accessories-5/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(30963, 3, 'product/20/58', 'accessories/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/58', 1, NULL, NULL, 58, 20),
(30968, 3, '10001000_1432889948', 'accessories-5/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(30970, 3, '19401500_1432889948', 'accessories-5/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(30971, 3, 'product/21/58', 'accessories/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/58', 1, NULL, NULL, 58, 21),
(30998, 3, '42402800_1432889948', 'accessories-5/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(31018, 3, '73604600_1432889948', 'accessories-5/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(31038, 3, '90305600_1432889948', 'accessories-5/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(31058, 3, '08006600_1432889949', 'accessories-5/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(31078, 3, '23607500_1432889949', 'accessories-5/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(31099, 3, '39008400_1432889949', 'accessories-5/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(31120, 3, '57009400_1432889949', 'accessories-5/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(31141, 3, '74710400_1432889949', 'accessories-5/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(31162, 3, '90711300_1432889949', 'accessories-5/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(31167, 3, '95211600_1432889949', 'accessories-5/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(31180, 3, 'product/37/58', 'accessories/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/58', 1, NULL, NULL, 58, 37),
(31186, 3, '09512400_1432889950', 'accessories-5/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(31207, 3, '22513100_1432889950', 'accessories-5/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(31228, 3, '36213900_1432889950', 'accessories-5/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(31249, 3, '54615000_1432889950', 'accessories-5/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(31270, 3, '70215900_1432889950', 'accessories-5/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(31275, 3, '73916100_1432889950', 'accessories-5/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(31288, 3, 'product/42/58', 'accessories/product-types/grouped-product.html', 'catalog/product/view/id/42/category/58', 1, NULL, NULL, 58, 42),
(31318, 3, '08018000_1432889951', 'accessories-5/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(31323, 3, '12018300_1432889951', 'accessories-5/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(31336, 3, 'product/44/58', 'accessories/product-types/bundle-product.html', 'catalog/product/view/id/44/category/58', 1, NULL, NULL, 58, 44),
(31342, 3, '40119900_1432889951', 'accessories-5/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(31347, 3, '44120100_1432889951', 'accessories-5/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(31360, 3, 'product/45/58', 'accessories/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/58', 1, NULL, NULL, 58, 45),
(31366, 3, '60521000_1432889951', 'accessories-5/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(31371, 3, '65821300_1432889951', 'accessories-5/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(31384, 3, 'product/46/58', 'accessories/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/58', 1, NULL, NULL, 58, 46),
(31389, 3, '80822200_1432889951', 'accessories-5/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(31394, 3, '84922400_1432889951', 'accessories-5/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(31407, 3, 'product/47/58', 'accessories/product-types/no-image.html', 'catalog/product/view/id/47/category/58', 1, NULL, NULL, 58, 47),
(31412, 3, '98423200_1432889951', 'accessories-5/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(31419, 3, '25224700_1432889952', 'accessories-5/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(31421, 3, '27124900_1432889952', 'accessories-5/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(31424, 3, '29525000_1432889952', 'accessories-5/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(31426, 3, '31125100_1432889952', 'accessories-5/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(31439, 3, 'product/48/58', 'accessories/product-types/custom-option.html', 'catalog/product/view/id/48/category/58', 1, NULL, NULL, 58, 48),
(31487, 4, 'category/58', 'accessories/product-types.html', 'catalog/category/view/id/58', 1, NULL, NULL, 58, NULL),
(31492, 4, '35136700_1432889954', 'accessories-5.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(31494, 4, '37236900_1432889954', 'accessories-5/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(31496, 4, '41137100_1432889954', 'accessories-5/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(31498, 4, '43137200_1432889954', 'accessories-5/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(31500, 4, '46437400_1432889954', 'accessories-5/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(31505, 4, '70838800_1432889954', 'accessories-5/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(31507, 4, '83639500_1432889954', 'accessories-5/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(31508, 4, 'product/7/58', 'accessories/product-types/configurable-product.html', 'catalog/product/view/id/7/category/58', 1, NULL, NULL, 58, 7),
(31528, 4, '11341100_1432889955', 'accessories-5/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(31530, 4, '16641400_1432889955', 'accessories-5/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(31531, 4, 'product/13/58', 'accessories/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/58', 1, NULL, NULL, 58, 13),
(31551, 4, '49443300_1432889955', 'accessories-5/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(31553, 4, '54143600_1432889955', 'accessories-5/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(31554, 4, 'product/19/58', 'accessories/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/58', 1, NULL, NULL, 58, 19),
(31559, 4, '60343900_1432889955', 'accessories-5/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(31561, 4, '64944200_1432889955', 'accessories-5/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(31562, 4, 'product/20/58', 'accessories/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/58', 1, NULL, NULL, 58, 20),
(31567, 4, '80145000_1432889955', 'accessories-5/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(31569, 4, '00246200_1432889956', 'accessories-5/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(31570, 4, 'product/21/58', 'accessories/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/58', 1, NULL, NULL, 58, 21),
(31597, 4, '57849500_1432889956', 'accessories-5/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(31617, 4, '99151900_1432889956', 'accessories-5/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(31637, 4, '15052800_1432889957', 'accessories-5/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(31657, 4, '37754100_1432889957', 'accessories-5/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(31677, 4, '61155400_1432889957', 'accessories-5/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(31698, 4, '82256600_1432889957', 'accessories-5/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(31719, 4, '00557700_1432889958', 'accessories-5/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(31740, 4, '25359100_1432889958', 'accessories-5/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(31761, 4, '46160300_1432889958', 'accessories-5/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(31766, 4, '54260700_1432889958', 'accessories-5/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(31779, 4, 'product/37/58', 'accessories/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/58', 1, NULL, NULL, 58, 37),
(31785, 4, '71361700_1432889958', 'accessories-5/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(31806, 4, '12764100_1432889959', 'accessories-5/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(31827, 4, '38965600_1432889959', 'accessories-5/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(31848, 4, '66467100_1432889959', 'accessories-5/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(31869, 4, '91568600_1432889959', 'accessories-5/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(31874, 4, '01569100_1432889960', 'accessories-5/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(31887, 4, 'product/42/58', 'accessories/product-types/grouped-product.html', 'catalog/product/view/id/42/category/58', 1, NULL, NULL, 58, 42),
(31917, 4, '49171900_1432889960', 'accessories-5/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(31922, 4, '54372200_1432889960', 'accessories-5/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(31935, 4, 'product/44/58', 'accessories/product-types/bundle-product.html', 'catalog/product/view/id/44/category/58', 1, NULL, NULL, 58, 44),
(31941, 4, '70473100_1432889960', 'accessories-5/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(31946, 4, '75373400_1432889960', 'accessories-5/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(31959, 4, 'product/45/58', 'accessories/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/58', 1, NULL, NULL, 58, 45),
(31965, 4, '94374500_1432889960', 'accessories-5/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(31970, 4, '01574900_1432889961', 'accessories-5/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(31983, 4, 'product/46/58', 'accessories/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/58', 1, NULL, NULL, 58, 46),
(31988, 4, '18375800_1432889961', 'accessories-5/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(31993, 4, '23376100_1432889961', 'accessories-5/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(32006, 4, 'product/47/58', 'accessories/product-types/no-image.html', 'catalog/product/view/id/47/category/58', 1, NULL, NULL, 58, 47),
(32011, 4, '40077100_1432889961', 'accessories-5/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(32018, 4, '46577400_1432889961', 'accessories-5/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(32020, 4, '48277500_1432889961', 'accessories-5/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(32023, 4, '50777700_1432889961', 'accessories-5/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(32025, 4, '52777800_1432889961', 'accessories-5/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(32038, 4, 'product/48/58', 'accessories/product-types/custom-option.html', 'catalog/product/view/id/48/category/58', 1, NULL, NULL, 58, 48),
(32086, 5, 'category/58', 'accessories/product-types.html', 'catalog/category/view/id/58', 1, NULL, NULL, 58, NULL),
(32091, 5, '10686800_1432889963', 'accessories-5.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(32093, 5, '15387100_1432889963', 'accessories-5/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(32095, 5, '17887200_1432889963', 'accessories-5/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(32097, 5, '19987400_1432889963', 'accessories-5/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(32099, 5, '21987500_1432889963', 'accessories-5/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(32104, 5, '38988400_1432889963', 'accessories-5/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(32106, 5, '40788500_1432889963', 'accessories-5/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(32107, 5, 'product/7/58', 'accessories/product-types/configurable-product.html', 'catalog/product/view/id/7/category/58', 1, NULL, NULL, 58, 7),
(32127, 5, '54689300_1432889963', 'accessories-5/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(32129, 5, '58889600_1432889963', 'accessories-5/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(32130, 5, 'product/13/58', 'accessories/product-types/configurable-product-02.html', 'catalog/product/view/id/13/category/58', 1, NULL, NULL, 58, 13),
(32150, 5, '75490500_1432889963', 'accessories-5/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(32152, 5, '78290700_1432889963', 'accessories-5/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(32153, 5, 'product/19/58', 'accessories/product-types/configurable-product-03.html', 'catalog/product/view/id/19/category/58', 1, NULL, NULL, 58, 19),
(32158, 5, '85291100_1432889963', 'accessories-5/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(32160, 5, '94491600_1432889963', 'accessories-5/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(32161, 5, 'product/20/58', 'accessories/product-types/configurable-product-04.html', 'catalog/product/view/id/20/category/58', 1, NULL, NULL, 58, 20),
(32166, 5, '15092800_1432889964', 'accessories-5/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(32168, 5, '22393200_1432889964', 'accessories-5/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(32169, 5, 'product/21/58', 'accessories/product-types/configurable-product-05.html', 'catalog/product/view/id/21/category/58', 1, NULL, NULL, 58, 21),
(32196, 5, '57295200_1432889964', 'accessories-5/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(32216, 5, '09398200_1432889965', 'accessories-5/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(32236, 5, '49000500_1432889965', 'accessories-5/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(32256, 5, '67501500_1432889965', 'accessories-5/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(32276, 5, '02103500_1432889966', 'accessories-5/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(32297, 5, '46106000_1432889966', 'accessories-5/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(32318, 5, '84508200_1432889966', 'accessories-5/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(32339, 5, '09409600_1432889967', 'accessories-5/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(32360, 5, '36411200_1432889967', 'accessories-5/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(32365, 5, '44111600_1432889967', 'accessories-5/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(32378, 5, 'product/37/58', 'accessories/product-types/simple-product-01.html', 'catalog/product/view/id/37/category/58', 1, NULL, NULL, 58, 37),
(32384, 5, '62812700_1432889967', 'accessories-5/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(32405, 5, '87114100_1432889967', 'accessories-5/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(32426, 5, '09715400_1432889968', 'accessories-5/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(32447, 5, '27316400_1432889968', 'accessories-5/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(32468, 5, '45817400_1432889968', 'accessories-5/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(32473, 5, '50617700_1432889968', 'accessories-5/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(32486, 5, 'product/42/58', 'accessories/product-types/grouped-product.html', 'catalog/product/view/id/42/category/58', 1, NULL, NULL, 58, 42),
(32516, 5, '89419900_1432889968', 'accessories-5/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(32521, 5, '93920200_1432889968', 'accessories-5/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(32534, 5, 'product/44/58', 'accessories/product-types/bundle-product.html', 'catalog/product/view/id/44/category/58', 1, NULL, NULL, 58, 44),
(32540, 5, '18421600_1432889969', 'accessories-5/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(32545, 5, '23121900_1432889969', 'accessories-5/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(32558, 5, 'product/45/58', 'accessories/product-types/bundle-product-02.html', 'catalog/product/view/id/45/category/58', 1, NULL, NULL, 58, 45),
(32564, 5, '39022800_1432889969', 'accessories-5/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(32569, 5, '43523000_1432889969', 'accessories-5/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(32582, 5, 'product/46/58', 'accessories/product-types/downloadable-product.html', 'catalog/product/view/id/46/category/58', 1, NULL, NULL, 58, 46),
(32587, 5, '58423900_1432889969', 'accessories-5/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(32592, 5, '62324100_1432889969', 'accessories-5/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(32605, 5, 'product/47/58', 'accessories/product-types/no-image.html', 'catalog/product/view/id/47/category/58', 1, NULL, NULL, 58, 47),
(32610, 5, '79225100_1432889969', 'accessories-5/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(32617, 5, '84625400_1432889969', 'accessories-5/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(32619, 5, '86525500_1432889969', 'accessories-5/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(32622, 5, '89225600_1432889969', 'accessories-5/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(32624, 5, '91925800_1432889969', 'accessories-5/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(32637, 5, 'product/48/58', 'accessories/product-types/custom-option.html', 'catalog/product/view/id/48/category/58', 1, NULL, NULL, 58, 48),
(32685, 1, '70190400_1432893180', 'accessories-16.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(32687, 1, '79691000_1432893180', 'accessories-16/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(32702, 1, '62995700_1432893181', 'accessories-16/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(32724, 1, '94597500_1432893181', 'accessories-16/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(32746, 1, '22299100_1432893182', 'accessories-16/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(32753, 1, '31099600_1432893182', 'accessories-16/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(32760, 1, '40300100_1432893182', 'accessories-16/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(32798, 1, '90603000_1432893182', 'accessories-16/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(32818, 1, '17304600_1432893183', 'accessories-16/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(32838, 1, '47706300_1432893183', 'accessories-16/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(32858, 1, '75007900_1432893183', 'accessories-16/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(32879, 1, '05109600_1432893184', 'accessories-16/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(32900, 1, '32111100_1432893184', 'accessories-16/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(32921, 1, '60212700_1432893184', 'accessories-16/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(32942, 1, '88814400_1432893184', 'accessories-16/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(32964, 1, '36817100_1432893185', 'accessories-16/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(32969, 1, '51718000_1432893185', 'accessories-16/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(32987, 1, '82819700_1432893185', 'accessories-16/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(33008, 1, '14221500_1432893186', 'accessories-16/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(33029, 1, '44723300_1432893186', 'accessories-16/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(33050, 1, '69124700_1432893186', 'accessories-16/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(33072, 1, '00326500_1432893187', 'accessories-16/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(33077, 1, '07026800_1432893187', 'accessories-16/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(33120, 1, '61830000_1432893187', 'accessories-16/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(33125, 1, '69030400_1432893187', 'accessories-16/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(33144, 1, '97132000_1432893187', 'accessories-16/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(33149, 1, '22533500_1432893188', 'accessories-16/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(33168, 1, '50735100_1432893188', 'accessories-16/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(33173, 1, '57235400_1432893188', 'accessories-16/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(33191, 1, '81036800_1432893188', 'accessories-16/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(33196, 1, '91937400_1432893188', 'accessories-16/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(33220, 1, '24939300_1432893189', 'accessories-16/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(33225, 1, '31039700_1432893189', 'accessories-16/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(33273, 2, '73347800_1432893190', 'accessories-16.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(33275, 2, '76048000_1432893190', 'accessories-16/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(33290, 2, '28851000_1432893191', 'accessories-16/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(33312, 2, '53052400_1432893191', 'accessories-16/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(33334, 2, '80753900_1432893191', 'accessories-16/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(33341, 2, '88854400_1432893191', 'accessories-16/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(33348, 2, '98955000_1432893191', 'accessories-16/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(33386, 2, '43857500_1432893192', 'accessories-16/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(33406, 2, '73659300_1432893192', 'accessories-16/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(33426, 2, '99760700_1432893192', 'accessories-16/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(33446, 2, '25662200_1432893193', 'accessories-16/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(33467, 2, '52063700_1432893193', 'accessories-16/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(33488, 2, '80465400_1432893193', 'accessories-16/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(33509, 2, '05766800_1432893194', 'accessories-16/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(33530, 2, '34968500_1432893194', 'accessories-16/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(33552, 2, '56469700_1432893194', 'accessories-16/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(33557, 2, '60770000_1432893194', 'accessories-16/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(33575, 2, '78671000_1432893194', 'accessories-16/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(33596, 2, '99972200_1432893194', 'accessories-16/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(33617, 2, '17073200_1432893195', 'accessories-16/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(33638, 2, '52475200_1432893195', 'accessories-16/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(33660, 2, '76976600_1432893195', 'accessories-16/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(33665, 2, '82576900_1432893195', 'accessories-16/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(33708, 2, '31879700_1432893196', 'accessories-16/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(33713, 2, '37580100_1432893196', 'accessories-16/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(33732, 2, '59181300_1432893196', 'accessories-16/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(33737, 2, '66781700_1432893196', 'accessories-16/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(33756, 2, '89983100_1432893196', 'accessories-16/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(33761, 2, '95883400_1432893196', 'accessories-16/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(33779, 2, '10084200_1432893197', 'accessories-16/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(33784, 2, '14084400_1432893197', 'accessories-16/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(33808, 2, '39985900_1432893197', 'accessories-16/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(33813, 2, '45086200_1432893197', 'accessories-16/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(33866, 3, '84894200_1432893198', 'accessories-6.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(33868, 3, '88594400_1432893198', 'accessories-6/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(33870, 3, '94494800_1432893198', 'accessories-6/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(33872, 3, '00095100_1432893199', 'accessories-6/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(33874, 3, '05795400_1432893199', 'accessories-6/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(33879, 3, '29796800_1432893199', 'accessories-6/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(33881, 3, '32696900_1432893199', 'accessories-6/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(33902, 3, '56498300_1432893199', 'accessories-6/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(33904, 3, '59098500_1432893199', 'accessories-6/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(33925, 3, '81199700_1432893199', 'accessories-6/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(33927, 3, '83499900_1432893199', 'accessories-6/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(33933, 3, '89900200_1432893199', 'accessories-6/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(33935, 3, '92200400_1432893199', 'accessories-6/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(33941, 3, '98900700_1432893199', 'accessories-6/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(33943, 3, '02000900_1432893200', 'accessories-6/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(33971, 3, '29802500_1432893200', 'accessories-6/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(33991, 3, '50803700_1432893200', 'accessories-6/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(34011, 3, '72104900_1432893200', 'accessories-6/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(34031, 3, '93206100_1432893200', 'accessories-6/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(34051, 3, '18707600_1432893201', 'accessories-6/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(34072, 3, '49709400_1432893201', 'accessories-6/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(34093, 3, '72210600_1432893201', 'accessories-6/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(34114, 3, '93211800_1432893201', 'accessories-6/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(34135, 3, '16713200_1432893202', 'accessories-6/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(34140, 3, '22813500_1432893202', 'accessories-6/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(34159, 3, '42314700_1432893202', 'accessories-6/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(34180, 3, '62915800_1432893202', 'accessories-6/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(34201, 3, '84517100_1432893202', 'accessories-6/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(34222, 3, '05818300_1432893203', 'accessories-6/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(34243, 3, '29819700_1432893203', 'accessories-6/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(34248, 3, '35520000_1432893203', 'accessories-6/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(34291, 3, '81022600_1432893203', 'accessories-6/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(34296, 3, '87022900_1432893203', 'accessories-6/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(34315, 3, '05824000_1432893204', 'accessories-6/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(34320, 3, '12124400_1432893204', 'accessories-6/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(34339, 3, '31625500_1432893204', 'accessories-6/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(34344, 3, '37525800_1432893204', 'accessories-6/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(34362, 3, '55126800_1432893204', 'accessories-6/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(34367, 3, '60327100_1432893204', 'accessories-6/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(34385, 3, '80528300_1432893204', 'accessories-6/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(34392, 3, '87528700_1432893204', 'accessories-6/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(34394, 3, '90228800_1432893204', 'accessories-6/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(34397, 3, '93629000_1432893204', 'accessories-6/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(34399, 3, '96629200_1432893204', 'accessories-6/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(34465, 4, '44137600_1432893206', 'accessories-6.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(34467, 4, '49938000_1432893206', 'accessories-6/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(34469, 4, '52438100_1432893206', 'accessories-6/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(34471, 4, '54838300_1432893206', 'accessories-6/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(34473, 4, '57438400_1432893206', 'accessories-6/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(34478, 4, '81539800_1432893206', 'accessories-6/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(34480, 4, '84239900_1432893206', 'accessories-6/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(34501, 4, '05541200_1432893207', 'accessories-6/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(34503, 4, '08041300_1432893207', 'accessories-6/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(34524, 4, '30042600_1432893207', 'accessories-6/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(34526, 4, '32542700_1432893207', 'accessories-6/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(34532, 4, '39143100_1432893207', 'accessories-6/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(34534, 4, '42043200_1432893207', 'accessories-6/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(34540, 4, '49143600_1432893207', 'accessories-6/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(34542, 4, '52043800_1432893207', 'accessories-6/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(34570, 4, '80145400_1432893207', 'accessories-6/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(34590, 4, '08447000_1432893208', 'accessories-6/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(34610, 4, '33948500_1432893208', 'accessories-6/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(34630, 4, '54249700_1432893208', 'accessories-6/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(34650, 4, '74950800_1432893208', 'accessories-6/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(34671, 4, '95552000_1432893208', 'accessories-6/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(34692, 4, '18453300_1432893209', 'accessories-6/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(34713, 4, '39054500_1432893209', 'accessories-6/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(34734, 4, '60155700_1432893209', 'accessories-6/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(34739, 4, '65856000_1432893209', 'accessories-6/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(34758, 4, '85157100_1432893209', 'accessories-6/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(34779, 4, '05358300_1432893210', 'accessories-6/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(34800, 4, '26759500_1432893210', 'accessories-6/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(34821, 4, '49360800_1432893210', 'accessories-6/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(34842, 4, '74662300_1432893210', 'accessories-6/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(34847, 4, '84162800_1432893210', 'accessories-6/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(34890, 4, '32365600_1432893211', 'accessories-6/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(34895, 4, '39166000_1432893211', 'accessories-6/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(34914, 4, '61567200_1432893211', 'accessories-6/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(34919, 4, '67567600_1432893211', 'accessories-6/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(34938, 4, '88168800_1432893211', 'accessories-6/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(34943, 4, '94669100_1432893211', 'accessories-6/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(34961, 4, '13170200_1432893212', 'accessories-6/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(34966, 4, '19270500_1432893212', 'accessories-6/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(34984, 4, '41471800_1432893212', 'accessories-6/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(34991, 4, '48772200_1432893212', 'accessories-6/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(34993, 4, '50972300_1432893212', 'accessories-6/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(34996, 4, '54972600_1432893212', 'accessories-6/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(34998, 4, '57872700_1432893212', 'accessories-6/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(35064, 5, '99580800_1432893213', 'accessories-6.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(35066, 5, '01881000_1432893214', 'accessories-6/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(35068, 5, '03881100_1432893214', 'accessories-6/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(35070, 5, '05681200_1432893214', 'accessories-6/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(35072, 5, '07681300_1432893214', 'accessories-6/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(35077, 5, '23782200_1432893214', 'accessories-6/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(35079, 5, '26182400_1432893214', 'accessories-6/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(35100, 5, '43383400_1432893214', 'accessories-6/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(35102, 5, '45283500_1432893214', 'accessories-6/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(35123, 5, '61684400_1432893214', 'accessories-6/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(35125, 5, '63984500_1432893214', 'accessories-6/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(35131, 5, '70384900_1432893214', 'accessories-6/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(35133, 5, '72785000_1432893214', 'accessories-6/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(35139, 5, '77285300_1432893214', 'accessories-6/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(35141, 5, '83485600_1432893214', 'accessories-6/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(35169, 5, '09387100_1432893215', 'accessories-6/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(35189, 5, '40988900_1432893215', 'accessories-6/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(35209, 5, '31394100_1432893216', 'accessories-6/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(35229, 5, '50295200_1432893216', 'accessories-6/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(35249, 5, '79196800_1432893216', 'accessories-6/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(35270, 5, '99198000_1432893216', 'accessories-6/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(35291, 5, '20799200_1432893217', 'accessories-6/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(35312, 5, '42700500_1432893217', 'accessories-6/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(35333, 5, '63701700_1432893217', 'accessories-6/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(35338, 5, '74002300_1432893217', 'accessories-6/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(35357, 5, '92503300_1432893217', 'accessories-6/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(35378, 5, '17304700_1432893218', 'accessories-6/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(35399, 5, '37805900_1432893218', 'accessories-6/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(35420, 5, '59507200_1432893218', 'accessories-6/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(35441, 5, '83508500_1432893218', 'accessories-6/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(35446, 5, '89808900_1432893218', 'accessories-6/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(35489, 5, '38611700_1432893219', 'accessories-6/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(35494, 5, '43612000_1432893219', 'accessories-6/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(35513, 5, '64913200_1432893219', 'accessories-6/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(35518, 5, '71513600_1432893219', 'accessories-6/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(35537, 5, '90614700_1432893219', 'accessories-6/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(35542, 5, '96215000_1432893219', 'accessories-6/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(35560, 5, '14916000_1432893220', 'accessories-6/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(35565, 5, '21716400_1432893220', 'accessories-6/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(35583, 5, '42417600_1432893220', 'accessories-6/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(35590, 5, '50318100_1432893220', 'accessories-6/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(35592, 5, '52818200_1432893220', 'accessories-6/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(35595, 5, '56218400_1432893220', 'accessories-6/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(35597, 5, '58418500_1432893220', 'accessories-6/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(35658, 1, '69202700_1432894948', 'accessories-17.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(35660, 1, '73903000_1432894948', 'accessories-17/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(35675, 1, '33406400_1432894949', 'accessories-17/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(35697, 1, '61908000_1432894949', 'accessories-17/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(35719, 1, '78909000_1432894949', 'accessories-17/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(35726, 1, '84009300_1432894949', 'accessories-17/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(35733, 1, '90709700_1432894949', 'accessories-17/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(35771, 1, '38512400_1432894950', 'accessories-17/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(35791, 1, '70314200_1432894950', 'accessories-17/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(35811, 1, '95815700_1432894950', 'accessories-17/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(35831, 1, '18517000_1432894951', 'accessories-17/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(35852, 1, '40318300_1432894951', 'accessories-17/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(35873, 1, '59819400_1432894951', 'accessories-17/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(35894, 1, '82520700_1432894951', 'accessories-17/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(35915, 1, '05322000_1432894952', 'accessories-17/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(35937, 1, '31923500_1432894952', 'accessories-17/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(35942, 1, '37623800_1432894952', 'accessories-17/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(35960, 1, '57725000_1432894952', 'accessories-17/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(35981, 1, '81026300_1432894952', 'accessories-17/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(36002, 1, '03127600_1432894953', 'accessories-17/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(36023, 1, '30129100_1432894953', 'accessories-17/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(36045, 1, '54330500_1432894953', 'accessories-17/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(36050, 1, '59330800_1432894953', 'accessories-17/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(36093, 1, '04633400_1432894954', 'accessories-17/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(36098, 1, '14233900_1432894954', 'accessories-17/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(36117, 1, '38435300_1432894954', 'accessories-17/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(36122, 1, '44935700_1432894954', 'accessories-17/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(36141, 1, '69337100_1432894954', 'accessories-17/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(36146, 1, '77837600_1432894954', 'accessories-17/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(36164, 1, '02138900_1432894955', 'accessories-17/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(36169, 1, '08239300_1432894955', 'accessories-17/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(36193, 1, '35740900_1432894955', 'accessories-17/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(36198, 1, '45341400_1432894955', 'accessories-17/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(36246, 2, '32852100_1432894957', 'accessories-17.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(36248, 2, '37852400_1432894957', 'accessories-17/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(36263, 2, '87855300_1432894957', 'accessories-17/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(36285, 2, '16456900_1432894958', 'accessories-17/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(36307, 2, '42558400_1432894958', 'accessories-17/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(36314, 2, '50858900_1432894958', 'accessories-17/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(36321, 2, '60859500_1432894958', 'accessories-17/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(36359, 2, '99761700_1432894958', 'accessories-17/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(36379, 2, '23963100_1432894959', 'accessories-17/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(36399, 2, '44464200_1432894959', 'accessories-17/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(36419, 2, '67065500_1432894959', 'accessories-17/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(36440, 2, '90666900_1432894959', 'accessories-17/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(36461, 2, '14168200_1432894960', 'accessories-17/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(36482, 2, '39469700_1432894960', 'accessories-17/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(36503, 2, '61971000_1432894960', 'accessories-17/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(36525, 2, '97773000_1432894960', 'accessories-17/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(36530, 2, '09973700_1432894961', 'accessories-17/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(36548, 2, '32175000_1432894961', 'accessories-17/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(36569, 2, '76077500_1432894961', 'accessories-17/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(36590, 2, '19380000_1432894962', 'accessories-17/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(36611, 2, '42381300_1432894962', 'accessories-17/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(36633, 2, '68382800_1432894962', 'accessories-17/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(36638, 2, '75283200_1432894962', 'accessories-17/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(36681, 2, '25686100_1432894963', 'accessories-17/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(36686, 2, '30786300_1432894963', 'accessories-17/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(36705, 2, '51487500_1432894963', 'accessories-17/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(36710, 2, '57487900_1432894963', 'accessories-17/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(36729, 2, '76789000_1432894963', 'accessories-17/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(36734, 2, '82789300_1432894963', 'accessories-17/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(36752, 2, '02690500_1432894964', 'accessories-17/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(36757, 2, '11591000_1432894964', 'accessories-17/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(36781, 2, '43092800_1432894964', 'accessories-17/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(36786, 2, '48393100_1432894964', 'accessories-17/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(36839, 3, '33603700_1432894966', 'accessories-7.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(36841, 3, '39204000_1432894966', 'accessories-7/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(36843, 3, '42304200_1432894966', 'accessories-7/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(36845, 3, '47404500_1432894966', 'accessories-7/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(36847, 3, '61305200_1432894966', 'accessories-7/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(36852, 3, '95307200_1432894966', 'accessories-7/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(36854, 3, '97307300_1432894966', 'accessories-7/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(36875, 3, '15408300_1432894967', 'accessories-7/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(36877, 3, '18708500_1432894967', 'accessories-7/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(36898, 3, '34409400_1432894967', 'accessories-7/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(36900, 3, '36209500_1432894967', 'accessories-7/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(36906, 3, '41609800_1432894967', 'accessories-7/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(36908, 3, '43209900_1432894967', 'accessories-7/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(36914, 3, '47310200_1432894967', 'accessories-7/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(36916, 3, '49310300_1432894967', 'accessories-7/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(36944, 3, '76511800_1432894967', 'accessories-7/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(36964, 3, '98413100_1432894967', 'accessories-7/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(36984, 3, '25814700_1432894968', 'accessories-7/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(37004, 3, '49816000_1432894968', 'accessories-7/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(37024, 3, '70017200_1432894968', 'accessories-7/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(37045, 3, '02119000_1432894969', 'accessories-7/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(37066, 3, '33320800_1432894969', 'accessories-7/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(37087, 3, '58722300_1432894969', 'accessories-7/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(37108, 3, '82123600_1432894969', 'accessories-7/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(37113, 3, '87523900_1432894969', 'accessories-7/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(37132, 3, '12225300_1432894970', 'accessories-7/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(37153, 3, '37326800_1432894970', 'accessories-7/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(37174, 3, '62428200_1432894970', 'accessories-7/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(37195, 3, '89429700_1432894970', 'accessories-7/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(37216, 3, '29032000_1432894971', 'accessories-7/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(37221, 3, '35532400_1432894971', 'accessories-7/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(37264, 3, '54739200_1432894972', 'accessories-7/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(37269, 3, '60539500_1432894972', 'accessories-7/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(37288, 3, '83240800_1432894972', 'accessories-7/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(37293, 3, '89741200_1432894972', 'accessories-7/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(37312, 3, '45244400_1432894973', 'accessories-7/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(37317, 3, '56145000_1432894973', 'accessories-7/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(37335, 3, '82546500_1432894973', 'accessories-7/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(37340, 3, '87846800_1432894973', 'accessories-7/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(37358, 3, '04647800_1432894974', 'accessories-7/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(37365, 3, '11548200_1432894974', 'accessories-7/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(37367, 3, '15648400_1432894974', 'accessories-7/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(37370, 3, '19848600_1432894974', 'accessories-7/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(37372, 3, '23448800_1432894974', 'accessories-7/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(37438, 4, '96758800_1432894975', 'accessories-7.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(37440, 4, '99658900_1432894975', 'accessories-7/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(37442, 4, '02159100_1432894976', 'accessories-7/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(37444, 4, '05259200_1432894976', 'accessories-7/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(37446, 4, '09659500_1432894976', 'accessories-7/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(37451, 4, '43261400_1432894976', 'accessories-7/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(37453, 4, '46961600_1432894976', 'accessories-7/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(37474, 4, '72763100_1432894976', 'accessories-7/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(37476, 4, '77863400_1432894976', 'accessories-7/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(37497, 4, '03064800_1432894977', 'accessories-7/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(37499, 4, '04864900_1432894977', 'accessories-7/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(37505, 4, '27266200_1432894977', 'accessories-7/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(37507, 4, '29066300_1432894977', 'accessories-7/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(37513, 4, '34066600_1432894977', 'accessories-7/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(37515, 4, '36066700_1432894977', 'accessories-7/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(37543, 4, '57167900_1432894977', 'accessories-7/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(37563, 4, '77769100_1432894977', 'accessories-7/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(37583, 4, '99770400_1432894977', 'accessories-7/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(37603, 4, '26171900_1432894978', 'accessories-7/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(37623, 4, '47573100_1432894978', 'accessories-7/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(37644, 4, '69674400_1432894978', 'accessories-7/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(37665, 4, '91575600_1432894978', 'accessories-7/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(37686, 4, '16477000_1432894979', 'accessories-7/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(37707, 4, '49678900_1432894979', 'accessories-7/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(37712, 4, '57379400_1432894979', 'accessories-7/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(37731, 4, '77980600_1432894979', 'accessories-7/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(37752, 4, '11582500_1432894980', 'accessories-7/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(37773, 4, '42684300_1432894980', 'accessories-7/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(37794, 4, '63385400_1432894980', 'accessories-7/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(37815, 4, '91887100_1432894980', 'accessories-7/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(37820, 4, '01587600_1432894981', 'accessories-7/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(37863, 4, '60791000_1432894981', 'accessories-7/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(37868, 4, '68191400_1432894981', 'accessories-7/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(37887, 4, '91992800_1432894981', 'accessories-7/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(37892, 4, '99893200_1432894981', 'accessories-7/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(37911, 4, '17994300_1432894982', 'accessories-7/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(37916, 4, '22194500_1432894982', 'accessories-7/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(37934, 4, '65497000_1432894982', 'accessories-7/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(37939, 4, '71097300_1432894982', 'accessories-7/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(37957, 4, '91198500_1432894982', 'accessories-7/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(37964, 4, '98398900_1432894982', 'accessories-7/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(37966, 4, '02499100_1432894983', 'accessories-7/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(37969, 4, '08099400_1432894983', 'accessories-7/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(37971, 4, '11099600_1432894983', 'accessories-7/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(38037, 5, '52213400_1432894985', 'accessories-7.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(38039, 5, '55313600_1432894985', 'accessories-7/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(38041, 5, '58513800_1432894985', 'accessories-7/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(38043, 5, '62614000_1432894985', 'accessories-7/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(38045, 5, '66414200_1432894985', 'accessories-7/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(38050, 5, '92215700_1432894985', 'accessories-7/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(38052, 5, '93915800_1432894985', 'accessories-7/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(38073, 5, '33418000_1432894986', 'accessories-7/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(38075, 5, '39618400_1432894986', 'accessories-7/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(38096, 5, '71220200_1432894986', 'accessories-7/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(38098, 5, '74920400_1432894986', 'accessories-7/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(38104, 5, '91421400_1432894986', 'accessories-7/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(38106, 5, '07622300_1432894987', 'accessories-7/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(38112, 5, '26323400_1432894987', 'accessories-7/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(38114, 5, '29123500_1432894987', 'accessories-7/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(38142, 5, '33929500_1432894988', 'accessories-7/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(38162, 5, '20134400_1432894989', 'accessories-7/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(38182, 5, '80637900_1432894989', 'accessories-7/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(38202, 5, '21840300_1432894990', 'accessories-7/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(38222, 5, '62642600_1432894990', 'accessories-7/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(38243, 5, '15945600_1432894991', 'accessories-7/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(38264, 5, '75249000_1432894991', 'accessories-7/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(38285, 5, '18051500_1432894992', 'accessories-7/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(38306, 5, '26757700_1432894993', 'accessories-7/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(38311, 5, '32358000_1432894993', 'accessories-7/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(38330, 5, '61859700_1432894993', 'accessories-7/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(38351, 5, '89261300_1432894993', 'accessories-7/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(38372, 5, '12262600_1432894994', 'accessories-7/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(38393, 5, '37864100_1432894994', 'accessories-7/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(38414, 5, '62065400_1432894994', 'accessories-7/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(38419, 5, '67665800_1432894994', 'accessories-7/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(38462, 5, '12268300_1432894995', 'accessories-7/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(38467, 5, '19968800_1432894995', 'accessories-7/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(38486, 5, '42770100_1432894995', 'accessories-7/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(38491, 5, '50370500_1432894995', 'accessories-7/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(38510, 5, '77772100_1432894995', 'accessories-7/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(38515, 5, '85572500_1432894995', 'accessories-7/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(38533, 5, '07473800_1432894996', 'accessories-7/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(38538, 5, '11774000_1432894996', 'accessories-7/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(38556, 5, '27874900_1432894996', 'accessories-7/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(38563, 5, '37675500_1432894996', 'accessories-7/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(38565, 5, '39575600_1432894996', 'accessories-7/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(38568, 5, '42775800_1432894996', 'accessories-7/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(38570, 5, '45175900_1432894996', 'accessories-7/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(38618, 1, '92042400_1434099126', 'accessories-18.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(38620, 1, '96042700_1434099126', 'accessories-18/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(38635, 1, '45445500_1434099127', 'accessories-18/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(38657, 1, '66446700_1434099127', 'accessories-18/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(38679, 1, '87347900_1434099127', 'accessories-18/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(38686, 1, '94648300_1434099127', 'accessories-18/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(38693, 1, '01248700_1434099128', 'accessories-18/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(38731, 1, '43251100_1434099128', 'accessories-18/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(38751, 1, '64652300_1434099128', 'accessories-18/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(38771, 1, '83653400_1434099128', 'accessories-18/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(38791, 1, '03454500_1434099129', 'accessories-18/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(38812, 1, '22855600_1434099129', 'accessories-18/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(38833, 1, '41456700_1434099129', 'accessories-18/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(38854, 1, '62157900_1434099129', 'accessories-18/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(38875, 1, '82359000_1434099129', 'accessories-18/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(38897, 1, '02760200_1434099130', 'accessories-18/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(38902, 1, '07660500_1434099130', 'accessories-18/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(38920, 1, '27361600_1434099130', 'accessories-18/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(38941, 1, '46862700_1434099130', 'accessories-18/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(38962, 1, '66963900_1434099130', 'accessories-18/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(38983, 1, '86265000_1434099130', 'accessories-18/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(39005, 1, '05566100_1434099131', 'accessories-18/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(39010, 1, '10466400_1434099131', 'accessories-18/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(39029, 1, '27967400_1434099131', 'accessories-18/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(39034, 1, '33067700_1434099131', 'accessories-18/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(39053, 1, '50968700_1434099131', 'accessories-18/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(39058, 1, '56469000_1434099131', 'accessories-18/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(39077, 1, '75170100_1434099131', 'accessories-18/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(39082, 1, '95271200_1434099131', 'accessories-18/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(39100, 1, '11572200_1434099132', 'accessories-18/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(39105, 1, '16572400_1434099132', 'accessories-18/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(39129, 1, '44974100_1434099132', 'accessories-18/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(39134, 1, '50574400_1434099132', 'accessories-18/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(39182, 2, '51380100_1434099133', 'accessories-18.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(39184, 2, '53780300_1434099133', 'accessories-18/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(39199, 2, '91682500_1434099133', 'accessories-18/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(39221, 2, '13183700_1434099134', 'accessories-18/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(39243, 2, '32784800_1434099134', 'accessories-18/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(39250, 2, '39485200_1434099134', 'accessories-18/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(39257, 2, '46385600_1434099134', 'accessories-18/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(39295, 2, '82887700_1434099134', 'accessories-18/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(39315, 2, '02388800_1434099135', 'accessories-18/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(39335, 2, '20289800_1434099135', 'accessories-18/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(39355, 2, '46391300_1434099135', 'accessories-18/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(39376, 2, '68292600_1434099135', 'accessories-18/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(39397, 2, '94094000_1434099135', 'accessories-18/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(39418, 2, '13395100_1434099136', 'accessories-18/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(39439, 2, '36496500_1434099136', 'accessories-18/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(39461, 2, '59097700_1434099136', 'accessories-18/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(39466, 2, '66698200_1434099136', 'accessories-18/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(39484, 2, '82799100_1434099136', 'accessories-18/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(39505, 2, '03500300_1434099137', 'accessories-18/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(39526, 2, '24901500_1434099137', 'accessories-18/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(39547, 2, '44402600_1434099137', 'accessories-18/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(39569, 2, '66603900_1434099137', 'accessories-18/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(39574, 2, '71504200_1434099137', 'accessories-18/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(39593, 2, '87805100_1434099137', 'accessories-18/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(39598, 2, '92805400_1434099137', 'accessories-18/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(39617, 2, '10506400_1434099138', 'accessories-18/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(39622, 2, '16006700_1434099138', 'accessories-18/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(39641, 2, '34207800_1434099138', 'accessories-18/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(39646, 2, '39108000_1434099138', 'accessories-18/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(39664, 2, '57209100_1434099138', 'accessories-18/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(39669, 2, '63209400_1434099138', 'accessories-18/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(39693, 2, '85710700_1434099138', 'accessories-18/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(39698, 2, '90611000_1434099138', 'accessories-18/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(39751, 3, '17718300_1434099140', 'accessories-8.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(39753, 3, '21818500_1434099140', 'accessories-8/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(39755, 3, '26418800_1434099140', 'accessories-8/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(39757, 3, '29819000_1434099140', 'accessories-8/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(39759, 3, '33419200_1434099140', 'accessories-8/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(39764, 3, '59420600_1434099140', 'accessories-8/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(39766, 3, '61820800_1434099140', 'accessories-8/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(39787, 3, '82622000_1434099140', 'accessories-8/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(39789, 3, '85022100_1434099140', 'accessories-8/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(39810, 3, '05523300_1434099141', 'accessories-8/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(39812, 3, '08123400_1434099141', 'accessories-8/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(39818, 3, '13923800_1434099141', 'accessories-8/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(39820, 3, '16323900_1434099141', 'accessories-8/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(39826, 3, '22024200_1434099141', 'accessories-8/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(39828, 3, '24324400_1434099141', 'accessories-8/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(39856, 3, '51825900_1434099141', 'accessories-8/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(39876, 3, '70427000_1434099141', 'accessories-8/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(39896, 3, '89128100_1434099141', 'accessories-8/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(39916, 3, '19829800_1434099142', 'accessories-8/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(39936, 3, '38030900_1434099142', 'accessories-8/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(39957, 3, '58332000_1434099142', 'accessories-8/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(39978, 3, '79533200_1434099142', 'accessories-8/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(39999, 3, '98534300_1434099142', 'accessories-8/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(40020, 3, '18235500_1434099143', 'accessories-8/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(40025, 3, '23835800_1434099143', 'accessories-8/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(40044, 3, '42736900_1434099143', 'accessories-8/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(40065, 3, '62738000_1434099143', 'accessories-8/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(40086, 3, '82439100_1434099143', 'accessories-8/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(40107, 3, '02040200_1434099144', 'accessories-8/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(40128, 3, '22041400_1434099144', 'accessories-8/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(40133, 3, '27141700_1434099144', 'accessories-8/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(40152, 3, '44542700_1434099144', 'accessories-8/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(40157, 3, '49443000_1434099144', 'accessories-8/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(40176, 3, '69744100_1434099144', 'accessories-8/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(40181, 3, '74644400_1434099144', 'accessories-8/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(40200, 3, '91845400_1434099144', 'accessories-8/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(40205, 3, '96945700_1434099144', 'accessories-8/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(40223, 3, '14246700_1434099145', 'accessories-8/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(40228, 3, '20347000_1434099145', 'accessories-8/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(40246, 3, '36747900_1434099145', 'accessories-8/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(40253, 3, '43548300_1434099145', 'accessories-8/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(40255, 3, '45648500_1434099145', 'accessories-8/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(40258, 3, '49348700_1434099145', 'accessories-8/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(40260, 3, '51448800_1434099145', 'accessories-8/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(40326, 4, '80056100_1434099146', 'accessories-8.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(40328, 4, '82356300_1434099146', 'accessories-8/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(40330, 4, '84756400_1434099146', 'accessories-8/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(40332, 4, '86956500_1434099146', 'accessories-8/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(40334, 4, '89056700_1434099146', 'accessories-8/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(40339, 4, '10557900_1434099147', 'accessories-8/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(40341, 4, '12658000_1434099147', 'accessories-8/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(40362, 4, '33059200_1434099147', 'accessories-8/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(40364, 4, '35459300_1434099147', 'accessories-8/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(40385, 4, '57060500_1434099147', 'accessories-8/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(40387, 4, '59660700_1434099147', 'accessories-8/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(40393, 4, '66161100_1434099147', 'accessories-8/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(40395, 4, '68561200_1434099147', 'accessories-8/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(40401, 4, '74661600_1434099147', 'accessories-8/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(40403, 4, '77661700_1434099147', 'accessories-8/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(40431, 4, '04663300_1434099148', 'accessories-8/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(40451, 4, '23564400_1434099148', 'accessories-8/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(40471, 4, '41465400_1434099148', 'accessories-8/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(40491, 4, '60866500_1434099148', 'accessories-8/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(40511, 4, '81267700_1434099148', 'accessories-8/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(40532, 4, '99568700_1434099148', 'accessories-8/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(40553, 4, '19069800_1434099149', 'accessories-8/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(40574, 4, '39071000_1434099149', 'accessories-8/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(40595, 4, '77673200_1434099149', 'accessories-8/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(40600, 4, '82673500_1434099149', 'accessories-8/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(40619, 4, '03374600_1434099150', 'accessories-8/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(40640, 4, '23075800_1434099150', 'accessories-8/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(40661, 4, '43877000_1434099150', 'accessories-8/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(40682, 4, '65478200_1434099150', 'accessories-8/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(40703, 4, '85279300_1434099150', 'accessories-8/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(40708, 4, '92379700_1434099150', 'accessories-8/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(40727, 4, '09280700_1434099151', 'accessories-8/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(40732, 4, '14581000_1434099151', 'accessories-8/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(40751, 4, '33782100_1434099151', 'accessories-8/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(40756, 4, '38482400_1434099151', 'accessories-8/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(40775, 4, '58383500_1434099151', 'accessories-8/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(40780, 4, '63083800_1434099151', 'accessories-8/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(40798, 4, '79884700_1434099151', 'accessories-8/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(40803, 4, '86285100_1434099151', 'accessories-8/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(40821, 4, '02386000_1434099152', 'accessories-8/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(40828, 4, '20187000_1434099152', 'accessories-8/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(40830, 4, '22987200_1434099152', 'accessories-8/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(40833, 4, '26287400_1434099152', 'accessories-8/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(40835, 4, '28587500_1434099152', 'accessories-8/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(40901, 5, '58194900_1434099153', 'accessories-8.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(40903, 5, '60395100_1434099153', 'accessories-8/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(40905, 5, '62895200_1434099153', 'accessories-8/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(40907, 5, '65395300_1434099153', 'accessories-8/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(40909, 5, '67695500_1434099153', 'accessories-8/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(40914, 5, '88396700_1434099153', 'accessories-8/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(40916, 5, '90596800_1434099153', 'accessories-8/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(40937, 5, '10597900_1434099154', 'accessories-8/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(40939, 5, '13198100_1434099154', 'accessories-8/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(40960, 5, '31999200_1434099154', 'accessories-8/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(40962, 5, '34299300_1434099154', 'accessories-8/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(40968, 5, '40799700_1434099154', 'accessories-8/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(40970, 5, '42999800_1434099154', 'accessories-8/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(40976, 5, '48900100_1434099154', 'accessories-8/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(40978, 5, '51500300_1434099154', 'accessories-8/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(41006, 5, '07503500_1434099155', 'accessories-8/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(41026, 5, '32104900_1434099155', 'accessories-8/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(41046, 5, '51206000_1434099155', 'accessories-8/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(41066, 5, '70107100_1434099155', 'accessories-8/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(41086, 5, '89708200_1434099155', 'accessories-8/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(41107, 5, '09409300_1434099156', 'accessories-8/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(41128, 5, '30210500_1434099156', 'accessories-8/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(41149, 5, '53211800_1434099156', 'accessories-8/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(41170, 5, '74113000_1434099156', 'accessories-8/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(41175, 5, '78913300_1434099156', 'accessories-8/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(41194, 5, '97014300_1434099156', 'accessories-8/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(41215, 5, '18315500_1434099157', 'accessories-8/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(41236, 5, '40716800_1434099157', 'accessories-8/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(41257, 5, '60317900_1434099157', 'accessories-8/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(41278, 5, '79519000_1434099157', 'accessories-8/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(41283, 5, '86919500_1434099157', 'accessories-8/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(41302, 5, '06620600_1434099158', 'accessories-8/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(41307, 5, '11820900_1434099158', 'accessories-8/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(41326, 5, '31622000_1434099158', 'accessories-8/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(41331, 5, '37022300_1434099158', 'accessories-8/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(41350, 5, '57223500_1434099158', 'accessories-8/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(41355, 5, '62123800_1434099158', 'accessories-8/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(41373, 5, '79124700_1434099158', 'accessories-8/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(41378, 5, '84125000_1434099158', 'accessories-8/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(41396, 5, '02626100_1434099159', 'accessories-8/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(41403, 5, '09526500_1434099159', 'accessories-8/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(41405, 5, '11626600_1434099159', 'accessories-8/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(41408, 5, '14826800_1434099159', 'accessories-8/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(41410, 5, '16926900_1434099159', 'accessories-8/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(41471, 1, '27911700_1434099943', 'accessories-19.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(41473, 1, '32012000_1434099943', 'accessories-19/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(41488, 1, '07616300_1434099944', 'accessories-19/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(41510, 1, '28417500_1434099944', 'accessories-19/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(41532, 1, '52018800_1434099944', 'accessories-19/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(41539, 1, '59119200_1434099944', 'accessories-19/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(41546, 1, '66019600_1434099944', 'accessories-19/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(41584, 1, '01721700_1434099945', 'accessories-19/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(41604, 1, '22122900_1434099945', 'accessories-19/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(41624, 1, '41323900_1434099945', 'accessories-19/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(41644, 1, '60225000_1434099945', 'accessories-19/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(41665, 1, '82126300_1434099945', 'accessories-19/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(41686, 1, '01327400_1434099946', 'accessories-19/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(41707, 1, '23428600_1434099946', 'accessories-19/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(41728, 1, '46029900_1434099946', 'accessories-19/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(41750, 1, '69331300_1434099946', 'accessories-19/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(41755, 1, '74531600_1434099946', 'accessories-19/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(41773, 1, '92132600_1434099946', 'accessories-19/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(41794, 1, '13733800_1434099947', 'accessories-19/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(41815, 1, '34835000_1434099947', 'accessories-19/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(41836, 1, '54536100_1434099947', 'accessories-19/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(41858, 1, '76737400_1434099947', 'accessories-19/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(41863, 1, '81737700_1434099947', 'accessories-19/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(41882, 1, '05439100_1434099948', 'accessories-19/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(41887, 1, '11639400_1434099948', 'accessories-19/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(41906, 1, '29040400_1434099948', 'accessories-19/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(41911, 1, '36740800_1434099948', 'accessories-19/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(41930, 1, '56342000_1434099948', 'accessories-19/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(41935, 1, '61042200_1434099948', 'accessories-19/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(41953, 1, '77943200_1434099948', 'accessories-19/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(41958, 1, '83343500_1434099948', 'accessories-19/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(41982, 1, '10145000_1434099949', 'accessories-19/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(41987, 1, '15445300_1434099949', 'accessories-19/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(41988, 1, 'product/49', 'virtual-product.html', 'catalog/product/view/id/49', 1, NULL, NULL, NULL, 49),
(41989, 1, 'product/49/50', 'accessories-27/virtual-product.html', 'catalog/product/view/id/49/category/50', 1, NULL, NULL, 50, 49),
(41990, 1, 'product/49/58', 'accessories-27/product-types/virtual-product.html', 'catalog/product/view/id/49/category/58', 1, NULL, NULL, 58, 49),
(42038, 2, '28551800_1434099950', 'accessories-19.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(42040, 2, '30651900_1434099950', 'accessories-19/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(42055, 2, '72854400_1434099950', 'accessories-19/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(42077, 2, '93655500_1434099950', 'accessories-19/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(42099, 2, '14156700_1434099951', 'accessories-19/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(42106, 2, '21457100_1434099951', 'accessories-19/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(42113, 2, '53659000_1434099951', 'accessories-19/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(42151, 2, '02561800_1434099952', 'accessories-19/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(42171, 2, '24163000_1434099952', 'accessories-19/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(42191, 2, '44064100_1434099952', 'accessories-19/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(42211, 2, '64965300_1434099952', 'accessories-19/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(42232, 2, '08267800_1434099953', 'accessories-19/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(42253, 2, '44369900_1434099953', 'accessories-19/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(42274, 2, '66071100_1434099953', 'accessories-19/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(42295, 2, '93672700_1434099953', 'accessories-19/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(42317, 2, '15874000_1434099954', 'accessories-19/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(42322, 2, '23274400_1434099954', 'accessories-19/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(42340, 2, '40975400_1434099954', 'accessories-19/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(42361, 2, '61476600_1434099954', 'accessories-19/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(42382, 2, '04879100_1434099955', 'accessories-19/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(42403, 2, '32580600_1434099955', 'accessories-19/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(42425, 2, '54481900_1434099955', 'accessories-19/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(42430, 2, '61682300_1434099955', 'accessories-19/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(42449, 2, '85283700_1434099955', 'accessories-19/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(42454, 2, '90283900_1434099955', 'accessories-19/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(42473, 2, '07484900_1434099956', 'accessories-19/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(42478, 2, '12585200_1434099956', 'accessories-19/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(42497, 2, '40886800_1434099956', 'accessories-19/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(42502, 2, '46087100_1434099956', 'accessories-19/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(42520, 2, '65388200_1434099956', 'accessories-19/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(42525, 2, '69988500_1434099956', 'accessories-19/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(42549, 2, '97890100_1434099956', 'accessories-19/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(42554, 2, '03890400_1434099957', 'accessories-19/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(42555, 2, 'product/49', 'virtual-product.html', 'catalog/product/view/id/49', 1, NULL, NULL, NULL, 49),
(42556, 2, 'product/49/50', 'accessories-27/virtual-product.html', 'catalog/product/view/id/49/category/50', 1, NULL, NULL, 50, 49),
(42557, 2, 'product/49/58', 'accessories-27/product-types/virtual-product.html', 'catalog/product/view/id/49/category/58', 1, NULL, NULL, 58, 49),
(42610, 3, '84900800_1434099958', 'accessories-9.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(42612, 3, '93301300_1434099958', 'accessories-9/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(42614, 3, '97901500_1434099958', 'accessories-9/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(42616, 3, '04301900_1434099959', 'accessories-9/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(42618, 3, '08202100_1434099959', 'accessories-9/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(42623, 3, '36403700_1434099959', 'accessories-9/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(42625, 3, '41704000_1434099959', 'accessories-9/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(42646, 3, '65105400_1434099959', 'accessories-9/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(42648, 3, '69005600_1434099959', 'accessories-9/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(42669, 3, '87706700_1434099959', 'accessories-9/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(42671, 3, '90106800_1434099959', 'accessories-9/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(42677, 3, '95807100_1434099959', 'accessories-9/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(42679, 3, '99207300_1434099959', 'accessories-9/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(42685, 3, '05407700_1434099960', 'accessories-9/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(42687, 3, '07707800_1434099960', 'accessories-9/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(42715, 3, '34609400_1434099960', 'accessories-9/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(42735, 3, '53510400_1434099960', 'accessories-9/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(42755, 3, '74011600_1434099960', 'accessories-9/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(42775, 3, '93012700_1434099960', 'accessories-9/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(42795, 3, '13713900_1434099961', 'accessories-9/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(42816, 3, '34815100_1434099961', 'accessories-9/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(42837, 3, '55316300_1434099961', 'accessories-9/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(42858, 3, '75317400_1434099961', 'accessories-9/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(42879, 3, '97618700_1434099961', 'accessories-9/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(42884, 3, '02919000_1434099962', 'accessories-9/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(42903, 3, '21520100_1434099962', 'accessories-9/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(42924, 3, '42221200_1434099962', 'accessories-9/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(42945, 3, '70322800_1434099962', 'accessories-9/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(42966, 3, '92324100_1434099962', 'accessories-9/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(42987, 3, '13825300_1434099963', 'accessories-9/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(42992, 3, '19325600_1434099963', 'accessories-9/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(43011, 3, '59627900_1434099963', 'accessories-9/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(43016, 3, '65028300_1434099963', 'accessories-9/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(43035, 3, '85329400_1434099963', 'accessories-9/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(43040, 3, '08230700_1434099964', 'accessories-9/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(43059, 3, '27631800_1434099964', 'accessories-9/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(43064, 3, '32732100_1434099964', 'accessories-9/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(43082, 3, '53833300_1434099964', 'accessories-9/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(43087, 3, '58833600_1434099964', 'accessories-9/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(43105, 3, '76034600_1434099964', 'accessories-9/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(43112, 3, '82935000_1434099964', 'accessories-9/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(43114, 3, '85335100_1434099964', 'accessories-9/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(43117, 3, '15036800_1434099965', 'accessories-9/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(43119, 3, '20137100_1434099965', 'accessories-9/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(43133, 3, 'product/49', 'virtual-product.html', 'catalog/product/view/id/49', 1, NULL, NULL, NULL, 49),
(43134, 3, 'product/49/50', 'accessories/virtual-product.html', 'catalog/product/view/id/49/category/50', 1, NULL, NULL, 50, 49),
(43135, 3, 'product/49/58', 'accessories/product-types/virtual-product.html', 'catalog/product/view/id/49/category/58', 1, NULL, NULL, 58, 49),
(43188, 4, '84852300_1434099967', 'accessories-9.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(43190, 4, '88552500_1434099967', 'accessories-9/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(43192, 4, '93552800_1434099967', 'accessories-9/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(43194, 4, '95852900_1434099967', 'accessories-9/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(43196, 4, '00753200_1434099968', 'accessories-9/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(43201, 4, '28354800_1434099968', 'accessories-9/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(43203, 4, '30854900_1434099968', 'accessories-9/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(43224, 4, '52256100_1434099968', 'accessories-9/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(43226, 4, '56556400_1434099968', 'accessories-9/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(43247, 4, '86258100_1434099968', 'accessories-9/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(43249, 4, '89758300_1434099968', 'accessories-9/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(43255, 4, '99458800_1434099968', 'accessories-9/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(43257, 4, '03059000_1434099969', 'accessories-9/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(43263, 4, '09159400_1434099969', 'accessories-9/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(43265, 4, '11859500_1434099969', 'accessories-9/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(43293, 4, '39861100_1434099969', 'accessories-9/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(43313, 4, '65162600_1434099969', 'accessories-9/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(43333, 4, '86163800_1434099969', 'accessories-9/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(43353, 4, '20765800_1434099970', 'accessories-9/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(43373, 4, '46267200_1434099970', 'accessories-9/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(43394, 4, '72768700_1434099970', 'accessories-9/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(43415, 4, '01470400_1434099971', 'accessories-9/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(43436, 4, '31472100_1434099971', 'accessories-9/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(43457, 4, '67874200_1434099971', 'accessories-9/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(43462, 4, '72274400_1434099971', 'accessories-9/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(43481, 4, '96175800_1434099971', 'accessories-9/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(43502, 4, '30477800_1434099972', 'accessories-9/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(43523, 4, '48378800_1434099972', 'accessories-9/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(43544, 4, '66879800_1434099972', 'accessories-9/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(43565, 4, '85180900_1434099972', 'accessories-9/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(43570, 4, '90281200_1434099972', 'accessories-9/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(43589, 4, '15882600_1434099973', 'accessories-9/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(43594, 4, '20882900_1434099973', 'accessories-9/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(43613, 4, '40584100_1434099973', 'accessories-9/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(43618, 4, '47584500_1434099973', 'accessories-9/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(43637, 4, '11588100_1434099974', 'accessories-9/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(43642, 4, '16188400_1434099974', 'accessories-9/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(43660, 4, '31489300_1434099974', 'accessories-9/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(43665, 4, '35589500_1434099974', 'accessories-9/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(43683, 4, '55090600_1434099974', 'accessories-9/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(43690, 4, '65591200_1434099974', 'accessories-9/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(43692, 4, '69591400_1434099974', 'accessories-9/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(43695, 4, '74991700_1434099974', 'accessories-9/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(43697, 4, '77491900_1434099974', 'accessories-9/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(43711, 4, 'product/49', 'virtual-product.html', 'catalog/product/view/id/49', 1, NULL, NULL, NULL, 49),
(43712, 4, 'product/49/50', 'accessories/virtual-product.html', 'catalog/product/view/id/49/category/50', 1, NULL, NULL, 50, 49),
(43713, 4, 'product/49/58', 'accessories/product-types/virtual-product.html', 'catalog/product/view/id/49/category/58', 1, NULL, NULL, 58, 49),
(43766, 5, '78803400_1434099976', 'accessories-9.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(43768, 5, '84903800_1434099976', 'accessories-9/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(43770, 5, '01104700_1434099977', 'accessories-9/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(43772, 5, '07205000_1434099977', 'accessories-9/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(43774, 5, '39006800_1434099977', 'accessories-9/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(43779, 5, '68808500_1434099977', 'accessories-9/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(43781, 5, '71408700_1434099977', 'accessories-9/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(43802, 5, '95910100_1434099977', 'accessories-9/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(43804, 5, '02410500_1434099978', 'accessories-9/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(43825, 5, '45112900_1434099978', 'accessories-9/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(43827, 5, '50613200_1434099978', 'accessories-9/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(43833, 5, '77614800_1434099978', 'accessories-9/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(43835, 5, '84015100_1434099978', 'accessories-9/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(43841, 5, '90615500_1434099978', 'accessories-9/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(43843, 5, '94715800_1434099978', 'accessories-9/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(43871, 5, '19517200_1434099979', 'accessories-9/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(43891, 5, '42518500_1434099979', 'accessories-9/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(43911, 5, '60519500_1434099979', 'accessories-9/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(43931, 5, '91021300_1434099979', 'accessories-9/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(43951, 5, '26923300_1434099980', 'accessories-9/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(43972, 5, '62525300_1434099980', 'accessories-9/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(43993, 5, '82926500_1434099980', 'accessories-9/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(44014, 5, '05027800_1434099981', 'accessories-9/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(44035, 5, '35729500_1434099981', 'accessories-9/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(44040, 5, '53830600_1434099981', 'accessories-9/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(44059, 5, '82432200_1434099981', 'accessories-9/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(44080, 5, '03333400_1434099982', 'accessories-9/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(44101, 5, '24134600_1434099982', 'accessories-9/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(44122, 5, '45535800_1434099982', 'accessories-9/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(44143, 5, '68137100_1434099982', 'accessories-9/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(44148, 5, '75337500_1434099982', 'accessories-9/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(44167, 5, '94038600_1434099982', 'accessories-9/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(44172, 5, '00138900_1434099983', 'accessories-9/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(44191, 5, '20040100_1434099983', 'accessories-9/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(44196, 5, '26340400_1434099983', 'accessories-9/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(44215, 5, '45041500_1434099983', 'accessories-9/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(44220, 5, '52041900_1434099983', 'accessories-9/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(44238, 5, '90244100_1434099983', 'accessories-9/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(44243, 5, '45647300_1434099984', 'accessories-9/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(44261, 5, '89949800_1434099984', 'accessories-9/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(44268, 5, '14151200_1434099985', 'accessories-9/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(44270, 5, '16951300_1434099985', 'accessories-9/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(44273, 5, '20651600_1434099985', 'accessories-9/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(44275, 5, '24851800_1434099985', 'accessories-9/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(44289, 5, 'product/49', 'virtual-product.html', 'catalog/product/view/id/49', 1, NULL, NULL, NULL, 49),
(44290, 5, 'product/49/50', 'accessories/virtual-product.html', 'catalog/product/view/id/49/category/50', 1, NULL, NULL, 50, 49),
(44291, 5, 'product/49/58', 'accessories/product-types/virtual-product.html', 'catalog/product/view/id/49/category/58', 1, NULL, NULL, 58, 49),
(44339, 1, '27141300_1434353019', 'accessories-20.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(44341, 1, '32941700_1434353019', 'accessories-20/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(44356, 1, '86444700_1434353019', 'accessories-20/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(44378, 1, '09746000_1434353020', 'accessories-20/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(44400, 1, '33847400_1434353020', 'accessories-20/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(44407, 1, '43748000_1434353020', 'accessories-20/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(44414, 1, '52548500_1434353020', 'accessories-20/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(44452, 1, '94550900_1434353020', 'accessories-20/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(44472, 1, '28552800_1434353021', 'accessories-20/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(44492, 1, '55854400_1434353021', 'accessories-20/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(44512, 1, '82755900_1434353021', 'accessories-20/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(44533, 1, '12757700_1434353022', 'accessories-20/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(44554, 1, '38359100_1434353022', 'accessories-20/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(44575, 1, '66660700_1434353022', 'accessories-20/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(44596, 1, '89862100_1434353022', 'accessories-20/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(44618, 1, '14963500_1434353023', 'accessories-20/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(44623, 1, '21363900_1434353023', 'accessories-20/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(44641, 1, '41165000_1434353023', 'accessories-20/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(44662, 1, '65966400_1434353023', 'accessories-20/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(44683, 1, '93868000_1434353023', 'accessories-20/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(44704, 1, '21969600_1434353024', 'accessories-20/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(44726, 1, '49371200_1434353024', 'accessories-20/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(44731, 1, '54871500_1434353024', 'accessories-20/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(44750, 1, '76872800_1434353024', 'accessories-20/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(44755, 1, '82573100_1434353024', 'accessories-20/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(44774, 1, '03474300_1434353025', 'accessories-20/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(44779, 1, '09474600_1434353025', 'accessories-20/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(44798, 1, '29475800_1434353025', 'accessories-20/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(44803, 1, '35976100_1434353025', 'accessories-20/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(44821, 1, '56277300_1434353025', 'accessories-20/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(44826, 1, '62277600_1434353025', 'accessories-20/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(44850, 1, '86579000_1434353025', 'accessories-20/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(44855, 1, '93379400_1434353025', 'accessories-20/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(44858, 1, '96979600_1434353025', 'accessories-20/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(44860, 1, '99679800_1434353025', 'accessories-20/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(44908, 2, '43088000_1434353027', 'accessories-20.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(44910, 2, '45288100_1434353027', 'accessories-20/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(44925, 2, '85290400_1434353027', 'accessories-20/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(44947, 2, '10291800_1434353028', 'accessories-20/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(44969, 2, '41493600_1434353028', 'accessories-20/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(44976, 2, '55594400_1434353028', 'accessories-20/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(44983, 2, '66195000_1434353028', 'accessories-20/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(45021, 2, '08697500_1434353029', 'accessories-20/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(45041, 2, '34799000_1434353029', 'accessories-20/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(45061, 2, '58100300_1434353029', 'accessories-20/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(45081, 2, '80901600_1434353029', 'accessories-20/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(45102, 2, '29204400_1434353030', 'accessories-20/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(45123, 2, '53305700_1434353030', 'accessories-20/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(45144, 2, '75007000_1434353030', 'accessories-20/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(45165, 2, '99708400_1434353030', 'accessories-20/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(45187, 2, '29110100_1434353031', 'accessories-20/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(45192, 2, '34810400_1434353031', 'accessories-20/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(45210, 2, '54911500_1434353031', 'accessories-20/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(45231, 2, '19815300_1434353032', 'accessories-20/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(45252, 2, '59717500_1434353032', 'accessories-20/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(45273, 2, '89819300_1434353032', 'accessories-20/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(45295, 2, '13420600_1434353033', 'accessories-20/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(45300, 2, '19721000_1434353033', 'accessories-20/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(45319, 2, '39422100_1434353033', 'accessories-20/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(45324, 2, '45222400_1434353033', 'accessories-20/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(45343, 2, '66323600_1434353033', 'accessories-20/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(45348, 2, '71523900_1434353033', 'accessories-20/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(45367, 2, '94625300_1434353033', 'accessories-20/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(45372, 2, '00825600_1434353034', 'accessories-20/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(45390, 2, '22526900_1434353034', 'accessories-20/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(45395, 2, '28427200_1434353034', 'accessories-20/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(45419, 2, '54028700_1434353034', 'accessories-20/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(45424, 2, '60029000_1434353034', 'accessories-20/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(45427, 2, '64229200_1434353034', 'accessories-20/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(45429, 2, '67029400_1434353034', 'accessories-20/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(45482, 3, '93936700_1434353035', 'accessories-10.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(45484, 3, '97936900_1434353035', 'accessories-10/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(45486, 3, '02237100_1434353036', 'accessories-10/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(45488, 3, '06137400_1434353036', 'accessories-10/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(45490, 3, '10137600_1434353036', 'accessories-10/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(45495, 3, '36939100_1434353036', 'accessories-10/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(45497, 3, '39939300_1434353036', 'accessories-10/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(45518, 3, '62940600_1434353036', 'accessories-10/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(45520, 3, '65840800_1434353036', 'accessories-10/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(45541, 3, '91042200_1434353036', 'accessories-10/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(45543, 3, '93742400_1434353036', 'accessories-10/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(45549, 3, '03342900_1434353037', 'accessories-10/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(45551, 3, '07143100_1434353037', 'accessories-10/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(45557, 3, '15543600_1434353037', 'accessories-10/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(45559, 3, '19043800_1434353037', 'accessories-10/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(45587, 3, '48745500_1434353037', 'accessories-10/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(45607, 3, '69146700_1434353037', 'accessories-10/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(45627, 3, '89647900_1434353037', 'accessories-10/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(45647, 3, '11249100_1434353038', 'accessories-10/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(45667, 3, '32750300_1434353038', 'accessories-10/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(45688, 3, '56051600_1434353038', 'accessories-10/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(45709, 3, '78352900_1434353038', 'accessories-10/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(45730, 3, '00954200_1434353039', 'accessories-10/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(45751, 3, '22755500_1434353039', 'accessories-10/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(45756, 3, '28955800_1434353039', 'accessories-10/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(45775, 3, '47556900_1434353039', 'accessories-10/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(45796, 3, '69158100_1434353039', 'accessories-10/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(45817, 3, '94159500_1434353039', 'accessories-10/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(45838, 3, '26261400_1434353040', 'accessories-10/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(45859, 3, '49262700_1434353040', 'accessories-10/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(45864, 3, '55463100_1434353040', 'accessories-10/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(45883, 3, '81864600_1434353040', 'accessories-10/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(45888, 3, '87664900_1434353040', 'accessories-10/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(45907, 3, '11066200_1434353041', 'accessories-10/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(45912, 3, '18966700_1434353041', 'accessories-10/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(45931, 3, '40367900_1434353041', 'accessories-10/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(45936, 3, '48168400_1434353041', 'accessories-10/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(45954, 3, '68769500_1434353041', 'accessories-10/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(45959, 3, '76070000_1434353041', 'accessories-10/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(45977, 3, '99771300_1434353041', 'accessories-10/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(45984, 3, '07671800_1434353042', 'accessories-10/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(45986, 3, '11572000_1434353042', 'accessories-10/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(45989, 3, '21772600_1434353042', 'accessories-10/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(45991, 3, '26972900_1434353042', 'accessories-10/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(46060, 4, '92482300_1434353043', 'accessories-10.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(46062, 4, '94982500_1434353043', 'accessories-10/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(46064, 4, '97282600_1434353043', 'accessories-10/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(46066, 4, '99882800_1434353043', 'accessories-10/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(46068, 4, '02282900_1434353044', 'accessories-10/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(46073, 4, '23484100_1434353044', 'accessories-10/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(46075, 4, '26484300_1434353044', 'accessories-10/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(46096, 4, '59086100_1434353044', 'accessories-10/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(46098, 4, '61886300_1434353044', 'accessories-10/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(46119, 4, '87287800_1434353044', 'accessories-10/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(46121, 4, '89787900_1434353044', 'accessories-10/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(46127, 4, '96488300_1434353044', 'accessories-10/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(46129, 4, '99688500_1434353044', 'accessories-10/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(46135, 4, '06388800_1434353045', 'accessories-10/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(46137, 4, '08789000_1434353045', 'accessories-10/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(46165, 4, '40290800_1434353045', 'accessories-10/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(46185, 4, '63892100_1434353045', 'accessories-10/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(46205, 4, '86493400_1434353045', 'accessories-10/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(46225, 4, '08394700_1434353046', 'accessories-10/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(46245, 4, '29795900_1434353046', 'accessories-10/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(46266, 4, '59397600_1434353046', 'accessories-10/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(46287, 4, '80798800_1434353046', 'accessories-10/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(46308, 4, '03500100_1434353047', 'accessories-10/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(46329, 4, '27001500_1434353047', 'accessories-10/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(46334, 4, '32601800_1434353047', 'accessories-10/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(46353, 4, '62903500_1434353047', 'accessories-10/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(46374, 4, '86004800_1434353047', 'accessories-10/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(46395, 4, '09106200_1434353048', 'accessories-10/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(46416, 4, '30507400_1434353048', 'accessories-10/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(46437, 4, '55908800_1434353048', 'accessories-10/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(46442, 4, '62509200_1434353048', 'accessories-10/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(46461, 4, '81910300_1434353048', 'accessories-10/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(46466, 4, '87410600_1434353048', 'accessories-10/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(46485, 4, '08111800_1434353049', 'accessories-10/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(46490, 4, '14412200_1434353049', 'accessories-10/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(46509, 4, '35113400_1434353049', 'accessories-10/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(46514, 4, '40613700_1434353049', 'accessories-10/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(46532, 4, '64415000_1434353049', 'accessories-10/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(46537, 4, '69615300_1434353049', 'accessories-10/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(46555, 4, '90516500_1434353049', 'accessories-10/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(46562, 4, '98417000_1434353049', 'accessories-10/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(46564, 4, '01117100_1434353050', 'accessories-10/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(46567, 4, '04817400_1434353050', 'accessories-10/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(46569, 4, '07417500_1434353050', 'accessories-10/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(46638, 5, '19329600_1434353052', 'accessories-10.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(46640, 5, '22929800_1434353052', 'accessories-10/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(46642, 5, '25330000_1434353052', 'accessories-10/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(46644, 5, '28330100_1434353052', 'accessories-10/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(46646, 5, '30830300_1434353052', 'accessories-10/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(46651, 5, '51931500_1434353052', 'accessories-10/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(46653, 5, '54531600_1434353052', 'accessories-10/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(46674, 5, '78433000_1434353052', 'accessories-10/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(46676, 5, '86333500_1434353052', 'accessories-10/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(46697, 5, '07534700_1434353053', 'accessories-10/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(46699, 5, '09934800_1434353053', 'accessories-10/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(46705, 5, '16535200_1434353053', 'accessories-10/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(46707, 5, '19435300_1434353053', 'accessories-10/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(46713, 5, '26235700_1434353053', 'accessories-10/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(46715, 5, '28735900_1434353053', 'accessories-10/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(46743, 5, '58137600_1434353053', 'accessories-10/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(46763, 5, '80438800_1434353053', 'accessories-10/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(46783, 5, '02840100_1434353054', 'accessories-10/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(46803, 5, '24541400_1434353054', 'accessories-10/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(46823, 5, '45442600_1434353054', 'accessories-10/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(46844, 5, '69043900_1434353054', 'accessories-10/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(46865, 5, '91545200_1434353054', 'accessories-10/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(46886, 5, '18546700_1434353055', 'accessories-10/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(46907, 5, '42748100_1434353055', 'accessories-10/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(46912, 5, '49548500_1434353055', 'accessories-10/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(46931, 5, '71949800_1434353055', 'accessories-10/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(46952, 5, '94251100_1434353055', 'accessories-10/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(46973, 5, '19452500_1434353056', 'accessories-10/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(46994, 5, '41753800_1434353056', 'accessories-10/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(47015, 5, '65355100_1434353056', 'accessories-10/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(47020, 5, '70755400_1434353056', 'accessories-10/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(47039, 5, '91356600_1434353056', 'accessories-10/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(47044, 5, '98457000_1434353056', 'accessories-10/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(47063, 5, '20858300_1434353057', 'accessories-10/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(47068, 5, '26458600_1434353057', 'accessories-10/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(47087, 5, '48959900_1434353057', 'accessories-10/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(47092, 5, '54760200_1434353057', 'accessories-10/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(47110, 5, '72661300_1434353057', 'accessories-10/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(47115, 5, '77661600_1434353057', 'accessories-10/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(47133, 5, '96662600_1434353057', 'accessories-10/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(47140, 5, '06463200_1434353058', 'accessories-10/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(47142, 5, '09263400_1434353058', 'accessories-10/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(47145, 5, '13163600_1434353058', 'accessories-10/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(47147, 5, '15863700_1434353058', 'accessories-10/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(47211, 1, '76296300_1434354217', 'accessories-21.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(47213, 1, '80496500_1434354217', 'accessories-21/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(47228, 1, '42200100_1434354218', 'accessories-21/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(47250, 1, '65001400_1434354218', 'accessories-21/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(47272, 1, '95803100_1434354218', 'accessories-21/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(47279, 1, '11204000_1434354219', 'accessories-21/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(47286, 1, '37405500_1434354219', 'accessories-21/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(47324, 1, '08209600_1434354220', 'accessories-21/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(47344, 1, '32711000_1434354220', 'accessories-21/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(47364, 1, '61312600_1434354220', 'accessories-21/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(47384, 1, '85914000_1434354220', 'accessories-21/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(47405, 1, '13315600_1434354221', 'accessories-21/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(47426, 1, '45217400_1434354221', 'accessories-21/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(47447, 1, '72218900_1434354221', 'accessories-21/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(47468, 1, '92620100_1434354221', 'accessories-21/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(47490, 1, '14921400_1434354222', 'accessories-21/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(47495, 1, '19921700_1434354222', 'accessories-21/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(47513, 1, '35722600_1434354222', 'accessories-21/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(47534, 1, '55323700_1434354222', 'accessories-21/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(47555, 1, '74024800_1434354222', 'accessories-21/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(47576, 1, '92625800_1434354222', 'accessories-21/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(47598, 1, '12527000_1434354223', 'accessories-21/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(47603, 1, '17027200_1434354223', 'accessories-21/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(47622, 1, '46128900_1434354223', 'accessories-21/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(47627, 1, '54229400_1434354223', 'accessories-21/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(47646, 1, '76930700_1434354223', 'accessories-21/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(47651, 1, '81730900_1434354223', 'accessories-21/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(47670, 1, '99632000_1434354223', 'accessories-21/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(47675, 1, '04232200_1434354224', 'accessories-21/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(47693, 1, '26333500_1434354224', 'accessories-21/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(47698, 1, '31433800_1434354224', 'accessories-21/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(47722, 1, '53235000_1434354224', 'accessories-21/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(47727, 1, '59035400_1434354224', 'accessories-21/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(47730, 1, '62735600_1434354224', 'accessories-21/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(47732, 1, '64835700_1434354224', 'accessories-21/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(47780, 2, '12044100_1434354226', 'accessories-21.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(47782, 2, '14844300_1434354226', 'accessories-21/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(47797, 2, '56546600_1434354226', 'accessories-21/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(47819, 2, '80848000_1434354226', 'accessories-21/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(47841, 2, '03049300_1434354227', 'accessories-21/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(47848, 2, '09649700_1434354227', 'accessories-21/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(47855, 2, '16050100_1434354227', 'accessories-21/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(47893, 2, '57152400_1434354227', 'accessories-21/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(47913, 2, '77353600_1434354227', 'accessories-21/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(47933, 2, '95654600_1434354227', 'accessories-21/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(47953, 2, '25856300_1434354228', 'accessories-21/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(47974, 2, '45257400_1434354228', 'accessories-21/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(47995, 2, '67358700_1434354228', 'accessories-21/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(48016, 2, '85959800_1434354228', 'accessories-21/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(48037, 2, '05260900_1434354229', 'accessories-21/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(48059, 2, '24962000_1434354229', 'accessories-21/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(48064, 2, '30562300_1434354229', 'accessories-21/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(48082, 2, '48963400_1434354229', 'accessories-21/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(48103, 2, '69464500_1434354229', 'accessories-21/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(48124, 2, '90565800_1434354229', 'accessories-21/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(48145, 2, '13967100_1434354230', 'accessories-21/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(48167, 2, '39168500_1434354230', 'accessories-21/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(48172, 2, '50369200_1434354230', 'accessories-21/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(48191, 2, '67770200_1434354230', 'accessories-21/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(48196, 2, '73270500_1434354230', 'accessories-21/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(48215, 2, '89771400_1434354230', 'accessories-21/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(48220, 2, '95271700_1434354230', 'accessories-21/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(48239, 2, '12072700_1434354231', 'accessories-21/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(48244, 2, '19373100_1434354231', 'accessories-21/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(48262, 2, '36974100_1434354231', 'accessories-21/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(48267, 2, '41674400_1434354231', 'accessories-21/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(48291, 2, '65575800_1434354231', 'accessories-21/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(48296, 2, '70476000_1434354231', 'accessories-21/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(48299, 2, '73376200_1434354231', 'accessories-21/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(48301, 2, '75776300_1434354231', 'accessories-21/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(48354, 3, '95983200_1434354232', 'accessories-11.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(48356, 3, '02383600_1434354233', 'accessories-11/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(48358, 3, '07183900_1434354233', 'accessories-11/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(48360, 3, '11684100_1434354233', 'accessories-11/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(48362, 3, '17384400_1434354233', 'accessories-11/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(48367, 3, '39285700_1434354233', 'accessories-11/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(48369, 3, '42985900_1434354233', 'accessories-11/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(48390, 3, '67887300_1434354233', 'accessories-11/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(48392, 3, '72487600_1434354233', 'accessories-11/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(48413, 3, '92888800_1434354233', 'accessories-11/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(48415, 3, '95588900_1434354233', 'accessories-11/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(48421, 3, '01689300_1434354234', 'accessories-11/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(48423, 3, '04189400_1434354234', 'accessories-11/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(48429, 3, '11089800_1434354234', 'accessories-11/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(48431, 3, '14490000_1434354234', 'accessories-11/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(48459, 3, '42391600_1434354234', 'accessories-11/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(48479, 3, '73193400_1434354234', 'accessories-11/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(48499, 3, '95694600_1434354234', 'accessories-11/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(48519, 3, '19296000_1434354235', 'accessories-11/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(48539, 3, '42297300_1434354235', 'accessories-11/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(48560, 3, '73399100_1434354235', 'accessories-11/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(48581, 3, '03400800_1434354236', 'accessories-11/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(48602, 3, '32902500_1434354236', 'accessories-11/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(48623, 3, '74904900_1434354236', 'accessories-11/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(48628, 3, '95406100_1434354236', 'accessories-11/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(48647, 3, '23007600_1434354237', 'accessories-11/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(48668, 3, '52009300_1434354237', 'accessories-11/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(48689, 3, '98912000_1434354237', 'accessories-11/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(48710, 3, '51615000_1434354238', 'accessories-11/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(48731, 3, '92817400_1434354238', 'accessories-11/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(48736, 3, '03718000_1434354239', 'accessories-11/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(48755, 3, '35719800_1434354239', 'accessories-11/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(48760, 3, '42620200_1434354239', 'accessories-11/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(48779, 3, '85622700_1434354239', 'accessories-11/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(48784, 3, '98823400_1434354239', 'accessories-11/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(48803, 3, '40525800_1434354240', 'accessories-11/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(48808, 3, '47526200_1434354240', 'accessories-11/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(48826, 3, '73327700_1434354240', 'accessories-11/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(48831, 3, '80228100_1434354240', 'accessories-11/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(48849, 3, '95729000_1434354240', 'accessories-11/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(48856, 3, '02229300_1434354241', 'accessories-11/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(48858, 3, '04529500_1434354241', 'accessories-11/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(48861, 3, '08329700_1434354241', 'accessories-11/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(48863, 3, '10929800_1434354241', 'accessories-11/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(48932, 4, '67338800_1434354242', 'accessories-11.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(48934, 4, '71339000_1434354242', 'accessories-11/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(48936, 4, '74439200_1434354242', 'accessories-11/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(48938, 4, '77439400_1434354242', 'accessories-11/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(48940, 4, '80939600_1434354242', 'accessories-11/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(48945, 4, '18141700_1434354243', 'accessories-11/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(48947, 4, '22441900_1434354243', 'accessories-11/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(48968, 4, '49543500_1434354243', 'accessories-11/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(48970, 4, '54043700_1434354243', 'accessories-11/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(48991, 4, '86345600_1434354243', 'accessories-11/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(48993, 4, '88745700_1434354243', 'accessories-11/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(48999, 4, '97746200_1434354243', 'accessories-11/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(49001, 4, '00246400_1434354244', 'accessories-11/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(49007, 4, '07246800_1434354244', 'accessories-11/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(49009, 4, '12547100_1434354244', 'accessories-11/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(49037, 4, '43048800_1434354244', 'accessories-11/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(49057, 4, '69750400_1434354244', 'accessories-11/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(49077, 4, '91151600_1434354244', 'accessories-11/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(49097, 4, '22153400_1434354245', 'accessories-11/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(49117, 4, '50055000_1434354245', 'accessories-11/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(49138, 4, '70756100_1434354245', 'accessories-11/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(49159, 4, '90657300_1434354245', 'accessories-11/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(49180, 4, '13858600_1434354246', 'accessories-11/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(49201, 4, '32359700_1434354246', 'accessories-11/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(49206, 4, '37259900_1434354246', 'accessories-11/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(49225, 4, '61161300_1434354246', 'accessories-11/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(49246, 4, '80562400_1434354246', 'accessories-11/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(49267, 4, '01363600_1434354247', 'accessories-11/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(49288, 4, '26165000_1434354247', 'accessories-11/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(49309, 4, '61267000_1434354247', 'accessories-11/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(49314, 4, '66467300_1434354247', 'accessories-11/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(49333, 4, '90568700_1434354247', 'accessories-11/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(49338, 4, '95769000_1434354247', 'accessories-11/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(49357, 4, '21070500_1434354248', 'accessories-11/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(49362, 4, '40771600_1434354248', 'accessories-11/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(49381, 4, '75573600_1434354248', 'accessories-11/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(49386, 4, '83374000_1434354248', 'accessories-11/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(49404, 4, '21276200_1434354249', 'accessories-11/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(49409, 4, '28376600_1434354249', 'accessories-11/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(49427, 4, '50677900_1434354249', 'accessories-11/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(49434, 4, '63678600_1434354249', 'accessories-11/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(49436, 4, '67778800_1434354249', 'accessories-11/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(49439, 4, '74979300_1434354249', 'accessories-11/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(49441, 4, '82679700_1434354249', 'accessories-11/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(49510, 5, '69090400_1434354251', 'accessories-11.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(49512, 5, '71490500_1434354251', 'accessories-11/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(49514, 5, '73790600_1434354251', 'accessories-11/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(49516, 5, '76390800_1434354251', 'accessories-11/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(49518, 5, '78590900_1434354251', 'accessories-11/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(49523, 5, '93991800_1434354251', 'accessories-11/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(49525, 5, '96391900_1434354251', 'accessories-11/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(49546, 5, '17893100_1434354252', 'accessories-11/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(49548, 5, '21193300_1434354252', 'accessories-11/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(49569, 5, '47494800_1434354252', 'accessories-11/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(49571, 5, '49795000_1434354252', 'accessories-11/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(49577, 5, '57095400_1434354252', 'accessories-11/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(49579, 5, '60495600_1434354252', 'accessories-11/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(49585, 5, '67696000_1434354252', 'accessories-11/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(49587, 5, '70096100_1434354252', 'accessories-11/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(49615, 5, '01697900_1434354253', 'accessories-11/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(49635, 5, '22599100_1434354253', 'accessories-11/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(49655, 5, '43100300_1434354253', 'accessories-11/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(49675, 5, '64501500_1434354253', 'accessories-11/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(49695, 5, '86602800_1434354253', 'accessories-11/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(49716, 5, '17204500_1434354254', 'accessories-11/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(49737, 5, '36705700_1434354254', 'accessories-11/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(49758, 5, '56206800_1434354254', 'accessories-11/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(49779, 5, '77408000_1434354254', 'accessories-11/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(49784, 5, '82208300_1434354254', 'accessories-11/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(49803, 5, '00609300_1434354255', 'accessories-11/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(49824, 5, '21310500_1434354255', 'accessories-11/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(49845, 5, '45111900_1434354255', 'accessories-11/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(49866, 5, '66713100_1434354255', 'accessories-11/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(49887, 5, '84414100_1434354255', 'accessories-11/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(49892, 5, '88914400_1434354255', 'accessories-11/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(49911, 5, '04915300_1434354256', 'accessories-11/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(49916, 5, '09315500_1434354256', 'accessories-11/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(49935, 5, '34517000_1434354256', 'accessories-11/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(49940, 5, '39717300_1434354256', 'accessories-11/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(49959, 5, '57318300_1434354256', 'accessories-11/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(49964, 5, '62718600_1434354256', 'accessories-11/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(49982, 5, '95220500_1434354256', 'accessories-11/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(49987, 5, '00020700_1434354257', 'accessories-11/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(50005, 5, '16421700_1434354257', 'accessories-11/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(50012, 5, '26122200_1434354257', 'accessories-11/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(50014, 5, '28522400_1434354257', 'accessories-11/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(50017, 5, '32722600_1434354257', 'accessories-11/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(50019, 5, '35622800_1434354257', 'accessories-11/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(50083, 1, '76300400_1434354445', 'accessories-22.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(50085, 1, '90301200_1434354445', 'accessories-22/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(50100, 1, '76306100_1434354446', 'accessories-22/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(50122, 1, '95807200_1434354446', 'accessories-22/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(50144, 1, '16908400_1434354447', 'accessories-22/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(50151, 1, '26409000_1434354447', 'accessories-22/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(50158, 1, '45610100_1434354447', 'accessories-22/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(50196, 1, '03513400_1434354448', 'accessories-22/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(50216, 1, '22614500_1434354448', 'accessories-22/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(50236, 1, '44915700_1434354448', 'accessories-22/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(50256, 1, '64716900_1434354448', 'accessories-22/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(50277, 1, '00919000_1434354449', 'accessories-22/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(50298, 1, '17819900_1434354449', 'accessories-22/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(50319, 1, '67422800_1434354449', 'accessories-22/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(50340, 1, '97924500_1434354449', 'accessories-22/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(50362, 1, '14925500_1434354450', 'accessories-22/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(50367, 1, '19625700_1434354450', 'accessories-22/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(50385, 1, '37326800_1434354450', 'accessories-22/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(50406, 1, '57227900_1434354450', 'accessories-22/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(50427, 1, '81329300_1434354450', 'accessories-22/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(50448, 1, '03330500_1434354451', 'accessories-22/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(50470, 1, '23831700_1434354451', 'accessories-22/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(50475, 1, '28131900_1434354451', 'accessories-22/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(50494, 1, '54333400_1434354451', 'accessories-22/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(50499, 1, '60033800_1434354451', 'accessories-22/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(50518, 1, '94935800_1434354451', 'accessories-22/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(50523, 1, '01336100_1434354452', 'accessories-22/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(50542, 1, '27937700_1434354452', 'accessories-22/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(50547, 1, '35738100_1434354452', 'accessories-22/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(50565, 1, '08642300_1434354453', 'accessories-22/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(50570, 1, '15742700_1434354453', 'accessories-22/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(50594, 1, '49844600_1434354453', 'accessories-22/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(50599, 1, '57045000_1434354453', 'accessories-22/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(50602, 1, '61145300_1434354453', 'accessories-22/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(50604, 1, '65245500_1434354453', 'accessories-22/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(50652, 2, '66057000_1434354455', 'accessories-22.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(50654, 2, '67957100_1434354455', 'accessories-22/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(50669, 2, '01159000_1434354456', 'accessories-22/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(50691, 2, '19660100_1434354456', 'accessories-22/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(50713, 2, '39461200_1434354456', 'accessories-22/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(50720, 2, '46561600_1434354456', 'accessories-22/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(50727, 2, '56062100_1434354456', 'accessories-22/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(50765, 2, '02464800_1434354457', 'accessories-22/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(50785, 2, '50567600_1434354457', 'accessories-22/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(50805, 2, '67768500_1434354457', 'accessories-22/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(50825, 2, '23271700_1434354458', 'accessories-22/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(50846, 2, '56173600_1434354458', 'accessories-22/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(50867, 2, '76674800_1434354458', 'accessories-22/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(50888, 2, '00576100_1434354459', 'accessories-22/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(50909, 2, '34778100_1434354459', 'accessories-22/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(50931, 2, '70480100_1434354459', 'accessories-22/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(50936, 2, '79480600_1434354459', 'accessories-22/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(50954, 2, '15382700_1434354460', 'accessories-22/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(50975, 2, '50784700_1434354460', 'accessories-22/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(50996, 2, '75686100_1434354460', 'accessories-22/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(51017, 2, '04487800_1434354461', 'accessories-22/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(51039, 2, '35989600_1434354461', 'accessories-22/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(51044, 2, '42590000_1434354461', 'accessories-22/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(51063, 2, '64691200_1434354461', 'accessories-22/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(51068, 2, '70291600_1434354461', 'accessories-22/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(51087, 2, '91892800_1434354461', 'accessories-22/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(51092, 2, '96393100_1434354461', 'accessories-22/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(51111, 2, '14894100_1434354462', 'accessories-22/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(51116, 2, '19594400_1434354462', 'accessories-22/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(51134, 2, '42995700_1434354462', 'accessories-22/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(51139, 2, '47596000_1434354462', 'accessories-22/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(51163, 2, '69597200_1434354462', 'accessories-22/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(51168, 2, '74397500_1434354462', 'accessories-22/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(51171, 2, '76697600_1434354462', 'accessories-22/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(51173, 2, '78697800_1434354462', 'accessories-22/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(51226, 3, '21905900_1434354464', 'accessories-12.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(51228, 3, '30606400_1434354464', 'accessories-12/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(51230, 3, '37506800_1434354464', 'accessories-12/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(51232, 3, '47807400_1434354464', 'accessories-12/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(51234, 3, '54807800_1434354464', 'accessories-12/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(51239, 3, '02710600_1434354465', 'accessories-12/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(51241, 3, '36112500_1434354465', 'accessories-12/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(51262, 3, '84615300_1434354465', 'accessories-12/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(51264, 3, '91315600_1434354465', 'accessories-12/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(51285, 3, '19217200_1434354466', 'accessories-12/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(51287, 3, '38718300_1434354466', 'accessories-12/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(51293, 3, '48518900_1434354466', 'accessories-12/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(51295, 3, '58719500_1434354466', 'accessories-12/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(51301, 3, '92221400_1434354466', 'accessories-12/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(51303, 3, '94521500_1434354466', 'accessories-12/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(51331, 3, '38424100_1434354467', 'accessories-12/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(51351, 3, '77732000_1434354468', 'accessories-12/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(51371, 3, '51036200_1434354469', 'accessories-12/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(51391, 3, '89438400_1434354469', 'accessories-12/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(51411, 3, '84243800_1434354470', 'accessories-12/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(51432, 3, '38746900_1434354471', 'accessories-12/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(51453, 3, '78949200_1434354471', 'accessories-12/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(51474, 3, '02850600_1434354472', 'accessories-12/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(51495, 3, '73654700_1434354472', 'accessories-12/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(51500, 3, '83555200_1434354472', 'accessories-12/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(51519, 3, '37858300_1434354473', 'accessories-12/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(51540, 3, '77460600_1434354473', 'accessories-12/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(51561, 3, '17862900_1434354474', 'accessories-12/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(51582, 3, '68165800_1434354474', 'accessories-12/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(51603, 3, '02667800_1434354475', 'accessories-12/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(51608, 3, '29669300_1434354475', 'accessories-12/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(51627, 3, '68071500_1434354475', 'accessories-12/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(51632, 3, '79672200_1434354475', 'accessories-12/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(51651, 3, '04273600_1434354476', 'accessories-12/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(51656, 3, '40175600_1434354476', 'accessories-12/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(51675, 3, '75277600_1434354476', 'accessories-12/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(51680, 3, '89678500_1434354476', 'accessories-12/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(51698, 3, '48281800_1434354477', 'accessories-12/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(51703, 3, '64082700_1434354477', 'accessories-12/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(51721, 3, '87684100_1434354477', 'accessories-12/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(51728, 3, '30886500_1434354478', 'accessories-12/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(51730, 3, '40387100_1434354478', 'accessories-12/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(51733, 3, '48787600_1434354478', 'accessories-12/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(51735, 3, '56188000_1434354478', 'accessories-12/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(51804, 4, '81312300_1434354482', 'accessories-12.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(51806, 4, '91112900_1434354482', 'accessories-12/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(51808, 4, '02113500_1434354483', 'accessories-12/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(51810, 4, '10914000_1434354483', 'accessories-12/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(51812, 4, '42215800_1434354483', 'accessories-12/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(51817, 4, '23220400_1434354484', 'accessories-12/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(51819, 4, '28420700_1434354484', 'accessories-12/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(51840, 4, '72823300_1434354484', 'accessories-12/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(51842, 4, '78923600_1434354484', 'accessories-12/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(51863, 4, '38527000_1434354485', 'accessories-12/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(51865, 4, '42827300_1434354485', 'accessories-12/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(51871, 4, '49627600_1434354485', 'accessories-12/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(51873, 4, '59028200_1434354485', 'accessories-12/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(51879, 4, '67828700_1434354485', 'accessories-12/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(51881, 4, '70328800_1434354485', 'accessories-12/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(51909, 4, '41432900_1434354486', 'accessories-12/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(51929, 4, '94635900_1434354486', 'accessories-12/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(51949, 4, '47539000_1434354487', 'accessories-12/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(51969, 4, '81440900_1434354487', 'accessories-12/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(51989, 4, '00542000_1434354488', 'accessories-12/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(52010, 4, '23843300_1434354488', 'accessories-12/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(52031, 4, '62951300_1434354489', 'accessories-12/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(52052, 4, '14754300_1434354490', 'accessories-12/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(52073, 4, '44355900_1434354490', 'accessories-12/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(52078, 4, '50956300_1434354490', 'accessories-12/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(52097, 4, '75657700_1434354490', 'accessories-12/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(52118, 4, '09959700_1434354491', 'accessories-12/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(52139, 4, '79363700_1434354491', 'accessories-12/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(52160, 4, '22266100_1434354492', 'accessories-12/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(52181, 4, '66868700_1434354492', 'accessories-12/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(52186, 4, '76669200_1434354492', 'accessories-12/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(52205, 4, '94770300_1434354492', 'accessories-12/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(52210, 4, '01270600_1434354493', 'accessories-12/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(52229, 4, '18071600_1434354493', 'accessories-12/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(52234, 4, '22471900_1434354493', 'accessories-12/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(52253, 4, '42173000_1434354493', 'accessories-12/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(52258, 4, '51273500_1434354493', 'accessories-12/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(52276, 4, '66874400_1434354493', 'accessories-12/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(52281, 4, '70874600_1434354493', 'accessories-12/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(52299, 4, '87075500_1434354493', 'accessories-12/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(52306, 4, '95876100_1434354493', 'accessories-12/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(52308, 4, '97976200_1434354493', 'accessories-12/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(52311, 4, '00976300_1434354494', 'accessories-12/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(52313, 4, '09576800_1434354494', 'accessories-12/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(52382, 5, '24189100_1434354496', 'accessories-12.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(52384, 5, '33289600_1434354496', 'accessories-12/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(52386, 5, '35789800_1434354496', 'accessories-12/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(52388, 5, '50790600_1434354496', 'accessories-12/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(52390, 5, '57991000_1434354496', 'accessories-12/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(52395, 5, '88392800_1434354496', 'accessories-12/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(52397, 5, '01893600_1434354497', 'accessories-12/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(52418, 5, '62597000_1434354497', 'accessories-12/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(52420, 5, '66597300_1434354497', 'accessories-12/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(52441, 5, '12399900_1434354498', 'accessories-12/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(52443, 5, '15100000_1434354498', 'accessories-12/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(52449, 5, '28600800_1434354498', 'accessories-12/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(52451, 5, '36601300_1434354498', 'accessories-12/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(52457, 5, '58302500_1434354498', 'accessories-12/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(52459, 5, '63302800_1434354498', 'accessories-12/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(52487, 5, '43307400_1434354499', 'accessories-12/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(52507, 5, '02510700_1434354500', 'accessories-12/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(52527, 5, '33112500_1434354500', 'accessories-12/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(52547, 5, '81615300_1434354500', 'accessories-12/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(52567, 5, '12317000_1434354501', 'accessories-12/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(52588, 5, '38318500_1434354501', 'accessories-12/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(52609, 5, '89621400_1434354501', 'accessories-12/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(52630, 5, '33524000_1434354502', 'accessories-12/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(52651, 5, '60925500_1434354502', 'accessories-12/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(52656, 5, '80026600_1434354502', 'accessories-12/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(52675, 5, '02327900_1434354503', 'accessories-12/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(52696, 5, '35229800_1434354503', 'accessories-12/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(52717, 5, '75832100_1434354503', 'accessories-12/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(52738, 5, '10134100_1434354504', 'accessories-12/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(52759, 5, '39935800_1434354504', 'accessories-12/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(52764, 5, '44336000_1434354504', 'accessories-12/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(52783, 5, '80138100_1434354504', 'accessories-12/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(52788, 5, '85738400_1434354504', 'accessories-12/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(52807, 5, '09439700_1434354505', 'accessories-12/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(52812, 5, '13840000_1434354505', 'accessories-12/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(52831, 5, '31041000_1434354505', 'accessories-12/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(52836, 5, '40141500_1434354505', 'accessories-12/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(52854, 5, '66143000_1434354505', 'accessories-12/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(52859, 5, '82543900_1434354505', 'accessories-12/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(52877, 5, '17345900_1434354506', 'accessories-12/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(52884, 5, '51447900_1434354506', 'accessories-12/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(52886, 5, '60748400_1434354506', 'accessories-12/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(52889, 5, '80449500_1434354506', 'accessories-12/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(52891, 5, '92650200_1434354506', 'accessories-12/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(52955, 1, '26912800_1434355147', 'accessories-23.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(52957, 1, '34213200_1434355147', 'accessories-23/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(52972, 1, '89216300_1434355147', 'accessories-23/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(52994, 1, '16317900_1434355148', 'accessories-23/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(53016, 1, '48119700_1434355148', 'accessories-23/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(53023, 1, '55120100_1434355148', 'accessories-23/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(53030, 1, '63320600_1434355148', 'accessories-23/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(53068, 1, '06523000_1434355149', 'accessories-23/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(53088, 1, '32324500_1434355149', 'accessories-23/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(53108, 1, '54925800_1434355149', 'accessories-23/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(53128, 1, '76827100_1434355149', 'accessories-23/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(53149, 1, '01328500_1434355150', 'accessories-23/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(53170, 1, '25329800_1434355150', 'accessories-23/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(53191, 1, '50931300_1434355150', 'accessories-23/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(53212, 1, '73132600_1434355150', 'accessories-23/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(53234, 1, '99534100_1434355150', 'accessories-23/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(53239, 1, '05234400_1434355151', 'accessories-23/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(53257, 1, '23535500_1434355151', 'accessories-23/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(53278, 1, '40936500_1434355151', 'accessories-23/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(53299, 1, '63137700_1434355151', 'accessories-23/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(53320, 1, '86339000_1434355151', 'accessories-23/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(53342, 1, '10940500_1434355152', 'accessories-23/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(53347, 1, '16840800_1434355152', 'accessories-23/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(53366, 1, '36441900_1434355152', 'accessories-23/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(53371, 1, '43742300_1434355152', 'accessories-23/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(53390, 1, '64543500_1434355152', 'accessories-23/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(53395, 1, '70843900_1434355152', 'accessories-23/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(53414, 1, '92945100_1434355152', 'accessories-23/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(53419, 1, '98545500_1434355152', 'accessories-23/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(53437, 1, '22246800_1434355153', 'accessories-23/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(53442, 1, '29147200_1434355153', 'accessories-23/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(53466, 1, '58548900_1434355153', 'accessories-23/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(53471, 1, '63349200_1434355153', 'accessories-23/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(53474, 1, '66049300_1434355153', 'accessories-23/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(53476, 1, '68049400_1434355153', 'accessories-23/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(53524, 2, '01057100_1434355155', 'accessories-23.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(53526, 2, '03657200_1434355155', 'accessories-23/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(53541, 2, '68060900_1434355155', 'accessories-23/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(53563, 2, '98462600_1434355155', 'accessories-23/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(53585, 2, '21263900_1434355156', 'accessories-23/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(53592, 2, '27064300_1434355156', 'accessories-23/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(53599, 2, '91167900_1434355156', 'accessories-23/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(53637, 2, '33170300_1434355157', 'accessories-23/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(53657, 2, '58271800_1434355157', 'accessories-23/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(53677, 2, '80673000_1434355157', 'accessories-23/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(53697, 2, '06174500_1434355158', 'accessories-23/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(53718, 2, '28475800_1434355158', 'accessories-23/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(53739, 2, '51777100_1434355158', 'accessories-23/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(53760, 2, '78778700_1434355158', 'accessories-23/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(53781, 2, '04180100_1434355159', 'accessories-23/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(53803, 2, '31781700_1434355159', 'accessories-23/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(53808, 2, '37382000_1434355159', 'accessories-23/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(53826, 2, '55383000_1434355159', 'accessories-23/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(53847, 2, '81484500_1434355159', 'accessories-23/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(53868, 2, '06886000_1434355160', 'accessories-23/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(53889, 2, '29387300_1434355160', 'accessories-23/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(53911, 2, '54688700_1434355160', 'accessories-23/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(53916, 2, '60289000_1434355160', 'accessories-23/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(53935, 2, '83590400_1434355160', 'accessories-23/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(53940, 2, '89190700_1434355160', 'accessories-23/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(53959, 2, '11292000_1434355161', 'accessories-23/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(53964, 2, '16392200_1434355161', 'accessories-23/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(53983, 2, '38993500_1434355161', 'accessories-23/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(53988, 2, '44493900_1434355161', 'accessories-23/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(54006, 2, '64295000_1434355161', 'accessories-23/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(54011, 2, '70795400_1434355161', 'accessories-23/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(54035, 2, '96896800_1434355161', 'accessories-23/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(54040, 2, '03997300_1434355162', 'accessories-23/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(54043, 2, '07597500_1434355162', 'accessories-23/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(54045, 2, '10797600_1434355162', 'accessories-23/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(54098, 3, '64206400_1434355163', 'accessories-13.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(54100, 3, '69206700_1434355163', 'accessories-13/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(54102, 3, '74407000_1434355163', 'accessories-13/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(54104, 3, '79807300_1434355163', 'accessories-13/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(54106, 3, '85007600_1434355163', 'accessories-13/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(54111, 3, '12709200_1434355164', 'accessories-13/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(54113, 3, '18009500_1434355164', 'accessories-13/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(54134, 3, '45811100_1434355164', 'accessories-13/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(54136, 3, '48611200_1434355164', 'accessories-13/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(54157, 3, '72112600_1434355164', 'accessories-13/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(54159, 3, '75112800_1434355164', 'accessories-13/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(54165, 3, '82213200_1434355164', 'accessories-13/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(54167, 3, '84913300_1434355164', 'accessories-13/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(54173, 3, '91813700_1434355164', 'accessories-13/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(54175, 3, '94213900_1434355164', 'accessories-13/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(54203, 3, '22815500_1434355165', 'accessories-13/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(54223, 3, '45616800_1434355165', 'accessories-13/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(54243, 3, '66018000_1434355165', 'accessories-13/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(54263, 3, '88219200_1434355165', 'accessories-13/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(54283, 3, '10220500_1434355166', 'accessories-13/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(54304, 3, '33321800_1434355166', 'accessories-13/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(54325, 3, '55523100_1434355166', 'accessories-13/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(54346, 3, '76224300_1434355166', 'accessories-13/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(54367, 3, '15726500_1434355167', 'accessories-13/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(54372, 3, '22726900_1434355167', 'accessories-13/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(54391, 3, '43428100_1434355167', 'accessories-13/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(54412, 3, '69529600_1434355167', 'accessories-13/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(54433, 3, '93631000_1434355167', 'accessories-13/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(54454, 3, '17732400_1434355168', 'accessories-13/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(54475, 3, '45433900_1434355168', 'accessories-13/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(54480, 3, '55134500_1434355168', 'accessories-13/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(54499, 3, '83136100_1434355168', 'accessories-13/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(54504, 3, '91136600_1434355168', 'accessories-13/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(54523, 3, '15538000_1434355169', 'accessories-13/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(54528, 3, '22538400_1434355169', 'accessories-13/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(54547, 3, '49939900_1434355169', 'accessories-13/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(54552, 3, '57140300_1434355169', 'accessories-13/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(54570, 3, '85542000_1434355169', 'accessories-13/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(54575, 3, '93242400_1434355169', 'accessories-13/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(54593, 3, '19543900_1434355170', 'accessories-13/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(54600, 3, '31144600_1434355170', 'accessories-13/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(54602, 3, '34244700_1434355170', 'accessories-13/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(54605, 3, '40045100_1434355170', 'accessories-13/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(54607, 3, '43345300_1434355170', 'accessories-13/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(54676, 4, '33356100_1434355172', 'accessories-13.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(54678, 4, '35356200_1434355172', 'accessories-13/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(54680, 4, '37756400_1434355172', 'accessories-13/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(54682, 4, '39756500_1434355172', 'accessories-13/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(54684, 4, '42056600_1434355172', 'accessories-13/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(54689, 4, '62257800_1434355172', 'accessories-13/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(54691, 4, '65258000_1434355172', 'accessories-13/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(54712, 4, '93959600_1434355172', 'accessories-13/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(54714, 4, '97159800_1434355172', 'accessories-13/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(54735, 4, '24361300_1434355173', 'accessories-13/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(54737, 4, '27161500_1434355173', 'accessories-13/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(54743, 4, '34261900_1434355173', 'accessories-13/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(54745, 4, '37562100_1434355173', 'accessories-13/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(54751, 4, '44562500_1434355173', 'accessories-13/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(54753, 4, '49162800_1434355173', 'accessories-13/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(54781, 4, '83964700_1434355173', 'accessories-13/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(54801, 4, '01365700_1434355174', 'accessories-13/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(54821, 4, '25167100_1434355174', 'accessories-13/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(54841, 4, '49068500_1434355174', 'accessories-13/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(54861, 4, '78770200_1434355174', 'accessories-13/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(54882, 4, '01071400_1434355175', 'accessories-13/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(54903, 4, '32673300_1434355175', 'accessories-13/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(54924, 4, '49674200_1434355175', 'accessories-13/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(54945, 4, '84876200_1434355175', 'accessories-13/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(54950, 4, '92776700_1434355175', 'accessories-13/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(54969, 4, '25178500_1434355176', 'accessories-13/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(54990, 4, '49079900_1434355176', 'accessories-13/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(55011, 4, '71781200_1434355176', 'accessories-13/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(55032, 4, '03283000_1434355177', 'accessories-13/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(55053, 4, '46685500_1434355177', 'accessories-13/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(55058, 4, '55986000_1434355177', 'accessories-13/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(55077, 4, '80587400_1434355177', 'accessories-13/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(55082, 4, '85187700_1434355177', 'accessories-13/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(55101, 4, '05888900_1434355178', 'accessories-13/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(55106, 4, '11889200_1434355178', 'accessories-13/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(55125, 4, '35490600_1434355178', 'accessories-13/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(55130, 4, '42491000_1434355178', 'accessories-13/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(55148, 4, '62892100_1434355178', 'accessories-13/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(55153, 4, '69292500_1434355178', 'accessories-13/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(55171, 4, '98794200_1434355178', 'accessories-13/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(55178, 4, '07294700_1434355179', 'accessories-13/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(55180, 4, '09794800_1434355179', 'accessories-13/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(55183, 4, '13395000_1434355179', 'accessories-13/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(55185, 4, '16395200_1434355179', 'accessories-13/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(55254, 5, '94705400_1434355180', 'accessories-13.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(55256, 5, '98005600_1434355180', 'accessories-13/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(55258, 5, '00505700_1434355181', 'accessories-13/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(55260, 5, '05406000_1434355181', 'accessories-13/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(55262, 5, '08906200_1434355181', 'accessories-13/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(55267, 5, '32307500_1434355181', 'accessories-13/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(55269, 5, '35107700_1434355181', 'accessories-13/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(55290, 5, '56308900_1434355181', 'accessories-13/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(55292, 5, '59009100_1434355181', 'accessories-13/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(55313, 5, '83410500_1434355181', 'accessories-13/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(55315, 5, '87210700_1434355181', 'accessories-13/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(55321, 5, '94511100_1434355181', 'accessories-13/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(55323, 5, '97111300_1434355181', 'accessories-13/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(55329, 5, '03511600_1434355182', 'accessories-13/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(55331, 5, '06011800_1434355182', 'accessories-13/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(55359, 5, '50514300_1434355182', 'accessories-13/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(55379, 5, '68815400_1434355182', 'accessories-13/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(55399, 5, '87416400_1434355182', 'accessories-13/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(55419, 5, '06117500_1434355183', 'accessories-13/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(55439, 5, '26418700_1434355183', 'accessories-13/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(55460, 5, '44719700_1434355183', 'accessories-13/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(55481, 5, '67121000_1434355183', 'accessories-13/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(55502, 5, '88622200_1434355183', 'accessories-13/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(55523, 5, '09123400_1434355184', 'accessories-13/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(55528, 5, '13623600_1434355184', 'accessories-13/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(55547, 5, '32724700_1434355184', 'accessories-13/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(55568, 5, '49225700_1434355184', 'accessories-13/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(55589, 5, '86227800_1434355184', 'accessories-13/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(55610, 5, '12329300_1434355185', 'accessories-13/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(55631, 5, '41030900_1434355185', 'accessories-13/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(55636, 5, '48931400_1434355185', 'accessories-13/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(55655, 5, '69232500_1434355185', 'accessories-13/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(55660, 5, '75932900_1434355185', 'accessories-13/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(55679, 5, '98334200_1434355185', 'accessories-13/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(55684, 5, '03734500_1434355186', 'accessories-13/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(55703, 5, '23235600_1434355186', 'accessories-13/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(55708, 5, '29536000_1434355186', 'accessories-13/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(55726, 5, '52237300_1434355186', 'accessories-13/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(55731, 5, '57537600_1434355186', 'accessories-13/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(55749, 5, '79038800_1434355186', 'accessories-13/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(55756, 5, '89039400_1434355186', 'accessories-13/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(55758, 5, '92639600_1434355186', 'accessories-13/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(55761, 5, '96439800_1434355186', 'accessories-13/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(55763, 5, '99240000_1434355186', 'accessories-13/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(55811, 1, '74106700_1436512620', 'accessories-24.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(55813, 1, '87307400_1436512620', 'accessories-24/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(55828, 1, '76912500_1436512621', 'accessories-24/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(55850, 1, '28115500_1436512622', 'accessories-24/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(55872, 1, '76018200_1436512622', 'accessories-24/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(55879, 1, '83318600_1436512622', 'accessories-24/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(55886, 1, '90619000_1436512622', 'accessories-24/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(55924, 1, '43922100_1436512623', 'accessories-24/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(55944, 1, '70623600_1436512623', 'accessories-24/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(55964, 1, '94125000_1436512623', 'accessories-24/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(55984, 1, '19526400_1436512624', 'accessories-24/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(56005, 1, '40427600_1436512624', 'accessories-24/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(56026, 1, '73129500_1436512624', 'accessories-24/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(56047, 1, '90730500_1436512624', 'accessories-24/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(56068, 1, '18632100_1436512625', 'accessories-24/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(56090, 1, '34433000_1436512625', 'accessories-24/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(56095, 1, '38533200_1436512625', 'accessories-24/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(56113, 1, '54634100_1436512625', 'accessories-24/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(56134, 1, '74835300_1436512625', 'accessories-24/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(56155, 1, '91436300_1436512625', 'accessories-24/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(56176, 1, '11237400_1436512626', 'accessories-24/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(56198, 1, '40139000_1436512626', 'accessories-24/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(56203, 1, '45539300_1436512626', 'accessories-24/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(56222, 1, '64440400_1436512626', 'accessories-24/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(56227, 1, '71240800_1436512626', 'accessories-24/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(56246, 1, '97942300_1436512626', 'accessories-24/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(56251, 1, '03042600_1436512627', 'accessories-24/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(56270, 1, '23143800_1436512627', 'accessories-24/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(56275, 1, '29344100_1436512627', 'accessories-24/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(56293, 1, '59845900_1436512627', 'accessories-24/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(56298, 1, '64346100_1436512627', 'accessories-24/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(56322, 1, '06348500_1436512628', 'accessories-24/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(56327, 1, '10848800_1436512628', 'accessories-24/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(56330, 1, '15149100_1436512628', 'accessories-24/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(56332, 1, '17649200_1436512628', 'accessories-24/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(56380, 2, '21855200_1436512629', 'accessories-24.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(56382, 2, '23855300_1436512629', 'accessories-24/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(56397, 2, '52756900_1436512629', 'accessories-24/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(56419, 2, '69457900_1436512629', 'accessories-24/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(56441, 2, '95759400_1436512629', 'accessories-24/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(56448, 2, '01559700_1436512630', 'accessories-24/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(56455, 2, '10360200_1436512630', 'accessories-24/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(56493, 2, '54062700_1436512630', 'accessories-24/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(56513, 2, '71963700_1436512630', 'accessories-24/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(56533, 2, '87964700_1436512630', 'accessories-24/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(56553, 2, '03465500_1436512631', 'accessories-24/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(56574, 2, '22466600_1436512631', 'accessories-24/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(56595, 2, '44567900_1436512631', 'accessories-24/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(56616, 2, '69769300_1436512631', 'accessories-24/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(56637, 2, '90170500_1436512631', 'accessories-24/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(56659, 2, '07771500_1436512632', 'accessories-24/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(56664, 2, '12171800_1436512632', 'accessories-24/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(56682, 2, '28772700_1436512632', 'accessories-24/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(56703, 2, '46273700_1436512632', 'accessories-24/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(56724, 2, '65474800_1436512632', 'accessories-24/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(56745, 2, '82075800_1436512632', 'accessories-24/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(56767, 2, '01076800_1436512633', 'accessories-24/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(56772, 2, '05877100_1436512633', 'accessories-24/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(56791, 2, '29778500_1436512633', 'accessories-24/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(56796, 2, '37778900_1436512633', 'accessories-24/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(56815, 2, '58980200_1436512633', 'accessories-24/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(56820, 2, '63680400_1436512633', 'accessories-24/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(56839, 2, '78881300_1436512633', 'accessories-24/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(56844, 2, '83181500_1436512633', 'accessories-24/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(56862, 2, '98182400_1436512633', 'accessories-24/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(56867, 2, '02082600_1436512634', 'accessories-24/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(56891, 2, '28984200_1436512634', 'accessories-24/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(56896, 2, '37084600_1436512634', 'accessories-24/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(56899, 2, '43085000_1436512634', 'accessories-24/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(56901, 2, '47485200_1436512634', 'accessories-24/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(56954, 3, '08794400_1436512636', 'accessories-14.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(56956, 3, '14594800_1436512636', 'accessories-14/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(56958, 3, '23095300_1436512636', 'accessories-14/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(56960, 3, '27295500_1436512636', 'accessories-14/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(56962, 3, '30695700_1436512636', 'accessories-14/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(56967, 3, '46696600_1436512636', 'accessories-14/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(56969, 3, '48996700_1436512636', 'accessories-14/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(56990, 3, '66497700_1436512636', 'accessories-14/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(56992, 3, '68597900_1436512636', 'accessories-14/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(57013, 3, '86598900_1436512636', 'accessories-14/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(57015, 3, '90099100_1436512636', 'accessories-14/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(57021, 3, '96099400_1436512636', 'accessories-14/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(57023, 3, '98799600_1436512636', 'accessories-14/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(57029, 3, '10500300_1436512637', 'accessories-14/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(57031, 3, '25401100_1436512637', 'accessories-14/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(57059, 3, '50402500_1436512637', 'accessories-14/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(57079, 3, '67903500_1436512637', 'accessories-14/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(57099, 3, '85904600_1436512637', 'accessories-14/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(57119, 3, '03505600_1436512638', 'accessories-14/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(57139, 3, '36407500_1436512638', 'accessories-14/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(57160, 3, '66509200_1436512638', 'accessories-14/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(57181, 3, '86610300_1436512638', 'accessories-14/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(57202, 3, '19212200_1436512639', 'accessories-14/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(57223, 3, '38313300_1436512639', 'accessories-14/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(57228, 3, '44213600_1436512639', 'accessories-14/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(57247, 3, '61214600_1436512639', 'accessories-14/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(57268, 3, '79715700_1436512639', 'accessories-14/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(57289, 3, '18717900_1436512640', 'accessories-14/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(57310, 3, '46519500_1436512640', 'accessories-14/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(57331, 3, '68320700_1436512640', 'accessories-14/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(57336, 3, '73521000_1436512640', 'accessories-14/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(57355, 3, '21923800_1436512641', 'accessories-14/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(57360, 3, '28424200_1436512641', 'accessories-14/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(57379, 3, '42525000_1436512641', 'accessories-14/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(57384, 3, '48025300_1436512641', 'accessories-14/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(57403, 3, '65126300_1436512641', 'accessories-14/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(57408, 3, '69226500_1436512641', 'accessories-14/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(57426, 3, '83527300_1436512641', 'accessories-14/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(57431, 3, '92027800_1436512641', 'accessories-14/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(57449, 3, '18629300_1436512642', 'accessories-14/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(57456, 3, '49631100_1436512642', 'accessories-14/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(57458, 3, '55131400_1436512642', 'accessories-14/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(57461, 3, '58831600_1436512642', 'accessories-14/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(57463, 3, '66432100_1436512642', 'accessories-14/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(57532, 4, '62443300_1436512644', 'accessories-14.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(57534, 4, '65843500_1436512644', 'accessories-14/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(57536, 4, '68143600_1436512644', 'accessories-14/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(57538, 4, '70643700_1436512644', 'accessories-14/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(57540, 4, '72943900_1436512644', 'accessories-14/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(57545, 4, '92045000_1436512644', 'accessories-14/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(57547, 4, '94645100_1436512644', 'accessories-14/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(57568, 4, '14946300_1436512645', 'accessories-14/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(57570, 4, '19046500_1436512645', 'accessories-14/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(57591, 4, '65349200_1436512645', 'accessories-14/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(57593, 4, '68649300_1436512645', 'accessories-14/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(57599, 4, '78549900_1436512645', 'accessories-14/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(57601, 4, '84450200_1436512645', 'accessories-14/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(57607, 4, '98251000_1436512645', 'accessories-14/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(57609, 4, '03351300_1436512646', 'accessories-14/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(57637, 4, '39253400_1436512646', 'accessories-14/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(57657, 4, '87056100_1436512646', 'accessories-14/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(57677, 4, '19958000_1436512647', 'accessories-14/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(57697, 4, '52759900_1436512647', 'accessories-14/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(57717, 4, '83261600_1436512647', 'accessories-14/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(57738, 4, '05962900_1436512648', 'accessories-14/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(57759, 4, '49065400_1436512648', 'accessories-14/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(57780, 4, '73966800_1436512648', 'accessories-14/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(57801, 4, '90867800_1436512648', 'accessories-14/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(57806, 4, '95268000_1436512648', 'accessories-14/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(57825, 4, '08768800_1436512649', 'accessories-14/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(57846, 4, '24769700_1436512649', 'accessories-14/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(57867, 4, '39770600_1436512649', 'accessories-14/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(57888, 4, '70972400_1436512649', 'accessories-14/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(57909, 4, '89173400_1436512649', 'accessories-14/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(57914, 4, '93373600_1436512649', 'accessories-14/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(57933, 4, '07674500_1436512650', 'accessories-14/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(57938, 4, '43776500_1436512650', 'accessories-14/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(57957, 4, '65077700_1436512650', 'accessories-14/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(57962, 4, '69278000_1436512650', 'accessories-14/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(57981, 4, '85178900_1436512650', 'accessories-14/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(57986, 4, '90579200_1436512650', 'accessories-14/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(58004, 4, '04080000_1436512651', 'accessories-14/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(58009, 4, '11980400_1436512651', 'accessories-14/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(58027, 4, '68783700_1436512651', 'accessories-14/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(58034, 4, '86184700_1436512651', 'accessories-14/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(58036, 4, '91084900_1436512651', 'accessories-14/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(58039, 4, '95885200_1436512651', 'accessories-14/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(58041, 4, '98785400_1436512651', 'accessories-14/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(58110, 5, '71101000_1436512654', 'accessories-14.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(58112, 5, '77601300_1436512654', 'accessories-14/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(58114, 5, '86201800_1436512654', 'accessories-14/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(58116, 5, '90802100_1436512654', 'accessories-14/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(58118, 5, '92902200_1436512654', 'accessories-14/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(58123, 5, '12303300_1436512655', 'accessories-14/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(58125, 5, '15403500_1436512655', 'accessories-14/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(58146, 5, '41105000_1436512655', 'accessories-14/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(58148, 5, '68306500_1436512655', 'accessories-14/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(58169, 5, '95408100_1436512655', 'accessories-14/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(58171, 5, '97308200_1436512655', 'accessories-14/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(58177, 5, '02108500_1436512656', 'accessories-14/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(58179, 5, '05108600_1436512656', 'accessories-14/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(58185, 5, '11909000_1436512656', 'accessories-14/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(58187, 5, '14209100_1436512656', 'accessories-14/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(58215, 5, '38310500_1436512656', 'accessories-14/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(58235, 5, '74912600_1436512656', 'accessories-14/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(58255, 5, '94113700_1436512656', 'accessories-14/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(58275, 5, '10214600_1436512657', 'accessories-14/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(58295, 5, '31015800_1436512657', 'accessories-14/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(58316, 5, '48316800_1436512657', 'accessories-14/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(58337, 5, '80718700_1436512657', 'accessories-14/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(58358, 5, '14120600_1436512658', 'accessories-14/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(58379, 5, '51222700_1436512658', 'accessories-14/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(58384, 5, '55923000_1436512658', 'accessories-14/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(58403, 5, '69923800_1436512658', 'accessories-14/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(58424, 5, '87124800_1436512658', 'accessories-14/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(58445, 5, '05025800_1436512659', 'accessories-14/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(58466, 5, '22026800_1436512659', 'accessories-14/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(58487, 5, '40527800_1436512659', 'accessories-14/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(58492, 5, '45928100_1436512659', 'accessories-14/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(58511, 5, '62229100_1436512659', 'accessories-14/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(58516, 5, '66229300_1436512659', 'accessories-14/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(58535, 5, '81830200_1436512659', 'accessories-14/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(58540, 5, '87930500_1436512659', 'accessories-14/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(58559, 5, '12031900_1436512660', 'accessories-14/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(58564, 5, '24432600_1436512660', 'accessories-14/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(58582, 5, '72435400_1436512660', 'accessories-14/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(58587, 5, '77135600_1436512660', 'accessories-14/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(58605, 5, '99736900_1436512660', 'accessories-14/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(58612, 5, '09237500_1436512661', 'accessories-14/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(58614, 5, '11937600_1436512661', 'accessories-14/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(58617, 5, '17437900_1436512661', 'accessories-14/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(58619, 5, '19938100_1436512661', 'accessories-14/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(58667, 1, '76316900_1436926352', 'accessories-25.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(58669, 1, '91020800_1436926352', 'accessories-25/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(58684, 1, '43033200_1436926354', 'accessories-25/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(58706, 1, '06037300_1436926355', 'accessories-25/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(58728, 1, '63023800_1436926355', 'accessories-25/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(58735, 1, '96371000_1436926355', 'accessories-25/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(58742, 1, '16044100_1436926356', 'accessories-25/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(58780, 1, '08123000_1436926357', 'accessories-25/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(58800, 1, '82268300_1436926357', 'accessories-25/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(58820, 1, '26416800_1436926358', 'accessories-25/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(58840, 1, '18602400_1436926359', 'accessories-25/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(58861, 1, '76925600_1436926359', 'accessories-25/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(58882, 1, '27429800_1436926360', 'accessories-25/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(58903, 1, '82695000_1436926360', 'accessories-25/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(58924, 1, '37928700_1436926361', 'accessories-25/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(58946, 1, '95260300_1436926361', 'accessories-25/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(58951, 1, '11320700_1436926362', 'accessories-25/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(58969, 1, '72222200_1436926362', 'accessories-25/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(58990, 1, '31943500_1436926363', 'accessories-25/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(59011, 1, '86471200_1436926363', 'accessories-25/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(59032, 1, '39786300_1436926364', 'accessories-25/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(59054, 1, '12787700_1436926365', 'accessories-25/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(59059, 1, '23842400_1436926365', 'accessories-25/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(59078, 1, '79697100_1436926365', 'accessories-25/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(59083, 1, '93320900_1436926365', 'accessories-25/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(59102, 1, '52304700_1436926366', 'accessories-25/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(59107, 1, '76920300_1436926366', 'accessories-25/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(59126, 1, '54734600_1436926367', 'accessories-25/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(59131, 1, '64741400_1436926367', 'accessories-25/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(59149, 1, '94668200_1436926367', 'accessories-25/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(59154, 1, '02215500_1436926368', 'accessories-25/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(59178, 1, '42248300_1436926368', 'accessories-25/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(59183, 1, '48558600_1436926368', 'accessories-25/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(59186, 1, '52278000_1436926368', 'accessories-25/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(59188, 1, '54386500_1436926368', 'accessories-25/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(59236, 2, '57350200_1436926370', 'accessories-25.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(59238, 2, '62193100_1436926370', 'accessories-25/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(59253, 2, '51516200_1436926371', 'accessories-25/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(59275, 2, '21582400_1436926372', 'accessories-25/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(59297, 2, '00608700_1436926373', 'accessories-25/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(59304, 2, '18883600_1436926373', 'accessories-25/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(59311, 2, '34552300_1436926373', 'accessories-25/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(59349, 2, '78715500_1436926374', 'accessories-25/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(59369, 2, '27405500_1436926375', 'accessories-25/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(59389, 2, '79911300_1436926375', 'accessories-25/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(59409, 2, '59608600_1436926376', 'accessories-25/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(59430, 2, '33025500_1436926377', 'accessories-25/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(59451, 2, '99213900_1436926377', 'accessories-25/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(59472, 2, '55184900_1436926378', 'accessories-25/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(59493, 2, '10981800_1436926379', 'accessories-25/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(59515, 2, '86615300_1436926379', 'accessories-25/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(59520, 2, '01970200_1436926380', 'accessories-25/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(59538, 2, '57539100_1436926380', 'accessories-25/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(59559, 2, '18891000_1436926381', 'accessories-25/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(59580, 2, '11337000_1436926382', 'accessories-25/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(59601, 2, '87508500_1436926382', 'accessories-25/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(59623, 2, '60637200_1436926383', 'accessories-25/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(59628, 2, '78510400_1436926383', 'accessories-25/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(59647, 2, '22358000_1436926384', 'accessories-25/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(59652, 2, '44086700_1436926384', 'accessories-25/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(59671, 2, '91946500_1436926385', 'accessories-25/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(59676, 2, '34995600_1436926386', 'accessories-25/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(59695, 2, '07669400_1436926387', 'accessories-25/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(59700, 2, '31339500_1436926387', 'accessories-25/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(59718, 2, '93523100_1436926387', 'accessories-25/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(59723, 2, '10512900_1436926388', 'accessories-25/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(59747, 2, '88063400_1436926388', 'accessories-25/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(59752, 2, '98771000_1436926388', 'accessories-25/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(59755, 2, '11008900_1436926389', 'accessories-25/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(59757, 2, '17551700_1436926389', 'accessories-25/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(59810, 3, '24061700_1436926396', 'accessories-15.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(59812, 3, '02392800_1436926397', 'accessories-15/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(59814, 3, '41491500_1436926397', 'accessories-15/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(59816, 3, '59739900_1436926397', 'accessories-15/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(59818, 3, '81790100_1436926397', 'accessories-15/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(59823, 3, '05953400_1436926399', 'accessories-15/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(59825, 3, '13475200_1436926399', 'accessories-15/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(59846, 3, '72250700_1436926399', 'accessories-15/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(59848, 3, '81607100_1436926399', 'accessories-15/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(59869, 3, '44691300_1436926401', 'accessories-15/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(59871, 3, '57130900_1436926401', 'accessories-15/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(59877, 3, '87133400_1436926401', 'accessories-15/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(59879, 3, '01657000_1436926402', 'accessories-15/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(59885, 3, '25902500_1436926402', 'accessories-15/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(59887, 3, '83445400_1436926402', 'accessories-15/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(59915, 3, '18274600_1436926404', 'accessories-15/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(59935, 3, '02498800_1436926405', 'accessories-15/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(59955, 3, '44924900_1436926408', 'accessories-15/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(59975, 3, '52607700_1436926409', 'accessories-15/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(59995, 3, '37386900_1436926410', 'accessories-15/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(60016, 3, '13765500_1436926411', 'accessories-15/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(60037, 3, '88523900_1436926411', 'accessories-15/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(60058, 3, '00196800_1436926413', 'accessories-15/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(60079, 3, '73819900_1436926413', 'accessories-15/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(60084, 3, '89383600_1436926413', 'accessories-15/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(60103, 3, '57588800_1436926414', 'accessories-15/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(60124, 3, '29986100_1436926415', 'accessories-15/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(60145, 3, '93136500_1436926415', 'accessories-15/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(60166, 3, '80245300_1436926416', 'accessories-15/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(60187, 3, '83884700_1436926418', 'accessories-15/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(60192, 3, '14222600_1436926419', 'accessories-15/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(60211, 3, '84908300_1436926419', 'accessories-15/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(60216, 3, '99969400_1436926419', 'accessories-15/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(60235, 3, '88883700_1436926420', 'accessories-15/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(60240, 3, '39740800_1436926421', 'accessories-15/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(60259, 3, '72386700_1436926422', 'accessories-15/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(60264, 3, '83410200_1436926422', 'accessories-15/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(60282, 3, '60260900_1436926423', 'accessories-15/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(60287, 3, '82193200_1436926423', 'accessories-15/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(60305, 3, '47796100_1436926424', 'accessories-15/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(60312, 3, '69643900_1436926424', 'accessories-15/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(60314, 3, '84822700_1436926424', 'accessories-15/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(60317, 3, '95726400_1436926424', 'accessories-15/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(60319, 3, '01351000_1436926425', 'accessories-15/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(60388, 4, '00146800_1436926433', 'accessories-15.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(60390, 4, '07375500_1436926433', 'accessories-15/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(60392, 4, '20059600_1436926433', 'accessories-15/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(60394, 4, '28512100_1436926433', 'accessories-15/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(60396, 4, '44623700_1436926433', 'accessories-15/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(60401, 4, '96949600_1436926433', 'accessories-15/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(60403, 4, '03632200_1436926434', 'accessories-15/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(60424, 4, '71878600_1436926434', 'accessories-15/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(60426, 4, '78317900_1436926434', 'accessories-15/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(60447, 4, '44355800_1436926435', 'accessories-15/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(60449, 4, '59447800_1436926435', 'accessories-15/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(60455, 4, '89667100_1436926435', 'accessories-15/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(60457, 4, '99623200_1436926435', 'accessories-15/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(60463, 4, '20874300_1436926436', 'accessories-15/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(60465, 4, '27839000_1436926436', 'accessories-15/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(60493, 4, '05257400_1436926437', 'accessories-15/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(60513, 4, '71510000_1436926437', 'accessories-15/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(60533, 4, '48759900_1436926438', 'accessories-15/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(60553, 4, '18344800_1436926439', 'accessories-15/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(60573, 4, '72643200_1436926439', 'accessories-15/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(60594, 4, '67798300_1436926443', 'accessories-15/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(60615, 4, '29972000_1436926444', 'accessories-15/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(60636, 4, '78385200_1436926444', 'accessories-15/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(60657, 4, '29219900_1436926445', 'accessories-15/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(60662, 4, '40778800_1436926445', 'accessories-15/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(60681, 4, '87730400_1436926445', 'accessories-15/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(60702, 4, '32682200_1436926446', 'accessories-15/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(60723, 4, '84265800_1436926446', 'accessories-15/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(60744, 4, '36000700_1436926447', 'accessories-15/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(60765, 4, '90184800_1436926447', 'accessories-15/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(60770, 4, '00224800_1436926448', 'accessories-15/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(60789, 4, '41190700_1436926448', 'accessories-15/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(60794, 4, '57883700_1436926448', 'accessories-15/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(60813, 4, '12382100_1436926449', 'accessories-15/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(60818, 4, '25695800_1436926449', 'accessories-15/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(60837, 4, '78094800_1436926449', 'accessories-15/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(60842, 4, '91506200_1436926449', 'accessories-15/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(60860, 4, '35959700_1436926450', 'accessories-15/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(60865, 4, '48254900_1436926450', 'accessories-15/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(60883, 4, '97982700_1436926450', 'accessories-15/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(60890, 4, '15937200_1436926451', 'accessories-15/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(60892, 4, '25240800_1436926451', 'accessories-15/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(60895, 4, '34814400_1436926451', 'accessories-15/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(60897, 4, '42883000_1436926451', 'accessories-15/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(60966, 5, '84165200_1436926455', 'accessories-15.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(60968, 5, '89924500_1436926455', 'accessories-15/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(60970, 5, '96277700_1436926455', 'accessories-15/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(60972, 5, '04013800_1436926456', 'accessories-15/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(60974, 5, '07948700_1436926456', 'accessories-15/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(60979, 5, '49453500_1436926456', 'accessories-15/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(60981, 5, '58249400_1436926456', 'accessories-15/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(61002, 5, '10808100_1436926457', 'accessories-15/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(61004, 5, '21778500_1436926457', 'accessories-15/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(61025, 5, '70978500_1436926457', 'accessories-15/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(61027, 5, '80088400_1436926457', 'accessories-15/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(61033, 5, '95254500_1436926457', 'accessories-15/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(61035, 5, '00391300_1436926458', 'accessories-15/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(61041, 5, '18316200_1436926458', 'accessories-15/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(61043, 5, '22547000_1436926458', 'accessories-15/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(61071, 5, '82757000_1436926458', 'accessories-15/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(61091, 5, '32438700_1436926459', 'accessories-15/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(61111, 5, '91580000_1436926459', 'accessories-15/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(61131, 5, '40253300_1436926460', 'accessories-15/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(61151, 5, '02079100_1436926461', 'accessories-15/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(61172, 5, '56479100_1436926461', 'accessories-15/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(61193, 5, '35704400_1436926462', 'accessories-15/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(61214, 5, '91861300_1436926462', 'accessories-15/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(61235, 5, '41423200_1436926463', 'accessories-15/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(61240, 5, '58982900_1436926463', 'accessories-15/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(61259, 5, '11157500_1436926464', 'accessories-15/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(61280, 5, '92476500_1436926468', 'accessories-15/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(61301, 5, '40642800_1436926470', 'accessories-15/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(61322, 5, '26234300_1436926471', 'accessories-15/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(61343, 5, '95847100_1436926471', 'accessories-15/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(61348, 5, '38293800_1436926472', 'accessories-15/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(61367, 5, '13487800_1436926473', 'accessories-15/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(61372, 5, '34052400_1436926473', 'accessories-15/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(61391, 5, '92007500_1436926473', 'accessories-15/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(61396, 5, '07972800_1436926474', 'accessories-15/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(61415, 5, '63656500_1436926474', 'accessories-15/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(61420, 5, '04827600_1436926475', 'accessories-15/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(61438, 5, '57910200_1436926475', 'accessories-15/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(61443, 5, '87242400_1436926475', 'accessories-15/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(61461, 5, '50830700_1436926476', 'accessories-15/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(61468, 5, '71516600_1436926476', 'accessories-15/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(61470, 5, '77591200_1436926476', 'accessories-15/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(61473, 5, '91444000_1436926476', 'accessories-15/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(61475, 5, '97787800_1436926476', 'accessories-15/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(61539, 1, '38871400_1436927303', 'accessories-26.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(61541, 1, '39334400_1436927303', 'accessories-26/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(61556, 1, '44994300_1436927303', 'accessories-26/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(61578, 1, '47070800_1436927303', 'accessories-26/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(61600, 1, '49307000_1436927303', 'accessories-26/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(61607, 1, '50049000_1436927303', 'accessories-26/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(61614, 1, '50796000_1436927303', 'accessories-26/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(61652, 1, '55132200_1436927303', 'accessories-26/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(61672, 1, '57841000_1436927303', 'accessories-26/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(61692, 1, '61132000_1436927303', 'accessories-26/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(61712, 1, '63712500_1436927303', 'accessories-26/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(61733, 1, '65912100_1436927303', 'accessories-26/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(61754, 1, '68439500_1436927303', 'accessories-26/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(61775, 1, '70554500_1436927303', 'accessories-26/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(61796, 1, '72920400_1436927303', 'accessories-26/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(61818, 1, '75510200_1436927303', 'accessories-26/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(61823, 1, '76023600_1436927303', 'accessories-26/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(61841, 1, '78002700_1436927303', 'accessories-26/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(61862, 1, '80850200_1436927303', 'accessories-26/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(61883, 1, '83456700_1436927303', 'accessories-26/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(61904, 1, '85623400_1436927303', 'accessories-26/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(61926, 1, '87760800_1436927303', 'accessories-26/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(61931, 1, '88415300_1436927303', 'accessories-26/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(61950, 1, '90562600_1436927303', 'accessories-26/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(61955, 1, '91128600_1436927303', 'accessories-26/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(61974, 1, '93208100_1436927303', 'accessories-26/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(61979, 1, '93724100_1436927303', 'accessories-26/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(61998, 1, '95578000_1436927303', 'accessories-26/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(62003, 1, '96129400_1436927303', 'accessories-26/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(62021, 1, '97976100_1436927303', 'accessories-26/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(62026, 1, '98884200_1436927303', 'accessories-26/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(62050, 1, '01216500_1436927304', 'accessories-26/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(62055, 1, '01746700_1436927304', 'accessories-26/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(62058, 1, '02088200_1436927304', 'accessories-26/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(62060, 1, '02334700_1436927304', 'accessories-26/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(62108, 2, '14088900_1436927304', 'accessories-26.html', 'accessories-27.html', 0, 'RP', NULL, 50, NULL),
(62110, 2, '14362100_1436927304', 'accessories-26/product-types.html', 'accessories-27/product-types.html', 0, 'RP', NULL, 58, NULL),
(62125, 2, '18940400_1436927304', 'accessories-26/product-types/configurable-product.html', 'accessories-27/product-types/configurable-product.html', 0, 'RP', NULL, 58, 7),
(62147, 2, '21062000_1436927304', 'accessories-26/product-types/configurable-product-02.html', 'accessories-27/product-types/configurable-product-02.html', 0, 'RP', NULL, 58, 13),
(62169, 2, '23616300_1436927304', 'accessories-26/product-types/configurable-product-03.html', 'accessories-27/product-types/configurable-product-03.html', 0, 'RP', NULL, 58, 19),
(62176, 2, '24654100_1436927304', 'accessories-26/product-types/configurable-product-04.html', 'accessories-27/product-types/configurable-product-04.html', 0, 'RP', NULL, 58, 20),
(62183, 2, '25301600_1436927304', 'accessories-26/product-types/configurable-product-05.html', 'accessories-27/product-types/configurable-product-05.html', 0, 'RP', NULL, 58, 21),
(62221, 2, '29282000_1436927304', 'accessories-26/configurable-product-04-red.html', 'accessories-27/configurable-product-04-red.html', 0, 'RP', NULL, 50, 29),
(62241, 2, '31241800_1436927304', 'accessories-26/configurable-product-04-green.html', 'accessories-27/configurable-product-04-green.html', 0, 'RP', NULL, 50, 30),
(62261, 2, '33217100_1436927304', 'accessories-26/configurable-product-04-blue.html', 'accessories-27/configurable-product-04-blue.html', 0, 'RP', NULL, 50, 31),
(62281, 2, '35221800_1436927304', 'accessories-26/configurable-product-05-armani.html', 'accessories-27/configurable-product-05-armani.html', 0, 'RP', NULL, 50, 32),
(62302, 2, '37286000_1436927304', 'accessories-26/configurable-product-05-buberry.html', 'accessories-27/configurable-product-05-buberry.html', 0, 'RP', NULL, 50, 33),
(62323, 2, '39707000_1436927304', 'accessories-26/configurable-product-05-chanel.html', 'accessories-27/configurable-product-05-chanel.html', 0, 'RP', NULL, 50, 34),
(62344, 2, '41736200_1436927304', 'accessories-26/configurable-product-05-hermes.html', 'accessories-27/configurable-product-05-hermes.html', 0, 'RP', NULL, 50, 35),
(62365, 2, '43832500_1436927304', 'accessories-26/configurable-product-05-versace.html', 'accessories-27/configurable-product-05-versace.html', 0, 'RP', NULL, 50, 36),
(62387, 2, '46056200_1436927304', 'accessories-26/simple-product-01.html', 'accessories-27/simple-product-01.html', 0, 'RP', NULL, 50, 37),
(62392, 2, '46613400_1436927304', 'accessories-26/product-types/simple-product-01.html', 'accessories-27/product-types/simple-product-01.html', 0, 'RP', NULL, 58, 37),
(62410, 2, '48642400_1436927304', 'accessories-26/simple-product-02.html', 'accessories-27/simple-product-02.html', 0, 'RP', NULL, 50, 38),
(62431, 2, '50640300_1436927304', 'accessories-26/simple-product-03.html', 'accessories-27/simple-product-03.html', 0, 'RP', NULL, 50, 39),
(62452, 2, '52779100_1436927304', 'accessories-26/simple-product-04.html', 'accessories-27/simple-product-04.html', 0, 'RP', NULL, 50, 40),
(62473, 2, '54945300_1436927304', 'accessories-26/simple-product-05.html', 'accessories-27/simple-product-05.html', 0, 'RP', NULL, 50, 41),
(62495, 2, '57168900_1436927304', 'accessories-26/grouped-product.html', 'accessories-27/grouped-product.html', 0, 'RP', NULL, 50, 42),
(62500, 2, '57731200_1436927304', 'accessories-26/product-types/grouped-product.html', 'accessories-27/product-types/grouped-product.html', 0, 'RP', NULL, 58, 42),
(62519, 2, '60344900_1436927304', 'accessories-26/bundle-product.html', 'accessories-27/bundle-product.html', 0, 'RP', NULL, 50, 44),
(62524, 2, '60989300_1436927304', 'accessories-26/product-types/bundle-product.html', 'accessories-27/product-types/bundle-product.html', 0, 'RP', NULL, 58, 44),
(62543, 2, '63581000_1436927304', 'accessories-26/bundle-product-02.html', 'accessories-27/bundle-product-02.html', 0, 'RP', NULL, 50, 45),
(62548, 2, '64101500_1436927304', 'accessories-26/product-types/bundle-product-02.html', 'accessories-27/product-types/bundle-product-02.html', 0, 'RP', NULL, 58, 45),
(62567, 2, '66022500_1436927304', 'accessories-26/downloadable-product.html', 'accessories-27/downloadable-product.html', 0, 'RP', NULL, 50, 46),
(62572, 2, '66593500_1436927304', 'accessories-26/product-types/downloadable-product.html', 'accessories-27/product-types/downloadable-product.html', 0, 'RP', NULL, 58, 46),
(62590, 2, '68791900_1436927304', 'accessories-26/no-image.html', 'accessories-27/no-image.html', 0, 'RP', NULL, 50, 47),
(62595, 2, '69336600_1436927304', 'accessories-26/product-types/no-image.html', 'accessories-27/product-types/no-image.html', 0, 'RP', NULL, 58, 47),
(62619, 2, '71639400_1436927304', 'accessories-26/custom-option.html', 'accessories-27/custom-option.html', 0, 'RP', NULL, 50, 48),
(62624, 2, '72242900_1436927304', 'accessories-26/product-types/custom-option.html', 'accessories-27/product-types/custom-option.html', 0, 'RP', NULL, 58, 48),
(62627, 2, '72587200_1436927304', 'accessories-26/virtual-product.html', 'accessories-27/virtual-product.html', 0, 'RP', NULL, 50, 49),
(62629, 2, '72833600_1436927304', 'accessories-26/product-types/virtual-product.html', 'accessories-27/product-types/virtual-product.html', 0, 'RP', NULL, 58, 49),
(62682, 3, '85559300_1436927304', 'accessories-16.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(62684, 3, '85903500_1436927304', 'accessories-16/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(62686, 3, '86265900_1436927304', 'accessories-16/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(62688, 3, '86633900_1436927304', 'accessories-16/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(62690, 3, '86977400_1436927304', 'accessories-16/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(62695, 3, '89843800_1436927304', 'accessories-16/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(62697, 3, '90108200_1436927304', 'accessories-16/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(62718, 3, '92231000_1436927304', 'accessories-16/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(62720, 3, '92519700_1436927304', 'accessories-16/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(62741, 3, '95030400_1436927304', 'accessories-16/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(62743, 3, '95271300_1436927304', 'accessories-16/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(62749, 3, '95857300_1436927304', 'accessories-16/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(62751, 3, '96137300_1436927304', 'accessories-16/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(62757, 3, '96751300_1436927304', 'accessories-16/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(62759, 3, '96986800_1436927304', 'accessories-16/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(62787, 3, '99771700_1436927304', 'accessories-16/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(62807, 3, '01788400_1436927305', 'accessories-16/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(62827, 3, '04061000_1436927305', 'accessories-16/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(62847, 3, '05961900_1436927305', 'accessories-16/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(62867, 3, '07905000_1436927305', 'accessories-16/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(62888, 3, '10068000_1436927305', 'accessories-16/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(62909, 3, '12244700_1436927305', 'accessories-16/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(62930, 3, '14370800_1436927305', 'accessories-16/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(62951, 3, '16519800_1436927305', 'accessories-16/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(62956, 3, '17068100_1436927305', 'accessories-16/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(62975, 3, '19381300_1436927305', 'accessories-16/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(62996, 3, '21391800_1436927305', 'accessories-16/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(63017, 3, '23627800_1436927305', 'accessories-16/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(63038, 3, '26507200_1436927305', 'accessories-16/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(63059, 3, '29075500_1436927305', 'accessories-16/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(63064, 3, '29697400_1436927305', 'accessories-16/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(63083, 3, '31540000_1436927305', 'accessories-16/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(63088, 3, '32067000_1436927305', 'accessories-16/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(63107, 3, '33971400_1436927305', 'accessories-16/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(63112, 3, '34536300_1436927305', 'accessories-16/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(63131, 3, '36577700_1436927305', 'accessories-16/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(63136, 3, '37166700_1436927305', 'accessories-16/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(63154, 3, '39083700_1436927305', 'accessories-16/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(63159, 3, '39778000_1436927305', 'accessories-16/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(63177, 3, '41892600_1436927305', 'accessories-16/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(63184, 3, '42551800_1436927305', 'accessories-16/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(63186, 3, '42830300_1436927305', 'accessories-16/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(63189, 3, '43224200_1436927305', 'accessories-16/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(63191, 3, '43485900_1436927305', 'accessories-16/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(63260, 4, '56826800_1436927305', 'accessories-16.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(63262, 4, '57046300_1436927305', 'accessories-16/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(63264, 4, '57265400_1436927305', 'accessories-16/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(63266, 4, '57498700_1436927305', 'accessories-16/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(63268, 4, '57739600_1436927305', 'accessories-16/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(63273, 4, '60633300_1436927305', 'accessories-16/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(63275, 4, '60938400_1436927305', 'accessories-16/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(63296, 4, '63524600_1436927305', 'accessories-16/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(63298, 4, '63903000_1436927305', 'accessories-16/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(63319, 4, '66172500_1436927305', 'accessories-16/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(63321, 4, '66442700_1436927305', 'accessories-16/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(63327, 4, '67052800_1436927305', 'accessories-16/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(63329, 4, '67322700_1436927305', 'accessories-16/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(63335, 4, '68078500_1436927305', 'accessories-16/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(63337, 4, '68388600_1436927305', 'accessories-16/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(63365, 4, '71124100_1436927305', 'accessories-16/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(63385, 4, '73312200_1436927305', 'accessories-16/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30),
(63405, 4, '75483400_1436927305', 'accessories-16/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(63425, 4, '77559600_1436927305', 'accessories-16/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(63445, 4, '79789300_1436927305', 'accessories-16/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(63466, 4, '82220100_1436927305', 'accessories-16/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(63487, 4, '84303800_1436927305', 'accessories-16/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(63508, 4, '86439400_1436927305', 'accessories-16/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(63529, 4, '88882200_1436927305', 'accessories-16/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(63534, 4, '89432600_1436927305', 'accessories-16/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(63553, 4, '91268300_1436927305', 'accessories-16/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(63574, 4, '93408700_1436927305', 'accessories-16/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(63595, 4, '95446900_1436927305', 'accessories-16/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(63616, 4, '97609500_1436927305', 'accessories-16/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(63637, 4, '00161600_1436927306', 'accessories-16/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(63642, 4, '00678400_1436927306', 'accessories-16/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(63661, 4, '02524600_1436927306', 'accessories-16/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(63666, 4, '03140600_1436927306', 'accessories-16/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(63685, 4, '04988300_1436927306', 'accessories-16/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(63690, 4, '05527400_1436927306', 'accessories-16/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(63709, 4, '07452300_1436927306', 'accessories-16/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(63714, 4, '08048200_1436927306', 'accessories-16/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(63732, 4, '10085700_1436927306', 'accessories-16/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(63737, 4, '10639700_1436927306', 'accessories-16/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(63755, 4, '12917000_1436927306', 'accessories-16/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(63762, 4, '13661600_1436927306', 'accessories-16/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(63764, 4, '13887600_1436927306', 'accessories-16/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(63767, 4, '14205800_1436927306', 'accessories-16/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(63769, 4, '14464800_1436927306', 'accessories-16/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48),
(63838, 5, '28232700_1436927306', 'accessories-16.html', 'accessories-17.html', 0, 'RP', NULL, 6, NULL),
(63840, 5, '28728800_1436927306', 'accessories-16/bras.html', 'accessories-17/bras.html', 0, 'RP', NULL, 26, NULL),
(63842, 5, '28952200_1436927306', 'accessories-16/cosmetics.html', 'accessories-17/cosmetics.html', 0, 'RP', NULL, 28, NULL),
(63844, 5, '29171100_1436927306', 'accessories-16/cfg-products.html', 'accessories-17/cfg-products.html', 0, 'RP', NULL, 40, NULL),
(63846, 5, '29409900_1436927306', 'accessories-16/product-types.html', 'accessories-17/product-types.html', 0, 'RP', NULL, 41, NULL),
(63851, 5, '32055900_1436927306', 'accessories-16/cfg-products/configurable-product.html', 'accessories-17/cfg-products/configurable-product.html', 0, 'RP', NULL, 40, 7),
(63853, 5, '32293400_1436927306', 'accessories-16/product-types/configurable-product.html', 'accessories-17/product-types/configurable-product.html', 0, 'RP', NULL, 41, 7),
(63874, 5, '34699100_1436927306', 'accessories-16/cfg-products/configurable-product-02.html', 'accessories-17/cfg-products/configurable-product-02.html', 0, 'RP', NULL, 40, 13),
(63876, 5, '34958900_1436927306', 'accessories-16/product-types/configurable-product-02.html', 'accessories-17/product-types/configurable-product-02.html', 0, 'RP', NULL, 41, 13),
(63897, 5, '36982200_1436927306', 'accessories-16/cfg-products/configurable-product-03.html', 'accessories-17/cfg-products/configurable-product-03.html', 0, 'RP', NULL, 40, 19),
(63899, 5, '37244300_1436927306', 'accessories-16/product-types/configurable-product-03.html', 'accessories-17/product-types/configurable-product-03.html', 0, 'RP', NULL, 41, 19),
(63905, 5, '37911200_1436927306', 'accessories-16/cfg-products/configurable-product-04.html', 'accessories-17/cfg-products/configurable-product-04.html', 0, 'RP', NULL, 40, 20),
(63907, 5, '38256000_1436927306', 'accessories-16/product-types/configurable-product-04.html', 'accessories-17/product-types/configurable-product-04.html', 0, 'RP', NULL, 41, 20),
(63913, 5, '38890400_1436927306', 'accessories-16/cfg-products/configurable-product-05.html', 'accessories-17/cfg-products/configurable-product-05.html', 0, 'RP', NULL, 40, 21),
(63915, 5, '39156900_1436927306', 'accessories-16/product-types/configurable-product-05.html', 'accessories-17/product-types/configurable-product-05.html', 0, 'RP', NULL, 41, 21),
(63943, 5, '41980500_1436927306', 'accessories-16/configurable-product-04-red.html', 'accessories-17/configurable-product-04-red.html', 0, 'RP', NULL, 6, 29),
(63963, 5, '44304700_1436927306', 'accessories-16/configurable-product-04-green.html', 'accessories-17/configurable-product-04-green.html', 0, 'RP', NULL, 6, 30);
INSERT INTO `#__core_url_rewrite` (`url_rewrite_id`, `store_id`, `id_path`, `request_path`, `target_path`, `is_system`, `options`, `description`, `category_id`, `product_id`) VALUES
(63983, 5, '46303400_1436927306', 'accessories-16/configurable-product-04-blue.html', 'accessories-17/configurable-product-04-blue.html', 0, 'RP', NULL, 6, 31),
(64003, 5, '48484500_1436927306', 'accessories-16/configurable-product-05-armani.html', 'accessories-17/configurable-product-05-armani.html', 0, 'RP', NULL, 6, 32),
(64023, 5, '50427300_1436927306', 'accessories-16/configurable-product-05-buberry.html', 'accessories-17/configurable-product-05-buberry.html', 0, 'RP', NULL, 6, 33),
(64044, 5, '52542800_1436927306', 'accessories-16/configurable-product-05-chanel.html', 'accessories-17/configurable-product-05-chanel.html', 0, 'RP', NULL, 6, 34),
(64065, 5, '55110200_1436927306', 'accessories-16/configurable-product-05-hermes.html', 'accessories-17/configurable-product-05-hermes.html', 0, 'RP', NULL, 6, 35),
(64086, 5, '57125400_1436927306', 'accessories-16/configurable-product-05-versace.html', 'accessories-17/configurable-product-05-versace.html', 0, 'RP', NULL, 6, 36),
(64107, 5, '59236100_1436927306', 'accessories-16/simple-product-01.html', 'accessories-17/simple-product-01.html', 0, 'RP', NULL, 6, 37),
(64112, 5, '59803500_1436927306', 'accessories-16/product-types/simple-product-01.html', 'accessories-17/product-types/simple-product-01.html', 0, 'RP', NULL, 41, 37),
(64131, 5, '61829900_1436927306', 'accessories-16/simple-product-02.html', 'accessories-17/simple-product-02.html', 0, 'RP', NULL, 6, 38),
(64152, 5, '64362900_1436927306', 'accessories-16/simple-product-03.html', 'accessories-17/simple-product-03.html', 0, 'RP', NULL, 6, 39),
(64173, 5, '67314600_1436927306', 'accessories-16/simple-product-04.html', 'accessories-17/simple-product-04.html', 0, 'RP', NULL, 6, 40),
(64194, 5, '69598600_1436927306', 'accessories-16/simple-product-05.html', 'accessories-17/simple-product-05.html', 0, 'RP', NULL, 6, 41),
(64215, 5, '71739800_1436927306', 'accessories-16/grouped-product.html', 'accessories-17/grouped-product.html', 0, 'RP', NULL, 6, 42),
(64220, 5, '72287900_1436927306', 'accessories-16/product-types/grouped-product.html', 'accessories-17/product-types/grouped-product.html', 0, 'RP', NULL, 41, 42),
(64239, 5, '74190200_1436927306', 'accessories-16/bundle-product.html', 'accessories-17/bundle-product.html', 0, 'RP', NULL, 6, 44),
(64244, 5, '74737300_1436927306', 'accessories-16/product-types/bundle-product.html', 'accessories-17/product-types/bundle-product.html', 0, 'RP', NULL, 41, 44),
(64263, 5, '76849000_1436927306', 'accessories-16/bundle-product-02.html', 'accessories-17/bundle-product-02.html', 0, 'RP', NULL, 6, 45),
(64268, 5, '77395600_1436927306', 'accessories-16/product-types/bundle-product-02.html', 'accessories-17/product-types/bundle-product-02.html', 0, 'RP', NULL, 41, 45),
(64287, 5, '79351900_1436927306', 'accessories-16/downloadable-product.html', 'accessories-17/downloadable-product.html', 0, 'RP', NULL, 6, 46),
(64292, 5, '79909300_1436927306', 'accessories-16/product-types/downloadable-product.html', 'accessories-17/product-types/downloadable-product.html', 0, 'RP', NULL, 41, 46),
(64310, 5, '81987900_1436927306', 'accessories-16/no-image.html', 'accessories-17/no-image.html', 0, 'RP', NULL, 6, 47),
(64315, 5, '82530400_1436927306', 'accessories-16/product-types/no-image.html', 'accessories-17/product-types/no-image.html', 0, 'RP', NULL, 41, 47),
(64333, 5, '84302700_1436927306', 'accessories-16/custom-option.html', 'accessories-17/custom-option.html', 0, 'RP', NULL, 6, 48),
(64340, 5, '85182800_1436927306', 'accessories-16/bras/custom-option.html', 'accessories-17/bras/custom-option.html', 0, 'RP', NULL, 26, 48),
(64342, 5, '85461500_1436927306', 'accessories-16/cosmetics/custom-option.html', 'accessories-17/cosmetics/custom-option.html', 0, 'RP', NULL, 28, 48),
(64345, 5, '85822500_1436927306', 'accessories-16/cfg-products/custom-option.html', 'accessories-17/cfg-products/custom-option.html', 0, 'RP', NULL, 40, 48),
(64347, 5, '86093300_1436927306', 'accessories-16/product-types/custom-option.html', 'accessories-17/product-types/custom-option.html', 0, 'RP', NULL, 41, 48);

CREATE TABLE IF NOT EXISTS `#__core_variable` (
`variable_id` int(10) unsigned NOT NULL COMMENT 'Variable Id',
  `code` varchar(255) DEFAULT NULL COMMENT 'Variable Code',
  `name` varchar(255) DEFAULT NULL COMMENT 'Variable Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Variables' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_variable_value` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Variable Value Id',
  `variable_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Variable Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `plain_value` text COMMENT 'Plain Text Value',
  `html_value` text COMMENT 'Html Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Variable Value' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__core_website` (
`website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `code` varchar(32) DEFAULT NULL COMMENT 'Code',
  `name` varchar(64) DEFAULT NULL COMMENT 'Website Name',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `default_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Default Group Id',
  `is_default` smallint(5) unsigned DEFAULT '0' COMMENT 'Defines Is Website Default'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Websites' AUTO_INCREMENT=2 ;

INSERT INTO `#__core_website` (`website_id`, `code`, `name`, `sort_order`, `default_group_id`, `is_default`) VALUES
(0, 'admin', 'Admin', 0, 0, 0),
(1, 'base', 'Main Website', 0, 1, 1);

CREATE TABLE IF NOT EXISTS `#__coupon_aggregated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int(11) NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `subtotal_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount Actual',
  `discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount Actual',
  `total_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount Actual',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Coupon Aggregated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__coupon_aggregated_order` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int(11) NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Coupon Aggregated Order' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__coupon_aggregated_updated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date NOT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `coupon_code` varchar(50) DEFAULT NULL COMMENT 'Coupon Code',
  `coupon_uses` int(11) NOT NULL DEFAULT '0' COMMENT 'Coupon Uses',
  `subtotal_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `total_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount',
  `subtotal_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal Amount Actual',
  `discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount Actual',
  `total_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Amount Actual',
  `rule_name` varchar(255) DEFAULT NULL COMMENT 'Rule Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Snspfx Coupon Aggregated Updated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__cron_schedule` (
`schedule_id` int(10) unsigned NOT NULL COMMENT 'Schedule Id',
  `job_code` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Job Code',
  `status` varchar(7) NOT NULL DEFAULT 'pending' COMMENT 'Status',
  `messages` text COMMENT 'Messages',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `scheduled_at` timestamp NULL DEFAULT NULL COMMENT 'Scheduled At',
  `executed_at` timestamp NULL DEFAULT NULL COMMENT 'Executed At',
  `finished_at` timestamp NULL DEFAULT NULL COMMENT 'Finished At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Cron Schedule' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_address_entity` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `parent_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `is_active` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Active'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity' AUTO_INCREMENT=2 ;

INSERT INTO `#__customer_address_entity` (`entity_id`, `entity_type_id`, `attribute_set_id`, `increment_id`, `parent_id`, `created_at`, `updated_at`, `is_active`) VALUES
(1, 2, 0, NULL, 2, '2015-01-19 02:05:57', '2015-01-19 02:05:57', 1);

CREATE TABLE IF NOT EXISTS `#__customer_address_entity_datetime` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity Datetime' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_address_entity_decimal` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity Decimal' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_address_entity_int` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity Int' AUTO_INCREMENT=2 ;

INSERT INTO `#__customer_address_entity_int` (`value_id`, `entity_type_id`, `attribute_id`, `entity_id`, `value`) VALUES
(1, 2, 29, 1, 18);

CREATE TABLE IF NOT EXISTS `#__customer_address_entity_text` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` text NOT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity Text' AUTO_INCREMENT=2 ;

INSERT INTO `#__customer_address_entity_text` (`value_id`, `entity_type_id`, `attribute_id`, `entity_id`, `value`) VALUES
(1, 2, 25, 1, 'hn');

CREATE TABLE IF NOT EXISTS `#__customer_address_entity_varchar` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Address Entity Varchar' AUTO_INCREMENT=9 ;

INSERT INTO `#__customer_address_entity_varchar` (`value_id`, `entity_type_id`, `attribute_id`, `entity_id`, `value`) VALUES
(1, 2, 20, 1, 'nguyen'),
(2, 2, 22, 1, 'nguyen'),
(3, 2, 24, 1, 'hn'),
(4, 2, 26, 1, 'hn'),
(5, 2, 28, 1, 'Florida'),
(6, 2, 30, 1, '999'),
(7, 2, 27, 1, 'US'),
(8, 2, 31, 1, '99999');

CREATE TABLE IF NOT EXISTS `#__customer_eav_attribute` (
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id',
  `is_visible` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Visible',
  `input_filter` varchar(255) DEFAULT NULL COMMENT 'Input Filter',
  `multiline_count` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Multiline Count',
  `validate_rules` text COMMENT 'Validate Rules',
  `is_system` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is System',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `data_model` varchar(255) DEFAULT NULL COMMENT 'Data Model'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Eav Attribute';

INSERT INTO `#__customer_eav_attribute` (`attribute_id`, `is_visible`, `input_filter`, `multiline_count`, `validate_rules`, `is_system`, `sort_order`, `data_model`) VALUES
(1, 1, NULL, 0, NULL, 1, 10, NULL),
(2, 0, NULL, 0, NULL, 1, 0, NULL),
(3, 1, NULL, 0, NULL, 1, 20, NULL),
(4, 0, NULL, 0, NULL, 0, 30, NULL),
(5, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 40, NULL),
(6, 1, NULL, 0, NULL, 1, 50, NULL),
(7, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 60, NULL),
(8, 0, NULL, 0, NULL, 0, 70, NULL),
(9, 1, NULL, 0, 'a:1:{s:16:"input_validation";s:5:"email";}', 1, 80, NULL),
(10, 1, NULL, 0, NULL, 1, 25, NULL),
(11, 0, 'date', 0, 'a:1:{s:16:"input_validation";s:4:"date";}', 0, 90, NULL),
(12, 0, NULL, 0, NULL, 1, 0, NULL),
(13, 0, NULL, 0, NULL, 1, 0, NULL),
(14, 0, NULL, 0, NULL, 1, 0, NULL),
(15, 0, NULL, 0, 'a:1:{s:15:"max_text_length";i:255;}', 0, 100, NULL),
(16, 0, NULL, 0, NULL, 1, 0, NULL),
(17, 0, 'datetime', 0, NULL, 0, 0, NULL),
(18, 0, NULL, 0, 'a:0:{}', 0, 110, NULL),
(19, 0, NULL, 0, NULL, 0, 10, NULL),
(20, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 20, NULL),
(21, 1, NULL, 0, NULL, 1, 30, NULL),
(22, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 40, NULL),
(23, 0, NULL, 0, NULL, 0, 50, NULL),
(24, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 60, NULL),
(25, 1, NULL, 2, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 70, NULL),
(26, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 80, NULL),
(27, 1, NULL, 0, NULL, 1, 90, NULL),
(28, 1, NULL, 0, NULL, 1, 100, NULL),
(29, 1, NULL, 0, NULL, 1, 100, NULL),
(30, 1, NULL, 0, 'a:0:{}', 1, 110, 'customer/attribute_data_postcode'),
(31, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 120, NULL),
(32, 1, NULL, 0, 'a:2:{s:15:"max_text_length";i:255;s:15:"min_text_length";i:1;}', 1, 130, NULL),
(33, 0, NULL, 0, NULL, 1, 0, NULL),
(34, 0, NULL, 0, 'a:1:{s:16:"input_validation";s:4:"date";}', 1, 0, NULL),
(35, 1, NULL, 0, NULL, 1, 28, NULL),
(36, 1, NULL, 0, NULL, 1, 140, NULL),
(37, 0, NULL, 0, NULL, 1, 0, NULL),
(38, 0, NULL, 0, NULL, 1, 0, NULL),
(39, 0, NULL, 0, NULL, 1, 0, NULL),
(40, 0, NULL, 0, NULL, 1, 0, NULL);

CREATE TABLE IF NOT EXISTS `#__customer_eav_attribute_website` (
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `is_visible` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Visible',
  `is_required` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Required',
  `default_value` text COMMENT 'Default Value',
  `multiline_count` smallint(5) unsigned DEFAULT NULL COMMENT 'Multiline Count'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Eav Attribute Website';

CREATE TABLE IF NOT EXISTS `#__customer_entity` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `website_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Website Id',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Group Id',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `store_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Store Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `is_active` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Active',
  `disable_auto_group_change` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Disable automatic group change based on VAT ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Entity' AUTO_INCREMENT=4 ;

INSERT INTO `#__customer_entity` (`entity_id`, `entity_type_id`, `attribute_set_id`, `website_id`, `email`, `group_id`, `increment_id`, `store_id`, `created_at`, `updated_at`, `is_active`, `disable_auto_group_change`) VALUES
(1, 1, 0, 1, 'thangnm.hnvn@gmail.com', 1, NULL, 1, '2014-12-04 20:56:40', '2014-12-04 20:56:40', 1, 0),
(2, 1, 0, 1, 'admin@mystore.com', 1, NULL, 1, '2015-01-18 20:57:06', '2015-01-19 02:05:57', 1, 0),
(3, 1, 0, 1, 'administrator@gmail.com', 1, NULL, 1, '2015-05-13 01:31:46', '2015-05-13 01:31:46', 1, 0);

CREATE TABLE IF NOT EXISTS `#__customer_entity_datetime` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Entity Datetime' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_entity_decimal` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Entity Decimal' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_entity_int` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Entity Int' AUTO_INCREMENT=3 ;

INSERT INTO `#__customer_entity_int` (`value_id`, `entity_type_id`, `attribute_id`, `entity_id`, `value`) VALUES
(1, 1, 13, 2, 1),
(2, 1, 14, 2, 1);

CREATE TABLE IF NOT EXISTS `#__customer_entity_text` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` text NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Entity Text' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__customer_entity_varchar` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Entity Varchar' AUTO_INCREMENT=13 ;

INSERT INTO `#__customer_entity_varchar` (`value_id`, `entity_type_id`, `attribute_id`, `entity_id`, `value`) VALUES
(1, 1, 5, 1, 'Nguyen'),
(2, 1, 7, 1, 'Thang'),
(3, 1, 12, 1, 'bb1f99dbec0b43a48a3e27d0d5a0974b:4LDDA5AxV2MdXdOVGZcIiadfLgnYFxbc'),
(4, 1, 3, 1, 'English'),
(5, 1, 5, 2, 'nguyen'),
(6, 1, 7, 2, 'nguyen'),
(7, 1, 12, 2, 'ef058104c0c84d4e6aedbb3ef352df24:Zq8m32XYkv6xx1SccCr6x2kVhYYcodDZ'),
(8, 1, 3, 2, 'English'),
(9, 1, 5, 3, 'admin'),
(10, 1, 7, 3, 'admin'),
(11, 1, 12, 3, '6a3b4d991b09bbb41ee0d1699e0ad70c:HTjMUecXjPp8MgkDbqgB9Y4MsNdxjkIr'),
(12, 1, 3, 3, 'English');

CREATE TABLE IF NOT EXISTS `#__customer_form_attribute` (
  `form_code` varchar(32) NOT NULL COMMENT 'Form Code',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Customer Form Attribute';

INSERT INTO `#__customer_form_attribute` (`form_code`, `attribute_id`) VALUES
('adminhtml_customer', 1),
('adminhtml_customer', 3),
('adminhtml_customer', 4),
('checkout_register', 4),
('customer_account_create', 4),
('customer_account_edit', 4),
('adminhtml_customer', 5),
('checkout_register', 5),
('customer_account_create', 5),
('customer_account_edit', 5),
('adminhtml_checkout', 6),
('adminhtml_customer', 6),
('checkout_register', 6),
('customer_account_create', 6),
('customer_account_edit', 6),
('adminhtml_customer', 7),
('checkout_register', 7),
('customer_account_create', 7),
('customer_account_edit', 7),
('adminhtml_customer', 8),
('checkout_register', 8),
('customer_account_create', 8),
('customer_account_edit', 8),
('adminhtml_checkout', 9),
('adminhtml_customer', 9),
('checkout_register', 9),
('customer_account_create', 9),
('customer_account_edit', 9),
('adminhtml_checkout', 10),
('adminhtml_customer', 10),
('adminhtml_checkout', 11),
('adminhtml_customer', 11),
('checkout_register', 11),
('customer_account_create', 11),
('customer_account_edit', 11),
('adminhtml_checkout', 15),
('adminhtml_customer', 15),
('checkout_register', 15),
('customer_account_create', 15),
('customer_account_edit', 15),
('adminhtml_customer', 17),
('checkout_register', 17),
('customer_account_create', 17),
('customer_account_edit', 17),
('adminhtml_checkout', 18),
('adminhtml_customer', 18),
('checkout_register', 18),
('customer_account_create', 18),
('customer_account_edit', 18),
('adminhtml_customer_address', 19),
('customer_address_edit', 19),
('customer_register_address', 19),
('adminhtml_customer_address', 20),
('customer_address_edit', 20),
('customer_register_address', 20),
('adminhtml_customer_address', 21),
('customer_address_edit', 21),
('customer_register_address', 21),
('adminhtml_customer_address', 22),
('customer_address_edit', 22),
('customer_register_address', 22),
('adminhtml_customer_address', 23),
('customer_address_edit', 23),
('customer_register_address', 23),
('adminhtml_customer_address', 24),
('customer_address_edit', 24),
('customer_register_address', 24),
('adminhtml_customer_address', 25),
('customer_address_edit', 25),
('customer_register_address', 25),
('adminhtml_customer_address', 26),
('customer_address_edit', 26),
('customer_register_address', 26),
('adminhtml_customer_address', 27),
('customer_address_edit', 27),
('customer_register_address', 27),
('adminhtml_customer_address', 28),
('customer_address_edit', 28),
('customer_register_address', 28),
('adminhtml_customer_address', 29),
('customer_address_edit', 29),
('customer_register_address', 29),
('adminhtml_customer_address', 30),
('customer_address_edit', 30),
('customer_register_address', 30),
('adminhtml_customer_address', 31),
('customer_address_edit', 31),
('customer_register_address', 31),
('adminhtml_customer_address', 32),
('customer_address_edit', 32),
('customer_register_address', 32),
('adminhtml_customer', 35),
('adminhtml_customer_address', 36),
('customer_address_edit', 36),
('customer_register_address', 36);

CREATE TABLE IF NOT EXISTS `#__customer_group` (
`customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `customer_group_code` varchar(32) NOT NULL COMMENT 'Customer Group Code',
  `tax_class_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tax Class Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Customer Group' AUTO_INCREMENT=4 ;

INSERT INTO `#__customer_group` (`customer_group_id`, `customer_group_code`, `tax_class_id`) VALUES
(0, 'NOT LOGGED IN', 3),
(1, 'General', 3),
(2, 'Wholesale', 3),
(3, 'Retailer', 3);

CREATE TABLE IF NOT EXISTS `#__dataflow_batch` (
`batch_id` int(10) unsigned NOT NULL COMMENT 'Batch Id',
  `profile_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Profile ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `adapter` varchar(128) DEFAULT NULL COMMENT 'Adapter',
  `params` text COMMENT 'Parameters',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Dataflow Batch' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__dataflow_batch_export` (
`batch_export_id` bigint(20) unsigned NOT NULL COMMENT 'Batch Export Id',
  `batch_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Batch Id',
  `batch_data` longtext COMMENT 'Batch Data',
  `status` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Dataflow Batch Export' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__dataflow_batch_import` (
`batch_import_id` bigint(20) unsigned NOT NULL COMMENT 'Batch Import Id',
  `batch_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Batch Id',
  `batch_data` longtext COMMENT 'Batch Data',
  `status` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Dataflow Batch Import' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__dataflow_import_data` (
`import_id` int(11) NOT NULL COMMENT 'Import Id',
  `session_id` int(11) DEFAULT NULL COMMENT 'Session Id',
  `serial_number` int(11) NOT NULL DEFAULT '0' COMMENT 'Serial Number',
  `value` text COMMENT 'Value',
  `status` int(11) NOT NULL DEFAULT '0' COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Dataflow Import Data' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__dataflow_profile` (
`profile_id` int(10) unsigned NOT NULL COMMENT 'Profile Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `actions_xml` text COMMENT 'Actions Xml',
  `gui_data` text COMMENT 'Gui Data',
  `direction` varchar(6) DEFAULT NULL COMMENT 'Direction',
  `entity_type` varchar(64) DEFAULT NULL COMMENT 'Entity Type',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `data_transfer` varchar(11) DEFAULT NULL COMMENT 'Data Transfer'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Dataflow Profile' AUTO_INCREMENT=7 ;

INSERT INTO `#__dataflow_profile` (`profile_id`, `name`, `created_at`, `updated_at`, `actions_xml`, `gui_data`, `direction`, `entity_type`, `store_id`, `data_transfer`) VALUES
(1, 'Export All Products', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="catalog/convert_adapter_product" method="load">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="catalog/convert_parser_product" method="unparse">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_mapper_column" method="map">\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_parser_csv" method="unparse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_adapter_io" method="save">\\r\\n    <var name="type">file</var>\\r\\n    <var name="path">var/export</var>\\r\\n    <var name="filename"><![CDATA[export_all_products.csv]]></var>\\r\\n</action>\\r\\n\\r\\n', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:23:"export_all_products.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:0:"";s:7:"product";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'export', 'product', 0, 'file'),
(2, 'Export Product Stocks', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="catalog/convert_adapter_product" method="load">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="catalog/convert_parser_product" method="unparse">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_mapper_column" method="map">\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_parser_csv" method="unparse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_adapter_io" method="save">\\r\\n    <var name="type">file</var>\\r\\n    <var name="path">var/export</var>\\r\\n    <var name="filename"><![CDATA[export_all_products.csv]]></var>\\r\\n</action>\\r\\n\\r\\n', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:25:"export_product_stocks.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:4:"true";s:7:"product";a:2:{s:2:"db";a:4:{i:1;s:5:"store";i:2;s:3:"sku";i:3;s:3:"qty";i:4;s:11:"is_in_stock";}s:4:"file";a:4:{i:1;s:5:"store";i:2;s:3:"sku";i:3;s:3:"qty";i:4;s:11:"is_in_stock";}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'export', 'product', 0, 'file'),
(3, 'Import All Products', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="dataflow/convert_parser_csv" method="parse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n    <var name="adapter">catalog/convert_adapter_product</var>\\r\\n    <var name="method">parse</var>\\r\\n</action>', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:23:"export_all_products.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:0:"";s:7:"product";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'import', 'product', 0, 'interactive'),
(4, 'Import Product Stocks', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="dataflow/convert_parser_csv" method="parse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n    <var name="adapter">catalog/convert_adapter_product</var>\\r\\n    <var name="method">parse</var>\\r\\n</action>', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:18:"export_product.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:0:"";s:7:"product";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'import', 'product', 0, 'interactive'),
(5, 'Export Customers', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="customer/convert_adapter_customer" method="load">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n    <var name="filter/adressType"><![CDATA[default_billing]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="customer/convert_parser_customer" method="unparse">\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_mapper_column" method="map">\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_parser_csv" method="unparse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n</action>\\r\\n\\r\\n<action type="dataflow/convert_adapter_io" method="save">\\r\\n    <var name="type">file</var>\\r\\n    <var name="path">var/export</var>\\r\\n    <var name="filename"><![CDATA[export_customers.csv]]></var>\\r\\n</action>\\r\\n\\r\\n', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:20:"export_customers.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:0:"";s:7:"product";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'export', 'customer', 0, 'file'),
(6, 'Import Customers', '2014-12-03 00:00:13', '2014-12-03 00:00:13', '<action type="dataflow/convert_parser_csv" method="parse">\\r\\n    <var name="delimiter"><![CDATA[,]]></var>\\r\\n    <var name="enclose"><![CDATA["]]></var>\\r\\n    <var name="fieldnames">true</var>\\r\\n    <var name="store"><![CDATA[0]]></var>\\r\\n    <var name="adapter">customer/convert_adapter_customer</var>\\r\\n    <var name="method">parse</var>\\r\\n</action>', 'a:5:{s:4:"file";a:7:{s:4:"type";s:4:"file";s:8:"filename";s:19:"export_customer.csv";s:4:"path";s:10:"var/export";s:4:"host";s:0:"";s:4:"user";s:0:"";s:8:"password";s:0:"";s:7:"passive";s:0:"";}s:5:"parse";a:5:{s:4:"type";s:3:"csv";s:12:"single_sheet";s:0:"";s:9:"delimiter";s:1:",";s:7:"enclose";s:1:""";s:10:"fieldnames";s:4:"true";}s:3:"map";a:3:{s:14:"only_specified";s:0:"";s:7:"product";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}s:8:"customer";a:2:{s:2:"db";a:0:{}s:4:"file";a:0:{}}}s:7:"product";a:1:{s:6:"filter";a:8:{s:4:"name";s:0:"";s:3:"sku";s:0:"";s:4:"type";s:1:"0";s:13:"attribute_set";s:0:"";s:5:"price";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:3:"qty";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}s:10:"visibility";s:1:"0";s:6:"status";s:1:"0";}}s:8:"customer";a:1:{s:6:"filter";a:10:{s:9:"firstname";s:0:"";s:8:"lastname";s:0:"";s:5:"email";s:0:"";s:5:"group";s:1:"0";s:10:"adressType";s:15:"default_billing";s:9:"telephone";s:0:"";s:8:"postcode";s:0:"";s:7:"country";s:0:"";s:6:"region";s:0:"";s:10:"created_at";a:2:{s:4:"from";s:0:"";s:2:"to";s:0:"";}}}}', 'import', 'customer', 0, 'interactive');

CREATE TABLE IF NOT EXISTS `#__dataflow_profile_history` (
`history_id` int(10) unsigned NOT NULL COMMENT 'History Id',
  `profile_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Profile Id',
  `action_code` varchar(64) DEFAULT NULL COMMENT 'Action Code',
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'User Id',
  `performed_at` timestamp NULL DEFAULT NULL COMMENT 'Performed At'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Dataflow Profile History' AUTO_INCREMENT=7 ;

INSERT INTO `#__dataflow_profile_history` (`history_id`, `profile_id`, `action_code`, `user_id`, `performed_at`) VALUES
(1, 1, 'create', 0, '2014-12-03 00:00:13'),
(2, 2, 'create', 0, '2014-12-03 00:00:13'),
(3, 3, 'create', 0, '2014-12-03 00:00:13'),
(4, 4, 'create', 0, '2014-12-03 00:00:13'),
(5, 5, 'create', 0, '2014-12-03 00:00:13'),
(6, 6, 'create', 0, '2014-12-03 00:00:13');

CREATE TABLE IF NOT EXISTS `#__dataflow_session` (
`session_id` int(11) NOT NULL COMMENT 'Session Id',
  `user_id` int(11) NOT NULL COMMENT 'User Id',
  `created_date` timestamp NULL DEFAULT NULL COMMENT 'Created Date',
  `file` varchar(255) DEFAULT NULL COMMENT 'File',
  `type` varchar(32) DEFAULT NULL COMMENT 'Type',
  `direction` varchar(32) DEFAULT NULL COMMENT 'Direction',
  `comment` varchar(255) DEFAULT NULL COMMENT 'Comment'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Dataflow Session' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__design_change` (
`design_change_id` int(11) NOT NULL COMMENT 'Design Change Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `design` varchar(255) DEFAULT NULL COMMENT 'Design',
  `date_from` date DEFAULT NULL COMMENT 'First Date of Design Activity',
  `date_to` date DEFAULT NULL COMMENT 'Last Date of Design Activity'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Design Changes' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__directory_country` (
  `country_id` varchar(2) NOT NULL DEFAULT '' COMMENT 'Country Id in ISO-2',
  `iso2_code` varchar(2) DEFAULT NULL COMMENT 'Country ISO-2 format',
  `iso3_code` varchar(3) DEFAULT NULL COMMENT 'Country ISO-3'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Directory Country';

INSERT INTO `#__directory_country` (`country_id`, `iso2_code`, `iso3_code`) VALUES
('AD', 'AD', 'AND'),
('AE', 'AE', 'ARE'),
('AF', 'AF', 'AFG'),
('AG', 'AG', 'ATG'),
('AI', 'AI', 'AIA'),
('AL', 'AL', 'ALB'),
('AM', 'AM', 'ARM'),
('AN', 'AN', 'ANT'),
('AO', 'AO', 'AGO'),
('AQ', 'AQ', 'ATA'),
('AR', 'AR', 'ARG'),
('AS', 'AS', 'ASM'),
('AT', 'AT', 'AUT'),
('AU', 'AU', 'AUS'),
('AW', 'AW', 'ABW'),
('AX', 'AX', 'ALA'),
('AZ', 'AZ', 'AZE'),
('BA', 'BA', 'BIH'),
('BB', 'BB', 'BRB'),
('BD', 'BD', 'BGD'),
('BE', 'BE', 'BEL'),
('BF', 'BF', 'BFA'),
('BG', 'BG', 'BGR'),
('BH', 'BH', 'BHR'),
('BI', 'BI', 'BDI'),
('BJ', 'BJ', 'BEN'),
('BL', 'BL', 'BLM'),
('BM', 'BM', 'BMU'),
('BN', 'BN', 'BRN'),
('BO', 'BO', 'BOL'),
('BR', 'BR', 'BRA'),
('BS', 'BS', 'BHS'),
('BT', 'BT', 'BTN'),
('BV', 'BV', 'BVT'),
('BW', 'BW', 'BWA'),
('BY', 'BY', 'BLR'),
('BZ', 'BZ', 'BLZ'),
('CA', 'CA', 'CAN'),
('CC', 'CC', 'CCK'),
('CD', 'CD', 'COD'),
('CF', 'CF', 'CAF'),
('CG', 'CG', 'COG'),
('CH', 'CH', 'CHE'),
('CI', 'CI', 'CIV'),
('CK', 'CK', 'COK'),
('CL', 'CL', 'CHL'),
('CM', 'CM', 'CMR'),
('CN', 'CN', 'CHN'),
('CO', 'CO', 'COL'),
('CR', 'CR', 'CRI'),
('CU', 'CU', 'CUB'),
('CV', 'CV', 'CPV'),
('CX', 'CX', 'CXR'),
('CY', 'CY', 'CYP'),
('CZ', 'CZ', 'CZE'),
('DE', 'DE', 'DEU'),
('DJ', 'DJ', 'DJI'),
('DK', 'DK', 'DNK'),
('DM', 'DM', 'DMA'),
('DO', 'DO', 'DOM'),
('DZ', 'DZ', 'DZA'),
('EC', 'EC', 'ECU'),
('EE', 'EE', 'EST'),
('EG', 'EG', 'EGY'),
('EH', 'EH', 'ESH'),
('ER', 'ER', 'ERI'),
('ES', 'ES', 'ESP'),
('ET', 'ET', 'ETH'),
('FI', 'FI', 'FIN'),
('FJ', 'FJ', 'FJI'),
('FK', 'FK', 'FLK'),
('FM', 'FM', 'FSM'),
('FO', 'FO', 'FRO'),
('FR', 'FR', 'FRA'),
('GA', 'GA', 'GAB'),
('GB', 'GB', 'GBR'),
('GD', 'GD', 'GRD'),
('GE', 'GE', 'GEO'),
('GF', 'GF', 'GUF'),
('GG', 'GG', 'GGY'),
('GH', 'GH', 'GHA'),
('GI', 'GI', 'GIB'),
('GL', 'GL', 'GRL'),
('GM', 'GM', 'GMB'),
('GN', 'GN', 'GIN'),
('GP', 'GP', 'GLP'),
('GQ', 'GQ', 'GNQ'),
('GR', 'GR', 'GRC'),
('GS', 'GS', 'SGS'),
('GT', 'GT', 'GTM'),
('GU', 'GU', 'GUM'),
('GW', 'GW', 'GNB'),
('GY', 'GY', 'GUY'),
('HK', 'HK', 'HKG'),
('HM', 'HM', 'HMD'),
('HN', 'HN', 'HND'),
('HR', 'HR', 'HRV'),
('HT', 'HT', 'HTI'),
('HU', 'HU', 'HUN'),
('ID', 'ID', 'IDN'),
('IE', 'IE', 'IRL'),
('IL', 'IL', 'ISR'),
('IM', 'IM', 'IMN'),
('IN', 'IN', 'IND'),
('IO', 'IO', 'IOT'),
('IQ', 'IQ', 'IRQ'),
('IR', 'IR', 'IRN'),
('IS', 'IS', 'ISL'),
('IT', 'IT', 'ITA'),
('JE', 'JE', 'JEY'),
('JM', 'JM', 'JAM'),
('JO', 'JO', 'JOR'),
('JP', 'JP', 'JPN'),
('KE', 'KE', 'KEN'),
('KG', 'KG', 'KGZ'),
('KH', 'KH', 'KHM'),
('KI', 'KI', 'KIR'),
('KM', 'KM', 'COM'),
('KN', 'KN', 'KNA'),
('KP', 'KP', 'PRK'),
('KR', 'KR', 'KOR'),
('KW', 'KW', 'KWT'),
('KY', 'KY', 'CYM'),
('KZ', 'KZ', 'KAZ'),
('LA', 'LA', 'LAO'),
('LB', 'LB', 'LBN'),
('LC', 'LC', 'LCA'),
('LI', 'LI', 'LIE'),
('LK', 'LK', 'LKA'),
('LR', 'LR', 'LBR'),
('LS', 'LS', 'LSO'),
('LT', 'LT', 'LTU'),
('LU', 'LU', 'LUX'),
('LV', 'LV', 'LVA'),
('LY', 'LY', 'LBY'),
('MA', 'MA', 'MAR'),
('MC', 'MC', 'MCO'),
('MD', 'MD', 'MDA'),
('ME', 'ME', 'MNE'),
('MF', 'MF', 'MAF'),
('MG', 'MG', 'MDG'),
('MH', 'MH', 'MHL'),
('MK', 'MK', 'MKD'),
('ML', 'ML', 'MLI'),
('MM', 'MM', 'MMR'),
('MN', 'MN', 'MNG'),
('MO', 'MO', 'MAC'),
('MP', 'MP', 'MNP'),
('MQ', 'MQ', 'MTQ'),
('MR', 'MR', 'MRT'),
('MS', 'MS', 'MSR'),
('MT', 'MT', 'MLT'),
('MU', 'MU', 'MUS'),
('MV', 'MV', 'MDV'),
('MW', 'MW', 'MWI'),
('MX', 'MX', 'MEX'),
('MY', 'MY', 'MYS'),
('MZ', 'MZ', 'MOZ'),
('NA', 'NA', 'NAM'),
('NC', 'NC', 'NCL'),
('NE', 'NE', 'NER'),
('NF', 'NF', 'NFK'),
('NG', 'NG', 'NGA'),
('NI', 'NI', 'NIC'),
('NL', 'NL', 'NLD'),
('NO', 'NO', 'NOR'),
('NP', 'NP', 'NPL'),
('NR', 'NR', 'NRU'),
('NU', 'NU', 'NIU'),
('NZ', 'NZ', 'NZL'),
('OM', 'OM', 'OMN'),
('PA', 'PA', 'PAN'),
('PE', 'PE', 'PER'),
('PF', 'PF', 'PYF'),
('PG', 'PG', 'PNG'),
('PH', 'PH', 'PHL'),
('PK', 'PK', 'PAK'),
('PL', 'PL', 'POL'),
('PM', 'PM', 'SPM'),
('PN', 'PN', 'PCN'),
('PR', 'PR', 'PRI'),
('PS', 'PS', 'PSE'),
('PT', 'PT', 'PRT'),
('PW', 'PW', 'PLW'),
('PY', 'PY', 'PRY'),
('QA', 'QA', 'QAT'),
('RE', 'RE', 'REU'),
('RO', 'RO', 'ROU'),
('RS', 'RS', 'SRB'),
('RU', 'RU', 'RUS'),
('RW', 'RW', 'RWA'),
('SA', 'SA', 'SAU'),
('SB', 'SB', 'SLB'),
('SC', 'SC', 'SYC'),
('SD', 'SD', 'SDN'),
('SE', 'SE', 'SWE'),
('SG', 'SG', 'SGP'),
('SH', 'SH', 'SHN'),
('SI', 'SI', 'SVN'),
('SJ', 'SJ', 'SJM'),
('SK', 'SK', 'SVK'),
('SL', 'SL', 'SLE'),
('SM', 'SM', 'SMR'),
('SN', 'SN', 'SEN'),
('SO', 'SO', 'SOM'),
('SR', 'SR', 'SUR'),
('ST', 'ST', 'STP'),
('SV', 'SV', 'SLV'),
('SY', 'SY', 'SYR'),
('SZ', 'SZ', 'SWZ'),
('TC', 'TC', 'TCA'),
('TD', 'TD', 'TCD'),
('TF', 'TF', 'ATF'),
('TG', 'TG', 'TGO'),
('TH', 'TH', 'THA'),
('TJ', 'TJ', 'TJK'),
('TK', 'TK', 'TKL'),
('TL', 'TL', 'TLS'),
('TM', 'TM', 'TKM'),
('TN', 'TN', 'TUN'),
('TO', 'TO', 'TON'),
('TR', 'TR', 'TUR'),
('TT', 'TT', 'TTO'),
('TV', 'TV', 'TUV'),
('TW', 'TW', 'TWN'),
('TZ', 'TZ', 'TZA'),
('UA', 'UA', 'UKR'),
('UG', 'UG', 'UGA'),
('UM', 'UM', 'UMI'),
('US', 'US', 'USA'),
('UY', 'UY', 'URY'),
('UZ', 'UZ', 'UZB'),
('VA', 'VA', 'VAT'),
('VC', 'VC', 'VCT'),
('VE', 'VE', 'VEN'),
('VG', 'VG', 'VGB'),
('VI', 'VI', 'VIR'),
('VN', 'VN', 'VNM'),
('VU', 'VU', 'VUT'),
('WF', 'WF', 'WLF'),
('WS', 'WS', 'WSM'),
('YE', 'YE', 'YEM'),
('YT', 'YT', 'MYT'),
('ZA', 'ZA', 'ZAF'),
('ZM', 'ZM', 'ZMB'),
('ZW', 'ZW', 'ZWE');

CREATE TABLE IF NOT EXISTS `#__directory_country_format` (
`country_format_id` int(10) unsigned NOT NULL COMMENT 'Country Format Id',
  `country_id` varchar(2) DEFAULT NULL COMMENT 'Country Id in ISO-2',
  `type` varchar(30) DEFAULT NULL COMMENT 'Country Format Type',
  `format` text NOT NULL COMMENT 'Country Format'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Directory Country Format' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__directory_country_region` (
`region_id` int(10) unsigned NOT NULL COMMENT 'Region Id',
  `country_id` varchar(4) NOT NULL DEFAULT '0' COMMENT 'Country Id in ISO-2',
  `code` varchar(32) DEFAULT NULL COMMENT 'Region code',
  `default_name` varchar(255) DEFAULT NULL COMMENT 'Region Name'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Directory Country Region' AUTO_INCREMENT=485 ;

INSERT INTO `#__directory_country_region` (`region_id`, `country_id`, `code`, `default_name`) VALUES
(1, 'US', 'AL', 'Alabama'),
(2, 'US', 'AK', 'Alaska'),
(3, 'US', 'AS', 'American Samoa'),
(4, 'US', 'AZ', 'Arizona'),
(5, 'US', 'AR', 'Arkansas'),
(6, 'US', 'AF', 'Armed Forces Africa'),
(7, 'US', 'AA', 'Armed Forces Americas'),
(8, 'US', 'AC', 'Armed Forces Canada'),
(9, 'US', 'AE', 'Armed Forces Europe'),
(10, 'US', 'AM', 'Armed Forces Middle East'),
(11, 'US', 'AP', 'Armed Forces Pacific'),
(12, 'US', 'CA', 'California'),
(13, 'US', 'CO', 'Colorado'),
(14, 'US', 'CT', 'Connecticut'),
(15, 'US', 'DE', 'Delaware'),
(16, 'US', 'DC', 'District of Columbia'),
(17, 'US', 'FM', 'Federated States Of Micronesia'),
(18, 'US', 'FL', 'Florida'),
(19, 'US', 'GA', 'Georgia'),
(20, 'US', 'GU', 'Guam'),
(21, 'US', 'HI', 'Hawaii'),
(22, 'US', 'ID', 'Idaho'),
(23, 'US', 'IL', 'Illinois'),
(24, 'US', 'IN', 'Indiana'),
(25, 'US', 'IA', 'Iowa'),
(26, 'US', 'KS', 'Kansas'),
(27, 'US', 'KY', 'Kentucky'),
(28, 'US', 'LA', 'Louisiana'),
(29, 'US', 'ME', 'Maine'),
(30, 'US', 'MH', 'Marshall Islands'),
(31, 'US', 'MD', 'Maryland'),
(32, 'US', 'MA', 'Massachusetts'),
(33, 'US', 'MI', 'Michigan'),
(34, 'US', 'MN', 'Minnesota'),
(35, 'US', 'MS', 'Mississippi'),
(36, 'US', 'MO', 'Missouri'),
(37, 'US', 'MT', 'Montana'),
(38, 'US', 'NE', 'Nebraska'),
(39, 'US', 'NV', 'Nevada'),
(40, 'US', 'NH', 'New Hampshire'),
(41, 'US', 'NJ', 'New Jersey'),
(42, 'US', 'NM', 'New Mexico'),
(43, 'US', 'NY', 'New York'),
(44, 'US', 'NC', 'North Carolina'),
(45, 'US', 'ND', 'North Dakota'),
(46, 'US', 'MP', 'Northern Mariana Islands'),
(47, 'US', 'OH', 'Ohio'),
(48, 'US', 'OK', 'Oklahoma'),
(49, 'US', 'OR', 'Oregon'),
(50, 'US', 'PW', 'Palau'),
(51, 'US', 'PA', 'Pennsylvania'),
(52, 'US', 'PR', 'Puerto Rico'),
(53, 'US', 'RI', 'Rhode Island'),
(54, 'US', 'SC', 'South Carolina'),
(55, 'US', 'SD', 'South Dakota'),
(56, 'US', 'TN', 'Tennessee'),
(57, 'US', 'TX', 'Texas'),
(58, 'US', 'UT', 'Utah'),
(59, 'US', 'VT', 'Vermont'),
(60, 'US', 'VI', 'Virgin Islands'),
(61, 'US', 'VA', 'Virginia'),
(62, 'US', 'WA', 'Washington'),
(63, 'US', 'WV', 'West Virginia'),
(64, 'US', 'WI', 'Wisconsin'),
(65, 'US', 'WY', 'Wyoming'),
(66, 'CA', 'AB', 'Alberta'),
(67, 'CA', 'BC', 'British Columbia'),
(68, 'CA', 'MB', 'Manitoba'),
(69, 'CA', 'NL', 'Newfoundland and Labrador'),
(70, 'CA', 'NB', 'New Brunswick'),
(71, 'CA', 'NS', 'Nova Scotia'),
(72, 'CA', 'NT', 'Northwest Territories'),
(73, 'CA', 'NU', 'Nunavut'),
(74, 'CA', 'ON', 'Ontario'),
(75, 'CA', 'PE', 'Prince Edward Island'),
(76, 'CA', 'QC', 'Quebec'),
(77, 'CA', 'SK', 'Saskatchewan'),
(78, 'CA', 'YT', 'Yukon Territory'),
(79, 'DE', 'NDS', 'Niedersachsen'),
(80, 'DE', 'BAW', 'Baden-WÃƒÂ¼rttemberg'),
(81, 'DE', 'BAY', 'Bayern'),
(82, 'DE', 'BER', 'Berlin'),
(83, 'DE', 'BRG', 'Brandenburg'),
(84, 'DE', 'BRE', 'Bremen'),
(85, 'DE', 'HAM', 'Hamburg'),
(86, 'DE', 'HES', 'Hessen'),
(87, 'DE', 'MEC', 'Mecklenburg-Vorpommern'),
(88, 'DE', 'NRW', 'Nordrhein-Westfalen'),
(89, 'DE', 'RHE', 'Rheinland-Pfalz'),
(90, 'DE', 'SAR', 'Saarland'),
(91, 'DE', 'SAS', 'Sachsen'),
(92, 'DE', 'SAC', 'Sachsen-Anhalt'),
(93, 'DE', 'SCN', 'Schleswig-Holstein'),
(94, 'DE', 'THE', 'ThÃƒÂ¼ringen'),
(95, 'AT', 'WI', 'Wien'),
(96, 'AT', 'NO', 'NiederÃƒÂ¶sterreich'),
(97, 'AT', 'OO', 'OberÃƒÂ¶sterreich'),
(98, 'AT', 'SB', 'Salzburg'),
(99, 'AT', 'KN', 'KÃƒÂ¤rnten'),
(100, 'AT', 'ST', 'Steiermark'),
(101, 'AT', 'TI', 'Tirol'),
(102, 'AT', 'BL', 'Burgenland'),
(103, 'AT', 'VB', 'Vorarlberg'),
(104, 'CH', 'AG', 'Aargau'),
(105, 'CH', 'AI', 'Appenzell Innerrhoden'),
(106, 'CH', 'AR', 'Appenzell Ausserrhoden'),
(107, 'CH', 'BE', 'Bern'),
(108, 'CH', 'BL', 'Basel-Landschaft'),
(109, 'CH', 'BS', 'Basel-Stadt'),
(110, 'CH', 'FR', 'Freiburg'),
(111, 'CH', 'GE', 'Genf'),
(112, 'CH', 'GL', 'Glarus'),
(113, 'CH', 'GR', 'GraubÃƒÂ¼nden'),
(114, 'CH', 'JU', 'Jura'),
(115, 'CH', 'LU', 'Luzern'),
(116, 'CH', 'NE', 'Neuenburg'),
(117, 'CH', 'NW', 'Nidwalden'),
(118, 'CH', 'OW', 'Obwalden'),
(119, 'CH', 'SG', 'St. Gallen'),
(120, 'CH', 'SH', 'Schaffhausen'),
(121, 'CH', 'SO', 'Solothurn'),
(122, 'CH', 'SZ', 'Schwyz'),
(123, 'CH', 'TG', 'Thurgau'),
(124, 'CH', 'TI', 'Tessin'),
(125, 'CH', 'UR', 'Uri'),
(126, 'CH', 'VD', 'Waadt'),
(127, 'CH', 'VS', 'Wallis'),
(128, 'CH', 'ZG', 'Zug'),
(129, 'CH', 'ZH', 'ZÃƒÂ¼rich'),
(130, 'ES', 'A CoruÃ‘Âa', 'A CoruÃƒÂ±a'),
(131, 'ES', 'Alava', 'Alava'),
(132, 'ES', 'Albacete', 'Albacete'),
(133, 'ES', 'Alicante', 'Alicante'),
(134, 'ES', 'Almeria', 'Almeria'),
(135, 'ES', 'Asturias', 'Asturias'),
(136, 'ES', 'Avila', 'Avila'),
(137, 'ES', 'Badajoz', 'Badajoz'),
(138, 'ES', 'Baleares', 'Baleares'),
(139, 'ES', 'Barcelona', 'Barcelona'),
(140, 'ES', 'Burgos', 'Burgos'),
(141, 'ES', 'Caceres', 'Caceres'),
(142, 'ES', 'Cadiz', 'Cadiz'),
(143, 'ES', 'Cantabria', 'Cantabria'),
(144, 'ES', 'Castellon', 'Castellon'),
(145, 'ES', 'Ceuta', 'Ceuta'),
(146, 'ES', 'Ciudad Real', 'Ciudad Real'),
(147, 'ES', 'Cordoba', 'Cordoba'),
(148, 'ES', 'Cuenca', 'Cuenca'),
(149, 'ES', 'Girona', 'Girona'),
(150, 'ES', 'Granada', 'Granada'),
(151, 'ES', 'Guadalajara', 'Guadalajara'),
(152, 'ES', 'Guipuzcoa', 'Guipuzcoa'),
(153, 'ES', 'Huelva', 'Huelva'),
(154, 'ES', 'Huesca', 'Huesca'),
(155, 'ES', 'Jaen', 'Jaen'),
(156, 'ES', 'La Rioja', 'La Rioja'),
(157, 'ES', 'Las Palmas', 'Las Palmas'),
(158, 'ES', 'Leon', 'Leon'),
(159, 'ES', 'Lleida', 'Lleida'),
(160, 'ES', 'Lugo', 'Lugo'),
(161, 'ES', 'Madrid', 'Madrid'),
(162, 'ES', 'Malaga', 'Malaga'),
(163, 'ES', 'Melilla', 'Melilla'),
(164, 'ES', 'Murcia', 'Murcia'),
(165, 'ES', 'Navarra', 'Navarra'),
(166, 'ES', 'Ourense', 'Ourense'),
(167, 'ES', 'Palencia', 'Palencia'),
(168, 'ES', 'Pontevedra', 'Pontevedra'),
(169, 'ES', 'Salamanca', 'Salamanca'),
(170, 'ES', 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife'),
(171, 'ES', 'Segovia', 'Segovia'),
(172, 'ES', 'Sevilla', 'Sevilla'),
(173, 'ES', 'Soria', 'Soria'),
(174, 'ES', 'Tarragona', 'Tarragona'),
(175, 'ES', 'Teruel', 'Teruel'),
(176, 'ES', 'Toledo', 'Toledo'),
(177, 'ES', 'Valencia', 'Valencia'),
(178, 'ES', 'Valladolid', 'Valladolid'),
(179, 'ES', 'Vizcaya', 'Vizcaya'),
(180, 'ES', 'Zamora', 'Zamora'),
(181, 'ES', 'Zaragoza', 'Zaragoza'),
(182, 'FR', '1', 'Ain'),
(183, 'FR', '2', 'Aisne'),
(184, 'FR', '3', 'Allier'),
(185, 'FR', '4', 'Alpes-de-Haute-Provence'),
(186, 'FR', '5', 'Hautes-Alpes'),
(187, 'FR', '6', 'Alpes-Maritimes'),
(188, 'FR', '7', 'ArdÃƒÂ¨che'),
(189, 'FR', '8', 'Ardennes'),
(190, 'FR', '9', 'AriÃƒÂ¨ge'),
(191, 'FR', '10', 'Aube'),
(192, 'FR', '11', 'Aude'),
(193, 'FR', '12', 'Aveyron'),
(194, 'FR', '13', 'Bouches-du-RhÃƒÂ´ne'),
(195, 'FR', '14', 'Calvados'),
(196, 'FR', '15', 'Cantal'),
(197, 'FR', '16', 'Charente'),
(198, 'FR', '17', 'Charente-Maritime'),
(199, 'FR', '18', 'Cher'),
(200, 'FR', '19', 'CorrÃƒÂ¨ze'),
(201, 'FR', '2A', 'Corse-du-Sud'),
(202, 'FR', '2B', 'Haute-Corse'),
(203, 'FR', '21', 'CÃƒÂ´te-d''Or'),
(204, 'FR', '22', 'CÃƒÂ´tes-d''Armor'),
(205, 'FR', '23', 'Creuse'),
(206, 'FR', '24', 'Dordogne'),
(207, 'FR', '25', 'Doubs'),
(208, 'FR', '26', 'DrÃƒÂ´me'),
(209, 'FR', '27', 'Eure'),
(210, 'FR', '28', 'Eure-et-Loir'),
(211, 'FR', '29', 'FinistÃƒÂ¨re'),
(212, 'FR', '30', 'Gard'),
(213, 'FR', '31', 'Haute-Garonne'),
(214, 'FR', '32', 'Gers'),
(215, 'FR', '33', 'Gironde'),
(216, 'FR', '34', 'HÃƒÂ©rault'),
(217, 'FR', '35', 'Ille-et-Vilaine'),
(218, 'FR', '36', 'Indre'),
(219, 'FR', '37', 'Indre-et-Loire'),
(220, 'FR', '38', 'IsÃƒÂ¨re'),
(221, 'FR', '39', 'Jura'),
(222, 'FR', '40', 'Landes'),
(223, 'FR', '41', 'Loir-et-Cher'),
(224, 'FR', '42', 'Loire'),
(225, 'FR', '43', 'Haute-Loire'),
(226, 'FR', '44', 'Loire-Atlantique'),
(227, 'FR', '45', 'Loiret'),
(228, 'FR', '46', 'Lot'),
(229, 'FR', '47', 'Lot-et-Garonne'),
(230, 'FR', '48', 'LozÃƒÂ¨re'),
(231, 'FR', '49', 'Maine-et-Loire'),
(232, 'FR', '50', 'Manche'),
(233, 'FR', '51', 'Marne'),
(234, 'FR', '52', 'Haute-Marne'),
(235, 'FR', '53', 'Mayenne'),
(236, 'FR', '54', 'Meurthe-et-Moselle'),
(237, 'FR', '55', 'Meuse'),
(238, 'FR', '56', 'Morbihan'),
(239, 'FR', '57', 'Moselle'),
(240, 'FR', '58', 'NiÃƒÂ¨vre'),
(241, 'FR', '59', 'Nord'),
(242, 'FR', '60', 'Oise'),
(243, 'FR', '61', 'Orne'),
(244, 'FR', '62', 'Pas-de-Calais'),
(245, 'FR', '63', 'Puy-de-DÃƒÂ´me'),
(246, 'FR', '64', 'PyrÃƒÂ©nÃƒÂ©es-Atlantiques'),
(247, 'FR', '65', 'Hautes-PyrÃƒÂ©nÃƒÂ©es'),
(248, 'FR', '66', 'PyrÃƒÂ©nÃƒÂ©es-Orientales'),
(249, 'FR', '67', 'Bas-Rhin'),
(250, 'FR', '68', 'Haut-Rhin'),
(251, 'FR', '69', 'RhÃƒÂ´ne'),
(252, 'FR', '70', 'Haute-SaÃƒÂ´ne'),
(253, 'FR', '71', 'SaÃƒÂ´ne-et-Loire'),
(254, 'FR', '72', 'Sarthe'),
(255, 'FR', '73', 'Savoie'),
(256, 'FR', '74', 'Haute-Savoie'),
(257, 'FR', '75', 'Amoda'),
(258, 'FR', '76', 'Seine-Maritime'),
(259, 'FR', '77', 'Seine-et-Marne'),
(260, 'FR', '78', 'Yvelines'),
(261, 'FR', '79', 'Deux-SÃƒÂ¨vres'),
(262, 'FR', '80', 'Somme'),
(263, 'FR', '81', 'Tarn'),
(264, 'FR', '82', 'Tarn-et-Garonne'),
(265, 'FR', '83', 'Var'),
(266, 'FR', '84', 'Vaucluse'),
(267, 'FR', '85', 'VendÃƒÂ©e'),
(268, 'FR', '86', 'Vienne'),
(269, 'FR', '87', 'Haute-Vienne'),
(270, 'FR', '88', 'Vosges'),
(271, 'FR', '89', 'Yonne'),
(272, 'FR', '90', 'Territoire-de-Belfort'),
(273, 'FR', '91', 'Essonne'),
(274, 'FR', '92', 'Hauts-de-Seine'),
(275, 'FR', '93', 'Seine-Saint-Denis'),
(276, 'FR', '94', 'Val-de-Marne'),
(277, 'FR', '95', 'Val-d''Oise'),
(278, 'RO', 'AB', 'Alba'),
(279, 'RO', 'AR', 'Arad'),
(280, 'RO', 'AG', 'ArgeÃ…Å¸'),
(281, 'RO', 'BC', 'BacÃ„Æ’u'),
(282, 'RO', 'BH', 'Bihor'),
(283, 'RO', 'BN', 'BistriÃ…Â£a-NÃ„Æ’sÃ„Æ’ud'),
(284, 'RO', 'BT', 'BotoÃ…Å¸ani'),
(285, 'RO', 'BV', 'BraÃ…Å¸ov'),
(286, 'RO', 'BR', 'BrÃ„Æ’ila'),
(287, 'RO', 'B', 'BucureÃ…Å¸ti'),
(288, 'RO', 'BZ', 'BuzÃ„Æ’u'),
(289, 'RO', 'CS', 'CaraÃ…Å¸-Severin'),
(290, 'RO', 'CL', 'CÃ„Æ’lÃ„Æ’raÃ…Å¸i'),
(291, 'RO', 'CJ', 'Cluj'),
(292, 'RO', 'CT', 'ConstanÃ…Â£a'),
(293, 'RO', 'CV', 'Covasna'),
(294, 'RO', 'DB', 'DÃƒÂ¢mboviÃ…Â£a'),
(295, 'RO', 'DJ', 'Dolj'),
(296, 'RO', 'GL', 'GalaÃ…Â£i'),
(297, 'RO', 'GR', 'Giurgiu'),
(298, 'RO', 'GJ', 'Gorj'),
(299, 'RO', 'HR', 'Harghita'),
(300, 'RO', 'HD', 'Hunedoara'),
(301, 'RO', 'IL', 'IalomiÃ…Â£a'),
(302, 'RO', 'IS', 'IaÃ…Å¸i'),
(303, 'RO', 'IF', 'Ilfov'),
(304, 'RO', 'MM', 'MaramureÃ…Å¸'),
(305, 'RO', 'MH', 'MehedinÃ…Â£i'),
(306, 'RO', 'MS', 'MureÃ…Å¸'),
(307, 'RO', 'NT', 'NeamÃ…Â£'),
(308, 'RO', 'OT', 'Olt'),
(309, 'RO', 'PH', 'Prahova'),
(310, 'RO', 'SM', 'Satu-Mare'),
(311, 'RO', 'SJ', 'SÃ„Æ’laj'),
(312, 'RO', 'SB', 'Sibiu'),
(313, 'RO', 'SV', 'Suceava'),
(314, 'RO', 'TR', 'Teleorman'),
(315, 'RO', 'TM', 'TimiÃ…Å¸'),
(316, 'RO', 'TL', 'Tulcea'),
(317, 'RO', 'VS', 'Vaslui'),
(318, 'RO', 'VL', 'VÃƒÂ¢lcea'),
(319, 'RO', 'VN', 'Vrancea'),
(320, 'FI', 'Lappi', 'Lappi'),
(321, 'FI', 'Pohjois-Pohjanmaa', 'Pohjois-Pohjanmaa'),
(322, 'FI', 'Kainuu', 'Kainuu'),
(323, 'FI', 'Pohjois-Karjala', 'Pohjois-Karjala'),
(324, 'FI', 'Pohjois-Savo', 'Pohjois-Savo'),
(325, 'FI', 'EtelÃƒÂ¤-Savo', 'EtelÃƒÂ¤-Savo'),
(326, 'FI', 'EtelÃƒÂ¤-Pohjanmaa', 'EtelÃƒÂ¤-Pohjanmaa'),
(327, 'FI', 'Pohjanmaa', 'Pohjanmaa'),
(328, 'FI', 'Pirkanmaa', 'Pirkanmaa'),
(329, 'FI', 'Satakunta', 'Satakunta'),
(330, 'FI', 'Keski-Pohjanmaa', 'Keski-Pohjanmaa'),
(331, 'FI', 'Keski-Suomi', 'Keski-Suomi'),
(332, 'FI', 'Varsinais-Suomi', 'Varsinais-Suomi'),
(333, 'FI', 'EtelÃƒÂ¤-Karjala', 'EtelÃƒÂ¤-Karjala'),
(334, 'FI', 'PÃƒÂ¤ijÃƒÂ¤t-HÃƒÂ¤me', 'PÃƒÂ¤ijÃƒÂ¤t-HÃƒÂ¤me'),
(335, 'FI', 'Kanta-HÃƒÂ¤me', 'Kanta-HÃƒÂ¤me'),
(336, 'FI', 'Uusimaa', 'Uusimaa'),
(337, 'FI', 'ItÃƒÂ¤-Uusimaa', 'ItÃƒÂ¤-Uusimaa'),
(338, 'FI', 'Kymenlaakso', 'Kymenlaakso'),
(339, 'FI', 'Ahvenanmaa', 'Ahvenanmaa'),
(340, 'EE', 'EE-37', 'Harjumaa'),
(341, 'EE', 'EE-39', 'Hiiumaa'),
(342, 'EE', 'EE-44', 'Ida-Virumaa'),
(343, 'EE', 'EE-49', 'JÃƒÂµgevamaa'),
(344, 'EE', 'EE-51', 'JÃƒÂ¤rvamaa'),
(345, 'EE', 'EE-57', 'LÃƒÂ¤ÃƒÂ¤nemaa'),
(346, 'EE', 'EE-59', 'LÃƒÂ¤ÃƒÂ¤ne-Virumaa'),
(347, 'EE', 'EE-65', 'PÃƒÂµlvamaa'),
(348, 'EE', 'EE-67', 'PÃƒÂ¤rnumaa'),
(349, 'EE', 'EE-70', 'Raplamaa'),
(350, 'EE', 'EE-74', 'Saaremaa'),
(351, 'EE', 'EE-78', 'Tartumaa'),
(352, 'EE', 'EE-82', 'Valgamaa'),
(353, 'EE', 'EE-84', 'Viljandimaa'),
(354, 'EE', 'EE-86', 'VÃƒÂµrumaa'),
(355, 'LV', 'LV-DGV', 'Daugavpils'),
(356, 'LV', 'LV-JEL', 'Jelgava'),
(357, 'LV', 'JÃ„â€œkabpils', 'JÃ„â€œkabpils'),
(358, 'LV', 'LV-JUR', 'JÃ…Â«rmala'),
(359, 'LV', 'LV-LPX', 'LiepÃ„Âja'),
(360, 'LV', 'LV-LE', 'LiepÃ„Âjas novads'),
(361, 'LV', 'LV-REZ', 'RÃ„â€œzekne'),
(362, 'LV', 'LV-RIX', 'RÃ„Â«ga'),
(363, 'LV', 'LV-RI', 'RÃ„Â«gas novads'),
(364, 'LV', 'Valmiera', 'Valmiera'),
(365, 'LV', 'LV-VEN', 'Ventspils'),
(366, 'LV', 'Aglonas novads', 'Aglonas novads'),
(367, 'LV', 'LV-AI', 'Aizkraukles novads'),
(368, 'LV', 'Aizputes novads', 'Aizputes novads'),
(369, 'LV', 'AknÃ„Â«stes novads', 'AknÃ„Â«stes novads'),
(370, 'LV', 'Alojas novads', 'Alojas novads'),
(371, 'LV', 'Alsungas novads', 'Alsungas novads'),
(372, 'LV', 'LV-AL', 'AlÃ…Â«ksnes novads'),
(373, 'LV', 'Amatas novads', 'Amatas novads'),
(374, 'LV', 'Apes novads', 'Apes novads'),
(375, 'LV', 'Auces novads', 'Auces novads'),
(376, 'LV', 'BabÃ„Â«tes novads', 'BabÃ„Â«tes novads'),
(377, 'LV', 'Baldones novads', 'Baldones novads'),
(378, 'LV', 'Baltinavas novads', 'Baltinavas novads'),
(379, 'LV', 'LV-BL', 'Balvu novads'),
(380, 'LV', 'LV-BU', 'Bauskas novads'),
(381, 'LV', 'BeverÃ„Â«nas novads', 'BeverÃ„Â«nas novads'),
(382, 'LV', 'BrocÃ„â€œnu novads', 'BrocÃ„â€œnu novads'),
(383, 'LV', 'Burtnieku novads', 'Burtnieku novads'),
(384, 'LV', 'Carnikavas novads', 'Carnikavas novads'),
(385, 'LV', 'Cesvaines novads', 'Cesvaines novads'),
(386, 'LV', 'Ciblas novads', 'Ciblas novads'),
(387, 'LV', 'LV-CE', 'CÃ„â€œsu novads'),
(388, 'LV', 'Dagdas novads', 'Dagdas novads'),
(389, 'LV', 'LV-DA', 'Daugavpils novads'),
(390, 'LV', 'LV-DO', 'Dobeles novads'),
(391, 'LV', 'Dundagas novads', 'Dundagas novads'),
(392, 'LV', 'Durbes novads', 'Durbes novads'),
(393, 'LV', 'Engures novads', 'Engures novads'),
(394, 'LV', 'Garkalnes novads', 'Garkalnes novads'),
(395, 'LV', 'GrobiÃ…â€ as novads', 'GrobiÃ…â€ as novads'),
(396, 'LV', 'LV-GU', 'Gulbenes novads'),
(397, 'LV', 'Iecavas novads', 'Iecavas novads'),
(398, 'LV', 'IkÃ…Â¡Ã„Â·iles novads', 'IkÃ…Â¡Ã„Â·iles novads'),
(399, 'LV', 'IlÃ…Â«kstes novads', 'IlÃ…Â«kstes novads'),
(400, 'LV', 'InÃ„Âukalna novads', 'InÃ„Âukalna novads'),
(401, 'LV', 'Jaunjelgavas novads', 'Jaunjelgavas novads'),
(402, 'LV', 'Jaunpiebalgas novads', 'Jaunpiebalgas novads'),
(403, 'LV', 'Jaunpils novads', 'Jaunpils novads'),
(404, 'LV', 'LV-JL', 'Jelgavas novads'),
(405, 'LV', 'LV-JK', 'JÃ„â€œkabpils novads'),
(406, 'LV', 'Kandavas novads', 'Kandavas novads'),
(407, 'LV', 'Kokneses novads', 'Kokneses novads'),
(408, 'LV', 'Krimuldas novads', 'Krimuldas novads'),
(409, 'LV', 'Krustpils novads', 'Krustpils novads'),
(410, 'LV', 'LV-KR', 'KrÃ„Âslavas novads'),
(411, 'LV', 'LV-KU', 'KuldÃ„Â«gas novads'),
(412, 'LV', 'KÃ„Ârsavas novads', 'KÃ„Ârsavas novads'),
(413, 'LV', 'LielvÃ„Ârdes novads', 'LielvÃ„Ârdes novads'),
(414, 'LV', 'LV-LM', 'LimbaÃ…Â¾u novads'),
(415, 'LV', 'LubÃ„Ânas novads', 'LubÃ„Ânas novads'),
(416, 'LV', 'LV-LU', 'Ludzas novads'),
(417, 'LV', 'LÃ„Â«gatnes novads', 'LÃ„Â«gatnes novads'),
(418, 'LV', 'LÃ„Â«vÃ„Ânu novads', 'LÃ„Â«vÃ„Ânu novads'),
(419, 'LV', 'LV-MA', 'Madonas novads'),
(420, 'LV', 'Mazsalacas novads', 'Mazsalacas novads'),
(421, 'LV', 'MÃ„Âlpils novads', 'MÃ„Âlpils novads'),
(422, 'LV', 'MÃ„Ârupes novads', 'MÃ„Ârupes novads'),
(423, 'LV', 'NaukÃ…Â¡Ã„â€œnu novads', 'NaukÃ…Â¡Ã„â€œnu novads'),
(424, 'LV', 'Neretas novads', 'Neretas novads'),
(425, 'LV', 'NÃ„Â«cas novads', 'NÃ„Â«cas novads'),
(426, 'LV', 'LV-OG', 'Ogres novads'),
(427, 'LV', 'Olaines novads', 'Olaines novads'),
(428, 'LV', 'Ozolnieku novads', 'Ozolnieku novads'),
(429, 'LV', 'LV-PR', 'PreiÃ„Â¼u novads'),
(430, 'LV', 'Priekules novads', 'Priekules novads'),
(431, 'LV', 'PriekuÃ„Â¼u novads', 'PriekuÃ„Â¼u novads'),
(432, 'LV', 'PÃ„Ârgaujas novads', 'PÃ„Ârgaujas novads'),
(433, 'LV', 'PÃ„Âvilostas novads', 'PÃ„Âvilostas novads'),
(434, 'LV', 'PÃ„Â¼aviÃ…â€ u novads', 'PÃ„Â¼aviÃ…â€ u novads'),
(435, 'LV', 'Raunas novads', 'Raunas novads'),
(436, 'LV', 'RiebiÃ…â€ u novads', 'RiebiÃ…â€ u novads'),
(437, 'LV', 'Rojas novads', 'Rojas novads'),
(438, 'LV', 'RopaÃ…Â¾u novads', 'RopaÃ…Â¾u novads'),
(439, 'LV', 'Rucavas novads', 'Rucavas novads'),
(440, 'LV', 'RugÃ„Âju novads', 'RugÃ„Âju novads'),
(441, 'LV', 'RundÃ„Âles novads', 'RundÃ„Âles novads'),
(442, 'LV', 'LV-RE', 'RÃ„â€œzeknes novads'),
(443, 'LV', 'RÃ…Â«jienas novads', 'RÃ…Â«jienas novads'),
(444, 'LV', 'SalacgrÃ„Â«vas novads', 'SalacgrÃ„Â«vas novads'),
(445, 'LV', 'Salas novads', 'Salas novads'),
(446, 'LV', 'Salaspils novads', 'Salaspils novads'),
(447, 'LV', 'LV-SA', 'Saldus novads'),
(448, 'LV', 'Saulkrastu novads', 'Saulkrastu novads'),
(449, 'LV', 'Siguldas novads', 'Siguldas novads'),
(450, 'LV', 'Skrundas novads', 'Skrundas novads'),
(451, 'LV', 'SkrÃ„Â«veru novads', 'SkrÃ„Â«veru novads'),
(452, 'LV', 'Smiltenes novads', 'Smiltenes novads'),
(453, 'LV', 'StopiÃ…â€ u novads', 'StopiÃ…â€ u novads'),
(454, 'LV', 'StrenÃ„Âu novads', 'StrenÃ„Âu novads'),
(455, 'LV', 'SÃ„â€œjas novads', 'SÃ„â€œjas novads'),
(456, 'LV', 'LV-TA', 'Talsu novads'),
(457, 'LV', 'LV-TU', 'Tukuma novads'),
(458, 'LV', 'TÃ„â€œrvetes novads', 'TÃ„â€œrvetes novads'),
(459, 'LV', 'VaiÃ…â€ odes novads', 'VaiÃ…â€ odes novads'),
(460, 'LV', 'LV-VK', 'Valkas novads'),
(461, 'LV', 'LV-VM', 'Valmieras novads'),
(462, 'LV', 'VarakÃ„Â¼Ã„Ânu novads', 'VarakÃ„Â¼Ã„Ânu novads'),
(463, 'LV', 'Vecpiebalgas novads', 'Vecpiebalgas novads'),
(464, 'LV', 'Vecumnieku novads', 'Vecumnieku novads'),
(465, 'LV', 'LV-VE', 'Ventspils novads'),
(466, 'LV', 'ViesÃ„Â«tes novads', 'ViesÃ„Â«tes novads'),
(467, 'LV', 'ViÃ„Â¼akas novads', 'ViÃ„Â¼akas novads'),
(468, 'LV', 'ViÃ„Â¼Ã„Ânu novads', 'ViÃ„Â¼Ã„Ânu novads'),
(469, 'LV', 'VÃ„Ârkavas novads', 'VÃ„Ârkavas novads'),
(470, 'LV', 'Zilupes novads', 'Zilupes novads'),
(471, 'LV', 'Ã„â‚¬daÃ…Â¾u novads', 'Ã„â‚¬daÃ…Â¾u novads'),
(472, 'LV', 'Ã„â€™rgÃ„Â¼u novads', 'Ã„â€™rgÃ„Â¼u novads'),
(473, 'LV', 'Ã„Â¶eguma novads', 'Ã„Â¶eguma novads'),
(474, 'LV', 'Ã„Â¶ekavas novads', 'Ã„Â¶ekavas novads'),
(475, 'LT', 'LT-AL', 'Alytaus Apskritis'),
(476, 'LT', 'LT-KU', 'Kauno Apskritis'),
(477, 'LT', 'LT-KL', 'KlaipÃ„â€”dos Apskritis'),
(478, 'LT', 'LT-MR', 'MarijampolÃ„â€”s Apskritis'),
(479, 'LT', 'LT-PN', 'PanevÃ„â€”Ã…Â¾io Apskritis'),
(480, 'LT', 'LT-SA', 'Ã…Â iauliÃ…Â³ Apskritis'),
(481, 'LT', 'LT-TA', 'TauragÃ„â€”s Apskritis'),
(482, 'LT', 'LT-TE', 'TelÃ…Â¡iÃ…Â³ Apskritis'),
(483, 'LT', 'LT-UT', 'Utenos Apskritis'),
(484, 'LT', 'LT-VL', 'Vilniaus Apskritis');

CREATE TABLE IF NOT EXISTS `#__directory_country_region_name` (
  `locale` varchar(8) NOT NULL DEFAULT '' COMMENT 'Locale',
  `region_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Region Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Region Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Directory Country Region Name';

INSERT INTO `#__directory_country_region_name` (`locale`, `region_id`, `name`) VALUES
('en_US', 1, 'Alabama'),
('en_US', 2, 'Alaska'),
('en_US', 3, 'American Samoa'),
('en_US', 4, 'Arizona'),
('en_US', 5, 'Arkansas'),
('en_US', 6, 'Armed Forces Africa'),
('en_US', 7, 'Armed Forces Americas'),
('en_US', 8, 'Armed Forces Canada'),
('en_US', 9, 'Armed Forces Europe'),
('en_US', 10, 'Armed Forces Middle East'),
('en_US', 11, 'Armed Forces Pacific'),
('en_US', 12, 'California'),
('en_US', 13, 'Colorado'),
('en_US', 14, 'Connecticut'),
('en_US', 15, 'Delaware'),
('en_US', 16, 'District of Columbia'),
('en_US', 17, 'Federated States Of Micronesia'),
('en_US', 18, 'Florida'),
('en_US', 19, 'Georgia'),
('en_US', 20, 'Guam'),
('en_US', 21, 'Hawaii'),
('en_US', 22, 'Idaho'),
('en_US', 23, 'Illinois'),
('en_US', 24, 'Indiana'),
('en_US', 25, 'Iowa'),
('en_US', 26, 'Kansas'),
('en_US', 27, 'Kentucky'),
('en_US', 28, 'Louisiana'),
('en_US', 29, 'Maine'),
('en_US', 30, 'Marshall Islands'),
('en_US', 31, 'Maryland'),
('en_US', 32, 'Massachusetts'),
('en_US', 33, 'Michigan'),
('en_US', 34, 'Minnesota'),
('en_US', 35, 'Mississippi'),
('en_US', 36, 'Missouri'),
('en_US', 37, 'Montana'),
('en_US', 38, 'Nebraska'),
('en_US', 39, 'Nevada'),
('en_US', 40, 'New Hampshire'),
('en_US', 41, 'New Jersey'),
('en_US', 42, 'New Mexico'),
('en_US', 43, 'New York'),
('en_US', 44, 'North Carolina'),
('en_US', 45, 'North Dakota'),
('en_US', 46, 'Northern Mariana Islands'),
('en_US', 47, 'Ohio'),
('en_US', 48, 'Oklahoma'),
('en_US', 49, 'Oregon'),
('en_US', 50, 'Palau'),
('en_US', 51, 'Pennsylvania'),
('en_US', 52, 'Puerto Rico'),
('en_US', 53, 'Rhode Island'),
('en_US', 54, 'South Carolina'),
('en_US', 55, 'South Dakota'),
('en_US', 56, 'Tennessee'),
('en_US', 57, 'Texas'),
('en_US', 58, 'Utah'),
('en_US', 59, 'Vermont'),
('en_US', 60, 'Virgin Islands'),
('en_US', 61, 'Virginia'),
('en_US', 62, 'Washington'),
('en_US', 63, 'West Virginia'),
('en_US', 64, 'Wisconsin'),
('en_US', 65, 'Wyoming'),
('en_US', 66, 'Alberta'),
('en_US', 67, 'British Columbia'),
('en_US', 68, 'Manitoba'),
('en_US', 69, 'Newfoundland and Labrador'),
('en_US', 70, 'New Brunswick'),
('en_US', 71, 'Nova Scotia'),
('en_US', 72, 'Northwest Territories'),
('en_US', 73, 'Nunavut'),
('en_US', 74, 'Ontario'),
('en_US', 75, 'Prince Edward Island'),
('en_US', 76, 'Quebec'),
('en_US', 77, 'Saskatchewan'),
('en_US', 78, 'Yukon Territory'),
('en_US', 79, 'Niedersachsen'),
('en_US', 80, 'Baden-WÃƒÂ¼rttemberg'),
('en_US', 81, 'Bayern'),
('en_US', 82, 'Berlin'),
('en_US', 83, 'Brandenburg'),
('en_US', 84, 'Bremen'),
('en_US', 85, 'Hamburg'),
('en_US', 86, 'Hessen'),
('en_US', 87, 'Mecklenburg-Vorpommern'),
('en_US', 88, 'Nordrhein-Westfalen'),
('en_US', 89, 'Rheinland-Pfalz'),
('en_US', 90, 'Saarland'),
('en_US', 91, 'Sachsen'),
('en_US', 92, 'Sachsen-Anhalt'),
('en_US', 93, 'Schleswig-Holstein'),
('en_US', 94, 'ThÃƒÂ¼ringen'),
('en_US', 95, 'Wien'),
('en_US', 96, 'NiederÃƒÂ¶sterreich'),
('en_US', 97, 'OberÃƒÂ¶sterreich'),
('en_US', 98, 'Salzburg'),
('en_US', 99, 'KÃƒÂ¤rnten'),
('en_US', 100, 'Steiermark'),
('en_US', 101, 'Tirol'),
('en_US', 102, 'Burgenland'),
('en_US', 103, 'Vorarlberg'),
('en_US', 104, 'Aargau'),
('en_US', 105, 'Appenzell Innerrhoden'),
('en_US', 106, 'Appenzell Ausserrhoden'),
('en_US', 107, 'Bern'),
('en_US', 108, 'Basel-Landschaft'),
('en_US', 109, 'Basel-Stadt'),
('en_US', 110, 'Freiburg'),
('en_US', 111, 'Genf'),
('en_US', 112, 'Glarus'),
('en_US', 113, 'GraubÃƒÂ¼nden'),
('en_US', 114, 'Jura'),
('en_US', 115, 'Luzern'),
('en_US', 116, 'Neuenburg'),
('en_US', 117, 'Nidwalden'),
('en_US', 118, 'Obwalden'),
('en_US', 119, 'St. Gallen'),
('en_US', 120, 'Schaffhausen'),
('en_US', 121, 'Solothurn'),
('en_US', 122, 'Schwyz'),
('en_US', 123, 'Thurgau'),
('en_US', 124, 'Tessin'),
('en_US', 125, 'Uri'),
('en_US', 126, 'Waadt'),
('en_US', 127, 'Wallis'),
('en_US', 128, 'Zug'),
('en_US', 129, 'ZÃƒÂ¼rich'),
('en_US', 130, 'A CoruÃƒÂ±a'),
('en_US', 131, 'Alava'),
('en_US', 132, 'Albacete'),
('en_US', 133, 'Alicante'),
('en_US', 134, 'Almeria'),
('en_US', 135, 'Asturias'),
('en_US', 136, 'Avila'),
('en_US', 137, 'Badajoz'),
('en_US', 138, 'Baleares'),
('en_US', 139, 'Barcelona'),
('en_US', 140, 'Burgos'),
('en_US', 141, 'Caceres'),
('en_US', 142, 'Cadiz'),
('en_US', 143, 'Cantabria'),
('en_US', 144, 'Castellon'),
('en_US', 145, 'Ceuta'),
('en_US', 146, 'Ciudad Real'),
('en_US', 147, 'Cordoba'),
('en_US', 148, 'Cuenca'),
('en_US', 149, 'Girona'),
('en_US', 150, 'Granada'),
('en_US', 151, 'Guadalajara'),
('en_US', 152, 'Guipuzcoa'),
('en_US', 153, 'Huelva'),
('en_US', 154, 'Huesca'),
('en_US', 155, 'Jaen'),
('en_US', 156, 'La Rioja'),
('en_US', 157, 'Las Palmas'),
('en_US', 158, 'Leon'),
('en_US', 159, 'Lleida'),
('en_US', 160, 'Lugo'),
('en_US', 161, 'Madrid'),
('en_US', 162, 'Malaga'),
('en_US', 163, 'Melilla'),
('en_US', 164, 'Murcia'),
('en_US', 165, 'Navarra'),
('en_US', 166, 'Ourense'),
('en_US', 167, 'Palencia'),
('en_US', 168, 'Pontevedra'),
('en_US', 169, 'Salamanca'),
('en_US', 170, 'Santa Cruz de Tenerife'),
('en_US', 171, 'Segovia'),
('en_US', 172, 'Sevilla'),
('en_US', 173, 'Soria'),
('en_US', 174, 'Tarragona'),
('en_US', 175, 'Teruel'),
('en_US', 176, 'Toledo'),
('en_US', 177, 'Valencia'),
('en_US', 178, 'Valladolid'),
('en_US', 179, 'Vizcaya'),
('en_US', 180, 'Zamora'),
('en_US', 181, 'Zaragoza'),
('en_US', 182, 'Ain'),
('en_US', 183, 'Aisne'),
('en_US', 184, 'Allier'),
('en_US', 185, 'Alpes-de-Haute-Provence'),
('en_US', 186, 'Hautes-Alpes'),
('en_US', 187, 'Alpes-Maritimes'),
('en_US', 188, 'ArdÃƒÂ¨che'),
('en_US', 189, 'Ardennes'),
('en_US', 190, 'AriÃƒÂ¨ge'),
('en_US', 191, 'Aube'),
('en_US', 192, 'Aude'),
('en_US', 193, 'Aveyron'),
('en_US', 194, 'Bouches-du-RhÃƒÂ´ne'),
('en_US', 195, 'Calvados'),
('en_US', 196, 'Cantal'),
('en_US', 197, 'Charente'),
('en_US', 198, 'Charente-Maritime'),
('en_US', 199, 'Cher'),
('en_US', 200, 'CorrÃƒÂ¨ze'),
('en_US', 201, 'Corse-du-Sud'),
('en_US', 202, 'Haute-Corse'),
('en_US', 203, 'CÃƒÂ´te-d''Or'),
('en_US', 204, 'CÃƒÂ´tes-d''Armor'),
('en_US', 205, 'Creuse'),
('en_US', 206, 'Dordogne'),
('en_US', 207, 'Doubs'),
('en_US', 208, 'DrÃƒÂ´me'),
('en_US', 209, 'Eure'),
('en_US', 210, 'Eure-et-Loir'),
('en_US', 211, 'FinistÃƒÂ¨re'),
('en_US', 212, 'Gard'),
('en_US', 213, 'Haute-Garonne'),
('en_US', 214, 'Gers'),
('en_US', 215, 'Gironde'),
('en_US', 216, 'HÃƒÂ©rault'),
('en_US', 217, 'Ille-et-Vilaine'),
('en_US', 218, 'Indre'),
('en_US', 219, 'Indre-et-Loire'),
('en_US', 220, 'IsÃƒÂ¨re'),
('en_US', 221, 'Jura'),
('en_US', 222, 'Landes'),
('en_US', 223, 'Loir-et-Cher'),
('en_US', 224, 'Loire'),
('en_US', 225, 'Haute-Loire'),
('en_US', 226, 'Loire-Atlantique'),
('en_US', 227, 'Loiret'),
('en_US', 228, 'Lot'),
('en_US', 229, 'Lot-et-Garonne'),
('en_US', 230, 'LozÃƒÂ¨re'),
('en_US', 231, 'Maine-et-Loire'),
('en_US', 232, 'Manche'),
('en_US', 233, 'Marne'),
('en_US', 234, 'Haute-Marne'),
('en_US', 235, 'Mayenne'),
('en_US', 236, 'Meurthe-et-Moselle'),
('en_US', 237, 'Meuse'),
('en_US', 238, 'Morbihan'),
('en_US', 239, 'Moselle'),
('en_US', 240, 'NiÃƒÂ¨vre'),
('en_US', 241, 'Nord'),
('en_US', 242, 'Oise'),
('en_US', 243, 'Orne'),
('en_US', 244, 'Pas-de-Calais'),
('en_US', 245, 'Puy-de-DÃƒÂ´me'),
('en_US', 246, 'PyrÃƒÂ©nÃƒÂ©es-Atlantiques'),
('en_US', 247, 'Hautes-PyrÃƒÂ©nÃƒÂ©es'),
('en_US', 248, 'PyrÃƒÂ©nÃƒÂ©es-Orientales'),
('en_US', 249, 'Bas-Rhin'),
('en_US', 250, 'Haut-Rhin'),
('en_US', 251, 'RhÃƒÂ´ne'),
('en_US', 252, 'Haute-SaÃƒÂ´ne'),
('en_US', 253, 'SaÃƒÂ´ne-et-Loire'),
('en_US', 254, 'Sarthe'),
('en_US', 255, 'Savoie'),
('en_US', 256, 'Haute-Savoie'),
('en_US', 257, 'Amoda'),
('en_US', 258, 'Seine-Maritime'),
('en_US', 259, 'Seine-et-Marne'),
('en_US', 260, 'Yvelines'),
('en_US', 261, 'Deux-SÃƒÂ¨vres'),
('en_US', 262, 'Somme'),
('en_US', 263, 'Tarn'),
('en_US', 264, 'Tarn-et-Garonne'),
('en_US', 265, 'Var'),
('en_US', 266, 'Vaucluse'),
('en_US', 267, 'VendÃƒÂ©e'),
('en_US', 268, 'Vienne'),
('en_US', 269, 'Haute-Vienne'),
('en_US', 270, 'Vosges'),
('en_US', 271, 'Yonne'),
('en_US', 272, 'Territoire-de-Belfort'),
('en_US', 273, 'Essonne'),
('en_US', 274, 'Hauts-de-Seine'),
('en_US', 275, 'Seine-Saint-Denis'),
('en_US', 276, 'Val-de-Marne'),
('en_US', 277, 'Val-d''Oise'),
('en_US', 278, 'Alba'),
('en_US', 279, 'Arad'),
('en_US', 280, 'ArgeÃ…Å¸'),
('en_US', 281, 'BacÃ„Æ’u'),
('en_US', 282, 'Bihor'),
('en_US', 283, 'BistriÃ…Â£a-NÃ„Æ’sÃ„Æ’ud'),
('en_US', 284, 'BotoÃ…Å¸ani'),
('en_US', 285, 'BraÃ…Å¸ov'),
('en_US', 286, 'BrÃ„Æ’ila'),
('en_US', 287, 'BucureÃ…Å¸ti'),
('en_US', 288, 'BuzÃ„Æ’u'),
('en_US', 289, 'CaraÃ…Å¸-Severin'),
('en_US', 290, 'CÃ„Æ’lÃ„Æ’raÃ…Å¸i'),
('en_US', 291, 'Cluj'),
('en_US', 292, 'ConstanÃ…Â£a'),
('en_US', 293, 'Covasna'),
('en_US', 294, 'DÃƒÂ¢mboviÃ…Â£a'),
('en_US', 295, 'Dolj'),
('en_US', 296, 'GalaÃ…Â£i'),
('en_US', 297, 'Giurgiu'),
('en_US', 298, 'Gorj'),
('en_US', 299, 'Harghita'),
('en_US', 300, 'Hunedoara'),
('en_US', 301, 'IalomiÃ…Â£a'),
('en_US', 302, 'IaÃ…Å¸i'),
('en_US', 303, 'Ilfov'),
('en_US', 304, 'MaramureÃ…Å¸'),
('en_US', 305, 'MehedinÃ…Â£i'),
('en_US', 306, 'MureÃ…Å¸'),
('en_US', 307, 'NeamÃ…Â£'),
('en_US', 308, 'Olt'),
('en_US', 309, 'Prahova'),
('en_US', 310, 'Satu-Mare'),
('en_US', 311, 'SÃ„Æ’laj'),
('en_US', 312, 'Sibiu'),
('en_US', 313, 'Suceava'),
('en_US', 314, 'Teleorman'),
('en_US', 315, 'TimiÃ…Å¸'),
('en_US', 316, 'Tulcea'),
('en_US', 317, 'Vaslui'),
('en_US', 318, 'VÃƒÂ¢lcea'),
('en_US', 319, 'Vrancea'),
('en_US', 320, 'Lappi'),
('en_US', 321, 'Pohjois-Pohjanmaa'),
('en_US', 322, 'Kainuu'),
('en_US', 323, 'Pohjois-Karjala'),
('en_US', 324, 'Pohjois-Savo'),
('en_US', 325, 'EtelÃƒÂ¤-Savo'),
('en_US', 326, 'EtelÃƒÂ¤-Pohjanmaa'),
('en_US', 327, 'Pohjanmaa'),
('en_US', 328, 'Pirkanmaa'),
('en_US', 329, 'Satakunta'),
('en_US', 330, 'Keski-Pohjanmaa'),
('en_US', 331, 'Keski-Suomi'),
('en_US', 332, 'Varsinais-Suomi'),
('en_US', 333, 'EtelÃƒÂ¤-Karjala'),
('en_US', 334, 'PÃƒÂ¤ijÃƒÂ¤t-HÃƒÂ¤me'),
('en_US', 335, 'Kanta-HÃƒÂ¤me'),
('en_US', 336, 'Uusimaa'),
('en_US', 337, 'ItÃƒÂ¤-Uusimaa'),
('en_US', 338, 'Kymenlaakso'),
('en_US', 339, 'Ahvenanmaa'),
('en_US', 340, 'Harjumaa'),
('en_US', 341, 'Hiiumaa'),
('en_US', 342, 'Ida-Virumaa'),
('en_US', 343, 'JÃƒÂµgevamaa'),
('en_US', 344, 'JÃƒÂ¤rvamaa'),
('en_US', 345, 'LÃƒÂ¤ÃƒÂ¤nemaa'),
('en_US', 346, 'LÃƒÂ¤ÃƒÂ¤ne-Virumaa'),
('en_US', 347, 'PÃƒÂµlvamaa'),
('en_US', 348, 'PÃƒÂ¤rnumaa'),
('en_US', 349, 'Raplamaa'),
('en_US', 350, 'Saaremaa'),
('en_US', 351, 'Tartumaa'),
('en_US', 352, 'Valgamaa'),
('en_US', 353, 'Viljandimaa'),
('en_US', 354, 'VÃƒÂµrumaa'),
('en_US', 355, 'Daugavpils'),
('en_US', 356, 'Jelgava'),
('en_US', 357, 'JÃ„â€œkabpils'),
('en_US', 358, 'JÃ…Â«rmala'),
('en_US', 359, 'LiepÃ„Âja'),
('en_US', 360, 'LiepÃ„Âjas novads'),
('en_US', 361, 'RÃ„â€œzekne'),
('en_US', 362, 'RÃ„Â«ga'),
('en_US', 363, 'RÃ„Â«gas novads'),
('en_US', 364, 'Valmiera'),
('en_US', 365, 'Ventspils'),
('en_US', 366, 'Aglonas novads'),
('en_US', 367, 'Aizkraukles novads'),
('en_US', 368, 'Aizputes novads'),
('en_US', 369, 'AknÃ„Â«stes novads'),
('en_US', 370, 'Alojas novads'),
('en_US', 371, 'Alsungas novads'),
('en_US', 372, 'AlÃ…Â«ksnes novads'),
('en_US', 373, 'Amatas novads'),
('en_US', 374, 'Apes novads'),
('en_US', 375, 'Auces novads'),
('en_US', 376, 'BabÃ„Â«tes novads'),
('en_US', 377, 'Baldones novads'),
('en_US', 378, 'Baltinavas novads'),
('en_US', 379, 'Balvu novads'),
('en_US', 380, 'Bauskas novads'),
('en_US', 381, 'BeverÃ„Â«nas novads'),
('en_US', 382, 'BrocÃ„â€œnu novads'),
('en_US', 383, 'Burtnieku novads'),
('en_US', 384, 'Carnikavas novads'),
('en_US', 385, 'Cesvaines novads'),
('en_US', 386, 'Ciblas novads'),
('en_US', 387, 'CÃ„â€œsu novads'),
('en_US', 388, 'Dagdas novads'),
('en_US', 389, 'Daugavpils novads'),
('en_US', 390, 'Dobeles novads'),
('en_US', 391, 'Dundagas novads'),
('en_US', 392, 'Durbes novads'),
('en_US', 393, 'Engures novads'),
('en_US', 394, 'Garkalnes novads'),
('en_US', 395, 'GrobiÃ…â€ as novads'),
('en_US', 396, 'Gulbenes novads'),
('en_US', 397, 'Iecavas novads'),
('en_US', 398, 'IkÃ…Â¡Ã„Â·iles novads'),
('en_US', 399, 'IlÃ…Â«kstes novads'),
('en_US', 400, 'InÃ„Âukalna novads'),
('en_US', 401, 'Jaunjelgavas novads'),
('en_US', 402, 'Jaunpiebalgas novads'),
('en_US', 403, 'Jaunpils novads'),
('en_US', 404, 'Jelgavas novads'),
('en_US', 405, 'JÃ„â€œkabpils novads'),
('en_US', 406, 'Kandavas novads'),
('en_US', 407, 'Kokneses novads'),
('en_US', 408, 'Krimuldas novads'),
('en_US', 409, 'Krustpils novads'),
('en_US', 410, 'KrÃ„Âslavas novads'),
('en_US', 411, 'KuldÃ„Â«gas novads'),
('en_US', 412, 'KÃ„Ârsavas novads'),
('en_US', 413, 'LielvÃ„Ârdes novads'),
('en_US', 414, 'LimbaÃ…Â¾u novads'),
('en_US', 415, 'LubÃ„Ânas novads'),
('en_US', 416, 'Ludzas novads'),
('en_US', 417, 'LÃ„Â«gatnes novads'),
('en_US', 418, 'LÃ„Â«vÃ„Ânu novads'),
('en_US', 419, 'Madonas novads'),
('en_US', 420, 'Mazsalacas novads'),
('en_US', 421, 'MÃ„Âlpils novads'),
('en_US', 422, 'MÃ„Ârupes novads'),
('en_US', 423, 'NaukÃ…Â¡Ã„â€œnu novads'),
('en_US', 424, 'Neretas novads'),
('en_US', 425, 'NÃ„Â«cas novads'),
('en_US', 426, 'Ogres novads'),
('en_US', 427, 'Olaines novads'),
('en_US', 428, 'Ozolnieku novads'),
('en_US', 429, 'PreiÃ„Â¼u novads'),
('en_US', 430, 'Priekules novads'),
('en_US', 431, 'PriekuÃ„Â¼u novads'),
('en_US', 432, 'PÃ„Ârgaujas novads'),
('en_US', 433, 'PÃ„Âvilostas novads'),
('en_US', 434, 'PÃ„Â¼aviÃ…â€ u novads'),
('en_US', 435, 'Raunas novads'),
('en_US', 436, 'RiebiÃ…â€ u novads'),
('en_US', 437, 'Rojas novads'),
('en_US', 438, 'RopaÃ…Â¾u novads'),
('en_US', 439, 'Rucavas novads'),
('en_US', 440, 'RugÃ„Âju novads'),
('en_US', 441, 'RundÃ„Âles novads'),
('en_US', 442, 'RÃ„â€œzeknes novads'),
('en_US', 443, 'RÃ…Â«jienas novads'),
('en_US', 444, 'SalacgrÃ„Â«vas novads'),
('en_US', 445, 'Salas novads'),
('en_US', 446, 'Salaspils novads'),
('en_US', 447, 'Saldus novads'),
('en_US', 448, 'Saulkrastu novads'),
('en_US', 449, 'Siguldas novads'),
('en_US', 450, 'Skrundas novads'),
('en_US', 451, 'SkrÃ„Â«veru novads'),
('en_US', 452, 'Smiltenes novads'),
('en_US', 453, 'StopiÃ…â€ u novads'),
('en_US', 454, 'StrenÃ„Âu novads'),
('en_US', 455, 'SÃ„â€œjas novads'),
('en_US', 456, 'Talsu novads'),
('en_US', 457, 'Tukuma novads'),
('en_US', 458, 'TÃ„â€œrvetes novads'),
('en_US', 459, 'VaiÃ…â€ odes novads'),
('en_US', 460, 'Valkas novads'),
('en_US', 461, 'Valmieras novads'),
('en_US', 462, 'VarakÃ„Â¼Ã„Ânu novads'),
('en_US', 463, 'Vecpiebalgas novads'),
('en_US', 464, 'Vecumnieku novads'),
('en_US', 465, 'Ventspils novads'),
('en_US', 466, 'ViesÃ„Â«tes novads'),
('en_US', 467, 'ViÃ„Â¼akas novads'),
('en_US', 468, 'ViÃ„Â¼Ã„Ânu novads'),
('en_US', 469, 'VÃ„Ârkavas novads'),
('en_US', 470, 'Zilupes novads'),
('en_US', 471, 'Ã„â‚¬daÃ…Â¾u novads'),
('en_US', 472, 'Ã„â€™rgÃ„Â¼u novads'),
('en_US', 473, 'Ã„Â¶eguma novads'),
('en_US', 474, 'Ã„Â¶ekavas novads'),
('en_US', 475, 'Alytaus Apskritis'),
('en_US', 476, 'Kauno Apskritis'),
('en_US', 477, 'KlaipÃ„â€”dos Apskritis'),
('en_US', 478, 'MarijampolÃ„â€”s Apskritis'),
('en_US', 479, 'PanevÃ„â€”Ã…Â¾io Apskritis'),
('en_US', 480, 'Ã…Â iauliÃ…Â³ Apskritis'),
('en_US', 481, 'TauragÃ„â€”s Apskritis'),
('en_US', 482, 'TelÃ…Â¡iÃ…Â³ Apskritis'),
('en_US', 483, 'Utenos Apskritis'),
('en_US', 484, 'Vilniaus Apskritis');

CREATE TABLE IF NOT EXISTS `#__directory_currency_rate` (
  `currency_from` varchar(3) NOT NULL DEFAULT '' COMMENT 'Currency Code Convert From',
  `currency_to` varchar(3) NOT NULL DEFAULT '' COMMENT 'Currency Code Convert To',
  `rate` decimal(24,12) NOT NULL DEFAULT '0.000000000000' COMMENT 'Currency Conversion Rate'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Directory Currency Rate';

INSERT INTO `#__directory_currency_rate` (`currency_from`, `currency_to`, `rate`) VALUES
('EUR', 'EUR', '1.000000000000'),
('EUR', 'USD', '1.415000000000'),
('USD', 'EUR', '0.706700000000'),
('USD', 'USD', '1.000000000000');

CREATE TABLE IF NOT EXISTS `#__downloadable_link` (
`link_id` int(10) unsigned NOT NULL COMMENT 'Link ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort order',
  `number_of_downloads` int(11) DEFAULT NULL COMMENT 'Number of downloads',
  `is_shareable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Shareable flag',
  `link_url` varchar(255) DEFAULT NULL COMMENT 'Link Url',
  `link_file` varchar(255) DEFAULT NULL COMMENT 'Link File',
  `link_type` varchar(20) DEFAULT NULL COMMENT 'Link Type',
  `sample_url` varchar(255) DEFAULT NULL COMMENT 'Sample Url',
  `sample_file` varchar(255) DEFAULT NULL COMMENT 'Sample File',
  `sample_type` varchar(20) DEFAULT NULL COMMENT 'Sample Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Downloadable Link Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__downloadable_link` (`link_id`, `product_id`, `sort_order`, `number_of_downloads`, `is_shareable`, `link_url`, `link_file`, `link_type`, `sample_url`, `sample_file`, `sample_type`) VALUES
(1, 46, 0, 10, 2, NULL, '/l/i/link1.txt', 'file', NULL, '/s/a/sample1.txt', 'file'),
(2, 46, 0, 0, 2, NULL, '/l/i/link2.txt', 'file', NULL, '/s/a/sample2.txt', 'file'),
(3, 46, 0, 0, 2, NULL, '/l/i/link3.txt', 'file', NULL, '/s/a/sample3.txt', 'file');

CREATE TABLE IF NOT EXISTS `#__downloadable_link_price` (
`price_id` int(10) unsigned NOT NULL COMMENT 'Price ID',
  `link_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Downloadable Link Price Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__downloadable_link_price` (`price_id`, `link_id`, `website_id`, `price`) VALUES
(1, 1, 0, '10.0000'),
(2, 2, 0, '15.0000'),
(3, 3, 0, '20.0000');

CREATE TABLE IF NOT EXISTS `#__downloadable_link_purchased` (
`purchased_id` int(10) unsigned NOT NULL COMMENT 'Purchased ID',
  `order_id` int(10) unsigned DEFAULT '0' COMMENT 'Order ID',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment ID',
  `order_item_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Order Item ID',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of creation',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of modification',
  `customer_id` int(10) unsigned DEFAULT '0' COMMENT 'Customer ID',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product name',
  `product_sku` varchar(255) DEFAULT NULL COMMENT 'Product sku',
  `link_section_title` varchar(255) DEFAULT NULL COMMENT 'Link_section_title'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Downloadable Link Purchased Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__downloadable_link_purchased_item` (
`item_id` int(10) unsigned NOT NULL COMMENT 'Item ID',
  `purchased_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Purchased ID',
  `order_item_id` int(10) unsigned DEFAULT '0' COMMENT 'Order Item ID',
  `product_id` int(10) unsigned DEFAULT '0' COMMENT 'Product ID',
  `link_hash` varchar(255) DEFAULT NULL COMMENT 'Link hash',
  `number_of_downloads_bought` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Number of downloads bought',
  `number_of_downloads_used` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Number of downloads used',
  `link_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `link_title` varchar(255) DEFAULT NULL COMMENT 'Link Title',
  `is_shareable` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Shareable Flag',
  `link_url` varchar(255) DEFAULT NULL COMMENT 'Link Url',
  `link_file` varchar(255) DEFAULT NULL COMMENT 'Link File',
  `link_type` varchar(255) DEFAULT NULL COMMENT 'Link Type',
  `status` varchar(50) DEFAULT NULL COMMENT 'Status',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Creation Time',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Update Time'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Downloadable Link Purchased Item Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__downloadable_link_title` (
`title_id` int(10) unsigned NOT NULL COMMENT 'Title ID',
  `link_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Link ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Link Title Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__downloadable_link_title` (`title_id`, `link_id`, `store_id`, `title`) VALUES
(1, 1, 0, 'Links #1'),
(2, 2, 0, 'Links #2'),
(3, 3, 0, 'Links #3');

CREATE TABLE IF NOT EXISTS `#__downloadable_sample` (
`sample_id` int(10) unsigned NOT NULL COMMENT 'Sample ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `sample_url` varchar(255) DEFAULT NULL COMMENT 'Sample URL',
  `sample_file` varchar(255) DEFAULT NULL COMMENT 'Sample file',
  `sample_type` varchar(20) DEFAULT NULL COMMENT 'Sample Type',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Downloadable Sample Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__downloadable_sample` (`sample_id`, `product_id`, `sample_url`, `sample_file`, `sample_type`, `sort_order`) VALUES
(1, 46, NULL, '/s/a/sample1_1.txt', 'file', 0),
(2, 46, NULL, '/s/a/sample2_1.txt', 'file', 0),
(3, 46, NULL, '/s/a/sample3_1.txt', 'file', 0);

CREATE TABLE IF NOT EXISTS `#__downloadable_sample_title` (
`title_id` int(10) unsigned NOT NULL COMMENT 'Title ID',
  `sample_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sample ID',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store ID',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Downloadable Sample Title Table' AUTO_INCREMENT=4 ;

INSERT INTO `#__downloadable_sample_title` (`title_id`, `sample_id`, `store_id`, `title`) VALUES
(1, 1, 0, 'Samples #1'),
(2, 2, 0, 'Samples #2'),
(3, 3, 0, 'Samples #3');

CREATE TABLE IF NOT EXISTS `#__eav_attribute` (
`attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_code` varchar(255) DEFAULT NULL COMMENT 'Attribute Code',
  `attribute_model` varchar(255) DEFAULT NULL COMMENT 'Attribute Model',
  `backend_model` varchar(255) DEFAULT NULL COMMENT 'Backend Model',
  `backend_type` varchar(8) NOT NULL DEFAULT 'static' COMMENT 'Backend Type',
  `backend_table` varchar(255) DEFAULT NULL COMMENT 'Backend Table',
  `frontend_model` varchar(255) DEFAULT NULL COMMENT 'Frontend Model',
  `frontend_input` varchar(50) DEFAULT NULL COMMENT 'Frontend Input',
  `frontend_label` varchar(255) DEFAULT NULL COMMENT 'Frontend Label',
  `frontend_class` varchar(255) DEFAULT NULL COMMENT 'Frontend Class',
  `source_model` varchar(255) DEFAULT NULL COMMENT 'Source Model',
  `is_required` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Required',
  `is_user_defined` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is User Defined',
  `default_value` text COMMENT 'Default Value',
  `is_unique` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Defines Is Unique',
  `note` varchar(255) DEFAULT NULL COMMENT 'Note'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Attribute' AUTO_INCREMENT=165 ;

INSERT INTO `#__eav_attribute` (`attribute_id`, `entity_type_id`, `attribute_code`, `attribute_model`, `backend_model`, `backend_type`, `backend_table`, `frontend_model`, `frontend_input`, `frontend_label`, `frontend_class`, `source_model`, `is_required`, `is_user_defined`, `default_value`, `is_unique`, `note`) VALUES
(1, 1, 'website_id', NULL, 'customer/customer_attribute_backend_website', 'static', NULL, NULL, 'select', 'Associate to Website', NULL, 'customer/customer_attribute_source_website', 1, 0, NULL, 0, NULL),
(2, 1, 'store_id', NULL, 'customer/customer_attribute_backend_store', 'static', NULL, NULL, 'select', 'Create In', NULL, 'customer/customer_attribute_source_store', 1, 0, NULL, 0, NULL),
(3, 1, 'created_in', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Created From', NULL, NULL, 0, 0, NULL, 0, NULL),
(4, 1, 'prefix', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Prefix', NULL, NULL, 0, 0, NULL, 0, NULL),
(5, 1, 'firstname', NULL, NULL, 'varchar', NULL, NULL, 'text', 'First Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(6, 1, 'middlename', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Middle Name/Initial', NULL, NULL, 0, 0, NULL, 0, NULL),
(7, 1, 'lastname', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Last Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(8, 1, 'suffix', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Suffix', NULL, NULL, 0, 0, NULL, 0, NULL),
(9, 1, 'email', NULL, NULL, 'static', NULL, NULL, 'text', 'Email', NULL, NULL, 1, 0, NULL, 0, NULL),
(10, 1, 'group_id', NULL, NULL, 'static', NULL, NULL, 'select', 'Group', NULL, 'customer/customer_attribute_source_group', 1, 0, NULL, 0, NULL),
(11, 1, 'dob', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, 'eav/entity_attribute_frontend_datetime', 'date', 'Date Of Birth', NULL, NULL, 0, 0, NULL, 0, NULL),
(12, 1, 'password_hash', NULL, 'customer/customer_attribute_backend_password', 'varchar', NULL, NULL, 'hidden', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(13, 1, 'default_billing', NULL, 'customer/customer_attribute_backend_billing', 'int', NULL, NULL, 'text', 'Default Billing Address', NULL, NULL, 0, 0, NULL, 0, NULL),
(14, 1, 'default_shipping', NULL, 'customer/customer_attribute_backend_shipping', 'int', NULL, NULL, 'text', 'Default Shipping Address', NULL, NULL, 0, 0, NULL, 0, NULL),
(15, 1, 'taxvat', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Tax/VAT Number', NULL, NULL, 0, 0, NULL, 0, NULL),
(16, 1, 'confirmation', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Is Confirmed', NULL, NULL, 0, 0, NULL, 0, NULL),
(17, 1, 'created_at', NULL, NULL, 'static', NULL, NULL, 'datetime', 'Created At', NULL, NULL, 0, 0, NULL, 0, NULL),
(18, 1, 'gender', NULL, NULL, 'int', NULL, NULL, 'select', 'Gender', NULL, 'eav/entity_attribute_source_table', 0, 0, NULL, 0, NULL),
(19, 2, 'prefix', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Prefix', NULL, NULL, 0, 0, NULL, 0, NULL),
(20, 2, 'firstname', NULL, NULL, 'varchar', NULL, NULL, 'text', 'First Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(21, 2, 'middlename', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Middle Name/Initial', NULL, NULL, 0, 0, NULL, 0, NULL),
(22, 2, 'lastname', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Last Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(23, 2, 'suffix', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Suffix', NULL, NULL, 0, 0, NULL, 0, NULL),
(24, 2, 'company', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Company', NULL, NULL, 0, 0, NULL, 0, NULL),
(25, 2, 'street', NULL, 'customer/entity_address_attribute_backend_street', 'text', NULL, NULL, 'multiline', 'Street Address', NULL, NULL, 1, 0, NULL, 0, NULL),
(26, 2, 'city', NULL, NULL, 'varchar', NULL, NULL, 'text', 'City', NULL, NULL, 1, 0, NULL, 0, NULL),
(27, 2, 'country_id', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Country', NULL, 'customer/entity_address_attribute_source_country', 1, 0, NULL, 0, NULL),
(28, 2, 'region', NULL, 'customer/entity_address_attribute_backend_region', 'varchar', NULL, NULL, 'text', 'State/Province', NULL, NULL, 0, 0, NULL, 0, NULL),
(29, 2, 'region_id', NULL, NULL, 'int', NULL, NULL, 'hidden', 'State/Province', NULL, 'customer/entity_address_attribute_source_region', 0, 0, NULL, 0, NULL),
(30, 2, 'postcode', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Zip/Postal Code', NULL, NULL, 1, 0, NULL, 0, NULL),
(31, 2, 'telephone', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Telephone', NULL, NULL, 1, 0, NULL, 0, NULL),
(32, 2, 'fax', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Fax', NULL, NULL, 0, 0, NULL, 0, NULL),
(33, 1, 'rp_token', NULL, NULL, 'varchar', NULL, NULL, 'hidden', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(34, 1, 'rp_token_created_at', NULL, NULL, 'datetime', NULL, NULL, 'date', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(35, 1, 'disable_auto_group_change', NULL, 'customer/attribute_backend_data_boolean', 'static', NULL, NULL, 'boolean', 'Disable Automatic Group Change Based on VAT ID', NULL, NULL, 0, 0, NULL, 0, NULL),
(36, 2, 'vat_id', NULL, NULL, 'varchar', NULL, NULL, 'text', 'VAT number', NULL, NULL, 0, 0, NULL, 0, NULL),
(37, 2, 'vat_is_valid', NULL, NULL, 'int', NULL, NULL, 'text', 'VAT number validity', NULL, NULL, 0, 0, NULL, 0, NULL),
(38, 2, 'vat_request_id', NULL, NULL, 'varchar', NULL, NULL, 'text', 'VAT number validation request ID', NULL, NULL, 0, 0, NULL, 0, NULL),
(39, 2, 'vat_request_date', NULL, NULL, 'varchar', NULL, NULL, 'text', 'VAT number validation request date', NULL, NULL, 0, 0, NULL, 0, NULL),
(40, 2, 'vat_request_success', NULL, NULL, 'int', NULL, NULL, 'text', 'VAT number validation request success', NULL, NULL, 0, 0, NULL, 0, NULL),
(41, 3, 'name', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(42, 3, 'is_active', NULL, NULL, 'int', NULL, NULL, 'select', 'Is Active', NULL, 'eav/entity_attribute_source_boolean', 1, 0, NULL, 0, NULL),
(43, 3, 'url_key', NULL, 'catalog/category_attribute_backend_urlkey', 'varchar', NULL, NULL, 'text', 'URL Key', NULL, NULL, 0, 0, NULL, 0, NULL),
(44, 3, 'description', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Description', NULL, NULL, 0, 0, NULL, 0, NULL),
(45, 3, 'image', NULL, 'catalog/category_attribute_backend_image', 'varchar', NULL, NULL, 'image', 'Image', NULL, NULL, 0, 0, NULL, 0, NULL),
(46, 3, 'meta_title', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Page Title', NULL, NULL, 0, 0, NULL, 0, NULL),
(47, 3, 'meta_keywords', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Meta Keywords', NULL, NULL, 0, 0, NULL, 0, NULL),
(48, 3, 'meta_description', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Meta Description', NULL, NULL, 0, 0, NULL, 0, NULL),
(49, 3, 'display_mode', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Display Mode', NULL, 'catalog/category_attribute_source_mode', 0, 0, NULL, 0, NULL),
(50, 3, 'landing_page', NULL, NULL, 'int', NULL, NULL, 'select', 'CMS Block', NULL, 'catalog/category_attribute_source_page', 0, 0, NULL, 0, NULL),
(51, 3, 'is_anchor', NULL, NULL, 'int', NULL, NULL, 'select', 'Is Anchor', NULL, 'eav/entity_attribute_source_boolean', 0, 0, NULL, 0, NULL),
(52, 3, 'path', NULL, NULL, 'static', NULL, NULL, 'text', 'Path', NULL, NULL, 0, 0, NULL, 0, NULL),
(53, 3, 'position', NULL, NULL, 'static', NULL, NULL, 'text', 'Position', NULL, NULL, 0, 0, NULL, 0, NULL),
(54, 3, 'all_children', NULL, NULL, 'text', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(55, 3, 'path_in_store', NULL, NULL, 'text', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(56, 3, 'children', NULL, NULL, 'text', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(57, 3, 'url_path', NULL, NULL, 'varchar', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(58, 3, 'custom_design', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Custom Design', NULL, 'core/design_source_design', 0, 0, NULL, 0, NULL),
(59, 3, 'custom_design_from', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, NULL, 'date', 'Active From', NULL, NULL, 0, 0, NULL, 0, NULL),
(60, 3, 'custom_design_to', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, NULL, 'date', 'Active To', NULL, NULL, 0, 0, NULL, 0, NULL),
(61, 3, 'page_layout', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Page Layout', NULL, 'catalog/category_attribute_source_layout', 0, 0, NULL, 0, NULL),
(62, 3, 'custom_layout_update', NULL, 'catalog/attribute_backend_customlayoutupdate', 'text', NULL, NULL, 'textarea', 'Custom Layout Update', NULL, NULL, 0, 0, NULL, 0, NULL),
(63, 3, 'level', NULL, NULL, 'static', NULL, NULL, 'text', 'Level', NULL, NULL, 0, 0, NULL, 0, NULL),
(64, 3, 'children_count', NULL, NULL, 'static', NULL, NULL, 'text', 'Children Count', NULL, NULL, 0, 0, NULL, 0, NULL),
(65, 3, 'available_sort_by', NULL, 'catalog/category_attribute_backend_sortby', 'text', NULL, NULL, 'multiselect', 'Available Product Listing Sort By', NULL, 'catalog/category_attribute_source_sortby', 1, 0, NULL, 0, NULL),
(66, 3, 'default_sort_by', NULL, 'catalog/category_attribute_backend_sortby', 'varchar', NULL, NULL, 'select', 'Default Product Listing Sort By', NULL, 'catalog/category_attribute_source_sortby', 1, 0, NULL, 0, NULL),
(67, 3, 'include_in_menu', NULL, NULL, 'int', NULL, NULL, 'select', 'Include in Navigation Menu', NULL, 'eav/entity_attribute_source_boolean', 1, 0, '1', 0, NULL),
(68, 3, 'custom_use_parent_settings', NULL, NULL, 'int', NULL, NULL, 'select', 'Use Parent Category Settings', NULL, 'eav/entity_attribute_source_boolean', 0, 0, NULL, 0, NULL),
(69, 3, 'custom_apply_to_products', NULL, NULL, 'int', NULL, NULL, 'select', 'Apply To Products', NULL, 'eav/entity_attribute_source_boolean', 0, 0, NULL, 0, NULL),
(70, 3, 'filter_price_range', NULL, NULL, 'decimal', NULL, NULL, 'text', 'Layered Navigation Price Step', NULL, NULL, 0, 0, NULL, 0, NULL),
(71, 4, 'name', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Name', NULL, NULL, 1, 0, NULL, 0, NULL),
(72, 4, 'description', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Description', NULL, NULL, 1, 0, NULL, 0, NULL),
(73, 4, 'short_description', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Short Description', NULL, NULL, 1, 0, NULL, 0, NULL),
(74, 4, 'sku', NULL, 'catalog/product_attribute_backend_sku', 'static', NULL, NULL, 'text', 'SKU', NULL, NULL, 1, 0, NULL, 1, NULL),
(75, 4, 'price', NULL, 'catalog/product_attribute_backend_price', 'decimal', NULL, NULL, 'price', 'Price', NULL, NULL, 1, 0, NULL, 0, NULL),
(76, 4, 'special_price', NULL, 'catalog/product_attribute_backend_price', 'decimal', NULL, NULL, 'price', 'Special Price', NULL, NULL, 0, 0, NULL, 0, 'The Special Price is active only when lower than the Actual Price'),
(77, 4, 'special_from_date', NULL, 'catalog/product_attribute_backend_startdate_specialprice', 'datetime', NULL, NULL, 'date', 'Special Price From Date', NULL, NULL, 0, 0, NULL, 0, NULL),
(78, 4, 'special_to_date', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, NULL, 'date', 'Special Price To Date', NULL, NULL, 0, 0, NULL, 0, NULL),
(79, 4, 'cost', NULL, 'catalog/product_attribute_backend_price', 'decimal', NULL, NULL, 'price', 'Cost', NULL, NULL, 0, 1, NULL, 0, NULL),
(80, 4, 'weight', NULL, NULL, 'decimal', NULL, NULL, 'weight', 'Weight', NULL, NULL, 1, 0, NULL, 0, NULL),
(81, 4, 'manufacturer', NULL, NULL, 'int', NULL, NULL, 'select', 'Manufacturer', NULL, NULL, 0, 1, '', 0, NULL),
(82, 4, 'meta_title', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Meta Title', NULL, NULL, 0, 0, NULL, 0, NULL),
(83, 4, 'meta_keyword', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Meta Keywords', NULL, NULL, 0, 0, NULL, 0, NULL),
(84, 4, 'meta_description', NULL, NULL, 'varchar', NULL, NULL, 'textarea', 'Meta Description', NULL, NULL, 0, 0, NULL, 0, 'Maximum 255 chars'),
(85, 4, 'image', NULL, NULL, 'varchar', NULL, 'catalog/product_attribute_frontend_image', 'media_image', 'Base Image', NULL, NULL, 0, 0, NULL, 0, NULL),
(86, 4, 'small_image', NULL, NULL, 'varchar', NULL, 'catalog/product_attribute_frontend_image', 'media_image', 'Small Image', NULL, NULL, 0, 0, NULL, 0, NULL),
(87, 4, 'thumbnail', NULL, NULL, 'varchar', NULL, 'catalog/product_attribute_frontend_image', 'media_image', 'Thumbnail', NULL, NULL, 0, 0, NULL, 0, NULL),
(88, 4, 'media_gallery', NULL, 'catalog/product_attribute_backend_media', 'varchar', NULL, NULL, 'gallery', 'Media Gallery', NULL, NULL, 0, 0, NULL, 0, NULL),
(89, 4, 'old_id', NULL, NULL, 'int', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(90, 4, 'group_price', NULL, 'catalog/product_attribute_backend_groupprice', 'decimal', NULL, NULL, 'text', 'Group Price', NULL, NULL, 0, 0, NULL, 0, NULL),
(91, 4, 'tier_price', NULL, 'catalog/product_attribute_backend_tierprice', 'decimal', NULL, NULL, 'text', 'Tier Price', NULL, NULL, 0, 0, NULL, 0, NULL),
(92, 4, 'color', NULL, NULL, 'int', NULL, NULL, 'select', 'Color', NULL, NULL, 0, 1, '5', 0, NULL),
(93, 4, 'news_from_date', NULL, 'catalog/product_attribute_backend_startdate', 'datetime', NULL, NULL, 'date', 'Set Product as New from Date', NULL, NULL, 0, 0, NULL, 0, NULL),
(94, 4, 'news_to_date', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, NULL, 'date', 'Set Product as New to Date', NULL, NULL, 0, 0, NULL, 0, NULL),
(95, 4, 'gallery', NULL, NULL, 'varchar', NULL, NULL, 'gallery', 'Image Gallery', NULL, NULL, 0, 0, NULL, 0, NULL),
(96, 4, 'status', NULL, NULL, 'int', NULL, NULL, 'select', 'Status', NULL, 'catalog/product_status', 1, 0, NULL, 0, NULL),
(97, 4, 'url_key', NULL, 'catalog/product_attribute_backend_urlkey', 'varchar', NULL, NULL, 'text', 'URL Key', NULL, NULL, 0, 0, NULL, 0, NULL),
(98, 4, 'url_path', NULL, NULL, 'varchar', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(99, 4, 'minimal_price', NULL, NULL, 'decimal', NULL, NULL, 'price', 'Minimal Price', NULL, NULL, 0, 0, NULL, 0, NULL),
(100, 4, 'is_recurring', NULL, NULL, 'int', NULL, NULL, 'select', 'Enable Recurring Profile', NULL, 'eav/entity_attribute_source_boolean', 0, 0, NULL, 0, 'Products with recurring profile participate in catalog as nominal items.'),
(101, 4, 'recurring_profile', NULL, 'catalog/product_attribute_backend_recurring', 'text', NULL, NULL, 'text', 'Recurring Payment Profile', NULL, NULL, 0, 0, NULL, 0, NULL),
(102, 4, 'visibility', NULL, NULL, 'int', NULL, NULL, 'select', 'Visibility', NULL, 'catalog/product_visibility', 1, 0, '4', 0, NULL),
(103, 4, 'custom_design', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Custom Design', NULL, 'core/design_source_design', 0, 0, NULL, 0, NULL),
(104, 4, 'custom_design_from', NULL, 'catalog/product_attribute_backend_startdate', 'datetime', NULL, NULL, 'date', 'Active From', NULL, NULL, 0, 0, NULL, 0, NULL),
(105, 4, 'custom_design_to', NULL, 'eav/entity_attribute_backend_datetime', 'datetime', NULL, NULL, 'date', 'Active To', NULL, NULL, 0, 0, NULL, 0, NULL),
(106, 4, 'custom_layout_update', NULL, 'catalog/attribute_backend_customlayoutupdate', 'text', NULL, NULL, 'textarea', 'Custom Layout Update', NULL, NULL, 0, 0, NULL, 0, NULL),
(107, 4, 'page_layout', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Page Layout', NULL, 'catalog/product_attribute_source_layout', 0, 0, NULL, 0, NULL),
(108, 4, 'category_ids', NULL, NULL, 'static', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(109, 4, 'options_container', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Display Product Options In', NULL, 'catalog/entity_product_attribute_design_options_container', 0, 0, 'container1', 0, NULL),
(110, 4, 'required_options', NULL, NULL, 'static', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(111, 4, 'has_options', NULL, NULL, 'static', NULL, NULL, 'text', NULL, NULL, NULL, 0, 0, NULL, 0, NULL),
(112, 4, 'image_label', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Image Label', NULL, NULL, 0, 0, NULL, 0, NULL),
(113, 4, 'small_image_label', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Small Image Label', NULL, NULL, 0, 0, NULL, 0, NULL),
(114, 4, 'thumbnail_label', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Thumbnail Label', NULL, NULL, 0, 0, NULL, 0, NULL),
(115, 4, 'created_at', NULL, 'eav/entity_attribute_backend_time_created', 'static', NULL, NULL, 'text', NULL, NULL, NULL, 1, 0, NULL, 0, NULL),
(116, 4, 'updated_at', NULL, 'eav/entity_attribute_backend_time_updated', 'static', NULL, NULL, 'text', NULL, NULL, NULL, 1, 0, NULL, 0, NULL),
(117, 4, 'country_of_manufacture', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Country of Manufacture', NULL, 'catalog/product_attribute_source_countryofmanufacture', 0, 0, NULL, 0, NULL),
(118, 4, 'msrp_enabled', NULL, 'catalog/product_attribute_backend_msrp', 'varchar', NULL, NULL, 'select', 'Apply MAP', NULL, 'catalog/product_attribute_source_msrp_type_enabled', 0, 0, '2', 0, NULL),
(119, 4, 'msrp_display_actual_price_type', NULL, 'catalog/product_attribute_backend_boolean', 'varchar', NULL, NULL, 'select', 'Display Actual Price', NULL, 'catalog/product_attribute_source_msrp_type_price', 0, 0, '4', 0, NULL),
(120, 4, 'msrp', NULL, 'catalog/product_attribute_backend_price', 'decimal', NULL, NULL, 'price', 'Manufacturer''s Suggested Retail Price', NULL, NULL, 0, 0, NULL, 0, NULL),
(121, 4, 'tax_class_id', NULL, NULL, 'int', NULL, NULL, 'select', 'Tax Class', NULL, 'tax/class_source_product', 1, 0, NULL, 0, NULL),
(122, 4, 'gift_message_available', NULL, 'catalog/product_attribute_backend_boolean', 'varchar', NULL, NULL, 'select', 'Allow Gift Message', NULL, 'eav/entity_attribute_source_boolean', 0, 0, NULL, 0, NULL),
(123, 4, 'price_type', NULL, NULL, 'int', NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, 0, NULL),
(124, 4, 'sku_type', NULL, NULL, 'int', NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, 0, NULL),
(125, 4, 'weight_type', NULL, NULL, 'int', NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, NULL, 0, NULL),
(126, 4, 'price_view', NULL, NULL, 'int', NULL, NULL, 'select', 'Price View', NULL, 'bundle/product_attribute_source_price_view', 1, 0, NULL, 0, NULL),
(127, 4, 'shipment_type', NULL, NULL, 'int', NULL, NULL, NULL, 'Shipment', NULL, NULL, 1, 0, NULL, 0, NULL),
(128, 4, 'links_purchased_separately', NULL, NULL, 'int', NULL, NULL, NULL, 'Links can be purchased separately', NULL, NULL, 1, 0, NULL, 0, NULL),
(129, 4, 'samples_title', NULL, NULL, 'varchar', NULL, NULL, NULL, 'Samples title', NULL, NULL, 1, 0, NULL, 0, NULL),
(130, 4, 'links_title', NULL, NULL, 'varchar', NULL, NULL, NULL, 'Links title', NULL, NULL, 1, 0, NULL, 0, NULL),
(131, 4, 'links_exist', NULL, NULL, 'int', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, '0', 0, NULL),
(154, 3, 'amoda_menulink', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Hide link', NULL, 'amoda/system_config_source_category_status', 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(155, 3, 'amoda_label', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Label', NULL, NULL, 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(156, 3, 'amoda_groupsubcat', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Group Subcategories', NULL, 'amoda/system_config_source_category_status', 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(157, 3, 'amoda_subcat_w', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Width for subcategories block', NULL, 'amoda/system_config_source_category_colWidth', 0, 1, NULL, 0, 'This field is applicable only for top-level categories and drop with subcategories and blocks.'),
(158, 3, 'amoda_subcat_colw', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Col width for subcategories', NULL, 'amoda/system_config_source_category_colWidth', 0, 1, NULL, 0, 'This field is applicable only for top-level categories and group subcategories.'),
(159, 3, 'amoda_menutype', NULL, NULL, 'varchar', NULL, NULL, 'select', 'Dropdown with', NULL, 'amoda/system_config_source_category_types', 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(160, 3, 'amoda_block_r', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Block Right', NULL, NULL, 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(161, 3, 'amoda_block_t', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Block Top', NULL, NULL, 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(162, 3, 'amoda_block_b', NULL, NULL, 'text', NULL, NULL, 'textarea', 'Block Bottom', NULL, NULL, 0, 1, NULL, 0, 'This field is applicable only for top-level categories.'),
(163, 3, 'amoda_custom_icon', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Icon', NULL, NULL, 0, 1, NULL, 0, 'Icon for navigation menu See more icon <a target="_blank" href="http://fortawesome.github.io/Font-Awesome/icons/">here</a>'),
(164, 3, 'amoda_title_alias', NULL, NULL, 'varchar', NULL, NULL, 'text', 'Name alias', NULL, NULL, 0, 1, NULL, 0, 'This field is applicable only for top-level categories.');

CREATE TABLE IF NOT EXISTS `#__eav_attribute_group` (
`attribute_group_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Group Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `attribute_group_name` varchar(255) DEFAULT NULL COMMENT 'Attribute Group Name',
  `sort_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `default_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Default Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Attribute Group' AUTO_INCREMENT=19 ;

INSERT INTO `#__eav_attribute_group` (`attribute_group_id`, `attribute_set_id`, `attribute_group_name`, `sort_order`, `default_id`) VALUES
(1, 1, 'General', 1, 1),
(2, 2, 'General', 1, 1),
(3, 3, 'General', 10, 1),
(4, 3, 'General Information', 2, 0),
(5, 3, 'Display Settings', 20, 0),
(6, 3, 'Custom Design', 30, 0),
(7, 4, 'General', 1, 1),
(8, 4, 'Prices', 2, 0),
(9, 4, 'Meta Information', 3, 0),
(10, 4, 'Images', 4, 0),
(11, 4, 'Recurring Profile', 5, 0),
(12, 4, 'Design', 6, 0),
(13, 5, 'General', 1, 1),
(14, 6, 'General', 1, 1),
(15, 7, 'General', 1, 1),
(16, 8, 'General', 1, 1),
(17, 4, 'Gift Options', 7, 0),
(18, 3, 'Amoda Menu', 31, 0);

CREATE TABLE IF NOT EXISTS `#__eav_attribute_label` (
`attribute_label_id` int(10) unsigned NOT NULL COMMENT 'Attribute Label Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Attribute Label' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_attribute_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Attribute Option' AUTO_INCREMENT=17 ;

INSERT INTO `#__eav_attribute_option` (`option_id`, `attribute_id`, `sort_order`) VALUES
(1, 18, 0),
(2, 18, 1),
(3, 92, 0),
(4, 92, 0),
(5, 92, 0),
(6, 92, 0),
(7, 92, 0),
(8, 92, 0),
(9, 81, 0),
(10, 81, 0),
(11, 81, 0),
(12, 81, 0),
(13, 81, 0),
(14, 81, 0),
(15, 81, 0),
(16, 81, 0);

CREATE TABLE IF NOT EXISTS `#__eav_attribute_option_value` (
`value_id` int(10) unsigned NOT NULL COMMENT 'Value Id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Option Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `value` varchar(255) DEFAULT NULL COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Attribute Option Value' AUTO_INCREMENT=79 ;

INSERT INTO `#__eav_attribute_option_value` (`value_id`, `option_id`, `store_id`, `value`) VALUES
(1, 1, 0, 'Male'),
(2, 2, 0, 'Female'),
(51, 9, 0, 'Buberry'),
(52, 9, 1, 'Buberry'),
(53, 10, 0, 'Armani'),
(54, 10, 1, 'Armani'),
(55, 11, 0, 'Prada'),
(56, 11, 1, 'Prada'),
(57, 12, 0, 'Dior'),
(58, 12, 1, 'Dior'),
(59, 13, 0, 'Gucci'),
(60, 13, 1, 'Gucci'),
(61, 14, 0, 'Hermes'),
(62, 14, 1, 'Hermes'),
(63, 15, 0, 'Chanel'),
(64, 15, 1, 'Chanel'),
(65, 16, 0, 'Versace'),
(66, 16, 1, 'Versace'),
(67, 3, 0, 'Black'),
(68, 3, 1, 'Black'),
(69, 4, 0, 'Blue'),
(70, 4, 1, 'Blue'),
(71, 6, 0, 'Green'),
(72, 6, 1, 'Green'),
(73, 5, 0, 'Red'),
(74, 5, 1, 'Red'),
(75, 8, 0, 'White'),
(76, 8, 1, 'White'),
(77, 7, 0, 'Yellow'),
(78, 7, 1, 'Yellow');

CREATE TABLE IF NOT EXISTS `#__eav_attribute_set` (
`attribute_set_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Set Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_set_name` varchar(255) DEFAULT NULL COMMENT 'Attribute Set Name',
  `sort_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Attribute Set' AUTO_INCREMENT=9 ;

INSERT INTO `#__eav_attribute_set` (`attribute_set_id`, `entity_type_id`, `attribute_set_name`, `sort_order`) VALUES
(1, 1, 'Default', 1),
(2, 2, 'Default', 1),
(3, 3, 'Default', 1),
(4, 4, 'Default', 1),
(5, 5, 'Default', 1),
(6, 6, 'Default', 1),
(7, 7, 'Default', 1),
(8, 8, 'Default', 1);

CREATE TABLE IF NOT EXISTS `#__eav_entity` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Parent Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `is_active` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Defines Is Entity Active'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_entity_attribute` (
`entity_attribute_id` int(10) unsigned NOT NULL COMMENT 'Entity Attribute Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Set Id',
  `attribute_group_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Group Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `sort_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Entity Attributes' AUTO_INCREMENT=247 ;

INSERT INTO `#__eav_entity_attribute` (`entity_attribute_id`, `entity_type_id`, `attribute_set_id`, `attribute_group_id`, `attribute_id`, `sort_order`) VALUES
(1, 1, 1, 1, 1, 10),
(2, 1, 1, 1, 2, 0),
(3, 1, 1, 1, 3, 20),
(4, 1, 1, 1, 4, 30),
(5, 1, 1, 1, 5, 40),
(6, 1, 1, 1, 6, 50),
(7, 1, 1, 1, 7, 60),
(8, 1, 1, 1, 8, 70),
(9, 1, 1, 1, 9, 80),
(10, 1, 1, 1, 10, 25),
(11, 1, 1, 1, 11, 90),
(12, 1, 1, 1, 12, 0),
(13, 1, 1, 1, 13, 0),
(14, 1, 1, 1, 14, 0),
(15, 1, 1, 1, 15, 100),
(16, 1, 1, 1, 16, 0),
(17, 1, 1, 1, 17, 86),
(18, 1, 1, 1, 18, 110),
(19, 2, 2, 2, 19, 10),
(20, 2, 2, 2, 20, 20),
(21, 2, 2, 2, 21, 30),
(22, 2, 2, 2, 22, 40),
(23, 2, 2, 2, 23, 50),
(24, 2, 2, 2, 24, 60),
(25, 2, 2, 2, 25, 70),
(26, 2, 2, 2, 26, 80),
(27, 2, 2, 2, 27, 90),
(28, 2, 2, 2, 28, 100),
(29, 2, 2, 2, 29, 100),
(30, 2, 2, 2, 30, 110),
(31, 2, 2, 2, 31, 120),
(32, 2, 2, 2, 32, 130),
(33, 1, 1, 1, 33, 111),
(34, 1, 1, 1, 34, 112),
(35, 1, 1, 1, 35, 28),
(36, 2, 2, 2, 36, 140),
(37, 2, 2, 2, 37, 132),
(38, 2, 2, 2, 38, 133),
(39, 2, 2, 2, 39, 134),
(40, 2, 2, 2, 40, 135),
(41, 3, 3, 4, 41, 1),
(42, 3, 3, 4, 42, 2),
(43, 3, 3, 4, 43, 3),
(44, 3, 3, 4, 44, 4),
(45, 3, 3, 4, 45, 5),
(46, 3, 3, 4, 46, 6),
(47, 3, 3, 4, 47, 7),
(48, 3, 3, 4, 48, 8),
(49, 3, 3, 5, 49, 10),
(50, 3, 3, 5, 50, 20),
(51, 3, 3, 5, 51, 30),
(52, 3, 3, 4, 52, 12),
(53, 3, 3, 4, 53, 13),
(54, 3, 3, 4, 54, 14),
(55, 3, 3, 4, 55, 15),
(56, 3, 3, 4, 56, 16),
(57, 3, 3, 4, 57, 17),
(58, 3, 3, 6, 58, 10),
(59, 3, 3, 6, 59, 30),
(60, 3, 3, 6, 60, 40),
(61, 3, 3, 6, 61, 50),
(62, 3, 3, 6, 62, 60),
(63, 3, 3, 4, 63, 24),
(64, 3, 3, 4, 64, 25),
(65, 3, 3, 5, 65, 40),
(66, 3, 3, 5, 66, 50),
(67, 3, 3, 4, 67, 10),
(68, 3, 3, 6, 68, 5),
(69, 3, 3, 6, 69, 6),
(70, 3, 3, 5, 70, 51),
(88, 4, 4, 7, 89, 6),
(96, 4, 4, 7, 98, 11),
(97, 4, 4, 8, 99, 8),
(106, 4, 4, 7, 108, 13),
(108, 4, 4, 7, 110, 14),
(109, 4, 4, 7, 111, 15),
(110, 4, 4, 7, 112, 16),
(111, 4, 4, 7, 113, 17),
(112, 4, 4, 7, 114, 18),
(113, 4, 4, 7, 115, 19),
(114, 4, 4, 7, 116, 20),
(121, 4, 4, 7, 123, 22),
(122, 4, 4, 7, 124, 23),
(123, 4, 4, 7, 125, 24),
(125, 4, 4, 7, 127, 25),
(126, 4, 4, 7, 128, 26),
(127, 4, 4, 7, 129, 27),
(128, 4, 4, 7, 130, 28),
(129, 4, 4, 7, 131, 29),
(131, 4, 4, 7, 71, 1),
(133, 4, 4, 7, 72, 2),
(135, 4, 4, 7, 73, 3),
(137, 4, 4, 7, 74, 4),
(139, 4, 4, 7, 80, 5),
(141, 4, 4, 7, 81, 12),
(143, 4, 4, 7, 92, 11),
(145, 4, 4, 7, 93, 6),
(147, 4, 4, 7, 94, 7),
(149, 4, 4, 7, 96, 8),
(151, 4, 4, 7, 97, 9),
(153, 4, 4, 7, 102, 10),
(155, 4, 4, 7, 117, 13),
(157, 4, 4, 8, 75, 1),
(159, 4, 4, 8, 76, 3),
(161, 4, 4, 8, 77, 4),
(163, 4, 4, 8, 78, 5),
(165, 4, 4, 8, 79, 6),
(167, 4, 4, 8, 90, 2),
(169, 4, 4, 8, 91, 7),
(171, 4, 4, 8, 118, 8),
(173, 4, 4, 8, 119, 9),
(175, 4, 4, 8, 120, 10),
(177, 4, 4, 8, 121, 11),
(179, 4, 4, 8, 126, 12),
(181, 4, 4, 9, 82, 1),
(183, 4, 4, 9, 83, 2),
(185, 4, 4, 9, 84, 3),
(187, 4, 4, 10, 85, 1),
(189, 4, 4, 10, 86, 2),
(191, 4, 4, 10, 87, 3),
(193, 4, 4, 10, 88, 4),
(195, 4, 4, 10, 95, 5),
(197, 4, 4, 11, 100, 1),
(199, 4, 4, 11, 101, 2),
(201, 4, 4, 12, 103, 1),
(203, 4, 4, 12, 104, 2),
(205, 4, 4, 12, 105, 3),
(207, 4, 4, 12, 106, 4),
(209, 4, 4, 12, 107, 5),
(211, 4, 4, 12, 109, 6),
(213, 4, 4, 17, 122, 1),
(214, 3, 3, 18, 132, 1),
(215, 3, 3, 18, 133, 2),
(216, 3, 3, 18, 134, 3),
(217, 3, 3, 18, 135, 4),
(218, 3, 3, 18, 136, 5),
(219, 3, 3, 18, 137, 6),
(220, 3, 3, 18, 138, 7),
(221, 3, 3, 18, 139, 8),
(222, 3, 3, 18, 140, 9),
(223, 3, 3, 4, 141, 2),
(224, 3, 3, 4, 142, 2),
(225, 3, 3, 18, 143, 10),
(226, 3, 3, 18, 144, 11),
(227, 3, 3, 18, 145, 12),
(228, 3, 3, 18, 146, 13),
(229, 3, 3, 18, 147, 14),
(230, 3, 3, 18, 148, 15),
(231, 3, 3, 18, 149, 16),
(232, 3, 3, 18, 150, 17),
(233, 3, 3, 18, 151, 18),
(234, 3, 3, 4, 152, 2),
(235, 3, 3, 4, 153, 2),
(236, 3, 3, 18, 154, 19),
(237, 3, 3, 18, 155, 20),
(238, 3, 3, 18, 156, 21),
(239, 3, 3, 18, 157, 22),
(240, 3, 3, 18, 158, 23),
(241, 3, 3, 18, 159, 24),
(242, 3, 3, 18, 160, 25),
(243, 3, 3, 18, 161, 26),
(244, 3, 3, 18, 162, 27),
(245, 3, 3, 4, 163, 2),
(246, 3, 3, 4, 164, 2);

CREATE TABLE IF NOT EXISTS `#__eav_entity_datetime` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Attribute Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity Value Prefix' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_entity_decimal` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Attribute Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity Value Prefix' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_entity_int` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` int(11) NOT NULL DEFAULT '0' COMMENT 'Attribute Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity Value Prefix' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_entity_store` (
`entity_store_id` int(10) unsigned NOT NULL COMMENT 'Entity Store Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `increment_prefix` varchar(20) DEFAULT NULL COMMENT 'Increment Prefix',
  `increment_last_id` varchar(50) DEFAULT NULL COMMENT 'Last Incremented Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Entity Store' AUTO_INCREMENT=2 ;

INSERT INTO `#__eav_entity_store` (`entity_store_id`, `entity_type_id`, `store_id`, `increment_prefix`, `increment_last_id`) VALUES
(1, 5, 1, '1', '100000001');

CREATE TABLE IF NOT EXISTS `#__eav_entity_text` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` text NOT NULL COMMENT 'Attribute Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity Value Prefix' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_entity_type` (
`entity_type_id` smallint(5) unsigned NOT NULL COMMENT 'Entity Type Id',
  `entity_type_code` varchar(50) NOT NULL COMMENT 'Entity Type Code',
  `entity_model` varchar(255) NOT NULL COMMENT 'Entity Model',
  `attribute_model` varchar(255) DEFAULT NULL COMMENT 'Attribute Model',
  `entity_table` varchar(255) DEFAULT NULL COMMENT 'Entity Table',
  `value_table_prefix` varchar(255) DEFAULT NULL COMMENT 'Value Table Prefix',
  `entity_id_field` varchar(255) DEFAULT NULL COMMENT 'Entity Id Field',
  `is_data_sharing` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Defines Is Data Sharing',
  `data_sharing_key` varchar(100) DEFAULT 'default' COMMENT 'Data Sharing Key',
  `default_attribute_set_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Default Attribute Set Id',
  `increment_model` varchar(255) DEFAULT '' COMMENT 'Increment Model',
  `increment_per_store` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Increment Per Store',
  `increment_pad_length` smallint(5) unsigned NOT NULL DEFAULT '8' COMMENT 'Increment Pad Length',
  `increment_pad_char` varchar(1) NOT NULL DEFAULT '0' COMMENT 'Increment Pad Char',
  `additional_attribute_table` varchar(255) DEFAULT '' COMMENT 'Additional Attribute Table',
  `entity_attribute_collection` varchar(255) DEFAULT NULL COMMENT 'Entity Attribute Collection'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Entity Type' AUTO_INCREMENT=9 ;

INSERT INTO `#__eav_entity_type` (`entity_type_id`, `entity_type_code`, `entity_model`, `attribute_model`, `entity_table`, `value_table_prefix`, `entity_id_field`, `is_data_sharing`, `data_sharing_key`, `default_attribute_set_id`, `increment_model`, `increment_per_store`, `increment_pad_length`, `increment_pad_char`, `additional_attribute_table`, `entity_attribute_collection`) VALUES
(1, 'customer', 'customer/customer', 'customer/attribute', 'customer/entity', NULL, NULL, 1, 'default', 1, 'eav/entity_increment_numeric', 0, 8, '0', 'customer/eav_attribute', 'customer/attribute_collection'),
(2, 'customer_address', 'customer/address', 'customer/attribute', 'customer/address_entity', NULL, NULL, 1, 'default', 2, NULL, 0, 8, '0', 'customer/eav_attribute', 'customer/address_attribute_collection'),
(3, 'catalog_category', 'catalog/category', 'catalog/resource_eav_attribute', 'catalog/category', NULL, NULL, 1, 'default', 3, NULL, 0, 8, '0', 'catalog/eav_attribute', 'catalog/category_attribute_collection'),
(4, 'catalog_product', 'catalog/product', 'catalog/resource_eav_attribute', 'catalog/product', NULL, NULL, 1, 'default', 4, NULL, 0, 8, '0', 'catalog/eav_attribute', 'catalog/product_attribute_collection'),
(5, 'order', 'sales/order', NULL, 'sales/order', NULL, NULL, 1, 'default', 0, 'eav/entity_increment_numeric', 1, 8, '0', NULL, NULL),
(6, 'invoice', 'sales/order_invoice', NULL, 'sales/invoice', NULL, NULL, 1, 'default', 0, 'eav/entity_increment_numeric', 1, 8, '0', NULL, NULL),
(7, 'creditmemo', 'sales/order_creditmemo', NULL, 'sales/creditmemo', NULL, NULL, 1, 'default', 0, 'eav/entity_increment_numeric', 1, 8, '0', NULL, NULL),
(8, 'shipment', 'sales/order_shipment', NULL, 'sales/shipment', NULL, NULL, 1, 'default', 0, 'eav/entity_increment_numeric', 1, 8, '0', NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__eav_entity_varchar` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `entity_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Type Id',
  `attribute_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Attribute Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `value` varchar(255) DEFAULT NULL COMMENT 'Attribute Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Entity Value Prefix' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__eav_form_element` (
`element_id` int(10) unsigned NOT NULL COMMENT 'Element Id',
  `type_id` smallint(5) unsigned NOT NULL COMMENT 'Type Id',
  `fieldset_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Fieldset Id',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id',
  `sort_order` int(11) NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Form Element' AUTO_INCREMENT=53 ;

INSERT INTO `#__eav_form_element` (`element_id`, `type_id`, `fieldset_id`, `attribute_id`, `sort_order`) VALUES
(1, 1, NULL, 20, 0),
(2, 1, NULL, 22, 1),
(3, 1, NULL, 24, 2),
(4, 1, NULL, 9, 3),
(5, 1, NULL, 25, 4),
(6, 1, NULL, 26, 5),
(7, 1, NULL, 28, 6),
(8, 1, NULL, 30, 7),
(9, 1, NULL, 27, 8),
(10, 1, NULL, 31, 9),
(11, 1, NULL, 32, 10),
(12, 2, NULL, 20, 0),
(13, 2, NULL, 22, 1),
(14, 2, NULL, 24, 2),
(15, 2, NULL, 9, 3),
(16, 2, NULL, 25, 4),
(17, 2, NULL, 26, 5),
(18, 2, NULL, 28, 6),
(19, 2, NULL, 30, 7),
(20, 2, NULL, 27, 8),
(21, 2, NULL, 31, 9),
(22, 2, NULL, 32, 10),
(23, 3, NULL, 20, 0),
(24, 3, NULL, 22, 1),
(25, 3, NULL, 24, 2),
(26, 3, NULL, 25, 3),
(27, 3, NULL, 26, 4),
(28, 3, NULL, 28, 5),
(29, 3, NULL, 30, 6),
(30, 3, NULL, 27, 7),
(31, 3, NULL, 31, 8),
(32, 3, NULL, 32, 9),
(33, 4, NULL, 20, 0),
(34, 4, NULL, 22, 1),
(35, 4, NULL, 24, 2),
(36, 4, NULL, 25, 3),
(37, 4, NULL, 26, 4),
(38, 4, NULL, 28, 5),
(39, 4, NULL, 30, 6),
(40, 4, NULL, 27, 7),
(41, 4, NULL, 31, 8),
(42, 4, NULL, 32, 9),
(43, 5, 1, 5, 0),
(44, 5, 1, 7, 1),
(45, 5, 1, 9, 2),
(46, 5, 2, 24, 0),
(47, 5, 2, 31, 1),
(48, 5, 2, 25, 2),
(49, 5, 2, 26, 3),
(50, 5, 2, 28, 4),
(51, 5, 2, 30, 5),
(52, 5, 2, 27, 6);

CREATE TABLE IF NOT EXISTS `#__eav_form_fieldset` (
`fieldset_id` smallint(5) unsigned NOT NULL COMMENT 'Fieldset Id',
  `type_id` smallint(5) unsigned NOT NULL COMMENT 'Type Id',
  `code` varchar(64) NOT NULL COMMENT 'Code',
  `sort_order` int(11) NOT NULL DEFAULT '0' COMMENT 'Sort Order'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Form Fieldset' AUTO_INCREMENT=3 ;

INSERT INTO `#__eav_form_fieldset` (`fieldset_id`, `type_id`, `code`, `sort_order`) VALUES
(1, 5, 'general', 1),
(2, 5, 'address', 2);

CREATE TABLE IF NOT EXISTS `#__eav_form_fieldset_label` (
  `fieldset_id` smallint(5) unsigned NOT NULL COMMENT 'Fieldset Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) NOT NULL COMMENT 'Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Form Fieldset Label';

INSERT INTO `#__eav_form_fieldset_label` (`fieldset_id`, `store_id`, `label`) VALUES
(1, 0, 'Personal Information'),
(2, 0, 'Address Information');

CREATE TABLE IF NOT EXISTS `#__eav_form_type` (
`type_id` smallint(5) unsigned NOT NULL COMMENT 'Type Id',
  `code` varchar(64) NOT NULL COMMENT 'Code',
  `label` varchar(255) NOT NULL COMMENT 'Label',
  `is_system` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is System',
  `theme` varchar(64) DEFAULT NULL COMMENT 'Theme',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Eav Form Type' AUTO_INCREMENT=6 ;

INSERT INTO `#__eav_form_type` (`type_id`, `code`, `label`, `is_system`, `theme`, `store_id`) VALUES
(1, 'checkout_onepage_register', 'checkout_onepage_register', 1, '', 0),
(2, 'checkout_onepage_register_guest', 'checkout_onepage_register_guest', 1, '', 0),
(3, 'checkout_onepage_billing_address', 'checkout_onepage_billing_address', 1, '', 0),
(4, 'checkout_onepage_shipping_address', 'checkout_onepage_shipping_address', 1, '', 0),
(5, 'checkout_multishipping_register', 'checkout_multishipping_register', 1, '', 0);

CREATE TABLE IF NOT EXISTS `#__eav_form_type_entity` (
  `type_id` smallint(5) unsigned NOT NULL COMMENT 'Type Id',
  `entity_type_id` smallint(5) unsigned NOT NULL COMMENT 'Entity Type Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Eav Form Type Entity';

INSERT INTO `#__eav_form_type_entity` (`type_id`, `entity_type_id`) VALUES
(1, 1),
(2, 1),
(5, 1),
(1, 2),
(2, 2),
(3, 2),
(4, 2),
(5, 2);

CREATE TABLE IF NOT EXISTS `#__gift_message` (
`gift_message_id` int(10) unsigned NOT NULL COMMENT 'GiftMessage Id',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer id',
  `sender` varchar(255) DEFAULT NULL COMMENT 'Sender',
  `recipient` varchar(255) DEFAULT NULL COMMENT 'Recipient',
  `message` text COMMENT 'Message'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Gift Message' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__importexport_importdata` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `entity` varchar(50) NOT NULL COMMENT 'Entity',
  `behavior` varchar(10) NOT NULL DEFAULT 'append' COMMENT 'Behavior',
  `data` longtext COMMENT 'Data'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Import Data Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__index_event` (
`event_id` bigint(20) unsigned NOT NULL COMMENT 'Event Id',
  `type` varchar(64) NOT NULL COMMENT 'Type',
  `entity` varchar(64) NOT NULL COMMENT 'Entity',
  `entity_pk` bigint(20) DEFAULT NULL COMMENT 'Entity Primary Key',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Creation Time',
  `old_data` mediumtext COMMENT 'Old Data',
  `new_data` mediumtext COMMENT 'New Data'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Index Event' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__index_process` (
`process_id` int(10) unsigned NOT NULL COMMENT 'Process Id',
  `indexer_code` varchar(32) NOT NULL COMMENT 'Indexer Code',
  `status` varchar(15) NOT NULL DEFAULT 'pending' COMMENT 'Status',
  `started_at` timestamp NULL DEFAULT NULL COMMENT 'Started At',
  `ended_at` timestamp NULL DEFAULT NULL COMMENT 'Ended At',
  `mode` varchar(9) NOT NULL DEFAULT 'real_time' COMMENT 'Mode'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Index Process' AUTO_INCREMENT=10 ;

INSERT INTO `#__index_process` (`process_id`, `indexer_code`, `status`, `started_at`, `ended_at`, `mode`) VALUES
(1, 'catalog_product_attribute', 'pending', '2015-07-14 19:28:23', '2015-07-14 19:28:23', 'manual'),
(2, 'catalog_product_price', 'pending', '2015-07-14 19:28:23', '2015-07-14 19:28:23', 'manual'),
(3, 'catalog_url', 'pending', '2015-07-14 19:28:23', '2015-07-14 19:28:26', 'manual'),
(4, 'catalog_product_flat', 'pending', '2015-07-14 19:28:26', '2015-07-14 19:28:30', 'manual'),
(5, 'catalog_category_flat', 'pending', '2015-07-14 19:28:30', '2015-07-14 19:28:30', 'manual'),
(6, 'catalog_category_product', 'pending', '2015-07-14 19:28:30', '2015-07-14 19:28:31', 'manual'),
(7, 'catalogsearch_fulltext', 'pending', '2015-07-14 19:28:31', '2015-07-14 19:28:31', 'manual'),
(8, 'cataloginventory_stock', 'pending', '2015-07-14 19:28:22', '2015-07-14 19:28:22', 'manual'),
(9, 'tag_summary', 'pending', '2015-07-14 19:28:31', '2015-07-14 19:28:31', 'manual');

CREATE TABLE IF NOT EXISTS `#__index_process_event` (
  `process_id` int(10) unsigned NOT NULL COMMENT 'Process Id',
  `event_id` bigint(20) unsigned NOT NULL COMMENT 'Event Id',
  `status` varchar(7) NOT NULL DEFAULT 'new' COMMENT 'Status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Index Process Event';

INSERT INTO `#__index_process_event` (`process_id`, `event_id`, `status`) VALUES
(1, 122, 'done'),
(1, 125, 'done'),
(1, 128, 'done'),
(1, 131, 'done'),
(1, 134, 'done'),
(1, 137, 'done'),
(1, 140, 'done'),
(1, 143, 'done'),
(1, 146, 'done'),
(1, 149, 'done'),
(1, 152, 'done'),
(1, 155, 'done'),
(1, 158, 'done'),
(1, 161, 'done'),
(1, 164, 'done'),
(1, 167, 'done'),
(1, 170, 'done'),
(1, 173, 'done'),
(1, 176, 'done'),
(1, 179, 'done'),
(1, 182, 'done'),
(1, 185, 'done'),
(1, 188, 'done'),
(1, 191, 'done'),
(1, 194, 'done'),
(1, 197, 'done'),
(1, 200, 'done'),
(1, 203, 'done'),
(1, 204, 'done'),
(1, 207, 'done'),
(2, 121, 'done'),
(2, 122, 'done'),
(2, 124, 'done'),
(2, 125, 'done'),
(2, 127, 'done'),
(2, 128, 'done'),
(2, 130, 'done'),
(2, 131, 'done'),
(2, 133, 'done'),
(2, 134, 'done'),
(2, 136, 'done'),
(2, 137, 'done'),
(2, 139, 'done'),
(2, 140, 'done'),
(2, 142, 'done'),
(2, 143, 'done'),
(2, 145, 'done'),
(2, 146, 'done'),
(2, 148, 'done'),
(2, 149, 'done'),
(2, 151, 'done'),
(2, 152, 'done'),
(2, 154, 'done'),
(2, 155, 'done'),
(2, 157, 'done'),
(2, 158, 'done'),
(2, 160, 'done'),
(2, 161, 'done'),
(2, 163, 'done'),
(2, 164, 'done'),
(2, 166, 'done'),
(2, 167, 'done'),
(2, 169, 'done'),
(2, 170, 'done'),
(2, 172, 'done'),
(2, 173, 'done'),
(2, 175, 'done'),
(2, 176, 'done'),
(2, 178, 'done'),
(2, 179, 'done'),
(2, 181, 'done'),
(2, 182, 'done'),
(2, 184, 'done'),
(2, 185, 'done'),
(2, 187, 'done'),
(2, 188, 'done'),
(2, 190, 'done'),
(2, 191, 'done'),
(2, 193, 'done'),
(2, 194, 'done'),
(2, 196, 'done'),
(2, 197, 'done'),
(2, 199, 'done'),
(2, 200, 'done'),
(2, 202, 'done'),
(2, 203, 'done'),
(2, 204, 'done'),
(2, 206, 'done'),
(2, 207, 'done'),
(3, 1, 'done'),
(3, 2, 'done'),
(3, 3, 'done'),
(3, 4, 'done'),
(3, 5, 'done'),
(3, 6, 'done'),
(3, 7, 'done'),
(3, 8, 'done'),
(3, 71, 'done'),
(3, 72, 'done'),
(3, 73, 'done'),
(3, 118, 'done'),
(3, 119, 'done'),
(3, 122, 'done'),
(3, 125, 'done'),
(3, 128, 'done'),
(3, 131, 'done'),
(3, 134, 'done'),
(3, 137, 'done'),
(3, 140, 'done'),
(3, 143, 'done'),
(3, 146, 'done'),
(3, 149, 'done'),
(3, 152, 'done'),
(3, 155, 'done'),
(3, 158, 'done'),
(3, 161, 'done'),
(3, 164, 'done'),
(3, 167, 'done'),
(3, 170, 'done'),
(3, 173, 'done'),
(3, 176, 'done'),
(3, 179, 'done'),
(3, 182, 'done'),
(3, 185, 'done'),
(3, 188, 'done'),
(3, 191, 'done'),
(3, 194, 'done'),
(3, 197, 'done'),
(3, 200, 'done'),
(3, 203, 'done'),
(3, 207, 'done'),
(4, 71, 'done'),
(4, 72, 'done'),
(4, 73, 'done'),
(4, 122, 'done'),
(4, 125, 'done'),
(4, 128, 'done'),
(4, 131, 'done'),
(4, 134, 'done'),
(4, 137, 'done'),
(4, 140, 'done'),
(4, 143, 'done'),
(4, 146, 'done'),
(4, 149, 'done'),
(4, 152, 'done'),
(4, 155, 'done'),
(4, 158, 'done'),
(4, 161, 'done'),
(4, 164, 'done'),
(4, 167, 'done'),
(4, 170, 'done'),
(4, 173, 'done'),
(4, 176, 'done'),
(4, 179, 'done'),
(4, 182, 'done'),
(4, 185, 'done'),
(4, 188, 'done'),
(4, 191, 'done'),
(4, 194, 'done'),
(4, 197, 'done'),
(4, 200, 'done'),
(4, 203, 'done'),
(4, 207, 'done'),
(5, 1, 'done'),
(5, 2, 'done'),
(5, 3, 'done'),
(5, 4, 'done'),
(5, 5, 'done'),
(5, 6, 'done'),
(5, 7, 'done'),
(5, 8, 'done'),
(5, 71, 'done'),
(5, 72, 'done'),
(5, 73, 'done'),
(5, 118, 'done'),
(5, 119, 'done'),
(6, 1, 'done'),
(6, 2, 'done'),
(6, 3, 'done'),
(6, 4, 'done'),
(6, 5, 'done'),
(6, 6, 'done'),
(6, 7, 'done'),
(6, 8, 'done'),
(6, 71, 'done'),
(6, 72, 'done'),
(6, 73, 'done'),
(6, 118, 'done'),
(6, 119, 'done'),
(6, 122, 'done'),
(6, 125, 'done'),
(6, 128, 'done'),
(6, 131, 'done'),
(6, 134, 'done'),
(6, 137, 'done'),
(6, 140, 'done'),
(6, 143, 'done'),
(6, 146, 'done'),
(6, 149, 'done'),
(6, 152, 'done'),
(6, 155, 'done'),
(6, 158, 'done'),
(6, 161, 'done'),
(6, 164, 'done'),
(6, 167, 'done'),
(6, 170, 'done'),
(6, 173, 'done'),
(6, 176, 'done'),
(6, 179, 'done'),
(6, 182, 'done'),
(6, 185, 'done'),
(6, 188, 'done'),
(6, 191, 'done'),
(6, 194, 'done'),
(6, 197, 'done'),
(6, 200, 'done'),
(6, 203, 'done'),
(6, 207, 'done'),
(7, 1, 'done'),
(7, 2, 'done'),
(7, 3, 'done'),
(7, 4, 'done'),
(7, 5, 'done'),
(7, 6, 'done'),
(7, 7, 'done'),
(7, 8, 'done'),
(7, 71, 'done'),
(7, 72, 'done'),
(7, 73, 'done'),
(7, 118, 'done'),
(7, 119, 'done'),
(7, 122, 'done'),
(7, 125, 'done'),
(7, 128, 'done'),
(7, 131, 'done'),
(7, 134, 'done'),
(7, 137, 'done'),
(7, 140, 'done'),
(7, 143, 'done'),
(7, 146, 'done'),
(7, 149, 'done'),
(7, 152, 'done'),
(7, 155, 'done'),
(7, 158, 'done'),
(7, 161, 'done'),
(7, 164, 'done'),
(7, 167, 'done'),
(7, 170, 'done'),
(7, 173, 'done'),
(7, 176, 'done'),
(7, 179, 'done'),
(7, 182, 'done'),
(7, 185, 'done'),
(7, 188, 'done'),
(7, 191, 'done'),
(7, 194, 'done'),
(7, 197, 'done'),
(7, 200, 'done'),
(7, 203, 'done'),
(7, 204, 'done'),
(7, 207, 'done'),
(8, 71, 'done'),
(8, 72, 'done'),
(8, 73, 'done'),
(8, 120, 'done'),
(8, 122, 'done'),
(8, 123, 'done'),
(8, 125, 'done'),
(8, 126, 'done'),
(8, 128, 'done'),
(8, 129, 'done'),
(8, 131, 'done'),
(8, 132, 'done'),
(8, 134, 'done'),
(8, 135, 'done'),
(8, 137, 'done'),
(8, 138, 'done'),
(8, 140, 'done'),
(8, 141, 'done'),
(8, 143, 'done'),
(8, 144, 'done'),
(8, 146, 'done'),
(8, 147, 'done'),
(8, 149, 'done'),
(8, 150, 'done'),
(8, 152, 'done'),
(8, 153, 'done'),
(8, 155, 'done'),
(8, 156, 'done'),
(8, 158, 'done'),
(8, 159, 'done'),
(8, 161, 'done'),
(8, 162, 'done'),
(8, 164, 'done'),
(8, 165, 'done'),
(8, 167, 'done'),
(8, 168, 'done'),
(8, 170, 'done'),
(8, 171, 'done'),
(8, 173, 'done'),
(8, 174, 'done'),
(8, 176, 'done'),
(8, 177, 'done'),
(8, 179, 'done'),
(8, 180, 'done'),
(8, 182, 'done'),
(8, 183, 'done'),
(8, 185, 'done'),
(8, 186, 'done'),
(8, 188, 'done'),
(8, 189, 'done'),
(8, 191, 'done'),
(8, 192, 'done'),
(8, 194, 'done'),
(8, 195, 'done'),
(8, 197, 'done'),
(8, 198, 'done'),
(8, 200, 'done'),
(8, 201, 'done'),
(8, 203, 'done'),
(8, 204, 'done'),
(8, 205, 'done'),
(8, 207, 'done'),
(9, 9, 'done'),
(9, 10, 'done'),
(9, 11, 'done'),
(9, 12, 'done'),
(9, 13, 'done'),
(9, 14, 'done'),
(9, 15, 'done'),
(9, 16, 'done'),
(9, 17, 'done'),
(9, 18, 'done'),
(9, 19, 'done'),
(9, 20, 'done'),
(9, 21, 'done'),
(9, 22, 'done'),
(9, 23, 'done'),
(9, 24, 'done'),
(9, 25, 'done'),
(9, 26, 'done'),
(9, 27, 'done'),
(9, 28, 'done'),
(9, 29, 'done'),
(9, 30, 'done'),
(9, 31, 'done'),
(9, 32, 'done'),
(9, 33, 'done'),
(9, 34, 'done'),
(9, 35, 'done'),
(9, 36, 'done'),
(9, 37, 'done'),
(9, 38, 'done'),
(9, 39, 'done'),
(9, 40, 'done'),
(9, 41, 'done'),
(9, 42, 'done'),
(9, 43, 'done'),
(9, 44, 'done'),
(9, 45, 'done'),
(9, 46, 'done'),
(9, 47, 'done'),
(9, 48, 'done'),
(9, 49, 'done'),
(9, 50, 'done'),
(9, 51, 'done'),
(9, 52, 'done'),
(9, 53, 'done'),
(9, 54, 'done'),
(9, 55, 'done'),
(9, 56, 'done'),
(9, 57, 'done'),
(9, 58, 'done'),
(9, 59, 'done'),
(9, 60, 'done'),
(9, 61, 'done'),
(9, 62, 'done'),
(9, 63, 'done'),
(9, 64, 'done'),
(9, 65, 'done'),
(9, 66, 'done'),
(9, 67, 'done'),
(9, 68, 'done'),
(9, 69, 'done'),
(9, 70, 'done'),
(9, 74, 'done'),
(9, 75, 'done'),
(9, 76, 'done'),
(9, 77, 'done'),
(9, 78, 'done'),
(9, 79, 'done'),
(9, 80, 'done'),
(9, 81, 'done'),
(9, 82, 'done'),
(9, 83, 'done'),
(9, 84, 'done'),
(9, 85, 'done'),
(9, 86, 'done'),
(9, 87, 'done'),
(9, 88, 'done'),
(9, 89, 'done'),
(9, 90, 'done'),
(9, 91, 'done'),
(9, 92, 'done'),
(9, 93, 'done'),
(9, 94, 'done'),
(9, 95, 'done'),
(9, 96, 'done'),
(9, 97, 'done'),
(9, 98, 'done'),
(9, 99, 'done'),
(9, 100, 'done'),
(9, 101, 'done'),
(9, 102, 'done'),
(9, 103, 'done'),
(9, 104, 'done'),
(9, 105, 'done'),
(9, 106, 'done'),
(9, 107, 'done'),
(9, 108, 'done'),
(9, 109, 'done'),
(9, 110, 'done'),
(9, 111, 'done'),
(9, 112, 'done'),
(9, 113, 'done'),
(9, 114, 'done'),
(9, 115, 'done'),
(9, 116, 'done'),
(9, 117, 'done'),
(9, 122, 'done'),
(9, 125, 'done'),
(9, 128, 'done'),
(9, 131, 'done'),
(9, 134, 'done'),
(9, 137, 'done'),
(9, 140, 'done'),
(9, 143, 'done'),
(9, 146, 'done'),
(9, 149, 'done'),
(9, 152, 'done'),
(9, 155, 'done'),
(9, 158, 'done'),
(9, 161, 'done'),
(9, 164, 'done'),
(9, 167, 'done'),
(9, 170, 'done'),
(9, 173, 'done'),
(9, 176, 'done'),
(9, 179, 'done'),
(9, 182, 'done'),
(9, 185, 'done'),
(9, 188, 'done'),
(9, 191, 'done'),
(9, 194, 'done'),
(9, 197, 'done'),
(9, 200, 'done'),
(9, 203, 'done'),
(9, 204, 'done'),
(9, 207, 'done');

CREATE TABLE IF NOT EXISTS `#__log_customer` (
`log_id` int(10) unsigned NOT NULL COMMENT 'Log ID',
  `visitor_id` bigint(20) unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `customer_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `login_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Login Time',
  `logout_at` timestamp NULL DEFAULT NULL COMMENT 'Logout Time',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Customers Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__log_quote` (
  `quote_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote ID',
  `visitor_id` bigint(20) unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Creation Time',
  `deleted_at` timestamp NULL DEFAULT NULL COMMENT 'Deletion Time'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Quotes Table';

INSERT INTO `#__log_quote` (`quote_id`, `visitor_id`, `created_at`, `deleted_at`) VALUES
(42, 28, '2015-07-01 21:36:19', NULL),
(43, 56, '2015-07-11 02:06:32', NULL),
(44, 68, '2015-07-13 02:02:00', NULL);

CREATE TABLE IF NOT EXISTS `#__log_summary` (
`summary_id` bigint(20) unsigned NOT NULL COMMENT 'Summary ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID',
  `type_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Type ID',
  `visitor_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Visitor Count',
  `customer_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Customer Count',
  `add_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Summary Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__log_summary_type` (
`type_id` smallint(5) unsigned NOT NULL COMMENT 'Type ID',
  `type_code` varchar(64) DEFAULT NULL COMMENT 'Type Code',
  `period` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Period',
  `period_type` varchar(6) NOT NULL DEFAULT 'MINUTE' COMMENT 'Period Type'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Summary Types Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__log_url` (
  `url_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'URL ID',
  `visitor_id` bigint(20) unsigned DEFAULT NULL COMMENT 'Visitor ID',
  `visit_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Visit Time'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log URL Table';

INSERT INTO `#__log_url` (`url_id`, `visitor_id`, `visit_time`) VALUES
(1, 49, '2015-06-30 02:38:46'),
(2, 49, '2015-06-30 02:39:07'),
(3, 49, '2015-06-30 02:39:14'),
(4, 1, '2015-06-30 02:39:48'),
(5, 2, '2015-06-30 02:40:13'),
(6, 2, '2015-06-30 02:40:22'),
(7, 2, '2015-06-30 02:40:26'),
(8, 2, '2015-06-30 02:40:43'),
(9, 2, '2015-06-30 02:40:51'),
(10, 2, '2015-06-30 02:40:53'),
(11, 3, '2015-06-30 02:42:12'),
(12, 3, '2015-06-30 02:42:22'),
(13, 3, '2015-06-30 02:42:27'),
(14, 4, '2015-06-30 02:42:50'),
(15, 5, '2015-06-30 02:42:47'),
(16, 3, '2015-06-30 02:42:54'),
(17, 4, '2015-06-30 02:43:02'),
(18, 4, '2015-06-30 02:43:05'),
(19, 5, '2015-06-30 02:43:02'),
(20, 5, '2015-06-30 02:43:04'),
(21, 3, '2015-06-30 02:43:06'),
(22, 3, '2015-06-30 02:43:12'),
(23, 3, '2015-06-30 02:43:15'),
(24, 4, '2015-06-30 02:45:44'),
(25, 4, '2015-06-30 02:45:53'),
(26, 4, '2015-06-30 02:46:04'),
(27, 4, '2015-06-30 02:46:09'),
(28, 4, '2015-06-30 02:46:15'),
(29, 4, '2015-06-30 02:46:22'),
(30, 4, '2015-06-30 02:46:27'),
(31, 4, '2015-06-30 02:47:29'),
(32, 4, '2015-06-30 02:55:00'),
(33, 4, '2015-06-30 02:55:06'),
(34, 4, '2015-06-30 02:55:09'),
(35, 4, '2015-06-30 02:55:24'),
(36, 4, '2015-06-30 02:55:32'),
(37, 4, '2015-06-30 02:55:36'),
(38, 3, '2015-06-30 02:55:42'),
(39, 49, '2015-06-30 02:55:50'),
(40, 3, '2015-06-30 02:55:55'),
(41, 49, '2015-06-30 02:56:04'),
(42, 3, '2015-06-30 02:56:08'),
(43, 49, '2015-06-30 02:56:10'),
(44, 3, '2015-06-30 02:56:20'),
(45, 3, '2015-06-30 02:56:30'),
(46, 3, '2015-06-30 02:56:43'),
(47, 49, '2015-06-30 02:57:19'),
(48, 4, '2015-06-30 02:58:51'),
(49, 4, '2015-06-30 03:01:40'),
(50, 4, '2015-06-30 03:01:48'),
(51, 4, '2015-06-30 03:01:53'),
(52, 3, '2015-06-30 03:03:35'),
(53, 3, '2015-06-30 03:03:49'),
(54, 3, '2015-06-30 03:03:51'),
(55, 3, '2015-06-30 03:04:21'),
(56, 3, '2015-06-30 03:04:27'),
(57, 3, '2015-06-30 03:04:32'),
(58, 49, '2015-06-30 03:04:44'),
(59, 49, '2015-06-30 03:05:07'),
(60, 49, '2015-06-30 03:05:13'),
(61, 3, '2015-06-30 03:06:12'),
(62, 3, '2015-06-30 03:06:28'),
(63, 3, '2015-06-30 03:06:30'),
(64, 49, '2015-06-30 03:10:11'),
(65, 2, '2015-06-30 03:10:25'),
(66, 3, '2015-06-30 03:10:35'),
(67, 49, '2015-06-30 03:10:38'),
(68, 2, '2015-06-30 03:10:37'),
(69, 2, '2015-06-30 03:10:43'),
(70, 49, '2015-06-30 03:10:47'),
(71, 3, '2015-06-30 03:10:48'),
(72, 3, '2015-06-30 03:10:53'),
(73, 49, '2015-06-30 03:17:37'),
(74, 49, '2015-06-30 03:17:53'),
(75, 49, '2015-06-30 03:17:58'),
(76, 49, '2015-06-30 03:18:34'),
(77, 49, '2015-06-30 03:18:49'),
(78, 49, '2015-06-30 03:18:57'),
(79, 2, '2015-06-30 03:23:47'),
(80, 2, '2015-06-30 03:23:54'),
(81, 2, '2015-06-30 03:23:57'),
(82, 49, '2015-06-30 03:25:21'),
(83, 49, '2015-06-30 03:25:39'),
(84, 49, '2015-06-30 03:25:45'),
(85, 2, '2015-06-30 03:28:09'),
(86, 2, '2015-06-30 03:28:19'),
(87, 2, '2015-06-30 03:28:21'),
(88, 3, '2015-06-30 03:28:30'),
(89, 3, '2015-06-30 03:28:39'),
(90, 3, '2015-06-30 03:28:41'),
(91, 2, '2015-06-30 03:32:05'),
(92, 2, '2015-06-30 03:32:12'),
(93, 2, '2015-06-30 03:32:14'),
(94, 6, '2015-06-30 19:06:44'),
(95, 6, '2015-06-30 19:07:01'),
(96, 6, '2015-06-30 19:07:04'),
(97, 7, '2015-06-30 19:08:53'),
(98, 7, '2015-06-30 19:16:31'),
(99, 7, '2015-06-30 19:16:36'),
(100, 8, '2015-06-30 19:17:21'),
(101, 8, '2015-06-30 19:17:35'),
(102, 8, '2015-06-30 19:17:44'),
(103, 6, '2015-06-30 19:19:57'),
(104, 6, '2015-06-30 19:20:12'),
(105, 6, '2015-06-30 19:20:15'),
(106, 9, '2015-06-30 19:21:15'),
(107, 9, '2015-06-30 19:21:23'),
(108, 9, '2015-06-30 19:21:28'),
(109, 7, '2015-06-30 19:28:38'),
(110, 7, '2015-06-30 19:28:45'),
(111, 7, '2015-06-30 19:28:50'),
(112, 8, '2015-06-30 19:31:11'),
(113, 8, '2015-06-30 19:31:39'),
(114, 8, '2015-06-30 19:31:50'),
(115, 8, '2015-06-30 19:31:55'),
(116, 7, '2015-06-30 19:33:22'),
(117, 9, '2015-06-30 19:33:32'),
(118, 9, '2015-06-30 19:33:44'),
(119, 9, '2015-06-30 19:33:49'),
(120, 9, '2015-06-30 19:35:42'),
(121, 9, '2015-06-30 19:35:47'),
(122, 9, '2015-06-30 19:35:53'),
(123, 7, '2015-06-30 19:36:00'),
(124, 7, '2015-06-30 19:36:06'),
(125, 10, '2015-06-30 19:38:37'),
(126, 10, '2015-06-30 19:38:50'),
(127, 10, '2015-06-30 19:38:56'),
(128, 11, '2015-06-30 19:49:10'),
(129, 11, '2015-06-30 19:49:32'),
(130, 11, '2015-06-30 19:49:38'),
(131, 10, '2015-06-30 19:51:21'),
(132, 10, '2015-06-30 19:51:34'),
(133, 10, '2015-06-30 19:51:40'),
(134, 12, '2015-06-30 19:57:46'),
(135, 12, '2015-06-30 19:58:08'),
(136, 12, '2015-06-30 19:58:15'),
(137, 12, '2015-06-30 20:42:21'),
(138, 12, '2015-06-30 20:42:48'),
(139, 12, '2015-06-30 20:42:55'),
(140, 12, '2015-06-30 20:52:30'),
(141, 13, '2015-06-30 20:58:09'),
(142, 13, '2015-06-30 20:58:29'),
(143, 13, '2015-06-30 21:00:25'),
(144, 13, '2015-06-30 21:00:47'),
(145, 13, '2015-06-30 21:00:58'),
(146, 13, '2015-06-30 21:01:21'),
(147, 13, '2015-06-30 21:01:43'),
(148, 13, '2015-06-30 21:01:49'),
(149, 14, '2015-06-30 21:34:21'),
(150, 14, '2015-06-30 21:34:33'),
(151, 14, '2015-06-30 21:34:37'),
(152, 12, '2015-06-30 21:36:24'),
(153, 12, '2015-06-30 21:36:40'),
(154, 12, '2015-06-30 21:36:46'),
(155, 12, '2015-06-30 21:43:08'),
(156, 12, '2015-06-30 21:43:51'),
(157, 12, '2015-06-30 21:44:01'),
(158, 12, '2015-06-30 21:44:08'),
(159, 12, '2015-06-30 21:44:20'),
(160, 12, '2015-06-30 21:44:28'),
(161, 12, '2015-06-30 21:45:46'),
(162, 12, '2015-06-30 21:46:17'),
(163, 12, '2015-06-30 21:46:25'),
(164, 12, '2015-06-30 21:46:31'),
(165, 12, '2015-06-30 21:46:45'),
(166, 12, '2015-06-30 21:46:52'),
(167, 12, '2015-06-30 21:50:37'),
(168, 12, '2015-06-30 21:55:25'),
(169, 12, '2015-06-30 21:55:39'),
(170, 12, '2015-06-30 21:55:48'),
(171, 14, '2015-06-30 21:56:08'),
(172, 14, '2015-06-30 21:56:19'),
(173, 14, '2015-06-30 21:56:28'),
(174, 12, '2015-06-30 21:59:17'),
(175, 12, '2015-06-30 21:59:39'),
(176, 12, '2015-06-30 21:59:44'),
(177, 15, '2015-07-01 00:31:10'),
(178, 15, '2015-07-01 00:31:36'),
(179, 15, '2015-07-01 00:31:41'),
(180, 15, '2015-07-01 00:44:10'),
(181, 15, '2015-07-01 00:44:29'),
(182, 15, '2015-07-01 00:44:37'),
(183, 16, '2015-07-01 01:38:21'),
(184, 16, '2015-07-01 01:38:40'),
(185, 16, '2015-07-01 01:38:49'),
(186, 16, '2015-07-01 02:37:29'),
(187, 16, '2015-07-01 02:38:23'),
(188, 16, '2015-07-01 02:38:40'),
(189, 17, '2015-07-01 02:39:34'),
(190, 17, '2015-07-01 02:40:02'),
(191, 17, '2015-07-01 02:40:08'),
(192, 17, '2015-07-01 02:41:41'),
(193, 17, '2015-07-01 02:42:15'),
(194, 17, '2015-07-01 02:42:24'),
(195, 17, '2015-07-01 02:58:21'),
(196, 18, '2015-07-01 02:58:32'),
(197, 18, '2015-07-01 02:58:43'),
(198, 18, '2015-07-01 02:58:52'),
(199, 18, '2015-07-01 03:03:23'),
(200, 18, '2015-07-01 03:03:46'),
(201, 18, '2015-07-01 03:03:55'),
(202, 17, '2015-07-01 03:04:00'),
(203, 17, '2015-07-01 03:04:17'),
(204, 17, '2015-07-01 03:04:25'),
(205, 18, '2015-07-01 03:08:49'),
(206, 18, '2015-07-01 03:09:03'),
(207, 17, '2015-07-01 03:09:04'),
(208, 18, '2015-07-01 03:09:13'),
(209, 17, '2015-07-01 03:09:30'),
(210, 17, '2015-07-01 03:09:36'),
(211, 18, '2015-07-01 03:11:21'),
(212, 19, '2015-07-01 03:11:23'),
(213, 19, '2015-07-01 03:11:31'),
(214, 19, '2015-07-01 03:11:35'),
(215, 18, '2015-07-01 03:11:39'),
(216, 17, '2015-07-01 03:11:51'),
(217, 18, '2015-07-01 03:12:02'),
(218, 19, '2015-07-01 03:12:46'),
(219, 19, '2015-07-01 03:12:54'),
(220, 19, '2015-07-01 03:13:00'),
(221, 19, '2015-07-01 03:13:16'),
(222, 19, '2015-07-01 03:13:23'),
(223, 19, '2015-07-01 03:13:27'),
(224, 17, '2015-07-01 03:14:52'),
(225, 17, '2015-07-01 03:15:22'),
(226, 17, '2015-07-01 03:15:29'),
(227, 20, '2015-07-01 03:20:16'),
(228, 21, '2015-07-01 03:20:50'),
(229, 20, '2015-07-01 03:20:57'),
(230, 21, '2015-07-01 03:21:02'),
(231, 20, '2015-07-01 03:21:05'),
(232, 21, '2015-07-01 03:21:10'),
(233, 22, '2015-07-01 03:22:20'),
(234, 22, '2015-07-01 03:22:37'),
(235, 22, '2015-07-01 03:22:49'),
(236, 21, '2015-07-01 03:27:05'),
(237, 21, '2015-07-01 03:30:10'),
(238, 20, '2015-07-01 03:35:05'),
(239, 23, '2015-07-01 18:53:14'),
(240, 23, '2015-07-01 18:53:31'),
(241, 23, '2015-07-01 18:53:39'),
(242, 23, '2015-07-01 18:56:23'),
(243, 23, '2015-07-01 19:15:38'),
(244, 23, '2015-07-01 19:31:49'),
(245, 23, '2015-07-01 19:32:01'),
(246, 23, '2015-07-01 19:32:06'),
(247, 23, '2015-07-01 19:46:46'),
(248, 24, '2015-07-01 19:57:32'),
(249, 24, '2015-07-01 19:57:50'),
(250, 24, '2015-07-01 19:57:57'),
(251, 24, '2015-07-01 19:58:30'),
(252, 24, '2015-07-01 20:01:44'),
(253, 24, '2015-07-01 20:05:20'),
(254, 24, '2015-07-01 20:20:46'),
(255, 25, '2015-07-01 20:26:38'),
(256, 25, '2015-07-01 20:27:03'),
(257, 26, '2015-07-01 20:27:11'),
(258, 25, '2015-07-01 20:27:15'),
(259, 26, '2015-07-01 20:27:30'),
(260, 26, '2015-07-01 20:27:37'),
(261, 26, '2015-07-01 20:28:24'),
(262, 27, '2015-07-01 20:36:55'),
(263, 27, '2015-07-01 20:37:57'),
(264, 27, '2015-07-01 20:38:05'),
(265, 28, '2015-07-01 20:40:19'),
(266, 28, '2015-07-01 20:40:31'),
(267, 28, '2015-07-01 20:40:34'),
(268, 28, '2015-07-01 20:41:58'),
(269, 28, '2015-07-01 20:42:05'),
(270, 28, '2015-07-01 20:42:07'),
(271, 28, '2015-07-01 20:46:18'),
(272, 28, '2015-07-01 20:46:21'),
(273, 28, '2015-07-01 20:46:33'),
(274, 28, '2015-07-01 20:46:41'),
(275, 28, '2015-07-01 20:46:48'),
(276, 28, '2015-07-01 20:47:01'),
(277, 29, '2015-07-01 20:49:48'),
(278, 29, '2015-07-01 20:50:08'),
(279, 29, '2015-07-01 20:50:17'),
(280, 28, '2015-07-01 20:51:14'),
(281, 28, '2015-07-01 20:51:20'),
(282, 28, '2015-07-01 20:51:24'),
(283, 29, '2015-07-01 20:52:08'),
(284, 29, '2015-07-01 20:52:34'),
(285, 29, '2015-07-01 20:52:46'),
(286, 29, '2015-07-01 20:53:00'),
(287, 28, '2015-07-01 20:53:15'),
(288, 29, '2015-07-01 20:53:22'),
(289, 29, '2015-07-01 20:53:28'),
(290, 29, '2015-07-01 20:55:29'),
(291, 30, '2015-07-01 20:55:57'),
(292, 31, '2015-07-01 20:56:02'),
(293, 31, '2015-07-01 20:56:18'),
(294, 31, '2015-07-01 20:56:22'),
(295, 31, '2015-07-01 20:56:27'),
(296, 29, '2015-07-01 20:58:38'),
(297, 29, '2015-07-01 20:59:02'),
(298, 29, '2015-07-01 20:59:09'),
(299, 28, '2015-07-01 21:03:01'),
(300, 29, '2015-07-01 21:03:46'),
(301, 28, '2015-07-01 21:11:05'),
(302, 29, '2015-07-01 21:26:49'),
(303, 29, '2015-07-01 21:27:17'),
(304, 29, '2015-07-01 21:27:26'),
(305, 28, '2015-07-01 21:29:22'),
(306, 28, '2015-07-01 21:29:33'),
(307, 28, '2015-07-01 21:29:37'),
(308, 28, '2015-07-01 21:36:19'),
(309, 28, '2015-07-01 21:36:58'),
(310, 28, '2015-07-01 21:37:00'),
(311, 28, '2015-07-01 21:37:43'),
(312, 28, '2015-07-01 21:37:51'),
(313, 28, '2015-07-01 21:37:55'),
(314, 28, '2015-07-01 21:39:53'),
(315, 28, '2015-07-01 21:39:58'),
(316, 31, '2015-07-01 21:39:52'),
(317, 28, '2015-07-01 21:40:01'),
(318, 31, '2015-07-01 21:40:05'),
(319, 28, '2015-07-01 21:40:29'),
(320, 31, '2015-07-01 21:40:27'),
(321, 31, '2015-07-01 21:40:29'),
(322, 28, '2015-07-01 21:40:38'),
(323, 28, '2015-07-01 21:40:56'),
(324, 28, '2015-07-01 21:41:03'),
(325, 28, '2015-07-01 21:41:06'),
(326, 28, '2015-07-01 21:42:35'),
(327, 31, '2015-07-01 21:44:02'),
(328, 31, '2015-07-01 21:44:15'),
(329, 31, '2015-07-01 21:44:18'),
(330, 32, '2015-07-01 21:48:48'),
(331, 31, '2015-07-01 21:48:57'),
(332, 32, '2015-07-01 21:49:09'),
(333, 31, '2015-07-01 21:49:13'),
(334, 31, '2015-07-01 21:49:16'),
(335, 32, '2015-07-01 21:49:18'),
(336, 32, '2015-07-01 21:49:21'),
(337, 31, '2015-07-01 21:49:31'),
(338, 31, '2015-07-01 21:49:44'),
(339, 31, '2015-07-01 21:49:48'),
(340, 29, '2015-07-01 21:50:55'),
(341, 29, '2015-07-01 21:51:15'),
(342, 29, '2015-07-01 21:51:20'),
(343, 32, '2015-07-01 21:53:09'),
(344, 32, '2015-07-01 21:53:52'),
(345, 32, '2015-07-01 21:55:12'),
(346, 32, '2015-07-01 21:56:02'),
(347, 32, '2015-07-01 21:56:10'),
(348, 32, '2015-07-01 21:56:13'),
(349, 33, '2015-07-01 21:57:04'),
(350, 31, '2015-07-01 21:57:30'),
(351, 31, '2015-07-01 21:57:51'),
(352, 31, '2015-07-01 21:57:55'),
(353, 33, '2015-07-01 21:58:32'),
(354, 33, '2015-07-01 21:58:37'),
(355, 29, '2015-07-01 21:59:57'),
(356, 29, '2015-07-01 22:00:14'),
(357, 29, '2015-07-01 22:00:23'),
(358, 32, '2015-07-01 22:02:51'),
(359, 32, '2015-07-01 22:03:53'),
(360, 32, '2015-07-01 22:03:59'),
(361, 34, '2015-07-02 00:04:08'),
(362, 34, '2015-07-02 00:04:24'),
(363, 34, '2015-07-02 00:04:32'),
(364, 35, '2015-07-02 00:06:27'),
(365, 34, '2015-07-02 00:16:39'),
(366, 34, '2015-07-02 00:17:01'),
(367, 34, '2015-07-02 00:17:13'),
(368, 34, '2015-07-02 00:17:31'),
(369, 34, '2015-07-02 00:17:38'),
(370, 34, '2015-07-02 00:17:44'),
(371, 34, '2015-07-02 00:17:51'),
(372, 34, '2015-07-02 00:17:56'),
(373, 36, '2015-07-02 00:22:56'),
(374, 36, '2015-07-02 00:23:11'),
(375, 36, '2015-07-02 00:23:16'),
(376, 36, '2015-07-02 00:58:56'),
(377, 36, '2015-07-02 00:59:11'),
(378, 36, '2015-07-02 00:59:14'),
(379, 36, '2015-07-02 01:03:23'),
(380, 36, '2015-07-02 01:03:39'),
(381, 36, '2015-07-02 01:03:42'),
(382, 36, '2015-07-02 01:04:45'),
(383, 36, '2015-07-02 01:06:35'),
(384, 36, '2015-07-02 01:06:48'),
(385, 36, '2015-07-02 01:06:51'),
(386, 36, '2015-07-02 01:11:26'),
(387, 37, '2015-07-02 01:34:33'),
(388, 38, '2015-07-02 01:35:20'),
(389, 39, '2015-07-02 01:35:39'),
(390, 42, '2015-07-02 01:36:04'),
(391, 39, '2015-07-02 01:36:08'),
(392, 38, '2015-07-02 01:36:21'),
(393, 39, '2015-07-02 01:36:27'),
(394, 40, '2015-07-02 01:36:31'),
(395, 41, '2015-07-02 01:37:08'),
(396, 39, '2015-07-02 01:37:12'),
(397, 38, '2015-07-02 01:37:17'),
(398, 40, '2015-07-02 01:37:31'),
(399, 39, '2015-07-02 01:37:39'),
(400, 40, '2015-07-02 01:37:40'),
(401, 41, '2015-07-02 01:37:48'),
(402, 41, '2015-07-02 01:38:01'),
(403, 40, '2015-07-02 01:38:02'),
(404, 38, '2015-07-02 01:38:05'),
(405, 40, '2015-07-02 01:38:09'),
(406, 41, '2015-07-02 01:38:10'),
(407, 41, '2015-07-02 01:38:15'),
(408, 41, '2015-07-02 01:38:23'),
(409, 41, '2015-07-02 01:38:30'),
(410, 41, '2015-07-02 01:38:36'),
(411, 41, '2015-07-02 01:38:43'),
(412, 41, '2015-07-02 01:38:50'),
(413, 41, '2015-07-02 01:38:55'),
(414, 41, '2015-07-02 01:39:06'),
(415, 41, '2015-07-02 01:39:11'),
(416, 41, '2015-07-02 01:39:18'),
(417, 41, '2015-07-02 01:39:26'),
(418, 41, '2015-07-02 01:48:32'),
(419, 41, '2015-07-02 01:48:59'),
(420, 41, '2015-07-02 01:49:07'),
(421, 41, '2015-07-02 01:49:12'),
(422, 41, '2015-07-02 01:49:33'),
(423, 41, '2015-07-02 01:49:40'),
(424, 41, '2015-07-02 01:49:47'),
(425, 41, '2015-07-02 01:49:53'),
(426, 41, '2015-07-02 01:50:00'),
(427, 41, '2015-07-02 01:50:23'),
(428, 41, '2015-07-02 01:50:36'),
(429, 41, '2015-07-02 01:50:44'),
(430, 41, '2015-07-02 01:51:11'),
(431, 41, '2015-07-02 01:51:28'),
(432, 41, '2015-07-02 01:51:37'),
(433, 41, '2015-07-02 01:52:03'),
(434, 41, '2015-07-02 01:52:22'),
(435, 41, '2015-07-02 01:52:30'),
(436, 43, '2015-07-02 19:11:05'),
(437, 43, '2015-07-02 19:11:15'),
(438, 43, '2015-07-02 19:11:22'),
(439, 43, '2015-07-02 19:13:15'),
(440, 43, '2015-07-02 19:13:22'),
(441, 43, '2015-07-02 19:13:28'),
(442, 43, '2015-07-02 19:30:13'),
(443, 43, '2015-07-02 19:30:50'),
(444, 43, '2015-07-02 19:31:00'),
(445, 43, '2015-07-02 19:31:06'),
(446, 43, '2015-07-02 19:31:11'),
(447, 43, '2015-07-02 19:31:18'),
(448, 43, '2015-07-02 19:33:07'),
(449, 44, '2015-07-02 19:33:03'),
(450, 44, '2015-07-02 19:33:14'),
(451, 44, '2015-07-02 19:33:19'),
(452, 43, '2015-07-02 19:33:33'),
(453, 43, '2015-07-02 19:34:35'),
(454, 43, '2015-07-02 19:34:50'),
(455, 43, '2015-07-02 19:34:57'),
(456, 43, '2015-07-02 19:35:47'),
(457, 43, '2015-07-02 19:36:08'),
(458, 43, '2015-07-02 19:36:18'),
(459, 43, '2015-07-02 19:37:51'),
(460, 43, '2015-07-02 19:50:01'),
(461, 43, '2015-07-02 19:50:31'),
(462, 43, '2015-07-02 19:50:40'),
(463, 43, '2015-07-02 19:50:47'),
(464, 43, '2015-07-02 19:50:56'),
(465, 43, '2015-07-02 19:51:03'),
(466, 43, '2015-07-02 20:38:32'),
(467, 43, '2015-07-02 20:38:44'),
(468, 43, '2015-07-02 20:40:56'),
(469, 43, '2015-07-02 21:09:44'),
(470, 43, '2015-07-02 21:09:51'),
(471, 43, '2015-07-02 21:10:02'),
(472, 43, '2015-07-02 21:10:08'),
(473, 43, '2015-07-02 21:10:13'),
(474, 45, '2015-07-02 21:12:45'),
(475, 45, '2015-07-02 21:12:55'),
(476, 45, '2015-07-02 21:12:59'),
(477, 45, '2015-07-02 21:13:53'),
(478, 45, '2015-07-02 21:14:14'),
(479, 45, '2015-07-02 21:14:23'),
(480, 45, '2015-07-02 21:14:25'),
(481, 43, '2015-07-02 21:15:06'),
(482, 43, '2015-07-02 21:15:27'),
(483, 43, '2015-07-02 21:15:37'),
(484, 43, '2015-07-02 21:19:40'),
(485, 43, '2015-07-02 21:20:06'),
(486, 43, '2015-07-02 21:20:13'),
(487, 43, '2015-07-02 21:22:48'),
(488, 43, '2015-07-02 21:28:25'),
(489, 43, '2015-07-02 21:28:54'),
(490, 43, '2015-07-02 21:29:02'),
(491, 43, '2015-07-02 21:36:09'),
(492, 46, '2015-07-02 21:36:33'),
(493, 43, '2015-07-02 21:36:36'),
(494, 43, '2015-07-02 21:36:47'),
(495, 46, '2015-07-02 21:36:57'),
(496, 46, '2015-07-02 21:37:10'),
(497, 46, '2015-07-02 21:37:56'),
(498, 46, '2015-07-02 21:38:07'),
(499, 46, '2015-07-02 21:38:16'),
(500, 46, '2015-07-02 21:41:22'),
(501, 46, '2015-07-02 21:41:38'),
(502, 46, '2015-07-02 21:41:48'),
(503, 46, '2015-07-02 21:44:03'),
(504, 43, '2015-07-02 21:44:09'),
(505, 46, '2015-07-02 21:44:15'),
(506, 46, '2015-07-02 21:44:24'),
(507, 43, '2015-07-02 21:44:48'),
(508, 43, '2015-07-02 21:45:00'),
(509, 47, '2015-07-03 01:09:53'),
(510, 47, '2015-07-03 01:10:02'),
(511, 47, '2015-07-03 01:10:08'),
(512, 48, '2015-07-03 03:03:23'),
(513, 48, '2015-07-03 03:03:34'),
(514, 48, '2015-07-03 03:03:38'),
(515, 48, '2015-07-03 03:03:53'),
(516, 49, '2015-07-05 19:04:12'),
(517, 49, '2015-07-05 19:04:20'),
(518, 49, '2015-07-05 19:04:22'),
(519, 49, '2015-07-05 19:05:46'),
(520, 49, '2015-07-05 19:06:03'),
(521, 49, '2015-07-05 19:07:43'),
(522, 49, '2015-07-05 19:07:51'),
(523, 49, '2015-07-05 19:07:55'),
(524, 50, '2015-07-09 03:05:29'),
(525, 50, '2015-07-09 03:05:53'),
(526, 50, '2015-07-09 03:05:59'),
(527, 51, '2015-07-09 23:32:33'),
(528, 51, '2015-07-09 23:32:53'),
(529, 51, '2015-07-09 23:33:02'),
(530, 51, '2015-07-10 00:14:06'),
(531, 51, '2015-07-10 00:19:03'),
(532, 51, '2015-07-10 00:19:19'),
(533, 51, '2015-07-10 00:19:25'),
(534, 51, '2015-07-10 00:22:54'),
(535, 51, '2015-07-10 00:50:14'),
(536, 51, '2015-07-10 00:50:34'),
(537, 51, '2015-07-10 00:50:42'),
(538, 51, '2015-07-10 01:18:06'),
(539, 51, '2015-07-10 01:18:22'),
(540, 51, '2015-07-10 01:18:27'),
(541, 51, '2015-07-10 01:28:09'),
(542, 51, '2015-07-10 01:37:25'),
(543, 51, '2015-07-10 01:37:42'),
(544, 51, '2015-07-10 01:37:49'),
(545, 51, '2015-07-10 01:38:30'),
(546, 51, '2015-07-10 01:38:44'),
(547, 51, '2015-07-10 01:38:49'),
(548, 51, '2015-07-10 01:55:45'),
(549, 51, '2015-07-10 01:56:05'),
(550, 51, '2015-07-10 01:56:11'),
(551, 51, '2015-07-10 02:01:16'),
(552, 51, '2015-07-10 02:01:39'),
(553, 51, '2015-07-10 02:01:46'),
(554, 51, '2015-07-10 02:04:31'),
(555, 51, '2015-07-10 02:04:48'),
(556, 51, '2015-07-10 02:04:53'),
(557, 51, '2015-07-10 02:07:51'),
(558, 51, '2015-07-10 02:08:30'),
(559, 51, '2015-07-10 02:14:33'),
(560, 51, '2015-07-10 02:15:17'),
(561, 51, '2015-07-10 02:15:34'),
(562, 51, '2015-07-10 02:16:23'),
(563, 51, '2015-07-10 02:18:11'),
(564, 51, '2015-07-10 02:19:27'),
(565, 51, '2015-07-10 02:19:39'),
(566, 51, '2015-07-10 02:20:05'),
(567, 51, '2015-07-10 02:20:31'),
(568, 51, '2015-07-10 02:20:54'),
(569, 51, '2015-07-10 02:21:21'),
(570, 51, '2015-07-10 02:21:30'),
(571, 51, '2015-07-10 02:21:40'),
(572, 51, '2015-07-10 02:21:46'),
(573, 51, '2015-07-10 02:21:52'),
(574, 51, '2015-07-10 02:22:01'),
(575, 51, '2015-07-10 02:22:08'),
(576, 51, '2015-07-10 02:46:45'),
(577, 51, '2015-07-10 02:53:36'),
(578, 51, '2015-07-10 02:53:58'),
(579, 51, '2015-07-10 02:54:06'),
(580, 51, '2015-07-10 02:57:54'),
(581, 51, '2015-07-10 02:58:24'),
(582, 51, '2015-07-10 02:58:53'),
(583, 51, '2015-07-10 02:59:00'),
(584, 51, '2015-07-10 02:59:11'),
(585, 51, '2015-07-10 02:59:18'),
(586, 51, '2015-07-10 02:59:27'),
(587, 51, '2015-07-10 02:59:36'),
(588, 51, '2015-07-10 02:59:44'),
(589, 52, '2015-07-10 19:25:44'),
(590, 52, '2015-07-10 19:26:07'),
(591, 52, '2015-07-10 19:26:12'),
(592, 52, '2015-07-10 19:43:39'),
(593, 52, '2015-07-10 19:43:57'),
(594, 52, '2015-07-10 19:44:17'),
(595, 52, '2015-07-10 19:44:24'),
(596, 52, '2015-07-10 19:44:29'),
(597, 52, '2015-07-10 19:44:36'),
(598, 52, '2015-07-10 19:44:42'),
(599, 52, '2015-07-10 19:44:49'),
(600, 52, '2015-07-10 19:44:55'),
(601, 52, '2015-07-10 19:45:03'),
(602, 52, '2015-07-10 20:20:00'),
(603, 52, '2015-07-10 20:20:26'),
(604, 52, '2015-07-10 20:20:33'),
(605, 52, '2015-07-10 20:28:25'),
(606, 52, '2015-07-10 20:28:44'),
(607, 52, '2015-07-10 20:28:54'),
(608, 52, '2015-07-10 20:29:53'),
(609, 52, '2015-07-10 20:30:12'),
(610, 52, '2015-07-10 20:30:17'),
(611, 52, '2015-07-10 20:35:07'),
(612, 52, '2015-07-10 20:35:34'),
(613, 52, '2015-07-10 20:35:40'),
(614, 52, '2015-07-10 20:37:54'),
(615, 52, '2015-07-10 20:38:16'),
(616, 52, '2015-07-10 20:38:25'),
(617, 52, '2015-07-10 20:55:06'),
(618, 52, '2015-07-10 20:55:32'),
(619, 52, '2015-07-10 20:55:38'),
(620, 52, '2015-07-10 21:24:46'),
(621, 52, '2015-07-10 21:25:11'),
(622, 52, '2015-07-10 21:25:18'),
(623, 52, '2015-07-10 21:46:22'),
(624, 52, '2015-07-10 21:46:48'),
(625, 52, '2015-07-10 21:46:54'),
(626, 52, '2015-07-10 21:49:49'),
(627, 54, '2015-07-10 23:53:43'),
(628, 53, '2015-07-10 23:53:44'),
(629, 53, '2015-07-10 23:54:07'),
(630, 53, '2015-07-10 23:54:14'),
(631, 53, '2015-07-10 23:54:20'),
(632, 53, '2015-07-10 23:54:27'),
(633, 53, '2015-07-11 00:13:17'),
(634, 53, '2015-07-11 00:13:39'),
(635, 53, '2015-07-11 00:14:12'),
(636, 53, '2015-07-11 00:14:21'),
(637, 53, '2015-07-11 00:14:30'),
(638, 53, '2015-07-11 00:14:38'),
(639, 53, '2015-07-11 00:14:43'),
(640, 53, '2015-07-11 00:14:51'),
(641, 53, '2015-07-11 00:14:57'),
(642, 53, '2015-07-11 00:18:19'),
(643, 53, '2015-07-11 00:18:40'),
(644, 53, '2015-07-11 00:19:09'),
(645, 53, '2015-07-11 00:19:17'),
(646, 53, '2015-07-11 00:19:25'),
(647, 53, '2015-07-11 00:19:33'),
(648, 53, '2015-07-11 00:19:39'),
(649, 53, '2015-07-11 00:19:43'),
(650, 53, '2015-07-11 00:19:49'),
(651, 53, '2015-07-11 00:22:49'),
(652, 53, '2015-07-11 00:24:53'),
(653, 53, '2015-07-11 00:36:30'),
(654, 55, '2015-07-11 01:07:13'),
(655, 53, '2015-07-11 01:06:52'),
(656, 55, '2015-07-11 01:10:15'),
(657, 55, '2015-07-11 01:10:30'),
(658, 55, '2015-07-11 01:10:56'),
(659, 55, '2015-07-11 01:11:03'),
(660, 55, '2015-07-11 01:11:08'),
(661, 53, '2015-07-11 01:12:39'),
(662, 53, '2015-07-11 01:12:46'),
(663, 55, '2015-07-11 01:17:06'),
(664, 56, '2015-07-11 01:17:41'),
(665, 56, '2015-07-11 01:18:06'),
(666, 56, '2015-07-11 01:18:12'),
(667, 55, '2015-07-11 01:19:03'),
(668, 55, '2015-07-11 01:19:11'),
(669, 55, '2015-07-11 01:19:13'),
(670, 55, '2015-07-11 01:19:34'),
(671, 55, '2015-07-11 01:19:52'),
(672, 55, '2015-07-11 01:19:57'),
(673, 55, '2015-07-11 01:20:01'),
(674, 55, '2015-07-11 01:20:08'),
(675, 55, '2015-07-11 01:20:13'),
(676, 53, '2015-07-11 01:25:10'),
(677, 53, '2015-07-11 01:25:15'),
(678, 53, '2015-07-11 01:34:37'),
(679, 53, '2015-07-11 01:36:16'),
(680, 55, '2015-07-11 01:43:30'),
(681, 55, '2015-07-11 01:49:19'),
(682, 55, '2015-07-11 01:53:43'),
(683, 55, '2015-07-11 01:57:03'),
(684, 56, '2015-07-11 02:06:32'),
(685, 56, '2015-07-11 02:06:52'),
(686, 53, '2015-07-11 02:17:22'),
(687, 53, '2015-07-11 02:17:33'),
(688, 53, '2015-07-11 02:17:39'),
(689, 53, '2015-07-11 02:19:52'),
(690, 53, '2015-07-11 02:20:12'),
(691, 53, '2015-07-11 02:20:18'),
(692, 53, '2015-07-11 02:22:17'),
(693, 53, '2015-07-11 02:22:32'),
(694, 53, '2015-07-11 02:22:37'),
(695, 53, '2015-07-11 02:24:22'),
(696, 53, '2015-07-11 02:24:40'),
(697, 53, '2015-07-11 02:24:45'),
(698, 53, '2015-07-11 02:26:58'),
(699, 53, '2015-07-11 02:27:11'),
(700, 53, '2015-07-11 02:27:18'),
(701, 53, '2015-07-11 02:28:39'),
(702, 57, '2015-07-11 02:29:03'),
(703, 53, '2015-07-11 02:29:09'),
(704, 53, '2015-07-11 02:29:19'),
(705, 57, '2015-07-11 02:29:22'),
(706, 57, '2015-07-11 02:29:30'),
(707, 53, '2015-07-11 02:34:57'),
(708, 53, '2015-07-11 02:36:56'),
(709, 53, '2015-07-11 02:37:16'),
(710, 53, '2015-07-11 02:37:26'),
(711, 53, '2015-07-11 02:50:49'),
(712, 53, '2015-07-11 02:51:01'),
(713, 53, '2015-07-11 02:51:08'),
(714, 53, '2015-07-11 02:52:54'),
(715, 53, '2015-07-11 02:53:06'),
(716, 53, '2015-07-11 02:53:12'),
(717, 53, '2015-07-11 02:53:36'),
(718, 53, '2015-07-11 02:54:03'),
(719, 53, '2015-07-11 02:54:14'),
(720, 53, '2015-07-11 02:54:24'),
(721, 53, '2015-07-11 02:54:32'),
(722, 53, '2015-07-11 02:54:37'),
(723, 53, '2015-07-11 02:58:39'),
(724, 53, '2015-07-11 02:59:25'),
(725, 53, '2015-07-11 03:23:49'),
(726, 53, '2015-07-11 03:24:08'),
(727, 53, '2015-07-11 03:24:16'),
(728, 53, '2015-07-11 03:24:21'),
(729, 53, '2015-07-11 03:24:27'),
(730, 53, '2015-07-11 03:24:34'),
(731, 58, '2015-07-12 18:45:24'),
(732, 58, '2015-07-12 18:45:36'),
(733, 58, '2015-07-12 18:45:42'),
(734, 58, '2015-07-12 19:25:31'),
(735, 58, '2015-07-12 19:25:43'),
(736, 58, '2015-07-12 19:25:49'),
(737, 58, '2015-07-12 19:26:51'),
(738, 58, '2015-07-12 19:34:03'),
(739, 59, '2015-07-12 20:02:02'),
(740, 58, '2015-07-12 20:06:11'),
(741, 58, '2015-07-12 20:08:16'),
(742, 58, '2015-07-12 20:08:38'),
(743, 58, '2015-07-12 20:08:44'),
(744, 58, '2015-07-12 20:11:27'),
(745, 58, '2015-07-12 20:11:54'),
(746, 58, '2015-07-12 20:12:00'),
(747, 60, '2015-07-12 21:23:13'),
(748, 60, '2015-07-12 21:23:18'),
(749, 60, '2015-07-12 21:23:22'),
(750, 60, '2015-07-12 21:24:57'),
(751, 61, '2015-07-12 21:31:39'),
(752, 61, '2015-07-12 21:31:59'),
(753, 61, '2015-07-12 21:32:07'),
(754, 61, '2015-07-12 21:32:47'),
(755, 61, '2015-07-12 21:33:15'),
(756, 61, '2015-07-12 21:33:20'),
(757, 61, '2015-07-12 21:35:22'),
(758, 61, '2015-07-12 21:35:45'),
(759, 61, '2015-07-12 21:35:50'),
(760, 61, '2015-07-12 21:36:28'),
(761, 62, '2015-07-12 21:38:40'),
(762, 62, '2015-07-12 21:39:07'),
(763, 62, '2015-07-12 21:39:12'),
(764, 63, '2015-07-12 21:39:46'),
(765, 63, '2015-07-12 21:40:03'),
(766, 63, '2015-07-12 21:40:08'),
(767, 62, '2015-07-12 21:40:17'),
(768, 63, '2015-07-12 21:40:21'),
(769, 62, '2015-07-12 21:40:38'),
(770, 64, '2015-07-12 21:41:21'),
(771, 61, '2015-07-12 21:41:22'),
(772, 61, '2015-07-12 21:41:29'),
(773, 64, '2015-07-12 21:44:02'),
(774, 63, '2015-07-12 21:44:05'),
(775, 64, '2015-07-12 21:44:06'),
(776, 63, '2015-07-12 21:44:08'),
(777, 64, '2015-07-12 21:44:13'),
(778, 63, '2015-07-12 21:44:15'),
(779, 63, '2015-07-12 21:44:23'),
(780, 64, '2015-07-12 21:44:25'),
(781, 63, '2015-07-12 21:44:26'),
(782, 64, '2015-07-12 21:44:31'),
(783, 64, '2015-07-12 21:44:33'),
(784, 63, '2015-07-12 21:44:43'),
(785, 63, '2015-07-12 21:44:50'),
(786, 63, '2015-07-12 21:44:56'),
(787, 61, '2015-07-12 21:46:49'),
(788, 61, '2015-07-12 21:47:25'),
(789, 61, '2015-07-12 21:47:29'),
(790, 63, '2015-07-12 21:47:32'),
(791, 63, '2015-07-12 21:47:52'),
(792, 63, '2015-07-12 21:48:13'),
(793, 63, '2015-07-12 21:48:18'),
(794, 63, '2015-07-12 21:48:23'),
(795, 63, '2015-07-12 21:48:27'),
(796, 63, '2015-07-12 21:48:32'),
(797, 61, '2015-07-12 21:53:35'),
(798, 61, '2015-07-12 21:54:03'),
(799, 61, '2015-07-12 21:54:11'),
(800, 63, '2015-07-12 21:54:19'),
(801, 64, '2015-07-12 21:54:31'),
(802, 63, '2015-07-12 21:54:31'),
(803, 63, '2015-07-12 21:54:32'),
(804, 64, '2015-07-12 21:54:43'),
(805, 64, '2015-07-12 21:54:46'),
(806, 64, '2015-07-12 22:00:34'),
(807, 63, '2015-07-12 22:00:39'),
(808, 64, '2015-07-12 22:00:45'),
(809, 64, '2015-07-12 22:00:49'),
(810, 63, '2015-07-12 22:00:53'),
(811, 64, '2015-07-12 22:00:53'),
(812, 64, '2015-07-12 22:00:59'),
(813, 63, '2015-07-12 22:00:59'),
(814, 63, '2015-07-12 22:01:05'),
(815, 64, '2015-07-12 22:01:05'),
(816, 63, '2015-07-12 22:01:11'),
(817, 63, '2015-07-12 22:01:18'),
(818, 64, '2015-07-12 22:01:44'),
(819, 64, '2015-07-12 22:07:20'),
(820, 65, '2015-07-12 23:52:27'),
(821, 65, '2015-07-12 23:52:40'),
(822, 65, '2015-07-12 23:52:50'),
(823, 65, '2015-07-13 00:20:29'),
(824, 65, '2015-07-13 00:20:48'),
(825, 65, '2015-07-13 00:20:54'),
(826, 66, '2015-07-13 01:30:52'),
(827, 66, '2015-07-13 01:31:09'),
(828, 66, '2015-07-13 01:31:17'),
(829, 67, '2015-07-13 01:48:57'),
(830, 67, '2015-07-13 01:49:16'),
(831, 67, '2015-07-13 01:51:05'),
(832, 67, '2015-07-13 01:51:42'),
(833, 67, '2015-07-13 01:51:58'),
(834, 67, '2015-07-13 01:52:02'),
(835, 68, '2015-07-13 01:55:33'),
(836, 68, '2015-07-13 01:55:41'),
(837, 68, '2015-07-13 01:55:45'),
(838, 68, '2015-07-13 01:56:44'),
(839, 68, '2015-07-13 01:56:49'),
(840, 68, '2015-07-13 01:56:52'),
(841, 68, '2015-07-13 01:58:07'),
(842, 68, '2015-07-13 01:58:16'),
(843, 69, '2015-07-13 01:59:11'),
(844, 68, '2015-07-13 01:59:19'),
(845, 69, '2015-07-13 02:00:08'),
(846, 68, '2015-07-13 02:00:16'),
(847, 68, '2015-07-13 02:02:00'),
(848, 66, '2015-07-13 02:02:55'),
(849, 66, '2015-07-13 02:02:55'),
(850, 66, '2015-07-13 02:03:04'),
(851, 66, '2015-07-13 02:03:32'),
(852, 66, '2015-07-13 02:05:48'),
(853, 66, '2015-07-13 02:05:54'),
(854, 68, '2015-07-13 02:06:34'),
(855, 68, '2015-07-13 02:06:43'),
(856, 68, '2015-07-13 02:06:48'),
(857, 66, '2015-07-13 02:06:54'),
(858, 66, '2015-07-13 02:07:00'),
(859, 68, '2015-07-13 02:09:05'),
(860, 68, '2015-07-13 02:09:09'),
(861, 68, '2015-07-13 02:09:35'),
(862, 68, '2015-07-13 02:10:07'),
(863, 68, '2015-07-13 02:10:07'),
(864, 68, '2015-07-13 02:10:10'),
(865, 67, '2015-07-13 02:11:28'),
(866, 67, '2015-07-13 02:11:32'),
(867, 70, '2015-07-13 02:11:51'),
(868, 68, '2015-07-13 02:11:53'),
(869, 70, '2015-07-13 02:11:55'),
(870, 70, '2015-07-13 02:12:23'),
(871, 68, '2015-07-13 02:15:37'),
(872, 68, '2015-07-13 02:15:41'),
(873, 68, '2015-07-13 02:20:11'),
(874, 68, '2015-07-13 02:20:23'),
(875, 68, '2015-07-13 02:20:27'),
(876, 68, '2015-07-13 02:21:23'),
(877, 68, '2015-07-13 02:21:29'),
(878, 68, '2015-07-13 02:21:33'),
(879, 68, '2015-07-13 02:21:50'),
(880, 68, '2015-07-13 02:21:59'),
(881, 68, '2015-07-13 02:22:02'),
(882, 68, '2015-07-13 02:22:43'),
(883, 68, '2015-07-13 02:22:54'),
(884, 68, '2015-07-13 02:22:57'),
(885, 68, '2015-07-13 02:23:16'),
(886, 68, '2015-07-13 02:23:23'),
(887, 68, '2015-07-13 02:23:26'),
(888, 68, '2015-07-13 02:23:51'),
(889, 68, '2015-07-13 02:26:37'),
(890, 68, '2015-07-13 02:26:43'),
(891, 68, '2015-07-13 02:26:47'),
(892, 68, '2015-07-13 02:28:35'),
(893, 68, '2015-07-13 02:28:42'),
(894, 68, '2015-07-13 02:28:46'),
(895, 68, '2015-07-13 02:30:46'),
(896, 68, '2015-07-13 02:30:58'),
(897, 68, '2015-07-13 02:31:03'),
(898, 68, '2015-07-13 02:31:07'),
(899, 66, '2015-07-13 02:31:08'),
(900, 68, '2015-07-13 02:31:12'),
(901, 66, '2015-07-13 02:31:23'),
(902, 66, '2015-07-13 02:31:39'),
(903, 66, '2015-07-13 02:31:54'),
(904, 66, '2015-07-13 02:32:08'),
(905, 66, '2015-07-13 02:32:40'),
(906, 66, '2015-07-13 02:34:51'),
(907, 66, '2015-07-13 02:35:34'),
(908, 66, '2015-07-13 02:42:10'),
(909, 66, '2015-07-13 02:42:24'),
(910, 66, '2015-07-13 02:43:19'),
(911, 66, '2015-07-13 02:43:37'),
(912, 66, '2015-07-13 02:43:45'),
(913, 67, '2015-07-13 03:01:23'),
(914, 67, '2015-07-13 03:11:26'),
(915, 67, '2015-07-13 03:19:14'),
(916, 67, '2015-07-13 03:19:22'),
(917, 67, '2015-07-13 03:22:54'),
(918, 66, '2015-07-13 03:23:49'),
(919, 66, '2015-07-13 03:23:57'),
(920, 71, '2015-07-13 19:06:41'),
(921, 71, '2015-07-13 19:06:50'),
(922, 71, '2015-07-13 19:06:54'),
(923, 71, '2015-07-13 19:08:08'),
(924, 71, '2015-07-13 19:08:24'),
(925, 71, '2015-07-13 19:08:33'),
(926, 71, '2015-07-13 19:17:05'),
(927, 71, '2015-07-13 19:17:23'),
(928, 71, '2015-07-13 19:17:28'),
(929, 71, '2015-07-13 19:17:34'),
(930, 71, '2015-07-13 19:17:38'),
(931, 71, '2015-07-13 19:17:52'),
(932, 71, '2015-07-13 19:19:07'),
(933, 71, '2015-07-13 19:19:11'),
(934, 71, '2015-07-13 19:19:28'),
(935, 71, '2015-07-13 19:19:32'),
(936, 71, '2015-07-13 19:19:39'),
(937, 71, '2015-07-13 19:20:46'),
(938, 71, '2015-07-13 19:46:20'),
(939, 71, '2015-07-13 19:46:28'),
(940, 71, '2015-07-13 20:05:59'),
(941, 71, '2015-07-13 20:06:04'),
(942, 71, '2015-07-13 20:19:09'),
(943, 71, '2015-07-13 20:31:41'),
(944, 71, '2015-07-13 20:31:47'),
(945, 71, '2015-07-13 20:39:13'),
(946, 71, '2015-07-13 20:39:19'),
(947, 71, '2015-07-13 20:40:02'),
(948, 71, '2015-07-13 20:40:06'),
(949, 71, '2015-07-13 21:02:42'),
(950, 71, '2015-07-13 21:03:08'),
(951, 71, '2015-07-13 21:03:37'),
(952, 71, '2015-07-13 21:03:44'),
(953, 71, '2015-07-13 21:03:45'),
(954, 71, '2015-07-13 21:03:52'),
(955, 71, '2015-07-13 21:09:23'),
(956, 71, '2015-07-13 21:09:30'),
(957, 71, '2015-07-13 21:17:20'),
(958, 71, '2015-07-13 21:17:25'),
(959, 71, '2015-07-13 21:19:36'),
(960, 71, '2015-07-13 21:19:42'),
(961, 71, '2015-07-13 21:19:52'),
(962, 71, '2015-07-13 21:19:59'),
(963, 71, '2015-07-13 21:21:23'),
(964, 71, '2015-07-13 21:21:31'),
(965, 71, '2015-07-13 21:21:32'),
(966, 71, '2015-07-13 21:21:38'),
(967, 71, '2015-07-13 21:22:10'),
(968, 71, '2015-07-13 21:26:46'),
(969, 71, '2015-07-13 21:26:52'),
(970, 71, '2015-07-13 21:27:16'),
(971, 71, '2015-07-13 21:27:30'),
(972, 71, '2015-07-13 21:27:42'),
(973, 71, '2015-07-13 21:35:40'),
(974, 71, '2015-07-13 21:35:57'),
(975, 71, '2015-07-13 21:36:02'),
(976, 72, '2015-07-14 00:06:25'),
(977, 72, '2015-07-14 00:06:41'),
(978, 72, '2015-07-14 00:06:47'),
(979, 72, '2015-07-14 00:46:12'),
(980, 72, '2015-07-14 00:46:59'),
(981, 72, '2015-07-14 00:47:09'),
(982, 72, '2015-07-14 00:47:16'),
(983, 72, '2015-07-14 00:47:26'),
(984, 72, '2015-07-14 00:47:37'),
(985, 72, '2015-07-14 00:48:20'),
(986, 72, '2015-07-14 00:48:44'),
(987, 72, '2015-07-14 00:48:59'),
(988, 72, '2015-07-14 00:49:46'),
(989, 72, '2015-07-14 00:50:04'),
(990, 72, '2015-07-14 00:50:10'),
(991, 72, '2015-07-14 00:50:46'),
(992, 72, '2015-07-14 00:51:05'),
(993, 72, '2015-07-14 00:51:15'),
(994, 72, '2015-07-14 00:51:42'),
(995, 72, '2015-07-14 00:51:57'),
(996, 72, '2015-07-14 00:52:04'),
(997, 72, '2015-07-14 00:52:44'),
(998, 72, '2015-07-14 00:52:59'),
(999, 72, '2015-07-14 00:53:07'),
(1000, 72, '2015-07-14 00:53:44'),
(1001, 72, '2015-07-14 00:53:59'),
(1002, 72, '2015-07-14 00:54:07'),
(1003, 72, '2015-07-14 00:54:36'),
(1004, 72, '2015-07-14 00:54:56'),
(1005, 72, '2015-07-14 00:55:07'),
(1006, 72, '2015-07-14 00:55:55'),
(1007, 72, '2015-07-14 00:56:05'),
(1008, 72, '2015-07-14 00:56:12'),
(1009, 72, '2015-07-14 00:58:29'),
(1010, 72, '2015-07-14 00:58:51'),
(1011, 72, '2015-07-14 00:59:12'),
(1012, 72, '2015-07-14 00:59:23'),
(1013, 72, '2015-07-14 00:59:29'),
(1014, 72, '2015-07-14 01:00:06'),
(1015, 72, '2015-07-14 01:00:24'),
(1016, 72, '2015-07-14 01:00:32'),
(1017, 72, '2015-07-14 01:00:53'),
(1018, 72, '2015-07-14 01:01:04'),
(1019, 72, '2015-07-14 01:01:12'),
(1020, 72, '2015-07-14 01:02:12'),
(1021, 72, '2015-07-14 01:02:29'),
(1022, 72, '2015-07-14 01:02:42'),
(1023, 72, '2015-07-14 01:03:08'),
(1024, 72, '2015-07-14 01:03:23'),
(1025, 72, '2015-07-14 01:03:29'),
(1026, 72, '2015-07-14 01:04:25'),
(1027, 72, '2015-07-14 01:05:02'),
(1028, 72, '2015-07-14 01:05:13'),
(1029, 72, '2015-07-14 01:07:52'),
(1030, 72, '2015-07-14 01:08:17'),
(1031, 72, '2015-07-14 01:08:32'),
(1032, 72, '2015-07-14 01:08:41'),
(1033, 72, '2015-07-14 01:40:37'),
(1034, 72, '2015-07-14 01:40:54'),
(1035, 72, '2015-07-14 01:41:03'),
(1036, 73, '2015-07-14 19:02:06'),
(1037, 73, '2015-07-14 19:02:13'),
(1038, 73, '2015-07-14 19:02:16');

CREATE TABLE IF NOT EXISTS `#__log_url_info` (
`url_id` bigint(20) unsigned NOT NULL COMMENT 'URL ID',
  `url` varchar(255) DEFAULT NULL COMMENT 'URL',
  `referer` varchar(255) DEFAULT NULL COMMENT 'Referrer'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Log URL Info Table' AUTO_INCREMENT=1039 ;

INSERT INTO `#__log_url_info` (`url_id`, `url`, `referer`) VALUES
(1, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(2, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(3, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(4, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(5, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(6, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(7, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(8, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(9, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(10, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(11, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(12, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(13, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(14, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(15, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(16, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(17, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(18, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(19, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(20, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(21, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(22, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(23, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(24, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english', NULL),
(25, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(26, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(27, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(28, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(29, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(30, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(31, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie'),
(32, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(33, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(34, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(35, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(36, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/amoda/quickview/index?id=10', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(37, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/amoda/quickview/index?id=10', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(38, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(39, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(40, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(41, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(42, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(43, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(44, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(45, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(46, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(47, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(48, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie'),
(49, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(50, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(51, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(52, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(53, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(54, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(55, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(56, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(57, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(58, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(59, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(60, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(61, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(62, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(63, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(64, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(65, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(66, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(67, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(68, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(69, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(70, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(71, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(72, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(73, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(74, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(75, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(76, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(77, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(78, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(79, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(80, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(81, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(82, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(83, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(84, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(85, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(86, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(87, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(88, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://view.contextualyield.com/scjs/tb/ctxjs/topBar.php?aff_id=1145&subaff_id=888888000000000000&ch=10742&utm_source=1145&utm_medium=midroll-ootd&utm_campaign=v8.5.4&utm_term=http&sbrand=stats&intformat=roll&nextpage=http%3A%2F%2Fdev.snsgroup.me%2Fm'),
(89, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(90, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(91, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(92, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(93, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(94, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(95, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(96, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(97, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(98, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(99, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(100, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(101, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(102, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(103, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(104, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(105, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(106, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(107, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(108, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(109, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(110, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(111, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(112, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/14', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(113, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-02-chanel-black.html'),
(114, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(115, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(116, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(117, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(118, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(119, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(120, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(121, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(122, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(123, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(124, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(125, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(126, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(127, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(128, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(129, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(130, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(131, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(132, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(133, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(134, 'http://192.168.100.102/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-02-chanel-black.html'),
(135, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(136, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(137, 'http://192.168.100.102/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-02-chanel-black.html'),
(138, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(139, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(140, 'http://192.168.100.102/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-02-chanel-black.html'),
(141, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(142, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(143, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(144, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(145, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(146, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(147, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(148, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(149, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(150, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(151, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(152, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(153, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(154, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(155, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://192.168.100.102/mage/sns_amoda/'),
(156, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://192.168.100.102/mage/sns_amoda/'),
(157, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(158, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(159, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(160, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(161, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(162, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(163, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(164, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(165, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(166, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(167, 'http://192.168.100.102/mage/sns_amoda/index.php/catalog/product/view/id/10', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(168, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(169, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(170, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(171, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(172, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(173, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(174, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://192.168.100.102/mage/sns_amoda/'),
(175, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(176, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(177, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://192.168.100.102/mage/sns_amoda/'),
(178, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(179, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(180, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://192.168.100.102/mage/sns_amoda/'),
(181, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(182, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(183, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(184, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(185, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(186, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(187, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(188, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(189, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(190, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(191, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(192, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(193, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(194, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(195, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(196, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(197, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(198, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(199, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(200, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(201, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(202, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(203, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(204, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(205, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(206, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(207, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(208, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(209, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(210, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(211, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(212, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(213, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(214, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(215, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(216, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(217, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(218, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(219, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(220, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(221, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(222, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(223, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(224, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(225, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(226, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(227, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(228, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(229, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(230, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(231, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(232, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(233, 'http://192.168.100.102/mage/sns_amoda/', NULL),
(234, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.102/mage/sns_amoda/'),
(235, 'http://192.168.100.102/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.102/mage/sns_amoda/'),
(236, 'http://192.168.100.102/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://192.168.100.102/mage/sns_amoda/'),
(237, 'http://192.168.100.102/mage/sns_amoda/index.php/catalog/product/view/id/39/category/3', 'http://192.168.100.102/mage/sns_amoda/index.php/men.html'),
(238, 'http://192.168.100.102/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://192.168.100.102/mage/sns_amoda/'),
(239, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(240, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(241, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(242, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(243, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/33/category/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(244, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men/configurable-product-05-buberry.html'),
(245, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(246, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(247, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/33/category/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(248, 'http://192.168.100.101/mage/sns_amoda/', NULL),
(249, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.101/mage/sns_amoda/'),
(250, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.101/mage/sns_amoda/'),
(251, 'http://192.168.100.101/mage/sns_amoda/index.php/amoda/pages/featured/', 'http://192.168.100.101/mage/sns_amoda/'),
(252, 'http://192.168.100.101/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://192.168.100.101/mage/sns_amoda/'),
(253, 'http://192.168.100.101/mage/sns_amoda/index.php/catalog/product/view/id/36/category/3', 'http://192.168.100.101/mage/sns_amoda/index.php/men.html'),
(254, 'http://192.168.100.101/mage/sns_amoda/index.php/catalog/product/view/id/36/category/3', 'http://192.168.100.101/mage/sns_amoda/index.php/men.html'),
(255, 'http://192.168.100.101/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(256, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.101/mage/sns_amoda/'),
(257, 'http://192.168.100.101/mage/sns_amoda/', NULL),
(258, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.101/mage/sns_amoda/'),
(259, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.101/mage/sns_amoda/'),
(260, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.101/mage/sns_amoda/'),
(261, 'http://192.168.100.101/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://192.168.100.101/mage/sns_amoda/'),
(262, 'http://192.168.100.101/mage/sns_amoda/', NULL),
(263, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://192.168.100.101/mage/sns_amoda/'),
(264, 'http://192.168.100.101/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://192.168.100.101/mage/sns_amoda/'),
(265, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(266, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(267, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(268, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(269, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(270, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(271, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(272, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(273, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(274, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(275, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(276, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(277, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://192.168.100.101/mage/sns_amoda/'),
(278, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(279, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(280, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(281, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(282, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(283, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://192.168.100.101/mage/sns_amoda/'),
(284, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', NULL),
(285, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(286, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(287, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(288, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(289, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(290, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/7', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(291, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(292, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(293, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(294, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(295, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(296, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(297, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(298, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(299, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(300, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', NULL),
(301, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(302, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(303, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(304, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(305, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(306, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(307, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(308, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/index/add/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll/product/10/form_key/8DIU01tGQkjP1Olp/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(309, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/amoda/quickview/index?id=12', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie'),
(310, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/amoda/quickview/index?id=12', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie'),
(311, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(312, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(313, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(314, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(315, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(316, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(317, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(318, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(319, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(320, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(321, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(322, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/whishlist/compare/product/17/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWdlcm1hbnkmc25zX2NsZWFyY29va2ll/form_key/8DIU01tGQkjP1Olp/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(323, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(324, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(325, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(326, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/index/add/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv/product/11/form_key/8DIU01tGQkjP1Olp/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(327, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(328, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(329, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(330, 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.php/', NULL),
(331, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(332, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.php/'),
(333, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(334, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(335, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(336, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(337, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(338, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(339, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(340, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(341, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(342, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(343, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', NULL),
(344, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', NULL),
(345, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', NULL),
(346, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(347, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(348, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(349, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(350, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(351, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(352, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(353, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(354, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(355, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(356, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(357, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(358, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(359, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(360, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(361, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(362, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(363, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(364, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(365, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(366, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(367, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(368, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(369, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(370, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(371, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(372, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(373, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(374, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(375, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(376, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(377, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(378, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(379, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(380, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(381, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(382, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/11', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(383, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(384, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(385, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(386, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalogsearch/result/?cat=&q=9', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(387, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(388, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', NULL),
(389, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie', NULL),
(390, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2&sns_clearcookie', NULL),
(391, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(392, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf&sns_clearcookie', NULL),
(393, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(394, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie', NULL);
INSERT INTO `#__log_url_info` (`url_id`, `url`, `referer`) VALUES
(395, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&sns_clearcookie', NULL),
(396, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a&sns_clearcookie', NULL),
(397, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac&sns_clearcookie', NULL),
(398, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(399, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d&sns_clearcookie', NULL),
(400, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(401, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(402, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(403, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(404, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142&sns_clearcookie', NULL),
(405, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(406, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(407, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(408, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(409, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(410, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(411, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(412, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(413, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(414, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy'),
(415, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy'),
(416, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(417, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(418, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2&sns_clearcookie', NULL),
(419, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf&sns_clearcookie', NULL),
(420, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(421, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(422, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a&sns_clearcookie', NULL),
(423, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(424, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(425, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(426, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(427, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d&sns_clearcookie', NULL),
(428, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(429, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(430, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac&sns_clearcookie', NULL),
(431, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(432, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(433, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142&sns_clearcookie', NULL),
(434, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(435, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(436, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(437, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(438, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(439, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(440, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(441, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(442, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(443, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(444, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(445, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(446, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(447, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(448, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(449, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/'),
(450, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(451, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(452, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(453, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(454, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(455, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(456, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(457, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(458, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(459, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/7', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(460, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(461, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(462, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(463, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(464, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(465, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(466, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(467, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(468, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-armani-black.html'),
(469, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(470, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(471, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-armani-black.html'),
(472, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(473, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(474, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(475, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(476, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(477, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', NULL),
(478, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(479, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(480, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(481, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(482, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(483, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(484, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(485, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(486, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(487, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/48', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(488, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(489, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(490, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(491, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(492, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(493, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(494, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(495, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(496, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(497, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(498, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(499, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(500, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(501, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(502, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(503, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(504, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(505, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(506, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(507, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(508, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(509, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(510, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(511, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(512, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(513, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(514, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(515, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/9', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(516, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(517, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(518, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(519, 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.php/', NULL),
(520, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/__preview', NULL),
(521, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(522, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(523, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(524, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(525, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(526, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(527, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(528, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(529, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(530, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(531, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(532, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(533, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(534, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(535, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(536, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(537, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(538, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(539, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(540, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(541, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(542, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(543, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(544, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(545, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(546, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(547, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(548, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(549, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(550, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(551, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(552, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(553, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(554, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(555, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(556, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(557, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(558, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(559, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(560, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(561, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(562, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(563, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(564, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(565, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(566, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(567, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(568, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', NULL),
(569, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', NULL),
(570, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english'),
(571, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english'),
(572, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(573, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(574, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(575, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(576, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(577, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(578, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(579, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(580, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(581, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(582, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(583, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(584, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(585, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(586, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(587, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany'),
(588, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany'),
(589, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(590, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(591, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(592, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(593, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(594, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(595, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(596, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(597, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany'),
(598, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=germany'),
(599, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(600, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(601, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(602, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(603, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(604, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(605, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(606, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(607, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(608, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(609, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(610, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(611, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(612, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(613, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(614, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(615, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(616, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(617, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(618, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(619, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(620, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(621, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(622, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(623, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(624, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(625, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(626, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(627, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(628, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(629, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(630, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(631, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(632, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(633, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(634, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(635, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(636, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(637, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(638, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(639, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(640, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(641, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(642, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(643, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(644, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(645, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(646, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(647, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(648, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(649, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(650, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(651, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(652, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/whishlist/compare/product/39/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvbWVuLmh0bWw,/form_key/yPSsCmPaVq0doVmc/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(653, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/7', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(654, 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.php/', NULL),
(655, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product.html'),
(656, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/__preview', NULL),
(657, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/__preview/', NULL),
(658, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/__preview/'),
(659, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(660, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(661, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product.html'),
(662, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product.html'),
(663, 'http://dev.snsgroup.me/mage/sns_amoda/_preview/index.html', NULL),
(664, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(665, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(666, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(667, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/_preview/index.html'),
(668, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(669, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(670, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(671, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(672, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(673, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(674, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(675, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(676, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product.html'),
(677, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product.html'),
(678, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(679, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(680, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(681, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?mode=list', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(682, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?mode=grid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?mode=list'),
(683, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/39/category/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?mode=grid'),
(684, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/index/add/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv/product/8/form_key/yD7eQPgApxKRCvrv/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(685, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/index/add/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv/product/10/form_key/yD7eQPgApxKRCvrv/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(686, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(687, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(688, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(689, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(690, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(691, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(692, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(693, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(694, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(695, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(696, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(697, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(698, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(699, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(700, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(701, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(702, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', NULL),
(703, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(704, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(705, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(706, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(707, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(708, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?___store=english&___from_store=germany'),
(709, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(710, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(711, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(712, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(713, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(714, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?___store=english&___from_store=germany'),
(715, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(716, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(717, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(718, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(719, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(720, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(721, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(722, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(723, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(724, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?mode=list', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(725, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(726, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(727, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(728, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(729, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(730, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(731, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(732, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(733, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(734, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(735, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(736, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(737, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(738, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?mode=list', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(739, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?mode=list', NULL),
(740, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/41/category/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?mode=list'),
(741, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?mode=list'),
(742, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(743, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(744, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(745, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(746, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(747, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/'),
(748, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(749, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(750, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(751, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(752, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(753, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(754, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(755, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french');
INSERT INTO `#__log_url_info` (`url_id`, `url`, `referer`) VALUES
(756, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(757, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(758, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(759, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(760, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(761, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', NULL),
(762, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(763, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(764, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(765, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(766, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(767, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(768, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(769, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/33/category/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(770, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(771, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(772, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(773, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(774, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(775, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(776, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(777, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(778, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(779, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(780, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(781, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(782, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(783, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(784, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(785, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(786, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(787, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(788, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(789, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(790, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(791, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(792, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(793, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(794, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(795, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(796, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(797, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=french'),
(798, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english'),
(799, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=english'),
(800, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(801, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(802, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(803, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(804, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(805, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(806, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(807, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(808, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(809, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(810, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(811, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english'),
(812, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(813, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(814, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(815, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(816, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(817, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(818, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(819, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=english'),
(820, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(821, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(822, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(823, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(824, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(825, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(826, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(827, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(828, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(829, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany'),
(830, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/7', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(831, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/7', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(832, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(833, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(834, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&___from_store=germany'),
(835, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(836, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(837, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(838, 'http://dev.snsgroup.me/mage/sns_amoda/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(839, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(840, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(841, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/10', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(842, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/10', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(843, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/10', NULL),
(844, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-armani-green.html'),
(845, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/10', NULL),
(846, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-armani-green.html'),
(847, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/proaddto/index/add/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvd29tZW4uaHRtbA,,/product/33/form_key/lgSYeFo9OZjzADrU/isAjax/1', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/women.html'),
(848, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(849, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(850, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(851, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/product/view/id/8', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(852, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(853, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(854, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/women.html'),
(855, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(856, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(857, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(858, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(859, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(860, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(861, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(862, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(863, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(864, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(865, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', NULL),
(866, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', NULL),
(867, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', NULL),
(868, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/'),
(869, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', NULL),
(870, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(871, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(872, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(873, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/women.html'),
(874, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(875, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(876, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(877, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(878, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(879, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&___from_store=french'),
(880, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(881, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(882, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(883, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(884, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(885, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(886, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(887, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(888, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(889, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(890, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(891, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(892, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(893, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(894, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(895, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(896, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(897, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(898, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(899, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(900, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&___from_store=germany'),
(901, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(902, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(903, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(904, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(905, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3?limit=45', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(906, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(907, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(908, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/4', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/women.html'),
(909, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/42', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/women.html'),
(910, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/cameras-photography.html'),
(911, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(912, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(913, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(914, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/?dir=asc&order=email', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/'),
(915, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/customer/account/login/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/?dir=asc&order=email'),
(916, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/?dir=asc&order=email', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/'),
(917, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/?dir=asc&order=email', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/'),
(918, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?limit=45'),
(919, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html?limit=45'),
(920, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', NULL),
(921, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(922, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(923, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(924, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(925, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(926, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/directory/currency/switch/currency/EUR/uenc/aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWRlZmF1bHQ,/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(927, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(928, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/page404', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(929, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(930, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(931, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/contacts/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(932, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/customer/account/login/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/contacts/'),
(933, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/customer/account/login/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/contacts/'),
(934, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(935, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(936, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(937, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=default'),
(938, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(939, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(940, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(941, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(942, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(943, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(944, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(945, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(946, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(947, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(948, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(949, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(950, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(951, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(952, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(953, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(954, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(955, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(956, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(957, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(958, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(959, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(960, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(961, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(962, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(963, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(964, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/catalog/category/view/id/3', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(965, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(966, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(967, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/diam-pharetra-nisi3/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/'),
(968, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(969, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/blog/', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(970, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html'),
(971, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(972, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/'),
(973, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(974, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(975, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(976, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(977, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(978, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(979, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', NULL),
(980, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&sns_clearcookie', NULL),
(981, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(982, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(983, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(984, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french'),
(985, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&sns_clearcookie', NULL),
(986, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(987, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany'),
(988, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy&sns_clearcookie', NULL),
(989, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy'),
(990, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=italy'),
(991, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2&sns_clearcookie', NULL),
(992, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(993, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(994, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf&sns_clearcookie', NULL),
(995, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(996, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(997, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a&sns_clearcookie', NULL),
(998, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(999, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(1000, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d&sns_clearcookie', NULL),
(1001, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(1002, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(1003, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac&sns_clearcookie', NULL),
(1004, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(1005, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(1006, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142&sns_clearcookie', NULL),
(1007, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1008, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1009, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2&sns_clearcookie', NULL),
(1010, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(1011, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142&sns_clearcookie', NULL),
(1012, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1013, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1014, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2&sns_clearcookie', NULL),
(1015, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(1016, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f38456&color_skin2=49c7b2'),
(1017, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf&sns_clearcookie', NULL),
(1018, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(1019, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ed573f&color_skin2=34abbf'),
(1020, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a&sns_clearcookie', NULL),
(1021, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(1022, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=f86091&color_skin2=16b97a'),
(1023, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d&sns_clearcookie', NULL),
(1024, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(1025, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=e3b420&color_skin2=62a91d'),
(1026, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac&sns_clearcookie', NULL),
(1027, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(1028, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac'),
(1029, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=d11d1e&color_skin2=418cac&sns_clearcookie', NULL),
(1030, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142&sns_clearcookie', NULL),
(1031, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1032, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=germany&color_skin1=ad6f56&color_skin2=129142'),
(1033, 'http://dev.snsgroup.me/mage/sns_amoda/', NULL),
(1034, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(1035, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/'),
(1036, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english&sns_clearcookie', 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html'),
(1037, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxslider', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english'),
(1038, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/producttabs/index/ajaxgrid', 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=english');

CREATE TABLE IF NOT EXISTS `#__log_visitor` (
`visitor_id` bigint(20) unsigned NOT NULL COMMENT 'Visitor ID',
  `session_id` varchar(64) DEFAULT NULL COMMENT 'Session ID',
  `first_visit_at` timestamp NULL DEFAULT NULL COMMENT 'First Visit Time',
  `last_visit_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Last Visit Time',
  `last_url_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'Last URL ID',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store ID'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Log Visitors Table' AUTO_INCREMENT=77 ;

INSERT INTO `#__log_visitor` (`visitor_id`, `session_id`, `first_visit_at`, `last_visit_at`, `last_url_id`, `store_id`) VALUES
(1, '94mg3tcddf3doigt8bboejhci7', '2015-06-30 02:39:24', '2015-06-30 02:39:48', 4, 2),
(2, '38jogdq0s1mn220mpon80lo5e0', '2015-06-30 02:39:58', '2015-06-30 03:32:14', 93, 2),
(3, '3flgg4qg8l905o0lp4jm6t1ga4', '2015-06-30 02:41:59', '2015-06-30 03:28:41', 90, 1),
(4, 'qom13mrv92u8n5pguet8blv8c0', '2015-06-30 02:42:40', '2015-06-30 03:01:53', 51, 3),
(5, 'apj9evo1eliap4mafv812kk314', '2015-06-30 02:42:39', '2015-06-30 02:43:04', 20, 1),
(6, '4m30sc61mq4t5dbon18nl5vho4', '2015-06-30 19:06:21', '2015-06-30 19:20:15', 105, 1),
(7, 'os3i0ci59q5tvejsgttsvf7j93', '2015-06-30 19:08:39', '2015-06-30 19:36:06', 124, 1),
(8, 'v2ts5521bvo1fmqdsq1ci8gvr4', '2015-06-30 19:16:53', '2015-06-30 19:31:55', 115, 1),
(9, 'hg0se0d624sfraiocm81ovks06', '2015-06-30 19:21:00', '2015-06-30 19:35:53', 122, 1),
(10, 'vhom0p7pjv9m1d5vbkuv178sd7', '2015-06-30 19:38:07', '2015-06-30 19:51:40', 133, 1),
(11, 'q64rli69gp9h68fpsaj80foka6', '2015-06-30 19:48:51', '2015-06-30 19:49:38', 130, 1),
(12, '5gkfmd1omeo7ftnuqot1tgpr96', '2015-06-30 19:57:13', '2015-06-30 21:59:44', 176, 3),
(13, 'v1jb2imq1c7irnpg38os4brvq3', '2015-06-30 20:57:33', '2015-06-30 21:01:48', 148, 1),
(14, '648natf01r4098l7s1osrr3671', '2015-06-30 21:33:43', '2015-06-30 21:56:28', 173, 1),
(15, 'h40ahvnf666jo709llo56fplo1', '2015-07-01 00:30:49', '2015-07-01 00:44:37', 182, 3),
(16, 'gsuq2deqr8ds2r9rqqsekqvl11', '2015-07-01 01:37:57', '2015-07-01 02:38:39', 188, 1),
(17, 'gsuq2deqr8ds2r9rqqsekqvl11', '2015-07-01 02:39:07', '2015-07-01 03:15:29', 226, 1),
(18, 'lmiptookke8ild6tnrgvqcv7r7', '2015-07-01 02:58:06', '2015-07-01 03:12:02', 217, 1),
(19, 'aed5qnd8e0ha0pangd403e83m6', '2015-07-01 03:11:03', '2015-07-01 03:13:27', 223, 1),
(20, 'hohve42qb4t0g92ltqknn4s4s2', '2015-07-01 03:19:32', '2015-07-01 03:35:05', 238, 2),
(21, '5v7o4jtfssdlg9k1qp005me9c2', '2015-07-01 03:20:11', '2015-07-01 03:30:10', 237, 1),
(22, 'i6egcsq0fmhkuas9gq2bga2502', '2015-07-01 03:21:45', '2015-07-01 03:22:49', 235, 1),
(23, 'rs0tb011bmhvdoiagb8sikoqm6', '2015-07-01 18:51:53', '2015-07-01 19:46:46', 247, 1),
(24, '5a4i31b22dkrg4ulbra7be3ga6', '2015-07-01 19:56:40', '2015-07-01 20:20:46', 254, 1),
(25, 's0oc2mv0u7oeetjgbvqa1bulg6', '2015-07-01 20:26:12', '2015-07-01 20:27:14', 258, 1),
(26, 'u7d3qb8sm4lhfvhi2gq7o5c381', '2015-07-01 20:26:41', '2015-07-01 20:28:24', 261, 1),
(27, 'khhtgnjghpumdsrhv4bh8m1oh5', '2015-07-01 20:36:31', '2015-07-01 20:38:05', 264, 1),
(28, 'e4l2gkvn8cd6007b7ph2rnked2', '2015-07-01 20:39:58', '2015-07-01 21:42:35', 326, 3),
(29, '9g716s94oaj3vf4c2ouktp3cr5', '2015-07-01 20:49:23', '2015-07-01 22:00:23', 357, 1),
(30, 'n8f3pr2unt3jajuq4hhak3q9c1', '2015-07-01 20:55:42', '2015-07-01 20:55:57', 291, 1),
(31, 'gh43n90bht4mcrj249tv1g6jq2', '2015-07-01 20:55:53', '2015-07-01 21:57:55', 352, 1),
(32, '7rl0add45g04tlkqqdvq85c6q2', '2015-07-01 21:48:45', '2015-07-01 22:03:59', 360, 1),
(33, 'df7o61srj13jhmh045de2oki85', '2015-07-01 21:56:46', '2015-07-01 21:58:37', 354, 1),
(34, 'herab47uarp8uh5tdd0v73shh7', '2015-07-02 00:03:45', '2015-07-02 00:17:56', 372, 2),
(35, 'dqjdrrrdk5fe2879jc4cmv2lt7', '2015-07-02 00:06:06', '2015-07-02 00:06:26', 364, 1),
(36, '37ibf0asr9heq1s7upssf8j3p1', '2015-07-02 00:22:43', '2015-07-02 01:11:26', 386, 1),
(37, 'd94g77d0sq0gs1kdcqpq9pem46', '2015-07-02 01:34:03', '2015-07-02 01:34:33', 387, 1),
(38, 'ea8agbknjjdua7akf34l4cpik2', '2015-07-02 01:34:43', '2015-07-02 01:38:05', 404, 3),
(39, 'k4h4m79nr0hlqopl9kg50u0pn0', '2015-07-02 01:35:04', '2015-07-02 01:37:38', 399, 3),
(40, '1chtsc4qfkdk70o8vuo4an1j27', '2015-07-02 01:35:17', '2015-07-02 01:38:09', 405, 3),
(41, 'pk6ssnm39rfqmqsrtr20o48ho0', '2015-07-02 01:35:17', '2015-07-02 01:52:30', 435, 3),
(42, '29v3f7bkvrijo5q0io57b27jh0', '2015-07-02 01:35:21', '2015-07-02 01:36:04', 390, 3),
(43, 'vhbji34o6ocuqo7nf4o0b6had3', '2015-07-02 19:10:36', '2015-07-02 21:45:00', 508, 1),
(44, 'pn20u62hotkcsl94sus1c6vhe5', '2015-07-02 19:32:42', '2015-07-02 19:33:19', 451, 1),
(45, 'om622iaiu74eu6qe249fhvtpa1', '2015-07-02 21:12:34', '2015-07-02 21:14:25', 480, 1),
(46, '042uie3qqapmspp72d8fet63l1', '2015-07-02 21:36:07', '2015-07-02 21:44:24', 506, 1),
(47, 'mpdtvhdl0c1pm29ornr3kq8175', '2015-07-03 01:09:38', '2015-07-03 01:10:08', 511, 1),
(48, 'qofmrendu0lrg8d118sfdit214', '2015-07-03 03:03:07', '2015-07-03 03:03:53', 515, 1),
(49, 'dm96kahesmvsh0nu951qb96io4', '2015-07-05 19:03:48', '2015-07-05 19:07:55', 523, 3),
(50, 'cqa74hhsv2pm09chltdn46chs0', '2015-07-09 03:04:56', '2015-07-09 03:05:59', 526, 1),
(51, 't4486pbt5a8ad5mt51mhke5237', '2015-07-09 23:31:59', '2015-07-10 02:59:42', 588, 3),
(52, 'jeoafc6ers7a9o1rf65bkphht7', '2015-07-10 19:24:58', '2015-07-10 21:49:49', 626, 1),
(53, '2rami7r0bd5nfcim1gqbgja5n7', '2015-07-10 23:53:17', '2015-07-11 03:24:34', 730, 2),
(54, 'nij9amkuiejcf9t85scdgod4g7', '2015-07-10 23:53:17', '2015-07-10 23:53:43', 627, 3),
(55, '2fvfpa3ip8grfimq8ft76d6qe5', '2015-07-11 01:07:05', '2015-07-11 01:57:02', 683, 2),
(56, 'q9cic4ar75fkcmvaptjq4bphl0', '2015-07-11 01:17:22', '2015-07-11 02:06:52', 685, 1),
(57, 'e9pa6tp9im1bglf5e74khl6v71', '2015-07-11 02:28:21', '2015-07-11 02:29:30', 706, 3),
(58, 'd1ou4opjo13sgbophg0o44rpo5', '2015-07-12 18:44:59', '2015-07-12 20:12:00', 746, 1),
(59, 'ftcph0l8clphpsum0273lan500', '2015-07-12 20:01:51', '2015-07-12 20:02:02', 739, 3),
(60, '138sm2fc7b66pg74rc9nicola0', '2015-07-12 21:23:01', '2015-07-12 21:24:57', 750, 1),
(61, 'olsslmh7qqij94tea979dknh75', '2015-07-12 21:31:18', '2015-07-12 21:54:11', 799, 1),
(62, 'v5bfvor2mc7hivq8b6121l7ve5', '2015-07-12 21:38:09', '2015-07-12 21:40:38', 769, 1),
(63, '8b2k012lnf8nfutdpongd6vnv6', '2015-07-12 21:39:27', '2015-07-12 22:01:18', 817, 2),
(64, 'ucdovnnhah23vlrou57vrjr450', '2015-07-12 21:41:06', '2015-07-12 22:07:20', 819, 3),
(65, '9b25uv92osd3spspavcegpp276', '2015-07-12 23:51:47', '2015-07-13 00:20:54', 825, 1),
(66, 'g61bvg2vbvpovqloopmlr2opj4', '2015-07-13 01:30:25', '2015-07-13 03:23:56', 919, 1),
(67, 'vrlclqdd8pf5fapnm11poj06a0', '2015-07-13 01:48:44', '2015-07-13 03:22:54', 917, 1),
(68, 'j2pfh5mnilm1lrftlqmj35lm83', '2015-07-13 01:55:24', '2015-07-13 02:31:12', 900, 2),
(69, 'f8tm5hf0ttn3q5dfpckcs5lg51', '2015-07-13 01:59:01', '2015-07-13 02:00:08', 845, 1),
(70, '2c5nonmiidkv674r99ja7t4v40', '2015-07-13 02:11:50', '2015-07-13 02:12:23', 870, 1),
(71, 'm260bpdcb7b5q3bki8t1uq0684', '2015-07-13 19:06:05', '2015-07-13 21:36:02', 975, 1),
(72, 'il9alsskv5mglb01mr3a3i8dv7', '2015-07-14 00:05:59', '2015-07-14 01:41:02', 1035, 3),
(73, 'bj52ljgvr028g8h2do5kvv23p1', '2015-07-14 19:01:56', '2015-07-14 19:02:16', 1038, 1),
(74, 'h58j4rq10fqg5oig83g2aksof7', '2015-07-14 19:27:12', '2015-07-14 19:27:12', 0, 1),
(75, 'h58j4rq10fqg5oig83g2aksof7', '2015-07-14 19:28:11', '2015-07-14 19:28:11', 0, 1),
(76, 'h58j4rq10fqg5oig83g2aksof7', '2015-07-14 19:28:35', '2015-07-14 19:28:43', 0, 1);

CREATE TABLE IF NOT EXISTS `#__log_visitor_info` (
  `visitor_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'Visitor ID',
  `http_referer` varchar(255) DEFAULT NULL COMMENT 'HTTP Referrer',
  `http_user_agent` varchar(255) DEFAULT NULL COMMENT 'HTTP User-Agent',
  `http_accept_charset` varchar(255) DEFAULT NULL COMMENT 'HTTP Accept-Charset',
  `http_accept_language` varchar(255) DEFAULT NULL COMMENT 'HTTP Accept-Language',
  `server_addr` varbinary(16) DEFAULT NULL,
  `remote_addr` varbinary(16) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Visitor Info Table';

INSERT INTO `#__log_visitor_info` (`visitor_id`, `http_referer`, `http_user_agent`, `http_accept_charset`, `http_accept_language`, `server_addr`, `remote_addr`) VALUES
(1, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) coc_coc_browser/49.0 Chrome/43.0.2357.132_coc_coc Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86468),
(2, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) coc_coc_browser/49.0 Chrome/43.0.2357.132_coc_coc Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86468),
(3, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86468),
(4, 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(5, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86473),
(6, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86468),
(7, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86473),
(8, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(9, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86468),
(10, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86466, 0xffffffffc0a86468),
(11, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86466, 0xffffffffc0a86473),
(12, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/configurable-product-02-chanel-black.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86466, 0xffffffffc0a86466),
(13, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(14, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86466, 0xffffffffc0a86468),
(15, 'http://192.168.100.102/mage/sns_amoda/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86466, 0xffffffffc0a86466),
(16, 'http://192.168.100.102/mage/sns_amoda/index.php/?___store=germany&___from_store=french', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(17, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(18, NULL, 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0x7f000001, 0x7f000001),
(19, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86468),
(20, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86466, 0xffffffffc0a86466),
(21, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86466, 0xffffffffc0a86468),
(22, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) coc_coc_browser/49.0 Chrome/43.0.2357.132_coc_coc Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0xffffffffc0a86466, 0xffffffffc0a86468),
(23, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(24, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86465, 0xffffffffc0a86469),
(25, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/men.html', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86465, 0xffffffffc0a86465),
(26, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86465, 0xffffffffc0a86465),
(27, NULL, 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86465, 0xffffffffc0a8646b),
(28, NULL, 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(29, 'http://192.168.100.101/mage/sns_amoda/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(30, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(31, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(32, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86473),
(33, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(34, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(35, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(36, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(37, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=english', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(38, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(39, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(40, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(41, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(42, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(43, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(44, 'http://dev.snsgroup.me/mage/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86432),
(45, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(46, NULL, 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.130 Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0x7f000001, 0x7f000001),
(47, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(48, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86469),
(49, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(50, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(51, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(52, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(53, 'http://dev.snsgroup.me/mage/sns_amoda/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(54, 'http://dev.snsgroup.me/mage/sns_amoda/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(55, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(56, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86473),
(57, NULL, 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0x7f000001, 0x7f000001),
(58, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(59, NULL, 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0x7f000001, 0x7f000001),
(60, 'http://dev.snsgroup.me/mage/', 'Mozilla/5.0 (Windows NT 10.0; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(61, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/', 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(62, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:38.0) Gecko/20100101 Firefox/38.0', NULL, 'vi-VN,vi;q=0.8,en-US;q=0.5,en;q=0.3', 0xffffffffc0a86432, 0xffffffffc0a86468),
(63, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(64, NULL, 'Mozilla/5.0 (Windows NT 6.3; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36', NULL, 'en,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86473),
(65, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(66, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(67, 'http://dev.snsgroup.me/mage/sns_amoda/index.php/?___store=french&___from_store=germany', 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(68, NULL, 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(69, NULL, 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_10_4) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/43.0.2357.132 Safari/537.36', NULL, 'en-US,en;q=0.8,vi;q=0.6,nl;q=0.4', 0x7f000001, 0x7f000001),
(70, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) coc_coc_browser/49.0 Chrome/43.0.2357.132_coc_coc Safari/537.36', NULL, 'vi-VN,vi;q=0.8,fr-FR;q=0.6,fr;q=0.4,en-US;q=0.2,en;q=0.2', 0xffffffffc0a86432, 0xffffffffc0a86468),
(71, NULL, 'Mozilla/5.0 (Windows NT 6.3; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0xffffffffc0a86432, 0xffffffffc0a86473),
(72, NULL, 'Mozilla/5.0 (Windows NT 6.1; WOW64; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001),
(73, 'http://dev.snsgroup.me/mage/sns_amoda/__preview/index.html', 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:39.0) Gecko/20100101 Firefox/39.0', NULL, 'en-US,en;q=0.5', 0x7f000001, 0x7f000001);

CREATE TABLE IF NOT EXISTS `#__log_visitor_online` (
`visitor_id` bigint(20) unsigned NOT NULL COMMENT 'Visitor ID',
  `visitor_type` varchar(1) NOT NULL COMMENT 'Visitor Type',
  `remote_addr` varbinary(16) DEFAULT NULL,
  `first_visit_at` timestamp NULL DEFAULT NULL COMMENT 'First Visit Time',
  `last_visit_at` timestamp NULL DEFAULT NULL COMMENT 'Last Visit Time',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer ID',
  `last_url` varchar(255) DEFAULT NULL COMMENT 'Last URL'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Log Visitor Online Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__newsletter_problem` (
`problem_id` int(10) unsigned NOT NULL COMMENT 'Problem Id',
  `subscriber_id` int(10) unsigned DEFAULT NULL COMMENT 'Subscriber Id',
  `queue_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Queue Id',
  `problem_error_code` int(10) unsigned DEFAULT '0' COMMENT 'Problem Error Code',
  `problem_error_text` varchar(200) DEFAULT NULL COMMENT 'Problem Error Text'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Newsletter Problems' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__newsletter_queue` (
`queue_id` int(10) unsigned NOT NULL COMMENT 'Queue Id',
  `template_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Template Id',
  `newsletter_type` int(11) DEFAULT NULL COMMENT 'Newsletter Type',
  `newsletter_text` text COMMENT 'Newsletter Text',
  `newsletter_styles` text COMMENT 'Newsletter Styles',
  `newsletter_subject` varchar(200) DEFAULT NULL COMMENT 'Newsletter Subject',
  `newsletter_sender_name` varchar(200) DEFAULT NULL COMMENT 'Newsletter Sender Name',
  `newsletter_sender_email` varchar(200) DEFAULT NULL COMMENT 'Newsletter Sender Email',
  `queue_status` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Queue Status',
  `queue_start_at` timestamp NULL DEFAULT NULL COMMENT 'Queue Start At',
  `queue_finish_at` timestamp NULL DEFAULT NULL COMMENT 'Queue Finish At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Newsletter Queue' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__newsletter_queue_link` (
`queue_link_id` int(10) unsigned NOT NULL COMMENT 'Queue Link Id',
  `queue_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Queue Id',
  `subscriber_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Subscriber Id',
  `letter_sent_at` timestamp NULL DEFAULT NULL COMMENT 'Letter Sent At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Newsletter Queue Link' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__newsletter_queue_store_link` (
  `queue_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Queue Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Newsletter Queue Store Link';

CREATE TABLE IF NOT EXISTS `#__newsletter_subscriber` (
`subscriber_id` int(10) unsigned NOT NULL COMMENT 'Subscriber Id',
  `store_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Store Id',
  `change_status_at` timestamp NULL DEFAULT NULL COMMENT 'Change Status At',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Id',
  `subscriber_email` varchar(150) DEFAULT NULL COMMENT 'Subscriber Email',
  `subscriber_status` int(11) NOT NULL DEFAULT '0' COMMENT 'Subscriber Status',
  `subscriber_confirm_code` varchar(32) DEFAULT 'NULL' COMMENT 'Subscriber Confirm Code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Newsletter Subscriber' AUTO_INCREMENT=2 ;

INSERT INTO `#__newsletter_subscriber` (`subscriber_id`, `store_id`, `change_status_at`, `customer_id`, `subscriber_email`, `subscriber_status`, `subscriber_confirm_code`) VALUES
(1, 1, NULL, 0, 'stephen105.ngo@gmail.com', 1, 'fizthhqjd680pigm7v6nxvyb8fhjvi1n');

CREATE TABLE IF NOT EXISTS `#__newsletter_template` (
`template_id` int(10) unsigned NOT NULL COMMENT 'Template Id',
  `template_code` varchar(150) DEFAULT NULL COMMENT 'Template Code',
  `template_text` text COMMENT 'Template Text',
  `template_text_preprocessed` text COMMENT 'Template Text Preprocessed',
  `template_styles` text COMMENT 'Template Styles',
  `template_type` int(10) unsigned DEFAULT NULL COMMENT 'Template Type',
  `template_subject` varchar(200) DEFAULT NULL COMMENT 'Template Subject',
  `template_sender_name` varchar(200) DEFAULT NULL COMMENT 'Template Sender Name',
  `template_sender_email` varchar(200) DEFAULT NULL COMMENT 'Template Sender Email',
  `template_actual` smallint(5) unsigned DEFAULT '1' COMMENT 'Template Actual',
  `added_at` timestamp NULL DEFAULT NULL COMMENT 'Added At',
  `modified_at` timestamp NULL DEFAULT NULL COMMENT 'Modified At'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Newsletter Template' AUTO_INCREMENT=2 ;

INSERT INTO `#__newsletter_template` (`template_id`, `template_code`, `template_text`, `template_text_preprocessed`, `template_styles`, `template_type`, `template_subject`, `template_sender_name`, `template_sender_email`, `template_actual`, `added_at`, `modified_at`) VALUES
(1, 'Example Newsletter Template', '{{template config_path="design/email/header"}}\n{{inlinecss file="email-inline.css"}}\n\n<table cellpadding="0" cellspacing="0" border="0">\n<tr>\n    <td class="full">\n        <table class="columns">\n            <tr>\n                <td class="email-heading">\n                    <h1>Welcome</h1>\n                    <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit,\n                    sed do eiusmod tempor incididunt ut labore et.</p>\n                </td>\n                <td class="store-info">\n                    <h4>Contact Us</h4>\n                    <p>\n                        {{depend store_phone}}\n                        <b>Call Us:</b>\n                        <a href="tel:{{var phone}}">{{var store_phone}}</a><br>\n                        {{/depend}}\n                        {{depend store_hours}}\n                        <span class="no-link">{{var store_hours}}</span><br>\n                        {{/depend}}\n                        {{depend store_email}}\n                        <b>Email:</b> <a href="mailto:{{var store_email}}">{{var store_email}}</a>\n                        {{/depend}}\n                    </p>\n                </td>\n            </tr>\n        </table>\n    </td>\n</tr>\n<tr>\n    <td class="full">\n        <table class="columns">\n            <tr>\n                <td>\n                    <img width="600" src="http://placehold.it/600x200" class="main-image">\n                </td>\n                <td class="expander"></td>\n            </tr>\n        </table>\n        <table class="columns">\n            <tr>\n                <td class="panel">\n                    <p>Phasellus dictum sapien a neque luctus cursus. Pellentesque sem dolor, fringilla et pharetra\n                    vitae. <a href="#">Click it! &raquo;</a></p>\n                </td>\n                <td class="expander"></td>\n            </tr>\n        </table>\n    </td>\n</tr>\n<tr>\n    <td>\n        <table class="row">\n            <tr>\n                <td class="half left wrapper">\n                    <table class="columns">\n                        <tr>\n                            <td>\n                                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor\n                                incididunt ut labore et. Lorem ipsum dolor sit amet, consectetur adipisicing elit,\n                                sed do eiusmod tempor incididunt ut labore et. Lorem ipsum dolor sit amet.</p>\n                                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor\n                                incididunt ut labore et. Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed\n                                do eiusmod tempor incididunt ut labore et. Lorem ipsum dolor sit amet.</p>\n                                <table class="button">\n                                    <tr>\n                                        <td>\n                                            <a href="#">Click Me!</a>\n                                        </td>\n                                    </tr>\n                                </table>\n                            </td>\n                            <td class="expander"></td>\n                        </tr>\n                    </table>\n                </td>\n                <td class="half right wrapper last">\n                    <table class="columns">\n                        <tr>\n                            <td class="panel sidebar-links">\n                                <h6>Header Thing</h6>\n                                <p>Sub-head or something</p>\n                                <table>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <hr/>\n                                        </td>\n                                    </tr>\n                                    <tr>\n                                        <td>\n                                            <p><a href="#">Just a Plain Link &raquo;</a></p>\n                                        </td>\n                                    </tr>\n                                    <tr><td>&nbsp;</td></tr>\n                                </table>\n                            </td>\n                            <td class="expander"></td>\n                        </tr>\n                    </table>\n                    <br>\n                    <table class="columns">\n                        <tr>\n                            <td class="panel">\n                                <h6>Connect With Us:</h6>\n                                <table class="social-button facebook">\n                                    <tr>\n                                        <td>\n                                            <a href="#">Facebook</a>\n                                        </td>\n                                    </tr>\n                                </table>\n                                <hr>\n                                <table class="social-button twitter">\n                                    <tr>\n                                        <td>\n                                            <a href="#">Twitter</a>\n                                        </td>\n                                    </tr>\n                                </table>\n                                <hr>\n                                <table class="social-button google-plus">\n                                    <tr>\n                                        <td>\n                                            <a href="#">Google +</a>\n                                        </td>\n                                    </tr>\n                                </table>\n                                <br>\n                                <h6>Contact Info:</h6>\n                                {{depend store_phone}}\n                                <p>\n                                    <b>Call Us:</b>\n                                    <a href="tel:{{var phone}}">{{var store_phone}}</a>\n                                </p>\n                                {{/depend}}\n                                {{depend store_hours}}\n                                <p><span class="no-link">{{var store_hours}}</span><br></p>\n                                {{/depend}}\n                                {{depend store_email}}\n                                <p><b>Email:</b> <a href="mailto:{{var store_email}}">{{var store_email}}</a></p>\n                                {{/depend}}\n                            </td>\n                            <td class="expander"></td>\n                        </tr>\n                    </table>\n                </td>\n            </tr>\n        </table>\n        <table class="row">\n            <tr>\n                <td class="full wrapper">\n                    {{block type="catalog/product_new" template="email/catalog/product/new.phtml" products_count="4"\n                    column_count="4" }}\n                </td>\n            </tr>\n        </table>\n        <table class="row">\n            <tr>\n                <td class="full wrapper last">\n                    <table class="columns">\n                        <tr>\n                            <td align="center">\n                                <center>\n                                    <p><a href="#">Terms</a> | <a href="#">Privacy</a> | <a href="#">Unsubscribe</a></p>\n                                </center>\n                            </td>\n                            <td class="expander"></td>\n                        </tr>\n                    </table>\n                </td>\n            </tr>\n        </table>\n    </td>\n</tr>\n</table>\n\n{{template config_path="design/email/footer"}}', NULL, NULL, 2, 'Example Subject', 'Owner', 'owner@example.com', 1, '2014-12-03 00:00:20', '2014-12-03 00:00:20');

CREATE TABLE IF NOT EXISTS `#__oauth_consumer` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `name` varchar(255) NOT NULL COMMENT 'Name of consumer',
  `key` varchar(32) NOT NULL COMMENT 'Key code',
  `secret` varchar(32) NOT NULL COMMENT 'Secret code',
  `callback_url` varchar(255) DEFAULT NULL COMMENT 'Callback URL',
  `rejected_callback_url` varchar(255) NOT NULL COMMENT 'Rejected callback URL'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='OAuth Consumers' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__oauth_nonce` (
  `nonce` varchar(32) NOT NULL COMMENT 'Nonce String',
  `timestamp` int(10) unsigned NOT NULL COMMENT 'Nonce Timestamp'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='snspfx_oauth_nonce';

CREATE TABLE IF NOT EXISTS `#__oauth_token` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity ID',
  `consumer_id` int(10) unsigned NOT NULL COMMENT 'Consumer ID',
  `admin_id` int(10) unsigned DEFAULT NULL COMMENT 'Admin user ID',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer user ID',
  `type` varchar(16) NOT NULL COMMENT 'Token Type',
  `token` varchar(32) NOT NULL COMMENT 'Token',
  `secret` varchar(32) NOT NULL COMMENT 'Token Secret',
  `verifier` varchar(32) DEFAULT NULL COMMENT 'Token Verifier',
  `callback_url` varchar(255) NOT NULL COMMENT 'Token Callback URL',
  `revoked` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Token revoked',
  `authorized` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Token authorized',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Token creation timestamp'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='OAuth Tokens' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__paypal_cert` (
`cert_id` smallint(5) unsigned NOT NULL COMMENT 'Cert Id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `content` text COMMENT 'Content',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Paypal Certificate Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__paypal_payment_transaction` (
`transaction_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `txn_id` varchar(100) DEFAULT NULL COMMENT 'Txn Id',
  `additional_information` blob COMMENT 'Additional Information',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='PayPal Payflow Link Payment Transaction' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__paypal_settlement_report` (
`report_id` int(10) unsigned NOT NULL COMMENT 'Report Id',
  `report_date` timestamp NULL DEFAULT NULL COMMENT 'Report Date',
  `account_id` varchar(64) DEFAULT NULL COMMENT 'Account Id',
  `filename` varchar(24) DEFAULT NULL COMMENT 'Filename',
  `last_modified` timestamp NULL DEFAULT NULL COMMENT 'Last Modified'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Paypal Settlement Report Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__paypal_settlement_report_row` (
`row_id` int(10) unsigned NOT NULL COMMENT 'Row Id',
  `report_id` int(10) unsigned NOT NULL COMMENT 'Report Id',
  `transaction_id` varchar(19) DEFAULT NULL COMMENT 'Transaction Id',
  `invoice_id` varchar(127) DEFAULT NULL COMMENT 'Invoice Id',
  `paypal_reference_id` varchar(19) DEFAULT NULL COMMENT 'Paypal Reference Id',
  `paypal_reference_id_type` varchar(3) DEFAULT NULL COMMENT 'Paypal Reference Id Type',
  `transaction_event_code` varchar(5) DEFAULT NULL COMMENT 'Transaction Event Code',
  `transaction_initiation_date` timestamp NULL DEFAULT NULL COMMENT 'Transaction Initiation Date',
  `transaction_completion_date` timestamp NULL DEFAULT NULL COMMENT 'Transaction Completion Date',
  `transaction_debit_or_credit` varchar(2) NOT NULL DEFAULT 'CR' COMMENT 'Transaction Debit Or Credit',
  `gross_transaction_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Gross Transaction Amount',
  `gross_transaction_currency` varchar(3) DEFAULT '' COMMENT 'Gross Transaction Currency',
  `fee_debit_or_credit` varchar(2) DEFAULT NULL COMMENT 'Fee Debit Or Credit',
  `fee_amount` decimal(20,6) NOT NULL DEFAULT '0.000000' COMMENT 'Fee Amount',
  `fee_currency` varchar(3) DEFAULT NULL COMMENT 'Fee Currency',
  `custom_field` varchar(255) DEFAULT NULL COMMENT 'Custom Field',
  `consumer_id` varchar(127) DEFAULT NULL COMMENT 'Consumer Id',
  `payment_tracking_id` varchar(255) DEFAULT NULL COMMENT 'Payment Tracking ID',
  `store_id` varchar(50) DEFAULT NULL COMMENT 'Store ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Paypal Settlement Report Row Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__persistent_session` (
`persistent_id` int(10) unsigned NOT NULL COMMENT 'Session id',
  `key` varchar(50) NOT NULL COMMENT 'Unique cookie key',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID',
  `info` text COMMENT 'Session Data',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Persistent Session' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__poll` (
`poll_id` int(10) unsigned NOT NULL COMMENT 'Poll Id',
  `poll_title` varchar(255) DEFAULT NULL COMMENT 'Poll title',
  `votes_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Votes Count',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store id',
  `date_posted` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date posted',
  `date_closed` timestamp NULL DEFAULT NULL COMMENT 'Date closed',
  `active` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Is active',
  `closed` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is closed',
  `answers_display` smallint(6) DEFAULT NULL COMMENT 'Answers display'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Poll' AUTO_INCREMENT=2 ;

INSERT INTO `#__poll` (`poll_id`, `poll_title`, `votes_count`, `store_id`, `date_posted`, `date_closed`, `active`, `closed`, `answers_display`) VALUES
(1, 'What is your favorite color', 7, 0, '2014-12-03 00:00:19', NULL, 1, 0, NULL);

CREATE TABLE IF NOT EXISTS `#__poll_answer` (
`answer_id` int(10) unsigned NOT NULL COMMENT 'Answer Id',
  `poll_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Poll Id',
  `answer_title` varchar(255) DEFAULT NULL COMMENT 'Answer title',
  `votes_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Votes Count',
  `answer_order` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Answers display'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Poll Answers' AUTO_INCREMENT=5 ;

INSERT INTO `#__poll_answer` (`answer_id`, `poll_id`, `answer_title`, `votes_count`, `answer_order`) VALUES
(1, 1, 'Green', 4, 0),
(2, 1, 'Red', 1, 0),
(3, 1, 'Black', 0, 0),
(4, 1, 'Magenta', 2, 0);

CREATE TABLE IF NOT EXISTS `#__poll_store` (
  `poll_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Poll Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Poll Store';

INSERT INTO `#__poll_store` (`poll_id`, `store_id`) VALUES
(1, 1);

CREATE TABLE IF NOT EXISTS `#__poll_vote` (
`vote_id` int(10) unsigned NOT NULL COMMENT 'Vote Id',
  `poll_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Poll Id',
  `poll_answer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Poll answer id',
  `ip_address` varbinary(16) DEFAULT NULL,
  `customer_id` int(11) DEFAULT NULL COMMENT 'Customer id',
  `vote_time` timestamp NULL DEFAULT NULL COMMENT 'Date closed'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Poll Vote' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__product_alert_price` (
`alert_price_id` int(10) unsigned NOT NULL COMMENT 'Product alert price id',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product id',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price amount',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website id',
  `add_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Product alert add date',
  `last_send_date` timestamp NULL DEFAULT NULL COMMENT 'Product alert last send date',
  `send_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert send count',
  `status` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Product Alert Price' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__product_alert_stock` (
`alert_stock_id` int(10) unsigned NOT NULL COMMENT 'Product alert stock id',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website id',
  `add_date` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Product alert add date',
  `send_date` timestamp NULL DEFAULT NULL COMMENT 'Product alert send date',
  `send_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Send Count',
  `status` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Product alert status'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Product Alert Stock' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__rating` (
`rating_id` smallint(5) unsigned NOT NULL COMMENT 'Rating Id',
  `entity_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `rating_code` varchar(64) NOT NULL COMMENT 'Rating Code',
  `position` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Position On Frontend'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Ratings' AUTO_INCREMENT=4 ;

INSERT INTO `#__rating` (`rating_id`, `entity_id`, `rating_code`, `position`) VALUES
(1, 1, 'Quality', 0),
(2, 1, 'Value', 0),
(3, 1, 'Price', 0);

CREATE TABLE IF NOT EXISTS `#__rating_entity` (
`entity_id` smallint(5) unsigned NOT NULL COMMENT 'Entity Id',
  `entity_code` varchar(64) NOT NULL COMMENT 'Entity Code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Rating entities' AUTO_INCREMENT=4 ;

INSERT INTO `#__rating_entity` (`entity_id`, `entity_code`) VALUES
(1, 'product'),
(2, 'product_review'),
(3, 'review');

CREATE TABLE IF NOT EXISTS `#__rating_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Rating Option Id',
  `rating_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Id',
  `code` varchar(32) NOT NULL COMMENT 'Rating Option Code',
  `value` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Option Value',
  `position` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Ration option position on frontend'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Rating options' AUTO_INCREMENT=16 ;

INSERT INTO `#__rating_option` (`option_id`, `rating_id`, `code`, `value`, `position`) VALUES
(1, 1, '1', 1, 1),
(2, 1, '2', 2, 2),
(3, 1, '3', 3, 3),
(4, 1, '4', 4, 4),
(5, 1, '5', 5, 5),
(6, 2, '1', 1, 1),
(7, 2, '2', 2, 2),
(8, 2, '3', 3, 3),
(9, 2, '4', 4, 4),
(10, 2, '5', 5, 5),
(11, 3, '1', 1, 1),
(12, 3, '2', 2, 2),
(13, 3, '3', 3, 3),
(14, 3, '4', 4, 4),
(15, 3, '5', 5, 5);

CREATE TABLE IF NOT EXISTS `#__rating_option_vote` (
`vote_id` bigint(20) unsigned NOT NULL COMMENT 'Vote id',
  `option_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Vote option id',
  `remote_ip` varchar(50) DEFAULT NULL,
  `remote_ip_long` varbinary(16) DEFAULT NULL,
  `customer_id` int(10) unsigned DEFAULT '0' COMMENT 'Customer Id',
  `entity_pk_value` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'Product id',
  `rating_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating id',
  `review_id` bigint(20) unsigned DEFAULT NULL COMMENT 'Review id',
  `percent` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Percent amount',
  `value` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Vote option value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Rating option values' AUTO_INCREMENT=34 ;

INSERT INTO `#__rating_option_vote` (`vote_id`, `option_id`, `remote_ip`, `remote_ip_long`, `customer_id`, `entity_pk_value`, `rating_id`, `review_id`, `percent`, `value`) VALUES
(1, 10, '127.0.0.1', 0x7f000001, 2, 9, 2, 6, 100, 5),
(2, 5, '127.0.0.1', 0x7f000001, 2, 9, 1, 6, 100, 5),
(3, 15, '127.0.0.1', 0x7f000001, 2, 9, 3, 6, 100, 5),
(4, 10, '127.0.0.1', 0x7f000001, 2, 9, 2, 7, 100, 5),
(5, 5, '127.0.0.1', 0x7f000001, 2, 9, 1, 7, 100, 5),
(6, 15, '127.0.0.1', 0x7f000001, 2, 9, 3, 7, 100, 5),
(7, 10, '127.0.0.1', 0x7f000001, 2, 8, 2, 8, 100, 5),
(8, 5, '127.0.0.1', 0x7f000001, 2, 8, 1, 8, 100, 5),
(9, 15, '127.0.0.1', 0x7f000001, 2, 8, 3, 8, 100, 5),
(10, 10, '127.0.0.1', 0x7f000001, 2, 11, 2, 9, 100, 5),
(11, 5, '127.0.0.1', 0x7f000001, 2, 11, 1, 9, 100, 5),
(12, 15, '127.0.0.1', 0x7f000001, 2, 11, 3, 9, 100, 5),
(13, 10, '127.0.0.1', 0x7f000001, NULL, 9, 2, 5, 100, 5),
(14, 5, '127.0.0.1', 0x7f000001, NULL, 9, 1, 5, 100, 5),
(15, 15, '127.0.0.1', 0x7f000001, NULL, 9, 3, 5, 100, 5),
(16, 10, '127.0.0.1', 0x7f000001, NULL, 8, 2, 4, 100, 5),
(17, 5, '127.0.0.1', 0x7f000001, NULL, 8, 1, 4, 100, 5),
(18, 15, '127.0.0.1', 0x7f000001, NULL, 8, 3, 4, 100, 5),
(19, 9, '127.0.0.1', 0x7f000001, NULL, 11, 2, 3, 80, 4),
(20, 3, '127.0.0.1', 0x7f000001, NULL, 11, 1, 3, 60, 3),
(21, 13, '127.0.0.1', 0x7f000001, NULL, 11, 3, 3, 60, 3),
(22, 6, '127.0.0.1', 0x7f000001, NULL, 9, 2, 2, 20, 1),
(23, 4, '127.0.0.1', 0x7f000001, NULL, 9, 1, 2, 80, 4),
(24, 15, '127.0.0.1', 0x7f000001, NULL, 9, 3, 2, 100, 5),
(25, 8, '127.0.0.1', 0x7f000001, NULL, 45, 2, 1, 60, 3),
(26, 4, '127.0.0.1', 0x7f000001, NULL, 45, 1, 1, 80, 4),
(27, 15, '127.0.0.1', 0x7f000001, NULL, 45, 3, 1, 100, 5),
(28, 5, '127.0.0.1', 0x7f000001, NULL, 45, 1, 10, 100, 5),
(29, 15, '127.0.0.1', 0x7f000001, NULL, 45, 3, 10, 100, 5),
(30, 10, '127.0.0.1', 0x7f000001, NULL, 45, 2, 10, 100, 5),
(31, 14, '127.0.0.1', 0x7f000001, NULL, 45, 3, 11, 80, 4),
(32, 9, '127.0.0.1', 0x7f000001, NULL, 45, 2, 11, 80, 4),
(33, 4, '127.0.0.1', 0x7f000001, NULL, 45, 1, 11, 80, 4);

CREATE TABLE IF NOT EXISTS `#__rating_option_vote_aggregated` (
`primary_id` int(11) NOT NULL COMMENT 'Vote aggregation id',
  `rating_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating id',
  `entity_pk_value` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'Product id',
  `vote_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Vote dty',
  `vote_value_sum` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'General vote sum',
  `percent` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Vote percent',
  `percent_approved` smallint(6) DEFAULT '0' COMMENT 'Vote percent approved by admin',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Rating vote aggregated' AUTO_INCREMENT=37 ;

INSERT INTO `#__rating_option_vote_aggregated` (`primary_id`, `rating_id`, `entity_pk_value`, `vote_count`, `vote_value_sum`, `percent`, `percent_approved`, `store_id`) VALUES
(1, 2, 9, 4, 16, 80, 80, 0),
(2, 2, 9, 4, 16, 80, 80, 1),
(3, 1, 9, 4, 19, 95, 95, 0),
(4, 1, 9, 4, 19, 95, 95, 1),
(5, 3, 9, 4, 20, 100, 100, 0),
(6, 3, 9, 4, 20, 100, 100, 1),
(7, 2, 8, 2, 10, 100, 100, 0),
(8, 2, 8, 2, 10, 100, 100, 1),
(9, 1, 8, 2, 10, 100, 100, 0),
(10, 1, 8, 2, 10, 100, 100, 1),
(11, 3, 8, 2, 10, 100, 100, 0),
(12, 3, 8, 2, 10, 100, 100, 1),
(13, 2, 11, 2, 9, 90, 90, 0),
(14, 2, 11, 2, 9, 90, 90, 1),
(15, 1, 11, 2, 8, 80, 80, 0),
(16, 1, 11, 2, 8, 80, 80, 1),
(17, 3, 11, 2, 8, 80, 80, 0),
(18, 3, 11, 2, 8, 80, 80, 1),
(19, 1, 11, 2, 8, 80, 80, 2),
(20, 2, 11, 2, 9, 90, 90, 2),
(21, 3, 11, 2, 8, 80, 80, 2),
(22, 1, 8, 2, 10, 100, 100, 2),
(23, 2, 8, 2, 10, 100, 100, 2),
(24, 3, 8, 2, 10, 100, 100, 2),
(25, 1, 9, 4, 19, 95, 95, 2),
(26, 2, 9, 4, 16, 80, 80, 2),
(27, 3, 9, 4, 20, 100, 100, 2),
(28, 2, 45, 3, 12, 80, 80, 0),
(29, 2, 45, 1, 3, 60, 60, 2),
(30, 1, 45, 3, 13, 87, 90, 0),
(31, 1, 45, 1, 4, 80, 80, 2),
(32, 3, 45, 3, 14, 93, 100, 0),
(33, 3, 45, 1, 5, 100, 100, 2),
(34, 1, 45, 2, 9, 90, 100, 1),
(35, 3, 45, 2, 9, 90, 100, 1),
(36, 2, 45, 2, 9, 90, 100, 1);

CREATE TABLE IF NOT EXISTS `#__rating_store` (
  `rating_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Rating Store';

INSERT INTO `#__rating_store` (`rating_id`, `store_id`) VALUES
(1, 0),
(2, 0),
(3, 0),
(1, 1),
(2, 1),
(3, 1),
(1, 2),
(2, 2),
(3, 2);

CREATE TABLE IF NOT EXISTS `#__rating_title` (
  `rating_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `value` varchar(255) NOT NULL COMMENT 'Rating Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Rating Title';

CREATE TABLE IF NOT EXISTS `#__report_compared_product_index` (
`index_id` bigint(20) unsigned NOT NULL COMMENT 'Index Id',
  `visitor_id` int(10) unsigned DEFAULT NULL COMMENT 'Visitor Id',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `added_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Added At'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Reports Compared Product Index Table' AUTO_INCREMENT=3 ;

INSERT INTO `#__report_compared_product_index` (`index_id`, `visitor_id`, `customer_id`, `product_id`, `store_id`, `added_at`) VALUES
(1, 28, NULL, 17, 3, '2015-07-01 21:40:37'),
(2, 53, NULL, 39, 3, '2015-07-11 00:24:52');

CREATE TABLE IF NOT EXISTS `#__report_event` (
`event_id` bigint(20) unsigned NOT NULL COMMENT 'Event Id',
  `logged_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Logged At',
  `event_type_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Event Type Id',
  `object_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Object Id',
  `subject_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Subject Id',
  `subtype` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Subtype',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Reports Event Table' AUTO_INCREMENT=38 ;

INSERT INTO `#__report_event` (`event_id`, `logged_at`, `event_type_id`, `object_id`, `subject_id`, `subtype`, `store_id`) VALUES
(1, '2015-06-30 02:55:30', 1, 10, 4, 1, 2),
(2, '2015-06-30 02:55:33', 1, 10, 4, 1, 2),
(3, '2015-06-30 19:30:43', 1, 14, 8, 1, 1),
(4, '2015-06-30 21:50:11', 1, 10, 12, 1, 3),
(5, '2015-07-01 03:29:45', 1, 39, 21, 1, 1),
(6, '2015-07-01 19:15:22', 1, 33, 23, 1, 1),
(7, '2015-07-01 19:46:22', 1, 33, 23, 1, 1),
(8, '2015-07-01 20:04:53', 1, 36, 24, 1, 1),
(9, '2015-07-01 20:20:34', 1, 36, 24, 1, 1),
(10, '2015-07-01 20:54:53', 1, 7, 29, 1, 3),
(11, '2015-07-01 21:36:18', 4, 10, 28, 1, 1),
(12, '2015-07-01 21:36:55', 1, 12, 28, 1, 1),
(13, '2015-07-01 21:36:58', 1, 12, 28, 1, 1),
(14, '2015-07-01 21:40:37', 3, 17, 28, 1, 3),
(15, '2015-07-01 21:42:34', 4, 11, 28, 1, 3),
(16, '2015-07-02 00:17:14', 1, 8, 34, 1, 1),
(17, '2015-07-02 01:04:33', 1, 11, 36, 1, 1),
(18, '2015-07-02 19:37:34', 1, 7, 43, 1, 1),
(19, '2015-07-02 20:38:33', 1, 8, 43, 1, 1),
(20, '2015-07-02 20:40:41', 1, 8, 43, 1, 1),
(21, '2015-07-02 21:09:52', 1, 8, 43, 1, 1),
(22, '2015-07-03 03:03:39', 1, 9, 48, 1, 1),
(23, '2015-07-11 00:24:53', 3, 39, 53, 1, 3),
(24, '2015-07-11 00:36:19', 1, 7, 53, 1, 3),
(25, '2015-07-11 01:56:39', 1, 39, 55, 1, 2),
(26, '2015-07-11 02:06:31', 4, 8, 56, 1, 1),
(27, '2015-07-11 02:06:51', 4, 10, 56, 1, 1),
(28, '2015-07-12 20:05:23', 1, 41, 58, 1, 2),
(29, '2015-07-12 21:40:27', 1, 33, 62, 1, 1),
(30, '2015-07-13 01:49:00', 1, 7, 67, 1, 2),
(31, '2015-07-13 01:50:49', 1, 7, 67, 1, 2),
(32, '2015-07-13 01:57:58', 1, 10, 68, 1, 3),
(33, '2015-07-13 01:58:08', 1, 10, 68, 1, 3),
(34, '2015-07-13 01:59:02', 1, 10, 69, 1, 1),
(35, '2015-07-13 01:59:53', 1, 10, 69, 1, 1),
(36, '2015-07-13 02:01:59', 4, 33, 68, 1, 3),
(37, '2015-07-13 02:03:05', 1, 8, 66, 1, 1);

CREATE TABLE IF NOT EXISTS `#__report_event_types` (
`event_type_id` smallint(5) unsigned NOT NULL COMMENT 'Event Type Id',
  `event_name` varchar(64) NOT NULL COMMENT 'Event Name',
  `customer_login` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Login'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Reports Event Type Table' AUTO_INCREMENT=7 ;

INSERT INTO `#__report_event_types` (`event_type_id`, `event_name`, `customer_login`) VALUES
(1, 'catalog_product_view', 0),
(2, 'sendfriend_product', 0),
(3, 'catalog_product_compare_add_product', 0),
(4, 'checkout_cart_add_product', 0),
(5, 'wishlist_add_product', 0),
(6, 'wishlist_share', 0);

CREATE TABLE IF NOT EXISTS `#__report_viewed_product_aggregated_daily` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int(11) NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Most Viewed Products Aggregated Daily' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__report_viewed_product_aggregated_monthly` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int(11) NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Most Viewed Products Aggregated Monthly' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__report_viewed_product_aggregated_yearly` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `views_num` int(11) NOT NULL DEFAULT '0' COMMENT 'Number of Views',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Most Viewed Products Aggregated Yearly' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__report_viewed_product_index` (
`index_id` bigint(20) unsigned NOT NULL COMMENT 'Index Id',
  `visitor_id` int(10) unsigned DEFAULT NULL COMMENT 'Visitor Id',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `added_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Added At'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Reports Viewed Product Index Table' AUTO_INCREMENT=30 ;

INSERT INTO `#__report_viewed_product_index` (`index_id`, `visitor_id`, `customer_id`, `product_id`, `store_id`, `added_at`) VALUES
(1, 4, NULL, 10, 2, '2015-06-30 02:55:33'),
(2, 8, NULL, 14, 1, '2015-06-30 19:30:43'),
(3, 12, NULL, 10, 3, '2015-06-30 21:50:10'),
(4, 21, NULL, 39, 1, '2015-07-01 03:29:44'),
(5, 23, NULL, 33, 1, '2015-07-01 19:46:22'),
(7, 24, NULL, 36, 1, '2015-07-01 20:20:33'),
(9, 29, NULL, 7, 3, '2015-07-01 20:54:53'),
(10, 28, NULL, 12, 1, '2015-07-01 21:36:58'),
(12, 34, NULL, 8, 1, '2015-07-02 00:17:14'),
(13, 36, NULL, 11, 1, '2015-07-02 01:04:33'),
(14, 43, NULL, 7, 1, '2015-07-02 19:37:34'),
(15, 43, NULL, 8, 1, '2015-07-02 21:09:52'),
(18, 48, NULL, 9, 1, '2015-07-03 03:03:39'),
(19, 53, NULL, 7, 3, '2015-07-11 00:36:18'),
(20, 55, NULL, 39, 2, '2015-07-11 01:56:39'),
(21, 58, NULL, 41, 2, '2015-07-12 20:05:23'),
(22, 62, NULL, 33, 1, '2015-07-12 21:40:27'),
(23, 67, NULL, 7, 2, '2015-07-13 01:50:48'),
(25, 68, NULL, 10, 3, '2015-07-13 01:58:08'),
(27, 69, NULL, 10, 1, '2015-07-13 01:59:53'),
(29, 66, NULL, 8, 1, '2015-07-13 02:03:05');

CREATE TABLE IF NOT EXISTS `#__review` (
`review_id` bigint(20) unsigned NOT NULL COMMENT 'Review id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Review create date',
  `entity_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity id',
  `entity_pk_value` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product id',
  `status_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Status code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Review base information' AUTO_INCREMENT=12 ;

INSERT INTO `#__review` (`review_id`, `created_at`, `entity_id`, `entity_pk_value`, `status_id`) VALUES
(1, '2014-12-04 20:58:08', 1, 45, 1),
(2, '2015-01-19 00:53:37', 1, 9, 1),
(3, '2015-01-19 00:54:30', 1, 11, 1),
(4, '2015-01-19 00:54:43', 1, 8, 1),
(5, '2015-01-19 00:54:53', 1, 9, 1),
(6, '2015-01-19 00:55:40', 1, 9, 1),
(7, '2015-01-19 00:55:48', 1, 9, 1),
(8, '2015-01-19 00:55:57', 1, 8, 1),
(9, '2015-01-19 00:56:13', 1, 11, 1),
(10, '2015-05-11 01:18:38', 1, 45, 1),
(11, '2015-05-13 01:29:46', 1, 45, 2);

CREATE TABLE IF NOT EXISTS `#__review_detail` (
`detail_id` bigint(20) unsigned NOT NULL COMMENT 'Review detail id',
  `review_id` bigint(20) unsigned NOT NULL DEFAULT '0' COMMENT 'Review id',
  `store_id` smallint(5) unsigned DEFAULT '0' COMMENT 'Store id',
  `title` varchar(255) NOT NULL COMMENT 'Title',
  `detail` text NOT NULL COMMENT 'Detail description',
  `nickname` varchar(128) NOT NULL COMMENT 'User nickname',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Review detail information' AUTO_INCREMENT=12 ;

INSERT INTO `#__review_detail` (`detail_id`, `review_id`, `store_id`, `title`, `detail`, `nickname`, `customer_id`) VALUES
(1, 1, 1, 'Excellent !!!', 'Good job :)', 'Nguyen', 1),
(2, 2, 1, 'i like its ', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(3, 3, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(4, 4, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(5, 5, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(6, 6, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(7, 7, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(8, 8, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(9, 9, 1, 'good', 'Maecenas dapibus nibh eu est. Proin faucibus pharetra nibh. Integer aliquet tellus in felis. Quisque mi pede, imperdiet a, dapibus vel, bibendum rhoncus, nulla. ', 'nguyen', 2),
(10, 10, 1, 'demo', 'demo', 'admin', NULL),
(11, 11, 1, 'demo', 'demo', 'admin', NULL);

CREATE TABLE IF NOT EXISTS `#__review_entity` (
`entity_id` smallint(5) unsigned NOT NULL COMMENT 'Review entity id',
  `entity_code` varchar(32) NOT NULL COMMENT 'Review entity code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Review entities' AUTO_INCREMENT=4 ;

INSERT INTO `#__review_entity` (`entity_id`, `entity_code`) VALUES
(1, 'product'),
(2, 'customer'),
(3, 'category');

CREATE TABLE IF NOT EXISTS `#__review_entity_summary` (
`primary_id` bigint(20) NOT NULL COMMENT 'Summary review entity id',
  `entity_pk_value` bigint(20) NOT NULL DEFAULT '0' COMMENT 'Product id',
  `entity_type` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Entity type id',
  `reviews_count` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Qty of reviews',
  `rating_summary` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Summarized rating',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Review aggregates' AUTO_INCREMENT=13 ;

INSERT INTO `#__review_entity_summary` (`primary_id`, `entity_pk_value`, `entity_type`, `reviews_count`, `rating_summary`, `store_id`) VALUES
(1, 45, 1, 1, 100, 1),
(2, 45, 1, 1, 80, 2),
(3, 9, 1, 4, 92, 1),
(4, 9, 1, 4, 92, 2),
(5, 11, 1, 2, 83, 1),
(6, 11, 1, 2, 83, 2),
(7, 8, 1, 2, 100, 1),
(8, 8, 1, 2, 100, 2),
(9, 11, 1, 2, 83, 0),
(10, 9, 1, 4, 92, 0),
(11, 8, 1, 2, 100, 0),
(12, 45, 1, 2, 90, 0);

CREATE TABLE IF NOT EXISTS `#__review_status` (
`status_id` smallint(5) unsigned NOT NULL COMMENT 'Status id',
  `status_code` varchar(32) NOT NULL COMMENT 'Status code'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Review statuses' AUTO_INCREMENT=4 ;

INSERT INTO `#__review_status` (`status_id`, `status_code`) VALUES
(1, 'Approved'),
(2, 'Pending'),
(3, 'Not Approved');

CREATE TABLE IF NOT EXISTS `#__review_store` (
  `review_id` bigint(20) unsigned NOT NULL COMMENT 'Review Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Review Store';

INSERT INTO `#__review_store` (`review_id`, `store_id`) VALUES
(1, 0),
(2, 0),
(3, 0),
(4, 0),
(5, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(11, 0),
(2, 1),
(3, 1),
(4, 1),
(5, 1),
(6, 1),
(7, 1),
(8, 1),
(9, 1),
(10, 1),
(11, 1),
(1, 2),
(2, 2),
(3, 2),
(4, 2),
(5, 2),
(6, 2),
(7, 2),
(8, 2),
(9, 2);

CREATE TABLE IF NOT EXISTS `#__salesrule` (
`rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `from_date` date DEFAULT NULL,
  `to_date` date DEFAULT NULL,
  `uses_per_customer` int(11) NOT NULL DEFAULT '0' COMMENT 'Uses Per Customer',
  `is_active` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is Active',
  `conditions_serialized` mediumtext COMMENT 'Conditions Serialized',
  `actions_serialized` mediumtext COMMENT 'Actions Serialized',
  `stop_rules_processing` smallint(6) NOT NULL DEFAULT '1' COMMENT 'Stop Rules Processing',
  `is_advanced` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Advanced',
  `product_ids` text COMMENT 'Product Ids',
  `sort_order` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort Order',
  `simple_action` varchar(32) DEFAULT NULL COMMENT 'Simple Action',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `discount_qty` decimal(12,4) DEFAULT NULL COMMENT 'Discount Qty',
  `discount_step` int(10) unsigned NOT NULL COMMENT 'Discount Step',
  `simple_free_shipping` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Simple Free Shipping',
  `apply_to_shipping` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Apply To Shipping',
  `times_used` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  `is_rss` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Is Rss',
  `coupon_type` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Coupon Type',
  `use_auto_generation` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Use Auto Generation',
  `uses_per_coupon` int(11) NOT NULL DEFAULT '0' COMMENT 'Uses Per Coupon'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__salesrule_coupon` (
`coupon_id` int(10) unsigned NOT NULL COMMENT 'Coupon Id',
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `usage_limit` int(10) unsigned DEFAULT NULL COMMENT 'Usage Limit',
  `usage_per_customer` int(10) unsigned DEFAULT NULL COMMENT 'Usage Per Customer',
  `times_used` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used',
  `expiration_date` timestamp NULL DEFAULT NULL COMMENT 'Expiration Date',
  `is_primary` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Primary',
  `created_at` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP COMMENT 'Coupon Code Creation Date',
  `type` smallint(6) DEFAULT '0' COMMENT 'Coupon Code Type'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule Coupon' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__salesrule_coupon_usage` (
  `coupon_id` int(10) unsigned NOT NULL COMMENT 'Coupon Id',
  `customer_id` int(10) unsigned NOT NULL COMMENT 'Customer Id',
  `times_used` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule Coupon Usage';

CREATE TABLE IF NOT EXISTS `#__salesrule_customer` (
`rule_customer_id` int(10) unsigned NOT NULL COMMENT 'Rule Customer Id',
  `rule_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Rule Id',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer Id',
  `times_used` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Times Used'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule Customer' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__salesrule_customer_group` (
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Rules To Customer Groups Relations';

CREATE TABLE IF NOT EXISTS `#__salesrule_label` (
`label_id` int(10) unsigned NOT NULL COMMENT 'Label Id',
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(255) DEFAULT NULL COMMENT 'Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule Label' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__salesrule_product_attribute` (
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Salesrule Product Attribute';

CREATE TABLE IF NOT EXISTS `#__salesrule_website` (
  `rule_id` int(10) unsigned NOT NULL COMMENT 'Rule Id',
  `website_id` smallint(5) unsigned NOT NULL COMMENT 'Website Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Rules To Websites Relations';

CREATE TABLE IF NOT EXISTS `#__sales_bestsellers_aggregated_daily` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Bestsellers Aggregated Daily' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_bestsellers_aggregated_monthly` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Bestsellers Aggregated Monthly' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_bestsellers_aggregated_yearly` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_name` varchar(255) DEFAULT NULL COMMENT 'Product Name',
  `product_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Product Price',
  `qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `rating_pos` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Rating Pos'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Bestsellers Aggregated Yearly' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_billing_agreement` (
`agreement_id` int(10) unsigned NOT NULL COMMENT 'Agreement Id',
  `customer_id` int(10) unsigned NOT NULL COMMENT 'Customer Id',
  `method_code` varchar(32) NOT NULL COMMENT 'Method Code',
  `reference_id` varchar(32) NOT NULL COMMENT 'Reference Id',
  `status` varchar(20) NOT NULL COMMENT 'Status',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `agreement_label` varchar(255) DEFAULT NULL COMMENT 'Agreement Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Billing Agreement' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_billing_agreement_order` (
  `agreement_id` int(10) unsigned NOT NULL COMMENT 'Agreement Id',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Billing Agreement Order';

CREATE TABLE IF NOT EXISTS `#__sales_flat_creditmemo` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `adjustment_positive` decimal(12,4) DEFAULT NULL COMMENT 'Adjustment Positive',
  `base_shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `store_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `base_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `base_adjustment_negative` decimal(12,4) DEFAULT NULL COMMENT 'Base Adjustment Negative',
  `base_subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `adjustment_negative` decimal(12,4) DEFAULT NULL COMMENT 'Adjustment Negative',
  `base_shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `store_to_base_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `base_to_global_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_adjustment` decimal(12,4) DEFAULT NULL COMMENT 'Base Adjustment',
  `base_subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Discount Amount',
  `subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal',
  `adjustment` decimal(12,4) DEFAULT NULL COMMENT 'Adjustment',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_adjustment_positive` decimal(12,4) DEFAULT NULL COMMENT 'Base Adjustment Positive',
  `base_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `email_sent` smallint(5) unsigned DEFAULT NULL COMMENT 'Email Sent',
  `creditmemo_status` int(11) DEFAULT NULL COMMENT 'Creditmemo Status',
  `state` int(11) DEFAULT NULL COMMENT 'State',
  `shipping_address_id` int(11) DEFAULT NULL COMMENT 'Shipping Address Id',
  `billing_address_id` int(11) DEFAULT NULL COMMENT 'Billing Address Id',
  `invoice_id` int(11) DEFAULT NULL COMMENT 'Invoice Id',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT 'Transaction Id',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `shipping_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Hidden Tax Amount',
  `base_shipping_hidden_tax_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Hidden Tax Amount',
  `shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Creditmemo' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_creditmemo_comment` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `is_customer_notified` int(11) DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Creditmemo Comment' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_creditmemo_grid` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `store_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `base_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `store_to_base_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `base_to_global_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `creditmemo_status` int(11) DEFAULT NULL COMMENT 'Creditmemo Status',
  `state` int(11) DEFAULT NULL COMMENT 'State',
  `invoice_id` int(11) DEFAULT NULL COMMENT 'Invoice Id',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `order_created_at` timestamp NULL DEFAULT NULL COMMENT 'Order Created At',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Creditmemo Grid';

CREATE TABLE IF NOT EXISTS `#__sales_flat_creditmemo_item` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `base_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Price',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_row_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total',
  `discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Discount Amount',
  `row_total` decimal(12,4) DEFAULT NULL COMMENT 'Row Total',
  `base_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `base_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Cost',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `base_row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `product_id` int(11) DEFAULT NULL COMMENT 'Product Id',
  `order_item_id` int(11) DEFAULT NULL COMMENT 'Order Item Id',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Creditmemo Item' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_invoice` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `store_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `base_shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `base_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `base_subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `store_to_base_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `base_shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `base_to_global_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal',
  `base_subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Discount Amount',
  `billing_address_id` int(11) DEFAULT NULL COMMENT 'Billing Address Id',
  `is_used_for_refund` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Used For Refund',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `email_sent` smallint(5) unsigned DEFAULT NULL COMMENT 'Email Sent',
  `can_void_flag` smallint(5) unsigned DEFAULT NULL COMMENT 'Can Void Flag',
  `state` int(11) DEFAULT NULL COMMENT 'State',
  `shipping_address_id` int(11) DEFAULT NULL COMMENT 'Shipping Address Id',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `transaction_id` varchar(255) DEFAULT NULL COMMENT 'Transaction Id',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `shipping_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Hidden Tax Amount',
  `base_shipping_hidden_tax_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Hidden Tax Amount',
  `shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `base_total_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Refunded',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Invoice' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_invoice_comment` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `is_customer_notified` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Invoice Comment' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_invoice_grid` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `state` int(11) DEFAULT NULL COMMENT 'State',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `order_currency_code` varchar(3) DEFAULT NULL COMMENT 'Order Currency Code',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `order_created_at` timestamp NULL DEFAULT NULL COMMENT 'Order Created At',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Invoice Grid';

CREATE TABLE IF NOT EXISTS `#__sales_flat_invoice_item` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `base_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Price',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `base_row_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total',
  `discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Discount Amount',
  `row_total` decimal(12,4) DEFAULT NULL COMMENT 'Row Total',
  `base_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `base_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Cost',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `base_row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `product_id` int(11) DEFAULT NULL COMMENT 'Product Id',
  `order_item_id` int(11) DEFAULT NULL COMMENT 'Order Item Id',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Invoice Item' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_order` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `state` varchar(32) DEFAULT NULL COMMENT 'State',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `coupon_code` varchar(255) DEFAULT NULL COMMENT 'Coupon Code',
  `protect_code` varchar(255) DEFAULT NULL COMMENT 'Protect Code',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `is_virtual` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `base_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Amount',
  `base_discount_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Canceled',
  `base_discount_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Invoiced',
  `base_discount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Refunded',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `base_shipping_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Canceled',
  `base_shipping_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Invoiced',
  `base_shipping_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Refunded',
  `base_shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `base_shipping_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Tax Refunded',
  `base_subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `base_subtotal_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Canceled',
  `base_subtotal_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Invoiced',
  `base_subtotal_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Refunded',
  `base_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Amount',
  `base_tax_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Canceled',
  `base_tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Invoiced',
  `base_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Refunded',
  `base_to_global_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Order Rate',
  `base_total_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Canceled',
  `base_total_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Invoiced',
  `base_total_invoiced_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Invoiced Cost',
  `base_total_offline_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Offline Refunded',
  `base_total_online_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Online Refunded',
  `base_total_paid` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Paid',
  `base_total_qty_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Qty Ordered',
  `base_total_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Refunded',
  `discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Discount Amount',
  `discount_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Discount Canceled',
  `discount_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Discount Invoiced',
  `discount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Discount Refunded',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `shipping_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Canceled',
  `shipping_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Invoiced',
  `shipping_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Refunded',
  `shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `shipping_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Tax Refunded',
  `store_to_base_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Base Rate',
  `store_to_order_rate` decimal(12,4) DEFAULT NULL COMMENT 'Store To Order Rate',
  `subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal',
  `subtotal_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Canceled',
  `subtotal_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Invoiced',
  `subtotal_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Refunded',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `tax_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Tax Canceled',
  `tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Tax Invoiced',
  `tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Tax Refunded',
  `total_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Total Canceled',
  `total_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Total Invoiced',
  `total_offline_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Total Offline Refunded',
  `total_online_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Total Online Refunded',
  `total_paid` decimal(12,4) DEFAULT NULL COMMENT 'Total Paid',
  `total_qty_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty Ordered',
  `total_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Total Refunded',
  `can_ship_partially` smallint(5) unsigned DEFAULT NULL COMMENT 'Can Ship Partially',
  `can_ship_partially_item` smallint(5) unsigned DEFAULT NULL COMMENT 'Can Ship Partially Item',
  `customer_is_guest` smallint(5) unsigned DEFAULT NULL COMMENT 'Customer Is Guest',
  `customer_note_notify` smallint(5) unsigned DEFAULT NULL COMMENT 'Customer Note Notify',
  `billing_address_id` int(11) DEFAULT NULL COMMENT 'Billing Address Id',
  `customer_group_id` smallint(6) DEFAULT NULL COMMENT 'Customer Group Id',
  `edit_increment` int(11) DEFAULT NULL COMMENT 'Edit Increment',
  `email_sent` smallint(5) unsigned DEFAULT NULL COMMENT 'Email Sent',
  `forced_shipment_with_invoice` smallint(5) unsigned DEFAULT NULL COMMENT 'Forced Do Shipment With Invoice',
  `payment_auth_expiration` int(11) DEFAULT NULL COMMENT 'Payment Authorization Expiration',
  `quote_address_id` int(11) DEFAULT NULL COMMENT 'Quote Address Id',
  `quote_id` int(11) DEFAULT NULL COMMENT 'Quote Id',
  `shipping_address_id` int(11) DEFAULT NULL COMMENT 'Shipping Address Id',
  `adjustment_negative` decimal(12,4) DEFAULT NULL COMMENT 'Adjustment Negative',
  `adjustment_positive` decimal(12,4) DEFAULT NULL COMMENT 'Adjustment Positive',
  `base_adjustment_negative` decimal(12,4) DEFAULT NULL COMMENT 'Base Adjustment Negative',
  `base_adjustment_positive` decimal(12,4) DEFAULT NULL COMMENT 'Base Adjustment Positive',
  `base_shipping_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Discount Amount',
  `base_subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Incl Tax',
  `base_total_due` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Due',
  `payment_authorization_amount` decimal(12,4) DEFAULT NULL COMMENT 'Payment Authorization Amount',
  `shipping_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Discount Amount',
  `subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `total_due` decimal(12,4) DEFAULT NULL COMMENT 'Total Due',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `customer_dob` datetime DEFAULT NULL COMMENT 'Customer Dob',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `applied_rule_ids` varchar(255) DEFAULT NULL COMMENT 'Applied Rule Ids',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `customer_email` varchar(255) DEFAULT NULL COMMENT 'Customer Email',
  `customer_firstname` varchar(255) DEFAULT NULL COMMENT 'Customer Firstname',
  `customer_lastname` varchar(255) DEFAULT NULL COMMENT 'Customer Lastname',
  `customer_middlename` varchar(255) DEFAULT NULL COMMENT 'Customer Middlename',
  `customer_prefix` varchar(255) DEFAULT NULL COMMENT 'Customer Prefix',
  `customer_suffix` varchar(255) DEFAULT NULL COMMENT 'Customer Suffix',
  `customer_taxvat` varchar(255) DEFAULT NULL COMMENT 'Customer Taxvat',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `ext_customer_id` varchar(255) DEFAULT NULL COMMENT 'Ext Customer Id',
  `ext_order_id` varchar(255) DEFAULT NULL COMMENT 'Ext Order Id',
  `global_currency_code` varchar(3) DEFAULT NULL COMMENT 'Global Currency Code',
  `hold_before_state` varchar(255) DEFAULT NULL COMMENT 'Hold Before State',
  `hold_before_status` varchar(255) DEFAULT NULL COMMENT 'Hold Before Status',
  `order_currency_code` varchar(255) DEFAULT NULL COMMENT 'Order Currency Code',
  `original_increment_id` varchar(50) DEFAULT NULL COMMENT 'Original Increment Id',
  `relation_child_id` varchar(32) DEFAULT NULL COMMENT 'Relation Child Id',
  `relation_child_real_id` varchar(32) DEFAULT NULL COMMENT 'Relation Child Real Id',
  `relation_parent_id` varchar(32) DEFAULT NULL COMMENT 'Relation Parent Id',
  `relation_parent_real_id` varchar(32) DEFAULT NULL COMMENT 'Relation Parent Real Id',
  `remote_ip` varchar(255) DEFAULT NULL COMMENT 'Remote Ip',
  `shipping_method` varchar(255) DEFAULT NULL COMMENT 'Shipping Method',
  `store_currency_code` varchar(3) DEFAULT NULL COMMENT 'Store Currency Code',
  `store_name` varchar(255) DEFAULT NULL COMMENT 'Store Name',
  `x_forwarded_for` varchar(255) DEFAULT NULL COMMENT 'X Forwarded For',
  `customer_note` text COMMENT 'Customer Note',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `total_item_count` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Total Item Count',
  `customer_gender` int(11) DEFAULT NULL COMMENT 'Customer Gender',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `shipping_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Hidden Tax Amount',
  `base_shipping_hidden_tax_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Hidden Tax Amount',
  `hidden_tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Invoiced',
  `base_hidden_tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Invoiced',
  `hidden_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Refunded',
  `base_hidden_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Refunded',
  `shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `coupon_rule_name` varchar(255) DEFAULT NULL COMMENT 'Coupon Sales Rule Name',
  `paypal_ipn_customer_notified` int(11) DEFAULT '0' COMMENT 'Paypal Ipn Customer Notified',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order' AUTO_INCREMENT=2 ;

INSERT INTO `#__sales_flat_order` (`entity_id`, `state`, `status`, `coupon_code`, `protect_code`, `shipping_description`, `is_virtual`, `store_id`, `customer_id`, `base_discount_amount`, `base_discount_canceled`, `base_discount_invoiced`, `base_discount_refunded`, `base_grand_total`, `base_shipping_amount`, `base_shipping_canceled`, `base_shipping_invoiced`, `base_shipping_refunded`, `base_shipping_tax_amount`, `base_shipping_tax_refunded`, `base_subtotal`, `base_subtotal_canceled`, `base_subtotal_invoiced`, `base_subtotal_refunded`, `base_tax_amount`, `base_tax_canceled`, `base_tax_invoiced`, `base_tax_refunded`, `base_to_global_rate`, `base_to_order_rate`, `base_total_canceled`, `base_total_invoiced`, `base_total_invoiced_cost`, `base_total_offline_refunded`, `base_total_online_refunded`, `base_total_paid`, `base_total_qty_ordered`, `base_total_refunded`, `discount_amount`, `discount_canceled`, `discount_invoiced`, `discount_refunded`, `grand_total`, `shipping_amount`, `shipping_canceled`, `shipping_invoiced`, `shipping_refunded`, `shipping_tax_amount`, `shipping_tax_refunded`, `store_to_base_rate`, `store_to_order_rate`, `subtotal`, `subtotal_canceled`, `subtotal_invoiced`, `subtotal_refunded`, `tax_amount`, `tax_canceled`, `tax_invoiced`, `tax_refunded`, `total_canceled`, `total_invoiced`, `total_offline_refunded`, `total_online_refunded`, `total_paid`, `total_qty_ordered`, `total_refunded`, `can_ship_partially`, `can_ship_partially_item`, `customer_is_guest`, `customer_note_notify`, `billing_address_id`, `customer_group_id`, `edit_increment`, `email_sent`, `forced_shipment_with_invoice`, `payment_auth_expiration`, `quote_address_id`, `quote_id`, `shipping_address_id`, `adjustment_negative`, `adjustment_positive`, `base_adjustment_negative`, `base_adjustment_positive`, `base_shipping_discount_amount`, `base_subtotal_incl_tax`, `base_total_due`, `payment_authorization_amount`, `shipping_discount_amount`, `subtotal_incl_tax`, `total_due`, `weight`, `customer_dob`, `increment_id`, `applied_rule_ids`, `base_currency_code`, `customer_email`, `customer_firstname`, `customer_lastname`, `customer_middlename`, `customer_prefix`, `customer_suffix`, `customer_taxvat`, `discount_description`, `ext_customer_id`, `ext_order_id`, `global_currency_code`, `hold_before_state`, `hold_before_status`, `order_currency_code`, `original_increment_id`, `relation_child_id`, `relation_child_real_id`, `relation_parent_id`, `relation_parent_real_id`, `remote_ip`, `shipping_method`, `store_currency_code`, `store_name`, `x_forwarded_for`, `customer_note`, `created_at`, `updated_at`, `total_item_count`, `customer_gender`, `hidden_tax_amount`, `base_hidden_tax_amount`, `shipping_hidden_tax_amount`, `base_shipping_hidden_tax_amnt`, `hidden_tax_invoiced`, `base_hidden_tax_invoiced`, `hidden_tax_refunded`, `base_hidden_tax_refunded`, `shipping_incl_tax`, `base_shipping_incl_tax`, `coupon_rule_name`, `paypal_ipn_customer_notified`, `gift_message_id`) VALUES
(1, 'new', 'pending', NULL, 'bacd6e', 'Flat Rate - Fixed', 0, 1, 2, '0.0000', NULL, NULL, NULL, '15296.0000', '125.0000', NULL, NULL, NULL, '0.0000', NULL, '15171.0000', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, '1.0000', '1.0000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, '15296.0000', '125.0000', NULL, NULL, NULL, '0.0000', NULL, '1.0000', '1.0000', '15171.0000', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '25.0000', NULL, NULL, NULL, 0, 1, 1, 1, NULL, 1, NULL, NULL, NULL, 10, 2, NULL, NULL, NULL, NULL, '0.0000', '15171.0000', NULL, NULL, '0.0000', '15171.0000', NULL, '25.0000', NULL, '100000001', NULL, 'USD', 'admin@mystore.com', 'nguyen', 'nguyen', NULL, NULL, NULL, NULL, NULL, NULL, NULL, 'USD', NULL, NULL, 'USD', NULL, NULL, NULL, NULL, NULL, '127.0.0.1', 'flatrate_flatrate', 'USD', 'Main Website\nMain Website Store\nEnglish', NULL, NULL, '2015-01-19 02:06:00', '2015-01-19 02:06:01', 5, NULL, '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, '125.0000', '125.0000', NULL, 0, NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_order_address` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Id',
  `customer_address_id` int(11) DEFAULT NULL COMMENT 'Customer Address Id',
  `quote_address_id` int(11) DEFAULT NULL COMMENT 'Quote Address Id',
  `region_id` int(11) DEFAULT NULL COMMENT 'Region Id',
  `customer_id` int(11) DEFAULT NULL COMMENT 'Customer Id',
  `fax` varchar(255) DEFAULT NULL COMMENT 'Fax',
  `region` varchar(255) DEFAULT NULL COMMENT 'Region',
  `postcode` varchar(255) DEFAULT NULL COMMENT 'Postcode',
  `lastname` varchar(255) DEFAULT NULL COMMENT 'Lastname',
  `street` varchar(255) DEFAULT NULL COMMENT 'Street',
  `city` varchar(255) DEFAULT NULL COMMENT 'City',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `telephone` varchar(255) DEFAULT NULL COMMENT 'Telephone',
  `country_id` varchar(2) DEFAULT NULL COMMENT 'Country Id',
  `firstname` varchar(255) DEFAULT NULL COMMENT 'Firstname',
  `address_type` varchar(255) DEFAULT NULL COMMENT 'Address Type',
  `prefix` varchar(255) DEFAULT NULL COMMENT 'Prefix',
  `middlename` varchar(255) DEFAULT NULL COMMENT 'Middlename',
  `suffix` varchar(255) DEFAULT NULL COMMENT 'Suffix',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `vat_id` text COMMENT 'Vat Id',
  `vat_is_valid` smallint(6) DEFAULT NULL COMMENT 'Vat Is Valid',
  `vat_request_id` text COMMENT 'Vat Request Id',
  `vat_request_date` text COMMENT 'Vat Request Date',
  `vat_request_success` smallint(6) DEFAULT NULL COMMENT 'Vat Request Success'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order Address' AUTO_INCREMENT=3 ;

INSERT INTO `#__sales_flat_order_address` (`entity_id`, `parent_id`, `customer_address_id`, `quote_address_id`, `region_id`, `customer_id`, `fax`, `region`, `postcode`, `lastname`, `street`, `city`, `email`, `telephone`, `country_id`, `firstname`, `address_type`, `prefix`, `middlename`, `suffix`, `company`, `vat_id`, `vat_is_valid`, `vat_request_id`, `vat_request_date`, `vat_request_success`) VALUES
(1, 1, 1, NULL, 18, 2, NULL, 'Florida', '999', 'nguyen', 'hn', 'hn', 'admin@mystore.com', '99999', 'US', 'nguyen', 'billing', NULL, NULL, NULL, 'hn', NULL, NULL, NULL, NULL, NULL),
(2, 1, NULL, NULL, 18, 2, NULL, 'Florida', '999', 'nguyen', 'hn', 'hn', 'admin@mystore.com', '99999', 'US', 'nguyen', 'shipping', NULL, NULL, NULL, 'hn', NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_order_grid` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `store_name` varchar(255) DEFAULT NULL COMMENT 'Store Name',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `base_grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Base Grand Total',
  `base_total_paid` decimal(12,4) DEFAULT NULL COMMENT 'Base Total Paid',
  `grand_total` decimal(12,4) DEFAULT NULL COMMENT 'Grand Total',
  `total_paid` decimal(12,4) DEFAULT NULL COMMENT 'Total Paid',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `base_currency_code` varchar(3) DEFAULT NULL COMMENT 'Base Currency Code',
  `order_currency_code` varchar(255) DEFAULT NULL COMMENT 'Order Currency Code',
  `shipping_name` varchar(255) DEFAULT NULL COMMENT 'Shipping Name',
  `billing_name` varchar(255) DEFAULT NULL COMMENT 'Billing Name',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order Grid';

INSERT INTO `#__sales_flat_order_grid` (`entity_id`, `status`, `store_id`, `store_name`, `customer_id`, `base_grand_total`, `base_total_paid`, `grand_total`, `total_paid`, `increment_id`, `base_currency_code`, `order_currency_code`, `shipping_name`, `billing_name`, `created_at`, `updated_at`) VALUES
(1, 'pending', 1, 'Main Website\nMain Website Store\nEnglish', 2, '15296.0000', NULL, '15296.0000', NULL, '100000001', 'USD', 'USD', 'nguyen nguyen', 'nguyen nguyen', '2015-01-19 02:06:00', '2015-01-19 02:06:01');

CREATE TABLE IF NOT EXISTS `#__sales_flat_order_item` (
`item_id` int(10) unsigned NOT NULL COMMENT 'Item Id',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id',
  `parent_item_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Item Id',
  `quote_item_id` int(10) unsigned DEFAULT NULL COMMENT 'Quote Item Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `product_type` varchar(255) DEFAULT NULL COMMENT 'Product Type',
  `product_options` text COMMENT 'Product Options',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `is_virtual` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `free_shipping` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `is_qty_decimal` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `no_discount` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'No Discount',
  `qty_backordered` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Backordered',
  `qty_canceled` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Canceled',
  `qty_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Invoiced',
  `qty_ordered` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Ordered',
  `qty_refunded` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Refunded',
  `qty_shipped` decimal(12,4) DEFAULT '0.0000' COMMENT 'Qty Shipped',
  `base_cost` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Cost',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `base_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Price',
  `original_price` decimal(12,4) DEFAULT NULL COMMENT 'Original Price',
  `base_original_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Original Price',
  `tax_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Percent',
  `tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `tax_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Invoiced',
  `base_tax_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Tax Invoiced',
  `discount_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Percent',
  `discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `discount_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Invoiced',
  `base_discount_invoiced` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Discount Invoiced',
  `amount_refunded` decimal(12,4) DEFAULT '0.0000' COMMENT 'Amount Refunded',
  `base_amount_refunded` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Amount Refunded',
  `row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Invoiced',
  `base_row_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Invoiced',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `base_tax_before_discount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Before Discount',
  `tax_before_discount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Before Discount',
  `ext_order_item_id` varchar(255) DEFAULT NULL COMMENT 'Ext Order Item Id',
  `locked_do_invoice` smallint(5) unsigned DEFAULT NULL COMMENT 'Locked Do Invoice',
  `locked_do_ship` smallint(5) unsigned DEFAULT NULL COMMENT 'Locked Do Ship',
  `price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `hidden_tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Invoiced',
  `base_hidden_tax_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Invoiced',
  `hidden_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Refunded',
  `base_hidden_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Refunded',
  `is_nominal` int(11) NOT NULL DEFAULT '0' COMMENT 'Is Nominal',
  `tax_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Tax Canceled',
  `hidden_tax_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Canceled',
  `tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Tax Refunded',
  `base_tax_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Refunded',
  `discount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Discount Refunded',
  `base_discount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Discount Refunded',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id',
  `gift_message_available` int(11) DEFAULT NULL COMMENT 'Gift Message Available',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order Item' AUTO_INCREMENT=7 ;

INSERT INTO `#__sales_flat_order_item` (`item_id`, `order_id`, `parent_item_id`, `quote_item_id`, `store_id`, `created_at`, `updated_at`, `product_id`, `product_type`, `product_options`, `weight`, `is_virtual`, `sku`, `name`, `description`, `applied_rule_ids`, `additional_data`, `free_shipping`, `is_qty_decimal`, `no_discount`, `qty_backordered`, `qty_canceled`, `qty_invoiced`, `qty_ordered`, `qty_refunded`, `qty_shipped`, `base_cost`, `price`, `base_price`, `original_price`, `base_original_price`, `tax_percent`, `tax_amount`, `base_tax_amount`, `tax_invoiced`, `base_tax_invoiced`, `discount_percent`, `discount_amount`, `base_discount_amount`, `discount_invoiced`, `base_discount_invoiced`, `amount_refunded`, `base_amount_refunded`, `row_total`, `base_row_total`, `row_invoiced`, `base_row_invoiced`, `row_weight`, `base_tax_before_discount`, `tax_before_discount`, `ext_order_item_id`, `locked_do_invoice`, `locked_do_ship`, `price_incl_tax`, `base_price_incl_tax`, `row_total_incl_tax`, `base_row_total_incl_tax`, `hidden_tax_amount`, `base_hidden_tax_amount`, `hidden_tax_invoiced`, `base_hidden_tax_invoiced`, `hidden_tax_refunded`, `base_hidden_tax_refunded`, `is_nominal`, `tax_canceled`, `hidden_tax_canceled`, `tax_refunded`, `base_tax_refunded`, `discount_refunded`, `base_discount_refunded`, `gift_message_id`, `gift_message_available`, `base_weee_tax_applied_amount`, `base_weee_tax_applied_row_amnt`, `weee_tax_applied_amount`, `weee_tax_applied_row_amount`, `weee_tax_applied`, `weee_tax_disposition`, `weee_tax_row_disposition`, `base_weee_tax_disposition`, `base_weee_tax_row_disposition`) VALUES
(1, 1, NULL, 8, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 8, 'simple', 'a:1:{s:15:"info_buyRequest";a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"8";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}}', '1.0000', 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '16.0000', '0.0000', '0.0000', NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '9984.0000', '9984.0000', '0.0000', '0.0000', '16.0000', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '9984.0000', '9984.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000'),
(2, 1, NULL, 9, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 7, 'configurable', 'a:6:{s:15:"info_buyRequest";a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}s:15:"attributes_info";a:2:{i:0;a:2:{s:5:"label";s:12:"Manufacturer";s:5:"value";s:6:"Armani";}i:1;a:2:{s:5:"label";s:5:"Color";s:5:"value";s:5:"Green";}}s:11:"simple_name";s:16:"Cfg Armani Green";s:10:"simple_sku";s:19:"Cfg-01-Armani-Green";s:20:"product_calculations";i:1;s:13:"shipment_type";i:0;}', '1.0000', 0, 'Cfg-01-Armani-Green', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '2.0000', '0.0000', '0.0000', NULL, '629.0000', '629.0000', '629.0000', '629.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1258.0000', '1258.0000', '0.0000', '0.0000', '2.0000', NULL, NULL, NULL, NULL, NULL, '629.0000', '629.0000', '1258.0000', '1258.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000'),
(3, 1, 2, 10, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 10, 'simple', 'a:1:{s:15:"info_buyRequest";a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}}', '1.0000', 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '2.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', NULL, '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000'),
(4, 1, NULL, 11, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 10, 'simple', 'a:1:{s:15:"info_buyRequest";a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:2:"10";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}}', '1.0000', 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '1.0000', '0.0000', '0.0000', NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '0.0000', '1.0000', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000'),
(5, 1, NULL, 12, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 41, 'simple', 'a:1:{s:15:"info_buyRequest";a:4:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4uaHRtbA,,";s:7:"product";s:2:"41";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}}', '1.0000', 0, 'sim-05', 'Simple product 05', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '1.0000', '0.0000', '0.0000', NULL, '113.0000', '113.0000', '113.0000', '113.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '113.0000', '113.0000', '0.0000', '0.0000', '1.0000', NULL, NULL, NULL, NULL, NULL, '113.0000', '113.0000', '113.0000', '113.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000'),
(6, 1, NULL, 13, 1, '2015-01-19 02:06:01', '2015-01-19 02:06:01', 9, 'simple', 'a:1:{s:15:"info_buyRequest";a:5:{s:4:"uenc";s:112:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC1hcm1hbmktYmx1ZS5odG1s";s:7:"product";s:1:"9";s:8:"form_key";s:16:"Apc0Q0wAw9ZKj1Zq";s:15:"related_product";s:0:"";s:3:"qty";s:1:"5";}}', '1.0000', 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, NULL, '0.0000', '0.0000', '5.0000', '0.0000', '0.0000', NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '3295.0000', '3295.0000', '0.0000', '0.0000', '5.0000', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '3295.0000', '3295.0000', '0.0000', '0.0000', NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', '0.0000');

CREATE TABLE IF NOT EXISTS `#__sales_flat_order_payment` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `base_shipping_captured` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Captured',
  `shipping_captured` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Captured',
  `amount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Amount Refunded',
  `base_amount_paid` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Paid',
  `amount_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Amount Canceled',
  `base_amount_authorized` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Authorized',
  `base_amount_paid_online` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Paid Online',
  `base_amount_refunded_online` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Refunded Online',
  `base_shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Amount',
  `shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `amount_paid` decimal(12,4) DEFAULT NULL COMMENT 'Amount Paid',
  `amount_authorized` decimal(12,4) DEFAULT NULL COMMENT 'Amount Authorized',
  `base_amount_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Ordered',
  `base_shipping_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Refunded',
  `shipping_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Refunded',
  `base_amount_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Refunded',
  `amount_ordered` decimal(12,4) DEFAULT NULL COMMENT 'Amount Ordered',
  `base_amount_canceled` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount Canceled',
  `quote_payment_id` int(11) DEFAULT NULL COMMENT 'Quote Payment Id',
  `additional_data` text COMMENT 'Additional Data',
  `cc_exp_month` varchar(255) DEFAULT NULL COMMENT 'Cc Exp Month',
  `cc_ss_start_year` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Start Year',
  `echeck_bank_name` varchar(255) DEFAULT NULL COMMENT 'Echeck Bank Name',
  `method` varchar(255) DEFAULT NULL COMMENT 'Method',
  `cc_debug_request_body` varchar(255) DEFAULT NULL COMMENT 'Cc Debug Request Body',
  `cc_secure_verify` varchar(255) DEFAULT NULL COMMENT 'Cc Secure Verify',
  `protection_eligibility` varchar(255) DEFAULT NULL COMMENT 'Protection Eligibility',
  `cc_approval` varchar(255) DEFAULT NULL COMMENT 'Cc Approval',
  `cc_last4` varchar(255) DEFAULT NULL COMMENT 'Cc Last4',
  `cc_status_description` varchar(255) DEFAULT NULL COMMENT 'Cc Status Description',
  `echeck_type` varchar(255) DEFAULT NULL COMMENT 'Echeck Type',
  `cc_debug_response_serialized` varchar(255) DEFAULT NULL COMMENT 'Cc Debug Response Serialized',
  `cc_ss_start_month` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Start Month',
  `echeck_account_type` varchar(255) DEFAULT NULL COMMENT 'Echeck Account Type',
  `last_trans_id` varchar(255) DEFAULT NULL COMMENT 'Last Trans Id',
  `cc_cid_status` varchar(255) DEFAULT NULL COMMENT 'Cc Cid Status',
  `cc_owner` varchar(255) DEFAULT NULL COMMENT 'Cc Owner',
  `cc_type` varchar(255) DEFAULT NULL COMMENT 'Cc Type',
  `po_number` varchar(255) DEFAULT NULL COMMENT 'Po Number',
  `cc_exp_year` varchar(255) DEFAULT NULL COMMENT 'Cc Exp Year',
  `cc_status` varchar(255) DEFAULT NULL COMMENT 'Cc Status',
  `echeck_routing_number` varchar(255) DEFAULT NULL COMMENT 'Echeck Routing Number',
  `account_status` varchar(255) DEFAULT NULL COMMENT 'Account Status',
  `anet_trans_method` varchar(255) DEFAULT NULL COMMENT 'Anet Trans Method',
  `cc_debug_response_body` varchar(255) DEFAULT NULL COMMENT 'Cc Debug Response Body',
  `cc_ss_issue` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Issue',
  `echeck_account_name` varchar(255) DEFAULT NULL COMMENT 'Echeck Account Name',
  `cc_avs_status` varchar(255) DEFAULT NULL COMMENT 'Cc Avs Status',
  `cc_number_enc` varchar(255) DEFAULT NULL COMMENT 'Cc Number Enc',
  `cc_trans_id` varchar(255) DEFAULT NULL COMMENT 'Cc Trans Id',
  `paybox_request_number` varchar(255) DEFAULT NULL COMMENT 'Paybox Request Number',
  `address_status` varchar(255) DEFAULT NULL COMMENT 'Address Status',
  `additional_information` text COMMENT 'Additional Information'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order Payment' AUTO_INCREMENT=2 ;

INSERT INTO `#__sales_flat_order_payment` (`entity_id`, `parent_id`, `base_shipping_captured`, `shipping_captured`, `amount_refunded`, `base_amount_paid`, `amount_canceled`, `base_amount_authorized`, `base_amount_paid_online`, `base_amount_refunded_online`, `base_shipping_amount`, `shipping_amount`, `amount_paid`, `amount_authorized`, `base_amount_ordered`, `base_shipping_refunded`, `shipping_refunded`, `base_amount_refunded`, `amount_ordered`, `base_amount_canceled`, `quote_payment_id`, `additional_data`, `cc_exp_month`, `cc_ss_start_year`, `echeck_bank_name`, `method`, `cc_debug_request_body`, `cc_secure_verify`, `protection_eligibility`, `cc_approval`, `cc_last4`, `cc_status_description`, `echeck_type`, `cc_debug_response_serialized`, `cc_ss_start_month`, `echeck_account_type`, `last_trans_id`, `cc_cid_status`, `cc_owner`, `cc_type`, `po_number`, `cc_exp_year`, `cc_status`, `echeck_routing_number`, `account_status`, `anet_trans_method`, `cc_debug_response_body`, `cc_ss_issue`, `echeck_account_name`, `cc_avs_status`, `cc_number_enc`, `cc_trans_id`, `paybox_request_number`, `address_status`, `additional_information`) VALUES
(1, 1, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '125.0000', '125.0000', NULL, NULL, '15296.0000', NULL, NULL, NULL, '15296.0000', NULL, NULL, NULL, '0', '0', NULL, 'checkmo', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, '0', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_order_status_history` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `is_customer_notified` int(11) DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `status` varchar(32) DEFAULT NULL COMMENT 'Status',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `entity_name` varchar(32) DEFAULT NULL COMMENT 'Shows what entity history is bind to.'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Order Status History' AUTO_INCREMENT=2 ;

INSERT INTO `#__sales_flat_order_status_history` (`entity_id`, `parent_id`, `is_customer_notified`, `is_visible_on_front`, `comment`, `status`, `created_at`, `entity_name`) VALUES
(1, 1, 1, 0, NULL, 'pending', '2015-01-19 02:06:01', 'order');

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `converted_at` timestamp NULL DEFAULT NULL COMMENT 'Converted At',
  `is_active` smallint(5) unsigned DEFAULT '1' COMMENT 'Is Active',
  `is_virtual` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Virtual',
  `is_multi_shipping` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Multi Shipping',
  `items_count` int(10) unsigned DEFAULT '0' COMMENT 'Items Count',
  `items_qty` decimal(12,4) DEFAULT '0.0000' COMMENT 'Items Qty',
  `orig_order_id` int(10) unsigned DEFAULT '0' COMMENT 'Orig Order Id',
  `store_to_base_rate` decimal(12,4) DEFAULT '0.0000' COMMENT 'Store To Base Rate',
  `store_to_quote_rate` decimal(12,4) DEFAULT '0.0000' COMMENT 'Store To Quote Rate',
  `base_currency_code` varchar(255) DEFAULT NULL COMMENT 'Base Currency Code',
  `store_currency_code` varchar(255) DEFAULT NULL COMMENT 'Store Currency Code',
  `quote_currency_code` varchar(255) DEFAULT NULL COMMENT 'Quote Currency Code',
  `grand_total` decimal(12,4) DEFAULT '0.0000' COMMENT 'Grand Total',
  `base_grand_total` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Grand Total',
  `checkout_method` varchar(255) DEFAULT NULL COMMENT 'Checkout Method',
  `customer_id` int(10) unsigned DEFAULT '0' COMMENT 'Customer Id',
  `customer_tax_class_id` int(10) unsigned DEFAULT '0' COMMENT 'Customer Tax Class Id',
  `customer_group_id` int(10) unsigned DEFAULT '0' COMMENT 'Customer Group Id',
  `customer_email` varchar(255) DEFAULT NULL COMMENT 'Customer Email',
  `customer_prefix` varchar(40) DEFAULT NULL COMMENT 'Customer Prefix',
  `customer_firstname` varchar(255) DEFAULT NULL COMMENT 'Customer Firstname',
  `customer_middlename` varchar(40) DEFAULT NULL COMMENT 'Customer Middlename',
  `customer_lastname` varchar(255) DEFAULT NULL COMMENT 'Customer Lastname',
  `customer_suffix` varchar(40) DEFAULT NULL COMMENT 'Customer Suffix',
  `customer_dob` datetime DEFAULT NULL COMMENT 'Customer Dob',
  `customer_note` varchar(255) DEFAULT NULL COMMENT 'Customer Note',
  `customer_note_notify` smallint(5) unsigned DEFAULT '1' COMMENT 'Customer Note Notify',
  `customer_is_guest` smallint(5) unsigned DEFAULT '0' COMMENT 'Customer Is Guest',
  `remote_ip` varchar(255) DEFAULT NULL COMMENT 'Remote Ip',
  `applied_rule_ids` varchar(255) DEFAULT NULL COMMENT 'Applied Rule Ids',
  `reserved_order_id` varchar(64) DEFAULT NULL COMMENT 'Reserved Order Id',
  `password_hash` varchar(255) DEFAULT NULL COMMENT 'Password Hash',
  `coupon_code` varchar(255) DEFAULT NULL COMMENT 'Coupon Code',
  `global_currency_code` varchar(255) DEFAULT NULL COMMENT 'Global Currency Code',
  `base_to_global_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Global Rate',
  `base_to_quote_rate` decimal(12,4) DEFAULT NULL COMMENT 'Base To Quote Rate',
  `customer_taxvat` varchar(255) DEFAULT NULL COMMENT 'Customer Taxvat',
  `customer_gender` varchar(255) DEFAULT NULL COMMENT 'Customer Gender',
  `subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal',
  `base_subtotal` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal',
  `subtotal_with_discount` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal With Discount',
  `base_subtotal_with_discount` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal With Discount',
  `is_changed` int(10) unsigned DEFAULT NULL COMMENT 'Is Changed',
  `trigger_recollect` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Trigger Recollect',
  `ext_shipping_info` text COMMENT 'Ext Shipping Info',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id',
  `is_persistent` smallint(5) unsigned DEFAULT '0' COMMENT 'Is Quote Persistent'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote' AUTO_INCREMENT=45 ;

INSERT INTO `#__sales_flat_quote` (`entity_id`, `store_id`, `created_at`, `updated_at`, `converted_at`, `is_active`, `is_virtual`, `is_multi_shipping`, `items_count`, `items_qty`, `orig_order_id`, `store_to_base_rate`, `store_to_quote_rate`, `base_currency_code`, `store_currency_code`, `quote_currency_code`, `grand_total`, `base_grand_total`, `checkout_method`, `customer_id`, `customer_tax_class_id`, `customer_group_id`, `customer_email`, `customer_prefix`, `customer_firstname`, `customer_middlename`, `customer_lastname`, `customer_suffix`, `customer_dob`, `customer_note`, `customer_note_notify`, `customer_is_guest`, `remote_ip`, `applied_rule_ids`, `reserved_order_id`, `password_hash`, `coupon_code`, `global_currency_code`, `base_to_global_rate`, `base_to_quote_rate`, `customer_taxvat`, `customer_gender`, `subtotal`, `base_subtotal`, `subtotal_with_discount`, `base_subtotal_with_discount`, `is_changed`, `trigger_recollect`, `ext_shipping_info`, `gift_message_id`, `is_persistent`) VALUES
(1, 1, '2014-12-03 00:27:10', '2014-12-03 00:27:12', NULL, 1, 0, 0, 0, '0.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '549.0000', '549.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '549.0000', '549.0000', '549.0000', '549.0000', 1, 0, NULL, NULL, 0),
(2, 1, '2014-12-04 20:56:41', '2014-12-04 20:56:41', NULL, 1, 0, 0, 0, '0.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '0.0000', '0.0000', NULL, 1, 3, 1, 'thangnm.hnvn@gmail.com', NULL, 'Nguyen', NULL, 'Thang', NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 1, 0, NULL, NULL, 0),
(3, 1, '2014-12-10 02:03:14', '2014-12-10 02:03:16', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '366.4500', '366.4500', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '366.4500', '366.4500', '366.4500', '366.4500', 1, 0, NULL, NULL, 0),
(4, 1, '2014-12-12 02:37:04', '2014-12-12 02:38:33', NULL, 1, 0, 0, 1, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1318.0000', '1318.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1318.0000', '1318.0000', '1318.0000', '1318.0000', 1, 0, NULL, NULL, 0),
(5, 1, '2014-12-12 02:49:19', '2014-12-12 02:49:20', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '189.0000', '189.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '189.0000', '189.0000', '189.0000', '189.0000', 1, 0, NULL, NULL, 0),
(6, 1, '2014-12-15 20:04:28', '2014-12-15 20:20:59', NULL, 1, 0, 0, 2, '3.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1942.0000', '1942.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1942.0000', '1942.0000', '1942.0000', '1942.0000', 1, 0, NULL, NULL, 0),
(7, 1, '2014-12-24 13:00:02', '2014-12-24 13:00:05', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '659.0000', '659.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', 1, 0, NULL, NULL, 0),
(8, 1, '2014-12-29 01:19:04', '2014-12-29 02:54:15', NULL, 1, 0, 0, 0, '0.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '0.0000', '0.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 1, 0, NULL, NULL, 0),
(9, 1, '2015-01-13 01:11:47', '2015-01-13 01:12:08', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '113.0000', '113.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '113.0000', '113.0000', '113.0000', '113.0000', 1, 0, NULL, NULL, 0),
(10, 1, '2015-01-18 18:52:52', '2015-01-19 02:06:04', NULL, 0, 0, 0, 5, '25.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '15296.0000', '15296.0000', NULL, 2, 3, 1, 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, '100000001', NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '15171.0000', '15171.0000', '15171.0000', '15171.0000', 1, 0, NULL, NULL, 0),
(11, 1, '2015-01-20 20:10:59', '2015-03-25 20:50:26', NULL, 1, 0, 0, 9, '65.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '35900.8600', '35900.8600', NULL, 2, 3, 1, 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '35575.8600', '35575.8600', '35575.8600', '35575.8600', 1, 0, NULL, NULL, 0),
(12, 1, '2015-01-22 02:10:32', '2015-01-22 02:10:40', NULL, 1, 0, 0, 1, '4.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '2516.0000', '2516.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '2516.0000', '2516.0000', '2516.0000', '2516.0000', 1, 0, NULL, NULL, 0),
(14, 1, '2015-01-23 04:05:32', '2015-01-23 04:05:33', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '659.0000', '659.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', 1, 0, NULL, NULL, 0),
(15, 1, '2015-01-23 23:52:13', '2015-01-23 23:52:21', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '659.0000', '659.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', 1, 0, NULL, NULL, 0),
(16, 1, '2015-03-11 02:12:09', '2015-03-11 02:24:05', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1283.0000', '1283.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1283.0000', '1283.0000', '1283.0000', '1283.0000', 1, 0, NULL, NULL, 0),
(18, 1, '2015-03-26 00:00:30', '2015-03-26 00:01:12', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '100.9800', '100.9800', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '100.9800', '100.9800', '100.9800', '100.9800', 1, 0, NULL, NULL, 0),
(19, 2, '2015-03-29 21:43:15', '2015-03-29 21:43:17', NULL, 1, 0, 0, 1, '4.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '2084.0000', '2084.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '2084.0000', '2084.0000', '2084.0000', '2084.0000', 1, 0, NULL, NULL, 0),
(20, 1, '2015-04-10 04:24:38', '2015-04-10 05:19:01', NULL, 1, 0, 0, 6, '11.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '6026.0000', '6026.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '6026.0000', '6026.0000', '6026.0000', '6026.0000', 1, 0, NULL, NULL, 0),
(21, 1, '2015-04-14 01:00:01', '2015-04-14 01:00:01', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '624.0000', '624.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', 1, 0, NULL, NULL, 0),
(22, 1, '2015-04-14 18:57:22', '2015-04-14 18:59:05', NULL, 1, 0, 0, 1, '4.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '2636.0000', '2636.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '2636.0000', '2636.0000', '2636.0000', '2636.0000', 1, 0, NULL, NULL, 0),
(23, 1, '2015-04-15 02:00:55', '2015-04-15 02:01:01', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '659.0000', '659.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', 1, 0, NULL, NULL, 0),
(24, 1, '2015-05-08 01:04:11', '2015-05-08 02:36:20', NULL, 1, 0, 0, 1, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1248.0000', '1248.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1248.0000', '1248.0000', '1248.0000', '1248.0000', 1, 0, NULL, NULL, 0),
(25, 1, '2015-05-11 19:20:19', '2015-05-11 19:20:47', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1113.0000', '1113.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1113.0000', '1113.0000', '1113.0000', '1113.0000', 1, 0, NULL, NULL, 0),
(26, 1, '2015-05-13 01:31:48', '2015-05-13 02:28:16', NULL, 1, 0, 0, 1, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1042.0000', '1042.0000', NULL, 3, 3, 1, 'administrator@gmail.com', NULL, 'admin', NULL, 'admin', NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1042.0000', '1042.0000', '1042.0000', '1042.0000', 1, 0, NULL, NULL, 0),
(27, 1, '2015-05-19 21:27:27', '2015-05-19 21:27:41', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1145.0000', '1145.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1145.0000', '1145.0000', '1145.0000', '1145.0000', 1, 0, NULL, NULL, 0),
(28, 1, '2015-05-24 21:43:42', '2015-05-24 21:43:42', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '119.0000', '119.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '119.0000', '119.0000', '119.0000', '119.0000', 1, 0, NULL, NULL, 0),
(29, 1, '2015-05-26 23:48:54', '2015-05-26 23:49:37', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1123.0000', '1123.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1123.0000', '1123.0000', '1123.0000', '1123.0000', 1, 0, NULL, NULL, 0),
(30, 1, '2015-05-26 23:56:13', '2015-05-26 23:56:23', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '201.9600', '201.9600', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '192.168.100.106', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '201.9600', '201.9600', '201.9600', '201.9600', 1, 0, NULL, NULL, 0),
(31, 1, '2015-05-27 21:22:38', '2015-05-27 21:22:38', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '499.0000', '499.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '499.0000', '499.0000', '499.0000', '499.0000', 1, 0, NULL, NULL, 0),
(32, 1, '2015-06-04 21:35:35', '2015-06-04 21:35:35', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '521.0000', '521.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', 1, 0, NULL, NULL, 0),
(33, 1, '2015-06-07 18:39:03', '2015-06-07 18:42:38', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1288.0000', '1288.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1288.0000', '1288.0000', '1288.0000', '1288.0000', 1, 0, NULL, NULL, 0),
(34, 1, '2015-06-09 02:54:13', '2015-06-09 02:54:13', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '79.0000', '79.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '79.0000', '79.0000', '79.0000', '79.0000', 1, 0, NULL, NULL, 0),
(35, 2, '2015-06-10 20:31:12', '2015-06-10 21:02:26', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1283.0000', '1283.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1283.0000', '1283.0000', '1283.0000', '1283.0000', 1, 0, NULL, NULL, 0),
(36, 3, '2015-06-10 20:36:17', '2015-06-10 20:36:17', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '624.0000', '624.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', 1, 0, NULL, NULL, 0),
(37, 1, '2015-06-10 21:21:19', '2015-06-10 21:24:22', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '659.0000', '659.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '192.168.100.106', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', 1, 0, NULL, NULL, 0),
(38, 3, '2015-06-11 00:09:55', '2015-06-11 00:09:55', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '624.0000', '624.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', 1, 0, NULL, NULL, 0),
(39, 3, '2015-06-11 02:12:35', '2015-06-11 02:12:35', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '521.0000', '521.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', 1, 0, NULL, NULL, 0),
(40, 1, '2015-06-12 03:31:48', '2015-06-12 03:31:48', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '614.0000', '614.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '614.0000', '614.0000', '614.0000', '614.0000', 1, 0, NULL, NULL, 0),
(41, 1, '2015-06-12 19:34:23', '2015-06-12 19:39:46', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1283.0000', '1283.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1283.0000', '1283.0000', '1283.0000', '1283.0000', 1, 0, NULL, NULL, 0),
(42, 3, '2015-07-01 21:36:18', '2015-07-01 21:42:34', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1135.0000', '1135.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1135.0000', '1135.0000', '1135.0000', '1135.0000', 1, 0, NULL, NULL, 0),
(43, 1, '2015-07-11 02:06:31', '2015-07-11 02:06:51', NULL, 1, 0, 0, 2, '2.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '1145.0000', '1145.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '192.168.100.115', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '1145.0000', '1145.0000', '1145.0000', '1145.0000', 1, 0, NULL, NULL, 0),
(44, 3, '2015-07-13 02:01:59', '2015-07-13 02:01:59', NULL, 1, 0, 0, 1, '1.0000', 0, '1.0000', '1.0000', 'USD', 'USD', 'USD', '199.0000', '199.0000', NULL, NULL, 3, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, '127.0.0.1', NULL, NULL, NULL, NULL, 'USD', '1.0000', '1.0000', NULL, NULL, '199.0000', '199.0000', '199.0000', '199.0000', 1, 0, NULL, NULL, 0);

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_address` (
`address_id` int(10) unsigned NOT NULL COMMENT 'Address Id',
  `quote_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `save_in_address_book` smallint(6) DEFAULT '0' COMMENT 'Save In Address Book',
  `customer_address_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Address Id',
  `address_type` varchar(255) DEFAULT NULL COMMENT 'Address Type',
  `email` varchar(255) DEFAULT NULL COMMENT 'Email',
  `prefix` varchar(40) DEFAULT NULL COMMENT 'Prefix',
  `firstname` varchar(255) DEFAULT NULL COMMENT 'Firstname',
  `middlename` varchar(40) DEFAULT NULL COMMENT 'Middlename',
  `lastname` varchar(255) DEFAULT NULL COMMENT 'Lastname',
  `suffix` varchar(40) DEFAULT NULL COMMENT 'Suffix',
  `company` varchar(255) DEFAULT NULL COMMENT 'Company',
  `street` varchar(255) DEFAULT NULL COMMENT 'Street',
  `city` varchar(255) DEFAULT NULL COMMENT 'City',
  `region` varchar(255) DEFAULT NULL COMMENT 'Region',
  `region_id` int(10) unsigned DEFAULT NULL COMMENT 'Region Id',
  `postcode` varchar(255) DEFAULT NULL COMMENT 'Postcode',
  `country_id` varchar(255) DEFAULT NULL COMMENT 'Country Id',
  `telephone` varchar(255) DEFAULT NULL COMMENT 'Telephone',
  `fax` varchar(255) DEFAULT NULL COMMENT 'Fax',
  `same_as_billing` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Same As Billing',
  `free_shipping` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `collect_shipping_rates` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Collect Shipping Rates',
  `shipping_method` varchar(255) DEFAULT NULL COMMENT 'Shipping Method',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `weight` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Weight',
  `subtotal` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal',
  `base_subtotal` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Subtotal',
  `subtotal_with_discount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Subtotal With Discount',
  `base_subtotal_with_discount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Subtotal With Discount',
  `tax_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `shipping_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Shipping Amount',
  `base_shipping_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Shipping Amount',
  `shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Tax Amount',
  `base_shipping_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Tax Amount',
  `discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `grand_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Grand Total',
  `base_grand_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Grand Total',
  `customer_notes` text COMMENT 'Customer Notes',
  `applied_taxes` text COMMENT 'Applied Taxes',
  `discount_description` varchar(255) DEFAULT NULL COMMENT 'Discount Description',
  `shipping_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Discount Amount',
  `base_shipping_discount_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Discount Amount',
  `subtotal_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Subtotal Incl Tax',
  `base_subtotal_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Subtotal Total Incl Tax',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `shipping_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Hidden Tax Amount',
  `base_shipping_hidden_tax_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Hidden Tax Amount',
  `shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Incl Tax',
  `base_shipping_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Shipping Incl Tax',
  `vat_id` text COMMENT 'Vat Id',
  `vat_is_valid` smallint(6) DEFAULT NULL COMMENT 'Vat Is Valid',
  `vat_request_id` text COMMENT 'Vat Request Id',
  `vat_request_date` text COMMENT 'Vat Request Date',
  `vat_request_success` smallint(6) DEFAULT NULL COMMENT 'Vat Request Success',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Address' AUTO_INCREMENT=91 ;

INSERT INTO `#__sales_flat_quote_address` (`address_id`, `quote_id`, `created_at`, `updated_at`, `customer_id`, `save_in_address_book`, `customer_address_id`, `address_type`, `email`, `prefix`, `firstname`, `middlename`, `lastname`, `suffix`, `company`, `street`, `city`, `region`, `region_id`, `postcode`, `country_id`, `telephone`, `fax`, `same_as_billing`, `free_shipping`, `collect_shipping_rates`, `shipping_method`, `shipping_description`, `weight`, `subtotal`, `base_subtotal`, `subtotal_with_discount`, `base_subtotal_with_discount`, `tax_amount`, `base_tax_amount`, `shipping_amount`, `base_shipping_amount`, `shipping_tax_amount`, `base_shipping_tax_amount`, `discount_amount`, `base_discount_amount`, `grand_total`, `base_grand_total`, `customer_notes`, `applied_taxes`, `discount_description`, `shipping_discount_amount`, `base_shipping_discount_amount`, `subtotal_incl_tax`, `base_subtotal_total_incl_tax`, `hidden_tax_amount`, `base_hidden_tax_amount`, `shipping_hidden_tax_amount`, `base_shipping_hidden_tax_amnt`, `shipping_incl_tax`, `base_shipping_incl_tax`, `vat_id`, `vat_is_valid`, `vat_request_id`, `vat_request_date`, `vat_request_success`, `gift_message_id`) VALUES
(1, 1, '2014-12-03 00:27:11', '2014-12-03 00:27:12', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(2, 1, '2014-12-03 00:27:11', '2014-12-03 00:27:12', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '549.0000', '549.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '549.0000', '549.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '549.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(3, 2, '2014-12-04 20:56:41', '2014-12-04 20:56:41', 1, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(4, 2, '2014-12-04 20:56:41', '2014-12-04 20:56:41', 1, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(5, 3, '2014-12-10 02:03:14', '2014-12-10 02:03:16', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(6, 3, '2014-12-10 02:03:14', '2014-12-10 02:03:16', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '366.4500', '366.4500', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '366.4500', '366.4500', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '366.4500', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(7, 4, '2014-12-12 02:37:04', '2014-12-12 02:38:33', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(8, 4, '2014-12-12 02:37:04', '2014-12-12 02:38:33', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1318.0000', '1318.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1318.0000', '1318.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1318.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(9, 5, '2014-12-12 02:49:19', '2014-12-12 02:49:21', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(10, 5, '2014-12-12 02:49:19', '2014-12-12 02:49:21', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '189.0000', '189.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '189.0000', '189.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '189.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(11, 6, '2014-12-15 20:04:29', '2014-12-15 20:21:00', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(12, 6, '2014-12-15 20:04:29', '2014-12-15 20:21:00', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '3.0000', '1942.0000', '1942.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1942.0000', '1942.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1942.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(13, 7, '2014-12-24 13:00:03', '2014-12-24 13:00:06', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(14, 7, '2014-12-24 13:00:03', '2014-12-24 13:00:06', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(15, 8, '2014-12-29 01:19:06', '2014-12-29 02:54:15', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(16, 8, '2014-12-29 01:19:06', '2014-12-29 02:54:15', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 1, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(17, 9, '2015-01-13 01:11:48', '2015-01-13 01:12:08', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(18, 9, '2015-01-13 01:11:48', '2015-01-13 01:12:08', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '113.0000', '113.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '113.0000', '113.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '113.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(21, 10, '2015-01-19 02:03:32', '2015-01-19 02:05:59', 2, 0, NULL, 'shipping', 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, 'hn', 'hn', 'hn', 'Florida', 18, '999', 'US', '99999', NULL, 1, 0, 0, 'flatrate_flatrate', 'Flat Rate - Fixed', '25.0000', '15171.0000', '15171.0000', '0.0000', '0.0000', '0.0000', '0.0000', '125.0000', '125.0000', '0.0000', '0.0000', '0.0000', '0.0000', '15296.0000', '15296.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '15171.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '125.0000', '125.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(22, 10, '2015-01-19 02:03:32', '2015-01-19 02:05:59', 2, 1, 1, 'billing', 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, 'hn', 'hn', 'hn', 'Florida', 18, '999', 'US', '99999', NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(23, 11, '2015-01-20 20:10:59', '2015-03-25 20:50:26', 2, 0, 1, 'billing', 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, 'hn', 'hn', 'hn', 'Florida', 18, '999', 'US', '99999', NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(24, 11, '2015-01-20 20:10:59', '2015-03-25 20:50:27', 2, 0, 1, 'shipping', 'admin@mystore.com', NULL, 'nguyen', NULL, 'nguyen', NULL, 'hn', 'hn', 'hn', 'Florida', 18, '999', 'US', '99999', NULL, 1, 0, 0, 'flatrate_flatrate', 'Flat Rate - Fixed', '65.0000', '35575.8600', '35575.8600', '0.0000', '0.0000', '0.0000', '0.0000', '325.0000', '325.0000', '0.0000', '0.0000', '0.0000', '0.0000', '35900.8600', '35900.8600', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '35575.8600', NULL, '0.0000', '0.0000', '0.0000', NULL, '325.0000', '325.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(25, 12, '2015-01-22 02:10:34', '2015-01-22 02:10:41', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(26, 12, '2015-01-22 02:10:35', '2015-01-22 02:10:41', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '4.0000', '2516.0000', '2516.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2516.0000', '2516.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '2516.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(29, 14, '2015-01-23 04:05:32', '2015-01-23 04:05:33', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(30, 14, '2015-01-23 04:05:33', '2015-01-23 04:05:34', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(31, 15, '2015-01-23 23:52:16', '2015-01-23 23:52:21', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(32, 15, '2015-01-23 23:52:16', '2015-01-23 23:52:21', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(33, 16, '2015-03-11 02:12:10', '2015-03-11 02:24:05', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(34, 16, '2015-03-11 02:12:10', '2015-03-11 02:24:05', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1283.0000', '1283.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1283.0000', '1283.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1283.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(37, 18, '2015-03-26 00:00:31', '2015-03-26 00:01:13', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(38, 18, '2015-03-26 00:00:31', '2015-03-26 00:01:13', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '100.9800', '100.9800', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '100.9800', '100.9800', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '100.9800', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(39, 19, '2015-03-29 21:43:16', '2015-03-29 21:43:18', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(40, 19, '2015-03-29 21:43:16', '2015-03-29 21:43:18', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '4.0000', '2084.0000', '2084.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2084.0000', '2084.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '2084.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(41, 20, '2015-04-10 04:24:38', '2015-04-10 05:19:01', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(42, 20, '2015-04-10 04:24:38', '2015-04-10 05:19:01', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '11.0000', '6026.0000', '6026.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '6026.0000', '6026.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '6026.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(43, 21, '2015-04-14 01:00:02', '2015-04-14 01:00:02', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(44, 21, '2015-04-14 01:00:02', '2015-04-14 01:00:02', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '624.0000', '624.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(45, 22, '2015-04-14 18:57:23', '2015-04-14 18:59:06', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(46, 22, '2015-04-14 18:57:23', '2015-04-14 18:59:06', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '4.0000', '2636.0000', '2636.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2636.0000', '2636.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '2636.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(47, 23, '2015-04-15 02:00:58', '2015-04-15 02:01:01', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(48, 23, '2015-04-15 02:00:58', '2015-04-15 02:01:01', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(49, 24, '2015-05-08 01:04:12', '2015-05-08 02:36:20', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(50, 24, '2015-05-08 01:04:12', '2015-05-08 02:36:20', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1248.0000', '1248.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1248.0000', '1248.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1248.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(51, 25, '2015-05-11 19:20:20', '2015-05-11 19:20:48', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(52, 25, '2015-05-11 19:20:20', '2015-05-11 19:20:48', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1113.0000', '1113.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1113.0000', '1113.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1113.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(53, 26, '2015-05-13 01:31:49', '2015-05-13 02:28:17', 3, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(54, 26, '2015-05-13 01:31:49', '2015-05-13 02:28:17', 3, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1042.0000', '1042.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1042.0000', '1042.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1042.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(55, 27, '2015-05-19 21:27:27', '2015-05-19 21:27:41', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(56, 27, '2015-05-19 21:27:27', '2015-05-19 21:27:41', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1145.0000', '1145.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1145.0000', '1145.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1145.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(57, 28, '2015-05-24 21:43:42', '2015-05-24 21:43:42', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(58, 28, '2015-05-24 21:43:42', '2015-05-24 21:43:42', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '119.0000', '119.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '119.0000', '119.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '119.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(59, 29, '2015-05-26 23:48:54', '2015-05-26 23:49:37', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(60, 29, '2015-05-26 23:48:54', '2015-05-26 23:49:37', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1123.0000', '1123.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1123.0000', '1123.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1123.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(61, 30, '2015-05-26 23:56:14', '2015-05-26 23:56:23', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(62, 30, '2015-05-26 23:56:14', '2015-05-26 23:56:23', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '201.9600', '201.9600', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '201.9600', '201.9600', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '201.9600', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(63, 31, '2015-05-27 21:22:38', '2015-05-27 21:22:38', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(64, 31, '2015-05-27 21:22:38', '2015-05-27 21:22:38', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '499.0000', '499.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '499.0000', '499.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '499.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(65, 32, '2015-06-04 21:35:35', '2015-06-04 21:35:35', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(66, 32, '2015-06-04 21:35:35', '2015-06-04 21:35:35', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '521.0000', '521.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(67, 33, '2015-06-07 18:39:03', '2015-06-07 18:42:38', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(68, 33, '2015-06-07 18:39:03', '2015-06-07 18:42:38', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '1288.0000', '1288.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1288.0000', '1288.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1288.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(69, 34, '2015-06-09 02:54:13', '2015-06-09 02:54:13', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(70, 34, '2015-06-09 02:54:13', '2015-06-09 02:54:13', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '79.0000', '79.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '79.0000', '79.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '79.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(71, 35, '2015-06-10 20:31:12', '2015-06-10 21:02:26', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(72, 35, '2015-06-10 20:31:12', '2015-06-10 21:02:26', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1283.0000', '1283.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1283.0000', '1283.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1283.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(73, 36, '2015-06-10 20:36:17', '2015-06-10 20:36:17', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(74, 36, '2015-06-10 20:36:17', '2015-06-10 20:36:17', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '624.0000', '624.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(75, 37, '2015-06-10 21:21:19', '2015-06-10 21:24:22', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(76, 37, '2015-06-10 21:21:19', '2015-06-10 21:24:22', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '659.0000', '659.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(77, 38, '2015-06-11 00:09:55', '2015-06-11 00:09:55', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(78, 38, '2015-06-11 00:09:55', '2015-06-11 00:09:55', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '624.0000', '624.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(79, 39, '2015-06-11 02:12:35', '2015-06-11 02:12:35', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(80, 39, '2015-06-11 02:12:35', '2015-06-11 02:12:35', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '521.0000', '521.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(81, 40, '2015-06-12 03:31:48', '2015-06-12 03:31:48', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(82, 40, '2015-06-12 03:31:48', '2015-06-12 03:31:48', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '614.0000', '614.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '614.0000', '614.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(83, 41, '2015-06-12 19:34:23', '2015-06-12 19:39:46', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(84, 41, '2015-06-12 19:34:23', '2015-06-12 19:39:46', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1283.0000', '1283.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1283.0000', '1283.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1283.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(85, 42, '2015-07-01 21:36:18', '2015-07-01 21:42:34', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(86, 42, '2015-07-01 21:36:18', '2015-07-01 21:42:34', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1135.0000', '1135.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1135.0000', '1135.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1135.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(87, 43, '2015-07-11 02:06:31', '2015-07-11 02:06:51', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(88, 43, '2015-07-11 02:06:31', '2015-07-11 02:06:51', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '2.0000', '1145.0000', '1145.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1145.0000', '1145.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '1145.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(89, 44, '2015-07-13 02:01:59', '2015-07-13 02:01:59', NULL, 0, NULL, 'billing', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, 0, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', NULL, 'a:0:{}', NULL, NULL, NULL, '0.0000', NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL),
(90, 44, '2015-07-13 02:01:59', '2015-07-13 02:01:59', NULL, 0, NULL, 'shipping', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 1, 0, 0, NULL, NULL, '1.0000', '199.0000', '199.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '199.0000', '199.0000', NULL, 'a:0:{}', NULL, '0.0000', '0.0000', '199.0000', NULL, '0.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', NULL, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_address_item` (
`address_item_id` int(10) unsigned NOT NULL COMMENT 'Address Item Id',
  `parent_item_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Item Id',
  `quote_address_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Address Id',
  `quote_item_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Item Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_total_with_discount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Total With Discount',
  `base_discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `base_tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `super_product_id` int(10) unsigned DEFAULT NULL COMMENT 'Super Product Id',
  `parent_product_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Product Id',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `image` varchar(255) DEFAULT NULL COMMENT 'Image',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `free_shipping` int(10) unsigned DEFAULT NULL COMMENT 'Free Shipping',
  `is_qty_decimal` int(10) unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `discount_percent` decimal(12,4) DEFAULT NULL COMMENT 'Discount Percent',
  `no_discount` int(10) unsigned DEFAULT NULL COMMENT 'No Discount',
  `tax_percent` decimal(12,4) DEFAULT NULL COMMENT 'Tax Percent',
  `base_price` decimal(12,4) DEFAULT NULL COMMENT 'Base Price',
  `base_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Cost',
  `price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Address Item' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_item` (
`item_id` int(10) unsigned NOT NULL COMMENT 'Item Id',
  `quote_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `product_id` int(10) unsigned DEFAULT NULL COMMENT 'Product Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `parent_item_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Item Id',
  `is_virtual` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Virtual',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `description` text COMMENT 'Description',
  `applied_rule_ids` text COMMENT 'Applied Rule Ids',
  `additional_data` text COMMENT 'Additional Data',
  `free_shipping` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Free Shipping',
  `is_qty_decimal` smallint(5) unsigned DEFAULT NULL COMMENT 'Is Qty Decimal',
  `no_discount` smallint(5) unsigned DEFAULT '0' COMMENT 'No Discount',
  `weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Weight',
  `qty` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Qty',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `base_price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Price',
  `custom_price` decimal(12,4) DEFAULT NULL COMMENT 'Custom Price',
  `discount_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Percent',
  `discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Discount Amount',
  `base_discount_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Discount Amount',
  `tax_percent` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Percent',
  `tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Tax Amount',
  `base_tax_amount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Base Tax Amount',
  `row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Row Total',
  `base_row_total` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Base Row Total',
  `row_total_with_discount` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Total With Discount',
  `row_weight` decimal(12,4) DEFAULT '0.0000' COMMENT 'Row Weight',
  `product_type` varchar(255) DEFAULT NULL COMMENT 'Product Type',
  `base_tax_before_discount` decimal(12,4) DEFAULT NULL COMMENT 'Base Tax Before Discount',
  `tax_before_discount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Before Discount',
  `original_custom_price` decimal(12,4) DEFAULT NULL COMMENT 'Original Custom Price',
  `redirect_url` varchar(255) DEFAULT NULL COMMENT 'Redirect Url',
  `base_cost` decimal(12,4) DEFAULT NULL COMMENT 'Base Cost',
  `price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Price Incl Tax',
  `base_price_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Price Incl Tax',
  `row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Row Total Incl Tax',
  `base_row_total_incl_tax` decimal(12,4) DEFAULT NULL COMMENT 'Base Row Total Incl Tax',
  `hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Hidden Tax Amount',
  `base_hidden_tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Hidden Tax Amount',
  `gift_message_id` int(11) DEFAULT NULL COMMENT 'Gift Message Id',
  `weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Disposition',
  `weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Row Disposition',
  `base_weee_tax_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Disposition',
  `base_weee_tax_row_disposition` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Row Disposition',
  `weee_tax_applied` text COMMENT 'Weee Tax Applied',
  `weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Amount',
  `weee_tax_applied_row_amount` decimal(12,4) DEFAULT NULL COMMENT 'Weee Tax Applied Row Amount',
  `base_weee_tax_applied_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Amount',
  `base_weee_tax_applied_row_amnt` decimal(12,4) DEFAULT NULL COMMENT 'Base Weee Tax Applied Row Amnt'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Item' AUTO_INCREMENT=82 ;

INSERT INTO `#__sales_flat_quote_item` (`item_id`, `quote_id`, `created_at`, `updated_at`, `product_id`, `store_id`, `parent_item_id`, `is_virtual`, `sku`, `name`, `description`, `applied_rule_ids`, `additional_data`, `free_shipping`, `is_qty_decimal`, `no_discount`, `weight`, `qty`, `price`, `base_price`, `custom_price`, `discount_percent`, `discount_amount`, `base_discount_amount`, `tax_percent`, `tax_amount`, `base_tax_amount`, `row_total`, `base_row_total`, `row_total_with_discount`, `row_weight`, `product_type`, `base_tax_before_discount`, `tax_before_discount`, `original_custom_price`, `redirect_url`, `base_cost`, `price_incl_tax`, `base_price_incl_tax`, `row_total_incl_tax`, `base_row_total_incl_tax`, `hidden_tax_amount`, `base_hidden_tax_amount`, `gift_message_id`, `weee_tax_disposition`, `weee_tax_row_disposition`, `base_weee_tax_disposition`, `base_weee_tax_row_disposition`, `weee_tax_applied`, `weee_tax_applied_amount`, `weee_tax_applied_row_amount`, `base_weee_tax_applied_amount`, `base_weee_tax_applied_row_amnt`) VALUES
(1, 3, '2014-12-10 02:03:14', '2014-12-10 02:03:14', 15, 1, NULL, 0, 'Cfg-02-Chanel-Blue', 'Cfg 02 Chanel Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '366.4500', '366.4500', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '366.4500', '366.4500', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '366.4500', '366.4500', '366.4500', '366.4500', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(2, 4, '2014-12-12 02:37:05', '2014-12-12 02:38:32', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1318.0000', '1318.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '1318.0000', '1318.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(3, 5, '2014-12-12 02:49:19', '2014-12-12 02:49:19', 35, 1, NULL, 0, 'Cfg-05-Hermes', 'Cfg 05 Hermes', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '189.0000', '189.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '189.0000', '189.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '189.0000', '189.0000', '189.0000', '189.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(4, 6, '2014-12-15 20:04:29', '2014-12-15 20:04:29', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(5, 6, '2014-12-15 20:04:31', '2014-12-15 20:20:58', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1318.0000', '1318.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '1318.0000', '1318.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(6, 7, '2014-12-24 13:00:03', '2014-12-24 13:00:03', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(7, 9, '2015-01-13 01:11:48', '2015-01-13 01:11:48', 41, 1, NULL, 0, 'sim-05', 'Simple product 05', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '113.0000', '113.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '113.0000', '113.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '113.0000', '113.0000', '113.0000', '113.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(8, 10, '2015-01-18 18:52:53', '2015-01-18 21:53:25', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '16.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '9984.0000', '9984.0000', '0.0000', '16.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '9984.0000', '9984.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(9, 10, '2015-01-18 18:57:35', '2015-01-18 20:30:09', 7, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '629.0000', '629.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1258.0000', '1258.0000', '0.0000', '2.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '629.0000', '629.0000', '1258.0000', '1258.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(10, 10, '2015-01-18 18:57:35', '2015-01-18 18:57:37', 10, 1, 9, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(11, 10, '2015-01-18 19:26:52', '2015-01-18 19:26:52', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(12, 10, '2015-01-18 21:49:39', '2015-01-18 21:49:39', 41, 1, NULL, 0, 'sim-05', 'Simple product 05', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '113.0000', '113.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '113.0000', '113.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '113.0000', '113.0000', '113.0000', '113.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(13, 10, '2015-01-19 00:52:56', '2015-01-19 00:52:56', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '5.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '3295.0000', '3295.0000', '0.0000', '5.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '3295.0000', '3295.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(14, 11, '2015-01-20 20:12:42', '2015-01-20 20:12:42', 28, 1, NULL, 0, 'Cfg-04-White', 'Cfg 04 White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '6.0000', '100.9800', '100.9800', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '605.8800', '605.8800', '0.0000', '6.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '100.9800', '100.9800', '605.8800', '605.8800', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(15, 11, '2015-01-20 20:19:53', '2015-01-20 20:43:26', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '32.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '19968.0000', '19968.0000', '0.0000', '32.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '19968.0000', '19968.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(16, 11, '2015-01-20 20:19:54', '2015-03-25 20:28:30', 7, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, '1.0000', '6.0000', '629.0000', '629.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '3774.0000', '3774.0000', '0.0000', '6.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '629.0000', '629.0000', '3774.0000', '3774.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(17, 11, '2015-01-20 20:19:54', '2015-01-20 20:19:56', 10, 1, 16, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(18, 11, '2015-01-20 20:19:54', '2015-01-20 20:43:27', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1042.0000', '1042.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '1042.0000', '1042.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(19, 11, '2015-01-20 20:19:54', '2015-01-20 20:43:27', 41, 1, NULL, 0, 'sim-05', 'Simple product 05', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '113.0000', '113.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '226.0000', '226.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '113.0000', '113.0000', '226.0000', '226.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(20, 11, '2015-01-20 20:19:54', '2015-01-20 20:43:27', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '10.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '6590.0000', '6590.0000', '0.0000', '10.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '6590.0000', '6590.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(21, 12, '2015-01-22 02:10:35', '2015-01-22 02:10:41', 7, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, '1.0000', '4.0000', '629.0000', '629.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2516.0000', '2516.0000', '0.0000', '4.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '629.0000', '629.0000', '2516.0000', '2516.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(22, 12, '2015-01-22 02:10:35', '2015-01-22 02:10:41', 10, 1, 21, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(25, 11, '2015-01-23 02:00:23', '2015-01-23 03:05:01', 7, 1, NULL, 0, 'Cfg-01-Buberry-Red', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, '1.0000', '5.0000', '614.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '3070.0000', '3070.0000', '0.0000', '5.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '614.0000', '614.0000', '3070.0000', '3070.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(26, 11, '2015-01-23 02:00:23', '2015-01-23 03:05:01', 11, 1, 25, 0, 'Cfg-01-Buberry-Red', 'Cfg Buberry Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(27, 14, '2015-01-23 04:05:33', '2015-01-23 04:05:33', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(28, 15, '2015-01-23 23:52:17', '2015-01-23 23:52:17', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(29, 16, '2015-03-11 02:12:10', '2015-03-11 02:12:10', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(30, 16, '2015-03-11 02:24:03', '2015-03-11 02:24:03', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(36, 11, '2015-03-25 20:26:58', '2015-03-25 20:28:30', 21, 1, NULL, 0, 'Cfg-05-Buberry', 'Configurable Product 05', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '199.0000', '199.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '199.0000', '199.0000', '0.0000', '1.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '199.0000', '199.0000', '199.0000', '199.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(37, 11, '2015-03-25 20:26:58', '2015-03-25 20:28:30', 33, 1, 36, 0, 'Cfg-05-Buberry', 'Cfg 05 Buberry', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(38, 11, '2015-03-25 20:27:04', '2015-03-25 20:28:30', 30, 1, NULL, 0, 'Cfg-04-Green', 'Cfg 04 Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '100.9800', '100.9800', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '100.9800', '100.9800', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '100.9800', '100.9800', '100.9800', '100.9800', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(39, 18, '2015-03-26 00:00:31', '2015-03-26 00:00:31', 28, 1, NULL, 0, 'Cfg-04-White', 'Cfg 04 White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '100.9800', '100.9800', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '100.9800', '100.9800', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '100.9800', '100.9800', '100.9800', '100.9800', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(40, 19, '2015-03-29 21:43:16', '2015-03-29 21:43:16', 10, 2, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '4.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2084.0000', '2084.0000', '0.0000', '4.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '2084.0000', '2084.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(41, 20, '2015-04-10 04:24:39', '2015-04-10 04:34:42', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '3.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1872.0000', '1872.0000', '0.0000', '3.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '1872.0000', '1872.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(42, 20, '2015-04-10 04:34:53', '2015-04-10 05:19:01', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '4.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2636.0000', '2636.0000', '0.0000', '4.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '2636.0000', '2636.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(43, 20, '2015-04-10 04:37:26', '2015-04-10 04:37:26', 11, 1, NULL, 0, 'Cfg-01-Buberry-Red', 'Cfg Buberry Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '614.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '614.0000', '614.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '614.0000', '614.0000', '614.0000', '614.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(44, 20, '2015-04-10 04:39:00', '2015-04-10 04:39:00', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(45, 20, '2015-04-10 04:40:12', '2015-04-10 04:40:12', 36, 1, NULL, 0, 'Cfg-05-Versace', 'Cfg 05 Versace', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '194.0000', '194.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '194.0000', '194.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '194.0000', '194.0000', '194.0000', '194.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(46, 20, '2015-04-10 04:42:48', '2015-04-10 04:42:48', 35, 1, NULL, 0, 'Cfg-05-Hermes', 'Cfg 05 Hermes', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '189.0000', '189.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '189.0000', '189.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '189.0000', '189.0000', '189.0000', '189.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(47, 21, '2015-04-14 01:00:02', '2015-04-14 01:00:02', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(48, 22, '2015-04-14 18:57:23', '2015-04-14 18:59:03', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '4.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '2636.0000', '2636.0000', '0.0000', '4.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '2636.0000', '2636.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(49, 23, '2015-04-15 02:00:58', '2015-04-15 02:00:58', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(50, 24, '2015-05-08 01:04:12', '2015-05-08 02:36:20', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1248.0000', '1248.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '1248.0000', '1248.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(51, 25, '2015-05-11 19:20:20', '2015-05-11 19:20:20', 11, 1, NULL, 0, 'Cfg-01-Buberry-Red', 'Cfg Buberry Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '614.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '614.0000', '614.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '614.0000', '614.0000', '614.0000', '614.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(52, 25, '2015-05-11 19:20:48', '2015-05-11 19:20:48', 12, 1, NULL, 0, 'Cfg-01-Buberry-Green', 'Cfg Buberry White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '499.0000', '499.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '499.0000', '499.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '499.0000', '499.0000', '499.0000', '499.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(53, 26, '2015-05-13 02:25:31', '2015-05-13 02:28:12', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '2.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '1042.0000', '1042.0000', '0.0000', '2.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '1042.0000', '1042.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(54, 27, '2015-05-19 21:27:27', '2015-05-19 21:27:27', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(55, 27, '2015-05-19 21:27:41', '2015-05-19 21:27:41', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(56, 28, '2015-05-24 21:43:42', '2015-05-24 21:43:42', 40, 1, NULL, 0, 'sim-04', 'Simple product 04', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '119.0000', '119.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '119.0000', '119.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '119.0000', '119.0000', '119.0000', '119.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(57, 29, '2015-05-26 23:48:54', '2015-05-26 23:48:54', 12, 1, NULL, 0, 'Cfg-01-Buberry-Green', 'Cfg Buberry White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '499.0000', '499.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '499.0000', '499.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '499.0000', '499.0000', '499.0000', '499.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(58, 29, '2015-05-26 23:49:37', '2015-05-26 23:49:37', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(59, 30, '2015-05-26 23:56:14', '2015-05-26 23:56:14', 28, 1, NULL, 0, 'Cfg-04-White', 'Cfg 04 White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '100.9800', '100.9800', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '100.9800', '100.9800', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '100.9800', '100.9800', '100.9800', '100.9800', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(60, 30, '2015-05-26 23:56:23', '2015-05-26 23:56:23', 29, 1, NULL, 0, 'Cfg-04-Red', 'Cfg 04 Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '100.9800', '100.9800', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '100.9800', '100.9800', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '100.9800', '100.9800', '100.9800', '100.9800', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(61, 31, '2015-05-27 21:22:38', '2015-05-27 21:22:38', 12, 1, NULL, 0, 'Cfg-01-Buberry-Green', 'Cfg Buberry White', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '499.0000', '499.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '499.0000', '499.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '499.0000', '499.0000', '499.0000', '499.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(62, 32, '2015-06-04 21:35:35', '2015-06-04 21:35:35', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(63, 33, '2015-06-07 18:39:03', '2015-06-07 18:39:03', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(64, 33, '2015-06-07 18:42:38', '2015-06-07 18:42:38', 7, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Configurable Product', NULL, NULL, NULL, 0, 0, 0, NULL, '1.0000', '629.0000', '629.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '629.0000', '629.0000', '0.0000', '0.0000', 'configurable', NULL, NULL, NULL, NULL, NULL, '629.0000', '629.0000', '629.0000', '629.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(65, 33, '2015-06-07 18:42:38', '2015-06-07 18:42:38', 10, 1, 64, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, NULL, '1.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', 'simple', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(66, 34, '2015-06-09 02:54:13', '2015-06-09 02:54:13', 39, 1, NULL, 0, 'sim-03', 'Simple product 03', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '79.0000', '79.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '79.0000', '79.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '79.0000', '79.0000', '79.0000', '79.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(67, 35, '2015-06-10 20:31:12', '2015-06-10 20:31:12', 8, 2, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(68, 35, '2015-06-10 20:31:24', '2015-06-10 20:31:24', 9, 2, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(69, 36, '2015-06-10 20:36:17', '2015-06-10 20:36:17', 8, 3, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(71, 37, '2015-06-10 21:24:05', '2015-06-10 21:24:05', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(72, 38, '2015-06-11 00:09:55', '2015-06-11 00:09:55', 8, 3, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(73, 39, '2015-06-11 02:12:35', '2015-06-11 02:12:35', 10, 3, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(74, 40, '2015-06-12 03:31:48', '2015-06-12 03:31:48', 11, 1, NULL, 0, 'Cfg-01-Buberry-Red', 'Cfg Buberry Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '614.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '614.0000', '614.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '614.0000', '614.0000', '614.0000', '614.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(75, 41, '2015-06-12 19:34:23', '2015-06-12 19:34:23', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(76, 41, '2015-06-12 19:39:46', '2015-06-12 19:39:46', 9, 1, NULL, 0, 'Cfg-01-Armani-Blue', 'Cfg Armani Blue', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '659.0000', '659.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '659.0000', '659.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '659.0000', '659.0000', '659.0000', '659.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(77, 42, '2015-07-01 21:36:18', '2015-07-01 21:36:18', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(78, 42, '2015-07-01 21:42:34', '2015-07-01 21:42:34', 11, 3, NULL, 0, 'Cfg-01-Buberry-Red', 'Cfg Buberry Red', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '614.0000', '614.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '614.0000', '614.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '614.0000', '614.0000', '614.0000', '614.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(79, 43, '2015-07-11 02:06:31', '2015-07-11 02:06:31', 8, 1, NULL, 0, 'Cfg-01-Armani-Black', 'Cfg Armani Black', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '624.0000', '624.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '624.0000', '624.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '624.0000', '624.0000', '624.0000', '624.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(80, 43, '2015-07-11 02:06:51', '2015-07-11 02:06:51', 10, 1, NULL, 0, 'Cfg-01-Armani-Green', 'Cfg Armani Green', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '521.0000', '521.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '521.0000', '521.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '521.0000', '521.0000', '521.0000', '521.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL),
(81, 44, '2015-07-13 02:01:59', '2015-07-13 02:01:59', 33, 3, NULL, 0, 'Cfg-05-Buberry', 'Cfg 05 Buberry', NULL, NULL, NULL, 0, 0, 0, '1.0000', '1.0000', '199.0000', '199.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '0.0000', '199.0000', '199.0000', '0.0000', '1.0000', 'simple', NULL, NULL, NULL, NULL, NULL, '199.0000', '199.0000', '199.0000', '199.0000', '0.0000', '0.0000', NULL, '0.0000', '0.0000', '0.0000', '0.0000', 'a:0:{}', '0.0000', '0.0000', '0.0000', NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_item_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `item_id` int(10) unsigned NOT NULL COMMENT 'Item Id',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` text COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Item Option' AUTO_INCREMENT=118 ;

INSERT INTO `#__sales_flat_quote_item_option` (`option_id`, `item_id`, `product_id`, `code`, `value`) VALUES
(1, 1, 15, 'info_buyRequest', 'a:5:{s:4:"uenc";s:92:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwL2luZGV4LnBocC9wYXJpcy9xdWlja3ZpZXcvaW5kZXgvP2lkPTE1";s:7:"product";s:2:"15";s:8:"form_key";s:16:"PVizrGi7nusxU2Sx";s:15:"related_product";s:0:"";s:3:"qty";s:1:"1";}'),
(2, 2, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:92:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwL2luZGV4LnBocC9wYXJpcy9xdWlja3ZpZXcvaW5kZXgvP2lkPTk,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"3GNjwdecZSJY7NaK";s:15:"related_product";s:0:"";s:3:"qty";s:1:"1";}'),
(3, 3, 35, 'info_buyRequest', 'a:4:{s:4:"uenc";s:68:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwL2luZGV4LnBocC93b21lbi5odG1s";s:7:"product";s:2:"35";s:8:"form_key";s:16:"g1eJRoc2fCfMDbt5";s:3:"qty";i:1;}'),
(4, 4, 8, 'info_buyRequest', 'a:4:{s:4:"uenc";s:92:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4Z3JpZA,,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"G0gluSsak1INR3V6";s:3:"qty";i:1;}'),
(5, 5, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:92:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4Z3JpZA,,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"G0gluSsak1INR3V6";s:3:"qty";i:1;}'),
(6, 6, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:44:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tZ18xOTEwLw,,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"jXYzCtBCQJkn9pdk";s:3:"qty";i:1;}'),
(7, 7, 41, 'info_buyRequest', 'a:4:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4uaHRtbA,,";s:7:"product";s:2:"41";s:8:"form_key";s:16:"7QpABtggCvQflSUf";s:3:"qty";i:1;}'),
(8, 8, 8, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"8";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}'),
(9, 9, 7, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}'),
(10, 9, 7, 'attributes', 'a:2:{i:81;s:2:"10";i:92;s:1:"6";}'),
(11, 9, 10, 'product_qty_10', '1'),
(12, 9, 10, 'simple_product', '10'),
(13, 10, 10, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}'),
(14, 10, 10, 'parent_product_id', '7'),
(15, 11, 10, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:2:"10";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}'),
(16, 12, 41, 'info_buyRequest', 'a:4:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4uaHRtbA,,";s:7:"product";s:2:"41";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";i:1;}'),
(17, 13, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:112:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC1hcm1hbmktYmx1ZS5odG1s";s:7:"product";s:1:"9";s:8:"form_key";s:16:"Apc0Q0wAw9ZKj1Zq";s:15:"related_product";s:0:"";s:3:"qty";s:1:"5";}'),
(18, 14, 28, 'info_buyRequest', 'a:5:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9zaW1vL3F1aWNrdmlldy9pbmRleC8_aWQ9Mjg,";s:7:"product";s:2:"28";s:8:"form_key";s:16:"TNoXjMkJZlH5pOzi";s:15:"related_product";s:0:"";s:3:"qty";s:1:"6";}'),
(19, 15, 8, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"8";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";s:7:"16.0000";}'),
(20, 16, 7, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:6:"2.0000";}'),
(21, 16, 7, 'attributes', 'a:2:{i:81;s:2:"10";i:92;s:1:"6";}'),
(22, 16, 10, 'product_qty_10', '1'),
(23, 16, 10, 'simple_product', '10'),
(24, 17, 10, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:6:"2.0000";}'),
(25, 17, 10, 'parent_product_id', '7'),
(26, 18, 10, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:2:"10";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";s:6:"1.0000";}'),
(27, 19, 41, 'info_buyRequest', 'a:4:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4uaHRtbA,,";s:7:"product";s:2:"41";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";s:3:"qty";s:6:"1.0000";}'),
(28, 20, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:112:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC1hcm1hbmktYmx1ZS5odG1s";s:7:"product";s:1:"9";s:8:"form_key";s:16:"Apc0Q0wAw9ZKj1Zq";s:15:"related_product";s:0:"";s:3:"qty";s:6:"5.0000";}'),
(29, 21, 7, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"Go6D7zSX61tF7ZfS";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"4";}'),
(30, 21, 7, 'attributes', 'a:2:{i:81;s:2:"10";i:92;s:1:"6";}'),
(31, 21, 10, 'product_qty_10', '1'),
(32, 21, 10, 'simple_product', '10'),
(33, 22, 10, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"Go6D7zSX61tF7ZfS";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"4";}'),
(34, 22, 10, 'parent_product_id', '7'),
(41, 25, 7, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"UuT82jECM67Wqq3R";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:1:"9";i:92;s:1:"5";}s:3:"qty";s:1:"5";}'),
(42, 25, 7, 'attributes', 'a:2:{i:81;s:1:"9";i:92;s:1:"5";}'),
(43, 25, 11, 'product_qty_11', '1'),
(44, 25, 11, 'simple_product', '11'),
(45, 26, 11, 'info_buyRequest', 'a:6:{s:4:"uenc";s:96:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9jb25maWd1cmFibGUtcHJvZHVjdC5odG1s";s:7:"product";s:1:"7";s:8:"form_key";s:16:"UuT82jECM67Wqq3R";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:1:"9";i:92;s:1:"5";}s:3:"qty";s:1:"5";}'),
(46, 26, 11, 'parent_product_id', '7'),
(47, 27, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"9";s:8:"form_key";s:16:"ITa4wOoZlkvyhz0J";s:3:"qty";i:1;}'),
(48, 28, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"9";s:8:"form_key";s:16:"S2H3OIoDdWij6mcr";s:3:"qty";i:1;}'),
(49, 29, 8, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"8";s:8:"form_key";s:16:"TrmFNZDn7bBSPq59";s:3:"qty";i:1;}'),
(50, 30, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9wcm9kdWN0dGFicy9pbmRleC9hamF4c2xpZGVy";s:7:"product";s:1:"9";s:8:"form_key";s:16:"TrmFNZDn7bBSPq59";s:3:"qty";i:1;}'),
(64, 36, 21, 'info_buyRequest', 'a:6:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4vY29uZmlndXJhYmxlLXByb2R1Y3QtMDUuaHRtbA,,";s:7:"product";s:2:"21";s:8:"form_key";s:16:"1vOev4epilcamUJt";s:15:"related_product";s:0:"";s:15:"super_attribute";a:1:{i:81;s:1:"9";}s:3:"qty";s:1:"1";}'),
(65, 36, 21, 'attributes', 'a:1:{i:81;s:1:"9";}'),
(66, 36, 33, 'product_qty_33', '1'),
(67, 36, 33, 'simple_product', '33'),
(68, 37, 33, 'info_buyRequest', 'a:6:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4vY29uZmlndXJhYmxlLXByb2R1Y3QtMDUuaHRtbA,,";s:7:"product";s:2:"21";s:8:"form_key";s:16:"1vOev4epilcamUJt";s:15:"related_product";s:0:"";s:15:"super_attribute";a:1:{i:81;s:1:"9";}s:3:"qty";s:1:"1";}'),
(69, 37, 33, 'parent_product_id', '21'),
(70, 38, 30, 'info_buyRequest', 'a:5:{s:4:"uenc";s:116:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4vY29uZmlndXJhYmxlLXByb2R1Y3QtMDQtZ3JlZW4uaHRtbA,,";s:7:"product";s:2:"30";s:8:"form_key";s:16:"1vOev4epilcamUJt";s:15:"related_product";s:0:"";s:3:"qty";s:1:"1";}'),
(71, 39, 28, 'info_buyRequest', 'a:4:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9tZW4uaHRtbA,,";s:7:"product";s:2:"28";s:8:"form_key";s:16:"0Bd6HbIbdOjmfJJ9";s:3:"qty";i:1;}'),
(72, 40, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC9zaW1vL3F1aWNrdmlldy9pbmRleC8_aWQ9MTA,";s:7:"product";s:2:"10";s:8:"form_key";s:16:"FgK8qmROKLqdKy1q";s:15:"related_product";s:0:"";s:3:"qty";s:1:"4";}'),
(73, 41, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC8,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(74, 42, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC8,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(75, 43, 11, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC8,";s:7:"product";s:2:"11";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(76, 44, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC8,";s:7:"product";s:2:"10";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(77, 45, 36, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC93b21lbi5odG1s";s:7:"product";s:2:"36";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(78, 46, 35, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC93b21lbi5odG1s";s:7:"product";s:2:"35";s:8:"form_key";s:16:"RzNkkvzuvJR0Yk7O";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(79, 47, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vLw,,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"7WOPIYrc7uyFPmiV";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(80, 48, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vL2luZGV4LnBocC8,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"XIHPygLSQ6vOG7Jb";s:3:"qty";i:1;}'),
(81, 49, 9, 'info_buyRequest', 'a:4:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19zaW1vLw,,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"w8sY3Esh19LhLRzv";s:3:"qty";i:1;}'),
(82, 50, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"IVyoTl392a5GoLuN";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(83, 51, 11, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:2:"11";s:8:"form_key";s:16:"mtGj7YSEL8JxWG22";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(84, 52, 12, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:2:"12";s:8:"form_key";s:16:"mtGj7YSEL8JxWG22";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(85, 53, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:2:"10";s:8:"form_key";s:16:"YVZ0s0AuX1FBJHET";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(86, 54, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:2:"10";s:8:"form_key";s:16:"h3ODOo7h5k3MNfr3";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(87, 55, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"h3ODOo7h5k3MNfr3";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(88, 56, 40, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAva2lkLmh0bWw,";s:7:"product";s:2:"40";s:8:"form_key";s:16:"qjgXagrF2NfBsJSz";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(89, 57, 12, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:2:"12";s:8:"form_key";s:16:"rGWlskbHQRZglp70";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(90, 58, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:1:"8";s:8:"form_key";s:16:"rGWlskbHQRZglp70";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(91, 59, 28, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvbWVuLmh0bWw,";s:7:"product";s:2:"28";s:8:"form_key";s:16:"IMUTxaMPIfsEbtvI";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(92, 60, 29, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvbWVuLmh0bWw,";s:7:"product";s:2:"29";s:8:"form_key";s:16:"IMUTxaMPIfsEbtvI";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(93, 61, 12, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:2:"12";s:8:"form_key";s:16:"N5OntJ96fTp4VK8P";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(94, 62, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:2:"10";s:8:"form_key";s:16:"Faq9oLgHJdqvnaBM";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(95, 63, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:88:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2g,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"XOgYFfuXPWaLYYFK";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(96, 64, 7, 'info_buyRequest', 'a:7:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvY29uZmlndXJhYmxlLXByb2R1Y3QuaHRtbA,,";s:7:"product";s:1:"7";s:8:"form_key";s:16:"XOgYFfuXPWaLYYFK";s:6:"isAjax";s:1:"1";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}'),
(97, 64, 7, 'attributes', 'a:2:{i:81;s:2:"10";i:92;s:1:"6";}'),
(98, 64, 10, 'product_qty_10', '1'),
(99, 64, 10, 'simple_product', '10'),
(100, 65, 10, 'info_buyRequest', 'a:7:{s:4:"uenc";s:100:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvY29uZmlndXJhYmxlLXByb2R1Y3QuaHRtbA,,";s:7:"product";s:1:"7";s:8:"form_key";s:16:"XOgYFfuXPWaLYYFK";s:6:"isAjax";s:1:"1";s:15:"related_product";s:0:"";s:15:"super_attribute";a:2:{i:81;s:2:"10";i:92;s:1:"6";}s:3:"qty";s:1:"1";}'),
(101, 65, 10, 'parent_product_id', '7'),
(102, 66, 39, 'info_buyRequest', 'a:5:{s:4:"uenc";s:76:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvbWVuLmh0bWw,";s:7:"product";s:2:"39";s:8:"form_key";s:16:"0mamlD0Qqb9cffAA";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(103, 67, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWZyZW5jaCZzbnNfY2xlYXJjb29raWU,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"5zu2tS0Pj15LxLkq";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(104, 68, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWZyZW5jaCZzbnNfY2xlYXJjb29raWU,";s:7:"product";s:1:"9";s:8:"form_key";s:16:"5zu2tS0Pj15LxLkq";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(105, 69, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:52:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS8,";s:7:"product";s:1:"8";s:8:"form_key";s:16:"PcDMk6gUXfzBKKnB";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(107, 71, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:1:"9";s:8:"form_key";s:16:"z5bkJG5viWVzSioy";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(108, 72, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:1:"8";s:8:"form_key";s:16:"pwTSwxrSHPudZkUG";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(109, 73, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:116:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWdlcm1hbnkmX19fZnJvbV9zdG9yZT1mcmVuY2g,";s:7:"product";s:2:"10";s:8:"form_key";s:16:"fUJ9LF7LujwFGOfC";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(110, 74, 11, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:2:"11";s:8:"form_key";s:16:"2mY9WXyweROgsnrE";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(111, 75, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:1:"8";s:8:"form_key";s:16:"ar8cezCgN1BXaBif";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(112, 76, 9, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:1:"9";s:8:"form_key";s:16:"ar8cezCgN1BXaBif";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(113, 77, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:108:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvP19fX3N0b3JlPWVuZ2xpc2gmc25zX2NsZWFyY29va2ll";s:7:"product";s:2:"10";s:8:"form_key";s:16:"8DIU01tGQkjP1Olp";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(114, 78, 11, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:2:"11";s:8:"form_key";s:16:"8DIU01tGQkjP1Olp";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(115, 79, 8, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:1:"8";s:8:"form_key";s:16:"yD7eQPgApxKRCvrv";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(116, 80, 10, 'info_buyRequest', 'a:5:{s:4:"uenc";s:64:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAv";s:7:"product";s:2:"10";s:8:"form_key";s:16:"yD7eQPgApxKRCvrv";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}'),
(117, 81, 33, 'info_buyRequest', 'a:5:{s:4:"uenc";s:80:"aHR0cDovL2Rldi5zbnNncm91cC5tZS9tYWdlL3Nuc19hbW9kYS9pbmRleC5waHAvd29tZW4uaHRtbA,,";s:7:"product";s:2:"33";s:8:"form_key";s:16:"lgSYeFo9OZjzADrU";s:6:"isAjax";s:1:"1";s:3:"qty";i:1;}');

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_payment` (
`payment_id` int(10) unsigned NOT NULL COMMENT 'Payment Id',
  `quote_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Quote Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `method` varchar(255) DEFAULT NULL COMMENT 'Method',
  `cc_type` varchar(255) DEFAULT NULL COMMENT 'Cc Type',
  `cc_number_enc` varchar(255) DEFAULT NULL COMMENT 'Cc Number Enc',
  `cc_last4` varchar(255) DEFAULT NULL COMMENT 'Cc Last4',
  `cc_cid_enc` varchar(255) DEFAULT NULL COMMENT 'Cc Cid Enc',
  `cc_owner` varchar(255) DEFAULT NULL COMMENT 'Cc Owner',
  `cc_exp_month` smallint(5) unsigned DEFAULT '0' COMMENT 'Cc Exp Month',
  `cc_exp_year` smallint(5) unsigned DEFAULT '0' COMMENT 'Cc Exp Year',
  `cc_ss_owner` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Owner',
  `cc_ss_start_month` smallint(5) unsigned DEFAULT '0' COMMENT 'Cc Ss Start Month',
  `cc_ss_start_year` smallint(5) unsigned DEFAULT '0' COMMENT 'Cc Ss Start Year',
  `po_number` varchar(255) DEFAULT NULL COMMENT 'Po Number',
  `additional_data` text COMMENT 'Additional Data',
  `cc_ss_issue` varchar(255) DEFAULT NULL COMMENT 'Cc Ss Issue',
  `additional_information` text COMMENT 'Additional Information',
  `paypal_payer_id` varchar(255) DEFAULT NULL COMMENT 'Paypal Payer Id',
  `paypal_payer_status` varchar(255) DEFAULT NULL COMMENT 'Paypal Payer Status',
  `paypal_correlation_id` varchar(255) DEFAULT NULL COMMENT 'Paypal Correlation Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Payment' AUTO_INCREMENT=7 ;

INSERT INTO `#__sales_flat_quote_payment` (`payment_id`, `quote_id`, `created_at`, `updated_at`, `method`, `cc_type`, `cc_number_enc`, `cc_last4`, `cc_cid_enc`, `cc_owner`, `cc_exp_month`, `cc_exp_year`, `cc_ss_owner`, `cc_ss_start_month`, `cc_ss_start_year`, `po_number`, `additional_data`, `cc_ss_issue`, `additional_information`, `paypal_payer_id`, `paypal_payer_status`, `paypal_correlation_id`) VALUES
(1, 9, '2015-01-13 01:12:08', '2015-01-13 01:12:08', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(3, 10, '2015-01-19 01:43:10', '2015-01-19 02:06:00', 'checkmo', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(5, 11, '2015-03-25 20:28:35', '2015-03-25 20:50:16', 'checkmo', NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL),
(6, 35, '2015-06-10 20:59:47', '2015-06-10 21:00:42', NULL, NULL, NULL, NULL, NULL, NULL, 0, 0, NULL, 0, 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__sales_flat_quote_shipping_rate` (
`rate_id` int(10) unsigned NOT NULL COMMENT 'Rate Id',
  `address_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Address Id',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Updated At',
  `carrier` varchar(255) DEFAULT NULL COMMENT 'Carrier',
  `carrier_title` varchar(255) DEFAULT NULL COMMENT 'Carrier Title',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `method` varchar(255) DEFAULT NULL COMMENT 'Method',
  `method_description` text COMMENT 'Method Description',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `error_message` text COMMENT 'Error Message',
  `method_title` text COMMENT 'Method Title'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Sales Flat Quote Shipping Rate' AUTO_INCREMENT=26 ;

INSERT INTO `#__sales_flat_quote_shipping_rate` (`rate_id`, `address_id`, `created_at`, `updated_at`, `carrier`, `carrier_title`, `code`, `method`, `method_description`, `price`, `error_message`, `method_title`) VALUES
(6, 21, '2015-01-19 02:05:40', '2015-01-19 02:05:59', 'flatrate', 'Flat Rate', 'flatrate_flatrate', 'flatrate', NULL, '125.0000', NULL, 'Fixed'),
(25, 24, '2015-03-25 20:50:27', '2015-03-25 20:50:27', 'flatrate', 'Flat Rate', 'flatrate_flatrate', 'flatrate', NULL, '325.0000', NULL, 'Fixed');

CREATE TABLE IF NOT EXISTS `#__sales_flat_shipment` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `total_weight` decimal(12,4) DEFAULT NULL COMMENT 'Total Weight',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `email_sent` smallint(5) unsigned DEFAULT NULL COMMENT 'Email Sent',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `customer_id` int(11) DEFAULT NULL COMMENT 'Customer Id',
  `shipping_address_id` int(11) DEFAULT NULL COMMENT 'Shipping Address Id',
  `billing_address_id` int(11) DEFAULT NULL COMMENT 'Billing Address Id',
  `shipment_status` int(11) DEFAULT NULL COMMENT 'Shipment Status',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `packages` text COMMENT 'Packed Products in Packages',
  `shipping_label` mediumblob COMMENT 'Shipping Label Content'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Shipment' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_shipment_comment` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `is_customer_notified` int(11) DEFAULT NULL COMMENT 'Is Customer Notified',
  `is_visible_on_front` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Visible On Front',
  `comment` text COMMENT 'Comment',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Shipment Comment' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_shipment_grid` (
  `entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `total_qty` decimal(12,4) DEFAULT NULL COMMENT 'Total Qty',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `shipment_status` int(11) DEFAULT NULL COMMENT 'Shipment Status',
  `increment_id` varchar(50) DEFAULT NULL COMMENT 'Increment Id',
  `order_increment_id` varchar(50) DEFAULT NULL COMMENT 'Order Increment Id',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `order_created_at` timestamp NULL DEFAULT NULL COMMENT 'Order Created At',
  `shipping_name` varchar(255) DEFAULT NULL COMMENT 'Shipping Name'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Shipment Grid';

CREATE TABLE IF NOT EXISTS `#__sales_flat_shipment_item` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `row_total` decimal(12,4) DEFAULT NULL COMMENT 'Row Total',
  `price` decimal(12,4) DEFAULT NULL COMMENT 'Price',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `product_id` int(11) DEFAULT NULL COMMENT 'Product Id',
  `order_item_id` int(11) DEFAULT NULL COMMENT 'Order Item Id',
  `additional_data` text COMMENT 'Additional Data',
  `description` text COMMENT 'Description',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `sku` varchar(255) DEFAULT NULL COMMENT 'Sku'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Shipment Item' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_flat_shipment_track` (
`entity_id` int(10) unsigned NOT NULL COMMENT 'Entity Id',
  `parent_id` int(10) unsigned NOT NULL COMMENT 'Parent Id',
  `weight` decimal(12,4) DEFAULT NULL COMMENT 'Weight',
  `qty` decimal(12,4) DEFAULT NULL COMMENT 'Qty',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `track_number` text COMMENT 'Number',
  `description` text COMMENT 'Description',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `carrier_code` varchar(32) DEFAULT NULL COMMENT 'Carrier Code',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Flat Shipment Track' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_invoiced_aggregated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `orders_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Orders Invoiced',
  `invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced',
  `invoiced_captured` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced Captured',
  `invoiced_not_captured` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced Not Captured'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Invoiced Aggregated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_invoiced_aggregated_order` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) NOT NULL DEFAULT '' COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `orders_invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Orders Invoiced',
  `invoiced` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced',
  `invoiced_captured` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced Captured',
  `invoiced_not_captured` decimal(12,4) DEFAULT NULL COMMENT 'Invoiced Not Captured'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Invoiced Aggregated Order' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_order_aggregated_created` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) NOT NULL DEFAULT '' COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Ordered',
  `total_qty_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Invoiced',
  `total_income_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Income Amount',
  `total_revenue_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Revenue Amount',
  `total_profit_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Profit Amount',
  `total_invoiced_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Invoiced Amount',
  `total_canceled_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Canceled Amount',
  `total_paid_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Paid Amount',
  `total_refunded_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Refunded Amount',
  `total_tax_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount',
  `total_tax_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount Actual',
  `total_shipping_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount',
  `total_shipping_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount Actual',
  `total_discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount',
  `total_discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount Actual'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Aggregated Created' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_order_aggregated_updated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_qty_ordered` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Ordered',
  `total_qty_invoiced` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Qty Invoiced',
  `total_income_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Income Amount',
  `total_revenue_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Revenue Amount',
  `total_profit_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Profit Amount',
  `total_invoiced_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Invoiced Amount',
  `total_canceled_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Canceled Amount',
  `total_paid_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Paid Amount',
  `total_refunded_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Refunded Amount',
  `total_tax_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount',
  `total_tax_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Tax Amount Actual',
  `total_shipping_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount',
  `total_shipping_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Shipping Amount Actual',
  `total_discount_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount',
  `total_discount_amount_actual` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Total Discount Amount Actual'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Snspfx Sales Order Aggregated Updated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_order_status` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `label` varchar(128) NOT NULL COMMENT 'Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Status Table';

INSERT INTO `#__sales_order_status` (`status`, `label`) VALUES
('canceled', 'Canceled'),
('closed', 'Closed'),
('complete', 'Complete'),
('fraud', 'Suspected Fraud'),
('holded', 'On Hold'),
('payment_review', 'Payment Review'),
('paypal_canceled_reversal', 'PayPal Canceled Reversal'),
('paypal_reversed', 'PayPal Reversed'),
('pending', 'Pending'),
('pending_payment', 'Pending Payment'),
('pending_paypal', 'Pending PayPal'),
('processing', 'Processing');

CREATE TABLE IF NOT EXISTS `#__sales_order_status_label` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `label` varchar(128) NOT NULL COMMENT 'Label'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Status Label Table';

CREATE TABLE IF NOT EXISTS `#__sales_order_status_state` (
  `status` varchar(32) NOT NULL COMMENT 'Status',
  `state` varchar(32) NOT NULL COMMENT 'Label',
  `is_default` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Is Default'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Status Table';

INSERT INTO `#__sales_order_status_state` (`status`, `state`, `is_default`) VALUES
('canceled', 'canceled', 1),
('closed', 'closed', 1),
('complete', 'complete', 1),
('fraud', 'payment_review', 0),
('holded', 'holded', 1),
('payment_review', 'payment_review', 1),
('pending', 'new', 1),
('pending_payment', 'pending_payment', 1),
('processing', 'processing', 1);

CREATE TABLE IF NOT EXISTS `#__sales_order_tax` (
`tax_id` int(10) unsigned NOT NULL COMMENT 'Tax Id',
  `order_id` int(10) unsigned NOT NULL COMMENT 'Order Id',
  `code` varchar(255) DEFAULT NULL COMMENT 'Code',
  `title` varchar(255) DEFAULT NULL COMMENT 'Title',
  `percent` decimal(12,4) DEFAULT NULL COMMENT 'Percent',
  `amount` decimal(12,4) DEFAULT NULL COMMENT 'Amount',
  `priority` int(11) NOT NULL COMMENT 'Priority',
  `position` int(11) NOT NULL COMMENT 'Position',
  `base_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Amount',
  `process` smallint(6) NOT NULL COMMENT 'Process',
  `base_real_amount` decimal(12,4) DEFAULT NULL COMMENT 'Base Real Amount',
  `hidden` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Hidden'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Tax Table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_order_tax_item` (
`tax_item_id` int(10) unsigned NOT NULL COMMENT 'Tax Item Id',
  `tax_id` int(10) unsigned NOT NULL COMMENT 'Tax Id',
  `item_id` int(10) unsigned NOT NULL COMMENT 'Item Id',
  `tax_percent` decimal(12,4) NOT NULL COMMENT 'Real Tax Percent For Item'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Order Tax Item' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_payment_transaction` (
`transaction_id` int(10) unsigned NOT NULL COMMENT 'Transaction Id',
  `parent_id` int(10) unsigned DEFAULT NULL COMMENT 'Parent Id',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id',
  `payment_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Payment Id',
  `txn_id` varchar(100) DEFAULT NULL COMMENT 'Txn Id',
  `parent_txn_id` varchar(100) DEFAULT NULL COMMENT 'Parent Txn Id',
  `txn_type` varchar(15) DEFAULT NULL COMMENT 'Txn Type',
  `is_closed` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Is Closed',
  `additional_information` blob COMMENT 'Additional Information',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Payment Transaction' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_recurring_profile` (
`profile_id` int(10) unsigned NOT NULL COMMENT 'Profile Id',
  `state` varchar(20) NOT NULL COMMENT 'State',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `method_code` varchar(32) NOT NULL COMMENT 'Method Code',
  `created_at` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Created At',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Updated At',
  `reference_id` varchar(32) DEFAULT NULL COMMENT 'Reference Id',
  `subscriber_name` varchar(150) DEFAULT NULL COMMENT 'Subscriber Name',
  `start_datetime` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Start Datetime',
  `internal_reference_id` varchar(42) NOT NULL COMMENT 'Internal Reference Id',
  `schedule_description` varchar(255) NOT NULL COMMENT 'Schedule Description',
  `suspension_threshold` smallint(5) unsigned DEFAULT NULL COMMENT 'Suspension Threshold',
  `bill_failed_later` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Bill Failed Later',
  `period_unit` varchar(20) NOT NULL COMMENT 'Period Unit',
  `period_frequency` smallint(5) unsigned DEFAULT NULL COMMENT 'Period Frequency',
  `period_max_cycles` smallint(5) unsigned DEFAULT NULL COMMENT 'Period Max Cycles',
  `billing_amount` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Billing Amount',
  `trial_period_unit` varchar(20) DEFAULT NULL COMMENT 'Trial Period Unit',
  `trial_period_frequency` smallint(5) unsigned DEFAULT NULL COMMENT 'Trial Period Frequency',
  `trial_period_max_cycles` smallint(5) unsigned DEFAULT NULL COMMENT 'Trial Period Max Cycles',
  `trial_billing_amount` text COMMENT 'Trial Billing Amount',
  `currency_code` varchar(3) NOT NULL COMMENT 'Currency Code',
  `shipping_amount` decimal(12,4) DEFAULT NULL COMMENT 'Shipping Amount',
  `tax_amount` decimal(12,4) DEFAULT NULL COMMENT 'Tax Amount',
  `init_amount` decimal(12,4) DEFAULT NULL COMMENT 'Init Amount',
  `init_may_fail` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Init May Fail',
  `order_info` text NOT NULL COMMENT 'Order Info',
  `order_item_info` text NOT NULL COMMENT 'Order Item Info',
  `billing_address_info` text NOT NULL COMMENT 'Billing Address Info',
  `shipping_address_info` text COMMENT 'Shipping Address Info',
  `profile_vendor_info` text COMMENT 'Profile Vendor Info',
  `additional_info` text COMMENT 'Additional Info'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Recurring Profile' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_recurring_profile_order` (
`link_id` int(10) unsigned NOT NULL COMMENT 'Link Id',
  `profile_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Profile Id',
  `order_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Order Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Recurring Profile Order' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_refunded_aggregated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) NOT NULL DEFAULT '' COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `refunded` decimal(12,4) DEFAULT NULL COMMENT 'Refunded',
  `online_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Online Refunded',
  `offline_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Offline Refunded'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Refunded Aggregated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_refunded_aggregated_order` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `refunded` decimal(12,4) DEFAULT NULL COMMENT 'Refunded',
  `online_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Online Refunded',
  `offline_refunded` decimal(12,4) DEFAULT NULL COMMENT 'Offline Refunded'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Refunded Aggregated Order' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_shipping_aggregated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_shipping` decimal(12,4) DEFAULT NULL COMMENT 'Total Shipping',
  `total_shipping_actual` decimal(12,4) DEFAULT NULL COMMENT 'Total Shipping Actual'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Shipping Aggregated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sales_shipping_aggregated_order` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `order_status` varchar(50) DEFAULT NULL COMMENT 'Order Status',
  `shipping_description` varchar(255) DEFAULT NULL COMMENT 'Shipping Description',
  `orders_count` int(11) NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `total_shipping` decimal(12,4) DEFAULT NULL COMMENT 'Total Shipping',
  `total_shipping_actual` decimal(12,4) DEFAULT NULL COMMENT 'Total Shipping Actual'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Sales Shipping Aggregated Order' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sendfriend_log` (
`log_id` int(10) unsigned NOT NULL COMMENT 'Log ID',
  `ip` varbinary(16) DEFAULT NULL,
  `time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Log time',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website ID'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Send to friend function log storage table' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__shipping_tablerate` (
`pk` int(10) unsigned NOT NULL COMMENT 'Primary key',
  `website_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `dest_country_id` varchar(4) NOT NULL DEFAULT '0' COMMENT 'Destination coutry ISO/2 or ISO/3 code',
  `dest_region_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Destination Region Id',
  `dest_zip` varchar(10) NOT NULL DEFAULT '*' COMMENT 'Destination Post Code (Zip)',
  `condition_name` varchar(20) NOT NULL COMMENT 'Rate Condition name',
  `condition_value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Rate condition value',
  `price` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Price',
  `cost` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Cost'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Shipping Tablerate' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__sitemap` (
`sitemap_id` int(10) unsigned NOT NULL COMMENT 'Sitemap Id',
  `sitemap_type` varchar(32) DEFAULT NULL COMMENT 'Sitemap Type',
  `sitemap_filename` varchar(32) DEFAULT NULL COMMENT 'Sitemap Filename',
  `sitemap_path` varchar(255) DEFAULT NULL COMMENT 'Sitemap Path',
  `sitemap_time` timestamp NULL DEFAULT NULL COMMENT 'Sitemap Time',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Google Sitemap' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__tag` (
`tag_id` int(10) unsigned NOT NULL COMMENT 'Tag Id',
  `name` varchar(255) DEFAULT NULL COMMENT 'Name',
  `status` smallint(6) NOT NULL DEFAULT '0' COMMENT 'Status',
  `first_customer_id` int(10) unsigned DEFAULT NULL COMMENT 'First Customer Id',
  `first_store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'First Store Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tag' AUTO_INCREMENT=50 ;

INSERT INTO `#__tag` (`tag_id`, `name`, `status`, `first_customer_id`, `first_store_id`) VALUES
(2, 'options', 1, 1, 1),
(5, 'nonummy', 1, 3, 1),
(6, 'mattis,', 1, 3, 1),
(7, 'lectus', 1, 3, 1),
(10, 'Ut', 1, 3, 1),
(11, 'metus.', 1, 3, 1),
(12, 'Maecenas', 1, 3, 1),
(16, 'Proin', 1, 3, 1),
(18, 'pharetra', 1, 3, 1),
(22, 'tellus', 1, 3, 1),
(25, 'Quisque', 1, 3, 1),
(29, 'vel,', 1, 3, 1),
(31, 'rhoncus,', 1, 3, 1),
(32, 'nulla.', 1, 3, 1),
(33, 'dapibus', 1, 3, 3),
(34, 'nibh', 1, 3, 3),
(35, 'eu', 1, 3, 3),
(36, 'est.', 1, 3, 3),
(37, 'faucibus', 1, 3, 3),
(38, 'nibh.', 1, 3, 3),
(39, 'Integer', 1, 3, 3),
(40, 'aliquet', 1, 3, 3),
(41, 'in', 1, 3, 3),
(42, 'felis.', 1, 3, 3),
(43, 'mi', 1, 3, 3),
(44, 'pede,', 1, 3, 3),
(45, 'imperdiet', 1, 3, 3),
(46, 'a,', 1, 3, 3),
(47, 'bibendum', 1, 3, 3),
(48, 'Sed', 1, 3, 3),
(49, 'velit.', 1, 3, 3);

CREATE TABLE IF NOT EXISTS `#__tag_properties` (
  `tag_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tag Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `base_popularity` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Base Popularity'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tag Properties';

CREATE TABLE IF NOT EXISTS `#__tag_relation` (
`tag_relation_id` int(10) unsigned NOT NULL COMMENT 'Tag Relation Id',
  `tag_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tag Id',
  `customer_id` int(10) unsigned DEFAULT NULL COMMENT 'Customer Id',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Store Id',
  `active` smallint(5) unsigned NOT NULL DEFAULT '1' COMMENT 'Active',
  `created_at` timestamp NULL DEFAULT NULL COMMENT 'Created At'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tag Relation' AUTO_INCREMENT=62 ;

INSERT INTO `#__tag_relation` (`tag_relation_id`, `tag_id`, `customer_id`, `product_id`, `store_id`, `active`, `created_at`) VALUES
(2, 2, 1, 45, 1, 1, '2014-12-04 20:56:44'),
(4, 2, 1, 44, 1, 1, '2014-12-04 20:59:03'),
(7, 5, 3, 45, 1, 1, '2015-05-13 01:31:57'),
(8, 6, 3, 45, 1, 1, '2015-05-13 01:31:57'),
(9, 7, 3, 45, 1, 1, '2015-05-13 01:31:58'),
(12, 10, 3, 45, 1, 1, '2015-05-13 01:33:53'),
(13, 11, 3, 45, 1, 1, '2015-05-13 01:33:53'),
(14, 12, 3, 45, 1, 1, '2015-05-13 01:33:54'),
(18, 16, 3, 45, 1, 1, '2015-05-13 01:33:57'),
(20, 18, 3, 45, 1, 1, '2015-05-13 01:33:58'),
(24, 22, 3, 45, 1, 1, '2015-05-13 01:34:01'),
(27, 25, 3, 45, 1, 1, '2015-05-13 01:34:03'),
(31, 29, 3, 45, 1, 1, '2015-05-13 01:34:05'),
(33, 31, 3, 45, 1, 1, '2015-05-13 01:34:06'),
(34, 32, 3, 45, 1, 1, '2015-05-13 01:34:06'),
(35, 10, 3, 8, 3, 1, '2015-05-20 02:21:37'),
(36, 11, 3, 8, 3, 1, '2015-05-20 02:21:38'),
(37, 12, 3, 8, 3, 1, '2015-05-20 02:21:38'),
(38, 33, 3, 8, 3, 1, '2015-05-20 02:21:39'),
(39, 34, 3, 8, 3, 1, '2015-05-20 02:21:40'),
(40, 35, 3, 8, 3, 1, '2015-05-20 02:21:41'),
(41, 36, 3, 8, 3, 1, '2015-05-20 02:21:42'),
(42, 16, 3, 8, 3, 1, '2015-05-20 02:21:42'),
(43, 37, 3, 8, 3, 1, '2015-05-20 02:21:42'),
(44, 18, 3, 8, 3, 1, '2015-05-20 02:21:43'),
(45, 38, 3, 8, 3, 1, '2015-05-20 02:21:43'),
(46, 39, 3, 8, 3, 1, '2015-05-20 02:21:44'),
(47, 40, 3, 8, 3, 1, '2015-05-20 02:21:44'),
(48, 22, 3, 8, 3, 1, '2015-05-20 02:21:45'),
(49, 41, 3, 8, 3, 1, '2015-05-20 02:21:46'),
(50, 42, 3, 8, 3, 1, '2015-05-20 02:21:47'),
(51, 25, 3, 8, 3, 1, '2015-05-20 02:21:47'),
(52, 43, 3, 8, 3, 1, '2015-05-20 02:21:48'),
(53, 44, 3, 8, 3, 1, '2015-05-20 02:21:49'),
(54, 45, 3, 8, 3, 1, '2015-05-20 02:21:49'),
(55, 46, 3, 8, 3, 1, '2015-05-20 02:21:50'),
(56, 29, 3, 8, 3, 1, '2015-05-20 02:21:51'),
(57, 47, 3, 8, 3, 1, '2015-05-20 02:21:51'),
(58, 31, 3, 8, 3, 1, '2015-05-20 02:21:52'),
(59, 32, 3, 8, 3, 1, '2015-05-20 02:21:52'),
(60, 48, 3, 8, 3, 1, '2015-05-20 02:21:52'),
(61, 49, 3, 8, 3, 1, '2015-05-20 02:21:53');

CREATE TABLE IF NOT EXISTS `#__tag_summary` (
  `tag_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Tag Id',
  `store_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Store Id',
  `customers` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customers',
  `products` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Products',
  `uses` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Uses',
  `historical_uses` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Historical Uses',
  `popularity` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Popularity',
  `base_popularity` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Base Popularity'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tag Summary';

INSERT INTO `#__tag_summary` (`tag_id`, `store_id`, `customers`, `products`, `uses`, `historical_uses`, `popularity`, `base_popularity`) VALUES
(2, 0, 1, 2, 0, 0, 2, 0),
(2, 1, 1, 2, 0, 0, 2, 0),
(5, 0, 1, 1, 0, 0, 1, 0),
(5, 1, 1, 1, 0, 0, 1, 0),
(6, 0, 1, 1, 0, 0, 1, 0),
(6, 1, 1, 1, 0, 0, 1, 0),
(7, 0, 1, 1, 0, 0, 1, 0),
(7, 1, 1, 1, 0, 0, 1, 0),
(10, 0, 1, 2, 0, 0, 2, 0),
(10, 1, 1, 1, 0, 0, 1, 0),
(10, 3, 1, 1, 0, 0, 1, 0),
(11, 0, 1, 2, 0, 0, 2, 0),
(11, 1, 1, 1, 0, 0, 1, 0),
(11, 3, 1, 1, 0, 0, 1, 0),
(12, 0, 1, 2, 0, 0, 2, 0),
(12, 1, 1, 1, 0, 0, 1, 0),
(12, 3, 1, 1, 0, 0, 1, 0),
(16, 0, 1, 2, 0, 0, 2, 0),
(16, 1, 1, 1, 0, 0, 1, 0),
(16, 3, 1, 1, 0, 0, 1, 0),
(18, 0, 1, 2, 0, 0, 2, 0),
(18, 1, 1, 1, 0, 0, 1, 0),
(18, 3, 1, 1, 0, 0, 1, 0),
(22, 0, 1, 2, 0, 0, 2, 0),
(22, 1, 1, 1, 0, 0, 1, 0),
(22, 3, 1, 1, 0, 0, 1, 0),
(25, 0, 1, 2, 0, 0, 2, 0),
(25, 1, 1, 1, 0, 0, 1, 0),
(25, 3, 1, 1, 0, 0, 1, 0),
(29, 0, 1, 2, 0, 0, 2, 0),
(29, 1, 1, 1, 0, 0, 1, 0),
(29, 3, 1, 1, 0, 0, 1, 0),
(31, 0, 1, 2, 0, 0, 2, 0),
(31, 1, 1, 1, 0, 0, 1, 0),
(31, 3, 1, 1, 0, 0, 1, 0),
(32, 0, 1, 2, 0, 0, 2, 0),
(32, 1, 1, 1, 0, 0, 1, 0),
(32, 3, 1, 1, 0, 0, 1, 0),
(33, 0, 1, 1, 0, 0, 1, 0),
(33, 3, 1, 1, 0, 0, 1, 0),
(34, 0, 1, 1, 0, 0, 1, 0),
(34, 3, 1, 1, 0, 0, 1, 0),
(35, 0, 1, 1, 0, 0, 1, 0),
(35, 3, 1, 1, 0, 0, 1, 0),
(36, 0, 1, 1, 0, 0, 1, 0),
(36, 3, 1, 1, 0, 0, 1, 0),
(37, 0, 1, 1, 0, 0, 1, 0),
(37, 3, 1, 1, 0, 0, 1, 0),
(38, 0, 1, 1, 0, 0, 1, 0),
(38, 3, 1, 1, 0, 0, 1, 0),
(39, 0, 1, 1, 0, 0, 1, 0),
(39, 3, 1, 1, 0, 0, 1, 0),
(40, 0, 1, 1, 0, 0, 1, 0),
(40, 3, 1, 1, 0, 0, 1, 0),
(41, 0, 1, 1, 0, 0, 1, 0),
(41, 3, 1, 1, 0, 0, 1, 0),
(42, 0, 1, 1, 0, 0, 1, 0),
(42, 3, 1, 1, 0, 0, 1, 0),
(43, 0, 1, 1, 0, 0, 1, 0),
(43, 3, 1, 1, 0, 0, 1, 0),
(44, 0, 1, 1, 0, 0, 1, 0),
(44, 3, 1, 1, 0, 0, 1, 0),
(45, 0, 1, 1, 0, 0, 1, 0),
(45, 3, 1, 1, 0, 0, 1, 0),
(46, 0, 1, 1, 0, 0, 1, 0),
(46, 3, 1, 1, 0, 0, 1, 0),
(47, 0, 1, 1, 0, 0, 1, 0),
(47, 3, 1, 1, 0, 0, 1, 0),
(48, 0, 1, 1, 0, 0, 1, 0),
(48, 3, 1, 1, 0, 0, 1, 0),
(49, 0, 1, 1, 0, 0, 1, 0),
(49, 3, 1, 1, 0, 0, 1, 0);

CREATE TABLE IF NOT EXISTS `#__tax_calculation` (
`tax_calculation_id` int(11) NOT NULL COMMENT 'Tax Calculation Id',
  `tax_calculation_rate_id` int(11) NOT NULL COMMENT 'Tax Calculation Rate Id',
  `tax_calculation_rule_id` int(11) NOT NULL COMMENT 'Tax Calculation Rule Id',
  `customer_tax_class_id` smallint(6) NOT NULL COMMENT 'Customer Tax Class Id',
  `product_tax_class_id` smallint(6) NOT NULL COMMENT 'Product Tax Class Id'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tax Calculation' AUTO_INCREMENT=3 ;

INSERT INTO `#__tax_calculation` (`tax_calculation_id`, `tax_calculation_rate_id`, `tax_calculation_rule_id`, `customer_tax_class_id`, `product_tax_class_id`) VALUES
(1, 1, 1, 3, 2),
(2, 2, 1, 3, 2);

CREATE TABLE IF NOT EXISTS `#__tax_calculation_rate` (
`tax_calculation_rate_id` int(11) NOT NULL COMMENT 'Tax Calculation Rate Id',
  `tax_country_id` varchar(2) NOT NULL COMMENT 'Tax Country Id',
  `tax_region_id` int(11) NOT NULL COMMENT 'Tax Region Id',
  `tax_postcode` varchar(21) DEFAULT NULL COMMENT 'Tax Postcode',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `rate` decimal(12,4) NOT NULL COMMENT 'Rate',
  `zip_is_range` smallint(6) DEFAULT NULL COMMENT 'Zip Is Range',
  `zip_from` int(10) unsigned DEFAULT NULL COMMENT 'Zip From',
  `zip_to` int(10) unsigned DEFAULT NULL COMMENT 'Zip To'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tax Calculation Rate' AUTO_INCREMENT=3 ;

INSERT INTO `#__tax_calculation_rate` (`tax_calculation_rate_id`, `tax_country_id`, `tax_region_id`, `tax_postcode`, `code`, `rate`, `zip_is_range`, `zip_from`, `zip_to`) VALUES
(1, 'US', 12, '*', 'US-CA-*-Rate 1', '8.2500', NULL, NULL, NULL),
(2, 'US', 43, '*', 'US-NY-*-Rate 1', '8.3750', NULL, NULL, NULL);

CREATE TABLE IF NOT EXISTS `#__tax_calculation_rate_title` (
`tax_calculation_rate_title_id` int(11) NOT NULL COMMENT 'Tax Calculation Rate Title Id',
  `tax_calculation_rate_id` int(11) NOT NULL COMMENT 'Tax Calculation Rate Id',
  `store_id` smallint(5) unsigned NOT NULL COMMENT 'Store Id',
  `value` varchar(255) NOT NULL COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tax Calculation Rate Title' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__tax_calculation_rule` (
`tax_calculation_rule_id` int(11) NOT NULL COMMENT 'Tax Calculation Rule Id',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `priority` int(11) NOT NULL COMMENT 'Priority',
  `position` int(11) NOT NULL COMMENT 'Position',
  `calculate_subtotal` int(11) NOT NULL COMMENT 'Calculate off subtotal option'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tax Calculation Rule' AUTO_INCREMENT=2 ;

INSERT INTO `#__tax_calculation_rule` (`tax_calculation_rule_id`, `code`, `priority`, `position`, `calculate_subtotal`) VALUES
(1, 'Retail Customer-Taxable Goods-Rate 1', 1, 1, 0);

CREATE TABLE IF NOT EXISTS `#__tax_class` (
`class_id` smallint(6) NOT NULL COMMENT 'Class Id',
  `class_name` varchar(255) NOT NULL COMMENT 'Class Name',
  `class_type` varchar(8) NOT NULL DEFAULT 'CUSTOMER' COMMENT 'Class Type'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Tax Class' AUTO_INCREMENT=5 ;

INSERT INTO `#__tax_class` (`class_id`, `class_name`, `class_type`) VALUES
(2, 'Taxable Goods', 'PRODUCT'),
(3, 'Retail Customer', 'CUSTOMER'),
(4, 'Shipping', 'PRODUCT');

CREATE TABLE IF NOT EXISTS `#__tax_order_aggregated_created` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `percent` float DEFAULT NULL COMMENT 'Percent',
  `orders_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `tax_base_amount_sum` float DEFAULT NULL COMMENT 'Tax Base Amount Sum'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Tax Order Aggregation' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__tax_order_aggregated_updated` (
`id` int(10) unsigned NOT NULL COMMENT 'Id',
  `period` date DEFAULT NULL COMMENT 'Period',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store Id',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `order_status` varchar(50) NOT NULL COMMENT 'Order Status',
  `percent` float DEFAULT NULL COMMENT 'Percent',
  `orders_count` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Orders Count',
  `tax_base_amount_sum` float DEFAULT NULL COMMENT 'Tax Base Amount Sum'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Snspfx Tax Order Aggregated Updated' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__weee_discount` (
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `customer_group_id` smallint(5) unsigned NOT NULL COMMENT 'Customer Group Id',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Weee Discount';

CREATE TABLE IF NOT EXISTS `#__weee_tax` (
`value_id` int(11) NOT NULL COMMENT 'Value Id',
  `website_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Website Id',
  `entity_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Entity Id',
  `country` varchar(2) DEFAULT NULL COMMENT 'Country',
  `value` decimal(12,4) NOT NULL DEFAULT '0.0000' COMMENT 'Value',
  `state` varchar(255) NOT NULL DEFAULT '*' COMMENT 'State',
  `attribute_id` smallint(5) unsigned NOT NULL COMMENT 'Attribute Id',
  `entity_type_id` smallint(5) unsigned NOT NULL COMMENT 'Entity Type Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Weee Tax' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__widget` (
`widget_id` int(10) unsigned NOT NULL COMMENT 'Widget Id',
  `widget_code` varchar(255) DEFAULT NULL COMMENT 'Widget code for template directive',
  `widget_type` varchar(255) DEFAULT NULL COMMENT 'Widget Type',
  `parameters` text COMMENT 'Parameters'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Preconfigured Widgets' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__widget_instance` (
`instance_id` int(10) unsigned NOT NULL COMMENT 'Instance Id',
  `instance_type` varchar(255) DEFAULT NULL COMMENT 'Instance Type',
  `package_theme` varchar(255) DEFAULT NULL COMMENT 'Package Theme',
  `title` varchar(255) DEFAULT NULL COMMENT 'Widget Title',
  `store_ids` varchar(255) NOT NULL DEFAULT '0' COMMENT 'Store ids',
  `widget_parameters` text COMMENT 'Widget parameters',
  `sort_order` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Sort order'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Instances of Widget for Package Theme' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__widget_instance_page` (
`page_id` int(10) unsigned NOT NULL COMMENT 'Page Id',
  `instance_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Instance Id',
  `page_group` varchar(25) DEFAULT NULL COMMENT 'Block Group Type',
  `layout_handle` varchar(255) DEFAULT NULL COMMENT 'Layout Handle',
  `block_reference` varchar(255) DEFAULT NULL COMMENT 'Block Reference',
  `page_for` varchar(25) DEFAULT NULL COMMENT 'For instance entities',
  `entities` text COMMENT 'Catalog entities (comma separated)',
  `page_template` varchar(255) DEFAULT NULL COMMENT 'Path to widget template'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Instance of Widget on Page' AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__widget_instance_page_layout` (
  `page_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Page Id',
  `layout_update_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Layout Update Id'
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='Layout updates';

CREATE TABLE IF NOT EXISTS `#__wishlist` (
`wishlist_id` int(10) unsigned NOT NULL COMMENT 'Wishlist ID',
  `customer_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Customer ID',
  `shared` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT 'Sharing flag (0 or 1)',
  `sharing_code` varchar(32) DEFAULT NULL COMMENT 'Sharing encrypted code',
  `updated_at` timestamp NULL DEFAULT NULL COMMENT 'Last updated date'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Wishlist main Table' AUTO_INCREMENT=2 ;

INSERT INTO `#__wishlist` (`wishlist_id`, `customer_id`, `shared`, `sharing_code`, `updated_at`) VALUES
(1, 2, 0, '16c77a724968f604e522e4e46b65d39a', '2015-01-18 21:17:46');

CREATE TABLE IF NOT EXISTS `#__wishlist_item` (
`wishlist_item_id` int(10) unsigned NOT NULL COMMENT 'Wishlist item ID',
  `wishlist_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Wishlist ID',
  `product_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Product ID',
  `store_id` smallint(5) unsigned DEFAULT NULL COMMENT 'Store ID',
  `added_at` timestamp NULL DEFAULT NULL COMMENT 'Add date and time',
  `description` text COMMENT 'Short description of wish list item',
  `qty` decimal(12,4) NOT NULL COMMENT 'Qty'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Wishlist items' AUTO_INCREMENT=5 ;

INSERT INTO `#__wishlist_item` (`wishlist_item_id`, `wishlist_id`, `product_id`, `store_id`, `added_at`, `description`, `qty`) VALUES
(3, 1, 7, 1, '2015-01-18 21:16:42', NULL, '1.0000'),
(4, 1, 11, 1, '2015-01-18 21:17:45', NULL, '1.0000');

CREATE TABLE IF NOT EXISTS `#__wishlist_item_option` (
`option_id` int(10) unsigned NOT NULL COMMENT 'Option Id',
  `wishlist_item_id` int(10) unsigned NOT NULL COMMENT 'Wishlist Item Id',
  `product_id` int(10) unsigned NOT NULL COMMENT 'Product Id',
  `code` varchar(255) NOT NULL COMMENT 'Code',
  `value` text COMMENT 'Value'
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 COMMENT='Wishlist Item Option Table' AUTO_INCREMENT=5 ;

INSERT INTO `#__wishlist_item_option` (`option_id`, `wishlist_item_id`, `product_id`, `code`, `value`) VALUES
(3, 3, 7, 'info_buyRequest', 'a:2:{s:7:"product";s:1:"7";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";}'),
(4, 4, 11, 'info_buyRequest', 'a:2:{s:7:"product";s:2:"11";s:8:"form_key";s:16:"xZYzAtKeCEmeCrs8";}');


ALTER TABLE `#__adminnotification_inbox`
 ADD PRIMARY KEY (`notification_id`), ADD KEY `IDX_SNSPFX_ADMINNOTIFICATION_INBOX_SEVERITY` (`severity`), ADD KEY `IDX_SNSPFX_ADMINNOTIFICATION_INBOX_IS_READ` (`is_read`), ADD KEY `IDX_SNSPFX_ADMINNOTIFICATION_INBOX_IS_REMOVE` (`is_remove`);

ALTER TABLE `#__admin_assert`
 ADD PRIMARY KEY (`assert_id`);

ALTER TABLE `#__admin_role`
 ADD PRIMARY KEY (`role_id`), ADD KEY `IDX_SNSPFX_ADMIN_ROLE_PARENT_ID_SORT_ORDER` (`parent_id`,`sort_order`), ADD KEY `IDX_SNSPFX_ADMIN_ROLE_TREE_LEVEL` (`tree_level`);

ALTER TABLE `#__admin_rule`
 ADD PRIMARY KEY (`rule_id`), ADD KEY `IDX_SNSPFX_ADMIN_RULE_RESOURCE_ID_ROLE_ID` (`resource_id`,`role_id`), ADD KEY `IDX_SNSPFX_ADMIN_RULE_ROLE_ID_RESOURCE_ID` (`role_id`,`resource_id`);

ALTER TABLE `#__admin_user`
 ADD PRIMARY KEY (`user_id`), ADD UNIQUE KEY `UNQ_SNSPFX_ADMIN_USER_USERNAME` (`username`);

ALTER TABLE `#__api2_acl_attribute`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_API2_ACL_ATTR_USR_TYPE_RES_ID_OPERATION` (`user_type`,`resource_id`,`operation`), ADD KEY `IDX_SNSPFX_API2_ACL_ATTRIBUTE_USER_TYPE` (`user_type`);

ALTER TABLE `#__api2_acl_role`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_API2_ACL_ROLE_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_API2_ACL_ROLE_UPDATED_AT` (`updated_at`);

ALTER TABLE `#__api2_acl_rule`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_API2_ACL_RULE_ROLE_ID_RESOURCE_ID_PRIVILEGE` (`role_id`,`resource_id`,`privilege`);

ALTER TABLE `#__api2_acl_user`
 ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_API2_ACL_USER_ADMIN_ID` (`admin_id`), ADD KEY `FK_SNSPFX_API2_ACL_USER_ROLE_ID_SNSPFX_API2_ACL_ROLE_ENTITY_ID` (`role_id`);

ALTER TABLE `#__api_assert`
 ADD PRIMARY KEY (`assert_id`);

ALTER TABLE `#__api_role`
 ADD PRIMARY KEY (`role_id`), ADD KEY `IDX_SNSPFX_API_ROLE_PARENT_ID_SORT_ORDER` (`parent_id`,`sort_order`), ADD KEY `IDX_SNSPFX_API_ROLE_TREE_LEVEL` (`tree_level`);

ALTER TABLE `#__api_rule`
 ADD PRIMARY KEY (`rule_id`), ADD KEY `IDX_SNSPFX_API_RULE_RESOURCE_ID_ROLE_ID` (`resource_id`,`role_id`), ADD KEY `IDX_SNSPFX_API_RULE_ROLE_ID_RESOURCE_ID` (`role_id`,`resource_id`);

ALTER TABLE `#__api_session`
 ADD KEY `IDX_SNSPFX_API_SESSION_USER_ID` (`user_id`), ADD KEY `IDX_SNSPFX_API_SESSION_SESSID` (`sessid`);

ALTER TABLE `#__api_user`
 ADD PRIMARY KEY (`user_id`);

ALTER TABLE `#__aw_blog`
 ADD PRIMARY KEY (`post_id`), ADD UNIQUE KEY `identifier` (`identifier`);

ALTER TABLE `#__aw_blog_cat`
 ADD PRIMARY KEY (`cat_id`);

ALTER TABLE `#__aw_blog_comment`
 ADD PRIMARY KEY (`comment_id`);

ALTER TABLE `#__aw_blog_tags`
 ADD PRIMARY KEY (`id`), ADD KEY `tag` (`tag`,`tag_count`,`store_id`);

ALTER TABLE `#__captcha_log`
 ADD PRIMARY KEY (`type`,`value`);

ALTER TABLE `#__cataloginventory_stock`
 ADD PRIMARY KEY (`stock_id`);

ALTER TABLE `#__cataloginventory_stock_item`
 ADD PRIMARY KEY (`item_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CATALOGINVENTORY_STOCK_ITEM_PRODUCT_ID_STOCK_ID` (`product_id`,`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_ITEM_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_ITEM_STOCK_ID` (`stock_id`);

ALTER TABLE `#__cataloginventory_stock_status`
 ADD PRIMARY KEY (`product_id`,`website_id`,`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_STOCK_ID` (`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__cataloginventory_stock_status_idx`
 ADD PRIMARY KEY (`product_id`,`website_id`,`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_IDX_STOCK_ID` (`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_IDX_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__cataloginventory_stock_status_tmp`
 ADD PRIMARY KEY (`product_id`,`website_id`,`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_TMP_STOCK_ID` (`stock_id`), ADD KEY `IDX_SNSPFX_CATALOGINVENTORY_STOCK_STATUS_TMP_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalogrule`
 ADD PRIMARY KEY (`rule_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_IS_ACTIVE_SORT_ORDER_TO_DATE_FROM_DATE` (`is_active`,`sort_order`,`to_date`,`from_date`);

ALTER TABLE `#__catalogrule_affected_product`
 ADD PRIMARY KEY (`product_id`);

ALTER TABLE `#__catalogrule_customer_group`
 ADD PRIMARY KEY (`rule_id`,`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_CUSTOMER_GROUP_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_CUSTOMER_GROUP_CUSTOMER_GROUP_ID` (`customer_group_id`);

ALTER TABLE `#__catalogrule_group_website`
 ADD PRIMARY KEY (`rule_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_GROUP_WEBSITE_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_GROUP_WEBSITE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_GROUP_WEBSITE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalogrule_product`
 ADD PRIMARY KEY (`rule_product_id`), ADD UNIQUE KEY `3355397E4BD64AF49DC91C4D4B0EC700` (`rule_id`,`from_time`,`to_time`,`website_id`,`customer_group_id`,`product_id`,`sort_order`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_FROM_TIME` (`from_time`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_TO_TIME` (`to_time`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalogrule_product_price`
 ADD PRIMARY KEY (`rule_product_price_id`), ADD UNIQUE KEY `5F199B8C1163D2B1AD6D63FCFC8B603A` (`rule_date`,`website_id`,`customer_group_id`,`product_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_PRICE_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_PRODUCT_PRICE_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalogrule_website`
 ADD PRIMARY KEY (`rule_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_WEBSITE_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_CATALOGRULE_WEBSITE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalogsearch_fulltext`
 ADD PRIMARY KEY (`fulltext_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CATALOGSEARCH_FULLTEXT_PRODUCT_ID_STORE_ID` (`product_id`,`store_id`), ADD FULLTEXT KEY `FTI_SNSPFX_CATALOGSEARCH_FULLTEXT_DATA_INDEX` (`data_index`);

ALTER TABLE `#__catalogsearch_query`
 ADD PRIMARY KEY (`query_id`), ADD KEY `IDX_SNSPFX_CATALOGSEARCH_QUERY_QUERY_TEXT_STORE_ID_POPULARITY` (`query_text`,`store_id`,`popularity`), ADD KEY `IDX_SNSPFX_CATALOGSEARCH_QUERY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SNSPFX_CATALOGSEARCH_QUERY_SYNONYM_FOR` (`synonym_for`);

ALTER TABLE `#__catalogsearch_result`
 ADD PRIMARY KEY (`query_id`,`product_id`), ADD KEY `IDX_SNSPFX_CATALOGSEARCH_RESULT_QUERY_ID` (`query_id`), ADD KEY `IDX_SNSPFX_CATALOGSEARCH_RESULT_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_category_anc_categs_index_idx`
 ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ANC_CATEGS_INDEX_IDX_CATEGORY_ID` (`category_id`), ADD KEY `IDX_SNSPFX_CAT_CTGR_ANC_CATEGS_IDX_IDX_PATH_CTGR_ID` (`path`,`category_id`);

ALTER TABLE `#__catalog_category_anc_categs_index_tmp`
 ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ANC_CATEGS_INDEX_TMP_CATEGORY_ID` (`category_id`), ADD KEY `IDX_SNSPFX_CAT_CTGR_ANC_CATEGS_IDX_TMP_PATH_CTGR_ID` (`path`,`category_id`);

ALTER TABLE `#__catalog_category_anc_products_index_idx`
 ADD KEY `IDX_SNSPFX_CAT_CTGR_ANC_PRDS_IDX_IDX_CTGR_ID_PRD_ID_POSITION` (`category_id`,`product_id`,`position`);

ALTER TABLE `#__catalog_category_anc_products_index_tmp`
 ADD KEY `IDX_SNSPFX_CAT_CTGR_ANC_PRDS_IDX_TMP_CTGR_ID_PRD_ID_POSITION` (`category_id`,`product_id`,`position`);

ALTER TABLE `#__catalog_category_entity`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_LEVEL` (`level`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_PATH_ENTITY_ID` (`path`,`entity_id`);

ALTER TABLE `#__catalog_category_entity_datetime`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `780CC4D92718123B7CB17FA5E74510E7` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DATETIME_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DATETIME_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_category_entity_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `F5460A17346F79C5234420BA702E4AA9` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_DECIMAL_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_category_entity_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `A417DDACA01F284650507CB4EA8B523F` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_INT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_INT_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_category_entity_text`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `508B4D4AC8E6C47C823721D9555F1FF0` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_TEXT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_TEXT_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_category_entity_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `B4D26583A85AD52BE80D0E0936A4D823` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_ENTITY_VARCHAR_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_category_flat_store_1`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_1_STORE_ID` (`store_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_1_PATH` (`path`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_1_LEVEL` (`level`);

ALTER TABLE `#__catalog_category_flat_store_2`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_2_STORE_ID` (`store_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_2_PATH` (`path`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_2_LEVEL` (`level`);

ALTER TABLE `#__catalog_category_flat_store_3`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_3_STORE_ID` (`store_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_3_PATH` (`path`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_3_LEVEL` (`level`);

ALTER TABLE `#__catalog_category_flat_store_4`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_4_STORE_ID` (`store_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_4_PATH` (`path`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_4_LEVEL` (`level`);

ALTER TABLE `#__catalog_category_flat_store_5`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_5_STORE_ID` (`store_id`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_5_PATH` (`path`), ADD KEY `IDX_SNS_CATALOG_CATEGORY_FLAT_STORE_5_LEVEL` (`level`);

ALTER TABLE `#__catalog_category_product`
 ADD PRIMARY KEY (`category_id`,`product_id`), ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_PRODUCT_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_category_product_index`
 ADD PRIMARY KEY (`category_id`,`product_id`,`store_id`), ADD KEY `IDX_SNSPFX_CAT_CTGR_PRD_IDX_PRD_ID_STORE_ID_CTGR_ID_VISIBILITY` (`product_id`,`store_id`,`category_id`,`visibility`), ADD KEY `EE6AD6499554450FF9D40C12D79B3D33` (`store_id`,`category_id`,`visibility`,`is_parent`,`position`);

ALTER TABLE `#__catalog_category_product_index_enbl_idx`
 ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_PRODUCT_INDEX_ENBL_IDX_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_CAT_CTGR_PRD_IDX_ENBL_IDX_PRD_ID_VISIBILITY` (`product_id`,`visibility`);

ALTER TABLE `#__catalog_category_product_index_enbl_tmp`
 ADD KEY `IDX_SNSPFX_CATALOG_CATEGORY_PRODUCT_INDEX_ENBL_TMP_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_CAT_CTGR_PRD_IDX_ENBL_TMP_PRD_ID_VISIBILITY` (`product_id`,`visibility`);

ALTER TABLE `#__catalog_category_product_index_idx`
 ADD KEY `IDX_SNSPFX_CAT_CTGR_PRD_IDX_IDX_PRD_ID_CTGR_ID_STORE_ID` (`product_id`,`category_id`,`store_id`);

ALTER TABLE `#__catalog_category_product_index_tmp`
 ADD KEY `IDX_SNSPFX_CAT_CTGR_PRD_IDX_TMP_PRD_ID_CTGR_ID_STORE_ID` (`product_id`,`category_id`,`store_id`);

ALTER TABLE `#__catalog_compare_item`
 ADD PRIMARY KEY (`catalog_compare_item_id`), ADD KEY `IDX_SNSPFX_CATALOG_COMPARE_ITEM_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_CATALOG_COMPARE_ITEM_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_CATALOG_COMPARE_ITEM_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`), ADD KEY `IDX_SNSPFX_CATALOG_COMPARE_ITEM_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`), ADD KEY `IDX_SNSPFX_CATALOG_COMPARE_ITEM_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_eav_attribute`
 ADD PRIMARY KEY (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_EAV_ATTRIBUTE_USED_FOR_SORT_BY` (`used_for_sort_by`), ADD KEY `IDX_SNSPFX_CATALOG_EAV_ATTRIBUTE_USED_IN_PRODUCT_LISTING` (`used_in_product_listing`);

ALTER TABLE `#__catalog_product_bundle_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_OPTION_PARENT_ID` (`parent_id`);

ALTER TABLE `#__catalog_product_bundle_option_value`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_BNDL_OPT_VAL_OPT_ID_STORE_ID` (`option_id`,`store_id`);

ALTER TABLE `#__catalog_product_bundle_price_index`
 ADD PRIMARY KEY (`entity_id`,`website_id`,`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_PRICE_INDEX_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_PRICE_INDEX_CUSTOMER_GROUP_ID` (`customer_group_id`);

ALTER TABLE `#__catalog_product_bundle_selection`
 ADD PRIMARY KEY (`selection_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_SELECTION_OPTION_ID` (`option_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_SELECTION_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_product_bundle_selection_price`
 ADD PRIMARY KEY (`selection_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_BUNDLE_SELECTION_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_bundle_stock_index`
 ADD PRIMARY KEY (`entity_id`,`website_id`,`stock_id`,`option_id`);

ALTER TABLE `#__catalog_product_enabled_index`
 ADD PRIMARY KEY (`product_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENABLED_INDEX_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_entity`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_SKU` (`sku`);

ALTER TABLE `#__catalog_product_entity_datetime`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_ENTT_DTIME_ENTT_ID_ATTR_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DATETIME_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DATETIME_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__catalog_product_entity_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_ENTT_DEC_ENTT_ID_ATTR_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DECIMAL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__catalog_product_entity_gallery`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `4BCCEDD96EBAD12F474A8E051BCB2E9C` (`entity_type_id`,`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GALLERY_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GALLERY_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GALLERY_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_entity_group_price`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `E04BB322C294DEB5CDA8142B475B0ACA` (`entity_id`,`all_groups`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GROUP_PRICE_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GROUP_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_GROUP_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_entity_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_ENTT_INT_ENTT_ID_ATTR_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_INT_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_INT_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__catalog_product_entity_media_gallery`
 ADD PRIMARY KEY (`value_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__catalog_product_entity_media_gallery_value`
 ADD PRIMARY KEY (`value_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_MEDIA_GALLERY_VALUE_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_entity_text`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_ENTT_TEXT_ENTT_ID_ATTR_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TEXT_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TEXT_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__catalog_product_entity_tier_price`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `CCFEC42F0B90CF1D9BD2275C99846F5B` (`entity_id`,`all_groups`,`customer_group_id`,`qty`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TIER_PRICE_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TIER_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_TIER_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_entity_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_ENTT_VCHR_ENTT_ID_ATTR_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_VARCHAR_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__catalog_product_flat_1`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_1_TYPE_ID` (`type_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_1_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_1_NAME` (`name`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_1_PRICE` (`price`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_1_STATUS` (`status`);

ALTER TABLE `#__catalog_product_flat_2`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_2_TYPE_ID` (`type_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_2_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_2_NAME` (`name`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_2_PRICE` (`price`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_2_STATUS` (`status`);

ALTER TABLE `#__catalog_product_flat_3`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_3_TYPE_ID` (`type_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_3_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_3_NAME` (`name`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_3_PRICE` (`price`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_3_STATUS` (`status`);

ALTER TABLE `#__catalog_product_flat_4`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_4_TYPE_ID` (`type_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_4_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_4_NAME` (`name`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_4_PRICE` (`price`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_4_STATUS` (`status`);

ALTER TABLE `#__catalog_product_flat_5`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_5_TYPE_ID` (`type_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_5_ATTRIBUTE_SET_ID` (`attribute_set_id`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_5_NAME` (`name`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_5_PRICE` (`price`), ADD KEY `IDX_SNS_CATALOG_PRODUCT_FLAT_5_STATUS` (`status`);

ALTER TABLE `#__catalog_product_index_eav`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_eav_decimal`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_eav_decimal_idx`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_IDX_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_eav_decimal_tmp`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_DECIMAL_TMP_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_eav_idx`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_IDX_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_IDX_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_IDX_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_IDX_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_eav_tmp`
 ADD PRIMARY KEY (`entity_id`,`attribute_id`,`store_id`,`value`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_TMP_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_TMP_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_TMP_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_EAV_TMP_VALUE` (`value`);

ALTER TABLE `#__catalog_product_index_group_price`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_GROUP_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_GROUP_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_index_price`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_MIN_PRICE` (`min_price`), ADD KEY `IDX_SNSPFX_CAT_PRD_IDX_PRICE_WS_ID_CSTR_GROUP_ID_MIN_PRICE` (`website_id`,`customer_group_id`,`min_price`);

ALTER TABLE `#__catalog_product_index_price_bundle_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_bundle_opt_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`);

ALTER TABLE `#__catalog_product_index_price_bundle_opt_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`);

ALTER TABLE `#__catalog_product_index_price_bundle_sel_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`,`selection_id`);

ALTER TABLE `#__catalog_product_index_price_bundle_sel_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`,`selection_id`);

ALTER TABLE `#__catalog_product_index_price_bundle_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_cfg_opt_agr_idx`
 ADD PRIMARY KEY (`parent_id`,`child_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_cfg_opt_agr_tmp`
 ADD PRIMARY KEY (`parent_id`,`child_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_cfg_opt_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_cfg_opt_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_downlod_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_downlod_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_final_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_final_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_IDX_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_IDX_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_IDX_MIN_PRICE` (`min_price`);

ALTER TABLE `#__catalog_product_index_price_opt_agr_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`);

ALTER TABLE `#__catalog_product_index_price_opt_agr_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`,`option_id`);

ALTER TABLE `#__catalog_product_index_price_opt_idx`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_opt_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`);

ALTER TABLE `#__catalog_product_index_price_tmp`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_TMP_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_TMP_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_PRICE_TMP_MIN_PRICE` (`min_price`);

ALTER TABLE `#__catalog_product_index_tier_price`
 ADD PRIMARY KEY (`entity_id`,`customer_group_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_TIER_PRICE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_TIER_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_index_website`
 ADD PRIMARY KEY (`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_INDEX_WEBSITE_WEBSITE_DATE` (`website_date`);

ALTER TABLE `#__catalog_product_link`
 ADD PRIMARY KEY (`link_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_LNK_LNK_TYPE_ID_PRD_ID_LNKED_PRD_ID` (`link_type_id`,`product_id`,`linked_product_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_LINKED_PRODUCT_ID` (`linked_product_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_LINK_TYPE_ID` (`link_type_id`);

ALTER TABLE `#__catalog_product_link_attribute`
 ADD PRIMARY KEY (`product_link_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_ATTRIBUTE_LINK_TYPE_ID` (`link_type_id`);

ALTER TABLE `#__catalog_product_link_attribute_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_LNK_ATTR_DEC_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`), ADD KEY `IDX_SNSPFX_CAT_PRD_LNK_ATTR_DEC_PRD_LNK_ATTR_ID` (`product_link_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_ATTRIBUTE_DECIMAL_LINK_ID` (`link_id`);

ALTER TABLE `#__catalog_product_link_attribute_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_LNK_ATTR_INT_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`), ADD KEY `IDX_SNSPFX_CAT_PRD_LNK_ATTR_INT_PRD_LNK_ATTR_ID` (`product_link_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_ATTRIBUTE_INT_LINK_ID` (`link_id`);

ALTER TABLE `#__catalog_product_link_attribute_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_LNK_ATTR_VCHR_PRD_LNK_ATTR_ID_LNK_ID` (`product_link_attribute_id`,`link_id`), ADD KEY `IDX_SNSPFX_CAT_PRD_LNK_ATTR_VCHR_PRD_LNK_ATTR_ID` (`product_link_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_LINK_ATTRIBUTE_VARCHAR_LINK_ID` (`link_id`);

ALTER TABLE `#__catalog_product_link_type`
 ADD PRIMARY KEY (`link_type_id`);

ALTER TABLE `#__catalog_product_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_product_option_price`
 ADD PRIMARY KEY (`option_price_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CATALOG_PRODUCT_OPTION_PRICE_OPTION_ID_STORE_ID` (`option_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_PRICE_OPTION_ID` (`option_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_PRICE_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_option_title`
 ADD PRIMARY KEY (`option_title_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CATALOG_PRODUCT_OPTION_TITLE_OPTION_ID_STORE_ID` (`option_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TITLE_OPTION_ID` (`option_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_option_type_price`
 ADD PRIMARY KEY (`option_type_price_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_OPT_TYPE_PRICE_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TYPE_PRICE_OPTION_TYPE_ID` (`option_type_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TYPE_PRICE_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_option_type_title`
 ADD PRIMARY KEY (`option_type_title_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_OPT_TYPE_TTL_OPT_TYPE_ID_STORE_ID` (`option_type_id`,`store_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TYPE_TITLE_OPTION_TYPE_ID` (`option_type_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TYPE_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_option_type_value`
 ADD PRIMARY KEY (`option_type_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_OPTION_TYPE_VALUE_OPTION_ID` (`option_id`);

ALTER TABLE `#__catalog_product_relation`
 ADD PRIMARY KEY (`parent_id`,`child_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_RELATION_CHILD_ID` (`child_id`);

ALTER TABLE `#__catalog_product_super_attribute`
 ADD PRIMARY KEY (`product_super_attribute_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_SPR_ATTR_PRD_ID_ATTR_ID` (`product_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_SUPER_ATTRIBUTE_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_product_super_attribute_label`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CAT_PRD_SPR_ATTR_LBL_PRD_SPR_ATTR_ID_STORE_ID` (`product_super_attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_CAT_PRD_SPR_ATTR_LBL_PRD_SPR_ATTR_ID` (`product_super_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_SUPER_ATTRIBUTE_LABEL_STORE_ID` (`store_id`);

ALTER TABLE `#__catalog_product_super_attribute_pricing`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `FFCEF28C144A9536DF77DFB954D48CF0` (`product_super_attribute_id`,`value_index`,`website_id`), ADD KEY `IDX_SNSPFX_CAT_PRD_SPR_ATTR_PRICING_PRD_SPR_ATTR_ID` (`product_super_attribute_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_SUPER_ATTRIBUTE_PRICING_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__catalog_product_super_link`
 ADD PRIMARY KEY (`link_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CATALOG_PRODUCT_SUPER_LINK_PRODUCT_ID_PARENT_ID` (`product_id`,`parent_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_SUPER_LINK_PARENT_ID` (`parent_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_SUPER_LINK_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__catalog_product_website`
 ADD PRIMARY KEY (`product_id`,`website_id`), ADD KEY `IDX_SNSPFX_CATALOG_PRODUCT_WEBSITE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__checkout_agreement`
 ADD PRIMARY KEY (`agreement_id`);

ALTER TABLE `#__checkout_agreement_store`
 ADD PRIMARY KEY (`agreement_id`,`store_id`), ADD KEY `FK_SNSPFX_CHKT_AGRT_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__cms_block`
 ADD PRIMARY KEY (`block_id`);

ALTER TABLE `#__cms_block_store`
 ADD PRIMARY KEY (`block_id`,`store_id`), ADD KEY `IDX_SNSPFX_CMS_BLOCK_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__cms_page`
 ADD PRIMARY KEY (`page_id`), ADD KEY `IDX_SNSPFX_CMS_PAGE_IDENTIFIER` (`identifier`);

ALTER TABLE `#__cms_page_store`
 ADD PRIMARY KEY (`page_id`,`store_id`), ADD KEY `IDX_SNSPFX_CMS_PAGE_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__core_cache`
 ADD PRIMARY KEY (`id`), ADD KEY `IDX_SNSPFX_CORE_CACHE_EXPIRE_TIME` (`expire_time`);

ALTER TABLE `#__core_cache_option`
 ADD PRIMARY KEY (`code`);

ALTER TABLE `#__core_cache_tag`
 ADD PRIMARY KEY (`tag`,`cache_id`), ADD KEY `IDX_SNSPFX_CORE_CACHE_TAG_CACHE_ID` (`cache_id`);

ALTER TABLE `#__core_config_data`
 ADD PRIMARY KEY (`config_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_CONFIG_DATA_SCOPE_SCOPE_ID_PATH` (`scope`,`scope_id`,`path`);

ALTER TABLE `#__core_email_queue`
 ADD PRIMARY KEY (`message_id`), ADD KEY `FA121383F5CA396E04E5459D725C34F3` (`entity_id`,`entity_type`,`event_type`,`message_body_hash`);

ALTER TABLE `#__core_email_queue_recipients`
 ADD PRIMARY KEY (`recipient_id`), ADD UNIQUE KEY `5871E64EABDCE1A1E3F725CC1660ACE7` (`message_id`,`recipient_email`,`email_type`), ADD KEY `IDX_SNSPFX_CORE_EMAIL_QUEUE_RECIPIENTS_RECIPIENT_EMAIL` (`recipient_email`), ADD KEY `IDX_SNSPFX_CORE_EMAIL_QUEUE_RECIPIENTS_EMAIL_TYPE` (`email_type`);

ALTER TABLE `#__core_email_template`
 ADD PRIMARY KEY (`template_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_EMAIL_TEMPLATE_TEMPLATE_CODE` (`template_code`), ADD KEY `IDX_SNSPFX_CORE_EMAIL_TEMPLATE_ADDED_AT` (`added_at`), ADD KEY `IDX_SNSPFX_CORE_EMAIL_TEMPLATE_MODIFIED_AT` (`modified_at`);

ALTER TABLE `#__core_flag`
 ADD PRIMARY KEY (`flag_id`), ADD KEY `IDX_SNSPFX_CORE_FLAG_LAST_UPDATE` (`last_update`);

ALTER TABLE `#__core_layout_link`
 ADD PRIMARY KEY (`layout_link_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_LYT_LNK_STORE_ID_PACKAGE_THEME_LYT_UPDATE_ID` (`store_id`,`package`,`theme`,`layout_update_id`), ADD KEY `IDX_SNSPFX_CORE_LAYOUT_LINK_LAYOUT_UPDATE_ID` (`layout_update_id`);

ALTER TABLE `#__core_layout_update`
 ADD PRIMARY KEY (`layout_update_id`), ADD KEY `IDX_SNSPFX_CORE_LAYOUT_UPDATE_HANDLE` (`handle`);

ALTER TABLE `#__core_resource`
 ADD PRIMARY KEY (`code`);

ALTER TABLE `#__core_session`
 ADD PRIMARY KEY (`session_id`);

ALTER TABLE `#__core_store`
 ADD PRIMARY KEY (`store_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_STORE_CODE` (`code`), ADD KEY `IDX_SNSPFX_CORE_STORE_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CORE_STORE_IS_ACTIVE_SORT_ORDER` (`is_active`,`sort_order`), ADD KEY `IDX_SNSPFX_CORE_STORE_GROUP_ID` (`group_id`);

ALTER TABLE `#__core_store_group`
 ADD PRIMARY KEY (`group_id`), ADD KEY `IDX_SNSPFX_CORE_STORE_GROUP_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_CORE_STORE_GROUP_DEFAULT_STORE_ID` (`default_store_id`);

ALTER TABLE `#__core_translate`
 ADD PRIMARY KEY (`key_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_TRANSLATE_STORE_ID_LOCALE_CRC_STRING_STRING` (`store_id`,`locale`,`crc_string`,`string`), ADD KEY `IDX_SNSPFX_CORE_TRANSLATE_STORE_ID` (`store_id`);

ALTER TABLE `#__core_url_rewrite`
 ADD PRIMARY KEY (`url_rewrite_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_URL_REWRITE_REQUEST_PATH_STORE_ID` (`request_path`,`store_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_URL_REWRITE_ID_PATH_IS_SYSTEM_STORE_ID` (`id_path`,`is_system`,`store_id`), ADD KEY `IDX_SNSPFX_CORE_URL_REWRITE_TARGET_PATH_STORE_ID` (`target_path`,`store_id`), ADD KEY `IDX_SNSPFX_CORE_URL_REWRITE_ID_PATH` (`id_path`), ADD KEY `IDX_SNSPFX_CORE_URL_REWRITE_STORE_ID` (`store_id`), ADD KEY `FK_SNSPFX_CORE_URL_REWRITE_CTGR_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` (`category_id`), ADD KEY `FK_SNSPFX_CORE_URL_REWRITE_PRD_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` (`product_id`);

ALTER TABLE `#__core_variable`
 ADD PRIMARY KEY (`variable_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_VARIABLE_CODE` (`code`);

ALTER TABLE `#__core_variable_value`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_VARIABLE_VALUE_VARIABLE_ID_STORE_ID` (`variable_id`,`store_id`), ADD KEY `IDX_SNSPFX_CORE_VARIABLE_VALUE_VARIABLE_ID` (`variable_id`), ADD KEY `IDX_SNSPFX_CORE_VARIABLE_VALUE_STORE_ID` (`store_id`);

ALTER TABLE `#__core_website`
 ADD PRIMARY KEY (`website_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CORE_WEBSITE_CODE` (`code`), ADD KEY `IDX_SNSPFX_CORE_WEBSITE_SORT_ORDER` (`sort_order`), ADD KEY `IDX_SNSPFX_CORE_WEBSITE_DEFAULT_GROUP_ID` (`default_group_id`);

ALTER TABLE `#__coupon_aggregated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_COUPON_AGGRED_PERIOD_STORE_ID_ORDER_STS_COUPON_CODE` (`period`,`store_id`,`order_status`,`coupon_code`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_RULE_NAME` (`rule_name`);

ALTER TABLE `#__coupon_aggregated_order`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `AB9105967C1F845FF3F9451F277E5B8D` (`period`,`store_id`,`order_status`,`coupon_code`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_ORDER_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_ORDER_RULE_NAME` (`rule_name`);

ALTER TABLE `#__coupon_aggregated_updated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `16BA160EB92E07895E82DF133A0E6769` (`period`,`store_id`,`order_status`,`coupon_code`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_UPDATED_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_COUPON_AGGREGATED_UPDATED_RULE_NAME` (`rule_name`);

ALTER TABLE `#__cron_schedule`
 ADD PRIMARY KEY (`schedule_id`), ADD KEY `IDX_SNSPFX_CRON_SCHEDULE_JOB_CODE` (`job_code`), ADD KEY `IDX_SNSPFX_CRON_SCHEDULE_SCHEDULED_AT_STATUS` (`scheduled_at`,`status`);

ALTER TABLE `#__customer_address_entity`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_PARENT_ID` (`parent_id`);

ALTER TABLE `#__customer_address_entity_datetime`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CSTR_ADDR_ENTT_DTIME_ENTT_ID_ATTR_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DATETIME_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DATETIME_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CSTR_ADDR_ENTT_DTIME_ENTT_ID_ATTR_ID_VAL` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_address_entity_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CSTR_ADDR_ENTT_DEC_ENTT_ID_ATTR_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DECIMAL_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CSTR_ADDR_ENTT_DEC_ENTT_ID_ATTR_ID_VAL` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_address_entity_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ADDRESS_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_INT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_INT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CSTR_ADDR_ENTT_INT_ENTT_ID_ATTR_ID_VAL` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_address_entity_text`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ADDRESS_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_TEXT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_TEXT_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__customer_address_entity_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CSTR_ADDR_ENTT_VCHR_ENTT_ID_ATTR_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_VARCHAR_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ADDRESS_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CSTR_ADDR_ENTT_VCHR_ENTT_ID_ATTR_ID_VAL` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_eav_attribute`
 ADD PRIMARY KEY (`attribute_id`);

ALTER TABLE `#__customer_eav_attribute_website`
 ADD PRIMARY KEY (`attribute_id`,`website_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_EAV_ATTRIBUTE_WEBSITE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__customer_entity`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_EMAIL_WEBSITE_ID` (`email`,`website_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_EMAIL_WEBSITE_ID` (`email`,`website_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__customer_entity_datetime`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DATETIME_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DATETIME_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_entity_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DECIMAL_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_entity_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_INT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_INT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_entity_text`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_TEXT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_TEXT_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__customer_entity_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_CUSTOMER_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID` (`entity_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_VARCHAR_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_VALUE` (`entity_id`,`attribute_id`,`value`);

ALTER TABLE `#__customer_form_attribute`
 ADD PRIMARY KEY (`form_code`,`attribute_id`), ADD KEY `IDX_SNSPFX_CUSTOMER_FORM_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__customer_group`
 ADD PRIMARY KEY (`customer_group_id`);

ALTER TABLE `#__dataflow_batch`
 ADD PRIMARY KEY (`batch_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_BATCH_PROFILE_ID` (`profile_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_BATCH_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_BATCH_CREATED_AT` (`created_at`);

ALTER TABLE `#__dataflow_batch_export`
 ADD PRIMARY KEY (`batch_export_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_BATCH_EXPORT_BATCH_ID` (`batch_id`);

ALTER TABLE `#__dataflow_batch_import`
 ADD PRIMARY KEY (`batch_import_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_BATCH_IMPORT_BATCH_ID` (`batch_id`);

ALTER TABLE `#__dataflow_import_data`
 ADD PRIMARY KEY (`import_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_IMPORT_DATA_SESSION_ID` (`session_id`);

ALTER TABLE `#__dataflow_profile`
 ADD PRIMARY KEY (`profile_id`);

ALTER TABLE `#__dataflow_profile_history`
 ADD PRIMARY KEY (`history_id`), ADD KEY `IDX_SNSPFX_DATAFLOW_PROFILE_HISTORY_PROFILE_ID` (`profile_id`);

ALTER TABLE `#__dataflow_session`
 ADD PRIMARY KEY (`session_id`);

ALTER TABLE `#__design_change`
 ADD PRIMARY KEY (`design_change_id`), ADD KEY `IDX_SNSPFX_DESIGN_CHANGE_STORE_ID` (`store_id`);

ALTER TABLE `#__directory_country`
 ADD PRIMARY KEY (`country_id`);

ALTER TABLE `#__directory_country_format`
 ADD PRIMARY KEY (`country_format_id`), ADD UNIQUE KEY `UNQ_SNSPFX_DIRECTORY_COUNTRY_FORMAT_COUNTRY_ID_TYPE` (`country_id`,`type`);

ALTER TABLE `#__directory_country_region`
 ADD PRIMARY KEY (`region_id`), ADD KEY `IDX_SNSPFX_DIRECTORY_COUNTRY_REGION_COUNTRY_ID` (`country_id`);

ALTER TABLE `#__directory_country_region_name`
 ADD PRIMARY KEY (`locale`,`region_id`), ADD KEY `IDX_SNSPFX_DIRECTORY_COUNTRY_REGION_NAME_REGION_ID` (`region_id`);

ALTER TABLE `#__directory_currency_rate`
 ADD PRIMARY KEY (`currency_from`,`currency_to`), ADD KEY `IDX_SNSPFX_DIRECTORY_CURRENCY_RATE_CURRENCY_TO` (`currency_to`);

ALTER TABLE `#__downloadable_link`
 ADD PRIMARY KEY (`link_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PRODUCT_ID_SORT_ORDER` (`product_id`,`sort_order`);

ALTER TABLE `#__downloadable_link_price`
 ADD PRIMARY KEY (`price_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PRICE_LINK_ID` (`link_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__downloadable_link_purchased`
 ADD PRIMARY KEY (`purchased_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_ORDER_ITEM_ID` (`order_item_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_CUSTOMER_ID` (`customer_id`);

ALTER TABLE `#__downloadable_link_purchased_item`
 ADD PRIMARY KEY (`item_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_ITEM_LINK_HASH` (`link_hash`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_ITEM_ORDER_ITEM_ID` (`order_item_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_PURCHASED_ITEM_PURCHASED_ID` (`purchased_id`);

ALTER TABLE `#__downloadable_link_title`
 ADD PRIMARY KEY (`title_id`), ADD UNIQUE KEY `UNQ_SNSPFX_DOWNLOADABLE_LINK_TITLE_LINK_ID_STORE_ID` (`link_id`,`store_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_TITLE_LINK_ID` (`link_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_LINK_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__downloadable_sample`
 ADD PRIMARY KEY (`sample_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_SAMPLE_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__downloadable_sample_title`
 ADD PRIMARY KEY (`title_id`), ADD UNIQUE KEY `UNQ_SNSPFX_DOWNLOADABLE_SAMPLE_TITLE_SAMPLE_ID_STORE_ID` (`sample_id`,`store_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_SAMPLE_TITLE_SAMPLE_ID` (`sample_id`), ADD KEY `IDX_SNSPFX_DOWNLOADABLE_SAMPLE_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_attribute`
 ADD PRIMARY KEY (`attribute_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ATTRIBUTE_ENTITY_TYPE_ID_ATTRIBUTE_CODE` (`entity_type_id`,`attribute_code`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_ENTITY_TYPE_ID` (`entity_type_id`);

ALTER TABLE `#__eav_attribute_group`
 ADD PRIMARY KEY (`attribute_group_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ATTR_GROUP_ATTR_SET_ID_ATTR_GROUP_NAME` (`attribute_set_id`,`attribute_group_name`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_GROUP_ATTRIBUTE_SET_ID_SORT_ORDER` (`attribute_set_id`,`sort_order`);

ALTER TABLE `#__eav_attribute_label`
 ADD PRIMARY KEY (`attribute_label_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_LABEL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_LABEL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_LABEL_ATTRIBUTE_ID_STORE_ID` (`attribute_id`,`store_id`);

ALTER TABLE `#__eav_attribute_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_OPTION_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__eav_attribute_option_value`
 ADD PRIMARY KEY (`value_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_OPTION_VALUE_OPTION_ID` (`option_id`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_OPTION_VALUE_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_attribute_set`
 ADD PRIMARY KEY (`attribute_set_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ATTRIBUTE_SET_ENTITY_TYPE_ID_ATTRIBUTE_SET_NAME` (`entity_type_id`,`attribute_set_name`), ADD KEY `IDX_SNSPFX_EAV_ATTRIBUTE_SET_ENTITY_TYPE_ID_SORT_ORDER` (`entity_type_id`,`sort_order`);

ALTER TABLE `#__eav_entity`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_entity_attribute`
 ADD PRIMARY KEY (`entity_attribute_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_SET_ID_ATTRIBUTE_ID` (`attribute_set_id`,`attribute_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_GROUP_ID_ATTRIBUTE_ID` (`attribute_group_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_SET_ID_SORT_ORDER` (`attribute_set_id`,`sort_order`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__eav_entity_datetime`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_DATETIME_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DATETIME_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`);

ALTER TABLE `#__eav_entity_decimal`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_DECIMAL_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_DECIMAL_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`);

ALTER TABLE `#__eav_entity_int`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_INT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_INT_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`);

ALTER TABLE `#__eav_entity_store`
 ADD PRIMARY KEY (`entity_store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_STORE_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_entity_text`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_TEXT_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_TEXT_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_TEXT_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_TEXT_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_TEXT_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__eav_entity_type`
 ADD PRIMARY KEY (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_TYPE_ENTITY_TYPE_CODE` (`entity_type_code`);

ALTER TABLE `#__eav_entity_varchar`
 ADD PRIMARY KEY (`value_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_ENTITY_VARCHAR_ENTITY_ID_ATTRIBUTE_ID_STORE_ID` (`entity_id`,`attribute_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_ENTITY_TYPE_ID` (`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_ATTRIBUTE_ID` (`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_ATTRIBUTE_ID_VALUE` (`attribute_id`,`value`), ADD KEY `IDX_SNSPFX_EAV_ENTITY_VARCHAR_ENTITY_TYPE_ID_VALUE` (`entity_type_id`,`value`);

ALTER TABLE `#__eav_form_element`
 ADD PRIMARY KEY (`element_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_FORM_ELEMENT_TYPE_ID_ATTRIBUTE_ID` (`type_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_ELEMENT_TYPE_ID` (`type_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_ELEMENT_FIELDSET_ID` (`fieldset_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_ELEMENT_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__eav_form_fieldset`
 ADD PRIMARY KEY (`fieldset_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_FORM_FIELDSET_TYPE_ID_CODE` (`type_id`,`code`), ADD KEY `IDX_SNSPFX_EAV_FORM_FIELDSET_TYPE_ID` (`type_id`);

ALTER TABLE `#__eav_form_fieldset_label`
 ADD PRIMARY KEY (`fieldset_id`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_FIELDSET_LABEL_FIELDSET_ID` (`fieldset_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_FIELDSET_LABEL_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_form_type`
 ADD PRIMARY KEY (`type_id`), ADD UNIQUE KEY `UNQ_SNSPFX_EAV_FORM_TYPE_CODE_THEME_STORE_ID` (`code`,`theme`,`store_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_TYPE_STORE_ID` (`store_id`);

ALTER TABLE `#__eav_form_type_entity`
 ADD PRIMARY KEY (`type_id`,`entity_type_id`), ADD KEY `IDX_SNSPFX_EAV_FORM_TYPE_ENTITY_ENTITY_TYPE_ID` (`entity_type_id`);

ALTER TABLE `#__gift_message`
 ADD PRIMARY KEY (`gift_message_id`);

ALTER TABLE `#__importexport_importdata`
 ADD PRIMARY KEY (`id`);

ALTER TABLE `#__index_event`
 ADD PRIMARY KEY (`event_id`), ADD UNIQUE KEY `UNQ_SNSPFX_INDEX_EVENT_TYPE_ENTITY_ENTITY_PK` (`type`,`entity`,`entity_pk`);

ALTER TABLE `#__index_process`
 ADD PRIMARY KEY (`process_id`), ADD UNIQUE KEY `UNQ_SNSPFX_INDEX_PROCESS_INDEXER_CODE` (`indexer_code`);

ALTER TABLE `#__index_process_event`
 ADD PRIMARY KEY (`process_id`,`event_id`), ADD KEY `IDX_SNSPFX_INDEX_PROCESS_EVENT_EVENT_ID` (`event_id`);

ALTER TABLE `#__log_customer`
 ADD PRIMARY KEY (`log_id`), ADD KEY `IDX_SNSPFX_LOG_CUSTOMER_VISITOR_ID` (`visitor_id`);

ALTER TABLE `#__log_quote`
 ADD PRIMARY KEY (`quote_id`);

ALTER TABLE `#__log_summary`
 ADD PRIMARY KEY (`summary_id`);

ALTER TABLE `#__log_summary_type`
 ADD PRIMARY KEY (`type_id`);

ALTER TABLE `#__log_url`
 ADD KEY `IDX_SNSPFX_LOG_URL_VISITOR_ID` (`visitor_id`), ADD KEY `url_id` (`url_id`);

ALTER TABLE `#__log_url_info`
 ADD PRIMARY KEY (`url_id`);

ALTER TABLE `#__log_visitor`
 ADD PRIMARY KEY (`visitor_id`);

ALTER TABLE `#__log_visitor_info`
 ADD PRIMARY KEY (`visitor_id`);

ALTER TABLE `#__log_visitor_online`
 ADD PRIMARY KEY (`visitor_id`), ADD KEY `IDX_SNSPFX_LOG_VISITOR_ONLINE_VISITOR_TYPE` (`visitor_type`), ADD KEY `IDX_SNSPFX_LOG_VISITOR_ONLINE_FIRST_VISIT_AT_LAST_VISIT_AT` (`first_visit_at`,`last_visit_at`), ADD KEY `IDX_SNSPFX_LOG_VISITOR_ONLINE_CUSTOMER_ID` (`customer_id`);

ALTER TABLE `#__newsletter_problem`
 ADD PRIMARY KEY (`problem_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_PROBLEM_SUBSCRIBER_ID` (`subscriber_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_PROBLEM_QUEUE_ID` (`queue_id`);

ALTER TABLE `#__newsletter_queue`
 ADD PRIMARY KEY (`queue_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_QUEUE_TEMPLATE_ID` (`template_id`);

ALTER TABLE `#__newsletter_queue_link`
 ADD PRIMARY KEY (`queue_link_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_QUEUE_LINK_SUBSCRIBER_ID` (`subscriber_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_QUEUE_LINK_QUEUE_ID` (`queue_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_QUEUE_LINK_QUEUE_ID_LETTER_SENT_AT` (`queue_id`,`letter_sent_at`);

ALTER TABLE `#__newsletter_queue_store_link`
 ADD PRIMARY KEY (`queue_id`,`store_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_QUEUE_STORE_LINK_STORE_ID` (`store_id`);

ALTER TABLE `#__newsletter_subscriber`
 ADD PRIMARY KEY (`subscriber_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_SUBSCRIBER_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_SUBSCRIBER_STORE_ID` (`store_id`);

ALTER TABLE `#__newsletter_template`
 ADD PRIMARY KEY (`template_id`), ADD KEY `IDX_SNSPFX_NEWSLETTER_TEMPLATE_TEMPLATE_ACTUAL` (`template_actual`), ADD KEY `IDX_SNSPFX_NEWSLETTER_TEMPLATE_ADDED_AT` (`added_at`), ADD KEY `IDX_SNSPFX_NEWSLETTER_TEMPLATE_MODIFIED_AT` (`modified_at`);

ALTER TABLE `#__oauth_consumer`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_OAUTH_CONSUMER_KEY` (`key`), ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_OAUTH_CONSUMER_SECRET` (`secret`), ADD KEY `IDX_SNSPFX_OAUTH_CONSUMER_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_OAUTH_CONSUMER_UPDATED_AT` (`updated_at`);

ALTER TABLE `#__oauth_nonce`
 ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_OAUTH_NONCE_NONCE` (`nonce`);

ALTER TABLE `#__oauth_token`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SNSPFX_OAUTH_TOKEN_TOKEN` (`token`), ADD KEY `IDX_SNSPFX_SNSPFX_OAUTH_TOKEN_CONSUMER_ID` (`consumer_id`), ADD KEY `FK_SNSPFX_OAUTH_TOKEN_ADMIN_ID_SNSPFX_SNSPFX_ADMIN_USER_USER_ID` (`admin_id`), ADD KEY `FK_SNSPFX_OAUTH_TOKEN_CSTR_ID_SNSPFX_SNSPFX_CSTR_ENTT_ENTT_ID` (`customer_id`);

ALTER TABLE `#__paypal_cert`
 ADD PRIMARY KEY (`cert_id`), ADD KEY `IDX_SNSPFX_PAYPAL_CERT_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__paypal_payment_transaction`
 ADD PRIMARY KEY (`transaction_id`), ADD UNIQUE KEY `UNQ_SNSPFX_PAYPAL_PAYMENT_TRANSACTION_TXN_ID` (`txn_id`);

ALTER TABLE `#__paypal_settlement_report`
 ADD PRIMARY KEY (`report_id`), ADD UNIQUE KEY `UNQ_SNSPFX_PAYPAL_SETTLEMENT_REPORT_REPORT_DATE_ACCOUNT_ID` (`report_date`,`account_id`);

ALTER TABLE `#__paypal_settlement_report_row`
 ADD PRIMARY KEY (`row_id`), ADD KEY `IDX_SNSPFX_PAYPAL_SETTLEMENT_REPORT_ROW_REPORT_ID` (`report_id`);

ALTER TABLE `#__persistent_session`
 ADD PRIMARY KEY (`persistent_id`), ADD UNIQUE KEY `IDX_SNSPFX_PERSISTENT_SESSION_KEY` (`key`), ADD UNIQUE KEY `IDX_SNSPFX_PERSISTENT_SESSION_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_PERSISTENT_SESSION_UPDATED_AT` (`updated_at`), ADD KEY `FK_SNSPFX_PERSISTENT_SESS_WS_ID_SNSPFX_CORE_WS_WS_ID` (`website_id`);

ALTER TABLE `#__poll`
 ADD PRIMARY KEY (`poll_id`), ADD KEY `IDX_SNSPFX_POLL_STORE_ID` (`store_id`);

ALTER TABLE `#__poll_answer`
 ADD PRIMARY KEY (`answer_id`), ADD KEY `IDX_SNSPFX_POLL_ANSWER_POLL_ID` (`poll_id`);

ALTER TABLE `#__poll_store`
 ADD PRIMARY KEY (`poll_id`,`store_id`), ADD KEY `IDX_SNSPFX_POLL_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__poll_vote`
 ADD PRIMARY KEY (`vote_id`), ADD KEY `IDX_SNSPFX_POLL_VOTE_POLL_ANSWER_ID` (`poll_answer_id`);

ALTER TABLE `#__product_alert_price`
 ADD PRIMARY KEY (`alert_price_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_PRICE_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_PRICE_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_PRICE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__product_alert_stock`
 ADD PRIMARY KEY (`alert_stock_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_STOCK_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_STOCK_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_PRODUCT_ALERT_STOCK_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__rating`
 ADD PRIMARY KEY (`rating_id`), ADD UNIQUE KEY `UNQ_SNSPFX_RATING_RATING_CODE` (`rating_code`), ADD KEY `IDX_SNSPFX_RATING_ENTITY_ID` (`entity_id`);

ALTER TABLE `#__rating_entity`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_RATING_ENTITY_ENTITY_CODE` (`entity_code`);

ALTER TABLE `#__rating_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `IDX_SNSPFX_RATING_OPTION_RATING_ID` (`rating_id`);

ALTER TABLE `#__rating_option_vote`
 ADD PRIMARY KEY (`vote_id`), ADD KEY `IDX_SNSPFX_RATING_OPTION_VOTE_OPTION_ID` (`option_id`), ADD KEY `FK_SNSPFX_RATING_OPTION_VOTE_REVIEW_ID_SNSPFX_REVIEW_REVIEW_ID` (`review_id`);

ALTER TABLE `#__rating_option_vote_aggregated`
 ADD PRIMARY KEY (`primary_id`), ADD KEY `IDX_SNSPFX_RATING_OPTION_VOTE_AGGREGATED_RATING_ID` (`rating_id`), ADD KEY `IDX_SNSPFX_RATING_OPTION_VOTE_AGGREGATED_STORE_ID` (`store_id`);

ALTER TABLE `#__rating_store`
 ADD PRIMARY KEY (`rating_id`,`store_id`), ADD KEY `IDX_SNSPFX_RATING_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__rating_title`
 ADD PRIMARY KEY (`rating_id`,`store_id`), ADD KEY `IDX_SNSPFX_RATING_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__report_compared_product_index`
 ADD PRIMARY KEY (`index_id`), ADD UNIQUE KEY `UNQ_SNSPFX_REPORT_COMPARED_PRODUCT_INDEX_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`), ADD UNIQUE KEY `UNQ_SNSPFX_REPORT_COMPARED_PRODUCT_INDEX_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`), ADD KEY `IDX_SNSPFX_REPORT_COMPARED_PRODUCT_INDEX_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REPORT_COMPARED_PRODUCT_INDEX_ADDED_AT` (`added_at`), ADD KEY `IDX_SNSPFX_REPORT_COMPARED_PRODUCT_INDEX_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__report_event`
 ADD PRIMARY KEY (`event_id`), ADD KEY `IDX_SNSPFX_REPORT_EVENT_EVENT_TYPE_ID` (`event_type_id`), ADD KEY `IDX_SNSPFX_REPORT_EVENT_SUBJECT_ID` (`subject_id`), ADD KEY `IDX_SNSPFX_REPORT_EVENT_OBJECT_ID` (`object_id`), ADD KEY `IDX_SNSPFX_REPORT_EVENT_SUBTYPE` (`subtype`), ADD KEY `IDX_SNSPFX_REPORT_EVENT_STORE_ID` (`store_id`);

ALTER TABLE `#__report_event_types`
 ADD PRIMARY KEY (`event_type_id`);

ALTER TABLE `#__report_viewed_product_aggregated_daily`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_REPORT_VIEWED_PRD_AGGRED_DAILY_PERIOD_STORE_ID_PRD_ID` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_DAILY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_DAILY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__report_viewed_product_aggregated_monthly`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `FCE20B4B223F9CB42221A9B67C466C74` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_MONTHLY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_MONTHLY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__report_viewed_product_aggregated_yearly`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `62A75102EFBE4E3AE77199949BEA7F42` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_YEARLY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_AGGREGATED_YEARLY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__report_viewed_product_index`
 ADD PRIMARY KEY (`index_id`), ADD UNIQUE KEY `UNQ_SNSPFX_REPORT_VIEWED_PRODUCT_INDEX_VISITOR_ID_PRODUCT_ID` (`visitor_id`,`product_id`), ADD UNIQUE KEY `UNQ_SNSPFX_REPORT_VIEWED_PRODUCT_INDEX_CUSTOMER_ID_PRODUCT_ID` (`customer_id`,`product_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_INDEX_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_INDEX_ADDED_AT` (`added_at`), ADD KEY `IDX_SNSPFX_REPORT_VIEWED_PRODUCT_INDEX_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__review`
 ADD PRIMARY KEY (`review_id`), ADD KEY `IDX_SNSPFX_REVIEW_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_REVIEW_STATUS_ID` (`status_id`), ADD KEY `IDX_SNSPFX_REVIEW_ENTITY_PK_VALUE` (`entity_pk_value`);

ALTER TABLE `#__review_detail`
 ADD PRIMARY KEY (`detail_id`), ADD KEY `IDX_SNSPFX_REVIEW_DETAIL_REVIEW_ID` (`review_id`), ADD KEY `IDX_SNSPFX_REVIEW_DETAIL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_REVIEW_DETAIL_CUSTOMER_ID` (`customer_id`);

ALTER TABLE `#__review_entity`
 ADD PRIMARY KEY (`entity_id`);

ALTER TABLE `#__review_entity_summary`
 ADD PRIMARY KEY (`primary_id`), ADD KEY `IDX_SNSPFX_REVIEW_ENTITY_SUMMARY_STORE_ID` (`store_id`);

ALTER TABLE `#__review_status`
 ADD PRIMARY KEY (`status_id`);

ALTER TABLE `#__review_store`
 ADD PRIMARY KEY (`review_id`,`store_id`), ADD KEY `IDX_SNSPFX_REVIEW_STORE_STORE_ID` (`store_id`);

ALTER TABLE `#__salesrule`
 ADD PRIMARY KEY (`rule_id`), ADD KEY `IDX_SNSPFX_SALESRULE_IS_ACTIVE_SORT_ORDER_TO_DATE_FROM_DATE` (`is_active`,`sort_order`,`to_date`,`from_date`);

ALTER TABLE `#__salesrule_coupon`
 ADD PRIMARY KEY (`coupon_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALESRULE_COUPON_CODE` (`code`), ADD UNIQUE KEY `UNQ_SNSPFX_SALESRULE_COUPON_RULE_ID_IS_PRIMARY` (`rule_id`,`is_primary`), ADD KEY `IDX_SNSPFX_SALESRULE_COUPON_RULE_ID` (`rule_id`);

ALTER TABLE `#__salesrule_coupon_usage`
 ADD PRIMARY KEY (`coupon_id`,`customer_id`), ADD KEY `IDX_SNSPFX_SALESRULE_COUPON_USAGE_COUPON_ID` (`coupon_id`), ADD KEY `IDX_SNSPFX_SALESRULE_COUPON_USAGE_CUSTOMER_ID` (`customer_id`);

ALTER TABLE `#__salesrule_customer`
 ADD PRIMARY KEY (`rule_customer_id`), ADD KEY `IDX_SNSPFX_SALESRULE_CUSTOMER_RULE_ID_CUSTOMER_ID` (`rule_id`,`customer_id`), ADD KEY `IDX_SNSPFX_SALESRULE_CUSTOMER_CUSTOMER_ID_RULE_ID` (`customer_id`,`rule_id`);

ALTER TABLE `#__salesrule_customer_group`
 ADD PRIMARY KEY (`rule_id`,`customer_group_id`), ADD KEY `IDX_SNSPFX_SALESRULE_CUSTOMER_GROUP_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_SALESRULE_CUSTOMER_GROUP_CUSTOMER_GROUP_ID` (`customer_group_id`);

ALTER TABLE `#__salesrule_label`
 ADD PRIMARY KEY (`label_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALESRULE_LABEL_RULE_ID_STORE_ID` (`rule_id`,`store_id`), ADD KEY `IDX_SNSPFX_SALESRULE_LABEL_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALESRULE_LABEL_RULE_ID` (`rule_id`);

ALTER TABLE `#__salesrule_product_attribute`
 ADD PRIMARY KEY (`rule_id`,`website_id`,`customer_group_id`,`attribute_id`), ADD KEY `IDX_SNSPFX_SALESRULE_PRODUCT_ATTRIBUTE_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_SALESRULE_PRODUCT_ATTRIBUTE_CUSTOMER_GROUP_ID` (`customer_group_id`), ADD KEY `IDX_SNSPFX_SALESRULE_PRODUCT_ATTRIBUTE_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__salesrule_website`
 ADD PRIMARY KEY (`rule_id`,`website_id`), ADD KEY `IDX_SNSPFX_SALESRULE_WEBSITE_RULE_ID` (`rule_id`), ADD KEY `IDX_SNSPFX_SALESRULE_WEBSITE_WEBSITE_ID` (`website_id`);

ALTER TABLE `#__sales_bestsellers_aggregated_daily`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_BESTSELLERS_AGGRED_DAILY_PERIOD_STORE_ID_PRD_ID` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_DAILY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_DAILY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__sales_bestsellers_aggregated_monthly`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `976DDFDBFAF946896E089FFF1C40FF83` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_MONTHLY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_MONTHLY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__sales_bestsellers_aggregated_yearly`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `6C6D12CEADE131E2678F036621BB5295` (`period`,`store_id`,`product_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_YEARLY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_BESTSELLERS_AGGREGATED_YEARLY_PRODUCT_ID` (`product_id`);

ALTER TABLE `#__sales_billing_agreement`
 ADD PRIMARY KEY (`agreement_id`), ADD KEY `IDX_SNSPFX_SALES_BILLING_AGREEMENT_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_SALES_BILLING_AGREEMENT_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_billing_agreement_order`
 ADD PRIMARY KEY (`agreement_id`,`order_id`), ADD KEY `IDX_SNSPFX_SALES_BILLING_AGREEMENT_ORDER_ORDER_ID` (`order_id`);

ALTER TABLE `#__sales_flat_creditmemo`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_CREDITMEMO_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_CREDITMEMO_STATUS` (`creditmemo_status`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_STATE` (`state`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_CREATED_AT` (`created_at`);

ALTER TABLE `#__sales_flat_creditmemo_comment`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_COMMENT_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_COMMENT_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_creditmemo_grid`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_GRAND_TOTAL` (`grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_BASE_GRAND_TOTAL` (`base_grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_CREDITMEMO_STATUS` (`creditmemo_status`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_STATE` (`state`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_ORDER_INCREMENT_ID` (`order_increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_ORDER_CREATED_AT` (`order_created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_GRID_BILLING_NAME` (`billing_name`);

ALTER TABLE `#__sales_flat_creditmemo_item`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_CREDITMEMO_ITEM_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_invoice`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_INVOICE_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRAND_TOTAL` (`grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_STATE` (`state`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_CREATED_AT` (`created_at`);

ALTER TABLE `#__sales_flat_invoice_comment`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_COMMENT_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_COMMENT_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_invoice_grid`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_INVOICE_GRID_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_GRAND_TOTAL` (`grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_STATE` (`state`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_ORDER_INCREMENT_ID` (`order_increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_ORDER_CREATED_AT` (`order_created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_GRID_BILLING_NAME` (`billing_name`);

ALTER TABLE `#__sales_flat_invoice_item`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_INVOICE_ITEM_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_order`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_ORDER_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_STATUS` (`status`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_STATE` (`state`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_EXT_ORDER_ID` (`ext_order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_QUOTE_ID` (`quote_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_UPDATED_AT` (`updated_at`);

ALTER TABLE `#__sales_flat_order_address`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_ADDRESS_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_order_grid`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_ORDER_GRID_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_STATUS` (`status`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_BASE_GRAND_TOTAL` (`base_grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_BASE_TOTAL_PAID` (`base_total_paid`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_GRAND_TOTAL` (`grand_total`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_TOTAL_PAID` (`total_paid`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_SHIPPING_NAME` (`shipping_name`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_BILLING_NAME` (`billing_name`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_GRID_UPDATED_AT` (`updated_at`);

ALTER TABLE `#__sales_flat_order_item`
 ADD PRIMARY KEY (`item_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_ITEM_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_ITEM_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_flat_order_payment`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_PAYMENT_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_order_status_history`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_STATUS_HISTORY_PARENT_ID` (`parent_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_ORDER_STATUS_HISTORY_CREATED_AT` (`created_at`);

ALTER TABLE `#__sales_flat_quote`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_CUSTOMER_ID_STORE_ID_IS_ACTIVE` (`customer_id`,`store_id`,`is_active`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_flat_quote_address`
 ADD PRIMARY KEY (`address_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ADDRESS_QUOTE_ID` (`quote_id`);

ALTER TABLE `#__sales_flat_quote_address_item`
 ADD PRIMARY KEY (`address_item_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ADDRESS_ITEM_QUOTE_ADDRESS_ID` (`quote_address_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ADDRESS_ITEM_PARENT_ITEM_ID` (`parent_item_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ADDRESS_ITEM_QUOTE_ITEM_ID` (`quote_item_id`);

ALTER TABLE `#__sales_flat_quote_item`
 ADD PRIMARY KEY (`item_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ITEM_PARENT_ITEM_ID` (`parent_item_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ITEM_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ITEM_QUOTE_ID` (`quote_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ITEM_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_flat_quote_item_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_ITEM_OPTION_ITEM_ID` (`item_id`);

ALTER TABLE `#__sales_flat_quote_payment`
 ADD PRIMARY KEY (`payment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_PAYMENT_QUOTE_ID` (`quote_id`);

ALTER TABLE `#__sales_flat_quote_shipping_rate`
 ADD PRIMARY KEY (`rate_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_QUOTE_SHIPPING_RATE_ADDRESS_ID` (`address_id`);

ALTER TABLE `#__sales_flat_shipment`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_SHIPMENT_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_TOTAL_QTY` (`total_qty`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_UPDATED_AT` (`updated_at`);

ALTER TABLE `#__sales_flat_shipment_comment`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_COMMENT_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_COMMENT_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_shipment_grid`
 ADD PRIMARY KEY (`entity_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_FLAT_SHIPMENT_GRID_INCREMENT_ID` (`increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_TOTAL_QTY` (`total_qty`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_SHIPMENT_STATUS` (`shipment_status`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_ORDER_INCREMENT_ID` (`order_increment_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_CREATED_AT` (`created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_ORDER_CREATED_AT` (`order_created_at`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_GRID_SHIPPING_NAME` (`shipping_name`);

ALTER TABLE `#__sales_flat_shipment_item`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_ITEM_PARENT_ID` (`parent_id`);

ALTER TABLE `#__sales_flat_shipment_track`
 ADD PRIMARY KEY (`entity_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_TRACK_PARENT_ID` (`parent_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_TRACK_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_FLAT_SHIPMENT_TRACK_CREATED_AT` (`created_at`);

ALTER TABLE `#__sales_invoiced_aggregated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_INVOICED_AGGRED_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_INVOICED_AGGREGATED_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_invoiced_aggregated_order`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_INVOICED_AGGRED_ORDER_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_INVOICED_AGGREGATED_ORDER_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_order_aggregated_created`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_ORDER_AGGRED_CREATED_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_ORDER_AGGREGATED_CREATED_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_order_aggregated_updated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_ORDER_AGGRED_UPDATED_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_ORDER_AGGREGATED_UPDATED_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_order_status`
 ADD PRIMARY KEY (`status`);

ALTER TABLE `#__sales_order_status_label`
 ADD PRIMARY KEY (`status`,`store_id`), ADD KEY `IDX_SNSPFX_SALES_ORDER_STATUS_LABEL_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_order_status_state`
 ADD PRIMARY KEY (`status`,`state`);

ALTER TABLE `#__sales_order_tax`
 ADD PRIMARY KEY (`tax_id`), ADD KEY `IDX_SNSPFX_SALES_ORDER_TAX_ORDER_ID_PRIORITY_POSITION` (`order_id`,`priority`,`position`);

ALTER TABLE `#__sales_order_tax_item`
 ADD PRIMARY KEY (`tax_item_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_ORDER_TAX_ITEM_TAX_ID_ITEM_ID` (`tax_id`,`item_id`), ADD KEY `IDX_SNSPFX_SALES_ORDER_TAX_ITEM_TAX_ID` (`tax_id`), ADD KEY `IDX_SNSPFX_SALES_ORDER_TAX_ITEM_ITEM_ID` (`item_id`);

ALTER TABLE `#__sales_payment_transaction`
 ADD PRIMARY KEY (`transaction_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_PAYMENT_TRANSACTION_ORDER_ID_PAYMENT_ID_TXN_ID` (`order_id`,`payment_id`,`txn_id`), ADD KEY `IDX_SNSPFX_SALES_PAYMENT_TRANSACTION_ORDER_ID` (`order_id`), ADD KEY `IDX_SNSPFX_SALES_PAYMENT_TRANSACTION_PARENT_ID` (`parent_id`), ADD KEY `IDX_SNSPFX_SALES_PAYMENT_TRANSACTION_PAYMENT_ID` (`payment_id`);

ALTER TABLE `#__sales_recurring_profile`
 ADD PRIMARY KEY (`profile_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_RECURRING_PROFILE_INTERNAL_REFERENCE_ID` (`internal_reference_id`), ADD KEY `IDX_SNSPFX_SALES_RECURRING_PROFILE_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_SALES_RECURRING_PROFILE_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_recurring_profile_order`
 ADD PRIMARY KEY (`link_id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_RECURRING_PROFILE_ORDER_PROFILE_ID_ORDER_ID` (`profile_id`,`order_id`), ADD KEY `IDX_SNSPFX_SALES_RECURRING_PROFILE_ORDER_ORDER_ID` (`order_id`);

ALTER TABLE `#__sales_refunded_aggregated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_REFUNDED_AGGRED_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_REFUNDED_AGGREGATED_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_refunded_aggregated_order`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `UNQ_SNSPFX_SALES_REFUNDED_AGGRED_ORDER_PERIOD_STORE_ID_ORDER_STS` (`period`,`store_id`,`order_status`), ADD KEY `IDX_SNSPFX_SALES_REFUNDED_AGGREGATED_ORDER_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_shipping_aggregated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `70B806EAEB724E6E2E9F8DAB33EEE5A5` (`period`,`store_id`,`order_status`,`shipping_description`), ADD KEY `IDX_SNSPFX_SALES_SHIPPING_AGGREGATED_STORE_ID` (`store_id`);

ALTER TABLE `#__sales_shipping_aggregated_order`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `3E6DBE5FF7CD5D5C81F7DF4255A04B68` (`period`,`store_id`,`order_status`,`shipping_description`), ADD KEY `IDX_SNSPFX_SALES_SHIPPING_AGGREGATED_ORDER_STORE_ID` (`store_id`);

ALTER TABLE `#__sendfriend_log`
 ADD PRIMARY KEY (`log_id`), ADD KEY `IDX_SNSPFX_SENDFRIEND_LOG_IP` (`ip`), ADD KEY `IDX_SNSPFX_SENDFRIEND_LOG_TIME` (`time`);

ALTER TABLE `#__shipping_tablerate`
 ADD PRIMARY KEY (`pk`), ADD UNIQUE KEY `3B9567DF26BCD3F70DA9BD2629C8B898` (`website_id`,`dest_country_id`,`dest_region_id`,`dest_zip`,`condition_name`,`condition_value`);

ALTER TABLE `#__sitemap`
 ADD PRIMARY KEY (`sitemap_id`), ADD KEY `IDX_SNSPFX_SITEMAP_STORE_ID` (`store_id`);

ALTER TABLE `#__tag`
 ADD PRIMARY KEY (`tag_id`), ADD KEY `FK_SNSPFX_TAG_FIRST_CUSTOMER_ID_SNSPFX_CUSTOMER_ENTITY_ENTITY_ID` (`first_customer_id`), ADD KEY `FK_SNSPFX_TAG_FIRST_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` (`first_store_id`);

ALTER TABLE `#__tag_properties`
 ADD PRIMARY KEY (`tag_id`,`store_id`), ADD KEY `IDX_SNSPFX_TAG_PROPERTIES_STORE_ID` (`store_id`);

ALTER TABLE `#__tag_relation`
 ADD PRIMARY KEY (`tag_relation_id`), ADD UNIQUE KEY `UNQ_SNSPFX_TAG_RELATION_TAG_ID_CUSTOMER_ID_PRODUCT_ID_STORE_ID` (`tag_id`,`customer_id`,`product_id`,`store_id`), ADD KEY `IDX_SNSPFX_TAG_RELATION_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_TAG_RELATION_TAG_ID` (`tag_id`), ADD KEY `IDX_SNSPFX_TAG_RELATION_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_TAG_RELATION_STORE_ID` (`store_id`);

ALTER TABLE `#__tag_summary`
 ADD PRIMARY KEY (`tag_id`,`store_id`), ADD KEY `IDX_SNSPFX_TAG_SUMMARY_STORE_ID` (`store_id`), ADD KEY `IDX_SNSPFX_TAG_SUMMARY_TAG_ID` (`tag_id`);

ALTER TABLE `#__tax_calculation`
 ADD PRIMARY KEY (`tax_calculation_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_TAX_CALCULATION_RULE_ID` (`tax_calculation_rule_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_TAX_CALCULATION_RATE_ID` (`tax_calculation_rate_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_CUSTOMER_TAX_CLASS_ID` (`customer_tax_class_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_PRODUCT_TAX_CLASS_ID` (`product_tax_class_id`), ADD KEY `365575026CF456E9339274CF24EA1816` (`tax_calculation_rate_id`,`customer_tax_class_id`,`product_tax_class_id`);

ALTER TABLE `#__tax_calculation_rate`
 ADD PRIMARY KEY (`tax_calculation_rate_id`), ADD KEY `1C1FA15BBF32297789804A892B7DEA73` (`tax_country_id`,`tax_region_id`,`tax_postcode`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_RATE_CODE` (`code`), ADD KEY `7AFF64852CE70D28D0C77F42FD856250` (`tax_calculation_rate_id`,`tax_country_id`,`tax_region_id`,`zip_is_range`,`tax_postcode`);

ALTER TABLE `#__tax_calculation_rate_title`
 ADD PRIMARY KEY (`tax_calculation_rate_title_id`), ADD KEY `IDX_SNSPFX_TAX_CALC_RATE_TTL_TAX_CALC_RATE_ID_STORE_ID` (`tax_calculation_rate_id`,`store_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_RATE_TITLE_TAX_CALCULATION_RATE_ID` (`tax_calculation_rate_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_RATE_TITLE_STORE_ID` (`store_id`);

ALTER TABLE `#__tax_calculation_rule`
 ADD PRIMARY KEY (`tax_calculation_rule_id`), ADD KEY `IDX_SNSPFX_TAX_CALC_RULE_PRIORITY_POSITION_TAX_CALC_RULE_ID` (`priority`,`position`,`tax_calculation_rule_id`), ADD KEY `IDX_SNSPFX_TAX_CALCULATION_RULE_CODE` (`code`);

ALTER TABLE `#__tax_class`
 ADD PRIMARY KEY (`class_id`);

ALTER TABLE `#__tax_order_aggregated_created`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `4F3AA624951CBA1B8C791C59C9F1D849` (`period`,`store_id`,`code`,`percent`,`order_status`), ADD KEY `IDX_SNSPFX_TAX_ORDER_AGGREGATED_CREATED_STORE_ID` (`store_id`);

ALTER TABLE `#__tax_order_aggregated_updated`
 ADD PRIMARY KEY (`id`), ADD UNIQUE KEY `C680CBB88DE9139F17E64DE9767D4E3C` (`period`,`store_id`,`code`,`percent`,`order_status`), ADD KEY `IDX_SNSPFX_TAX_ORDER_AGGREGATED_UPDATED_STORE_ID` (`store_id`);

ALTER TABLE `#__weee_discount`
 ADD KEY `IDX_SNSPFX_WEEE_DISCOUNT_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_WEEE_DISCOUNT_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_WEEE_DISCOUNT_CUSTOMER_GROUP_ID` (`customer_group_id`);

ALTER TABLE `#__weee_tax`
 ADD PRIMARY KEY (`value_id`), ADD KEY `IDX_SNSPFX_WEEE_TAX_WEBSITE_ID` (`website_id`), ADD KEY `IDX_SNSPFX_WEEE_TAX_ENTITY_ID` (`entity_id`), ADD KEY `IDX_SNSPFX_WEEE_TAX_COUNTRY` (`country`), ADD KEY `IDX_SNSPFX_WEEE_TAX_ATTRIBUTE_ID` (`attribute_id`);

ALTER TABLE `#__widget`
 ADD PRIMARY KEY (`widget_id`), ADD KEY `IDX_SNSPFX_WIDGET_WIDGET_CODE` (`widget_code`);

ALTER TABLE `#__widget_instance`
 ADD PRIMARY KEY (`instance_id`);

ALTER TABLE `#__widget_instance_page`
 ADD PRIMARY KEY (`page_id`), ADD KEY `IDX_SNSPFX_WIDGET_INSTANCE_PAGE_INSTANCE_ID` (`instance_id`);

ALTER TABLE `#__widget_instance_page_layout`
 ADD UNIQUE KEY `UNQ_SNSPFX_WIDGET_INSTANCE_PAGE_LAYOUT_LAYOUT_UPDATE_ID_PAGE_ID` (`layout_update_id`,`page_id`), ADD KEY `IDX_SNSPFX_WIDGET_INSTANCE_PAGE_LAYOUT_PAGE_ID` (`page_id`), ADD KEY `IDX_SNSPFX_WIDGET_INSTANCE_PAGE_LAYOUT_LAYOUT_UPDATE_ID` (`layout_update_id`);

ALTER TABLE `#__wishlist`
 ADD PRIMARY KEY (`wishlist_id`), ADD UNIQUE KEY `UNQ_SNSPFX_WISHLIST_CUSTOMER_ID` (`customer_id`), ADD KEY `IDX_SNSPFX_WISHLIST_SHARED` (`shared`);

ALTER TABLE `#__wishlist_item`
 ADD PRIMARY KEY (`wishlist_item_id`), ADD KEY `IDX_SNSPFX_WISHLIST_ITEM_WISHLIST_ID` (`wishlist_id`), ADD KEY `IDX_SNSPFX_WISHLIST_ITEM_PRODUCT_ID` (`product_id`), ADD KEY `IDX_SNSPFX_WISHLIST_ITEM_STORE_ID` (`store_id`);

ALTER TABLE `#__wishlist_item_option`
 ADD PRIMARY KEY (`option_id`), ADD KEY `FK_3DE126D84316732A74B16C2D50C57B53` (`wishlist_item_id`);


ALTER TABLE `#__adminnotification_inbox`
MODIFY `notification_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Notification id',AUTO_INCREMENT=94;
ALTER TABLE `#__admin_assert`
MODIFY `assert_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Assert ID';
ALTER TABLE `#__admin_role`
MODIFY `role_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Role ID',AUTO_INCREMENT=4;
ALTER TABLE `#__admin_rule`
MODIFY `rule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule ID',AUTO_INCREMENT=2;
ALTER TABLE `#__admin_user`
MODIFY `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'User ID',AUTO_INCREMENT=2;
ALTER TABLE `#__api2_acl_attribute`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID';
ALTER TABLE `#__api2_acl_role`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',AUTO_INCREMENT=3;
ALTER TABLE `#__api2_acl_rule`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID';
ALTER TABLE `#__api_assert`
MODIFY `assert_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Assert id';
ALTER TABLE `#__api_role`
MODIFY `role_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Role id';
ALTER TABLE `#__api_rule`
MODIFY `rule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Api rule Id';
ALTER TABLE `#__api_user`
MODIFY `user_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'User id';
ALTER TABLE `#__aw_blog`
MODIFY `post_id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=9;
ALTER TABLE `#__aw_blog_cat`
MODIFY `cat_id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=2;
ALTER TABLE `#__aw_blog_comment`
MODIFY `comment_id` int(11) unsigned NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
ALTER TABLE `#__aw_blog_tags`
MODIFY `id` int(11) NOT NULL AUTO_INCREMENT,AUTO_INCREMENT=3;
ALTER TABLE `#__cataloginventory_stock`
MODIFY `stock_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Stock Id',AUTO_INCREMENT=2;
ALTER TABLE `#__cataloginventory_stock_item`
MODIFY `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item Id',AUTO_INCREMENT=50;
ALTER TABLE `#__catalogrule`
MODIFY `rule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Id';
ALTER TABLE `#__catalogrule_product`
MODIFY `rule_product_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product Id';
ALTER TABLE `#__catalogrule_product_price`
MODIFY `rule_product_price_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Product PriceId';
ALTER TABLE `#__catalogsearch_fulltext`
MODIFY `fulltext_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',AUTO_INCREMENT=4676;
ALTER TABLE `#__catalogsearch_query`
MODIFY `query_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Query ID',AUTO_INCREMENT=17;
ALTER TABLE `#__catalog_category_entity`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',AUTO_INCREMENT=59;
ALTER TABLE `#__catalog_category_entity_datetime`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=35;
ALTER TABLE `#__catalog_category_entity_decimal`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=57;
ALTER TABLE `#__catalog_category_entity_int`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=311;
ALTER TABLE `#__catalog_category_entity_text`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=801;
ALTER TABLE `#__catalog_category_entity_varchar`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=1206;
ALTER TABLE `#__catalog_compare_item`
MODIFY `catalog_compare_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Compare Item ID',AUTO_INCREMENT=3;
ALTER TABLE `#__catalog_product_bundle_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Id',AUTO_INCREMENT=9;
ALTER TABLE `#__catalog_product_bundle_option_value`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=21;
ALTER TABLE `#__catalog_product_bundle_selection`
MODIFY `selection_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Selection Id',AUTO_INCREMENT=25;
ALTER TABLE `#__catalog_product_entity`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID',AUTO_INCREMENT=50;
ALTER TABLE `#__catalog_product_entity_datetime`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=645;
ALTER TABLE `#__catalog_product_entity_decimal`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=351;
ALTER TABLE `#__catalog_product_entity_gallery`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID';
ALTER TABLE `#__catalog_product_entity_group_price`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID';
ALTER TABLE `#__catalog_product_entity_int`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=316;
ALTER TABLE `#__catalog_product_entity_media_gallery`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=203;
ALTER TABLE `#__catalog_product_entity_text`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=344;
ALTER TABLE `#__catalog_product_entity_tier_price`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID';
ALTER TABLE `#__catalog_product_entity_varchar`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=1834;
ALTER TABLE `#__catalog_product_link`
MODIFY `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',AUTO_INCREMENT=2327;
ALTER TABLE `#__catalog_product_link_attribute`
MODIFY `product_link_attribute_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product Link Attribute ID',AUTO_INCREMENT=6;
ALTER TABLE `#__catalog_product_link_attribute_decimal`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=6;
ALTER TABLE `#__catalog_product_link_attribute_int`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=3366;
ALTER TABLE `#__catalog_product_link_attribute_varchar`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID';
ALTER TABLE `#__catalog_product_link_type`
MODIFY `link_type_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link Type ID',AUTO_INCREMENT=6;
ALTER TABLE `#__catalog_product_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option ID',AUTO_INCREMENT=11;
ALTER TABLE `#__catalog_product_option_price`
MODIFY `option_price_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Price ID',AUTO_INCREMENT=7;
ALTER TABLE `#__catalog_product_option_title`
MODIFY `option_title_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Title ID',AUTO_INCREMENT=11;
ALTER TABLE `#__catalog_product_option_type_price`
MODIFY `option_type_price_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Price ID',AUTO_INCREMENT=16;
ALTER TABLE `#__catalog_product_option_type_title`
MODIFY `option_type_title_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type Title ID',AUTO_INCREMENT=16;
ALTER TABLE `#__catalog_product_option_type_value`
MODIFY `option_type_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Type ID',AUTO_INCREMENT=16;
ALTER TABLE `#__catalog_product_super_attribute`
MODIFY `product_super_attribute_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product Super Attribute ID',AUTO_INCREMENT=11;
ALTER TABLE `#__catalog_product_super_attribute_label`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=11;
ALTER TABLE `#__catalog_product_super_attribute_pricing`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value ID',AUTO_INCREMENT=36;
ALTER TABLE `#__catalog_product_super_link`
MODIFY `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',AUTO_INCREMENT=30;
ALTER TABLE `#__checkout_agreement`
MODIFY `agreement_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Agreement Id';
ALTER TABLE `#__cms_block`
MODIFY `block_id` smallint(6) NOT NULL AUTO_INCREMENT COMMENT 'Block ID',AUTO_INCREMENT=65;
ALTER TABLE `#__cms_page`
MODIFY `page_id` smallint(6) NOT NULL AUTO_INCREMENT COMMENT 'Page ID',AUTO_INCREMENT=11;
ALTER TABLE `#__core_config_data`
MODIFY `config_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Config Id',AUTO_INCREMENT=407;
ALTER TABLE `#__core_email_queue`
MODIFY `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Message Id',AUTO_INCREMENT=2;
ALTER TABLE `#__core_email_queue_recipients`
MODIFY `recipient_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Recipient Id',AUTO_INCREMENT=2;
ALTER TABLE `#__core_email_template`
MODIFY `template_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Template Id';
ALTER TABLE `#__core_flag`
MODIFY `flag_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Flag Id',AUTO_INCREMENT=3;
ALTER TABLE `#__core_layout_link`
MODIFY `layout_link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link Id';
ALTER TABLE `#__core_layout_update`
MODIFY `layout_update_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Layout Update Id';
ALTER TABLE `#__core_store`
MODIFY `store_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Store Id',AUTO_INCREMENT=6;
ALTER TABLE `#__core_store_group`
MODIFY `group_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Group Id',AUTO_INCREMENT=2;
ALTER TABLE `#__core_translate`
MODIFY `key_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Key Id of Translation';
ALTER TABLE `#__core_url_rewrite`
MODIFY `url_rewrite_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rewrite Id',AUTO_INCREMENT=64364;
ALTER TABLE `#__core_variable`
MODIFY `variable_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Variable Id';
ALTER TABLE `#__core_variable_value`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Variable Value Id';
ALTER TABLE `#__core_website`
MODIFY `website_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Website Id',AUTO_INCREMENT=2;
ALTER TABLE `#__coupon_aggregated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__coupon_aggregated_order`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__coupon_aggregated_updated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__cron_schedule`
MODIFY `schedule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Schedule Id';
ALTER TABLE `#__customer_address_entity`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=2;
ALTER TABLE `#__customer_address_entity_datetime`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__customer_address_entity_decimal`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__customer_address_entity_int`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=2;
ALTER TABLE `#__customer_address_entity_text`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=2;
ALTER TABLE `#__customer_address_entity_varchar`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=9;
ALTER TABLE `#__customer_entity`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=4;
ALTER TABLE `#__customer_entity_datetime`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__customer_entity_decimal`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__customer_entity_int`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=3;
ALTER TABLE `#__customer_entity_text`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__customer_entity_varchar`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=13;
ALTER TABLE `#__customer_group`
MODIFY `customer_group_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Customer Group Id',AUTO_INCREMENT=4;
ALTER TABLE `#__dataflow_batch`
MODIFY `batch_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Batch Id';
ALTER TABLE `#__dataflow_batch_export`
MODIFY `batch_export_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Batch Export Id';
ALTER TABLE `#__dataflow_batch_import`
MODIFY `batch_import_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Batch Import Id';
ALTER TABLE `#__dataflow_import_data`
MODIFY `import_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Import Id';
ALTER TABLE `#__dataflow_profile`
MODIFY `profile_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Profile Id',AUTO_INCREMENT=7;
ALTER TABLE `#__dataflow_profile_history`
MODIFY `history_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'History Id',AUTO_INCREMENT=7;
ALTER TABLE `#__dataflow_session`
MODIFY `session_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Session Id';
ALTER TABLE `#__design_change`
MODIFY `design_change_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Design Change Id';
ALTER TABLE `#__directory_country_format`
MODIFY `country_format_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Country Format Id';
ALTER TABLE `#__directory_country_region`
MODIFY `region_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Region Id',AUTO_INCREMENT=485;
ALTER TABLE `#__downloadable_link`
MODIFY `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link ID',AUTO_INCREMENT=4;
ALTER TABLE `#__downloadable_link_price`
MODIFY `price_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Price ID',AUTO_INCREMENT=4;
ALTER TABLE `#__downloadable_link_purchased`
MODIFY `purchased_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Purchased ID';
ALTER TABLE `#__downloadable_link_purchased_item`
MODIFY `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item ID';
ALTER TABLE `#__downloadable_link_title`
MODIFY `title_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Title ID',AUTO_INCREMENT=4;
ALTER TABLE `#__downloadable_sample`
MODIFY `sample_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Sample ID',AUTO_INCREMENT=4;
ALTER TABLE `#__downloadable_sample_title`
MODIFY `title_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Title ID',AUTO_INCREMENT=4;
ALTER TABLE `#__eav_attribute`
MODIFY `attribute_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Id',AUTO_INCREMENT=165;
ALTER TABLE `#__eav_attribute_group`
MODIFY `attribute_group_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Group Id',AUTO_INCREMENT=19;
ALTER TABLE `#__eav_attribute_label`
MODIFY `attribute_label_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Label Id';
ALTER TABLE `#__eav_attribute_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Id',AUTO_INCREMENT=17;
ALTER TABLE `#__eav_attribute_option_value`
MODIFY `value_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Value Id',AUTO_INCREMENT=79;
ALTER TABLE `#__eav_attribute_set`
MODIFY `attribute_set_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Attribute Set Id',AUTO_INCREMENT=9;
ALTER TABLE `#__eav_entity`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__eav_entity_attribute`
MODIFY `entity_attribute_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Attribute Id',AUTO_INCREMENT=247;
ALTER TABLE `#__eav_entity_datetime`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__eav_entity_decimal`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__eav_entity_int`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__eav_entity_store`
MODIFY `entity_store_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Store Id',AUTO_INCREMENT=2;
ALTER TABLE `#__eav_entity_text`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__eav_entity_type`
MODIFY `entity_type_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Type Id',AUTO_INCREMENT=9;
ALTER TABLE `#__eav_entity_varchar`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__eav_form_element`
MODIFY `element_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Element Id',AUTO_INCREMENT=53;
ALTER TABLE `#__eav_form_fieldset`
MODIFY `fieldset_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Fieldset Id',AUTO_INCREMENT=3;
ALTER TABLE `#__eav_form_type`
MODIFY `type_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Type Id',AUTO_INCREMENT=6;
ALTER TABLE `#__gift_message`
MODIFY `gift_message_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'GiftMessage Id';
ALTER TABLE `#__importexport_importdata`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__index_event`
MODIFY `event_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Event Id';
ALTER TABLE `#__index_process`
MODIFY `process_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Process Id',AUTO_INCREMENT=10;
ALTER TABLE `#__log_customer`
MODIFY `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID';
ALTER TABLE `#__log_summary`
MODIFY `summary_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Summary ID';
ALTER TABLE `#__log_summary_type`
MODIFY `type_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Type ID';
ALTER TABLE `#__log_url_info`
MODIFY `url_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'URL ID',AUTO_INCREMENT=1039;
ALTER TABLE `#__log_visitor`
MODIFY `visitor_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Visitor ID',AUTO_INCREMENT=77;
ALTER TABLE `#__log_visitor_online`
MODIFY `visitor_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Visitor ID';
ALTER TABLE `#__newsletter_problem`
MODIFY `problem_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Problem Id';
ALTER TABLE `#__newsletter_queue`
MODIFY `queue_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Queue Id';
ALTER TABLE `#__newsletter_queue_link`
MODIFY `queue_link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Queue Link Id';
ALTER TABLE `#__newsletter_subscriber`
MODIFY `subscriber_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Subscriber Id',AUTO_INCREMENT=2;
ALTER TABLE `#__newsletter_template`
MODIFY `template_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Template Id',AUTO_INCREMENT=2;
ALTER TABLE `#__oauth_consumer`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__oauth_token`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity ID';
ALTER TABLE `#__paypal_cert`
MODIFY `cert_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Cert Id';
ALTER TABLE `#__paypal_payment_transaction`
MODIFY `transaction_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__paypal_settlement_report`
MODIFY `report_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Report Id';
ALTER TABLE `#__paypal_settlement_report_row`
MODIFY `row_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Row Id';
ALTER TABLE `#__persistent_session`
MODIFY `persistent_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Session id';
ALTER TABLE `#__poll`
MODIFY `poll_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Poll Id',AUTO_INCREMENT=2;
ALTER TABLE `#__poll_answer`
MODIFY `answer_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Answer Id',AUTO_INCREMENT=5;
ALTER TABLE `#__poll_vote`
MODIFY `vote_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Vote Id';
ALTER TABLE `#__product_alert_price`
MODIFY `alert_price_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product alert price id';
ALTER TABLE `#__product_alert_stock`
MODIFY `alert_stock_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Product alert stock id';
ALTER TABLE `#__rating`
MODIFY `rating_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rating Id',AUTO_INCREMENT=4;
ALTER TABLE `#__rating_entity`
MODIFY `entity_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=4;
ALTER TABLE `#__rating_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rating Option Id',AUTO_INCREMENT=16;
ALTER TABLE `#__rating_option_vote`
MODIFY `vote_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Vote id',AUTO_INCREMENT=34;
ALTER TABLE `#__rating_option_vote_aggregated`
MODIFY `primary_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Vote aggregation id',AUTO_INCREMENT=37;
ALTER TABLE `#__report_compared_product_index`
MODIFY `index_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Index Id',AUTO_INCREMENT=3;
ALTER TABLE `#__report_event`
MODIFY `event_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Event Id',AUTO_INCREMENT=38;
ALTER TABLE `#__report_event_types`
MODIFY `event_type_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Event Type Id',AUTO_INCREMENT=7;
ALTER TABLE `#__report_viewed_product_aggregated_daily`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__report_viewed_product_aggregated_monthly`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__report_viewed_product_aggregated_yearly`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__report_viewed_product_index`
MODIFY `index_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Index Id',AUTO_INCREMENT=30;
ALTER TABLE `#__review`
MODIFY `review_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review id',AUTO_INCREMENT=12;
ALTER TABLE `#__review_detail`
MODIFY `detail_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review detail id',AUTO_INCREMENT=12;
ALTER TABLE `#__review_entity`
MODIFY `entity_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Review entity id',AUTO_INCREMENT=4;
ALTER TABLE `#__review_entity_summary`
MODIFY `primary_id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'Summary review entity id',AUTO_INCREMENT=13;
ALTER TABLE `#__review_status`
MODIFY `status_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Status id',AUTO_INCREMENT=4;
ALTER TABLE `#__salesrule`
MODIFY `rule_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Id';
ALTER TABLE `#__salesrule_coupon`
MODIFY `coupon_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Coupon Id';
ALTER TABLE `#__salesrule_customer`
MODIFY `rule_customer_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rule Customer Id';
ALTER TABLE `#__salesrule_label`
MODIFY `label_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Label Id';
ALTER TABLE `#__sales_bestsellers_aggregated_daily`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_bestsellers_aggregated_monthly`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_bestsellers_aggregated_yearly`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_billing_agreement`
MODIFY `agreement_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Agreement Id';
ALTER TABLE `#__sales_flat_creditmemo`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_creditmemo_comment`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_creditmemo_item`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_invoice`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_invoice_comment`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_invoice_item`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_order`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=2;
ALTER TABLE `#__sales_flat_order_address`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=3;
ALTER TABLE `#__sales_flat_order_item`
MODIFY `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item Id',AUTO_INCREMENT=7;
ALTER TABLE `#__sales_flat_order_payment`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=2;
ALTER TABLE `#__sales_flat_order_status_history`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=2;
ALTER TABLE `#__sales_flat_quote`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id',AUTO_INCREMENT=45;
ALTER TABLE `#__sales_flat_quote_address`
MODIFY `address_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Address Id',AUTO_INCREMENT=91;
ALTER TABLE `#__sales_flat_quote_address_item`
MODIFY `address_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Address Item Id';
ALTER TABLE `#__sales_flat_quote_item`
MODIFY `item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Item Id',AUTO_INCREMENT=82;
ALTER TABLE `#__sales_flat_quote_item_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Id',AUTO_INCREMENT=118;
ALTER TABLE `#__sales_flat_quote_payment`
MODIFY `payment_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Payment Id',AUTO_INCREMENT=7;
ALTER TABLE `#__sales_flat_quote_shipping_rate`
MODIFY `rate_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Rate Id',AUTO_INCREMENT=26;
ALTER TABLE `#__sales_flat_shipment`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_shipment_comment`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_shipment_item`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_flat_shipment_track`
MODIFY `entity_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Entity Id';
ALTER TABLE `#__sales_invoiced_aggregated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_invoiced_aggregated_order`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_order_aggregated_created`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_order_aggregated_updated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_order_tax`
MODIFY `tax_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tax Id';
ALTER TABLE `#__sales_order_tax_item`
MODIFY `tax_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tax Item Id';
ALTER TABLE `#__sales_payment_transaction`
MODIFY `transaction_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Transaction Id';
ALTER TABLE `#__sales_recurring_profile`
MODIFY `profile_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Profile Id';
ALTER TABLE `#__sales_recurring_profile_order`
MODIFY `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Link Id';
ALTER TABLE `#__sales_refunded_aggregated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_refunded_aggregated_order`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_shipping_aggregated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sales_shipping_aggregated_order`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__sendfriend_log`
MODIFY `log_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Log ID';
ALTER TABLE `#__shipping_tablerate`
MODIFY `pk` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary key';
ALTER TABLE `#__sitemap`
MODIFY `sitemap_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Sitemap Id';
ALTER TABLE `#__tag`
MODIFY `tag_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tag Id',AUTO_INCREMENT=50;
ALTER TABLE `#__tag_relation`
MODIFY `tag_relation_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Tag Relation Id',AUTO_INCREMENT=62;
ALTER TABLE `#__tax_calculation`
MODIFY `tax_calculation_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Id',AUTO_INCREMENT=3;
ALTER TABLE `#__tax_calculation_rate`
MODIFY `tax_calculation_rate_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rate Id',AUTO_INCREMENT=3;
ALTER TABLE `#__tax_calculation_rate_title`
MODIFY `tax_calculation_rate_title_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rate Title Id';
ALTER TABLE `#__tax_calculation_rule`
MODIFY `tax_calculation_rule_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Tax Calculation Rule Id',AUTO_INCREMENT=2;
ALTER TABLE `#__tax_class`
MODIFY `class_id` smallint(6) NOT NULL AUTO_INCREMENT COMMENT 'Class Id',AUTO_INCREMENT=5;
ALTER TABLE `#__tax_order_aggregated_created`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__tax_order_aggregated_updated`
MODIFY `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Id';
ALTER TABLE `#__weee_tax`
MODIFY `value_id` int(11) NOT NULL AUTO_INCREMENT COMMENT 'Value Id';
ALTER TABLE `#__widget`
MODIFY `widget_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Widget Id';
ALTER TABLE `#__widget_instance`
MODIFY `instance_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Instance Id';
ALTER TABLE `#__widget_instance_page`
MODIFY `page_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Page Id';
ALTER TABLE `#__wishlist`
MODIFY `wishlist_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Wishlist ID',AUTO_INCREMENT=2;
ALTER TABLE `#__wishlist_item`
MODIFY `wishlist_item_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Wishlist item ID',AUTO_INCREMENT=5;
ALTER TABLE `#__wishlist_item_option`
MODIFY `option_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Option Id',AUTO_INCREMENT=5;

ALTER TABLE `#__admin_rule`
ADD CONSTRAINT `FK_SNSPFX_ADMIN_RULE_ROLE_ID_SNSPFX_ADMIN_ROLE_ROLE_ID` FOREIGN KEY (`role_id`) REFERENCES `#__admin_role` (`role_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__api2_acl_rule`
ADD CONSTRAINT `FK_SNSPFX_API2_ACL_RULE_ROLE_ID_SNSPFX_API2_ACL_ROLE_ENTITY_ID` FOREIGN KEY (`role_id`) REFERENCES `#__api2_acl_role` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__api2_acl_user`
ADD CONSTRAINT `FK_SNSPFX_API2_ACL_USER_ADMIN_ID_SNSPFX_ADMIN_USER_USER_ID` FOREIGN KEY (`admin_id`) REFERENCES `#__admin_user` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_API2_ACL_USER_ROLE_ID_SNSPFX_API2_ACL_ROLE_ENTITY_ID` FOREIGN KEY (`role_id`) REFERENCES `#__api2_acl_role` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__api_rule`
ADD CONSTRAINT `FK_SNSPFX_API_RULE_ROLE_ID_SNSPFX_API_ROLE_ROLE_ID` FOREIGN KEY (`role_id`) REFERENCES `#__api_role` (`role_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__api_session`
ADD CONSTRAINT `FK_SNSPFX_API_SESSION_USER_ID_SNSPFX_API_USER_USER_ID` FOREIGN KEY (`user_id`) REFERENCES `#__api_user` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__cataloginventory_stock_item`
ADD CONSTRAINT `FK_C46B4B0448A73694286929648873CFF9` FOREIGN KEY (`stock_id`) REFERENCES `#__cataloginventory_stock` (`stock_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATINV_STOCK_ITEM_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__cataloginventory_stock_status`
ADD CONSTRAINT `FK_SNSPFX_CATINV_STOCK_STS_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATINV_STOCK_STS_STOCK_ID_SNSPFX_CATINV_STOCK_STOCK_ID` FOREIGN KEY (`stock_id`) REFERENCES `#__cataloginventory_stock` (`stock_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATINV_STOCK_STS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogrule_customer_group`
ADD CONSTRAINT `FK_9BA7FB9814C822D34297FDA8260BD283` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_CSTR_GROUP_RULE_ID_SNSPFX_CATRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__catalogrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogrule_group_website`
ADD CONSTRAINT `FK_D942FE9C034F066ED03CAA6B1FE070A1` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_GROUP_WS_RULE_ID_SNSPFX_CATRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__catalogrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_GROUP_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogrule_product`
ADD CONSTRAINT `FK_6E578D637177481060861D2813C1BEF8` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATALOGRULE_PRODUCT_RULE_ID_SNSPFX_CATALOGRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__catalogrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_PRD_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_PRD_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogrule_product_price`
ADD CONSTRAINT `FK_856EA28031BA7D140FF61CB4AD2711BE` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_PRD_PRICE_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_PRD_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogrule_website`
ADD CONSTRAINT `FK_SNSPFX_CATALOGRULE_WEBSITE_RULE_ID_SNSPFX_CATALOGRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__catalogrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATRULE_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogsearch_query`
ADD CONSTRAINT `FK_SNSPFX_CATSRCH_QR_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalogsearch_result`
ADD CONSTRAINT `FK_SNSPFX_CATSRCH_RESULT_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CATSRCH_RESULT_QR_ID_SNSPFX_CATSRCH_QR_QR_ID` FOREIGN KEY (`query_id`) REFERENCES `#__catalogsearch_query` (`query_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_entity_datetime`
ADD CONSTRAINT `FK_B1E96F4B47EBBCF53AB65AA23F3E05DF` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C8F79D173FEA9BA532B25FEB9B95A8A8` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_DTIME_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_entity_decimal`
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_DEC_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_DEC_ENTT_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_DEC_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_entity_int`
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_INT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_INT_ENTT_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_INT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_entity_text`
ADD CONSTRAINT `FK_28744F852E4E7C09678B247CD4AF5CB6` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_TEXT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_TEXT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_entity_varchar`
ADD CONSTRAINT `FK_B14E0A9028B6424A8EC661520696DD85` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_VCHR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_ENTT_VCHR_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_flat_store_1`
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_1_ENTT_ID_SNS_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_1_STORE_ID_SNS_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_flat_store_2`
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_2_ENTT_ID_SNS_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_2_STORE_ID_SNS_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_flat_store_3`
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_3_ENTT_ID_SNS_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_3_STORE_ID_SNS_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_flat_store_4`
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_4_ENTT_ID_SNS_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_4_STORE_ID_SNS_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_flat_store_5`
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_5_ENTT_ID_SNS_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNS_CAT_CTGR_FLAT_STORE_5_STORE_ID_SNS_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_product`
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_PRD_CTGR_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`category_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_PRD_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_category_product_index`
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_PRD_IDX_CTGR_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`category_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_PRD_IDX_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CTGR_PRD_IDX_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_compare_item`
ADD CONSTRAINT `FK_SNSPFX_CAT_CMP_ITEM_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CMP_ITEM_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_CMP_ITEM_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__catalog_eav_attribute`
ADD CONSTRAINT `FK_SNSPFX_CAT_EAV_ATTR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_bundle_option`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_BNDL_OPT_PARENT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_bundle_option_value`
ADD CONSTRAINT `FK_0595F90A2F963492DC65B0C6C220FDDD` FOREIGN KEY (`option_id`) REFERENCES `#__catalog_product_bundle_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_bundle_price_index`
ADD CONSTRAINT `FK_6F11E1CF33CDC88351B62D94FFD041E7` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_A5D54C4F57D9041EB420558B6FCDFF82` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_BNDL_PRICE_IDX_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_bundle_selection`
ADD CONSTRAINT `FK_319170413BCCB5DA737616564B81C5C7` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_785D14794C80DCBE7B000169FBB137B9` FOREIGN KEY (`option_id`) REFERENCES `#__catalog_product_bundle_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_bundle_selection_price`
ADD CONSTRAINT `FK_44302ABFBABF61729EE1C140D17C9CC7` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_88A5DD2BDFC240D288E4978216B0E264` FOREIGN KEY (`selection_id`) REFERENCES `#__catalog_product_bundle_selection` (`selection_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_enabled_index`
ADD CONSTRAINT `FK_6E1551D9ABE9C3B15DF8F4C55DF0C5ED` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENABLED_IDX_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity`
ADD CONSTRAINT `FK_033D4DD64D63997584479489B09C03D9` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_93F47CDC1DAD6A5BF0217CC926595528` FOREIGN KEY (`attribute_set_id`) REFERENCES `#__eav_attribute_set` (`attribute_set_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_datetime`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DTIME_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DTIME_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DTIME_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_decimal`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DEC_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DEC_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_DEC_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_gallery`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_GLR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_GLR_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_GLR_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_group_price`
ADD CONSTRAINT `FK_17152A0DD76A1FE9936188ED2AFCBAF4` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_2B8719DE46586E77827396EBCA53CF36` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_GROUP_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_int`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_INT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_INT_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_INT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_media_gallery`
ADD CONSTRAINT `FK_019F0FB38636D35120EC22715C6DB36D` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_MDA_GLR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_media_gallery_value`
ADD CONSTRAINT `FK_0EB9F85DED4A37FB8AFA46A17F29EEAE` FOREIGN KEY (`value_id`) REFERENCES `#__catalog_product_entity_media_gallery` (`value_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_A6D8052237F63B1A2A94F7B2FCFE82FC` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_text`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_TEXT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_TEXT_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_TEXT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_tier_price`
ADD CONSTRAINT `FK_DD20D9A30FF34161CE4F336D1AF61CCF` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FB4EECB49378CA163E451DF687CA55E6` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_TIER_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_entity_varchar`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_VCHR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_VCHR_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_ENTT_VCHR_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_flat_1`
ADD CONSTRAINT `FK_SNS_SNS_CAT_PRD_FLAT_1_ENTT_ID_SNS_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_flat_2`
ADD CONSTRAINT `FK_SNS_SNS_CAT_PRD_FLAT_2_ENTT_ID_SNS_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_flat_3`
ADD CONSTRAINT `FK_SNS_SNS_CAT_PRD_FLAT_3_ENTT_ID_SNS_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_flat_4`
ADD CONSTRAINT `FK_SNS_SNS_CAT_PRD_FLAT_4_ENTT_ID_SNS_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_flat_5`
ADD CONSTRAINT `FK_SNS_SNS_CAT_PRD_FLAT_5_ENTT_ID_SNS_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_eav`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_EAV_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_EAV_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_EAV_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_eav_decimal`
ADD CONSTRAINT `FK_173D507B5500F051FF168F7242C3AC4D` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_2930A274E3E334608F42689012E660A8` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_EAV_DEC_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_group_price`
ADD CONSTRAINT `FK_41C26EC2DCF2D3A8571E49232B6FBD81` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FE203CF8608CC45A0AD7ED5C8FB314CD` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_GROUP_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_price`
ADD CONSTRAINT `FK_F7B88CE0616DD685647CF75DE83BC6E5` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_PRICE_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_tier_price`
ADD CONSTRAINT `FK_A1712D568488B2874E4CA6A1900352F9` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_CEB0F2280421DA39288DB8A25E361954` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_TIER_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_index_website`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_IDX_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_link`
ADD CONSTRAINT `FK_61419EE165A48B2BC90458AE37EE7E86` FOREIGN KEY (`link_type_id`) REFERENCES `#__catalog_product_link_type` (`link_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_LNK_LNKED_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`linked_product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_LNK_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_link_attribute`
ADD CONSTRAINT `FK_BBA8F5AA549E6C49CD6EED9B767A4028` FOREIGN KEY (`link_type_id`) REFERENCES `#__catalog_product_link_type` (`link_type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_link_attribute_decimal`
ADD CONSTRAINT `FK_AE5452CA9DA55550916E13A5119B149C` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `#__catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_LNK_ATTR_DEC_LNK_ID_SNSPFX_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `#__catalog_product_link` (`link_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_link_attribute_int`
ADD CONSTRAINT `FK_ABA4E0CA63E0B35593723ED980E532B6` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `#__catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_LNK_ATTR_INT_LNK_ID_SNSPFX_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `#__catalog_product_link` (`link_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_link_attribute_varchar`
ADD CONSTRAINT `FK_7AA6CF3EB0F06F671DB43418B9D55F35` FOREIGN KEY (`product_link_attribute_id`) REFERENCES `#__catalog_product_link_attribute` (`product_link_attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_LNK_ATTR_VCHR_LNK_ID_SNSPFX_CAT_PRD_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `#__catalog_product_link` (`link_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option_price`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_PRICE_OPT_ID_SNSPFX_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `#__catalog_product_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_PRICE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option_title`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_TTL_OPT_ID_SNSPFX_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `#__catalog_product_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_TTL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option_type_price`
ADD CONSTRAINT `FK_150E3E669AA267DA600CBB8C9C1A35A0` FOREIGN KEY (`option_type_id`) REFERENCES `#__catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_BF932445159C6CB2EA2BC30B01358F20` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option_type_title`
ADD CONSTRAINT `FK_ABBD67B4CCBFB92981104E1BED4310FD` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_DAE664CF57708D2DA398AD5AE2723B0B` FOREIGN KEY (`option_type_id`) REFERENCES `#__catalog_product_option_type_value` (`option_type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_option_type_value`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_OPT_TYPE_VAL_OPT_ID_SNSPFX_CAT_PRD_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `#__catalog_product_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_relation`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_RELATION_CHILD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`child_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_RELATION_PARENT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_super_attribute`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_SPR_ATTR_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__catalog_product_super_attribute_label`
ADD CONSTRAINT `FK_B4F4B28D621D86205EB0119B742F61AF` FOREIGN KEY (`product_super_attribute_id`) REFERENCES `#__catalog_product_super_attribute` (`product_super_attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_EE63D989E8899347B9DF30ED1788DC11` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_super_attribute_pricing`
ADD CONSTRAINT `FK_84D54A8D86214B81A54CE5DD7CEFAB60` FOREIGN KEY (`product_super_attribute_id`) REFERENCES `#__catalog_product_super_attribute` (`product_super_attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_SPR_ATTR_PRICING_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_super_link`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_SPR_LNK_PARENT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_SPR_LNK_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__catalog_product_website`
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_WS_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CAT_PRD_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__checkout_agreement_store`
ADD CONSTRAINT `FK_SNSPFX_CHKT_AGRT_STORE_AGRT_ID_SNSPFX_CHKT_AGRT_AGRT_ID` FOREIGN KEY (`agreement_id`) REFERENCES `#__checkout_agreement` (`agreement_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CHKT_AGRT_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__cms_block_store`
ADD CONSTRAINT `FK_SNSPFX_CMS_BLOCK_STORE_BLOCK_ID_SNSPFX_CMS_BLOCK_BLOCK_ID` FOREIGN KEY (`block_id`) REFERENCES `#__cms_block` (`block_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CMS_BLOCK_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__cms_page_store`
ADD CONSTRAINT `FK_SNSPFX_CMS_PAGE_STORE_PAGE_ID_SNSPFX_CMS_PAGE_PAGE_ID` FOREIGN KEY (`page_id`) REFERENCES `#__cms_page` (`page_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CMS_PAGE_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_email_queue_recipients`
ADD CONSTRAINT `FK_3C898FA1F0B34AE520CC7425DB87AA3C` FOREIGN KEY (`message_id`) REFERENCES `#__core_email_queue` (`message_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_layout_link`
ADD CONSTRAINT `FK_ACD047E7B3651651DA52DB6566FD96A1` FOREIGN KEY (`layout_update_id`) REFERENCES `#__core_layout_update` (`layout_update_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CORE_LAYOUT_LINK_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_store`
ADD CONSTRAINT `FK_SNSPFX_CORE_STORE_GROUP_ID_SNSPFX_CORE_STORE_GROUP_GROUP_ID` FOREIGN KEY (`group_id`) REFERENCES `#__core_store_group` (`group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CORE_STORE_WEBSITE_ID_SNSPFX_CORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_store_group`
ADD CONSTRAINT `FK_SNSPFX_CORE_STORE_GROUP_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_translate`
ADD CONSTRAINT `FK_SNSPFX_CORE_TRANSLATE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_url_rewrite`
ADD CONSTRAINT `FK_SNSPFX_CORE_URL_REWRITE_CTGR_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`category_id`) REFERENCES `#__catalog_category_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CORE_URL_REWRITE_PRD_ID_SNSPFX_CAT_CTGR_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CORE_URL_REWRITE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__core_variable_value`
ADD CONSTRAINT `FK_FC82311503632F33E90C72713B658663` FOREIGN KEY (`variable_id`) REFERENCES `#__core_variable` (`variable_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CORE_VARIABLE_VAL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__coupon_aggregated`
ADD CONSTRAINT `FK_SNSPFX_COUPON_AGGREGATED_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__coupon_aggregated_order`
ADD CONSTRAINT `FK_98FDCD8F901704AEDD457CF2F137D2E2` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__coupon_aggregated_updated`
ADD CONSTRAINT `FK_4E5218087045299A37152D92BD672AED` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity`
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_PARENT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`parent_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity_datetime`
ADD CONSTRAINT `FK_4A3A9CE6BA60B4E5CED0DF0C8AE5A6CF` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_D95950992D112E5DF098E7BD14FF39B7` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_address_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_DTIME_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity_decimal`
ADD CONSTRAINT `FK_7EF052FA64F08C44DA6D4523BE6C29FC` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_address_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_ABE8EC0B8E53500933E0ECC24ECA95D5` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_DEC_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity_int`
ADD CONSTRAINT `FK_8230C80B0A1794063ED42C8B86CCC06F` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_address_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_92B75075199481960714F64FEA110111` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_INT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity_text`
ADD CONSTRAINT `FK_253C76D7E4B8E77B1C7F1751EA008669` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_5640C4F34B22DA20C6227F6222D4E294` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_address_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_TEXT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_address_entity_varchar`
ADD CONSTRAINT `FK_B9D340F5BEEC8D93CC98112E4E86BCE7` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_address_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_DF49EF039DD0A7F02EF3CC59F7CBE8BB` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ADDR_ENTT_VCHR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_eav_attribute`
ADD CONSTRAINT `FK_SNSPFX_CSTR_EAV_ATTR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_eav_attribute_website`
ADD CONSTRAINT `FK_SNSPFX_CSTR_EAV_ATTR_WS_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_EAV_ATTR_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity`
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CUSTOMER_ENTITY_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity_datetime`
ADD CONSTRAINT `FK_D8B2551C7B1F71934619AF9787EC12FD` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_DTIME_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_DTIME_ENTT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity_decimal`
ADD CONSTRAINT `FK_7269CC2490C8F46E1320C863673A2FAF` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_DEC_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_DEC_ENTT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity_int`
ADD CONSTRAINT `FK_CC0B95174B9999072505455C527A48F2` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_INT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_INT_ENTT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity_text`
ADD CONSTRAINT `FK_AA76183F82FB742FF0A476FD5AF6E83A` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_TEXT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_TEXT_ENTT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_entity_varchar`
ADD CONSTRAINT `FK_D4ACB794DBB815A7444CF654F20D93EA` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_VCHR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_CSTR_ENTT_VCHR_ENTT_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__customer_form_attribute`
ADD CONSTRAINT `FK_SNSPFX_CSTR_FORM_ATTR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__dataflow_batch`
ADD CONSTRAINT `FK_C1AFDE3A6F2CE1413F1CE23A3E049100` FOREIGN KEY (`profile_id`) REFERENCES `#__dataflow_profile` (`profile_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_DATAFLOW_BATCH_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__dataflow_batch_export`
ADD CONSTRAINT `FK_C65F92DCCD32E7C9FA1DE1DA3CE1A4B5` FOREIGN KEY (`batch_id`) REFERENCES `#__dataflow_batch` (`batch_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__dataflow_batch_import`
ADD CONSTRAINT `FK_F854149E42D7BA1155C2BE1472722374` FOREIGN KEY (`batch_id`) REFERENCES `#__dataflow_batch` (`batch_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__dataflow_import_data`
ADD CONSTRAINT `FK_28CE06353BD740B8AA0A5FADFF0D7B1C` FOREIGN KEY (`session_id`) REFERENCES `#__dataflow_session` (`session_id`) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER TABLE `#__dataflow_profile_history`
ADD CONSTRAINT `FK_5C195D060F06ABE72CD33DE59EED6A8F` FOREIGN KEY (`profile_id`) REFERENCES `#__dataflow_profile` (`profile_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__design_change`
ADD CONSTRAINT `FK_SNSPFX_DESIGN_CHANGE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__directory_country_region_name`
ADD CONSTRAINT `FK_4198A4E1BA68E27D82B8CC66784C3038` FOREIGN KEY (`region_id`) REFERENCES `#__directory_country_region` (`region_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_link`
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_link_price`
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_PRICE_LNK_ID_SNSPFX_DL_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `#__downloadable_link` (`link_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_link_purchased`
ADD CONSTRAINT `FK_8E1C541F202C1038F2AD88057E2D9210` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_PURCHASED_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_link_purchased_item`
ADD CONSTRAINT `FK_2A318A35350ED8CE2E8E5FBE4160228C` FOREIGN KEY (`order_item_id`) REFERENCES `#__sales_flat_order_item` (`item_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_D5432DF736D388A657008CD0DFB7B09D` FOREIGN KEY (`purchased_id`) REFERENCES `#__downloadable_link_purchased` (`purchased_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_link_title`
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_TTL_LNK_ID_SNSPFX_DL_LNK_LNK_ID` FOREIGN KEY (`link_id`) REFERENCES `#__downloadable_link` (`link_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_DL_LNK_TTL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_sample`
ADD CONSTRAINT `FK_SNSPFX_DL_SAMPLE_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__downloadable_sample_title`
ADD CONSTRAINT `FK_SNSPFX_DL_SAMPLE_TTL_SAMPLE_ID_SNSPFX_DL_SAMPLE_SAMPLE_ID` FOREIGN KEY (`sample_id`) REFERENCES `#__downloadable_sample` (`sample_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_DL_SAMPLE_TTL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute`
ADD CONSTRAINT `FK_FDC889CF86B93D22D792A906C248BF44` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute_group`
ADD CONSTRAINT `FK_E06D3FA963C7E7668BDACA7027982E59` FOREIGN KEY (`attribute_set_id`) REFERENCES `#__eav_attribute_set` (`attribute_set_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute_label`
ADD CONSTRAINT `FK_SNSPFX_EAV_ATTR_LBL_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ATTR_LBL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute_option`
ADD CONSTRAINT `FK_SNSPFX_EAV_ATTR_OPT_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute_option_value`
ADD CONSTRAINT `FK_SNSPFX_EAV_ATTR_OPT_VAL_OPT_ID_SNSPFX_EAV_ATTR_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `#__eav_attribute_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ATTR_OPT_VAL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_attribute_set`
ADD CONSTRAINT `FK_92960CB41EF44FCE79799A75ED08BE8E` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity`
ADD CONSTRAINT `FK_0322A565A30FC88BD5F2D43EF72CBC17` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_attribute`
ADD CONSTRAINT `FK_F14FCD155E479FA26C9AD1B62BD837A8` FOREIGN KEY (`attribute_group_id`) REFERENCES `#__eav_attribute_group` (`attribute_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTT_ATTR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_datetime`
ADD CONSTRAINT `FK_4FF431D1A161DB8EF07DB6136388BAA5` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTT_DTIME_ENTT_ID_SNSPFX_EAV_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__eav_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTT_DTIME_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_decimal`
ADD CONSTRAINT `FK_1C8BC763A648F5C369366FAFC84226C9` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_DECIMAL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTT_DEC_ENTT_ID_SNSPFX_EAV_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__eav_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_int`
ADD CONSTRAINT `FK_0EAB59495C1D2277B882CC49C9DEEDE1` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_INT_ENTITY_ID_SNSPFX_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__eav_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_INT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_store`
ADD CONSTRAINT `FK_E56D195486666FE04060DFBBD7451300` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_text`
ADD CONSTRAINT `FK_2FE10C45E923F1C79A75F3F58271DBB8` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_TEXT_ENTITY_ID_SNSPFX_EAV_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__eav_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_TEXT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_entity_varchar`
ADD CONSTRAINT `FK_9EFFEAEC8EEF7E95DC127E3D1EF2E412` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTITY_VARCHAR_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_ENTT_VCHR_ENTT_ID_SNSPFX_EAV_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__eav_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_form_element`
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_ELEMENT_TYPE_ID_SNSPFX_EAV_FORM_TYPE_TYPE_ID` FOREIGN KEY (`type_id`) REFERENCES `#__eav_form_type` (`type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_ELM_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_ELM_FSET_ID_SNSPFX_EAV_FORM_FSET_FSET_ID` FOREIGN KEY (`fieldset_id`) REFERENCES `#__eav_form_fieldset` (`fieldset_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__eav_form_fieldset`
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_FIELDSET_TYPE_ID_SNSPFX_EAV_FORM_TYPE_TYPE_ID` FOREIGN KEY (`type_id`) REFERENCES `#__eav_form_type` (`type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_form_fieldset_label`
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_FSET_LBL_FSET_ID_SNSPFX_EAV_FORM_FSET_FSET_ID` FOREIGN KEY (`fieldset_id`) REFERENCES `#__eav_form_fieldset` (`fieldset_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_FSET_LBL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_form_type`
ADD CONSTRAINT `FK_SNSPFX_EAV_FORM_TYPE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__eav_form_type_entity`
ADD CONSTRAINT `FK_52CC18DF3D75E1C91CFD433085CBD74E` FOREIGN KEY (`entity_type_id`) REFERENCES `#__eav_entity_type` (`entity_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C54528C8C92B559FCEB68462E642F630` FOREIGN KEY (`type_id`) REFERENCES `#__eav_form_type` (`type_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__index_process_event`
ADD CONSTRAINT `FK_04D53C459DCD3EFF7C6BA37C5928D9BE` FOREIGN KEY (`process_id`) REFERENCES `#__index_process` (`process_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_IDX_PROCESS_EVENT_EVENT_ID_SNSPFX_IDX_EVENT_EVENT_ID` FOREIGN KEY (`event_id`) REFERENCES `#__index_event` (`event_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__newsletter_problem`
ADD CONSTRAINT `FK_C6EB441216883A51DF9B30558FB21A15` FOREIGN KEY (`subscriber_id`) REFERENCES `#__newsletter_subscriber` (`subscriber_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_NLTTR_PROBLEM_QUEUE_ID_SNSPFX_NLTTR_QUEUE_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `#__newsletter_queue` (`queue_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__newsletter_queue`
ADD CONSTRAINT `FK_E86135B154D0E5EF31BD99629AB255A3` FOREIGN KEY (`template_id`) REFERENCES `#__newsletter_template` (`template_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__newsletter_queue_link`
ADD CONSTRAINT `FK_A9DAEDFF5CC4D2CD9AA8C88FA3023E02` FOREIGN KEY (`subscriber_id`) REFERENCES `#__newsletter_subscriber` (`subscriber_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_NLTTR_QUEUE_LNK_QUEUE_ID_SNSPFX_NLTTR_QUEUE_QUEUE_ID` FOREIGN KEY (`queue_id`) REFERENCES `#__newsletter_queue` (`queue_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__newsletter_queue_store_link`
ADD CONSTRAINT `FK_AD74244EE534EB90F922545C58372250` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C081EC4A45B9857677F51ABFF3066267` FOREIGN KEY (`queue_id`) REFERENCES `#__newsletter_queue` (`queue_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__newsletter_subscriber`
ADD CONSTRAINT `FK_SNSPFX_NLTTR_SUBSCRIBER_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__oauth_token`
ADD CONSTRAINT `FK_SNSPFX_OAUTH_TOKEN_ADMIN_ID_SNSPFX_SNSPFX_ADMIN_USER_USER_ID` FOREIGN KEY (`admin_id`) REFERENCES `#__admin_user` (`user_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_OAUTH_TOKEN_CONSUMER_ID_SNSPFX_OAUTH_CONSUMER_ENTT_ID` FOREIGN KEY (`consumer_id`) REFERENCES `#__oauth_consumer` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_OAUTH_TOKEN_CSTR_ID_SNSPFX_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__paypal_cert`
ADD CONSTRAINT `FK_SNSPFX_PAYPAL_CERT_WEBSITE_ID_SNSPFX_CORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__paypal_settlement_report_row`
ADD CONSTRAINT `FK_6CBF7B6D58A45919DFD81734DC1D1694` FOREIGN KEY (`report_id`) REFERENCES `#__paypal_settlement_report` (`report_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__persistent_session`
ADD CONSTRAINT `FK_SNSPFX_PERSISTENT_SESS_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_PERSISTENT_SESS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__poll`
ADD CONSTRAINT `FK_SNSPFX_POLL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__poll_answer`
ADD CONSTRAINT `FK_SNSPFX_POLL_ANSWER_POLL_ID_SNSPFX_POLL_POLL_ID` FOREIGN KEY (`poll_id`) REFERENCES `#__poll` (`poll_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__poll_store`
ADD CONSTRAINT `FK_SNSPFX_POLL_STORE_POLL_ID_SNSPFX_POLL_POLL_ID` FOREIGN KEY (`poll_id`) REFERENCES `#__poll` (`poll_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_POLL_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__poll_vote`
ADD CONSTRAINT `FK_SNSPFX_POLL_VOTE_POLL_ANSWER_ID_SNSPFX_POLL_ANSWER_ANSWER_ID` FOREIGN KEY (`poll_answer_id`) REFERENCES `#__poll_answer` (`answer_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__product_alert_price`
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_PRICE_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_PRICE_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_PRICE_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__product_alert_stock`
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_STOCK_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_STOCK_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_PRD_ALERT_STOCK_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating`
ADD CONSTRAINT `FK_SNSPFX_RATING_ENTITY_ID_SNSPFX_RATING_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__rating_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating_option`
ADD CONSTRAINT `FK_SNSPFX_RATING_OPTION_RATING_ID_SNSPFX_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `#__rating` (`rating_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating_option_vote`
ADD CONSTRAINT `FK_SNSPFX_RATING_OPTION_VOTE_REVIEW_ID_SNSPFX_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `#__review` (`review_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_RATING_OPT_VOTE_OPT_ID_SNSPFX_RATING_OPT_OPT_ID` FOREIGN KEY (`option_id`) REFERENCES `#__rating_option` (`option_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating_option_vote_aggregated`
ADD CONSTRAINT `FK_3370C992EDED159DE88B9728C7C498A8` FOREIGN KEY (`rating_id`) REFERENCES `#__rating` (`rating_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_37FEDB6FC3E9598AA18D11875567C849` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating_store`
ADD CONSTRAINT `FK_SNSPFX_RATING_STORE_RATING_ID_SNSPFX_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `#__rating` (`rating_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_RATING_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__rating_title`
ADD CONSTRAINT `FK_SNSPFX_RATING_TITLE_RATING_ID_SNSPFX_RATING_RATING_ID` FOREIGN KEY (`rating_id`) REFERENCES `#__rating` (`rating_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_RATING_TITLE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_compared_product_index`
ADD CONSTRAINT `FK_2B7F2582A2AEEDB4875F97803E519A8D` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REPORT_CMPD_PRD_IDX_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REPORT_CMPD_PRD_IDX_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_event`
ADD CONSTRAINT `FK_B9F9EE948312C2070B83C036742C7795` FOREIGN KEY (`event_type_id`) REFERENCES `#__report_event_types` (`event_type_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REPORT_EVENT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_viewed_product_aggregated_daily`
ADD CONSTRAINT `FK_53936592197764A9D7A3E3B7C7C21328` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C681D39EE080031F7DCE71DCBD944E8F` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_viewed_product_aggregated_monthly`
ADD CONSTRAINT `FK_BF5A7D1D709A121C1A02D39283309875` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FEAF8DAF62875D1DEC620FDF1CC38B38` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_viewed_product_aggregated_yearly`
ADD CONSTRAINT `FK_6221CBBB762AB1544ADD485CDD3C7A36` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_AFBCDD22CF520D22ECEE1FD70F073E6D` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__report_viewed_product_index`
ADD CONSTRAINT `FK_BED1EE3DDBF08B6725F7E31CD5AE9D85` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C3A9790DB0D1AF1758A50CD74218686C` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REPORT_VIEWED_PRD_IDX_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__review`
ADD CONSTRAINT `FK_SNSPFX_REVIEW_ENTITY_ID_SNSPFX_REVIEW_ENTITY_ENTITY_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__review_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REVIEW_STATUS_ID_SNSPFX_REVIEW_STATUS_STATUS_ID` FOREIGN KEY (`status_id`) REFERENCES `#__review_status` (`status_id`) ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER TABLE `#__review_detail`
ADD CONSTRAINT `FK_SNSPFX_REVIEW_DETAIL_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REVIEW_DETAIL_REVIEW_ID_SNSPFX_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `#__review` (`review_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REVIEW_DETAIL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__review_entity_summary`
ADD CONSTRAINT `FK_BDAA26383F94D88C34F89769FD707453` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__review_store`
ADD CONSTRAINT `FK_SNSPFX_REVIEW_STORE_REVIEW_ID_SNSPFX_REVIEW_REVIEW_ID` FOREIGN KEY (`review_id`) REFERENCES `#__review` (`review_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_REVIEW_STORE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_coupon`
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_COUPON_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_coupon_usage`
ADD CONSTRAINT `FK_334E9B3EE5BD8BADA13EE32908900168` FOREIGN KEY (`coupon_id`) REFERENCES `#__salesrule_coupon` (`coupon_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_A7A141D2BCC4EBC82C06D2ADF70FF29F` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_customer`
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_CSTR_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_CUSTOMER_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_customer_group`
ADD CONSTRAINT `FK_F9F6DFC428B98C29F3969353C8DCC6BB` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_CSTR_GROUP_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_label`
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_LABEL_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_LABEL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__salesrule_product_attribute`
ADD CONSTRAINT `FK_1AAEF4DCDFD5A4554F16B4D05521CA3E` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_PRD_ATTR_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_PRD_ATTR_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_PRD_ATTR_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE NO ACTION;

ALTER TABLE `#__salesrule_website`
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_WEBSITE_RULE_ID_SNSPFX_SALESRULE_RULE_ID` FOREIGN KEY (`rule_id`) REFERENCES `#__salesrule` (`rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALESRULE_WS_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_bestsellers_aggregated_daily`
ADD CONSTRAINT `FK_879E89C2C9099A66B93D60B71680FBFD` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_E124586BAAED64EA7F34FAD292BFE8BF` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_bestsellers_aggregated_monthly`
ADD CONSTRAINT `FK_762FC5AFFBB91F21B7DCFDECDBCF2DF5` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_E84B901E8D151C39E030A0966251BF2A` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_bestsellers_aggregated_yearly`
ADD CONSTRAINT `FK_52B5942104643D5BCD8DCCE864B5EAA0` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_8B220A2701E313DC4EED0D4C89642D4A` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_billing_agreement`
ADD CONSTRAINT `FK_SNSPFX_SALES_BILLING_AGRT_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALES_BILLING_AGRT_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_billing_agreement_order`
ADD CONSTRAINT `FK_65B717BB8574A82F84A352FCD0B28B4B` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_7346D051068BB77E1414C41DFC0A32B3` FOREIGN KEY (`agreement_id`) REFERENCES `#__sales_billing_agreement` (`agreement_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_creditmemo`
ADD CONSTRAINT `FK_D02F8567DD67801710D13343B5C76149` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_E0148F841A10C330D1830B79B1BBD5A9` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_creditmemo_comment`
ADD CONSTRAINT `FK_4B248F492E9E73F5E11F98922E143CCC` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_creditmemo` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_creditmemo_grid`
ADD CONSTRAINT `FK_8FF2AFF21E39980715E249A604CF4C8E` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FC363E29565A609E3CCB2F8E50AB908A` FOREIGN KEY (`entity_id`) REFERENCES `#__sales_flat_creditmemo` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_creditmemo_item`
ADD CONSTRAINT `FK_D9F147603CB43490B1197845844681F2` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_creditmemo` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_invoice`
ADD CONSTRAINT `FK_9A8DAAD7FC7D8E722CAF54B1CCF2B508` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALES_FLAT_INVOICE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_invoice_comment`
ADD CONSTRAINT `FK_6AC29883D6B6AAD68BDEABF5A415411C` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_invoice` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_invoice_grid`
ADD CONSTRAINT `FK_976E7583052FA6CC106C815684A810C8` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_AAC8113E71CF0E5D26B071BF8539E2F9` FOREIGN KEY (`entity_id`) REFERENCES `#__sales_flat_invoice` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_invoice_item`
ADD CONSTRAINT `FK_6EFF1BE20CBF44AF75F68B3212A537E5` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_invoice` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order`
ADD CONSTRAINT `FK_SNSPFX_SALES_FLAT_ORDER_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALES_FLAT_ORDER_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order_address`
ADD CONSTRAINT `FK_8D78830CBA90C0EFF5900A185A299BE6` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order_grid`
ADD CONSTRAINT `FK_1DEBF26A92202D9D5429253D992B3E36` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_F892D5D52F31EC72F62794035B2F1A9A` FOREIGN KEY (`entity_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALES_FLAT_ORDER_GRID_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order_item`
ADD CONSTRAINT `FK_B2923EFD2CB9BA7A41624A71CFC2EDEF` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FC28A7D264AAA3B47F6FA335DD3D1423` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order_payment`
ADD CONSTRAINT `FK_AE3DAFFDE8581072AA5F091088A3C705` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_order_status_history`
ADD CONSTRAINT `FK_9C5CD9F9C4E5B392FBD1609C1A5C8FF7` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote`
ADD CONSTRAINT `FK_SNSPFX_SALES_FLAT_QUOTE_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_address`
ADD CONSTRAINT `FK_6E64D8A8BB8B26E4C7C8376110359484` FOREIGN KEY (`quote_id`) REFERENCES `#__sales_flat_quote` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_address_item`
ADD CONSTRAINT `FK_04D78B7D09EDA5A0D57B7C968D21D602` FOREIGN KEY (`parent_item_id`) REFERENCES `#__sales_flat_quote_address_item` (`address_item_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_22D474FE4A9E43EEC58B79B2A301BE3D` FOREIGN KEY (`quote_address_id`) REFERENCES `#__sales_flat_quote_address` (`address_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_5EB2081143915387ADFCB68A0800402F` FOREIGN KEY (`quote_item_id`) REFERENCES `#__sales_flat_quote_item` (`item_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_item`
ADD CONSTRAINT `FK_4125CD9D8869FD7EECA34C10B2F8A13E` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_6405C7AC53C49321BD4C81C8980D4332` FOREIGN KEY (`parent_item_id`) REFERENCES `#__sales_flat_quote_item` (`item_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_9AB08E8EC56067C9AFC5CA9FF68E5A95` FOREIGN KEY (`quote_id`) REFERENCES `#__sales_flat_quote` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_DCEFA7FB6D67AA6E9543B1E9220C3961` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_item_option`
ADD CONSTRAINT `FK_B15A91DB474490B2598ED55A1D36DB02` FOREIGN KEY (`item_id`) REFERENCES `#__sales_flat_quote_item` (`item_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_payment`
ADD CONSTRAINT `FK_E6D6EFB8889DE282ACF00BCE2F046932` FOREIGN KEY (`quote_id`) REFERENCES `#__sales_flat_quote` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_quote_shipping_rate`
ADD CONSTRAINT `FK_BA5C3AB548FA6D729A97BA17E64CC4AD` FOREIGN KEY (`address_id`) REFERENCES `#__sales_flat_quote_address` (`address_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_shipment`
ADD CONSTRAINT `FK_0B9053BAD4EF4FB0099F0AEB8EB11B81` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C339753A3CCE6711BCB6D8604085CC7C` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_shipment_comment`
ADD CONSTRAINT `FK_9899247D712F8E0B95E6F19F156E45F6` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_shipment` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_shipment_grid`
ADD CONSTRAINT `FK_3AE0F78CA47B859A32A3F78421AFF68F` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_F7CF5CA341F2A55B672D7E9FDB485A36` FOREIGN KEY (`entity_id`) REFERENCES `#__sales_flat_shipment` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_shipment_item`
ADD CONSTRAINT `FK_33286C3ABBC93722C12C2DDD080B56BD` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_shipment` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_flat_shipment_track`
ADD CONSTRAINT `FK_A96B56A56F8A4873066A7B3A316DEEE5` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_flat_shipment` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_invoiced_aggregated`
ADD CONSTRAINT `FK_E1CE568506E5C9B0153B0B28C09E1F3D` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_invoiced_aggregated_order`
ADD CONSTRAINT `FK_4B38839574213B1948463C729FFE1C12` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_order_aggregated_created`
ADD CONSTRAINT `FK_FEBBF3E885823642F1873886939E0965` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_order_aggregated_updated`
ADD CONSTRAINT `FK_E2C72AA3F023A37DC018A186485DB5BF` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_order_status_label`
ADD CONSTRAINT `FK_E8AB33948BFA0AFB480A3BFE8BF52A4C` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_SALES_ORDER_STS_LBL_STS_SNSPFX_SALES_ORDER_STS_STS` FOREIGN KEY (`status`) REFERENCES `#__sales_order_status` (`status`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_order_status_state`
ADD CONSTRAINT `FK_SNSPFX_SALES_ORDER_STS_STATE_STS_SNSPFX_SALES_ORDER_STS_STS` FOREIGN KEY (`status`) REFERENCES `#__sales_order_status` (`status`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_order_tax_item`
ADD CONSTRAINT `FK_5DC4B30A9CA74CEA291F470DF189D91A` FOREIGN KEY (`item_id`) REFERENCES `#__sales_flat_order_item` (`item_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_AD1AD5E277DBB829B4662E0FA8064BB3` FOREIGN KEY (`tax_id`) REFERENCES `#__sales_order_tax` (`tax_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_payment_transaction`
ADD CONSTRAINT `FK_3550BDBE01AD72F2B295AE6C3EB8EBC0` FOREIGN KEY (`parent_id`) REFERENCES `#__sales_payment_transaction` (`transaction_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_4635B0DA5A335BB2AE1D1FAF6A860D07` FOREIGN KEY (`payment_id`) REFERENCES `#__sales_flat_order_payment` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_C60E77055DC301B59EBDC454DD494B7A` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_recurring_profile`
ADD CONSTRAINT `FK_93FBD76307C7FD1DE7B0BCF44450C393` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_E399E37728CABF9DB2047A9A8840A35D` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_recurring_profile_order`
ADD CONSTRAINT `FK_08CE10D4489E746F1F1950FC7C2FE62F` FOREIGN KEY (`profile_id`) REFERENCES `#__sales_recurring_profile` (`profile_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_467A99FF1161D8ABA9D088189FD17857` FOREIGN KEY (`order_id`) REFERENCES `#__sales_flat_order` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__sales_refunded_aggregated`
ADD CONSTRAINT `FK_CCCF2F1146DFE3B52E237209E9A3489D` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_refunded_aggregated_order`
ADD CONSTRAINT `FK_1FF5A202A8BB4D70DF0D67613D43A528` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_shipping_aggregated`
ADD CONSTRAINT `FK_SNSPFX_SALES_SHPP_AGGRED_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sales_shipping_aggregated_order`
ADD CONSTRAINT `FK_EA5F217884FC6B4BAB14D294020D47E1` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE;

ALTER TABLE `#__sitemap`
ADD CONSTRAINT `FK_SNSPFX_SITEMAP_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tag`
ADD CONSTRAINT `FK_SNSPFX_TAG_FIRST_CUSTOMER_ID_SNSPFX_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`first_customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE SET NULL ON UPDATE NO ACTION,
ADD CONSTRAINT `FK_SNSPFX_TAG_FIRST_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`first_store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE NO ACTION;

ALTER TABLE `#__tag_properties`
ADD CONSTRAINT `FK_SNSPFX_TAG_PROPERTIES_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAG_PROPERTIES_TAG_ID_SNSPFX_TAG_TAG_ID` FOREIGN KEY (`tag_id`) REFERENCES `#__tag` (`tag_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tag_relation`
ADD CONSTRAINT `FK_SNSPFX_TAG_RELATION_CSTR_ID_SNSPFX_CSTR_ENTT_ENTT_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAG_RELATION_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAG_RELATION_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAG_RELATION_TAG_ID_SNSPFX_TAG_TAG_ID` FOREIGN KEY (`tag_id`) REFERENCES `#__tag` (`tag_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tag_summary`
ADD CONSTRAINT `FK_SNSPFX_TAG_SUMMARY_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAG_SUMMARY_TAG_ID_SNSPFX_TAG_TAG_ID` FOREIGN KEY (`tag_id`) REFERENCES `#__tag` (`tag_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tax_calculation`
ADD CONSTRAINT `FK_3033DBFAF56A4BB21921F1088CF7C2F3` FOREIGN KEY (`tax_calculation_rate_id`) REFERENCES `#__tax_calculation_rate` (`tax_calculation_rate_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_AE58F9B9567E126AC6D87EF5D847291E` FOREIGN KEY (`tax_calculation_rule_id`) REFERENCES `#__tax_calculation_rule` (`tax_calculation_rule_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAX_CALC_CSTR_TAX_CLASS_ID_SNSPFX_TAX_CLASS_CLASS_ID` FOREIGN KEY (`customer_tax_class_id`) REFERENCES `#__tax_class` (`class_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAX_CALC_PRD_TAX_CLASS_ID_SNSPFX_TAX_CLASS_CLASS_ID` FOREIGN KEY (`product_tax_class_id`) REFERENCES `#__tax_class` (`class_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tax_calculation_rate_title`
ADD CONSTRAINT `FK_4CE204567EBCC037201EC64C1D6283F1` FOREIGN KEY (`tax_calculation_rate_id`) REFERENCES `#__tax_calculation_rate` (`tax_calculation_rate_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_TAX_CALC_RATE_TTL_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tax_order_aggregated_created`
ADD CONSTRAINT `FK_2189310BD6DC8E38B054921B2715F1E0` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__tax_order_aggregated_updated`
ADD CONSTRAINT `FK_9628BDEE865DAB758DC88E21B8154330` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__weee_discount`
ADD CONSTRAINT `FK_A9805134FB122981F64168D8E0704B0F` FOREIGN KEY (`customer_group_id`) REFERENCES `#__customer_group` (`customer_group_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WEEE_DISCOUNT_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WEEE_DISCOUNT_WS_ID_SNSPFX_CORE_WS_WS_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__weee_tax`
ADD CONSTRAINT `FK_SNSPFX_WEEE_TAX_ATTR_ID_SNSPFX_EAV_ATTR_ATTR_ID` FOREIGN KEY (`attribute_id`) REFERENCES `#__eav_attribute` (`attribute_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WEEE_TAX_COUNTRY_SNSPFX_DIRECTORY_COUNTRY_COUNTRY_ID` FOREIGN KEY (`country`) REFERENCES `#__directory_country` (`country_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WEEE_TAX_ENTT_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`entity_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WEEE_TAX_WEBSITE_ID_SNSPFX_CORE_WEBSITE_WEBSITE_ID` FOREIGN KEY (`website_id`) REFERENCES `#__core_website` (`website_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__widget_instance_page`
ADD CONSTRAINT `FK_14808841ECEEA600CF9E24B6B303D6CB` FOREIGN KEY (`instance_id`) REFERENCES `#__widget_instance` (`instance_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__widget_instance_page_layout`
ADD CONSTRAINT `FK_52CF85D38802FD022E2AE2A21301C8CD` FOREIGN KEY (`page_id`) REFERENCES `#__widget_instance_page` (`page_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_FF2319AE4DA49D30B9FEF2627FA16F23` FOREIGN KEY (`layout_update_id`) REFERENCES `#__core_layout_update` (`layout_update_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__wishlist`
ADD CONSTRAINT `FK_SNSPFX_WISHLIST_CUSTOMER_ID_SNSPFX_CUSTOMER_ENTITY_ENTITY_ID` FOREIGN KEY (`customer_id`) REFERENCES `#__customer_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__wishlist_item`
ADD CONSTRAINT `FK_SNSPFX_WISHLIST_ITEM_PRD_ID_SNSPFX_CAT_PRD_ENTT_ENTT_ID` FOREIGN KEY (`product_id`) REFERENCES `#__catalog_product_entity` (`entity_id`) ON DELETE CASCADE ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WISHLIST_ITEM_STORE_ID_SNSPFX_CORE_STORE_STORE_ID` FOREIGN KEY (`store_id`) REFERENCES `#__core_store` (`store_id`) ON DELETE SET NULL ON UPDATE CASCADE,
ADD CONSTRAINT `FK_SNSPFX_WISHLIST_ITEM_WISHLIST_ID_SNSPFX_WISHLIST_WISHLIST_ID` FOREIGN KEY (`wishlist_id`) REFERENCES `#__wishlist` (`wishlist_id`) ON DELETE CASCADE ON UPDATE CASCADE;

ALTER TABLE `#__wishlist_item_option`
ADD CONSTRAINT `FK_3DE126D84316732A74B16C2D50C57B53` FOREIGN KEY (`wishlist_item_id`) REFERENCES `#__wishlist_item` (`wishlist_item_id`) ON DELETE CASCADE ON UPDATE CASCADE;
SET FOREIGN_KEY_CHECKS=1;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
